/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(J){for(var e=[],D=0,L=J.length;D<L;D++)e[D]=te[J[D]];return e};define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function L(I){const b=[];for(let d in I)D.call(I,d)&&b.push(I[d]);return b}e.values=L;function R(I,b){for(let d in I)if(D.call(I,d)&&b({key:d,value:I[d]},function(){delete I[d]})===!1)return}e.forEach=R;function T(I,b){const d=Object.create(null);for(const v of I){const h=b(v);let E=d[h];E||(E=d[h]=[]),E.push(v)}return d}e.groupBy=T;function i(I){const b=Object.create(null);return I&&I.forEach((d,v)=>{b[v]=d}),b}e.fromMap=i;function P(I,b){const d=[],v=[];for(let h of I)b.has(h)||d.push(h);for(let h of b)I.has(h)||v.push(h);return{removed:d,added:v}}e.diffSets=P;function S(I,b){const d=[],v=[];for(let[h,E]of I)b.has(h)||d.push(E);for(let[h,E]of b)I.has(h)||v.push(E);return{removed:d,added:v}}e.diffMaps=S;class C{constructor(){this.map=new Map}add(b,d){let v=this.map.get(b);v||(v=new Set,this.map.set(b,v)),v.add(d)}delete(b,d){const v=this.map.get(b);!v||(v.delete(d),v.size===0&&this.map.delete(b))}forEach(b,d){const v=this.map.get(b);!v||v.forEach(d)}}e.SetMap=C}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(i){return(P,S,C)=>{let I=null,b=null;if(typeof C.value=="function"?(I="value",b=C.value):typeof C.get=="function"&&(I="get",b=C.get),!b)throw new Error("not supported");C[I]=i(b,S)}}e.createDecorator=D;function L(i,P,S){let C=null,I=null;if(typeof S.value=="function"?(C="value",I=S.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",I=S.get),!I)throw new Error("not supported");const b=`$memoize$${P}`;S[C]=function(...d){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[b]}}e.memoize=L;function R(i,P,S){return D((C,I)=>{const b=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...v){this[d]||(this[d]=S?S():void 0),clearTimeout(this[b]),P&&(this[d]=P(this[d],...v),v=[this[d]]),this[b]=setTimeout(()=>{C.apply(this,v),this[d]=S?S():void 0},i)}})}e.debounce=R;function T(i,P,S){return D((C,I)=>{const b=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,v=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...E){if(this[d]||(this[d]=S?S():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...E)),this[h])return;const y=this[v]+i;y<=Date.now()?(this[v]=Date.now(),C.apply(this,[this[d]]),this[d]=S?S():void 0):(this[h]=!0,this[b]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),C.apply(this,[this[d]]),this[d]=S?S():void 0},y-Date.now()))}})}e.throttle=T}),define(te[9],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(s=>{s(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=D,e.errorHandler=new D;function L(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=L;function R(l){S(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=R;function T(l){S(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=T;function i(l){if(l instanceof Error){let{name:r,message:s}=l;const n=l.stacktrace||l.stack;return{$isError:!0,name:r,message:s,stack:n}}return l}e.transformErrorForSerialization=i;const P="Canceled";function S(l){return l instanceof Error&&l.name===P&&l.message===P}e.isPromiseCanceledError=S;class C extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=C;function I(){const l=new Error(P);return l.name=l.message,l}e.canceled=I;function b(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=b;function d(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=d;function v(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function E(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=E;class y extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=y;class m extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function g(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=g;function a(l,r=Object.create(null)){const s=new Error(l);return r.actions&&(s.actions=r.actions),s}e.createErrorWithActions=a}),define(te[17],ne([0,1,9]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(U,N=0){return U[U.length-(1+N)]}e.tail=L;function R(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=R;function T(U,N,z=(x,K)=>x===K){if(U===N)return!0;if(!U||!N||U.length!==N.length)return!1;for(let x=0,K=U.length;x<K;x++)if(!z(U[x],N[x]))return!1;return!0}e.equals=T;function i(U,N,z){let x=0,K=U.length-1;for(;x<=K;){const ee=(x+K)/2|0,V=z(U[ee],N);if(V<0)x=ee+1;else if(V>0)K=ee-1;else return ee}return-(x+1)}e.binarySearch=i;function P(U,N){let z=0,x=U.length;if(x===0)return 0;for(;z<x;){const K=Math.floor((z+x)/2);N(U[K])?x=K:z=K+1}return z}e.findFirstInSorted=P;function S(U,N,z){if(U=U|0,U>=N.length)throw new TypeError("invalid index");let x=N[Math.floor(N.length*Math.random())],K=[],ee=[],V=[];for(let X of N){const se=z(X,x);se<0?K.push(X):se>0?ee.push(X):V.push(X)}return U<K.length?S(U,K,z):U<K.length+V.length?V[0]:S(U-(K.length+V.length),ee,z)}e.quickSelect=S;function C(U,N){const z=[];let x;for(const K of U.slice(0).sort(N))!x||N(x[0],K)!==0?(x=[K],z.push(x)):x.push(K);return z}e.groupBy=C;function I(U,N,z){const x=[];function K(X,se,oe){if(se===0&&oe.length===0)return;const le=x[x.length-1];le&&le.start+le.deleteCount===X?(le.deleteCount+=se,le.toInsert.push(...oe)):x.push({start:X,deleteCount:se,toInsert:oe})}let ee=0,V=0;for(;;){if(ee===U.length){K(ee,0,N.slice(V));break}if(V===N.length){K(ee,U.length-ee,[]);break}const X=U[ee],se=N[V],oe=z(X,se);oe===0?(ee+=1,V+=1):oe<0?(K(ee,1,[]),ee+=1):oe>0&&(K(ee,0,[se]),V+=1)}return x}e.sortedDiff=I;function b(U,N,z){const x=I(U,N,z),K=[],ee=[];for(const V of x)K.push(...U.slice(V.start,V.start+V.deleteCount)),ee.push(...V.toInsert);return{removed:K,added:ee}}e.delta=b;function d(U,N,z){if(z===0)return[];const x=U.slice(0,z).sort(N);return h(U,N,x,z,U.length),x}e.top=d;function v(U,N,z,x,K){return z===0?Promise.resolve([]):new Promise((ee,V)=>{(async()=>{const X=U.length,se=U.slice(0,z).sort(N);for(let oe=z,le=Math.min(z+x,X);oe<X;oe=le,le=Math.min(le+x,X)){if(oe>z&&await new Promise(he=>setTimeout(he)),K&&K.isCancellationRequested)throw(0,D.canceled)();h(U,N,se,oe,le)}return se})().then(ee,V)})}e.topAsync=v;function h(U,N,z,x,K){for(const ee=z.length;x<K;x++){const V=U[x];if(N(V,z[ee-1])<0){z.pop();const X=P(z,se=>N(V,se)<0);z.splice(X,0,V)}}}function E(U){return U.filter(N=>!!N)}e.coalesce=E;function y(U){let N=0;for(let z=0;z<U.length;z++)U[z]&&(U[N]=U[z],N+=1);U.length=N}e.coalesceInPlace=y;function m(U,N,z){U.splice(z,0,U.splice(N,1)[0])}e.move=m;function w(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=w;function g(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=g;function a(U,N=z=>z){const z=new Set;return U.filter(x=>{const K=N(x);return z.has(K)?!1:(z.add(K),!0)})}e.distinct=a;function l(U){const N=Object.create(null);return z=>{const x=U(z);return N[x]?!1:(N[x]=!0,!0)}}e.uniqueFilter=l;function r(U,N){const z=s(U,N);if(z!==-1)return U[z]}e.findLast=r;function s(U,N){for(let z=U.length-1;z>=0;z--){const x=U[z];if(N(x))return z}return-1}e.lastIndex=s;function n(U,N){return U.length>0?U[0]:N}e.firstOrDefault=n;function t(U,N,z=(x,K)=>x===K){let x=0;for(let K=0,ee=Math.min(U.length,N.length);K<ee&&z(U[K],N[K]);K++)x++;return x}e.commonPrefixLength=t;function o(U){return[].concat(...U)}e.flatten=o;function c(U,N){let z=typeof N=="number"?U:0;typeof N=="number"?z=U:(z=0,N=U);const x=[];if(z<=N)for(let K=z;K<N;K++)x.push(K);else for(let K=z;K>N;K--)x.push(K);return x}e.range=c;function u(U,N,z){return U.reduce((x,K)=>(x[N(K)]=z?z(K):K,x),Object.create(null))}e.index=u;function f(U,N){return U.push(N),()=>p(U,N)}e.insert=f;function p(U,N){const z=U.indexOf(N);if(z>-1)return U.splice(z,1),N}e.remove=p;function k(U,N,z){const x=U.slice(0,N),K=U.slice(N);return x.concat(z,K)}e.arrayInsert=k;function O(U,N){let z;if(typeof N=="number"){let x=N;z=()=>{const K=Math.sin(x++)*179426549;return K-Math.floor(K)}}else z=Math.random;for(let x=U.length-1;x>0;x-=1){const K=Math.floor(z()*(x+1)),ee=U[x];U[x]=U[K],U[K]=ee}}e.shuffle=O;function F(U,N){const z=U.indexOf(N);z>-1&&(U.splice(z,1),U.unshift(N))}e.pushToStart=F;function W(U,N){const z=U.indexOf(N);z>-1&&(U.splice(z,1),U.push(N))}e.pushToEnd=W;function $(U,N){return Array.isArray(U)?U.map(N):N(U)}e.mapArrayOrNot=$;function A(U){return Array.isArray(U)?U:[U]}e.asArray=A;function q(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=q;function _(U,N){for(const z of U){const x=N(z);if(x!==void 0)return x}}e.mapFind=_;function M(U,N,z){const x=Z(U,N),K=U.length,ee=z.length;U.length=K+ee;for(let V=K-1;V>=x;V--)U[V+ee]=U[V];for(let V=0;V<ee;V++)U[V+x]=z[V]}e.insertInto=M;function B(U,N,z,x){const K=Z(U,N),ee=U.splice(K,z);return M(U,K,x),ee}e.splice=B;function Z(U,N){return N<0?Math.max(N+U.length,0):Math.min(N,U.length)}function H(U,N){let z=Number.MAX_SAFE_INTEGER,x=0;return U.forEach((K,ee)=>{const V=N(K);V<z&&(z=V,x=ee)}),x}e.minIndex=H;function j(U,N){let z=Number.MIN_SAFE_INTEGER,x=0;return U.forEach((K,ee)=>{const V=N(K);V>z&&(z=V,x=ee)}),x}e.maxIndex=j;class Q{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let z=this.firstIdx;for(;z<this.items.length&&N(this.items[z]);)z++;const x=z===this.firstIdx?null:this.items.slice(this.firstIdx,z);return this.firstIdx=z,x}takeFromEndWhile(N){let z=this.lastIdx;for(;z>=0&&N(this.items[z]);)z--;const x=z===this.lastIdx?null:this.items.slice(z+1,this.lastIdx+1);return this.lastIdx=z,x}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const z=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,z}}e.ArrayQueue=Q}),define(te[68],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(L){const R=this;let T=!1,i;return function(){return T||(T=!0,i=L.apply(R,arguments)),i}}e.once=D}),define(te[56],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function R(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}L.is=R;const T=Object.freeze([]);function i(){return T}L.empty=i;function*P(l){yield l}L.single=P;function S(l){return l||T}L.from=S;function C(l){return!l||l[Symbol.iterator]().next().done===!0}L.isEmpty=C;function I(l){return l[Symbol.iterator]().next().value}L.first=I;function b(l,r){for(const s of l)if(r(s))return!0;return!1}L.some=b;function d(l,r){for(const s of l)if(r(s))return s}L.find=d;function*v(l,r){for(const s of l)r(s)&&(yield s)}L.filter=v;function*h(l,r){let s=0;for(const n of l)yield r(n,s++)}L.map=h;function*E(...l){for(const r of l)for(const s of r)yield s}L.concat=E;function*y(l){for(const r of l)for(const s of r)yield s}L.concatNested=y;function m(l,r,s){let n=s;for(const t of l)n=r(n,t);return n}L.reduce=m;function*w(l,r,s=l.length){for(r<0&&(r+=l.length),s<0?s+=l.length:s>l.length&&(s=l.length);r<s;r++)yield l[r]}L.slice=w;function g(l,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,l];const n=l[Symbol.iterator]();for(let t=0;t<r;t++){const o=n.next();if(o.done)return[s,L.empty()];s.push(o.value)}return[s,{[Symbol.iterator](){return n}}]}L.consume=g;function a(l,r,s=(n,t)=>n===t){const n=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const o=n.next(),c=t.next();if(o.done!==c.done)return!1;if(o.done)return!0;if(!s(o.value,c.value))return!1}}L.equals=a})(D=e.Iterable||(e.Iterable={}))}),define(te[31],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var L;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(r){r.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function i(r,s=!1){let n=0,t=r.length,o="",c=0,u=16,f=0;function p(q){let _=0,M=0;for(;_<q;){const B=r.charCodeAt(n);if(B>=48&&B<=57)M=M*16+B-48;else if(B>=65&&B<=70)M=M*16+B-65+10;else if(B>=97&&B<=102)M=M*16+B-97+10;else break;n++,_++}return _<q&&(M=-1),M}function k(q){n=q,o="",c=0,u=16,f=0}function O(){const q=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&C(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&C(r.charCodeAt(n)))for(n++;n<r.length&&C(r.charCodeAt(n));)n++;else return f=3,r.substring(q,n);let _=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&C(r.charCodeAt(n))){for(n++;n<r.length&&C(r.charCodeAt(n));)n++;_=n}else f=3;return r.substring(q,_)}function F(){let q="",_=n;for(;;){if(n>=t){q+=r.substring(_,n),f=2;break}const M=r.charCodeAt(n);if(M===34){q+=r.substring(_,n),n++;break}if(M===92){if(q+=r.substring(_,n),n++,n>=t){f=2;break}switch(r.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const Z=p(4);Z>=0?q+=String.fromCharCode(Z):f=4;break;default:f=5}_=n;continue}if(M>=0&&M<=31)if(S(M)){q+=r.substring(_,n),f=2;break}else f=6;n++}return q}function W(){if(o="",f=0,c=n,n>=t)return c=t,u=17;let q=r.charCodeAt(n);if(P(q)){do n++,o+=String.fromCharCode(q),q=r.charCodeAt(n);while(P(q));return u=15}if(S(q))return n++,o+=String.fromCharCode(q),q===13&&r.charCodeAt(n)===10&&(n++,o+=`
`),u=14;switch(q){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,o=F(),u=10;case 47:const _=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<t&&!S(r.charCodeAt(n));)n++;return o=r.substring(_,n),u=12}if(r.charCodeAt(n+1)===42){n+=2;const M=t-1;let B=!1;for(;n<M;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,f=1),o=r.substring(_,n),u=13}return o+=String.fromCharCode(q),n++,u=16;case 45:if(o+=String.fromCharCode(q),n++,n===t||!C(r.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),u=11;default:for(;n<t&&$(q);)n++,q=r.charCodeAt(n);if(c!==n){switch(o=r.substring(c,n),o){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return o+=String.fromCharCode(q),n++,u=16}}function $(q){if(P(q)||S(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function A(){let q;do q=W();while(q>=12&&q<=15);return q}return{setPosition:k,getPosition:()=>n,scan:s?A:W,getToken:()=>u,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>f}}e.createScanner=i;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function S(r){return r===10||r===13||r===8232||r===8233}function C(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function b(r,s){const n=[],t=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function f(p,k,O,F){c.value=p,c.offset=k,c.length=O,c.type=F,c.colonOffset=void 0,o=c}try{g(r,{onObjectBegin:(p,k)=>{if(s<=p)throw t;o=void 0,u=s>p,n.push("")},onObjectProperty:(p,k,O)=>{if(s<k||(f(p,k,O,"property"),n[n.length-1]=p,s<=k+O))throw t},onObjectEnd:(p,k)=>{if(s<=p)throw t;o=void 0,n.pop()},onArrayBegin:(p,k)=>{if(s<=p)throw t;o=void 0,n.push(0)},onArrayEnd:(p,k)=>{if(s<=p)throw t;o=void 0,n.pop()},onLiteralValue:(p,k,O)=>{if(s<k||(f(p,k,O,l(p)),s<=k+O))throw t},onSeparator:(p,k,O)=>{if(s<=k)throw t;if(p===":"&&o&&o.type==="property")o.colonOffset=k,u=!1,o=void 0;else if(p===","){const F=n[n.length-1];typeof F=="number"?n[n.length-1]=F+1:(u=!0,n[n.length-1]=""),o=void 0}}})}catch(p){if(p!==t)throw p}return{path:n,previousNode:o,isAtPropertyKey:u,matches:p=>{let k=0;for(let O=0;k<p.length&&O<n.length;O++)if(p[k]===n[O]||p[k]==="*")k++;else if(p[k]!=="**")return!1;return k===p.length}}}e.getLocation=b;function d(r,s=[],n=T.DEFAULT){let t=null,o=[];const c=[];function u(p){Array.isArray(o)?o.push(p):t!==null&&(o[t]=p)}return g(r,{onObjectBegin:()=>{const p={};u(p),c.push(o),o=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const p=[];u(p),c.push(o),o=p,t=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:u,onError:(p,k,O)=>{s.push({error:p,offset:k,length:O})}},n),o[0]}e.parse=d;function v(r,s=[],n=T.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(p){t.type==="property"&&(t.length=p-t.offset,t=t.parent)}function c(p){return t.children.push(p),p}g(r,{onObjectBegin:p=>{t=c({type:"object",offset:p,length:-1,parent:t,children:[]})},onObjectProperty:(p,k,O)=>{t=c({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:p,offset:k,length:O,parent:t})},onObjectEnd:(p,k)=>{t.length=p+k-t.offset,t=t.parent,o(p+k)},onArrayBegin:(p,k)=>{t=c({type:"array",offset:p,length:-1,parent:t,children:[]})},onArrayEnd:(p,k)=>{t.length=p+k-t.offset,t=t.parent,o(p+k)},onLiteralValue:(p,k,O)=>{c({type:l(p),offset:k,length:O,parent:t,value:p}),o(k+O)},onSeparator:(p,k,O)=>{t.type==="property"&&(p===":"?t.colonOffset=k:p===","&&o(k))},onError:(p,k,O)=>{s.push({error:p,offset:k,length:O})}},n);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=v;function h(r,s){if(!r)return;let n=r;for(let t of s)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===t){n=c.children[1],o=!0;break}if(!o)return}else{const o=t;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=h;function E(r){if(!r.parent||!r.parent.children)return[];const s=E(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;s.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&s.push(n)}return s}e.getNodePath=E;function y(r){switch(r.type){case"array":return r.children.map(y);case"object":const s=Object.create(null);for(let n of r.children){const t=n.children[1];t&&(s[n.children[0].value]=y(t))}return s;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=y;function m(r,s,n=!1){return s>=r.offset&&s<r.offset+r.length||n&&s===r.offset+r.length}e.contains=m;function w(r,s,n=!1){if(m(r,s,n)){const t=r.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=s;o++){const c=w(t[o],s,n);if(c)return c}return r}}e.findNodeAtOffset=w;function g(r,s,n=T.DEFAULT){const t=i(r,!1);function o(z){return z?()=>z(t.getTokenOffset(),t.getTokenLength()):()=>!0}function c(z){return z?x=>z(x,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=o(s.onObjectBegin),f=c(s.onObjectProperty),p=o(s.onObjectEnd),k=o(s.onArrayBegin),O=o(s.onArrayEnd),F=c(s.onLiteralValue),W=c(s.onSeparator),$=o(s.onComment),A=c(s.onError),q=n&&n.disallowComments,_=n&&n.allowTrailingComma;function M(){for(;;){const z=t.scan();switch(t.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:q||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(z){case 12:case 13:q?B(10):$();break;case 16:B(1);break;case 15:case 14:break;default:return z}}}function B(z,x=[],K=[]){if(A(z),x.length+K.length>0){let ee=t.getToken();for(;ee!==17;){if(x.indexOf(ee)!==-1){M();break}else if(K.indexOf(ee)!==-1)break;ee=M()}}}function Z(z){const x=t.getTokenValue();return z?F(x):f(x),M(),!0}function H(){switch(t.getToken()){case 11:let z=0;try{z=JSON.parse(t.getTokenValue()),typeof z!="number"&&(B(2),z=0)}catch(x){B(2)}F(z);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return M(),!0}function j(){return t.getToken()!==10?(B(3,[],[2,5]),!1):(Z(!1),t.getToken()===6?(W(":"),M(),N()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Q(){u(),M();let z=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(z||B(4,[],[]),W(","),M(),t.getToken()===2&&_)break}else z&&B(6,[],[]);j()||B(4,[],[2,5]),z=!0}return p(),t.getToken()!==2?B(7,[2],[]):M(),!0}function U(){k(),M();let z=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(z||B(4,[],[]),W(","),M(),t.getToken()===4&&_)break}else z&&B(6,[],[]);N()||B(4,[],[4,5]),z=!0}return O(),t.getToken()!==4?B(8,[4],[]):M(),!0}function N(){switch(t.getToken()){case 3:return U();case 1:return Q();case 10:return Z(!0);default:return H()}}return M(),t.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):N()?(t.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=g;function a(r,s){let n=i(r),t=[],o,c=0,u;do switch(u=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:c!==u&&t.push(r.substring(c,u)),s!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,s)),c=n.getPosition();break}while(o!==17);return t.join("")}e.stripComments=a;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[48],ne([0,1,31]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,C,I){let b,d,v,h,E;if(C){for(h=C.offset,E=h+C.length,v=h;v>0&&!P(S,v-1);)v--;let c=E;for(;c<S.length&&!P(S,c);)c++;d=S.substring(v,c),b=T(d,I)}else d=S,b=0,v=0,h=0,E=S.length;const y=i(I,S);let m=!1,w=0,g;I.insertSpaces?g=R(" ",I.tabSize||4):g="	";const a=(0,D.createScanner)(d,!1);let l=!1;function r(){return y+R(g,b+w)}function s(){let c=a.scan();for(m=!1;c===15||c===14;)m=m||c===14,c=a.scan();return l=c===16||a.getTokenError()!==0,c}const n=[];function t(c,u,f){!l&&u<E&&f>h&&S.substring(u,f)!==c&&n.push({offset:u,length:f-u,content:c})}let o=s();if(o!==17){const c=a.getTokenOffset()+v,u=R(g,b);t(u,v,c)}for(;o!==17;){let c=a.getTokenOffset()+a.getTokenLength()+v,u=s(),f="";for(;!m&&(u===12||u===13);){const k=a.getTokenOffset()+v;t(" ",c,k),c=a.getTokenOffset()+a.getTokenLength()+v,f=u===12?r():"",u=s()}if(u===2)o!==1&&(w--,f=r());else if(u===4)o!==3&&(w--,f=r());else{switch(o){case 3:case 1:w++,f=r();break;case 5:case 12:f=r();break;case 13:m?f=r():f=" ";break;case 6:f=" ";break;case 10:if(u===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?f=" ":u!==5&&u!==17&&(l=!0);break;case 16:l=!0;break}m&&(u===12||u===13)&&(f=r())}const p=a.getTokenOffset()+v;t(f,c,p),o=u}return n}e.format=L;function R(S,C){let I="";for(let b=0;b<C;b++)I+=S;return I}function T(S,C){let I=0,b=0;const d=C.tabSize||4;for(;I<S.length;){const v=S.charAt(I);if(v===" ")b++;else if(v==="	")b+=d;else break;I++}return Math.floor(b/d)}function i(S,C){for(let I=0;I<C.length;I++){const b=C.charAt(I);if(b==="\r")return I+1<C.length&&C.charAt(I+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=i;function P(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=P}),define(te[40],ne([0,1,31,48]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(C,I,b){return T(C,I,void 0,b)}e.removeProperty=R;function T(C,I,b,d,v){const h=I.slice(),E=[],y=(0,D.parseTree)(C,E);let m,w;for(;h.length>0&&(w=h.pop(),m=(0,D.findNodeAtLocation)(y,h),m===void 0&&b!==void 0);)typeof w=="string"?b={[w]:b}:b=[b];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const g=(0,D.findNodeAtLocation)(m,[w]);if(g!==void 0)if(b===void 0){if(!g.parent)throw new Error("Malformed AST");const a=m.children.indexOf(g.parent);let l,r=g.parent.offset+g.parent.length;if(a>0){const s=m.children[a-1];l=s.offset+s.length}else l=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return i(C,{offset:l,length:r-l,content:""},d)}else return i(C,{offset:g.offset,length:g.length,content:JSON.stringify(b)},d);else{if(b===void 0)return[];const a=`${JSON.stringify(w)}: ${JSON.stringify(b)}`,l=v?v(m.children.map(s=>s.children[0].value)):m.children.length;let r;if(l>0){const s=m.children[l-1];r={offset:s.offset+s.length,length:0,content:","+a}}else m.children.length===0?r={offset:m.offset+1,length:0,content:a}:r={offset:m.offset+1,length:0,content:a+","};return i(C,r,d)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(b!==void 0){const g=`${JSON.stringify(b)}`;let a;if(m.children.length===0||w===0)a={offset:m.offset+1,length:0,content:m.children.length===0?g:g+","};else{const l=w===-1||w>m.children.length?m.children.length:w,r=m.children[l-1];a={offset:r.offset+r.length,length:0,content:","+g}}return i(C,a,d)}else{const g=w,a=m.children[g];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===g){const r=m.children[g-1],s=r.offset+r.length,n=m.offset+m.length;l={offset:s,length:n-2-s,content:""}}else l={offset:a.offset,length:m.children[g+1].offset-a.offset,content:""};return i(C,l,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return i(C,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(b)},d)}}e.setProperty=T;function i(C,I,b){let d=P(C,I),v=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;v>0&&!(0,L.isEOL)(d,v-1);)v--;for(;h<d.length&&!(0,L.isEOL)(d,h);)h++}const E=(0,L.format)(d,{offset:v,length:h-v},b);for(let m=E.length-1;m>=0;m--){const w=E[m];d=P(d,w),v=Math.min(v,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const y=C.length-(d.length-h)-v;return[{offset:v,length:y,content:d.substring(v,h)}]}e.withFormatting=i;function P(C,I){return C.substring(0,I.offset)+I.content+C.substring(I.offset+I.length)}e.applyEdit=P;function S(C,I){let b=I.slice(0).sort((v,h)=>{const E=v.offset-h.offset;return E===0?v.length-h.length:E}),d=C.length;for(let v=b.length-1;v>=0;v--){let h=b[v];if(h.offset+h.length<=d)C=P(C,h);else throw new Error("Overlapping edit");d=h.offset}return C}e.applyEdits=S}),define(te[2],ne([0,1,68,56]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let T=null;function i(t){T=t}if(e.setDisposableTracker=i,R){const t="__is_disposable_tracked__";i(new class{trackDisposable(o){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[t]||console.log(c)},3e3)}setParent(o,c){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsDisposed(o){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsSingleton(o){}})}function P(t){return T?.trackDisposable(t),t}function S(t){T?.markAsDisposed(t)}function C(t,o){T?.setParent(t,o)}function I(t,o){if(!!T)for(const c of t)T.setParent(c,o)}function b(t){return T?.markAsSingleton(t),t}e.markAsSingleton=b;class d extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=d;function v(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=v;function h(t){if(L.Iterable.is(t)){let o=[];for(const c of t)if(c)try{c.dispose()}catch(u){o.push(u)}if(o.length===1)throw o[0];if(o.length>1)throw new d(o);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function E(...t){const o=y(()=>h(t));return I(t,o),o}e.combinedDisposable=E;function y(t){const o=P({dispose:(0,D.once)(()=>{S(o),t()})});return o}e.toDisposable=y;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return C(o,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new m,P(this),C(this._store,this)}dispose(){S(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&C(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&C(o,null),o}}e.MutableDisposable=g;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(o,...c){let u=this.references.get(o);u||(u={counter:0,object:this.createReferencedObject(o,...c)},this.references.set(o,u));const{object:f}=u,p=(0,D.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(o,u.object),this.references.delete(o))});return u.counter++,{object:f,dispose:p}}}e.ReferenceCollection=l;class r{constructor(o){this.referenceCollection=o}async acquire(o,...c){const u=this.referenceCollection.acquire(o,...c);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(f){throw u.dispose(),f}}}e.AsyncReferenceCollection=r;class s{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=s;function n(t){const o=new m;try{t(o)}finally{o.dispose()}}e.disposeOnReturn=n}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class L{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const i=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=i}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,i){const P=new D(T);if(this._first===D.Undefined)this._first=P,this._last=P;else if(i){const C=this._last;this._last=P,P.prev=C,C.next=P}else{const C=this._first;this._first=P,P.next=C,C.prev=P}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const i=T.prev;i.next=T.next,T.next.prev=i}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=L}),function(){function J(R){const T=[];typeof R=="number"&&T.push("code/timeOrigin",R);function i(S){T.push(S,Date.now())}function P(){const S=[];for(let C=0;C<T.length;C+=2)S.push({name:T[C],startTime:T[C+1]});return S}return{mark:i,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const i of performance.getEntriesByType("mark"))T.push({name:i.name,startTime:Math.round(R+i.startTime)});return T}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let L=!1,R=!1,T=!1,i=!1,P=!1,S=!1,C=!1,I,b=D,d,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const E=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=E&&h?.sandboxed,typeof navigator=="object"&&!E)v=navigator.userAgent,L=v.indexOf("Windows")>=0,R=v.indexOf("Macintosh")>=0,C=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=v.indexOf("Linux")>=0,S=!0,I=navigator.language,b=I;else if(typeof h=="object"){L=h.platform==="win32",R=h.platform==="darwin",T=h.platform==="linux",i=T&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,I=D,b=D;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const t=JSON.parse(n),o=t.availableLanguages["*"];I=t.locale,b=o||D,d=t._translationsConfigFile}catch(t){}P=!0}else console.error("Unable to resolve platform.");var y;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function m(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let w=0;R?w=1:L?w=3:T&&(w=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=T,e.isLinuxSnap=i,e.isNative=P,e.isWeb=S,e.isIOS=C,e.platform=w,e.userAgent=v,e.language=b;var g;(function(n){function t(){return e.language}n.value=t;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=o;function c(){return e.language==="en"}n.isDefault=c})(g=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=d,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",o=>{if(o.data&&o.data.vscodeScheduleAsyncWork)for(let c=0,u=n.length;c<u;c++){const f=n[c];if(f.id===o.data.vscodeScheduleAsyncWork){n.splice(c,1),f.callback();return}}});let t=0;return o=>{const c=++t;n.push({id:c,callback:o}),e.globals.postMessage({vscodeScheduleAsyncWork:c},"*")}}return n=>setTimeout(n)})();var a;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||C?2:L?1:3;let l=!0,r=!1;function s(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,l=new Uint16Array(n.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=s}),define(te[32],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;L={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(te[10],ne([0,1,32]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,T=90,i=122,P=46,S=47,C=92,I=58,b=63;class d extends Error{constructor(a,l,r){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const n=a.indexOf(".")!==-1?"property":"argument";let t=`The "${a}" ${n} ${s} of type ${l}`;t+=`. Received type ${typeof r}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function v(g,a){if(typeof g!="string")throw new d(a,"string",g)}function h(g){return g===S||g===C}function E(g){return g===S}function y(g){return g>=L&&g<=T||g>=R&&g<=i}function m(g,a,l,r){let s="",n=0,t=-1,o=0,c=0;for(let u=0;u<=g.length;++u){if(u<g.length)c=g.charCodeAt(u);else{if(r(c))break;c=S}if(r(c)){if(!(t===u-1||o===1))if(o===2){if(s.length<2||n!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const f=s.lastIndexOf(l);f===-1?(s="",n=0):(s=s.slice(0,f),n=s.length-1-s.lastIndexOf(l)),t=u,o=0;continue}else if(s.length!==0){s="",n=0,t=u,o=0;continue}}a&&(s+=s.length>0?`${l}..`:"..",n=2)}else s.length>0?s+=`${l}${g.slice(t+1,u)}`:s=g.slice(t+1,u),n=u-t-1;t=u,o=0}else c===P&&o!==-1?++o:o=-1}return s}function w(g,a){if(a===null||typeof a!="object")throw new d("pathObject","Object",a);const l=a.dir||a.root,r=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${r}`:`${l}${g}${r}`:r}e.win32={resolve(...g){let a="",l="",r=!1;for(let s=g.length-1;s>=-1;s--){let n;if(s>=0){if(n=g[s],v(n,"path"),n.length===0)continue}else a.length===0?n=D.cwd():(n=D.env[`=${a}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==a.toLowerCase()&&n.charCodeAt(2)===C)&&(n=`${a}\\`));const t=n.length;let o=0,c="",u=!1;const f=n.charCodeAt(0);if(t===1)h(f)&&(o=1,u=!0);else if(h(f))if(u=!0,h(n.charCodeAt(1))){let p=2,k=p;for(;p<t&&!h(n.charCodeAt(p));)p++;if(p<t&&p!==k){const O=n.slice(k,p);for(k=p;p<t&&h(n.charCodeAt(p));)p++;if(p<t&&p!==k){for(k=p;p<t&&!h(n.charCodeAt(p));)p++;(p===t||p!==k)&&(c=`\\\\${O}\\${n.slice(k,p)}`,o=p)}}}else o=1;else y(f)&&n.charCodeAt(1)===I&&(c=n.slice(0,2),o=2,t>2&&h(n.charCodeAt(2))&&(u=!0,o=3));if(c.length>0)if(a.length>0){if(c.toLowerCase()!==a.toLowerCase())continue}else a=c;if(r){if(a.length>0)break}else if(l=`${n.slice(o)}\\${l}`,r=u,u&&a.length>0)break}return l=m(l,!r,"\\",h),r?`${a}\\${l}`:`${a}${l}`||"."},normalize(g){v(g,"path");const a=g.length;if(a===0)return".";let l=0,r,s=!1;const n=g.charCodeAt(0);if(a===1)return E(n)?"\\":g;if(h(n))if(s=!0,h(g.charCodeAt(1))){let o=2,c=o;for(;o<a&&!h(g.charCodeAt(o));)o++;if(o<a&&o!==c){const u=g.slice(c,o);for(c=o;o<a&&h(g.charCodeAt(o));)o++;if(o<a&&o!==c){for(c=o;o<a&&!h(g.charCodeAt(o));)o++;if(o===a)return`\\\\${u}\\${g.slice(c)}\\`;o!==c&&(r=`\\\\${u}\\${g.slice(c,o)}`,l=o)}}}else l=1;else y(n)&&g.charCodeAt(1)===I&&(r=g.slice(0,2),l=2,a>2&&h(g.charCodeAt(2))&&(s=!0,l=3));let t=l<a?m(g.slice(l),!s,"\\",h):"";return t.length===0&&!s&&(t="."),t.length>0&&h(g.charCodeAt(a-1))&&(t+="\\"),r===void 0?s?`\\${t}`:t:s?`${r}\\${t}`:`${r}${t}`},isAbsolute(g){v(g,"path");const a=g.length;if(a===0)return!1;const l=g.charCodeAt(0);return h(l)||a>2&&y(l)&&g.charCodeAt(1)===I&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let a,l;for(let n=0;n<g.length;++n){const t=g[n];v(t,"path"),t.length>0&&(a===void 0?a=l=t:a+=`\\${t}`)}if(a===void 0)return".";let r=!0,s=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++s;const n=l.length;n>1&&h(l.charCodeAt(1))&&(++s,n>2&&(h(l.charCodeAt(2))?++s:r=!1))}if(r){for(;s<a.length&&h(a.charCodeAt(s));)s++;s>=2&&(a=`\\${a.slice(s)}`)}return e.win32.normalize(a)},relative(g,a){if(v(g,"from"),v(a,"to"),g===a)return"";const l=e.win32.resolve(g),r=e.win32.resolve(a);if(l===r||(g=l.toLowerCase(),a=r.toLowerCase(),g===a))return"";let s=0;for(;s<g.length&&g.charCodeAt(s)===C;)s++;let n=g.length;for(;n-1>s&&g.charCodeAt(n-1)===C;)n--;const t=n-s;let o=0;for(;o<a.length&&a.charCodeAt(o)===C;)o++;let c=a.length;for(;c-1>o&&a.charCodeAt(c-1)===C;)c--;const u=c-o,f=t<u?t:u;let p=-1,k=0;for(;k<f;k++){const F=g.charCodeAt(s+k);if(F!==a.charCodeAt(o+k))break;F===C&&(p=k)}if(k!==f){if(p===-1)return r}else{if(u>f){if(a.charCodeAt(o+k)===C)return r.slice(o+k+1);if(k===2)return r.slice(o+k)}t>f&&(g.charCodeAt(s+k)===C?p=k:k===2&&(p=3)),p===-1&&(p=0)}let O="";for(k=s+p+1;k<=n;++k)(k===n||g.charCodeAt(k)===C)&&(O+=O.length===0?"..":"\\..");return o+=p,O.length>0?`${O}${r.slice(o,c)}`:(r.charCodeAt(o)===C&&++o,r.slice(o,c))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const a=e.win32.resolve(g);if(a.length<=2)return g;if(a.charCodeAt(0)===C){if(a.charCodeAt(1)===C){const l=a.charCodeAt(2);if(l!==b&&l!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(y(a.charCodeAt(0))&&a.charCodeAt(1)===I&&a.charCodeAt(2)===C)return`\\\\?\\${a}`;return g},dirname(g){v(g,"path");const a=g.length;if(a===0)return".";let l=-1,r=0;const s=g.charCodeAt(0);if(a===1)return h(s)?g:".";if(h(s)){if(l=r=1,h(g.charCodeAt(1))){let o=2,c=o;for(;o<a&&!h(g.charCodeAt(o));)o++;if(o<a&&o!==c){for(c=o;o<a&&h(g.charCodeAt(o));)o++;if(o<a&&o!==c){for(c=o;o<a&&!h(g.charCodeAt(o));)o++;if(o===a)return g;o!==c&&(l=r=o+1)}}}}else y(s)&&g.charCodeAt(1)===I&&(l=a>2&&h(g.charCodeAt(2))?3:2,r=l);let n=-1,t=!0;for(let o=a-1;o>=r;--o)if(h(g.charCodeAt(o))){if(!t){n=o;break}}else t=!1;if(n===-1){if(l===-1)return".";n=l}return g.slice(0,n)},basename(g,a){a!==void 0&&v(a,"ext"),v(g,"path");let l=0,r=-1,s=!0,n;if(g.length>=2&&y(g.charCodeAt(0))&&g.charCodeAt(1)===I&&(l=2),a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let t=a.length-1,o=-1;for(n=g.length-1;n>=l;--n){const c=g.charCodeAt(n);if(h(c)){if(!s){l=n+1;break}}else o===-1&&(s=!1,o=n+1),t>=0&&(c===a.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=o))}return l===r?r=o:r===-1&&(r=g.length),g.slice(l,r)}for(n=g.length-1;n>=l;--n)if(h(g.charCodeAt(n))){if(!s){l=n+1;break}}else r===-1&&(s=!1,r=n+1);return r===-1?"":g.slice(l,r)},extname(g){v(g,"path");let a=0,l=-1,r=0,s=-1,n=!0,t=0;g.length>=2&&g.charCodeAt(1)===I&&y(g.charCodeAt(0))&&(a=r=2);for(let o=g.length-1;o>=a;--o){const c=g.charCodeAt(o);if(h(c)){if(!n){r=o+1;break}continue}s===-1&&(n=!1,s=o+1),c===P?l===-1?l=o:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||s===-1||t===0||t===1&&l===s-1&&l===r+1?"":g.slice(l,s)},format:w.bind(null,"\\"),parse(g){v(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const l=g.length;let r=0,s=g.charCodeAt(0);if(l===1)return h(s)?(a.root=a.dir=g,a):(a.base=a.name=g,a);if(h(s)){if(r=1,h(g.charCodeAt(1))){let p=2,k=p;for(;p<l&&!h(g.charCodeAt(p));)p++;if(p<l&&p!==k){for(k=p;p<l&&h(g.charCodeAt(p));)p++;if(p<l&&p!==k){for(k=p;p<l&&!h(g.charCodeAt(p));)p++;p===l?r=p:p!==k&&(r=p+1)}}}}else if(y(s)&&g.charCodeAt(1)===I){if(l<=2)return a.root=a.dir=g,a;if(r=2,h(g.charCodeAt(2))){if(l===3)return a.root=a.dir=g,a;r=3}}r>0&&(a.root=g.slice(0,r));let n=-1,t=r,o=-1,c=!0,u=g.length-1,f=0;for(;u>=r;--u){if(s=g.charCodeAt(u),h(s)){if(!c){t=u+1;break}continue}o===-1&&(c=!1,o=u+1),s===P?n===-1?n=u:f!==1&&(f=1):n!==-1&&(f=-1)}return o!==-1&&(n===-1||f===0||f===1&&n===o-1&&n===t+1?a.base=a.name=g.slice(t,o):(a.name=g.slice(t,n),a.base=g.slice(t,o),a.ext=g.slice(n,o))),t>0&&t!==r?a.dir=g.slice(0,t-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let a="",l=!1;for(let r=g.length-1;r>=-1&&!l;r--){const s=r>=0?g[r]:D.cwd();v(s,"path"),s.length!==0&&(a=`${s}/${a}`,l=s.charCodeAt(0)===S)}return a=m(a,!l,"/",E),l?`/${a}`:a.length>0?a:"."},normalize(g){if(v(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===S,l=g.charCodeAt(g.length-1)===S;return g=m(g,!a,"/",E),g.length===0?a?"/":l?"./":".":(l&&(g+="/"),a?`/${g}`:g)},isAbsolute(g){return v(g,"path"),g.length>0&&g.charCodeAt(0)===S},join(...g){if(g.length===0)return".";let a;for(let l=0;l<g.length;++l){const r=g[l];v(r,"path"),r.length>0&&(a===void 0?a=r:a+=`/${r}`)}return a===void 0?".":e.posix.normalize(a)},relative(g,a){if(v(g,"from"),v(a,"to"),g===a||(g=e.posix.resolve(g),a=e.posix.resolve(a),g===a))return"";const l=1,r=g.length,s=r-l,n=1,t=a.length-n,o=s<t?s:t;let c=-1,u=0;for(;u<o;u++){const p=g.charCodeAt(l+u);if(p!==a.charCodeAt(n+u))break;p===S&&(c=u)}if(u===o)if(t>o){if(a.charCodeAt(n+u)===S)return a.slice(n+u+1);if(u===0)return a.slice(n+u)}else s>o&&(g.charCodeAt(l+u)===S?c=u:u===0&&(c=0));let f="";for(u=l+c+1;u<=r;++u)(u===r||g.charCodeAt(u)===S)&&(f+=f.length===0?"..":"/..");return`${f}${a.slice(n+c)}`},toNamespacedPath(g){return g},dirname(g){if(v(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===S;let l=-1,r=!0;for(let s=g.length-1;s>=1;--s)if(g.charCodeAt(s)===S){if(!r){l=s;break}}else r=!1;return l===-1?a?"/":".":a&&l===1?"//":g.slice(0,l)},basename(g,a){a!==void 0&&v(a,"ext"),v(g,"path");let l=0,r=-1,s=!0,n;if(a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let t=a.length-1,o=-1;for(n=g.length-1;n>=0;--n){const c=g.charCodeAt(n);if(c===S){if(!s){l=n+1;break}}else o===-1&&(s=!1,o=n+1),t>=0&&(c===a.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=o))}return l===r?r=o:r===-1&&(r=g.length),g.slice(l,r)}for(n=g.length-1;n>=0;--n)if(g.charCodeAt(n)===S){if(!s){l=n+1;break}}else r===-1&&(s=!1,r=n+1);return r===-1?"":g.slice(l,r)},extname(g){v(g,"path");let a=-1,l=0,r=-1,s=!0,n=0;for(let t=g.length-1;t>=0;--t){const o=g.charCodeAt(t);if(o===S){if(!s){l=t+1;break}continue}r===-1&&(s=!1,r=t+1),o===P?a===-1?a=t:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||r===-1||n===0||n===1&&a===r-1&&a===l+1?"":g.slice(a,r)},format:w.bind(null,"/"),parse(g){v(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const l=g.charCodeAt(0)===S;let r;l?(a.root="/",r=1):r=0;let s=-1,n=0,t=-1,o=!0,c=g.length-1,u=0;for(;c>=r;--c){const f=g.charCodeAt(c);if(f===S){if(!o){n=c+1;break}continue}t===-1&&(o=!1,t=c+1),f===P?s===-1?s=c:u!==1&&(u=1):s!==-1&&(u=-1)}if(t!==-1){const f=n===0&&l?1:n;s===-1||u===0||u===1&&s===t-1&&s===n+1?a.base=a.name=g.slice(f,t):(a.name=g.slice(f,s),a.base=g.slice(f,t),a.ext=g.slice(s,t))}return n>0?a.dir=g.slice(0,n-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var L;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(T,...i){const P=i.reduce((I,b)=>(I[b]=!0,I),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(I=>!P[I]).forEach(I=>{for(let b=0;b<S.length;b++)if(I.search(S[b])!==-1){delete T[I];break}})}e.sanitizeProcessEnvironment=R}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:J)[L]=D[L]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function D(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return J[L].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=J,D.c=e,D.d=function(L,R,T){D.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:T})},D.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,R){if(1&R&&(L=D(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var i in L)D.d(T,i,function(P){return L[P]}.bind(null,i));return T},D.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(R,"a",R),R},D.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},D.p="",D(D.s=0)}([function(J,e,D){(function(L){var R;e=J.exports=K,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,i=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],C=0,I=C++;S[I]="0|[1-9]\\d*";var b=C++;S[b]="[0-9]+";var d=C++;S[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=C++;S[v]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var h=C++;S[h]="("+S[b]+")\\.("+S[b]+")\\.("+S[b]+")";var E=C++;S[E]="(?:"+S[I]+"|"+S[d]+")";var y=C++;S[y]="(?:"+S[b]+"|"+S[d]+")";var m=C++;S[m]="(?:-("+S[E]+"(?:\\."+S[E]+")*))";var w=C++;S[w]="(?:-?("+S[y]+"(?:\\."+S[y]+")*))";var g=C++;S[g]="[0-9A-Za-z-]+";var a=C++;S[a]="(?:\\+("+S[g]+"(?:\\."+S[g]+")*))";var l=C++,r="v?"+S[v]+S[m]+"?"+S[a]+"?";S[l]="^"+r+"$";var s="[v=\\s]*"+S[h]+S[w]+"?"+S[a]+"?",n=C++;S[n]="^"+s+"$";var t=C++;S[t]="((?:<|>)?=?)";var o=C++;S[o]=S[b]+"|x|X|\\*";var c=C++;S[c]=S[I]+"|x|X|\\*";var u=C++;S[u]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[m]+")?"+S[a]+"?)?)?";var f=C++;S[f]="[v=\\s]*("+S[o]+")(?:\\.("+S[o]+")(?:\\.("+S[o]+")(?:"+S[w]+")?"+S[a]+"?)?)?";var p=C++;S[p]="^"+S[t]+"\\s*"+S[u]+"$";var k=C++;S[k]="^"+S[t]+"\\s*"+S[f]+"$";var O=C++;S[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=C++;S[F]="(?:~>?)";var W=C++;S[W]="(\\s*)"+S[F]+"\\s+",P[W]=new RegExp(S[W],"g");var $=C++;S[$]="^"+S[F]+S[u]+"$";var A=C++;S[A]="^"+S[F]+S[f]+"$";var q=C++;S[q]="(?:\\^)";var _=C++;S[_]="(\\s*)"+S[q]+"\\s+",P[_]=new RegExp(S[_],"g");var M=C++;S[M]="^"+S[q]+S[u]+"$";var B=C++;S[B]="^"+S[q]+S[f]+"$";var Z=C++;S[Z]="^"+S[t]+"\\s*("+s+")$|^$";var H=C++;S[H]="^"+S[t]+"\\s*("+r+")$|^$";var j=C++;S[j]="(\\s*)"+S[t]+"\\s*("+s+"|"+S[u]+")",P[j]=new RegExp(S[j],"g");var Q=C++;S[Q]="^\\s*("+S[u]+")\\s+-\\s+("+S[u]+")\\s*$";var U=C++;S[U]="^\\s*("+S[f]+")\\s+-\\s+("+S[f]+")\\s*$";var N=C++;S[N]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)R(z,S[z]),P[z]||(P[z]=new RegExp(S[z]));function x(ie,ae){if(ie instanceof K)return ie;if(typeof ie!="string"||ie.length>T||!(ae?P[n]:P[l]).test(ie))return null;try{return new K(ie,ae)}catch(ce){return null}}function K(ie,ae){if(ie instanceof K){if(ie.loose===ae)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof K))return new K(ie,ae);R("SemVer",ie,ae),this.loose=ae;var ce=ie.trim().match(ae?P[n]:P[l]);if(!ce)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Pe=+ye;if(Pe>=0&&Pe<i)return Pe}return ye}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=x,e.valid=function(ie,ae){var ce=x(ie,ae);return ce?ce.version:null},e.clean=function(ie,ae){var ce=x(ie.trim().replace(/^[=v]+/,""),ae);return ce?ce.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ie){return R("SemVer.compare",this.version,this.loose,ie),ie instanceof K||(ie=new K(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},K.prototype.compareMain=function(ie){return ie instanceof K||(ie=new K(ie,this.loose)),V(this.major,ie.major)||V(this.minor,ie.minor)||V(this.patch,ie.patch)},K.prototype.comparePre=function(ie){if(ie instanceof K||(ie=new K(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ae=0;do{var ce=this.prerelease[ae],ye=ie.prerelease[ae];if(R("prerelease compare",ae,ce,ye),ce===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ce===void 0)return-1;if(ce!==ye)return V(ce,ye)}while(++ae)},K.prototype.inc=function(ie,ae){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ae,ce,ye){typeof ce=="string"&&(ye=ce,ce=void 0);try{return new K(ie,ce).inc(ae,ye).version}catch(Pe){return null}},e.diff=function(ie,ae){if(le(ie,ae))return null;var ce=x(ie),ye=x(ae);if(ce.prerelease.length||ye.prerelease.length){for(var Pe in ce)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ce[Pe]!==ye[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ce)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ce[Pe]!==ye[Pe])return Pe},e.compareIdentifiers=V;var ee=/^[0-9]+$/;function V(ie,ae){var ce=ee.test(ie),ye=ee.test(ae);return ce&&ye&&(ie=+ie,ae=+ae),ce&&!ye?-1:ye&&!ce?1:ie<ae?-1:ie>ae?1:0}function X(ie,ae,ce){return new K(ie,ce).compare(new K(ae,ce))}function se(ie,ae,ce){return X(ie,ae,ce)>0}function oe(ie,ae,ce){return X(ie,ae,ce)<0}function le(ie,ae,ce){return X(ie,ae,ce)===0}function he(ie,ae,ce){return X(ie,ae,ce)!==0}function be(ie,ae,ce){return X(ie,ae,ce)>=0}function Ce(ie,ae,ce){return X(ie,ae,ce)<=0}function we(ie,ae,ce,ye){var Pe;switch(ae){case"===":typeof ie=="object"&&(ie=ie.version),typeof ce=="object"&&(ce=ce.version),Pe=ie===ce;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof ce=="object"&&(ce=ce.version),Pe=ie!==ce;break;case"":case"=":case"==":Pe=le(ie,ce,ye);break;case"!=":Pe=he(ie,ce,ye);break;case">":Pe=se(ie,ce,ye);break;case">=":Pe=be(ie,ce,ye);break;case"<":Pe=oe(ie,ce,ye);break;case"<=":Pe=Ce(ie,ce,ye);break;default:throw new TypeError("Invalid operator: "+ae)}return Pe}function ve(ie,ae){if(ie instanceof ve){if(ie.loose===ae)return ie;ie=ie.value}if(!(this instanceof ve))return new ve(ie,ae);R("comparator",ie,ae),this.loose=ae,this.parse(ie),this.semver===De?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ie,ae){return V(ae,ie)},e.major=function(ie,ae){return new K(ie,ae).major},e.minor=function(ie,ae){return new K(ie,ae).minor},e.patch=function(ie,ae){return new K(ie,ae).patch},e.compare=X,e.compareLoose=function(ie,ae){return X(ie,ae,!0)},e.rcompare=function(ie,ae,ce){return X(ae,ie,ce)},e.sort=function(ie,ae){return ie.sort(function(ce,ye){return e.compare(ce,ye,ae)})},e.rsort=function(ie,ae){return ie.sort(function(ce,ye){return e.rcompare(ce,ye,ae)})},e.gt=se,e.lt=oe,e.eq=le,e.neq=he,e.gte=be,e.lte=Ce,e.cmp=we,e.Comparator=ve;var De={};function Se(ie,ae){if(ie instanceof Se)return ie.loose===ae?ie:new Se(ie.raw,ae);if(ie instanceof ve)return new Se(ie.value,ae);if(!(this instanceof Se))return new Se(ie,ae);if(this.loose=ae,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function Ie(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function Me(ie,ae,ce,ye,Pe,_e,Te,Fe,Ae,Ue,Y,re,ue){return((ae=Ie(ce)?"":Ie(ye)?">="+ce+".0.0":Ie(Pe)?">="+ce+"."+ye+".0":">="+ae)+" "+(Fe=Ie(Ae)?"":Ie(Ue)?"<"+(+Ae+1)+".0.0":Ie(Y)?"<"+Ae+"."+(+Ue+1)+".0":re?"<="+Ae+"."+Ue+"."+Y+"-"+re:"<="+Fe)).trim()}function je(ie,ae){for(var ce=0;ce<ie.length;ce++)if(!ie[ce].test(ae))return!1;if(ae.prerelease.length){for(ce=0;ce<ie.length;ce++)if(R(ie[ce].semver),ie[ce].semver!==De&&ie[ce].semver.prerelease.length>0){var ye=ie[ce].semver;if(ye.major===ae.major&&ye.minor===ae.minor&&ye.patch===ae.patch)return!0}return!1}return!0}function Ne(ie,ae,ce){try{ae=new Se(ae,ce)}catch(ye){return!1}return ae.test(ie)}function We(ie,ae,ce,ye){var Pe,_e,Te,Fe,Ae;switch(ie=new K(ie,ye),ae=new Se(ae,ye),ce){case">":Pe=se,_e=Ce,Te=oe,Fe=">",Ae=">=";break;case"<":Pe=oe,_e=be,Te=se,Fe="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ie,ae,ye))return!1;for(var Ue=0;Ue<ae.set.length;++Ue){var Y=ae.set[Ue],re=null,ue=null;if(Y.forEach(function(fe){fe.semver===De&&(fe=new ve(">=0.0.0")),re=re||fe,ue=ue||fe,Pe(fe.semver,re.semver,ye)?re=fe:Te(fe.semver,ue.semver,ye)&&(ue=fe)}),re.operator===Fe||re.operator===Ae||(!ue.operator||ue.operator===Fe)&&_e(ie,ue.semver)||ue.operator===Ae&&Te(ie,ue.semver))return!1}return!0}ve.prototype.parse=function(ie){var ae=this.loose?P[Z]:P[H],ce=ie.match(ae);if(!ce)throw new TypeError("Invalid comparator: "+ie);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new K(ce[2],this.loose):this.semver=De},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ie){return R("Comparator.test",ie,this.loose),this.semver===De||(typeof ie=="string"&&(ie=new K(ie,this.loose)),we(ie,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ie,ae){if(!(ie instanceof ve))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new Se(ie.value,ae),Ne(this.value,ce,ae);if(ie.operator==="")return ce=new Se(this.value,ae),Ne(ie.semver,ce,ae);var ye=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),_e=this.semver.version===ie.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Fe=we(this.semver,"<",ie.semver,ae)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),Ae=we(this.semver,">",ie.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return ye||Pe||_e&&Te||Fe||Ae},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(ie){var ae=this.loose;ie=ie.trim(),R("range",ie,ae);var ce=ae?P[U]:P[Q];ie=ie.replace(ce,Me),R("hyphen replace",ie),ie=ie.replace(P[j],"$1$2$3"),R("comparator trim",ie,P[j]),ie=(ie=(ie=ie.replace(P[W],"$1~")).replace(P[_],"$1^")).split(/\s+/).join(" ");var ye=ae?P[Z]:P[H],Pe=ie.split(" ").map(function(_e){return function(Te,Fe){return R("comp",Te),Te=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(Y){return function(re,ue){R("caret",re,ue);var fe=ue?P[B]:P[M];return re.replace(fe,function(pe,ge,Ee,Re,ke){var Le;return R("caret",re,pe,ge,Ee,Re,ke),Ie(ge)?Le="":Ie(Ee)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(Re)?Le=ge==="0"?">="+ge+"."+Ee+".0 <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+".0 <"+(+ge+1)+".0.0":ke?(R("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=ge==="0"?Ee==="0"?">="+ge+"."+Ee+"."+Re+ke+" <"+ge+"."+Ee+"."+(+Re+1):">="+ge+"."+Ee+"."+Re+ke+" <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+"."+Re+ke+" <"+(+ge+1)+".0.0"):(R("no pr"),Le=ge==="0"?Ee==="0"?">="+ge+"."+Ee+"."+Re+" <"+ge+"."+Ee+"."+(+Re+1):">="+ge+"."+Ee+"."+Re+" <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+"."+Re+" <"+(+ge+1)+".0.0"),R("caret return",Le),Le})}(Y,Ue)}).join(" ")}(Te,Fe),R("caret",Te),Te=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(Y){return function(re,ue){var fe=ue?P[A]:P[$];return re.replace(fe,function(pe,ge,Ee,Re,ke){var Le;return R("tilde",re,pe,ge,Ee,Re,ke),Ie(ge)?Le="":Ie(Ee)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(Re)?Le=">="+ge+"."+Ee+".0 <"+ge+"."+(+Ee+1)+".0":ke?(R("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=">="+ge+"."+Ee+"."+Re+ke+" <"+ge+"."+(+Ee+1)+".0"):Le=">="+ge+"."+Ee+"."+Re+" <"+ge+"."+(+Ee+1)+".0",R("tilde return",Le),Le})}(Y,Ue)}).join(" ")}(Te,Fe),R("tildes",Te),Te=function(Ae,Ue){return R("replaceXRanges",Ae,Ue),Ae.split(/\s+/).map(function(Y){return function(re,ue){re=re.trim();var fe=ue?P[k]:P[p];return re.replace(fe,function(pe,ge,Ee,Re,ke,Le){R("xRange",re,pe,ge,Ee,Re,ke,Le);var $e=Ie(Ee),Ye=$e||Ie(Re),He=Ye||Ie(ke);return ge==="="&&He&&(ge=""),$e?pe=ge===">"||ge==="<"?"<0.0.0":"*":ge&&He?(Ye&&(Re=0),He&&(ke=0),ge===">"?(ge=">=",Ye?(Ee=+Ee+1,Re=0,ke=0):He&&(Re=+Re+1,ke=0)):ge==="<="&&(ge="<",Ye?Ee=+Ee+1:Re=+Re+1),pe=ge+Ee+"."+Re+"."+ke):Ye?pe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":He&&(pe=">="+Ee+"."+Re+".0 <"+Ee+"."+(+Re+1)+".0"),R("xRange return",pe),pe})}(Y,Ue)}).join(" ")}(Te,Fe),R("xrange",Te),Te=function(Ae,Ue){return R("replaceStars",Ae,Ue),Ae.trim().replace(P[N],"")}(Te,Fe),R("stars",Te),Te}(_e,ae)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(_e){return!!_e.match(ye)})),Pe=Pe.map(function(_e){return new ve(_e,ae)})},Se.prototype.intersects=function(ie,ae){if(!(ie instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ye){return ie.set.some(function(Pe){return Pe.every(function(_e){return ye.intersects(_e,ae)})})})})},e.toComparators=function(ie,ae){return new Se(ie,ae).set.map(function(ce){return ce.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new K(ie,this.loose));for(var ae=0;ae<this.set.length;ae++)if(je(this.set[ae],ie))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ie,ae,ce){var ye=null,Pe=null;try{var _e=new Se(ae,ce)}catch(Te){return null}return ie.forEach(function(Te){_e.test(Te)&&(ye&&Pe.compare(Te)!==-1||(Pe=new K(ye=Te,ce)))}),ye},e.minSatisfying=function(ie,ae,ce){var ye=null,Pe=null;try{var _e=new Se(ae,ce)}catch(Te){return null}return ie.forEach(function(Te){_e.test(Te)&&(ye&&Pe.compare(Te)!==1||(Pe=new K(ye=Te,ce)))}),ye},e.validRange=function(ie,ae){try{return new Se(ie,ae).range||"*"}catch(ce){return null}},e.ltr=function(ie,ae,ce){return We(ie,ae,"<",ce)},e.gtr=function(ie,ae,ce){return We(ie,ae,">",ce)},e.outside=We,e.prerelease=function(ie,ae){var ce=x(ie,ae);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(ie,ae,ce){return ie=new Se(ie,ce),ae=new Se(ae,ce),ie.intersects(ae)},e.coerce=function(ie){if(ie instanceof K)return ie;if(typeof ie!="string")return null;var ae=ie.match(P[O]);return ae==null?null:x((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(J,e){var D,L,R=J.exports={};function T(){throw new Error("setTimeout has not been defined")}function i(){throw new Error("clearTimeout has not been defined")}function P(y){if(D===setTimeout)return setTimeout(y,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(y,0);try{return D(y,0)}catch(m){try{return D.call(null,y,0)}catch(w){return D.call(this,y,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch(y){D=T}try{L=typeof clearTimeout=="function"?clearTimeout:i}catch(y){L=i}})();var S,C=[],I=!1,b=-1;function d(){I&&S&&(I=!1,S.length?C=S.concat(C):b=-1,C.length&&v())}function v(){if(!I){var y=P(d);I=!0;for(var m=C.length;m;){for(S=C,C=[];++b<m;)S&&S[b].run();b=-1,m=C.length}S=null,I=!1,function(w){if(L===clearTimeout)return clearTimeout(w);if((L===i||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(w);try{L(w)}catch(g){try{return L.call(null,w)}catch(a){return L.call(this,w)}}}(y)}}function h(y,m){this.fun=y,this.array=m}function E(){}R.nextTick=function(y){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];C.push(new h(y,m)),C.length!==1||I||P(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=E,R.addListener=E,R.once=E,R.off=E,R.removeListener=E,R.removeAllListeners=E,R.emit=E,R.prependListener=E,R.prependOnceListener=E,R.listeners=function(y){return[]},R.binding=function(y){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(y){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[103],ne([0,1]),function(J,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(P,S,C){this.level=P,this.key=S,this.value=C,this.forward=[]}}const R=void 0;class T{constructor(P,S=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new L(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,R,R)}has(P){return Boolean(T._search(this,P,this.comparator))}get(P){return T._search(this,P,this.comparator)?.value}set(P,S){return T._insert(this,P,S,this.comparator)&&(this._size+=1),this}delete(P){const S=T._delete(this,P,this.comparator);return S&&(this._size-=1),S}forEach(P,S){let C=this._header.forward[0];for(;C;)P.call(S,C.value,C.key,this),C=C.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",S=this._header.forward[0];for(;S;)P+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return P}static _search(P,S,C){let I=P._header;for(let b=P._level-1;b>=0;b--)for(;I.forward[b]&&C(I.forward[b].key,S)<0;)I=I.forward[b];if(I=I.forward[0],I&&C(I.key,S)===0)return I}static _insert(P,S,C,I){let b=[],d=P._header;for(let v=P._level-1;v>=0;v--){for(;d.forward[v]&&I(d.forward[v].key,S)<0;)d=d.forward[v];b[v]=d}if(d=d.forward[0],d&&I(d.key,S)===0)return d.value=C,!1;{let v=T._randomLevel(P);if(v>P._level){for(let h=P._level;h<v;h++)b[h]=P._header;P._level=v}d=new L(v,S,C);for(let h=0;h<v;h++)d.forward[h]=b[h].forward[h],b[h].forward[h]=d;return!0}}static _randomLevel(P,S=.5){let C=1;for(;Math.random()<S&&C<P._maxLevel;)C+=1;return C}static _delete(P,S,C){let I=[],b=P._header;for(let d=P._level-1;d>=0;d--){for(;b.forward[d]&&C(b.forward[d].key,S)<0;)b=b.forward[d];I[d]=b}if(b=b.forward[0],!b||C(b.key,S)!==0)return!1;for(let d=0;d<P._level&&I[d].forward[d]===b;d++)I[d].forward[d]=b.forward[d];for(;P._level>0&&P._header.forward[P._level-1]===R;)P._level-=1;return!0}}e.SkipList=T}),define(te[104],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(i){this._highResolution=L&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new R(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(te[3],ne([0,1,9,68,2,101,104]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(a){a.None=()=>R.Disposable.None;function l(_){return(M,B=null,Z)=>{let H=!1,j;return j=_(Q=>{if(!H)return j?j.dispose():H=!0,M.call(B,Q)},null,Z),H&&j.dispose(),j}}a.once=l;function r(_,M){return u((B,Z=null,H)=>_(j=>B.call(Z,M(j)),null,H))}a.map=r;function s(_,M){return u((B,Z=null,H)=>_(j=>{M(j),B.call(Z,j)},null,H))}a.forEach=s;function n(_,M){return u((B,Z=null,H)=>_(j=>M(j)&&B.call(Z,j),null,H))}a.filter=n;function t(_){return _}a.signal=t;function o(..._){return(M,B=null,Z)=>(0,R.combinedDisposable)(..._.map(H=>H(j=>M.call(B,j),null,Z)))}a.any=o;function c(_,M,B){let Z=B;return r(_,H=>(Z=M(Z,H),Z))}a.reduce=c;function u(_){let M;const B=new d({onFirstListenerAdd(){M=_(B.fire,B)},onLastListenerRemove(){M.dispose()}});return B.event}function f(_,M,B=100,Z=!1,H){let j,Q,U,N=0;const z=new d({leakWarningThreshold:H,onFirstListenerAdd(){j=_(x=>{N++,Q=M(Q,x),Z&&!U&&(z.fire(Q),Q=void 0),clearTimeout(U),U=setTimeout(()=>{const K=Q;Q=void 0,U=void 0,(!Z||N>1)&&z.fire(K),N=0},B)})},onLastListenerRemove(){j.dispose()}});return z.event}a.debounce=f;function p(_,M=(B,Z)=>B===Z){let B=!0,Z;return n(_,H=>{const j=B||!M(H,Z);return B=!1,Z=H,j})}a.latch=p;function k(_,M){return[a.filter(_,M),a.filter(_,B=>!M(B))]}a.split=k;function O(_,M=!1,B=[]){let Z=B.slice(),H=_(U=>{Z?Z.push(U):Q.fire(U)});const j=()=>{Z&&Z.forEach(U=>Q.fire(U)),Z=null},Q=new d({onFirstListenerAdd(){H||(H=_(U=>Q.fire(U)))},onFirstListenerDidAdd(){Z&&(M?setTimeout(j):j())},onLastListenerRemove(){H&&H.dispose(),H=null}});return Q.event}a.buffer=O;class F{constructor(M){this.event=M}map(M){return new F(r(this.event,M))}forEach(M){return new F(s(this.event,M))}filter(M){return new F(n(this.event,M))}reduce(M,B){return new F(c(this.event,M,B))}latch(){return new F(p(this.event))}debounce(M,B=100,Z=!1,H){return new F(f(this.event,M,B,Z,H))}on(M,B,Z){return this.event(M,B,Z)}once(M,B,Z){return l(this.event)(M,B,Z)}}function W(_){return new F(_)}a.chain=W;function $(_,M,B=Z=>Z){const Z=(...U)=>Q.fire(B(...U)),H=()=>_.on(M,Z),j=()=>_.removeListener(M,Z),Q=new d({onFirstListenerAdd:H,onLastListenerRemove:j});return Q.event}a.fromNodeEventEmitter=$;function A(_,M,B=Z=>Z){const Z=(...U)=>Q.fire(B(...U)),H=()=>_.addEventListener(M,Z),j=()=>_.removeEventListener(M,Z),Q=new d({onFirstListenerAdd:H,onLastListenerRemove:j});return Q.event}a.fromDOMEventEmitter=A;function q(_){return new Promise(M=>l(_)(M))}a.toPromise=q})(P=e.Event||(e.Event={}));class S{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${S._idPool++}`}start(l){this._stopWatch=new i.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let C=-1;function I(a){const l=C;return C=a,{dispose(){C=l}}}e.setGlobalLeakWarningThreshold=I;class b{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=C;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(s)||0;if(this._stacks.set(s,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,o=0;for(const[c,u]of this._stacks)(!t||o<u)&&(t=c,o=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${o}):`),console.warn(t)}return()=>{const t=this._stacks.get(s)||0;this._stacks.set(s,t-1)}}}class d{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=C>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,s)=>{this._listeners||(this._listeners=new T.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const o=this._leakageMon?.check(this._listeners.size),c=(0,R.toDisposable)(()=>{o&&o(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof R.DisposableStore?s.add(c):Array.isArray(s)&&s.push(c),c}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,s]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,s):r[0].call(r[1],s)}catch(n){(0,D.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class v extends d{async fireAsync(l,r,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),o=[],c={...t,waitUntil:u=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof n=="function"?n:n[0])),o.push(u)}};try{typeof n=="function"?n.call(void 0,c):n[0].call(n[1],c)}catch(u){(0,D.onUnexpectedError)(u);continue}Object.freeze(o),await Promise.allSettled(o).then(u=>{for(const f of u)f.status==="rejected"&&(0,D.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=v;class h extends d{constructor(l){super(l);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class E extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=E;class y extends d{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const s=()=>{this.hasListeners&&this.unhook(r);const n=this.events.indexOf(r);this.events.splice(n,1)};return(0,R.toDisposable)((0,L.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,s,n)=>l(t=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>r.call(s,t)):r.call(s,t)},void 0,n)}bufferEvents(l){const r=[];this.buffers.push(r);const s=l();return this.buffers.pop(),r.forEach(n=>n()),s}}e.EventBufferer=w;class g{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(te[27],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,S){const C=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(C)}}});var R;(function(P){function S(C){return C===P.None||C===P.Cancelled||C instanceof T?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=R.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=i}),define(te[49],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(I){const b=this._icons.get(I.id);b?I.description?b.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function T(C){return C?C.replace(/\$\((.*?)\)/g,(I,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=T;class i{constructor(I,b,d){this.id=I,this.definition=b,this.description=d,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function P(C,I){const b=["codicon","codicon-"+C];return I&&b.push("codicon-modifier-"+I),b}e.getClassNamesArray=P;var S;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function b(h){if(h instanceof i)return["codicon","codicon-"+h.id];const E=I.exec(h.id);if(!E)return b(i.error);let[,y,m]=E;const w=["codicon","codicon-"+y];return m&&w.push("codicon-modifier-"+m.substr(1)),w}C.asClassNameArray=b;function d(h){return b(h).join(" ")}C.asClassName=d;function v(h){return"."+b(h).join(".")}C.asCSSSelector=v})(S=e.CSSIcon||(e.CSSIcon={}))}),define(te[50],ne([0,1,9,2]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(g){const a=g;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=R;function T(g){const a=g;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=T;function i(g,a){return new P(g,a)}e.newWriteableStream=i;class P{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,D.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let r;switch(a){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const s=r.indexOf(l);s>=0&&r.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(g,a){const l=[];let r;for(;(r=g.read())!==null;)l.push(r);return a(l)}e.consumeReadable=S;function C(g,a,l){const r=[];let s;for(;(s=g.read())!==null&&r.length<l;)r.push(s);return s===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s!="undefined"){const n=s;return s=void 0,n}return g.read()}}}e.peekReadable=C;function I(g,a){return new Promise((l,r)=>{const s=[];b(g,{onData:n=>{a&&s.push(n)},onError:n=>{a?r(n):l(void 0)},onEnd:()=>{l(a?a(s):void 0)}})})}e.consumeStream=I;function b(g,a){g.on("error",l=>a.onError(l)),g.on("end",()=>a.onEnd()),g.on("data",l=>a.onData(l))}e.listenStream=b;function d(g,a){return new Promise((l,r)=>{const s=new L.DisposableStore,n=[],t=u=>{if(n.push(u),n.length>a)return s.dispose(),g.pause(),l({stream:g,buffer:n,ended:!1})},o=u=>r(u),c=()=>l({stream:g,buffer:n,ended:!0});s.add((0,L.toDisposable)(()=>g.removeListener("error",o))),g.on("error",o),s.add((0,L.toDisposable)(()=>g.removeListener("end",c))),g.on("end",c),s.add((0,L.toDisposable)(()=>g.removeListener("data",t))),g.on("data",t)})}e.peekStream=d;function v(g,a){const l=i(a);return l.end(g),l}e.toStream=v;function h(){const g=i(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=h;function E(g){let a=!1;return{read:()=>a?null:(a=!0,g)}}e.toReadable=E;function y(g,a,l){const r=i(l);return b(g,{onData:s=>r.write(a.data(s)),onError:s=>r.error(a.error?a.error(s):s),onEnd:()=>r.end()}),r}e.transform=y;function m(g,a,l){let r=!1;return{read:()=>{const s=a.read();return r?s:(r=!0,s!==null?l([g,s]):g)}}}e.prefixedReadable=m;function w(g,a,l){let r=!1;const s=i(l);return b(a,{onData:n=>r?s.write(n):(r=!0,s.write(l([g,n]))),onError:n=>s.error(n),onEnd:()=>{r||(r=!0,s.write(g)),s.end()}}),s}e.prefixedStream=w}),define(te[19],ne([0,1,50]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let R,T;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,o){return!(o?.dontUseNodeBuffer||!1)&&L?new i(Buffer.from(t)):(R||(R=new TextEncoder),new i(R.encode(t)))}static concat(t,o){if(typeof o=="undefined"){o=0;for(let f=0,p=t.length;f<p;f++)o+=t[f].byteLength}const c=i.alloc(o);let u=0;for(let f=0,p=t.length;f<p;f++){const k=t[f];c.set(k,u),u+=k.byteLength}return c}toString(){return L?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(t,o){return new i(this.buffer.subarray(t,o))}set(t,o){t instanceof i?this.buffer.set(t.buffer,o):this.buffer.set(t,o)}readUInt32BE(t){return C(this.buffer,t)}writeUInt32BE(t,o){I(this.buffer,t,o)}readUInt32LE(t){return b(this.buffer,t)}writeUInt32LE(t,o){d(this.buffer,t,o)}readUInt8(t){return v(this.buffer,t)}writeUInt8(t,o){h(this.buffer,t,o)}}e.VSBuffer=i;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=P;function S(n,t,o){n[o+0]=t&255,t=t>>>8,n[o+1]=t&255}e.writeUInt16LE=S;function C(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=C;function I(n,t,o){n[o+3]=t,t=t>>>8,n[o+2]=t,t=t>>>8,n[o+1]=t,t=t>>>8,n[o]=t}e.writeUInt32BE=I;function b(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=b;function d(n,t,o){n[o+0]=t&255,t=t>>>8,n[o+1]=t&255,t=t>>>8,n[o+2]=t&255,t=t>>>8,n[o+3]=t&255}e.writeUInt32LE=d;function v(n,t){return n[t]}e.readUInt8=v;function h(n,t,o){n[o]=t}e.writeUInt8=h;function E(n){return D.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=E;function y(n){return D.toReadable(n)}e.bufferToReadable=y;function m(n){return D.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=m;async function w(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=w;function g(n){return D.toStream(n,t=>i.concat(t))}e.bufferToStream=g;function a(n){return D.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=a;function l(n){return D.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=l;function r(n,t){return D.prefixedReadable(n,t,o=>i.concat(o))}e.prefixedBufferReadable=r;function s(n,t){return D.prefixedStream(n,t,o=>i.concat(o))}e.prefixedBufferStream=s}),define(te[25],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=L;const R=/{(\d+)}/g;function T(Y,...re){return re.length===0?Y:Y.replace(R,function(ue,fe){const pe=parseInt(fe,10);return isNaN(pe)||pe<0||pe>=re.length?ue:re[pe]})}e.format=T;const i=/{([^}]+)}/g;function P(Y,re){return Y.replace(i,(ue,fe)=>re[fe]??ue)}e.format2=P;function S(Y){return Y.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=S;function C(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function I(Y,re){let ue=0;const fe=re.charCodeAt(0);for(let pe=Y.length-1;pe>=0;pe--)Y.charCodeAt(pe)===fe&&ue++;return ue}e.count=I;function b(Y,re,ue="\u2026"){return Y.length<=re?Y:`${Y.substr(0,re)}${ue}`}e.truncate=b;function d(Y,re=" "){const ue=v(Y,re);return h(ue,re)}e.trim=d;function v(Y,re){if(!Y||!re)return Y;const ue=re.length;if(ue===0||Y.length===0)return Y;let fe=0;for(;Y.indexOf(re,fe)===fe;)fe=fe+ue;return Y.substring(fe)}e.ltrim=v;function h(Y,re){if(!Y||!re)return Y;const ue=re.length,fe=Y.length;if(ue===0||fe===0)return Y;let pe=fe,ge=-1;for(;ge=Y.lastIndexOf(re,pe-1),!(ge===-1||ge+ue!==pe);){if(ge===0)return"";pe=ge}return Y.substring(0,pe)}e.rtrim=h;function E(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function y(Y){return Y.replace(/\*/g,"")}e.stripWildcards=y;function m(Y,re,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");re||(Y=C(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let fe="";return ue.global&&(fe+="g"),ue.matchCase||(fe+="i"),ue.multiline&&(fe+="m"),ue.unicode&&(fe+="u"),new RegExp(Y,fe)}e.createRegExp=m;function w(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function g(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function a(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=a;function l(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=l;function r(Y){for(let re=0,ue=Y.length;re<ue;re++){const fe=Y.charCodeAt(re);if(fe!==32&&fe!==9)return re}return-1}e.firstNonWhitespaceIndex=r;function s(Y,re=0,ue=Y.length){for(let fe=re;fe<ue;fe++){const pe=Y.charCodeAt(fe);if(pe!==32&&pe!==9)return Y.substring(re,fe)}return Y.substring(re,ue)}e.getLeadingWhitespace=s;function n(Y,re=Y.length-1){for(let ue=re;ue>=0;ue--){const fe=Y.charCodeAt(ue);if(fe!==32&&fe!==9)return ue}return-1}e.lastNonWhitespaceIndex=n;function t(Y,re){return Y<re?-1:Y>re?1:0}e.compare=t;function o(Y,re,ue=0,fe=Y.length,pe=0,ge=re.length){for(;ue<fe&&pe<ge;ue++,pe++){let ke=Y.charCodeAt(ue),Le=re.charCodeAt(pe);if(ke<Le)return-1;if(ke>Le)return 1}const Ee=fe-ue,Re=ge-pe;return Ee<Re?-1:Ee>Re?1:0}e.compareSubstring=o;function c(Y,re){return u(Y,re,0,Y.length,0,re.length)}e.compareIgnoreCase=c;function u(Y,re,ue=0,fe=Y.length,pe=0,ge=re.length){for(;ue<fe&&pe<ge;ue++,pe++){let ke=Y.charCodeAt(ue),Le=re.charCodeAt(pe);if(ke===Le)continue;if(ke>=128||Le>=128)return o(Y.toLowerCase(),re.toLowerCase(),ue,fe,pe,ge);f(ke)&&(ke-=32),f(Le)&&(Le-=32);const $e=ke-Le;if($e!==0)return $e}const Ee=fe-ue,Re=ge-pe;return Ee<Re?-1:Ee>Re?1:0}e.compareSubstringIgnoreCase=u;function f(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=f;function p(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=p;function k(Y,re){return Y.length===re.length&&u(Y,re)===0}e.equalsIgnoreCase=k;function O(Y,re){const ue=re.length;return re.length>Y.length?!1:u(Y,re,0,ue)===0}e.startsWithIgnoreCase=O;function F(Y,re){let ue,fe=Math.min(Y.length,re.length);for(ue=0;ue<fe;ue++)if(Y.charCodeAt(ue)!==re.charCodeAt(ue))return ue;return fe}e.commonPrefixLength=F;function W(Y,re){let ue,fe=Math.min(Y.length,re.length);const pe=Y.length-1,ge=re.length-1;for(ue=0;ue<fe;ue++)if(Y.charCodeAt(pe-ue)!==re.charCodeAt(ge-ue))return ue;return fe}e.commonSuffixLength=W;function $(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=$;function A(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=A;function q(Y,re){return(Y-55296<<10)+(re-56320)+65536}e.computeCodePoint=q;function _(Y,re,ue){const fe=Y.charCodeAt(ue);if($(fe)&&ue+1<re){const pe=Y.charCodeAt(ue+1);if(A(pe))return q(fe,pe)}return fe}e.getNextCodePoint=_;function M(Y,re){const ue=Y.charCodeAt(re-1);if(A(ue)&&re>1){const fe=Y.charCodeAt(re-2);if($(fe))return q(fe,ue)}return ue}function B(Y,re){const ue=ae.getInstance(),fe=re,pe=Y.length,ge=_(Y,pe,re);re+=ge>=65536?2:1;let Ee=ue.getGraphemeBreakType(ge);for(;re<pe;){const Re=_(Y,pe,re),ke=ue.getGraphemeBreakType(Re);if(We(Ee,ke))break;re+=Re>=65536?2:1,Ee=ke}return re-fe}e.nextCharLength=B;function Z(Y,re){const ue=ae.getInstance(),fe=re,pe=M(Y,re);re-=pe>=65536?2:1;let ge=ue.getGraphemeBreakType(pe);for(;re>0;){const Ee=M(Y,re),Re=ue.getGraphemeBreakType(Ee);if(We(Re,ge))break;re-=Ee>=65536?2:1,ge=Re}return fe-re}e.prevCharLength=Z;function H(Y,re){const ue=ae.getInstance(),fe=Y.length,pe=re,ge=_(Y,fe,re),Ee=ue.getGraphemeBreakType(ge);re+=ge>=65536?2:1;let Re=Ee;for(;re<fe;){const Le=_(Y,fe,re),$e=ue.getGraphemeBreakType(Le);if(We(Re,$e))break;re+=Le>=65536?2:1,Re=$e}const ke=re;for(re=pe,Re=Ee;re>0;){const Le=M(Y,re),$e=ue.getGraphemeBreakType(Le);if(We($e,Re))break;re-=Le>=65536?2:1,Re=$e}return[re,ke]}function j(Y,re){return re>0&&A(Y.charCodeAt(re))?H(Y,re-1):H(Y,re)}e.getCharContainingOffset=j;const Q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function U(Y){return Q.test(Y)}e.containsRTL=U;const N=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function z(Y){return N.test(Y)}e.containsEmoji=z;const x=/^[\t\n\r\x20-\x7E]*$/;function K(Y){return x.test(Y)}e.isBasicASCII=K,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=ee;function V(Y){for(let re=0,ue=Y.length;re<ue;re++)if(X(Y.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=V;function X(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=X;function se(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=se;function oe(Y,re){if(Y.length<re)return Y;const ue=/\b/g;let fe=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<re);)fe=ue.lastIndex,ue.lastIndex+=1;return Y.substring(fe).replace(/^\s/,"")}e.lcut=oe;const le=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,be=/\x1b\[0?m/g;function Ce(Y){return Y&&(Y=Y.replace(le,""),Y=Y.replace(he,""),Y=Y.replace(be,"")),Y}e.removeAnsiEscapeCodes=Ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function ve(Y){return we(Y)?Y.substr(1):Y}e.stripUTF8BOM=ve;function De(Y,re){if(!Y||!re||Y.length<re.length)return!1;const ue=re.length,fe=Y.toLowerCase();let pe=0,ge=-1;for(;pe<ue;){const Ee=fe.indexOf(re[pe],ge+1);if(Ee<0)return!1;ge=Ee,pe++}return!0}e.fuzzyContains=De;function Se(Y,re=!1){return Y?(re&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Se;function Ie(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Ie;function Me(Y,re=1){if(re===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),re--;while(re>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Me;function je(Y){const re=90-65+1;return Y=Y%(2*re),Y<re?String.fromCharCode(97+Y):String.fromCharCode(65+Y-re)}e.singleLetterHash=je;function Ne(Y){return ae.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ne;function We(Y,re){return Y===0?re!==5&&re!==7:Y===2&&re===3?!1:Y===4||Y===2||Y===3||re===4||re===2||re===3?!0:!(Y===8&&(re===8||re===9||re===11||re===12)||(Y===11||Y===9)&&(re===9||re===10)||(Y===12||Y===10)&&re===10||re===5||re===13||re===7||Y===1||Y===13&&re===14||Y===6&&re===6)}e.breakBetweenGraphemeBreakType=We;var ie;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ce()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const ue=this._data,fe=ue.length/3;let pe=1;for(;pe<=fe;)if(re<ue[3*pe])pe=2*pe;else if(re>ue[3*pe+1])pe=2*pe+1;else return ue[3*pe+2];return 0}}ae._INSTANCE=null;function ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ye(Y,re){if(Y===0)return 0;const ue=Pe(Y,re);if(ue!==void 0)return ue;const fe=M(re,Y);return Y-=_e(fe),Y}e.getLeftDeleteOffset=ye;function Pe(Y,re){let ue=M(re,Y);for(Y-=_e(ue);Te(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=M(re,Y),Y-=_e(ue)}if(!!se(ue)){if(Y>=0){const fe=M(re,Y);fe===8205&&(Y-=_e(fe))}return Y}}function _e(Y){return Y>=65536?2:1}function Te(Y){return 127995<=Y&&Y<=127999}var Fe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class Ae{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ae.map){let fe=function(Ee){const Re=new Map;for(let ke=0;ke<Ee.length;ke+=2)Re.set(Ee[ke],Ee[ke+1]);return Re};const re=Ae.getData();let ue=D.locale;(!ue||!(ue in re))&&(ue=D.language),(!ue||!(ue in re))&&(ue="_default");const pe=fe(re._common),ge=fe(re[ue]);for(const[Ee,Re]of ge)pe.set(Ee,Re);Ae.map=pe}return Ae.map}static isAmbiguous(re){return Ae.getConfusablesForCurrentLocale().has(re)}static getPrimaryConfusable(re){return Ae.getConfusablesForCurrentLocale().get(re)}static getPrimaryConfusableCodePoints(){return new Set(Ae.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ae;class Ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ue.getRawData())),this._data}static isInvisibleCharacter(re){return Ue.getData().has(re)}static get codePoints(){return Ue.getData()}}e.InvisibleCharacters=Ue,Ue._data=void 0}),define(te[105],ne([0,1,25]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(m){return R(m,0)}e.hash=L;function R(m,w){switch(typeof m){case"object":return m===null?T(349,w):Array.isArray(m)?S(m,w):C(m,w);case"string":return P(m,w);case"boolean":return i(m,w);case"number":return T(m,w);case"undefined":return T(937,w);default:return T(617,w)}}e.doHash=R;function T(m,w){return(w<<5)-w+m|0}e.numberHash=T;function i(m,w){return T(m?433:863,w)}function P(m,w){w=T(149417,w);for(let g=0,a=m.length;g<a;g++)w=T(m.charCodeAt(g),w);return w}e.stringHash=P;function S(m,w){return w=T(104579,w),m.reduce((g,a)=>R(a,g),w)}function C(m,w){return w=T(181387,w),Object.keys(m).sort().reduce((g,a)=>(g=P(a,g),R(m[a],g)),w)}class I{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=R(w,this._value),this._value}}e.Hasher=I;var b;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function d(m,w,g=32){const a=g-w,l=~((1<<a)-1);return(m<<w|(l&m)>>>a)>>>0}function v(m,w=0,g=m.byteLength,a=0){for(let l=0;l<g;l++)m[w+l]=a}function h(m,w,g="0"){for(;m.length<w;)m=g+m;return m}function E(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(g=>g.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),w/4)}e.toHexString=E;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const g=w.length;if(g===0)return;const a=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,s,n;for(r!==0?(s=r,n=-1,r=0):(s=w.charCodeAt(0),n=0);;){let t=s;if(D.isHighSurrogate(s))if(n+1<g){const o=w.charCodeAt(n+1);D.isLowSurrogate(o)?(n++,t=D.computeCodePoint(s,o)):t=65533}else{r=s;break}else D.isLowSurrogate(s)&&(t=65533);if(l=this._push(a,l,t),n++,n<g)s=w.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,g,a){return a<128?w[g++]=a:a<2048?(w[g++]=192|(a&1984)>>>6,w[g++]=128|(a&63)>>>0):a<65536?(w[g++]=224|(a&61440)>>>12,w[g++]=128|(a&4032)>>>6,w[g++]=128|(a&63)>>>0):(w[g++]=240|(a&1835008)>>>18,w[g++]=128|(a&258048)>>>12,w[g++]=128|(a&4032)>>>6,w[g++]=128|(a&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=y._bigBlock32,g=this._buffDV;for(let u=0;u<64;u+=4)w.setUint32(u,g.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)w.setUint32(u,d(w.getUint32(u-12,!1)^w.getUint32(u-32,!1)^w.getUint32(u-56,!1)^w.getUint32(u-64,!1),1),!1);let a=this._h0,l=this._h1,r=this._h2,s=this._h3,n=this._h4,t,o,c;for(let u=0;u<80;u++)u<20?(t=l&r|~l&s,o=1518500249):u<40?(t=l^r^s,o=1859775393):u<60?(t=l&r|l&s|r&s,o=2400959708):(t=l^r^s,o=3395469782),c=d(a,5)+t+n+o+w.getUint32(u*4,!1)&4294967295,n=s,s=r,r=d(l,30),l=a,a=c;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var bt=this&&this.__classPrivateFieldSet||function(J,e,D,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(J,D):R?R.value=D:e.set(J,D),D},Ve=this&&this.__classPrivateFieldGet||function(J,e,D,L){if(D==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?L:D==="a"?L.call(J):L?L.value:e.get(J)};define(te[41],ne([0,1,17,25]),function(J,e,D,L){"use strict";var R,T,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(n,t,o){let c=n.get(t);return c===void 0&&(c=o,n.set(t,c)),c}e.getOrSet=P;function S(n){const t=[];return n.forEach((o,c)=>{t.push(`${c} => ${o}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=S;function C(n){const t=[];return n.forEach(o=>{t.push(o)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=C;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),c=this._value.charCodeAt(this._pos);return o-c}value(){return this._value[this._pos]}}e.StringIterator=I;class b{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class d{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var v;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(y||(y={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new h(t))}static forPaths(){return new m(new d)}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new b)}clear(){this._root=void 0}fill(t,o){if(o){const c=o.slice(0);(0,D.shuffle)(c);for(let u of c)this.set(u,t)}else{const c=t.slice(0);(0,D.shuffle)(c);for(let u of c)this.set(u[0],u[1])}}set(t,o){const c=this._iter.reset(t);let u;this._root||(this._root=new E,this._root.segment=c.value());const f=[];for(u=this._root;;){const k=c.cmp(u.segment);if(k>0)u.left||(u.left=new E,u.left.segment=c.value()),f.push([-1,u]),u=u.left;else if(k<0)u.right||(u.right=new E,u.right.segment=c.value()),f.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new E,u.mid.segment=c.value()),f.push([0,u]),u=u.mid;else break}const p=u.value;u.value=o,u.key=t;for(let k=f.length-1;k>=0;k--){const O=f[k][1];O.updateHeight();const F=O.balanceFactor();if(F<-1||F>1){const W=f[k][0],$=f[k+1][0];if(W===1&&$===1)f[k][1]=O.rotateLeft();else if(W===-1&&$===-1)f[k][1]=O.rotateRight();else if(W===1&&$===-1)O.right=f[k+1][1]=f[k+1][1].rotateRight(),f[k][1]=O.rotateLeft();else if(W===-1&&$===1)O.left=f[k+1][1]=f[k+1][1].rotateLeft(),f[k][1]=O.rotateRight();else throw new Error;if(k>0)switch(f[k-1][0]){case-1:f[k-1][1].left=f[k][1];break;case 1:f[k-1][1].right=f[k][1];break;case 0:f[k-1][1].mid=f[k][1];break}else this._root=f[0][1]}}return p}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let c=this._root;for(;c;){const u=o.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else break}return c}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const c=this._iter.reset(t),u=[];let f=this._root;for(;f;){const p=c.cmp(f.segment);if(p>0)u.push([-1,f]),f=f.left;else if(p<0)u.push([1,f]),f=f.right;else if(c.hasNext())c.next(),u.push([0,f]),f=f.mid;else break}if(!!f){if(o?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const p=this._min(f.right),{key:k,value:O,segment:F}=p;this._delete(p.key,!1),f.key=k,f.value=O,f.segment=F}else{const p=f.left??f.right;if(u.length>0){const[k,O]=u[u.length-1];switch(k){case-1:O.left=p;break;case 0:O.mid=p;break;case 1:O.right=p;break}}else this._root=p}for(let p=u.length-1;p>=0;p--){const k=u[p][1];k.updateHeight();const O=k.balanceFactor();if(O>1?(k.right.balanceFactor()>=0||(k.right=u[p+1][1]=u[p+1][1].rotateRight()),u[p][1]=k.rotateLeft()):O<-1&&(k.left.balanceFactor()<=0||(k.left=u[p+1][1]=u[p+1][1].rotateLeft()),u[p][1]=k.rotateRight()),p>0)switch(u[p-1][0]){case-1:u[p-1][1].left=u[p][1];break;case 1:u[p-1][1].right=u[p][1];break;case 0:u[p-1][1].mid=u[p][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let c=this._root,u;for(;c;){const f=o.cmp(c.segment);if(f>0)c=c.left;else if(f<0)c=c.right;else if(o.hasNext())o.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(t){const o=this._iter.reset(t);let c=this._root;for(;c;){const u=o.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(t){for(const[o,c]of this)t(c,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const c=o.balanceFactor();return c<-1||c>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=m;class w{constructor(t,o){this.uri=t,this.value=o}}class g{constructor(t,o){this[R]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=o??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new w(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[c,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=n=>n.toString();var a;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const c=this._map.get(t);if(!!c)return o!==0&&this.touch(c,o),c.value}set(t,o,c=0){let u=this._map.get(t);if(u)u.value=o,c!==0&&this.touch(u,c);else{switch(u={key:t,value:o,next:void 0,previous:void 0},c){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const c=this._state;let u=this._head;for(;u;){if(o?t.bind(o)(u.value,u.key,this):t(u.value,u.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,o=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.key,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return u}values(){const t=this,o=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.value,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return u}entries(){const t=this,o=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:[c.key,c.value],done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,c=this.size;for(;o&&c>t;)this._map.delete(o.key),o=o.next,c--;this._head=o,this._size=c,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,c=t.previous;if(!o||!c)throw new Error("Invalid list");o.previous=c,c.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const c=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(c.previous=u,u.next=c),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const c=t.next,u=t.previous;t===this._head?(c.previous=void 0,this._head=c):(c.previous=u,u.next=c),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,c)=>{t.push([c,o])}),t}fromJSON(t){this.clear();for(const[o,c]of t)this.set(o,c)}}e.LinkedMap=l;class r extends l{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class s{constructor(t){i.set(this,void 0),bt(this,i,t,"f")}get size(){return Ve(this,i,"f").size}forEach(t,o){Ve(this,i,"f").forEach(t,o)}get(t){return Ve(this,i,"f").get(t)}has(t){return Ve(this,i,"f").has(t)}entries(){return Ve(this,i,"f").entries()}keys(){return Ve(this,i,"f").keys()}values(){return Ve(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Ve(this,i,"f").entries()}}e.ReadonlyMapView=s}),define(te[69],ne([0,1,41]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new D.LRUCache(1e4);function R(C){return S(C,"NFC",L)}e.normalizeNFC=R;const T=new D.LRUCache(1e4);function i(C){return S(C,"NFD",T)}e.normalizeNFD=i;const P=/[^\u0000-\u0080]/;function S(C,I,b){if(!C)return C;const d=b.get(C);if(d)return d;let v;return P.test(C)?v=C.normalize(I):v=C,b.set(C,v),v}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(I){return i(I).replace(C,"")}}()}),define(te[15],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(f){return Array.isArray(f)}e.isArray=D;function L(f){return typeof f=="string"}e.isString=L;function R(f){return Array.isArray(f)&&f.every(p=>L(p))}e.isStringArray=R;function T(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=T;function i(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=i;function P(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=P;function S(f){return f===!0||f===!1}e.isBoolean=S;function C(f){return typeof f=="undefined"}e.isUndefined=C;function I(f){return!b(f)}e.isDefined=I;function b(f){return C(f)||f===null}e.isUndefinedOrNull=b;function d(f,p){if(!f)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=d;function v(f){if(b(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=v;function h(...f){const p=[];for(let k=0;k<f.length;k++){const O=f[k];if(b(O))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);p.push(O)}return p}e.assertAllDefined=h;const E=Object.prototype.hasOwnProperty;function y(f){if(!T(f))return!1;for(let p in f)if(E.call(f,p))return!1;return!0}e.isEmptyObject=y;function m(f){return typeof f=="function"}e.isFunction=m;function w(...f){return f.length>0&&f.every(m)}e.areFunctions=w;function g(f,p){const k=Math.min(f.length,p.length);for(let O=0;O<k;O++)a(f[O],p[O])}e.validateConstraints=g;function a(f,p){if(L(p)){if(typeof f!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(m(p)){try{if(f instanceof p)return}catch{}if(!b(f)&&f.constructor===p||p.length===1&&p.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(f){let p=[],k=Object.getPrototypeOf(f);for(;Object.prototype!==k;)p=p.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return p}e.getAllPropertyNames=l;function r(f){const p=[];for(const k of l(f))typeof f[k]=="function"&&p.push(k);return p}e.getAllMethodNames=r;function s(f,p){const k=F=>function(){const W=Array.prototype.slice.call(arguments,0);return p(F,W)};let O={};for(const F of f)O[F]=k(F);return O}e.createProxyObject=s;function n(f){return f===null?void 0:f}e.withNullAsUndefined=n;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function o(f){return class{constructor(){return new Proxy({},{get(p,k){if(p[k])return p[k];throw new Error(`Not Implemented: ${f}->${String(k)}`)}})}}}e.NotImplementedProxy=o;function c(f,p="Unreachable"){throw new Error(p)}e.assertNever=c;function u(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=u}),define(te[42],ne([0,1,10,4,25,15]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function P(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function S(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=S;function C(n,t=D.posix.sep){if(!n)return"";const o=n.length,c=n.charCodeAt(0);if(i(c)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let f=3;const p=f;for(;f<o&&!i(n.charCodeAt(f));f++);if(p!==f&&!i(n.charCodeAt(f+1))){for(f+=1;f<o;f++)if(i(n.charCodeAt(f)))return n.slice(0,f+1).replace(/[\\/]/g,t)}}return t}else if(m(c)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let u=n.indexOf("://");if(u!==-1){for(u+=3;u<o;u++)if(i(n.charCodeAt(u)))return n.slice(0,u+1)}return""}e.getRoot=C;function I(n){if(!L.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let o=2;const c=o;for(;o<n.length&&(t=n.charCodeAt(o),t!==92);o++);return!(c===o||(t=n.charCodeAt(o+1),isNaN(t)||t===92))}e.isUNC=I;const b=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,t=L.isWindows){const o=t?b:d;return!(!n||n.length===0||/^\s+$/.test(n)||(o.lastIndex=0,o.test(n))||t&&v.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function E(n,t,o){const c=n===t;return!o||c?c:!n||!t?!1:(0,R.equalsIgnoreCase)(n,t)}e.isEqual=E;function y(n,t,o,c=D.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(o){if(!(0,R.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let f=t.length;return t.charAt(t.length-1)===c&&f--,n.charAt(f)===c}return t.charAt(t.length-1)!==c&&(t+=c),n.indexOf(t)===0}e.isEqualOrParent=y;function m(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=m;function w(n,t){return L.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(t,n)),n=(0,D.normalize)(n),L.isWindows?(n=(0,R.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,R.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=w;function g(n){const t=(0,D.normalize)(n);return L.isWindows?n.length>3?!1:a(t)&&(n.length===2||t.charCodeAt(2)===92):t===D.posix.sep}e.isRootOrDriveLetter=g;function a(n,t){return(t!==void 0?t:L.isWindows)?m(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(n){return a(n)?n[0]:void 0}e.getDriveLetter=l;function r(n,t,o){return t.length>n.length?-1:n===t?0:(o&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function s(n){const t=n.split(":");let o,c,u;if(t.forEach(f=>{const p=Number(f);(0,T.isNumber)(p)?c===void 0?c=p:u===void 0&&(u=p):o=o?[o,f].join(":"):f}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:c!==void 0?c:void 0,column:u!==void 0?u:c!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[28],ne([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const y=Array.isArray(E)?[]:{};return Object.keys(E).forEach(m=>{E[m]&&typeof E[m]=="object"?y[m]=L(E[m]):y[m]=E[m]}),y}e.deepClone=L;function R(E){if(!E||typeof E!="object")return E;const y=[E];for(;y.length>0;){const m=y.shift();Object.freeze(m);for(const w in m)if(T.call(m,w)){const g=m[w];typeof g=="object"&&!Object.isFrozen(g)&&y.push(g)}}return E}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function i(E,y){return P(E,y,new Set)}e.cloneAndChange=i;function P(E,y,m){if((0,D.isUndefinedOrNull)(E))return E;const w=y(E);if(typeof w!="undefined")return w;if((0,D.isArray)(E)){const g=[];for(const a of E)g.push(P(a,y,m));return g}if((0,D.isObject)(E)){if(m.has(E))throw new Error("Cannot clone recursive data-structure");m.add(E);const g={};for(let a in E)T.call(E,a)&&(g[a]=P(E[a],y,m));return m.delete(E),g}return E}function S(E,y,m=!0){return(0,D.isObject)(E)?((0,D.isObject)(y)&&Object.keys(y).forEach(w=>{w in E?m&&((0,D.isObject)(E[w])&&(0,D.isObject)(y[w])?S(E[w],y[w],m):E[w]=y[w]):E[w]=y[w]}),E):y}e.mixin=S;function C(E,y){if(E===y)return!0;if(E==null||y===null||y===void 0||typeof E!=typeof y||typeof E!="object"||Array.isArray(E)!==Array.isArray(y))return!1;let m,w;if(Array.isArray(E)){if(E.length!==y.length)return!1;for(m=0;m<E.length;m++)if(!C(E[m],y[m]))return!1}else{const g=[];for(w in E)g.push(w);g.sort();const a=[];for(w in y)a.push(w);if(a.sort(),!C(g,a))return!1;for(m=0;m<g.length;m++)if(!C(E[g[m]],y[g[m]]))return!1}return!0}e.equals=C;function I(E){const y=new Set;return JSON.stringify(E,(m,w)=>{if((0,D.isObject)(w)||Array.isArray(w)){if(y.has(w))return"[Circular]";y.add(w)}return w})}e.safeStringify=I;function b(E,y,m){const w=y(E);return typeof w=="undefined"?m:w}e.getOrDefault=b;function d(E,y){const m=Object.create(null);return!E||!y||Object.keys(y).forEach(g=>{const a=E[g],l=y[g];C(a,l)||(m[g]=l)}),m}e.distinct=d;function v(E,y){const m=y.toLowerCase(),w=Object.keys(E).find(g=>g.toLowerCase()===m);return w?E[w]:E[y]}e.getCaseInsensitive=v;function h(E,y){const m=Object.create(null);for(const[w,g]of Object.entries(E))y(w,g)&&(m[w]=g);return m}e.filter=h}),define(te[7],ne([0,1,10,4]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,T=/^\//,i=/^\/\//;function P(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!T.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,t){return!n&&!t?"file":n}function C(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==b&&(t=b+t):t=b;break}return t}const I="",b="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(t,o,c,u,f,p=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=S(t,p),this.authority=o||I,this.path=C(this.scheme,c||I),this.query=u||I,this.fragment=f||I,P(this,p))}static isUri(t){return t instanceof v?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:o,authority:c,path:u,query:f,fragment:p}=t;return o===void 0?o=this.scheme:o===null&&(o=I),c===void 0?c=this.authority:c===null&&(c=I),u===void 0?u=this.path:u===null&&(u=I),f===void 0?f=this.query:f===null&&(f=I),p===void 0?p=this.fragment:p===null&&(p=I),o===this.scheme&&c===this.authority&&u===this.path&&f===this.query&&p===this.fragment?this:new E(o,c,u,f,p)}static parse(t,o=!1){const c=d.exec(t);return c?new E(c[2]||I,s(c[4]||I),s(c[5]||I),s(c[7]||I),s(c[9]||I),o):new E(I,I,I,I,I)}static file(t){let o=I;if(L.isWindows&&(t=t.replace(/\\/g,b)),t[0]===b&&t[1]===b){const c=t.indexOf(b,2);c===-1?(o=t.substring(2),t=b):(o=t.substring(2,c),t=t.substring(c)||b)}return new E("file",o,t,I,I)}static from(t){const o=new E(t.scheme,t.authority,t.path,t.query,t.fragment);return P(o,!0),o}static joinPath(t,...o){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return L.isWindows&&t.scheme==="file"?c=v.file(D.win32.join(g(t,!0),...o)).path:c=D.posix.join(t.path,...o),t.with({path:c})}toString(t=!1){return a(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof v)return t;{const o=new E(t);return o._formatted=t.external,o._fsPath=t._sep===h?t.fsPath:null,o}}else return t}}e.URI=v;const h=L.isWindows?1:void 0;class E extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,t){let o,c=-1;for(let u=0;u<n.length;u++){const f=n.charCodeAt(u);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)c!==-1&&(o+=encodeURIComponent(n.substring(c,u)),c=-1),o!==void 0&&(o+=n.charAt(u));else{o===void 0&&(o=n.substr(0,u));const p=y[f];p!==void 0?(c!==-1&&(o+=encodeURIComponent(n.substring(c,u)),c=-1),o+=p):c===-1&&(c=u)}}return c!==-1&&(o+=encodeURIComponent(n.substring(c))),o!==void 0?o:n}function w(n){let t;for(let o=0;o<n.length;o++){const c=n.charCodeAt(o);c===35||c===63?(t===void 0&&(t=n.substr(0,o)),t+=y[c]):t!==void 0&&(t+=n[o])}return t!==void 0?t:n}function g(n,t){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=g;function a(n,t){const o=t?w:m;let c="",{scheme:u,authority:f,path:p,query:k,fragment:O}=n;if(u&&(c+=u,c+=":"),(f||u==="file")&&(c+=b,c+=b),f){let F=f.indexOf("@");if(F!==-1){const W=f.substr(0,F);f=f.substr(F+1),F=W.indexOf(":"),F===-1?c+=o(W,!1):(c+=o(W.substr(0,F),!1),c+=":",c+=o(W.substr(F+1),!1)),c+="@"}f=f.toLowerCase(),F=f.indexOf(":"),F===-1?c+=o(f,!1):(c+=o(f.substr(0,F),!1),c+=f.substr(F))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const F=p.charCodeAt(1);F>=65&&F<=90&&(p=`/${String.fromCharCode(F+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const F=p.charCodeAt(0);F>=65&&F<=90&&(p=`${String.fromCharCode(F+32)}:${p.substr(2)}`)}c+=o(p,!0)}return k&&(c+="?",c+=o(k,!1)),O&&(c+="#",c+=t?O:m(O,!1)),c}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(r)?n.replace(r,t=>l(t)):n}}),define(te[106],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(C){const I=C;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=L;function R(C){const I=[];let b;try{const d=JSON.parse(C.arguments),v=d[d.length-1];v&&v.__$stack&&(d.pop(),b=v.__$stack),I.push(...d)}catch(d){I.push("Unable to log remote console arguments",C.arguments)}return{args:I,stack:b}}e.parse=R;function T(C){if(typeof C!="string")return T(R(C).stack);const I=C;if(I){const b=i(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=T;function i(C){if(!C)return C;const I=C.indexOf(`
`);return I===-1?C:C.substring(0,I)}function P(C,I){const{args:b,stack:d}=R(C),v=typeof b[0]=="string"&&b.length===1;let h=i(d);h&&(h=`(${h.trim()})`);let E=[];if(typeof b[0]=="string"?h&&v?E=[`%c[${I}] %c${b[0]} %c${h}`,S("blue"),S(""),S("grey")]:E=[`%c[${I}] %c${b[0]}`,S("blue"),S(""),...b.slice(1)]:E=[`%c[${I}]%`,S("blue"),...b],h&&!v&&E.push(h),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,E)}e.log=P;function S(C){return`color: ${C}`}}),define(te[107],ne([0,1,19,25,7]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,S)}e.stringify=T;function i(I){let b=JSON.parse(I);return b=C(b),b}e.parse=i;var P;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function S(I,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,L.regExpFlags)(b)}:b}function C(I,b=0){if(!I||b>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return R.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof D.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let d=0;d<I.length;++d)I[d]=C(I[d],b+1);else for(const d in I)Object.hasOwnProperty.call(I,d)&&(I[d]=C(I[d],b+1))}return I}e.revive=C}),define(te[16],ne([0,1,4,7]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(R=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,C,I){this._hosts[S]=C,this._ports[S]=I}setConnectionToken(S,C){this._connectionTokens[S]=C}rewrite(S){if(this._delegate)return this._delegate(S);const C=S.authority;let I=this._hosts[C];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const b=this._ports[C],d=this._connectionTokens[C];let v=`path=${encodeURIComponent(S.path)}`;return typeof d=="string"&&(v+=`&tkn=${encodeURIComponent(d)}`),L.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${I}:${b}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new T;class i{asBrowserUri(S,C){const I=this.toUri(S,C);return I.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?I.with({scheme:R.vscodeFileResource,authority:I.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(S,C){const I=this.toUri(S,C);return I.scheme===R.vscodeFileResource?I.with({scheme:R.file,authority:I.authority!==i.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(S,C){return L.URI.isUri(S)?S:L.URI.parse(C.toUrl(S))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(te[18],ne([0,1,42,16,10,4,25,7]),function(J,e,D,L,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(v){return(0,P.uriToFsPath)(v,!0)}e.originalFSPath=S;class C{constructor(h){this._ignorePathCasing=h}compare(h,E,y=!1){return h===E?0:(0,i.compare)(this.getComparisonKey(h,y),this.getComparisonKey(E,y))}isEqual(h,E,y=!1){return h===E?!0:!h||!E?!1:this.getComparisonKey(h,y)===this.getComparisonKey(E,y)}getComparisonKey(h,E=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,E,y=!1){if(h.scheme===E.scheme){if(h.scheme===L.Schemas.file)return D.isEqualOrParent(S(h),S(E),this._ignorePathCasing(h))&&h.query===E.query&&(y||h.fragment===E.fragment);if((0,e.isEqualAuthority)(h.authority,E.authority))return D.isEqualOrParent(h.path,E.path,this._ignorePathCasing(h),"/")&&h.query===E.query&&(y||h.fragment===E.fragment)}return!1}joinPath(h,...E){return P.URI.joinPath(h,...E)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return R.posix.basename(h.path)}extname(h){return R.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let E;return h.scheme===L.Schemas.file?E=P.URI.file(R.dirname(S(h))).path:(E=R.posix.dirname(h.path),h.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),E="/")),h.with({path:E})}normalizePath(h){if(!h.path.length)return h;let E;return h.scheme===L.Schemas.file?E=P.URI.file(R.normalize(S(h))).path:E=R.posix.normalize(h.path),h.with({path:E})}relativePath(h,E){if(h.scheme!==E.scheme||!(0,e.isEqualAuthority)(h.authority,E.authority))return;if(h.scheme===L.Schemas.file){const w=R.relative(S(h),S(E));return T.isWindows?D.toSlashes(w):w}let y=h.path||"/",m=E.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const g=Math.min(y.length,m.length);w<g&&!(y.charCodeAt(w)!==m.charCodeAt(w)&&y.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);y=m.substr(0,w)+y.substr(w)}return R.posix.relative(y,m)}resolvePath(h,E){if(h.scheme===L.Schemas.file){const y=P.URI.file(R.resolve(S(h),E));return h.with({authority:y.authority,path:y.path})}return E=D.toPosixPath(E),h.with({path:R.posix.resolve(h.path,E)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,E){return h===E||h!==void 0&&E!==void 0&&(0,i.equalsIgnoreCase)(h,E)}hasTrailingPathSeparator(h,E=R.sep){if(h.scheme===L.Schemas.file){const y=S(h);return y.length>D.getRoot(y).length&&y[y.length-1]===E}else{const y=h.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,E=R.sep){return(0,e.hasTrailingPathSeparator)(h,E)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,E=R.sep){let y=!1;if(h.scheme===L.Schemas.file){const m=S(h);y=m!==void 0&&m.length===D.getRoot(m).length&&m[m.length-1]===E}else{E="/";const m=h.path;y=m.length===1&&m.charCodeAt(m.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(h,E)?h.with({path:h.path+"/"}):h}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(v=>v.scheme===L.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new C(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(v,h){const E=[];for(let y=0;y<v.length;y++){const m=h(v[y]);v.some((w,g)=>g===y?!1:(0,e.isEqualOrParent)(m,h(w)))||E.push(v[y])}return E}e.distinctParents=I;var b;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(E){const y=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(g=>{const[a,l]=g.split(":");a&&l&&y.set(a,l)});const w=E.path.substring(0,E.path.indexOf(";"));return w&&y.set(v.META_DATA_MIME,w),y}v.parseMetaData=h})(b=e.DataUri||(e.DataUri={}));function d(v,h,E){if(h){let y=v.path;return y&&y[0]!==R.posix.sep&&(y=R.posix.sep+y),v.with({scheme:E,authority:h,path:y})}return v.with({scheme:E})}e.toLocalResource=d}),define(te[5],ne([0,1,27,9,3,2,18,4]),function(J,e,D,L,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(U){return!!U&&typeof U.then=="function"}e.isThenable=S;function C(U){const N=new D.CancellationTokenSource,z=U(N.token),x=new Promise((K,ee)=>{const V=N.token.onCancellationRequested(()=>{V.dispose(),N.dispose(),ee((0,L.canceled)())});Promise.resolve(z).then(X=>{V.dispose(),N.dispose(),K(X)},X=>{V.dispose(),N.dispose(),ee(X)})});return new class{cancel(){N.cancel()}then(K,ee){return x.then(K,ee)}catch(K){return this.then(void 0,K)}finally(K){return x.finally(K)}}}e.createCancelablePromise=C;function I(U,N,z){return Promise.race([U,new Promise(x=>N.onCancellationRequested(()=>x(z)))])}e.raceCancellation=I;async function b(U){let N=-1;const z=U.map((K,ee)=>K.then(V=>(N=ee,V))),x=await Promise.race(z);return U.forEach((K,ee)=>{ee!==N&&K.cancel()}),x}e.raceCancellablePromises=b;function d(U,N,z){let x;const K=setTimeout(()=>{x?.(void 0),z?.()},N);return Promise.race([U.finally(()=>clearTimeout(K)),new Promise(ee=>x=ee)])}e.raceTimeout=d;function v(U){return new Promise((N,z)=>{const x=U();S(x)?x.then(N,z):N(x)})}e.asPromise=v;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(z,z).then(x)})}return new Promise((z,x)=>{this.queuedPromise.then(z,x)})}return this.activePromise=N(),new Promise((z,x)=>{this.activePromise.then(K=>{this.activePromise=null,z(K)},K=>{this.activePromise=null,x(K)})})}}e.Throttler=h;class E{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=E;class y{constructor(){this.promiseMap=new Map}queue(N,z){const K=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(N)===K&&this.promiseMap.delete(N)});return this.promiseMap.set(N,K),K}}e.SequencerByKey=y;class m{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,z=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,K)=>{this.doResolve=x,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=m;class w{constructor(N){this.delayer=new m(N),this.throttler=new h}trigger(N,z){return this.delayer.trigger(()=>this.throttler.queue(N),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class g{constructor(){this._isOpen=!1,this._promise=new Promise((N,z)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class a extends g{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(U,N){return N?new Promise((z,x)=>{const K=setTimeout(()=>{ee.dispose(),z()},U),ee=N.onCancellationRequested(()=>{clearTimeout(K),ee.dispose(),x((0,L.canceled)())})}):C(z=>l(U,z))}e.timeout=l;function r(U,N=0){const z=setTimeout(U,N);return(0,T.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=r;function s(U){const N=[];let z=0;const x=U.length;function K(){return z<x?U[z++]():null}function ee(V){V!=null&&N.push(V);const X=K();return X?X.then(ee):Promise.resolve(N)}return Promise.resolve(null).then(ee)}e.sequence=s;function n(U,N=x=>!!x,z=null){let x=0;const K=U.length,ee=()=>{if(x>=K)return Promise.resolve(z);const V=U[x++];return Promise.resolve(V()).then(se=>N(se)?Promise.resolve(se):ee())};return ee()}e.first=n;function t(U,N=x=>!!x,z=null){if(U.length===0)return Promise.resolve(z);let x=U.length;const K=()=>{x=-1;for(const ee of U)ee.cancel?.()};return new Promise((ee,V)=>{for(const X of U)X.then(se=>{--x>=0&&N(se)?(K(),ee(se)):x===0&&ee(z)}).catch(se=>{--x>=0&&(K(),V(se))})})}e.firstParallel=t;class o{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((z,x)=>{this.outstandingPromises.push({factory:N,c:z,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const z=N.factory();z.then(N.c,N.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class c extends o{constructor(){super(1)}}e.Queue=c;class u{constructor(){this.queues=new Map}queueFor(N,z=i.extUri){const x=z.getComparisonKey(N);let K=this.queues.get(x);return K||(K=new c,R.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete(x)}),this.queues.set(x,K)),K}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=u;class f{constructor(N,z){this._token=-1,typeof N=="function"&&typeof z=="number"&&this.setIfNotSet(N,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},z)}setIfNotSet(N,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},z))}}e.TimeoutTimer=f;class p{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,z){this.cancel(),this._token=setInterval(()=>{N()},z)}}e.IntervalTimer=p;class k{constructor(N,z){this.timeoutToken=-1,this.runner=N,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=k;class O{constructor(N,z){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=O;class F extends k{constructor(N,z){super(N,z);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class W extends T.Disposable{constructor(N,z,x,K){super();this.maxWorkChunkSize=N,this.maxPendingWork=z,this.throttleDelay=x,this.handler=K,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.maxPendingWork)return!1}else if(this.pending+N.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new k(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{(0,P.setTimeout0)(()=>{if(N)return;const z=Date.now()+3;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(U,N)=>{const z=requestIdleCallback(U,typeof N=="number"?{timeout:N}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(z))}}}}();class ${constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function A(U,N,z){let x;for(let K=0;K<z;K++)try{return await U()}catch(ee){x=ee,await l(N)}throw x}e.retry=A;class q{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,z,x){return this._pending={taskId:N,cancel:()=>x?.(),promise:z},z.then(()=>this.donePending(N),()=>this.donePending(N)),z}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let z,x;const K=new Promise((ee,V)=>{z=ee,x=V});this._next={run:N,promise:K,promiseResolve:z,promiseReject:x}}return this._next.promise}}e.TaskSequentializer=q;class _{constructor(N,z=()=>Date.now()){this.interval=N,this.nowFn=z,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=_;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,z)=>{this.completeCallback=N,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(z=>{this.completeCallback(N),this.resolved=!0,z()})}error(N){return new Promise(z=>{this.errorCallback(N),this.rejected=!0,z()})}cancel(){new Promise(N=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=M;var B;(function(U){async function N(x){let K;const ee=await Promise.all(x.map(V=>V.then(X=>X,X=>{K||(K=X)})));if(typeof K!="undefined")throw K;return ee}U.settled=N;function z(x){return new Promise(async(K,ee)=>{try{await x(K,ee)}catch(V){ee(V)}})}U.withAsyncBody=z})(B=e.Promises||(e.Promises={}));var Z;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(Z||(Z={}));class H{constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const z={emitOne:x=>this.emitOne(x),emitMany:x=>this.emitMany(x),reject:x=>this.reject(x)};try{await Promise.resolve(N(z)),this.resolve()}catch(x){this.reject(x)}finally{z.emitOne=void 0,z.emitMany=void 0,z.reject=void 0}})}static fromArray(N){return new H(z=>{z.emitMany(N)})}static fromPromise(N){return new H(async z=>{z.emitMany(await N)})}static fromPromises(N){return new H(async z=>{await Promise.all(N.map(async x=>z.emitOne(await x)))})}static merge(N){return new H(async z=>{await Promise.all(N.map(async x=>{for await(const K of x)z.emitOne(K)}))})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,z){return new H(async x=>{for await(const K of N)x.emitOne(z(K))})}map(N){return H.map(this,N)}static filter(N,z){return new H(async x=>{for await(const K of N)z(K)&&x.emitOne(K)})}filter(N){return H.filter(this,N)}static coalesce(N){return H.filter(N,z=>!!z)}coalesce(){return H.coalesce(this)}static async toPromise(N){const z=[];for await(const x of N)z.push(x);return z}toPromise(){return H.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class j extends H{constructor(N,z){super(z);this._source=N}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=j;function Q(U){const N=new D.CancellationTokenSource,z=U(N.token);return new j(N,async x=>{const K=N.token.onCancellationRequested(()=>{K.dispose(),N.dispose(),x.reject((0,L.canceled)())});try{for await(const ee of z){if(N.token.isCancellationRequested)return;x.emitOne(ee)}K.dispose(),N.dispose()}catch(ee){K.dispose(),N.dispose(),x.reject(ee)}})}e.createCancelableAsyncIterable=Q}),define(te[108],ne([0,1,5,42,41,10,25]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const S="**",C="/",I="[/\\\\]",b="[^/\\\\]",d=/\//g;function v(j){switch(j){case 0:return"";case 1:return`${b}*?`;default:return`(?:${I}|${b}+${I}|${I}${b}+)*?`}}function h(j,Q){if(!j)return[];const U=[];let N=!1,z=!1,x="";for(const K of j){switch(K){case Q:if(!N&&!z){U.push(x),x="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":z=!0;break;case"]":z=!1;break}x+=K}return x&&U.push(x),U}e.splitGlobAware=h;function E(j){if(!j)return"";let Q="";const U=h(j,C);if(U.every(N=>N===S))Q=".*";else{let N=!1;U.forEach((z,x)=>{if(z===S){N||(Q+=v(2),N=!0);return}let K=!1,ee="",V=!1,X="";for(const se of z){if(se!=="}"&&K){ee+=se;continue}if(V&&(se!=="]"||!X)){let oe;se==="-"?oe=se:(se==="^"||se==="!")&&!X?oe="^":se===C?oe="":oe=i.escapeRegExpCharacters(se),X+=oe;continue}switch(se){case"{":K=!0;continue;case"[":V=!0;continue;case"}":Q+=`(?:${h(ee,",").map(he=>E(he)).join("|")})`,K=!1,ee="";break;case"]":Q+="["+X+"]",V=!1,X="";break;case"?":Q+=b;continue;case"*":Q+=v(1);continue;default:Q+=i.escapeRegExpCharacters(se)}}x<U.length-1&&(U[x+1]!==S||x+2<U.length)&&(Q+=I),N=!1})}return Q}const y=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new R.LRUCache(1e4),s=function(){return!1},n=function(){return null};function t(j,Q){if(!j)return n;let U;typeof j!="string"?U=j.pattern:U=j,U=U.trim();const N=`${U}_${!!Q.trimForExclusions}`;let z=r.get(N);if(z)return o(z,j);let x;if(y.test(U)){const K=U.substr(4);z=function(ee,V){return typeof ee=="string"&&ee.endsWith(K)?U:null}}else(x=m.exec(c(U,Q)))?z=u(x[1],U):(Q.trimForExclusions?g:w).test(U)?z=f(U,Q):(x=a.exec(c(U,Q)))?z=p(x[1].substr(1),U,!0):(x=l.exec(c(U,Q)))?z=p(x[1],U,!1):z=k(U);return r.set(N,z),o(z,j)}function o(j,Q){return typeof Q=="string"?j:function(U,N){return L.isEqualOrParent(U,Q.base)?j(T.relative(Q.base,U),N):null}}function c(j,Q){return Q.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function u(j,Q){const U=`/${j}`,N=`\\${j}`,z=function(K,ee){return typeof K!="string"?null:ee?ee===j?Q:null:K===j||K.endsWith(U)||K.endsWith(N)?Q:null},x=[j];return z.basenames=x,z.patterns=[Q],z.allBasenames=x,z}function f(j,Q){const U=H(j.slice(1,-1).split(",").map(ee=>t(ee,Q)).filter(ee=>ee!==n),j),N=U.length;if(!N)return n;if(N===1)return U[0];const z=function(ee,V){for(let X=0,se=U.length;X<se;X++)if(U[X](ee,V))return j;return null},x=U.find(ee=>!!ee.allBasenames);x&&(z.allBasenames=x.allBasenames);const K=U.reduce((ee,V)=>V.allPaths?ee.concat(V.allPaths):ee,[]);return K.length&&(z.allPaths=K),z}function p(j,Q,U){const N=T.sep===T.posix.sep,z=N?j:j.replace(d,T.sep),x=T.sep+z,K=T.posix.sep+j,ee=U?function(V,X){return typeof V=="string"&&(V===z||V.endsWith(x)||!N&&(V===j||V.endsWith(K)))?Q:null}:function(V,X){return typeof V=="string"&&(V===z||!N&&V===j)?Q:null};return ee.allPaths=[(U?"*/":"./")+j],ee}function k(j){try{const Q=new RegExp(`^${E(j)}$`);return function(U){return Q.lastIndex=0,typeof U=="string"&&Q.test(U)?j:null}}catch(Q){return n}}function O(j,Q,U){return!j||typeof Q!="string"?!1:F(j)(Q,void 0,U)}e.match=O;function F(j,Q={}){if(!j)return s;if(typeof j=="string"||q(j)){const U=t(j,Q);if(U===n)return s;const N=function(z,x){return!!U(z,x)};return U.allBasenames&&(N.allBasenames=U.allBasenames),U.allPaths&&(N.allPaths=U.allPaths),N}return B(j,Q)}e.parse=F;function W(j){if(!j)return;let Q;return U=>(Q||(Q=(j()||Promise.resolve([])).then(N=>N?A(N):{})),Q.then(N=>!!N[U]))}e.hasSiblingPromiseFn=W;function $(j){if(!j)return;let Q;return U=>{if(!Q){const N=j();Q=N?A(N):{}}return!!Q[U]}}e.hasSiblingFn=$;function A(j){const Q={};for(const U of j)Q[U]=!0;return Q}function q(j){const Q=j;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=q;function _(j){return j.allBasenames||[]}e.getBasenameTerms=_;function M(j){return j.allPaths||[]}e.getPathTerms=M;function B(j,Q){const U=H(Object.getOwnPropertyNames(j).map(ee=>Z(ee,j[ee],Q)).filter(ee=>ee!==n)),N=U.length;if(!N)return n;if(!U.some(ee=>!!ee.requiresSiblings)){if(N===1)return U[0];const ee=function(se,oe){for(let le=0,he=U.length;le<he;le++){const be=U[le](se,oe);if(be)return be}return null},V=U.find(se=>!!se.allBasenames);V&&(ee.allBasenames=V.allBasenames);const X=U.reduce((se,oe)=>oe.allPaths?se.concat(oe.allPaths):se,[]);return X.length&&(ee.allPaths=X),ee}const z=function(ee,V,X){let se;for(let oe=0,le=U.length;oe<le;oe++){const he=U[oe];he.requiresSiblings&&X&&(V||(V=T.basename(ee)),se||(se=V.substr(0,V.length-T.extname(ee).length)));const be=he(ee,V,se,X);if(be)return be}return null},x=U.find(ee=>!!ee.allBasenames);x&&(z.allBasenames=x.allBasenames);const K=U.reduce((ee,V)=>V.allPaths?ee.concat(V.allPaths):ee,[]);return K.length&&(z.allPaths=K),z}function Z(j,Q,U){if(Q===!1)return n;const N=t(j,U);if(N===n)return n;if(typeof Q=="boolean")return N;if(Q){const z=Q.when;if(typeof z=="string"){const x=(K,ee,V,X)=>{if(!X||!N(K,ee))return null;const se=z.replace("$(basename)",V),oe=X(se);return(0,D.isThenable)(oe)?oe.then(le=>le?j:null):oe?j:null};return x.requiresSiblings=!0,x}}return N}function H(j,Q){const U=j.filter(ee=>!!ee.basenames);if(U.length<2)return j;const N=U.reduce((ee,V)=>{const X=V.basenames;return X?ee.concat(X):ee},[]);let z;if(Q){z=[];for(let ee=0,V=N.length;ee<V;ee++)z.push(Q)}else z=U.reduce((ee,V)=>{const X=V.patterns;return X?ee.concat(X):ee},[]);const x=function(ee,V){if(typeof ee!="string")return null;if(!V){let se;for(se=ee.length;se>0;se--){const oe=ee.charCodeAt(se-1);if(oe===47||oe===92)break}V=ee.substr(se)}const X=N.indexOf(V);return X!==-1?z[X]:null};x.basenames=N,x.patterns=z,x.allBasenames=N;const K=j.filter(ee=>!ee.basenames);return K.push(x),K}}),define(te[109],ne([0,1,108,16,10,18,25]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let S=[],C=[],I=[];function b(t,o=!1){const c=d(t);S.push(c),c.userConfigured?I.push(c):C.push(c),o&&!c.userConfigured&&S.forEach(u=>{u.mime===c.mime||u.userConfigured||(c.extension&&u.extension===c.extension&&console.warn(`Overwriting extension <<${c.extension}>> to now point to mime <<${c.mime}>>`),c.filename&&u.filename===c.filename&&console.warn(`Overwriting filename <<${c.filename}>> to now point to mime <<${c.mime}>>`),c.filepattern&&u.filepattern===c.filepattern&&console.warn(`Overwriting filepattern <<${c.filepattern}>> to now point to mime <<${c.mime}>>`),c.firstline&&u.firstline===c.firstline&&console.warn(`Overwriting firstline <<${c.firstline}>> to now point to mime <<${c.mime}>>`))})}e.registerTextMime=b;function d(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,D.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(R.posix.sep)>=0:!1}}function v(t){t?(S=S.filter(o=>!o.userConfigured),I=[]):(S=[],C=[],I=[])}e.clearTextMimes=v;function h(t,o){let c;if(t)switch(t.scheme){case L.Schemas.file:c=t.fsPath;break;case L.Schemas.data:c=T.DataUri.parseMetaData(t).get(T.DataUri.META_DATA_LABEL);break;default:c=t.path}if(!c)return[P.unknown];c=c.toLowerCase();const u=(0,R.basename)(c),f=E(c,u,I);if(f)return[f,P.text];const p=E(c,u,C);if(p)return[p,P.text];if(o){const k=y(o);if(k)return[k,P.text]}return[P.unknown]}e.guessMimeTypes=h;function E(t,o,c){let u=null,f=null,p=null;for(let k=c.length-1;k>=0;k--){const O=c[k];if(o===O.filenameLowercase){u=O;break}if(O.filepattern&&(!f||O.filepattern.length>f.filepattern.length)){const F=O.filepatternOnPath?t:o;O.filepatternLowercase?.(F)&&(f=O)}O.extension&&(!p||O.extension.length>p.extension.length)&&o.endsWith(O.extensionLowercase)&&(p=O)}return u?u.mime:f?f.mime:p?p.mime:null}function y(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let o=S.length-1;o>=0;o--){const c=S[o];if(!c.firstline)continue;const u=t.match(c.firstline);if(u&&u.length>0)return c.mime}return null}function m(t){return t?typeof t=="string"?t===P.binary||t===P.text||t===P.unknown:t.length===1&&m(t[0]):!0}e.isUnspecific=m;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(t){const o=(0,R.extname)(t),c=w[o.toLowerCase()];return c!==void 0?c:l(t)}e.getMediaOrTextMime=a;function l(t){const o=(0,R.extname)(t);return g[o.toLowerCase()]}e.getMediaMime=l;function r(t){for(const o in g)if(g[o]===t)return o}e.getExtensionForMimeType=r;const s=/^(.+)\/(.+?)(;.+)?$/;function n(t,o){const c=s.exec(t);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:o?void 0:t}e.normalizeMimeType=n}),define(te[110],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(I){return I.toJSON()}class R{constructor(b){this._uriTransformer=b}transformIncoming(b){const d=this._uriTransformer.transformIncoming(b);return d===b?b:L(D.URI.from(d))}transformOutgoing(b){const d=this._uriTransformer.transformOutgoing(b);return d===b?b:L(D.URI.from(d))}transformOutgoingURI(b){const d=this._uriTransformer.transformOutgoing(b);return d===b?b:D.URI.from(d)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function T(I,b,d){if(!I||d>200)return null;if(typeof I=="object"){if(I instanceof D.URI)return b.transformOutgoing(I);for(let v in I)if(Object.hasOwnProperty.call(I,v)){const h=T(I[v],b,d+1);h!==null&&(I[v]=h)}}return null}function i(I,b){const d=T(I,b,0);return d===null?I:d}e.transformOutgoingURIs=i;function P(I,b,d,v){if(!I||v>200)return null;if(typeof I=="object"){if(I.$mid===1)return d?D.URI.revive(b.transformIncoming(I)):b.transformIncoming(I);for(let h in I)if(Object.hasOwnProperty.call(I,h)){const E=P(I[h],b,d,v+1);E!==null&&(I[h]=E)}}return null}function S(I,b){const d=P(I,b,!1,0);return d===null?I:d}e.transformIncomingURIs=S;function C(I,b){const d=P(I,b,!0,0);return d===null?I:d}e.transformAndReviveIncomingURIs=C}),define(te[29],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return D.test(S)}e.isUUID=L;const R=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(S){for(let C=0;C<S.length;C++)S[C]=Math.floor(Math.random()*256);return S};function P(){i(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let S=0,C="";return C+=T[R[S++]],C+=T[R[S++]],C+=T[R[S++]],C+=T[R[S++]],C+="-",C+=T[R[S++]],C+=T[R[S++]],C+="-",C+=T[R[S++]],C+=T[R[S++]],C+="-",C+=T[R[S++]],C+=T[R[S++]],C+="-",C+=T[R[S++]],C+=T[R[S++]],C+=T[R[S++]],C+=T[R[S++]],C+=T[R[S++]],C+=T[R[S++]],C}e.generateUuid=P}),define(te[111],ne([0,1,243]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const i=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return i;let S=0,C,I=S;for(;I<P.length;)if(C=P.charCodeAt(I),C===13||C===10){if(i.push(P.substring(S,I)),I++,I<P.length){const b=C;C=P.charCodeAt(I),(b===13&&C===10||b===10&&C===13)&&I++}S=I}else I++;return this.remaining=S<P.length?P.substr(S):null,i}end(){return this.remaining}}e.LineDecoder=L}),define(te[112],ne([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(i){const P=i.replace(/\-/g,":").toLowerCase();return!L.has(P)}function T(){const i=(0,D.networkInterfaces)();for(let P in i){const S=i[P];if(S){for(const{mac:C}of S)if(R(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(te[113],ne([0,1,33,9,41,29,112]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,b=0;const d=(0,D.networkInterfaces)();for(let v in d){const h=d[v];if(h)for(const{mac:E,internal:y}of h)y||(b+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(I+=1))}this._value=b>0?I/b:0}return this._value}};let P;async function S(){return P||(P=(async()=>await C()||T.generateUuid())()),P}e.getMachineId=S;async function C(){try{const I=await new Promise((d,v)=>{J(["crypto"],d,v)}),b=(0,i.getMac)();return I.createHash("sha256").update(b,"utf8").digest("hex")}catch(I){L.onUnexpectedError(I);return}}}),define(te[20],ne([0,1,51,33,244,5,42,69,10,4,18,7,29]),function(J,e,D,L,R,T,i,P,S,C,I,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function h(_,M=v.UNLINK){if((0,i.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return M===v.UNLINK?y(_):E(_)}async function E(_){try{const M=(0,S.join)((0,L.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(_,M)}catch(B){return y(_)}y(M).catch(B=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function y(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function m(_){if((0,i.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(_,{recursive:!0})}e.rimrafSync=m;async function w(_,M){return l(await(M?g(_):(0,R.promisify)(D.readdir)(_)))}async function g(_){try{return await(0,R.promisify)(D.readdir)(_,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const M=[],B=await w(_);for(const Z of B){let H=!1,j=!1,Q=!1;try{const U=await e.Promises.lstat((0,S.join)(_,Z));H=U.isFile(),j=U.isDirectory(),Q=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}M.push({name:Z,isFile:()=>H,isDirectory:()=>j,isSymbolicLink:()=>Q})}return M}function a(_){return l(D.readdirSync(_))}e.readdirSync=a;function l(_){return _.map(M=>typeof M=="string"?C.isMacintosh?(0,P.normalizeNFC)(M):M:(M.name=C.isMacintosh?(0,P.normalizeNFC)(M.name):M.name,M))}async function r(_){const M=await w(_),B=[];for(const Z of M)await n.existsDirectory((0,S.join)(_,Z))&&B.push(Z);return B}function s(_,M=1e3){return new Promise(B=>{let Z=!1;const H=setInterval(()=>{Z||(Z=!0,D.access(_,j=>{Z=!1,j&&(clearInterval(H),B(void 0))}))},M)})}e.whenDeleted=s;var n;(function(_){async function M(H){let j;try{if(j=await e.Promises.lstat(H),!j.isSymbolicLink())return{stat:j}}catch(Q){}try{return{stat:await e.Promises.stat(H),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(C.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw U}throw Q}}_.stat=M;async function B(H){try{const{stat:j,symbolicLink:Q}=await _.stat(H);return j.isFile()&&Q?.dangling!==!0}catch(j){}return!1}_.existsFile=B;async function Z(H){try{const{stat:j,symbolicLink:Q}=await _.stat(H);return j.isDirectory()&&Q?.dangling!==!0}catch(j){}return!1}_.existsDirectory=Z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new T.ResourceQueue;function o(_,M,B){return t.queueFor(b.URI.file(_),I.extUriBiasedIgnorePathCase).queue(()=>{const Z=p(B);return new Promise((H,j)=>u(_,M,Z,Q=>Q?j(Q):H()))})}let c=!0;function u(_,M,B,Z){if(!c)return D.writeFile(_,M,{mode:B.mode,flag:B.flag},Z);D.open(_,B.flag,B.mode,(H,j)=>{if(H)return Z(H);D.writeFile(j,M,Q=>{if(Q)return D.close(j,()=>Z(Q));D.fdatasync(j,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),c=!1),D.close(j,N=>Z(N))))})})}function f(_,M,B){const Z=p(B);if(!c)return D.writeFileSync(_,M,{mode:Z.mode,flag:Z.flag});const H=D.openSync(_,Z.flag,Z.mode);try{D.writeFileSync(H,M);try{D.fdatasyncSync(H)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),c=!1}}finally{D.closeSync(H)}}e.writeFileSync=f;function p(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function k(_,M){if(_===M)return;async function B(Z){try{const H=await e.Promises.lstat(Z);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes(Z,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(_,M),await B(M)}catch(Z){if(_.toLowerCase()!==M.toLowerCase()&&Z.code==="EXDEV"||_.endsWith("."))await O(_,M,{preserveSymlinks:!1}),await h(_,v.MOVE),await B(M);else throw Z}}async function O(_,M,B){return W(_,M,{root:{source:_,target:M},options:B,handledSourcePaths:new Set})}const F=511;async function W(_,M,B){if(B.handledSourcePaths.has(_))return;B.handledSourcePaths.add(_);const{stat:Z,symbolicLink:H}=await n.stat(_);if(H){if(B.options.preserveSymlinks)try{return await q(_,M,B)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(H.dangling)return}return Z.isDirectory()?$(_,M,Z.mode&F,B):A(_,M,Z.mode&F)}async function $(_,M,B,Z){await e.Promises.mkdir(M,{recursive:!0,mode:B});const H=await w(_);for(const j of H)await W((0,S.join)(_,j),(0,S.join)(M,j),Z)}async function A(_,M,B){await e.Promises.copyFile(_,M),await e.Promises.chmod(M,B)}async function q(_,M,B){let Z=await e.Promises.readlink(_);(0,i.isEqualOrParent)(Z,B.root.source,!C.isLinux)&&(Z=(0,S.join)(B.root.target,Z.substr(B.root.source.length+1))),await e.Promises.symlink(Z,M)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return r}get writeFile(){return o}get rm(){return h}get move(){return k}get copy(){return O}}}),define(te[114],ne([0,1,51,10,25,20]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(I){const b=(0,L.dirname)(I);if(I===b)return I;const d=((0,L.basename)(I)||I).toLowerCase();try{const h=(0,T.readdirSync)(b).filter(E=>E.toLowerCase()===d);if(h.length===1){const E=i(b);if(E)return(0,L.join)(E,h[0])}else if(h.length>1){const E=h.indexOf(d);if(E>=0){const y=i(b);if(y)return(0,L.join)(y,h[E])}}}catch(v){}return null}e.realcaseSync=i;async function P(I){try{return await T.Promises.realpath(I)}catch(b){const d=C(I);return await T.Promises.access(d,D.constants.R_OK),d}}e.realpath=P;function S(I){try{return D.realpathSync(I)}catch(b){const d=C(I);return D.accessSync(d,D.constants.R_OK),d}}e.realpathSync=S;function C(I){return(0,R.rtrim)((0,L.normalize)(I),L.sep)}}),define(te[115],ne([0,1,57]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(P,S,C,I=1){let b=!1;return new Promise(d=>{const v=setTimeout(()=>{if(!b)return b=!0,d(0)},C);R(P,S,I,h=>{if(!b)return b=!0,clearTimeout(v),d(h)})})}e.findFreePort=L;function R(P,S,C,I){if(S===0)return I(0);const b=new D.Socket;b.once("connect",()=>(i(b),R(P+C,S-1,C,I))),b.once("data",()=>{}),b.once("error",d=>(i(b),d.code!=="ECONNREFUSED"?R(P+C,S-1,C,I):I(P))),b.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(P,S,C){let I=!1,b,d=1;const v=D.createServer({pauseOnConnect:!0});function h(E,y){I||(I=!0,v.removeAllListeners(),v.close(),b&&clearTimeout(b),y(E))}return new Promise(E=>{b=setTimeout(()=>{h(0,E)},C),v.on("listening",()=>{h(P,E)}),v.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&d<S?(P++,d++,v.listen(P,"127.0.0.1")):h(0,E)}),v.on("close",()=>{h(0,E)}),v.listen(P,"127.0.0.1")})}e.findFreePortFaster=T;function i(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(S){console.error(S)}}}),define(te[70],ne([0,1,33,10,20]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,i=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var S;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(S||(S={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class b{constructor(l,r,s){this.exePath=l,this.displayName=r,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:a=!1}={}){return a?C===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:a=!1,findPreview:l=!1}={}){const r=d({useAlternateBitness:a});if(!r)return null;const s=L.join(r,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(s))return null;let n=-1,t=null;for(const u of await R.Promises.readdir(s)){let f=-1;if(l){const k=u.indexOf("-");if(k<0)continue;const O=u.substring(0,k);if(!T.test(O)||u.substring(k+1)!=="preview")continue;f=parseInt(O,10)}else{if(!T.test(u))continue;f=parseInt(u,10)}if(f<=n)continue;const p=L.join(s,u,"pwsh.exe");!await R.SymlinkSupport.existsFile(p)||(t=p,n=f)}if(!t)return null;const o=r.includes("x86")?" (x86)":"",c=l?" Preview":"";return new b(t,`PowerShell${c}${o}`,!0)}async function h({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:s}=a?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:i,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(l))if(r.test(n)){const t=L.join(l,n,"pwsh.exe");return new b(t,s)}return null}function E(){const a=L.join(D.homedir(),".dotnet","tools","pwsh.exe");return new b(a,".NET Core PowerShell Global Tool")}function y(){const a=L.join(process.env.windir,C===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(a,"Windows PowerShell",!0)}async function*m(){let a=await v();a&&(yield a),a=await v({useAlternateBitness:!0}),a&&(yield a),a=await h(),a&&(yield a),a=E(),a&&(yield a),a=await v({findPreview:!0}),a&&(yield a),a=await h({findPreview:!0}),a&&(yield a),a=await v({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=y(),a&&(yield a)}async function*w(){for await(const a of m())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=w;async function g(){for await(const a of w())return a;return null}e.getFirstAvailablePowerShellInstallation=g}),define(te[116],ne([0,1,45,16]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(i){return new Promise((P,S)=>{let C;const I=new Map;function b(v,h,E,y,m){const w=I.get(h);if(v===i||w){const g={name:d(E),cmd:E,pid:v,ppid:h,load:y,mem:m};I.set(v,g),v===i&&(C=g),w&&(w.children||(w.children=[]),w.children.push(g),w.children.length>1&&(w.children=w.children.sort((a,l)=>a.pid-l.pid)))}}function d(v){const h=/--vscode-window-kind=shared-process/,E=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,w=/--crashes-directory/,g=/\\pipe\\winpty-control/,a=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(v))return"electron-crash-reporter";if(g.exec(v))return"winpty-process";if(a.exec(v))return"console-window-host (Windows internal process)";let r=l.exec(v);if(r&&r.length===2)return r[1]==="renderer"?h.exec(v)?"shared-process":E.exec(v)?"issue-reporter":y.exec(v)?"process-explorer":"window":r[1]==="utility"&&m.exec(v)?"utility-network-service":r[1];const s=/[a-zA-Z-]+\.js/g;let n="";do r=s.exec(v),r&&(n+=r+" ");while(r);return n&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${n}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,E)=>{J(["windows-process-tree"],h,E)}).then(h=>{h.getProcessList(i,E=>{h.getProcessCpuUsage(E,y=>{const m=new Map;y.forEach(w=>{const g=v(w.commandLine||"");m.set(w.pid,{name:d(g),cmd:g,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),C=m.get(i),C?(m.forEach(w=>{const g=m.get(w.ppid);g&&(g.children||(g.children=[]),g.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((g,a)=>g.pid-a.pid))}),P(C)):S(new Error(`Root process ${i} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[C];const E=[];for(;h.length;){const m=h.shift();m&&(E.push(m.pid),m.children&&(h=h.concat(m.children)))}let y=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);y+=" "+E.join(" "),(0,D.exec)(y,{},(m,w,g)=>{if(m||g)S(m||new Error(g.toString()));else{const a=w.toString().split(`
`);for(let l=0;l<E.length;l++){const r=I.get(E[l]);r.load=parseFloat(a[l])}if(!C){S(new Error(`Root process ${i} not found`));return}P(C)}})};(0,D.exec)("which ps",{},(h,E,y)=>{if(h||y)if(process.platform!=="linux")S(h||new Error(y.toString()));else{const m=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,D.exec)(m,{},(w,g,a)=>{w||a?S(w||new Error(a.toString())):(T(g,b),v())})}else{const m=E.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${m} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,a,l)=>{g||l&&!l.includes("screen size is bogus")?S(g||new Error(l.toString())):(T(a,b),process.platform==="linux"?v():C?P(C):S(new Error(`Root process ${i} not found`)))})}})}})}e.listProcesses=R;function T(i,P){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=i.toString().split(`
`);for(const I of C){const b=S.exec(I.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(te[117],ne([0,1,51,27,42,2,69,10,4,20]),function(J,e,D,L,R,T,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function I(h,E,y){return d({path:h,isDirectory:!1},E,y)}e.watchFile=I;function b(h,E,y){return d({path:h,isDirectory:!0},E,y)}e.watchFolder=b,e.CHANGE_BUFFER_DELAY=100;function d(h,E,y){if(S.isMacintosh&&(0,R.isEqualOrParent)(h.path,"/Volumes/"))return y(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const m=(0,P.basename)(h.path),w=new Map;let g=!1,a=[(0,T.toDisposable)(()=>{w.forEach(l=>(0,T.dispose)(l)),w.clear()})];try{const l=(0,D.watch)(h.path);a.push((0,T.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const r=new Set;h.isDirectory&&C.Promises.readdir(h.path).then(s=>s.forEach(n=>r.add(n))),l.on("error",(s,n)=>{g||y(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${n})`)}),l.on("change",(s,n)=>{if(g)return;let t="";if(n&&(t=n.toString(),S.isMacintosh&&(t=(0,i.normalizeNFC)(t))),!t||s!=="change"&&s!=="rename")return;const o=h.isDirectory?(0,P.join)(h.path,t):h.path;if(h.isDirectory)if(s==="rename"){const c=w.get(o);c&&(0,T.dispose)(c);const u=setTimeout(async()=>{w.delete(o);const f=await C.Promises.exists(o);if(g)return;let p;f?r.has(t)?p="changed":(p="added",r.add(t)):(r.delete(t),p="deleted"),E(p,o)},e.CHANGE_BUFFER_DELAY);w.set(o,(0,T.toDisposable)(()=>clearTimeout(u)))}else{let c;r.has(t)?c="changed":(c="added",r.add(t)),E(c,o)}else if(s==="rename"||t!==m){const c=setTimeout(async()=>{const u=await C.Promises.exists(o);g||(u?(E("changed",o),a=[d(h,E,y)]):E("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,T.dispose)(a),a=[(0,T.toDisposable)(()=>clearTimeout(c))]}else E("changed",o)})}catch(l){C.Promises.exists(h.path).then(r=>{r&&!g&&y(`Failed to watch ${h.path} for changes using fs.watch() (${l.toString()})`)})}return(0,T.toDisposable)(()=>{g=!0,a=(0,T.dispose)(a)})}async function v(h,E,y,m=512){const w=await C.Promises.open(h,"r"),g=Buffer.allocUnsafe(m),a=new L.CancellationTokenSource(y);let l,r=!1;const s=I(h,async n=>{if(n==="changed"){if(r)return;r=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:t}=await C.Promises.read(w,g,0,m,null);if(!t||a.token.isCancellationRequested)break;E(g.slice(0,t))}}catch(t){l=new Error(t),a.dispose(!0)}finally{r=!1}}},n=>{l=new Error(n),a.dispose(!0)});return new Promise((n,t)=>{a.token.onCancellationRequested(async()=>{s.dispose(),await C.Promises.close(w),l?t(l):n()})})}e.watchFileContents=v});var de=this&&this.__decorate||function(J,e,D,L){var R=arguments.length,T=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,D,L);else for(var P=J.length-1;P>=0;P--)(i=J[P])&&(T=(R<3?i(T):R>3?i(e,D,T):i(e,D))||T);return R>3&&T&&Object.defineProperty(e,D,T),T};define(te[34],ne([0,1,17,5,19,27,67,9,3,2,107,25,15]),function(J,e,D,L,R,T,i,P,S,C,I,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(E=e.ResponseType||(e.ResponseType={}));function y(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(m||(m={}));class w{constructor(j){this.buffer=j,this.pos=0}read(j){const Q=this.buffer.slice(this.pos,this.pos+j);return this.pos+=Q.byteLength,Q}}class g{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var a;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(a||(a={}));function l(H){const j=R.VSBuffer.alloc(4);return j.writeUInt32BE(H,0),j}function r(H){return H.read(4).readUInt32BE(0)}function s(H){const j=R.VSBuffer.alloc(1);return j.writeUInt8(H,0),j}const n={Undefined:s(a.Undefined),String:s(a.String),Buffer:s(a.Buffer),VSBuffer:s(a.VSBuffer),Array:s(a.Array),Object:s(a.Object)},t=typeof Buffer!="undefined";function o(H,j){if(typeof j=="undefined")H.write(n.Undefined);else if(typeof j=="string"){const Q=R.VSBuffer.fromString(j);H.write(n.String),H.write(l(Q.byteLength)),H.write(Q)}else if(t&&Buffer.isBuffer(j)){const Q=R.VSBuffer.wrap(j);H.write(n.Buffer),H.write(l(Q.byteLength)),H.write(Q)}else if(j instanceof R.VSBuffer)H.write(n.VSBuffer),H.write(l(j.byteLength)),H.write(j);else if(Array.isArray(j)){H.write(n.Array),H.write(l(j.length));for(const Q of j)o(H,Q)}else{const Q=R.VSBuffer.fromString(JSON.stringify(j));H.write(n.Object),H.write(l(Q.byteLength)),H.write(Q)}}function c(H){switch(H.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return H.read(r(H)).toString();case a.Buffer:return H.read(r(H)).buffer;case a.VSBuffer:return H.read(r(H));case a.Array:{const Q=r(H),U=[];for(let N=0;N<Q;N++)U.push(c(H));return U}case a.Object:return JSON.parse(H.read(r(H)).toString())}}class u{constructor(j,Q,U=null,N=1e3){this.protocol=j,this.ctx=Q,this.logger=U,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(j,Q){this.channels.set(j,Q),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const Q=this.send([j.type]);this.logger&&this.logger.logOutgoing(Q,0,1,y(j.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([j.type,j.id],j.data);this.logger&&this.logger.logOutgoing(Q,j.id,1,y(j.type),j.data);return}}}send(j,Q=void 0){const U=new g;return o(U,j),o(U,Q),this.sendBuffer(U.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch(Q){return 0}}onRawMessage(j){const Q=new w(j),U=c(Q),N=c(Q),z=U[0];switch(z){case 100:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${h(z)}: ${U[2]}.${U[3]}`,N),this.onPromise({type:z,id:U[1],channelName:U[2],name:U[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${h(z)}: ${U[2]}.${U[3]}`,N),this.onEventListen({type:z,id:U[1],channelName:U[2],name:U[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${h(z)}`),this.disposeActiveRequest({type:z,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${h(z)}`),this.disposeActiveRequest({type:z,id:U[1]})}}onPromise(j){const Q=this.channels.get(j.channelName);if(!Q){this.collectPendingRequest(j);return}const U=new T.CancellationTokenSource;let N;try{N=Q.call(this.ctx,j.name,j.arg,U.token)}catch(K){N=Promise.reject(K)}const z=j.id;N.then(K=>{this.sendResponse({id:z,data:K,type:201}),this.activeRequests.delete(j.id)},K=>{K instanceof Error?this.sendResponse({id:z,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:z,data:K,type:203}),this.activeRequests.delete(j.id)});const x=(0,C.toDisposable)(()=>U.cancel());this.activeRequests.set(j.id,x)}onEventListen(j){const Q=this.channels.get(j.channelName);if(!Q){this.collectPendingRequest(j);return}const U=j.id,z=Q.listen(this.ctx,j.name,j.arg)(x=>this.sendResponse({id:U,data:x,type:204}));this.activeRequests.set(j.id,z)}disposeActiveRequest(j){const Q=this.activeRequests.get(j.id);Q&&(Q.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let Q=this.pendingRequests.get(j.channelName);Q||(Q=[],this.pendingRequests.set(j.channelName,Q));const U=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:j,timeoutTimer:U})}flushPendingRequests(j){const Q=this.pendingRequests.get(j);if(Q){for(const U of Q)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var f;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(j,Q=null){this.protocol=j,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=Q}getChannel(j){const Q=this;return{call(U,N,z){return Q.isDisposed?Promise.reject(P.canceled()):Q.requestPromise(j,U,N,z)},listen(U,N){return Q.isDisposed?Promise.reject(P.canceled()):Q.requestEvent(j,U,N)}}}requestPromise(j,Q,U,N=T.CancellationToken.None){const z=this.lastRequestId++,K={id:z,type:100,channelName:j,name:Q,arg:U};if(N.isCancellationRequested)return Promise.reject(P.canceled());let ee;return new Promise((X,se)=>{if(N.isCancellationRequested)return se(P.canceled());const oe=()=>{const Ce=we=>{switch(we.type){case 201:this.handlers.delete(z),X(we.data);break;case 202:this.handlers.delete(z);const ve=new Error(we.data.message);ve.stack=we.data.stack,ve.name=we.data.name,se(ve);break;case 203:this.handlers.delete(z),se(we.data);break}};this.handlers.set(z,Ce),this.sendRequest(K)};let le=null;this.state===m.Idle?oe():(le=(0,L.createCancelablePromise)(Ce=>this.whenInitialized()),le.then(()=>{le=null,oe()}));const he=()=>{le?(le.cancel(),le=null):this.sendRequest({id:z,type:101}),se(P.canceled())},be=N.onCancellationRequested(he);ee=(0,C.combinedDisposable)((0,C.toDisposable)(he),be),this.activeRequests.add(ee)}).finally(()=>{this.activeRequests.delete(ee)})}requestEvent(j,Q,U){const N=this.lastRequestId++,x={id:N,type:102,channelName:j,name:Q,arg:U};let K=null;const ee=new S.Emitter({onFirstListenerAdd:()=>{K=(0,L.createCancelablePromise)(X=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(ee),this.sendRequest(x)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(ee),this.sendRequest({id:N,type:103}))}}),V=X=>ee.fire(X.data);return this.handlers.set(N,V),ee.event}sendRequest(j){switch(j.type){case 100:case 102:{const Q=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(Q,j.id,0,`${h(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const Q=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(Q,j.id,0,h(j.type));return}}}send(j,Q=void 0){const U=new g;return o(U,j),o(U,Q),this.sendBuffer(U.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch(Q){return 0}}onBuffer(j){const Q=new w(j),U=c(Q),N=c(Q),z=U[0];switch(z){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,y(z)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],0,y(z),N),this.onResponse({type:U[0],id:U[1],data:N})}}onResponse(j){if(j.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const Q=this.handlers.get(j.id);Q&&Q(j)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}de([i.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class k{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:Q,onDidClientDisconnect:U})=>{S.Event.once(Q.onMessage)(z=>{const x=new w(z),K=c(x),ee=new u(Q,K),V=new p(Q);this.channels.forEach((se,oe)=>ee.registerChannel(oe,se));const X={channelServer:ee,channelClient:V,ctx:K};this._connections.add(X),this._onDidAddConnection.fire(X),U(()=>{ee.dispose(),V.dispose(),this._connections.delete(X),this._onDidRemoveConnection.fire(X)})})})}get connections(){const j=[];return this._connections.forEach(Q=>j.push(Q)),j}getChannel(j,Q){const U=this;return{call(N,z,x){let K;if((0,d.isFunction)(Q)){let V=(0,D.getRandomElement)(U.connections.filter(Q));K=V?Promise.resolve(V):S.Event.toPromise(S.Event.filter(U.onDidAddConnection,Q))}else K=Q.routeCall(U,N,z);const ee=K.then(V=>V.channelClient.getChannel(j));return F(ee).call(N,z,x)},listen(N,z){if((0,d.isFunction)(Q))return U.getMulticastEvent(j,Q,N,z);const x=Q.routeEvent(U,N,z).then(K=>K.channelClient.getChannel(j));return F(x).listen(N,z)}}}getMulticastEvent(j,Q,U,N){const z=this;let x=new C.DisposableStore;const K=new S.Emitter({onFirstListenerAdd:()=>{x=new C.DisposableStore;const ee=new S.EventMultiplexer,V=new Map,X=oe=>{const he=oe.channelClient.getChannel(j).listen(U,N),be=ee.add(he);V.set(oe,be)},se=oe=>{const le=V.get(oe);!le||(le.dispose(),V.delete(oe))};z.connections.filter(Q).forEach(X),S.Event.filter(z.onDidAddConnection,Q)(X,void 0,x),z.onDidRemoveConnection(se,void 0,x),ee.event(K.fire,K,x),x.add(ee)},onLastListenerRemove:()=>{x.dispose()}});return K.event}registerChannel(j,Q){this.channels.set(j,Q),this._connections.forEach(U=>{U.channelServer.registerChannel(j,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=k;class O{constructor(j,Q,U=null){const N=new g;o(N,Q),j.send(N.buffer),this.channelClient=new p(j,U),this.channelServer=new u(j,Q,U)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,Q){this.channelServer.registerChannel(j,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function F(H){return{call(j,Q,U){return H.then(N=>N.call(j,Q,U))},listen(j,Q){const U=new S.Relay;return H.then(N=>U.input=N.listen(j,Q)),U.event}}}e.getDelayedChannel=F;function W(H){let j=!1;return{call(Q,U,N){return j?H.call(Q,U,N):(0,L.timeout)(0).then(()=>j=!0).then(()=>H.call(Q,U,N))},listen(Q,U){if(j)return H.listen(Q,U);const N=new S.Relay;return(0,L.timeout)(0).then(()=>j=!0).then(()=>N.input=H.listen(Q,U)),N.event}}}e.getNextTickChannel=W;class ${constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const Q of j.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=$;var A;(function(H){function j(z,x){const K=z,ee=x&&x.disableMarshalling,V=new Map;for(const X in K)U(X)&&V.set(X,S.Event.buffer(K[X],!0));return new class{listen(X,se,oe){const le=V.get(se);if(le)return le;if(N(se)){const he=K[se];if(typeof he=="function")return he.call(K,oe)}throw new Error(`Event not found: ${se}`)}call(X,se,oe){const le=K[se];if(typeof le=="function"){if(!ee&&Array.isArray(oe))for(let he=0;he<oe.length;he++)oe[he]=(0,I.revive)(oe[he]);return le.apply(K,oe)}throw new Error(`Method not found: ${se}`)}}}H.fromService=j;function Q(z,x){const K=x&&x.disableMarshalling;return new Proxy({},{get(ee,V){if(typeof V=="string")return x?.properties?.has(V)?x.properties.get(V):N(V)?function(X){return z.listen(V,X)}:U(V)?z.listen(V):async function(...X){let se;x&&!(0,d.isUndefinedOrNull)(x.context)?se=[x.context,...X]:se=X;const oe=await z.call(V,se);return K?oe:(0,I.revive)(oe)};throw new Error(`Property not found: ${String(V)}`)}})}H.toService=Q;function U(z){return z[0]==="o"&&z[1]==="n"&&b.isUpperAsciiLetter(z.charCodeAt(2))}function N(z){return/^onDynamic/.test(z)&&b.isUpperAsciiLetter(z.charCodeAt(9))}})(A=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let j=H.toString();if(j!=="[object Object]")return j}return H}function M(H){return Array.isArray(H)?H.map(_):_(H)}function B(H,j,Q,U,N,z,x){x=M(x);const K=q[N],ee=K[U%K.length];let V=[`%c[${H}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${ee}`];/\($/.test(z)?(V=V.concat(x),V.push(")")):V.push(x),console.log.apply(console,V)}e.logWithColors=B;class Z{constructor(j,Q){this._outgoingPrefix=j,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,Q,U,N,z){this._totalOutgoing+=j,B(this._outgoingPrefix,this._totalOutgoing,j,Q,U,N,z)}logIncoming(j,Q,U,N,z){this._totalIncoming+=j,B(this._incomingPrefix,this._totalIncoming,j,Q,U,N,z)}}e.IPCLogger=Z}),define(te[118],ne([0,1,19,3,34]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(S){this.port=S,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",C=>D.VSBuffer.wrap(C.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class i extends R.IPCClient{constructor(S,C){const I=new T(S);super(I,C);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=i}),define(te[71],ne([0,1,19,3,2,34]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var i;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(i=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function S(){return P||(P=D.VSBuffer.alloc(0)),P}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,n){if(s===0)return S();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const u=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=s),u}if(this._chunks[0].byteLength>s){const u=this._chunks[0].slice(0,s);return n&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),u}let t=D.VSBuffer.alloc(s),o=0,c=0;for(;s>0;){const u=this._chunks[c];if(u.byteLength>s){const f=u.slice(0,s);t.set(f,o),o+=s,n&&(this._chunks[c]=u.slice(s),this._totalLength-=s),s-=s}else t.set(u,o),o+=u.byteLength,n?(this._chunks.shift(),this._totalLength-=u.byteLength):c++,s-=u.byteLength}return t}}e.ChunkStream=C;var I;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var b;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,n,t,o){this.type=s,this.id=n,this.ack=t,this.data=o,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends R.Disposable{constructor(s){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5);else{const t=this._state.messageType,o=this._state.id,c=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(t,o,c,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=D.VSBuffer.alloc(13);n.writeUInt8(s.type,0),n.writeUInt32BE(s.id,1),n.writeUInt32BE(s.ack,5),n.writeUInt32BE(s.data.byteLength,9),this._writeSoon(n,s.data)}_bufferAdd(s,n){const t=this._totalLength===0;return this._data.push(s,n),this._totalLength+=s.byteLength+n.byteLength,t}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,n){this._bufferAdd(s,n)&&setTimeout(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends R.Disposable{constructor(s){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new d(1,0,0,s))}}e.Protocol=E;class y extends T.IPCClient{constructor(s,n,t=null){super(s,n,t);this.protocol=s}static fromSocket(s,n){return new y(new E(s),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=y;class m{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=m;class w{constructor(s){this.data=s,this.next=null}}class g{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],n=0,t=this._first;for(;t;)s[n++]=t.data,t=t.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const n=new w(s);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let n=0;n<a._HISTORY_LENGTH;n++)this.lastRuns[n]=s-1e3*n;setInterval(()=>{for(let n=a._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),n=(1+a._HISTORY_LENGTH)*1e3;let t=0;for(let o=0;o<a._HISTORY_LENGTH;o++)s-this.lastRuns[o]<=n&&t++;return 1-t/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class l{constructor(s,n=null,t=a.getInstance()){this._onControlMessage=new m,this.onControlMessage=this._onControlMessage.event,this._onMessage=new m,this.onMessage=this._onMessage.event,this._onDidDispose=new m,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new m,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new m,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=t,this._isReconnecting=!1,this._outgoingUnackMsg=new g,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),n&&this._socketReader.acceptChunk(n),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new d(5,0,0,S());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const n=new d(4,0,0,S());this._socketWriter.write(n),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,n){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(t=>this._receiveMessage(t))),this._socketDisposables.push(this._socket.onClose(t=>this._onSocketClose.fire(t))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let n=0,t=s.length;n<t;n++)this._socketWriter.write(s[n]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new d(6,0,0,S())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const n=this._outgoingUnackMsg.toArray();for(let t=0,o=n.length;t<o;t++)this._socketWriter.write(n[t]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const t=new d(1,n,this._incomingAckId,s);this._outgoingUnackMsg.push(t),this._isReconnecting||(this._socketWriter.write(t),this._recvAckCheck())}sendControl(s){const n=new d(2,0,0,s);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),n=Date.now()-s.writtenTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-n,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,S());this._socketWriter.write(s)}}e.PersistentProtocol=l}),define(te[119],ne([0,1,72,3,34,118]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class i extends R.IPCServer{static getOnDidClientConnect(){const S=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(C,I)=>I);return L.Event.map(S,C=>{const{port1:I,port2:b}=new MessageChannel,v={protocol:new T.Protocol(I),onDidClientDisconnect:L.Event.fromDOMEventEmitter(I,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[b]),v})}constructor(){super(i.getOnDidClientConnect())}}e.Server=i}),define(te[120],ne([0,1,19,9]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,S){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((I,b)=>{C.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(C,P),C.responseType="arraybuffer",C.onerror=d=>b(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=d=>{I({res:{statusCode:C.status,headers:i(C)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=d=>b(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(C.timeout=P.timeout),C.send(P.data),S.onCancellationRequested(()=>{C.abort(),b((0,L.canceled)())})})}e.request=R;function T(P,S){if(S.headers){e:for(let C in S.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(C,S.headers[C])}}}function i(P){const S=Object.create(null);for(const C of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const I=C.indexOf(":");S[C.substr(0,I).trim().toLowerCase()]=C.substr(I+1).trim()}return S}}),define(te[73],ne([0,1,5,3,2,15]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var i;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(i=e.StorageHint||(e.StorageHint={}));function P(b){const d=b;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var S;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(S||(S={}));class C extends R.Disposable{constructor(d,v=Object.create(null)){super();this.database=d,this.options=v,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((v,h)=>this.accept(h,v)),d.deleted?.forEach(v=>this.accept(v,void 0))}accept(d,v){if(this.state===S.Closed)return;let h=!1;(0,T.isUndefinedOrNull)(v)?h=this.cache.delete(d):this.cache.get(d)!==v&&(this.cache.set(d,v),h=!0),h&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==i.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,v){const h=this.cache.get(d);return(0,T.isUndefinedOrNull)(h)?v:h}getBoolean(d,v){const h=this.get(d);return(0,T.isUndefinedOrNull)(h)?v:h==="true"}getNumber(d,v){const h=this.get(d);return(0,T.isUndefinedOrNull)(h)?v:parseInt(h,10)}async set(d,v){if(this.state===S.Closed)return;if((0,T.isUndefinedOrNull)(v))return this.delete(d);const h=String(v);if(this.cache.get(d)!==h)return this.cache.set(d,h),this.pendingInserts.set(d,h),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===S.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.doFlush(0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((v,h)=>this.items.set(h,v)),d.delete&&d.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=I}),define(te[121],ne([12,13]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[58],ne([0,1,121]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,T=R*24,i=T*7,P=T*30,S=T*365;function C(b,d){typeof b!="number"&&(b=b.getTime());const v=Math.round((new Date().getTime()-b)/1e3);if(v<-30)return(0,D.localize)(0,null,C(new Date().getTime()+v*1e3,!1));if(v<30)return(0,D.localize)(1,null);let h;return v<L?(h=v,d?h===1?(0,D.localize)(2,null,h):(0,D.localize)(3,null,h):h===1?(0,D.localize)(4,null,h):(0,D.localize)(5,null,h)):v<R?(h=Math.floor(v/L),d?h===1?(0,D.localize)(6,null,h):(0,D.localize)(7,null,h):h===1?(0,D.localize)(8,null,h):(0,D.localize)(9,null,h)):v<T?(h=Math.floor(v/R),d?h===1?(0,D.localize)(10,null,h):(0,D.localize)(11,null,h):h===1?(0,D.localize)(12,null,h):(0,D.localize)(13,null,h)):v<i?(h=Math.floor(v/T),d?h===1?(0,D.localize)(14,null,h):(0,D.localize)(15,null,h):h===1?(0,D.localize)(16,null,h):(0,D.localize)(17,null,h)):v<P?(h=Math.floor(v/i),d?h===1?(0,D.localize)(18,null,h):(0,D.localize)(19,null,h):h===1?(0,D.localize)(20,null,h):(0,D.localize)(21,null,h)):v<S?(h=Math.floor(v/P),d?h===1?(0,D.localize)(22,null,h):(0,D.localize)(23,null,h):h===1?(0,D.localize)(24,null,h):(0,D.localize)(25,null,h)):(h=Math.floor(v/S),d?h===1?(0,D.localize)(26,null,h):(0,D.localize)(27,null,h):h===1?(0,D.localize)(28,null,h):(0,D.localize)(29,null,h))}e.fromNow=C;function I(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(te[122],ne([12,13]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,17,15,122]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(C,I){return I&&(C.stack||C.stacktrace)?R.localize(0,null,P(C),i(C.stack)||i(C.stacktrace)):P(C)}function i(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?R.localize(1,null,C.message):C.message||R.localize(2,null)}function S(C=null,I=!1){if(!C)return R.localize(3,null);if(Array.isArray(C)){const b=D.coalesce(C),d=S(b[0],I);return b.length>1?R.localize(4,null,d,b.length):d}if(L.isString(C))return C;if(C.detail){const b=C.detail;if(b.error)return T(b.error,I);if(b.exception)return T(b.exception,I)}return C.stack?T(C,I):C.message?C.message:R.localize(5,null)}e.toErrorMessage=S}),define(te[123],ne([12,13]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,45,42,16,28,10,4,32,102,15,111,20,123]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function E(r,s){if(P.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};s&&(n.cwd=s);const t=D.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],n);return new Promise(o=>{t.once("error",c=>{o({success:!1,error:c})}),t.once("exit",(c,u)=>{o(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(P.isLinux||P.isMacintosh)try{const n=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{D.execFile(n,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,c,u)=>{t(o?{success:!1,error:o}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function y(r){!r||(delete r.DEBUG,P.isMacintosh&&delete r.DYLD_LIBRARY_PATH,P.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=y;function m(r=S.env){return r.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(s,n,t,o){if(n!==void 0&&t!==void 0&&o!==void 0)this.cmd=s,this.args=n,this.shell=t,this.options=o;else{const c=s;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(S.env).forEach(u=>{c[u]=S.env[u]}),Object.keys(this.options.env).forEach(u=>{c[u]=this.options.env[u]}),this.options.env=c}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const n=s.lastIndexOf(i.sep);return n!==-1&&(s=s.substring(n+1)),w.WellKnowCommands[s]?s:"other"}start(s){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(v.localize(0,null))):this.useExec().then(n=>{let t,o;const c=new Promise((u,f)=>{t=u,o=f});if(n){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(f,p,k)=>{this.childProcess=null;const O=f;O&&O.killed?o({killed:this.terminateRequested,stdout:p.toString(),stderr:k.toString()}):this.handleExec(t,s,f,p,k)})}else{let u=null;const f=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,t,s,o);const k={terminated:this.terminateRequested};I.isNumber(p)&&(k.cmdCode=p),t(k)};if(this.shell&&P.isWindows){const p=T.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let k=!1,O=!1;const F=[];let W=this.ensureQuotes(this.cmd);F.push(W.value),k=W.quoted,this.args&&this.args.forEach(A=>{W=this.ensureQuotes(A),F.push(W.value),O=O&&W.quoted});const $=["/s","/c"];k?O?$.push('"'+F.join(" ")+'"'):F.length>1?$.push('"'+F[0]+'" '+F.slice(1).join(" ")):$.push('"'+F[0]+'"'):$.push(F.join(" ")),u=D.spawn(m(),$,p)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(I.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",p=>{this.childProcess=null,o({terminated:this.terminateRequested,error:p})}),u.pid&&(this.childProcess.on("close",f),this.handleSpawn(u,t,s,o,!0)))}return c})}handleClose(s,n,t,o){}ensureQuotes(s){return w.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,E(s,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!P.isWindows)return s(!1);const n=D.spawn(m(),["/s","/c"]);n.on("error",t=>s(!0)),n.on("exit",t=>s(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class g extends w{constructor(s,n,t,o){super(s,n,t,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,n,t,o,c){[o,c].forEach((u,f)=>{const p=new b.LineDecoder;p.write(u).forEach(F=>{n({line:F,source:f===0?0:1})});const O=p.end();O&&n({line:O,source:f===0?0:1})}),s({terminated:this.terminateRequested,error:t})}handleSpawn(s,n,t,o,c){const u=new b.LineDecoder,f=new b.LineDecoder;s.stdout.on("data",p=>{u.write(p).forEach(O=>t({line:O,source:0}))}),s.stderr.on("data",p=>{f.write(p).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=f}handleClose(s,n,t,o){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&t({line:c,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=g;function a(r){let s=[],n=!1;const t=function(o){if(n){s.push(o);return}(!r.send(o,u=>{if(u&&console.error(u),n=!1,s.length>0){const f=s.slice(0);s=[],f.forEach(p=>t(p))}})||P.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=a;var l;(function(r){async function s(n,t,o){if(i.isAbsolute(n))return n;if(t===void 0&&(t=S.cwd()),i.dirname(n)!=="."||(o===void 0&&I.isString(S.env.PATH)&&(o=S.env.PATH.split(i.delimiter)),o===void 0||o.length===0))return i.join(t,n);async function u(f){if(await d.Promises.exists(f)){let p;try{p=await d.Promises.stat(f)}catch(k){k.message.startsWith("EACCES")&&(p=await d.Promises.lstat(f))}return p?!p.isDirectory():!1}return!1}for(let f of o){let p;if(i.isAbsolute(f)?p=i.join(f,n):p=i.join(t,f,n),await u(p))return p;let k=p+".com";if(await u(k)||(k=p+".exe",await u(k)))return k}return i.join(t,n)}r.findExecutable=s})(l=e.win32||(e.win32={}))}),define(te[124],ne([0,1,33,4,70,74]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function i(v,h){return v===1?L.isWindows?b():T.getWindowsShell(h):C(v,h)}e.getSystemShell=i;function P(v,h){return v===1?L.isWindows?d(h):T.getWindowsShell(h):C(v,h)}e.getSystemShellSync=P;let S=null;function C(v,h){if(L.isLinux&&v===2||L.isMacintosh&&v===3)return"/bin/bash";if(!S){let E;if(L.isWindows)E="/bin/bash";else{if(E=h.SHELL,!E)try{E=(0,D.userInfo)().shell}catch(y){}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}S=E}return S}let I=null;async function b(){return I||(I=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),I}function d(v){if(I)return I;const h=L.isWindows&&parseFloat((0,D.release)())>=10,E=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${v.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?y:T.getWindowsShell(v)}}),define(te[52],ne([0,1,45,5,19,27,106,9,3,2,28,74,34]),function(J,e,D,L,R,T,i,P,S,C,I,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends d.ChannelServer{constructor(y){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(w){}},onMessage:S.Event.fromNodeEventEmitter(process,"message",m=>R.VSBuffer.wrap(Buffer.from(m,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=v;class h{constructor(y,m){this.modulePath=y,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new S.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new L.Delayer(w),this.child=null,this._client=null}getChannel(y){const m=this;return{call(w,g,a){return m.requestPromise(y,w,g,a)},listen(w,g){return m.requestEvent(y,w,g)}}}requestPromise(y,m,w,g=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(y),l=(0,L.createCancelablePromise)(n=>a.call(m,w,n)),r=g.onCancellationRequested(()=>l.cancel()),s=(0,C.toDisposable)(()=>l.cancel());return this.activeRequests.add(s),l.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(y,m,w){if(!this.disposeDelayer)return S.Event.None;this.disposeDelayer.cancel();let g;const a=new S.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(y).listen(m,w)(a.fire,a),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,b.removeDangerousEnvVariables)(m.env),this.child=(0,D.fork)(this.modulePath,y,m);const w=new S.Emitter;S.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,i.isRemoteConsoleLog)(t)){(0,i.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(R.VSBuffer.wrap(Buffer.from(t,"base64")))});const a=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&a.send(t.buffer.toString("base64")),r=w.event,s={send:l,onMessage:r};this._client=new d.ChannelClient(s);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,o)=>{process.removeListener("exit",n),this.activeRequests.forEach(c=>(0,C.dispose)(c)),this.activeRequests.clear(),t!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:o})})}return this._client}getCachedChannel(y){let m=this.channels.get(y);return m||(m=this.client.getChannel(y),this.channels.set(y,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[125],ne([12,13]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[126],ne([12,13]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[127],ne([12,13]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[128],ne([12,13]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[129],ne([12,13]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[130],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[131],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[132],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[133],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[134],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[135],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[136],ne([12,13]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[137],ne([12,13]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[138],ne([12,13]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[139],ne([12,13]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[140],ne([12,13]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[141],ne([12,13]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[142],ne([12,13]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[143],ne([12,13]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[144],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[145],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[146],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[147],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[148],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[149],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[150],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var L;(function(i){i.Team="team",i.Internal="internal",i.Insiders="insider",i.Public="public"})(L=e.TargetPopulation||(e.TargetPopulation={}));var R;(function(i){i.Market="X-MSEdge-Market",i.CorpNet="X-FD-Corpnet",i.ApplicationVersion="X-VSCode-AppVersion",i.Build="X-VSCode-Build",i.ClientId="X-MSEdge-ClientId",i.ExtensionName="X-VSCode-ExtensionName",i.Language="X-VSCode-Language",i.TargetPopulation="X-VSCode-TargetPopulation"})(R=e.Filters||(e.Filters={}));class T{constructor(P,S,C,I){this.version=P,this.appName=S,this.machineId=C,this.targetPopulation=I}getFilterValue(P){switch(P){case R.ApplicationVersion:return this.version;case R.Build:return this.appName;case R.ClientId:return this.machineId;case R.Language:return D.language;case R.ExtensionName:return"vscode-core";case R.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let P=new Map,S=Object.values(R);for(let C of S)P.set(C,this.getFilterValue(C));return P}}e.AssignmentFilterProvider=T}),define(te[75],ne([0,1,58,67,16,10,32,18,7]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(E,y,m){this._args=E,this.paths=y,this.productService=m}get appRoot(){return(0,T.dirname)(R.FileAccess.asFileUri("",J).fsPath)}get userHome(){return S.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return S.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return S.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(S.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return S.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return S.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=i.env.VSCODE_PORTABLE;return E?S.URI.file((0,T.join)(E,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,T.resolve)(E):(0,T.normalize)((0,T.join)(R.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const E=this.args["extensions-download-dir"];return E?(0,T.resolve)(E):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,T.resolve)(E);const y=i.env.VSCODE_EXTENSIONS;if(y)return y;const m=i.env.VSCODE_PORTABLE;return m?(0,T.join)(m,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(y=>/^[^:/?#]+?:\/\//.test(y)?S.URI.parse(y):S.URI.file((0,T.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?S.URI.parse(E):S.URI.file((0,T.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!i.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return S.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([L.memoize],C.prototype,"appRoot",null),de([L.memoize],C.prototype,"userHome",null),de([L.memoize],C.prototype,"userDataPath",null),de([L.memoize],C.prototype,"appSettingsHome",null),de([L.memoize],C.prototype,"tmpDir",null),de([L.memoize],C.prototype,"userRoamingDataHome",null),de([L.memoize],C.prototype,"settingsResource",null),de([L.memoize],C.prototype,"userDataSyncHome",null),de([L.memoize],C.prototype,"userDataSyncLogResource",null),de([L.memoize],C.prototype,"sync",null),de([L.memoize],C.prototype,"machineSettingsResource",null),de([L.memoize],C.prototype,"globalStorageHome",null),de([L.memoize],C.prototype,"workspaceStorageHome",null),de([L.memoize],C.prototype,"keybindingsResource",null),de([L.memoize],C.prototype,"keyboardLayoutResource",null),de([L.memoize],C.prototype,"argvResource",null),de([L.memoize],C.prototype,"snippetsHome",null),de([L.memoize],C.prototype,"isExtensionDevelopment",null),de([L.memoize],C.prototype,"untitledWorkspacesHome",null),de([L.memoize],C.prototype,"installSourcePath",null),de([L.memoize],C.prototype,"builtinExtensionsPath",null),de([L.memoize],C.prototype,"extensionsPath",null),de([L.memoize],C.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],C.prototype,"extensionDevelopmentKind",null),de([L.memoize],C.prototype,"extensionTestsLocationURI",null),de([L.memoize],C.prototype,"debugExtensionHost",null),de([L.memoize],C.prototype,"serviceMachineIdResource",null),de([L.memoize],C.prototype,"telemetryLogResource",null),de([L.memoize],C.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=C;function I(h,E){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,E,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function b(h,E){return v(h["inspect-search"],h["inspect-brk-search"],5876,E,h.extensionEnvironment)}e.parseSearchPort=b;function d(h,E){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,E,h.extensionEnvironment)}e.parsePtyHostPort=d;function v(h,E,y,m,w,g){const l=Number(E||h)||(m?null:y),r=l?Boolean(!!E):!1;let s;if(g)try{s=JSON.parse(g)}catch{}return{port:l,break:r,debugId:w,env:s}}}),define(te[151],ne([0,1,245,4,127]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const i={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(h,E,y=i){const m={},w=[],g=[];for(let s in E){const n=E[s];n.alias&&(m[s]=n.alias),n.type==="string"||n.type==="string[]"?(w.push(s),n.deprecates&&w.push(n.deprecates)):n.type==="boolean"&&(g.push(s),n.deprecates&&g.push(n.deprecates))}const a=D(h,{string:w,boolean:g,alias:m}),l={},r=a;l._=a._.map(s=>String(s)).filter(s=>s.length>0),delete r._;for(let s in E){const n=E[s];n.alias&&delete r[n.alias];let t=r[s];n.deprecates&&r.hasOwnProperty(n.deprecates)&&(t||(t=r[n.deprecates]),delete r[n.deprecates]),typeof t!="undefined"&&(n.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):n.type==="string"&&Array.isArray(t)&&(t=t.pop(),y.onMultipleValues(s,t)),l[s]=t),delete r[s]}for(let s in r)y.onUnknownOption(s);return l}e.parseArgs=P;function S(h,E){let y="";return E.args&&(Array.isArray(E.args)?y=` <${E.args.join("> <")}>`:y=` <${E.args}>`),E.alias?`-${E.alias} --${h}${y}`:`--${h}${y}`}function C(h,E){let y=0,m=[];for(const l in h){const r=h[l],s=S(l,r);y=Math.max(y,s.length),m.push([s,r.description])}let w=y+2+1;if(E-w<25)return m.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let g=E-w-1,a=[];for(const l of m){let r=l[0],s=b(l[1],g),n=I(w-r.length-2);a.push("  "+r+n+s[0]);for(let t=1;t<s.length;t++)a.push(I(w)+s[t])}return a}e.formatOptions=C;function I(h){return" ".repeat(h)}function b(h,E){let y=[];for(;h.length;){let m=h.length<E?h.length:h.lastIndexOf(" ",E),w=h.slice(0,m).trim();h=h.slice(m),y.push(w)}return y}function d(h,E,y,m,w){const g=process.stdout.isTTY&&process.stdout.columns||80,a=w?.noInputFiles!==!0?`[${(0,R.localize)(32,null)}...]`:"",l=[`${h} ${y}`];l.push(""),l.push(`${(0,R.localize)(33,null)}: ${E} [${(0,R.localize)(34,null)}]${a}`),l.push(""),w?.noPipe!==!0&&(L.isWindows?l.push((0,R.localize)(35,null,E)):l.push((0,R.localize)(36,null,E)),l.push(""));const r={};for(const s in m){const n=m[s];if(n.description&&n.cat){let t=r[n.cat];t||(r[n.cat]=t={}),t[s]=n}}for(let s in r){const n=s;let t=r[n];t&&(l.push(T[n]),l.push(...C(t,g)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=d;function v(h,E){return`${h||(0,R.localize)(37,null)}
${E||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=v}),function(){"use strict";function J(e,D,L,R){function T(P){const S=i(P),C=[S];return e.isAbsolute(S)||C.unshift(R),e.resolve(...C)}function i(P){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,L);const I=P["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(b,"AppData","Roaming")}break;case"darwin":C=e.join(D.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,L)}return{getUserDataPath:T}}if(typeof define=="function")define(te[152],ne([0,153,33,16,18,32]),function(e,D,L,R,T,i){const P=T.dirname(R.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(T.joinPath(P,"package.json").fsPath);return J(D,L,S.name,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),L=require("os");module.exports=J(D,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[154],ne([0,1,33,75,152]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends L.AbstractNativeEnvironmentService{constructor(P,S){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},S)}}e.NativeEnvironmentService=T}),define(te[155],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,i=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(y){const m=y.match(i);return m?m[1]:null}function I(y){if(y.indexOf("://")===-1){const m=y.match(L);return m?C(m[2]):null}try{const m=D.URI.parse(y);if(m.authority)return C(m.authority)}catch(m){}return null}function b(y,m){const w=new Set;let g;for(;g=P.exec(y);){const l=I(g[1]);l&&w.add(l)}const a=new Set(m);return Array.from(w).map(l=>a.has(l)?l:l.replace(S,"a"))}e.getDomainsOfRemotes=b;function d(y){const m=y.match(T);return m?m[2]:null}function v(y,m,w){return y&&m?(w&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${y}${m}`:`${y}/${m}`):null}function h(y,m){if(y.indexOf("://")===-1){const w=y.match(R);if(w)return v(w[2],w[3],m)}try{const w=D.URI.parse(y);if(w.authority)return v(d(w.authority),w.path,m)}catch(w){}return null}function E(y,m=!1){const w=[];let g;for(;g=P.exec(y);){const a=h(g[1],m);a&&w.push(a)}return w}e.getRemotes=E}),define(te[156],ne([0,1,28]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(T,i){const P=S=>{if(typeof S!="string")return;const C=L.exec(S);if(!C)return;const I=i[C[1]]??S;return typeof I=="string"?I:typeof I.message=="string"?I.message:S};return(0,D.cloneAndChange)(T,P)}e.localizeManifest=R}),define(te[157],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,i,P,S){return this.channel.call("promptImportantExtensionsInstallNotification",[T,i,P,S])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class L{constructor(T){this.service=T}listen(T,i){throw new Error(`Event not found: ${i}`)}call(T,i,P){switch(i){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${i}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[76],ne([0,1,136]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function T(d){return d=d.trim(),d==="*"||L.test(d)}e.isValidVersionStr=T;function i(d){if(!T(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=d.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=i;function P(d){if(!d)return null;let v=d.majorBase,h=d.majorMustEqual,E=d.minorBase,y=d.minorMustEqual,m=d.patchBase,w=d.patchMustEqual;d.hasCaret&&(v===0||(y=!1),w=!1);let g=0;if(d.preRelease){const a=R.exec(d.preRelease);if(a){const[,l,r,s]=a;g=Date.UTC(Number(l),Number(r)-1,Number(s))}}return{majorBase:v,majorMustEqual:h,minorBase:E,minorMustEqual:y,patchBase:m,patchMustEqual:w,isMinimum:d.hasGreaterEquals,notBefore:g}}e.normalizeVersion=P;function S(d,v,h){let E;typeof d=="string"?E=P(i(d)):E=d;let y;v instanceof Date?y=v.getTime():typeof v=="string"&&(y=new Date(v).getTime());let m;if(typeof h=="string"?m=P(i(h)):m=h,!E||!m)return!1;let w=E.majorBase,g=E.minorBase,a=E.patchBase,l=m.majorBase,r=m.minorBase,s=m.patchBase,n=m.notBefore,t=m.majorMustEqual,o=m.minorMustEqual,c=m.patchMustEqual;return m.isMinimum?w>l?!0:w<l?!1:g>r?!0:g<r||y&&y<n?!1:a>=s:(w===1&&l===0&&(!t||!o||!c)&&(l=1,r=0,s=0,t=!0,o=!1,c=!1),w<l?!1:w>l?!t:g<r?!1:g>r?!o:a<s?!1:a>s?!c:!(y&&y<n))}e.isValidVersion=S;function C(d,v,h,E){return h.isBuiltin||typeof h.main=="undefined"?!0:b(d,v,h.engines.vscode,E)}e.isValidExtensionVersion=C;function I(d,v,h){return d==="*"||b(v,h,d)}e.isEngineValid=I;function b(d,v,h,E=[]){let y=P(i(h));if(!y)return E.push(D.localize(0,null,h)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return E.push(D.localize(1,null,h)),!1}else if(!y.majorMustEqual)return E.push(D.localize(2,null,h)),!1;return S(d,v,y)?!0:(E.push(D.localize(3,null,d,h)),!1)}}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,T=[],i=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=D}),define(te[77],ne([0,1,53]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(i,P,S){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],S)),L.push([i,P])}e.registerSingleton=R;function T(){return L}e.getSingletonServiceDescriptors=T}),define(te[158],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class L{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let i of this._nodes.values())i.outgoing.size===0&&T.push(i);return T}insertEdge(T,i){const P=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(i);P.outgoing.set(this._hashFn(i),S),S.incoming.set(this._hashFn(T),P)}removeNode(T){const i=this._hashFn(T);this._nodes.delete(i);for(let P of this._nodes.values())P.outgoing.delete(i),P.incoming.delete(i)}lookupOrInsertNode(T){const i=this._hashFn(T);let P=this._nodes.get(i);return P||(P=new D(T),this._nodes.set(i,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[i,P]of this._nodes)T.push(`${i}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,i]of this._nodes){const P=new Set([T]),S=this._findCycle(i,P);if(S)return S}}_findCycle(T,i){for(let[P,S]of T.outgoing){if(i.has(P))return[...i,P].join(" -> ");i.add(P);const C=this._findCycle(S,i);if(C)return C;i.delete(P)}}}e.Graph=L}),define(te[6],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(i,P,S,C){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:i,index:S,optional:C}):(P[D.DI_DEPENDENCIES]=[{id:i,index:S,optional:C}],P[D.DI_TARGET]=P)}function R(i){if(D.serviceIds.has(i))return D.serviceIds.get(i);const P=function(S,C,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(P,S,I,!1)};return P.toString=()=>i,D.serviceIds.set(i,P),P}e.createDecorator=R;function T(i){return i}e.refineServiceDecorator=T}),define(te[159],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[160],ne([0,1,4,25,6]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=D.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",D.isMacintosh),i.set("isLinux",D.isLinux),i.set("isWindows",D.isWindows),i.set("isWeb",D.isWeb),i.set("isMacNative",D.isMacintosh&&!D.isWeb),i.set("isEdge",T.indexOf("Edg/")>=0),i.set("isFirefox",T.indexOf("Firefox")>=0),i.set("isChrome",T.indexOf("Chrome")>=0),i.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var S;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return d.INSTANCE}static true(){return v.INSTANCE}static has(A){return h.create(A)}static equals(A,q){return E.create(A,q)}static notEquals(A,q){return w.create(A,q)}static regex(A,q){return t.create(A,q)}static in(A,q){return y.create(A,q)}static not(A){return g.create(A)}static and(...A){return u.create(A,null)}static or(...A){return f.create(A,null,!0)}static greater(A,q){return l.create(A,q)}static greaterEquals(A,q){return r.create(A,q)}static smaller(A,q){return s.create(A,q)}static smallerEquals(A,q){return n.create(A,q)}static deserialize(A,q=!1){if(!!A)return this._deserializeOrExpression(A,q)}static _deserializeOrExpression(A,q){let _=A.split("||");return f.create(_.map(M=>this._deserializeAndExpression(M,q)),null,!0)}static _deserializeAndExpression(A,q){let _=A.split("&&");return u.create(_.map(M=>this._deserializeOne(M,q)),null)}static _deserializeOne(A,q){if(A=A.trim(),A.indexOf("!=")>=0){let _=A.split("!=");return w.create(_[0].trim(),this._deserializeValue(_[1],q))}if(A.indexOf("==")>=0){let _=A.split("==");return E.create(_[0].trim(),this._deserializeValue(_[1],q))}if(A.indexOf("=~")>=0){let _=A.split("=~");return t.create(_[0].trim(),this._deserializeRegexValue(_[1],q))}if(A.indexOf(" in ")>=0){let _=A.split(" in ");return y.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const _=A.split(">=");return r.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const _=A.split(">");return l.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const _=A.split("<=");return n.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const _=A.split("<");return s.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(A)?g.create(A.substr(1).trim()):h.create(A)}static _deserializeValue(A,q){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;let _=/^'([^']*)'$/.exec(A);return _?_[1].trim():A}static _deserializeRegexValue(A,q){if((0,L.isFalsyOrWhitespace)(A)){if(q)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=A.indexOf("/"),M=A.lastIndexOf("/");if(_===M||_<0){if(q)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}let B=A.slice(_+1,M),Z=A[M+1]==="i"?"i":"";try{return new RegExp(B,Z)}catch(H){if(q)throw new Error(`bad regexp-value '${A}', parse error: ${H}`);return console.warn(`bad regexp-value '${A}', parse error: ${H}`),null}}}e.ContextKeyExpr=C;function I($,A){const q=$?$.substituteConstants():void 0,_=A?A.substituteConstants():void 0;return!q&&!_?!0:!q||!_?!1:q.equals(_)}e.expressionsAreEqualWithConstantSubstitution=I;function b($,A){return $.cmp(A)}class d{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class v{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class h{constructor(A,q){this.key=A,this.negated=q,this.type=2}static create(A,q=null){const _=i.get(A);return typeof _=="boolean"?_?v.INSTANCE:d.INSTANCE:new h(A,q)}cmp(A){return A.type!==this.type?this.type-A.type:k(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=i.get(this.key);return typeof A=="boolean"?A?v.INSTANCE:d.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class E{constructor(A,q,_){this.key=A,this.value=q,this.negated=_,this.type=4}static create(A,q,_=null){if(typeof q=="boolean")return q?h.create(A,_):g.create(A,_);const M=i.get(A);return typeof M=="boolean"?q===(M?"true":"false")?v.INSTANCE:d.INSTANCE:new E(A,q,_)}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=i.get(this.key);if(typeof A=="boolean"){const q=A?"true":"false";return this.value===q?v.INSTANCE:d.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=E;class y{constructor(A,q){this.key=A,this.valueKey=q,this.type=10,this.negated=null}static create(A,q){return new y(A,q)}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const q=A.getValue(this.valueKey),_=A.getValue(this.key);return Array.isArray(q)?q.indexOf(_)>=0:typeof _=="string"&&typeof q=="object"&&q!==null?P.call(q,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=y;class m{constructor(A){this._actual=A,this.type=11}static create(A){return new m(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new m(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class w{constructor(A,q,_){this.key=A,this.value=q,this.negated=_,this.type=5}static create(A,q,_=null){if(typeof q=="boolean")return q?g.create(A,_):h.create(A,_);const M=i.get(A);return typeof M=="boolean"?q===(M?"true":"false")?d.INSTANCE:v.INSTANCE:new w(A,q,_)}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=i.get(this.key);if(typeof A=="boolean"){const q=A?"true":"false";return this.value===q?d.INSTANCE:v.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class g{constructor(A,q){this.key=A,this.negated=q,this.type=3}static create(A,q=null){const _=i.get(A);return typeof _=="boolean"?_?d.INSTANCE:v.INSTANCE:new g(A,q)}cmp(A){return A.type!==this.type?this.type-A.type:k(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=i.get(this.key);return typeof A=="boolean"?A?d.INSTANCE:v.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function a($,A){if(typeof $=="string"){const q=parseFloat($);isNaN(q)||($=q)}return typeof $=="string"||typeof $=="number"?A($):d.INSTANCE}class l{constructor(A,q,_){this.key=A,this.value=q,this.negated=_,this.type=12}static create(A,q,_=null){return a(q,M=>new l(A,M,_))}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(A,q,_){this.key=A,this.value=q,this.negated=_,this.type=13}static create(A,q,_=null){return a(q,M=>new r(A,M,_))}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class s{constructor(A,q,_){this.key=A,this.value=q,this.negated=_,this.type=14}static create(A,q,_=null){return a(q,M=>new s(A,M,_))}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class n{constructor(A,q,_){this.key=A,this.value=q,this.negated=_,this.type=15}static create(A,q,_=null){return a(q,M=>new n(A,M,_))}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(A,q){this.key=A,this.regexp=q,this.type=7,this.negated=null}static create(A,q){return new t(A,q)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const q=this.regexp?this.regexp.source:"",_=A.regexp?A.regexp.source:"";return q<_?-1:q>_?1:0}equals(A){if(A.type===this.type){const q=this.regexp?this.regexp.source:"",_=A.regexp?A.regexp.source:"";return this.key===A.key&&q===_}return!1}substituteConstants(){return this}evaluate(A){let q=A.getValue(this.key);return this.regexp?this.regexp.test(q):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class o{constructor(A){this._actual=A,this.type=8}static create(A){return new o(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new o(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function c($){let A=null;for(let q=0,_=$.length;q<_;q++){const M=$[q].substituteConstants();if($[q]!==M&&A===null){A=[];for(let B=0;B<q;B++)A[B]=$[B]}A!==null&&(A[q]=M)}return A===null?$:A}class u{constructor(A,q){this.expr=A,this.negated=q,this.type=6}static create(A,q){return u._normalizeArr(A,q)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let q=0,_=this.expr.length;q<_;q++){const M=b(this.expr[q],A.expr[q]);if(M!==0)return M}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let q=0,_=this.expr.length;q<_;q++)if(!this.expr[q].equals(A.expr[q]))return!1;return!0}return!1}substituteConstants(){const A=c(this.expr);return A===this.expr?this:u.create(A,this.negated)}evaluate(A){for(let q=0,_=this.expr.length;q<_;q++)if(!this.expr[q].evaluate(A))return!1;return!0}static _normalizeArr(A,q){const _=[];let M=!1;for(const B of A)if(!!B){if(B.type===1){M=!0;continue}if(B.type===0)return d.INSTANCE;if(B.type===6){_.push(...B.expr);continue}_.push(B)}if(_.length===0&&M)return v.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(b);for(let B=1;B<_.length;B++)_[B-1].equals(_[B])&&(_.splice(B,1),B--);if(_.length===1)return _[0];for(;_.length>1;){const B=_[_.length-1];if(B.type!==9)break;_.pop();const Z=_.pop(),H=_.length===0,j=f.create(B.expr.map(Q=>u.create([Q,Z],null)),null,H);j&&(_.push(j),_.sort(b))}return _.length===1?_[0]:new u(_,q)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(let q of this.expr)A.push(...q.keys());return A}map(A){return new u(this.expr.map(q=>q.map(A)),null)}negate(){if(!this.negated){const A=[];for(let q of this.expr)A.push(q.negate());this.negated=f.create(A,this,!0)}return this.negated}}class f{constructor(A,q){this.expr=A,this.negated=q,this.type=9}static create(A,q,_){return f._normalizeArr(A,q,_)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let q=0,_=this.expr.length;q<_;q++){const M=b(this.expr[q],A.expr[q]);if(M!==0)return M}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let q=0,_=this.expr.length;q<_;q++)if(!this.expr[q].equals(A.expr[q]))return!1;return!0}return!1}substituteConstants(){const A=c(this.expr);return A===this.expr?this:f.create(A,this.negated,!1)}evaluate(A){for(let q=0,_=this.expr.length;q<_;q++)if(this.expr[q].evaluate(A))return!0;return!1}static _normalizeArr(A,q,_){let M=[],B=!1;if(A){for(let Z=0,H=A.length;Z<H;Z++){const j=A[Z];if(!!j){if(j.type===0){B=!0;continue}if(j.type===1)return v.INSTANCE;if(j.type===9){M=M.concat(j.expr);continue}M.push(j)}}if(M.length===0&&B)return d.INSTANCE;M.sort(b)}if(M.length!==0){if(M.length===1)return M[0];for(let Z=1;Z<M.length;Z++)M[Z-1].equals(M[Z])&&(M.splice(Z,1),Z--);if(M.length===1)return M[0];if(_){for(let Z=0;Z<M.length;Z++)for(let H=Z+1;H<M.length;H++)F(M[Z],M[H])&&(M.splice(H,1),H--);if(M.length===1)return M[0]}return new f(M,q)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(let q of this.expr)A.push(...q.keys());return A}map(A){return new f(this.expr.map(q=>q.map(A)),null)}negate(){if(!this.negated){let A=[];for(let q of this.expr)A.push(q.negate());for(;A.length>1;){const q=A.shift(),_=A.shift(),M=[];for(const Z of W(q))for(const H of W(_))M.push(u.create([Z,H],null));const B=A.length===0;A.unshift(f.create(M,null,B))}this.negated=A[0]}return this.negated}}class p extends h{constructor(A,q,_){super(A,null);this._defaultValue=q,typeof _=="object"?p._info.push({..._,key:A}):_!==!0&&p._info.push({key:A,description:_,type:q!=null?typeof q:void 0})}static all(){return p._info.values()}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return E.create(this.key,A)}notEqualsTo(A){return w.create(this.key,A)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function k($,A){return $<A?-1:$>A?1:0}function O($,A,q,_){return $<q?-1:$>q?1:A<_?-1:A>_?1:0}function F($,A){if(A.type===6&&$.type!==9&&$.type!==6){for(const M of A.expr)if($.equals(M))return!0}const q=$.negate(),_=W(q).concat(W(A));_.sort(b);for(let M=0;M<_.length;M++){const Z=_[M].negate();for(let H=M+1;H<_.length;H++){const j=_[H];if(Z.equals(j))return!0}}return!1}e.implies=F;function W($){return $.type===9?$.expr:[$]}}),define(te[78],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(te[79],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[11],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,16,131,6]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var T;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));function i(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function P(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function S(g,a){switch(g){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function C(g,a){return a==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function I(g,a,l){return C(a,l)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===l?!0:b(l).includes(g)}e.isTargetPlatformCompatible=I;function b(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function d(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=d;var v;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var h;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var E;(function(g){g.Install="install",g.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var y;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var m;(function(g){g.Unsupported="Unsupported",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(a,l){super(a);this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var G=this&&this.__param||function(J,e){return function(D,L){e(D,L,J)}};define(te[161],ne([0,1,2,30]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(i){super();this.extensionManagementService=i,this._register(i),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=de([G(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(te[162],ne([0,1,3,2,28,7,110,30]),function(J,e,D,L,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(E,y){return T.URI.revive(y?y.transformIncoming(E):E)}function C(E,y){return y?y.transformOutgoingURI(E):E}function I(E,y){y=y||i.DefaultURITransformer;const m=E.manifest;return{...(0,i.transformAndReviveIncomingURIs)({...E,manifest:void 0},y),manifest:m}}function b(E,y){return y?(0,R.cloneAndChange)(E,m=>m instanceof T.URI?y.transformOutgoingURI(m):void 0):E}class d{constructor(y,m){this.service=y,this.getUriTransformer=m,this.onInstallExtension=D.Event.buffer(y.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(y.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(y.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(y.onDidUninstallExtension,!0)}listen(y,m){const w=this.getUriTransformer(y);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,g=>g.map(a=>({...a,local:a.local?b(a.local,w):a.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(y,m,w){const g=this.getUriTransformer(y);switch(m){case"zip":return this.service.zip(I(w[0],g)).then(a=>C(a,g));case"unzip":return this.service.unzip(S(w[0],g));case"install":return this.service.install(S(w[0],g),w[1]);case"getManifest":return this.service.getManifest(S(w[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(I(w[0],g),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(w[0],g));case"getInstalled":return this.service.getInstalled(w[0]).then(a=>a.map(l=>b(l,g)));case"updateMetadata":return this.service.updateMetadata(I(w[0],g),w[1]).then(a=>b(a,g));case"updateExtensionScope":return this.service.updateExtensionScope(I(w[0],g),w[1]).then(a=>b(a,g));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class v extends L.Disposable{constructor(y){super();this.channel=y,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?T.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(w=>({...w,local:w.local?I(w.local,null):w.local,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(y){const m=await this.getTargetPlatform();return y.allTargetPlatforms.some(w=>(0,P.isTargetPlatformCompatible)(w,y.allTargetPlatforms,m))}zip(y){return Promise.resolve(this.channel.call("zip",[y]).then(m=>T.URI.revive(m)))}unzip(y){return Promise.resolve(this.channel.call("unzip",[y]))}install(y,m){return Promise.resolve(this.channel.call("install",[y,m])).then(w=>I(w,null))}getManifest(y){return Promise.resolve(this.channel.call("getManifest",[y]))}installFromGallery(y,m){return Promise.resolve(this.channel.call("installFromGallery",[y,m])).then(w=>I(w,null))}uninstall(y,m){return Promise.resolve(this.channel.call("uninstall",[y,m]))}reinstallFromGallery(y){return Promise.resolve(this.channel.call("reinstallFromGallery",[y]))}getInstalled(y=null){return Promise.resolve(this.channel.call("getInstalled",[y])).then(m=>m.map(w=>I(w,null)))}updateMetadata(y,m){return Promise.resolve(this.channel.call("updateMetadata",[y,m])).then(w=>I(w,null))}updateExtensionScope(y,m){return Promise.resolve(this.channel.call("updateExtensionScope",[y,m])).then(w=>I(w,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=v;class h{constructor(y){this.service=y}listen(y,m){throw new Error("Invalid listen")}call(y,m,w){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(i){i[i.FILE=1]="FILE",i[i.WORKSPACE=2]="WORKSPACE",i[i.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(i){switch(i){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var T;(function(i){i.Ignored="ignored",i.Cancelled="cancelled",i.TooMany="toomany",i.IncompatibleWindow="incompatibleWindow",i.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[14],ne([0,1,41,10,25,15,7,138,6]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(_){return _.create===!0}e.isFileOpenForWriteOptions=C;var I;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var b;(function(_){_[_.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var d;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=v;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function E(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=E;function y(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=y;var m;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(M,B){super(M);this.code=B}}e.FileSystemProviderError=w;function g(_,M){const B=new w(_.toString(),M);return l(B,M),B}e.createFileSystemProviderError=g;function a(_){return _||g((0,P.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=a;function l(_,M){return _.name=M?`${M} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=l;function r(_){if(!_)return m.Unknown;if(_ instanceof w)return _.code;const M=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!M)return m.Unknown;switch(M[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=r;function s(_){if(_ instanceof f)return _.fileOperationResult;switch(r(_)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var n;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(M,B,Z){this.resource=M,this.operation=B,this.target=Z}isOperation(M){return this.operation===M}}e.FileOperationEvent=t;var o;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class c{constructor(M,B){this.added=void 0,this.updated=void 0,this.deleted=void 0;const Z=new Map;for(const H of M){const j=Z.get(H.type);j?j.push([H.resource,H]):Z.set(H.type,[[H.resource,H]])}for(const[H,j]of Z)switch(H){case 1:this.added=D.TernarySearchTree.forUris(()=>B),this.added.fill(j);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>B),this.updated.fill(j);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>B),this.deleted.fill(j);break}}contains(M,...B){return this.doContains(M,{includeChildren:!1},...B)}affects(M,...B){return this.doContains(M,{includeChildren:!0},...B)}doContains(M,B,...Z){if(!M)return!1;const H=Z.length>0;return!!((!H||Z.includes(1))&&(this.added?.get(M)||B.includeChildren&&this.added?.findSuperstr(M))||(!H||Z.includes(0))&&(this.updated?.get(M)||B.includeChildren&&this.updated?.findSuperstr(M))||(!H||Z.includes(2))&&(this.deleted?.findSubstr(M)||B.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function u(_,M,B){return!_||!M||_===M||M.length>_.length?!1:(M.charAt(M.length-1)!==L.sep&&(M+=L.sep),B?(0,R.startsWithIgnoreCase)(_,M):_.indexOf(M)===0)}e.isParent=u;class f extends Error{constructor(M,B,Z){super(M);this.fileOperationResult=B,this.options=Z}}e.FileOperationError=f;class p extends f{constructor(M,B,Z){super(M,2,Z);this.stat=B}}e.NotModifiedSinceFileOperationError=p;var k;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(k=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=F;async function W(_,M){if(!M.hasProvider(i.URI.from({scheme:_.scheme})))return new Promise(B=>{const Z=M.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===_.scheme&&H.added&&(Z.dispose(),B())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(M){return(0,T.isNumber)(M)||(M=0),M<$.KB?(0,P.localize)(1,null,M.toFixed(0)):M<$.MB?(0,P.localize)(2,null,(M/$.KB).toFixed(2)):M<$.GB?(0,P.localize)(3,null,(M/$.MB).toFixed(2)):M<$.TB?(0,P.localize)(4,null,(M/$.GB).toFixed(2)):(0,P.localize)(5,null,(M/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var A;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(A=e.Arch||(e.Arch={}));function q(_){return{maxFileSize:_===0?300*$.MB:16*$.GB,maxHeapSize:_===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=q}),define(te[163],ne([0,1,81,50,14]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}async checksum(P){const S=(await this.fileService.readFileStream(P)).value;return new Promise((C,I)=>{const b=(0,D.createHash)("md5");(0,L.listenStream)(S,{onData:d=>b.update(d.buffer),onError:d=>I(d),onEnd:()=>C(b.digest("base64").replace(/=+$/,""))})})}};T=de([G(0,R.IFileService)],T),e.ChecksumService=T}),define(te[164],ne([0,1,246,128,151,14]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function i(d,v){const h={onUnknownOption:y=>{console.warn((0,L.localize)(0,null,y))},onMultipleValues:(y,m)=>{console.warn((0,L.localize)(1,null,y,m))}},E=(0,R.parseArgs)(d,R.OPTIONS,v?h:void 0);return E.goto&&E._.forEach(y=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,L.localize)(2,null))),E["max-memory"]&&D(parseInt(E["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),E}function P(d){const v=d.findIndex(h=>!/^-/.test(h));if(v>-1)return[...d.slice(0,v),...d.slice(v+1)]}function S(d){let[,...v]=d;process.env.VSCODE_DEV&&(v=P(v)||[]);const h=!b(process.env);return i(v,h)}e.parseMainProcessArgv=S;function C(d){const[,,...v]=d;return i(v,!0)}e.parseCLIProcessArgv=C;function I(d,...v){const h=d.indexOf("--");return h===-1?d.push(...v):d.splice(h,0,...v),d}e.addArg=I;function b(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(te[165],ne([0,1,45,10,129,27,38,9,4,29,124,164,5]),function(J,e,D,L,R,T,i,P,S,C,I,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const v=1e4;let h;async function E(m,w,g){return w["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(g)&&!w["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(g)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=d.Promises.withAsyncBody(async(a,l)=>{const r=new T.CancellationTokenSource,s=setTimeout(()=>{r.dispose(!0),l(new Error((0,R.localize)(0,null)))},v);try{a(await y(m,r.token))}catch(n){!(0,P.isPromiseCanceledError)(n)&&!r.token.isCancellationRequested?l(new Error((0,R.localize)(1,null,(0,i.toErrorMessage)(n)))):a({})}finally{clearTimeout(s),r.dispose()}})),h)}e.resolveShellEnv=E;async function y(m,w){const g=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",g);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",a);const l=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",s);const n=await(0,I.getSystemShell)(S.OS,s);return m.trace("getUnixShellEnvironment#shell",n),new Promise((t,o)=>{if(w.isCancellationRequested)return o((0,P.canceled)());const c=(0,L.basename)(n);let u,f;const p=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(u=`& '${process.execPath}' ${p} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,f=["-Login","-Command"]):(u=`'${process.execPath}' ${p} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?f=["-ic"]:f=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),u);const k=(0,D.spawn)(n,[...f,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});w.onCancellationRequested(()=>(k.kill(),o((0,P.canceled)()))),k.on("error",W=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,i.toErrorMessage)(W)),o(W)});const O=[];k.stdout.on("data",W=>O.push(W));const F=[];k.stderr.on("data",W=>F.push(W)),k.on("close",(W,$)=>{const A=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",A);const q=Buffer.concat(F).toString("utf8");if(q.trim()&&m.trace("getUnixShellEnvironment#stderr",q),W||$)return o(new Error((0,R.localize)(2,null,W,$)));const _=r.exec(A),M=_?_[1]:"{}";try{const B=JSON.parse(M);g?B.ELECTRON_RUN_AS_NODE=g:delete B.ELECTRON_RUN_AS_NODE,a?B.ELECTRON_NO_ATTACH_CONSOLE=a:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",B),t(B)}catch(B){m.error("getUnixShellEnvironment#errorCaught",(0,i.toErrorMessage)(B)),o(B)}})})}}),define(te[82],ne([0,1,19,9,139,14]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function i(I,b,d,v,h,E){let y;try{await P(I,b,d,v,h,E)}catch(m){y=m}finally{y&&h.errorTransformer&&(y=h.errorTransformer(y)),typeof y!="undefined"&&d.error(y),d.end()}}e.readFileIntoStream=i;async function P(I,b,d,v,h,E){S(E);const y=await I.open(b,{create:!1});try{S(E);let m=0,w=0,g=h&&typeof h.length=="number"?h.length:void 0,a=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,r=0;do w=await I.read(y,l,a.buffer,r,a.byteLength-r),l+=w,r+=w,m+=w,typeof g=="number"&&(g-=w),r===a.byteLength&&(await d.write(v(a)),a=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),r=0);while(w>0&&(typeof g!="number"||g>0)&&S(E)&&C(m,h));if(r>0){let s=r;typeof g=="number"&&(s=Math.min(r,g)),d.write(v(a.slice(0,s)))}}catch(m){throw(0,T.ensureFileSystemProviderError)(m)}finally{await I.close(y)}}function S(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function C(I,b){if(b?.limits){if(typeof b.limits.memory=="number"&&I>b.limits.memory)throw(0,T.createFileSystemProviderError)((0,R.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&I>b.limits.size)throw(0,T.createFileSystemProviderError)((0,R.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[54],ne([0,1,2,4,7,14]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class i extends D.Disposable{constructor(d,v,h){super();this.onFileChanges=d,this.onLogMessage=v,this.verboseLogging=h,this.serviceDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new D.DisposableStore;this.serviceDisposables.value=d,this.service=this.createService(d),this.service.setVerboseLogging(this.verboseLogging),d.add(this.service.onDidChangeFile(v=>this.onFileChanges(v))),d.add(this.service.onDidLogMessage(v=>this.onLogMessage(v))),d.add(this.service.onDidError(v=>this.onError(v)))}onError(d){this.restartCounter<i.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.service?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${d}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=i,i.MAX_RESTARTS=5;class P extends D.Disposable{}e.WatcherService=P;function S(b){return b.map(d=>({type:d.type,resource:R.URI.file(d.path)}))}e.toFileChanges=S;function C(b){const d=new I;for(const v of b)d.processEvent(v);return d.coalesce()}e.coalesceEvents=C;class I{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return L.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const v=this.mapPathToChange.get(this.toKey(d));let h=!1;if(v){const E=v.type,y=d.type;v.path!==d.path&&d.type===2?h=!0:E===1&&y===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(v)):E===2&&y===1?v.type=0:E===1&&y===0||(v.type=y)}else h=!0;h&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],v=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(d.push(h),!1):!0).sort((h,E)=>h.path.length-E.path.length).filter(h=>v.some(E=>(0,T.isParent)(h.path,E,!L.isLinux))?!1:(v.push(h.path),!0)).concat(d)}}}),define(te[166],ne([0,1,5,2,10,114,20,117,54]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class C extends L.Disposable{constructor(b,d,v,h){super();this.path=b,this.onDidFilesChange=d,this.onLogMessage=v,this.verboseLogging=h,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:d}=await i.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(d)try{v=await(0,T.realpath)(v)}catch(h){if(this.onError(h),d.dangling)return}b.isDirectory()?this._register((0,P.watchFolder)(v,(h,E)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(E))})},h=>this.onError(h))):this._register((0,P.watchFile)(v,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,S.coalesceEvents)(d);if(this.verboseLogging)for(const h of v)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=C}),define(te[167],ne([0,1,16,34,52,54]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends T.WatcherService{constructor(S,C,I){super();this.onDidFilesChange=S,this.onLogMessage=C,this.verboseLogging=I,this.isDisposed=!1,this.startWatching()}startWatching(){const S=this._register(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(C=>!this.isDisposed&&this.onDidFilesChange(C))),this._register(this.service.onDidLogMessage(C=>this.onLogMessage(C)))}async setVerboseLogging(S){this.verboseLogging=S,this.isDisposed||await this.service?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}async watch(S){this.isDisposed||await this.service?.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(te[168],ne([0,1,16,34,52,54]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends T.AbstractWatcherService{constructor(S,C,I){super(S,C,I);this.init()}createService(S){const C=S.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(C.onDidProcessExit(({code:I,signal:b})=>this.onError(`terminated by itself with code ${I}, signal: ${b}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(C.getChannel("watcher")))}}e.FileWatcher=i}),define(te[83],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[T,i]of R)this.set(T,i)}set(R,T){const i=this._entries.get(R);return this._entries.set(R,T),i}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(te[169],ne([0,1,5,9,53,158,6,83]),function(J,e,D,L,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class C extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new P.ServiceCollection,E=!1,y){this._activeInstantiations=new Set,this._services=h,this._strict=E,this._parent=y,this._services.set(i.IInstantiationService,this)}createChild(h){return new I(h,this._strict,this)}invokeFunction(h,...E){let y=d.traceInvocation(h),m=!1;try{return h({get:g=>{if(m)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(g,y);if(!a)throw new Error(`[invokeFunction] unknown service '${g}'`);return a}},...E)}finally{m=!0,y.stop()}}createInstance(h,...E){let y,m;return h instanceof R.SyncDescriptor?(y=d.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(E),y)):(y=d.traceCreation(h),m=this._createInstance(h,E,y)),y.stop(),m}_createInstance(h,E=[],y){let m=i._util.getServiceDependencies(h).sort((a,l)=>a.index-l.index),w=[];for(const a of m){let l=this._getOrCreateServiceInstance(a.id,y);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${a.id}.`);w.push(l)}let g=m.length>0?m[0].index:E.length;if(E.length!==g){console.warn(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${E.length} static arguments`);let a=g-E.length;a>0?E=E.concat(new Array(a)):E=E.slice(0,g)}return new h(...[...E,...w])}_setServiceInstance(h,E){if(this._services.get(h)instanceof R.SyncDescriptor)this._services.set(h,E);else if(this._parent)this._parent._setServiceInstance(h,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let E=this._services.get(h);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):E}_getOrCreateServiceInstance(h,E){let y=this._getServiceInstanceOrDescriptor(h);return y instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,y,E.branch(h,!0)):(E.branch(h,!1),y)}_safeCreateAndCacheServiceInstance(h,E,y){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,E,y)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,E,y){const m=new T.Graph(a=>a.id.toString());let w=0;const g=[{id:h,desc:E,_trace:y}];for(;g.length;){const a=g.pop();if(m.lookupOrInsertNode(a),w++>1e3)throw new C(m);for(let l of i._util.getServiceDependencies(a.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),r instanceof R.SyncDescriptor){const s={id:l.id,desc:r,_trace:a._trace.branch(l.id,!0)};m.insertEdge(a,s),g.push(s)}}}for(;;){const a=m.roots();if(a.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof R.SyncDescriptor){const s=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,s)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,E,y=[],m,w){if(this._services.get(h)instanceof R.SyncDescriptor)return this._createServiceInstance(E,y,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,E,y,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(h,E=[],y,m){if(y){const w=new D.IdleValue(()=>this._createInstance(h,E,m));return new Proxy(Object.create(null),{get(g,a){if(a in g)return g[a];let l=w.value,r=l[a];return typeof r!="function"||(r=r.bind(l),g[a]=r),r},set(g,a,l){return w.value[a]=l,!0}})}else return this._createInstance(h,E,m)}}e.InstantiationService=I;var b;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(b||(b={}));class d{constructor(h,E){this.type=h,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return S?new d(0,h.name):d._None}branch(h,E){let y=new d(2,h.toString());return this._dep.push([h,E,y]),y}stop(){let h=Date.now()-this._start;d._totals+=h;let E=!1;function y(w,g){let a=[],l=new Array(w+1).join("	");for(const[r,s,n]of g._dep)if(s&&n){E=!0,a.push(`${l}CREATES -> ${r}`);let t=y(w+1,n);t&&a.push(t)}else a.push(`${l}uses -> ${r}`);return a.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||E)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(te[170],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,T){this.server=R,this.router=T}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,T){this.server.registerChannel(R,T)}}e.MessagePortMainProcessService=D}),define(te[171],ne([0,1,34,53,77,6]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class i{constructor(v,h,E){const y=E.getChannel(v);return P(h)?new h.channelClientCtor(y):D.ProxyChannel.toService(y,h?.proxyOptions)}}function P(d){return!!d?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let S=class extends i{constructor(v,h,E){super(v,h,E)}};S=de([G(2,e.IMainProcessService)],S);function C(d,v,h){(0,R.registerSingleton)(d,new L.SyncDescriptor(S,[v,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let I=class extends i{constructor(v,h,E){super(v,h,E)}};I=de([G(2,e.ISharedProcessService)],I);function b(d,v,h){(0,R.registerSingleton)(d,new L.SyncDescriptor(I,[v,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=b}),define(te[59],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const T of R.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[172],ne([0,1,2,59]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(i){super();this.localizationsService=i,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=de([G(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(te[8],ne([0,1,38,3,2,4,6]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function P(){return new Date().toISOString()}var S;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function C(s,n,t){switch(n){case S.Trace:s.trace(t);break;case S.Debug:s.debug(t);break;case S.Info:s.info(t);break;case S.Warning:s.warn(t);break;case S.Error:s.error(t);break;case S.Critical:s.critical(t);break;default:throw new Error("Invalid log level")}}e.log=C;function I(s){let n="";for(let t=0;t<s.length;t++){let o=s[t];if(typeof o=="object")try{o=JSON.stringify(o)}catch(c){}n+=(t>0?" ":"")+o}return n}e.format=I;class b extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class d extends b{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,I([n,...t]))}debug(n,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,I([n,...t]))}info(n,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,I([n,...t]))}warn(n,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,I([n,...t]))}error(n,...t){if(this.checkLogLevel(S.Error))if(n instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=n.stack,this.log(S.Error,I(o))}else this.log(S.Error,I([n,...t]))}critical(n,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,I([n,...t]))}flush(){}}e.AbstractMessageLogger=d;class v extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!T.isWindows}trace(n,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}debug(n,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}info(n,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}warn(n,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,n,...t):console.warn(`[main ${P()}]`,n,...t))}error(n,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,n,...t):console.error(`[main ${P()}]`,n,...t))}critical(n,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,n,...t):console.error(`[main ${P()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class E extends b{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,D.toErrorMessage)(n,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class y extends b{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const o of this.logServices)o.trace(n,...t)}debug(n,...t){for(const o of this.logServices)o.debug(n,...t)}info(n,...t){for(const o of this.logServices)o.info(n,...t)}warn(n,...t){for(const o of this.logServices)o.warn(n,...t)}error(n,...t){for(const o of this.logServices)o.error(n,...t)}critical(n,...t){for(const o of this.logServices)o.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=y;class m extends R.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=m;class w extends R.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(o))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let o=this.loggers.get(n.toString());return o||(o=this.doCreateLogger(n,t?.always?S.Trace:this.logLevel,t),this.loggers.set(n.toString(),o),t?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class g{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return S.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=g;function a(s){if(s.verbose)return S.Trace;if(typeof s.logLevel=="string"){const n=l(s.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(s){switch(s){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function r(s){switch(s){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=r}),define(te[173],ne([0,1,5,9,2,10,20,11,8]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends R.Disposable{constructor(b,d){super();this.environmentService=b,this.logService=d,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,T.basename)(this.environmentService.logsPath),d=(0,T.dirname)(this.environmentService.logsPath),E=(await i.Promises.readdir(d)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==b),y=E.slice(0,Math.max(0,E.length-9));y.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(m=>i.Promises.rm((0,T.join)(d,m)))))}catch(b){(0,L.onUnexpectedError)(b)}}};C=de([G(0,P.IEnvironmentService),G(1,S.ILogService)],C),e.LogsDataCleaner=C}),define(te[174],ne([0,1,5,9,2,10,20,11,8]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let C=class gt extends R.Disposable{constructor(b,d,v){super();this.backupWorkspacesPath=b,this.environmentService=d,this.logService=v,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const b=await i.Promises.readFile(this.backupWorkspacesPath,"utf8"),v=JSON.parse(b).emptyWorkspaceInfos.map(E=>E.backupFolder),h=await i.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async E=>{E.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||E===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||v.indexOf(E)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${E}.`),await i.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,E)))}))}catch(b){(0,L.onUnexpectedError)(b)}}};C.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,C.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",C=de([G(1,P.INativeEnvironmentService),G(2,S.ILogService)],C),e.StorageDataCleaner=C}),define(te[84],ne([0,1,5,19,31,40,11,14,6,8]),function(J,e,D,L,R,T,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var I;(function(d){d.ERROR_INVALID_FILE="ERROR_INVALID_FILE",d.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(I=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,S.createDecorator)(e.UserConfigurationFileServiceId);let b=class{constructor(v,h,E){this.environmentService=v,this.fileService=h,this.logService=E,this.queue=new D.Queue}async updateSettings(v,h){return this.queue.queue(()=>this.doWrite(v,h))}async doWrite(v,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),v);const{value:E,mtime:y,etag:m}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let w=E.toString();const g=[];if((0,R.parse)(w,g,{allowTrailingComma:!0,allowEmptyContent:!0}),g.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(v,w,h)[0];if(a){w=w.substring(0,a.offset)+a.content+w.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(w),{etag:m,mtime:y})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(v,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,v,h)})}getEdits({value:v,path:h},E,y){return h.length?(0,T.setProperty)(E,h,v,y):[{content:JSON.stringify(v,null,y.insertSpaces&&y.tabSize?" ".repeat(y.tabSize):"	"),length:E.length,offset:0}]}};b=de([G(0,i.IEnvironmentService),G(1,P.IFileService),G(2,C.ILogService)],b),e.UserConfigurationFileService=b}),define(te[175],ne([0,1,45,5,38,3,2,16,10,20,11,8]),function(J,e,D,L,R,T,i,P,S,C,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends i.Disposable{constructor(h,E){super();this.environmentService=h,this.logService=E,this.processesLimiter=new L.Limiter(5)}async postUninstall(h){const E=this.parseScript(h,"uninstall");return E&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${y}`)))),C.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(h,E){const y=`vscode:${E}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[y]=="string"){const m=h.manifest.scripts[y].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${y} should be a node script`),null):{script:(0,S.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,E,y,m,w){return new Promise((g,a)=>{const l=this.start(h,E,y,w);let r;const s=n=>{r&&(clearTimeout(r),r=null),n?a(n):g(void 0)};l.on("error",n=>{s((0,R.toErrorMessage)(n)||"Unknown")}),l.on("exit",(n,t)=>{s(n?`post-${E} process exited with code ${n}`:void 0)}),m&&(r=setTimeout(()=>{r=null,l.kill(),a("timed out")},5e3))})}start(h,E,y,m){const w={silent:!0,execArgv:void 0},g=(0,D.fork)(h,[`--type=extension-post-${E}`,...y],w);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const a=T.Event.fromNodeEventEmitter(g.stdout,"data"),l=T.Event.fromNodeEventEmitter(g.stderr,"data");a(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${E}`,n)),l(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${E}`,n));const r=T.Event.any(T.Event.map(a,n=>({data:`%c${n}`,format:[""]})),T.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return T.Event.debounce(r,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,S.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=de([G(0,I.IEnvironmentService),G(1,b.ILogService)],d),e.ExtensionsLifecycle=d}),define(te[176],ne([0,1,17,5,9,3,2,10,54,8]),function(J,e,D,L,R,T,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends i.Disposable{constructor(d){super();this.logService=d,this._onDidErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(d,v){return v.recursive?this.watchRecursive(d,v):this.watchNonRecursive(d)}watchRecursive(d,v){const h={path:this.toFilePath(d),excludes:v.excludes},E=(0,D.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,i.toDisposable)(()=>{E(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,R.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,S.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(d,v){return d.watch(v)}watchNonRecursive(d){const v=this.createNonRecursiveWatcher(this.toFilePath(d),E=>this._onDidChangeFile.fire((0,S.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===C.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{v.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)});return(0,i.combinedDisposable)(v,h)}onWatcherLogMessage(d){d.type==="error"&&this._onDidErrorOccur.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,P.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(te[177],ne([0,1,17,5,19,27,3,56,2,41,16,178,18,50,137,14,82,8]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class Ke extends S.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new i.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new i.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new i.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new i.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new i.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new i.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new E.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new E.FileChangesEvent(l,!0)))),this.watchedResources=C.TernarySearchTree.forUris(l=>{const r=this.getProvider(l.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const r=new S.DisposableStore;return r.add(l.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(l)))),r.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidErrorOccur=="function"&&r.add(l.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,S.dispose)(r)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(r){l.push(r)}}),!this.provider.has(a)&&await L.Promises.settled(l)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,l){const r=this.provider.get(a.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return P.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,d.isAbsolutePath)(a))throw new E.FileOperationError((0,h.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const r=new Error;throw r.name="ENOPRO",r.message=(0,h.localize)(1,null,a.toString()),r}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,E.hasOpenReadWriteCloseCapability)(l)||(0,E.hasReadWriteCapability)(l)||(0,E.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,E.hasOpenReadWriteCloseCapability)(l)||(0,E.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(r){throw(0,E.toFileSystemProviderErrorCode)(r)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,h.localize)(2,null,this.resourceForError(a)),1):(0,E.ensureFileSystemProviderError)(r)}}async doResolveFile(a,l){const r=await this.withProvider(a),s=this.isPathCaseSensitive(r),n=l?.resolveTo,t=l?.resolveSingleChildDescendants,o=l?.resolveMetadata,c=await r.stat(a);let u;return this.toFileStat(r,a,c,void 0,!!o,(f,p)=>(u||(u=C.TernarySearchTree.forUris(()=>!s),u.set(a,!0),n&&u.fill(!0,n)),u.get(f.resource)||u.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&t?p===1:!1))}async toFileStat(a,l,r,s,n,t){const{providerExtUri:o}=this.getExtUri(a),c={resource:l,name:o.basename(l),isFile:(r.type&E.FileType.File)!=0,isDirectory:(r.type&E.FileType.Directory)!=0,isSymbolicLink:(r.type&E.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&E.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,E.etag)({mtime:r.mtime,size:r.size})};if(c.isDirectory&&t(c,s)){try{const u=await a.readdir(l),f=await L.Promises.settled(u.map(async([p,k])=>{try{const O=o.joinPath(l,p),F=n?await a.stat(O):{type:k};return await this.toFileStat(a,O,F,u.length,n,t)}catch(O){return this.logService.trace(O),null}}));c.children=(0,D.coalesce)(f)}catch(u){this.logService.trace(u),c.children=[]}return c}return c}async resolveAll(a){return L.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch(r){return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(r){return r}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new E.FileOperationError((0,h.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=R.VSBuffer.fromString(""),r){await this.doValidateCreateFile(a,r);const s=await this.writeFile(a,l);return this._onDidRunOperation.fire(new E.FileOperationEvent(a,0,s)),s}async writeFile(a,l,r){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:n}=this.getExtUri(s);try{await this.validateWriteFile(s,a,r)||await this.mkdirp(s,n.dirname(a));let o;if((0,E.hasReadWriteCapability)(s)&&!(l instanceof R.VSBuffer))if((0,v.isReadableStream)(l)){const c=await(0,v.peekStream)(l,3);c.ended?o=R.VSBuffer.concat(c.buffer):o=c}else o=(0,v.peekReadable)(l,c=>R.VSBuffer.concat(c),3);else o=l;!(0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasReadWriteCapability)(s)&&o instanceof R.VSBuffer?await this.doWriteUnbuffered(s,a,r,o):await this.doWriteBuffered(s,a,r,o instanceof R.VSBuffer?(0,R.bufferToReadable)(o):o)}catch(t){throw new E.FileOperationError((0,h.localize)(4,null,this.resourceForError(a),(0,E.ensureFileSystemProviderError)(t).toString()),(0,E.toFileOperationResult)(t),r)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,r){if(!!r?.unlock&&!(a.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(l)));let n;try{n=await a.stat(l)}catch(t){return}if((n.type&E.FileType.Directory)!=0)throw new E.FileOperationError((0,h.localize)(6,null,this.resourceForError(l)),0,r);if(this.throwIfFileIsReadonly(l,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==E.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,E.etag)({mtime:r.mtime,size:n.size}))throw new E.FileOperationError((0,h.localize)(7,null),3,r);return n}async readFile(a,l){const r=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(r,a,l):this.doReadFile(r,a,l)}async doReadFileAtomic(a,l,r){return new Promise((s,n)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(a,l,r);s(t)}catch(t){n(t)}})})}async doReadFile(a,l,r){const s=await this.doReadFileStream(a,l,{...r,preferUnbuffered:!0});return{...s,value:await(0,R.streamToBuffer)(s.value)}}async readFileStream(a,l){const r=await this.withReadProvider(a);return this.doReadFileStream(r,a,l)}async doReadFileStream(a,l,r){const s=new T.CancellationTokenSource,n=this.validateReadFile(l,r).then(o=>o,o=>{throw s.cancel(),o});let t;try{return typeof r?.etag=="string"&&r.etag!==E.ETAG_DISABLED&&await n,!((0,E.hasOpenReadWriteCloseCapability)(a)||(0,E.hasFileReadStreamCapability)(a))||(0,E.hasReadWriteCapability)(a)&&r?.preferUnbuffered?t=this.readFileUnbuffered(a,l,r):(0,E.hasFileReadStreamCapability)(a)?t=this.readFileStreamed(a,l,s.token,r):t=this.readFileBuffered(a,l,s.token,r),{...await n,value:t}}catch(o){t&&await(0,v.consumeStream)(t);const c=(0,h.localize)(8,null,this.resourceForError(l),(0,E.ensureFileSystemProviderError)(o).toString());throw o instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(c,o.stat,r):new E.FileOperationError(c,(0,E.toFileOperationResult)(o),r)}}readFileStreamed(a,l,r,s=Object.create(null)){const n=a.readFileStream(l,s,r);return(0,v.transform)(n,{data:t=>t instanceof R.VSBuffer?t:R.VSBuffer.wrap(t),error:t=>new E.FileOperationError((0,h.localize)(9,null,this.resourceForError(l),(0,E.ensureFileSystemProviderError)(t).toString()),(0,E.toFileOperationResult)(t),s)},t=>R.VSBuffer.concat(t))}readFileBuffered(a,l,r,s=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,y.readFileIntoStream)(a,l,n,t=>t,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new E.FileOperationError((0,h.localize)(10,null,this.resourceForError(l),(0,E.ensureFileSystemProviderError)(t).toString()),(0,E.toFileOperationResult)(t),s)},r),n}readFileUnbuffered(a,l,r){const s=(0,v.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n=await a.readFile(l);typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(l,n.byteLength,r),s.end(R.VSBuffer.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async validateReadFile(a,l){const r=await this.resolve(a,{resolveMetadata:!0});if(r.isDirectory)throw new E.FileOperationError((0,h.localize)(11,null,this.resourceForError(a)),0,l);if(typeof l?.etag=="string"&&l.etag!==E.ETAG_DISABLED&&l.etag===r.etag)throw new E.NotModifiedSinceFileOperationError((0,h.localize)(12,null),r,l);return this.validateReadFileLimits(a,r.size,l),r}validateReadFileLimits(a,l,r){if(r?.limits){let s;if(typeof r.limits.memory=="number"&&l>r.limits.memory&&(s=9),typeof r.limits.size=="number"&&l>r.limits.size&&(s=7),typeof s=="number")throw new E.FileOperationError((0,h.localize)(13,null,this.resourceForError(a)),s)}}async canMove(a,l,r){return this.doCanMoveCopy(a,l,"move",r)}async canCopy(a,l,r){return this.doCanMoveCopy(a,l,"copy",r)}async doCanMoveCopy(a,l,r,s){if(a.toString()!==l.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(n,a,t,l,r,s)}catch(n){return n}return!0}async move(a,l,r){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(s,a,n,l,"move",!!r),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(a,t==="move"?2:3,o)),o}async copy(a,l,r){const s=await this.withReadProvider(a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(s,a,n,l,"copy",!!r),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(a,t==="copy"?3:2,o)),o}async doMoveCopy(a,l,r,s,n,t){if(l.toString()===s.toString())return n;const{exists:o,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(a,l,r,s,n,t);if(o&&!c&&t&&await this.del(s,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(s)),n==="copy"){if(a===r&&(0,E.hasFileFolderCopyCapability)(a))await a.copy(l,s,{overwrite:t});else{const u=await this.resolve(l);u.isDirectory?await this.doCopyFolder(a,u,r,s):await this.doCopyFile(a,l,r,s)}return n}else return a===r?(await a.rename(l,s,{overwrite:t}),n):(await this.doMoveCopy(a,l,r,s,"copy",t),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,r,s){if((0,E.hasOpenReadWriteCloseCapability)(a)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(a,l,r,s);if((0,E.hasOpenReadWriteCloseCapability)(a)&&(0,E.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(a,l,r,s);if((0,E.hasReadWriteCapability)(a)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(a,l,r,s);if((0,E.hasReadWriteCapability)(a)&&(0,E.hasReadWriteCapability)(r))return this.doPipeUnbuffered(a,l,r,s)}async doCopyFolder(a,l,r,s){await r.mkdir(s),Array.isArray(l.children)&&await L.Promises.settled(l.children.map(async n=>{const t=this.getExtUri(r).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.doCopyFolder(a,await this.resolve(n.resource),r,t):this.doCopyFile(a,n.resource,r,t)}))}async doValidateMoveCopy(a,l,r,s,n,t){let o=!1;if(a===r){const{providerExtUri:u,isPathCaseSensitive:f}=this.getExtUri(a);if(f||(o=u.isEqual(l,s)),o&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(l),this.resourceForError(s)));if(!o&&u.isEqualOrParent(s,l))throw new Error((0,h.localize)(15,null,this.resourceForError(l),this.resourceForError(s)))}const c=await this.exists(s);if(c&&!o){if(!t)throw new E.FileOperationError((0,h.localize)(16,null,this.resourceForError(l),this.resourceForError(s)),4);if(a===r){const{providerExtUri:u}=this.getExtUri(a);if(u.isEqualOrParent(l,s))throw new Error((0,h.localize)(17,null,this.resourceForError(l),this.resourceForError(s)))}}return{exists:c,isSameResourceWithDifferentPathCase:o}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(a,0,r)),r}async mkdirp(a,l){const r=[],{providerExtUri:s}=this.getExtUri(a);for(;!s.isEqual(l,s.dirname(l));)try{if(((await a.stat(l)).type&E.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(l)));break}catch(n){if((0,E.toFileSystemProviderErrorCode)(n)!==E.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(s.basename(l)),l=s.dirname(l)}for(let n=r.length-1;n>=0;n--){l=s.joinPath(l,r[n]);try{await a.mkdir(l)}catch(t){if((0,E.toFileSystemProviderErrorCode)(t)!==E.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(r){return r}return!0}async doValidateDelete(a,l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(r.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(a)));let n;try{n=await r.stat(a)}catch(o){}if(n)this.throwIfFileIsReadonly(a,n);else throw new E.FileOperationError((0,h.localize)(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const o=await this.resolve(a);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(a)))}return r}async del(a,l){const r=await this.doValidateDelete(a,l),s=!!l?.useTrash,n=!!l?.recursive;await r.delete(a,{recursive:n,useTrash:s}),this._onDidRunOperation.fire(new E.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let r,s;{for(const n of a)this.watchedResources.has(n.resource)?(r||(r=[]),r.push(n)):(s||(s=[]),s.push(n));r&&this._onDidFilesChange.fire(new E.FileChangesEvent(r,!l))}if(s){const n=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(s)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const r=new S.DisposableStore;let s=!1,n=()=>{s=!0};return r.add((0,S.toDisposable)(()=>n())),this.doWatch(a,l).then(t=>{s?(0,S.dispose)(t):n=()=>(0,S.dispose)(t)},t=>this.logService.error(t)),l.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),r.add((0,S.toDisposable)(()=>{const t=this.watchedResources.get(a);typeof t=="number"&&(t<=1?this.watchedResources.delete(a):this.watchedResources.set(a,t-1))}))),r}async doWatch(a,l){const r=await this.withProvider(a),s=this.toWatchKey(r,a,l);let n=this.activeWatchers.get(s);return n||(n={count:0,disposable:r.watch(a,l)},this.activeWatchers.set(s,n)),n.count+=1,(0,S.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,S.dispose)(n.disposable),this.activeWatchers.delete(s)))})}toWatchKey(a,l,r){const{providerExtUri:s}=this.getExtUri(a);return[s.getComparisonKey(l),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,S.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,l,r,s){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const n=await a.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,v.isReadableStream)(s)||(0,v.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(a,n,s):await this.doWriteReadableBufferedQueued(a,n,s)}catch(t){throw(0,E.ensureFileSystemProviderError)(t)}finally{await a.close(n)}})}async doWriteStreamBufferedQueued(a,l,r){let s=0,n;if((0,v.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=R.VSBuffer.concat(r.buffer);await this.doWriteBuffer(a,l,t,t.byteLength,s,0),s+=t.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((t,o)=>{(0,v.listenStream)(n,{onData:async c=>{n.pause();try{await this.doWriteBuffer(a,l,c,c.byteLength,s,0)}catch(u){return o(u)}s+=c.byteLength,setTimeout(()=>n.resume())},onError:c=>o(c),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(a,l,r){let s=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(a,l,n,n.byteLength,s,0),s+=n.byteLength}async doWriteBuffer(a,l,r,s,n,t){let o=0;for(;o<s;)o+=await a.write(l,n+o,r.buffer,t+o,s-o)}async doWriteUnbuffered(a,l,r,s){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,r,s))}async doWriteUnbufferedQueued(a,l,r,s){let n;s instanceof R.VSBuffer?n=s:(0,v.isReadableStream)(s)?n=await(0,R.streamToBuffer)(s):(0,v.isReadableBufferedStream)(s)?n=await(0,R.bufferedStreamToBuffer)(s):n=(0,R.readableToBuffer)(s),await a.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(a,l,r,s){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,r,s))}async doPipeBufferedQueued(a,l,r,s){let n,t;try{n=await a.open(l,{create:!1}),t=await r.open(s,{create:!0,unlock:!1});const o=R.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,u=0,f=0;do f=await a.read(n,c,o.buffer,u,o.byteLength-u),await this.doWriteBuffer(r,t,o,f,c,u),c+=f,u+=f,u===o.byteLength&&(u=0);while(f>0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await L.Promises.settled([typeof n=="number"?a.close(n):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(a,l,r,s){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,r,s))}async doPipeUnbufferedQueued(a,l,r,s){return r.writeFile(s,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,r,s){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,r,s))}async doPipeUnbufferedToBufferedQueued(a,l,r,s){const n=await r.open(s,{create:!0,unlock:!1});try{const t=await a.readFile(l);await this.doWriteBuffer(r,n,R.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,E.ensureFileSystemProviderError)(t)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(a,l,r,s){const n=await(0,R.streamToBuffer)(this.readFileBuffered(a,l,T.CancellationToken.None));await this.doWriteUnbuffered(r,s,void 0,n)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new E.FileOperationError((0,h.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,h.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===I.Schemas.file?a.fsPath:a.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=de([G(0,m.ILogService)],w),e.FileService=w}),define(te[179],ne([0,1,51,247,5,19,3,42,10,4,18,50,20,140,14,82,166,167,168,176,38]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(r)}`)}})();class l extends g.AbstractDiskFileSystemProvider{constructor(s,n){super(s);this.options=n,this.onDidChangeCapabilities=i.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:n,symbolicLink:t}=await d.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(n,t),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(s){try{const n=await d.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),t=[];return await Promise.all(n.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,I.joinPath)(s,o.name))).type:c=this.toType(o),t.push([o.name,c])}catch(c){this.logService.trace(c)}})),t}catch(n){throw this.toFileSystemProviderError(n)}}toType(s,n){let t;return n?.dangling?t=h.FileType.Unknown:s.isFile()?t=h.FileType.File:s.isDirectory()?t=h.FileType.Directory:t=h.FileType.Unknown,n&&(t|=h.FileType.SymbolicLink),t}async readFile(s){try{const n=this.toFilePath(s);return await d.Promises.readFile(n)}catch(n){throw this.toFileSystemProviderError(n)}}readFileStream(s,n,t){const o=(0,b.newWriteableStream)(c=>T.VSBuffer.concat(c.map(u=>T.VSBuffer.wrap(u))).buffer);return(0,E.readFileIntoStream)(this,s,o,c=>c.buffer,{...n,bufferSize:256*1024},t),o}async writeFile(s,n,t){let o;try{const c=this.toFilePath(s);if(!t.create||!t.overwrite){if(await d.Promises.exists(c)){if(!t.overwrite)throw(0,h.createFileSystemProviderError)((0,v.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,h.createFileSystemProviderError)((0,v.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(s,{create:!0,unlock:t.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(s,c)}finally{typeof o=="number"&&await this.close(o)}}async open(s,n){try{const t=this.toFilePath(s);if((0,h.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:u}=await d.SymlinkSupport.stat(t);u.mode&128||await d.Promises.chmod(t,u.mode|128)}catch(u){this.logService.trace(u)}let o;if((0,h.isFileOpenForWriteOptions)(n)){if(C.isWindows)try{await d.Promises.truncate(t,0),o="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}o||(o="w")}else o="r";const c=await d.Promises.open(t,o);return this.mapHandleToPos.set(c,0),(0,h.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(c,s),c}catch(t){throw(0,h.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(s,t):this.toFileSystemProviderError(t)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await d.Promises.fdatasync(s)}catch(n){this.canFlush=!1,this.logService.error(n)}return await d.Promises.close(s)}catch(n){throw this.toFileSystemProviderError(n)}}async read(s,n,t,o,c){const u=this.normalizePos(s,n);let f=null;try{const p=await d.Promises.read(s,t,o,c,u);return typeof p=="number"?f=p:f=p.bytesRead,f}catch(p){throw this.toFileSystemProviderError(p)}finally{this.updatePos(s,u,f)}}normalizePos(s,n){return n===this.mapHandleToPos.get(s)?null:n}updatePos(s,n,t){const o=this.mapHandleToPos.get(s);typeof o=="number"&&(typeof n=="number"||(typeof t=="number"?this.mapHandleToPos.set(s,o+t):this.mapHandleToPos.delete(s)))}async write(s,n,t,o,c){return(0,R.retry)(()=>this.doWrite(s,n,t,o,c),100,3)}async doWrite(s,n,t,o,c){const u=this.normalizePos(s,n);let f=null;try{const p=await d.Promises.write(s,t,o,c,u);return typeof p=="number"?f=p:f=p.bytesWritten,f}catch(p){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),p)}finally{this.updatePos(s,u,f)}}async mkdir(s){try{await d.Promises.mkdir(this.toFilePath(s))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(s,n){try{const t=this.toFilePath(s);await this.doDelete(t,n)}catch(t){throw this.toFileSystemProviderError(t)}}async doDelete(s,n){n.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}async rename(s,n,t){const o=this.toFilePath(s),c=this.toFilePath(n);if(o!==c)try{await this.validateTargetDeleted(s,n,"move",t.overwrite),await d.Promises.move(o,c)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,v.localize)(2,null,(0,S.basename)(o),(0,S.basename)((0,S.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(s,n,t){const o=this.toFilePath(s),c=this.toFilePath(n);if(o!==c)try{await this.validateTargetDeleted(s,n,"copy",t.overwrite),await d.Promises.copy(o,c,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,v.localize)(3,null,(0,S.basename)(o),(0,S.basename)((0,S.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(s,n,t,o){const c=this.toFilePath(s),u=this.toFilePath(n);let f=!1;if(!!(this.capabilities&1024)||(f=(0,P.isEqual)(c,u,!0)),f&&t==="copy")throw(0,h.createFileSystemProviderError)((0,v.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!f&&await d.Promises.exists(u)){if(!o)throw(0,h.createFileSystemProviderError)((0,v.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(s,n,t){let o,c=!1;return this.options?.watcher?.usePolling?c=!1:c=this.options?.legacyWatcher==="on",c?o=m.FileWatcher:o=w.FileWatcher,new o(u=>s(u),u=>n(u),t,this.options?.watcher)}doWatch(s,n){const t=this.options?.watcher?.usePolling;if(t===!0)for(const o of n)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(t))for(const o of n)t.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(s,n)}createNonRecursiveWatcher(s,n,t,o){return new y.FileWatcher(s,c=>n(c),c=>t(c),o)}toFileSystemProviderError(s){if(s instanceof h.FileSystemProviderError)return s;let n;switch(s.code){case"ENOENT":n=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=h.FileSystemProviderErrorCode.NoPermissions;break;default:n=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(s,n)}async toFileSystemProviderWriteError(s,n){let t=this.toFileSystemProviderError(n);if(s&&t.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await d.SymlinkSupport.stat(this.toFilePath(s));o.mode&128||(t=(0,h.createFileSystemProviderError)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return t}}e.DiskFileSystemProvider=l}),define(te[85],ne([0,1,3,7,8]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(d){this.service=d,this.onDidChangeLogLevel=D.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(d,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=T;class i{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){i.setLevel(this.channel,d)}static setLevel(d,v){return d.call("setLevel",v)}}e.LogLevelChannelClient=i;class P{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,v){throw new Error(`Event not found: ${v}`)}async call(d,v,h){switch(v){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(d,v){this.loggers.set(d.toString(),this.loggerService.createLogger(d,v))}consoleLog(d,v){let h=console.log;switch(d){case R.LogLevel.Error:h=console.error;break;case R.LogLevel.Warning:h=console.warn;break;case R.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(d,v){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[E,y]of v)(0,R.log)(h,E,y)}}e.LoggerChannel=P;class S extends R.AbstractLoggerService{constructor(d,v,h){super(d,v);this.channel=h}createConsoleMainLogger(){return new R.AdapterLogger({log:(d,v)=>{this.channel.call("consoleLog",[d,v])}})}doCreateLogger(d,v,h){return new C(this.channel,d,v,h)}}e.LoggerChannelClient=S;class C extends R.AbstractMessageLogger{constructor(d,v,h,E){super(E?.always);this.channel=d,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,v){const h=[[d,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class I extends R.LogService{constructor(d,v){super(v);this.parent=d,this._register(d.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=I}),define(te[60],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[86],ne([0,1,16,4,32,18]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)i=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const P=(0,T.dirname)(D.FileAccess.asFileUri("",J));i=J.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const S=J.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:S.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i}),define(te[26],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(te[180],ne([0,1,5,9,2,10,20,8,26]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends R.Disposable{constructor(b,d,v){super();this.productService=d,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},30*1e3)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),v=(0,T.dirname)(b),h=(0,T.basename)(b),E=await i.Promises.readdir(v);await Promise.all(E.map(async y=>{if(y===h)return;const m=(0,T.join)(v,y),w=await i.Promises.stat(m);if(w.isDirectory()&&d-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),i.Promises.rm(m)}))}catch(d){(0,L.onUnexpectedError)(d)}}};C=de([G(1,S.IProductService),G(2,P.ILogService)],C),e.CodeCacheCleaner=C}),define(te[181],ne([0,1,5,9,2,10,20,11,8,26]),function(J,e,D,L,R,T,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends R.Disposable{constructor(d,v,h){super();this.environmentService=d,this.logService=v,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),v=JSON.parse(await i.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(v)){const g=v[w];d[`${g.hash}.${w}`]=!0}const h=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await i.Promises.exists(h))return;const y=await i.Promises.readdir(h);for(const w of y){if(d[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await i.Promises.rm((0,T.join)(h,w))}const m=Date.now();for(const w of Object.keys(d)){const g=(0,T.join)(h,w),a=await i.Promises.readdir(g);for(const l of a){if(l==="tcf.json")continue;const r=(0,T.join)(g,l),s=await i.Promises.stat(r);s.isDirectory()&&m-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(w,l)}`),await i.Promises.rm(r))}}}catch(d){(0,L.onUnexpectedError)(d)}}};I=de([G(0,P.INativeEnvironmentService),G(1,S.ILogService),G(2,C.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(te[35],ne([0,1,100,15]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(i,P){D.ok(L.isString(i)),D.ok(L.isObject(P)),D.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,P)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new R}),define(te[87],ne([0,1,3,35]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,C){this.schemasById[R(S)]=C,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new T;L.Registry.add(e.Extensions.JSONContribution,i)}),define(te[39],ne([0,1,17,3,15,126,87,35]),function(J,e,D,L,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=P.Registry.as(i.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const s=this.doRegisterConfigurations(l,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}updateConfigurations({add:l,remove:r}){const s=[];s.push(...this.doDeregisterConfigurations(r)),s.push(...this.doRegisterConfigurations(l,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,D.distinct)(s))}registerDefaultConfigurations(l){const r=[],s=[];for(const n of l)for(const t in n)if(r.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...n[t]};const o={type:"object",default:this.defaultValues[t],description:T.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};s.push(...h(t)),this.configurationProperties[t]=o,this.defaultLanguageConfigurationOverridesNode.properties[t]=o}else{this.defaultValues[t]=n[t];const o=this.configurationProperties[t];o&&(this.updatePropertyDefaultValue(t,o),this.updateSchema(t,o))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterDefaultConfigurations(l){const r=[];for(const s of l)for(const n in s)if(r.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const t=this.configurationProperties[n];t&&(this.updatePropertyDefaultValue(n,t),this.updateSchema(n,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const s=[];return l.forEach(n=>{s.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),s}doDeregisterConfigurations(l){const r=[],s=n=>{if(n.properties)for(const t in n.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>s(t))};for(const n of l){s(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,s,n=3){n=R.isUndefinedOrNull(l.scope)?n:l.scope;let t=[],o=l.properties;if(o)for(let u in o){if(r&&w(u)){delete o[u];continue}const f=o[u];if(this.updatePropertyDefaultValue(u,f),e.OVERRIDE_PROPERTY_REGEX.test(u)?f.scope=void 0:(f.scope=R.isUndefinedOrNull(f.scope)?n:f.scope,f.restricted=R.isUndefinedOrNull(f.restricted)?!!s?.restrictedConfigurations?.includes(u):f.restricted),o[u].hasOwnProperty("included")&&!o[u].included){this.excludedConfigurationProperties[u]=o[u],delete o[u];continue}else this.configurationProperties[u]=o[u];!o[u].deprecationMessage&&o[u].markdownDeprecationMessage&&(o[u].deprecationMessage=o[u].markdownDeprecationMessage),t.push(u)}let c=l.allOf;if(c)for(let u of c)t.push(...this.validateAndRegisterProperties(u,r,s,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(l){const r=s=>{let n=s.properties;if(n)for(const o in n)this.updateSchema(o,n[o]);let t=s.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,s={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,s),e.allSettings.properties[r]=s,e.applicationSettings.properties[r]=s,e.machineSettings.properties[r]=s,e.machineOverridableSettings.properties[r]=s,e.windowSettings.properties[r]=s,e.resourceSettings.properties[r]=s}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){let s=this.defaultValues[l];R.isUndefined(s)&&(s=r.default),R.isUndefined(s)&&(s=y(r.type)),r.default=s}}const d="\\[([^\\]]+)\\]",v=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(a){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let r=v.exec(a);for(;r?.length;){const s=r[1].trim();s&&l.push(s),r=v.exec(a)}}return(0,D.distinct)(l)}e.overrideIdentifiersFromKey=h;function E(a){return a.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=E;function y(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const m=new b;P.Registry.add(e.Extensions.Configuration,m);function w(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?T.localize(7,null,a):m.getConfigurationProperties()[a]!==void 0?T.localize(8,null,a):null:T.localize(6,null)}e.validateProperty=w;function g(){const a=[],l=m.getConfigurationProperties();for(const r of Object.keys(l))a.push([r,l[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=g}),define(te[21],ne([0,1,15,7,39,6,35]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function P(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof L.URI)}e.isConfigurationOverrides=P;function S(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||D.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=S;var C;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=I;function b(a,l){const r=Object.create(null);for(let s in a)d(r,s,a[s],l);return r}e.toValuesTree=b;function d(a,l,r,s){const n=l.split("."),t=n.pop();let o=a;for(let c=0;c<n.length;c++){let u=n[c],f=o[u];switch(typeof f){case"undefined":f=o[u]=Object.create(null);break;case"object":break;default:s(`Ignoring ${l} as ${n.slice(0,c+1).join(".")} is ${JSON.stringify(f)}`);return}o=f}if(typeof o=="object"&&o!==null)try{o[t]=r}catch(c){s(`Ignoring ${l} as ${n.join(".")} is ${JSON.stringify(o)}`)}else s(`Ignoring ${l} as ${n.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=d;function v(a,l){const r=l.split(".");h(a,r)}e.removeFromValueTree=v;function h(a,l){const r=l.shift();if(l.length===0){delete a[r];return}if(Object.keys(a).indexOf(r)!==-1){const s=a[r];typeof s=="object"&&!Array.isArray(s)&&(h(s,l),Object.keys(s).length===0&&delete a[r])}}function E(a,l,r){function s(o,c){let u=o;for(const f of c){if(typeof u!="object"||u===null)return;u=u[f]}return u}const n=l.split("."),t=s(a,n);return typeof t=="undefined"?r:t}e.getConfigurationValue=E;function y(a,l,r){Object.keys(l).forEach(s=>{s!=="__proto__"&&(s in a?D.isObject(a[s])&&D.isObject(l[s])?y(a[s],l[s],r):r&&(a[s]=l[s]):a[s]=l[s])})}e.merge=y;function m(){const a=i.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=m;function w(){const a=Object.create(null),l=i.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let r in l){let s=l[r].default;d(a,r,s,n=>console.error(`Conflict in default settings: ${n}`))}return a}e.getDefaultValues=w;function g(a,l,r){const s=a.inspect(l),n=a.inspect(r);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:s.defaultValue}e.getMigratedSettingValue=g}),define(te[88],ne([0,1,17,3,31,2,41,28,15,7,21,39,35]),function(J,e,D,L,R,T,i,P,S,C,I,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(n={},t=[],o=[]){this._contents=n,this._keys=t,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const o=this.getContentsForOverrideIdentifer(t);return o?n?(0,I.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const o of this.overrides)o.identifiers.includes(n)&&t.push(...o.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return D.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=P.deepClone(this.contents),o=P.deepClone(this.overrides),c=[...this.keys];for(const u of n){this.mergeContents(t,u.contents);for(const f of u.overrides){const[p]=o.filter(k=>D.equals(k.identifiers,f.identifiers));p?(this.mergeContents(p.contents,f.contents),p.keys.push(...f.keys),p.keys=D.distinct(p.keys)):o.push(P.deepClone(f))}for(const f of u.keys)c.indexOf(f)===-1&&c.push(f)}return new v(t,c,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let o={};for(const c of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[c],f=t[c];f&&(typeof u=="object"&&typeof f=="object"?(u=P.deepClone(u),this.mergeContents(u,f)):u=f),o[c]=u}return new v(o,this.keys,this.overrides)}mergeContents(n,t){for(const o of Object.keys(t)){if(o in n&&S.isObject(n[o])&&S.isObject(t[o])){this.mergeContents(n[o],t[o]);continue}n[o]=P.deepClone(t[o])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?P.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,o=null;const c=u=>{u&&(o?this.mergeContents(o,u):o=P.deepClone(u))};for(const u of this.overrides)D.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&c(u.contents);return c(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,I.addToValueTree)(this.contents,n,t,o=>{throw new Error(o)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let o=0;o<t;o++)n.indexOf(this.keys[o])===0&&(t=o);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=v;class h extends v{constructor(){const n=(0,I.getDefaultValues)(),t=(0,I.getConfigurationKeys)(),o=[];for(const c of Object.keys(n))b.OVERRIDE_PROPERTY_REGEX.test(c)&&o.push({identifiers:(0,b.overrideIdentifiersFromKey)(c),keys:Object.keys(n[c]),contents:(0,I.toValuesTree)(n[c],u=>console.error(`Conflict in default settings file: ${u}`))});super(n,t,o)}}e.DefaultConfigurationModel=h;class E{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!S.isUndefinedOrNull(n)){const o=this.doParseContent(n);this.parseRaw(o,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:o,keys:c,overrides:u,restricted:f}=this.doParseRaw(n,t);this._configurationModel=new v(o,c,u),this._restrictedConfigurations=f||[]}doParseContent(n){let t={},o=null,c=[],u=[],f=[];function p(O){Array.isArray(c)?c.push(O):o!==null&&(c[o]=O)}let k={onObjectBegin:()=>{let O={};p(O),u.push(c),c=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{let O=[];p(O),u.push(c),c=O,o=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:p,onError:(O,F,W)=>{f.push({error:O,offset:F,length:W})}};if(n)try{R.visit(n,k),t=c[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return t}doParseRaw(n,t){const o=d.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),c=this.filter(n,o,!0,t);n=c.raw;const u=(0,I.toValuesTree)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),f=Object.keys(n),p=this.toOverrides(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:u,keys:f,overrides:p,restricted:c.restricted}}filter(n,t,o,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:n,restricted:[]};const u={},f=[];for(let p in n)if(b.OVERRIDE_PROPERTY_REGEX.test(p)&&o){const k=this.filter(n[p],t,!1,c);u[p]=k.raw,f.push(...k.restricted)}else{const k=t[p],O=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&f.push(p),(O===void 0||c.scopes===void 0||c.scopes.includes(O))&&(c.skipRestricted&&k?.restricted||(u[p]=n[p]))}return{raw:u,restricted:f}}toOverrides(n,t){const o=[];for(const c of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(c)){const u={};for(const f in n[c])u[f]=n[c][f];o.push({identifiers:(0,b.overrideIdentifiersFromKey)(c),keys:Object.keys(u),contents:(0,I.toValuesTree)(u,t)})}return o}}e.ConfigurationModelParser=E;class y extends T.Disposable{constructor(n,t,o,c){super();this.userSettingsResource=n,this.scopes=t,this.fileService=c,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class m{constructor(n,t,o=new v,c=new v,u=new i.ResourceMap,f=new v,p=new i.ResourceMap,k=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=o,this._workspaceConfiguration=c,this._folderConfigurations=u,this._memoryConfiguration=f,this._memoryConfigurationByResource=p,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,o){return this.getConsolidateConfigurationModel(t,o).getValue(n)}updateValue(n,t,o={}){let c;o.resource?(c=this._memoryConfigurationByResource.get(o.resource),c||(c=new v,this._memoryConfigurationByResource.set(o.resource,c))):c=this._memoryConfiguration,t===void 0?c.removeValue(n):c.setValue(n,t),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,o){const c=this.getConsolidateConfigurationModel(t,o),u=this.getFolderConfigurationModelForResource(t.resource,o),f=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,p=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),k=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),F=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),W=o?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,$=u?t.overrideIdentifier?u.freeze().override(t.overrideIdentifier).getValue(n):u.freeze().getValue(n):void 0,A=t.overrideIdentifier?f.override(t.overrideIdentifier).getValue(n):f.getValue(n),q=c.getValue(n),_=D.distinct(D.flatten(c.overrides.map(M=>M.identifiers))).filter(M=>c.getOverrideValue(n,M)!==void 0);return{defaultValue:p,userValue:k,userLocalValue:O,userRemoteValue:F,workspaceValue:W,workspaceFolderValue:$,memoryValue:A,value:q,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:W!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:u?.freeze().getValue(n),override:t.overrideIdentifier?u?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:A!==void 0?{value:f.getValue(n),override:t.overrideIdentifier?f.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:_.length?_:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const o=[];for(const c of t)for(const u of(0,b.overrideIdentifiersFromKey)(c)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(u),p=n.getKeysForOverrideIdentifier(u),k=[...p.filter(O=>f.indexOf(O)===-1),...f.filter(O=>p.indexOf(O)===-1),...f.filter(O=>!P.equals(this._defaultConfiguration.override(u).getValue(O),n.override(u).getValue(O)))];o.push([u,k])}return this.updateDefaultConfiguration(n),{keys:t,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:o,removed:c,overrides:u}=l(this.localUserConfiguration,n),f=[...t,...o,...c];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:o,removed:c,overrides:u}=l(this.remoteUserConfiguration,n);let f=[...t,...o,...c];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:o,removed:c,overrides:u}=l(this.workspaceConfiguration,n);let f=[...t,...o,...c];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const o=this.folderConfigurations.get(n),{added:c,updated:u,removed:f,overrides:p}=l(o,t);let k=[...c,...u,...f];return(k.length||!o)&&this.updateFolderConfiguration(n,t),{keys:k,overrides:p}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:c,removed:u,overrides:f}=l(t,void 0);return{keys:[...o,...c,...u],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let o=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?o.override(n.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:n},t){let o=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const c=t.getFolder(n);c&&(o=this.getFolderConsolidatedConfiguration(c.uri)||o);const u=this._memoryConfigurationByResource.get(n);u&&(o=o.merge(u))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const o=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(n);c?(t=o.merge(c),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=o}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const o=t.getFolder(n);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:o,overrides:c,keys:u}=this._folderConfigurations.get(t);return n.push([t,{contents:o,overrides:c,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(o=>n.add(o))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(c=>t.add(c))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),o=this.parseConfigurationModel(n.user),c=this.parseConfigurationModel(n.workspace),u=n.folders.reduce((f,p)=>(f.set(C.URI.revive(p[0]),this.parseConfigurationModel(p[1])),f),new i.ResourceMap);return new m(t,o,new v,c,u,new v,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new v(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=m;function w(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const n=new Set,t=new Map;for(const c of s)c.keys.forEach(u=>n.add(u)),c.overrides.forEach(([u,f])=>{const p=(0,i.getOrSet)(t,u,new Set);f.forEach(k=>p.add(k))});const o=[];return t.forEach((c,u)=>o.push([u,[...c.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=w;class g{constructor(n,t,o,c){this.change=n,this.previous=t,this.currentConfiguraiton=o,this.currentWorkspace=c,this._previousConfiguration=void 0;const u=new Set;n.keys.forEach(p=>u.add(p)),n.overrides.forEach(([,p])=>p.forEach(k=>u.add(k))),this.affectedKeys=[...u.values()];const f=new v;this.affectedKeys.forEach(p=>f.setValue(p,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!P.equals(o,c)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let o=(0,I.toValuesTree)({[t]:!0},()=>{}),c;for(;typeof o=="object"&&(c=Object.keys(o)[0]);){if(n=n[c],!n)return!1;o=o[c]}return!0}}e.ConfigurationChangeEvent=g;class a extends g{constructor(n,t,o,c){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=o,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=a;function l(s,n){const{added:t,removed:o,updated:c}=r(n,s),u=[],f=s?.getAllOverrideIdentifiers()||[],p=n?.getAllOverrideIdentifiers()||[];if(n){const k=p.filter(O=>!f.includes(O));for(const O of k)u.push([O,n.getKeysForOverrideIdentifier(O)])}if(s){const k=f.filter(O=>!p.includes(O));for(const O of k)u.push([O,s.getKeysForOverrideIdentifier(O)])}if(n&&s){for(const k of f)if(p.includes(k)){const O=r({contents:s.getOverrideValue(void 0,k)||{},keys:s.getKeysForOverrideIdentifier(k)},{contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)});u.push([k,[...O.added,...O.removed,...O.updated]])}}return{added:t,removed:o,updated:c,overrides:u}}function r(s,n){const t=s?n?s.keys.filter(u=>n.keys.indexOf(u)===-1):[...s.keys]:[],o=n?s?n.keys.filter(u=>s.keys.indexOf(u)===-1):[...n.keys]:[],c=[];if(s&&n){for(const u of n.keys)if(s.keys.indexOf(u)!==-1){const f=(0,I.getConfigurationValue)(n.contents,u),p=(0,I.getConfigurationValue)(s.contents,u);P.equals(f,p)||c.push(u)}}return{added:t,removed:o,updated:c}}}),define(te[182],ne([0,1,5,3,2,18,21,88,39,35]),function(J,e,D,L,R,T,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends R.Disposable{constructor(d,v){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,v)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(C.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,v){const h=typeof d=="string"?d:void 0,E=(0,i.isConfigurationOverrides)(d)?d:(0,i.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,E,void 0)}updateValue(d,v,h,E){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,v,1)}onDidDefaultConfigurationChange(d){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,d);this.trigger(h,v,6)}trigger(d,v,h){const E=new P.ConfigurationChangeEvent(d,{data:v},this.configuration);E.source=h,E.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(te[183],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var L;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(i,P=L.Unknown,S){super(i);this._message=i,this._code=P,this._detail=S,this.isHandled=P===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(i){return i instanceof R&&i._code===L.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof R&&i._code===L.NoResolverFound}static isHandled(i){return i instanceof R&&i.isHandled}}e.RemoteAuthorityResolverError=R}),define(te[184],ne([0,1,5,19,27,9,3,2,29,71,183]),function(J,e,D,L,R,T,i,P,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var d;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function v(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(U){const N=new R.CancellationTokenSource;return setTimeout(()=>N.cancel(),U),N.token}function E(U,N){if(U.isCancellationRequested||N.isCancellationRequested)return R.CancellationToken.Cancelled;const z=new R.CancellationTokenSource;return U.onCancellationRequested(()=>z.cancel()),N.onCancellationRequested(()=>z.cancel()),z.token}class y{constructor(N){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((z,x)=>{this._resolvePromise=z,this._rejectPromise=x}),N.isCancellationRequested?this._timeout():this._disposables.add(N.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(N){this._state==="pending"?this._disposables.add(N):N.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(N))}reject(N){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(N))}}function m(U,N){const z=new y(N);return z.registerDisposable(U.onControlMessage(x=>{const K=JSON.parse(x.toString()),ee=B(K);ee?z.reject(ee):z.resolve(K)})),z.promise}function w(U,N,z,x,K,ee){const V=new y(ee);return N.connect(z,x,K,(X,se)=>{V.didTimeout?(X&&U.error(X),se?.dispose()):X||!se?V.reject(X):V.resolve(se)}),V.promise}function g(U,N){const z=new y(N);return U.then(x=>{z.didTimeout||z.resolve(x)},x=>{z.didTimeout||z.reject(x)}),z.promise}async function a(U,N,z,x){const K=j(U,N);U.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await w(U.logService,U.socketFactory,U.host,U.port,`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,x)}catch(le){throw U.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),U.logService.error(le),le}U.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let V,X;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(ee,null),V=U.reconnectionProtocol,X=!1):(V=new C.PersistentProtocol(ee,null),X=!0),U.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const se=await g(U.signService.createNewMessage((0,S.generateUuid)()),x),oe={type:"auth",auth:U.connectionToken||"00000000000000000000",data:se.data};V.sendControl(L.VSBuffer.fromString(JSON.stringify(oe)));try{const le=await m(V,E(x,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(U.logService.trace(`${K} 4/6. received SignRequest control message.`),!await g(U.signService.validate(se,le.signedData),x)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const be=await g(U.signService.sign(le.data),x),Ce={type:"connectionType",commit:U.commit,signedData:be,desiredConnectionType:N};return z&&(Ce.args=z),U.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(L.VSBuffer.fromString(JSON.stringify(Ce))),{protocol:V,ownsProtocol:X}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(U.logService.error(`${K} the handshake timed out. Error:`),U.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${K} received error control message when negotiating connection. Error:`),U.logService.error(le)),X&&M(V),le}}async function l(U,N,z,x){const K=Date.now(),ee=j(U,N),{protocol:V,ownsProtocol:X}=await a(U,N,z,x),se=new y(x);return se.registerDisposable(V.onControlMessage(oe=>{const le=JSON.parse(oe.toString()),he=B(le);he?(U.logService.error(`${ee} received error control message when negotiating connection. Error:`),U.logService.error(he),X&&M(V),se.reject(he)):(U.reconnectionProtocol&&U.reconnectionProtocol.endAcceptReconnection(),U.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${Q(K)}!`),se.resolve({protocol:V,firstMessage:le}))})),se.promise}async function r(U,N){const{protocol:z}=await l(U,1,void 0,N);return{protocol:z}}async function s(U,N,z){const{protocol:x,firstMessage:K}=await l(U,2,N,z),ee=K&&K.debugPort;return{protocol:x,debugPort:ee}}async function n(U,N,z){const x=Date.now(),K=j(U,3),{protocol:ee}=await a(U,3,N,z);return U.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${Q(x)}!`),ee}async function t(U,N,z){const{host:x,port:K,connectionToken:ee}=await U.addressProvider.getAddress();return{commit:U.commit,host:x,port:K,connectionToken:ee,reconnectionToken:N,reconnectionProtocol:z,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function o(U,N,z){try{const x=(0,S.generateUuid)(),K=await t(U,x,null),{protocol:ee}=await r(K,R.CancellationToken.None);return new q(U,N,z,x,ee)}catch(x){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(x),A.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(x)),x}}e.connectRemoteAgentManagement=o;async function c(U,N){try{const z=(0,S.generateUuid)(),x=await t(U,z,null),{protocol:K,debugPort:ee}=await s(x,N,R.CancellationToken.None);return new _(U,N,z,K,ee)}catch(z){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(z),A.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(z)),z}}e.connectRemoteAgentExtensionHost=c;async function u(U,N,z){const x=await t(U,(0,S.generateUuid)(),null);return await n(x,{host:N,port:z},R.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function f(U){return(0,D.createCancelablePromise)(N=>new Promise((z,x)=>{const K=setTimeout(z,U*1e3);N.onCancellationRequested(()=>{clearTimeout(K),z()})}))}var p;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(p=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class k{constructor(N,z){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=k;class O{constructor(N,z,x,K){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.durationSeconds=x,this.cancellableTimer=K,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class F{constructor(N,z,x){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.attempt=x,this.type=2}}e.ReconnectionRunningEvent=F;class W{constructor(N,z,x){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.attempt=x,this.type=4}}e.ConnectionGainEvent=W;class ${constructor(N,z,x,K){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.attempt=x,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class A extends P.Disposable{constructor(N,z,x,K){super();this._connectionType=N,this._onDidStateChange=this._register(new i.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=z,this.reconnectionToken=x,this.protocol=K,this._isReconnecting=!1,this._onDidStateChange.fire(new W(this.reconnectionToken,0,0)),this._register(K.onSocketClose(ee=>{const V=H(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${V} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${V} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${V} received socket close event.`),this._beginReconnecting()})),this._register(K.onSocketTimeout(()=>{const ee=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${ee} received socket timeout event.`),this._beginReconnecting()})),A._instances.push(this),A._permanentFailure&&this._gotoPermanentFailure(A._permanentFailureMillisSinceLastIncomingData,A._permanentFailureAttempt,A._permanentFailureHandled)}static triggerPermanentFailure(N,z,x){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=N,this._permanentFailureAttempt=z,this._permanentFailureHandled=x,this._instances.forEach(K=>K._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(A._permanentFailure)return;const N=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const K=x<z.length?z[x]:z[z.length-1];try{if(K>0){const V=f(K);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,V)),this._options.logService.info(`${N} waiting for ${K} seconds before reconnecting...`);try{await V}catch{}}if(A._permanentFailure){this._options.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this._options.logService.info(`${N} resolving connection...`);const ee=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${N} connecting to ${ee.host}:${ee.port}...`),await this._reconnect(ee,h(b)),this._options.logService.info(`${N} reconnected!`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ee),A.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this._options.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ee),A.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this._options.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this._options.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((0,T.isPromiseCanceledError)(ee)){this._options.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if(ee instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ee),A.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,I.RemoteAuthorityResolverError.isHandled(ee));break}this._options.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ee),A.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!A._permanentFailure)}_gotoPermanentFailure(N,z,x){this._onDidStateChange.fire(new $(this.reconnectionToken,N,z,x)),M(this.protocol)}}A._permanentFailure=!1,A._permanentFailureMillisSinceLastIncomingData=0,A._permanentFailureAttempt=0,A._permanentFailureHandled=!1,A._instances=[];class q extends A{constructor(N,z,x,K,ee){super(1,N,K,ee);this.client=this._register(new C.Client(ee,{remoteAuthority:z,clientId:x},N.ipcLogger))}async _reconnect(N,z){await r(N,z)}}e.ManagementPersistentConnection=q;class _ extends A{constructor(N,z,x,K,ee){super(2,N,x,K);this._startArguments=z,this.debugPort=ee}async _reconnect(N,z){await s(N,this._startArguments,z)}}e.ExtensionHostPersistentConnection=_;function M(U){try{U.acceptDisconnect();const N=U.getSocket();U.dispose(),N.dispose()}catch(N){(0,T.onUnexpectedError)(N)}}function B(U){if(U&&U.type==="error"){const N=new Error(`Connection error: ${U.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function Z(U,N){for(;U.length<N;)U+=" ";return U}function H(U,N,z){return`[remote-connection][${Z(v(U),13)}][${N.substr(0,5)}\u2026][${z?"reconnect":"initial"}]`}function j(U,N){return`${H(N,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function Q(U){return`${Date.now()-U} ms`}}),define(te[185],ne([0,1,16]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(C){return C.scheme===D.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=L;function R(C){if(!C)return;const I=C.indexOf("+");return I<0?C:C.substr(0,I)}e.getRemoteName=R;function T(C){return C.scheme!==D.Schemas.file&&C.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=T;function i(C){if(C.folders.length)return C.folders.every(I=>T(I.uri))?C.folders[0].uri:void 0;if(C.configuration&&T(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=i;function P(C){return i(C)?.scheme}e.getVirtualWorkspaceScheme=P;function S(C){return i(C)!==void 0}e.isVirtualWorkspace=S}),define(te[89],ne([0,1,25,6,185]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=T;function i(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class S{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,h){if(typeof v=="undefined"||v===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof v=="string"||typeof h=="string"){let E=typeof v=="string"?v:v.value,y=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(E,y)}return v._lower===h._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=S;function C(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function I(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function b(d,v){if(v){const h=`onResolveRemoteAuthority:${(0,R.getRemoteName)(v)}`;return d.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[36],ne([0,1,25,89]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(h,E){return h.uuid&&E.uuid?h.uuid===E.uuid:h.id===E.id?!0:(0,D.compareIgnoreCase)(h.id,E.id)===0}e.areSameExtensions=R;class T{constructor(E,y){this.version=y,this.id=E.id,this.uuid=E.uuid}key(){return`${this.id}-${this.version}`}equals(E){return E instanceof T?R(this,E)&&this.version===E.version:!1}}e.ExtensionIdentifierWithVersion=T;function i(h,E){return`${h}.${E}`}e.getExtensionId=i;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function S(h,E){return P(i(h,E))}e.getGalleryExtensionId=S;function C(h,E){const y=[],m=w=>{for(const g of y)if(g.some(a=>R(E(a),E(w))))return g;return null};for(const w of h){const g=m(w);g?g.push(w):y.push([w])}return y}e.groupByExtension=C;function I(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function b(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function d(h){const E=new Set;for(const y of h)y.malicious&&E.add(y.id.id);return E}e.getMaliciousExtensionsSet=d;function v(h,E){const y=[],m=E.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&y.every(g=>!R(g.identifier,{id:w}))){const g=h.filter(a=>R(a.identifier,{id:w}));g.length===1&&(y.push(g[0]),m.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.getExtensionDependencies=v}),define(te[186],ne([0,1,5,9,2,4,18,61,7,29,20,11,30,36,14,8]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends R.Disposable{constructor(g,a,l,r){super();this.fileService=a,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=S.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,a){await this.cleanUpPromise;const l=this.getName(g),r=(0,i.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const s=(0,i.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(g,s,a);try{await this.rename(s,r,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(s)}catch(t){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,s.path),n}}return r}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,a,l){try{await I.Promises.rename(g.fsPath,a.fsPath)}catch(r){if(T.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${g} to ${a} with 'EPERM' error. Trying again...`),this.rename(g,a,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const a=[],l=[];for(const n of g.children){const t=this.parse(n.name);t&&l.push([t,n])}const r=(0,v.groupByExtension)(l,([n])=>n),s=[];for(const n of r)n.sort((t,o)=>P.rcompare(t[0].version,o[0].version)),a.push(...n.slice(1).map(t=>t[1].resource)),s.push(n[0][1]);s.sort((n,t)=>n.mtime-t.mtime),a.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(a.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?`${new v.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase()}${g.properties.targetPlatform!=="undefined"?`-${g.properties.targetPlatform}`:""}`:(0,C.generateUuid)()}parse(g){const a=y.exec(g);return a&&a[1]&&a[2]?new v.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};m=de([G(0,b.INativeEnvironmentService),G(1,h.IFileService),G(2,d.IExtensionGalleryService),G(3,E.ILogService)],m),e.ExtensionsDownloader=m}),define(te[187],ne([0,1,2,10,20,89]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class i extends D.Disposable{constructor(S,C){super();this.environmentService=S,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(C.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(S){S.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=i}),define(te[188],ne([0,1,81,17,5,2,16,10,20,11,30,36,59,8]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends T.Disposable{constructor(m,w,g){super();this.extensionManagementService=m,this.logService=g,this.cache=this._register(new E(w,g)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,L.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(g=>w[g]&&w[g].extensions.some(a=>(0,b.areSameExtensions)(a.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(w);return!(0,L.equals)(Object.keys(m),Object.keys(g))}};h=de([G(0,I.IExtensionManagementService),G(1,C.INativeEnvironmentService),G(2,v.ILogService)],h),e.LocalizationsService=h;let E=class extends T.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(g=>delete w[g]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const g of w)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,g);Object.keys(m).forEach(g=>this.updateHash(m[g]))}createLanguagePacksFromExtension(m,w){const g=w.identifier,a=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of a)if(w.location.scheme===i.Schemas.file&&(0,d.isValidLocalization)(l)){let r=m[l.languageId];r||(r={hash:"",extensions:[],translations:{}},m[l.languageId]=r);let s=r.extensions.filter(n=>(0,b.areSameExtensions)(n.extensionIdentifier,g))[0];s?s.version=w.manifest.version:r.extensions.push({extensionIdentifier:g,version:w.manifest.version});for(const n of l.translations)r.translations[n.id]=(0,P.join)(w.location.fsPath,n.path)}}updateHash(m){if(m){const w=(0,D.createHash)("md5");for(const g of m.extensions)w.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch(a){return{}}}).then(g=>(w=m(g),g)).then(g=>{for(const l of Object.keys(g))g[l]||delete g[l];this.languagePacks=g,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),S.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>w,g=>this.logService.error(g))})}};E=de([G(0,C.INativeEnvironmentService),G(1,v.ILogService)],E)}),define(te[189],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,8]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var i;(function(h){h.Http="http",h.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const E=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!E)return{address:E[1],port:+E[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=b;function d(h,E){return E?E!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=d;let v=class{constructor(E){this.logService=E,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(E,y){return this._tunnelProvider=E,E?(this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const E=[],y=Array.from(this._tunnels.values());for(let m of y){const w=Array.from(m.values());for(let g of w){const a=await g.value;a&&E.push(a)}}return E}async dispose(){for(const E of this._tunnels.values()){for(const{value:y}of E.values())await y.then(m=>m?.dispose());E.clear()}this._tunnels.clear()}openTunnel(E,y,m,w,g=!1,a=P.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${m} on local port ${w}.`),!E)return;y||(y="localhost");const r=this.retainOrCreateTunnel(E,y,m,w,g,a,l);return r?r.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(s);return(s.tunnelRemoteHost!==y||s.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(E){return{tunnelRemotePort:E.tunnelRemotePort,tunnelRemoteHost:E.tunnelRemoteHost,tunnelLocalPort:E.tunnelLocalPort,localAddress:E.localAddress,privacy:E.privacy,protocol:E.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${E.tunnelRemoteHost}:${E.tunnelRemotePort} `);const y=this._tunnels.get(E.tunnelRemoteHost);if(y){const m=y.get(E.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(E.tunnelRemoteHost,E.tunnelRemotePort,m))}}}}async tryDisposeTunnel(E,y,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${E}:${y}.`);const w=m.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(E)&&this._tunnels.get(E).delete(y),w}}async closeTunnel(E,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${E}:${y} `);const m=this._tunnels.get(E);if(m&&m.has(y)){const w=m.get(y);w.refcount=0,await this.tryDisposeTunnel(E,y,w)}}addTunnelToMap(E,y,m){this._tunnels.has(E)||this._tunnels.set(E,new Map),this._tunnels.get(E).set(y,{refcount:1,value:m})}async removeEmptyTunnelFromMap(E,y){const m=this._tunnels.get(E);m&&(await m.get(y)||m.delete(y),m.size===0&&this._tunnels.delete(E))}getTunnelFromMap(E,y){let m=[E];I(E)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):b(E)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const w=m.map(g=>this._tunnels.get(g));for(const g of w){const a=g?.get(y);if(a)return a}}canTunnel(E){return!!C(E)}createWithProvider(E,y,m,w,g,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${m} on local port ${w}.`);const s={elevationRequired:g?d(w===void 0?m:w):!1},n={remoteAddress:{host:y,port:m},localAddressPort:w,privacy:a,public:a!==P.Private,protocol:l},t=E.forwardPort(n,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(y,m,t),t}};v=de([G(0,T.ILogService)],v),e.AbstractTunnelService=v}),define(te[190],ne([0,1,8,62,2,9,5]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new i.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let S=class Et extends R.Disposable{constructor(I,b){super();this._tunnelService=I,this._logService=b,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Et._lastId)}}async startTunnel(I,b,d,v,h,E){const y=new P,m=await Promise.resolve(this._tunnelService.openTunnel(I,y,d,v,h,E));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${v} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(b))throw this._disposedTunnels.delete(b),y.dispose(),await m.dispose(),(0,T.canceled)();return y.setTunnel(m),this._tunnels.set(b,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${m.localAddress} (local) to ${d}:${v} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(I,b){const d=this._tunnels.get(I);!d||d.setAddress(b)}async destroyTunnel(I){const b=this._tunnels.get(I);if(b){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await b.dispose();return}this._disposedTunnels.add(I)}};S._lastId=0,S=de([G(0,L.ISharedTunnelsService),G(1,D.ILogService)],S),e.SharedProcessTunnelService=S}),define(te[191],ne([0,1,120,21,8]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,S){this.configurationService=P,this.logService=S}request(P,S){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,S)}async resolveProxy(P){}};T=de([G(0,L.IConfigurationService),G(1,R.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,19,141,39,6,35]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function S(h){return h.res.statusCode===204}async function C(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await(0,D.streamToBuffer)(h.stream)).toString()}e.asText=C;async function I(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const y=(await(0,D.streamToBuffer)(h.stream)).toString();try{return JSON.parse(y)}catch(m){throw m.message+=`:
`+y,m}}e.asJson=I;function b(h){v(h)}e.updateProxyConfigurationsScope=b;let d;function v(h){const E=i.Registry.as(R.Extensions.Configuration),y=d;d={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[d],remove:y?[y]:[]})}v(2)}),define(te[192],ne([0,1,27,16,14,43]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let i=class{constructor(S,C){this.requestService=S,this.fileService=C}async download(S,C,I=D.CancellationToken.None){if(S.scheme===L.Schemas.file||S.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(S,C);return}const b={type:"GET",url:S.toString()},d=await this.requestService.request(b,I);if(d.res.statusCode===200)await this.fileService.writeFile(C,d.stream);else{const v=await(0,T.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${v}`)}}};i=de([G(0,T.IRequestService),G(1,R.IFileService)],i),e.DownloadService=i}),define(te[193],ne([0,1,17,27,66,2,18,155,14,8,26,43]),function(J,e,D,L,R,T,i,P,S,C,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends T.Disposable{constructor(h,E,y,m){super();this.fileService=h,this.productService=E,this.requestService=y,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const E=[];for(const[y,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,i.joinPath)(h,y)),g=new Map;(0,R.forEach)(m.recommendations,({key:l,value:r})=>{if((0,D.isNonEmptyArray)(r.remotes))for(const s of r.remotes)g.set(s,{extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else E.push({extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const a=(0,P.getDomainsOfRemotes)(w.value.toString(),[...g.keys()]);for(const l of a){const r=g.get(l);r&&E.push(r)}}catch(w){}return E}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(h.res.statusCode!==200)return[];const E=await(0,b.asJson)(h);return E?E.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=de([G(0,S.IFileService),G(1,I.IProductService),G(2,b.IRequestService),G(3,C.ILogService)],d),e.ExtensionTipsService=d}),define(te[46],ne([0,1,19,29]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(T,i,P){let S=P&&P.get("storage.serviceMachineId",0)||null;if(S)return S;try{const I=(await i.readFile(T.serviceMachineIdResource)).value.toString();S=(0,L.isUUID)(I)?I:null}catch(C){S=null}if(!S){S=(0,L.generateUuid)();try{await i.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(S))}catch(C){}}return P&&P.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=R}),define(te[90],ne([0,1,105,6]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(T){return(0,D.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,L.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[194],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(L){L.Spawn="vscode:shared-process->shared-process-worker=spawn",L.Terminate="vscode:shared-process->shared-process-worker=terminate",L.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",L.Ready="vscode:shared-process-worker->shared-process=ready",L.Ack="vscode:shared-process-worker->shared-process=ack",L.Trace="vscode:shared-process-worker->shared-process=trace",L.Info="vscode:shared-process-worker->shared-process=info",L.Warn="vscode:shared-process-worker->shared-process=warn",L.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[195],ne([0,1,72,153,5,27,3,2,16,4,29,11,8,26,90,194]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let y=class{constructor(g,a,l){this.logService=g,this.productService=a,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(g){const a=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${a})`);const l=(0,h.hash)(g);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${a})`),this.doDisposeWorker(g));const r=new T.CancellationTokenSource;let s,n,t;this.processeDisposables.set(l,f=>{r.dispose(!0),s?.terminate(g,T.CancellationToken.None),n?.close(),t?.close(),this.processeDisposables.delete(l);const p=this.processResolvers.get(l);p&&(this.processResolvers.delete(l),p({reason:f}))}),s=await this.getOrCreateWebWorker(g);const o=new Promise(f=>{this.processResolvers.set(l,f)});if(r.token.isCancellationRequested)return o;const{port1:c,port2:u}=new MessageChannel;return n=c,t=u,await s.spawn(g,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${a})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[n])),o}getOrCreateWebWorker(g){let a=this.workers.get(g.process.moduleId);if(!a){this.logService.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const l=new m(g.process.type,this.logService,this.productService,this.environmentService);a=l.init(),l.onDidProcessSelfTerminate(({configuration:r,reason:s})=>{this.doDisposeWorker(r,s)}),this.workers.set(g.process.moduleId,a)}return a}async disposeWorker(g){return this.doDisposeWorker(g)}doDisposeWorker(g,a){const l=this.processeDisposables.get((0,h.hash)(g));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),l(a))}};y=de([G(0,d.ILogService),G(1,v.IProductService),G(2,b.INativeEnvironmentService)],y),e.SharedProcessWorkerService=y;class m extends P.Disposable{constructor(g,a,l,r){super();this.type=g,this.logService=a,this.productService=l,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new i.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const g=new R.DeferredPromise,a=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return a.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},a.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},a.onmessage=l=>{const{id:r,message:s,configuration:n,nonce:t}=l.data;switch(r){case E.SharedProcessWorkerMessages.Ready:g.complete(a);break;case E.SharedProcessWorkerMessages.Ack:if(t){const o=this.mapMessageNonceToPendingMessageResolve.get(t);o&&(this.mapMessageNonceToPendingMessageResolve.delete(t),o())}break;case E.SharedProcessWorkerMessages.SelfTerminated:n&&s&&this._onDidProcessSelfTerminate.fire({configuration:n,reason:JSON.parse(s)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,s);break;case E.SharedProcessWorkerMessages.Info:s&&this.logService.info(s);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,s);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,s);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},a.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async send(g,a,l){const r=await this.workerReady;if(!a.isCancellationRequested)return new Promise(s=>{const n=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(n,s);const t={...g,nonce:n};l?r.postMessage(t,[l]):r.postMessage(t),a.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(n)&&s()})})}spawn(g,a,l){const r={id:E.SharedProcessWorkerMessages.Spawn,configuration:g,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,l,a)}getSharedProcessWorkerEnvironment(){const g={bootstrapPath:S.FileAccess.asFileUri("bootstrap-fork",J).fsPath,env:Object.create(null)};if(C.isLinux){const a={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&l&&(0,I.isUUID)(l)){const t=r["linux-x64"];a.submitURL=t.concat("&uid=",l,"&iid=",l,"&sid=",l),a.uploadToServer=!0}const n=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;g.env.BREAKPAD_DUMP_LOCATION=(0,L.join)(n,this.type),g.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(a)}return g}terminate(g,a){const l={id:E.SharedProcessWorkerMessages.Terminate,configuration:g};return this.send(l,a)}}}),define(te[91],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[196],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((R,T)=>J(["vsda"],R,T))}async createNewMessage(R){try{const T=await this.vsda(),i=new T.validator;if(i){const P=String(D._nextId++);return this.validators.set(P,i),{id:P,data:i.createNewMessage(R)}}}catch(T){}return{id:"",data:R}}async validate(R,T){if(!R.id)return!0;const i=this.validators.get(R.id);if(!i)return!1;this.validators.delete(R.id);try{return i.validate(T)==="ok"}catch(P){return!1}}async sign(R){try{const T=await this.vsda(),i=new T.signer;if(i)return i.sign(R)}catch(T){}return R}}e.SignService=D,D._nextId=1}),define(te[23],ne([0,1,5,3,2,178,15,73,6]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var I;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var d;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class v extends R.Disposable{constructor(m={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,w){w===C?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:w,target:this.getKeyTargets(m)[w]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,w,g){return this.getStorage(w)?.get(m,g)}getBoolean(m,w,g){return this.getStorage(w)?.getBoolean(m,g)}getNumber(m,w,g){return this.getStorage(w)?.getNumber(m,g)}store(m,w,g,a){if((0,i.isUndefinedOrNull)(w)){this.remove(m,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,g,a),this.getStorage(g)?.set(m,w)})}remove(m,w){this.withPausedEmitters(()=>{this.updateKeyTarget(m,w,void 0),this.getStorage(w)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,w){const g=[],a=this.getKeyTargets(m);for(const l of Object.keys(a))a[l]===w&&g.push(l);return g}updateKeyTarget(m,w,g){const a=this.getKeyTargets(w);typeof g=="number"?a[m]!==g&&(a[m]=g,this.getStorage(w)?.set(C,JSON.stringify(a))):typeof a[m]=="number"&&(delete a[m],this.getStorage(w)?.set(C,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const w=this.get(C,m);if(w)try{return JSON.parse(w)}catch(g){}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=I.NONE){this._onWillSaveState.fire({reason:m});const w=this.getStorage(0),g=this.getStorage(1);switch(m){case I.NONE:await D.Promises.settled([w?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([w?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return E(m,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends v{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function E(y,m,w,g){const a=c=>{try{return JSON.parse(c)}catch(u){return c}},l=new Map,r=new Map;y.forEach((c,u)=>{l.set(u,c),r.set(u,a(c))});const s=new Map,n=new Map;m.forEach((c,u)=>{s.set(u,c),n.set(u,a(c))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((c,u)=>{t.push({key:u,value:c})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${g})`);let o=[];s.forEach((c,u)=>{o.push({key:u,value:c})}),console.table(o),console.groupEnd(),console.log(n)}e.logStorage=E}),define(te[197],ne([0,1,3,2,15,30,36,23]),function(J,e,D,L,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends L.Disposable{constructor(b){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(b)),this._register(this.storageManger.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"})))}async enableExtension(b,d){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:d}),!0):!1}async disableExtension(b,d){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){let d=this.getDisabledExtensions();return d.every(v=>!(0,i.areSameExtensions)(v,b))?(d.push(b),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(b){let d=this.getDisabledExtensions();for(let v=0;v<d.length;v++){const h=d[v];if((0,i.areSameExtensions)(h,b))return d.splice(v,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(b){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,d){this.storageManger.set(b,d,0)}};S=de([G(0,P.IStorageService)],S),e.GlobalExtensionEnablementService=S;class C extends L.Disposable{constructor(b){super();this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(b,d){let v;return d===0?((0,R.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,d)),v=this.storage[b]):v=this._get(b,d),JSON.parse(v)}set(b,d,v){let h=JSON.stringify(d.map(({id:y,uuid:m})=>({id:y,uuid:m})));this._get(b,v)!==h&&(v===0&&(d.length?this.storage[b]=h:delete this.storage[b]),this._set(b,d.length?h:void 0,v))}onDidStorageChange(b){if(b.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const v=this.get(b.key,b.scope);delete this.storage[b.key];const h=this.get(b.key,b.scope),E=v.filter(m=>!h.some(w=>(0,i.areSameExtensions)(m,w))),y=h.filter(m=>!v.some(w=>(0,i.areSameExtensions)(w,m)));(E.length||y.length)&&this._onDidChange.fire([...E,...y])}}_get(b,d){return this.storageService.get(b,d,"[]")}_set(b,d,v){d?this.storageService.store(b,d,v,1):this.storageService.remove(b,v)}}e.StorageManager=C}),define(te[198],ne([0,1,3,2]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(C,I){super();this.channel=C,this.workspace=I}async getItems(){const C={workspace:this.workspace},I=await this.channel.call("getItems",C);return new Map(I)}updateItems(C){const I={workspace:this.workspace};return C.insert&&(I.insert=Array.from(C.insert.entries())),C.delete&&(I.delete=Array.from(C.delete.values())),this.channel.call("updateItems",I)}}class T extends R{constructor(C){super(C,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(C=>this.onDidChangeGlobalStorage(C)))}onDidChangeGlobalStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}async close(){this.dispose()}}class i extends R{constructor(C,I){super(C,I);this.onDidChangeItemsExternal=D.Event.None}async close(){const C={workspace:this.workspace};return this.channel.call("close",C)}}class P extends L.Disposable{constructor(C,I){super();this.channel=C,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new i(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[199],ne([0,1,5,2,18,73,23,198]),function(J,e,D,L,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends i.AbstractStorageService{constructor(I,b,d){super();this.mainProcessService=b,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),b=new T.Storage(I.globalStorage);return this._register(b.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),b}createWorkspaceStorage(I){const b=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(b.workspaceStorage){const d=new T.Storage(b.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(v=>this.emitDidChangeValue(1,v)),this.workspaceStorageId=I?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,R.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(i.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const b=this.workspaceStorage,d=b?.items??new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[v,h]of d)this.workspaceStorage.set(v,h)}}e.NativeStorageService=S}),define(te[200],ne([0,1,4,32,7,29]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function i(C){if(D.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function P(C,I,b,d,v,h,E,y,m,w){const g=Object.create(null);g["common.machineId"]=E,g.sessionID=(0,T.generateUuid)()+Date.now(),g.commitHash=v,g.version=h,g["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,D.PlatformToString)(D.platform),g["common.nodePlatform"]=L.platform,g["common.nodeArch"]=d,g["common.product"]=w||"desktop";const a=S(y||[]);a&&(g["common.msftInternal"]=a);let l=0;const r=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(g["common.snap"]="true");const s=i(b);s&&(g["common.platformDetail"]=s);try{const n=await C.readFile(R.URI.file(m));g["common.source"]=n.value.toString().slice(0,30)}catch(n){}return g}e.resolveCommonProperties=P;function S(C){const I=L.env.USERDNSDOMAIN;if(!I)return!1;const b=I.toLowerCase();return C.some(d=>b===d)}e.verifyMicrosoftInternalDomain=S}),define(te[22],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[201],ne([0,1,33,56,5,31,16,10,4,7,113,20,116,78,14,26,22]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(r,s){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],t=new Map,o=new Map,c=2e4;function u(k,O,F,W){const $=O.substring(k.length+1);return R.Promises.withAsyncBody(async A=>{let q;try{q=await b.Promises.readdir(O,{withFileTypes:!0})}catch(B){A();return}if(W.count>=c){W.count+=q.length,W.maxReached=!0,A();return}let _=q.length;if(_===0){A();return}let M=q;W.count+q.length>c&&(W.maxReached=!0,_=c-W.count,M=q.slice(0,_)),W.count+=q.length;for(const B of M)if(B.isDirectory()){if(F.includes(B.name)||await u(k,(0,P.join)(O,B.name),F,W),--_==0){A();return}}else{const Z=B.name.lastIndexOf(".");if(Z>=0){const H=B.name.substring(Z+1);H&&t.set(H,(t.get(H)??0)+1)}for(const H of n)H.relativePathPattern?.test($)!==!1&&H.filePattern.test(B.name)&&o.set(H.tag,(o.get(H.tag)??0)+1);if(--_==0){A();return}}})}const f={count:0,maxReached:!1};await u(r,r,s,f);const p=await a(r);return{configFiles:w(o),fileTypes:w(t),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:p}}e.collectWorkspaceStats=m;function w(r){return[...L.Iterable.map(r.entries(),([s,n])=>({name:s,count:n}))].sort((s,n)=>n.count-s.count)}function g(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},s=D.cpus();return s&&s.length>0&&(r.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),r}e.getMachineInfo=g;async function a(r){try{const s=new Map,n=(0,P.join)(r,".vscode","launch.json"),t=await b.Promises.readFile(n),o=[],c=(0,T.parse)(t.toString(),o);if(o.length)return console.log(`Unable to parse ${n}`),[];if((0,T.getNodeType)(c)==="object"&&c.configurations)for(const u of c.configurations){const f=u.type;f&&(s.has(f)?s.set(f,s.get(f)+1):s.set(f,1))}return w(s)}catch(s){return[]}}e.collectLaunchConfigs=a;let l=class{constructor(s,n){this.telemetryService=s,this.productService=n}formatMachineInfo(s){const n=[];return n.push(`OS Version:       ${s.os}`),n.push(`CPUs:             ${s.cpus}`),n.push(`Memory (System):  ${s.memory}`),n.push(`VM:               ${s.vmHint}`),n.join(`
`)}formatEnvironment(s){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const t=D.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),S.isWindows||n.push(`Load (avg):       ${D.loadavg().map(o=>Math.round(o)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${s.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(s,n){return Promise.all([(0,d.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async t=>{let[o,c]=t,u=this.formatProcessList(s,o);return n.forEach(f=>{if((0,v.isRemoteDiagnosticError)(f))u+=`
${f.errorMessage}`,c+=`
${f.errorMessage}`;else if(u+=`

Remote: ${f.hostName}`,f.processes&&(u+=`
${this.formatProcessList(s,f.processes)}`),f.workspaceMetadata){c+=`
|  Remote: ${f.hostName}`;for(const p of Object.keys(f.workspaceMetadata)){const k=f.workspaceMetadata[p];let O=`${k.fileCount} files`;k.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${p}): ${O}`,c+=this.formatWorkspaceStats(k)}}}),{processInfo:u,workspaceInfo:c}})}async getSystemInfo(s,n){const{memory:t,vmHint:o,os:c,cpus:u}=g(),f={os:c,memory:t,cpus:u,vmHint:o,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:n};return S.isWindows||(f.load=`${D.loadavg().map(p=>Math.round(p)).join(", ")}`),S.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(s,n){const t=[];return(0,d.listProcesses)(s.mainPID).then(async o=>(t.push(""),t.push(this.formatEnvironment(s)),t.push(""),t.push(this.formatProcessList(s,o)),s.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(s))),n.forEach(c=>{if((0,v.isRemoteDiagnosticError)(c))t.push(`
${c.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${c.hostName}`),t.push(this.formatMachineInfo(c.machineInfo)),c.processes&&t.push(this.formatProcessList(s,c.processes)),c.workspaceMetadata)for(const u of Object.keys(c.workspaceMetadata)){const f=c.workspaceMetadata[u];let p=`${f.fileCount} files`;f.maxFilesReached&&(p=`more than ${p}`),t.push(`Folder (${u}): ${p}`),t.push(this.formatWorkspaceStats(f))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(s){const n=[],t=60;let o=0;const c=(k,O)=>{const F=` ${k}(${O})`;o+F.length>t?(n.push(u),u="|                 ",o=u.length):o+=F.length,u+=F};let u="|      File types:";const f=10;let p=s.fileTypes.length>f?f:s.fileTypes.length;for(let k=0;k<p;k++){const O=s.fileTypes[k];c(O.name,O.count)}if(n.push(u),s.configFiles.length>=0&&(u="|      Conf files:",o=0,s.configFiles.forEach(k=>{c(k.name,k.count)}),n.push(u)),s.launchConfigFiles.length>0){let k="|      Launch Configs:";s.launchConfigFiles.forEach(O=>{k+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(k)}return n.join(`
`)}expandGPUFeatures(s){const n=Math.max(...Object.keys(s).map(t=>t.length));return Object.keys(s).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${s[t]}`).join(`
                  `)}formatWorkspaceMetadata(s){const n=[],t=[];return s.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(n.push(`|  Window (${o.title})`),o.folderURIs.forEach(c=>{const u=C.URI.revive(c);if(u.scheme===i.Schemas.file){const f=u.fsPath;t.push(m(f,["node_modules",".git"]).then(p=>{let k=`${p.fileCount} files`;p.maxFilesReached&&(k=`more than ${k}`),n.push(`|    Folder (${(0,P.basename)(f)}): ${k}`),n.push(this.formatWorkspaceStats(p))}).catch(p=>{n.push(`|      Error: Unable to collect workspace stats for folder ${f} (${p.toString()})`)}))}else n.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(o=>n.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(s,n){const t=new Map;s.windows.forEach(c=>t.set(c.pid,c.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(s.mainPID,t,o,n,0),o.join(`
`)}formatProcessItem(s,n,t,o,c){const u=c===0;let f;u?f=o.pid===s?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(c)} ${o.name}`,o.name==="window"&&(f=`${f} (${n.get(o.pid)})`));const p=process.platform==="win32"?o.mem:D.totalmem()*(o.mem/100);t.push(`${o.load.toFixed(0).padStart(5," ")}	${(p/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(o.children)&&o.children.forEach(k=>this.formatProcessItem(s,n,t,k,c+1))}async reportWorkspaceStats(s){for(const{uri:n}of s.folders){const t=C.URI.revive(n);if(t.scheme!==i.Schemas.file)continue;const o=t.fsPath;try{const c=await m(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),c.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),c.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),c.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};l=de([G(0,y.ITelemetryService),G(1,E.IProductService)],l),e.DiagnosticsService=l}),define(te[202],ne([0,1,17,5,27,9,3,2,4,7,130,30,36,8,26,22]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let y=class extends P.Disposable{constructor(r,s,n,t){super();this.galleryService=r,this.telemetryService=s,this.logService=n,this.productService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new i.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new i.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new i.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new i.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const s=await this.getTargetPlatform();return r.allTargetPlatforms.some(n=>(0,b.isTargetPlatformCompatible)(n,r.allTargetPlatforms,s))}async installFromGallery(r,s={}){try{if(!this.galleryService.isEnabled())throw new b.ExtensionManagementError(I.localize(0,null),b.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(r,!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,s)}catch(n){throw g(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(r),void 0,n),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(n),w(n)}}async uninstall(r,s={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,s)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const s=await this.findGalleryExtension(r);if(!s)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsReport(){const r=new Date().getTime();return(!this.reportedExtensions||r-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=r),this.reportedExtensions}registerParticipant(r){this.participants.push(r)}async installExtension(r,s,n){if(!C.URI.isUri(s)){let f=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(s.identifier,s.version).key());if(f)return this.logService.info("Extensions is already requested to install",s.identifier.id),f.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],o=[],c=this.createInstallExtensionTask(r,s,n);C.URI.isUri(s)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(c.identifier,r.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:s}),this.logService.info("Installing extension:",c.identifier.id),t.push({task:c,manifest:r});let u=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const p=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,r,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:k,manifest:O}of p)if(u=u||!!O.extensionDependencies?.some(F=>(0,d.areSameExtensions)({id:F},c.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(k.identifier,k.version).key()))this.logService.info("Extension is already requested to install",k.identifier.id);else{const F=this.createInstallExtensionTask(O,k,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(F.identifier,O.version).key(),F),this._onInstallExtension.fire({identifier:F.identifier,source:k}),this.logService.info("Installing extension:",F.identifier.id),t.push({task:F,manifest:O})}}catch(p){if(C.URI.isUri(c.source))(0,D.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,p.message),(0,D.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,p.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),p}const f=t.reduce((p,{task:k,manifest:O})=>(p.set(k.identifier.id.toLowerCase(),{task:k,manifest:O}),p),new Map);for(;f.size;){let p;const k=[...f.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(F=>f.has(F.toLowerCase())));k.length?p=f.size===1?k:k.filter(({task:O})=>!(O===c&&!u)):(this.logService.info("Found extensions with circular dependencies",k.map(({task:O})=>O.identifier.id)),p=[...f.values()]),await this.joinAllSettled(p.map(async({task:O})=>{const F=new Date().getTime();try{const W=await O.run();if(await this.joinAllSettled(this.participants.map($=>$.postInstall(W,O.source,n,R.CancellationToken.None))),!C.URI.isUri(O.source)&&(g(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-F,void 0),S.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch($){}o.push({local:W,identifier:O.identifier,operation:O.operation,source:O.source})}catch(W){throw C.URI.isUri(O.source)||g(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-F,W),this.logService.error("Error while installing the extension:",O.identifier.id),W}finally{f.delete(O.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:p})=>this.logService.info("Extension installed successfully:",p.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:p})=>(0,d.areSameExtensions)(p,c.identifier))[0].local}catch(f){if(t.forEach(({task:p})=>p.cancel()),o.length)try{const p=await Promise.allSettled(o.map(({local:k})=>this.createUninstallExtensionTask(k,{versionOnly:!0}).run()));for(let k=0;k<p.length;k++){const O=p[k],{identifier:F}=o[k];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,T.getErrorMessage)(O.reason))}}catch(p){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(p),o.map(({identifier:k})=>k.id))}throw this._onDidInstallExtensions.fire(t.map(({task:p})=>({identifier:p.identifier,operation:1,source:p.source}))),f}finally{for(const{task:f,manifest:p}of t)if(!C.URI.isUri(f.source)){const k=new d.ExtensionIdentifierWithVersion(f.identifier,p.version).key();this.installingExtensions.delete(k)||this.logService.warn("Installation task is not found in the cache",k)}}}async joinAllSettled(r){const s=[],n=[],t=await Promise.allSettled(r);for(const o of t)o.status==="fulfilled"?s.push(o.value):n.push(o.reason);if(n.length)throw m(n);return s}async getAllDepsAndPackExtensionsToInstall(r,s,n,t){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const c=[r,...o.map(p=>p.identifier)],u=[],f=async(p,k)=>{const O=k.extensionDependencies||[],F=[...O];if(k.extensionPack){const W=n?o.find($=>(0,d.areSameExtensions)($.identifier,p)):void 0;for(const $ of k.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(A=>(0,d.areSameExtensions)({id:A},{id:$}))||F.every(A=>!(0,d.areSameExtensions)({id:A},{id:$}))&&F.push($)}if(F.length){const W=[...c,...u.map(A=>A.gallery.identifier)],$=F.filter(A=>W.every(q=>!(0,d.areSameExtensions)(q,{id:A})));if($.length){const A=await this.galleryService.query({names:$,pageSize:F.length},R.CancellationToken.None);for(const q of A.firstPage){if(W.find(B=>(0,d.areSameExtensions)(B,q.identifier)))continue;const _=O.some(B=>(0,d.areSameExtensions)({id:B},q.identifier));let M;try{M=await this.checkAndGetCompatibleVersion(q,!0,t)}catch(B){if(B instanceof b.ExtensionManagementError&&B.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!_){this.logService.info("Skipping the packed extension as it cannot be installed",q.identifier.id);continue}else throw B}u.push({gallery:M.extension,manifest:M.manifest}),await f(M.extension.identifier,k)}}}};return await f(r,s),o=await this.getInstalled(),u.filter(p=>!o.some(k=>(0,d.areSameExtensions)(k.identifier,p.gallery.identifier)))}async checkAndGetCompatibleVersion(r,s,n){if(await this.isMalicious(r))throw new b.ExtensionManagementError(I.localize(3,null,r.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(r)){const c=await this.getTargetPlatform();throw new b.ExtensionManagementError(I.localize(4,null,r.identifier.id,this.productService.nameLong,(0,b.TargetPlatformToString)(c)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const t=await this.getCompatibleVersion(r,s,n);if(t){if(n&&r.hasPreReleaseVersion&&!t.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(I.localize(5,null,r.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new b.ExtensionManagementError(I.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.Incompatible);const o=await this.galleryService.getManifest(t,R.CancellationToken.None);if(o===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(o.version!==t.version)throw new b.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:t,manifest:o}}async getCompatibleVersion(r,s,n){const t=await this.getTargetPlatform();let o=null;return s&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==n&&(o=await this.galleryService.getCompatibleExtension(r.identifier,n,t)),!o&&await this.galleryService.isExtensionCompatible(r,n,t)&&(o=r),!o&&s&&(o=await this.galleryService.getCompatibleExtension(r,n,t)),o}async isMalicious(r){const s=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(s).has(r.identifier.id)}async unininstallExtension(r,s){const n=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),n.waitUntilTaskIsFinished();const t=(f,p)=>{const k=this.createUninstallExtensionTask(f,p);return this.uninstallingExtensions.set(k.extension.identifier.id.toLowerCase(),k),this.logService.info("Uninstalling extension:",f.identifier.id),this._onUninstallExtension.fire(f.identifier),k},o=(f,p)=>{p?this.logService.error("Failed to uninstall extension:",f.identifier.id,p.message):this.logService.info("Successfully uninstalled extension:",f.identifier.id),g(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(f),void 0,p),this._onDidUninstallExtension.fire({identifier:f.identifier,error:p?.code})},c=[],u=[];try{c.push(t(r,{}));const f=await this.getInstalled(1);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const p=this.getAllPackExtensionsToUninstall(r,f);for(const k of p)this.uninstallingExtensions.has(k.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",k.identifier.id):c.push(t(k,{}))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(c.map(p=>p.extension),f,r),await this.joinAllSettled(c.map(async p=>{try{if(await p.run(),await this.joinAllSettled(this.participants.map(k=>k.postUninstall(p.extension,s,R.CancellationToken.None))),p.extension.identifier.uuid)try{await this.galleryService.reportStatistic(p.extension.manifest.publisher,p.extension.manifest.name,p.extension.manifest.version,"uninstall")}catch(k){}o(p.extension)}catch(k){const O=k instanceof b.ExtensionManagementError?k:new b.ExtensionManagementError((0,T.getErrorMessage)(k),b.ExtensionManagementErrorCode.Internal);throw o(p.extension,O),O}finally{u.push(p)}}))}catch(f){const p=f instanceof b.ExtensionManagementError?f:new b.ExtensionManagementError((0,T.getErrorMessage)(f),b.ExtensionManagementErrorCode.Internal);for(const k of c){try{k.cancel()}catch(O){}u.includes(k)||o(k.extension,p)}throw p}finally{for(const f of c)this.uninstallingExtensions.delete(f.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",f.extension.identifier.id)}}checkForDependents(r,s,n){for(const t of r){const o=this.getDependents(t,s);if(o.length){const c=o.filter(u=>!r.some(f=>(0,d.areSameExtensions)(f.identifier,u.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(t,c,n))}}}getDependentsErrorMessage(r,s,n){return n===r?s.length===1?I.localize(7,null,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(8,null,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(9,null,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?I.localize(10,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(11,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(12,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(r,s,n=[]){if(n.indexOf(r)!==-1)return[];n.push(r);const t=r.manifest.extensionPack?r.manifest.extensionPack:[];if(t.length){const o=s.filter(u=>!u.isBuiltin&&t.some(f=>(0,d.areSameExtensions)({id:f},u.identifier))),c=[];for(const u of o)c.push(...this.getAllPackExtensionsToUninstall(u,s,n));return[...o,...c]}return[]}getDependents(r,s){return s.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(t=>(0,d.areSameExtensions)({id:t},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const s=await this.findGalleryExtensionById(r.identifier.uuid);return s||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${r.length} reported extensions from service`),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};y=de([G(0,b.IExtensionGalleryService),G(1,E.ITelemetryService),G(2,v.ILogService),G(3,h.IProductService)],y),e.AbstractExtensionManagementService=y;function m(l){const r=Array.isArray(l)?l:[l];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((s,n)=>new Error(`${s.message}${s.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=m;function w(l){if(l instanceof b.ExtensionManagementError)return l;const r=new b.ExtensionManagementError(l.message,b.ExtensionManagementErrorCode.Internal);return r.stack=l.stack,r}function g(l,r,s,n,t){const o=t?t instanceof b.ExtensionManagementError?t.code:b.ExtensionManagementErrorCode.Internal:void 0;l.publicLogError(r,{...s,success:!t,duration:n,errorcode:o})}e.reportTelemetry=g;class a{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(r=>new Promise((s,n)=>{const t=r.onCancellationRequested(()=>{t.dispose(),n((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=a}),define(te[203],ne([0,1,17,5,66,3,10,4,32,7,132,11,30,193,80,14,8,60,26,43,23,22]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let n=class extends v.ExtensionTipsService{constructor(o,c,u,f,p,k,O,F,W,$){super(O,F,W,$);this.environmentService=o,this.telemetryService=c,this.extensionManagementService=u,this.storageService=f,this.nativeHostService=p,this.extensionRecommendationNotificationService=k,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&(0,R.forEach)(F.exeBasedExtensionTips,({key:A,value:q})=>{const _=[],M=[],B=[];(0,R.forEach)(q.recommendations,({key:Z,value:H})=>{H.important?q.important?_.push({extensionId:Z,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):M.push({extensionId:Z,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):B.push({extensionId:Z,extensionName:H.name,isExtensionPack:!!H.isExtensionPack})}),_.length&&this.highImportanceExecutableTips.set(A,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:_}),M.length&&this.mediumImportanceExecutableTips.set(A,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:M}),B.length&&this.allOtherExecutableTips.set(A,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:B})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,u)}groupImportantTipsByExe(o,c){const u=new Map;o.forEach(F=>u.set(F.extensionId.toLowerCase(),F));const{installed:f,uninstalled:p}=this.groupByInstalled([...u.keys()],c);for(const F of f){const W=u.get(F);W&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:W.exeName})}for(const F of p){const W=u.get(F);W&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:W.exeName})}const k=this.getPromptedExecutableTips(),O=new Map;for(const F of p){const W=u.get(F);if(W&&(!k[W.exeName]||!k[W.exeName].includes(W.extensionId))){let $=O.get(W.exeName);$||($=[],O.set(W.exeName,$)),$.push(W)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":const f=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const p=this._register((0,L.disposableTimeout)(()=>{p.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),c=Date.now()-o,u=7*24*60*60*1e3;if(c<u){const k=this._register((0,L.disposableTimeout)(()=>{k.dispose(),this.promptMediumImportanceExeBasedTip()},u-c));return}const[f,p]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(k=>{switch(k){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(p[0].exeName,p);const O=this._register((0,L.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const F=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(F(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const W=this._register((0,L.disposableTimeout)(()=>{W.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(o){const c=o.map(({extensionId:f})=>f.toLowerCase()),u=(0,I.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,u,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(s,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(s,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(o,c){const u=this.getPromptedExecutableTips();u[o]=c.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(r,JSON.stringify(u),0,0)}groupByInstalled(o,c){const u=[],f=[],p=c.reduce((k,O)=>(k.add(O.identifier.id.toLowerCase()),k),new Set);return o.forEach(k=>{p.has(k.toLowerCase())?u.push(k):f.push(k)}),{installed:u,uninstalled:f}}async getValidExecutableBasedExtensionTips(o){const c=[],u=new Map;for(const f of o.keys()){const p=o.get(f);if(!p||!(0,D.isNonEmptyArray)(p.recommendations))continue;const k=[];P.isWindows?p.windowsPath&&k.push(p.windowsPath.replace("%USERPROFILE%",S.env.USERPROFILE).replace("%ProgramFiles(x86)%",S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",S.env.ProgramFiles).replace("%APPDATA%",S.env.APPDATA).replace("%WINDIR%",S.env.WINDIR)):(k.push((0,i.join)("/usr/local/bin",f)),k.push((0,i.join)("/usr/bin",f)),k.push((0,i.join)(this.environmentService.userHome.fsPath,f)));for(const O of k){let F=u.get(O);if(F===void 0&&(F=await this.fileService.exists(C.URI.file(O)),u.set(O,F)),F)for(const{extensionId:W,extensionName:$,isExtensionPack:A}of p.recommendations)c.push({extensionId:W,extensionName:$,isExtensionPack:A,exeName:f,exeFriendlyName:p.exeFriendlyName,windowsPath:p.windowsPath})}}return c}};n=de([G(0,b.INativeEnvironmentService),G(1,l.ITelemetryService),G(2,d.IExtensionManagementService),G(3,a.IStorageService),G(4,m.INativeHostService),G(5,h.IExtensionRecommendationNotificationService),G(6,E.IFileService),G(7,w.IProductService),G(8,g.IRequestService),G(9,y.ILogService)],n),e.ExtensionTipsService=n}),define(te[92],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,i){throw new Error(`Event not found: ${i}`)}call(T,i,{eventName:P,data:S}){return this.appenders.forEach(C=>C.log(P,S)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class L{constructor(T){this.channel=T}log(T,i){return this.channel.call("log",{eventName:T,data:i}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[44],ne([0,1,28,15,21,22]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class i{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,w){return Promise.resolve(void 0)}publicLog2(m,w){return this.publicLog(m,w)}publicLogError(m,w){return Promise.resolve(void 0)}publicLogError2(m,w){return this.publicLogError(m,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=i,e.NullTelemetryService=new i;class P{async publicLog(m,w,g){}async publicLogError(m,w,g){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(y,m){return m.onDidChangeConfiguration(w=>{w.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(w.source),configurationKeys:h(w.sourceConfig)})})}e.configurationTelemetry=S;function C(y,m){return!(m.disableTelemetry||!y.enableTelemetry)}e.supportsTelemetry=C;function I(y){const m=y.getValue(T.TELEMETRY_SETTING_ID),w=y.getValue("telemetry.enableCrashReporter");if(y.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function b(y){const m=Object.create(null),w=Object.create(null),g=Object.create(null);v(y,g);for(let a in g){a=a.length>150?a.substr(a.length-149):a;const l=g[a];typeof l=="number"?w[a]=l:typeof l=="boolean"?w[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),m[a]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(m[a]=l)}return{properties:m,measurements:w}}e.validateTelemetryData=b;function d(y){if(!y)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{y.indexOf(`${g}+`)===0&&(m=g)}),m}e.cleanRemoteAuthority=d;function v(y,m,w=0,g){if(!!y)for(let a of Object.getOwnPropertyNames(y)){const l=y[a],r=g?g+a:a;Array.isArray(l)?m[r]=(0,D.safeStringify)(l):l instanceof Date?m[r]=l.toISOString():(0,L.isObject)(l)?w<2?v(l,m,w+1,r+"."):m[r]=(0,D.safeStringify)(l):m[r]=l}}function h(y){if(!y)return[];const m=[];return E(m,"",y),m}function E(y,m,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(g=>E(y,m?`${m}.${g}`:g,w[g])):y.push(m)}}),define(te[204],ne([0,1,44,150]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class R{constructor(){}setSharedProperty(S,C){}postEvent(S,C){}}class T{constructor(S,C,I,b,d){this.getMachineId=S,this.configurationService=C,this.productService=I,this.telemetry=b,this.keyValueStorage=d,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,D.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const v=this.configurationService.getValue("experiments.overrideDelay"),h=typeof v=="number"?v:0;this.overrideInitDelay=new Promise(E=>setTimeout(E,h))}get experimentsEnabled(){return!0}async getTreatment(S){await this.overrideInitDelay;const C=this.configurationService.getValue("experiments.override."+S);if(C!==void 0)return C;if(!this.tasClient||!this.experimentsEnabled)return;let I;const b=await this.tasClient;return this.networkInitialized?I=b.getTreatmentVariable("vscode",S):I=await b.getTreatmentVariableAsync("vscode",S,!0),I=b.getTreatmentVariable("vscode",S),I}async setupTASClient(){const S=this.productService.quality==="stable"?L.TargetPopulation.Public:L.TargetPopulation.Insiders,C=await this.getMachineId(),I=new L.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,C,S),b=this.productService.tasConfig,d=new(await new Promise((v,h)=>{J(["tas-client-umd"],v,h)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:L.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:b.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:b.assignmentContextTelemetryPropertyName,telemetryEventName:b.telemetryEventName,endpoint:b.endpoint,refetchInterval:L.ASSIGNMENT_REFETCH_INTERVAL});return await d.initializePromise,d.initialFetch.then(()=>this.networkInitialized=!0),d}}e.BaseAssignmentService=T;class i extends T{constructor(S,C,I){super(()=>Promise.resolve(S),C,I,new R)}}e.AssignmentService=i}),define(te[205],ne([0,1,17,27,9,28,4,32,15,7,21,11,30,36,76,14,8,26,43,46,23,22,44]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g,a,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=i.isWeb?"web":(0,d.getTargetPlatform)(i.platform,P.arch);var n;(function(V){V[V.None=0]="None",V[V.IncludeVersions=1]="IncludeVersions",V[V.IncludeFiles=2]="IncludeFiles",V[V.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",V[V.IncludeSharedAccounts=8]="IncludeSharedAccounts",V[V.IncludeVersionProperties=16]="IncludeVersionProperties",V[V.ExcludeNonValidated=32]="ExcludeNonValidated",V[V.IncludeInstallationTargets=64]="IncludeInstallationTargets",V[V.IncludeAssetUri=128]="IncludeAssetUri",V[V.IncludeStatistics=256]="IncludeStatistics",V[V.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",V[V.Unpublished=4096]="Unpublished"})(n||(n={}));function t(...V){return String(V.reduce((X,se)=>X|se,0))}var o;(function(V){V[V.Tag=1]="Tag",V[V.ExtensionId=4]="ExtensionId",V[V.Category=5]="Category",V[V.ExtensionName=7]="ExtensionName",V[V.Target=8]="Target",V[V.Featured=9]="Featured",V[V.SearchText=10]="SearchText",V[V.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class k{constructor(X=p){this.state=X}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(X,se=this.state.pageSize){return new k({...this.state,pageNumber:X,pageSize:se})}withFilter(X,...se){const oe=[...this.state.criteria,...se.length?se.map(le=>({filterType:X,value:le})):[{filterType:X}]];return new k({...this.state,criteria:oe})}withSortBy(X){return new k({...this.state,sortBy:X})}withSortOrder(X){return new k({...this.state,sortOrder:X})}withFlags(...X){return new k({...this.state,flags:X.reduce((se,oe)=>se|oe,0)})}withAssetTypes(...X){return new k({...this.state,assetTypes:X})}get raw(){const{criteria:X,pageNumber:se,pageSize:oe,sortBy:le,sortOrder:he,flags:be,assetTypes:Ce}=this.state;return{filters:[{criteria:X,pageNumber:se,pageSize:oe,sortBy:le,sortOrder:he}],assetTypes:Ce,flags:be}}get searchText(){const X=this.state.criteria.filter(se=>se.filterType===o.SearchText)[0];return X&&X.value?X.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(X=>String(X.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(V,X){const se=(V||[]).filter(oe=>oe.statisticName===X)[0];return se?se.value:0}function F(V){const X="Microsoft.VisualStudio.Code.Translation.";return V.files.filter(oe=>oe.assetType.indexOf(X)===0).reduce((oe,le)=>{const he=q(V,le.assetType);return he&&oe.push([le.assetType.substring(X.length),he]),oe},[])}function W(V){if(V.properties){const X=V.properties.filter(le=>le.key===c.Repository),se=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),oe=X.filter(le=>se.test(le.value))[0];return oe?{uri:oe.value,fallbackUri:oe.value}:null}return q(V,c.Repository)}function $(V){return{uri:`${V.fallbackAssetUri}/${c.VSIX}?redirect=true${V.targetPlatform?`&targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${c.VSIX}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}}function A(V){const X=q(V,c.Icon);if(X)return X;const se=d.DefaultIconPath;return{uri:se,fallbackUri:se}}function q(V,X){return V.files.filter(oe=>oe.assetType===X)[0]?{uri:`${V.assetUri}/${X}`,fallbackUri:`${V.fallbackAssetUri}/${X}`}:null}function _(V,X){const se=V.properties?V.properties.filter(le=>le.key===X):[],oe=se.length>0&&se[0].value;return oe?oe.split(",").map(le=>(0,v.adoptToGalleryExtensionId)(le)):[]}function M(V){const X=V.properties?V.properties.filter(se=>se.key===u.Engine):[];return X.length>0&&X[0].value||""}function B(V){const X=V.properties?V.properties.filter(se=>se.key===u.PreRelease):[];return X.length>0&&X[0].value==="true"}function Z(V){const X=V.properties?V.properties.filter(oe=>oe.key===u.LocalizedLanguages):[],se=X.length>0&&X[0].value||"";return se?se.split(","):[]}function H(V){return V.indexOf("preview")!==-1}function j(V){return V.targetPlatform?(0,d.toTargetPlatform)(V.targetPlatform):"undefined"}function Q(V){const X=(0,D.distinct)(V.versions.map(j)),se=!!V.tags?.includes(d.WEB_EXTENSION_TAG),oe=X.indexOf("web");return se?oe===-1&&X.push("web"):oe!==-1&&X.splice(oe,1),X}function U(V,X){const se=(0,d.getFallbackTargetPlarforms)(X);for(let oe=0;oe<V.length;oe++){const le=V[oe];if(le.version===V[oe-1]?.version){let he=oe;const be=j(le);if(be===X)for(;he>0&&V[he-1].version===le.version;)he--;else if(se.includes(be))for(;he>0&&V[he-1].version===le.version&&j(V[he-1])!==X;)he--;he!==oe&&(V.splice(oe,1),V.splice(he,0,le))}}return V}e.sortExtensionVersions=U;function N(V,X,se,oe){const le=V.versions[0],he={manifest:q(X,c.Manifest),readme:q(X,c.Details),changelog:q(X,c.Changelog),license:q(X,c.License),repository:W(X),download:$(X),icon:A(X),coreTranslations:F(X)};return{identifier:{id:(0,v.getGalleryExtensionId)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},name:V.extensionName,version:X.version,displayName:V.displayName,publisherId:V.publisher.publisherId,publisher:V.publisher.publisherName,publisherDisplayName:V.publisher.displayName,publisherDomain:V.publisher.domain?{link:V.publisher.domain,verified:!!V.publisher.isDomainVerified}:void 0,description:V.shortDescription||"",installCount:O(V.statistics,"install"),rating:O(V.statistics,"averagerating"),ratingCount:O(V.statistics,"ratingcount"),categories:V.categories||[],tags:V.tags||[],releaseDate:Date.parse(V.releaseDate),lastUpdated:Date.parse(V.lastUpdated),allTargetPlatforms:se,assets:he,properties:{dependencies:_(X,u.Dependency),extensionPack:_(X,u.ExtensionPack),engine:M(X),localizedLanguages:Z(X),targetPlatform:j(X),isPreReleaseVersion:B(X)},hasPreReleaseVersion:B(le),preview:H(V.flags),telemetryData:oe}}let z=class{constructor(X,se,oe,le,he,be,Ce,we){this.requestService=se,this.logService=oe,this.environmentService=le,this.telemetryService=he,this.fileService=be,this.productService=Ce,this.configurationService=we;const ve=Ce.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=ee(Ce.version,Ce,this.environmentService,this.configurationService,this.fileService,X)}api(X=""){return`${this.extensionsGalleryUrl}${X}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(X,se,oe){const le=(0,S.isBoolean)(se)?se:!1,he=(0,S.isBoolean)(se)?oe:se;let be=new k().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,X.length).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionName,...X.map(({id:ve})=>ve.toLowerCase()));X.every(ve=>!ve.version)&&(be=be.withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly));const{galleryExtensions:Ce}=await this.queryGallery(be,s,L.CancellationToken.None),we=Ce.map(ve=>{const De=(0,v.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName);return{rawGalleryExtension:ve,version:X.find(Se=>(0,v.areSameExtensions)(Se,{id:De}))?.version}});return this.converToGalleryExtensions(we,le,s,()=>{},he)}async getCompatibleExtension(X,se,oe){const le=(0,d.isIExtensionIdentifier)(X)?null:X;if(le){if((0,d.isNotWebExtensionInWebTargetPlatform)(le.allTargetPlatforms,oe))return null;if(await this.isExtensionCompatible(le,se,oe))return le}const{id:he,uuid:be}=le?le.identifier:X;let Ce=new k().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");be?Ce=Ce.withFilter(o.ExtensionId,be):Ce=Ce.withFilter(o.ExtensionName,he);const{galleryExtensions:we}=await this.queryGallery(Ce,oe,L.CancellationToken.None),[ve]=we;if(!ve||!ve.versions.length)return null;const De=Q(ve);if((0,d.isNotWebExtensionInWebTargetPlatform)(De,oe))return null;for(let Se of ve.versions){if(!M(Se)){const Ie=await this.getEngine(Se);Se={...Se,properties:[...Se.properties||[],{key:u.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(Se,se,De,oe))return N(ve,Se,De)}return null}async isExtensionCompatible(X,se,oe){if(!(0,d.isTargetPlatformCompatible)(X.properties.targetPlatform,X.allTargetPlatforms,oe)||!se&&X.properties.isPreReleaseVersion)return!1;let le=X.properties.engine;if(!le){const he=await this.getManifest(X,L.CancellationToken.None);if(!he)throw new Error("Manifest was not found");le=he.engines.vscode}return(0,h.isEngineValid)(le,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(X,se,oe,le){if(!(0,d.isTargetPlatformCompatible)(j(X),oe,le)||!se&&B(X))return!1;const he=await this.getEngine(X);return(0,h.isEngineValid)(he,this.productService.version,this.productService.date)}async query(X,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let oe=X.text||"";const le=(0,T.getOrDefault)(X,Se=>Se.pageSize,50);let he=new k().withFlags(n.IncludeLatestVersionOnly,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,le).withFilter(o.Target,"Microsoft.VisualStudio.Code");oe?(oe=oe.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Se,Ie,Me)=>(he=he.withFilter(o.Category,Me||Ie),"")),oe=oe.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Se,Ie,Me)=>(he=he.withFilter(o.Tag,Me||Ie),"")),oe=oe.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(o.Featured),"")),oe=oe.trim(),oe&&(oe=oe.length<200?oe:oe.substring(0,200),he=he.withFilter(o.SearchText,oe)),he=he.withSortBy(0)):X.ids?he=he.withFilter(o.ExtensionId,...X.ids):X.names?he=he.withFilter(o.ExtensionName,...X.names):he=he.withSortBy(4),typeof X.sortBy=="number"&&(he=he.withSortBy(X.sortBy)),typeof X.sortOrder=="number"&&(he=he.withSortOrder(X.sortOrder));const{galleryExtensions:be,total:Ce}=await this.queryGallery(he,s,se),we=Se=>({index:(he.pageNumber-1)*he.pageSize+Se,querySource:X.source}),ve=await this.converToGalleryExtensions(be.map(Se=>({rawGalleryExtension:Se})),!!X.includePreRelease,s,we,se),De=async(Se,Ie)=>{if(Ie.isCancellationRequested)throw(0,R.canceled)();const Me=he.withPage(Se+1),{galleryExtensions:je}=await this.queryGallery(Me,s,Ie);return await this.converToGalleryExtensions(je.map(Ne=>({rawGalleryExtension:Ne})),!!X.includePreRelease,s,we,se)};return{firstPage:ve,total:Ce,pageSize:he.pageSize,getPage:De}}async converToGalleryExtensions(X,se,oe,le,he){const be=(ve,De)=>{const Se=Q(ve);let Ie=ve.versions[0];return Ie=ve.versions.find(Me=>Me.version===Ie.version&&(0,d.isTargetPlatformCompatible)(j(Me),Se,oe))||Ie,!se&&B(Ie)&&(Ie=ve.versions.find(Me=>Me.version!==Ie.version&&!B(Me))||Ie),N(ve,Ie,Se,le(De))},Ce=[],we=new Map;for(let ve=0;ve<X.length;ve++){const{rawGalleryExtension:De,version:Se}=X[ve];if(Se){const Ie=De.versions.find(Me=>Me.version===Se);Ie&&Ce.push([ve,N(De,Ie,Q(De))])}else{const Ie=be(De,ve);Ie.properties.isPreReleaseVersion&&!se?we.set(Ie.identifier.uuid,ve):Ce.push([ve,Ie])}}if(we.size){const ve=new k().withFlags(n.IncludeVersions,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,we.size).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionId,...we.keys()),{galleryExtensions:De}=await this.queryGallery(ve,oe,he);if(De.length!==we.size)throw new Error("Not all extensions with latest versions are returned");for(const Se of De){const Ie=we.get(Se.extensionId),Me=be(Se,Ie);Ce.push([Ie,Me])}}return Ce.sort((ve,De)=>ve[0]-De[0]).map(([,ve])=>ve)}async queryGallery(X,se,oe){if(!this.isEnabled())throw new Error("No extension gallery service configured.");X=X.withFlags(X.flags,n.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,t(n.Unpublished));const le=await this.commonHeadersPromise,he=JSON.stringify(X.raw),be={...le,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},Ce=new Date().getTime();let we,ve,De=0;try{if(we=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:be},oe),we.res.statusCode&&we.res.statusCode>=400&&we.res.statusCode<500)return{galleryExtensions:[],total:De};const Se=await(0,w.asJson)(we);if(Se){const Ie=Se.results[0],Me=Ie.extensions;Me.forEach(Ne=>U(Ne.versions,se));const je=Ie.resultMetadata&&Ie.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return De=je&&je.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Me,total:De}}return{galleryExtensions:[],total:De}}catch(Se){throw ve=Se,Se}finally{this.telemetryService.publicLog2("galleryService:query",{...X.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-Ce,success:!!we&&(0,w.isSuccess)(we),responseBodySize:we?.res.headers["Content-Length"],statusCode:we?String(we.res.statusCode):void 0,errorCode:ve?(0,R.isPromiseCanceledError)(ve)?"canceled":(0,R.getErrorMessage)(ve).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(De)})}}async reportStatistic(X,se,oe,le){if(!this.isEnabled())return;const he=i.isWeb?this.api(`/itemName/${X}.${se}/version/${oe}/statType/${le==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${X}/extensions/${se}/${oe}/stats?statType=${le}`),be=i.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.commonHeadersPromise,Accept:be};try{await this.requestService.request({type:"POST",url:he,headers:we},L.CancellationToken.None)}catch(ve){}}async download(X,se,oe){this.logService.trace("ExtensionGalleryService#download",X.identifier.id);const le=(0,v.getGalleryExtensionTelemetryData)(X),he=new Date().getTime(),be=De=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...le,duration:De}),Ce=oe===1?"install":oe===2?"update":"",we=Ce?{uri:`${X.assets.download.uri}${C.URI.parse(X.assets.download.uri).query?"&":"?"}${Ce}=true`,fallbackUri:`${X.assets.download.fallbackUri}${C.URI.parse(X.assets.download.fallbackUri).query?"&":"?"}${Ce}=true`}:X.assets.download,ve=await this.getAsset(we);await this.fileService.writeFile(se,ve.stream),be(new Date().getTime()-he)}async getReadme(X,se){if(X.assets.readme){const oe=await this.getAsset(X.assets.readme,{},se);return await(0,w.asText)(oe)||""}return""}async getManifest(X,se){if(X.assets.manifest){const oe=await this.getAsset(X.assets.manifest,{},se),le=await(0,w.asText)(oe);return le?JSON.parse(le):null}return null}async getManifestFromRawExtensionVersion(X,se){const oe=q(X,c.Manifest);if(!oe)throw new Error("Manifest was not found");const le={"Accept-Encoding":"gzip"},he=await this.getAsset(oe,{headers:le});return await(0,w.asJson)(he)}async getCoreTranslation(X,se){const oe=X.assets.coreTranslations.filter(le=>le[0]===se.toUpperCase())[0];if(oe){const le=await this.getAsset(oe[1]),he=await(0,w.asText)(le);return he?JSON.parse(he):null}return null}async getChangelog(X,se){if(X.assets.changelog){const oe=await this.getAsset(X.assets.changelog,{},se);return await(0,w.asText)(oe)||""}return""}async getAllCompatibleVersions(X,se,oe){let le=new k().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");X.identifier.uuid?le=le.withFilter(o.ExtensionId,X.identifier.uuid):le=le.withFilter(o.ExtensionName,X.identifier.id);const{galleryExtensions:he}=await this.queryGallery(le,oe,L.CancellationToken.None);if(!he.length)return[];const be=Q(he[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(be,oe))return[];const Ce=[];for(const we of he[0].versions)try{Ce[Ce.length-1]?.version!==we.version&&await this.isRawExtensionVersionCompatible(we,se,be,oe)&&Ce.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:B(we)})}catch(ve){}return Ce}async getAsset(X,se={},oe=L.CancellationToken.None){const le=await this.commonHeadersPromise,he={type:"GET"},be={...le,...se.headers||{}};se={...se,...he,headers:be};const Ce=X.uri,we=X.fallbackUri,ve={...se,url:Ce};try{const De=await this.requestService.request(ve,oe);if(De.res.statusCode===200)return De;const Se=await(0,w.asText)(De);throw new Error(`Expected 200, got back ${De.res.statusCode} instead.

${Se}`)}catch(De){if((0,R.isPromiseCanceledError)(De))throw De;const Se=(0,R.getErrorMessage)(De);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Ce,message:Se});const Ie={...se,url:we};return this.requestService.request(Ie,oe)}}async getEngine(X){let se=M(X);if(!se){const oe=await this.getManifestFromRawExtensionVersion(X,L.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");se=oe.engines.vscode}return se}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const X=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(X.res.statusCode!==200)throw new Error("Could not get extensions report.");const se=await(0,w.asJson)(X),oe=new Map;if(se)for(const le of se.malicious){const he=oe.get(le)||{id:{id:le},malicious:!0,slow:!1};he.malicious=!0,oe.set(le,he)}return[...oe.values()]}};z=de([G(1,w.IRequestService),G(2,y.ILogService),G(3,b.IEnvironmentService),G(4,l.ITelemetryService),G(5,E.IFileService),G(6,m.IProductService),G(7,I.IConfigurationService)],z);let x=class extends z{constructor(X,se,oe,le,he,be,Ce,we){super(X,se,oe,le,he,be,Ce,we)}};x=de([G(0,a.IStorageService),G(1,w.IRequestService),G(2,y.ILogService),G(3,b.IEnvironmentService),G(4,l.ITelemetryService),G(5,E.IFileService),G(6,m.IProductService),G(7,I.IConfigurationService)],x),e.ExtensionGalleryService=x;let K=class extends z{constructor(X,se,oe,le,he,be,Ce){super(void 0,X,se,oe,le,he,be,Ce)}};K=de([G(0,w.IRequestService),G(1,y.ILogService),G(2,b.IEnvironmentService),G(3,l.ITelemetryService),G(4,E.IFileService),G(5,m.IProductService),G(6,I.IConfigurationService)],K),e.ExtensionGalleryServiceWithNoStorageService=K;async function ee(V,X,se,oe,le,he){const be={"X-Market-Client-Id":`VSCode ${V}`,"User-Agent":`VSCode ${V}`},Ce=await(0,g.getServiceMachineId)(se,le,he);return(0,r.supportsTelemetry)(X,se)&&(0,r.getTelemetryLevel)(oe)===3&&(be["X-Market-User-Id"]=Ce),be}e.resolveMarketplaceHeaders=ee}),define(te[93],ne([0,1,2,11,8,44]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let i=class extends D.Disposable{constructor(S,C,I=""){super();this.prefix=I;const b=S.getLogger(C.telemetryLogResource);b?this.logger=this._register(b):(this.logger=this._register(S.createLogger(C.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(S,C){this.logger.trace(`${this.prefix}telemetry/${S}`,(0,T.validateTelemetryData)(C))}};i=de([G(0,R.ILoggerService),G(1,L.IEnvironmentService)],i),e.TelemetryLogAppender=i}),define(te[94],ne([0,1,2,28,4,25,142,21,39,86,35,22,44]),function(J,e,D,L,R,T,i,P,S,C,I,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(y,m){this._configurationService=m,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const g=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})})}setExperimentProperty(y,m){this._experimentProperties[y]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const y=await this._commonProperties;let m=y.sessionID,w=y["common.machineId"],g=y["common.firstSessionDate"],a=y["common.msftInternal"];return{sessionId:m,machineId:w,firstSessionDate:g,msftInternal:a}}dispose(){this._disposables.dispose()}_log(y,m,w,g){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(a=>{w=(0,L.mixin)(w,a),w=(0,L.mixin)(w,this._experimentProperties),w=(0,L.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,g)}),this._appenders.forEach(l=>l.log(y,w))},a=>{console.error(a)})}publicLog(y,m,w){return this._log(y,3,m,w)}publicLog2(y,m,w){return this.publicLog(y,m,w)}publicLogError(y,m){return this.sendErrorTelemetry?this._log(y,2,m,!0):Promise.resolve(void 0)}publicLogError2(y,m){return this.publicLogError(y,m)}_anonymizeFilePaths(y){let m=y;const w=[];for(let r of this._cleanupPatterns)for(;;){const s=r.exec(y);if(!s)break;w.push([s.index,r.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const r=a.exec(y);if(!r)break;!g.test(r[0])&&w.every(([s,n])=>r.index<s||r.index>=n)&&(m+=y.substring(l,r.index)+"<REDACTED: user-file-path>",l=a.lastIndex)}return l<y.length&&(m+=y.substr(l)),m}_removePropertiesWithPossibleUserInfo(y){if(!y)return y;const m=y.toLowerCase(),w=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":w.test(m)?"<REDACTED: email>":y}_cleanupInfo(y,m){let w=y;m&&(w=this._anonymizeFilePaths(w));for(let g of this._cleanupPatterns)w=w.replace(g,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=de([G(1,P.IConfigurationService)],v),e.TelemetryService=v;function h(){const E=(0,i.localize)(0,null,C.default.nameLong),y=C.default.privacyStatementUrl?(0,i.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,i.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=R.isWeb?"":(0,i.localize)(3,null),w=(0,i.localize)(4,null),g=(0,i.localize)(5,null),a=(0,i.localize)(6,null),l=(0,i.localize)(7,null),r=`
|       | ${w} | ${g} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,i.localize)(8,null);return`
${E} ${y} ${m}

&nbsp;

${l}
${r}

&nbsp;

${s}
`}I.Registry.as(S.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,i.localize)(10,null),(0,i.localize)(11,null),(0,i.localize)(12,null),(0,i.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(S.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,i.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,i.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,i.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[206],ne([0,1,9,28,44]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(P,S){const C=await new Promise((b,d)=>{J(["applicationinsights"],b,d)});let I;return C.defaultClient?(I=new C.TelemetryClient(P),I.channel.setUseDiskRetryCaching(!0)):(C.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=C.defaultClient),P.indexOf("AIF-")===0&&(I.config.endpointUrl=S?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class i{constructor(S,C,I,b,d){this._eventPrefix=S,this._defaultData=C,this.testCollector=b,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(C=>{S(C)},C=>{(0,D.onUnexpectedError)(C),console.error(C)})}}log(S,C){!this._aiClient||(C=(0,L.mixin)(C,this._defaultData),C=(0,R.validateTelemetryData)(C),this.testCollector&&(C.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+S,properties:C.properties,measurements:C.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(C=>{C.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=i}),define(te[207],ne([0,1,16,52,21,11,8,22,92,93,94]),function(J,e,D,L,R,T,i,P,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let b=class{constructor(v,h,E,y){this.configurationService=v,this.telemetryService=h,this.loggerService=E,this.environmentService=y,this.customTelemetryServices=new Map}async getCustomTelemetryService(v){if(!this.customTelemetryServices.has(v.id)){const{machineId:h,sessionId:E}=await this.telemetryService.getTelemetryInfo(),y=Object.create(null);y["common.vscodemachineid"]=h,y["common.vscodesessionid"]=E;const m=[v.id,JSON.stringify(y),v.aiKey],g=new L.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=[new S.TelemetryAppenderClient(g),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${v.id}] `)];this.customTelemetryServices.set(v.id,new I.TelemetryService({appenders:a,sendErrorTelemetry:v.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(v.id)}async publicLog(v,h,E){await(await this.getCustomTelemetryService(v)).publicLog(h,E)}async publicLogError(v,h,E){await(await this.getCustomTelemetryService(v)).publicLogError(h,E)}};b=de([G(0,R.IConfigurationService),G(1,P.ITelemetryService),G(2,i.ILoggerService),G(3,T.IEnvironmentService)],b),e.CustomEndpointTelemetryService=b}),define(te[208],ne([0,1,5,27,3,2,8]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(C,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((I,b)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,I),this._onCreateRequest.fire({requestId:d,...C});const v=new L.CancellationTokenSource;(0,D.timeout)(this._timeout,v.token).then(()=>b(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,T.toDisposable)(()=>v.cancel())])})}acceptReply(C,I){const b=this._pendingRequests.get(C);b?(this._pendingRequests.delete(C),(0,T.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),b(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};P=de([G(1,i.ILogService)],P),e.RequestStore=P}),define(te[95],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(y){y.Shell="terminal.integrated.shell.",y.ShellArgs="terminal.integrated.shellArgs.",y.DefaultProfile="terminal.integrated.defaultProfile.",y.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(y){y.ShellLinux="terminal.integrated.shell.linux",y.ShellMacOs="terminal.integrated.shell.osx",y.ShellWindows="terminal.integrated.shell.windows",y.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",y.AutomationShellLinux="terminal.integrated.automationShell.linux",y.AutomationShellMacOs="terminal.integrated.automationShell.osx",y.AutomationShellWindows="terminal.integrated.automationShell.windows",y.AutomationProfileLinux="terminal.integrated.automationProfile.linux",y.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",y.AutomationProfileWindows="terminal.integrated.automationProfile.windows",y.ShellArgsLinux="terminal.integrated.shellArgs.linux",y.ShellArgsMacOs="terminal.integrated.shellArgs.osx",y.ShellArgsWindows="terminal.integrated.shellArgs.windows",y.ProfilesWindows="terminal.integrated.profiles.windows",y.ProfilesMacOs="terminal.integrated.profiles.osx",y.ProfilesLinux="terminal.integrated.profiles.linux",y.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",y.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",y.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",y.UseWslProfiles="terminal.integrated.useWslProfiles",y.TabsEnabled="terminal.integrated.tabs.enabled",y.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",y.TabsHideCondition="terminal.integrated.tabs.hideCondition",y.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",y.TabsShowActions="terminal.integrated.tabs.showActions",y.TabsLocation="terminal.integrated.tabs.location",y.TabsFocusMode="terminal.integrated.tabs.focusMode",y.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",y.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",y.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",y.CopyOnSelection="terminal.integrated.copyOnSelection",y.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",y.FontFamily="terminal.integrated.fontFamily",y.FontSize="terminal.integrated.fontSize",y.LetterSpacing="terminal.integrated.letterSpacing",y.LineHeight="terminal.integrated.lineHeight",y.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",y.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",y.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",y.BellDuration="terminal.integrated.bellDuration",y.FontWeight="terminal.integrated.fontWeight",y.FontWeightBold="terminal.integrated.fontWeightBold",y.CursorBlinking="terminal.integrated.cursorBlinking",y.CursorStyle="terminal.integrated.cursorStyle",y.CursorWidth="terminal.integrated.cursorWidth",y.Scrollback="terminal.integrated.scrollback",y.DetectLocale="terminal.integrated.detectLocale",y.DefaultLocation="terminal.integrated.defaultLocation",y.GpuAcceleration="terminal.integrated.gpuAcceleration",y.TerminalTitleSeparator="terminal.integrated.tabs.separator",y.TerminalTitle="terminal.integrated.tabs.title",y.TerminalDescription="terminal.integrated.tabs.description",y.RightClickBehavior="terminal.integrated.rightClickBehavior",y.Cwd="terminal.integrated.cwd",y.ConfirmOnExit="terminal.integrated.confirmOnExit",y.ConfirmOnKill="terminal.integrated.confirmOnKill",y.EnableBell="terminal.integrated.enableBell",y.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",y.AllowChords="terminal.integrated.allowChords",y.AllowMnemonics="terminal.integrated.allowMnemonics",y.EnvMacOs="terminal.integrated.env.osx",y.EnvLinux="terminal.integrated.env.linux",y.EnvWindows="terminal.integrated.env.windows",y.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",y.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",y.ShowExitAlert="terminal.integrated.showExitAlert",y.SplitCwd="terminal.integrated.splitCwd",y.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",y.WordSeparators="terminal.integrated.wordSeparators",y.EnableFileLinks="terminal.integrated.enableFileLinks",y.UnicodeVersion="terminal.integrated.unicodeVersion",y.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",y.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",y.LocalEchoEnabled="terminal.integrated.localEchoEnabled",y.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",y.LocalEchoStyle="terminal.integrated.localEchoStyle",y.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",y.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",y.CustomGlyphs="terminal.integrated.customGlyphs",y.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",y.InheritEnv="terminal.integrated.inheritEnv",y.ShowLinkHover="terminal.integrated.showLinkHover",y.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(y){y.CommandPrompt="cmd",y.PowerShell="pwsh",y.Wsl="wsl",y.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var i;(function(y){y[y.Api=0]="Api",y[y.Process=1]="Process",y[y.Sequence=2]="Sequence",y[y.Config=3]="Config"})(i=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(y){y.LocalPty="localPty",y.PtyHost="ptyHost",y.Log="log",y.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var S;(function(y){y.Cwd="cwd",y.InitialCwd="initialCwd",y.FixedDimensions="fixedDimensions",y.Title="title",y.ShellType="shellType",y.HasChildProcesses="hasChildProcesses",y.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",y.OverrideDimensions="overrideDimensions"})(S=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(y){y[y.BeatInterval=5e3]="BeatInterval",y[y.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",y[y.SecondWaitMultiplier=1]="SecondWaitMultiplier",y[y.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(y){y[y.Panel=1]="Panel",y[y.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var b;(function(y){y.TerminalView="view",y.Editor="editor"})(b=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(y){y.CwdDetection="cwdDetection"})(d=e.ProcessCapability||(e.ProcessCapability={}));var v;(function(y){y[y.GraceTime=6e4]="GraceTime",y[y.ShortGraceTime=6e3]="ShortGraceTime"})(v=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(y){y[y.HighWatermarkChars=1e5]="HighWatermarkChars",y[y.LowWatermarkChars=5e3]="LowWatermarkChars",y[y.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var E;(function(y){y.GitBash="Git Bash",y.Pwsh="PowerShell"})(E=e.ProfileSource||(e.ProfileSource={}))}),define(te[209],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[210],ne([0,1,33,28,10,4,32,15,20]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let d=0;return b&&b.length===4&&(d=parseInt(b[3])),d}e.getWindowsBuildNumber=C;async function I(b,d,v,h=i.env,E=S.Promises.exists){if(R.isAbsolute(b))return await E(b)?b:void 0;if(d===void 0&&(d=i.cwd()),R.dirname(b)!=="."){const g=R.join(d,b);return await E(g)?g:void 0}const m=(0,L.getCaseInsensitive)(h,"PATH");if(v===void 0&&(0,P.isString)(m)&&(v=m.split(R.delimiter)),v===void 0||v.length===0){const g=R.join(d,b);return await E(g)?g:void 0}for(let g of v){let a;if(R.isAbsolute(g)?a=R.join(g,b):a=R.join(d,g,b),await E(a))return a;if(T.isWindows){let l=a+".com";if(await E(l)||(l=a+".exe",await E(l)))return l}}const w=R.join(d,b);return await E(w)?w:void 0}e.findExecutable=I}),define(te[211],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[96],ne([0,1,49,3,2,6,35,211]),function(J,e,D,L,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(y){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}y.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function C(y){return{id:y}}e.themeColorFromId=C;var I;(function(y){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||S.isThemeColor(n.color))}y.isThemeIcon=m;const w=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function g(n){const t=w.exec(n);if(!t)return;let[,o]=t;return{id:o}}y.fromString=g;function a(n,t){let o=n.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),t&&(o=`${o}~${t}`),{id:o}}y.modify=a;function l(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}y.getModifier=l;function r(n,t){return n.id===t.id&&n.color?.id===t.color?.id}y.isEqual=r;function s(n,t){return{id:n.id,color:t?C(t):void 0}}y.asThemeIcon=s,y.asClassNameArray=D.CSSIcon.asClassNameArray,y.asClassName=D.CSSIcon.asClassName,y.asCSSSelector=D.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function b(y){switch(y){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,R.toDisposable)(()=>{const w=this.themingParticipants.indexOf(m);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new d;i.Registry.add(e.Extensions.ThemingContribution,v);function h(y){return v.onColorThemeChange(y)}e.registerThemingParticipant=h;class E extends R.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,w){let g=this.theme.getColor(m);return g&&w&&(g=w(g,this.theme)),g?g.toString():null}}e.Themable=E}),define(te[212],ne([0,1,49,7,96]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(b,d){const v=b.map(h=>({name:h.profileName,description:i(h)}));return d&&v.push(...d.map(h=>({name:h.title,description:P(h)}))),{values:v.map(h=>h.name),markdownDescriptions:v.map(h=>h.description)}}e.createProfileSchemaEnums=T;function i(b){let d=`$(${R.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:D.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?d+=`
- args: "${b.args}"`:d+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(d+=`
- overrideName: ${b.overrideName}`),b.color&&(d+=`
- color: ${b.color}`),b.env&&(d+=`
- env: ${JSON.stringify(b.env)}`),d}function P(b){return`$(${R.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:D.Codicon.terminal.id}) ${b.title}
- extensionIdenfifier: ${b.extensionIdentifier}`}function S(b,d){if(!b&&!d)return!0;if(typeof b=="string"&&typeof d=="string")return b===d;if(Array.isArray(b)&&Array.isArray(d)){if(b.length!==d.length)return!1;for(let v=0;v<b.length;v++)if(b[v]!==d[v])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function C(b,d){if(!b&&!d)return!0;if(!b||!d)return!1;if(R.ThemeIcon.isThemeIcon(b)&&R.ThemeIcon.isThemeIcon(d))return b.id===d.id&&b.color===d.color;if(typeof b=="object"&&b&&"light"in b&&"dark"in b&&typeof d=="object"&&d&&"light"in d&&"dark"in d){const v=b,h=d;if((L.URI.isUri(v.light)||I(v.light))&&(L.URI.isUri(v.dark)||I(v.dark))&&(L.URI.isUri(h.light)||I(h.light))&&(L.URI.isUri(h.dark)||I(h.dark)))return v.light.path===h.light.path&&v.dark.path===h.dark.path}if(L.URI.isUri(b)&&L.URI.isUri(d)||I(b)||I(d)){const v=b,h=d;return v.path===h.path&&v.scheme===h.scheme}return!1}e.terminalIconsEqual=C;function I(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.isUriComponents=I}),define(te[213],ne([0,1,49,143,39,35,212]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,g=>g.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,g=>`$(${g.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},C=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),b=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,L.localize)(9,null,"`#terminal.integrated.automationProfile.linux#`"),v=(0,L.localize)(10,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,L.localize)(11,null,"`#terminal.integrated.automationProfile.windows#`"),E={id:"terminal",order:100,title:(0,L.localize)(12,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,L.localize)(17,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,L.localize)(18,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(19,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(22,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(23,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(24,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(25,null)}},{type:"string",markdownDescription:(0,L.localize)(26,null)}],default:[],markdownDeprecationMessage:b},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(27,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(28,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(29,null),type:"string"},id:{description:(0,L.localize)(30,null),type:"string"},title:{description:(0,L.localize)(31,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(32,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(33,null),type:"string"},id:{description:(0,L.localize)(34,null),type:"string"},title:{description:(0,L.localize)(35,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(36,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(37,null),type:"string"},id:{description:(0,L.localize)(38,null),type:"string"},title:{description:(0,L.localize)(39,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(42,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(43,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,L.localize)(44,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function y(){T.Registry.as(R.Extensions.Configuration).registerConfiguration(E),w()}e.registerTerminalPlatformConfiguration=y;let m;function w(g,a){const l=T.Registry.as(R.Extensions.Configuration);let r;g&&(r=(0,i.createProfileSchemaEnums)(g?.profiles,a));const s=m;m={id:"terminal",order:100,title:(0,L.localize)(45,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(46,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:g?.os===3?r?.values:void 0,markdownEnumDescriptions:g?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(47,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:g?.os===2?r?.values:void 0,markdownEnumDescriptions:g?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(48,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:g?.os===1?r?.values:void 0,markdownEnumDescriptions:g?.os===1?r?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[m],remove:s?[s]:[]})}e.registerTerminalDefaultProfileConfiguration=w}),define(te[214],ne([0,1,45,49,10,4,20,70,210,96]),function(J,e,D,L,R,T,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,b=!0;function d(s,n,t,o,c=process.env,u,f,p,k){return u=u||{existsFile:i.SymlinkSupport.existsFile,readFile:i.Promises.readFile},T.isWindows?v(t,u,c,f,o.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:o.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:o.getValue("terminal.integrated.defaultProfile.windows"),k,p):a(u,f,t,s&&typeof s=="object"?{...s}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),k,p,c)}e.detectAvailableProfiles=d;async function v(s,n,t,o,c,u,f,p,k){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),F=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let W=!1;(0,S.getWindowsBuildNumber)()>=16299&&(W=!0),await y(p);const $=new Map;s&&($.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${F}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${F}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),l(u,$);const A=await h($.entries(),f,n,t,o,k);if(s||!s&&c)try{const q=await w(`${F}\\${W?"wsl":"bash"}.exe`,f);for(const _ of q)(!u||!(_.profileName in u))&&A.push(_)}catch(q){b&&(o?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return A}async function h(s,n,t,o=process.env,c,u){const f=[];for(const[p,k]of s){if(k===null)continue;let O,F,W;if("source"in k){const q=I?.get(k.source);if(!q)continue;O=q.paths,F=k.args||q.args,k.icon?W=E(k.icon):q.icon&&(W=q.icon)}else O=Array.isArray(k.path)?k.path:[k.path],F=T.isWindows||Array.isArray(k.args)?k.args:void 0,W=E(k.icon)||void 0;const $=await u?.(O)||O.slice(),A=await r(p,n,$,t,o,F,k.env,k.overrideName,k.isAutoDetected,c);A?(A.isAutoDetected=k.isAutoDetected,A.icon=W,A.color=k.color,f.push(A)):c?.trace("profile not validated",p,O)}return f}function E(s){return typeof s=="string"?{id:s}:s}async function y(s){I&&!s||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:s||await m(),icon:C.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function m(){const s=[];for await(const n of(0,P.enumeratePowerShellInstallations)())s.push(n.exePath);return s}async function w(s,n){const t=[],o=await new Promise((f,p)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(k,O)=>{if(k)return p("Problem occurred when getting wsl distros");f(O)})});if(!o)return[];const c=new RegExp(/[\r?\n]/),u=o.split(c).filter(f=>f.trim().length>0&&f!=="");for(const f of u){if(f===""||f.startsWith("docker-desktop"))continue;const p=`${f} (WSL)`,k={profileName:p,path:s,args:["-d",`${f}`],isDefault:p===n,icon:g(f)};t.push(k)}return t}function g(s){return s.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):s.includes("Debian")?C.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function a(s,n,t,o,c,u,f,p){const k=new Map;if(t){const O=(await s.readFile("/etc/shells")).toString(),F=u||O.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),W=new Map;for(const $ of F){let A=(0,R.basename)($),q=W.get(A)||0;q++,q>1&&(A=`${A} (${q})`),W.set(A,q),k.set(A,{path:$,isAutoDetected:!0})}}return l(o,k),await h(k.entries(),c,s,p,n,f)}function l(s,n){if(!!s)for(const[t,o]of Object.entries(s))o===null||!("path"in o)&&!("source"in o)?n.delete(t):n.set(t,o)}async function r(s,n,t,o,c,u,f,p,k,O){if(t.length===0)return Promise.resolve(void 0);const F=t.shift();if(F==="")return r(s,n,t,o,c,u,f,p,k);const W={profileName:s,path:F,args:u,env:f,overrideName:p,isAutoDetected:k,isDefault:s===n};if((0,R.basename)(F)===F){const A=c.PATH?c.PATH.split(R.delimiter):void 0;return await(0,S.findExecutable)(F,void 0,A,void 0,o.existsFile)?W:r(s,n,t,o,c,u)}return await o.existsFile((0,R.normalize)(F))?W:r(s,n,t,o,c,u,f,p,k)}}),define(te[215],ne([0,1,3,2,16,4,34,52,21,11,75,165,8,85,22,208,95,213,214]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let a=0,l=class extends L.Disposable{constructor(s,n,t,o,c){super();this._reconnectConstants=s,this._configurationService=n,this._environmentService=t,this._logService=o,this._telemetryService=c,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new E.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,b.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:a,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?s.debugBrk=n.port:!n.break&&n.port&&(s.debug=n.port));const t=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s);this._onPtyHostStart.fire(),i.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(f=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(f.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}, giving up`))}));const c=t.getChannel(y.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const u=i.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(f=>this._onProcessData.fire(f))),this._register(u.onProcessReady(f=>this._onProcessReady.fire(f))),this._register(u.onProcessExit(f=>this._onProcessExit.fire(f))),this._register(u.onDidChangeProperty(f=>this._onDidChangeProperty.fire(f))),this._register(u.onProcessReplay(f=>this._onProcessReplay.fire(f))),this._register(u.onProcessOrphanQuestion(f=>this._onProcessOrphanQuestion.fire(f))),this._register(u.onDidRequestDetach(f=>this._onDidRequestDetach.fire(f))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,n,t,o,c,u,f,p,k,O,F){const W=setTimeout(()=>this._handleUnresponsiveCreateProcess(),y.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(s,n,t,o,c,u,f,p,k,O,F);return clearTimeout(W),a=Math.max(a,$),$}updateTitle(s,n,t){return this._proxy.updateTitle(s,n,t)}updateIcon(s,n,t){return this._proxy.updateIcon(s,n,t)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,n){return this._proxy.shutdown(s,n)}input(s,n){return this._proxy.input(s,n)}processBinary(s,n){return this._proxy.processBinary(s,n)}resize(s,n,t){return this._proxy.resize(s,n,t)}acknowledgeDataEvent(s,n){return this._proxy.acknowledgeDataEvent(s,n)}setUnicodeVersion(s,n){return this._proxy.setUnicodeVersion(s,n)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,n,t,o=!1){const c=await this._shellEnv;return(0,w.detectAvailableProfiles)(n,t,o,this._configurationService,c,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,n){return this._proxy.requestDetachInstance(s,n)}async acceptDetachInstanceReply(s,n){return this._proxy.acceptDetachInstanceReply(s,n)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,n){return this._proxy.refreshProperty(s,n)}async updateProperty(s,n,t){return this._proxy.updateProperty(s,n,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:n})}async acceptPtyHostResolvedVariables(s,n){this._resolveVariablesRequestStore.acceptReply(s,n)}};l=de([G(1,S.IConfigurationService),G(2,C.IEnvironmentService),G(3,d.ILogService),G(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(te[37],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(te[216],ne([0,1,3,2,7,11,36,14,8,37]),function(J,e,D,L,R,T,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends L.Disposable{constructor(d,v,h,E,y){super();this.extensionsManagementService=d,this.logService=E,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(w=>this.onInstallExtension(w))),this._register(d.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(d.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const m=R.URI.file(h.extensionsPath);this._register(v.watch(m)),this._register(D.Event.filter(v.onDidChangeFilesRaw,w=>w.changes.some(g=>this.doesChangeAffects(g,m)))(()=>this.onDidChange()))}doesChangeAffects(d,v){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),v)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const v of d)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(v=>!(0,i.areSameExtensions)(v,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,i.areSameExtensions)(v,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),v=d.filter(E=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,i.areSameExtensions)(y,E.identifier))?!1:E.installedTimestamp&&E.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",E.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",E.identifier.id),!1)),h=this.installedExtensions.filter(E=>this.installingExtensions.some(y=>(0,i.areSameExtensions)(y,E))?!1:d.every(y=>!(0,i.areSameExtensions)(y.identifier,E))?(this.logService.info("Detected extension removed from another source",E.id),!0):!1);this.installedExtensions=d.map(E=>E.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};I=de([G(1,P.IFileService),G(2,T.INativeEnvironmentService),G(3,S.ILogService),G(4,C.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(te[217],ne([0,1,37,77,14,18,103,3,2]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(d){this.uri=d,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let I=class{constructor(d){this._fileService=d,this._dispooables=new S.DisposableStore,this._limit=2**16;const v=new Map,h=E=>{let y=v.get(E.scheme);return y===void 0&&(y=d.hasProvider(E)&&!this._fileService.hasCapability(E,1024),v.set(E.scheme,y)),y};this._dispooables.add(P.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(E=>{v.delete(E.scheme)})),this.extUri=new T.ExtUri(h),this._canonicalUris=new i.SkipList((E,y)=>this.extUri.compare(E,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,T.normalizePath)(d));let v=this._canonicalUris.get(d);return v?v.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new C(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((h,E)=>h[1].touch<E[1].touch?1:h[1].touch>E[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(d[h][0],d[h][1].touch())}};I=de([G(0,R.IFileService)],I),e.UriIdentityService=I,(0,L.registerSingleton)(D.IUriIdentityService,I,!0)}),define(te[55],ne([0,1,40]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(i,P,S,C){const I=(0,D.setProperty)(i,P,S,C)[0];return I&&(i=i.substring(0,I.offset)+I.content+i.substring(I.offset+I.length)),i}e.edit=L;function R(i,P,S){let C=S;for(;C>=0;){if(i.charAt(C)===P.charAt(P.length-1)&&P.length===1)return C+1;if(C--,P.length===2&&C>=0&&i.charAt(C)===P.charAt(0))return C+2}return 0}e.getLineStartOffset=R;function T(i,P,S){let C=S;for(;C>=0;)if(i.charAt(C)===P.charAt(P.length-1)&&P.length===1||(C++,P.length===2&&C>=0&&i.charAt(C)===P.charAt(1)))return C;return i.length-1}e.getLineEndOffset=T}),define(te[218],ne([0,1,28,61]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(b,d,v,h,E){const y=[],m=[],w=[];if(!d){const O=b.filter(({identifier:F})=>E.every(W=>W.toLowerCase()!==F.id.toLowerCase()));return{local:{added:y,removed:m,updated:w},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}b=b.map(C),d=d.map(C),v=v?v.map(C):null;const g=new Map,a=O=>{O.uuid&&g.set(O.id.toLowerCase(),O.uuid)};b.forEach(({identifier:O})=>a(O)),d.forEach(({identifier:O})=>a(O)),v&&v.forEach(({identifier:O})=>a(O));const l=O=>{const F=O.identifier.uuid||g.get(O.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${O.identifier.id.toLowerCase()}`},r=(O,F)=>(O.set(l(F),F),O),s=b.reduce(r,new Map),n=d.reduce(r,new Map),t=d.reduce((O,F)=>{const W=l(F);F=(0,D.deepClone)(F);const $=s.get(W);return $&&($.installed&&(F.installed=!0),F.version||(F.version=$.version)),r(O,F)},new Map),o=v?v.reduce(r,new Map):null,c=h.reduce(r,new Map),u=E.reduce((O,F)=>{const W=g.get(F.toLowerCase());return O.add(W?`uuid:${W}`:`id:${F.toLowerCase()}`)},new Set),f=T(s,n,u);if(f.added.size>0||f.removed.size>0||f.updated.size>0){const O=T(o,s,u),F=T(o,n,u),W=($,A)=>{const q=s.get($);if(q){const _=n.get($);return{...A?_:q,version:(_.version&&L.gt(_.version,q.version),q.version),state:i(q,_,o?.get($))}}};for(const $ of F.removed.values()){const A=s.get($);A&&m.push(A.identifier)}for(const $ of F.added.values())if(O.added.has($)){if(f.updated.has($)){const A=W($,!0);A&&(w.push(I(A,$)),t.set($,A))}}else{const A=n.get($);A.installed&&y.push(I(A,$))}for(const $ of F.updated.values()){const A=W($,!0);A&&(w.push(I(A,$)),t.set($,A))}for(const $ of O.added.values())F.added.has($)||t.set($,s.get($));for(const $ of O.updated.values())if(!F.removed.has($)&&!F.updated.has($)){const A=W($,!1);A&&(t.get($)?.installed&&(A.installed=!0),t.set($,A))}for(const $ of O.removed.values())!c.has($)&&!F.updated.has($)&&o?.get($)?.installed&&t.delete($)}const p=[],k=T(n,t,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(k.added.size>0||k.updated.size>0||k.removed.size>0)&&t.forEach((O,F)=>p.push(I(O,F))),{local:{added:y,removed:m,updated:w},remote:p.length?{added:[...k.added].map(O=>t.get(O)),updated:[...k.updated].map(O=>t.get(O)),removed:[...k.removed].map(O=>n.get(O)),all:p}:null}}e.merge=R;function T(b,d,v,{checkInstalledProperty:h,checkVersionProperty:E}={checkInstalledProperty:!1,checkVersionProperty:!1}){const y=b?[...b.keys()].filter(l=>!v.has(l)):[],m=[...d.keys()].filter(l=>!v.has(l)),w=m.filter(l=>y.indexOf(l)===-1).reduce((l,r)=>(l.add(r),l),new Set),g=y.filter(l=>m.indexOf(l)===-1).reduce((l,r)=>(l.add(r),l),new Set),a=new Set;for(const l of y){if(g.has(l))continue;const r=b.get(l),s=d.get(l);(!s||r.disabled!==s.disabled||!S(r.state,s.state)||E&&r.version!==s.version||h&&r.installed!==s.installed)&&a.add(l)}return{added:w,removed:g,updated:a}}function i(b,d,v){const h=b.state,E=d.state,y=v?.state;if(!d.version||h&&L.gt(b.version,d.version))return h;if(E&&L.gt(d.version,b.version)||!h)return E;if(!E)return h;const m=(0,D.deepClone)(h),w=y?P(y,E):{added:Object.keys(E).reduce((a,l)=>(a.add(l),a),new Set),removed:new Set,updated:new Set},g=y?P(y,h):{added:Object.keys(h).reduce((a,l)=>(a.add(l),a),new Set),removed:new Set,updated:new Set};for(const a of[...w.added.values(),...w.updated.values()])m[a]=E[a];for(const a of w.removed.values())g.updated.has(a)||delete m[a];return m}function P(b,d){const v=Object.keys(b),h=Object.keys(d),E=h.filter(w=>v.indexOf(w)===-1).reduce((w,g)=>(w.add(g),w),new Set),y=v.filter(w=>h.indexOf(w)===-1).reduce((w,g)=>(w.add(g),w),new Set),m=new Set;for(const w of v){if(y.has(w))continue;const g=b[w],a=d[w];(0,D.equals)(g,a)||m.add(w)}return{added:E,removed:y,updated:m}}function S(b={},d={}){const{added:v,removed:h,updated:E}=P(b,d);return v.size===0&&h.size===0&&E.size===0}function C(b){return{...b,disabled:!!b.disabled,installed:!!b.installed}}function I(b,d){const v={identifier:{id:b.identifier.id,uuid:d.startsWith("uuid:")?d.substring("uuid:".length):void 0}};return b.version&&(v.version=b.version),b.disabled&&(v.disabled=!0),b.installed&&(v.installed=!0),b.state&&(v.state=b.state),v}}),define(te[97],ne([0,1,17,3,2,36,6,26,23]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,i.createDecorator)("IExtensionsStorageSyncService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let I=class it extends R.Disposable{constructor(d,v){super();this.storageService=d,this.productService=v,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const v=C.exec(d);if(v&&v[1])return{id:v[1],version:v[2]}}initialize(){const d=this.storageService.keys(0,1);for(const v of d){const h=it.fromKey(v);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const v=it.fromKey(d.key);if(v){this.extensionsWithKeysForSync.add(v.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,v){this.storageService.store(it.toKey(d),JSON.stringify(v),0,1)}getKeysForSync(d){const v=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(it.toKey(d),0),E=h?JSON.parse(h):void 0;return E&&v?(0,D.distinct)([...E,...v]):E||v}};I=de([G(0,S.IStorageService),G(1,P.IProductService)],I),e.ExtensionsStorageSyncService=I}),define(te[98],ne([0,1,17,21,6]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,S){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return C=C.filter(I=>I!==P&&I!==`-${P}`),S&&C.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}updateSynchronizedExtensions(P,S){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return C=C.filter(I=>I!==P&&I!==`-${P}`),S&&C.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}getIgnoredExtensions(P){const S=P.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),I=[],b=[];if(Array.isArray(C))for(const d of C)d.startsWith("-")?b.push(d.substring(1)):I.push(d);return(0,D.distinct)([...S,...I].filter(d=>b.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};T=de([G(0,L.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[219],ne([0,1,17,31,28,160,55]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(a){return(0,L.parse)(a)||[]}e.parseKeybindings=P;async function S(a,l,r,s,n){const t=P(a),o=P(l),c=r?P(r):null,u=[...t,...o,...c||[]].map(M=>M.key),f=await n.resolveUserBindings(u);let p=I(t,o,c,f);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:a,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};const k=d(t),O=d(o),F=c?d(c):null,W=h(k,O,f),$=F?h(F,k,f):{added:[...k.keys()].reduce((M,B)=>(M.add(B),M),new Set),removed:new Set,updated:new Set},A=F?h(F,O,f):{added:[...O.keys()].reduce((M,B)=>(M.add(B),M),new Set),removed:new Set,updated:new Set},q=C(W,$,A);let _=a;for(const M of q.removed.values())q.conflicts.has(M)||(_=w(_,M,s));for(const M of q.added.values()){if(q.conflicts.has(M))continue;const B=O.get(M);if(B.some(Z=>Z.command!==`-${M}`&&p.conflicts.has(f[Z.key]))){q.conflicts.add(M);continue}_=m(_,B,s)}for(const M of q.updated.values()){if(q.conflicts.has(M))continue;const B=O.get(M);if(B.some(Z=>Z.command!==`-${M}`&&p.conflicts.has(f[Z.key]))){q.conflicts.add(M);continue}_=g(_,M,B,s)}return{mergeContent:_,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.merge=S;function C(a,l,r){const s=new Set,n=new Set,t=new Set,o=new Set;for(const c of l.removed.values())r.updated.has(c)&&o.add(c);for(const c of r.removed.values())o.has(c)||(l.updated.has(c)?o.add(c):n.add(c));for(const c of l.added.values())o.has(c)||r.added.has(c)&&a.updated.has(c)&&o.add(c);for(const c of r.added.values())o.has(c)||(l.added.has(c)?a.updated.has(c)&&o.add(c):s.add(c));for(const c of l.updated.values())o.has(c)||r.updated.has(c)&&a.updated.has(c)&&o.add(c);for(const c of r.updated.values())o.has(c)||(l.updated.has(c)?a.updated.has(c)&&o.add(c):t.add(c));return{added:s,removed:n,updated:t,conflicts:o}}function I(a,l,r,s){const n=new Set,t=b(a,s),o=b(l,s),c=r?b(r,s):null,u=v(t,o);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const f=c?v(c,t):{added:[...t.keys()].reduce(($,A)=>($.add(A),$),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const p=c?v(c,o):{added:[...o.keys()].reduce(($,A)=>($.add(A),$),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:k,removed:O,updated:F,conflicts:W}=C(u,f,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:k,removed:O,updated:F,conflicts:W}}function b(a,l){const r=new Map;for(const s of a){const n=l[s.key];let t=r.get(n);t||(t=[],r.set(n,t)),t.push(s)}return r}function d(a){const l=new Map;for(const r of a){const s=r.command[0]==="-"?r.command.substring(1):r.command;let n=l.get(s);n||(n=[],l.set(s,n)),n.push(r)}return l}function v(a,l){const r=[...a.keys()],s=[...l.keys()],n=s.filter(c=>r.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),t=r.filter(c=>s.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),o=new Set;for(const c of r){if(t.has(c))continue;const u=a.get(c).map(p=>({...p,key:c})),f=l.get(c).map(p=>({...p,key:c}));(0,D.equals)(u,f,(p,k)=>y(p,k))||o.add(c)}return{added:n,removed:t,updated:o}}function h(a,l,r){const s=[...a.keys()],n=[...l.keys()],t=n.filter(u=>s.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),o=s.filter(u=>n.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),c=new Set;for(const u of s){if(o.has(u))continue;const f=a.get(u).map(k=>({...k,key:r[k.key]})),p=l.get(u).map(k=>({...k,key:r[k.key]}));E(f,p)||c.add(u)}return{added:t,removed:o,updated:c}}function E(a,l){return!(!(0,D.equals)(a.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,s)=>y(r,s))||!(0,D.equals)(a.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,s)=>y(r,s)))}function y(a,l){if(a.command!==l.command||a.key!==l.key)return!1;const r=T.ContextKeyExpr.deserialize(a.when),s=T.ContextKeyExpr.deserialize(l.when);return!(r&&!s||!r&&s||r&&s&&!r.equals(s)||!R.equals(a.args,l.args))}function m(a,l,r){for(const s of l)a=i.edit(a,[-1],s,r);return a}function w(a,l,r){const s=P(a);for(let n=s.length-1;n>=0;n--)(s[n].command===l||s[n].command===`-${l}`)&&(a=i.edit(a,[n],void 0,r));return a}function g(a,l,r,s){const n=P(a),t=n.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=n.length-1;o>=0;o--)(n[o].command===l||n[o].command===`-${l}`)&&(a=i.edit(a,[o],void 0,s));for(let o=r.length-1;o>=0;o--)a=i.edit(a,[t],r[o],s);return a}}),define(te[220],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,i,P){const S={},C={},I=new Set;if(!i)return{local:{added:S,updated:C,removed:[...I.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const b=L(T,i);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:S,updated:C,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=L(P,T),v=L(P,i),h={},E={},y=new Set,m=new Set;for(const w of d.removed.values())v.updated.has(w)?S[w]=i[w]:y.add(w);for(const w of v.removed.values())m.has(w)||(d.updated.has(w)?m.add(w):I.add(w));for(const w of d.updated.values())m.has(w)||(v.updated.has(w)?b.updated.has(w)&&m.add(w):E[w]=T[w]);for(const w of v.updated.values())m.has(w)||(d.updated.has(w)?b.updated.has(w)&&m.add(w):T[w]!==void 0&&(C[w]=i[w]));for(const w of d.added.values())m.has(w)||(v.added.has(w)?b.updated.has(w)&&m.add(w):h[w]=T[w]);for(const w of v.added.values())m.has(w)||(d.added.has(w)?b.updated.has(w)&&m.add(w):S[w]=i[w]);return{local:{added:S,removed:[...I.values()],updated:C},remote:{added:h,removed:[...y.values()],updated:E},conflicts:[...m.values()]}}e.merge=D;function L(T,i){const P=T?Object.keys(T):[],S=i?Object.keys(i):[],C=S.filter(d=>P.indexOf(d)===-1).reduce((d,v)=>(d.add(v),d),new Set),I=P.filter(d=>S.indexOf(d)===-1).reduce((d,v)=>(d.add(v),d),new Set),b=new Set;for(const d of P){if(I.has(d))continue;const v=T[d],h=i[d];v!==h&&b.add(d)}return{added:C,removed:I,updated:b}}function R(T,i){const{added:P,removed:S,updated:C}=L(T,i);return P.size===0&&S.size===0&&C.size===0}e.areSame=R}),define(te[24],ne([0,1,17,18,15,148,39,30,6,87,35]),function(J,e,D,L,R,T,i,P,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function b(){const c=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(u=>!!c[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=b;function d(){const c=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(c).filter(k=>!!c[k].ignoreSync),f=Object.keys(c).filter(k=>c[k].scope===2||c[k].scope===6),p=b();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...f,...p])}e.getDefaultIgnoredSettings=d,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function v(){const c="vscode://schemas/ignoredSettings",u=I.Registry.as(i.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const f=I.Registry.as(C.Extensions.JSONContribution),p=()=>{const k=b(),O=d().filter(A=>A!==e.CONFIGURATION_SYNC_STORE_KEY),F=Object.keys(i.allSettings.properties).filter(A=>O.indexOf(A)===-1),W=O.filter(A=>k.indexOf(A)===-1),$={items:{type:"string",enum:[...F,...W.map(A=>`-${A}`)]}};f.registerSchema(c,$)};return u.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=v;function h(c){return c&&(0,R.isObject)(c)&&(0,R.isString)(c.id)&&(0,R.isArray)(c.scopes)}e.isAuthenticationProvider=h;var E;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(E=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function y(c,u,f){return f.joinPath(u.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(c){const u={};return u[e.HEADER_EXECUTION_ID]=c,u}e.createSyncHeaders=m;var w;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(u,f,p,k){super(u);this.code=f,this.resource=p,this.operationId=k,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class a extends g{constructor(u,f,p,k,O){super(u,p,void 0,O);this.url=f,this.serverCode=k}}e.UserDataSyncStoreError=a;class l extends g{constructor(u,f){super(u,f)}}e.UserDataAutoSyncError=l,function(c){function u(f){if(f instanceof c)return f;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(f.name);if(p&&p[1]){const k=p[2]==="unknown"?void 0:p[2],O=p[3]==="unknown"?void 0:p[3];return new c(f.message,p[1],k,O)}return new c(f.message,"Unknown")}c.toUserDataSyncError=u}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var s;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var n;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(c){return`sync.enable.${c}`}e.getEnablementKey=t,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(c,u){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(f=>(0,L.isEqualOrParent)(c,(0,L.joinPath)(u.userDataSyncHome,f,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(te[47],ne([0,1,17,5,19,27,3,31,2,25,15,7,144,21,11,14,8,46,23,22,37,24]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=r;let s=class extends S.Disposable{constructor(u,f,p,k,O,F,W,$,A,q,_){super();this.resource=u,this.fileService=f,this.environmentService=p,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=F,this.userDataSyncResourceEnablementService=W,this.telemetryService=$,this.logService=A,this.configurationService=q,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new i.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=_.extUri,this.syncFolder=this.extUri.joinPath(p.userDataSyncHome,u),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(u,p,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(p,f,k)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const u=await this.syncPreviewPromise;this.syncPreviewPromise=null;const f=await this.performSync(u.remoteUserData,u.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(f)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const u=await this.getLastSyncUserData();(u?(await this.doGenerateSyncResourcePreview(u,u,!0,this.getUserDataSyncConfiguration(),T.CancellationToken.None)).resourcePreviews.some(({remoteChange:p})=>p!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(u){if(this._status!==u){const f=this._status;u==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),f==="hasConflicts"&&u==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=u,this._onDidChangStatus.fire(u)}}async sync(u,f={}){await this._sync(u,!0,this.getUserDataSyncConfiguration(),f)}async preview(u,f,p={}){return this._sync(u,!1,f,p)}async apply(u,f={}){try{this.syncHeaders={...f};const p=await this.doApply(u);return this.setStatus(p),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(u,f,p,k){try{if(this.syncHeaders={...k},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const F=await this.getLastSyncUserData(),W=await this.getLatestRemoteUserData(u,F);return O=await this.performSync(W,F,f,p),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(u){const f=await this.resolveContent(u);if(!f)return!1;const p=this.parseSyncData(f);if(!p)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const k=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,k),F=await this.isRemoteDataFromCurrentMachine(O),W=await this.generateSyncPreview({ref:O.ref,syncData:p},k,F,this.getUserDataSyncConfiguration(),T.CancellationToken.None),$=[];for(const A of W){const q=await this.getAcceptResult(A,A.remoteResource,void 0,T.CancellationToken.None),{remoteChange:_}=await this.getAcceptResult(A,A.previewResource,A.remoteContent,T.CancellationToken.None);$.push([A,{...q,remoteChange:_!==0?_:2}])}await this.applyResult(O,k,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(u){const f=await this.currentMachineIdPromise;return!!u.syncData?.machineId&&u.syncData.machineId===f}async getLatestRemoteUserData(u,f){if(f){const p=u&&u.latest?u.latest[this.resource]:void 0;if(f.ref===p||p===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async performSync(u,f,p,k){if(u.syncData&&u.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,u.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(u,f,p,k)}catch(O){if(O instanceof l.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(u,f,p,k);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),u=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.performSync(u,f,p,k)}throw O}}async doSync(u,f,p,k){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(F=>this.doGenerateSyncResourcePreview(u,f,p,k,F)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:F})=>F==="conflict")?"hasConflicts":p?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(u){return await this.updateSyncResourcePreview(u,async f=>{const p=await this.getMergeResult(f,T.CancellationToken.None);await this.fileService.writeFile(f.previewResource,R.VSBuffer.fromString(p?.content||""));const k=p&&!p.hasConflicts?await this.getAcceptResult(f,f.previewResource,void 0,T.CancellationToken.None):void 0;return f.acceptResult=k,f.mergeState=p.hasConflicts?"conflict":k?"accepted":"preview",f.localChange=k?k.localChange:p.localChange,f.remoteChange=k?k.remoteChange:p.remoteChange,f}),this.syncPreviewPromise}async accept(u,f){return await this.updateSyncResourcePreview(u,async p=>{const k=await this.getAcceptResult(p,u,f,T.CancellationToken.None);return p.acceptResult=k,p.mergeState="accepted",p.localChange=k.localChange,p.remoteChange=k.remoteChange,p}),this.syncPreviewPromise}async discard(u){return await this.updateSyncResourcePreview(u,async f=>{const p=await this.getMergeResult(f,T.CancellationToken.None);return await this.fileService.writeFile(f.previewResource,R.VSBuffer.fromString(p.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=p.localChange,f.remoteChange=p.remoteChange,f}),this.syncPreviewPromise}async updateSyncResourcePreview(u,f){if(!this.syncPreviewPromise)return;let p=await this.syncPreviewPromise;const k=p.resourcePreviews.findIndex(({localResource:O,remoteResource:F,previewResource:W})=>this.extUri.isEqual(O,u)||this.extUri.isEqual(F,u)||this.extUri.isEqual(W,u));k!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async O=>{const F=[...p.resourcePreviews];return F[k]=await f(F[k]),{...p,resourcePreviews:F}}),p=await this.syncPreviewPromise,this.updateConflicts(p.resourcePreviews),p.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(u){if(!this.syncPreviewPromise)return"idle";const f=await this.syncPreviewPromise;return f.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.applyResult(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(p=>[p,p.acceptResult]),u),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(u){}}updateConflicts(u){const f=u.filter(({mergeState:p})=>p==="conflict");(0,D.equals)(this._conflicts,f,(p,k)=>this.extUri.isEqual(p.previewResource,k.previewResource))||(this._conflicts=f,this._onDidChangeConflicts.fire(f))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:f,ref:p})=>({created:f,uri:this.toRemoteBackupResource(p)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:f,ref:p})=>({created:f,uri:this.toLocalBackupResource(p)}))}toRemoteBackupResource(u){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${u}`})}toLocalBackupResource(u){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${u}`})}async getMachineId({uri:u}){const f=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(f))){const{content:p}=await this.getUserData(f);if(p)return this.parseSyncData(p)?.machineId}}async resolveContent(u){const f=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(f))){const{content:p}=await this.getUserData(f);return p}return this.extUri.isEqual(u,this.toLocalBackupResource(f))?this.userDataSyncBackupStoreService.resolveContent(this.resource,f):null}async resolvePreviewContent(u){const f=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(f)for(const p of f.resourcePreviews){if(this.extUri.isEqual(p.acceptedResource,u))return p.acceptResult?p.acceptResult.content:null;if(this.extUri.isEqual(p.remoteResource,u))return p.remoteContent;if(this.extUri.isEqual(p.localResource,u))return p.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(u){}}async doGenerateSyncResourcePreview(u,f,p,k,O){const F=await this.isRemoteDataFromCurrentMachine(u),W=await this.generateSyncPreview(u,f,F,k,O),$=[];for(const A of W){const q=A.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(A.localChange===0&&A.remoteChange===0)$.push({...A,acceptedResource:q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const _=p?await this.getMergeResult(A,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(A.previewResource,R.VSBuffer.fromString(_?.content||""));const M=_&&!_.hasConflicts?await this.getAcceptResult(A,A.previewResource,void 0,O):void 0;$.push({...A,acceptResult:M,mergeState:_?.hasConflicts?"conflict":M?"accepted":"preview",localChange:M?M.localChange:_?_.localChange:A.localChange,remoteChange:M?M.remoteChange:_?_.remoteChange:A.remoteChange})}}return{remoteUserData:u,lastSyncUserData:f,resourcePreviews:$,isLastSyncFromCurrentMachine:F}}async getLastSyncUserData(){try{const u=await this.fileService.readFile(this.lastSyncResource),f=JSON.parse(u.value.toString()),p=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=f.version&&p&&f.version!==p,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;const k=f;if(k.content===null)return{ref:f.ref,syncData:null};const O=JSON.parse(k.content);if(r(O))return{...f,syncData:O,content:void 0}}catch(u){u instanceof E.FileOperationError&&u.fileOperationResult===1||this.logService.error(u)}return null}async updateLastSyncUserData(u,f={}){if(f.ref||f.content||f.version)throw new Error("Cannot have core properties as additional");const p=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),k={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,version:p,...f};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(k)))}async getRemoteUserData(u){const{ref:f,content:p}=await this.getUserData(u);let k=null;return p!==null&&(k=this.parseSyncData(p)),{ref:f,syncData:k}}parseSyncData(u){try{const f=JSON.parse(u);if(r(f))return f}catch(f){this.logService.error(f)}throw new l.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(u){if((0,I.isString)(u)){const f=await this.userDataSyncStoreService.resolveContent(this.resource,u);return{ref:u,content:f}}else{const f=u?{ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,f,this.syncHeaders)}}async updateRemoteUserData(u,f){const p=await this.currentMachineIdPromise,k={version:this.version,machineId:p,content:u};return f=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(k),f,this.syncHeaders),{ref:f,syncData:k}}async backupLocal(u){const f={version:this.version,content:u};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};s=de([G(1,E.IFileService),G(2,h.IEnvironmentService),G(3,w.IStorageService),G(4,l.IUserDataSyncStoreService),G(5,l.IUserDataSyncBackupStoreService),G(6,l.IUserDataSyncResourceEnablementService),G(7,g.ITelemetryService),G(8,l.IUserDataSyncLogService),G(9,v.IConfigurationService),G(10,a.IUriIdentityService)],s),e.AbstractSynchroniser=s;let n=class extends s{constructor(u,f,p,k,O,F,W,$,A,q,_,M){super(f,p,k,O,F,W,$,A,q,_,M);this.file=u,this._register(this.fileService.watch(this.extUri.dirname(u))),this._register(this.fileService.onDidFilesChange(B=>this.onFileChanges(B)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(u){return null}}async updateLocalFileContent(u,f,p){try{f?await this.writeFileContent(u,f,p):await this.fileService.createFile(this.file,R.VSBuffer.fromString(u),{overwrite:p})}catch(k){throw k instanceof E.FileOperationError&&k.fileOperationResult===1||k instanceof E.FileOperationError&&k.fileOperationResult===3?new l.UserDataSyncError(k.message,"LocalPreconditionFailed"):k}}async writeFileContent(u,f,p){await this.fileService.writeFile(this.file,R.VSBuffer.fromString(u),p?void 0:f)}onFileChanges(u){!u.contains(this.file)||this.triggerLocalChange()}};n=de([G(2,E.IFileService),G(3,h.IEnvironmentService),G(4,w.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncResourceEnablementService),G(8,g.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,v.IConfigurationService),G(11,a.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let t=class extends n{constructor(u,f,p,k,O,F,W,$,A,q,_,M,B){super(u,f,p,k,O,F,W,$,A,q,M,B);this.userDataSyncUtilService=_,this._formattingOptions=void 0}hasErrors(u){const f=[];return(0,P.parse)(u,f,{allowEmptyContent:!0,allowTrailingComma:!0}),f.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([G(2,E.IFileService),G(3,h.IEnvironmentService),G(4,w.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncResourceEnablementService),G(8,g.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,l.IUserDataSyncUtilService),G(11,v.IConfigurationService),G(12,a.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let o=class{constructor(u,f,p,k,O){this.resource=u,this.environmentService=f,this.logService=p,this.fileService=k,this.extUri=O.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,f,this.extUri)}async initialize({ref:u,content:f}){if(!f){this.logService.info("Remote content does not exist.",this.resource);return}const p=this.parseSyncData(f);if(!!p)try{await this.doInitialize({ref:u,syncData:p})}catch(k){this.logService.error(k)}}parseSyncData(u){try{const f=JSON.parse(u);if(r(f))return f}catch(f){this.logService.error(f)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(u,f={}){const p={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,...f};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(p)))}};o=de([G(1,h.IEnvironmentService),G(2,y.ILogService),G(3,E.IFileService),G(4,a.IUriIdentityService)],o),e.AbstractInitializer=o}),define(te[221],ne([0,1,5,27,9,3,40,48,25,7,21,11,30,36,14,8,23,22,37,47,218,97,98,24]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g,a,l,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function n(f,p){const k=JSON.parse(f.content);if(f.version===1||f.version===2){const O=(await p.getInstalled(0)).filter(F=>F.isBuiltin);for(const F of k)f.version===1&&(F.enabled===!1&&(F.disabled=!0),delete F.enabled),f.version===2&&O.every(W=>!(0,v.areSameExtensions)(W.identifier,F.identifier))&&(F.installed=!0)}return k}function t(f,p,k){const O=k.get((0,v.getExtensionId)(f,p),0)||"{}";return JSON.parse(O)}e.getExtensionStorageState=t;function o(f,p,k,O){O.store((0,v.getExtensionId)(f,p),JSON.stringify(k),0,1)}e.storeExtensionStorageState=o;let c=class mt extends g.AbstractSynchroniser{constructor(p,k,O,F,W,$,A,q,_,M,B,Z,H,j,Q){super("extensions",k,p,O,F,W,Z,H,_,B,Q);this.storageService=O,this.extensionManagementService=$,this.extensionEnablementService=A,this.ignoredExtensionsManagementService=q,this.extensionGalleryService=M,this.extensionsStorageSyncService=j,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,U=>U.some(({local:N})=>!!N)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,U=>!U.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(p,k){const O=p.syncData?await n(p.syncData,this.extensionManagementService):null,F=k?.skippedExtensions||[],W=k?.syncData?await n(k.syncData,this.extensionManagementService):null,$=await this.extensionManagementService.getInstalled(void 0,!0),A=this.getLocalExtensions($),q=this.ignoredExtensionsManagementService.getIgnoredExtensions($);O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:_,remote:M}=(0,a.merge)(A,O,W,F,q),B={local:_,remote:M,content:this.getPreviewContent(A,_.added,_.updated,_.removed),localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:M!==null?2:0};return[{skippedExtensions:F,localResource:this.localResource,localContent:this.format(A),localExtensions:A,remoteResource:this.remoteResource,remoteContent:O?this.format(O):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(p,k,O,F){const W=[...k,...O],$=new Set,A=q=>{$.add(q.id.toLowerCase()),q.uuid&&$.add(q.uuid)};W.forEach(({identifier:q})=>A(q)),F.forEach(A);for(const q of p)$.has(q.identifier.id.toLowerCase())||q.identifier.uuid&&$.has(q.identifier.uuid)||W.push(q);return this.format(W)}async getMergeResult(p,k){return{...p.previewResult,hasConflicts:!1}}async getAcceptResult(p,k,O,F){if(this.extUri.isEqual(k,this.localResource))return this.acceptLocal(p);if(this.extUri.isEqual(k,this.remoteResource))return this.acceptRemote(p);if(this.extUri.isEqual(k,this.previewResource))return p.previewResult;throw new Error(`Invalid Resource: ${k.toString()}`)}async acceptLocal(p){const k=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),F=(0,a.merge)(p.localExtensions,null,null,p.skippedExtensions,O),{local:W,remote:$}=F;return{content:p.localContent,local:W,remote:$,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:$!==null?2:0}}async acceptRemote(p){const k=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),F=p.remoteContent?JSON.parse(p.remoteContent):null;if(F!==null){const W=(0,a.merge)(p.localExtensions,F,p.localExtensions,[],O),{local:$,remote:A}=W;return{content:p.remoteContent,local:$,remote:A,localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:A!==null?2:0}}else return{content:p.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(p,k,O,F){let{skippedExtensions:W,localExtensions:$}=O[0][0],{local:A,remote:q,localChange:_,remoteChange:M}=O[0][1];if(_===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),_!==0&&(await this.backupLocal(JSON.stringify($)),W=await this.updateLocalExtensions(A.added,A.removed,A.updated,W)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const B=JSON.stringify(q.all);p=await this.updateRemoteUserData(B,F?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(Z=>Z.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(Z=>Z.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(Z=>Z.identifier.id))}.`:""}`)}k?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(p,{skippedExtensions:W}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${W.length?` Skipped: ${JSON.stringify(W.map(B=>B.identifier.id))}.`:""}`))}async getAssociatedResources({uri:p}){return[{resource:this.extUri.joinPath(p,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(p){if(this.extUri.isEqual(p,mt.EXTENSIONS_DATA_URI)){const O=await this.extensionManagementService.getInstalled(),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(O),W=this.getLocalExtensions(O).filter($=>!F.some(A=>(0,v.areSameExtensions)({id:A},$.identifier)));return this.format(W)}if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let k=await super.resolveContent(p);if(k)return k;if(k=await super.resolveContent(this.extUri.dirname(p)),k){const O=this.parseSyncData(k);if(O)switch(this.extUri.basename(p)){case"extensions.json":return this.format(this.parseExtensions(O))}}return null}format(p){p.sort((F,W)=>!F.identifier.uuid&&W.identifier.uuid?-1:F.identifier.uuid&&!W.identifier.uuid?1:(0,S.compare)(F.identifier.id,W.identifier.id));const k=JSON.stringify(p),O=(0,P.format)(k,void 0,{});return(0,i.applyEdits)(k,O)}async hasLocalData(){try{const p=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(p).some(O=>O.installed||O.disabled))return!0}catch(p){}return!1}async updateLocalExtensions(p,k,O,F){const W=[],$=[],A=await this.extensionManagementService.getInstalled();if(k.length){const _=A.filter(({identifier:M,isBuiltin:B})=>!B&&k.some(Z=>(0,v.areSameExtensions)(M,Z)));await D.Promises.settled(_.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),W.push(M.identifier)}))}(p.length||O.length)&&await D.Promises.settled([...p,...O].map(async _=>{const M=A.find(Z=>(0,v.areSameExtensions)(Z.identifier,_.identifier));if(M&&M.isBuiltin){_.state&&M.manifest.version===_.version&&this.updateExtensionState(_.state,M.manifest.publisher,M.manifest.name,M.manifest.version),_.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,_.identifier.id),await this.extensionEnablementService.disableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,_.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,_.identifier.id),await this.extensionEnablementService.enableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,_.identifier.id)),W.push(_.identifier);return}const B=(await this.extensionGalleryService.getExtensions([_.identifier],L.CancellationToken.None))[0];if(_.state&&(M?M.manifest.version===_.version:!!B)){const Z=M?M.manifest.publisher:B.publisher,H=M?M.manifest.name:B.name;this.updateExtensionState(_.state,Z,H,M?.manifest.version)}if(B)try{_.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,_.identifier.id,B.version),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,_.identifier.id,B.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,_.identifier.id,B.version),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,_.identifier.id,B.version)),M||(await this.extensionManagementService.canInstall(B)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,_.identifier.id,B.version),await this.extensionManagementService.installFromGallery(B,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,_.identifier.id,B.version),W.push(B.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),$.push(_)))}catch(Z){$.push(_),Z instanceof d.ExtensionManagementError&&[d.ExtensionManagementErrorCode.Incompatible,d.ExtensionManagementErrorCode.IncompatiblePreRelease,d.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(Z.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):(this.logService.error(Z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,B.displayName||B.identifier.id))}else $.push(_),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,_.identifier.id)}));const q=[];for(const _ of F)W.some(M=>(0,v.areSameExtensions)(M,_.identifier))||q.push(_);for(const _ of $)q.some(M=>(0,v.areSameExtensions)(M.identifier,_.identifier))||q.push(_);return q}updateExtensionState(p,k,O,F){const W=t(k,O,this.storageService),$=F?this.extensionsStorageSyncService.getKeysForSync({id:(0,v.getGalleryExtensionId)(k,O),version:F}):void 0;$?$.forEach(A=>{W[A]=p[A]}):Object.keys(p).forEach(A=>W[A]=p[A]),o(k,O,W,this.storageService)}parseExtensions(p){return JSON.parse(p.content)}getLocalExtensions(p){const k=this.extensionEnablementService.getDisabledExtensions();return p.map(({identifier:O,isBuiltin:F,manifest:W})=>{const $={identifier:O,version:W.version};k.some(A=>(0,v.areSameExtensions)(A,O))&&($.disabled=!0),F||($.installed=!0);try{const A=this.extensionsStorageSyncService.getKeysForSync({id:O.id,version:W.version});if(A){const q=t(W.publisher,W.name,this.storageService);$.state=Object.keys(q).reduce((_,M)=>(A.includes(M)&&(_[M]=q[M]),_),{})}}catch(A){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(A))}return $})}};c.EXTENSIONS_DATA_URI=C.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),c=de([G(0,b.IEnvironmentService),G(1,h.IFileService),G(2,y.IStorageService),G(3,s.IUserDataSyncStoreService),G(4,s.IUserDataSyncBackupStoreService),G(5,d.IExtensionManagementService),G(6,d.IGlobalExtensionEnablementService),G(7,r.IIgnoredExtensionsManagementService),G(8,s.IUserDataSyncLogService),G(9,d.IExtensionGalleryService),G(10,I.IConfigurationService),G(11,s.IUserDataSyncResourceEnablementService),G(12,m.ITelemetryService),G(13,l.IExtensionsStorageSyncService),G(14,w.IUriIdentityService)],c),e.ExtensionsSynchroniser=c;let u=class extends g.AbstractInitializer{constructor(p,k,O,F,W,$){super("extensions",F,W,O,$);this.extensionManagementService=p,this.ignoredExtensionsManagementService=k}async parseExtensions(p){return p.syncData?await n(p.syncData,this.extensionManagementService):null}generatePreview(p,k){const O=[],F=[],W=[];for(const $ of p){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension($.identifier.id))continue;const A=k.find(q=>(0,v.areSameExtensions)(q.identifier,$.identifier));A?(O.push(A),$.disabled&&W.push($.identifier)):$.installed&&(F.push($.identifier),$.disabled&&W.push($.identifier))}return{installedExtensions:O,newExtensions:F,disabledExtensions:W,remoteExtensions:p}}};u=de([G(0,d.IExtensionManagementService),G(1,r.IIgnoredExtensionsManagementService),G(2,h.IFileService),G(3,b.IEnvironmentService),G(4,E.ILogService),G(5,w.IUriIdentityService)],u),e.AbstractExtensionsInitializer=u}),define(te[222],ne([0,1,28,24]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,S,C,I,b){if(!S)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const d=T(P,S);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=C?T(C,S):{added:Object.keys(S).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},h=C?T(C,P):{added:Object.keys(P).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},E={added:{},removed:[],updated:{}},y=D.deepClone(S),m=!C;for(const w of h.added.values())w!==L.SYNC_SERVICE_URL_TYPE&&m&&v.added.has(w)||(y[w]=P[w]);for(const w of h.updated.values())y[w]=P[w];for(const w of h.removed.values())I.unregistered.includes(w)||delete y[w];for(const w of v.added.values()){const g=S[w];if(I.machine.includes(w)){b.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(w))continue;const a=P[w];a&&a.value===g.value||w===L.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(w)||(a?E.updated[w]=g:E.added[w]=g)}for(const w of v.updated.values()){const g=S[w];if(I.machine.includes(w)){b.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const a=P[w];a&&a.value===g.value||(E.updated[w]=g)}for(const w of v.removed.values()){if(I.machine.includes(w)){b.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||E.removed.push(w)}return{local:E,remote:i(y,S)?null:y}}e.merge=R;function T(P,S){const C=Object.keys(P),I=Object.keys(S),b=I.filter(h=>C.indexOf(h)===-1).reduce((h,E)=>(h.add(E),h),new Set),d=C.filter(h=>I.indexOf(h)===-1).reduce((h,E)=>(h.add(E),h),new Set),v=new Set;for(const h of C){if(d.has(h))continue;const E=P[h],y=S[h];D.equals(E,y)||v.add(h)}return{added:b,removed:d,updated:v}}function i(P,S){const{added:C,removed:I,updated:b}=T(P,S);return C.size===0&&I.size===0&&b.size===0}}),define(te[223],ne([0,1,19,9,3,31,40,48,4,7,29,21,11,14,8,46,23,22,37,47,55,222,24]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g,a,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",n=["locale"];function t(p){const k=p.storage?Object.keys(p.storage).sort():[],O={};k.forEach($=>O[$]=p.storage[$]),p.storage=O;const F=JSON.stringify(p),W=(0,P.format)(F,void 0,{});return(0,i.applyEdits)(F,W)}const o=1;let c=class vt extends g.AbstractSynchroniser{constructor(k,O,F,W,$,A,q,_,M,B){super("globalState",k,$,M,O,F,A,q,W,_,B);this.storageService=M,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(k.onDidFilesChange,Z=>Z.contains(this.environmentService.argvResource)),R.Event.filter(M.onDidChangeValue,Z=>Z.scope===0&&Z.target!==void 0?Z.target===0:M.keys(0,0).includes(Z.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(k,O,F){const W=k.syncData?JSON.parse(k.syncData.content):null;O=O===null&&F?k:O;const $=O&&O.syncData?JSON.parse(O.syncData.content):null,A=await this.getLocalGlobalState();W?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const q=this.getStorageKeys($),{local:_,remote:M}=(0,l.merge)(A.storage,W?W.storage:null,$?$.storage:null,q,this.logService),B={content:null,local:_,remote:M,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:t(A),localUserData:A,remoteResource:this.remoteResource,remoteContent:W?t(W):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource,storageKeys:q}]}async getMergeResult(k,O){return{...k.previewResult,hasConflicts:!1}}async getAcceptResult(k,O,F,W){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(k);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(k);if(this.extUri.isEqual(O,this.previewResource))return k.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(k){return{content:k.localContent,local:{added:{},removed:[],updated:{}},remote:k.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(k){if(k.remoteContent!==null){const O=JSON.parse(k.remoteContent),{local:F,remote:W}=(0,l.merge)(k.localUserData.storage,O.storage,null,k.storageKeys,this.logService);return{content:k.remoteContent,local:F,remote:W,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:k.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(k,O,F,W){let{localUserData:$}=F[0][0],{local:A,remote:q,localChange:_,remoteChange:M}=F[0][1];if(_===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),_!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify($)),await this.writeLocalGlobalState(A),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),M!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const B=JSON.stringify({storage:q});k=await this.updateRemoteUserData(B,W?null:k.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}O?.ref!==k.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(k),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:k}){return[{resource:this.extUri.joinPath(k,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(k){if(this.extUri.isEqual(k,vt.GLOBAL_STATE_DATA_URI)){const F=await this.getLocalGlobalState();return t(F)}if(this.extUri.isEqual(this.remoteResource,k)||this.extUri.isEqual(this.localResource,k)||this.extUri.isEqual(this.acceptedResource,k))return this.resolvePreviewContent(k);let O=await super.resolveContent(k);if(O)return O;if(O=await super.resolveContent(this.extUri.dirname(k)),O){const F=this.parseSyncData(O);if(F)switch(this.extUri.basename(k)){case"globalState.json":return t(JSON.parse(F.content))}}return null}async hasLocalData(){try{const{storage:k}=await this.getLocalGlobalState();if(Object.keys(k).length>1||k[`${s}.locale`]?.value!=="en")return!0}catch(k){}return!1}async getLocalGlobalState(){const k={},O=await this.getLocalArgvContent(),F=(0,T.parse)(O);for(const W of n)F[W]!==void 0&&(k[`${s}${W}`]={version:1,value:F[W]});for(const W of this.storageService.keys(0,0)){const $=this.storageService.get(W,0);$&&(k[W]={version:1,value:$})}return{storage:k}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const k=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),k.value.toString()}catch(k){this.logService.debug((0,L.getErrorMessage)(k))}return"{}"}async writeLocalGlobalState({added:k,removed:O,updated:F}){const W={},$={},A=(_,M)=>{for(const B of _){if(B.startsWith(s)){W[B.substring(s.length)]=M?M[B].value:void 0;continue}if(M){const Z=M[B];Z.value!==String(this.storageService.get(B,0))&&($[B]=Z.value)}else this.storageService.get(B,0)!==void 0&&($[B]=void 0)}};if(A(Object.keys(k),k),A(Object.keys(F),F),A(O),Object.keys(W).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(W),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys($).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const _ of Object.keys($))this.storageService.store(_,$[_],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys($))}}async updateArgv(k){const O=await this.getLocalArgvContent();let F=O;for(const W of Object.keys(k))F=(0,a.edit)(F,[W],k[W],{});O!==F&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(F)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(k){const O=this.storageService.keys(0,0),F=this.storageService.keys(0,1),W=[...O,...F],$=k?.storage?Object.keys(k.storage).filter(A=>!A.startsWith(s)&&!W.includes(A)&&this.storageService.get(A,0)!==void 0):[];if(!S.isWeb){const A=[...r.ALL_SYNC_RESOURCES.map(q=>(0,r.getEnablementKey)(q)),r.SYNC_SERVICE_URL_TYPE];$.push(...A),F.push(...A)}return{user:O,machine:F,unregistered:$}}};c.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=de([G(0,v.IFileService),G(1,r.IUserDataSyncStoreService),G(2,r.IUserDataSyncBackupStoreService),G(3,r.IUserDataSyncLogService),G(4,d.IEnvironmentService),G(5,r.IUserDataSyncResourceEnablementService),G(6,m.ITelemetryService),G(7,b.IConfigurationService),G(8,y.IStorageService),G(9,w.IUriIdentityService)],c),e.GlobalStateSynchroniser=c;let u=class extends g.AbstractInitializer{constructor(k,O,F,W,$){super("globalState",F,W,O,$);this.storageService=k}async doInitialize(k){const O=k.syncData?JSON.parse(k.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},W={};for(const $ of Object.keys(O.storage))$.startsWith(s)?F[$.substring(s.length)]=O.storage[$].value:this.storageService.get($,0)===void 0&&(W[$]=O.storage[$].value);if(Object.keys(F).length){let $="{}";try{$=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(A){}for(const A of Object.keys(F))$=(0,a.edit)($,[A],F[A],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString($))}if(Object.keys(W).length)for(const $ of Object.keys(W))this.storageService.store($,W[$],0,0)}};u=de([G(0,y.IStorageService),G(1,v.IFileService),G(2,d.IEnvironmentService),G(3,r.IUserDataSyncLogService),G(4,w.IUriIdentityService)],u),e.GlobalStateInitializer=u;let f=class{constructor(k,O,F,W,$){this.userDataSyncStoreClient=k,this.storageService=O,this.environmentService=F,this.fileService=W,this.logService=$}getSyncStoreType(k){return this.parseGlobalState(k)?.storage[r.SYNC_SERVICE_URL_TYPE]?.value}async sync(k){const O=(0,r.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(k,O)}catch(F){if(F instanceof r.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(k,O)}throw F}}async doSync(k,O){const F=await this.userDataSyncStoreClient.read("globalState",null,O),W=this.parseGlobalState(F)||{storage:{}};W.storage[r.SYNC_SERVICE_URL_TYPE]={value:k,version:o};const $=await(0,E.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),A={version:o,machineId:$,content:t(W)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(A),F.ref,O)}parseGlobalState({content:k}){if(!k)return null;const O=JSON.parse(k);if((0,g.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};f=de([G(1,y.IStorageService),G(2,d.IEnvironmentService),G(3,v.IFileService),G(4,h.ILogService)],f),e.UserDataSyncStoreTypeSynchronizer=f}),define(te[224],ne([0,1,17,19,3,31,4,15,145,21,11,14,23,22,37,47,219,24]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,s){try{const n=JSON.parse(l);if(!r)return(0,P.isUndefined)(n.all)?null:n.all;switch(i.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return s.error(n),null}}e.getKeybindingsContentFromSyncContent=w;let g=class extends E.AbstractJsonFileSynchroniser{constructor(r,s,n,t,o,c,u,f,p,k,O){super(u.keybindingsResource,"keybindings",c,u,f,r,s,o,k,n,p,t,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(t.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,s,n,t){const o=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;s=s===null&&n?r:s;const c=s?this.getKeybindingsContentFromLastSyncUserData(s):null,u=await this.getLocalFileContent(),f=await this.getFormattingOptions();let p=null,k=!1,O=!1,F=!1;if(o){let $=u?u.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new m.UserDataSyncError((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==$||c!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const A=await(0,y.merge)($,o,c,f,this.userDataSyncUtilService);A.hasChanges&&(p=A.mergeContent,F=A.hasConflicts,k=F||A.mergeContent!==$,O=F||A.mergeContent!==o)}}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),p=u.value.toString(),O=!0);const W={content:p,localChange:k?u?2:1:0,remoteChange:O?2:0,hasConflicts:F};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:W.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:W.remoteChange,previewResource:this.previewResource,previewResult:W,acceptedResource:this.acceptedResource}]}async getMergeResult(r,s){return r.previewResult}async getAcceptResult(r,s,n,t){if(this.extUri.isEqual(s,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(r,s,n,t){const{fileContent:o}=n[0][0];let{content:c,localChange:u,remoteChange:f}=n[0][1];if(u===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new m.UserDataSyncError((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(c||"[]",o,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),f!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const p=this.toSyncContent(c||"[]",r.syncData?.content);r=await this.updateRemoteUserData(p,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(p){}s?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const s=(0,T.parse)(r.value.toString());if((0,D.isNonEmptyArray)(s))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:s}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let s=await super.resolveContent(r);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(r)),s){const n=this.parseSyncData(s);if(n)switch(this.extUri.basename(r)){case"keybindings.json":return w(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,s){let n={};try{n=JSON.parse(s||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=r,i.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=de([G(0,m.IUserDataSyncStoreService),G(1,m.IUserDataSyncBackupStoreService),G(2,m.IUserDataSyncLogService),G(3,C.IConfigurationService),G(4,m.IUserDataSyncResourceEnablementService),G(5,b.IFileService),G(6,I.IEnvironmentService),G(7,d.IStorageService),G(8,m.IUserDataSyncUtilService),G(9,v.ITelemetryService),G(10,h.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let a=class extends E.AbstractInitializer{constructor(r,s,n,t){super("keybindings",s,n,r,t)}async doInitialize(r){const s=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!s){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(s)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),s=(0,T.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(s)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(s){return this.logService.error(s),null}}};a=de([G(0,b.IFileService),G(1,I.IEnvironmentService),G(2,m.IUserDataSyncLogService),G(3,h.IUriIdentityService)],a),e.KeybindingsInitializer=a}),define(te[225],ne([0,1,17,31,40,48,28,55,24]),function(J,e,D,L,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function C(c,u,f){let p=[];f?p=b(f):p=I(u);const k=[],O=[...(0,S.getDisallowedIgnoredSettings)()];if(Array.isArray(p))for(const F of p)F.startsWith("-")?O.push(F.substring(1)):k.push(F);return(0,D.distinct)([...c,...k].filter(F=>O.indexOf(F)===-1))}e.getIgnoredSettings=C;function I(c){let u=c.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=c.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:c.getValue("settingsSync.ignoredSettings")||[]}function b(c){const u=(0,L.parse)(c);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function d(c,u,f,p){if(f.length){const k=o(u),O=(0,L.parse)(u),F=(0,L.parse)(c),W=[];for(const $ of f){const A=O[$],q=F[$];A===void 0?c=P.edit(c,[$],void 0,p):q!==void 0?c=P.edit(c,[$],A,p):W.push(l($,k))}W.sort(($,A)=>$.startOffset-A.startOffset),W.forEach($=>c=m($.setting.key,u,c,p))}return c}e.updateIgnoredSettings=d;function v(c,u,f,p,k,O){const F=d(c,u,p,O),W=f!==F,$=f!==u;if(!W&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(W&&!$)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if($&&!W)return{conflictsSettings:[],localContent:d(u,c,p,O),remoteContent:null,hasConflicts:!1};if(f===null&&E(c)){const V=h(c,u,p)?null:d(u,c,p,O);return{conflictsSettings:[],localContent:V,remoteContent:null,hasConflicts:!1}}let A=c,q=u;const _=(0,L.parse)(c),M=(0,L.parse)(u),B=f?(0,L.parse)(f):null,Z=p.reduce((V,X)=>(V.add(X),V),new Set),H=y(_,M,Z),j=y(B,_,Z),Q=y(B,M,Z),U=new Map,N=new Set,z=V=>{N.add(V);const X=k.filter(({key:se})=>se===V)[0];X?(A=P.edit(A,[V],X.value,O),q=P.edit(q,[V],X.value,O)):U.set(V,{key:V,localValue:_[V],remoteValue:M[V]})};for(const V of j.removed.values())Q.updated.has(V)?z(V):q=P.edit(q,[V],void 0,O);for(const V of Q.removed.values())N.has(V)||(j.updated.has(V)?z(V):A=P.edit(A,[V],void 0,O));for(const V of j.updated.values())N.has(V)||(Q.updated.has(V)?H.updated.has(V)&&z(V):q=P.edit(q,[V],_[V],O));for(const V of Q.updated.values())N.has(V)||(j.updated.has(V)?H.updated.has(V)&&z(V):A=P.edit(A,[V],M[V],O));for(const V of j.added.values())N.has(V)||(Q.added.has(V)?H.updated.has(V)&&z(V):q=m(V,A,q,O));for(const V of Q.added.values())N.has(V)||(j.added.has(V)?H.updated.has(V)&&z(V):A=m(V,q,A,O));const x=U.size>0||!h(A,q,p),K=x||!h(A,c,[]),ee=x||!h(q,u,[]);return{localContent:K?A:null,remoteContent:ee?q:null,conflictsSettings:[...U.values()],hasConflicts:x}}e.merge=v;function h(c,u,f){if(c===u)return!0;const p=(0,L.parse)(c),k=(0,L.parse)(u),O=f.reduce(($,A)=>($.add(A),$),new Set),F=o(c).filter($=>!($.setting&&O.has($.setting.key))),W=o(u).filter($=>!($.setting&&O.has($.setting.key)));if(F.length!==W.length)return!1;for(let $=0;$<F.length;$++){const A=F[$],q=W[$];if(A.setting&&q.setting){if(A.setting.key!==q.setting.key||!i.equals(p[A.setting.key],k[A.setting.key]))return!1}else if(!A.setting&&!q.setting){if(A.value!==q.value)return!1}else return!1}return!0}e.areSame=h;function E(c){return c?o(c).length===0:!0}e.isEmpty=E;function y(c,u,f){const p=c?Object.keys(c).filter($=>!f.has($)):[],k=Object.keys(u).filter($=>!f.has($)),O=k.filter($=>p.indexOf($)===-1).reduce(($,A)=>($.add(A),$),new Set),F=p.filter($=>k.indexOf($)===-1).reduce(($,A)=>($.add(A),$),new Set),W=new Set;if(c)for(const $ of p){if(F.has($))continue;const A=c[$],q=u[$];i.equals(A,q)||W.add($)}return{added:O,removed:F,updated:W}}function m(c,u,f,p){const k=(0,L.parse)(u),O=o(u),F=o(f),W=w(c,O,F);return g(f,c,k[c],W,F,p)}e.addSetting=m;function w(c,u,f){const p=u.findIndex(O=>O.setting?.key===c),k=u[p-1];if(k){if(k.setting){const F=l(k.setting.key,f);if(F)return{index:f.indexOf(F),insertAfter:!0}}else{const F=r(p,u);if(F){const W=l(F.setting.key,f);if(W){const $=s(f.indexOf(W),f),A=n(u,F,u[p]);if($){const q=n(f,W,$),_=t(A,q);return _?{index:f.indexOf(_),insertAfter:!0}:{index:f.indexOf($),insertAfter:!1}}else{const q=n(f,W,f[f.length-1]),_=t(A,q);return _?{index:f.indexOf(_),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const O=u[p+1];if(O)if(O.setting){const F=l(O.setting.key,f);if(F)return{index:f.indexOf(F),insertAfter:!1}}else{const F=s(p,u);if(F){const W=l(F.setting.key,f);if(W){const $=r(f.indexOf(W),f),A=n(u,u[p],F);if($){const q=n(f,$,W),_=t(A.reverse(),q.reverse());return _?{index:f.indexOf(_),insertAfter:!1}:{index:f.indexOf($),insertAfter:!0}}else{const q=n(f,f[0],W),_=t(A.reverse(),q.reverse());return _?{index:f.indexOf(_),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function g(c,u,f,p,k,O){let F;return p.index===-1?F=(0,R.setProperty)(c,[u],f,O):F=a(c,u,f,p,k,O).map(W=>(0,R.withFormatting)(c,W,O)[0]),(0,R.applyEdits)(c,F)}function a(c,u,f,p,k,O){const F=`${JSON.stringify(u)}: ${JSON.stringify(f)}`,W=(0,T.getEOL)(O,c),$=k[p.index];if(p.insertAfter){const A=[];if($.setting)A.push({offset:$.endOffset,length:0,content:","+F});else{const q=s(p.index,k),_=r(p.index,k),M=_?.setting?.commaOffset;_&&M===void 0&&A.push({offset:_.endOffset,length:0,content:","});const B=M!==void 0&&M>$.endOffset;A.push({offset:B?M+1:$.endOffset,length:0,content:q?W+F+",":W+F})}return A}else{if($.setting)return[{offset:$.startOffset,length:0,content:F+","}];const A=(k[p.index-1]&&!k[p.index-1].setting?W:"")+F+(s(p.index,k)?",":"")+W;return[{offset:$.startOffset,length:0,content:A}]}}function l(c,u){return u.filter(f=>f.setting?.key===c)[0]}function r(c,u){for(let f=c-1;f>=0;f--)if(u[f].setting)return u[f]}function s(c,u){for(let f=c+1;f<u.length;f++)if(u[f].setting)return u[f]}function n(c,u,f){const p=c.indexOf(u),k=c.indexOf(f);return c.filter((O,F)=>p<F&&F<k)}function t(c,u){if(c.length&&u.length){let f=0;for(;f<u.length&&f<c.length;f++)if(c[f].value!==u[f].value)return u[f-1];return u[f-1]}}function o(c){const u=[];let f=-1,p,k;const O={onObjectBegin:F=>{f++},onObjectProperty:(F,W,$)=>{f===0&&(p=W,k=F)},onObjectEnd:(F,W)=>{f--,f===0&&u.push({startOffset:p,endOffset:F+W,value:c.substring(p,F+W),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(F,W)=>{f++},onArrayEnd:(F,W)=>{f--,f===0&&u.push({startOffset:p,endOffset:F+W,value:c.substring(p,F+W),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(F,W,$)=>{f===0&&u.push({startOffset:p,endOffset:W+$,value:c.substring(p,W+$),setting:{key:k,commaOffset:void 0}})},onSeparator:(F,W,$)=>{if(f===0&&F===","){let A=u.length-1;for(;A>=0&&!u[A].setting;A--);const q=u[A];q&&u.splice(A,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:W}})}},onComment:(F,W)=>{f===0&&u.push({startOffset:F,endOffset:F+W,value:c.substring(F,F+W)})}};return(0,L.visit)(c,O),u}}),define(te[226],ne([0,1,19,3,40,146,21,88,84,11,30,14,23,22,37,47,55,225,24]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function a(n){const t=JSON.parse(n);return g(t)?t:{settings:n}}e.parseSettingsSyncContent=a;let l=class extends E.AbstractJsonFileSynchroniser{constructor(t,o,c,u,f,p,k,O,F,W,$,A,q){super(o.settingsResource,"settings",t,o,c,u,f,F,W,p,k,O,q);this.extensionManagementService=$,this.userConfigurationFileService=A,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const o=await this.getLastSyncUserData(),c=await this.getLatestRemoteUserData(t,o),u=this.getSettingsSyncContent(c),f=new P.ConfigurationModelParser(w.USER_DATA_SYNC_CONFIGURATION_SCOPE);return u?.settings&&f.parse(u.settings),f.configurationModel.getValue(w.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,o,c){const u=await this.getLocalFileContent(),f=await this.getFormattingOptions(),p=this.getSettingsSyncContent(t);o=o===null&&c?t:o;const k=o?this.getSettingsSyncContent(o):null,O=await this.getIgnoredSettings();let F=null,W=!1,$=!1,A=!1;if(p){let _=u?u.value.toString().trim():"{}";_=_||"{}",this.validateContent(_),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,m.merge)(_,p.settings,k?k.settings:null,O,[],f);F=M.localContent||M.remoteContent,W=M.localContent!==null,$=M.remoteContent!==null,A=M.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),F=u.value.toString(),$=!0);const q={content:F,localChange:W?2:0,remoteChange:$?2:0,hasConflicts:A};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:p?p.settings:null,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async getMergeResult(t,o){const c=await this.getFormattingOptions(),u=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,m.updateIgnoredSettings)(t.previewResult.content,"{}",u,c):null}}async getAcceptResult(t,o,c,u){const f=await this.getFormattingOptions(),p=await this.getIgnoredSettings();if(this.extUri.isEqual(o,this.localResource))return{content:t.fileContent?(0,m.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",p,f):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:t.remoteContent!==null?(0,m.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",p,f):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return c===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:c!==null?(0,m.updateIgnoredSettings)(c,t.fileContent?t.fileContent.value.toString():"{}",p,f):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(t,o,c,u){const{fileContent:f}=c[0][0];let{content:p,localChange:k,remoteChange:O}=c[0][1];if(k===0&&O===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),p=p?p.trim():"{}",p=p||"{}",this.validateContent(p),k!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),f&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(f.value.toString()))),await this.updateLocalFileContent(p,f,u),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),O!==0){const F=await this.getFormattingOptions(),W=this.getSettingsSyncContent(t),$=await this.getIgnoredSettings(p);p=(0,m.updateIgnoredSettings)(p,W?W.settings:"{}",$,F),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(p)),u?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(F){}o?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const o=await this.getFormattingOptions(),c=(0,y.edit)(t.value.toString(),[w.CONFIGURATION_SYNC_STORE_KEY],void 0,o);return!(0,m.isEmpty)(c)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const o=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:o}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let o=await super.resolveContent(t);if(o)return o;if(o=await super.resolveContent(this.extUri.dirname(t)),o){const c=this.parseSyncData(o);if(c){const u=this.parseSettingsSyncContent(c.content);if(u)switch(this.extUri.basename(t)){case"settings.json":return u.settings}}}return null}async resolvePreviewContent(t){let o=await super.resolvePreviewContent(t);if(o){const c=await this.getFormattingOptions(),u=await this.getIgnoredSettings();o=(0,m.updateIgnoredSettings)(o,"{}",u,c)}return o}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return a(t)}catch(o){this.logService.error(o)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const c=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,u=>u.some(({local:f})=>!!f)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,u=>!u.error))(()=>{c.dispose(),this._defaultIgnoredSettings=void 0})}const o=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(o,this.configurationService,t)}async writeFileContent(t,o,c){await this.userConfigurationFileService.write(D.VSBuffer.fromString(t),c?void 0:{etag:o.etag,mtime:o.mtime})}validateContent(t){if(this.hasErrors(t))throw new w.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const o=JSON.parse(t.value.toString());if(!s(o))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const c=this.parseSettingsSyncContent(o.content);if(!c||!c.settings)return;let u=c.settings;const f=await this.getFormattingOptions();for(const p in o)if(["version","content","machineId"].indexOf(p)===-1&&o[p]!==void 0){const k=(0,R.setProperty)(u,[p],o[p],f);k.length&&(u=(0,R.applyEdits)(u,k))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(u))}catch(t){}}};l=de([G(0,b.IFileService),G(1,C.IEnvironmentService),G(2,d.IStorageService),G(3,w.IUserDataSyncStoreService),G(4,w.IUserDataSyncBackupStoreService),G(5,w.IUserDataSyncLogService),G(6,w.IUserDataSyncUtilService),G(7,i.IConfigurationService),G(8,w.IUserDataSyncResourceEnablementService),G(9,v.ITelemetryService),G(10,I.IExtensionManagementService),G(11,S.IUserConfigurationFileService),G(12,h.IUriIdentityService)],l),e.SettingsSynchroniser=l;let r=class extends E.AbstractInitializer{constructor(t,o,c,u){super("settings",o,c,t,u)}async doInitialize(t){const o=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!o){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(o.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return a(t)}catch(o){this.logService.error(o)}return null}};r=de([G(0,b.IFileService),G(1,C.IEnvironmentService),G(2,w.IUserDataSyncLogService),G(3,h.IUriIdentityService)],r),e.SettingsInitializer=r;function s(n){return!!(n&&n.version!==void 0&&typeof n.version=="number"&&n.content!==void 0&&typeof n.content=="string"&&n.machineId!==void 0&&typeof n.machineId=="string")}}),define(te[227],ne([0,1,19,3,28,21,11,14,23,22,37,47,220,24]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends b.AbstractSynchroniser{constructor(m,w,g,a,l,r,s,n,t,o){super("snippets",w,m,g,a,l,n,t,r,s,o);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,c=>c.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,g){const a=await this.getSnippetsFileContents(),l=this.toSnippetsContents(a),r=m.syncData?this.parseSnippets(m.syncData):null;w=w===null&&g?m:w;const s=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,d.merge)(l,r,s);return this.getResourcePreviews(n,a,r||{})}async getMergeResult(m,w){return m.previewResult}async getAcceptResult(m,w,g,a){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return g===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:g,localChange:g===null?m.fileContent!==null?3:0:2,remoteChange:g===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(m,w,g,a){const l=g.map(([r,s])=>({...r,acceptResult:s}));l.every(({localChange:r,remoteChange:s})=>r===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,a)),l.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(l,m,a)),w?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch(s){}}getResourcePreviews(m,w,g){const a=new Map;for(const l of Object.keys(m.local.added)){const r={content:m.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};a.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.local.updated)){const r={content:m.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.added)){const r={content:m.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.updated)){const r={content:m.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:g[l]?2:1};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!a.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...a.values()]}async getAssociatedResources({uri:m}){let w=await super.resolveContent(m);if(w){const g=this.parseSyncData(w);if(g){const a=this.parseSnippets(g),l=[];for(const r of Object.keys(a)){const s=this.extUri.joinPath(m,r),n=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(n);l.push({resource:s,comparableResource:t?n:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const g=this.parseSyncData(w);if(g)return this.parseSnippets(g)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch(m){}return!1}async updateLocalBackup(m){const w={};for(const g of m)g.fileContent&&(w[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(m,w){for(const{fileContent:g,acceptResult:a,localResource:l,remoteResource:r,localChange:s}of m)if(s!==0){const n=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,n);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,D.VSBuffer.fromString(a.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,D.VSBuffer.fromString(a.content),w?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,w,g){const a=w.syncData?this.parseSnippets(w.syncData):{},l=(0,R.deepClone)(a);for(const{acceptResult:r,localResource:s,remoteResource:n,remoteChange:t}of m)if(t!==0){const o=s?this.extUri.basename(s):this.extUri.basename(n);t===3?delete l[o]:l[o]=r.content}return(0,d.areSame)(a,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),g?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const w={};for(const g of Object.keys(m))w[g]=m[g].value.toString();return w}async getSnippetsFileContents(){const m={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof P.FileOperationError&&g.fileOperationResult===1)return m;throw g}for(const g of w.children||[]){const a=g.resource,l=this.extUri.extname(a);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,a),s=await this.fileService.readFile(a);m[r]=s}}return m}};h=de([G(0,i.IEnvironmentService),G(1,P.IFileService),G(2,S.IStorageService),G(3,v.IUserDataSyncStoreService),G(4,v.IUserDataSyncBackupStoreService),G(5,v.IUserDataSyncLogService),G(6,T.IConfigurationService),G(7,v.IUserDataSyncResourceEnablementService),G(8,C.ITelemetryService),G(9,I.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let E=class extends b.AbstractInitializer{constructor(m,w,g,a){super("snippets",w,g,m,a)}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const a of Object.keys(w)){const l=w[a];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,a);await this.fileService.createFile(r,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};E=de([G(0,P.IFileService),G(1,i.IEnvironmentService),G(2,v.IUserDataSyncLogService),G(3,I.IUriIdentityService)],E),e.SnippetsInitializer=E}),define(te[63],ne([0,1,3,2,6,24]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let i=class extends L.Disposable{constructor(S,C){super();this.userDataSyncStoreService=S,this.logService=C,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};i=de([G(0,T.IUserDataSyncStoreService),G(1,T.IUserDataSyncLogService)],i),e.UserDataSyncAccountService=i}),define(te[228],ne([0,1,5,19,58,2,18,21,11,14,24]),function(J,e,D,L,R,T,i,P,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let b=class extends T.Disposable{constructor(v,h,E,y){super();this.environmentService=v,this.fileService=h,this.configurationService=E,this.logService=y,I.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(v){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,v),E=await this.fileService.resolve(h);return E.children?E.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(v,h){if(!h){const E=await this.getAllRefs(v);E.length&&(h=E[E.length-1].ref)}if(h){const E=(0,i.joinPath)(this.environmentService.userDataSyncHome,v,h);return(await this.fileService.readFile(E)).value.toString()}return null}async backup(v,h){const E=(0,i.joinPath)(this.environmentService.userDataSyncHome,v),y=(0,i.joinPath)(E,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(y,L.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(v)}catch(m){}}async cleanUpBackup(v){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,v);try{try{if(!await this.fileService.exists(h))return}catch(y){return}const E=await this.fileService.resolve(h);if(E.children){const y=E.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=y.filter(a=>Date.now()-this.getCreationTime(a)>m);const g=y.length-w.length;g<10&&(w=w.slice(10-g)),await D.Promises.settled(w.map(async a=>{this.logService.info("Deleting from backup",a.resource.path),await this.fileService.del(a.resource)}))}}catch(E){this.logService.error(E)}}getCreationTime(v){return v.ctime||new Date(parseInt(v.name.substring(0,4)),parseInt(v.name.substring(4,6))-1,parseInt(v.name.substring(6,8)),parseInt(v.name.substring(9,11)),parseInt(v.name.substring(11,13)),parseInt(v.name.substring(13,15))).getTime()}};b=de([G(0,S.IEnvironmentService),G(1,C.IFileService),G(2,P.IConfigurationService),G(3,I.IUserDataSyncLogService)],b),e.UserDataSyncBackupStoreService=b}),define(te[229],ne([0,1,2,7]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(d){this.service=d}listen(d,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(d,v,h){switch(v){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class T{constructor(d){this.service=d}listen(d,v){throw new Error(`Event not found: ${v}`)}call(d,v,h){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class i{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=i;class P{constructor(d){this.service=d}listen(d,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(d,v,h){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class S{constructor(d){this.service=d}listen(d,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(d,v,h){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class C{constructor(d){this.service=d}listen(d,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(d,v,h){switch(v){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class I extends D.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:L.URI.revive(d.url),type:d.type,defaultUrl:L.URI.revive(d.defaultUrl),insidersUrl:L.URI.revive(d.insidersUrl),stableUrl:L.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(te[230],ne([0,1,11,8]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends L.AbstractLogger{constructor(i,P){super();this.logger=this._register(i.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(i,...P){this.logger.trace(i,...P)}debug(i,...P){this.logger.debug(i,...P)}info(i,...P){this.logger.info(i,...P)}warn(i,...P){this.logger.warn(i,...P)}error(i,...P){this.logger.error(i,...P)}critical(i,...P){this.logger.critical(i,...P)}flush(){this.logger.flush()}};R=de([G(0,L.ILoggerService),G(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(te[64],ne([0,1,3,2,4,25,149,11,14,6,26,46,23,24]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let E=class et extends L.Disposable{constructor(m,w,g,a,l,r){super();this.storageService=g,this.userDataSyncStoreService=a,this.logService=l,this.productService=r,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(m,w,g)}async getMachines(m){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(a=>({...a,isCurrent:a.id===w}))}async addCurrentMachine(m){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(m);g.machines.some(({id:a})=>a===w)||(g.machines.push({id:w,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(m){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(m),a=g.machines.filter(({id:l})=>l!==w);a.length!==g.machines.length&&(g.machines=a,await this.writeMachinesData(g))}async renameMachine(m,w,g){const a=await this.currentMachineIdPromise,l=await this.readMachinesData(g),r=l.machines.find(({id:s})=>s===m);r&&(r.name=w,await this.writeMachinesData(l),l.machines.some(({id:s})=>s===a)&&this.storageService.store(h,w,0,1))}async setEnablement(m,w){const g=await this.readMachinesData(),a=g.machines.find(({id:l})=>l===m);a&&(a.disabled=w?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(m){const w=this.storageService.get(h,0);if(w)return w;const g=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,a=new RegExp(`${(0,T.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let l=0;for(const r of m){const s=a.exec(r.name),n=s?parseInt(s[1]):0;l=n>l?n:l}return`${g} #${l+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const w=this.parse(this.userData);if(w.version!==et.VERSION)throw new Error((0,i.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(m){const w=JSON.stringify(m),g=await this.userDataSyncStoreService.write(et.RESOURCE,w,this.userData?.ref||null);this.userData={ref:g,content:w},this._onDidChange.fire()}async readUserData(m){if(this.userData){const w=m&&m.latest?m.latest[et.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(w){this.logService.error(w)}return{version:et.VERSION,machines:[]}}};E.VERSION=1,E.RESOURCE="machines",E=de([G(0,P.IEnvironmentService),G(1,S.IFileService),G(2,d.IStorageService),G(3,v.IUserDataSyncStoreService),G(4,v.IUserDataSyncLogService),G(5,I.IProductService)],E),e.UserDataSyncMachinesService=E}),define(te[99],ne([0,1,5,58,38,9,3,2,4,18,7,147,11,26,23,22,24,63,64]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const g="sync.enable",a="sync.disableMachineEventually",l="sync.sessionId",r="sync.storeUrl",s="sync.productQuality";let n=class extends P.Disposable{constructor(u,f,p){super();this.storageService=u,this.environmentService=f,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new i.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(k=>this.onDidStorageChange(k)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(g,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(g,u,0,1)}onDidStorageChange(u){if(u.scope===0&&g===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=de([G(0,h.IStorageService),G(1,d.IEnvironmentService),G(2,y.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let t=class extends P.Disposable{constructor(u,f,p,k,O,F,W,$,A,q,_){super();this.userDataSyncStoreManagementService=f,this.userDataSyncStoreService=p,this.userDataSyncResourceEnablementService=k,this.userDataSyncService=O,this.logService=F,this.userDataSyncAccountService=W,this.telemetryService=$,this.userDataSyncMachinesService=A,this.storageService=q,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=_,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(f.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,f.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(W.onDidChangeAccount(()=>this.updateAutoSync())),this._register(p.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(i.Event.debounce(O.onDidChangeLocal,(M,B)=>M?[...M,B]:[B],1e3)(M=>this.triggerSync(M,!1,!1))),this._register(i.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(r,0);return u?I.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(r,u.toString(),0,1):this.storageService.remove(r,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:f}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(p=>this.onDidFinishSync(p))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(f&&this.logService.info(f),this.autoSync.clear()):f&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(f))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,f,p){try{this.userDataSyncAccountService.account&&!p&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(l,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(k){if(f)this.logService.error(k),this.updateEnablement(!1);else throw k}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(g,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const f=y.UserDataSyncError.toUserDataSyncError(u);f instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:f.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),f.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):f.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):f.code==="LocalTooManyRequests"||f.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):f.code==="UpgradeRequired"||f.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):f.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with newer version than of client. Requires client upgrade.`)):f.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with older version than of client. Requires server reset.`)):f.code==="ServiceChanged"||f.code==="DefaultServiceChanged"?S.isWeb&&f.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(f),this.successiveFailures++),this._onError.fire(f)}async disableMachineEventually(){this.storageService.store(a,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(a,0,!1)}stopDisableMachineEventually(){this.storageService.remove(a,0)}async triggerSync(u,f,p){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(f&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",p)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};t=de([G(0,v.IProductService),G(1,y.IUserDataSyncStoreManagementService),G(2,y.IUserDataSyncStoreService),G(3,y.IUserDataSyncResourceEnablementService),G(4,y.IUserDataSyncService),G(5,y.IUserDataSyncLogService),G(6,m.IUserDataSyncAccountService),G(7,E.ITelemetryService),G(8,w.IUserDataSyncMachinesService),G(9,h.IStorageService),G(10,y.IUserDataAutoSyncEnablementService)],t),e.UserDataAutoSyncService=t;class o extends P.Disposable{constructor(u,f,p,k,O,F,W,$){super();this.lastSyncUrl=u,this.interval=f,this.userDataSyncStoreManagementService=p,this.userDataSyncStoreService=k,this.userDataSyncService=O,this.userDataSyncMachinesService=F,this.logService=W,this.storageService=$,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new i.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new i.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(u,f){const p=(0,D.createCancelablePromise)(async k=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,T.isPromiseCanceledError)(O))return}return this.doSync(u,f,k)});return this.syncPromise=p,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),f=this.userDataSyncStoreManagementService.userDataSyncStore;return!!f&&!!u&&(!(0,C.isEqual)(f.defaultUrl,u.defaultUrl)||!(0,C.isEqual)(f.insidersUrl,u.insidersUrl)||!(0,C.isEqual)(f.stableUrl,u.stableUrl))}async doSync(u,f,p){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let k;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,f),p.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const O=this.storageService.get(l,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const F=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(p.isCancellationRequested)return;const W=F.find($=>$.isCurrent);if(W?.disabled)throw new y.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch($){throw new y.UserDataAutoSyncError((0,R.toErrorMessage)($),$ instanceof y.UserDataSyncError?$.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(l,this.manifest.session,0,1),p.isCancellationRequested)return;W||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),k=O}this._onDidFinishSync.fire(k)}register(u){return super._register(u)}}o.INTERVAL_SYNCING="Interval"}),define(te[231],ne([0,1,3,2,4,23,22,24]),function(J,e,D,L,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends L.Disposable{constructor(I,b){super();this.storageService=I,this.telemetryService=b,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(I.onDidChangeValue(d=>this.onDidStorageChange(d)))}isResourceEnabled(I){return this.storageService.getBoolean((0,P.getEnablementKey)(I),0,!0)}setResourceEnablement(I,b){if(this.isResourceEnabled(I)!==b){const d=(0,P.getEnablementKey)(I);this.telemetryService.publicLog2(d,{enabled:b}),this.storeResourceEnablement(d,b)}}getResourceSyncStateVersion(I){}storeResourceEnablement(I,b){this.storageService.store(I,b,0,R.isWeb?0:1)}onDidStorageChange(I){if(I.scope===0){const b=P.ALL_SYNC_RESOURCES.filter(d=>(0,P.getEnablementKey)(d)===I.key)[0];if(b){this._onDidChangeResourceEnablement.fire([b,this.isResourceEnabled(b)]);return}}}};S=de([G(0,T.IStorageService),G(1,i.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(te[232],ne([0,1,17,5,38,9,3,2,18,29,21,6,23,22,221,223,224,226,227,24]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const a="sync.lastSyncTime";let l=class extends P.Disposable{constructor(t,o,c,u,f,p,k){super();this.userDataSyncStoreService=t,this.userDataSyncStoreManagementService=o,this.instantiationService=c,this.configurationService=u,this.logService=f,this.telemetryService=p,this.storageService=k,this._status="uninitialized",this._onDidChangeStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new i.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new i.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new i.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new i.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(y.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(w.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(E.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(a,0,void 0),this.onDidChangeLocal=i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeLocal,()=>O.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(t,o){await this.checkEnablement();const c=(0,C.generateUuid)();try{const k=(0,g.createSyncHeaders)(c);o&&(k["Cache-Control"]="no-cache"),t=await this.userDataSyncStoreService.manifest(t,k)}catch(k){const O=g.UserDataSyncError.toUserDataSyncError(k);throw this.reportUserDataSyncError(O,c),O}let u=!1;const f=this;let p;return{manifest:t,run(){if(u)throw new Error("Can run a task only once");return p=(0,L.createCancelablePromise)(k=>f.sync(t,c,k)),p.finally(()=>p=void 0)},async stop(){if(p&&p.cancel(),f.status!=="idle")return f.stop()}}}async createManualSyncTask(){await this.checkEnablement();const t=(0,C.generateUuid)(),o=(0,g.createSyncHeaders)(t);let c;try{c=await this.userDataSyncStoreService.manifest(null,o)}catch(u){const f=g.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(f,t),f}return new r(t,c,o,this.synchronisers,this.configurationService,this.logService)}async sync(t,o,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),c.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const f=(0,g.createSyncHeaders)(o);for(const p of this.synchronisers){if(c.isCancellationRequested)return;try{await p.sync(t,f)}catch(k){let O=!1;if(k instanceof g.UserDataSyncError)switch(k.code){case"TooLarge":k=new g.UserDataSyncError(k.message,k.code,p.resource),O=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":O=!0;break}const F=g.UserDataSyncError.toUserDataSyncError(k);if(this.reportUserDataSyncError(F,o),O)throw F;this.logService.error(k),this.logService.error(`${p.resource}: ${(0,R.toErrorMessage)(k)}`),this._syncErrors.push([p.resource,F])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(f){const p=g.UserDataSyncError.toUserDataSyncError(f);throw this.reportUserDataSyncError(p,o),p}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const t of this.synchronisers)try{t.status!=="idle"&&await t.stop()}catch(o){this.logService.error(o)}}async replace(t){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(t))return}async accept(t,o,c,u){await this.checkEnablement();const f=this.getSynchroniser(t);await f.accept(o,c),u&&await f.apply(!1,(0,g.createSyncHeaders)((0,C.generateUuid)()))}async resolveContent(t){for(const o of this.synchronisers){const c=await o.resolveContent(t);if(c)return c}return null}getRemoteSyncResourceHandles(t){return this.getSynchroniser(t).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(t){return this.getSynchroniser(t).getLocalSyncResourceHandles()}getAssociatedResources(t,o){return this.getSynchroniser(t).getAssociatedResources(o)}getMachineId(t,o){return this.getSynchroniser(t).getMachineId(o)}async hasLocalData(){const t=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of t)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(t){this.logService.error(t)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(a,0);for(const t of this.synchronisers)try{await t.resetLocal()}catch(o){this.logService.error(`${t.resource}: ${(0,R.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const t of this.synchronisers)if(await t.hasPreviouslySynced())return!0;return!1}setStatus(t){const o=this._status;this._status!==t&&(this._status=t,this._onDidChangeStatus.fire(t),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const t=this.computeStatus();this.setStatus(t)}updateConflicts(){const t=this.computeConflicts();(0,D.equals)(this._conflicts,t,([o,c],[u,f])=>o===o&&(0,D.equals)(c,f,(p,k)=>(0,S.isEqual)(p.previewResource,k.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(t))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(a,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(t,o){this.telemetryService.publicLog2("sync/error",{code:t.code,serverCode:t instanceof g.UserDataSyncStoreError?String(t.serverCode):void 0,url:t instanceof g.UserDataSyncStoreError?t.url:void 0,resource:t.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(t=>t.status==="hasConflicts").map(t=>[t.resource,t.conflicts.map(s)])}getSynchroniser(t){return this.synchronisers.find(o=>o.resource===t)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};l=de([G(0,g.IUserDataSyncStoreService),G(1,g.IUserDataSyncStoreManagementService),G(2,b.IInstantiationService),G(3,I.IConfigurationService),G(4,g.IUserDataSyncLogService),G(5,v.ITelemetryService),G(6,d.IStorageService)],l),e.UserDataSyncService=l;class r extends P.Disposable{constructor(t,o,c,u,f,p){super();this.id=t,this.manifest=o,this.syncHeaders=c,this.synchronisers=u,this.configurationService=f,this.logService=p,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new i.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(t=>this.getPreviews(t))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(t){throw this.logService.error(t),t}}async accept(t,o){try{return await this.performAction(t,c=>c.accept(t,o))}catch(c){throw this.logService.error(c),c}}async merge(t){try{return t?await this.performAction(t,o=>o.merge(t)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(t){try{return await this.performAction(t,o=>o.discard(t))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const t=[];for(const[,o]of this.previews)for(const c of o.resourcePreviews)c.mergeState==="conflict"&&t.push(c.previewResource);for(const o of t)await this.discard(o);return this.previews}catch(t){throw this.logService.error(t),t}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const t=[];for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(p=>p.resource===o);for(const p of c.resourcePreviews)(p.localChange!==0||p.remoteChange!==0)&&p.mergeState==="preview"&&await u.merge(p.previewResource);const f=await u.apply(!1,this.syncHeaders);f&&t.push(this.toSyncResourcePreview(u.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}catch(t){throw this.logService.error(t),t}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,o]of this.previews){this.synchronizingResources.push([t,o.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(u=>u.resource===t);for(const u of o.resourcePreviews)await c.accept(u.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,o]of this.previews){this.synchronizingResources.push([t,o.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(u=>u.resource===t);for(const u of o.resourcePreviews)await c.accept(u.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async stop(){for(const t of this.synchronisers)try{await t.stop()}catch(o){(0,T.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(t,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:A,previewResource:q,remoteResource:_})=>(0,S.isEqual)(t,A)||(0,S.isEqual)(t,q)||(0,S.isEqual)(t,_)));if(c===-1)return this.previews;const[u,f]=this.previews[c],p=f.resourcePreviews.find(({localResource:$,remoteResource:A,previewResource:q})=>(0,S.isEqual)($,t)||(0,S.isEqual)(A,t)||(0,S.isEqual)(q,t));if(!p)return this.previews;let k=this.synchronizingResources.find($=>$[0]===u);k||(k=[u,[]],this.synchronizingResources.push(k)),k[1].some($=>(0,S.isEqual)($,p.localResource))||(k[1].push(p.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const O=this.synchronisers.find($=>$.resource===this.previews[c][0]),F=await o(O);F?this.previews.splice(c,1,this.toSyncResourcePreview(O.resource,F)):this.previews.splice(c,1);const W=this.synchronizingResources.findIndex($=>$[0]===u);return this.synchronizingResources[W][1].splice(k[1].findIndex($=>(0,S.isEqual)($,p.localResource)),1),k[1].length||(this.synchronizingResources.splice(W,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const t=[];for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(p=>p.resource===o);let f=c;for(const p of c.resourcePreviews)(p.localChange!==0||p.remoteChange!==0)&&p.mergeState==="preview"&&(f=await u.merge(p.previewResource));f&&t.push(this.toSyncResourcePreview(u.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}async getPreviews(t){const o=[],c=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(t.isCancellationRequested)return[];const f=await u.preview(this.manifest,c,this.syncHeaders);f&&o.push(this.toSyncResourcePreview(u.resource,f))}return o}async getUserDataSyncConfiguration(){const t=this.configurationService.getValue(g.USER_DATA_SYNC_CONFIGURATION_SCOPE),o=await this.synchronisers.find(c=>c instanceof m.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...t,...o}}toSyncResourcePreview(t,o){return[t,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(n){return{localResource:n.localResource,previewResource:n.previewResource,remoteResource:n.remoteResource,acceptedResource:n.acceptedResource,localChange:n.localChange,remoteChange:n.remoteChange,mergeState:n.mergeState}}}),define(te[233],ne([0,1,3,2,15,7,24]),function(J,e,D,L,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(b,d){this.service=b,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(b,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(b,d,v){try{return await this._call(b,d,v)}catch(h){throw this.logService.error(h),h}}async _call(b,d,v){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(v[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(v[0],T.URI.revive(v[1]),v[2],v[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(v[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(v[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(v[0]);case"getAssociatedResources":return this.service.getAssociatedResources(v[0],{created:v[1].created,uri:T.URI.revive(v[1].uri)});case"getMachineId":return this.service.getMachineId(v[0],{created:v[1].created,uri:T.URI.revive(v[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),E=v[0],y=this.getManualSyncTask(E);switch(v=v.slice(1),h){case"preview":return y.preview();case"accept":return y.accept(T.URI.revive(v[0]),v[1]);case"merge":return y.merge(T.URI.revive(v[0]));case"discard":return y.discard(T.URI.revive(v[0]));case"discardConflicts":return y.discardConflicts();case"apply":return y.apply();case"pull":return y.pull();case"push":return y.push();case"stop":return y.stop();case"_getStatus":return y.status;case"dispose":return this.disposeManualSyncTask(y)}}throw new Error("Invalid call")}getManualSyncTask(b){const d=this.manualSyncTasks.get(this.createKey(b));if(!d)throw new Error(`Manual sync taks not found: ${b}`);return d.manualSyncTask}async createManualSyncTask(){const b=new L.DisposableStore,d=b.add(await this.service.createManualSyncTask());return b.add(d.onSynchronizeResources(v=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:v}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:b}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(b){b.dispose();const d=this.createKey(b.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(b){return`manualSyncTask-${b}`}}e.UserDataSyncChannel=P;class S extends L.Disposable{constructor(b){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,v,h){return b.call(d,v,h).then(null,E=>{throw i.UserDataSyncError.toUserDataSyncError(E)})},listen(d,v){return b.listen(d,v)}},this.channel.call("_getInitialData").then(([d,v,h])=>{this.updateStatus(d),this.updateConflicts(v),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(E=>this.updateStatus(E))),this._register(this.channel.listen("onDidChangeLastSyncTime")(E=>this.updateLastSyncTime(E)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([v,h])=>[v,i.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:b,manifest:d,status:v}=await this.channel.call("createManualSyncTask"),h=this,E=new C(b,d,v,{async call(y,m,w){return h.channel.call(`manualSync/${y}`,[b,...(0,R.isArray)(m)?m:[m]],w)},listen(y,m){return D.Event.map(D.Event.filter(h.channel.listen(`manualSync/${y}`,m),w=>!E.isDiposed()&&w.manualSyncTaskId===b),w=>w.data)}});return E}replace(b){return this.channel.call("replace",[b])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(b,d,v,h){return this.channel.call("accept",[b,d,v,h])}resolveContent(b){return this.channel.call("resolveContent",[b])}async getLocalSyncResourceHandles(b){return(await this.channel.call("getLocalSyncResourceHandles",[b])).map(({created:v,uri:h})=>({created:v,uri:T.URI.revive(h)}))}async getRemoteSyncResourceHandles(b){return(await this.channel.call("getRemoteSyncResourceHandles",[b])).map(({created:v,uri:h})=>({created:v,uri:T.URI.revive(h)}))}async getAssociatedResources(b,d){return(await this.channel.call("getAssociatedResources",[b,d])).map(({resource:h,comparableResource:E})=>({resource:T.URI.revive(h),comparableResource:T.URI.revive(E)}))}async getMachineId(b,d){return this.channel.call("getMachineId",[b,d])}async updateStatus(b){this._status=b,this._onDidChangeStatus.fire(b)}async updateConflicts(b){this._conflicts=b.map(([d,v])=>[d,v.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(b){this._lastSyncTime!==b&&(this._lastSyncTime=b,this._onDidChangeLastSyncTime.fire(b))}}e.UserDataSyncChannelClient=S;class C extends L.Disposable{constructor(b,d,v,h){super();this.id=b,this.manifest=d,this._disposed=!1,this._status=v;const E=this;this.channel={async call(y,m,w){try{const g=await h.call(y,m,w);return E.isDiposed()||(E._status=await h.call("_getStatus")),g}catch(g){throw i.UserDataSyncError.toUserDataSyncError(g)}},listen(y,m){return h.listen(y,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const b=await this.channel.call("preview");return this.deserializePreviews(b)}async accept(b,d){const v=await this.channel.call("accept",[b,d]);return this.deserializePreviews(v)}async merge(b){const d=await this.channel.call("merge",[b]);return this.deserializePreviews(d)}async discard(b){const d=await this.channel.call("discard",[b]);return this.deserializePreviews(d)}async discardConflicts(){const b=await this.channel.call("discardConflicts");return this.deserializePreviews(b)}async apply(){const b=await this.channel.call("apply");return this.deserializePreviews(b)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(b){return b.map(([d,v])=>[d,{isLastSyncFromCurrentMachine:v.isLastSyncFromCurrentMachine,resourcePreviews:v.resourcePreviews.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource),acceptedResource:T.URI.revive(h.acceptedResource)}))}])}}}),define(te[234],ne([0,1,5,27,9,3,2,109,4,18,15,7,29,21,11,14,26,43,46,23,24]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",t=100,o=1e3*60*5;let c=class extends i.Disposable{constructor(F,W,$){super();this.productService=F,this.configurationService=W,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter($.onDidChangeValue,A=>A.key===a.SYNC_SERVICE_URL_TYPE&&A.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(a.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(F){this.storageService.store(a.SYNC_SERVICE_URL_TYPE,F,0,S.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[a.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(a.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(F,W){F=S.isWeb&&F?.web?{...F,...F.web}:F;const $={...F||{},...W||{}};if($&&(0,I.isString)($.url)&&(0,I.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(A=>(0,I.isArray)($.authenticationProviders[A].scopes))){const A=$,q=!!A.canSwitch&&!W?.url,_=A.url===A.insidersUrl?"insiders":"stable",M=(q?this.userDataSyncStoreType:void 0)||_,B=W?.url||(M==="insiders"?A.insidersUrl:M==="stable"?A.stableUrl:A.url);return{url:b.URI.parse(B),type:M,defaultType:_,defaultUrl:b.URI.parse(A.url),stableUrl:b.URI.parse(A.stableUrl),insidersUrl:b.URI.parse(A.insidersUrl),canSwitch:q,authenticationProviders:Object.keys(A.authenticationProviders).reduce((Z,H)=>(Z.push({id:H,scopes:A.authenticationProviders[H].scopes}),Z),[])}}}};c=de([G(0,y.IProductService),G(1,v.IConfigurationService),G(2,g.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let u=class extends c{constructor(F,W,$){super(F,W,$);const A=this.storageService.get(l,0);A&&(this.previousConfigurationSyncStore=JSON.parse(A));const q=this.productService[a.CONFIGURATION_SYNC_STORE_KEY];q?this.storageService.store(l,JSON.stringify(q),0,1):this.storageService.remove(l,0)}async switch(F){F!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=F,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=de([G(0,y.IProductService),G(1,v.IConfigurationService),G(2,g.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let f=class extends i.Disposable{constructor(F,W,$,A,q,_,M){super();this.requestService=$,this.logService=A,this.storageService=M,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(F),this.commonHeadersPromise=(0,w.getServiceMachineId)(q,_,M).then(B=>{const Z={"X-Client-Name":`${W.applicationName}${S.isWeb?"-web":""}`,"X-Client-Version":W.version};return W.commit&&(Z["X-Client-Commit"]=W.commit),Z}),this.session=new k(t,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,i.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(F,W){this.authToken={token:F,type:W}}updateUserDataSyncStoreUrl(F){this.userDataSyncStoreUrl=F?(0,C.joinPath)(F,"v1"):void 0}initDonotMakeRequestsUntil(){const F=this.storageService.getNumber(r,0);F&&Date.now()<F&&this.setDonotMakeRequestsUntil(new Date(F))}setDonotMakeRequestsUntil(F){this._donotMakeRequestsUntil?.getTime()!==F?.getTime()&&(this._donotMakeRequestsUntil=F,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(W=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),W).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,W=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",F),$={},A=await this.request(W.toString(),{type:"GET",headers:$},[],L.CancellationToken.None);return(await(0,m.asJson)(A)||[]).map(({url:_,created:M})=>({ref:(0,C.relativePath)(W,W.with({path:_})),created:M*1e3}))}async resolveContent(F,W){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",F,W).toString(),A={};A["Cache-Control"]="no-cache";const q=await this.request($,{type:"GET",headers:A},[],L.CancellationToken.None);return await(0,m.asText)(q)}async delete(F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",F).toString(),$={};await this.request(W,{type:"DELETE",headers:$},[],L.CancellationToken.None)}async read(F,W,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",F,"latest").toString();$={...$},$["Cache-Control"]="no-cache",W&&($["If-None-Match"]=W.ref);const q=await this.request(A,{type:"GET",headers:$},[304],L.CancellationToken.None);let _=null;if(q.res.statusCode===304&&(_=W),_===null){const M=q.res.headers.etag;if(!M)throw new a.UserDataSyncStoreError("Server did not return the ref",A,"NoRef",q.res.statusCode,q.res.headers[a.HEADER_OPERATION_ID]);const B=await(0,m.asText)(q);if(!B&&q.res.statusCode===304)throw new a.UserDataSyncStoreError("Empty response",A,"EmptyResponse",q.res.statusCode,q.res.headers[a.HEADER_OPERATION_ID]);_={ref:M,content:B}}return _}async write(F,W,$,A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",F).toString();A={...A},A["Content-Type"]=P.Mimes.text,$&&(A["If-Match"]=$);const _=await this.request(q,{type:"POST",data:W,headers:A},[],L.CancellationToken.None),M=_.res.headers.etag;if(!M)throw new a.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",_.res.statusCode,_.res.headers[a.HEADER_OPERATION_ID]);return M}async manifest(F,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();W={...W},W["Content-Type"]="application/json",F&&(W["If-None-Match"]=F.ref);const A=await this.request($,{type:"GET",headers:W},[304],L.CancellationToken.None);let q=null;if(A.res.statusCode===304&&(q=F),!q){const M=A.res.headers.etag;if(!M)throw new a.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",A.res.statusCode,A.res.headers[a.HEADER_OPERATION_ID]);const B=await(0,m.asText)(A);if(!B&&A.res.statusCode===304)throw new a.UserDataSyncStoreError("Empty response",$,"EmptyResponse",A.res.statusCode,A.res.headers[a.HEADER_OPERATION_ID]);B&&(q={...JSON.parse(B),ref:M})}const _=this.storageService.get(s,0);return _&&q&&_!==q.session&&this.clearSession(),q===null&&_&&this.clearSession(),q&&this.storageService.store(s,q.session,0,1),q}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),W={"Content-Type":P.Mimes.text};await this.request(F,{type:"DELETE",headers:W},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(n,0)}async request(F,W,$,A){if(!this.authToken)throw new a.UserDataSyncStoreError("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new a.UserDataSyncStoreError(`${W.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const q=await this.commonHeadersPromise;W.headers={...W.headers||{},...q,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(W.headers),this.logService.trace("Sending request to server",{url:F,type:W.type,headers:{...W.headers,authorization:void 0}});let _;try{_=await this.session.request(F,W,A)}catch(H){if(!(H instanceof a.UserDataSyncStoreError)){let j="RequestFailed";const Q=(0,R.getErrorMessage)(H).toLowerCase();Q.includes("xhr timeout")?j="RequestTimeout":Q.includes("protocol")&&Q.includes("not supported")?j="RequestProtocolNotSupported":Q.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":Q.includes("headers must be an object")?j="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(H)&&(j="RequestCanceled"),H=new a.UserDataSyncStoreError(`Connection refused for the request '${F}'.`,F,j,void 0,void 0)}throw this.logService.info("Request failed",F),H}const M=_.res.headers[a.HEADER_OPERATION_ID],B={url:F,status:_.res.statusCode,"execution-id":W.headers[a.HEADER_EXECUTION_ID],"operation-id":M},Z=(0,m.isSuccess)(_)||_.res.statusCode&&$.indexOf(_.res.statusCode)!==-1;if(Z?this.logService.trace("Request succeeded",B):this.logService.info("Request failed",B),_.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new a.UserDataSyncStoreError(`Request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",_.res.statusCode,M);if(this._onTokenSucceed.fire(),_.res.statusCode===409)throw new a.UserDataSyncStoreError(`${W.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",_.res.statusCode,M);if(_.res.statusCode===410)throw new a.UserDataSyncStoreError(`${W.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",_.res.statusCode,M);if(_.res.statusCode===412)throw new a.UserDataSyncStoreError(`${W.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",_.res.statusCode,M);if(_.res.statusCode===413)throw new a.UserDataSyncStoreError(`${W.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",_.res.statusCode,M);if(_.res.statusCode===426)throw new a.UserDataSyncStoreError(`${W.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",_.res.statusCode,M);if(_.res.statusCode===429){const H=_.res.headers["retry-after"];throw H?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(H)*1e3)),new a.UserDataSyncStoreError(`${W.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",_.res.statusCode,M)):new a.UserDataSyncStoreError(`${W.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",_.res.statusCode,M)}if(!Z)throw new a.UserDataSyncStoreError("Server returned "+_.res.statusCode,F,"Unknown",_.res.statusCode,M);return _}addSessionHeaders(F){let W=this.storageService.get(n,0);W===void 0&&(W=(0,d.generateUuid)(),this.storageService.store(n,W,0,1)),F["X-Machine-Session-Id"]=W;const $=this.storageService.get(s,0);$!==void 0&&(F["X-User-Session-Id"]=$)}};f=de([G(1,y.IProductService),G(2,m.IRequestService),G(3,a.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,E.IFileService),G(6,g.IStorageService)],f),e.UserDataSyncStoreClient=f;let p=class extends f{constructor(F,W,$,A,q,_,M){super(F.userDataSyncStore?.url,W,$,A,q,_,M);this._register(F.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(F.userDataSyncStore?.url)))}};p=de([G(0,a.IUserDataSyncStoreManagementService),G(1,y.IProductService),G(2,m.IRequestService),G(3,a.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,E.IFileService),G(6,g.IStorageService)],p),e.UserDataSyncStoreService=p;class k{constructor(F,W,$,A){this.limit=F,this.interval=W,this.requestService=$,this.logService=A,this.requests=[],this.startTime=void 0}request(F,W,$){if(this.isExpired()&&this.reset(),W.url=F,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new a.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(F),this.requestService.request(W,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=k}),define(te[235],ne([0,1,3,60,26,23,22,99,24,63,64]),function(J,e,D,L,R,T,i,P,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends P.UserDataAutoSyncService{constructor(v,h,E,y,m,w,g,a,l,r,s,n){super(v,h,E,y,m,g,a,l,r,s,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(w.onDidFocusWindow,()=>"windowFocus"),D.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(t,o)=>t?[...t,o]:[o],1e3)(t=>this.triggerSync(t,!0,!1)))}};b=de([G(0,R.IProductService),G(1,S.IUserDataSyncStoreManagementService),G(2,S.IUserDataSyncStoreService),G(3,S.IUserDataSyncResourceEnablementService),G(4,S.IUserDataSyncService),G(5,L.INativeHostService),G(6,S.IUserDataSyncLogService),G(7,C.IUserDataSyncAccountService),G(8,i.ITelemetryService),G(9,I.IUserDataSyncMachinesService),G(10,T.IStorageService),G(11,S.IUserDataAutoSyncEnablementService)],b),e.UserDataAutoSyncService=b}),define(te[236],ne([0,1,5,3,2]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:S,getActiveWindowId:C}){super();this.disposables=this._register(new R.DisposableStore),L.Event.latch(L.Event.any(P,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>C()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch(b){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[65],ne([0,1,51,5,10,15,20,125,248,249]),function(J,e,D,L,R,T,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(r,s){let n=s.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=s}}e.ExtractError=I;function b(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(s=>r&s).reduce((s,n)=>s+n,r&61440)}function d(l){if(l instanceof I)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new I(r,l)}function v(l,r,s,n,t,o){const c=R.dirname(r),u=R.join(n,c);if(!u.startsWith(n))return Promise.reject(new Error(P.localize(0,null,r)));const f=R.join(n,r);let p;return o.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(i.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((k,O)=>{if(!o.isCancellationRequested)try{p=(0,D.createWriteStream)(f,{mode:s}),p.once("close",()=>k()),p.once("error",O),l.once("error",O),l.pipe(p)}catch(F){O(F)}}))}function h(l,r,s,n){let t=(0,L.createCancelablePromise)(()=>Promise.resolve()),o=0;return n.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((c,u)=>{const f=new L.Sequencer,p=k=>{k.isCancellationRequested||(o++,l.readEntry())};l.once("error",u),l.once("close",()=>t.then(()=>{n.isCancellationRequested||l.entryCount===o?c():u(new I("Incomplete",new Error(P.localize(1,null,o,l.entryCount))))},u)),l.readEntry(),l.on("entry",k=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(k.fileName)){p(n);return}const O=k.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(O)){const $=R.join(r,O);t=(0,L.createCancelablePromise)(A=>i.Promises.mkdir($,{recursive:!0}).then(()=>p(A)).then(void 0,u));return}const F=y(l,k),W=b(k);t=(0,L.createCancelablePromise)($=>f.queue(()=>F.then(A=>v(A,O,W,r,s,$).then(()=>p($)))).then(null,u))})})}function E(l,r=!1){return new Promise((s,n)=>{(0,S.open)(l,r?{lazyEntries:!0}:void 0,(t,o)=>{t?n(d(t)):s((0,T.assertIsDefined)(o))})})}function y(l,r){return new Promise((s,n)=>{l.openReadStream(r,(t,o)=>{t?n(d(t)):s((0,T.assertIsDefined)(o))})})}function m(l,r){return new Promise((s,n)=>{const t=new C.ZipFile;r.forEach(c=>{c.contents?t.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&t.addFile(c.localPath,c.path)}),t.end();const o=(0,D.createWriteStream)(l);t.outputStream.pipe(o),t.outputStream.once("error",n),o.once("error",n),o.once("finish",()=>s(l))})}e.zip=m;function w(l,r,s={},n){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=E(l,!0);return s.overwrite&&(o=o.then(c=>i.Promises.rm(r).then(()=>c))),o.then(c=>h(c,r,{sourcePathRegex:t},n))}e.extract=w;function g(l,r){return E(l).then(s=>new Promise((n,t)=>{s.on("entry",o=>{o.fileName===r&&y(s,o).then(c=>n(c),c=>t(c))}),s.once("close",()=>t(new Error(P.localize(2,null,r))))}))}function a(l,r){return g(l,r).then(s=>new Promise((n,t)=>{const o=[];s.once("error",t),s.on("data",c=>o.push(c)),s.on("end",()=>n(Buffer.concat(o)))}))}e.buffer=a}),define(te[237],ne([0,1,65,134]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(T){return(0,D.buffer)(T,"extension/package.json").then(i=>{try{return JSON.parse(i.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(te[238],ne([0,1,17,5,9,2,16,10,4,18,61,7,29,20,65,135,11,30,36,156,14,8,26]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g,a,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let s=class extends T.Disposable{constructor(t,o,c,u,f){super();this.beforeRemovingExtension=t,this.fileService=o,this.logService=c,this.environmentService=u,this.productService=f,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const o=[];(t===null||t===0)&&o.push(this.scanSystemExtensions().then(null,c=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(c).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&o.push(this.scanUserExtensions(!0).then(null,c=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(c).message,m.ExtensionManagementErrorCode.Internal))));try{const c=await Promise.all(o);return(0,D.flatten)(c)}catch(c){throw this.joinErrors(c)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[o,c]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return c=c.filter(u=>!o[new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),t&&(c=(0,w.groupByExtension)(c,f=>f.identifier).map(f=>f.sort((p,k)=>I.rcompare(p.manifest.version,k.manifest.version))[0])),this.logService.trace("Scanned user extensions:",c.length),c}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,o,c,u){const f=t.key(),p=P.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),k=P.join(this.extensionsPath,f);try{await v.Promises.rm(k)}catch(F){try{await v.Promises.rm(k)}catch(W){}throw new m.ExtensionManagementError((0,E.localize)(0,null,k,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,o,p,u);let O=await this.scanExtension(b.URI.file(p),1);if(!O)throw new Error((0,E.localize)(1,null,p));await this.storeMetadata(O,{...c,installedTimestamp:Date.now()});try{await this.rename(t,p,k,Date.now()+2*60*1e3),this.logService.info("Renamed to",k)}catch(F){try{await v.Promises.rm(p)}catch(W){}if(F.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(F)}. Deleted from extracted location`,p),F}try{O=await this.scanExtension(b.URI.file(k),1)}catch(F){}if(O)return O;throw new Error((0,E.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,o){return this.setMetadata(t,o),await this.storeMetadata(t,{...o,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const c=P.join(t.location.fsPath,"package.json"),u=await v.Promises.readFile(c,"utf8"),{manifest:f}=await this.parseManifest(u);return f.__metadata=o,await v.Promises.writeFile(c,JSON.stringify(f,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const o=t.map(c=>new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version));await this.withUninstalledExtensions(c=>{o.forEach(u=>c[u.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(u=>delete u[t.key()]);const c=(await this.scanExtensions(1)).find(u=>new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(t))||null;return c?(await this.storeMetadata(c,{installedTimestamp:Date.now()}),this.scanExtension(c.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await v.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let c={};if(o)try{c=JSON.parse(o)}catch(u){}return t&&(t(c),Object.keys(c).length?await v.Promises.writeFile(this.uninstalledPath,JSON.stringify(c)):await v.Promises.rm(this.uninstalledPath)),c})}async removeExtension(t,o){this.logService.trace(`Deleting ${o} extension from disk`,t.identifier.id,t.location.fsPath),await v.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,o,c,u){this.logService.trace(`Started extracting the extension from ${o} to ${c}`);try{await v.Promises.rm(c)}catch(f){throw new m.ExtensionManagementError(this.joinErrors(f).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(o,c,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${c}:`,t.id)}catch(f){try{await v.Promises.rm(c)}catch(k){}let p=m.ExtensionManagementErrorCode.Extract;throw f instanceof h.ExtractError&&(f.type==="CorruptZip"?p=m.ExtensionManagementErrorCode.CorruptZip:f.type==="Incomplete"&&(p=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(f.message,p)}}async rename(t,o,c,u){try{await v.Promises.rename(o,c)}catch(f){if(S.isWindows&&f&&f.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${o} to ${c} with 'EPERM' error. Trying again...`,t.id),this.rename(t,o,c,u);throw new m.ExtensionManagementError(f.message||(0,E.localize)(3,null,o,c),f.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const o=this.scanDevSystemExtensions(),[c,u]=await Promise.all([t,o]);return[...c,...u]}async scanExtensionsInDir(t,o){const c=new L.Limiter(10),u=await this.fileService.resolve(b.URI.file(t));return u.children?(await Promise.all(u.children.filter(p=>p.isDirectory).map(p=>c.queue(async()=>o===1&&(0,C.basename)(p.resource).indexOf(".")===0?null:this.scanExtension(p.resource,o))))).filter(p=>p&&p.identifier):[]}async scanExtension(t,o){try{const c=await this.fileService.resolve(t);if(c.children){const{manifest:u,metadata:f}=await this.readManifest(t.fsPath),p=c.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,k=c.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,O={id:(0,w.getGalleryExtensionId)(u.publisher,u.name)},F={type:o,identifier:O,manifest:u,location:t,readmeUrl:p,changelogUrl:k,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return f&&this.setMetadata(F,f),F}}catch(c){o!==0&&this.logService.trace(c)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(c=>t.some(u=>(0,w.areSameExtensions)(c.identifier,{id:u})))}else return[]}setMetadata(t,o){t.publisherDisplayName=o.publisherDisplayName||null,t.publisherId=o.publisherId||null,t.identifier.uuid=o.id,t.isMachineScoped=!!o.isMachineScoped,t.isPreReleaseVersion=!!o.isPreReleaseVersion,t.hadPreReleaseVersion=!!o.hadPreReleaseVersion,t.isBuiltin=t.type===0||!!o.isBuiltin,t.installedTimestamp=o.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),c=new Set;for(const p of o)t[new w.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]||c.add(p.identifier.id.toLowerCase());const u=(0,w.groupByExtension)(o,p=>p.identifier);await L.Promises.settled(u.map(async p=>{const k=p.sort((O,F)=>I.rcompare(O.manifest.version,F.manifest.version))[0];c.has(k.identifier.id.toLowerCase())||await this.beforeRemovingExtension(k)}));const f=o.filter(p=>t[new w.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]);await L.Promises.settled(f.map(p=>this.removeUninstalledExtension(p)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),o=[],c=(0,w.groupByExtension)(t,u=>u.identifier);o.push(...(0,D.flatten)(c.map(u=>u.sort((f,p)=>I.rcompare(f.manifest.version,p.manifest.version)).slice(1)))),await L.Promises.settled(o.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const o=Array.isArray(t)?t:[t];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((c,u)=>new Error(`${c.message}${c.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(i.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const o=[v.Promises.readFile(P.join(t,"package.json"),"utf8").then(p=>this.parseManifest(p)),v.Promises.readFile(P.join(t,"package.nls.json"),"utf8").then(void 0,p=>p.code!=="ENOENT"?Promise.reject(p):"{}").then(p=>JSON.parse(p))],[{manifest:c,metadata:u},f]=await Promise.all(o);return{manifest:(0,g.localizeManifest)(c,f),metadata:u}}parseManifest(t){return new Promise((o,c)=>{try{const u=JSON.parse(t),f=u.__metadata||null;o({manifest:u,metadata:f})}catch(u){c(new Error((0,E.localize)(4,null)))}})}};s=de([G(1,a.IFileService),G(2,l.ILogService),G(3,y.INativeEnvironmentService),G(4,r.IProductService)],s),e.ExtensionsScanner=s}),define(te[239],ne([0,1,38,9,16,10,4,32,18,61,7,29,20,65,133,79,11,202,30,36,186,175,237,187,238,216,76,14,6,8,26,22,37]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g,a,l,r,s,n,t,o,c,u,f,p,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let F=class extends m.AbstractExtensionManagementService{constructor(M,B,Z,H,j,Q,U,N,z){super(M,B,Z,N);this.environmentService=H,this.downloadService=j,this.fileService=U;const x=this._register(Q.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(Q.createInstance(n.ExtensionsScanner,ee=>x.postUninstall(ee))),this.manifestCache=this._register(new s.ExtensionsManifestCache(H,this)),this.extensionsDownloader=this._register(Q.createInstance(a.ExtensionsDownloader));const K=this._register(new t.ExtensionsWatcher(this,U,H,Z,z));this._register(K.onDidChangeExtensionsByAnotherSource(({added:ee,removed:V})=>{ee.length&&this._onDidInstallExtensions.fire(ee.map(X=>({identifier:X.identifier,operation:0,local:X}))),V.forEach(X=>this._onDidUninstallExtension.fire({identifier:X}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const M=await this.isAlpineLinux(),B=(0,w.getTargetPlatform)(M?"alpine":i.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",B),B})()),this._targetPlatformPromise}async isAlpineLinux(){if(!i.isLinux)return!1;let M;try{M=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch(B){try{M=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(Z){this.logService.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(Z))}}return!!M&&(M.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const B=await this.collectFiles(M),Z=await(0,v.zip)((0,S.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)()).fsPath,B);return I.URI.file(Z)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const B=await this.downloadVsix(M),Z=T.resolve(B.fsPath);return(0,r.getManifest)(Z)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async install(M,B={}){this.logService.trace("ExtensionManagementService#install",M.toString());const Z=await this.downloadVsix(M),H=await(0,r.getManifest)(T.resolve(Z.fsPath));if(H.engines&&H.engines.vscode&&!(0,o.isEngineValid)(H.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,g.getGalleryExtensionId)(H.publisher,H.name),this.productService.version));return this.installExtension(H,Z,B)}async updateMetadata(M,B){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},...B}),this.manifestCache.invalidate(),M}async updateExtensionScope(M,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:B}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===R.Schemas.file)return M;const B=(0,S.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)());return await this.downloadService.download(M,B),B}createInstallExtensionTask(M,B,Z){return I.URI.isUri(B)?new A(M,B,Z,this.galleryService,this.extensionsScanner,this.logService):new $(B,Z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,B){return new q(M,B,this.extensionsScanner)}async collectFiles(M){const B=async H=>{let j=await d.Promises.readdir(H);j=j.map(N=>T.join(H,N));const Q=await Promise.all(j.map(N=>d.Promises.stat(N)));let U=Promise.resolve([]);return Q.forEach((N,z)=>{const x=j[z];N.isFile()&&(U=U.then(K=>[...K,x])),N.isDirectory()&&(U=U.then(K=>B(x).then(ee=>[...K,...ee])))}),U};return(await B(M.location.fsPath)).map(H=>({path:`extension/${T.relative(M.location.fsPath,H)}`,localPath:H}))}};F=de([G(0,w.IExtensionGalleryService),G(1,k.ITelemetryService),G(2,f.ILogService),G(3,y.INativeEnvironmentService),G(4,E.IDownloadService),G(5,u.IInstantiationService),G(6,c.IFileService),G(7,p.IProductService),G(8,O.IUriIdentityService)],F),e.ExtensionManagementService=F;class W extends m.AbstractExtensionTask{constructor(M,B,Z,H){super();this.identifier=M,this.source=B,this.extensionsScanner=Z,this.logService=H,this._operation=1}get operation(){return this._operation}async installExtension(M,B){try{const Z=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(Z)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(Z,{...Z.manifest.__metadata||{},...M.metadata}):Z}catch(Z){throw i.isMacintosh?new w.ExtensionManagementError(h.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(h.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(M,B)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const Z=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),Z}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:B,metadata:Z},H){let j=await this.extensionsScanner.extractUserExtension(B,M,Z,H);return this.logService.info("Extracting completed.",B.id),j}}class $ extends W{constructor(M,B,Z,H,j){super(M.identifier,M,H,j);this.gallery=M,this.options=B,this.extensionsDownloader=Z}async doRun(M){const Z=(await this.extensionsScanner.scanExtensions(null)).find(j=>(0,g.areSameExtensions)(j.identifier,this.gallery.identifier));Z&&(this._operation=2);const H=await this.downloadInstallableExtension(this.gallery,this._operation);H.metadata.isMachineScoped=this.options.isMachineScoped||Z?.isMachineScoped,H.metadata.isBuiltin=this.options.isBuiltin||Z?.isBuiltin,H.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,H.metadata.hadPreReleaseVersion=this.gallery.properties.isPreReleaseVersion||Z?.hadPreReleaseVersion;try{const j=await this.installExtension(H,M);return Z&&C.neq(Z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(Z),j}catch(j){throw await this.deleteDownloadedVSIX(H.zipPath),j}}async deleteDownloadedVSIX(M){try{await this.extensionsDownloader.delete(I.URI.file(M))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",M.toString(),(0,L.getErrorMessage)(B))}}async downloadInstallableExtension(M,B){const Z={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let H;try{this.logService.trace("Started downloading extension:",M.identifier.id),H=(await this.extensionsDownloader.downloadExtension(M,B)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,H)}catch(j){throw new w.ExtensionManagementError((0,m.joinErrors)(j).message,w.ExtensionManagementErrorCode.Download)}try{const j=await(0,r.getManifest)(H);return{zipPath:H,identifierWithVersion:new g.ExtensionIdentifierWithVersion(M.identifier,j.version),metadata:Z}}catch(j){throw await this.deleteDownloadedVSIX(H),new w.ExtensionManagementError((0,m.joinErrors)(j).message,w.ExtensionManagementErrorCode.Invalid)}}}class A extends W{constructor(M,B,Z,H,j,Q){super({id:(0,g.getGalleryExtensionId)(M.publisher,M.name)},B,j,Q);this.manifest=M,this.location=B,this.options=Z,this.galleryService=H}async doRun(M){const B=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),H=(await this.extensionsScanner.scanExtensions(1)).find(Q=>(0,g.areSameExtensions)(this.identifier,Q.identifier)),j=await this.getMetadata(this.identifier.id,M);if(j.isMachineScoped=this.options.isMachineScoped||H?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||H?.isBuiltin,H)if(this._operation=2,B.equals(new g.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version)))try{await this.extensionsScanner.removeExtension(H,"existing")}catch(Q){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else C.gt(H.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(H);else{const Q=await this.unsetUninstalledAndGetLocal(B);if(Q)try{await this.extensionsScanner.removeExtension(Q,"existing")}catch(U){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:B,metadata:j},M)}async getMetadata(M,B){try{const Z=(await this.galleryService.query({names:[M],pageSize:1},B)).firstPage[0];if(Z)return{id:Z.identifier.uuid,publisherDisplayName:Z.publisherDisplayName,publisherId:Z.publisherId}}catch(Z){}return{}}}class q extends m.AbstractExtensionTask{constructor(M,B,Z){super();this.extension=M,this.options=B,this.extensionsScanner=Z}async doRun(M){const B=[],Z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const H=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);B.push(...Z.filter(j=>H.equals(new g.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else B.push(...Z.filter(H=>(0,g.areSameExtensions)(H.identifier,this.extension.identifier)));if(!B.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const H of B)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(H)}catch(j){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(j)))}}}}),define(te[240],ne([0,1,81,57,33,19,9,3,2,10,4,29,34,71,250]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{constructor(u){this.socket=u,this._errorListener=f=>{if(f){if(f.code==="EPIPE")return;(0,i.onUnexpectedError)(f)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const f=p=>u(T.VSBuffer.wrap(p));return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(u){const f=p=>{u({type:0,hadError:p,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,i.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,i.onUnexpectedError)(f)}}end(){this.socket.end()}drain(){return new Promise((u,f)=>{if(this.socket.bufferSize===0){u();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),u()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=E;var y;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var m;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(m||(m={}));class w extends S.Disposable{constructor(u,f,p,k){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=f,this._recordInflateBytes=k,f?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,i.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),p&&(this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,i.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new v.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):T.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let f=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.length-4),this._isEnded||this._write(T.VSBuffer.wrap(f),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,f){let p=2;u.byteLength<126?p+=0:u.byteLength<2**16?p+=2:p+=8;const k=T.VSBuffer.alloc(p);if(f?k.writeUInt8(194,0):k.writeUInt8(130,0),u.byteLength<126)k.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){k.writeUInt8(126,1);let O=1;k.writeUInt8(u.byteLength>>>8&255,++O),k.writeUInt8(u.byteLength>>>0&255,++O)}else{k.writeUInt8(127,1);let O=1;k.writeUInt8(0,++O),k.writeUInt8(0,++O),k.writeUInt8(0,++O),k.writeUInt8(0,++O),k.writeUInt8(u.byteLength>>>24&255,++O),k.writeUInt8(u.byteLength>>>16&255,++O),k.writeUInt8(u.byteLength>>>8&255,++O),k.writeUInt8(u.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=k.byteLength+u.byteLength,this.socket.write(T.VSBuffer.concat([k,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),p=f.readUInt8(0),k=(p&128)>>>7,O=(p&64)>>>6,F=f.readUInt8(1),W=(F&128)>>>7,$=F&127;this._state.state=2,this._state.readLen=2+(W?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=k,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(k),this._state.mask=0}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),p=f.readUInt8(1),k=(p&128)>>>7;let O=p&127,F=1;O===126?O=f.readUInt8(++F)*2**8+f.readUInt8(++F):O===127&&(O=f.readUInt8(++F)*0+f.readUInt8(++F)*0+f.readUInt8(++F)*0+f.readUInt8(++F)*0+f.readUInt8(++F)*2**24+f.readUInt8(++F)*2**16+f.readUInt8(++F)*2**8+f.readUInt8(++F));let W=0;k&&(W=f.readUInt8(++F)*2**24+f.readUInt8(++F)*2**16+f.readUInt8(++F)*2**8+f.readUInt8(++F)),this._state.state=3,this._state.readLen=O,this._state.mask=W}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);g(f,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(f.buffer)),this._zlibInflate.write(f.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const p=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=p.length,this._onData.fire(T.VSBuffer.wrap(p))})):(this._totalIncomingDataBytes+=f.byteLength,this._onData.fire(f))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=w;function g(c,u){if(u===0)return;let f=c.byteLength>>>2;for(let $=0;$<f;$++){const A=c.readUInt32BE($*4);c.writeUInt32BE(A^u,$*4)}let p=f*4,k=c.byteLength-p;const O=u>>>24&255,F=u>>>16&255,W=u>>>8&255;k>=1&&c.writeUInt8(c.readUInt8(p)^O,p),k>=2&&c.writeUInt8(c.readUInt8(p+1)^F,p+1),k>=3&&c.writeUInt8(c.readUInt8(p+2)^W,p+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function l(){const c=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):u=(0,C.join)((0,R.tmpdir)(),`vscode-ipc-${c}.sock`),s(u),u}e.createRandomIPCHandle=l;function r(c,u,f){const p=(0,D.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${f}-${u}-sock`;let k;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?k=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${f}-${u}.sock`):k=(0,C.join)(c,`${f}-${u}.sock`),s(k),k}e.createStaticIPCHandle=r;function s(c){const u=a[I.platform];typeof u=="number"&&c.length>=u&&console.warn(`WARNING: IPC handle "${c}" is longer than ${u} chars, try a shorter --user-data-dir`)}class n extends d.IPCServer{constructor(u){super(n.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const f=P.Event.fromNodeEventEmitter(u,"connection");return P.Event.map(f,p=>({protocol:new v.Protocol(new E(p)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(p,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function t(c){return new Promise((u,f)=>{const p=(0,L.createServer)();p.on("error",f),p.listen(c,()=>{p.removeListener("error",f),u(new n(p))})})}e.serve=t;function o(c,u){return new Promise((f,p)=>{const k=(0,L.createConnection)(c,()=>{k.removeListener("error",p),f(v.Client.fromSocket(new E(k),u))});k.once("error",p)})}e.connect=o}),define(te[241],ne([0,1,57,240]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,T,i,P){const S=I=>P(I,void 0),C=D.createConnection({host:R,port:T},()=>{C.removeListener("error",S);const I=Buffer.alloc(16);for(let h=0;h<16;h++)I[h]=Math.round(Math.random()*256);const b=I.toString("base64");let d=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${T}/?${i}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${b}`];C.write(d.join(`\r
`)+`\r
\r
`);const v=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",v),P(void 0,new L.NodeSocket(C)))};C.on("data",v)});C.once("error",S)}}}),define(te[242],ne([0,1,57,115,241,5,2,21,8,26,184,62,91]),function(J,e,D,L,R,T,i,P,S,C,I,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(w,g,a,l,r){let s;for(let n=3;n&&(s&&s.dispose(),s=await new h(w,g,a,l,r).waitForReady(),!(r&&L.BROWSER_RESTRICTED_PORTS[r]||!L.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));n--);return s}class h extends i.Disposable{constructor(g,a,l,r,s){super();this.defaultTunnelHost=a,this.suggestedLocalPort=s,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let g=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(g){g.pause();const a=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,I.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),r=l.getSocket().socket,s=l.readEntireBuffer();l.dispose(),s.byteLength>0&&g.write(s.buffer),g.on("end",()=>{this._socketsDispose.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{this._socketsDispose.delete(g.localAddress),r.destroy()}),r.on("end",()=>g.end()),r.on("close",()=>g.end()),r.on("error",()=>{g.destroy()}),g.pipe(r),r.pipe(g),this._socketsDispose.set(g.localAddress,()=>{g.end(),r.end()})}}let E=class extends b.AbstractTunnelService{constructor(g,a,l,r,s){super(a);this.socketFactory=g,this.signService=l,this.productService=r,this.configurationService=s}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,a,l,r,s,n,t){const o=this.getTunnelFromMap(a,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,r,s,n,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${r}.`);const c={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},u=v(c,this.defaultTunnelHost,a,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,u),u}}};E=de([G(1,S.ILogService),G(2,d.ISignService),G(3,C.IProductService),G(4,P.IConfigurationService)],E),e.BaseTunnelService=E;let y=class extends E{constructor(g,a,l,r){super(R.nodeSocketFactory,g,a,l,r)}};y=de([G(0,S.ILogService),G(1,d.ISignService),G(2,C.IProductService),G(3,P.IConfigurationService)],y),e.TunnelService=y;let m=class extends i.Disposable{constructor(g,a,l,r){super();this.logService=g,this.productService=a,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(g,a,l,r,s,n,t,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${s}.`),!this._tunnelServices.has(g)){const c=new y(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(g,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(a,l,r,s,n,t,o)}};m=de([G(0,S.ILogService),G(1,C.IProductService),G(2,d.ISignService),G(3,P.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[251],ne([0,1,72,33,38,9,2,16,18,7,34,119,180,161,181,172,173,174,159,163,21,182,78,201,79,192,11,154,197,205,30,162,203,239,80,157,14,177,179,53,6,169,83,170,171,59,188,8,85,60,86,26,191,43,23,199,200,22,92,93,94,44,206,207,95,209,215,97,98,99,24,63,228,229,230,64,231,232,233,234,235,236,91,196,62,242,189,190,90,195,84,204,37,217]),function(J,e,D,L,R,T,i,P,S,C,I,b,d,v,h,E,y,m,w,g,a,l,r,s,n,t,o,c,u,f,p,k,O,F,W,$,A,q,_,M,B,Z,H,j,Q,U,N,z,x,K,ee,V,X,se,oe,le,he,be,Ce,we,ve,De,Se,Ie,Me,je,Ne,We,ie,ae,ce,ye,Pe,_e,Te,Fe,Ae,Ue,Y,re,ue,fe,pe,ge,Ee,Re,ke,Le,$e,Ye,He,Ct,It,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Rt extends i.Disposable{constructor(me){super();this.configuration=me,this.server=this._register(new b.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const me=()=>this.dispose();process.once("exit",me),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",me);const Oe="vscode:electron-main->shared-process=disposeWorker",qe=(Ge,ze)=>this.onDisposeWorker(ze);D.ipcRenderer.on(Oe,qe),this._register((0,i.toDisposable)(()=>D.ipcRenderer.removeListener(Oe,qe)))}onDisposeWorker(me){this.sharedProcessWorkerService?.disposeWorker(me)}async open(){const me=await this.initServices();(0,ce.registerConfiguration)(),me.invokeFunction(Oe=>{const qe=Oe.get(z.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(qe)}),this._register((0,i.combinedDisposable)(me.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),me.createInstance(h.LanguagePackCachedDataCleaner),me.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),me.createInstance(y.LogsDataCleaner),me.createInstance(E.LocalizationsUpdater),me.createInstance(v.DeprecatedExtensionsCleaner)))}async initServices(){const me=new H.ServiceCollection,Oe={_serviceBrand:void 0,...ee.default};me.set(V.IProductService,Oe);const qe=new I.StaticRouter(xe=>xe==="main"),Ge=new j.MessagePortMainProcessService(this.server,qe);me.set(Q.IMainProcessService,Ge);const ze=new c.NativeEnvironmentService(this.configuration.args,Oe);me.set(o.INativeEnvironmentService,ze);const rt=new x.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Qe=new x.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ge.getChannel("logger"));me.set(z.ILoggerService,Qe);const at=this._register(new z.MultiplexLogService([this._register(new z.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,S.joinPath)(C.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new x.FollowerLogService(rt,at));me.set(z.ILogService,Je),this.sharedProcessWorkerService=new Ye.SharedProcessWorkerService(Je,Oe,ze),me.set($e.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Xe=this._register(new q.FileService(Je));me.set(A.IFileService,Xe);const ct=this._register(new _.DiskFileSystemProvider(Je));Xe.registerProvider(P.Schemas.file,ct);const Be=this._register(new l.ConfigurationService(ze.settingsResource,Xe));me.set(a.IConfigurationService,Be);const tt=new le.NativeStorageService(void 0,Ge,ze);me.set(oe.IStorageService,tt),this._register((0,i.toDisposable)(()=>tt.flush())),await Promise.all([Be.initialize(),tt.initialize()]),me.set(He.IUserConfigurationFileService,I.ProxyChannel.toService(Ge.getChannel(He.UserConfigurationFileServiceId))),me.set(It.IUriIdentityService,new Pt.UriIdentityService(Xe)),me.set(se.IRequestService,new M.SyncDescriptor(X.RequestService)),me.set(w.IChecksumService,new M.SyncDescriptor(g.ChecksumService));const st=I.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});me.set(K.INativeHostService,st),me.set(n.IDownloadService,new M.SyncDescriptor(t.DownloadService));const lt=this._register(new fe.ActiveWindowManager(st)),ut=new I.StaticRouter(xe=>lt.getActiveClientId().then(dt=>xe===dt));me.set(W.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Ct.AssignmentService(this.configuration.machineId,Be,Oe);let nt;const Ze=[];if((0,De.supportsTelemetry)(Oe,ze)){const xe=new we.TelemetryLogAppender(Qe,ze);Ze.push(xe);const{appRoot:dt,extensionsPath:Tt,installSourcePath:Lt}=ze;if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const ot=await ht.getTreatment("telemetryMigration")??!1,ft=Oe.quality!=="stable";if(ft&&ot){const wt=new Se.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ot,!0);this._register((0,i.toDisposable)(()=>wt.flush())),Ze.push(wt)}const St=new Se.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ft?!1:ot,ot&&ft);this._register((0,i.toDisposable)(()=>St.flush())),Ze.push(St)}nt=new ve.TelemetryService({appenders:Ze,commonProperties:(0,he.resolveCommonProperties)(Xe,(0,L.release)(),(0,L.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,Lt),sendErrorTelemetry:!0,piiPaths:[dt,Tt]},Be)}else{nt=De.NullTelemetryService;const xe=De.NullAppender;Ze.push(xe)}this.server.registerChannel("telemetryAppender",new Ce.TelemetryAppenderChannel(Ze)),me.set(be.ITelemetryService,nt);const kt=new Ie.CustomEndpointTelemetryService(Be,nt,Qe,ze);me.set(be.ICustomEndpointTelemetryService,kt),me.set(p.IExtensionManagementService,new M.SyncDescriptor(F.ExtensionManagementService)),me.set(p.IExtensionGalleryService,new M.SyncDescriptor(f.ExtensionGalleryService)),me.set(p.IExtensionTipsService,new M.SyncDescriptor(O.ExtensionTipsService)),me.set(U.ILocalizationsService,new M.SyncDescriptor(N.LocalizationsService)),me.set(r.IDiagnosticsService,new M.SyncDescriptor(s.DiagnosticsService)),me.set(ye.IUserDataSyncAccountService,new M.SyncDescriptor(ye.UserDataSyncAccountService)),me.set(ce.IUserDataSyncLogService,new M.SyncDescriptor(Te.UserDataSyncLogService)),me.set(ce.IUserDataSyncUtilService,new _e.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",xe=>xe.ctx!=="main"))),me.set(p.IGlobalExtensionEnablementService,new M.SyncDescriptor(u.GlobalExtensionEnablementService)),me.set(ie.IIgnoredExtensionsManagementService,new M.SyncDescriptor(ie.IgnoredExtensionsManagementService)),me.set(We.IExtensionsStorageSyncService,new M.SyncDescriptor(We.ExtensionsStorageSyncService)),me.set(ce.IUserDataSyncStoreManagementService,new M.SyncDescriptor(re.UserDataSyncStoreManagementService)),me.set(ce.IUserDataSyncStoreService,new M.SyncDescriptor(re.UserDataSyncStoreService)),me.set(Fe.IUserDataSyncMachinesService,new M.SyncDescriptor(Fe.UserDataSyncMachinesService)),me.set(ce.IUserDataSyncBackupStoreService,new M.SyncDescriptor(Pe.UserDataSyncBackupStoreService)),me.set(ce.IUserDataAutoSyncEnablementService,new M.SyncDescriptor(ae.UserDataAutoSyncEnablementService)),me.set(ce.IUserDataSyncResourceEnablementService,new M.SyncDescriptor(Ae.UserDataSyncResourceEnablementService)),me.set(ce.IUserDataSyncService,new M.SyncDescriptor(Ue.UserDataSyncService));const yt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Be.getValue("terminal.integrated.persistentSessionScrollback")??100},Be,ze,Je,nt);return await yt.initialize(),me.set(je.ILocalPtyService,this._register(yt)),me.set(pe.ISignService,new M.SyncDescriptor(ge.SignService)),me.set(Ee.ISharedTunnelsService,new M.SyncDescriptor(Re.SharedTunnelsService)),me.set(ke.ISharedProcessTunnelService,new M.SyncDescriptor(Le.SharedProcessTunnelService)),new Z.InstantiationService(me)}initChannels(me){const Oe=new k.ExtensionManagementChannel(me.get(p.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const qe=I.ProxyChannel.fromService(me.get(U.ILocalizationsService));this.server.registerChannel("localizations",qe);const Ge=I.ProxyChannel.fromService(me.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const ze=new k.ExtensionTipsChannel(me.get(p.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const rt=I.ProxyChannel.fromService(me.get(w.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=new _e.UserDataSyncMachinesServiceChannel(me.get(Fe.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Qe);const at=I.ProxyChannel.fromService(me.get(be.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Je=new _e.UserDataSyncAccountServiceChannel(me.get(ye.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const Xe=new _e.UserDataSyncStoreManagementServiceChannel(me.get(ce.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Xe);const ct=new Y.UserDataSyncChannel(me.get(ce.IUserDataSyncService),me.get(z.ILogService));this.server.registerChannel("userDataSync",ct);const Be=this._register(me.get(B.IInstantiationService).createInstance(ue.UserDataAutoSyncService)),tt=new _e.UserDataAutoSyncChannel(Be);this.server.registerChannel("userDataAutoSync",tt);const st=me.get(je.ILocalPtyService),lt=I.ProxyChannel.fromService(st);this.server.registerChannel(Me.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(me.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=I.ProxyChannel.fromService(me.get($e.ISharedProcessWorkerService));this.server.registerChannel($e.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(me){window.addEventListener("unhandledrejection",Oe=>{(0,T.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Oe=>{const qe=(0,R.toErrorMessage)(Oe,!0);!qe||me.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function Dt(pt){const me=new Rt(pt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await me.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Dt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c1f2f40bcd81380bf2e286af64becddada57db88/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
