/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","fs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/labels","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","child_process","vs/base/common/errorMessage","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],Z=function($){for(var e=[],v=0,R=$.length;v<R;v++)e[v]=Q[$[v]];return e};define(Q[104],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,M){if(!R)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}e.ok=v}),define(Q[46],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(n){return(I,h,f)=>{let y=null,E=null;if(typeof f.value=="function"?(y="value",E=f.value):typeof f.get=="function"&&(y="get",E=f.get),!E)throw new Error("not supported");f[y]=n(E,h)}}e.createDecorator=v;function R(n,I,h){let f=null,y=null;if(typeof h.value=="function"?(f="value",y=h.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(f="get",y=h.get),!y)throw new Error("not supported");const E=`$memoize$${I}`;h[f]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,m)}),this[E]}}e.memoize=R;function M(n,I,h){return v((f,y)=>{const E=`$debounce$${y}`,m=`$debounce$result$${y}`;return function(...p){this[m]||(this[m]=h?h():void 0),clearTimeout(this[E]),I&&(this[m]=I(this[m],...p),p=[this[m]]),this[E]=setTimeout(()=>{f.apply(this,p),this[m]=h?h():void 0},n)}})}e.debounce=M;function C(n,I,h){return v((f,y)=>{const E=`$throttle$timer$${y}`,m=`$throttle$result$${y}`,p=`$throttle$lastRun$${y}`,t=`$throttle$pending$${y}`;return function(...w){if(this[m]||(this[m]=h?h():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...w)),this[t])return;const b=this[p]+n;b<=Date.now()?(this[p]=Date.now(),f.apply(this,[this[m]]),this[m]=h?h():void 0):(this[t]=!0,this[E]=setTimeout(()=>{this[t]=!1,this[p]=Date.now(),f.apply(this,[this[m]]),this[m]=h?h():void 0},b-Date.now()))}})}e.throttle=C}),define(Q[16],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(c=>{c(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=v,e.errorHandler=new v;function R(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=R;function M(u){h(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=M;function C(u){h(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=C;function n(u){if(u instanceof Error){let{name:s,message:c}=u;const i=u.stacktrace||u.stack;return{$isError:!0,name:s,message:c,stack:i}}return u}e.transformErrorForSerialization=n;const I="Canceled";function h(u){return u instanceof Error&&u.name===I&&u.message===I}e.isPromiseCanceledError=h;class f extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=f;function y(){const u=new Error(I);return u.name=u.message,u}e.canceled=y;function E(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=E;function m(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=m;function p(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function t(u){const s=new Error(`${u} has been disposed`);return s.name="DISPOSED",s}e.disposed=t;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=w;class b extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=b;class S extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=S;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function l(u){const s=u;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=l;function a(u,s=Object.create(null)){const c=new Error(u);return s.actions&&(c.actions=s.actions),c}e.createErrorWithActions=a}),define(Q[30],Z([0,1,16]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(O,D=0){return O[O.length-(1+D)]}e.tail=R;function M(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=M;function C(O,D,T=(_,B)=>_===B){if(O===D)return!0;if(!O||!D||O.length!==D.length)return!1;for(let _=0,B=O.length;_<B;_++)if(!T(O[_],D[_]))return!1;return!0}e.equals=C;function n(O,D,T){let _=0,B=O.length-1;for(;_<=B;){const X=(_+B)/2|0,N=T(O[X],D);if(N<0)_=X+1;else if(N>0)B=X-1;else return X}return-(_+1)}e.binarySearch=n;function I(O,D){let T=0,_=O.length;if(_===0)return 0;for(;T<_;){const B=Math.floor((T+_)/2);D(O[B])?_=B:T=B+1}return T}e.findFirstInSorted=I;function h(O,D,T){if(O=O|0,O>=D.length)throw new TypeError("invalid index");let _=D[Math.floor(D.length*Math.random())],B=[],X=[],N=[];for(let H of D){const ie=T(H,_);ie<0?B.push(H):ie>0?X.push(H):N.push(H)}return O<B.length?h(O,B,T):O<B.length+N.length?N[0]:h(O-(B.length+N.length),X,T)}e.quickSelect=h;function f(O,D){const T=[];let _;for(const B of O.slice(0).sort(D))!_||D(_[0],B)!==0?(_=[B],T.push(_)):_.push(B);return T}e.groupBy=f;function y(O,D,T){const _=[];function B(H,ie,re){if(ie===0&&re.length===0)return;const se=_[_.length-1];se&&se.start+se.deleteCount===H?(se.deleteCount+=ie,se.toInsert.push(...re)):_.push({start:H,deleteCount:ie,toInsert:re})}let X=0,N=0;for(;;){if(X===O.length){B(X,0,D.slice(N));break}if(N===D.length){B(X,O.length-X,[]);break}const H=O[X],ie=D[N],re=T(H,ie);re===0?(X+=1,N+=1):re<0?(B(X,1,[]),X+=1):re>0&&(B(X,0,[ie]),N+=1)}return _}e.sortedDiff=y;function E(O,D,T){const _=y(O,D,T),B=[],X=[];for(const N of _)B.push(...O.slice(N.start,N.start+N.deleteCount)),X.push(...N.toInsert);return{removed:B,added:X}}e.delta=E;function m(O,D,T){if(T===0)return[];const _=O.slice(0,T).sort(D);return t(O,D,_,T,O.length),_}e.top=m;function p(O,D,T,_,B){return T===0?Promise.resolve([]):new Promise((X,N)=>{(async()=>{const H=O.length,ie=O.slice(0,T).sort(D);for(let re=T,se=Math.min(T+_,H);re<H;re=se,se=Math.min(se+_,H)){if(re>T&&await new Promise(x=>setTimeout(x)),B&&B.isCancellationRequested)throw(0,v.canceled)();t(O,D,ie,re,se)}return ie})().then(X,N)})}e.topAsync=p;function t(O,D,T,_,B){for(const X=T.length;_<B;_++){const N=O[_];if(D(N,T[X-1])<0){T.pop();const H=I(T,ie=>D(N,ie)<0);T.splice(H,0,N)}}}function w(O){return O.filter(D=>!!D)}e.coalesce=w;function b(O){let D=0;for(let T=0;T<O.length;T++)O[T]&&(O[D]=O[T],D+=1);O.length=D}e.coalesceInPlace=b;function S(O,D,T){O.splice(T,0,O.splice(D,1)[0])}e.move=S;function P(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=P;function l(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=l;function a(O,D=T=>T){const T=new Set;return O.filter(_=>{const B=D(_);return T.has(B)?!1:(T.add(B),!0)})}e.distinct=a;function u(O){const D=Object.create(null);return T=>{const _=O(T);return D[_]?!1:(D[_]=!0,!0)}}e.uniqueFilter=u;function s(O,D){const T=c(O,D);if(T!==-1)return O[T]}e.findLast=s;function c(O,D){for(let T=O.length-1;T>=0;T--){const _=O[T];if(D(_))return T}return-1}e.lastIndex=c;function i(O,D){return O.length>0?O[0]:D}e.firstOrDefault=i;function r(O,D,T=(_,B)=>_===B){let _=0;for(let B=0,X=Math.min(O.length,D.length);B<X&&T(O[B],D[B]);B++)_++;return _}e.commonPrefixLength=r;function o(O){return[].concat(...O)}e.flatten=o;function d(O,D){let T=typeof D=="number"?O:0;typeof D=="number"?T=O:(T=0,D=O);const _=[];if(T<=D)for(let B=T;B<D;B++)_.push(B);else for(let B=T;B>D;B--)_.push(B);return _}e.range=d;function g(O,D,T){return O.reduce((_,B)=>(_[D(B)]=T?T(B):B,_),Object.create(null))}e.index=g;function k(O,D){return O.push(D),()=>L(O,D)}e.insert=k;function L(O,D){const T=O.indexOf(D);if(T>-1)return O.splice(T,1),D}e.remove=L;function A(O,D,T){const _=O.slice(0,D),B=O.slice(D);return _.concat(T,B)}e.arrayInsert=A;function W(O,D){let T;if(typeof D=="number"){let _=D;T=()=>{const B=Math.sin(_++)*179426549;return B-Math.floor(B)}}else T=Math.random;for(let _=O.length-1;_>0;_-=1){const B=Math.floor(T()*(_+1)),X=O[_];O[_]=O[B],O[B]=X}}e.shuffle=W;function V(O,D){const T=O.indexOf(D);T>-1&&(O.splice(T,1),O.unshift(D))}e.pushToStart=V;function ee(O,D){const T=O.indexOf(D);T>-1&&(O.splice(T,1),O.push(D))}e.pushToEnd=ee;function oe(O,D){return Array.isArray(O)?O.map(D):D(O)}e.mapArrayOrNot=oe;function ae(O){return Array.isArray(O)?O:[O]}e.asArray=ae;function K(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=K;function F(O,D){for(const T of O){const _=D(T);if(_!==void 0)return _}}e.mapFind=F;function U(O,D,T){const _=Y(O,D),B=O.length,X=T.length;O.length=B+X;for(let N=B-1;N>=_;N--)O[N+X]=O[N];for(let N=0;N<X;N++)O[N+_]=T[N]}e.insertInto=U;function G(O,D,T,_){const B=Y(O,D),X=O.splice(B,T);return U(O,B,_),X}e.splice=G;function Y(O,D){return D<0?Math.max(D+O.length,0):Math.min(D,O.length)}function q(O,D){let T=Number.MAX_SAFE_INTEGER,_=0;return O.forEach((B,X)=>{const N=D(B);N<T&&(T=N,_=X)}),_}e.minIndex=q;function z(O,D){let T=Number.MIN_SAFE_INTEGER,_=0;return O.forEach((B,X)=>{const N=D(B);N>T&&(T=N,_=X)}),_}e.maxIndex=z;class J{constructor(D){this.items=D,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(D){let T=this.firstIdx;for(;T<this.items.length&&D(this.items[T]);)T++;const _=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,_}takeFromEndWhile(D){let T=this.lastIdx;for(;T>=0&&D(this.items[T]);)T--;const _=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,_}peek(){return this.items[this.firstIdx]}dequeue(){const D=this.items[this.firstIdx];return this.firstIdx++,D}takeCount(D){const T=this.items.slice(this.firstIdx,this.firstIdx+D);return this.firstIdx+=D,T}}e.ArrayQueue=J}),define(Q[42],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const M=this;let C=!1,n;return function(){return C||(C=!0,n=R.apply(M,arguments)),n}}e.once=v}),define(Q[69],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function M(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}R.is=M;const C=Object.freeze([]);function n(){return C}R.empty=n;function*I(u){yield u}R.single=I;function h(u){return u||C}R.from=h;function f(u){return!u||u[Symbol.iterator]().next().done===!0}R.isEmpty=f;function y(u){return u[Symbol.iterator]().next().value}R.first=y;function E(u,s){for(const c of u)if(s(c))return!0;return!1}R.some=E;function m(u,s){for(const c of u)if(s(c))return c}R.find=m;function*p(u,s){for(const c of u)s(c)&&(yield c)}R.filter=p;function*t(u,s){let c=0;for(const i of u)yield s(i,c++)}R.map=t;function*w(...u){for(const s of u)for(const c of s)yield c}R.concat=w;function*b(u){for(const s of u)for(const c of s)yield c}R.concatNested=b;function S(u,s,c){let i=c;for(const r of u)i=s(i,r);return i}R.reduce=S;function*P(u,s,c=u.length){for(s<0&&(s+=u.length),c<0?c+=u.length:c>u.length&&(c=u.length);s<c;s++)yield u[s]}R.slice=P;function l(u,s=Number.POSITIVE_INFINITY){const c=[];if(s===0)return[c,u];const i=u[Symbol.iterator]();for(let r=0;r<s;r++){const o=i.next();if(o.done)return[c,R.empty()];c.push(o.value)}return[c,{[Symbol.iterator](){return i}}]}R.consume=l;function a(u,s,c=(i,r)=>i===r){const i=u[Symbol.iterator](),r=s[Symbol.iterator]();for(;;){const o=i.next(),d=r.next();if(o.done!==d.done)return!1;if(o.done)return!0;if(!c(o.value,d.value))return!1}}R.equals=a})(v=e.Iterable||(e.Iterable={}))}),define(Q[39],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var M;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(M=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(s){s.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function n(s,c=!1){let i=0,r=s.length,o="",d=0,g=16,k=0;function L(K){let F=0,U=0;for(;F<K;){const G=s.charCodeAt(i);if(G>=48&&G<=57)U=U*16+G-48;else if(G>=65&&G<=70)U=U*16+G-65+10;else if(G>=97&&G<=102)U=U*16+G-97+10;else break;i++,F++}return F<K&&(U=-1),U}function A(K){i=K,o="",d=0,g=16,k=0}function W(){const K=i;if(s.charCodeAt(i)===48)i++;else for(i++;i<s.length&&f(s.charCodeAt(i));)i++;if(i<s.length&&s.charCodeAt(i)===46)if(i++,i<s.length&&f(s.charCodeAt(i)))for(i++;i<s.length&&f(s.charCodeAt(i));)i++;else return k=3,s.substring(K,i);let F=i;if(i<s.length&&(s.charCodeAt(i)===69||s.charCodeAt(i)===101))if(i++,(i<s.length&&s.charCodeAt(i)===43||s.charCodeAt(i)===45)&&i++,i<s.length&&f(s.charCodeAt(i))){for(i++;i<s.length&&f(s.charCodeAt(i));)i++;F=i}else k=3;return s.substring(K,F)}function V(){let K="",F=i;for(;;){if(i>=r){K+=s.substring(F,i),k=2;break}const U=s.charCodeAt(i);if(U===34){K+=s.substring(F,i),i++;break}if(U===92){if(K+=s.substring(F,i),i++,i>=r){k=2;break}switch(s.charCodeAt(i++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const Y=L(4);Y>=0?K+=String.fromCharCode(Y):k=4;break;default:k=5}F=i;continue}if(U>=0&&U<=31)if(h(U)){K+=s.substring(F,i),k=2;break}else k=6;i++}return K}function ee(){if(o="",k=0,d=i,i>=r)return d=r,g=17;let K=s.charCodeAt(i);if(I(K)){do i++,o+=String.fromCharCode(K),K=s.charCodeAt(i);while(I(K));return g=15}if(h(K))return i++,o+=String.fromCharCode(K),K===13&&s.charCodeAt(i)===10&&(i++,o+=`
`),g=14;switch(K){case 123:return i++,g=1;case 125:return i++,g=2;case 91:return i++,g=3;case 93:return i++,g=4;case 58:return i++,g=6;case 44:return i++,g=5;case 34:return i++,o=V(),g=10;case 47:const F=i-1;if(s.charCodeAt(i+1)===47){for(i+=2;i<r&&!h(s.charCodeAt(i));)i++;return o=s.substring(F,i),g=12}if(s.charCodeAt(i+1)===42){i+=2;const U=r-1;let G=!1;for(;i<U;){if(s.charCodeAt(i)===42&&s.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,k=1),o=s.substring(F,i),g=13}return o+=String.fromCharCode(K),i++,g=16;case 45:if(o+=String.fromCharCode(K),i++,i===r||!f(s.charCodeAt(i)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=W(),g=11;default:for(;i<r&&oe(K);)i++,K=s.charCodeAt(i);if(d!==i){switch(o=s.substring(d,i),o){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return o+=String.fromCharCode(K),i++,g=16}}function oe(K){if(I(K)||h(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let K;do K=ee();while(K>=12&&K<=15);return K}return{setPosition:A,getPosition:()=>i,scan:c?ae:ee,getToken:()=>g,getTokenValue:()=>o,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>k}}e.createScanner=n;function I(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function f(s){return s>=48&&s<=57}var y;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(y||(y={}));function E(s,c){const i=[],r=new Object;let o;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function k(L,A,W,V){d.value=L,d.offset=A,d.length=W,d.type=V,d.colonOffset=void 0,o=d}try{l(s,{onObjectBegin:(L,A)=>{if(c<=L)throw r;o=void 0,g=c>L,i.push("")},onObjectProperty:(L,A,W)=>{if(c<A||(k(L,A,W,"property"),i[i.length-1]=L,c<=A+W))throw r},onObjectEnd:(L,A)=>{if(c<=L)throw r;o=void 0,i.pop()},onArrayBegin:(L,A)=>{if(c<=L)throw r;o=void 0,i.push(0)},onArrayEnd:(L,A)=>{if(c<=L)throw r;o=void 0,i.pop()},onLiteralValue:(L,A,W)=>{if(c<A||(k(L,A,W,u(L)),c<=A+W))throw r},onSeparator:(L,A,W)=>{if(c<=A)throw r;if(L===":"&&o&&o.type==="property")o.colonOffset=A,g=!1,o=void 0;else if(L===","){const V=i[i.length-1];typeof V=="number"?i[i.length-1]=V+1:(g=!0,i[i.length-1]=""),o=void 0}}})}catch(L){if(L!==r)throw L}return{path:i,previousNode:o,isAtPropertyKey:g,matches:L=>{let A=0;for(let W=0;A<L.length&&W<i.length;W++)if(L[A]===i[W]||L[A]==="*")A++;else if(L[A]!=="**")return!1;return A===L.length}}}e.getLocation=E;function m(s,c=[],i=C.DEFAULT){let r=null,o=[];const d=[];function g(L){Array.isArray(o)?o.push(L):r!==null&&(o[r]=L)}return l(s,{onObjectBegin:()=>{const L={};g(L),d.push(o),o=L,r=null},onObjectProperty:L=>{r=L},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{const L=[];g(L),d.push(o),o=L,r=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:g,onError:(L,A,W)=>{c.push({error:L,offset:A,length:W})}},i),o[0]}e.parse=m;function p(s,c=[],i=C.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(L){r.type==="property"&&(r.length=L-r.offset,r=r.parent)}function d(L){return r.children.push(L),L}l(s,{onObjectBegin:L=>{r=d({type:"object",offset:L,length:-1,parent:r,children:[]})},onObjectProperty:(L,A,W)=>{r=d({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:L,offset:A,length:W,parent:r})},onObjectEnd:(L,A)=>{r.length=L+A-r.offset,r=r.parent,o(L+A)},onArrayBegin:(L,A)=>{r=d({type:"array",offset:L,length:-1,parent:r,children:[]})},onArrayEnd:(L,A)=>{r.length=L+A-r.offset,r=r.parent,o(L+A)},onLiteralValue:(L,A,W)=>{d({type:u(L),offset:A,length:W,parent:r,value:L}),o(A+W)},onSeparator:(L,A,W)=>{r.type==="property"&&(L===":"?r.colonOffset=A:L===","&&o(A))},onError:(L,A,W)=>{c.push({error:L,offset:A,length:W})}},i);const k=r.children[0];return k&&delete k.parent,k}e.parseTree=p;function t(s,c){if(!s)return;let i=s;for(let r of c)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===r){i=d.children[1],o=!0;break}if(!o)return}else{const o=r;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=t;function w(s){if(!s.parent||!s.parent.children)return[];const c=w(s.parent);if(s.parent.type==="property"){const i=s.parent.children[0].value;c.push(i)}else if(s.parent.type==="array"){const i=s.parent.children.indexOf(s);i!==-1&&c.push(i)}return c}e.getNodePath=w;function b(s){switch(s.type){case"array":return s.children.map(b);case"object":const c=Object.create(null);for(let i of s.children){const r=i.children[1];r&&(c[i.children[0].value]=b(r))}return c;case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=b;function S(s,c,i=!1){return c>=s.offset&&c<s.offset+s.length||i&&c===s.offset+s.length}e.contains=S;function P(s,c,i=!1){if(S(s,c,i)){const r=s.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=c;o++){const d=P(r[o],c,i);if(d)return d}return s}}e.findNodeAtOffset=P;function l(s,c,i=C.DEFAULT){const r=n(s,!1);function o(T){return T?()=>T(r.getTokenOffset(),r.getTokenLength()):()=>!0}function d(T){return T?_=>T(_,r.getTokenOffset(),r.getTokenLength()):()=>!0}const g=o(c.onObjectBegin),k=d(c.onObjectProperty),L=o(c.onObjectEnd),A=o(c.onArrayBegin),W=o(c.onArrayEnd),V=d(c.onLiteralValue),ee=d(c.onSeparator),oe=o(c.onComment),ae=d(c.onError),K=i&&i.disallowComments,F=i&&i.allowTrailingComma;function U(){for(;;){const T=r.scan();switch(r.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:K||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(T){case 12:case 13:K?G(10):oe();break;case 16:G(1);break;case 15:case 14:break;default:return T}}}function G(T,_=[],B=[]){if(ae(T),_.length+B.length>0){let X=r.getToken();for(;X!==17;){if(_.indexOf(X)!==-1){U();break}else if(B.indexOf(X)!==-1)break;X=U()}}}function Y(T){const _=r.getTokenValue();return T?V(_):k(_),U(),!0}function q(){switch(r.getToken()){case 11:let T=0;try{T=JSON.parse(r.getTokenValue()),typeof T!="number"&&(G(2),T=0)}catch(_){G(2)}V(T);break;case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return U(),!0}function z(){return r.getToken()!==10?(G(3,[],[2,5]),!1):(Y(!1),r.getToken()===6?(ee(":"),U(),D()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function J(){g(),U();let T=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(T||G(4,[],[]),ee(","),U(),r.getToken()===2&&F)break}else T&&G(6,[],[]);z()||G(4,[],[2,5]),T=!0}return L(),r.getToken()!==2?G(7,[2],[]):U(),!0}function O(){A(),U();let T=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(T||G(4,[],[]),ee(","),U(),r.getToken()===4&&F)break}else T&&G(6,[],[]);D()||G(4,[],[4,5]),T=!0}return W(),r.getToken()!==4?G(8,[4],[]):U(),!0}function D(){switch(r.getToken()){case 3:return O();case 1:return J();case 10:return Y(!0);default:return q()}}return U(),r.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):D()?(r.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=l;function a(s,c){let i=n(s),r=[],o,d=0,g;do switch(g=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:d!==g&&r.push(s.substring(d,g)),c!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,c)),d=i.getPosition();break}while(o!==17);return r.join("")}e.stripComments=a;function u(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Q[105],Z([0,1,39]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(h,f,y){let E,m,p,t,w;if(f){for(t=f.offset,w=t+f.length,p=t;p>0&&!I(h,p-1);)p--;let d=w;for(;d<h.length&&!I(h,d);)d++;m=h.substring(p,d),E=C(m,y)}else m=h,E=0,p=0,t=0,w=h.length;const b=n(y,h);let S=!1,P=0,l;y.insertSpaces?l=M(" ",y.tabSize||4):l="	";const a=(0,v.createScanner)(m,!1);let u=!1;function s(){return b+M(l,E+P)}function c(){let d=a.scan();for(S=!1;d===15||d===14;)S=S||d===14,d=a.scan();return u=d===16||a.getTokenError()!==0,d}const i=[];function r(d,g,k){!u&&g<w&&k>t&&h.substring(g,k)!==d&&i.push({offset:g,length:k-g,content:d})}let o=c();if(o!==17){const d=a.getTokenOffset()+p,g=M(l,E);r(g,p,d)}for(;o!==17;){let d=a.getTokenOffset()+a.getTokenLength()+p,g=c(),k="";for(;!S&&(g===12||g===13);){const A=a.getTokenOffset()+p;r(" ",d,A),d=a.getTokenOffset()+a.getTokenLength()+p,k=g===12?s():"",g=c()}if(g===2)o!==1&&(P--,k=s());else if(g===4)o!==3&&(P--,k=s());else{switch(o){case 3:case 1:P++,k=s();break;case 5:case 12:k=s();break;case 13:S?k=s():k=" ";break;case 6:k=" ";break;case 10:if(g===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?k=" ":g!==5&&g!==17&&(u=!0);break;case 16:u=!0;break}S&&(g===12||g===13)&&(k=s())}const L=a.getTokenOffset()+p;r(k,d,L),o=g}return i}e.format=R;function M(h,f){let y="";for(let E=0;E<f;E++)y+=h;return y}function C(h,f){let y=0,E=0;const m=f.tabSize||4;for(;y<h.length;){const p=h.charAt(y);if(p===" ")E++;else if(p==="	")E+=m;else break;y++}return Math.floor(E/m)}function n(h,f){for(let y=0;y<f.length;y++){const E=f.charAt(y);if(E==="\r")return y+1<f.length&&f.charAt(y+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=n;function I(h,f){return`\r
`.indexOf(h.charAt(f))!==-1}e.isEOL=I}),define(Q[78],Z([0,1,39,105]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function M(f,y,E){return C(f,y,void 0,E)}e.removeProperty=M;function C(f,y,E,m,p){const t=y.slice(),w=[],b=(0,v.parseTree)(f,w);let S,P;for(;t.length>0&&(P=t.pop(),S=(0,v.findNodeAtLocation)(b,t),S===void 0&&E!==void 0);)typeof P=="string"?E={[P]:E}:E=[E];if(S)if(S.type==="object"&&typeof P=="string"&&Array.isArray(S.children)){const l=(0,v.findNodeAtLocation)(S,[P]);if(l!==void 0)if(E===void 0){if(!l.parent)throw new Error("Malformed AST");const a=S.children.indexOf(l.parent);let u,s=l.parent.offset+l.parent.length;if(a>0){const c=S.children[a-1];u=c.offset+c.length}else u=S.offset+1,S.children.length>1&&(s=S.children[1].offset);return n(f,{offset:u,length:s-u,content:""},m)}else return n(f,{offset:l.offset,length:l.length,content:JSON.stringify(E)},m);else{if(E===void 0)return[];const a=`${JSON.stringify(P)}: ${JSON.stringify(E)}`,u=p?p(S.children.map(c=>c.children[0].value)):S.children.length;let s;if(u>0){const c=S.children[u-1];s={offset:c.offset+c.length,length:0,content:","+a}}else S.children.length===0?s={offset:S.offset+1,length:0,content:a}:s={offset:S.offset+1,length:0,content:a+","};return n(f,s,m)}}else if(S.type==="array"&&typeof P=="number"&&Array.isArray(S.children))if(E!==void 0){const l=`${JSON.stringify(E)}`;let a;if(S.children.length===0||P===0)a={offset:S.offset+1,length:0,content:S.children.length===0?l:l+","};else{const u=P===-1||P>S.children.length?S.children.length:P,s=S.children[u-1];a={offset:s.offset+s.length,length:0,content:","+l}}return n(f,a,m)}else{const l=P,a=S.children[l];let u;if(S.children.length===1)u={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===l){const s=S.children[l-1],c=s.offset+s.length,i=S.offset+S.length;u={offset:c,length:i-2-c,content:""}}else u={offset:a.offset,length:S.children[l+1].offset-a.offset,content:""};return n(f,u,m)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${S.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return n(f,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(E)},m)}}e.setProperty=C;function n(f,y,E){let m=I(f,y),p=y.offset,t=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;p>0&&!(0,R.isEOL)(m,p-1);)p--;for(;t<m.length&&!(0,R.isEOL)(m,t);)t++}const w=(0,R.format)(m,{offset:p,length:t-p},E);for(let S=w.length-1;S>=0;S--){const P=w[S];m=I(m,P),p=Math.min(p,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const b=f.length-(m.length-t)-p;return[{offset:p,length:b,content:m.substring(p,t)}]}e.withFormatting=n;function I(f,y){return f.substring(0,y.offset)+y.content+f.substring(y.offset+y.length)}e.applyEdit=I;function h(f,y){let E=y.slice(0).sort((p,t)=>{const w=p.offset-t.offset;return w===0?p.length-t.length:w}),m=f.length;for(let p=E.length-1;p>=0;p--){let t=E[p];if(t.offset+t.length<=m)f=I(f,t);else throw new Error("Overlapping edit");m=t.offset}return f}e.applyEdits=h}),define(Q[79],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var v;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(v=e.KeyCode||(e.KeyCode={}));var R;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(R=e.ScanCode||(e.ScanCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,b){this._keyCodeToStr[w]=b,this._strToKeyCode[b.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const C=new M,n=new M,I=new M;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],f=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>y[t]||0,toEnum:t=>f[t]||0,toString:t=>h[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let b=[],S=[];for(const P of w){const[l,a,u,s,c,i,r,o,d,g]=P;if(S[u]||(S[u]=!0,h[u]=s,f[s]=u,y[s.toLowerCase()]=u,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[u]=c,c!==0&&c!==3&&c!==5&&c!==4&&c!==6&&c!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[c]=u))),!b[c]){if(b[c]=!0,!i)throw new Error(`String representation missing for key code ${c} around scan code ${s}`);C.define(c,i),n.define(c,d||i),I.define(c,g||d||i)}r&&(e.EVENT_KEY_CODE_MAP[r]=c),o&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[o]=c)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var E;(function(t){function w(u){return C.keyCodeToStr(u)}t.toString=w;function b(u){return C.strToKeyCode(u)}t.fromString=b;function S(u){return n.keyCodeToStr(u)}t.toUserSettingsUS=S;function P(u){return I.keyCodeToStr(u)}t.toUserSettingsGeneral=P;function l(u){return n.strToKeyCode(u)||I.strToKeyCode(u)}t.fromUserSettings=l;function a(u){if(u>=93&&u<=108)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(u)}t.toElectronAccelerator=a})(E=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(m=e.KeyMod||(e.KeyMod={}));function p(t,w){const b=(w&65535)<<16>>>0;return(t|b)>>>0}e.KeyChord=p}),define(Q[59],Z([0,1,16]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var R;(function(E){E[E.CtrlCmd=2048]="CtrlCmd",E[E.Shift=1024]="Shift",E[E.Alt=512]="Alt",E[E.WinCtrl=256]="WinCtrl",E[E.KeyCode=255]="KeyCode"})(R||(R={}));function M(E,m){if(E===0)return null;const p=(E&65535)>>>0,t=(E&4294901760)>>>16;return t!==0?new I([C(p,m),C(t,m)]):new I([C(p,m)])}e.createKeybinding=M;function C(E,m){const p=!!(E&2048),t=!!(E&256),w=m===2?t:p,b=!!(E&1024),S=!!(E&512),P=m===2?p:t,l=E&255;return new n(w,b,S,P,l)}e.createSimpleKeybinding=C;class n{constructor(m,p,t,w,b){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=w,this.keyCode=b}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.keyCode===m.keyCode}getHashCode(){const m=this.ctrlKey?"1":"0",p=this.shiftKey?"1":"0",t=this.altKey?"1":"0",w=this.metaKey?"1":"0";return`${m}${p}${t}${w}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=n;class I{constructor(m){if(m.length===0)throw(0,v.illegalArgument)("parts");this.parts=m}getHashCode(){let m="";for(let p=0,t=this.parts.length;p<t;p++)p!==0&&(m+=";"),m+=this.parts[p].getHashCode();return m}equals(m){if(m===null||this.parts.length!==m.parts.length)return!1;for(let p=0;p<this.parts.length;p++)if(!this.parts[p].equals(m.parts[p]))return!1;return!0}}e.ChordKeybinding=I;class h{constructor(m,p,t,w,b){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=w,this.scanCode=b}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.scanCode===m.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=h;class f{constructor(m,p,t,w,b,S){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=w,this.keyLabel=b,this.keyAriaLabel=S}}e.ResolvedKeybindingPart=f;class y{}e.ResolvedKeybinding=y}),define(Q[106],Z([0,1,79,59]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class M{static _readModifiers(n){n=n.toLowerCase().trim();let I=!1,h=!1,f=!1,y=!1,E;do E=!1,/^ctrl(\+|\-)/.test(n)&&(I=!0,n=n.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(n)&&(h=!0,n=n.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(n)&&(f=!0,n=n.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(n)&&(y=!0,n=n.substr("meta-".length),E=!0),/^win(\+|\-)/.test(n)&&(y=!0,n=n.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(n)&&(y=!0,n=n.substr("cmd-".length),E=!0);while(E);let m;const p=n.indexOf(" ");return p>0?(m=n.substring(0,p),n=n.substring(p)):(m=n,n=""),{remains:n,ctrl:I,shift:h,alt:f,meta:y,key:m}}static parseSimpleKeybinding(n){const I=this._readModifiers(n),h=v.KeyCodeUtils.fromUserSettings(I.key);return[new R.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,h),I.remains]}static parseKeybinding(n,I){if(!n)return null;const h=[];let f;do[f,n]=this.parseSimpleKeybinding(n),h.push(f);while(n.length>0);return new R.ChordKeybinding(h)}static parseSimpleUserBinding(n){const I=this._readModifiers(n),h=I.key.match(/^\[([^\]]+)\]$/);if(h){const y=h[1],E=v.ScanCodeUtils.lowerCaseToEnum(y);return[new R.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,E),I.remains]}const f=v.KeyCodeUtils.fromUserSettings(I.key);return[new R.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,f),I.remains]}static parseUserBinding(n){if(!n)return[];const I=[];let h;for(;n.length>0;)[h,n]=this.parseSimpleUserBinding(n),I.push(h);return I}}e.KeybindingParser=M}),define(Q[2],Z([0,1,42,69]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const M=!1;let C=null;function n(r){C=r}if(e.setDisposableTracker=n,M){const r="__is_disposable_tracked__";n(new class{trackDisposable(o){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(d)},3e3)}setParent(o,d){if(o&&o!==P.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==P.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function I(r){return C?.trackDisposable(r),r}function h(r){C?.markAsDisposed(r)}function f(r,o){C?.setParent(r,o)}function y(r,o){if(!!C)for(const d of r)C.setParent(d,o)}function E(r){return C?.markAsSingleton(r),r}e.markAsSingleton=E;class m extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=m;function p(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=p;function t(r){if(R.Iterable.is(r)){let o=[];for(const d of r)if(d)try{d.dispose()}catch(g){o.push(g)}if(o.length===1)throw o[0];if(o.length>1)throw new m(o);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=t;function w(...r){const o=b(()=>t(r));return y(r,o),o}e.combinedDisposable=w;function b(r){const o=I({dispose:(0,v.once)(()=>{h(o),r()})});return o}e.toDisposable=b;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return f(o,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new S,I(this),f(this._store,this)}dispose(){h(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&f(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&f(o,null),o}}e.MutableDisposable=l;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class u{constructor(){this.references=new Map}acquire(o,...d){let g=this.references.get(o);g||(g={counter:0,object:this.createReferencedObject(o,...d)},this.references.set(o,g));const{object:k}=g,L=(0,v.once)(()=>{--g.counter==0&&(this.destroyReferencedObject(o,g.object),this.references.delete(o))});return g.counter++,{object:k,dispose:L}}}e.ReferenceCollection=u;class s{constructor(o){this.referenceCollection=o}async acquire(o,...d){const g=this.referenceCollection.acquire(o,...d);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(k){throw g.dispose(),k}}}e.AsyncReferenceCollection=s;class c{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=c;function i(r){const o=new S;try{r(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(Q[107],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(C){this.element=C,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let C=this._first;for(;C!==v.Undefined;){const n=C.next;C.prev=v.Undefined,C.next=v.Undefined,C=n}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,n){const I=new v(C);if(this._first===v.Undefined)this._first=I,this._last=I;else if(n){const f=this._last;this._last=I,I.prev=f,f.next=I}else{const f=this._first;this._first=I,I.next=f,f.prev=I}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(I))}}shift(){if(this._first!==v.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==v.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==v.Undefined&&C.next!==v.Undefined){const n=C.prev;n.next=C.next,C.next.prev=n}else C.prev===v.Undefined&&C.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):C.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):C.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==v.Undefined;)yield C.element,C=C.next}}e.LinkedList=R}),function(){function $(M){const C=[];typeof M=="number"&&C.push("code/timeOrigin",M);function n(h){C.push(h,Date.now())}function I(){const h=[];for(let f=0;f<C.length;f+=2)h.push({name:C[f],startTime:C[f+1]});return h}return{mark:n,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const n of performance.getEntriesByType("mark"))C.push({name:n.name,startTime:Math.round(M+n.startTime)});return C}};if(typeof process=="object"){const M=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function v(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(Q[3],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let R=!1,M=!1,C=!1,n=!1,I=!1,h=!1,f=!1,y,E=v,m,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let t;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?t=e.globals.vscode.process:typeof process!="undefined"&&(t=process);const w=typeof t?.versions?.electron=="string"&&t.type==="renderer";if(e.isElectronSandboxed=w&&t?.sandboxed,typeof navigator=="object"&&!w)p=navigator.userAgent,R=p.indexOf("Windows")>=0,M=p.indexOf("Macintosh")>=0,f=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=p.indexOf("Linux")>=0,h=!0,y=navigator.language,E=y;else if(typeof t=="object"){R=t.platform==="win32",M=t.platform==="darwin",C=t.platform==="linux",n=C&&!!t.env.SNAP&&!!t.env.SNAP_REVISION,y=v,E=v;const i=t.env.VSCODE_NLS_CONFIG;if(i)try{const r=JSON.parse(i),o=r.availableLanguages["*"];y=r.locale,E=o||v,m=r._translationsConfigFile}catch(r){}I=!0}else console.error("Unable to resolve platform.");var b;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function S(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let P=0;M?P=1:R?P=3:C&&(P=2),e.isWindows=R,e.isMacintosh=M,e.isLinux=C,e.isLinuxSnap=n,e.isNative=I,e.isWeb=h,e.isIOS=f,e.platform=P,e.userAgent=p,e.language=E;var l;(function(i){function r(){return e.language}i.value=r;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=o;function d(){return e.language==="en"}i.isDefault=d})(l=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=m,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let i=[];e.globals.addEventListener("message",o=>{if(o.data&&o.data.vscodeScheduleAsyncWork)for(let d=0,g=i.length;d<g;d++){const k=i[d];if(k.id===o.data.vscodeScheduleAsyncWork){i.splice(d,1),k.callback();return}}});let r=0;return o=>{const d=++r;i.push({id:d,callback:o}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return i=>setTimeout(i)})();var a;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=M||f?2:R?1:3;let u=!0,s=!1;function c(){if(!s){s=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,u=new Uint16Array(i.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=c}),define(Q[34],Z([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const M=v.globals.vscode.process;R={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process!="undefined"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(Q[8],Z([0,1,34]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,M=97,C=90,n=122,I=46,h=47,f=92,y=58,E=63;class m extends Error{constructor(a,u,s){let c;typeof u=="string"&&u.indexOf("not ")===0?(c="must not be",u=u.replace(/^not /,"")):c="must be";const i=a.indexOf(".")!==-1?"property":"argument";let r=`The "${a}" ${i} ${c} of type ${u}`;r+=`. Received type ${typeof s}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function p(l,a){if(typeof l!="string")throw new m(a,"string",l)}function t(l){return l===h||l===f}function w(l){return l===h}function b(l){return l>=R&&l<=C||l>=M&&l<=n}function S(l,a,u,s){let c="",i=0,r=-1,o=0,d=0;for(let g=0;g<=l.length;++g){if(g<l.length)d=l.charCodeAt(g);else{if(s(d))break;d=h}if(s(d)){if(!(r===g-1||o===1))if(o===2){if(c.length<2||i!==2||c.charCodeAt(c.length-1)!==I||c.charCodeAt(c.length-2)!==I){if(c.length>2){const k=c.lastIndexOf(u);k===-1?(c="",i=0):(c=c.slice(0,k),i=c.length-1-c.lastIndexOf(u)),r=g,o=0;continue}else if(c.length!==0){c="",i=0,r=g,o=0;continue}}a&&(c+=c.length>0?`${u}..`:"..",i=2)}else c.length>0?c+=`${u}${l.slice(r+1,g)}`:c=l.slice(r+1,g),i=g-r-1;r=g,o=0}else d===I&&o!==-1?++o:o=-1}return c}function P(l,a){if(a===null||typeof a!="object")throw new m("pathObject","Object",a);const u=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return u?u===a.root?`${u}${s}`:`${u}${l}${s}`:s}e.win32={resolve(...l){let a="",u="",s=!1;for(let c=l.length-1;c>=-1;c--){let i;if(c>=0){if(i=l[c],p(i,"path"),i.length===0)continue}else a.length===0?i=v.cwd():(i=v.env[`=${a}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===f)&&(i=`${a}\\`));const r=i.length;let o=0,d="",g=!1;const k=i.charCodeAt(0);if(r===1)t(k)&&(o=1,g=!0);else if(t(k))if(g=!0,t(i.charCodeAt(1))){let L=2,A=L;for(;L<r&&!t(i.charCodeAt(L));)L++;if(L<r&&L!==A){const W=i.slice(A,L);for(A=L;L<r&&t(i.charCodeAt(L));)L++;if(L<r&&L!==A){for(A=L;L<r&&!t(i.charCodeAt(L));)L++;(L===r||L!==A)&&(d=`\\\\${W}\\${i.slice(A,L)}`,o=L)}}}else o=1;else b(k)&&i.charCodeAt(1)===y&&(d=i.slice(0,2),o=2,r>2&&t(i.charCodeAt(2))&&(g=!0,o=3));if(d.length>0)if(a.length>0){if(d.toLowerCase()!==a.toLowerCase())continue}else a=d;if(s){if(a.length>0)break}else if(u=`${i.slice(o)}\\${u}`,s=g,g&&a.length>0)break}return u=S(u,!s,"\\",t),s?`${a}\\${u}`:`${a}${u}`||"."},normalize(l){p(l,"path");const a=l.length;if(a===0)return".";let u=0,s,c=!1;const i=l.charCodeAt(0);if(a===1)return w(i)?"\\":l;if(t(i))if(c=!0,t(l.charCodeAt(1))){let o=2,d=o;for(;o<a&&!t(l.charCodeAt(o));)o++;if(o<a&&o!==d){const g=l.slice(d,o);for(d=o;o<a&&t(l.charCodeAt(o));)o++;if(o<a&&o!==d){for(d=o;o<a&&!t(l.charCodeAt(o));)o++;if(o===a)return`\\\\${g}\\${l.slice(d)}\\`;o!==d&&(s=`\\\\${g}\\${l.slice(d,o)}`,u=o)}}}else u=1;else b(i)&&l.charCodeAt(1)===y&&(s=l.slice(0,2),u=2,a>2&&t(l.charCodeAt(2))&&(c=!0,u=3));let r=u<a?S(l.slice(u),!c,"\\",t):"";return r.length===0&&!c&&(r="."),r.length>0&&t(l.charCodeAt(a-1))&&(r+="\\"),s===void 0?c?`\\${r}`:r:c?`${s}\\${r}`:`${s}${r}`},isAbsolute(l){p(l,"path");const a=l.length;if(a===0)return!1;const u=l.charCodeAt(0);return t(u)||a>2&&b(u)&&l.charCodeAt(1)===y&&t(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let a,u;for(let i=0;i<l.length;++i){const r=l[i];p(r,"path"),r.length>0&&(a===void 0?a=u=r:a+=`\\${r}`)}if(a===void 0)return".";let s=!0,c=0;if(typeof u=="string"&&t(u.charCodeAt(0))){++c;const i=u.length;i>1&&t(u.charCodeAt(1))&&(++c,i>2&&(t(u.charCodeAt(2))?++c:s=!1))}if(s){for(;c<a.length&&t(a.charCodeAt(c));)c++;c>=2&&(a=`\\${a.slice(c)}`)}return e.win32.normalize(a)},relative(l,a){if(p(l,"from"),p(a,"to"),l===a)return"";const u=e.win32.resolve(l),s=e.win32.resolve(a);if(u===s||(l=u.toLowerCase(),a=s.toLowerCase(),l===a))return"";let c=0;for(;c<l.length&&l.charCodeAt(c)===f;)c++;let i=l.length;for(;i-1>c&&l.charCodeAt(i-1)===f;)i--;const r=i-c;let o=0;for(;o<a.length&&a.charCodeAt(o)===f;)o++;let d=a.length;for(;d-1>o&&a.charCodeAt(d-1)===f;)d--;const g=d-o,k=r<g?r:g;let L=-1,A=0;for(;A<k;A++){const V=l.charCodeAt(c+A);if(V!==a.charCodeAt(o+A))break;V===f&&(L=A)}if(A!==k){if(L===-1)return s}else{if(g>k){if(a.charCodeAt(o+A)===f)return s.slice(o+A+1);if(A===2)return s.slice(o+A)}r>k&&(l.charCodeAt(c+A)===f?L=A:A===2&&(L=3)),L===-1&&(L=0)}let W="";for(A=c+L+1;A<=i;++A)(A===i||l.charCodeAt(A)===f)&&(W+=W.length===0?"..":"\\..");return o+=L,W.length>0?`${W}${s.slice(o,d)}`:(s.charCodeAt(o)===f&&++o,s.slice(o,d))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const a=e.win32.resolve(l);if(a.length<=2)return l;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const u=a.charCodeAt(2);if(u!==E&&u!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(b(a.charCodeAt(0))&&a.charCodeAt(1)===y&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return l},dirname(l){p(l,"path");const a=l.length;if(a===0)return".";let u=-1,s=0;const c=l.charCodeAt(0);if(a===1)return t(c)?l:".";if(t(c)){if(u=s=1,t(l.charCodeAt(1))){let o=2,d=o;for(;o<a&&!t(l.charCodeAt(o));)o++;if(o<a&&o!==d){for(d=o;o<a&&t(l.charCodeAt(o));)o++;if(o<a&&o!==d){for(d=o;o<a&&!t(l.charCodeAt(o));)o++;if(o===a)return l;o!==d&&(u=s=o+1)}}}}else b(c)&&l.charCodeAt(1)===y&&(u=a>2&&t(l.charCodeAt(2))?3:2,s=u);let i=-1,r=!0;for(let o=a-1;o>=s;--o)if(t(l.charCodeAt(o))){if(!r){i=o;break}}else r=!1;if(i===-1){if(u===-1)return".";i=u}return l.slice(0,i)},basename(l,a){a!==void 0&&p(a,"ext"),p(l,"path");let u=0,s=-1,c=!0,i;if(l.length>=2&&b(l.charCodeAt(0))&&l.charCodeAt(1)===y&&(u=2),a!==void 0&&a.length>0&&a.length<=l.length){if(a===l)return"";let r=a.length-1,o=-1;for(i=l.length-1;i>=u;--i){const d=l.charCodeAt(i);if(t(d)){if(!c){u=i+1;break}}else o===-1&&(c=!1,o=i+1),r>=0&&(d===a.charCodeAt(r)?--r==-1&&(s=i):(r=-1,s=o))}return u===s?s=o:s===-1&&(s=l.length),l.slice(u,s)}for(i=l.length-1;i>=u;--i)if(t(l.charCodeAt(i))){if(!c){u=i+1;break}}else s===-1&&(c=!1,s=i+1);return s===-1?"":l.slice(u,s)},extname(l){p(l,"path");let a=0,u=-1,s=0,c=-1,i=!0,r=0;l.length>=2&&l.charCodeAt(1)===y&&b(l.charCodeAt(0))&&(a=s=2);for(let o=l.length-1;o>=a;--o){const d=l.charCodeAt(o);if(t(d)){if(!i){s=o+1;break}continue}c===-1&&(i=!1,c=o+1),d===I?u===-1?u=o:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||c===-1||r===0||r===1&&u===c-1&&u===s+1?"":l.slice(u,c)},format:P.bind(null,"\\"),parse(l){p(l,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return a;const u=l.length;let s=0,c=l.charCodeAt(0);if(u===1)return t(c)?(a.root=a.dir=l,a):(a.base=a.name=l,a);if(t(c)){if(s=1,t(l.charCodeAt(1))){let L=2,A=L;for(;L<u&&!t(l.charCodeAt(L));)L++;if(L<u&&L!==A){for(A=L;L<u&&t(l.charCodeAt(L));)L++;if(L<u&&L!==A){for(A=L;L<u&&!t(l.charCodeAt(L));)L++;L===u?s=L:L!==A&&(s=L+1)}}}}else if(b(c)&&l.charCodeAt(1)===y){if(u<=2)return a.root=a.dir=l,a;if(s=2,t(l.charCodeAt(2))){if(u===3)return a.root=a.dir=l,a;s=3}}s>0&&(a.root=l.slice(0,s));let i=-1,r=s,o=-1,d=!0,g=l.length-1,k=0;for(;g>=s;--g){if(c=l.charCodeAt(g),t(c)){if(!d){r=g+1;break}continue}o===-1&&(d=!1,o=g+1),c===I?i===-1?i=g:k!==1&&(k=1):i!==-1&&(k=-1)}return o!==-1&&(i===-1||k===0||k===1&&i===o-1&&i===r+1?a.base=a.name=l.slice(r,o):(a.name=l.slice(r,i),a.base=l.slice(r,o),a.ext=l.slice(i,o))),r>0&&r!==s?a.dir=l.slice(0,r-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let a="",u=!1;for(let s=l.length-1;s>=-1&&!u;s--){const c=s>=0?l[s]:v.cwd();p(c,"path"),c.length!==0&&(a=`${c}/${a}`,u=c.charCodeAt(0)===h)}return a=S(a,!u,"/",w),u?`/${a}`:a.length>0?a:"."},normalize(l){if(p(l,"path"),l.length===0)return".";const a=l.charCodeAt(0)===h,u=l.charCodeAt(l.length-1)===h;return l=S(l,!a,"/",w),l.length===0?a?"/":u?"./":".":(u&&(l+="/"),a?`/${l}`:l)},isAbsolute(l){return p(l,"path"),l.length>0&&l.charCodeAt(0)===h},join(...l){if(l.length===0)return".";let a;for(let u=0;u<l.length;++u){const s=l[u];p(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(l,a){if(p(l,"from"),p(a,"to"),l===a||(l=e.posix.resolve(l),a=e.posix.resolve(a),l===a))return"";const u=1,s=l.length,c=s-u,i=1,r=a.length-i,o=c<r?c:r;let d=-1,g=0;for(;g<o;g++){const L=l.charCodeAt(u+g);if(L!==a.charCodeAt(i+g))break;L===h&&(d=g)}if(g===o)if(r>o){if(a.charCodeAt(i+g)===h)return a.slice(i+g+1);if(g===0)return a.slice(i+g)}else c>o&&(l.charCodeAt(u+g)===h?d=g:g===0&&(d=0));let k="";for(g=u+d+1;g<=s;++g)(g===s||l.charCodeAt(g)===h)&&(k+=k.length===0?"..":"/..");return`${k}${a.slice(i+d)}`},toNamespacedPath(l){return l},dirname(l){if(p(l,"path"),l.length===0)return".";const a=l.charCodeAt(0)===h;let u=-1,s=!0;for(let c=l.length-1;c>=1;--c)if(l.charCodeAt(c)===h){if(!s){u=c;break}}else s=!1;return u===-1?a?"/":".":a&&u===1?"//":l.slice(0,u)},basename(l,a){a!==void 0&&p(a,"ext"),p(l,"path");let u=0,s=-1,c=!0,i;if(a!==void 0&&a.length>0&&a.length<=l.length){if(a===l)return"";let r=a.length-1,o=-1;for(i=l.length-1;i>=0;--i){const d=l.charCodeAt(i);if(d===h){if(!c){u=i+1;break}}else o===-1&&(c=!1,o=i+1),r>=0&&(d===a.charCodeAt(r)?--r==-1&&(s=i):(r=-1,s=o))}return u===s?s=o:s===-1&&(s=l.length),l.slice(u,s)}for(i=l.length-1;i>=0;--i)if(l.charCodeAt(i)===h){if(!c){u=i+1;break}}else s===-1&&(c=!1,s=i+1);return s===-1?"":l.slice(u,s)},extname(l){p(l,"path");let a=-1,u=0,s=-1,c=!0,i=0;for(let r=l.length-1;r>=0;--r){const o=l.charCodeAt(r);if(o===h){if(!c){u=r+1;break}continue}s===-1&&(c=!1,s=r+1),o===I?a===-1?a=r:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||s===-1||i===0||i===1&&a===s-1&&a===u+1?"":l.slice(a,s)},format:P.bind(null,"/"),parse(l){p(l,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return a;const u=l.charCodeAt(0)===h;let s;u?(a.root="/",s=1):s=0;let c=-1,i=0,r=-1,o=!0,d=l.length-1,g=0;for(;d>=s;--d){const k=l.charCodeAt(d);if(k===h){if(!o){i=d+1;break}continue}r===-1&&(o=!1,r=d+1),k===I?c===-1?c=d:g!==1&&(g=1):c!==-1&&(g=-1)}if(r!==-1){const k=i===0&&u?1:i;c===-1||g===0||g===1&&c===r-1&&c===i+1?a.base=a.name=l.slice(k,r):(a.name=l.slice(k,c),a.base=l.slice(k,r),a.ext=l.slice(c,r))}return i>0?a.dir=l.slice(0,i-1):u&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[80],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var R;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(C,...n){const I=n.reduce((y,E)=>(y[E]=!0,y),{}),h=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(y=>!I[y]).forEach(y=>{for(let E=0;E<h.length;E++)if(y.search(h[E])!==-1){delete C[y];break}})}e.sanitizeProcessEnvironment=M}),define(Q[108],Z([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class M{constructor(n){this._highResolution=R&&n,this._startTime=this._now(),this._stopTime=-1}static create(n=!0){return new M(n)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=M}),define(Q[4],Z([0,1,16,42,2,107,108]),function($,e,v,R,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(a){a.None=()=>M.Disposable.None;function u(F){return(U,G=null,Y)=>{let q=!1,z;return z=F(J=>{if(!q)return z?z.dispose():q=!0,U.call(G,J)},null,Y),q&&z.dispose(),z}}a.once=u;function s(F,U){return g((G,Y=null,q)=>F(z=>G.call(Y,U(z)),null,q))}a.map=s;function c(F,U){return g((G,Y=null,q)=>F(z=>{U(z),G.call(Y,z)},null,q))}a.forEach=c;function i(F,U){return g((G,Y=null,q)=>F(z=>U(z)&&G.call(Y,z),null,q))}a.filter=i;function r(F){return F}a.signal=r;function o(...F){return(U,G=null,Y)=>(0,M.combinedDisposable)(...F.map(q=>q(z=>U.call(G,z),null,Y)))}a.any=o;function d(F,U,G){let Y=G;return s(F,q=>(Y=U(Y,q),Y))}a.reduce=d;function g(F){let U;const G=new m({onFirstListenerAdd(){U=F(G.fire,G)},onLastListenerRemove(){U.dispose()}});return G.event}function k(F,U,G=100,Y=!1,q){let z,J,O,D=0;const T=new m({leakWarningThreshold:q,onFirstListenerAdd(){z=F(_=>{D++,J=U(J,_),Y&&!O&&(T.fire(J),J=void 0),clearTimeout(O),O=setTimeout(()=>{const B=J;J=void 0,O=void 0,(!Y||D>1)&&T.fire(B),D=0},G)})},onLastListenerRemove(){z.dispose()}});return T.event}a.debounce=k;function L(F,U=(G,Y)=>G===Y){let G=!0,Y;return i(F,q=>{const z=G||!U(q,Y);return G=!1,Y=q,z})}a.latch=L;function A(F,U){return[a.filter(F,U),a.filter(F,G=>!U(G))]}a.split=A;function W(F,U=!1,G=[]){let Y=G.slice(),q=F(O=>{Y?Y.push(O):J.fire(O)});const z=()=>{Y&&Y.forEach(O=>J.fire(O)),Y=null},J=new m({onFirstListenerAdd(){q||(q=F(O=>J.fire(O)))},onFirstListenerDidAdd(){Y&&(U?setTimeout(z):z())},onLastListenerRemove(){q&&q.dispose(),q=null}});return J.event}a.buffer=W;class V{constructor(U){this.event=U}map(U){return new V(s(this.event,U))}forEach(U){return new V(c(this.event,U))}filter(U){return new V(i(this.event,U))}reduce(U,G){return new V(d(this.event,U,G))}latch(){return new V(L(this.event))}debounce(U,G=100,Y=!1,q){return new V(k(this.event,U,G,Y,q))}on(U,G,Y){return this.event(U,G,Y)}once(U,G,Y){return u(this.event)(U,G,Y)}}function ee(F){return new V(F)}a.chain=ee;function oe(F,U,G=Y=>Y){const Y=(...O)=>J.fire(G(...O)),q=()=>F.on(U,Y),z=()=>F.removeListener(U,Y),J=new m({onFirstListenerAdd:q,onLastListenerRemove:z});return J.event}a.fromNodeEventEmitter=oe;function ae(F,U,G=Y=>Y){const Y=(...O)=>J.fire(G(...O)),q=()=>F.addEventListener(U,Y),z=()=>F.removeEventListener(U,Y),J=new m({onFirstListenerAdd:q,onLastListenerRemove:z});return J.event}a.fromDOMEventEmitter=ae;function K(F){return new Promise(U=>u(F)(U))}a.toPromise=K})(I=e.Event||(e.Event={}));class h{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${h._idPool++}`}start(u){this._stopWatch=new n.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}h._idPool=0;let f=-1;function y(a){const u=f;return f=a,{dispose(){f=u}}}e.setGlobalLeakWarningThreshold=y;class E{constructor(u,s=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let s=f;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||u<s)return;this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(c)||0;if(this._stacks.set(c,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let r,o=0;for(const[d,g]of this._stacks)(!r||o<g)&&(r=d,o=g);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${o}):`),console.warn(r)}return()=>{const r=this._stacks.get(c)||0;this._stacks.set(c,r-1)}}}class m{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=f>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0}get event(){return this._event||(this._event=(u,s,c)=>{this._listeners||(this._listeners=new C.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(s?[u,s]:u);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,s);const o=this._leakageMon?.check(this._listeners.size),d=(0,M.toDisposable)(()=>{o&&o(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return c instanceof M.DisposableStore?c.add(d):Array.isArray(c)&&c.push(d),d}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,c]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,c):s[0].call(s[1],c)}catch(i){(0,v.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class p extends m{async fireAsync(u,s,c){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,u]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[i,r]=this._asyncDeliveryQueue.shift(),o=[],d={...r,waitUntil:g=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");c&&(g=c(g,typeof i=="function"?i:i[0])),o.push(g)}};try{typeof i=="function"?i.call(void 0,d):i[0].call(i[1],d)}catch(g){(0,v.onUnexpectedError)(g);continue}Object.freeze(o),await Promise.allSettled(o).then(g=>{for(const k of g)k.status==="rejected"&&(0,v.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=p;class t extends m{constructor(u){super(u);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=t;class w extends t{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=w;class b extends m{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=b;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const s={event:u,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const c=()=>{this.hasListeners&&this.unhook(s);const i=this.events.indexOf(s);this.events.splice(i,1)};return(0,M.toDisposable)((0,R.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(s=>this.emitter.fire(s))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class P{constructor(){this.buffers=[]}wrapEvent(u){return(s,c,i)=>u(r=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>s.call(c,r)):s.call(c,r)},void 0,i)}bufferEvents(u){const s=[];this.buffers.push(s);const c=u();return this.buffers.pop(),s.forEach(i=>i()),c}}e.EventBufferer=P;class l{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=M.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(Q[23],Z([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(I,h){const f=setTimeout(I.bind(h),0);return{dispose(){clearTimeout(f)}}});var M;(function(I){function h(f){return f===I.None||f===I.Cancelled||f instanceof C?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}I.isCancellationToken=h,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(M=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class n{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=M.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=M.None}}e.CancellationTokenSource=n}),define(Q[109],Z([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(y){const E=this._icons.get(y.id);E?y.description?E.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const M=new R;e.iconRegistry=M;function C(f){return f?f.replace(/\$\((.*?)\)/g,(y,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=C;class n{constructor(y,E,m){this.id=y,this.definition=E,this.description=m,M.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n,n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function I(f,y){const E=["codicon","codicon-"+f];return y&&E.push("codicon-modifier-"+y),E}e.getClassNamesArray=I;var h;(function(f){f.iconNameSegment="[A-Za-z0-9]+",f.iconNameExpression="[A-Za-z0-9-]+",f.iconModifierExpression="~[A-Za-z]+",f.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${f.iconNameExpression})(${f.iconModifierExpression})?$`);function E(t){if(t instanceof n)return["codicon","codicon-"+t.id];const w=y.exec(t.id);if(!w)return E(n.error);let[,b,S]=w;const P=["codicon","codicon-"+b];return S&&P.push("codicon-modifier-"+S.substr(1)),P}f.asClassNameArray=E;function m(t){return E(t).join(" ")}f.asClassName=m;function p(t){return"."+E(t).join(".")}f.asCSSSelector=p})(h=e.CSSIcon||(e.CSSIcon={}))}),define(Q[60],Z([0,1,16,2]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function M(l){const a=l;return a?[a.on,a.pause,a.resume,a.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=M;function C(l){const a=l;return a?M(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=C;function n(l,a){return new I(l,a)}e.newWriteableStream=n;class I{constructor(a,u){this.reducer=a,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(u=>u(a))}emitError(a){this.listeners.error.length===0?(0,v.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(u=>u(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,u){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(a,u){if(this.state.destroyed)return;let s;switch(a){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const c=s.indexOf(u);c>=0&&s.splice(c,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(l,a){const u=[];let s;for(;(s=l.read())!==null;)u.push(s);return a(u)}e.consumeReadable=h;function f(l,a,u){const s=[];let c;for(;(c=l.read())!==null&&s.length<u;)s.push(c);return c===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof c!="undefined"){const i=c;return c=void 0,i}return l.read()}}}e.peekReadable=f;function y(l,a){return new Promise((u,s)=>{const c=[];E(l,{onData:i=>{a&&c.push(i)},onError:i=>{a?s(i):u(void 0)},onEnd:()=>{u(a?a(c):void 0)}})})}e.consumeStream=y;function E(l,a){l.on("error",u=>a.onError(u)),l.on("end",()=>a.onEnd()),l.on("data",u=>a.onData(u))}e.listenStream=E;function m(l,a){return new Promise((u,s)=>{const c=new R.DisposableStore,i=[],r=g=>{if(i.push(g),i.length>a)return c.dispose(),l.pause(),u({stream:l,buffer:i,ended:!1})},o=g=>s(g),d=()=>u({stream:l,buffer:i,ended:!0});c.add((0,R.toDisposable)(()=>l.removeListener("error",o))),l.on("error",o),c.add((0,R.toDisposable)(()=>l.removeListener("end",d))),l.on("end",d),c.add((0,R.toDisposable)(()=>l.removeListener("data",r))),l.on("data",r)})}e.peekStream=m;function p(l,a){const u=n(a);return u.end(l),u}e.toStream=p;function t(){const l=n(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=t;function w(l){let a=!1;return{read:()=>a?null:(a=!0,l)}}e.toReadable=w;function b(l,a,u){const s=n(u);return E(l,{onData:c=>s.write(a.data(c)),onError:c=>s.error(a.error?a.error(c):c),onEnd:()=>s.end()}),s}e.transform=b;function S(l,a,u){let s=!1;return{read:()=>{const c=a.read();return s?c:(s=!0,c!==null?u([l,c]):l)}}}e.prefixedReadable=S;function P(l,a,u){let s=!1;const c=n(u);return E(a,{onData:i=>s?c.write(i):(s=!0,c.write(u([l,i]))),onError:i=>c.error(i),onEnd:()=>{s||(s=!0,c.write(l)),c.end()}}),c}e.prefixedStream=P}),define(Q[17],Z([0,1,60]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined";let M,C;class n{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return R?new n(Buffer.allocUnsafe(r)):new n(new Uint8Array(r))}static wrap(r){return R&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new n(r)}static fromString(r,o){return!(o?.dontUseNodeBuffer||!1)&&R?new n(Buffer.from(r)):(M||(M=new TextEncoder),new n(M.encode(r)))}static concat(r,o){if(typeof o=="undefined"){o=0;for(let k=0,L=r.length;k<L;k++)o+=r[k].byteLength}const d=n.alloc(o);let g=0;for(let k=0,L=r.length;k<L;k++){const A=r[k];d.set(A,g),g+=A.byteLength}return d}toString(){return R?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(r,o){return new n(this.buffer.subarray(r,o))}set(r,o){r instanceof n?this.buffer.set(r.buffer,o):this.buffer.set(r,o)}readUInt32BE(r){return f(this.buffer,r)}writeUInt32BE(r,o){y(this.buffer,r,o)}readUInt32LE(r){return E(this.buffer,r)}writeUInt32LE(r,o){m(this.buffer,r,o)}readUInt8(r){return p(this.buffer,r)}writeUInt8(r,o){t(this.buffer,r,o)}}e.VSBuffer=n;function I(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0}e.readUInt16LE=I;function h(i,r,o){i[o+0]=r&255,r=r>>>8,i[o+1]=r&255}e.writeUInt16LE=h;function f(i,r){return i[r]*2**24+i[r+1]*2**16+i[r+2]*2**8+i[r+3]}e.readUInt32BE=f;function y(i,r,o){i[o+3]=r,r=r>>>8,i[o+2]=r,r=r>>>8,i[o+1]=r,r=r>>>8,i[o]=r}e.writeUInt32BE=y;function E(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0|i[r+2]<<16>>>0|i[r+3]<<24>>>0}e.readUInt32LE=E;function m(i,r,o){i[o+0]=r&255,r=r>>>8,i[o+1]=r&255,r=r>>>8,i[o+2]=r&255,r=r>>>8,i[o+3]=r&255}e.writeUInt32LE=m;function p(i,r){return i[r]}e.readUInt8=p;function t(i,r,o){i[o]=r}e.writeUInt8=t;function w(i){return v.consumeReadable(i,r=>n.concat(r))}e.readableToBuffer=w;function b(i){return v.toReadable(i)}e.bufferToReadable=b;function S(i){return v.consumeStream(i,r=>n.concat(r))}e.streamToBuffer=S;async function P(i){return i.ended?n.concat(i.buffer):n.concat([...i.buffer,await S(i.stream)])}e.bufferedStreamToBuffer=P;function l(i){return v.toStream(i,r=>n.concat(r))}e.bufferToStream=l;function a(i){return v.transform(i,{data:r=>typeof r=="string"?n.fromString(r):n.wrap(r)},r=>n.concat(r))}e.streamToBufferReadableStream=a;function u(i){return v.newWriteableStream(r=>n.concat(r),i)}e.newWriteableBufferStream=u;function s(i,r){return v.prefixedReadable(i,r,o=>n.concat(o))}e.prefixedBufferReadable=s;function c(i,r){return v.prefixedStream(i,r,o=>n.concat(o))}e.prefixedBufferStream=c}),define(Q[25],Z([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=R;const M=/{(\d+)}/g;function C(j,...ne){return ne.length===0?j:j.replace(M,function(ue,pe){const Ie=parseInt(pe,10);return isNaN(Ie)||Ie<0||Ie>=ne.length?ue:ne[Ie]})}e.format=C;const n=/{([^}]+)}/g;function I(j,ne){return j.replace(n,(ue,pe)=>ne[pe]??ue)}e.format2=I;function h(j){return j.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=h;function f(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function y(j,ne){let ue=0;const pe=ne.charCodeAt(0);for(let Ie=j.length-1;Ie>=0;Ie--)j.charCodeAt(Ie)===pe&&ue++;return ue}e.count=y;function E(j,ne,ue="\u2026"){return j.length<=ne?j:`${j.substr(0,ne)}${ue}`}e.truncate=E;function m(j,ne=" "){const ue=p(j,ne);return t(ue,ne)}e.trim=m;function p(j,ne){if(!j||!ne)return j;const ue=ne.length;if(ue===0||j.length===0)return j;let pe=0;for(;j.indexOf(ne,pe)===pe;)pe=pe+ue;return j.substring(pe)}e.ltrim=p;function t(j,ne){if(!j||!ne)return j;const ue=ne.length,pe=j.length;if(ue===0||pe===0)return j;let Ie=pe,Me=-1;for(;Me=j.lastIndexOf(ne,Ie-1),!(Me===-1||Me+ue!==Ie);){if(Me===0)return"";Ie=Me}return j.substring(0,Ie)}e.rtrim=t;function w(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function b(j){return j.replace(/\*/g,"")}e.stripWildcards=b;function S(j,ne,ue={}){if(!j)throw new Error("Cannot create regex from empty string");ne||(j=f(j)),ue.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let pe="";return ue.global&&(pe+="g"),ue.matchCase||(pe+="i"),ue.multiline&&(pe+="m"),ue.unicode&&(pe+="u"),new RegExp(j,pe)}e.createRegExp=S;function P(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function l(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function a(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=a;function u(j){return j.split(/\r\n|\r|\n/)}e.splitLines=u;function s(j){for(let ne=0,ue=j.length;ne<ue;ne++){const pe=j.charCodeAt(ne);if(pe!==32&&pe!==9)return ne}return-1}e.firstNonWhitespaceIndex=s;function c(j,ne=0,ue=j.length){for(let pe=ne;pe<ue;pe++){const Ie=j.charCodeAt(pe);if(Ie!==32&&Ie!==9)return j.substring(ne,pe)}return j.substring(ne,ue)}e.getLeadingWhitespace=c;function i(j,ne=j.length-1){for(let ue=ne;ue>=0;ue--){const pe=j.charCodeAt(ue);if(pe!==32&&pe!==9)return ue}return-1}e.lastNonWhitespaceIndex=i;function r(j,ne){return j<ne?-1:j>ne?1:0}e.compare=r;function o(j,ne,ue=0,pe=j.length,Ie=0,Me=ne.length){for(;ue<pe&&Ie<Me;ue++,Ie++){let Oe=j.charCodeAt(ue),Ne=ne.charCodeAt(Ie);if(Oe<Ne)return-1;if(Oe>Ne)return 1}const Te=pe-ue,Fe=Me-Ie;return Te<Fe?-1:Te>Fe?1:0}e.compareSubstring=o;function d(j,ne){return g(j,ne,0,j.length,0,ne.length)}e.compareIgnoreCase=d;function g(j,ne,ue=0,pe=j.length,Ie=0,Me=ne.length){for(;ue<pe&&Ie<Me;ue++,Ie++){let Oe=j.charCodeAt(ue),Ne=ne.charCodeAt(Ie);if(Oe===Ne)continue;if(Oe>=128||Ne>=128)return o(j.toLowerCase(),ne.toLowerCase(),ue,pe,Ie,Me);k(Oe)&&(Oe-=32),k(Ne)&&(Ne-=32);const je=Oe-Ne;if(je!==0)return je}const Te=pe-ue,Fe=Me-Ie;return Te<Fe?-1:Te>Fe?1:0}e.compareSubstringIgnoreCase=g;function k(j){return j>=97&&j<=122}e.isLowerAsciiLetter=k;function L(j){return j>=65&&j<=90}e.isUpperAsciiLetter=L;function A(j,ne){return j.length===ne.length&&g(j,ne)===0}e.equalsIgnoreCase=A;function W(j,ne){const ue=ne.length;return ne.length>j.length?!1:g(j,ne,0,ue)===0}e.startsWithIgnoreCase=W;function V(j,ne){let ue,pe=Math.min(j.length,ne.length);for(ue=0;ue<pe;ue++)if(j.charCodeAt(ue)!==ne.charCodeAt(ue))return ue;return pe}e.commonPrefixLength=V;function ee(j,ne){let ue,pe=Math.min(j.length,ne.length);const Ie=j.length-1,Me=ne.length-1;for(ue=0;ue<pe;ue++)if(j.charCodeAt(Ie-ue)!==ne.charCodeAt(Me-ue))return ue;return pe}e.commonSuffixLength=ee;function oe(j){return 55296<=j&&j<=56319}e.isHighSurrogate=oe;function ae(j){return 56320<=j&&j<=57343}e.isLowSurrogate=ae;function K(j,ne){return(j-55296<<10)+(ne-56320)+65536}e.computeCodePoint=K;function F(j,ne,ue){const pe=j.charCodeAt(ue);if(oe(pe)&&ue+1<ne){const Ie=j.charCodeAt(ue+1);if(ae(Ie))return K(pe,Ie)}return pe}e.getNextCodePoint=F;function U(j,ne){const ue=j.charCodeAt(ne-1);if(ae(ue)&&ne>1){const pe=j.charCodeAt(ne-2);if(oe(pe))return K(pe,ue)}return ue}function G(j,ne){const ue=ze.getInstance(),pe=ne,Ie=j.length,Me=F(j,Ie,ne);ne+=Me>=65536?2:1;let Te=ue.getGraphemeBreakType(Me);for(;ne<Ie;){const Fe=F(j,Ie,ne),Oe=ue.getGraphemeBreakType(Fe);if(We(Te,Oe))break;ne+=Fe>=65536?2:1,Te=Oe}return ne-pe}e.nextCharLength=G;function Y(j,ne){const ue=ze.getInstance(),pe=ne,Ie=U(j,ne);ne-=Ie>=65536?2:1;let Me=ue.getGraphemeBreakType(Ie);for(;ne>0;){const Te=U(j,ne),Fe=ue.getGraphemeBreakType(Te);if(We(Fe,Me))break;ne-=Te>=65536?2:1,Me=Fe}return pe-ne}e.prevCharLength=Y;function q(j,ne){const ue=ze.getInstance(),pe=j.length,Ie=ne,Me=F(j,pe,ne),Te=ue.getGraphemeBreakType(Me);ne+=Me>=65536?2:1;let Fe=Te;for(;ne<pe;){const Ne=F(j,pe,ne),je=ue.getGraphemeBreakType(Ne);if(We(Fe,je))break;ne+=Ne>=65536?2:1,Fe=je}const Oe=ne;for(ne=Ie,Fe=Te;ne>0;){const Ne=U(j,ne),je=ue.getGraphemeBreakType(Ne);if(We(je,Fe))break;ne-=Ne>=65536?2:1,Fe=je}return[ne,Oe]}function z(j,ne){return ne>0&&ae(j.charCodeAt(ne))?q(j,ne-1):q(j,ne)}e.getCharContainingOffset=z;const J=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(j){return J.test(j)}e.containsRTL=O;const D=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function T(j){return D.test(j)}e.containsEmoji=T;const _=/^[\t\n\r\x20-\x7E]*$/;function B(j){return _.test(j)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=X;function N(j){for(let ne=0,ue=j.length;ne<ue;ne++)if(H(j.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=N;function H(j){return j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=H;function ie(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129008||j>=129280&&j<=129535||j>=129648&&j<=129782}e.isEmojiImprecise=ie;function re(j,ne){if(j.length<ne)return j;const ue=/\b/g;let pe=0;for(;ue.test(j)&&!(j.length-ue.lastIndex<ne);)pe=ue.lastIndex,ue.lastIndex+=1;return j.substring(pe).replace(/^\s/,"")}e.lcut=re;const se=/\x1B\x5B[12]?K/g,x=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(j){return j&&(j=j.replace(se,""),j=j.replace(x,""),j=j.replace(ce,"")),j}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function me(j){return he(j)?j.substr(1):j}e.stripUTF8BOM=me;function be(j,ne){if(!j||!ne||j.length<ne.length)return!1;const ue=ne.length,pe=j.toLowerCase();let Ie=0,Me=-1;for(;Ie<ue;){const Te=pe.indexOf(ne[Ie],Me+1);if(Te<0)return!1;Me=Te,Ie++}return!0}e.fuzzyContains=be;function de(j,ne=!1){return j?(ne&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=de;function fe(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=fe;function Se(j,ne=1){if(ne===0)return"";let ue=-1;do ue=j.indexOf(`
`,ue+1),ne--;while(ne>0&&ue>=0);return ue===-1?j:(j[ue-1]==="\r"&&ue--,j.substr(0,ue))}e.getNLines=Se;function Ce(j){const ne=90-65+1;return j=j%(2*ne),j<ne?String.fromCharCode(97+j):String.fromCharCode(65+j-ne)}e.singleLetterHash=Ce;function Le(j){return ze.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Le;function We(j,ne){return j===0?ne!==5&&ne!==7:j===2&&ne===3?!1:j===4||j===2||j===3||ne===4||ne===2||ne===3?!0:!(j===8&&(ne===8||ne===9||ne===11||ne===12)||(j===11||j===9)&&(ne===9||ne===10)||(j===12||j===10)&&ne===10||ne===5||ne===13||ne===7||j===1||j===13&&ne===14||j===6&&ne===6)}e.breakBetweenGraphemeBreakType=We;var $e;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Qe()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const ue=this._data,pe=ue.length/3;let Ie=1;for(;Ie<=pe;)if(ne<ue[3*Ie])Ie=2*Ie;else if(ne>ue[3*Ie+1])Ie=2*Ie+1;else return ue[3*Ie+2];return 0}}ze._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(j,ne){if(j===0)return 0;const ue=gt(j,ne);if(ue!==void 0)return ue;const pe=U(ne,j);return j-=Je(pe),j}e.getLeftDeleteOffset=Ge;function gt(j,ne){let ue=U(ne,j);for(j-=Je(ue);at(ue)||ue===65039||ue===8419;){if(j===0)return;ue=U(ne,j),j-=Je(ue)}if(!!ie(ue)){if(j>=0){const pe=U(ne,j);pe===8205&&(j-=Je(pe))}return j}}function Je(j){return j>=65536?2:1}function at(j){return 127995<=j&&j<=127999}var ct;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.noBreakWhitespace="\xA0";class Ve{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ve.map){let pe=function(Te){const Fe=new Map;for(let Oe=0;Oe<Te.length;Oe+=2)Fe.set(Te[Oe],Te[Oe+1]);return Fe};const ne=Ve.getData();let ue=v.locale;(!ue||!(ue in ne))&&(ue=v.language),(!ue||!(ue in ne))&&(ue="_default");const Ie=pe(ne._common),Me=pe(ne[ue]);for(const[Te,Fe]of Me)Ie.set(Te,Fe);Ve.map=Ie}return Ve.map}static isAmbiguous(ne){return Ve.getConfusablesForCurrentLocale().has(ne)}static getPrimaryConfusable(ne){return Ve.getConfusablesForCurrentLocale().get(ne)}static getPrimaryConfusableCodePoints(){return new Set(Ve.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ve;class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(ne){return He.getData().has(ne)}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He,He._data=void 0}),define(Q[81],Z([0,1,25]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(S){return M(S,0)}e.hash=R;function M(S,P){switch(typeof S){case"object":return S===null?C(349,P):Array.isArray(S)?h(S,P):f(S,P);case"string":return I(S,P);case"boolean":return n(S,P);case"number":return C(S,P);case"undefined":return C(937,P);default:return C(617,P)}}e.doHash=M;function C(S,P){return(P<<5)-P+S|0}e.numberHash=C;function n(S,P){return C(S?433:863,P)}function I(S,P){P=C(149417,P);for(let l=0,a=S.length;l<a;l++)P=C(S.charCodeAt(l),P);return P}e.stringHash=I;function h(S,P){return P=C(104579,P),S.reduce((l,a)=>M(a,l),P)}function f(S,P){return P=C(181387,P),Object.keys(S).sort().reduce((l,a)=>(l=I(a,l),M(S[a],l)),P)}class y{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=M(P,this._value),this._value}}e.Hasher=y;var E;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(S,P,l=32){const a=l-P,u=~((1<<a)-1);return(S<<P|(u&S)>>>a)>>>0}function p(S,P=0,l=S.byteLength,a=0){for(let u=0;u<l;u++)S[P+u]=a}function t(S,P,l="0"){for(;S.length<P;)S=l+S;return S}function w(S,P=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(l=>l.toString(16).padStart(2,"0")).join(""):t((S>>>0).toString(16),P/4)}e.toHexString=w;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const l=P.length;if(l===0)return;const a=this._buff;let u=this._buffLen,s=this._leftoverHighSurrogate,c,i;for(s!==0?(c=s,i=-1,s=0):(c=P.charCodeAt(0),i=0);;){let r=c;if(v.isHighSurrogate(c))if(i+1<l){const o=P.charCodeAt(i+1);v.isLowSurrogate(o)?(i++,r=v.computeCodePoint(c,o)):r=65533}else{s=c;break}else v.isLowSurrogate(c)&&(r=65533);if(u=this._push(a,u,r),i++,i<l)c=P.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=s}_push(P,l,a){return a<128?P[l++]=a:a<2048?(P[l++]=192|(a&1984)>>>6,P[l++]=128|(a&63)>>>0):a<65536?(P[l++]=224|(a&61440)>>>12,P[l++]=128|(a&4032)>>>6,P[l++]=128|(a&63)>>>0):(P[l++]=240|(a&1835008)>>>18,P[l++]=128|(a&258048)>>>12,P[l++]=128|(a&4032)>>>6,P[l++]=128|(a&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=b._bigBlock32,l=this._buffDV;for(let g=0;g<64;g+=4)P.setUint32(g,l.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)P.setUint32(g,m(P.getUint32(g-12,!1)^P.getUint32(g-32,!1)^P.getUint32(g-56,!1)^P.getUint32(g-64,!1),1),!1);let a=this._h0,u=this._h1,s=this._h2,c=this._h3,i=this._h4,r,o,d;for(let g=0;g<80;g++)g<20?(r=u&s|~u&c,o=1518500249):g<40?(r=u^s^c,o=1859775393):g<60?(r=u&s|u&c|s&c,o=2400959708):(r=u^s^c,o=3395469782),d=m(a,5)+r+i+o+P.getUint32(g*4,!1)&4294967295,i=c,c=s,s=m(u,30),u=a,a=d;this._h0=this._h0+a&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))});var kt=this&&this.__classPrivateFieldSet||function($,e,v,R,M){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!M)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?$!==e||!M:!e.has($))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?M.call($,v):M?M.value=v:e.set($,v),v},Ke=this&&this.__classPrivateFieldGet||function($,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?$!==e||!R:!e.has($))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call($):R?R.value:e.get($)};define(Q[40],Z([0,1,30,25]),function($,e,v,R){"use strict";var M,C,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(i,r,o){let d=i.get(r);return d===void 0&&(d=o,i.set(r,d)),d}e.getOrSet=I;function h(i){const r=[];return i.forEach((o,d)=>{r.push(`${d} => ${o}`)}),`Map(${i.size}) {${r.join(", ")}}`}e.mapToString=h;function f(i){const r=[];return i.forEach(o=>{r.push(o)}),`Set(${i.size}) {${r.join(", ")}}`}e.setToString=f;class y{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const o=r.charCodeAt(0),d=this._value.charCodeAt(this._pos);return o-d}value(){return this._value[this._pos]}}e.StringIterator=y;class E{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class m{constructor(r=!0,o=!0){this._splitOnBackslash=r,this._caseSensitive=o}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,R.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var p;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(p||(p={}));class t{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,R.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(b||(b={}));class S{constructor(r){this._iter=r}static forUris(r=()=>!1){return new S(new t(r))}static forPaths(){return new S(new m)}static forStrings(){return new S(new y)}static forConfigKeys(){return new S(new E)}clear(){this._root=void 0}fill(r,o){if(o){const d=o.slice(0);(0,v.shuffle)(d);for(let g of d)this.set(g,r)}else{const d=r.slice(0);(0,v.shuffle)(d);for(let g of d)this.set(g[0],g[1])}}set(r,o){const d=this._iter.reset(r);let g;this._root||(this._root=new w,this._root.segment=d.value());const k=[];for(g=this._root;;){const A=d.cmp(g.segment);if(A>0)g.left||(g.left=new w,g.left.segment=d.value()),k.push([-1,g]),g=g.left;else if(A<0)g.right||(g.right=new w,g.right.segment=d.value()),k.push([1,g]),g=g.right;else if(d.hasNext())d.next(),g.mid||(g.mid=new w,g.mid.segment=d.value()),k.push([0,g]),g=g.mid;else break}const L=g.value;g.value=o,g.key=r;for(let A=k.length-1;A>=0;A--){const W=k[A][1];W.updateHeight();const V=W.balanceFactor();if(V<-1||V>1){const ee=k[A][0],oe=k[A+1][0];if(ee===1&&oe===1)k[A][1]=W.rotateLeft();else if(ee===-1&&oe===-1)k[A][1]=W.rotateRight();else if(ee===1&&oe===-1)W.right=k[A+1][1]=k[A+1][1].rotateRight(),k[A][1]=W.rotateLeft();else if(ee===-1&&oe===1)W.left=k[A+1][1]=k[A+1][1].rotateLeft(),k[A][1]=W.rotateRight();else throw new Error;if(A>0)switch(k[A-1][0]){case-1:k[A-1][1].left=k[A][1];break;case 1:k[A-1][1].right=k[A][1];break;case 0:k[A-1][1].mid=k[A][1];break}else this._root=k[0][1]}}return L}get(r){return this._getNode(r)?.value}_getNode(r){const o=this._iter.reset(r);let d=this._root;for(;d;){const g=o.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(o.hasNext())o.next(),d=d.mid;else break}return d}has(r){const o=this._getNode(r);return!(o?.value===void 0&&o?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,o){const d=this._iter.reset(r),g=[];let k=this._root;for(;k;){const L=d.cmp(k.segment);if(L>0)g.push([-1,k]),k=k.left;else if(L<0)g.push([1,k]),k=k.right;else if(d.hasNext())d.next(),g.push([0,k]),k=k.mid;else break}if(!!k){if(o?(k.left=void 0,k.mid=void 0,k.right=void 0,k.height=1):(k.key=void 0,k.value=void 0),!k.mid&&!k.value)if(k.left&&k.right){const L=this._min(k.right),{key:A,value:W,segment:V}=L;this._delete(L.key,!1),k.key=A,k.value=W,k.segment=V}else{const L=k.left??k.right;if(g.length>0){const[A,W]=g[g.length-1];switch(A){case-1:W.left=L;break;case 0:W.mid=L;break;case 1:W.right=L;break}}else this._root=L}for(let L=g.length-1;L>=0;L--){const A=g[L][1];A.updateHeight();const W=A.balanceFactor();if(W>1?(A.right.balanceFactor()>=0||(A.right=g[L+1][1]=g[L+1][1].rotateRight()),g[L][1]=A.rotateLeft()):W<-1&&(A.left.balanceFactor()<=0||(A.left=g[L+1][1]=g[L+1][1].rotateLeft()),g[L][1]=A.rotateRight()),L>0)switch(g[L-1][0]){case-1:g[L-1][1].left=g[L][1];break;case 1:g[L-1][1].right=g[L][1];break;case 0:g[L-1][1].mid=g[L][1];break}else this._root=g[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const o=this._iter.reset(r);let d=this._root,g;for(;d;){const k=o.cmp(d.segment);if(k>0)d=d.left;else if(k<0)d=d.right;else if(o.hasNext())o.next(),g=d.value||g,d=d.mid;else break}return d&&d.value||g}findSuperstr(r){const o=this._iter.reset(r);let d=this._root;for(;d;){const g=o.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(o.hasNext())o.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(r){for(const[o,d]of this)r(d,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=o=>{if(!o)return!0;const d=o.balanceFactor();return d<-1||d>1?!1:r(o.left)&&r(o.right)};return r(this._root)}}e.TernarySearchTree=S;class P{constructor(r,o){this.uri=r,this.value=o}}class l{constructor(r,o){this[M]="ResourceMap",r instanceof l?(this.map=new Map(r.map),this.toKey=o??l.defaultToKey):(this.map=new Map,this.toKey=r??l.defaultToKey)}set(r,o){return this.map.set(this.toKey(r),new P(r,o)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,o){typeof o!="undefined"&&(r=r.bind(o));for(let[d,g]of this.map)r(g.value,g.uri,this)}*values(){for(let r of this.map.values())yield r.value}*keys(){for(let r of this.map.values())yield r.uri}*entries(){for(let r of this.map.values())yield[r.uri,r.value]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=l,l.defaultToKey=i=>i.toString();var a;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class u{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,o=0){const d=this._map.get(r);if(!!d)return o!==0&&this.touch(d,o),d.value}set(r,o,d=0){let g=this._map.get(r);if(g)g.value=o,d!==0&&this.touch(g,d);else{switch(g={key:r,value:o,next:void 0,previous:void 0},d){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(r,g),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this._map.get(r);if(!!o)return this._map.delete(r),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,o){const d=this._state;let g=this._head;for(;g;){if(o?r.bind(o)(g.value,g.key,this):r(g.value,g.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const r=this,o=this._state;let d=this._head;const g={[Symbol.iterator](){return g},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const k={value:d.key,done:!1};return d=d.next,k}else return{value:void 0,done:!0}}};return g}values(){const r=this,o=this._state;let d=this._head;const g={[Symbol.iterator](){return g},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const k={value:d.value,done:!1};return d=d.next,k}else return{value:void 0,done:!0}}};return g}entries(){const r=this,o=this._state;let d=this._head;const g={[Symbol.iterator](){return g},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const k={value:[d.key,d.value],done:!1};return d=d.next,k}else return{value:void 0,done:!0}}};return g}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this._head,d=this.size;for(;o&&d>r;)this._map.delete(o.key),o=o.next,d--;this._head=o,this._size=d,o&&(o.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const o=r.next,d=r.previous;if(!o||!d)throw new Error("Invalid list");o.previous=d,d.next=o}r.next=void 0,r.previous=void 0,this._state++}touch(r,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this._head)return;const d=r.next,g=r.previous;r===this._tail?(g.next=void 0,this._tail=g):(d.previous=g,g.next=d),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(o===2){if(r===this._tail)return;const d=r.next,g=r.previous;r===this._head?(d.previous=void 0,this._head=d):(d.previous=g,g.next=d),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((o,d)=>{r.push([d,o])}),r}fromJSON(r){this.clear();for(const[o,d]of r)this.set(o,d)}}e.LinkedMap=u;class s extends u{constructor(r,o=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class c{constructor(r){n.set(this,void 0),kt(this,n,r,"f")}get size(){return Ke(this,n,"f").size}forEach(r,o){Ke(this,n,"f").forEach(r,o)}get(r){return Ke(this,n,"f").get(r)}has(r){return Ke(this,n,"f").has(r)}entries(){return Ke(this,n,"f").entries()}keys(){return Ke(this,n,"f").keys()}values(){return Ke(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return Ke(this,n,"f").entries()}}e.ReadonlyMapView=c}),define(Q[70],Z([0,1,40]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new v.LRUCache(1e4);function M(f){return h(f,"NFC",R)}e.normalizeNFC=M;const C=new v.LRUCache(1e4);function n(f){return h(f,"NFD",C)}e.normalizeNFD=n;const I=/[^\u0000-\u0080]/;function h(f,y,E){if(!f)return f;const m=E.get(f);if(m)return m;let p;return I.test(f)?p=f.normalize(y):p=f,E.set(f,p),p}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(y){return n(y).replace(f,"")}}()}),define(Q[13],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(k){return Array.isArray(k)}e.isArray=v;function R(k){return typeof k=="string"}e.isString=R;function M(k){return Array.isArray(k)&&k.every(L=>R(L))}e.isStringArray=M;function C(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.isObject=C;function n(k){return typeof k=="number"&&!isNaN(k)}e.isNumber=n;function I(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.isIterable=I;function h(k){return k===!0||k===!1}e.isBoolean=h;function f(k){return typeof k=="undefined"}e.isUndefined=f;function y(k){return!E(k)}e.isDefined=y;function E(k){return f(k)||k===null}e.isUndefinedOrNull=E;function m(k,L){if(!k)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=m;function p(k){if(E(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.assertIsDefined=p;function t(...k){const L=[];for(let A=0;A<k.length;A++){const W=k[A];if(E(W))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);L.push(W)}return L}e.assertAllDefined=t;const w=Object.prototype.hasOwnProperty;function b(k){if(!C(k))return!1;for(let L in k)if(w.call(k,L))return!1;return!0}e.isEmptyObject=b;function S(k){return typeof k=="function"}e.isFunction=S;function P(...k){return k.length>0&&k.every(S)}e.areFunctions=P;function l(k,L){const A=Math.min(k.length,L.length);for(let W=0;W<A;W++)a(k[W],L[W])}e.validateConstraints=l;function a(k,L){if(R(L)){if(typeof k!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(S(L)){try{if(k instanceof L)return}catch{}if(!E(k)&&k.constructor===L||L.length===1&&L.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function u(k){let L=[],A=Object.getPrototypeOf(k);for(;Object.prototype!==A;)L=L.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return L}e.getAllPropertyNames=u;function s(k){const L=[];for(const A of u(k))typeof k[A]=="function"&&L.push(A);return L}e.getAllMethodNames=s;function c(k,L){const A=V=>function(){const ee=Array.prototype.slice.call(arguments,0);return L(V,ee)};let W={};for(const V of k)W[V]=A(V);return W}e.createProxyObject=c;function i(k){return k===null?void 0:k}e.withNullAsUndefined=i;function r(k){return typeof k=="undefined"?null:k}e.withUndefinedAsNull=r;function o(k){return class{constructor(){return new Proxy({},{get(L,A){if(L[A])return L[A];throw new Error(`Not Implemented: ${k}->${String(A)}`)}})}}}e.NotImplementedProxy=o;function d(k,L="Unreachable"){throw new Error(L)}e.assertNever=d;function g(k){return!!k&&typeof k.then=="function"&&typeof k.catch=="function"}e.isPromise=g}),define(Q[32],Z([0,1,8,3,25,13]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(i){return i===47||i===92}e.isPathSeparator=n;function I(i){return i.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=I;function h(i){return i.indexOf("/")===-1&&(i=I(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=h;function f(i,r=v.posix.sep){if(!i)return"";const o=i.length,d=i.charCodeAt(0);if(n(d)){if(n(i.charCodeAt(1))&&!n(i.charCodeAt(2))){let k=3;const L=k;for(;k<o&&!n(i.charCodeAt(k));k++);if(L!==k&&!n(i.charCodeAt(k+1))){for(k+=1;k<o;k++)if(n(i.charCodeAt(k)))return i.slice(0,k+1).replace(/[\\/]/g,r)}}return r}else if(S(d)&&i.charCodeAt(1)===58)return n(i.charCodeAt(2))?i.slice(0,2)+r:i.slice(0,2);let g=i.indexOf("://");if(g!==-1){for(g+=3;g<o;g++)if(n(i.charCodeAt(g)))return i.slice(0,g+1)}return""}e.getRoot=f;function y(i){if(!R.isWindows||!i||i.length<5)return!1;let r=i.charCodeAt(0);if(r!==92||(r=i.charCodeAt(1),r!==92))return!1;let o=2;const d=o;for(;o<i.length&&(r=i.charCodeAt(o),r!==92);o++);return!(d===o||(r=i.charCodeAt(o+1),isNaN(r)||r===92))}e.isUNC=y;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(i,r=R.isWindows){const o=r?E:m;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||r&&p.test(i)||i==="."||i===".."||r&&i[i.length-1]==="."||r&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=t;function w(i,r,o){const d=i===r;return!o||d?d:!i||!r?!1:(0,M.equalsIgnoreCase)(i,r)}e.isEqual=w;function b(i,r,o,d=v.sep){if(i===r)return!0;if(!i||!r||r.length>i.length)return!1;if(o){if(!(0,M.startsWithIgnoreCase)(i,r))return!1;if(r.length===i.length)return!0;let k=r.length;return r.charAt(r.length-1)===d&&k--,i.charAt(k)===d}return r.charAt(r.length-1)!==d&&(r+=d),i.indexOf(r)===0}e.isEqualOrParent=b;function S(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=S;function P(i,r){return R.isWindows&&i.endsWith(":")&&(i+=v.sep),(0,v.isAbsolute)(i)||(i=(0,v.join)(r,i)),i=(0,v.normalize)(i),R.isWindows?(i=(0,M.rtrim)(i,v.sep),i.endsWith(":")&&(i+=v.sep)):(i=(0,M.rtrim)(i,v.sep),i||(i=v.sep)),i}e.sanitizeFilePath=P;function l(i){const r=(0,v.normalize)(i);return R.isWindows?i.length>3?!1:a(r)&&(i.length===2||r.charCodeAt(2)===92):r===v.posix.sep}e.isRootOrDriveLetter=l;function a(i,r){return(r!==void 0?r:R.isWindows)?S(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function u(i){return a(i)?i[0]:void 0}e.getDriveLetter=u;function s(i,r,o){return r.length>i.length?-1:i===r?0:(o&&(i=i.toLowerCase(),r=r.toLowerCase()),i.indexOf(r))}e.indexOfPath=s;function c(i){const r=i.split(":");let o,d,g;if(r.forEach(k=>{const L=Number(k);(0,C.isNumber)(L)?d===void 0?d=L:g===void 0&&(g=L):o=o?[o,k].join(":"):k}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:d!==void 0?d:void 0,column:g!==void 0?g:d!==void 0?1:void 0}}e.parseLineAndColumnAware=c}),define(Q[47],Z([0,1,13]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const b=Array.isArray(w)?[]:{};return Object.keys(w).forEach(S=>{w[S]&&typeof w[S]=="object"?b[S]=R(w[S]):b[S]=w[S]}),b}e.deepClone=R;function M(w){if(!w||typeof w!="object")return w;const b=[w];for(;b.length>0;){const S=b.shift();Object.freeze(S);for(const P in S)if(C.call(S,P)){const l=S[P];typeof l=="object"&&!Object.isFrozen(l)&&b.push(l)}}return w}e.deepFreeze=M;const C=Object.prototype.hasOwnProperty;function n(w,b){return I(w,b,new Set)}e.cloneAndChange=n;function I(w,b,S){if((0,v.isUndefinedOrNull)(w))return w;const P=b(w);if(typeof P!="undefined")return P;if((0,v.isArray)(w)){const l=[];for(const a of w)l.push(I(a,b,S));return l}if((0,v.isObject)(w)){if(S.has(w))throw new Error("Cannot clone recursive data-structure");S.add(w);const l={};for(let a in w)C.call(w,a)&&(l[a]=I(w[a],b,S));return S.delete(w),l}return w}function h(w,b,S=!0){return(0,v.isObject)(w)?((0,v.isObject)(b)&&Object.keys(b).forEach(P=>{P in w?S&&((0,v.isObject)(w[P])&&(0,v.isObject)(b[P])?h(w[P],b[P],S):w[P]=b[P]):w[P]=b[P]}),w):b}e.mixin=h;function f(w,b){if(w===b)return!0;if(w==null||b===null||b===void 0||typeof w!=typeof b||typeof w!="object"||Array.isArray(w)!==Array.isArray(b))return!1;let S,P;if(Array.isArray(w)){if(w.length!==b.length)return!1;for(S=0;S<w.length;S++)if(!f(w[S],b[S]))return!1}else{const l=[];for(P in w)l.push(P);l.sort();const a=[];for(P in b)a.push(P);if(a.sort(),!f(l,a))return!1;for(S=0;S<l.length;S++)if(!f(w[l[S]],b[l[S]]))return!1}return!0}e.equals=f;function y(w){const b=new Set;return JSON.stringify(w,(S,P)=>{if((0,v.isObject)(P)||Array.isArray(P)){if(b.has(P))return"[Circular]";b.add(P)}return P})}e.safeStringify=y;function E(w,b,S){const P=b(w);return typeof P=="undefined"?S:P}e.getOrDefault=E;function m(w,b){const S=Object.create(null);return!w||!b||Object.keys(b).forEach(l=>{const a=w[l],u=b[l];f(a,u)||(S[l]=u)}),S}e.distinct=m;function p(w,b){const S=b.toLowerCase(),P=Object.keys(w).find(l=>l.toLowerCase()===S);return P?w[P]:w[b]}e.getCaseInsensitive=p;function t(w,b){const S=Object.create(null);for(const[P,l]of Object.entries(w))b(P,l)&&(S[P]=l);return S}e.filter=t}),define(Q[7],Z([0,1,8,3]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const M=/^\w[\w\d+.-]*$/,C=/^\//,n=/^\/\//;function I(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!M.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(n.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,r){return!i&&!r?"file":i}function f(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==E&&(r=E+r):r=E;break}return r}const y="",E="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(r,o,d,g,k,L=!1){typeof r=="object"?(this.scheme=r.scheme||y,this.authority=r.authority||y,this.path=r.path||y,this.query=r.query||y,this.fragment=r.fragment||y):(this.scheme=h(r,L),this.authority=o||y,this.path=f(this.scheme,d||y),this.query=g||y,this.fragment=k||y,I(this,L))}static isUri(r){return r instanceof p?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return l(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:d,path:g,query:k,fragment:L}=r;return o===void 0?o=this.scheme:o===null&&(o=y),d===void 0?d=this.authority:d===null&&(d=y),g===void 0?g=this.path:g===null&&(g=y),k===void 0?k=this.query:k===null&&(k=y),L===void 0?L=this.fragment:L===null&&(L=y),o===this.scheme&&d===this.authority&&g===this.path&&k===this.query&&L===this.fragment?this:new w(o,d,g,k,L)}static parse(r,o=!1){const d=m.exec(r);return d?new w(d[2]||y,c(d[4]||y),c(d[5]||y),c(d[7]||y),c(d[9]||y),o):new w(y,y,y,y,y)}static file(r){let o=y;if(R.isWindows&&(r=r.replace(/\\/g,E)),r[0]===E&&r[1]===E){const d=r.indexOf(E,2);d===-1?(o=r.substring(2),r=E):(o=r.substring(2,d),r=r.substring(d)||E)}return new w("file",o,r,y,y)}static from(r){const o=new w(r.scheme,r.authority,r.path,r.query,r.fragment);return I(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return R.isWindows&&r.scheme==="file"?d=p.file(v.win32.join(l(r,!0),...o)).path:d=v.posix.join(r.path,...o),r.with({path:d})}toString(r=!1){return a(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof p)return r;{const o=new w(r);return o._formatted=r.external,o._fsPath=r._sep===t?r.fsPath:null,o}}else return r}}e.URI=p;const t=R.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(r=!1){return r?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=t),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(i,r){let o,d=-1;for(let g=0;g<i.length;g++){const k=i.charCodeAt(g);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||r&&k===47)d!==-1&&(o+=encodeURIComponent(i.substring(d,g)),d=-1),o!==void 0&&(o+=i.charAt(g));else{o===void 0&&(o=i.substr(0,g));const L=b[k];L!==void 0?(d!==-1&&(o+=encodeURIComponent(i.substring(d,g)),d=-1),o+=L):d===-1&&(d=g)}}return d!==-1&&(o+=encodeURIComponent(i.substring(d))),o!==void 0?o:i}function P(i){let r;for(let o=0;o<i.length;o++){const d=i.charCodeAt(o);d===35||d===63?(r===void 0&&(r=i.substr(0,o)),r+=b[d]):r!==void 0&&(r+=i[o])}return r!==void 0?r:i}function l(i,r){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,R.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=l;function a(i,r){const o=r?P:S;let d="",{scheme:g,authority:k,path:L,query:A,fragment:W}=i;if(g&&(d+=g,d+=":"),(k||g==="file")&&(d+=E,d+=E),k){let V=k.indexOf("@");if(V!==-1){const ee=k.substr(0,V);k=k.substr(V+1),V=ee.indexOf(":"),V===-1?d+=o(ee,!1):(d+=o(ee.substr(0,V),!1),d+=":",d+=o(ee.substr(V+1),!1)),d+="@"}k=k.toLowerCase(),V=k.indexOf(":"),V===-1?d+=o(k,!1):(d+=o(k.substr(0,V),!1),d+=k.substr(V))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const V=L.charCodeAt(1);V>=65&&V<=90&&(L=`/${String.fromCharCode(V+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const V=L.charCodeAt(0);V>=65&&V<=90&&(L=`${String.fromCharCode(V+32)}:${L.substr(2)}`)}d+=o(L,!0)}return A&&(d+="?",d+=o(A,!1)),W&&(d+="#",d+=r?W:S(W,!1)),d}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(s)?i.replace(s,r=>u(r)):i}}),define(Q[110],Z([0,1,7]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(f){const y=f;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=R;function M(f){const y=[];let E;try{const m=JSON.parse(f.arguments),p=m[m.length-1];p&&p.__$stack&&(m.pop(),E=p.__$stack),y.push(...m)}catch(m){y.push("Unable to log remote console arguments",f.arguments)}return{args:y,stack:E}}e.parse=M;function C(f){if(typeof f!="string")return C(M(f).stack);const y=f;if(y){const E=n(y),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:v.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=C;function n(f){if(!f)return f;const y=f.indexOf(`
`);return y===-1?f:f.substring(0,y)}function I(f,y){const{args:E,stack:m}=M(f),p=typeof E[0]=="string"&&E.length===1;let t=n(m);t&&(t=`(${t.trim()})`);let w=[];if(typeof E[0]=="string"?t&&p?w=[`%c[${y}] %c${E[0]} %c${t}`,h("blue"),h(""),h("grey")]:w=[`%c[${y}] %c${E[0]}`,h("blue"),h(""),...E.slice(1)]:w=[`%c[${y}]%`,h("blue"),...E],t&&!p&&w.push(t),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,w)}e.log=I;function h(f){return`color: ${f}`}}),define(Q[111],Z([0,1,17,25,7]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(y){return JSON.stringify(y,h)}e.stringify=C;function n(y){let E=JSON.parse(y);return E=f(E),E}e.parse=n;var I;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function h(y,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,R.regExpFlags)(E)}:E}function f(y,E=0){if(!y||E>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return M.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof v.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let m=0;m<y.length;++m)y[m]=f(y[m],E+1);else for(const m in y)Object.hasOwnProperty.call(y,m)&&(y[m]=f(y[m],E+1))}return y}e.revive=f}),define(Q[10],Z([0,1,3,7]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var M;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(M=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}set(h,f,y){this._hosts[h]=f,this._ports[h]=y}setConnectionToken(h,f){this._connectionTokens[h]=f}rewrite(h){if(this._delegate)return this._delegate(h);const f=h.authority;let y=this._hosts[f];y&&y.indexOf(":")!==-1&&(y=`[${y}]`);const E=this._ports[f],m=this._connectionTokens[f];let p=`path=${encodeURIComponent(h.path)}`;return typeof m=="string"&&(p+=`&tkn=${encodeURIComponent(m)}`),R.URI.from({scheme:v.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${y}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new C;class n{asBrowserUri(h,f){const y=this.toUri(h,f);return y.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===M.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${M.vscodeFileResource}://${n.FALLBACK_AUTHORITY}`)?y.with({scheme:M.vscodeFileResource,authority:y.authority||n.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(h,f){const y=this.toUri(h,f);return y.scheme===M.vscodeFileResource?y.with({scheme:M.file,authority:y.authority!==n.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(h,f){return R.URI.isUri(h)?h:R.URI.parse(f.toUrl(h))}}n.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new n}),define(Q[15],Z([0,1,32,10,8,3,25,7]),function($,e,v,R,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(p){return(0,I.uriToFsPath)(p,!0)}e.originalFSPath=h;class f{constructor(t){this._ignorePathCasing=t}compare(t,w,b=!1){return t===w?0:(0,n.compare)(this.getComparisonKey(t,b),this.getComparisonKey(w,b))}isEqual(t,w,b=!1){return t===w?!0:!t||!w?!1:this.getComparisonKey(t,b)===this.getComparisonKey(w,b)}getComparisonKey(t,w=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,w,b=!1){if(t.scheme===w.scheme){if(t.scheme===R.Schemas.file)return v.isEqualOrParent(h(t),h(w),this._ignorePathCasing(t))&&t.query===w.query&&(b||t.fragment===w.fragment);if((0,e.isEqualAuthority)(t.authority,w.authority))return v.isEqualOrParent(t.path,w.path,this._ignorePathCasing(t),"/")&&t.query===w.query&&(b||t.fragment===w.fragment)}return!1}joinPath(t,...w){return I.URI.joinPath(t,...w)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return M.posix.basename(t.path)}extname(t){return M.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let w;return t.scheme===R.Schemas.file?w=I.URI.file(M.dirname(h(t))).path:(w=M.posix.dirname(t.path),t.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),w="/")),t.with({path:w})}normalizePath(t){if(!t.path.length)return t;let w;return t.scheme===R.Schemas.file?w=I.URI.file(M.normalize(h(t))).path:w=M.posix.normalize(t.path),t.with({path:w})}relativePath(t,w){if(t.scheme!==w.scheme||!(0,e.isEqualAuthority)(t.authority,w.authority))return;if(t.scheme===R.Schemas.file){const P=M.relative(h(t),h(w));return C.isWindows?v.toSlashes(P):P}let b=t.path||"/",S=w.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const l=Math.min(b.length,S.length);P<l&&!(b.charCodeAt(P)!==S.charCodeAt(P)&&b.charAt(P).toLowerCase()!==S.charAt(P).toLowerCase());P++);b=S.substr(0,P)+b.substr(P)}return M.posix.relative(b,S)}resolvePath(t,w){if(t.scheme===R.Schemas.file){const b=I.URI.file(M.resolve(h(t),w));return t.with({authority:b.authority,path:b.path})}return w=v.toPosixPath(w),t.with({path:M.posix.resolve(t.path,w)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,w){return t===w||t!==void 0&&w!==void 0&&(0,n.equalsIgnoreCase)(t,w)}hasTrailingPathSeparator(t,w=M.sep){if(t.scheme===R.Schemas.file){const b=h(t);return b.length>v.getRoot(b).length&&b[b.length-1]===w}else{const b=t.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,w=M.sep){return(0,e.hasTrailingPathSeparator)(t,w)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,w=M.sep){let b=!1;if(t.scheme===R.Schemas.file){const S=h(t);b=S!==void 0&&S.length===v.getRoot(S).length&&S[S.length-1]===w}else{w="/";const S=t.path;b=S.length===1&&S.charCodeAt(S.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(t,w)?t.with({path:t.path+"/"}):t}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(p=>p.scheme===R.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new f(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(p,t){const w=[];for(let b=0;b<p.length;b++){const S=t(p[b]);p.some((P,l)=>l===b?!1:(0,e.isEqualOrParent)(S,t(P)))||w.push(p[b])}return w}e.distinctParents=y;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function t(w){const b=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(l=>{const[a,u]=l.split(":");a&&u&&b.set(a,u)});const P=w.path.substring(0,w.path.indexOf(";"));return P&&b.set(p.META_DATA_MIME,P),b}p.parseMetaData=t})(E=e.DataUri||(e.DataUri={}));function m(p,t,w){if(t){let b=p.path;return b&&b[0]!==M.posix.sep&&(b=M.posix.sep+b),p.with({scheme:w,authority:t,path:b})}return p.with({scheme:w})}e.toLocalResource=m}),define(Q[9],Z([0,1,23,16,4,2,15,3]),function($,e,v,R,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(O){return!!O&&typeof O.then=="function"}e.isThenable=h;function f(O){const D=new v.CancellationTokenSource,T=O(D.token),_=new Promise((B,X)=>{const N=D.token.onCancellationRequested(()=>{N.dispose(),D.dispose(),X((0,R.canceled)())});Promise.resolve(T).then(H=>{N.dispose(),D.dispose(),B(H)},H=>{N.dispose(),D.dispose(),X(H)})});return new class{cancel(){D.cancel()}then(B,X){return _.then(B,X)}catch(B){return this.then(void 0,B)}finally(B){return _.finally(B)}}}e.createCancelablePromise=f;function y(O,D,T){return Promise.race([O,new Promise(_=>D.onCancellationRequested(()=>_(T)))])}e.raceCancellation=y;async function E(O){let D=-1;const T=O.map((B,X)=>B.then(N=>(D=X,N))),_=await Promise.race(T);return O.forEach((B,X)=>{X!==D&&B.cancel()}),_}e.raceCancellablePromises=E;function m(O,D,T){let _;const B=setTimeout(()=>{_?.(void 0),T?.()},D);return Promise.race([O.finally(()=>clearTimeout(B)),new Promise(X=>_=X)])}e.raceTimeout=m;function p(O){return new Promise((D,T)=>{const _=O();h(_)?_.then(D,T):D(_)})}e.asPromise=p;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(T,T).then(_)})}return new Promise((T,_)=>{this.queuedPromise.then(T,_)})}return this.activePromise=D(),new Promise((T,_)=>{this.activePromise.then(B=>{this.activePromise=null,T(B)},B=>{this.activePromise=null,_(B)})})}}e.Throttler=t;class w{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=w;class b{constructor(){this.promiseMap=new Map}queue(D,T){const B=(this.promiseMap.get(D)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(D)===B&&this.promiseMap.delete(D)});return this.promiseMap.set(D,B),B}}e.SequencerByKey=b;class S{constructor(D){this.defaultDelay=D,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,T=this.defaultDelay){return this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,B)=>{this.doResolve=_,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class P{constructor(D){this.delayer=new S(D),this.throttler=new t}trigger(D,T){return this.delayer.trigger(()=>this.throttler.queue(D),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class l{constructor(){this._isOpen=!1,this._promise=new Promise((D,T)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class a extends l{constructor(D){super();this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function u(O,D){return D?new Promise((T,_)=>{const B=setTimeout(()=>{X.dispose(),T()},O),X=D.onCancellationRequested(()=>{clearTimeout(B),X.dispose(),_((0,R.canceled)())})}):f(T=>u(O,T))}e.timeout=u;function s(O,D=0){const T=setTimeout(O,D);return(0,C.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=s;function c(O){const D=[];let T=0;const _=O.length;function B(){return T<_?O[T++]():null}function X(N){N!=null&&D.push(N);const H=B();return H?H.then(X):Promise.resolve(D)}return Promise.resolve(null).then(X)}e.sequence=c;function i(O,D=_=>!!_,T=null){let _=0;const B=O.length,X=()=>{if(_>=B)return Promise.resolve(T);const N=O[_++];return Promise.resolve(N()).then(ie=>D(ie)?Promise.resolve(ie):X())};return X()}e.first=i;function r(O,D=_=>!!_,T=null){if(O.length===0)return Promise.resolve(T);let _=O.length;const B=()=>{_=-1;for(const X of O)X.cancel?.()};return new Promise((X,N)=>{for(const H of O)H.then(ie=>{--_>=0&&D(ie)?(B(),X(ie)):_===0&&X(T)}).catch(ie=>{--_>=0&&(B(),N(ie))})})}e.firstParallel=r;class o{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new M.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(D){return this._size++,new Promise((T,_)=>{this.outstandingPromises.push({factory:D,c:T,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const T=D.factory();T.then(D.c,D.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class d extends o{constructor(){super(1)}}e.Queue=d;class g{constructor(){this.queues=new Map}queueFor(D,T=n.extUri){const _=T.getComparisonKey(D);let B=this.queues.get(_);return B||(B=new d,M.Event.once(B.onFinished)(()=>{B?.dispose(),this.queues.delete(_)}),this.queues.set(_,B)),B}dispose(){this.queues.forEach(D=>D.dispose()),this.queues.clear()}}e.ResourceQueue=g;class k{constructor(D,T){this._token=-1,typeof D=="function"&&typeof T=="number"&&this.setIfNotSet(D,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},T)}setIfNotSet(D,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},T))}}e.TimeoutTimer=k;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,T){this.cancel(),this._token=setInterval(()=>{D()},T)}}e.IntervalTimer=L;class A{constructor(D,T){this.timeoutToken=-1,this.runner=D,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class W{constructor(D,T){T%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=D,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(D=this.timeout){D%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${D}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(D/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=W;class V extends A{constructor(D,T){super(D,T);this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner&&this.runner(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=V;class ee extends C.Disposable{constructor(D,T,_,B){super();this.maxWorkChunkSize=D,this.maxPendingWork=T,this.throttleDelay=_,this.handler=B,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(D){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+D.length>this.maxPendingWork)return!1}else if(this.pending+D.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...D),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ee,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=O=>{(0,I.setTimeout0)(()=>{if(D)return;const T=Date.now()+3;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let D=!1;return{dispose(){D||(D=!0)}}}:e.runWhenIdle=(O,D)=>{const T=requestIdleCallback(O,typeof D=="number"?{timeout:D}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(T))}}}}();class oe{constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=oe;async function ae(O,D,T){let _;for(let B=0;B<T;B++)try{return await O()}catch(X){_=X,await u(D)}throw _}e.retry=ae;class K{hasPending(D){return this._pending?typeof D=="number"?this._pending.taskId===D:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(D,T,_){return this._pending={taskId:D,cancel:()=>_?.(),promise:T},T.then(()=>this.donePending(D),()=>this.donePending(D)),T}donePending(D){this._pending&&D===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const D=this._next;this._next=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this._next)this._next.run=D;else{let T,_;const B=new Promise((X,N)=>{T=X,_=N});this._next={run:D,promise:B,promiseResolve:T,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=K;class F{constructor(D,T=()=>Date.now()){this.interval=D,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const D=this.nowFn();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((D,T)=>{this.completeCallback=D,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(D){return new Promise(T=>{this.completeCallback(D),this.resolved=!0,T()})}error(D){return new Promise(T=>{this.errorCallback(D),this.rejected=!0,T()})}cancel(){new Promise(D=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,D()})}}e.DeferredPromise=U;var G;(function(O){async function D(_){let B;const X=await Promise.all(_.map(N=>N.then(H=>H,H=>{B||(B=H)})));if(typeof B!="undefined")throw B;return X}O.settled=D;function T(_){return new Promise(async(B,X)=>{try{await _(B,X)}catch(N){X(N)}})}O.withAsyncBody=T})(G=e.Promises||(e.Promises={}));var Y;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(Y||(Y={}));class q{constructor(D){this._state=0,this._results=[],this._error=null,this._onStateChanged=new M.Emitter,queueMicrotask(async()=>{const T={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(D(T)),this.resolve()}catch(_){this.reject(_)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}static fromArray(D){return new q(T=>{T.emitMany(D)})}static fromPromise(D){return new q(async T=>{T.emitMany(await D)})}static fromPromises(D){return new q(async T=>{await Promise.all(D.map(async _=>T.emitOne(await _)))})}static merge(D){return new q(async T=>{await Promise.all(D.map(async _=>{for await(const B of _)T.emitOne(B)}))})}[Symbol.asyncIterator](){let D=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(D<this._results.length)return{done:!1,value:this._results[D++]};if(this._state===1)return{done:!0,value:void 0};await M.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(D,T){return new q(async _=>{for await(const B of D)_.emitOne(T(B))})}map(D){return q.map(this,D)}static filter(D,T){return new q(async _=>{for await(const B of D)T(B)&&_.emitOne(B)})}filter(D){return q.filter(this,D)}static coalesce(D){return q.filter(D,T=>!!T)}coalesce(){return q.coalesce(this)}static async toPromise(D){const T=[];for await(const _ of D)T.push(_);return T}toPromise(){return q.toPromise(this)}emitOne(D){this._state===0&&(this._results.push(D),this._onStateChanged.fire())}emitMany(D){this._state===0&&(this._results=this._results.concat(D),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(D){this._state===0&&(this._state=2,this._error=D,this._onStateChanged.fire())}}e.AsyncIterableObject=q,q.EMPTY=q.fromArray([]);class z extends q{constructor(D,T){super(T);this._source=D}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=z;function J(O){const D=new v.CancellationTokenSource,T=O(D.token);return new z(D,async _=>{const B=D.token.onCancellationRequested(()=>{B.dispose(),D.dispose(),_.reject((0,R.canceled)())});try{for await(const X of T){if(D.token.isCancellationRequested)return;_.emitOne(X)}B.dispose(),D.dispose()}catch(X){B.dispose(),D.dispose(),_.reject(X)}})}e.createCancelableAsyncIterable=J}),define(Q[33],Z([0,1,32,10,8,3,15,25,7]),function($,e,v,R,M,C,n,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function f(r,o,d){if(typeof r=="string"&&(r=h.URI.file(r)),d){const k=d.getWorkspaceFolder(r);if(k){const L=d.getWorkspace().folders.length>1;let A;if((0,n.isEqual)(k.uri,r)?A="":A=(0,n.relativePath)(k.uri,r),L){const W=k.name?k.name:(0,n.basename)(k.uri);A=A?W+" \u2022 "+A:W}return A}}if(r.scheme!==R.Schemas.file&&r.scheme!==R.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(r.fsPath))return(0,M.normalize)(E(r.fsPath));let g=(0,M.normalize)(r.fsPath);return!C.isWindows&&o?.userHome&&(g=p(g,o.userHome.fsPath)),g}e.getPathLabel=f;function y(r){if(!r)return;typeof r=="string"&&(r=h.URI.file(r));const o=(0,n.basename)(r)||(r.scheme===R.Schemas.file?r.fsPath:r.path);return C.isWindows&&(0,v.isRootOrDriveLetter)(o)?E(o):o}e.getBaseLabel=y;function E(r,o){return(0,v.hasDriveLetter)(r,o)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=E;let m=Object.create(null);function p(r,o){if(C.isWindows||!r||!o)return r;let d=m.original===o?m.normalized:void 0;return d||(d=`${(0,I.rtrim)(o,M.posix.sep)}${M.posix.sep}`,m={original:o,normalized:d}),(C.isLinux?r.startsWith(d):(0,I.startsWithIgnoreCase)(r,d))&&(r=`~/${r.substr(d.length)}`),r}e.tildify=p;function t(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=t;const w="\u2026",b="\\\\",S="~";function P(r,o=M.sep){const d=new Array(r.length);let g=!1;for(let k=0;k<r.length;k++){let L=r[k];if(L===""){d[k]=`.${o}`;continue}if(!L){d[k]=L;continue}g=!0;let A="";L.indexOf(b)===0?(A=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length)):L.indexOf(o)===0?(A=L.substr(0,L.indexOf(o)+o.length),L=L.substr(L.indexOf(o)+o.length)):L.indexOf(S)===0&&(A=L.substr(0,L.indexOf(S)+S.length),L=L.substr(L.indexOf(S)+S.length));const W=L.split(o);for(let V=1;g&&V<=W.length;V++)for(let ee=W.length-V;g&&ee>=0;ee--){g=!1;let oe=W.slice(ee,ee+V).join(o);for(let ae=0;!g&&ae<r.length;ae++)if(ae!==k&&r[ae]&&r[ae].indexOf(oe)>-1){const K=ee+V===W.length,F=ee>0&&r[ae].indexOf(o)>-1?o+oe:oe,U=r[ae].endsWith(F);g=!K||U}if(!g){let ae="";(W[0].endsWith(":")||A!=="")&&(ee===1&&(ee=0,V++,oe=W[0]+o+oe),ee>0&&(ae=W[0]+o),ae=A+ae),ee>0&&(ae=ae+w+o),ae=ae+oe,ee+V<W.length&&(ae=ae+o+w),d[k]=ae}}g&&(d[k]=L)}return d}e.shorten=P;var l;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function a(r,o=Object.create(null)){const d=[];let g=!1,k="";for(const L of r)if(L==="$"||g&&L==="{")k&&d.push({value:k,type:l.TEXT}),k="",g=!0;else if(L==="}"&&g){const A=o[k];if(typeof A=="string")A.length&&d.push({value:A,type:l.VARIABLE});else if(A){const W=d[d.length-1];(!W||W.type!==l.SEPARATOR)&&d.push({value:A.label,type:l.SEPARATOR})}k="",g=!1}else k+=L;return k&&!g&&d.push({value:k,type:l.TEXT}),d.filter((L,A)=>{if(L.type===l.SEPARATOR){const W=d[A-1],V=d[A+1];return[W,V].every(ee=>ee&&(ee.type===l.VARIABLE||ee.type===l.TEXT)&&ee.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=a;function u(r,o){return C.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):r.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function s(r,o){return C.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):C.isWindows?r.replace(/&&|&/g,d=>d==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function c(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=c;function i(r){const o=r.indexOf("/")!==-1?M.posix:M.win32,d=o.basename(r),g=o.dirname(r);return d.length?{name:d,parentPath:g}:{name:g,parentPath:""}}e.splitName=i}),define(Q[112],Z([0,1,7]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(y){return y.toJSON()}class M{constructor(E){this._uriTransformer=E}transformIncoming(E){const m=this._uriTransformer.transformIncoming(E);return m===E?E:R(v.URI.from(m))}transformOutgoing(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:R(v.URI.from(m))}transformOutgoingURI(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:v.URI.from(m)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function C(y,E,m){if(!y||m>200)return null;if(typeof y=="object"){if(y instanceof v.URI)return E.transformOutgoing(y);for(let p in y)if(Object.hasOwnProperty.call(y,p)){const t=C(y[p],E,m+1);t!==null&&(y[p]=t)}}return null}function n(y,E){const m=C(y,E,0);return m===null?y:m}e.transformOutgoingURIs=n;function I(y,E,m,p){if(!y||p>200)return null;if(typeof y=="object"){if(y.$mid===1)return m?v.URI.revive(E.transformIncoming(y)):E.transformIncoming(y);for(let t in y)if(Object.hasOwnProperty.call(y,t)){const w=I(y[t],E,m,p+1);w!==null&&(y[t]=w)}}return null}function h(y,E){const m=I(y,E,!1,0);return m===null?y:m}e.transformIncomingURIs=h;function f(y,E){const m=I(y,E,!0,0);return m===null?y:m}e.transformAndReviveIncomingURIs=f}),define(Q[31],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(h){return v.test(h)}e.isUUID=R;const M=new Uint8Array(16),C=[];for(let h=0;h<256;h++)C.push(h.toString(16).padStart(2,"0"));let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(h){for(let f=0;f<h.length;f++)h[f]=Math.floor(Math.random()*256);return h};function I(){n(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let h=0,f="";return f+=C[M[h++]],f+=C[M[h++]],f+=C[M[h++]],f+=C[M[h++]],f+="-",f+=C[M[h++]],f+=C[M[h++]],f+="-",f+=C[M[h++]],f+=C[M[h++]],f+="-",f+=C[M[h++]],f+=C[M[h++]],f+="-",f+=C[M[h++]],f+=C[M[h++]],f+=C[M[h++]],f+=C[M[h++]],f+=C[M[h++]],f+=C[M[h++]],f}e.generateUuid=I}),define(Q[113],Z([0,1,16,4,2,3,13,25]),function($,e,v,R,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const h="$initialize";let f=!1;function y(i){!C.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(i.message))}e.logOnceWebWorkerWarning=y;var E;(function(i){i[i.Request=0]="Request",i[i.Reply=1]="Reply",i[i.SubscribeEvent=2]="SubscribeEvent",i[i.Event=3]="Event",i[i.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class m{constructor(r,o,d,g){this.vsWorker=r,this.req=o,this.method=d,this.args=g,this.type=0}}class p{constructor(r,o,d,g){this.vsWorker=r,this.seq=o,this.res=d,this.err=g,this.type=1}}class t{constructor(r,o,d,g){this.vsWorker=r,this.req=o,this.eventName=d,this.arg=g,this.type=2}}class w{constructor(r,o,d){this.vsWorker=r,this.req=o,this.event=d,this.type=3}}class b{constructor(r,o){this.vsWorker=r,this.req=o,this.type=4}}class S{constructor(r){this._workerId=-1,this._handler=r,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(r){this._workerId=r}sendMessage(r,o){const d=String(++this._lastSentReq);return new Promise((g,k)=>{this._pendingReplies[d]={resolve:g,reject:k},this._send(new m(this._workerId,d,r,o))})}listen(r,o){let d=null;const g=new R.Emitter({onFirstListenerAdd:()=>{d=String(++this._lastSentReq),this._pendingEmitters.set(d,g),this._send(new t(this._workerId,d,r,o))},onLastListenerRemove:()=>{this._pendingEmitters.delete(d),this._send(new b(this._workerId,d)),d=null}});return g.event}handleMessage(r){!r||!r.vsWorker||this._workerId!==-1&&r.vsWorker!==this._workerId||this._handleMessage(r)}_handleMessage(r){switch(r.type){case 1:return this._handleReplyMessage(r);case 0:return this._handleRequestMessage(r);case 2:return this._handleSubscribeEventMessage(r);case 3:return this._handleEventMessage(r);case 4:return this._handleUnsubscribeEventMessage(r)}}_handleReplyMessage(r){if(!this._pendingReplies[r.seq]){console.warn("Got reply to unknown seq");return}let o=this._pendingReplies[r.seq];if(delete this._pendingReplies[r.seq],r.err){let d=r.err;r.err.$isError&&(d=new Error,d.name=r.err.name,d.message=r.err.message,d.stack=r.err.stack),o.reject(d);return}o.resolve(r.res)}_handleRequestMessage(r){let o=r.req;this._handler.handleMessage(r.method,r.args).then(g=>{this._send(new p(this._workerId,o,g,void 0))},g=>{g.detail instanceof Error&&(g.detail=(0,v.transformErrorForSerialization)(g.detail)),this._send(new p(this._workerId,o,void 0,(0,v.transformErrorForSerialization)(g)))})}_handleSubscribeEventMessage(r){const o=r.req,d=this._handler.handleEvent(r.eventName,r.arg)(g=>{this._send(new w(this._workerId,o,g))});this._pendingEvents.set(o,d)}_handleEventMessage(r){if(!this._pendingEmitters.has(r.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(r.req).fire(r.event)}_handleUnsubscribeEventMessage(r){if(!this._pendingEvents.has(r.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(r.req).dispose(),this._pendingEvents.delete(r.req)}_send(r){let o=[];if(r.type===0)for(let d=0;d<r.args.length;d++)r.args[d]instanceof ArrayBuffer&&o.push(r.args[d]);else r.type===1&&r.res instanceof ArrayBuffer&&o.push(r.res);this._handler.sendMessage(r,o)}}class P extends M.Disposable{constructor(r,o,d){super();let g=null;this._worker=this._register(r.create("vs/base/common/worker/simpleWorker",V=>{this._protocol.handleMessage(V)},V=>{g&&g(V)})),this._protocol=new S({sendMessage:(V,ee)=>{this._worker.postMessage(V,ee)},handleMessage:(V,ee)=>{if(typeof d[V]!="function")return Promise.reject(new Error("Missing method "+V+" on main thread host."));try{return Promise.resolve(d[V].apply(d,ee))}catch(oe){return Promise.reject(oe)}},handleEvent:(V,ee)=>{if(a(V)){const oe=d[V].call(d,ee);if(typeof oe!="function")throw new Error(`Missing dynamic event ${V} on main thread host.`);return oe}if(l(V)){const oe=d[V];if(typeof oe!="function")throw new Error(`Missing event ${V} on main thread host.`);return oe}throw new Error(`Malformed event name ${V}`)}}),this._protocol.setWorkerId(this._worker.getId());let k=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?k=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(k=C.globals.requirejs.s.contexts._.config);const L=n.getAllMethodNames(d);this._onModuleLoaded=this._protocol.sendMessage(h,[this._worker.getId(),JSON.parse(JSON.stringify(k)),o,L]);const A=(V,ee)=>this._request(V,ee),W=(V,ee)=>this._protocol.listen(V,ee);this._lazyProxy=new Promise((V,ee)=>{g=ee,this._onModuleLoaded.then(oe=>{V(u(oe,A,W))},oe=>{ee(oe),this._onError("Worker failed to load "+o,oe)})})}getProxyObject(){return this._lazyProxy}_request(r,o){return new Promise((d,g)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(r,o).then(d,g)},g)})}_onError(r,o){console.error(r),console.info(o)}}e.SimpleWorkerClient=P;function l(i){return i[0]==="o"&&i[1]==="n"&&I.isUpperAsciiLetter(i.charCodeAt(2))}function a(i){return/^onDynamic/.test(i)&&I.isUpperAsciiLetter(i.charCodeAt(9))}function u(i,r,o){const d=L=>function(){const A=Array.prototype.slice.call(arguments,0);return r(L,A)},g=L=>function(A){return o(L,A)};let k={};for(const L of i){if(a(L)){k[L]=g(L);continue}if(l(L)){k[L]=o(L,void 0);continue}k[L]=d(L)}return k}class s{constructor(r,o){this._requestHandlerFactory=o,this._requestHandler=null,this._protocol=new S({sendMessage:(d,g)=>{r(d,g)},handleMessage:(d,g)=>this._handleMessage(d,g),handleEvent:(d,g)=>this._handleEvent(d,g)})}onmessage(r){this._protocol.handleMessage(r)}_handleMessage(r,o){if(r===h)return this.initialize(o[0],o[1],o[2],o[3]);if(!this._requestHandler||typeof this._requestHandler[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this._requestHandler[r].apply(this._requestHandler,o))}catch(d){return Promise.reject(d)}}_handleEvent(r,o){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(r)){const d=this._requestHandler[r].call(this._requestHandler,o);if(typeof d!="function")throw new Error(`Missing dynamic event ${r} on request handler.`);return d}if(l(r)){const d=this._requestHandler[r];if(typeof d!="function")throw new Error(`Missing event ${r} on request handler.`);return d}throw new Error(`Malformed event name ${r}`)}initialize(r,o,d,g){this._protocol.setWorkerId(r);const A=u(g,(W,V)=>this._protocol.sendMessage(W,V),(W,V)=>this._protocol.listen(W,V));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(A),Promise.resolve(n.getAllMethodNames(this._requestHandler))):(o&&(typeof o.baseUrl!="undefined"&&delete o.baseUrl,typeof o.paths!="undefined"&&typeof o.paths.vs!="undefined"&&delete o.paths.vs,typeof o.trustedTypesPolicy!==void 0&&delete o.trustedTypesPolicy,o.catchError=!0,C.globals.require.config(o)),new Promise((W,V)=>{(C.globals.require||$)([d],oe=>{if(this._requestHandler=oe.create(A),!this._requestHandler){V(new Error("No RequestHandler!"));return}W(n.getAllMethodNames(this._requestHandler))},V)}))}}e.SimpleWorkerServer=s;function c(i){return new s(i,null)}e.create=c}),define(Q[114],Z([0,1,61,28,42]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(n,I){if(await new Promise((y,E)=>{const m=R.createReadStream(n),p=v.createHash("sha1");m.pipe(p);const t=(0,M.once)((w,b)=>{m.removeAllListeners(),p.removeAllListeners(),w?E(w):y(b)});m.once("error",t),m.once("end",t),p.once("error",t),p.once("data",w=>t(void 0,w.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=C}),define(Q[115],Z([0,1,245]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(C="utf8"){this.stringDecoder=new v.StringDecoder(C),this.remaining=null}write(C){const n=[],I=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(I.length<1)return n;let h=0,f,y=h;for(;y<I.length;)if(f=I.charCodeAt(y),f===13||f===10){if(n.push(I.substring(h,y)),y++,y<I.length){const E=f;f=I.charCodeAt(y),(E===13&&f===10||E===10&&f===13)&&y++}h=y}else y++;return this.remaining=h<I.length?I.substr(h):null,n}end(){return this.remaining}}e.LineDecoder=R}),define(Q[116],Z([0,1,26]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function M(n){const I=n.replace(/\-/g,":").toLowerCase();return!R.has(I)}function C(){const n=(0,v.networkInterfaces)();for(let I in n){const h=n[I];if(h){for(const{mac:f}of h)if(M(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(Q[71],Z([0,1,26,16,40,31,116]),function($,e,v,R,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=M.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,E=0;const m=(0,v.networkInterfaces)();for(let p in m){const t=m[p];if(t)for(const{mac:w,internal:b}of t)b||(E+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(y+=1))}this._value=E>0?y/E:0}return this._value}};let I;async function h(){return I||(I=(async()=>await f()||C.generateUuid())()),I}e.getMachineId=h;async function f(){try{const y=await new Promise((m,p)=>{$(["crypto"],m,p)}),E=(0,n.getMac)();return y.createHash("sha256").update(E,"utf8").digest("hex")}catch(y){R.onUnexpectedError(y);return}}}),define(Q[21],Z([0,1,28,26,117,9,32,70,8,3,15,7,31]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function t(F,U=p.UNLINK){if((0,n.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return U===p.UNLINK?b(F):w(F)}async function w(F){try{const U=(0,h.join)((0,R.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(F,U)}catch(G){return b(F)}b(U).catch(G=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function b(F){return e.Promises.rmdir(F,{recursive:!0,maxRetries:3})}function S(F){if((0,n.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(F,{recursive:!0})}e.rimrafSync=S;async function P(F,U){return u(await(U?l(F):(0,M.promisify)(v.readdir)(F)))}async function l(F){try{return await(0,M.promisify)(v.readdir)(F,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const U=[],G=await P(F);for(const Y of G){let q=!1,z=!1,J=!1;try{const O=await e.Promises.lstat((0,h.join)(F,Y));q=O.isFile(),z=O.isDirectory(),J=O.isSymbolicLink()}catch(O){console.warn("[node.js fs] unexpected error from lstat after readdir: ",O)}U.push({name:Y,isFile:()=>q,isDirectory:()=>z,isSymbolicLink:()=>J})}return U}function a(F){return u(v.readdirSync(F))}e.readdirSync=a;function u(F){return F.map(U=>typeof U=="string"?f.isMacintosh?(0,I.normalizeNFC)(U):U:(U.name=f.isMacintosh?(0,I.normalizeNFC)(U.name):U.name,U))}async function s(F){const U=await P(F),G=[];for(const Y of U)await i.existsDirectory((0,h.join)(F,Y))&&G.push(Y);return G}function c(F,U=1e3){return new Promise(G=>{let Y=!1;const q=setInterval(()=>{Y||(Y=!0,v.access(F,z=>{Y=!1,z&&(clearInterval(q),G(void 0))}))},U)})}e.whenDeleted=c;var i;(function(F){async function U(q){let z;try{if(z=await e.Promises.lstat(q),!z.isSymbolicLink())return{stat:z}}catch(J){}try{return{stat:await e.Promises.stat(q),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(f.isWindows&&J.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(O){if(O.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw O}throw J}}F.stat=U;async function G(q){try{const{stat:z,symbolicLink:J}=await F.stat(q);return z.isFile()&&J?.dangling!==!0}catch(z){}return!1}F.existsFile=G;async function Y(q){try{const{stat:z,symbolicLink:J}=await F.stat(q);return z.isDirectory()&&J?.dangling!==!0}catch(z){}return!1}F.existsDirectory=Y})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new C.ResourceQueue;function o(F,U,G){return r.queueFor(E.URI.file(F),y.extUriBiasedIgnorePathCase).queue(()=>{const Y=L(G);return new Promise((q,z)=>g(F,U,Y,J=>J?z(J):q()))})}let d=!0;function g(F,U,G,Y){if(!d)return v.writeFile(F,U,{mode:G.mode,flag:G.flag},Y);v.open(F,G.flag,G.mode,(q,z)=>{if(q)return Y(q);v.writeFile(z,U,J=>{if(J)return v.close(z,()=>Y(J));v.fdatasync(z,O=>(O&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",O),d=!1),v.close(z,D=>Y(D))))})})}function k(F,U,G){const Y=L(G);if(!d)return v.writeFileSync(F,U,{mode:Y.mode,flag:Y.flag});const q=v.openSync(F,Y.flag,Y.mode);try{v.writeFileSync(q,U);try{v.fdatasyncSync(q)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),d=!1}}finally{v.closeSync(q)}}e.writeFileSync=k;function L(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function A(F,U){if(F===U)return;async function G(Y){try{const q=await e.Promises.lstat(Y);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(Y,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(F,U),await G(U)}catch(Y){if(F.toLowerCase()!==U.toLowerCase()&&Y.code==="EXDEV"||F.endsWith("."))await W(F,U,{preserveSymlinks:!1}),await t(F,p.MOVE),await G(U);else throw Y}}async function W(F,U,G){return ee(F,U,{root:{source:F,target:U},options:G,handledSourcePaths:new Set})}const V=511;async function ee(F,U,G){if(G.handledSourcePaths.has(F))return;G.handledSourcePaths.add(F);const{stat:Y,symbolicLink:q}=await i.stat(F);if(q){if(G.options.preserveSymlinks)try{return await K(F,U,G)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(q.dangling)return}return Y.isDirectory()?oe(F,U,Y.mode&V,G):ae(F,U,Y.mode&V)}async function oe(F,U,G,Y){await e.Promises.mkdir(U,{recursive:!0,mode:G});const q=await P(F);for(const z of q)await ee((0,h.join)(F,z),(0,h.join)(U,z),Y)}async function ae(F,U,G){await e.Promises.copyFile(F,U),await e.Promises.chmod(U,G)}async function K(F,U,G){let Y=await e.Promises.readlink(F);(0,n.isEqualOrParent)(Y,G.root.source,!f.isLinux)&&(Y=(0,h.join)(G.root.target,Y.substr(G.root.source.length+1))),await e.Promises.symlink(Y,U)}e.Promises=new class{get access(){return(0,M.promisify)(v.access)}get stat(){return(0,M.promisify)(v.stat)}get lstat(){return(0,M.promisify)(v.lstat)}get utimes(){return(0,M.promisify)(v.utimes)}get read(){return(0,M.promisify)(v.read)}get readFile(){return(0,M.promisify)(v.readFile)}get write(){return(0,M.promisify)(v.write)}get appendFile(){return(0,M.promisify)(v.appendFile)}get fdatasync(){return(0,M.promisify)(v.fdatasync)}get truncate(){return(0,M.promisify)(v.truncate)}get rename(){return(0,M.promisify)(v.rename)}get copyFile(){return(0,M.promisify)(v.copyFile)}get open(){return(0,M.promisify)(v.open)}get close(){return(0,M.promisify)(v.close)}get symlink(){return(0,M.promisify)(v.symlink)}get readlink(){return(0,M.promisify)(v.readlink)}get chmod(){return(0,M.promisify)(v.chmod)}get mkdir(){return(0,M.promisify)(v.mkdir)}get unlink(){return(0,M.promisify)(v.unlink)}get rmdir(){return(0,M.promisify)(v.rmdir)}get realpath(){return(0,M.promisify)(v.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return s}get writeFile(){return o}get rm(){return t}get move(){return A}get copy(){return W}}}),define(Q[82],Z([0,1,28,8,25,21]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(y){const E=(0,R.dirname)(y);if(y===E)return y;const m=((0,R.basename)(y)||y).toLowerCase();try{const t=(0,C.readdirSync)(E).filter(w=>w.toLowerCase()===m);if(t.length===1){const w=n(E);if(w)return(0,R.join)(w,t[0])}else if(t.length>1){const w=t.indexOf(m);if(w>=0){const b=n(E);if(b)return(0,R.join)(b,t[w])}}}catch(p){}return null}e.realcaseSync=n;async function I(y){try{return await C.Promises.realpath(y)}catch(E){const m=f(y);return await C.Promises.access(m,v.constants.R_OK),m}}e.realpath=I;function h(y){try{return v.realpathSync(y)}catch(E){const m=f(y);return v.accessSync(m,v.constants.R_OK),m}}e.realpathSync=h;function f(y){return(0,M.rtrim)((0,R.normalize)(y),R.sep)}}),define(Q[118],Z([0,1,62]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function R(I,h,f,y=1){let E=!1;return new Promise(m=>{const p=setTimeout(()=>{if(!E)return E=!0,m(0)},f);M(I,h,y,t=>{if(!E)return E=!0,clearTimeout(p),m(t)})})}e.findFreePort=R;function M(I,h,f,y){if(h===0)return y(0);const E=new v.Socket;E.once("connect",()=>(n(E),M(I+f,h-1,f,y))),E.once("data",()=>{}),E.once("error",m=>(n(E),m.code!=="ECONNREFUSED"?M(I+f,h-1,f,y):y(I))),E.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(I,h,f){let y=!1,E,m=1;const p=v.createServer({pauseOnConnect:!0});function t(w,b){y||(y=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),b(w))}return new Promise(w=>{E=setTimeout(()=>{t(0,w)},f),p.on("listening",()=>{t(I,w)}),p.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&m<h?(I++,m++,p.listen(I,"127.0.0.1")):t(0,w)}),p.on("close",()=>{t(0,w)}),p.listen(I,"127.0.0.1")})}e.findFreePortFaster=C;function n(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(h){console.error(h)}}}),define(Q[119],Z([0,1,26,8,21]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,n=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var h;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(h||(h={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class E{constructor(u,s,c){this.exePath=u,this.displayName=s,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await M.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?f===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:a=!1,findPreview:u=!1}={}){const s=m({useAlternateBitness:a});if(!s)return null;const c=R.join(s,"PowerShell");if(!await M.SymlinkSupport.existsDirectory(c))return null;let i=-1,r=null;for(const g of await M.Promises.readdir(c)){let k=-1;if(u){const A=g.indexOf("-");if(A<0)continue;const W=g.substring(0,A);if(!C.test(W)||g.substring(A+1)!=="preview")continue;k=parseInt(W,10)}else{if(!C.test(g))continue;k=parseInt(g,10)}if(k<=i)continue;const L=R.join(c,g,"pwsh.exe");!await M.SymlinkSupport.existsFile(L)||(r=L,i=k)}if(!r)return null;const o=s.includes("x86")?" (x86)":"",d=u?" Preview":"";return new E(r,`PowerShell${d}${o}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const u=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await M.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:s,pwshMsixName:c}=a?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:n,pwshMsixName:"PowerShell (Store)"};for(const i of await M.Promises.readdir(u))if(s.test(i)){const r=R.join(u,i,"pwsh.exe");return new E(r,c)}return null}function w(){const a=R.join(v.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function b(){const a=R.join(process.env.windir,f===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}async function*S(){let a=await p();a&&(yield a),a=await p({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=w(),a&&(yield a),a=await p({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await p({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=b(),a&&(yield a)}async function*P(){for await(const a of S())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=P;async function l(){for await(const a of P())return a;return null}e.getFirstAvailablePowerShellInstallation=l}),define(Q[83],Z([0,1,43,10]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function M(n){return new Promise((I,h)=>{let f;const y=new Map;function E(p,t,w,b,S){const P=y.get(t);if(p===n||P){const l={name:m(w),cmd:w,pid:p,ppid:t,load:b,mem:S};y.set(p,l),p===n&&(f=l),P&&(P.children||(P.children=[]),P.children.push(l),P.children.length>1&&(P.children=P.children.sort((a,u)=>a.pid-u.pid)))}}function m(p){const t=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,S=/--utility-sub-type=network/,P=/--crashes-directory/,l=/\\pipe\\winpty-control/,a=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(P.exec(p))return"electron-crash-reporter";if(l.exec(p))return"winpty-process";if(a.exec(p))return"console-window-host (Windows internal process)";let s=u.exec(p);if(s&&s.length===2)return s[1]==="renderer"?t.exec(p)?"shared-process":w.exec(p)?"issue-reporter":b.exec(p)?"process-explorer":"window":s[1]==="utility"&&S.exec(p)?"utility-network-service":s[1];const c=/[a-zA-Z-]+\.js/g;let i="";do s=c.exec(p),s&&(i+=s+" ");while(s);return i&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${i}`:p}if(process.platform==="win32"){const p=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,w)=>{$(["windows-process-tree"],t,w)}).then(t=>{t.getProcessList(n,w=>{t.getProcessCpuUsage(w,b=>{const S=new Map;b.forEach(P=>{const l=p(P.commandLine||"");S.set(P.pid,{name:m(l),cmd:l,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),f=S.get(n),f?(S.forEach(P=>{const l=S.get(P.ppid);l&&(l.children||(l.children=[]),l.children.push(P))}),S.forEach(P=>{P.children&&(P.children=P.children.sort((l,a)=>l.pid-a.pid))}),I(f)):h(new Error(`Root process ${n} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let p=function(){let t=[f];const w=[];for(;t.length;){const S=t.shift();S&&(w.push(S.pid),S.children&&(t=t.concat(S.children)))}let b=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",$).fsPath);b+=" "+w.join(" "),(0,v.exec)(b,{},(S,P,l)=>{if(S||l)h(S||new Error(l.toString()));else{const a=P.toString().split(`
`);for(let u=0;u<w.length;u++){const s=y.get(w[u]);s.load=parseFloat(a[u])}if(!f){h(new Error(`Root process ${n} not found`));return}I(f)}})};(0,v.exec)("which ps",{},(t,w,b)=>{if(t||b)if(process.platform!=="linux")h(t||new Error(b.toString()));else{const S=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",$).fsPath);(0,v.exec)(S,{},(P,l,a)=>{P||a?h(P||new Error(a.toString())):(C(l,E),p())})}else{const S=w.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${S} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,a,u)=>{l||u&&!u.includes("screen size is bogus")?h(l||new Error(u.toString())):(C(a,E),process.platform==="linux"?p():f?I(f):h(new Error(`Root process ${n} not found`)))})}})}})}e.listProcesses=M;function C(n,I){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=n.toString().split(`
`);for(const y of f){const E=h.exec(y.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(Q[120],Z([0,1,28,23,32,2,70,8,3,21]),function($,e,v,R,M,C,n,I,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(t,w,b){return m({path:t,isDirectory:!1},w,b)}e.watchFile=y;function E(t,w,b){return m({path:t,isDirectory:!0},w,b)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function m(t,w,b){if(h.isMacintosh&&(0,M.isEqualOrParent)(t.path,"/Volumes/"))return b(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const S=(0,I.basename)(t.path),P=new Map;let l=!1,a=[(0,C.toDisposable)(()=>{P.forEach(u=>(0,C.dispose)(u)),P.clear()})];try{const u=(0,v.watch)(t.path);a.push((0,C.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const s=new Set;t.isDirectory&&f.Promises.readdir(t.path).then(c=>c.forEach(i=>s.add(i))),u.on("error",(c,i)=>{l||b(`Failed to watch ${t.path} for changes using fs.watch() (${c}, ${i})`)}),u.on("change",(c,i)=>{if(l)return;let r="";if(i&&(r=i.toString(),h.isMacintosh&&(r=(0,n.normalizeNFC)(r))),!r||c!=="change"&&c!=="rename")return;const o=t.isDirectory?(0,I.join)(t.path,r):t.path;if(t.isDirectory)if(c==="rename"){const d=P.get(o);d&&(0,C.dispose)(d);const g=setTimeout(async()=>{P.delete(o);const k=await f.Promises.exists(o);if(l)return;let L;k?s.has(r)?L="changed":(L="added",s.add(r)):(s.delete(r),L="deleted"),w(L,o)},e.CHANGE_BUFFER_DELAY);P.set(o,(0,C.toDisposable)(()=>clearTimeout(g)))}else{let d;s.has(r)?d="changed":(d="added",s.add(r)),w(d,o)}else if(c==="rename"||r!==S){const d=setTimeout(async()=>{const g=await f.Promises.exists(o);l||(g?(w("changed",o),a=[m(t,w,b)]):w("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,C.dispose)(a),a=[(0,C.toDisposable)(()=>clearTimeout(d))]}else w("changed",o)})}catch(u){f.Promises.exists(t.path).then(s=>{s&&!l&&b(`Failed to watch ${t.path} for changes using fs.watch() (${u.toString()})`)})}return(0,C.toDisposable)(()=>{l=!0,a=(0,C.dispose)(a)})}async function p(t,w,b,S=512){const P=await f.Promises.open(t,"r"),l=Buffer.allocUnsafe(S),a=new R.CancellationTokenSource(b);let u,s=!1;const c=y(t,async i=>{if(i==="changed"){if(s)return;s=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:r}=await f.Promises.read(P,l,0,S,null);if(!r||a.token.isCancellationRequested)break;w(l.slice(0,r))}}catch(r){u=new Error(r),a.dispose(!0)}finally{s=!1}}},i=>{u=new Error(i),a.dispose(!0)});return new Promise((i,r)=>{a.token.onCancellationRequested(async()=>{c.dispose(),await f.Promises.close(P),u?r(u):i()})})}e.watchFileContents=p}),define(Q[121],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[122],Z([0,1,14,13,121]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){v.ipcMain.on(M.CONTEXT_MENU_CHANNEL,(I,h,f,y,E)=>{const m=n(I,y,f);m.popup({window:(0,R.withNullAsUndefined)(v.BrowserWindow.fromWebContents(I.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{m&&I.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=C;function n(I,h,f){const y=new v.Menu;return f.forEach(E=>{let m;E.type==="separator"?m=new v.MenuItem({type:E.type}):Array.isArray(E.submenu)?m=new v.MenuItem({submenu:n(I,h,E.submenu),label:E.label}):m=new v.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(p,t,w)=>I.sender.send(h,E.id,w)}),y.append(m)}),y}});var ge=this&&this.__decorate||function($,e,v,R){var M=arguments.length,C=M<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,n;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate($,e,v,R);else for(var I=$.length-1;I>=0;I--)(n=$[I])&&(C=(M<3?n(C):M>3?n(e,v,C):n(e,v))||C);return M>3&&C&&Object.defineProperty(e,v,C),C};define(Q[35],Z([0,1,30,9,17,23,46,16,4,2,111,25,13]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function t(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function b(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(S||(S={}));class P{constructor(z){this.buffer=z,this.pos=0}read(z){const J=this.buffer.slice(this.pos,this.pos+z);return this.pos+=J.byteLength,J}}class l{constructor(){this.buffers=[]}get buffer(){return M.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var a;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(a||(a={}));function u(q){const z=M.VSBuffer.alloc(4);return z.writeUInt32BE(q,0),z}function s(q){return q.read(4).readUInt32BE(0)}function c(q){const z=M.VSBuffer.alloc(1);return z.writeUInt8(q,0),z}const i={Undefined:c(a.Undefined),String:c(a.String),Buffer:c(a.Buffer),VSBuffer:c(a.VSBuffer),Array:c(a.Array),Object:c(a.Object)},r=typeof Buffer!="undefined";function o(q,z){if(typeof z=="undefined")q.write(i.Undefined);else if(typeof z=="string"){const J=M.VSBuffer.fromString(z);q.write(i.String),q.write(u(J.byteLength)),q.write(J)}else if(r&&Buffer.isBuffer(z)){const J=M.VSBuffer.wrap(z);q.write(i.Buffer),q.write(u(J.byteLength)),q.write(J)}else if(z instanceof M.VSBuffer)q.write(i.VSBuffer),q.write(u(z.byteLength)),q.write(z);else if(Array.isArray(z)){q.write(i.Array),q.write(u(z.length));for(const J of z)o(q,J)}else{const J=M.VSBuffer.fromString(JSON.stringify(z));q.write(i.Object),q.write(u(J.byteLength)),q.write(J)}}function d(q){switch(q.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return q.read(s(q)).toString();case a.Buffer:return q.read(s(q)).buffer;case a.VSBuffer:return q.read(s(q));case a.Array:{const J=s(q),O=[];for(let D=0;D<J;D++)O.push(d(q));return O}case a.Object:return JSON.parse(q.read(s(q)).toString())}}class g{constructor(z,J,O=null,D=1e3){this.protocol=z,this.ctx=J,this.logger=O,this.timeoutDelay=D,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(T=>this.onRawMessage(T)),this.sendResponse({type:200})}registerChannel(z,J){this.channels.set(z,J),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const J=this.send([z.type]);this.logger&&this.logger.logOutgoing(J,0,1,b(z.type));return}case 201:case 202:case 204:case 203:{const J=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(J,z.id,1,b(z.type),z.data);return}}}send(z,J=void 0){const O=new l;return o(O,z),o(O,J),this.sendBuffer(O.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(J){return 0}}onRawMessage(z){const J=new P(z),O=d(J),D=d(J),T=O[0];switch(T){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,O[1],1,`${t(T)}: ${O[2]}.${O[3]}`,D),this.onPromise({type:T,id:O[1],channelName:O[2],name:O[3],arg:D});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,O[1],1,`${t(T)}: ${O[2]}.${O[3]}`,D),this.onEventListen({type:T,id:O[1],channelName:O[2],name:O[3],arg:D});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,O[1],1,`${t(T)}`),this.disposeActiveRequest({type:T,id:O[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,O[1],1,`${t(T)}`),this.disposeActiveRequest({type:T,id:O[1]})}}onPromise(z){const J=this.channels.get(z.channelName);if(!J){this.collectPendingRequest(z);return}const O=new C.CancellationTokenSource;let D;try{D=J.call(this.ctx,z.name,z.arg,O.token)}catch(B){D=Promise.reject(B)}const T=z.id;D.then(B=>{this.sendResponse({id:T,data:B,type:201}),this.activeRequests.delete(z.id)},B=>{B instanceof Error?this.sendResponse({id:T,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:T,data:B,type:203}),this.activeRequests.delete(z.id)});const _=(0,f.toDisposable)(()=>O.cancel());this.activeRequests.set(z.id,_)}onEventListen(z){const J=this.channels.get(z.channelName);if(!J){this.collectPendingRequest(z);return}const O=z.id,T=J.listen(this.ctx,z.name,z.arg)(_=>this.sendResponse({id:O,data:_,type:204}));this.activeRequests.set(z.id,T)}disposeActiveRequest(z){const J=this.activeRequests.get(z.id);J&&(J.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let J=this.pendingRequests.get(z.channelName);J||(J=[],this.pendingRequests.set(z.channelName,J));const O=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);J.push({request:z,timeoutTimer:O})}flushPendingRequests(z){const J=this.pendingRequests.get(z);if(J){for(const O of J)switch(clearTimeout(O.timeoutTimer),O.request.type){case 100:this.onPromise(O.request);break;case 102:this.onEventListen(O.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=g;var k;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(z,J=null){this.protocol=z,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(O=>this.onBuffer(O)),this.logger=J}getChannel(z){const J=this;return{call(O,D,T){return J.isDisposed?Promise.reject(I.canceled()):J.requestPromise(z,O,D,T)},listen(O,D){return J.isDisposed?Promise.reject(I.canceled()):J.requestEvent(z,O,D)}}}requestPromise(z,J,O,D=C.CancellationToken.None){const T=this.lastRequestId++,B={id:T,type:100,channelName:z,name:J,arg:O};if(D.isCancellationRequested)return Promise.reject(I.canceled());let X;return new Promise((H,ie)=>{if(D.isCancellationRequested)return ie(I.canceled());const re=()=>{const le=he=>{switch(he.type){case 201:this.handlers.delete(T),H(he.data);break;case 202:this.handlers.delete(T);const me=new Error(he.data.message);me.stack=he.data.stack,me.name=he.data.name,ie(me);break;case 203:this.handlers.delete(T),ie(he.data);break}};this.handlers.set(T,le),this.sendRequest(B)};let se=null;this.state===S.Idle?re():(se=(0,R.createCancelablePromise)(le=>this.whenInitialized()),se.then(()=>{se=null,re()}));const x=()=>{se?(se.cancel(),se=null):this.sendRequest({id:T,type:101}),ie(I.canceled())},ce=D.onCancellationRequested(x);X=(0,f.combinedDisposable)((0,f.toDisposable)(x),ce),this.activeRequests.add(X)}).finally(()=>{this.activeRequests.delete(X)})}requestEvent(z,J,O){const D=this.lastRequestId++,_={id:D,type:102,channelName:z,name:J,arg:O};let B=null;const X=new h.Emitter({onFirstListenerAdd:()=>{B=(0,R.createCancelablePromise)(H=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add(X),this.sendRequest(_)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete(X),this.sendRequest({id:D,type:103}))}}),N=H=>X.fire(H.data);return this.handlers.set(D,N),X.event}sendRequest(z){switch(z.type){case 100:case 102:{const J=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(J,z.id,0,`${t(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const J=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(J,z.id,0,t(z.type));return}}}send(z,J=void 0){const O=new l;return o(O,z),o(O,J),this.sendBuffer(O.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(J){return 0}}onBuffer(z){const J=new P(z),O=d(J),D=d(J),T=O[0];switch(T){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,b(T)),this.onResponse({type:O[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,O[1],0,b(T),D),this.onResponse({type:O[0],id:O[1],data:D})}}onResponse(z){if(z.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const J=this.handlers.get(z.id);J&&J(z)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}ge([n.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class A{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:J,onDidClientDisconnect:O})=>{h.Event.once(J.onMessage)(T=>{const _=new P(T),B=d(_),X=new g(J,B),N=new L(J);this.channels.forEach((ie,re)=>X.registerChannel(re,ie));const H={channelServer:X,channelClient:N,ctx:B};this._connections.add(H),this._onDidAddConnection.fire(H),O(()=>{X.dispose(),N.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}get connections(){const z=[];return this._connections.forEach(J=>z.push(J)),z}getChannel(z,J){const O=this;return{call(D,T,_){let B;if((0,m.isFunction)(J)){let N=(0,v.getRandomElement)(O.connections.filter(J));B=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(O.onDidAddConnection,J))}else B=J.routeCall(O,D,T);const X=B.then(N=>N.channelClient.getChannel(z));return V(X).call(D,T,_)},listen(D,T){if((0,m.isFunction)(J))return O.getMulticastEvent(z,J,D,T);const _=J.routeEvent(O,D,T).then(B=>B.channelClient.getChannel(z));return V(_).listen(D,T)}}}getMulticastEvent(z,J,O,D){const T=this;let _=new f.DisposableStore;const B=new h.Emitter({onFirstListenerAdd:()=>{_=new f.DisposableStore;const X=new h.EventMultiplexer,N=new Map,H=re=>{const x=re.channelClient.getChannel(z).listen(O,D),ce=X.add(x);N.set(re,ce)},ie=re=>{const se=N.get(re);!se||(se.dispose(),N.delete(re))};T.connections.filter(J).forEach(H),h.Event.filter(T.onDidAddConnection,J)(H,void 0,_),T.onDidRemoveConnection(ie,void 0,_),X.event(B.fire,B,_),_.add(X)},onLastListenerRemove:()=>{_.dispose()}});return B.event}registerChannel(z,J){this.channels.set(z,J),this._connections.forEach(O=>{O.channelServer.registerChannel(z,J)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class W{constructor(z,J,O=null){const D=new l;o(D,J),z.send(D.buffer),this.channelClient=new L(z,O),this.channelServer=new g(z,J,O)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,J){this.channelServer.registerChannel(z,J)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function V(q){return{call(z,J,O){return q.then(D=>D.call(z,J,O))},listen(z,J){const O=new h.Relay;return q.then(D=>O.input=D.listen(z,J)),O.event}}}e.getDelayedChannel=V;function ee(q){let z=!1;return{call(J,O,D){return z?q.call(J,O,D):(0,R.timeout)(0).then(()=>z=!0).then(()=>q.call(J,O,D))},listen(J,O){if(z)return q.listen(J,O);const D=new h.Relay;return(0,R.timeout)(0).then(()=>z=!0).then(()=>D.input=q.listen(J,O)),D.event}}}e.getNextTickChannel=ee;class oe{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const J of z.connections)if(await Promise.resolve(this.fn(J.ctx)))return Promise.resolve(J);return await h.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=oe;var ae;(function(q){function z(T,_){const B=T,X=_&&_.disableMarshalling,N=new Map;for(const H in B)O(H)&&N.set(H,h.Event.buffer(B[H],!0));return new class{listen(H,ie,re){const se=N.get(ie);if(se)return se;if(D(ie)){const x=B[ie];if(typeof x=="function")return x.call(B,re)}throw new Error(`Event not found: ${ie}`)}call(H,ie,re){const se=B[ie];if(typeof se=="function"){if(!X&&Array.isArray(re))for(let x=0;x<re.length;x++)re[x]=(0,y.revive)(re[x]);return se.apply(B,re)}throw new Error(`Method not found: ${ie}`)}}}q.fromService=z;function J(T,_){const B=_&&_.disableMarshalling;return new Proxy({},{get(X,N){if(typeof N=="string")return _?.properties?.has(N)?_.properties.get(N):D(N)?function(H){return T.listen(N,H)}:O(N)?T.listen(N):async function(...H){let ie;_&&!(0,m.isUndefinedOrNull)(_.context)?ie=[_.context,...H]:ie=H;const re=await T.call(N,ie);return B?re:(0,y.revive)(re)};throw new Error(`Property not found: ${String(N)}`)}})}q.toService=J;function O(T){return T[0]==="o"&&T[1]==="n"&&E.isUpperAsciiLetter(T.charCodeAt(2))}function D(T){return/^onDynamic/.test(T)&&E.isUpperAsciiLetter(T.charCodeAt(9))}})(ae=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let z=q.toString();if(z!=="[object Object]")return z}return q}function U(q){return Array.isArray(q)?q.map(F):F(q)}function G(q,z,J,O,D,T,_){_=U(_);const B=K[D],X=B[O%B.length];let N=[`%c[${q}]%c[${String(z).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(O).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${X}`];/\($/.test(T)?(N=N.concat(_),N.push(")")):N.push(_),console.log.apply(console,N)}e.logWithColors=G;class Y{constructor(z,J){this._outgoingPrefix=z,this._incomingPrefix=J,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,J,O,D,T){this._totalOutgoing+=z,G(this._outgoingPrefix,this._totalOutgoing,z,J,O,D,T)}logIncoming(z,J,O,D,T){this._totalIncoming+=z,G(this._incomingPrefix,this._totalIncoming,z,J,O,D,T)}}e.IPCLogger=Y}),define(Q[123],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(M,C){this.sender=M,this.onMessage=C}send(M){try{this.sender.send("vscode:message",M.buffer)}catch(C){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Q[124],Z([0,1,17,4,35]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(h){this.port=h,this.onMessage=R.Event.fromDOMEventEmitter(this.port,"message",f=>v.VSBuffer.wrap(f.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class n extends M.IPCClient{constructor(h,f){const y=new C(h);super(y,f);this.protocol=y}dispose(){this.protocol.disconnect()}}e.Client=n}),define(Q[84],Z([0,1,17,4,2,35]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var n;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(n=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function h(){return I||(I=v.VSBuffer.alloc(0)),I}class f{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(c){this._chunks.push(c),this._totalLength+=c.byteLength}read(c){return this._read(c,!0)}peek(c){return this._read(c,!1)}_read(c,i){if(c===0)return h();if(c>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===c){const g=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=c),g}if(this._chunks[0].byteLength>c){const g=this._chunks[0].slice(0,c);return i&&(this._chunks[0]=this._chunks[0].slice(c),this._totalLength-=c),g}let r=v.VSBuffer.alloc(c),o=0,d=0;for(;c>0;){const g=this._chunks[d];if(g.byteLength>c){const k=g.slice(0,c);r.set(k,o),o+=c,i&&(this._chunks[d]=g.slice(c),this._totalLength-=c),c-=c}else r.set(g,o),o+=g.byteLength,i?(this._chunks.shift(),this._totalLength-=g.byteLength):d++,c-=g.byteLength}return r}}e.ChunkStream=f;var y;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(y||(y={}));var E;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(c,i,r,o){this.type=c,this.id=i,this.ack=r,this.data=o,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends M.Disposable{constructor(c){super();this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=c,this._isDisposed=!1,this._incomingData=new f,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5);else{const r=this._state.messageType,o=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(r,o,d,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class t{constructor(c){this._isDisposed=!1,this._socket=c,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(c){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(c){if(this._isDisposed)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=v.VSBuffer.alloc(13);i.writeUInt8(c.type,0),i.writeUInt32BE(c.id,1),i.writeUInt32BE(c.ack,5),i.writeUInt32BE(c.data.byteLength,9),this._writeSoon(i,c.data)}_bufferAdd(c,i){const r=this._totalLength===0;return this._data.push(c,i),this._totalLength+=c.byteLength+i.byteLength,r}_bufferTake(){const c=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,c}_writeSoon(c,i){this._bufferAdd(c,i)&&setTimeout(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends M.Disposable{constructor(c){super();this._onMessage=new R.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=c,this._socketWriter=this._register(new t(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(c){this._socketWriter.write(new m(1,0,0,c))}}e.Protocol=w;class b extends C.IPCClient{constructor(c,i,r=null){super(c,i,r);this.protocol=c}static fromSocket(c,i){return new b(new w(c),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const c=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),c.end()}}e.Client=b;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new R.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(c){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(c):this._emitter.fire(c):this._bufferedMessages.push(c)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class P{constructor(c){this.data=c,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let c=[],i=0,r=this._first;for(;r;)c[i++]=r.data,r=r.next;return c}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(c){const i=new P(c);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class a{constructor(){this.lastRuns=[];const c=Date.now();for(let i=0;i<a._HISTORY_LENGTH;i++)this.lastRuns[i]=c-1e3*i;setInterval(()=>{for(let i=a._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const c=Date.now(),i=(1+a._HISTORY_LENGTH)*1e3;let r=0;for(let o=0;o<a._HISTORY_LENGTH;o++)c-this.lastRuns[o]<=i&&r++;return 1-r/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class u{constructor(c,i=null,r=a.getInstance()){this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=r,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=c,this._socketWriter=new t(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),i&&this._socketReader.acceptChunk(i),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,M.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const c=new m(5,0,0,h());this._socketWriter.write(c),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const c=Date.now()-this._socketWriter.lastWriteTime;if(c>=5e3){const i=new m(4,0,0,h());this._socketWriter.write(i),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-c+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const c=Date.now()-this._socketReader.lastReadTime;if(c>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-c,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(c,i){this._isReconnecting=!0,this._socketDisposables=(0,M.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=c,this._socketWriter=new t(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.push(this._socket.onClose(r=>this._onSocketClose.fire(r))),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1;const c=this._outgoingUnackMsg.toArray();for(let i=0,r=c.length;i<r;i++)this._socketWriter.write(c[i]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(c){if(c.ack>this._outgoingAckId){this._outgoingAckId=c.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=c.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(c.type===1){if(c.id>this._incomingMsgId)if(c.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new m(6,0,0,h())))}else this._incomingMsgId=c.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(c.data)}else if(c.type===2)this._onControlMessage.fire(c.data);else if(c.type===5)this._onDidDispose.fire();else if(c.type===6){const i=this._outgoingUnackMsg.toArray();for(let r=0,o=i.length;r<o;r++)this._socketWriter.write(i[r]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(c){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const r=new m(1,i,this._incomingAckId,c);this._outgoingUnackMsg.push(r),this._isReconnecting||(this._socketWriter.write(r),this._recvAckCheck())}sendControl(c){const i=new m(2,0,0,c);this._socketWriter.write(i)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const c=Date.now()-this._incomingMsgLastTime;if(c>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-c+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const c=this._outgoingUnackMsg.peek(),i=Date.now()-c.writtenTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-i,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const c=new m(3,0,this._incomingAckId,h());this._socketWriter.write(c)}}e.PersistentProtocol=u}),define(Q[125],Z([0,1,14,17,4,2,35,123]),function($,e,v,R,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(y,E){const m=M.Event.fromNodeEventEmitter(v.ipcMain,E,(t,w)=>({event:t,message:w})),p=M.Event.filter(m,({event:t})=>t.sender.id===y);return M.Event.map(p,({message:t})=>t&&R.VSBuffer.wrap(t))}class f extends n.IPCServer{constructor(){super(f.getOnDidClientConnect())}static getOnDidClientConnect(){const E=M.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:m})=>m);return M.Event.map(E,m=>{const p=m.id,t=f.Clients.get(p);t&&t.dispose();const w=new M.Emitter;f.Clients.set(p,(0,C.toDisposable)(()=>w.fire()));const b=h(p,"vscode:message"),S=M.Event.any(M.Event.signal(h(p,"vscode:disconnect")),w.event);return{protocol:new I.Protocol(m,b),onDidClientDisconnect:S}})}}e.Server=f,f.Clients=new Map}),define(Q[85],Z([0,1,14,4,31,124]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class n extends C.Client{constructor(f,y){super({addEventListener:(E,m)=>f.addListener(E,m),removeEventListener:(E,m)=>f.removeListener(E,m),postMessage:E=>f.postMessage(E),start:()=>f.start(),close:()=>f.close()},y)}}e.Client=n;async function I(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const f=(0,M.generateUuid)();h.webContents.send("vscode:createMessageChannel",f);const y=R.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(m,p)=>({nonce:p,port:m.ports[0]})),{port:E}=await R.Event.toPromise(R.Event.once(R.Event.filter(y,m=>m.nonce===f)));return E}e.connect=I}),define(Q[86],Z([0,1,9,4,2,13]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var n;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(n=e.StorageHint||(e.StorageHint={}));function I(E){const m=E;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var h;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(h||(h={}));class f extends M.Disposable{constructor(m,p=Object.create(null)){super();this.database=m,this.options=p,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((p,t)=>this.accept(t,p)),m.deleted?.forEach(p=>this.accept(p,void 0))}accept(m,p){if(this.state===h.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(p)?t=this.cache.delete(m):this.cache.get(m)!==p&&(this.cache.set(m,p),t=!0),t&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==n.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,p){const t=this.cache.get(m);return(0,C.isUndefinedOrNull)(t)?p:t}getBoolean(m,p){const t=this.get(m);return(0,C.isUndefinedOrNull)(t)?p:t==="true"}getNumber(m,p){const t=this.get(m);return(0,C.isUndefinedOrNull)(t)?p:parseInt(t,10)}async set(m,p){if(this.state===h.Closed)return;if((0,C.isUndefinedOrNull)(p))return this.delete(m);const t=String(p);if(this.cache.get(m)!==t)return this.cache.set(m,t),this.pendingInserts.set(m,t),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===h.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.doFlush(0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((p,t)=>this.items.set(t,p)),m.delete&&m.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=y}),define(Q[126],Z([0,1,9,4,40,8,21]),function($,e,v,R,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(y,E=Object.create(null)){this.path=y,this.options=E,this.name=(0,C.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return R.Event.None}async getItems(){const y=await this.whenConnected,E=new Map;return(await this.all(y,"SELECT * FROM ItemTable")).forEach(p=>E.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(y){const E=await this.whenConnected;return this.doUpdateItems(E,y)}doUpdateItems(y,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,M.mapToString)(E.insert):"0"}), delete(${E.delete?(0,M.setToString)(E.delete):"0"})`),this.transaction(y,()=>{const m=E.insert,p=E.delete;if(m&&m.size>0){const t=[];t.push([]);let w=0;m.forEach((b,S)=>{let P=t[w];P.length>I.MAX_HOST_PARAMETERS&&(w++,P=[],t.push(P)),P.push(S,b)}),t.forEach(b=>{this.prepare(y,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,S=>S.run(b),()=>{const S=[];let P=0;return m.forEach((l,a)=>{S.push(a),P+=l.length}),`Keys: ${S.join(", ")} Length: ${P}`})})}if(p&&p.size){const t=[];t.push([]);let w=0;p.forEach(b=>{let S=t[w];S.length>I.MAX_HOST_PARAMETERS&&(w++,S=[],t.push(S)),S.push(b)}),t.forEach(b=>{this.prepare(y,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,S=>S.run(b),()=>{const S=[];return p.forEach(P=>{S.push(P)}),`Keys: ${S.join(", ")}`})})}})}async close(y){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,y)}doClose(y,E){return new Promise((m,p)=>{y.db.close(t=>(t&&this.handleSQLiteError(y,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?m():!y.isErroneous&&!y.isInMemory?this.backup().then(m,w=>(this.logger.error(`[storage ${this.name}] backup(): ${w}`),m())):typeof E=="function"?n.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(w=>{const b=()=>this.doClose(w,void 0);return this.doUpdateItems(w,{insert:E()}).then(()=>b(),S=>(b(),Promise.reject(S)))})).then(m,p):p(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const y=this.toBackupPath(this.path);return n.Promises.copy(this.path,y,{preserveSymlinks:!1})}toBackupPath(y){return`${y}.backup`}async checkIntegrity(y){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${y})`);const E=await this.whenConnected,m=await this.get(E,y?"PRAGMA integrity_check":"PRAGMA quick_check"),p=y?m.integrity_check:m.quick_check;return E.isErroneous?`${p} (last error: ${E.lastError})`:E.isInMemory?`${p} (in-memory!)`:p}async connect(y,E=!0){this.logger.trace(`[storage ${this.name}] open(${y}, retryOnBusy: ${E})`);try{return await this.doConnect(y)}catch(m){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${m}`),m.code==="SQLITE_BUSY"&&E)return await(0,v.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(y,!1);try{await n.Promises.unlink(y);try{await n.Promises.rename(this.toBackupPath(y),y)}catch(p){}return await this.doConnect(y)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(y,E){y.isErroneous=!0,y.lastError=E,this.logger.error(E)}doConnect(y){return new Promise((E,m)=>{new Promise((p,t)=>{$(["@vscode/sqlite3"],p,t)}).then(p=>{const t={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(y,w=>w?t.db?t.db.close(()=>m(w)):m(w):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(t),b=>t.db.close(()=>m(b)))),isInMemory:y===I.IN_MEMORY_PATH};t.db.on("error",w=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${w}`)),this.logger.isTracing&&t.db.on("trace",w=>this.logger.trace(`[storage ${this.name}] Trace (event): ${w}`))},m)})}exec(y,E){return new Promise((m,p)=>{y.db.exec(E,t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] exec(): ${t}`),p(t)):m())})}get(y,E){return new Promise((m,p)=>{y.db.get(E,(t,w)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] get(): ${t}`),p(t)):m(w))})}all(y,E){return new Promise((m,p)=>{y.db.all(E,(t,w)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] all(): ${t}`),p(t)):m(w))})}transaction(y,E){return new Promise((m,p)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),E(),y.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] transaction(): ${t}`),p(t)):m())})})}prepare(y,E,m,p){const t=y.db.prepare(E),w=b=>{this.handleSQLiteError(y,`[storage ${this.name}] prepare(): ${b} (${E}). Details: ${p()}`)};t.on("error",w),m(t),t.finalize(b=>{b&&w(b),t.removeListener("error",w)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class h{constructor(y){y&&typeof y.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=y.logTrace),y&&typeof y.logError=="function"&&(this.logError=y.logError)}get isTracing(){return!!this.logTrace}trace(y){this.logTrace&&this.logTrace(y)}error(y){this.logError&&this.logError(y)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[127],Z([12,11]),function($,e){return $.create("vs/base/common/date",e)}),define(Q[128],Z([0,1,127]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,M=R*60,C=M*24,n=C*7,I=C*30,h=C*365;function f(E,m){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,v.localize)(0,null,f(new Date().getTime()+p*1e3,!1));if(p<30)return(0,v.localize)(1,null);let t;return p<R?(t=p,m?t===1?(0,v.localize)(2,null,t):(0,v.localize)(3,null,t):t===1?(0,v.localize)(4,null,t):(0,v.localize)(5,null,t)):p<M?(t=Math.floor(p/R),m?t===1?(0,v.localize)(6,null,t):(0,v.localize)(7,null,t):t===1?(0,v.localize)(8,null,t):(0,v.localize)(9,null,t)):p<C?(t=Math.floor(p/M),m?t===1?(0,v.localize)(10,null,t):(0,v.localize)(11,null,t):t===1?(0,v.localize)(12,null,t):(0,v.localize)(13,null,t)):p<n?(t=Math.floor(p/C),m?t===1?(0,v.localize)(14,null,t):(0,v.localize)(15,null,t):t===1?(0,v.localize)(16,null,t):(0,v.localize)(17,null,t)):p<I?(t=Math.floor(p/n),m?t===1?(0,v.localize)(18,null,t):(0,v.localize)(19,null,t):t===1?(0,v.localize)(20,null,t):(0,v.localize)(21,null,t)):p<h?(t=Math.floor(p/I),m?t===1?(0,v.localize)(22,null,t):(0,v.localize)(23,null,t):t===1?(0,v.localize)(24,null,t):(0,v.localize)(25,null,t)):(t=Math.floor(p/h),m?t===1?(0,v.localize)(26,null,t):(0,v.localize)(27,null,t):t===1?(0,v.localize)(28,null,t):(0,v.localize)(29,null,t))}e.fromNow=f;function y(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(Q[129],Z([12,11]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Q[44],Z([0,1,30,13,129]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(f,y){return y&&(f.stack||f.stacktrace)?M.localize(0,null,I(f),n(f.stack)||n(f.stacktrace)):I(f)}function n(f){return Array.isArray(f)?f.join(`
`):f}function I(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?M.localize(1,null,f.message):f.message||M.localize(2,null)}function h(f=null,y=!1){if(!f)return M.localize(3,null);if(Array.isArray(f)){const E=v.coalesce(f),m=h(E[0],y);return E.length>1?M.localize(4,null,m,E.length):m}if(R.isString(f))return f;if(f.detail){const E=f.detail;if(E.error)return C(E.error,y);if(E.exception)return C(E.exception,y)}return f.stack?C(f,y):f.message?f.message:M.localize(5,null)}e.toErrorMessage=h}),define(Q[130],Z([12,11]),function($,e){return $.create("vs/base/common/keybindingLabels",e)}),define(Q[131],Z([0,1,130]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(n,I,h=I){this.modifierLabels=[null],this.modifierLabels[2]=n,this.modifierLabels[1]=I,this.modifierLabels[3]=h}toLabel(n,I,h){if(I.length===0)return null;const f=[];for(let y=0,E=I.length;y<E;y++){const m=I[y],p=h(m);if(p===null)return null;f[y]=M(m,p,this.modifierLabels[n])}return f.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function M(C,n,I){if(n===null)return"";const h=[];return C.ctrlKey&&h.push(I.ctrlKey),C.shiftKey&&h.push(I.shiftKey),C.altKey&&h.push(I.altKey),C.metaKey&&h.push(I.metaKey),n!==""&&h.push(n),h.join(I.separator)}}),define(Q[132],Z([12,11]),function($,e){return $.create("vs/base/node/processes",e)}),define(Q[72],Z([0,1,43,32,10,47,8,3,34,80,13,115,21,132]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return f.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return f.TerminateResponseCode}});function t(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(s,c){if(I.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const r=v.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(o=>{r.once("error",d=>{o({success:!1,error:d})}),r.once("exit",(d,g)=>{o(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?t(i.status):1})}else if(I.isLinux||I.isMacintosh)try{const i=M.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(r=>{v.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(o,d,g)=>{r(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function b(s){!s||(delete s.DEBUG,I.isMacintosh&&delete s.DYLD_LIBRARY_PATH,I.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=b;function S(s=h.env){return s.comspec||"cmd.exe"}e.getWindowsShell=S;class P{constructor(c,i,r,o){if(i!==void 0&&r!==void 0&&o!==void 0)this.cmd=c,this.args=i,this.shell=r,this.options=o;else{const d=c;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(h.env).forEach(g=>{d[g]=h.env[g]}),Object.keys(this.options.env).forEach(g=>{d[g]=this.options.env[g]}),this.options.env=d}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(n.sep);return i!==-1&&(c=c.substring(i+1)),P.WellKnowCommands[c]?c:"other"}start(c){return I.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(h.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(i=>{let r,o;const d=new Promise((g,k)=>{r=g,o=k});if(i){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=v.exec(g,this.options,(k,L,A)=>{this.childProcess=null;const W=k;W&&W.killed?o({killed:this.terminateRequested,stdout:L.toString(),stderr:A.toString()}):this.handleExec(r,c,k,L,A)})}else{let g=null;const k=L=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(L,r,c,o);const A={terminated:this.terminateRequested};y.isNumber(L)&&(A.cmdCode=L),r(A)};if(this.shell&&I.isWindows){const L=C.deepClone(this.options);L.windowsVerbatimArguments=!0,L.detached=!1;let A=!1,W=!1;const V=[];let ee=this.ensureQuotes(this.cmd);V.push(ee.value),A=ee.quoted,this.args&&this.args.forEach(ae=>{ee=this.ensureQuotes(ae),V.push(ee.value),W=W&&ee.quoted});const oe=["/s","/c"];A?W?oe.push('"'+V.join(" ")+'"'):V.length>1?oe.push('"'+V[0]+'" '+V.slice(1).join(" ")):oe.push('"'+V[0]+'"'):oe.push(V.join(" ")),g=v.spawn(S(),oe,L)}else this.cmd&&(g=v.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(y.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",L=>{this.childProcess=null,o({terminated:this.terminateRequested,error:L})}),g.pid&&(this.childProcess.on("close",k),this.handleSpawn(g,r,c,o,!0)))}return d})}handleClose(c,i,r,o){}ensureQuotes(c){return P.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,w(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!I.isWindows)return c(!1);const i=v.spawn(S(),["/s","/c"]);i.on("error",r=>c(!0)),i.on("exit",r=>c(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class l extends P{constructor(c,i,r,o){super(c,i,r,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,r,o,d){[o,d].forEach((g,k)=>{const L=new E.LineDecoder;L.write(g).forEach(V=>{i({line:V,source:k===0?0:1})});const W=L.end();W&&i({line:W,source:k===0?0:1})}),c({terminated:this.terminateRequested,error:r})}handleSpawn(c,i,r,o,d){const g=new E.LineDecoder,k=new E.LineDecoder;c.stdout.on("data",L=>{g.write(L).forEach(W=>r({line:W,source:0}))}),c.stderr.on("data",L=>{k.write(L).forEach(W=>r({line:W,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=k}handleClose(c,i,r,o){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&r({line:d,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&r({line:g,source:1})}}e.LineProcess=l;function a(s){let c=[],i=!1;const r=function(o){if(i){c.push(o);return}(!s.send(o,g=>{if(g&&console.error(g),i=!1,c.length>0){const k=c.slice(0);c=[],k.forEach(L=>r(L))}})||I.isWindows)&&(i=!0)};return{send:r}}e.createQueuedSender=a;var u;(function(s){async function c(i,r,o){if(n.isAbsolute(i))return i;if(r===void 0&&(r=h.cwd()),n.dirname(i)!=="."||(o===void 0&&y.isString(h.env.PATH)&&(o=h.env.PATH.split(n.delimiter)),o===void 0||o.length===0))return n.join(r,i);async function g(k){if(await m.Promises.exists(k)){let L;try{L=await m.Promises.stat(k)}catch(A){A.message.startsWith("EACCES")&&(L=await m.Promises.lstat(k))}return L?!L.isDirectory():!1}return!1}for(let k of o){let L;if(n.isAbsolute(k)?L=n.join(k,i):L=n.join(r,k,i),await g(L))return L;let A=L+".com";if(await g(A)||(A=L+".exe",await g(A)))return A}return n.join(r,i)}s.findExecutable=c})(u=e.win32||(e.win32={}))}),define(Q[133],Z([0,1,26,3,119,72]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function n(p,t){return p===1?R.isWindows?E():C.getWindowsShell(t):f(p,t)}e.getSystemShell=n;function I(p,t){return p===1?R.isWindows?m(t):C.getWindowsShell(t):f(p,t)}e.getSystemShellSync=I;let h=null;function f(p,t){if(R.isLinux&&p===2||R.isMacintosh&&p===3)return"/bin/bash";if(!h){let w;if(R.isWindows)w="/bin/bash";else{if(w=t.SHELL,!w)try{w=(0,v.userInfo)().shell}catch(b){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}h=w}return h}let y=null;async function E(){return y||(y=(await(0,M.getFirstAvailablePowerShellInstallation)()).exePath),y}function m(p){if(y)return y;const t=R.isWindows&&parseFloat((0,v.release)())>=10,w=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${p.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?b:C.getWindowsShell(p)}}),define(Q[87],Z([0,1,43,9,17,23,110,16,4,2,47,72,35]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends m.ChannelServer{constructor(b){super({send:S=>{try{process.send&&process.send(S.buffer.toString("base64"))}catch(P){}},onMessage:h.Event.fromNodeEventEmitter(process,"message",S=>M.VSBuffer.wrap(Buffer.from(S,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=p;class t{constructor(b,S){this.modulePath=b,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new R.Delayer(P),this.child=null,this._client=null}getChannel(b){const S=this;return{call(P,l,a){return S.requestPromise(b,P,l,a)},listen(P,l){return S.requestEvent(b,P,l)}}}requestPromise(b,S,P,l=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),u=(0,R.createCancelablePromise)(i=>a.call(S,P,i)),s=l.onCancellationRequested(()=>u.cancel()),c=(0,f.toDisposable)(()=>u.cancel());return this.activeRequests.add(c),u.finally(()=>{s.dispose(),this.activeRequests.delete(c),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(b,S,P){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let l;const a=new h.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(b).listen(S,P)(a.fire,a),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,E.removeDangerousEnvVariables)(S.env),this.child=(0,v.fork)(this.modulePath,b,S);const P=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,n.isRemoteConsoleLog)(r)){(0,n.log)(r,`IPC Library: ${this.options.serverName}`);return}P.fire(M.VSBuffer.wrap(Buffer.from(r,"base64")))});const a=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,u=r=>this.child&&this.child.connected&&a.send(r.buffer.toString("base64")),s=P.event,c={send:u,onMessage:s};this._client=new m.ChannelClient(c);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(d=>(0,f.dispose)(d)),this.activeRequests.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:o})})}return this._client}getCachedChannel(b){let S=this.channels.get(b);return S||(S=this.client.getChannel(b),this.channels.set(b,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Q[134],Z([12,11]),function($,e){return $.create("vs/code/electron-main/app",e)}),define(Q[135],Z([12,11]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[136],Z([12,11]),function($,e){return $.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[137],Z([12,11]),function($,e){return $.create("vs/platform/environment/node/argv",e)}),define(Q[138],Z([12,11]),function($,e){return $.create("vs/platform/environment/node/argvHelper",e)}),define(Q[139],Z([12,11]),function($,e){return $.create("vs/platform/environment/node/shellEnv",e)}),define(Q[140],Z([12,11]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[141],Z([12,11]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[142],Z([12,11]),function($,e){return $.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[143],Z([12,11]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Q[144],Z([12,11]),function($,e){return $.create("vs/platform/files/common/files",e)}),define(Q[145],Z([12,11]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Q[146],Z([12,11]),function($,e){return $.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Q[147],Z([12,11]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[148],Z([12,11]),function($,e){return $.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[149],Z([12,11]),function($,e){return $.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[150],Z([12,11]),function($,e){return $.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Q[151],Z([12,11]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Q[152],Z([12,11]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[153],Z([12,11]),function($,e){return $.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[154],Z([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/window",e)}),define(Q[155],Z([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[156],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[157],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[158],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[159],Z([0,1,4,2]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class M{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(I,h,f){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:f[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:f[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:f[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:f[0],port:f[1],subId:f[2]}))}throw new Error("Method not implemented.")}listen(I,h,f){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=M,M.ChannelName="extensionhostdebugservice";class C extends R.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,h,f){this.channel.call("attach",[I,h,f])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,h){this.channel.call("terminate",[I,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,h){return this.channel.call("openExtensionDevelopmentHostWindow",[I,h])}}e.ExtensionHostDebugChannelClient=C}),define(Q[160],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(n){this.driver=n}listen(n,I){throw new Error(`No event found: ${I}`)}call(n,I,h){switch(I){case"click":return this.driver.click(h[0],h[1],h[2]);case"doubleClick":return this.driver.doubleClick(h);case"setValue":return this.driver.setValue(h[0],h[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(h);case"getElements":return this.driver.getElements(h[0],h[1]);case"getElementXY":return this.driver.getElementXY(h[0],h[1],h[2]);case"typeInEditor":return this.driver.typeInEditor(h[0],h[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(h);case"writeInTerminal":return this.driver.writeInTerminal(h[0],h[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=v;class R{constructor(n){this.channel=n}click(n,I,h){return this.channel.call("click",[n,I,h])}doubleClick(n){return this.channel.call("doubleClick",n)}setValue(n,I){return this.channel.call("setValue",[n,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(n){return this.channel.call("isActiveElement",n)}getElements(n,I){return this.channel.call("getElements",[n,I])}getElementXY(n,I,h){return this.channel.call("getElementXY",[n,I,h])}typeInEditor(n,I){return this.channel.call("typeInEditor",[n,I])}getTerminalBuffer(n){return this.channel.call("getTerminalBuffer",n)}writeInTerminal(n,I){return this.channel.call("writeInTerminal",[n,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=R;class M{constructor(n){this.channel=n}registerWindowDriver(n){return this.channel.call("registerWindowDriver",n)}reloadWindowDriver(n){return this.channel.call("reloadWindowDriver",n)}}e.WindowDriverRegistryChannelClient=M}),define(Q[161],Z([0,1,128,46,10,8,34,15,7]),function($,e,v,R,M,C,n,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class f{constructor(w,b,S){this._args=w,this.paths=b,this.productService=S}get appRoot(){return(0,C.dirname)(M.FileAccess.asFileUri("",$).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(h.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return h.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return h.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=n.env.VSCODE_PORTABLE;return w?h.URI.file((0,C.join)(w,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,C.resolve)(w):(0,C.normalize)((0,C.join)(M.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const w=this.args["extensions-download-dir"];return w?(0,C.resolve)(w):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,C.resolve)(w);const b=n.env.VSCODE_EXTENSIONS;if(b)return b;const S=n.env.VSCODE_PORTABLE;return S?(0,C.join)(S,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(b=>/^[^:/?#]+?:\/\//.test(b)?h.URI.parse(b):h.URI.file((0,C.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?h.URI.parse(w):h.URI.file((0,C.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!n.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return h.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ge([R.memoize],f.prototype,"appRoot",null),ge([R.memoize],f.prototype,"userHome",null),ge([R.memoize],f.prototype,"userDataPath",null),ge([R.memoize],f.prototype,"appSettingsHome",null),ge([R.memoize],f.prototype,"tmpDir",null),ge([R.memoize],f.prototype,"userRoamingDataHome",null),ge([R.memoize],f.prototype,"settingsResource",null),ge([R.memoize],f.prototype,"userDataSyncHome",null),ge([R.memoize],f.prototype,"userDataSyncLogResource",null),ge([R.memoize],f.prototype,"sync",null),ge([R.memoize],f.prototype,"machineSettingsResource",null),ge([R.memoize],f.prototype,"globalStorageHome",null),ge([R.memoize],f.prototype,"workspaceStorageHome",null),ge([R.memoize],f.prototype,"keybindingsResource",null),ge([R.memoize],f.prototype,"keyboardLayoutResource",null),ge([R.memoize],f.prototype,"argvResource",null),ge([R.memoize],f.prototype,"snippetsHome",null),ge([R.memoize],f.prototype,"isExtensionDevelopment",null),ge([R.memoize],f.prototype,"untitledWorkspacesHome",null),ge([R.memoize],f.prototype,"installSourcePath",null),ge([R.memoize],f.prototype,"builtinExtensionsPath",null),ge([R.memoize],f.prototype,"extensionsPath",null),ge([R.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ge([R.memoize],f.prototype,"extensionDevelopmentKind",null),ge([R.memoize],f.prototype,"extensionTestsLocationURI",null),ge([R.memoize],f.prototype,"debugExtensionHost",null),ge([R.memoize],f.prototype,"serviceMachineIdResource",null),ge([R.memoize],f.prototype,"telemetryLogResource",null),ge([R.memoize],f.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=f;function y(t,w){return p(t["inspect-extensions"],t["inspect-brk-extensions"],5870,w,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=y;function E(t,w){return p(t["inspect-search"],t["inspect-brk-search"],5876,w,t.extensionEnvironment)}e.parseSearchPort=E;function m(t,w){return p(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,w,t.extensionEnvironment)}e.parsePtyHostPort=m;function p(t,w,b,S,P,l){const u=Number(w||t)||(S?null:b),s=u?Boolean(!!w):!1;let c;if(l)try{c=JSON.parse(l)}catch{}return{port:u,break:s,debugId:P,env:c}}}),define(Q[88],Z([0,1,246,3,137]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,M.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(14,null)},category:{type:"string",cat:"e",description:(0,M.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,M.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,M.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,M.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,M.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,M.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,M.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,M.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const n={onUnknownOption:()=>{},onMultipleValues:()=>{}};function I(t,w,b=n){const S={},P=[],l=[];for(let c in w){const i=w[c];i.alias&&(S[c]=i.alias),i.type==="string"||i.type==="string[]"?(P.push(c),i.deprecates&&P.push(i.deprecates)):i.type==="boolean"&&(l.push(c),i.deprecates&&l.push(i.deprecates))}const a=v(t,{string:P,boolean:l,alias:S}),u={},s=a;u._=a._.map(c=>String(c)).filter(c=>c.length>0),delete s._;for(let c in w){const i=w[c];i.alias&&delete s[i.alias];let r=s[c];i.deprecates&&s.hasOwnProperty(i.deprecates)&&(r||(r=s[i.deprecates]),delete s[i.deprecates]),typeof r!="undefined"&&(i.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):i.type==="string"&&Array.isArray(r)&&(r=r.pop(),b.onMultipleValues(c,r)),u[c]=r),delete s[c]}for(let c in s)b.onUnknownOption(c);return u}e.parseArgs=I;function h(t,w){let b="";return w.args&&(Array.isArray(w.args)?b=` <${w.args.join("> <")}>`:b=` <${w.args}>`),w.alias?`-${w.alias} --${t}${b}`:`--${t}${b}`}function f(t,w){let b=0,S=[];for(const u in t){const s=t[u],c=h(u,s);b=Math.max(b,c.length),S.push([c,s.description])}let P=b+2+1;if(w-P<25)return S.reduce((u,s)=>u.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);let l=w-P-1,a=[];for(const u of S){let s=u[0],c=E(u[1],l),i=y(P-s.length-2);a.push("  "+s+i+c[0]);for(let r=1;r<c.length;r++)a.push(y(P)+c[r])}return a}e.formatOptions=f;function y(t){return" ".repeat(t)}function E(t,w){let b=[];for(;t.length;){let S=t.length<w?t.length:t.lastIndexOf(" ",w),P=t.slice(0,S).trim();t=t.slice(S),b.push(P)}return b}function m(t,w,b,S,P){const l=process.stdout.isTTY&&process.stdout.columns||80,a=P?.noInputFiles!==!0?`[${(0,M.localize)(32,null)}...]`:"",u=[`${t} ${b}`];u.push(""),u.push(`${(0,M.localize)(33,null)}: ${w} [${(0,M.localize)(34,null)}]${a}`),u.push(""),P?.noPipe!==!0&&(R.isWindows?u.push((0,M.localize)(35,null,w)):u.push((0,M.localize)(36,null,w)),u.push(""));const s={};for(const c in S){const i=S[c];if(i.description&&i.cat){let r=s[i.cat];r||(s[i.cat]=r={}),r[c]=i}}for(let c in s){const i=c;let r=s[i];r&&(u.push(C[i]),u.push(...f(r,l)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=m;function p(t,w){return`${t||(0,M.localize)(37,null)}
${w||(0,M.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(Q[162],Z([0,1,62,159,88]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends R.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,h,f){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(f[0],f[1]):super.call(I,h,f)}async openExtensionDevelopmentHostWindow(I,h){const f=(0,M.parseArgs)(I,M.OPTIONS);f.debugRenderer=h;const y=f.extensionDevelopmentPath;if(!y)return{success:!1};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:f});if(!h)return{success:!0};const m=E.win;if(!m)return{success:!0};const p=m.webContents.debugger;let t=p.isAttached()?Infinity:0;const w=(0,v.createServer)(b=>{t++==0&&p.attach();let S=!1;const P=u=>{S||b.write(JSON.stringify(u)+"\0")},l=(u,s,c,i)=>P({method:s,params:c,sessionId:i});m.on("close",()=>{p.removeListener("message",l),b.end(),S=!0}),p.addListener("message",l);let a=Buffer.alloc(0);b.on("data",u=>{a=Buffer.concat([a,u]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let c;try{const i=a.slice(0,s).toString("utf8");a=a.slice(s+1),c=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}p.sendCommand(c.method,c.params,c.sessionId).then(i=>P({id:c.id,sessionId:c.sessionId,result:i})).catch(i=>P({id:c.id,sessionId:c.sessionId,error:{code:0,message:i.message}}))}}),b.on("error",u=>{console.error("error on cdp pipe:",u)}),b.on("close",()=>{S=!0,--t==0&&p.detach()})});return await new Promise(b=>w.listen(0,b)),m.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function $(e,v,R,M){function C(I){const h=n(I),f=[h];return e.isAbsolute(h)||f.unshift(M),e.resolve(...f)}function n(I){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,R);const y=I["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(E,"AppData","Roaming")}break;case"darwin":f=e.join(v.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,R)}return{getUserDataPath:C}}if(typeof define=="function")define(Q[163],Z([0,247,26,10,15,34]),function(e,v,R,M,C,n){const I=C.dirname(M.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(C.joinPath(I,"package.json").fsPath);return $(v,R,h.name,n.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),R=require("os");module.exports=$(v,R,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[164],Z([0,1,26,161,163]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends R.AbstractNativeEnvironmentService{constructor(I,h){super(I,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,M.getUserDataPath)(I)},h)}}e.NativeEnvironmentService=C}),define(Q[165],Z([0,1,28,26,8]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(n){const I=(0,M.join)((0,R.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(I,""),n&&console.log(`Marker file for --wait created: ${I}`),I}catch(h){n&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=C}),define(Q[166],Z([0,1,141]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function C(m){return m=m.trim(),m==="*"||R.test(m)}e.isValidVersionStr=C;function n(m){if(!C(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=m.match(R);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=n;function I(m){if(!m)return null;let p=m.majorBase,t=m.majorMustEqual,w=m.minorBase,b=m.minorMustEqual,S=m.patchBase,P=m.patchMustEqual;m.hasCaret&&(p===0||(b=!1),P=!1);let l=0;if(m.preRelease){const a=M.exec(m.preRelease);if(a){const[,u,s,c]=a;l=Date.UTC(Number(u),Number(s)-1,Number(c))}}return{majorBase:p,majorMustEqual:t,minorBase:w,minorMustEqual:b,patchBase:S,patchMustEqual:P,isMinimum:m.hasGreaterEquals,notBefore:l}}e.normalizeVersion=I;function h(m,p,t){let w;typeof m=="string"?w=I(n(m)):w=m;let b;p instanceof Date?b=p.getTime():typeof p=="string"&&(b=new Date(p).getTime());let S;if(typeof t=="string"?S=I(n(t)):S=t,!w||!S)return!1;let P=w.majorBase,l=w.minorBase,a=w.patchBase,u=S.majorBase,s=S.minorBase,c=S.patchBase,i=S.notBefore,r=S.majorMustEqual,o=S.minorMustEqual,d=S.patchMustEqual;return S.isMinimum?P>u?!0:P<u?!1:l>s?!0:l<s||b&&b<i?!1:a>=c:(P===1&&u===0&&(!r||!o||!d)&&(u=1,s=0,c=0,r=!0,o=!1,d=!1),P<u?!1:P>u?!r:l<s?!1:l>s?!o:a<c?!1:a>c?!d:!(b&&b<i))}e.isValidVersion=h;function f(m,p,t,w){return t.isBuiltin||typeof t.main=="undefined"?!0:E(m,p,t.engines.vscode,w)}e.isValidExtensionVersion=f;function y(m,p,t){return m==="*"||E(p,t,m)}e.isEngineValid=y;function E(m,p,t,w=[]){let b=I(n(t));if(!b)return w.push(v.localize(0,null,t)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return w.push(v.localize(1,null,t)),!1}else if(!b.majorMustEqual)return w.push(v.localize(2,null,t)),!1;return h(m,p,b)?!0:(w.push(v.localize(3,null,m,t)),!1)}}),define(Q[167],Z([0,1,4,2,17,60,23]),function($,e,v,R,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class I extends R.Disposable{constructor(f,y){super();this.provider=f,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,y,E){const m=this.getUriTransformer(f);switch(y){case"stat":return this.stat(m,E[0]);case"readdir":return this.readdir(m,E[0]);case"open":return this.open(m,E[0],E[1]);case"close":return this.close(E[0]);case"read":return this.read(E[0],E[1],E[2]);case"readFile":return this.readFile(m,E[0]);case"write":return this.write(E[0],E[1],E[2],E[3],E[4]);case"writeFile":return this.writeFile(m,E[0],E[1],E[2]);case"rename":return this.rename(m,E[0],E[1],E[2]);case"copy":return this.copy(m,E[0],E[1],E[2]);case"mkdir":return this.mkdir(m,E[0]);case"delete":return this.delete(m,E[0],E[1]);case"watch":return this.watch(m,E[0],E[1],E[2],E[3]);case"unwatch":return this.unwatch(E[0],E[1])}throw new Error(`IPC Command ${y} not found`)}listen(f,y,E){const m=this.getUriTransformer(f);switch(y){case"fileChange":return this.onFileChange(m,E[0]);case"readFileStream":return this.onReadFileStream(m,E[0],E[1])}throw new Error(`Unknown event ${y}`)}stat(f,y){const E=this.transformIncoming(f,y,!0);return this.provider.stat(E)}readdir(f,y){const E=this.transformIncoming(f,y);return this.provider.readdir(E)}async readFile(f,y){const E=this.transformIncoming(f,y,!0),m=await this.provider.readFile(E);return M.VSBuffer.wrap(m)}onReadFileStream(f,y,E){const m=this.transformIncoming(f,y,!0),p=new n.CancellationTokenSource,t=new v.Emitter({onLastListenerRemove:()=>{p.cancel()}}),w=this.provider.readFileStream(m,E,p.token);return(0,C.listenStream)(w,{onData:b=>t.fire(M.VSBuffer.wrap(b)),onError:b=>t.fire(b),onEnd:()=>{t.fire("end"),t.dispose(),p.dispose()}}),t.event}writeFile(f,y,E,m){const p=this.transformIncoming(f,y);return this.provider.writeFile(p,E.buffer,m)}open(f,y,E){const m=this.transformIncoming(f,y,!0);return this.provider.open(m,E)}close(f){return this.provider.close(f)}async read(f,y,E){const m=M.VSBuffer.alloc(E),p=0,t=await this.provider.read(f,y,m.buffer,p,E);return[m,t]}write(f,y,E,m,p){return this.provider.write(f,y,E.buffer,m,p)}mkdir(f,y){const E=this.transformIncoming(f,y);return this.provider.mkdir(E)}delete(f,y,E){const m=this.transformIncoming(f,y);return this.provider.delete(m,E)}rename(f,y,E,m){const p=this.transformIncoming(f,y),t=this.transformIncoming(f,E);return this.provider.rename(p,t,m)}copy(f,y,E,m){const p=this.transformIncoming(f,y),t=this.transformIncoming(f,E);return this.provider.copy(p,t,m)}onFileChange(f,y){const E=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(f,E))},onLastListenerRemove:()=>{(0,R.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return E.event}async watch(f,y,E,m,p){const t=this.sessionToWatcher.get(y);if(t){const w=this.transformIncoming(f,m),b=t.watch(E,w,p);this.watchRequests.set(y+E,b)}}async unwatch(f,y){const E=f+y,m=this.watchRequests.get(E);m&&((0,R.dispose)(m),this.watchRequests.delete(E))}dispose(){super.dispose(),this.watchRequests.forEach(f=>(0,R.dispose)(f)),this.watchRequests.clear(),this.sessionToWatcher.forEach(f=>(0,R.dispose)(f)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=I}),define(Q[73],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(M,C=[],n=!1){this.ctor=M,this.staticArguments=C,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=v}),define(Q[168],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=v;class R{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let n of this._nodes.values())n.outgoing.size===0&&C.push(n);return C}insertEdge(C,n){const I=this.lookupOrInsertNode(C),h=this.lookupOrInsertNode(n);I.outgoing.set(this._hashFn(n),h),h.incoming.set(this._hashFn(C),I)}removeNode(C){const n=this._hashFn(C);this._nodes.delete(n);for(let I of this._nodes.values())I.outgoing.delete(n),I.incoming.delete(n)}lookupOrInsertNode(C){const n=this._hashFn(C);let I=this._nodes.get(n);return I||(I=new v(C),this._nodes.set(n,I)),I}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[n,I]of this._nodes)C.push(`${n}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,n]of this._nodes){const I=new Set([C]),h=this._findCycle(n,I);if(h)return h}}_findCycle(C,n){for(let[I,h]of C.outgoing){if(n.has(I))return[...n,I].join(" -> ");n.add(I);const f=this._findCycle(h,n);if(f)return f;n.delete(I)}}}e.Graph=R}),define(Q[5],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function I(h){return h[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=I})(v=e._util||(e._util={})),e.IInstantiationService=M("instantiationService");function R(n,I,h,f){I[v.DI_TARGET]===I?I[v.DI_DEPENDENCIES].push({id:n,index:h,optional:f}):(I[v.DI_DEPENDENCIES]=[{id:n,index:h,optional:f}],I[v.DI_TARGET]=I)}function M(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const I=function(h,f,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(I,h,y,!1)};return I.toString=()=>n,v.serviceIds.set(n,I),I}e.createDecorator=M;function C(n){return n}e.refineServiceDecorator=C}),define(Q[74],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function R(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=R}),define(Q[89],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class R{constructor(C){this.machineId=C}encryption(){return new Promise((C,n)=>$(["vscode-encrypt"],C,n))}async encrypt(C){try{return(await this.encryption()).encrypt(this.machineId,C)}catch(n){return C}}async decrypt(C){try{return(await this.encryption()).decrypt(this.machineId,C)}catch(n){return C}}}e.EncryptionMainService=R}),define(Q[48],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[169],Z([0,1,10,140,5]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function n(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function I(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function h(l,a){switch(l){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=h;function f(l,a){return a==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function y(l,a,u){return f(a,u)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===u?!0:E(u).includes(l)}e.isTargetPlatformCompatible=y;function E(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function m(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=m;var p;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var t;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var w;(function(l){l.Install="install",l.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var b;(function(l){l[l.None=0]="None",l[l.Install=1]="Install",l[l.Update=2]="Update"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var S;(function(l){l.Unsupported="Unsupported",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(a,u){super(a);this.code=u,this.name=u}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,M.createDecorator)("IExtensionManagementCLIService")}),define(Q[170],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Q[171],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Q[90],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Q[172],Z([0,1,43,10,8,3,80,21,72,142,90]),function($,e,v,R,M,C,n,I,h,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=f.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends m{openTerminal(a,u){return this.spawnTerminal(v,a,h.getWindowsShell(),u)}spawnTerminal(a,u,s,c){const i=u.windowsExec||p.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const r=M.basename(i).toLowerCase();if(r==="cmder"||r==="cmder.exe")return a.spawn(i,c?[c]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(r==="wt"||r==="wt.exe")&&o.push("-d ."),new Promise((d,g)=>{const k=b(process),L=a.spawn(s,o,{cwd:c,env:k});L.on("error",g),L.on("exit",()=>d())})}runInTerminal(a,u,s,c,i){const r="windowsExec"in i&&i.windowsExec?i.windowsExec:p.getDefaultTerminalWindows();return new Promise((o,d)=>{const g=`"${u} - ${E}"`,k=`""${s.join('" "')}" & pause"`,L=["/c","start",g,"/wait",r,"/c",k],A=Object.assign({},b(process),c);Object.keys(A).filter(ee=>A[ee]===null).forEach(ee=>delete A[ee]);const W={cwd:u,env:A,windowsVerbatimArguments:!0};v.spawn(p.CMD,L,W).on("error",ee=>{d(S(ee))}),o(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class t extends m{openTerminal(a,u){return this.spawnTerminal(v,a,u)}runInTerminal(a,u,s,c,i){const r=i.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((o,d)=>{if(r===y.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const g=r===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${g}.scpt`,$).fsPath,"-t",a||E,"-w",u];for(let V of s)L.push("-a"),L.push(V);if(c){const V=Object.assign({},b(process),c);for(let ee in V){const oe=V[ee];oe===null?(L.push("-u"),L.push(ee)):(L.push("-e"),L.push(`${ee}=${oe}`))}}let A="";const W=v.spawn(t.OSASCRIPT,L);W.on("error",V=>{d(S(V))}),W.stderr.on("data",V=>{A+=V.toString()}),W.on("exit",V=>{if(V===0)o(void 0);else if(A){const ee=A.split(`
`,1);d(new Error(ee[0]))}else d(new Error(f.localize(1,null,g,V)))})}else d(new Error(f.localize(2,null,r)))})}spawnTerminal(a,u,s){const c=u.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((i,r)=>{const o=["-a",c];s&&o.push(s);const d=b(process),g=a.spawn("/usr/bin/open",o,{cwd:s,env:d});g.on("error",r),g.on("exit",()=>i())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class w extends m{openTerminal(a,u){return this.spawnTerminal(v,a,u)}runInTerminal(a,u,s,c,i){const r=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((o,d)=>{let g=[];r.then(k=>{k.indexOf("gnome-terminal")>=0?g.push("-x"):g.push("-e"),g.push("bash"),g.push("-c");const L=`${P(s)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;g.push(`''${L}''`);const A=Object.assign({},b(process),c);Object.keys(A).filter(oe=>A[oe]===null).forEach(oe=>delete A[oe]);const W={cwd:u,env:A};let V="";const ee=v.spawn(k,g,W);ee.on("error",oe=>{d(S(oe))}),ee.stderr.on("data",oe=>{V+=oe.toString()}),ee.on("exit",oe=>{if(oe===0)o(void 0);else if(V){const ae=V.split(`
`,1);d(new Error(ae[0]))}else d(new Error(f.localize(4,null,k,oe)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await I.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{a?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,u,s){const c=u.linuxExec?Promise.resolve(u.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,r)=>{c.then(o=>{const d=b(process),g=a.spawn(o,[],{cwd:s,env:d});g.on("error",r),g.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=f.localize(3,null);function b(l){const a={...l.env};return(0,n.sanitizeProcessEnvironment)(a),a}function S(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(f.localize(5,null,l.path)):l}function P(l){let a="";for(let u of l)u.indexOf(" ")>=0?a+='"'+u+'"':a+=u,a+=" ";return a}}),define(Q[18],Z([0,1,40,8,25,13,7,144,5]),function($,e,v,R,M,C,n,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function f(F){return F.create===!0}e.isFileOpenForWriteOptions=f;var y;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var E;(function(F){F[F.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var m;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=p;function t(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=t;function w(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function b(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=b;var S;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(U,G){super(U);this.code=G}}e.FileSystemProviderError=P;function l(F,U){const G=new P(F.toString(),U);return u(G,U),G}e.createFileSystemProviderError=l;function a(F){return F||l((0,I.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=a;function u(F,U){return F.name=U?`${U} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=u;function s(F){if(!F)return S.Unknown;if(F instanceof P)return F.code;const U=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!U)return S.Unknown;switch(U[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=s;function c(F){if(F instanceof k)return F.fileOperationResult;switch(s(F)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var i;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(U,G,Y){this.resource=U,this.operation=G,this.target=Y}isOperation(U){return this.operation===U}}e.FileOperationEvent=r;var o;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class d{constructor(U,G){this.added=void 0,this.updated=void 0,this.deleted=void 0;const Y=new Map;for(const q of U){const z=Y.get(q.type);z?z.push([q.resource,q]):Y.set(q.type,[[q.resource,q]])}for(const[q,z]of Y)switch(q){case 1:this.added=v.TernarySearchTree.forUris(()=>G),this.added.fill(z);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>G),this.updated.fill(z);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>G),this.deleted.fill(z);break}}contains(U,...G){return this.doContains(U,{includeChildren:!1},...G)}affects(U,...G){return this.doContains(U,{includeChildren:!0},...G)}doContains(U,G,...Y){if(!U)return!1;const q=Y.length>0;return!!((!q||Y.includes(1))&&(this.added?.get(U)||G.includeChildren&&this.added?.findSuperstr(U))||(!q||Y.includes(0))&&(this.updated?.get(U)||G.includeChildren&&this.updated?.findSuperstr(U))||(!q||Y.includes(2))&&(this.deleted?.findSubstr(U)||G.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function g(F,U,G){return!F||!U||F===U||U.length>F.length?!1:(U.charAt(U.length-1)!==R.sep&&(U+=R.sep),G?(0,M.startsWithIgnoreCase)(F,U):F.indexOf(U)===0)}e.isParent=g;class k extends Error{constructor(U,G,Y){super(U);this.fileOperationResult=G,this.options=Y}}e.FileOperationError=k;class L extends k{constructor(U,G,Y){super(U,2,Y);this.stat=G}}e.NotModifiedSinceFileOperationError=L;var A;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var W;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(W=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=V;async function ee(F,U){if(!U.hasProvider(n.URI.from({scheme:F.scheme})))return new Promise(G=>{const Y=U.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===F.scheme&&q.added&&(Y.dispose(),G())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class oe{static formatSize(U){return(0,C.isNumber)(U)||(U=0),U<oe.KB?(0,I.localize)(1,null,U.toFixed(0)):U<oe.MB?(0,I.localize)(2,null,(U/oe.KB).toFixed(2)):U<oe.GB?(0,I.localize)(3,null,(U/oe.MB).toFixed(2)):U<oe.TB?(0,I.localize)(4,null,(U/oe.GB).toFixed(2)):(0,I.localize)(5,null,(U/oe.TB).toFixed(2))}}e.ByteSize=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;var ae;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(ae=e.Arch||(e.Arch={}));function K(F){return{maxFileSize:F===0?300*oe.MB:16*oe.GB,maxHeapSize:F===0?700*oe.MB:2*700*oe.MB}}e.getPlatformLimits=K}),define(Q[54],Z([0,1,248,138,88,18]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function n(m,p){const t={onUnknownOption:b=>{console.warn((0,R.localize)(0,null,b))},onMultipleValues:(b,S)=>{console.warn((0,R.localize)(1,null,b,S))}},w=(0,M.parseArgs)(m,M.OPTIONS,p?t:void 0);return w.goto&&w._.forEach(b=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,R.localize)(2,null))),w["max-memory"]&&v(parseInt(w["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function I(m){const p=m.findIndex(t=>!/^-/.test(t));if(p>-1)return[...m.slice(0,p),...m.slice(p+1)]}function h(m){let[,...p]=m;process.env.VSCODE_DEV&&(p=I(p)||[]);const t=!E(process.env);return n(p,t)}e.parseMainProcessArgv=h;function f(m){const[,,...p]=m;return n(p,!0)}e.parseCLIProcessArgv=f;function y(m,...p){const t=m.indexOf("--");return t===-1?m.push(...p):m.splice(t,0,...p),m}e.addArg=y;function E(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(Q[91],Z([0,1,43,8,139,23,44,16,3,31,133,54,9]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let t;async function w(S,P,l){return P["force-disable-user-env"]?(S.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(S.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(l)&&!P["force-user-env"]?(S.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(l)?S.trace("resolveShellEnv(): running (--force-user-env)"):S.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=m.Promises.withAsyncBody(async(a,u)=>{const s=new C.CancellationTokenSource,c=setTimeout(()=>{s.dispose(!0),u(new Error((0,M.localize)(0,null)))},p);try{a(await b(S,s.token))}catch(i){!(0,I.isPromiseCanceledError)(i)&&!s.token.isCancellationRequested?u(new Error((0,M.localize)(1,null,(0,n.toErrorMessage)(i)))):a({})}finally{clearTimeout(c),s.dispose()}})),t)}e.resolveShellEnv=w;async function b(S,P){const l=process.env.ELECTRON_RUN_AS_NODE;S.trace("getUnixShellEnvironment#runAsNode",l);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;S.trace("getUnixShellEnvironment#noAttach",a);const u=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(u+"(.*)"+u),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};S.trace("getUnixShellEnvironment#env",c);const i=await(0,y.getSystemShell)(h.OS,c);return S.trace("getUnixShellEnvironment#shell",i),new Promise((r,o)=>{if(P.isCancellationRequested)return o((0,I.canceled)());const d=(0,R.basename)(i);let g,k;const L=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(d)?(g=`& '${process.execPath}' ${L} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,k=["-Login","-Command"]):(g=`'${process.execPath}' ${L} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,d==="tcsh"?k=["-ic"]:k=["-ilc"]),S.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),g);const A=(0,v.spawn)(i,[...k,g],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});P.onCancellationRequested(()=>(A.kill(),o((0,I.canceled)()))),A.on("error",ee=>{S.error("getUnixShellEnvironment#errorChildProcess",(0,n.toErrorMessage)(ee)),o(ee)});const W=[];A.stdout.on("data",ee=>W.push(ee));const V=[];A.stderr.on("data",ee=>V.push(ee)),A.on("close",(ee,oe)=>{const ae=Buffer.concat(W).toString("utf8");S.trace("getUnixShellEnvironment#raw",ae);const K=Buffer.concat(V).toString("utf8");if(K.trim()&&S.trace("getUnixShellEnvironment#stderr",K),ee||oe)return o(new Error((0,M.localize)(2,null,ee,oe)));const F=s.exec(ae),U=F?F[1]:"{}";try{const G=JSON.parse(U);l?G.ELECTRON_RUN_AS_NODE=l:delete G.ELECTRON_RUN_AS_NODE,a?G.ELECTRON_NO_ATTACH_CONSOLE=a:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,S.trace("getUnixShellEnvironment#result",G),r(G)}catch(G){S.error("getUnixShellEnvironment#errorCaught",(0,n.toErrorMessage)(G)),o(G)}})})}}),define(Q[92],Z([0,1,17,16,145,18]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(y,E,m,p,t,w){let b;try{await I(y,E,m,p,t,w)}catch(S){b=S}finally{b&&t.errorTransformer&&(b=t.errorTransformer(b)),typeof b!="undefined"&&m.error(b),m.end()}}e.readFileIntoStream=n;async function I(y,E,m,p,t,w){h(w);const b=await y.open(E,{create:!1});try{h(w);let S=0,P=0,l=t&&typeof t.length=="number"?t.length:void 0,a=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof l=="number"?l:t.bufferSize)),u=t&&typeof t.position=="number"?t.position:0,s=0;do P=await y.read(b,u,a.buffer,s,a.byteLength-s),u+=P,s+=P,S+=P,typeof l=="number"&&(l-=P),s===a.byteLength&&(await m.write(p(a)),a=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof l=="number"?l:t.bufferSize)),s=0);while(P>0&&(typeof l!="number"||l>0)&&h(w)&&f(S,t));if(s>0){let c=s;typeof l=="number"&&(c=Math.min(s,l)),m.write(p(a.slice(0,c)))}}catch(S){throw(0,C.ensureFileSystemProviderError)(S)}finally{await y.close(b)}}function h(y){if(y.isCancellationRequested)throw(0,R.canceled)();return!0}function f(y,E){if(E?.limits){if(typeof E.limits.memory=="number"&&y>E.limits.memory)throw(0,C.createFileSystemProviderError)((0,M.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&y>E.limits.size)throw(0,C.createFileSystemProviderError)((0,M.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[55],Z([0,1,2,3,7,18]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class n extends v.Disposable{constructor(m,p,t){super();this.onFileChanges=m,this.onLogMessage=p,this.verboseLogging=t,this.serviceDisposables=this._register(new v.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new v.DisposableStore;this.serviceDisposables.value=m,this.service=this.createService(m),this.service.setVerboseLogging(this.verboseLogging),m.add(this.service.onDidChangeFile(p=>this.onFileChanges(p))),m.add(this.service.onDidLogMessage(p=>this.onLogMessage(p))),m.add(this.service.onDidError(p=>this.onError(p)))}onError(m){this.restartCounter<n.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.service?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.service?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${m}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=n,n.MAX_RESTARTS=5;class I extends v.Disposable{}e.WatcherService=I;function h(E){return E.map(m=>({type:m.type,resource:M.URI.file(m.path)}))}e.toFileChanges=h;function f(E){const m=new y;for(const p of E)m.processEvent(p);return m.coalesce()}e.coalesceEvents=f;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return R.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const p=this.mapPathToChange.get(this.toKey(m));let t=!1;if(p){const w=p.type,b=m.type;p.path!==m.path&&m.type===2?t=!0:w===1&&b===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(p)):w===2&&b===1?p.type=0:w===1&&b===0||(p.type=b)}else t=!0;t&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],p=[];return Array.from(this.coalesced).filter(t=>t.type!==2?(m.push(t),!1):!0).sort((t,w)=>t.path.length-w.path.length).filter(t=>p.some(w=>(0,C.isParent)(t.path,w,!R.isLinux))?!1:(p.push(t.path),!0)).concat(m)}}}),define(Q[93],Z([0,1,9,2,8,82,21,120,55]),function($,e,v,R,M,C,n,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class f extends R.Disposable{constructor(E,m,p,t){super();this.path=E,this.onDidFilesChange=m,this.onLogMessage=p,this.verboseLogging=t,this.fileChangesDelayer=this._register(new v.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:m}=await n.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(m)try{p=await(0,C.realpath)(p)}catch(t){if(this.onError(t),m.dangling)return}E.isDirectory()?this._register((0,I.watchFolder)(p,(t,w)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,M.join)(this.path,(0,M.basename)(w))})},t=>this.onError(t))):this._register((0,I.watchFile)(p,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,h.coalesceEvents)(m);if(this.verboseLogging)for(const t of p)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=f}),define(Q[173],Z([0,1,10,35,87,55]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class n extends C.WatcherService{constructor(h,f,y){super();this.onDidFilesChange=h,this.onLogMessage=f,this.verboseLogging=y,this.isDisposed=!1,this.startWatching()}startWatching(){const h=this._register(new M.Client(v.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f)))}async setVerboseLogging(h){this.verboseLogging=h,this.isDisposed||await this.service?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}async watch(h){this.isDisposed||await this.service?.watch(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=n}),define(Q[174],Z([0,1,10,35,87,55]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class n extends C.AbstractWatcherService{constructor(h,f,y){super(h,f,y);this.init()}createService(h){const f=h.add(new M.Client(v.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(f.onDidProcessExit(({code:y,signal:E})=>this.onError(`terminated by itself with code ${y}, signal: ${E}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(f.getChannel("watcher")))}}e.FileWatcher=n}),define(Q[75],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...M){this._entries=new Map;for(let[C,n]of M)this.set(C,n)}set(M,C){const n=this._entries.get(M);return this._entries.set(M,C),n}has(M){return this._entries.has(M)}get(M){return this._entries.get(M)}}e.ServiceCollection=v}),define(Q[175],Z([0,1,9,16,73,168,5,75]),function($,e,v,R,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const h=!1;class f extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class y{constructor(t=new I.ServiceCollection,w=!1,b){this._activeInstantiations=new Set,this._services=t,this._strict=w,this._parent=b,this._services.set(n.IInstantiationService,this)}createChild(t){return new y(t,this._strict,this)}invokeFunction(t,...w){let b=m.traceInvocation(t),S=!1;try{return t({get:l=>{if(S)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(l,b);if(!a)throw new Error(`[invokeFunction] unknown service '${l}'`);return a}},...w)}finally{S=!0,b.stop()}}createInstance(t,...w){let b,S;return t instanceof M.SyncDescriptor?(b=m.traceCreation(t.ctor),S=this._createInstance(t.ctor,t.staticArguments.concat(w),b)):(b=m.traceCreation(t),S=this._createInstance(t,w,b)),b.stop(),S}_createInstance(t,w=[],b){let S=n._util.getServiceDependencies(t).sort((a,u)=>a.index-u.index),P=[];for(const a of S){let u=this._getOrCreateServiceInstance(a.id,b);if(!u&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);P.push(u)}let l=S.length>0?S[0].index:w.length;if(w.length!==l){console.warn(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${w.length} static arguments`);let a=l-w.length;a>0?w=w.concat(new Array(a)):w=w.slice(0,l)}return new t(...[...w,...P])}_setServiceInstance(t,w){if(this._services.get(t)instanceof M.SyncDescriptor)this._services.set(t,w);else if(this._parent)this._parent._setServiceInstance(t,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let w=this._services.get(t);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):w}_getOrCreateServiceInstance(t,w){let b=this._getServiceInstanceOrDescriptor(t);return b instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,b,w.branch(t,!0)):(w.branch(t,!1),b)}_safeCreateAndCacheServiceInstance(t,w,b){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,w,b)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,w,b){const S=new C.Graph(a=>a.id.toString());let P=0;const l=[{id:t,desc:w,_trace:b}];for(;l.length;){const a=l.pop();if(S.lookupOrInsertNode(a),P++>1e3)throw new f(S);for(let u of n._util.getServiceDependencies(a.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(u.id);if(!s&&!u.optional&&console.warn(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`),s instanceof M.SyncDescriptor){const c={id:u.id,desc:s,_trace:a._trace.branch(u.id,!0)};S.insertEdge(a,c),l.push(c)}}}for(;;){const a=S.roots();if(a.length===0){if(!S.isEmpty())throw new f(S);break}for(const{data:u}of a){if(this._getServiceInstanceOrDescriptor(u.id)instanceof M.SyncDescriptor){const c=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,c)}S.removeNode(u)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,w,b=[],S,P){if(this._services.get(t)instanceof M.SyncDescriptor)return this._createServiceInstance(w,b,S,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,w,b,S,P);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(t,w=[],b,S){if(b){const P=new v.IdleValue(()=>this._createInstance(t,w,S));return new Proxy(Object.create(null),{get(l,a){if(a in l)return l[a];let u=P.value,s=u[a];return typeof s!="function"||(s=s.bind(u),l[a]=s),s},set(l,a,u){return P.value[a]=u,!0}})}else return this._createInstance(t,w,S)}}e.InstantiationService=y;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class m{constructor(t,w){this.type=t,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return h?new m(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(t){return h?new m(0,t.name):m._None}branch(t,w){let b=new m(2,t.toString());return this._dep.push([t,w,b]),b}stop(){let t=Date.now()-this._start;m._totals+=t;let w=!1;function b(P,l){let a=[],u=new Array(P+1).join("	");for(const[s,c,i]of l._dep)if(c&&i){w=!0,a.push(`${u}CREATES -> ${s}`);let r=b(P+1,i);r&&a.push(r)}else a.push(`${u}uses -> ${s}`);return a.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(t>2||w)&&console.log(S.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Q[176],Z([0,1,16,131,59]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends M.ResolvedKeybinding{constructor(I,h){super();if(h.length===0)throw(0,v.illegalArgument)("parts");this._os=I,this._parts=h}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new M.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=C}),define(Q[177],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class v{constructor(C,n,I,h,f,y,E){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?R(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=R(C.getSingleModifierDispatchParts())),this.bubble=n?n.charCodeAt(0)===94:!1,this.command=this.bubble?n.substr(1):n,this.commandArgs=I,this.when=h,this.isDefault=f,this.extensionId=y,this.isBuiltinExtension=E}}e.ResolvedKeybindingItem=v;function R(M){let C=[];for(let n=0,I=M.length;n<I;n++){const h=M[n];if(!h)return C;C.push(h)}return C}e.removeElementsAfterNulls=R}),define(Q[178],Z([0,1,79,59,176,177]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class n extends M.BaseResolvedKeybinding{constructor(h,f){super(f,h.parts)}_keyCodeToUILabel(h){if(this._os===2)switch(h){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(h)}_getLabel(h){return h.isDuplicateModifierCase()?"":this._keyCodeToUILabel(h.keyCode)}_getAriaLabel(h){return h.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(h.keyCode)}_getElectronAccelerator(h){return v.KeyCodeUtils.toElectronAccelerator(h.keyCode)}_getUserSettingsLabel(h){if(h.isDuplicateModifierCase())return"";const f=v.KeyCodeUtils.toUserSettingsUS(h.keyCode);return f&&f.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(h){return n.getDispatchStr(h)}static getDispatchStr(h){if(h.isModifierKey())return null;let f="";return h.ctrlKey&&(f+="ctrl+"),h.shiftKey&&(f+="shift+"),h.altKey&&(f+="alt+"),h.metaKey&&(f+="meta+"),f+=v.KeyCodeUtils.toString(h.keyCode),f}_getSingleModifierDispatchPart(h){return h.keyCode===5&&!h.shiftKey&&!h.altKey&&!h.metaKey?"ctrl":h.keyCode===4&&!h.ctrlKey&&!h.altKey&&!h.metaKey?"shift":h.keyCode===6&&!h.ctrlKey&&!h.shiftKey&&!h.metaKey?"alt":h.keyCode===57&&!h.ctrlKey&&!h.shiftKey&&!h.altKey?"meta":null}static _scanCodeToKeyCode(h){const f=v.IMMUTABLE_CODE_TO_KEY_CODE[h];if(f!==-1)return f;switch(h){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(h){if(!h)return null;if(h instanceof R.SimpleKeybinding)return h;const f=this._scanCodeToKeyCode(h.scanCode);return f===0?null:new R.SimpleKeybinding(h.ctrlKey,h.shiftKey,h.altKey,h.metaKey,f)}static resolveUserBinding(h,f){const y=(0,C.removeElementsAfterNulls)(h.map(E=>this._resolveSimpleUserBinding(E)));return y.length>0?[new n(new R.ChordKeybinding(y),f)]:[]}}e.USLayoutResolvedKeybinding=n}),define(Q[179],Z([0,1,9]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(M,C){if(M.length===0)return Promise.resolve(!1);const n=[];let I=!1;for(let h of M){if(h===!0)return Promise.resolve(!0);(0,v.isThenable)(h)&&n.push(h.then(f=>{f&&(I=!0)},f=>{C(f),I=!0}))}return v.Promises.settled(n).then(()=>I)}e.handleVetos=R}),define(Q[6],Z([0,1,44,4,2,3,5]),function($,e,v,R,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,n.createDecorator)("logService"),e.ILoggerService=(0,n.createDecorator)("loggerService");function I(){return new Date().toISOString()}var h;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function f(c,i,r){switch(i){case h.Trace:c.trace(r);break;case h.Debug:c.debug(r);break;case h.Info:c.info(r);break;case h.Warning:c.warn(r);break;case h.Error:c.error(r);break;case h.Critical:c.critical(r);break;default:throw new Error("Invalid log level")}}e.log=f;function y(c){let i="";for(let r=0;r<c.length;r++){let o=c[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(d){}i+=(r>0?" ":"")+o}return i}e.format=y;class E extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class m extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...r){this.checkLogLevel(h.Trace)&&this.log(h.Trace,y([i,...r]))}debug(i,...r){this.checkLogLevel(h.Debug)&&this.log(h.Debug,y([i,...r]))}info(i,...r){this.checkLogLevel(h.Info)&&this.log(h.Info,y([i,...r]))}warn(i,...r){this.checkLogLevel(h.Warning)&&this.log(h.Warning,y([i,...r]))}error(i,...r){if(this.checkLogLevel(h.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(h.Error,y(o))}else this.log(h.Error,y([i,...r]))}critical(i,...r){this.checkLogLevel(h.Critical)&&this.log(h.Critical,y([i,...r]))}flush(){}}e.AbstractMessageLogger=m;class p extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!C.isWindows}trace(i,...r){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...r):console.log(`[main ${I()}]`,i,...r))}debug(i,...r){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...r):console.log(`[main ${I()}]`,i,...r))}info(i,...r){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...r):console.log(`[main ${I()}]`,i,...r))}warn(i,...r){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...r):console.warn(`[main ${I()}]`,i,...r))}error(i,...r){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...r):console.error(`[main ${I()}]`,i,...r))}critical(i,...r){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...r):console.error(`[main ${I()}]`,i,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class t extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...r){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",i,...r)}debug(i,...r){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...r)}info(i,...r){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",i,...r)}warn(i,...r){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",i,...r)}error(i,...r){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",i,...r)}critical(i,...r){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...r)}dispose(){}flush(){}}e.ConsoleLogger=t;class w extends E{constructor(i,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(r)}trace(i,...r){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(i),...r])}debug(i,...r){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(i),...r])}info(i,...r){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(i),...r])}warn(i,...r){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(i),...r])}error(i,...r){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(i),...r])}critical(i,...r){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(i),...r])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class b extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const r of this.logServices)r.setLevel(i);super.setLevel(i)}trace(i,...r){for(const o of this.logServices)o.trace(i,...r)}debug(i,...r){for(const o of this.logServices)o.debug(i,...r)}info(i,...r){for(const o of this.logServices)o.info(i,...r)}warn(i,...r){for(const o of this.logServices)o.warn(i,...r)}error(i,...r){for(const o of this.logServices)o.error(i,...r)}critical(i,...r){for(const o of this.logServices)o.critical(i,...r)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=b;class S extends M.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...r){this.logger.trace(i,...r)}debug(i,...r){this.logger.debug(i,...r)}info(i,...r){this.logger.info(i,...r)}warn(i,...r){this.logger.warn(i,...r)}error(i,...r){this.logger.error(i,...r)}critical(i,...r){this.logger.critical(i,...r)}flush(){this.logger.flush()}}e.LogService=S;class P extends M.Disposable{constructor(i,r){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,r){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,r?.always?h.Trace:this.logLevel,r),this.loggers.set(i.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class l{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(i){}getLevel(){return h.Info}trace(i,...r){}debug(i,...r){}info(i,...r){}warn(i,...r){}error(i,...r){}critical(i,...r){}dispose(){}flush(){}}e.NullLogService=l;function a(c){if(c.verbose)return h.Trace;if(typeof c.logLevel=="string"){const i=u(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function u(c){switch(c){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=u;function s(c){switch(c){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=s});var te=this&&this.__param||function($,e){return function(v,R){e(v,R,$)}};define(Q[180],Z([0,1,9,17,39,78,48,18,5,6]),function($,e,v,R,M,C,n,I,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var y;(function(m){m.ERROR_INVALID_FILE="ERROR_INVALID_FILE",m.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(y=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,h.createDecorator)(e.UserConfigurationFileServiceId);let E=class{constructor(p,t,w){this.environmentService=p,this.fileService=t,this.logService=w,this.queue=new v.Queue}async updateSettings(p,t){return this.queue.queue(()=>this.doWrite(p,t))}async doWrite(p,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),p);const{value:w,mtime:b,etag:S}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let P=w.toString();const l=[];if((0,M.parse)(P,l,{allowTrailingComma:!0,allowEmptyContent:!0}),l.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(p,P,t)[0];if(a){P=P.substring(0,a.offset)+a.content+P.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(P),{etag:S,mtime:b})}catch(u){if(u.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(p,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,p,t)})}getEdits({value:p,path:t},w,b){return t.length?(0,C.setProperty)(w,t,p,b):[{content:JSON.stringify(p,null,b.insertSpaces&&b.tabSize?" ".repeat(b.tabSize):"	"),length:w.length,offset:0}]}};E=ge([te(0,n.IEnvironmentService),te(1,I.IFileService),te(2,f.ILogService)],E),e.UserConfigurationFileService=E}),define(Q[181],Z([0,1,30,9,16,4,2,8,55,6]),function($,e,v,R,M,C,n,I,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends n.Disposable{constructor(m){super();this.logService=m,this._onDidErrorOccur=this._register(new C.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(m,p){return p.recursive?this.watchRecursive(m,p):this.watchNonRecursive(m)}watchRecursive(m,p){const t={path:this.toFilePath(m),excludes:p.excludes},w=(0,v.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(m=>(0,M.onUnexpectedError)(m))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(m,p){return m.watch(p)}watchNonRecursive(m){const p=this.createNonRecursiveWatcher(this.toFilePath(m),w=>this._onDidChangeFile.fire((0,h.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===f.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return(0,n.combinedDisposable)(p,t)}onWatcherLogMessage(m){m.type==="error"&&this._onDidErrorOccur.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(Q[182],Z([0,1,30,9,17,23,4,69,2,40,10,63,15,60,143,18,92,6]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=class Ye extends h.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new n.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new n.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new n.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new n.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new n.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new n.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new n.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new R.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new w.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new R.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new w.FileChangesEvent(u,!0)))),this.watchedResources=f.TernarySearchTree.forUris(u=>{const s=this.getProvider(u.scheme);return s?!this.isPathCaseSensitive(s):!1}),this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(a,u){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:u});const s=new h.DisposableStore;return s.add(u.onDidChangeFile(c=>this.onDidChangeFile(c,this.isPathCaseSensitive(u)))),s.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:a}))),typeof u.onDidErrorOccur=="function"&&s.add(u.onDidErrorOccur(c=>this._onError.fire(new Error(c)))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:u}),this.provider.delete(a),(0,h.dispose)(s)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(s){u.push(s)}}),!this.provider.has(a)&&await R.Promises.settled(u)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,u){const s=this.provider.get(a.scheme);return!!(s&&s.capabilities&u)}listCapabilities(){return I.Iterable.map(this.provider,([a,u])=>({scheme:a,capabilities:u.capabilities}))}async withProvider(a){if(!(0,m.isAbsolutePath)(a))throw new w.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const u=this.provider.get(a.scheme);if(!u){const s=new Error;throw s.name="ENOPRO",s.message=(0,t.localize)(1,null,a.toString()),s}return u}async withReadProvider(a){const u=await this.withProvider(a);if((0,w.hasOpenReadWriteCloseCapability)(u)||(0,w.hasReadWriteCapability)(u)||(0,w.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const u=await this.withProvider(a);if((0,w.hasOpenReadWriteCloseCapability)(u)||(0,w.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,u){try{return await this.doResolveFile(a,u)}catch(s){throw(0,w.toFileSystemProviderErrorCode)(s)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,w.ensureFileSystemProviderError)(s)}}async doResolveFile(a,u){const s=await this.withProvider(a),c=this.isPathCaseSensitive(s),i=u?.resolveTo,r=u?.resolveSingleChildDescendants,o=u?.resolveMetadata,d=await s.stat(a);let g;return this.toFileStat(s,a,d,void 0,!!o,(k,L)=>(g||(g=f.TernarySearchTree.forUris(()=>!c),g.set(a,!0),i&&g.fill(!0,i)),g.get(k.resource)||g.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&r?L===1:!1))}async toFileStat(a,u,s,c,i,r){const{providerExtUri:o}=this.getExtUri(a),d={resource:u,name:o.basename(u),isFile:(s.type&w.FileType.File)!=0,isDirectory:(s.type&w.FileType.Directory)!=0,isSymbolicLink:(s.type&w.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&w.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,w.etag)({mtime:s.mtime,size:s.size})};if(d.isDirectory&&r(d,c)){try{const g=await a.readdir(u),k=await R.Promises.settled(g.map(async([L,A])=>{try{const W=o.joinPath(u,L),V=i?await a.stat(W):{type:A};return await this.toFileStat(a,W,V,g.length,i,r)}catch(W){return this.logService.trace(W),null}}));d.children=(0,v.coalesce)(k)}catch(g){this.logService.trace(g),d.children=[]}return d}return d}async resolveAll(a){return R.Promises.settled(a.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async exists(a){const u=await this.withProvider(a);try{return!!await u.stat(a)}catch(s){return!1}}async canCreateFile(a,u){try{await this.doValidateCreateFile(a,u)}catch(s){return s}return!0}async doValidateCreateFile(a,u){if(!u?.overwrite&&await this.exists(a))throw new w.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,u)}async createFile(a,u=M.VSBuffer.fromString(""),s){await this.doValidateCreateFile(a,s);const c=await this.writeFile(a,u);return this._onDidRunOperation.fire(new w.FileOperationEvent(a,0,c)),c}async writeFile(a,u,s){const c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:i}=this.getExtUri(c);try{await this.validateWriteFile(c,a,s)||await this.mkdirp(c,i.dirname(a));let o;if((0,w.hasReadWriteCapability)(c)&&!(u instanceof M.VSBuffer))if((0,p.isReadableStream)(u)){const d=await(0,p.peekStream)(u,3);d.ended?o=M.VSBuffer.concat(d.buffer):o=d}else o=(0,p.peekReadable)(u,d=>M.VSBuffer.concat(d),3);else o=u;!(0,w.hasOpenReadWriteCloseCapability)(c)||(0,w.hasReadWriteCapability)(c)&&o instanceof M.VSBuffer?await this.doWriteUnbuffered(c,a,s,o):await this.doWriteBuffered(c,a,s,o instanceof M.VSBuffer?(0,M.bufferToReadable)(o):o)}catch(r){throw new w.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,w.ensureFileSystemProviderError)(r).toString()),(0,w.toFileOperationResult)(r),s)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,u,s){if(!!s?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(u)));let i;try{i=await a.stat(u)}catch(r){return}if((i.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,t.localize)(6,null,this.resourceForError(u)),0,s);if(this.throwIfFileIsReadonly(u,i),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==w.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&s.mtime<i.mtime&&s.etag!==(0,w.etag)({mtime:s.mtime,size:i.size}))throw new w.FileOperationError((0,t.localize)(7,null),3,s);return i}async readFile(a,u){const s=await this.withReadProvider(a);return u?.atomic?this.doReadFileAtomic(s,a,u):this.doReadFile(s,a,u)}async doReadFileAtomic(a,u,s){return new Promise((c,i)=>{this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(a,u,s);c(r)}catch(r){i(r)}})})}async doReadFile(a,u,s){const c=await this.doReadFileStream(a,u,{...s,preferUnbuffered:!0});return{...c,value:await(0,M.streamToBuffer)(c.value)}}async readFileStream(a,u){const s=await this.withReadProvider(a);return this.doReadFileStream(s,a,u)}async doReadFileStream(a,u,s){const c=new C.CancellationTokenSource,i=this.validateReadFile(u,s).then(o=>o,o=>{throw c.cancel(),o});let r;try{return typeof s?.etag=="string"&&s.etag!==w.ETAG_DISABLED&&await i,!((0,w.hasOpenReadWriteCloseCapability)(a)||(0,w.hasFileReadStreamCapability)(a))||(0,w.hasReadWriteCapability)(a)&&s?.preferUnbuffered?r=this.readFileUnbuffered(a,u,s):(0,w.hasFileReadStreamCapability)(a)?r=this.readFileStreamed(a,u,c.token,s):r=this.readFileBuffered(a,u,c.token,s),{...await i,value:r}}catch(o){r&&await(0,p.consumeStream)(r);const d=(0,t.localize)(8,null,this.resourceForError(u),(0,w.ensureFileSystemProviderError)(o).toString());throw o instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(d,o.stat,s):new w.FileOperationError(d,(0,w.toFileOperationResult)(o),s)}}readFileStreamed(a,u,s,c=Object.create(null)){const i=a.readFileStream(u,c,s);return(0,p.transform)(i,{data:r=>r instanceof M.VSBuffer?r:M.VSBuffer.wrap(r),error:r=>new w.FileOperationError((0,t.localize)(9,null,this.resourceForError(u),(0,w.ensureFileSystemProviderError)(r).toString()),(0,w.toFileOperationResult)(r),c)},r=>M.VSBuffer.concat(r))}readFileBuffered(a,u,s,c=Object.create(null)){const i=(0,M.newWriteableBufferStream)();return(0,b.readFileIntoStream)(a,u,i,r=>r,{...c,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new w.FileOperationError((0,t.localize)(10,null,this.resourceForError(u),(0,w.ensureFileSystemProviderError)(r).toString()),(0,w.toFileOperationResult)(r),c)},s),i}readFileUnbuffered(a,u,s){const c=(0,p.newWriteableStream)(i=>M.VSBuffer.concat(i));return(async()=>{try{let i=await a.readFile(u);typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.validateReadFileLimits(u,i.byteLength,s),c.end(M.VSBuffer.wrap(i))}catch(i){c.error(i),c.end()}})(),c}async validateReadFile(a,u){const s=await this.resolve(a,{resolveMetadata:!0});if(s.isDirectory)throw new w.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,u);if(typeof u?.etag=="string"&&u.etag!==w.ETAG_DISABLED&&u.etag===s.etag)throw new w.NotModifiedSinceFileOperationError((0,t.localize)(12,null),s,u);return this.validateReadFileLimits(a,s.size,u),s}validateReadFileLimits(a,u,s){if(s?.limits){let c;if(typeof s.limits.memory=="number"&&u>s.limits.memory&&(c=9),typeof s.limits.size=="number"&&u>s.limits.size&&(c=7),typeof c=="number")throw new w.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),c)}}async canMove(a,u,s){return this.doCanMoveCopy(a,u,"move",s)}async canCopy(a,u,s){return this.doCanMoveCopy(a,u,"copy",s)}async doCanMoveCopy(a,u,s,c){if(a.toString()!==u.toString())try{const i=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(i,a,r,u,s,c)}catch(i){return i}return!0}async move(a,u,s){const c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(c,a,i,u,"move",!!s),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,r==="move"?2:3,o)),o}async copy(a,u,s){const c=await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(c,a,i,u,"copy",!!s),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,r==="copy"?3:2,o)),o}async doMoveCopy(a,u,s,c,i,r){if(u.toString()===c.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(a,u,s,c,i,r);if(o&&!d&&r&&await this.del(c,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(c)),i==="copy"){if(a===s&&(0,w.hasFileFolderCopyCapability)(a))await a.copy(u,c,{overwrite:r});else{const g=await this.resolve(u);g.isDirectory?await this.doCopyFolder(a,g,s,c):await this.doCopyFile(a,u,s,c)}return i}else return a===s?(await a.rename(u,c,{overwrite:r}),i):(await this.doMoveCopy(a,u,s,c,"copy",r),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(a,u,s,c){if((0,w.hasOpenReadWriteCloseCapability)(a)&&(0,w.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(a,u,s,c);if((0,w.hasOpenReadWriteCloseCapability)(a)&&(0,w.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(a,u,s,c);if((0,w.hasReadWriteCapability)(a)&&(0,w.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(a,u,s,c);if((0,w.hasReadWriteCapability)(a)&&(0,w.hasReadWriteCapability)(s))return this.doPipeUnbuffered(a,u,s,c)}async doCopyFolder(a,u,s,c){await s.mkdir(c),Array.isArray(u.children)&&await R.Promises.settled(u.children.map(async i=>{const r=this.getExtUri(s).providerExtUri.joinPath(c,i.name);return i.isDirectory?this.doCopyFolder(a,await this.resolve(i.resource),s,r):this.doCopyFile(a,i.resource,s,r)}))}async doValidateMoveCopy(a,u,s,c,i,r){let o=!1;if(a===s){const{providerExtUri:g,isPathCaseSensitive:k}=this.getExtUri(a);if(k||(o=g.isEqual(u,c)),o&&i==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(u),this.resourceForError(c)));if(!o&&g.isEqualOrParent(c,u))throw new Error((0,t.localize)(15,null,this.resourceForError(u),this.resourceForError(c)))}const d=await this.exists(c);if(d&&!o){if(!r)throw new w.FileOperationError((0,t.localize)(16,null,this.resourceForError(u),this.resourceForError(c)),4);if(a===s){const{providerExtUri:g}=this.getExtUri(a);if(g.isEqualOrParent(u,c))throw new Error((0,t.localize)(17,null,this.resourceForError(u),this.resourceForError(c)))}}return{exists:d,isSameResourceWithDifferentPathCase:o}}getExtUri(a){const u=this.isPathCaseSensitive(a);return{providerExtUri:u?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(u,a);const s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,0,s)),s}async mkdirp(a,u){const s=[],{providerExtUri:c}=this.getExtUri(a);for(;!c.isEqual(u,c.dirname(u));)try{if(((await a.stat(u)).type&w.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(u)));break}catch(i){if((0,w.toFileSystemProviderErrorCode)(i)!==w.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(c.basename(u)),u=c.dirname(u)}for(let i=s.length-1;i>=0;i--){u=c.joinPath(u,s[i]);try{await a.mkdir(u)}catch(r){if((0,w.toFileSystemProviderErrorCode)(r)!==w.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(a,u){try{await this.doValidateDelete(a,u)}catch(s){return s}return!0}async doValidateDelete(a,u){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!u?.useTrash&&!(s.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let i;try{i=await s.stat(a)}catch(o){}if(i)this.throwIfFileIsReadonly(a,i);else throw new w.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!u?.recursive){const o=await this.resolve(a);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return s}async del(a,u){const s=await this.doValidateDelete(a,u),c=!!u?.useTrash,i=!!u?.recursive;await s.delete(a,{recursive:i,useTrash:c}),this._onDidRunOperation.fire(new w.FileOperationEvent(a,1))}onDidChangeFile(a,u){this._onDidChangeFilesRaw.fire({changes:a});let s,c;{for(const i of a)this.watchedResources.has(i.resource)?(s||(s=[]),s.push(i)):(c||(c=[]),c.push(i));s&&this._onDidFilesChange.fire(new w.FileChangesEvent(s,!u))}if(c){const i=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(c)&&Ye.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${c[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,u={recursive:!1,excludes:[]}){const s=new h.DisposableStore;let c=!1,i=()=>{c=!0};return s.add((0,h.toDisposable)(()=>i())),this.doWatch(a,u).then(r=>{c?(0,h.dispose)(r):i=()=>(0,h.dispose)(r)},r=>this.logService.error(r)),u.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),s.add((0,h.toDisposable)(()=>{const r=this.watchedResources.get(a);typeof r=="number"&&(r<=1?this.watchedResources.delete(a):this.watchedResources.set(a,r-1))}))),s}async doWatch(a,u){const s=await this.withProvider(a),c=this.toWatchKey(s,a,u);let i=this.activeWatchers.get(c);return i||(i={count:0,disposable:s.watch(a,u)},this.activeWatchers.set(c,i)),i.count+=1,(0,h.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,h.dispose)(i.disposable),this.activeWatchers.delete(c)))})}toWatchKey(a,u,s){const{providerExtUri:c}=this.getExtUri(a);return[c.getComparisonKey(u),String(s.recursive),s.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,h.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,u,s,c){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{const i=await a.open(u,{create:!0,unlock:s?.unlock??!1});try{(0,p.isReadableStream)(c)||(0,p.isReadableBufferedStream)(c)?await this.doWriteStreamBufferedQueued(a,i,c):await this.doWriteReadableBufferedQueued(a,i,c)}catch(r){throw(0,w.ensureFileSystemProviderError)(r)}finally{await a.close(i)}})}async doWriteStreamBufferedQueued(a,u,s){let c=0,i;if((0,p.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=M.VSBuffer.concat(s.buffer);await this.doWriteBuffer(a,u,r,r.byteLength,c,0),c+=r.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((r,o)=>{(0,p.listenStream)(i,{onData:async d=>{i.pause();try{await this.doWriteBuffer(a,u,d,d.byteLength,c,0)}catch(g){return o(g)}c+=d.byteLength,setTimeout(()=>i.resume())},onError:d=>o(d),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(a,u,s){let c=0,i;for(;(i=s.read())!==null;)await this.doWriteBuffer(a,u,i,i.byteLength,c,0),c+=i.byteLength}async doWriteBuffer(a,u,s,c,i,r){let o=0;for(;o<c;)o+=await a.write(u,i+o,s.buffer,r+o,c-o)}async doWriteUnbuffered(a,u,s,c){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,u,s,c))}async doWriteUnbufferedQueued(a,u,s,c){let i;c instanceof M.VSBuffer?i=c:(0,p.isReadableStream)(c)?i=await(0,M.streamToBuffer)(c):(0,p.isReadableBufferedStream)(c)?i=await(0,M.bufferedStreamToBuffer)(c):i=(0,M.readableToBuffer)(c),await a.writeFile(u,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(a,u,s,c){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,u,s,c))}async doPipeBufferedQueued(a,u,s,c){let i,r;try{i=await a.open(u,{create:!1}),r=await s.open(c,{create:!0,unlock:!1});const o=M.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,g=0,k=0;do k=await a.read(i,d,o.buffer,g,o.byteLength-g),await this.doWriteBuffer(s,r,o,k,d,g),d+=k,g+=k,g===o.byteLength&&(g=0);while(k>0)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await R.Promises.settled([typeof i=="number"?a.close(i):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async doPipeUnbuffered(a,u,s,c){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,u,s,c))}async doPipeUnbufferedQueued(a,u,s,c){return s.writeFile(c,await a.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,u,s,c){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,u,s,c))}async doPipeUnbufferedToBufferedQueued(a,u,s,c){const i=await s.open(c,{create:!0,unlock:!1});try{const r=await a.readFile(u);await this.doWriteBuffer(s,i,M.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,w.ensureFileSystemProviderError)(r)}finally{await s.close(i)}}async doPipeBufferedToUnbuffered(a,u,s,c){const i=await(0,M.streamToBuffer)(this.readFileBuffered(a,u,C.CancellationToken.None));await this.doWriteUnbuffered(s,c,void 0,i)}throwIfFileSystemIsReadonly(a,u){if(a.capabilities&2048)throw new w.FileOperationError((0,t.localize)(22,null,this.resourceForError(u)),6);return a}throwIfFileIsReadonly(a,u){if((u.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===y.Schemas.file?a.fsPath:a.toString(!0)}};P.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},P=ge([te(0,S.ILogService)],P),e.FileService=P}),define(Q[183],Z([0,1,14,146,3,7,18,93,8,2,55,6,167,112]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends m.AbstractDiskFileSystemProviderChannel{constructor(S,P){super(S,P)}getUriTransformer(S){return p.DefaultURITransformer}transformIncoming(S,P){return C.URI.revive(P)}async delete(S,P,l){if(!l.useTrash)return super.delete(S,P,l);const a=this.transformIncoming(S,P),u=(0,h.normalize)(a.fsPath);try{await v.shell.trashItem(u)}catch(s){throw(0,n.createFileSystemProviderError)(M.isWindows?(0,R.localize)(0,null,(0,h.basename)(u)):(0,R.localize)(1,null,(0,h.basename)(u)),n.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(S,P){return new w(P,this.logService)}}e.DiskFileSystemProviderChannel=t;class w extends f.Disposable{constructor(S,P){super();this.sessionEmitter=S,this.logService=P,this.watcherRequests=new Map}watch(S,P,l){if(l.recursive)throw(0,n.createFileSystemProviderError)("Recursive watcher is not supported from main process",n.FileSystemProviderErrorCode.Unavailable);const a=new f.DisposableStore;this.watcherRequests.set(S,a),a.add((0,f.toDisposable)(()=>this.watcherRequests.delete(S)));const u=a.add(new I.FileWatcher((0,h.normalize)(P.fsPath),s=>this.sessionEmitter.fire((0,y.toFileChanges)(s)),s=>this.onWatcherLogMessage(s),this.logService.getLevel()===E.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{u.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})),a}onWatcherLogMessage(S){S.type==="error"&&this.sessionEmitter.fire(S.message),this.logService[S.type](S.message)}dispose(){super.dispose(),this.watcherRequests.forEach(S=>(0,f.dispose)(S)),this.watcherRequests.clear()}}}),define(Q[94],Z([0,1,28,249,9,17,4,32,8,3,15,60,21,147,18,92,93,173,174,181,44]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(v)}catch(s){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(s)}`)}})();class u extends l.AbstractDiskFileSystemProvider{constructor(c,i){super(c);this.options=i,this.onDidChangeCapabilities=n.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,f.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(c){try{const{stat:i,symbolicLink:r}=await m.SymlinkSupport.stat(this.toFilePath(c));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(c){try{const i=await m.Promises.readdir(this.toFilePath(c),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async o=>{try{let d;o.isSymbolicLink()?d=(await this.stat((0,y.joinPath)(c,o.name))).type:d=this.toType(o),r.push([o.name,d])}catch(d){this.logService.trace(d)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(c,i){let r;return i?.dangling?r=t.FileType.Unknown:c.isFile()?r=t.FileType.File:c.isDirectory()?r=t.FileType.Directory:r=t.FileType.Unknown,i&&(r|=t.FileType.SymbolicLink),r}async readFile(c){try{const i=this.toFilePath(c);return await m.Promises.readFile(i)}catch(i){throw this.toFileSystemProviderError(i)}}readFileStream(c,i,r){const o=(0,E.newWriteableStream)(d=>C.VSBuffer.concat(d.map(g=>C.VSBuffer.wrap(g))).buffer);return(0,w.readFileIntoStream)(this,c,o,d=>d.buffer,{...i,bufferSize:256*1024},r),o}async writeFile(c,i,r){let o;try{const d=this.toFilePath(c);if(!r.create||!r.overwrite){if(await m.Promises.exists(d)){if(!r.overwrite)throw(0,t.createFileSystemProviderError)((0,p.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,t.createFileSystemProviderError)((0,p.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(c,{create:!0,unlock:r.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(c,d)}finally{typeof o=="number"&&await this.close(o)}}async open(c,i){try{const r=this.toFilePath(c);if((0,t.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:g}=await m.SymlinkSupport.stat(r);g.mode&128||await m.Promises.chmod(r,g.mode|128)}catch(g){this.logService.trace(g)}let o;if((0,t.isFileOpenForWriteOptions)(i)){if(f.isWindows)try{await m.Promises.truncate(r,0),o="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}o||(o="w")}else o="r";const d=await m.Promises.open(r,o);return this.mapHandleToPos.set(d,0),(0,t.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(d,c),d}catch(r){throw(0,t.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(c,r):this.toFileSystemProviderError(r)}}async close(c){try{if(this.mapHandleToPos.delete(c),this.writeHandles.delete(c)&&this.canFlush)try{await m.Promises.fdatasync(c)}catch(i){this.canFlush=!1,this.logService.error(i)}return await m.Promises.close(c)}catch(i){throw this.toFileSystemProviderError(i)}}async read(c,i,r,o,d){const g=this.normalizePos(c,i);let k=null;try{const L=await m.Promises.read(c,r,o,d,g);return typeof L=="number"?k=L:k=L.bytesRead,k}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(c,g,k)}}normalizePos(c,i){return i===this.mapHandleToPos.get(c)?null:i}updatePos(c,i,r){const o=this.mapHandleToPos.get(c);typeof o=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(c,o+r):this.mapHandleToPos.delete(c)))}async write(c,i,r,o,d){return(0,M.retry)(()=>this.doWrite(c,i,r,o,d),100,3)}async doWrite(c,i,r,o,d){const g=this.normalizePos(c,i);let k=null;try{const L=await m.Promises.write(c,r,o,d,g);return typeof L=="number"?k=L:k=L.bytesWritten,k}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(c),L)}finally{this.updatePos(c,g,k)}}async mkdir(c){try{await m.Promises.mkdir(this.toFilePath(c))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(c,i){try{const r=this.toFilePath(c);await this.doDelete(r,i)}catch(r){throw this.toFileSystemProviderError(r)}}async doDelete(c,i){i.recursive?await m.Promises.rm(c,m.RimRafMode.MOVE):await m.Promises.unlink(c)}async rename(c,i,r){const o=this.toFilePath(c),d=this.toFilePath(i);if(o!==d)try{await this.validateTargetDeleted(c,i,"move",r.overwrite),await m.Promises.move(o,d)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,p.localize)(2,null,(0,h.basename)(o),(0,h.basename)((0,h.dirname)(d)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(c,i,r){const o=this.toFilePath(c),d=this.toFilePath(i);if(o!==d)try{await this.validateTargetDeleted(c,i,"copy",r.overwrite),await m.Promises.copy(o,d,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,p.localize)(3,null,(0,h.basename)(o),(0,h.basename)((0,h.dirname)(d)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(c,i,r,o){const d=this.toFilePath(c),g=this.toFilePath(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,I.isEqual)(d,g,!0)),k&&r==="copy")throw(0,t.createFileSystemProviderError)((0,p.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!k&&await m.Promises.exists(g)){if(!o)throw(0,t.createFileSystemProviderError)((0,p.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(c,i,r){let o,d=!1;return this.options?.watcher?.usePolling?d=!1:d=this.options?.legacyWatcher==="on",d?o=S.FileWatcher:o=P.FileWatcher,new o(g=>c(g),g=>i(g),r,this.options?.watcher)}doWatch(c,i){const r=this.options?.watcher?.usePolling;if(r===!0)for(const o of i)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(r))for(const o of i)r.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(c,i)}createNonRecursiveWatcher(c,i,r,o){return new b.FileWatcher(c,d=>i(d),d=>r(d),o)}toFileSystemProviderError(c){if(c instanceof t.FileSystemProviderError)return c;let i;switch(c.code){case"ENOENT":i=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=t.FileSystemProviderErrorCode.NoPermissions;break;default:i=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(c,i)}async toFileSystemProviderWriteError(c,i){let r=this.toFileSystemProviderError(i);if(c&&r.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await m.SymlinkSupport.stat(this.toFilePath(c));o.mode&128||(r=(0,t.createFileSystemProviderError)(i,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=u}),define(Q[95],Z([0,1,6]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(C,n){switch(n){case v.LogLevel.Trace:return C.trace;case v.LogLevel.Debug:return C.debug;case v.LogLevel.Info:return C.info;case v.LogLevel.Warning:return C.warn;case v.LogLevel.Error:return C.error;case v.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class M extends v.AbstractLogger{constructor(n=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(n),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(n){this._logger=n;for(const{level:I,args:h}of this.buffer)R(n,I).apply(n,h);this.buffer=[]}_log(n,...I){this._logger?R(this._logger,n).apply(this._logger,I):this.getLevel()<=n&&this.buffer.push({level:n,args:I})}trace(n,...I){this._log(v.LogLevel.Trace,n,...I)}debug(n,...I){this._log(v.LogLevel.Debug,n,...I)}info(n,...I){this._log(v.LogLevel.Info,n,...I)}warn(n,...I){this._log(v.LogLevel.Warning,n,...I)}error(n,...I){this._log(v.LogLevel.Error,n,...I)}critical(n,...I){this._log(v.LogLevel.Critical,n,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=M}),define(Q[184],Z([0,1,9,17,15,18,5,95,6]),function($,e,v,R,M,C,n,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const f=5*C.ByteSize.MB;let y=class extends h.AbstractLogger{constructor(p,t,w,b,S){super();this.name=p,this.resource=t,this.donotUseFormatters=b,this.fileService=S,this.backupIndex=1,this.setLevel(w),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,(0,h.format)(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,(0,h.format)(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,(0,h.format)(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,(0,h.format)(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=p.stack,this._log(h.LogLevel.Error,(0,h.format)(t))}else this._log(h.LogLevel.Error,(0,h.format)(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,(0,h.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,t){this.queue.queue(async()=>{await this.initializePromise;let w=await this.loadContent();w.length>f&&(await this.fileService.writeFile(this.getBackupResource(),R.VSBuffer.fromString(w)),w=""),this.donotUseFormatters?w+=t:w+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${t}
`,await this.fileService.writeFile(this.resource,R.VSBuffer.fromString(w))})}getCurrentTimestamp(){const p=b=>b<10?`0${b}`:b,t=b=>b<10?`00${b}`:b<100?`0${b}`:b,w=new Date;return`${w.getFullYear()}-${p(w.getMonth()+1)}-${p(w.getDate())} ${p(w.getHours())}:${p(w.getMinutes())}:${p(w.getSeconds())}.${t(w.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}};y=ge([te(4,C.IFileService)],y),e.FileLogger=y;let E=class extends h.AbstractLoggerService{constructor(p,t,w){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=t,this.fileService=w}doCreateLogger(p,t,w){const b=new I.BufferLogService(t);return(0,C.whenProviderRegistered)(p,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(y,w?.name||(0,M.basename)(p),p,b.getLevel(),!!w?.donotUseFormatters)),b}};E=ge([te(0,h.ILogService),te(1,n.IInstantiationService),te(2,C.IFileService)],E),e.FileLoggerService=E}),define(Q[185],Z([0,1,4,7,6]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(m){this.service=m,this.onDidChangeLogLevel=v.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(m,p,t){switch(p){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=C;class n{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){n.setLevel(this.channel,m)}static setLevel(m,p){return m.call("setLevel",p)}}e.LogLevelChannelClient=n;class I{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,p){throw new Error(`Event not found: ${p}`)}async call(m,p,t){switch(p){case"createLogger":this.createLogger(R.URI.revive(t[0]),t[1]);return;case"log":return this.log(R.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${p}`)}createLogger(m,p){this.loggers.set(m.toString(),this.loggerService.createLogger(m,p))}consoleLog(m,p){let t=console.log;switch(m){case M.LogLevel.Error:t=console.error;break;case M.LogLevel.Warning:t=console.warn;break;case M.LogLevel.Info:t=console.info;break}t.call(console,...p)}log(m,p){const t=this.loggers.get(m.toString());if(!t)throw new Error("Create the logger before logging");for(const[w,b]of p)(0,M.log)(t,w,b)}}e.LoggerChannel=I;class h extends M.AbstractLoggerService{constructor(m,p,t){super(m,p);this.channel=t}createConsoleMainLogger(){return new M.AdapterLogger({log:(m,p)=>{this.channel.call("consoleLog",[m,p])}})}doCreateLogger(m,p,t){return new f(this.channel,m,p,t)}}e.LoggerChannelClient=h;class f extends M.AbstractMessageLogger{constructor(m,p,t,w){super(w?.always);this.channel=m,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[p,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,p){const t=[[m,p]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(m){this.channel.call("log",[this.file,m])}}class y extends M.LogService{constructor(m,p){super(p);this.parent=m,this._register(m.onDidChangeLogLevel(t=>p.setLevel(t)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=y}),define(Q[96],Z([0,1,18,6]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function M(I,h,f,y,E){try{const m=await new Promise((t,w)=>{$(["spdlog"],t,w)});m.setFlushOn(R.LogLevel.Trace);const p=await m.createAsyncRotatingLogger(I,h,f,y);return E&&p.clearFormatters(),p}catch(m){console.error(m)}return null}function C(I,h,f){switch(h){case R.LogLevel.Trace:I.trace(f);break;case R.LogLevel.Debug:I.debug(f);break;case R.LogLevel.Info:I.info(f);break;case R.LogLevel.Warning:I.warn(f);break;case R.LogLevel.Error:I.error(f);break;case R.LogLevel.Critical:I.critical(f);break;default:throw new Error("Invalid log level")}}class n extends R.AbstractMessageLogger{constructor(h,f,y,E,m){super();this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(h,f,y,E),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}async _createSpdLogLogger(h,f,y,E){const m=y?6:1,p=30/m*v.ByteSize.MB,t=await M(h,f,p,m,E);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:w,message:b}of this.buffer)C(this._logger,w,b);this.buffer=[]}}log(h,f){this._logger?C(this._logger,h,f):this.getLevel()<=h&&this.buffer.push({level:h,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Q[186],Z([0,1,10,15,31,18,184,6,96]),function($,e,v,R,M,C,n,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let f=class extends I.AbstractLoggerService{constructor(E,m){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=m}doCreateLogger(E,m,p){return E.scheme===v.Schemas.file?new h.SpdLogLogger(p?.name||(0,M.generateUuid)(),E.fsPath,!p?.donotRotate,!!p?.donotUseFormatters,m):new n.FileLogger(p?.name??(0,R.basename)(E),E,m,!!p?.donotUseFormatters,this.fileService)}};f=ge([te(0,I.ILogService),te(1,C.IFileService)],f),e.LoggerService=f}),define(Q[187],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(n){return n.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function R(n){return n.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function M(n){return n.uri!==void 0}e.isMenubarMenuItemRecentAction=M;function C(n){return!v(n)&&!R(n)&&!M(n)}e.isMenubarMenuItemAction=C}),define(Q[56],Z([0,1,10,3,34,15]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const I=R.globals.vscode.context.configuration();if(I)n=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof $?.__$__nodeRequire=="function"){const I=(0,C.dirname)(v.FileAccess.asFileUri("",$));n=$.__$__nodeRequire((0,C.joinPath)(I,"product.json").fsPath);const h=$.__$__nodeRequire((0,C.joinPath)(I,"package.json").fsPath);M.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`}),Object.assign(n,{version:h.version})}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=n}),define(Q[22],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Q[188],Z([0,1,61,6,22]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(I,h){this.productService=I,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const f=/^(.*)#([^#]+)$/.exec(h);if(!f)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,y,E]=f;let m=this.trustedExtensionUrlPublicKeys.get(I);if(!m){if(m=this.productService.trustedExtensionUrlPublicKeys[I],!m||m.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...m])}const p=Buffer.from(decodeURIComponent(E),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const t=p.slice(0,6),w=p.readUIntBE(0,6),b=Date.now()-w;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const S=p.slice(6),P=v.createVerify("SHA256");P.write(t),P.write(Buffer.from(y)),P.end();for(let l=0;l<m.length;l++){let a=m[l];if(a!==null){if(typeof a=="string")try{a=v.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),m[l]=a}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${l+1} for ${I}:`,u),m[l]=null;continue}if(P.verify(a,S))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};C=ge([te(0,M.IProductService),te(1,R.ILogService)],C),e.ExtensionUrlTrustService=C}),define(Q[57],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Q[189],Z([0,1,14,2,40,10,3,15,7,31,48,6]),function($,e,v,R,M,C,n,I,h,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends R.Disposable{constructor(t,w){super();this.logService=w,this.validRoots=M.TernarySearchTree.forUris(()=>!n.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(h.URI.file(t.appRoot)),this.addValidFileRoot(h.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=v.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(w,b)=>this.handleResourceRequest(w,b)),t.protocol.interceptFileProtocol(C.Schemas.file,(w,b)=>this.handleFileRequest(w,b)),this._register((0,R.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?R.Disposable.None:(this.validRoots.set(t,!0),(0,R.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,w){const b=h.URI.parse(t.url);return this.logService.error(`Refused to load resource ${b.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),w({error:-3})}handleResourceRequest(t,w){const b=h.URI.parse(t.url),S=C.FileAccess.asFileUri(b);return this.validRoots.findSubstr(S)?w({path:S.fsPath}):this.validExtensions.has((0,I.extname)(S))?w({path:S.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${S.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),w({error:-3}))}createIPCObjectUrl(){let t;const w=h.URI.from({scheme:"vscode",path:(0,f.generateUuid)()}),b=w.toString(),S=async()=>t;return v.ipcMain.handle(b,S),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:w,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),v.ipcMain.removeHandler(b)}}}};m=ge([te(0,y.INativeEnvironmentService),te(1,E.ILogService)],m),e.ProtocolMainService=m}),define(Q[37],Z([0,1,104,13]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class M{constructor(){this.data=new Map}add(n,I){v.ok(R.isString(n)),v.ok(R.isObject(I)),v.ok(!this.data.has(n),"There is already an extension with this id"),this.data.set(n,I)}knows(n){return this.data.has(n)}as(n){return this.data.get(n)||null}}e.Registry=new M}),define(Q[190],Z([0,1,4,37]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function M(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class C{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,f){this.schemasById[M(h)]=f,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const n=new C;R.Registry.add(e.Extensions.JSONContribution,n)}),define(Q[49],Z([0,1,30,4,13,135,190,37]),function($,e,v,R,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=I.Registry.as(n.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,s=!0){this.registerConfigurations([u],s)}registerConfigurations(u,s=!0){const c=this.doRegisterConfigurations(u,s);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(u){const s=this.doDeregisterConfigurations(u);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}updateConfigurations({add:u,remove:s}){const c=[];c.push(...this.doDeregisterConfigurations(s)),c.push(...this.doRegisterConfigurations(u,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,v.distinct)(c))}registerDefaultConfigurations(u){const s=[],c=[];for(const i of u)for(const r in i)if(s.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){this.defaultValues[r]={...this.defaultValues[r]||{},...i[r]};const o={type:"object",default:this.defaultValues[r],description:C.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId};c.push(...t(r)),this.configurationProperties[r]=o,this.defaultLanguageConfigurationOverridesNode.properties[r]=o}else{this.defaultValues[r]=i[r];const o=this.configurationProperties[r];o&&(this.updatePropertyDefaultValue(r,o),this.updateSchema(r,o))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(u){const s=[];for(const c of u)for(const i in c)if(s.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const r=this.configurationProperties[i];r&&(this.updatePropertyDefaultValue(i,r),this.updateSchema(i,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const s of u)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,s){const c=[];return u.forEach(i=>{c.push(...this.validateAndRegisterProperties(i,s,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),c}doDeregisterConfigurations(u){const s=[],c=i=>{if(i.properties)for(const r in i.properties)s.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r]);i.allOf&&i.allOf.forEach(r=>c(r))};for(const i of u){c(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}return s}validateAndRegisterProperties(u,s=!0,c,i=3){i=M.isUndefinedOrNull(u.scope)?i:u.scope;let r=[],o=u.properties;if(o)for(let g in o){if(s&&P(g)){delete o[g];continue}const k=o[g];if(this.updatePropertyDefaultValue(g,k),e.OVERRIDE_PROPERTY_REGEX.test(g)?k.scope=void 0:(k.scope=M.isUndefinedOrNull(k.scope)?i:k.scope,k.restricted=M.isUndefinedOrNull(k.restricted)?!!c?.restrictedConfigurations?.includes(g):k.restricted),o[g].hasOwnProperty("included")&&!o[g].included){this.excludedConfigurationProperties[g]=o[g],delete o[g];continue}else this.configurationProperties[g]=o[g];!o[g].deprecationMessage&&o[g].markdownDeprecationMessage&&(o[g].deprecationMessage=o[g].markdownDeprecationMessage),r.push(g)}let d=u.allOf;if(d)for(let g of d)r.push(...this.validateAndRegisterProperties(g,s,c,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const s=c=>{let i=c.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);let r=c.allOf;r&&r.forEach(s)};s(u)}updateSchema(u,s){switch(e.allSettings.properties[u]=s,s.scope){case 1:e.applicationSettings.properties[u]=s;break;case 2:e.machineSettings.properties[u]=s;break;case 6:e.machineOverridableSettings.properties[u]=s;break;case 3:e.windowSettings.properties[u]=s;break;case 4:e.resourceSettings.properties[u]=s;break;case 5:e.resourceSettings.properties[u]=s,this.resourceLanguageSettingsSchema.properties[u]=s;break}}removeFromSchema(u,s){switch(delete e.allSettings.properties[u],s.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const s=`[${u}]`,c={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,c),e.allSettings.properties[s]=c,e.applicationSettings.properties[s]=c,e.machineSettings.properties[s]=c,e.machineOverridableSettings.properties[s]=c,e.windowSettings.properties[s]=c,e.resourceSettings.properties[s]=c}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,s){let c=this.defaultValues[u];M.isUndefined(c)&&(c=s.default),M.isUndefined(c)&&(c=b(s.type)),s.default=c}}const m="\\[([^\\]]+)\\]",p=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(a){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let s=p.exec(a);for(;s?.length;){const c=s[1].trim();c&&u.push(c),s=p.exec(a)}}return(0,v.distinct)(u)}e.overrideIdentifiersFromKey=t;function w(a){return a.reduce((u,s)=>`${u}[${s}]`,"")}e.keyFromOverrideIdentifiers=w;function b(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const S=new E;I.Registry.add(e.Extensions.Configuration,S);function P(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?C.localize(7,null,a):S.getConfigurationProperties()[a]!==void 0?C.localize(8,null,a):null:C.localize(6,null)}e.validateProperty=P;function l(){const a=[],u=S.getConfigurationProperties();for(const s of Object.keys(u))a.push([s,u[s].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=l}),define(Q[19],Z([0,1,13,7,49,5,37]),function($,e,v,R,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function I(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof R.URI)}e.isConfigurationOverrides=I;function h(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||v.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=h;var f;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(f=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function E(a,u){const s=Object.create(null);for(let c in a)m(s,c,a[c],u);return s}e.toValuesTree=E;function m(a,u,s,c){const i=u.split("."),r=i.pop();let o=a;for(let d=0;d<i.length;d++){let g=i[d],k=o[g];switch(typeof k){case"undefined":k=o[g]=Object.create(null);break;case"object":break;default:c(`Ignoring ${u} as ${i.slice(0,d+1).join(".")} is ${JSON.stringify(k)}`);return}o=k}if(typeof o=="object"&&o!==null)try{o[r]=s}catch(d){c(`Ignoring ${u} as ${i.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${u} as ${i.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=m;function p(a,u){const s=u.split(".");t(a,s)}e.removeFromValueTree=p;function t(a,u){const s=u.shift();if(u.length===0){delete a[s];return}if(Object.keys(a).indexOf(s)!==-1){const c=a[s];typeof c=="object"&&!Array.isArray(c)&&(t(c,u),Object.keys(c).length===0&&delete a[s])}}function w(a,u,s){function c(o,d){let g=o;for(const k of d){if(typeof g!="object"||g===null)return;g=g[k]}return g}const i=u.split("."),r=c(a,i);return typeof r=="undefined"?s:r}e.getConfigurationValue=w;function b(a,u,s){Object.keys(u).forEach(c=>{c!=="__proto__"&&(c in a?v.isObject(a[c])&&v.isObject(u[c])?b(a[c],u[c],s):s&&(a[c]=u[c]):a[c]=u[c])})}e.merge=b;function S(){const a=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=S;function P(){const a=Object.create(null),u=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let s in u){let c=u[s].default;m(a,s,c,i=>console.error(`Conflict in default settings: ${i}`))}return a}e.getDefaultValues=P;function l(a,u,s){const c=a.inspect(u),i=a.inspect(s);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof i.userValue!="undefined"||typeof i.workspaceValue!="undefined"||typeof i.workspaceFolderValue!="undefined"?i.value:c.defaultValue}e.getMigratedSettingValue=l}),define(Q[191],Z([0,1,30,4,39,2,40,47,13,7,19,49,37]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(i={},r=[],o=[]){this._contents=i,this._keys=r,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,y.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,r){const o=this.getContentsForOverrideIdentifer(r);return o?i?(0,y.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const r=[];for(const o of this.overrides)o.identifiers.includes(i)&&r.push(...o.keys);return v.distinct(r)}getAllOverrideIdentifiers(){const i=[];for(const r of this.overrides)i.push(...r.identifiers);return v.distinct(i)}override(i){let r=this.overrideConfigurations.get(i);return r||(r=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,r)),r}merge(...i){const r=I.deepClone(this.contents),o=I.deepClone(this.overrides),d=[...this.keys];for(const g of i){this.mergeContents(r,g.contents);for(const k of g.overrides){const[L]=o.filter(A=>v.equals(A.identifiers,k.identifiers));L?(this.mergeContents(L.contents,k.contents),L.keys.push(...k.keys),L.keys=v.distinct(L.keys)):o.push(I.deepClone(k))}for(const k of g.keys)d.indexOf(k)===-1&&d.push(k)}return new p(r,d,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const r=this.getContentsForOverrideIdentifer(i);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let o={};for(const d of v.distinct([...Object.keys(this.contents),...Object.keys(r)])){let g=this.contents[d],k=r[d];k&&(typeof g=="object"&&typeof k=="object"?(g=I.deepClone(g),this.mergeContents(g,k)):g=k),o[d]=g}return new p(o,this.keys,this.overrides)}mergeContents(i,r){for(const o of Object.keys(r)){if(o in i&&h.isObject(i[o])&&h.isObject(r[o])){this.mergeContents(i[o],r[o]);continue}i[o]=I.deepClone(r[o])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let r=null,o=null;const d=g=>{g&&(o?this.mergeContents(o,g):o=I.deepClone(g))};for(const g of this.overrides)v.equals(g.identifiers,[i])?r=g.contents:g.identifiers.includes(i)&&d(g.contents);return d(r),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,r){this.addKey(i),(0,y.addToValueTree)(this.contents,i,r,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,y.removeFromValueTree)(this.contents,i)}addKey(i){let r=this.keys.length;for(let o=0;o<r;o++)i.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,i)}removeKey(i){let r=this.keys.indexOf(i);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=p;class t extends p{constructor(){const i=(0,y.getDefaultValues)(),r=(0,y.getConfigurationKeys)(),o=[];for(const d of Object.keys(i))E.OVERRIDE_PROPERTY_REGEX.test(d)&&o.push({identifiers:(0,E.overrideIdentifiersFromKey)(d),keys:Object.keys(i[d]),contents:(0,y.toValuesTree)(i[d],g=>console.error(`Conflict in default settings file: ${g}`))});super(i,r,o)}}e.DefaultConfigurationModel=t;class w{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,r){if(!h.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,r)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,r){this._raw=i;const{contents:o,keys:d,overrides:g,restricted:k}=this.doParseRaw(i,r);this._configurationModel=new p(o,d,g),this._restrictedConfigurations=k||[]}doParseContent(i){let r={},o=null,d=[],g=[],k=[];function L(W){Array.isArray(d)?d.push(W):o!==null&&(d[o]=W)}let A={onObjectBegin:()=>{let W={};L(W),g.push(d),d=W,o=null},onObjectProperty:W=>{o=W},onObjectEnd:()=>{d=g.pop()},onArrayBegin:()=>{let W=[];L(W),g.push(d),d=W,o=null},onArrayEnd:()=>{d=g.pop()},onLiteralValue:L,onError:(W,V,ee)=>{k.push({error:W,offset:V,length:ee})}};if(i)try{M.visit(i,A),r=d[0]||{}}catch(W){console.error(`Error while parsing settings file ${this._name}: ${W}`),this._parseErrors=[W]}return r}doParseRaw(i,r){const o=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),d=this.filter(i,o,!0,r);i=d.raw;const g=(0,y.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),k=Object.keys(i),L=this.toOverrides(i,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:g,keys:k,overrides:L,restricted:d.restricted}}filter(i,r,o,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:i,restricted:[]};const g={},k=[];for(let L in i)if(E.OVERRIDE_PROPERTY_REGEX.test(L)&&o){const A=this.filter(i[L],r,!1,d);g[L]=A.raw,k.push(...A.restricted)}else{const A=r[L],W=A?typeof A.scope!="undefined"?A.scope:3:void 0;A?.restricted&&k.push(L),(W===void 0||d.scopes===void 0||d.scopes.includes(W))&&(d.skipRestricted&&A?.restricted||(g[L]=i[L]))}return{raw:g,restricted:k}}toOverrides(i,r){const o=[];for(const d of Object.keys(i))if(E.OVERRIDE_PROPERTY_REGEX.test(d)){const g={};for(const k in i[d])g[k]=i[d][k];o.push({identifiers:(0,E.overrideIdentifiersFromKey)(d),keys:Object.keys(g),contents:(0,y.toValuesTree)(g,r)})}return o}}e.ConfigurationModelParser=w;class b extends C.Disposable{constructor(i,r,o,d){super();this.userSettingsResource=i,this.scopes=r,this.fileService=d,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,g=>g.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class S{constructor(i,r,o=new p,d=new p,g=new n.ResourceMap,k=new p,L=new n.ResourceMap,A=!0){this._defaultConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=d,this._folderConfigurations=g,this._memoryConfiguration=k,this._memoryConfigurationByResource=L,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new n.ResourceMap,this._userConfiguration=null}getValue(i,r,o){return this.getConsolidateConfigurationModel(r,o).getValue(i)}updateValue(i,r,o={}){let d;o.resource?(d=this._memoryConfigurationByResource.get(o.resource),d||(d=new p,this._memoryConfigurationByResource.set(o.resource,d))):d=this._memoryConfiguration,r===void 0?d.removeValue(i):d.setValue(i,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,r,o){const d=this.getConsolidateConfigurationModel(r,o),g=this.getFolderConfigurationModelForResource(r.resource,o),k=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,L=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),A=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),W=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),V=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),ee=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,oe=g?r.overrideIdentifier?g.freeze().override(r.overrideIdentifier).getValue(i):g.freeze().getValue(i):void 0,ae=r.overrideIdentifier?k.override(r.overrideIdentifier).getValue(i):k.getValue(i),K=d.getValue(i),F=v.distinct(v.flatten(d.overrides.map(U=>U.identifiers))).filter(U=>d.getOverrideValue(i,U)!==void 0);return{defaultValue:L,userValue:A,userLocalValue:W,userRemoteValue:V,workspaceValue:ee,workspaceFolderValue:oe,memoryValue:ae,value:K,default:L!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,userRemote:V!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,workspace:ee!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,workspaceFolder:oe!==void 0?{value:g?.freeze().getValue(i),override:r.overrideIdentifier?g?.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,memory:ae!==void 0?{value:k.getValue(i),override:r.overrideIdentifier?k.getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(i){const r=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,r){this._folderConfigurations.set(i,r),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,r){const o=[];for(const d of r)for(const g of(0,E.overrideIdentifiersFromKey)(d)){const k=this._defaultConfiguration.getKeysForOverrideIdentifier(g),L=i.getKeysForOverrideIdentifier(g),A=[...L.filter(W=>k.indexOf(W)===-1),...k.filter(W=>L.indexOf(W)===-1),...k.filter(W=>!I.equals(this._defaultConfiguration.override(g).getValue(W),i.override(g).getValue(W)))];o.push([g,A])}return this.updateDefaultConfiguration(i),{keys:r,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:r,updated:o,removed:d,overrides:g}=u(this.localUserConfiguration,i),k=[...r,...o,...d];return k.length&&this.updateLocalUserConfiguration(i),{keys:k,overrides:g}}compareAndUpdateRemoteUserConfiguration(i){const{added:r,updated:o,removed:d,overrides:g}=u(this.remoteUserConfiguration,i);let k=[...r,...o,...d];return k.length&&this.updateRemoteUserConfiguration(i),{keys:k,overrides:g}}compareAndUpdateWorkspaceConfiguration(i){const{added:r,updated:o,removed:d,overrides:g}=u(this.workspaceConfiguration,i);let k=[...r,...o,...d];return k.length&&this.updateWorkspaceConfiguration(i),{keys:k,overrides:g}}compareAndUpdateFolderConfiguration(i,r){const o=this.folderConfigurations.get(i),{added:d,updated:g,removed:k,overrides:L}=u(o,r);let A=[...d,...g,...k];return(A.length||!o)&&this.updateFolderConfiguration(i,r),{keys:A,overrides:L}}compareAndDeleteFolderConfiguration(i){const r=this.folderConfigurations.get(i);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:d,removed:g,overrides:k}=u(r,void 0);return{keys:[...o,...d,...g],overrides:k}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,r){let o=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier?o.override(i.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:i},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&i){const d=r.getFolder(i);d&&(o=this.getFolderConsolidatedConfiguration(d.uri)||o);const g=this._memoryConfigurationByResource.get(i);g&&(o=o.merge(g))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let r=this._foldersConsolidatedConfigurations.get(i);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(i);d?(r=o.merge(d),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(i,r)):r=o}return r}getFolderConfigurationModelForResource(i,r){if(r&&i){const o=r.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,r)=>{const{contents:o,overrides:d,keys:g}=this._folderConfigurations.get(r);return i.push([r,{contents:o,overrides:d,keys:g}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>i.add(r)),this.userConfiguration.freeze().keys.forEach(r=>i.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(d=>r.add(d))),[...r.values()]}static parse(i){const r=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.user),d=this.parseConfigurationModel(i.workspace),g=i.folders.reduce((k,L)=>(k.set(f.URI.revive(L[0]),this.parseConfigurationModel(L[1])),k),new n.ResourceMap);return new S(r,o,new p,d,g,new p,new n.ResourceMap,!1)}static parseConfigurationModel(i){return new p(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=S;function P(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,r=new Map;for(const d of c)d.keys.forEach(g=>i.add(g)),d.overrides.forEach(([g,k])=>{const L=(0,n.getOrSet)(r,g,new Set);k.forEach(A=>L.add(A))});const o=[];return r.forEach((d,g)=>o.push([g,[...d.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=P;class l{constructor(i,r,o,d){this.change=i,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=d,this._previousConfiguration=void 0;const g=new Set;i.keys.forEach(L=>g.add(L)),i.overrides.forEach(([,L])=>L.forEach(A=>g.add(A))),this.affectedKeys=[...g.values()];const k=new p;this.affectedKeys.forEach(L=>k.setValue(L,{})),this.affectedKeysTree=k.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,r,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(i,r,this.currentWorkspace);return!I.equals(o,d)}return!0}return!1}doesAffectedKeysTreeContains(i,r){let o=(0,y.toValuesTree)({[r]:!0},()=>{}),d;for(;typeof o=="object"&&(d=Object.keys(o)[0]);){if(i=i[d],!i)return!1;o=o[d]}return!0}}e.ConfigurationChangeEvent=l;class a extends l{constructor(i,r,o,d){super({keys:i.allKeys(),overrides:[]},void 0,i,r);this.source=o,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=a;function u(c,i){const{added:r,removed:o,updated:d}=s(i,c),g=[],k=c?.getAllOverrideIdentifiers()||[],L=i?.getAllOverrideIdentifiers()||[];if(i){const A=L.filter(W=>!k.includes(W));for(const W of A)g.push([W,i.getKeysForOverrideIdentifier(W)])}if(c){const A=k.filter(W=>!L.includes(W));for(const W of A)g.push([W,c.getKeysForOverrideIdentifier(W)])}if(i&&c){for(const A of k)if(L.includes(A)){const W=s({contents:c.getOverrideValue(void 0,A)||{},keys:c.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});g.push([A,[...W.added,...W.removed,...W.updated]])}}return{added:r,removed:o,updated:d,overrides:g}}function s(c,i){const r=c?i?c.keys.filter(g=>i.keys.indexOf(g)===-1):[...c.keys]:[],o=i?c?i.keys.filter(g=>c.keys.indexOf(g)===-1):[...i.keys]:[],d=[];if(c&&i){for(const g of i.keys)if(c.keys.indexOf(g)!==-1){const k=(0,y.getConfigurationValue)(i.contents,g),L=(0,y.getConfigurationValue)(c.contents,g);I.equals(k,L)||d.push(g)}}return{added:r,removed:o,updated:d}}}),define(Q[192],Z([0,1,9,4,2,15,19,191,49,37]),function($,e,v,R,M,C,n,I,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends M.Disposable{constructor(m,p){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,p)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(f.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(t=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,p){const t=typeof m=="string"?m:void 0,w=(0,n.isConfigurationOverrides)(m)?m:(0,n.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(t,w,void 0)}updateValue(m,p,t,w){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(t,p,1)}onDidDefaultConfigurationChange(m){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,m);this.trigger(t,p,6)}trigger(m,p,t){const w=new I.ConfigurationChangeEvent(m,{data:p},this.configuration);w.source=t,w.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(Q[193],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends Error{constructor(n,I=R.Unknown,h){super(n);this._message=n,this._code=I,this._detail=h,this.isHandled=I===R.NotAvailable&&h===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(n){return n instanceof M&&n._code===R.TemporarilyNotAvailable}static isNoResolverFound(n){return n instanceof M&&n._code===R.NoResolverFound}static isHandled(n){return n instanceof M&&n.isHandled}}e.RemoteAuthorityResolverError=M}),define(Q[194],Z([0,1,9,17,23,16,4,2,31,84,193]),function($,e,v,R,M,C,n,I,h,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var m;(function(O){O[O.Management=1]="Management",O[O.ExtensionHost=2]="ExtensionHost",O[O.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function p(O){switch(O){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(O){const D=new M.CancellationTokenSource;return setTimeout(()=>D.cancel(),O),D.token}function w(O,D){if(O.isCancellationRequested||D.isCancellationRequested)return M.CancellationToken.Cancelled;const T=new M.CancellationTokenSource;return O.onCancellationRequested(()=>T.cancel()),D.onCancellationRequested(()=>T.cancel()),T.token}class b{constructor(D){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((T,_)=>{this._resolvePromise=T,this._rejectPromise=_}),D.isCancellationRequested?this._timeout():this._disposables.add(D.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(D){this._state==="pending"?this._disposables.add(D):D.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(D))}reject(D){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(D))}}function S(O,D){const T=new b(D);return T.registerDisposable(O.onControlMessage(_=>{const B=JSON.parse(_.toString()),X=G(B);X?T.reject(X):T.resolve(B)})),T.promise}function P(O,D,T,_,B,X){const N=new b(X);return D.connect(T,_,B,(H,ie)=>{N.didTimeout?(H&&O.error(H),ie?.dispose()):H||!ie?N.reject(H):N.resolve(ie)}),N.promise}function l(O,D){const T=new b(D);return O.then(_=>{T.didTimeout||T.resolve(_)},_=>{T.didTimeout||T.reject(_)}),T.promise}async function a(O,D,T,_){const B=z(O,D);O.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let X;try{X=await P(O.logService,O.socketFactory,O.host,O.port,`reconnectionToken=${O.reconnectionToken}&reconnection=${O.reconnectionProtocol?"true":"false"}`,_)}catch(se){throw O.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),O.logService.error(se),se}O.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let N,H;O.reconnectionProtocol?(O.reconnectionProtocol.beginAcceptReconnection(X,null),N=O.reconnectionProtocol,H=!1):(N=new f.PersistentProtocol(X,null),H=!0),O.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const ie=await l(O.signService.createNewMessage((0,h.generateUuid)()),_),re={type:"auth",auth:O.connectionToken||"00000000000000000000",data:ie.data};N.sendControl(R.VSBuffer.fromString(JSON.stringify(re)));try{const se=await S(N,w(_,t(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const he=new Error("Unexpected handshake message");throw he.code="VSCODE_CONNECTION_ERROR",he}if(O.logService.trace(`${B} 4/6. received SignRequest control message.`),!await l(O.signService.validate(ie,se.signedData),_)){const he=new Error("Refused to connect to unsupported server");throw he.code="VSCODE_CONNECTION_ERROR",he}const ce=await l(O.signService.sign(se.data),_),le={type:"connectionType",commit:O.commit,signedData:ce,desiredConnectionType:D};return T&&(le.args=T),O.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(R.VSBuffer.fromString(JSON.stringify(le))),{protocol:N,ownsProtocol:H}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(O.logService.error(`${B} the handshake timed out. Error:`),O.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(O.logService.error(`${B} received error control message when negotiating connection. Error:`),O.logService.error(se)),H&&U(N),se}}async function u(O,D,T,_){const B=Date.now(),X=z(O,D),{protocol:N,ownsProtocol:H}=await a(O,D,T,_),ie=new b(_);return ie.registerDisposable(N.onControlMessage(re=>{const se=JSON.parse(re.toString()),x=G(se);x?(O.logService.error(`${X} received error control message when negotiating connection. Error:`),O.logService.error(x),H&&U(N),ie.reject(x)):(O.reconnectionProtocol&&O.reconnectionProtocol.endAcceptReconnection(),O.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${J(B)}!`),ie.resolve({protocol:N,firstMessage:se}))})),ie.promise}async function s(O,D){const{protocol:T}=await u(O,1,void 0,D);return{protocol:T}}async function c(O,D,T){const{protocol:_,firstMessage:B}=await u(O,2,D,T),X=B&&B.debugPort;return{protocol:_,debugPort:X}}async function i(O,D,T){const _=Date.now(),B=z(O,3),{protocol:X}=await a(O,3,D,T);return O.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${J(_)}!`),X}async function r(O,D,T){const{host:_,port:B,connectionToken:X}=await O.addressProvider.getAddress();return{commit:O.commit,host:_,port:B,connectionToken:X,reconnectionToken:D,reconnectionProtocol:T,socketFactory:O.socketFactory,signService:O.signService,logService:O.logService}}async function o(O,D,T){try{const _=(0,h.generateUuid)(),B=await r(O,_,null),{protocol:X}=await s(B,M.CancellationToken.None);return new K(O,D,T,_,X)}catch(_){throw O.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),O.logService.error(_),ae.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentManagement=o;async function d(O,D){try{const T=(0,h.generateUuid)(),_=await r(O,T,null),{protocol:B,debugPort:X}=await c(_,D,M.CancellationToken.None);return new F(O,D,T,B,X)}catch(T){throw O.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),O.logService.error(T),ae.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentExtensionHost=d;async function g(O,D,T){const _=await r(O,(0,h.generateUuid)(),null);return await i(_,{host:D,port:T},M.CancellationToken.None)}e.connectRemoteAgentTunnel=g;function k(O){return(0,v.createCancelablePromise)(D=>new Promise((T,_)=>{const B=setTimeout(T,O*1e3);D.onCancellationRequested(()=>{clearTimeout(B),T()})}))}var L;(function(O){O[O.ConnectionLost=0]="ConnectionLost",O[O.ReconnectionWait=1]="ReconnectionWait",O[O.ReconnectionRunning=2]="ReconnectionRunning",O[O.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",O[O.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(D,T){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=A;class W{constructor(D,T,_,B){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.durationSeconds=_,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class V{constructor(D,T,_){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=_,this.type=2}}e.ReconnectionRunningEvent=V;class ee{constructor(D,T,_){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=_,this.type=4}}e.ConnectionGainEvent=ee;class oe{constructor(D,T,_,B){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=_,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class ae extends I.Disposable{constructor(D,T,_,B){super();this._connectionType=D,this._onDidStateChange=this._register(new n.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=T,this.reconnectionToken=_,this.protocol=B,this._isReconnecting=!1,this._onDidStateChange.fire(new ee(this.reconnectionToken,0,0)),this._register(B.onSocketClose(X=>{const N=q(this._connectionType,this.reconnectionToken,!0);X?X.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${X.hadError}).`),X.error&&this._options.logService.error(X.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this._options.logService.error(X.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(()=>{const X=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${X} received socket timeout event.`),this._beginReconnecting()})),ae._instances.push(this),ae._permanentFailure&&this._gotoPermanentFailure(ae._permanentFailureMillisSinceLastIncomingData,ae._permanentFailureAttempt,ae._permanentFailureHandled)}static triggerPermanentFailure(D,T,_){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=D,this._permanentFailureAttempt=T,this._permanentFailureHandled=_,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(ae._permanentFailure)return;const D=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const B=_<T.length?T[_]:T[T.length-1];try{if(B>0){const N=k(B);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,N)),this._options.logService.info(`${D} waiting for ${B} seconds before reconnecting...`);try{await N}catch{}}if(ae._permanentFailure){this._options.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this._options.logService.info(`${D} resolving connection...`);const X=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${D} connecting to ${X.host}:${X.port}...`),await this._reconnect(X,t(E)),this._options.logService.info(`${D} reconnected!`),this._onDidStateChange.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(X),ae.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this._options.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(X),ae.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this._options.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this._options.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((0,C.isPromiseCanceledError)(X)){this._options.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if(X instanceof y.RemoteAuthorityResolverError){this._options.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(X),ae.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,y.RemoteAuthorityResolverError.isHandled(X));break}this._options.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(X),ae.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!ae._permanentFailure)}_gotoPermanentFailure(D,T,_){this._onDidStateChange.fire(new oe(this.reconnectionToken,D,T,_)),U(this.protocol)}}ae._permanentFailure=!1,ae._permanentFailureMillisSinceLastIncomingData=0,ae._permanentFailureAttempt=0,ae._permanentFailureHandled=!1,ae._instances=[];class K extends ae{constructor(D,T,_,B,X){super(1,D,B,X);this.client=this._register(new f.Client(X,{remoteAuthority:T,clientId:_},D.ipcLogger))}async _reconnect(D,T){await s(D,T)}}e.ManagementPersistentConnection=K;class F extends ae{constructor(D,T,_,B,X){super(2,D,_,B);this._startArguments=T,this.debugPort=X}async _reconnect(D,T){await c(D,this._startArguments,T)}}e.ExtensionHostPersistentConnection=F;function U(O){try{O.acceptDisconnect();const D=O.getSocket();O.dispose(),D.dispose()}catch(D){(0,C.onUnexpectedError)(D)}}function G(O){if(O&&O.type==="error"){const D=new Error(`Connection error: ${O.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function Y(O,D){for(;O.length<D;)O+=" ";return O}function q(O,D,T){return`[remote-connection][${Y(p(O),13)}][${D.substr(0,5)}\u2026][${T?"reconnect":"initial"}]`}function z(O,D){return`${q(D,O.reconnectionToken,!!O.reconnectionProtocol)}[${O.host}:${O.port}]`}function J(O){return`${Date.now()-O} ms`}}),define(Q[64],Z([0,1,10]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(f){return f.scheme===v.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=R;function M(f){if(!f)return;const y=f.indexOf("+");return y<0?f:f.substr(0,y)}e.getRemoteName=M;function C(f){return f.scheme!==v.Schemas.file&&f.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=C;function n(f){if(f.folders.length)return f.folders.every(y=>C(y.uri))?f.folders[0].uri:void 0;if(f.configuration&&C(f.configuration))return f.configuration}e.getVirtualWorkspaceLocation=n;function I(f){return n(f)?.scheme}e.getVirtualWorkspaceScheme=I;function h(f){return n(f)!==void 0}e.isVirtualWorkspace=h}),define(Q[195],Z([0,1,25,5,64]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=C;function n(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=n,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class h{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,t){if(typeof p=="undefined"||p===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof p=="string"||typeof t=="string"){let w=typeof p=="string"?p:p.value,b=typeof t=="string"?t:t.value;return v.equalsIgnoreCase(w,b)}return p._lower===t._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=h;function f(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function y(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function E(m,p){if(p){const t=`onResolveRemoteAuthority:${(0,M.getRemoteName)(p)}`;return m.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[196],Z([0,1,25,195]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function M(t,w){return t.uuid&&w.uuid?t.uuid===w.uuid:t.id===w.id?!0:(0,v.compareIgnoreCase)(t.id,w.id)===0}e.areSameExtensions=M;class C{constructor(w,b){this.version=b,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof C?M(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=C;function n(t,w){return`${t}.${w}`}e.getExtensionId=n;function I(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function h(t,w){return I(n(t,w))}e.getGalleryExtensionId=h;function f(t,w){const b=[],S=P=>{for(const l of b)if(l.some(a=>M(w(a),w(P))))return l;return null};for(const P of t){const l=S(P);l?l.push(P):b.push([P])}return b}e.groupByExtension=f;function y(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function E(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function m(t){const w=new Set;for(const b of t)b.malicious&&w.add(b.id.id);return w}e.getMaliciousExtensionsSet=m;function p(t,w){const b=[],S=w.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const P=S.shift();if(P&&b.every(l=>!M(l.identifier,{id:P}))){const l=t.filter(a=>M(a.identifier,{id:P}));l.length===1&&(b.push(l[0]),S.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=p}),define(Q[97],Z([0,1,4,3,5,6]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,M.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,M.createDecorator)("sharedTunnelsService");var n;(function(t){t.Http="http",t.Https="https"})(n=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=E;function m(t,w){return w?w!==1&&t<1024:!R.isWindows&&t<1024}e.isPortPrivileged=m;let p=class{constructor(w){this.logService=w,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,b){return this._tunnelProvider=w,w?(this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],b=Array.from(this._tunnels.values());for(let S of b){const P=Array.from(S.values());for(let l of P){const a=await l.value;a&&w.push(a)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:b}of w.values())await b.then(S=>S?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,b,S,P,l=!1,a=I.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${S} on local port ${P}.`),!w)return;b||(b="localhost");const s=this.retainOrCreateTunnel(w,b,S,P,l,a,u);return s?s.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(b,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(c);return(c.tunnelRemoteHost!==b||c.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const b=this._tunnels.get(w.tunnelRemoteHost);if(b){const S=b.get(w.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,S))}}}}async tryDisposeTunnel(w,b,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${b}.`);const P=S.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(b),P}}async closeTunnel(w,b){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${b} `);const S=this._tunnels.get(w);if(S&&S.has(b)){const P=S.get(b);P.refcount=0,await this.tryDisposeTunnel(w,b,P)}}addTunnelToMap(w,b,S){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(b,{refcount:1,value:S})}async removeEmptyTunnelFromMap(w,b){const S=this._tunnels.get(w);S&&(await S.get(b)||S.delete(b),S.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,b){let S=[w];y(w)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):E(w)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const P=S.map(l=>this._tunnels.get(l));for(const l of P){const a=l?.get(b);if(a)return a}}canTunnel(w){return!!f(w)}createWithProvider(w,b,S,P,l,a,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${S} on local port ${P}.`);const c={elevationRequired:l?m(P===void 0?S:P):!1},i={remoteAddress:{host:b,port:S},localAddressPort:P,privacy:a,public:a!==I.Private,protocol:u},r=w.forwardPort(i,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(b,S,r),r}};p=ge([te(0,C.ILogService)],p),e.AbstractTunnelService=p}),define(Q[50],Z([0,1,17,151,49,5,37]),function($,e,v,R,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function h(t){return t.res.statusCode===204}async function f(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return h(t)?null:(await(0,v.streamToBuffer)(t.stream)).toString()}e.asText=f;async function y(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(h(t))return null;const b=(await(0,v.streamToBuffer)(t.stream)).toString();try{return JSON.parse(b)}catch(S){throw S.message+=`:
`+b,S}}e.asJson=y;function E(t){p(t)}e.updateProxyConfigurationsScope=E;let m;function p(t){const w=n.Registry.as(M.Extensions.Configuration),b=m;m={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[m],remove:b?[b]:[]})}p(2)}),define(Q[197],Z([0,1,198,13]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function M(n,I){return n.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:n.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function C(n,I,h={}){const f=(0,v.parse)(n),y=h.proxyUrl||M(f,I);if(!y)return null;const E=(0,v.parse)(y);if(!/^https?:$/.test(E.protocol||""))return null;const m={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,R.isBoolean)(h.strictSSL)?h.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((p,t)=>{$(["http-proxy-agent"],p,t)}))(m):new(await new Promise((p,t)=>{$(["https-proxy-agent"],p,t)}))(m)}e.getProxyAgent=C}),define(Q[199],Z([0,1,17,31]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function M(C,n,I){let h=I&&I.get("storage.serviceMachineId",0)||null;if(h)return h;try{const y=(await n.readFile(C.serviceMachineIdResource)).value.toString();h=(0,R.isUUID)(y)?y:null}catch(f){h=null}if(!h){h=(0,R.generateUuid)();try{await n.writeFile(C.serviceMachineIdResource,v.VSBuffer.fromString(h))}catch(f){}}return I&&I.store("storage.serviceMachineId",h,0,1),h}e.getServiceMachineId=M}),define(Q[76],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[200],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((M,C)=>$(["vsda"],M,C))}async createNewMessage(M){try{const C=await this.vsda(),n=new C.validator;if(n){const I=String(v._nextId++);return this.validators.set(I,n),{id:I,data:n.createNewMessage(M)}}}catch(C){}return{id:"",data:M}}async validate(M,C){if(!M.id)return!0;const n=this.validators.get(M.id);if(!n)return!1;this.validators.delete(M.id);try{return n.validate(C)==="ok"}catch(I){return!1}}async sign(M){try{const C=await this.vsda(),n=new C.signer;if(n)return n.sign(M)}catch(C){}return M}}e.SignService=v,v._nextId=1}),define(Q[38],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Q[20],Z([0,1,14,9,4,2,3,34,13,5,179,6,38]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,f.createDecorator)("lifecycleMainService");var p;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class dt extends C.Disposable{constructor(b,S){super();this.logService=b,this.stateMainService=S,this._onBeforeShutdown=this._register(new M.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new M.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new M.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new M.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new M.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(dt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(dt.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),n.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};v.app.addListener("before-quit",b);const S=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!n.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",S),v.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",b),v.app.removeListener("window-all-closed",S),v.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(S){b.push(S)}}),this.pendingWillShutdownPromise=(async()=>{try{await R.Promises.settled(b)}catch(S){this.logService.error(S)}try{await this.stateMainService.close()}catch(S){this.logService.error(S)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const S=this.phaseWhen.get(this._phase);S&&(S.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let S=this.phaseWhen.get(b);S||(S=new R.Barrier,this.phaseWhen.set(b,S)),await S.wait()}registerWindow(b){const S=new C.DisposableStore;this.windowCounter++,S.add(b.onWillLoad(l=>this._onWillLoadWindow.fire({window:b,workspace:l.workspace,reason:l.reason})));const P=(0,h.assertIsDefined)(b.win);P.on("close",l=>{const a=b.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),l.preventDefault(),this.unload(b,1).then(u=>{if(u){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(b),b.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,S.dispose(),this.windowCounter===0&&(!n.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(b,S){await this.unload(b,3)||b.reload(S)}async unload(b,S){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const P=this._quitRequested?2:S;let l=await this.onBeforeUnloadWindowInRenderer(b,P);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(b,P),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,P),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,S){return new Promise(P=>{const l=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${l}`,u=`vscode:cancel${l}`;v.ipcMain.once(a,()=>{P(!1)}),v.ipcMain.once(u,()=>{P(!0)}),b.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:u,reason:S})})}onBeforeUnloadWindowInMain(b,S){const P=[];return this._onBeforeUnloadWindow.fire({reason:S,window:b,veto(l){P.push(l)}}),(0,y.handleVetos)(P,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(b,S){return new Promise(P=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(a,()=>P()),b.send("vscode:onWillUnload",{replyChannel:a,reason:S})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(dt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(S=>{this.pendingQuitPromiseResolve=S,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const S=process.argv.slice(1);if(b?.addArgs&&S.push(...b.addArgs),b?.removeArgs)for(const a of b.removeArgs){const u=S.indexOf(a);u>=0&&S.splice(u,1)}const P=()=>{try{if(n.isWindows){const a=(0,I.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:S})};v.app.once("quit",P),await this.quit(!0)&&v.app.removeListener("quit",P)}async kill(b){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,R.timeout)(1e3),(async()=>{for(const S of v.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let P;S.webContents&&!S.webContents.isDestroyed()?P=new Promise(l=>S.once("closed",l)):P=Promise.resolve(),S.destroy(),await P}})()]),v.app.exit(b)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=ge([te(0,E.ILogService),te(1,m.IStateMainService)],t),e.LifecycleMainService=t}),define(Q[201],Z([0,1,4,2,5,20]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let n=class extends R.Disposable{constructor(f){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,f.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const f=await new Promise((y,E)=>{$(["native-keymap"],y,E)});this._keyboardLayoutData=I(f),f.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(f),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};n=ge([te(0,C.ILifecycleMainService)],n),e.KeyboardLayoutMainService=n;function I(h){const f=h.getKeyMap(),y=h.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:y}}}),define(Q[98],Z([0,1,9,4,2,63,13,86,5]),function($,e,v,R,M,C,n,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,h.createDecorator)("storageService");var y;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(b){b[b.GLOBAL=0]="GLOBAL",b[b.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var m;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class p extends M.Disposable{constructor(S={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new M.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,M.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,P){P===f?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:P,target:this.getKeyTargets(S)[P]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,P,l){return this.getStorage(P)?.get(S,l)}getBoolean(S,P,l){return this.getStorage(P)?.getBoolean(S,l)}getNumber(S,P,l){return this.getStorage(P)?.getNumber(S,l)}store(S,P,l,a){if((0,n.isUndefinedOrNull)(P)){this.remove(S,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,l,a),this.getStorage(l)?.set(S,P)})}remove(S,P){this.withPausedEmitters(()=>{this.updateKeyTarget(S,P,void 0),this.getStorage(P)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,P){const l=[],a=this.getKeyTargets(S);for(const u of Object.keys(a))a[u]===P&&l.push(u);return l}updateKeyTarget(S,P,l){const a=this.getKeyTargets(P);typeof l=="number"?a[S]!==l&&(a[S]=l,this.getStorage(P)?.set(f,JSON.stringify(a))):typeof a[S]=="number"&&(delete a[S],this.getStorage(P)?.set(f,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const P=this.get(f,S);if(P)try{return JSON.parse(P)}catch(l){}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=y.NONE){this._onWillSaveState.fire({reason:S});const P=this.getStorage(0),l=this.getStorage(1);switch(S){case y.NONE:await v.Promises.settled([P?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await v.Promises.settled([P?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async logStorage(){const S=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return w(S,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends p{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=t;async function w(b,S,P,l){const a=d=>{try{return JSON.parse(d)}catch(g){return d}},u=new Map,s=new Map;b.forEach((d,g)=>{u.set(g,d),s.set(g,a(d))});const c=new Map,i=new Map;S.forEach((d,g)=>{c.set(g,d),i.set(g,a(d))}),console.group(`Storage: Global (path: ${P})`);let r=[];u.forEach((d,g)=>{r.push({key:g,value:d})}),console.table(r),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${l})`);let o=[];c.forEach((d,g)=>{o.push({key:g,value:d})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=w}),define(Q[202],Z([0,1,3,34,7,31]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function n(f){if(v.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function I(f,y,E,m,p,t,w,b,S,P){const l=Object.create(null);l["common.machineId"]=w,l.sessionID=(0,C.generateUuid)()+Date.now(),l.commitHash=p,l.version=t,l["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,v.PlatformToString)(v.platform),l["common.nodePlatform"]=R.platform,l["common.nodeArch"]=m,l["common.product"]=P||"desktop";const a=h(b||[]);a&&(l["common.msftInternal"]=a);let u=0;const s=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),v.isLinuxSnap&&(l["common.snap"]="true");const c=n(E);c&&(l["common.platformDetail"]=c);try{const i=await f.readFile(M.URI.file(S));l["common.source"]=i.value.toString().slice(0,30)}catch(i){}return l}e.resolveCommonProperties=I;function h(f){const y=R.env.USERDNSDOMAIN;if(!y)return!1;const E=y.toLowerCase();return f.some(m=>E===m)}e.verifyMicrosoftInternalDomain=h}),define(Q[29],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var M;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(M=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[203],Z([0,1,26,69,9,39,10,8,3,7,71,21,83,74,18,22,29]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function S(s,c){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,d=2e4;function g(A,W,V,ee){const oe=W.substring(A.length+1);return M.Promises.withAsyncBody(async ae=>{let K;try{K=await E.Promises.readdir(W,{withFileTypes:!0})}catch(G){ae();return}if(ee.count>=d){ee.count+=K.length,ee.maxReached=!0,ae();return}let F=K.length;if(F===0){ae();return}let U=K;ee.count+K.length>d&&(ee.maxReached=!0,F=d-ee.count,U=K.slice(0,F)),ee.count+=K.length;for(const G of U)if(G.isDirectory()){if(V.includes(G.name)||await g(A,(0,I.join)(W,G.name),V,ee),--F==0){ae();return}}else{const Y=G.name.lastIndexOf(".");if(Y>=0){const q=G.name.substring(Y+1);q&&r.set(q,(r.get(q)??0)+1)}for(const q of i)q.relativePathPattern?.test(oe)!==!1&&q.filePattern.test(G.name)&&o.set(q.tag,(o.get(q.tag)??0)+1);if(--F==0){ae();return}}})}const k={count:0,maxReached:!1};await g(s,s,c,k);const L=await a(s);return{configFiles:P(o),fileTypes:P(r),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=S;function P(s){return[...R.Iterable.map(s.entries(),([c,i])=>({name:c,count:i}))].sort((c,i)=>i.count-c.count)}function l(){const s={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},c=v.cpus();return c&&c.length>0&&(s.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),s}e.getMachineInfo=l;async function a(s){try{const c=new Map,i=(0,I.join)(s,".vscode","launch.json"),r=await E.Promises.readFile(i),o=[],d=(0,C.parse)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,C.getNodeType)(d)==="object"&&d.configurations)for(const g of d.configurations){const k=g.type;k&&(c.has(k)?c.set(k,c.get(k)+1):c.set(k,1))}return P(c)}catch(c){return[]}}e.collectLaunchConfigs=a;let u=class{constructor(c,i){this.telemetryService=c,this.productService=i}formatMachineInfo(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}formatEnvironment(c){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const r=v.cpus();return r&&r.length>0&&i.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),i.push(`Memory (System):  ${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||i.push(`Load (avg):       ${v.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,m.listProcesses)(c.mainPID),this.formatWorkspaceMetadata(c)]).then(async r=>{let[o,d]=r,g=this.formatProcessList(c,o);return i.forEach(k=>{if((0,p.isRemoteDiagnosticError)(k))g+=`
${k.errorMessage}`,d+=`
${k.errorMessage}`;else if(g+=`

Remote: ${k.hostName}`,k.processes&&(g+=`
${this.formatProcessList(c,k.processes)}`),k.workspaceMetadata){d+=`
|  Remote: ${k.hostName}`;for(const L of Object.keys(k.workspaceMetadata)){const A=k.workspaceMetadata[L];let W=`${A.fileCount} files`;A.maxFilesReached&&(W=`more than ${W}`),d+=`|    Folder (${L}): ${W}`,d+=this.formatWorkspaceStats(A)}}}),{processInfo:g,workspaceInfo:d}})}async getSystemInfo(c,i){const{memory:r,vmHint:o,os:d,cpus:g}=l(),k={os:d,memory:r,cpus:g,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return h.isWindows||(k.load=`${v.loadavg().map(L=>Math.round(L)).join(", ")}`),h.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(c,i){const r=[];return(0,m.listProcesses)(c.mainPID).then(async o=>(r.push(""),r.push(this.formatEnvironment(c)),r.push(""),r.push(this.formatProcessList(c,o)),c.windows.some(d=>d.folderURIs&&d.folderURIs.length>0&&!d.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(c))),i.forEach(d=>{if((0,p.isRemoteDiagnosticError)(d))r.push(`
${d.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${d.hostName}`),r.push(this.formatMachineInfo(d.machineInfo)),d.processes&&r.push(this.formatProcessList(c,d.processes)),d.workspaceMetadata)for(const g of Object.keys(d.workspaceMetadata)){const k=d.workspaceMetadata[g];let L=`${k.fileCount} files`;k.maxFilesReached&&(L=`more than ${L}`),r.push(`Folder (${g}): ${L}`),r.push(this.formatWorkspaceStats(k))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(c){const i=[],r=60;let o=0;const d=(A,W)=>{const V=` ${A}(${W})`;o+V.length>r?(i.push(g),g="|                 ",o=g.length):o+=V.length,g+=V};let g="|      File types:";const k=10;let L=c.fileTypes.length>k?k:c.fileTypes.length;for(let A=0;A<L;A++){const W=c.fileTypes[A];d(W.name,W.count)}if(i.push(g),c.configFiles.length>=0&&(g="|      Conf files:",o=0,c.configFiles.forEach(A=>{d(A.name,A.count)}),i.push(g)),c.launchConfigFiles.length>0){let A="|      Launch Configs:";c.launchConfigFiles.forEach(W=>{A+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),i.push(A)}return i.join(`
`)}expandGPUFeatures(c){const i=Math.max(...Object.keys(c).map(r=>r.length));return Object.keys(c).map(r=>`${r}:  ${" ".repeat(i-r.length)}  ${c[r]}`).join(`
                  `)}formatWorkspaceMetadata(c){const i=[],r=[];return c.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(d=>{const g=f.URI.revive(d);if(g.scheme===n.Schemas.file){const k=g.fsPath;r.push(S(k,["node_modules",".git"]).then(L=>{let A=`${L.fileCount} files`;L.maxFilesReached&&(A=`more than ${A}`),i.push(`|    Folder (${(0,I.basename)(k)}): ${A}`),i.push(this.formatWorkspaceStats(L))}).catch(L=>{i.push(`|      Error: Unable to collect workspace stats for folder ${k} (${L.toString()})`)}))}else i.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(c,i){const r=new Map;c.windows.forEach(d=>r.set(d.pid,d.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(c.mainPID,r,o,i,0),o.join(`
`)}formatProcessItem(c,i,r,o,d){const g=d===0;let k;g?k=o.pid===c?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(d)} ${o.name}`,o.name==="window"&&(k=`${k} (${i.get(o.pid)})`));const L=process.platform==="win32"?o.mem:v.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(L/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(o.children)&&o.children.forEach(A=>this.formatProcessItem(c,i,r,A,d+1))}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const r=f.URI.revive(i);if(r.scheme!==n.Schemas.file)continue;const o=r.fsPath;try{const d=await S(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),d.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:g.name,count:g.count})}),d.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:g.name,count:g.count})}),d.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};u=ge([te(0,b.ITelemetryService),te(1,w.IProductService)],u),e.DiagnosticsService=u}),define(Q[204],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(C){this.appenders=C}listen(C,n){throw new Error(`Event not found: ${n}`)}call(C,n,{eventName:I,data:h}){return this.appenders.forEach(f=>f.log(I,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class R{constructor(C){this.channel=C}log(C,n){return this.channel.call("log",{eventName:C,data:n}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Q[65],Z([0,1,47,13,19,29]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class n{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(S,P){return Promise.resolve(void 0)}publicLog2(S,P){return this.publicLog(S,P)}publicLogError(S,P){return Promise.resolve(void 0)}publicLogError2(S,P){return this.publicLogError(S,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=n,e.NullTelemetryService=new n;class I{async publicLog(S,P,l){}async publicLogError(S,P,l){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(b,S){return S.onDidChangeConfiguration(P=>{P.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=h;function f(b,S){return!(S.disableTelemetry||!b.enableTelemetry)}e.supportsTelemetry=f;function y(b){const S=b.getValue(C.TELEMETRY_SETTING_ID),P=b.getValue("telemetry.enableCrashReporter");if(b.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(S??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function E(b){const S=Object.create(null),P=Object.create(null),l=Object.create(null);p(b,l);for(let a in l){a=a.length>150?a.substr(a.length-149):a;const u=l[a];typeof u=="number"?P[a]=u:typeof u=="boolean"?P[a]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${u.length}`),S[a]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(S[a]=u)}return{properties:S,measurements:P}}e.validateTelemetryData=E;function m(b){if(!b)return"none";let S="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(l=>{b.indexOf(`${l}+`)===0&&(S=l)}),S}e.cleanRemoteAuthority=m;function p(b,S,P=0,l){if(!!b)for(let a of Object.getOwnPropertyNames(b)){const u=b[a],s=l?l+a:a;Array.isArray(u)?S[s]=(0,v.safeStringify)(u):u instanceof Date?S[s]=u.toISOString():(0,R.isObject)(u)?P<2?p(u,S,P+1,s+"."):S[s]=(0,v.safeStringify)(u):S[s]=u}}function t(b){if(!b)return[];const S=[];return w(S,"",b),S}function w(b,S,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(l=>w(b,S?`${S}.${l}`:l,P[l])):b.push(S)}}),define(Q[205],Z([0,1,30,23,16,47,3,34,13,7,19,48,169,196,166,18,6,22,50,199,98,29,65]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const c=n.isWeb?"web":(0,m.getTargetPlatform)(n.platform,I.arch);var i;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(i||(i={}));function r(...N){return String(N.reduce((H,ie)=>H|ie,0))}var o;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const d={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},g={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},L={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class A{constructor(H=L){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,ie=this.state.pageSize){return new A({...this.state,pageNumber:H,pageSize:ie})}withFilter(H,...ie){const re=[...this.state.criteria,...ie.length?ie.map(se=>({filterType:H,value:se})):[{filterType:H}]];return new A({...this.state,criteria:re})}withSortBy(H){return new A({...this.state,sortBy:H})}withSortOrder(H){return new A({...this.state,sortOrder:H})}withFlags(...H){return new A({...this.state,flags:H.reduce((ie,re)=>ie|re,0)})}withAssetTypes(...H){return new A({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:ie,pageSize:re,sortBy:se,sortOrder:x,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:H,pageNumber:ie,pageSize:re,sortBy:se,sortOrder:x}],assetTypes:le,flags:ce}}get searchText(){const H=this.state.criteria.filter(ie=>ie.filterType===o.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function W(N,H){const ie=(N||[]).filter(re=>re.statisticName===H)[0];return ie?ie.value:0}function V(N){const H="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(re=>re.assetType.indexOf(H)===0).reduce((re,se)=>{const x=K(N,se.assetType);return x&&re.push([se.assetType.substring(H.length),x]),re},[])}function ee(N){if(N.properties){const H=N.properties.filter(se=>se.key===d.Repository),ie=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=H.filter(se=>ie.test(se.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return K(N,d.Repository)}function oe(N){return{uri:`${N.fallbackAssetUri}/${d.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${d.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function ae(N){const H=K(N,d.Icon);if(H)return H;const ie=m.DefaultIconPath;return{uri:ie,fallbackUri:ie}}function K(N,H){return N.files.filter(re=>re.assetType===H)[0]?{uri:`${N.assetUri}/${H}`,fallbackUri:`${N.fallbackAssetUri}/${H}`}:null}function F(N,H){const ie=N.properties?N.properties.filter(se=>se.key===H):[],re=ie.length>0&&ie[0].value;return re?re.split(",").map(se=>(0,p.adoptToGalleryExtensionId)(se)):[]}function U(N){const H=N.properties?N.properties.filter(ie=>ie.key===g.Engine):[];return H.length>0&&H[0].value||""}function G(N){const H=N.properties?N.properties.filter(ie=>ie.key===g.PreRelease):[];return H.length>0&&H[0].value==="true"}function Y(N){const H=N.properties?N.properties.filter(re=>re.key===g.LocalizedLanguages):[],ie=H.length>0&&H[0].value||"";return ie?ie.split(","):[]}function q(N){return N.indexOf("preview")!==-1}function z(N){return N.targetPlatform?(0,m.toTargetPlatform)(N.targetPlatform):"undefined"}function J(N){const H=(0,v.distinct)(N.versions.map(z)),ie=!!N.tags?.includes(m.WEB_EXTENSION_TAG),re=H.indexOf("web");return ie?re===-1&&H.push("web"):re!==-1&&H.splice(re,1),H}function O(N,H){const ie=(0,m.getFallbackTargetPlarforms)(H);for(let re=0;re<N.length;re++){const se=N[re];if(se.version===N[re-1]?.version){let x=re;const ce=z(se);if(ce===H)for(;x>0&&N[x-1].version===se.version;)x--;else if(ie.includes(ce))for(;x>0&&N[x-1].version===se.version&&z(N[x-1])!==H;)x--;x!==re&&(N.splice(re,1),N.splice(x,0,se))}}return N}e.sortExtensionVersions=O;function D(N,H,ie,re){const se=N.versions[0],x={manifest:K(H,d.Manifest),readme:K(H,d.Details),changelog:K(H,d.Changelog),license:K(H,d.License),repository:ee(H),download:oe(H),icon:ae(H),coreTranslations:V(H)};return{identifier:{id:(0,p.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:H.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:W(N.statistics,"install"),rating:W(N.statistics,"averagerating"),ratingCount:W(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:ie,assets:x,properties:{dependencies:F(H,g.Dependency),extensionPack:F(H,g.ExtensionPack),engine:U(H),localizedLanguages:Y(H),targetPlatform:z(H),isPreReleaseVersion:G(H)},hasPreReleaseVersion:G(se),preview:q(N.flags),telemetryData:re}}let T=class{constructor(H,ie,re,se,x,ce,le,he){this.requestService=ie,this.logService=re,this.environmentService=se,this.telemetryService=x,this.fileService=ce,this.productService=le,this.configurationService=he;const me=le.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=X(le.version,le,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,ie,re){const se=(0,h.isBoolean)(ie)?ie:!1,x=(0,h.isBoolean)(ie)?re:ie;let ce=new A().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,H.length).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionName,...H.map(({id:me})=>me.toLowerCase()));H.every(me=>!me.version)&&(ce=ce.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,c,R.CancellationToken.None),he=le.map(me=>{const be=(0,p.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName);return{rawGalleryExtension:me,version:H.find(de=>(0,p.areSameExtensions)(de,{id:be}))?.version}});return this.converToGalleryExtensions(he,se,c,()=>{},x)}async getCompatibleExtension(H,ie,re){const se=(0,m.isIExtensionIdentifier)(H)?null:H;if(se){if((0,m.isNotWebExtensionInWebTargetPlatform)(se.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(se,ie,re))return se}const{id:x,uuid:ce}=se?se.identifier:H;let le=new A().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");ce?le=le.withFilter(o.ExtensionId,ce):le=le.withFilter(o.ExtensionName,x);const{galleryExtensions:he}=await this.queryGallery(le,re,R.CancellationToken.None),[me]=he;if(!me||!me.versions.length)return null;const be=J(me);if((0,m.isNotWebExtensionInWebTargetPlatform)(be,re))return null;for(let de of me.versions){if(!U(de)){const fe=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:g.Engine,value:fe}]}}if(await this.isRawExtensionVersionCompatible(de,ie,be,re))return D(me,de,be)}return null}async isExtensionCompatible(H,ie,re){if(!(0,m.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re)||!ie&&H.properties.isPreReleaseVersion)return!1;let se=H.properties.engine;if(!se){const x=await this.getManifest(H,R.CancellationToken.None);if(!x)throw new Error("Manifest was not found");se=x.engines.vscode}return(0,t.isEngineValid)(se,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,ie,re,se){if(!(0,m.isTargetPlatformCompatible)(z(H),re,se)||!ie&&G(H))return!1;const x=await this.getEngine(H);return(0,t.isEngineValid)(x,this.productService.version,this.productService.date)}async query(H,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let re=H.text||"";const se=(0,C.getOrDefault)(H,de=>de.pageSize,50);let x=new A().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(o.Target,"Microsoft.VisualStudio.Code");re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,fe,Se)=>(x=x.withFilter(o.Category,Se||fe),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,fe,Se)=>(x=x.withFilter(o.Tag,Se||fe),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(x=x.withFilter(o.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),x=x.withFilter(o.SearchText,re)),x=x.withSortBy(0)):H.ids?x=x.withFilter(o.ExtensionId,...H.ids):H.names?x=x.withFilter(o.ExtensionName,...H.names):x=x.withSortBy(4),typeof H.sortBy=="number"&&(x=x.withSortBy(H.sortBy)),typeof H.sortOrder=="number"&&(x=x.withSortOrder(H.sortOrder));const{galleryExtensions:ce,total:le}=await this.queryGallery(x,c,ie),he=de=>({index:(x.pageNumber-1)*x.pageSize+de,querySource:H.source}),me=await this.converToGalleryExtensions(ce.map(de=>({rawGalleryExtension:de})),!!H.includePreRelease,c,he,ie),be=async(de,fe)=>{if(fe.isCancellationRequested)throw(0,M.canceled)();const Se=x.withPage(de+1),{galleryExtensions:Ce}=await this.queryGallery(Se,c,fe);return await this.converToGalleryExtensions(Ce.map(Le=>({rawGalleryExtension:Le})),!!H.includePreRelease,c,he,ie)};return{firstPage:me,total:le,pageSize:x.pageSize,getPage:be}}async converToGalleryExtensions(H,ie,re,se,x){const ce=(me,be)=>{const de=J(me);let fe=me.versions[0];return fe=me.versions.find(Se=>Se.version===fe.version&&(0,m.isTargetPlatformCompatible)(z(Se),de,re))||fe,!ie&&G(fe)&&(fe=me.versions.find(Se=>Se.version!==fe.version&&!G(Se))||fe),D(me,fe,de,se(be))},le=[],he=new Map;for(let me=0;me<H.length;me++){const{rawGalleryExtension:be,version:de}=H[me];if(de){const fe=be.versions.find(Se=>Se.version===de);fe&&le.push([me,D(be,fe,J(be))])}else{const fe=ce(be,me);fe.properties.isPreReleaseVersion&&!ie?he.set(fe.identifier.uuid,me):le.push([me,fe])}}if(he.size){const me=new A().withFlags(i.IncludeVersions,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,he.size).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionId,...he.keys()),{galleryExtensions:be}=await this.queryGallery(me,re,x);if(be.length!==he.size)throw new Error("Not all extensions with latest versions are returned");for(const de of be){const fe=he.get(de.extensionId),Se=ce(de,fe);le.push([fe,Se])}}return le.sort((me,be)=>me[0]-be[0]).map(([,me])=>me)}async queryGallery(H,ie,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,i.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,r(i.Unpublished));const se=await this.commonHeadersPromise,x=JSON.stringify(H.raw),ce={...se,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},le=new Date().getTime();let he,me,be=0;try{if(he=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:x,headers:ce},re),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:be};const de=await(0,P.asJson)(he);if(de){const fe=de.results[0],Se=fe.extensions;Se.forEach(Le=>O(Le.versions,ie));const Ce=fe.resultMetadata&&fe.resultMetadata.filter(Le=>Le.metadataType==="ResultCount")[0];return be=Ce&&Ce.metadataItems.filter(Le=>Le.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:be}}return{galleryExtensions:[],total:be}}catch(de){throw me=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(x.length),duration:new Date().getTime()-le,success:!!he&&(0,P.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:me?(0,M.isPromiseCanceledError)(me)?"canceled":(0,M.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(be)})}}async reportStatistic(H,ie,re,se){if(!this.isEnabled())return;const x=n.isWeb?this.api(`/itemName/${H}.${ie}/version/${re}/statType/${se==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${ie}/${re}/stats?statType=${se}`),ce=n.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:x,headers:he},R.CancellationToken.None)}catch(me){}}async download(H,ie,re){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const se=(0,p.getGalleryExtensionTelemetryData)(H),x=new Date().getTime(),ce=be=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...se,duration:be}),le=re===1?"install":re===2?"update":"",he=le?{uri:`${H.assets.download.uri}${f.URI.parse(H.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${H.assets.download.fallbackUri}${f.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:H.assets.download,me=await this.getAsset(he);await this.fileService.writeFile(ie,me.stream),ce(new Date().getTime()-x)}async getReadme(H,ie){if(H.assets.readme){const re=await this.getAsset(H.assets.readme,{},ie);return await(0,P.asText)(re)||""}return""}async getManifest(H,ie){if(H.assets.manifest){const re=await this.getAsset(H.assets.manifest,{},ie),se=await(0,P.asText)(re);return se?JSON.parse(se):null}return null}async getManifestFromRawExtensionVersion(H,ie){const re=K(H,d.Manifest);if(!re)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},x=await this.getAsset(re,{headers:se});return await(0,P.asJson)(x)}async getCoreTranslation(H,ie){const re=H.assets.coreTranslations.filter(se=>se[0]===ie.toUpperCase())[0];if(re){const se=await this.getAsset(re[1]),x=await(0,P.asText)(se);return x?JSON.parse(x):null}return null}async getChangelog(H,ie){if(H.assets.changelog){const re=await this.getAsset(H.assets.changelog,{},ie);return await(0,P.asText)(re)||""}return""}async getAllCompatibleVersions(H,ie,re){let se=new A().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?se=se.withFilter(o.ExtensionId,H.identifier.uuid):se=se.withFilter(o.ExtensionName,H.identifier.id);const{galleryExtensions:x}=await this.queryGallery(se,re,R.CancellationToken.None);if(!x.length)return[];const ce=J(x[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(ce,re))return[];const le=[];for(const he of x[0].versions)try{le[le.length-1]?.version!==he.version&&await this.isRawExtensionVersionCompatible(he,ie,ce,re)&&le.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:G(he)})}catch(me){}return le}async getAsset(H,ie={},re=R.CancellationToken.None){const se=await this.commonHeadersPromise,x={type:"GET"},ce={...se,...ie.headers||{}};ie={...ie,...x,headers:ce};const le=H.uri,he=H.fallbackUri,me={...ie,url:le};try{const be=await this.requestService.request(me,re);if(be.res.statusCode===200)return be;const de=await(0,P.asText)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${de}`)}catch(be){if((0,M.isPromiseCanceledError)(be))throw be;const de=(0,M.getErrorMessage)(be);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:de});const fe={...ie,url:he};return this.requestService.request(fe,re)}}async getEngine(H){let ie=U(H);if(!ie){const re=await this.getManifestFromRawExtensionVersion(H,R.CancellationToken.None);if(!re)throw new Error("Manifest was not found");ie=re.engines.vscode}return ie}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const ie=await(0,P.asJson)(H),re=new Map;if(ie)for(const se of ie.malicious){const x=re.get(se)||{id:{id:se},malicious:!0,slow:!1};x.malicious=!0,re.set(se,x)}return[...re.values()]}};T=ge([te(1,P.IRequestService),te(2,b.ILogService),te(3,E.IEnvironmentService),te(4,u.ITelemetryService),te(5,w.IFileService),te(6,S.IProductService),te(7,y.IConfigurationService)],T);let _=class extends T{constructor(H,ie,re,se,x,ce,le,he){super(H,ie,re,se,x,ce,le,he)}};_=ge([te(0,a.IStorageService),te(1,P.IRequestService),te(2,b.ILogService),te(3,E.IEnvironmentService),te(4,u.ITelemetryService),te(5,w.IFileService),te(6,S.IProductService),te(7,y.IConfigurationService)],_),e.ExtensionGalleryService=_;let B=class extends T{constructor(H,ie,re,se,x,ce,le){super(void 0,H,ie,re,se,x,ce,le)}};B=ge([te(0,P.IRequestService),te(1,b.ILogService),te(2,E.IEnvironmentService),te(3,u.ITelemetryService),te(4,w.IFileService),te(5,S.IProductService),te(6,y.IConfigurationService)],B),e.ExtensionGalleryServiceWithNoStorageService=B;async function X(N,H,ie,re,se,x){const ce={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},le=await(0,l.getServiceMachineId)(ie,se,x);return(0,s.supportsTelemetry)(H,ie)&&(0,s.getTelemetryLevel)(re)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=X}),define(Q[206],Z([0,1,2,47,3,25,152,19,49,56,37,29,65]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(b,S){this._configurationService=S,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=b.appenders,this._commonProperties=b.commonProperties||Promise.resolve({}),this._piiPaths=b.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!b.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const l=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!l})})}setExperimentProperty(b,S){this._experimentProperties[b]=S}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const b=await this._commonProperties;let S=b.sessionID,P=b["common.machineId"],l=b["common.firstSessionDate"],a=b["common.msftInternal"];return{sessionId:S,machineId:P,firstSessionDate:l,msftInternal:a}}dispose(){this._disposables.dispose()}_log(b,S,P,l){return this.telemetryLevel<S?Promise.resolve(void 0):this._commonProperties.then(a=>{P=(0,R.mixin)(P,a),P=(0,R.mixin)(P,this._experimentProperties),P=(0,R.cloneAndChange)(P,u=>{if(typeof u=="string")return this._cleanupInfo(u,l)}),this._appenders.forEach(u=>u.log(b,P))},a=>{console.error(a)})}publicLog(b,S,P){return this._log(b,3,S,P)}publicLog2(b,S,P){return this.publicLog(b,S,P)}publicLogError(b,S){return this.sendErrorTelemetry?this._log(b,2,S,!0):Promise.resolve(void 0)}publicLogError2(b,S){return this.publicLogError(b,S)}_anonymizeFilePaths(b){let S=b;const P=[];for(let s of this._cleanupPatterns)for(;;){const c=s.exec(b);if(!c)break;P.push([c.index,s.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(S="";;){const s=a.exec(b);if(!s)break;!l.test(s[0])&&P.every(([c,i])=>s.index<c||s.index>=i)&&(S+=b.substring(u,s.index)+"<REDACTED: user-file-path>",u=a.lastIndex)}return u<b.length&&(S+=b.substr(u)),S}_removePropertiesWithPossibleUserInfo(b){if(!b)return b;const S=b.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(S)?"<REDACTED: secret>":P.test(S)?"<REDACTED: email>":b}_cleanupInfo(b,S){let P=b;S&&(P=this._anonymizeFilePaths(P));for(let l of this._cleanupPatterns)P=P.replace(l,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ge([te(1,I.IConfigurationService)],p),e.TelemetryService=p;function t(){const w=(0,n.localize)(0,null,f.default.nameLong),b=f.default.privacyStatementUrl?(0,n.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,n.localize)(1,null,"https://aka.ms/vscode-telemetry"),S=M.isWeb?"":(0,n.localize)(3,null),P=(0,n.localize)(4,null),l=(0,n.localize)(5,null),a=(0,n.localize)(6,null),u=(0,n.localize)(7,null),s=`
|       | ${P} | ${l} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,n.localize)(8,null);return`
${w} ${b} ${S}

&nbsp;

${u}
${s}

&nbsp;

${c}
`}y.Registry.as(h.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,n.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,n.localize)(10,null),(0,n.localize)(11,null),(0,n.localize)(12,null),(0,n.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(h.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,n.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,n.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,n.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,n.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[207],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Q[208],Z([0,1,109,4,2,5,37,207]),function($,e,v,R,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var h;(function(b){function S(P){return P&&typeof P=="object"&&typeof P.id=="string"}b.isThemeColor=S})(h=e.ThemeColor||(e.ThemeColor={}));function f(b){return{id:b}}e.themeColorFromId=f;var y;(function(b){function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||h.isThemeColor(i.color))}b.isThemeIcon=S;const P=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function l(i){const r=P.exec(i);if(!r)return;let[,o]=r;return{id:o}}b.fromString=l;function a(i,r){let o=i.id;const d=o.lastIndexOf("~");return d!==-1&&(o=o.substring(0,d)),r&&(o=`${o}~${r}`),{id:o}}b.modify=a;function u(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}b.getModifier=u;function s(i,r){return i.id===r.id&&i.color?.id===r.color?.id}b.isEqual=s;function c(i,r){return{id:i.id,color:r?f(r):void 0}}b.asThemeIcon=c,b.asClassNameArray=v.CSSIcon.asClassNameArray,b.asClassName=v.CSSIcon.asClassName,b.asCSSSelector=v.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function E(b){switch(b){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new R.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,M.toDisposable)(()=>{const P=this.themingParticipants.indexOf(S);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new m;n.Registry.add(e.Extensions.ThemingContribution,p);function t(b){return p.onColorThemeChange(b)}e.registerThemingParticipant=t;class w extends M.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,P){let l=this.theme.getColor(S);return l&&P&&(l=P(l,this.theme)),l?l.toString():null}}e.Themable=w}),define(Q[66],Z([0,1,14,3,5,38]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const n="#FFFFFF",I="#1E1E1E",h="#000000",f="theme",y="themeBackground",E="windowSplash";e.IThemeMainService=(0,M.createDecorator)("themeMainService");let m=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((R.isWindows||R.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return h;let t=this.stateMainService.getItem(y,null);if(!t){let w;(R.isWindows||R.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?w="hc-black":w=this.stateMainService.getItem(f,"vs-dark").split(" ")[0],t=w==="hc-black"?h:w==="vs"?n:I}return R.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,w){this.stateMainService.setItems([{key:f,data:w.baseTheme},{key:y,data:w.colorInfo.background},{key:E,data:w}]),typeof t=="number"&&this.updateBackgroundColor(t,w)}updateBackgroundColor(t,w){for(const b of v.BrowserWindow.getAllWindows())if(b.id===t){b.setBackgroundColor(w.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};m=ge([te(0,C.IStateMainService)],m),e.ThemeMainService=m}),define(Q[41],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(R=e.StateType||(e.StateType={}));var M;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(M=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,n)=>({type:"idle",updateType:C,error:n}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Q[209],Z([0,1,3,153,49,37]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[210],Z([0,1,4,41]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class M{constructor(I){this.service=I}listen(I,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(I,h,f){switch(h){case"checkForUpdates":return this.service.checkForUpdates(f);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=M;class C{constructor(I){this.channel=I,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(Q[99],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Q[211],Z([0,1,7]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(I){this.handler=I}listen(I,h){throw new Error(`Event not found: ${h}`)}call(I,h,f){switch(h){case"handleURL":return this.handler.handleURL(v.URI.revive(f[0]),f[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=R;class M{constructor(I){this.channel=I}handleURL(I,h){return this.channel.call("handleURL",[I.toJSON(),h])}}e.URLHandlerChannelClient=M;class C{constructor(I){this.next=I}async routeCall(I,h,f,y){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(f){const E=v.URI.revive(f);if(E&&E.query){const m=/\bwindowId=(\d+)/.exec(E.query);if(m){const p=m[1],t=new RegExp(`window:${p}`),w=I.connections.find(b=>t.test(b.ctx));if(w)return w}}}return this.next.routeCall(I,h,f,y)}routeEvent(I,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=C}),define(Q[212],Z([0,1,9,2,7,22]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class n extends R.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(f,y){const E=[...this.handlers.values()];return(0,v.first)(E.map(m=>()=>m.handleURL(f,y)),void 0,!1).then(m=>m||!1)}registerHandler(f){return this.handlers.add(f),(0,R.toDisposable)(()=>this.handlers.delete(f))}}e.AbstractURLService=n;let I=class extends n{constructor(f){super();this.productService=f}create(f){let{authority:y,path:E,query:m,fragment:p}=f||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&E&&E.indexOf("/")!==0&&(E=`/${E}`),M.URI.from({scheme:this.productService.urlProtocol,authority:y,path:E,query:m,fragment:p})}};I=ge([te(0,C.IProductService)],I),e.NativeURLService=I}),define(Q[213],Z([0,1,14,9,4,2,3,7]),function($,e,v,R,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(y){try{return I.URI.parse(y)}catch(E){return null}}class f{constructor(E,m,p,t,w){if(this.urlService=m,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=E,n.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),v.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,P)}const b=M.Event.map(M.Event.fromNodeEventEmitter(v.app,"open-url",(P,l)=>({event:P,url:l})),({event:P,url:l})=>(P.preventDefault(),l));this.disposables.add(b(P=>{const l=h(P);!l||this.urlService.open(l,{originalUrl:P})})),p.getWindows().filter(P=>P.isReady).length>0?this.flush():M.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const m of this.uris)await this.urlService.open(m.uri,{originalUrl:m.url})||E.push(m);E.length!==0&&(this.uris=E,this.flushDisposable=(0,R.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=f}),define(Q[214],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Q[215],Z([0,1,14,2,10,7]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends R.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(M.Schemas.vscodeWebview,h)}handleWebviewRequest(h,f){try{const y=C.URI.parse(h.url),E=n.validWebviewFilePaths.get(y.path);if(typeof E=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${E}`,p=M.FileAccess.asFileUri(m,$);return f(decodeURIComponent(p.fsPath))}else return f({error:-10})}catch{}return f({error:-2})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Q[67],Z([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(f){return!!f.workspaceUri}e.isWorkspaceToOpen=R;function M(f){return!!f.folderUri}e.isFolderToOpen=M;function C(f){return!!f.fileUri}e.isFileToOpen=C;function n(f){const y=I(f),E=f.getValue("window.menuBarVisibility");return E==="default"||y==="native"&&E==="compact"||v.isMacintosh&&v.isNative?"classic":E}e.getMenuBarVisibility=n;function I(f){if(v.isWeb)return"custom";const y=f.getValue("window");if(y){if(v.isMacintosh&&y.nativeTabs===!0||v.isMacintosh&&y.nativeFullScreen===!1)return"native";const p=f.getValue("workbench.colorCustomizations");if(p?.["window.activeBorder"]||p?.["window.inactiveBorder"])return"custom";const t=y.titleBarStyle;if(t==="native"||t==="custom")return t}return v.isLinux?"native":"custom"}e.getTitleBarStyle=I;function h(f=0){return Math.pow(1.2,f)}e.zoomLevelToZoomFactor=h}),define(Q[36],Z([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var R;(function(f){f[f.INITIAL=1]="INITIAL",f[f.LOAD=2]="LOAD",f[f.RELOAD=3]="RELOAD"})(R=e.LoadReason||(e.LoadReason={}));var M;(function(f){f[f.CLOSE=1]="CLOSE",f[f.QUIT=2]="QUIT",f[f.RELOAD=3]="RELOAD",f[f.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));var C;(function(f){f[f.CLI=0]="CLI",f[f.DOCK=1]="DOCK",f[f.MENU=2]="MENU",f[f.DIALOG=3]="DIALOG",f[f.DESKTOP=4]="DESKTOP",f[f.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const n=function(f=1){return{width:1024,height:768,mode:f}};e.defaultWindowState=n;var I;(function(f){f[f.Maximized=0]="Maximized",f[f.Normal=1]="Normal",f[f.Minimized=2]="Minimized",f[f.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var h;(function(f){f[f.UNRESPONSIVE=1]="UNRESPONSIVE",f[f.CRASHED=2]="CRASHED",f[f.LOAD=3]="LOAD"})(h=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(Q[216],Z([0,1,14,4,2,215,36]),function($,e,v,R,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends M.Disposable{constructor(f){super();this.windowsMainService=f,this._onFoundInFrame=this._register(new R.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(f,y){let E;if(typeof f.windowId=="number"){const{windowId:m}=f,p=this.windowsMainService.getWindowById(m);if(!p?.win)throw new Error(`Invalid windowId: ${m}`);E=p.win.webContents}else{const{webContentsId:m}=f;if(E=v.webContents.fromId(m),!E)throw new Error(`Invalid webContentsId: ${m}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(y)}async findInFrame(f,y,E,m){const p=this.getFrameByName(f,y),t=p;if(typeof t.findInFrame=="function"){t.findInFrame(E,{findNext:m.findNext,forward:m.forward});const w=(b,S)=>{S.finalUpdate&&(this._onFoundInFrame.fire(S),p.removeListener("found-in-frame",w))};p.on("found-in-frame",w)}}async stopFindInFrame(f,y,E){const p=this.getFrameByName(f,y);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(E.keepSelection?"keepSelection":"clearSelection")}getFrameByName(f,y){const E=this.windowsMainService.getWindowById(f.windowId);if(!E?.win)throw new Error(`Invalid windowId: ${f}`);const m=E.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===y);if(!m)throw new Error(`Unknown frame: ${y}`);return m}};I=ge([te(0,n.IWindowsMainService)],I),e.WebviewMainService=I}),define(Q[217],Z([0,1,9,4,2]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends M.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:h,getActiveWindowId:f}){super();this.disposables=this._register(new M.DisposableStore),R.Event.latch(R.Event.any(I,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>f()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(Q[218],Z([0,1,40,15,7,5]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var n;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(n=e.WorkbenchState||(e.WorkbenchState={}));function I(m){const p=m;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=I;function h(m){const p=m;return!!(p&&typeof p=="object"&&M.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=h;class f{constructor(p,t,w,b,S){this._id=p,this._transient=w,this._configuration=b,this._ignorePathCasing=S,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class y{constructor(p,t){this.raw=t,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,R.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function E(m){return new y({uri:m,index:0,name:(0,R.basenameOrAuthority)(m)},{uri:m.toString()})}e.toWorkspaceFolder=E}),define(Q[27],Z([0,1,32,39,78,33,10,8,3,15,7,156,5,64,218]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(F){return(typeof F=="string"?(0,I.extname)(F):(0,f.extname)(F))===w}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function S(F){return F.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function P(F){return F.hasOwnProperty("folderUri")}e.isRecentFolder=P;function l(F){return F.hasOwnProperty("fileUri")}e.isRecentFile=l;function a(F){const U=F;return typeof U?.id=="string"&&y.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=a;function u(F){if(F.configuration)return{id:F.id,configPath:F.configuration};if(F.folders.length===1)return{id:F.id,uri:F.folders[0].uri}}e.toWorkspaceIdentifier=u;function s(F){const U=F;return typeof U?.id=="string"&&y.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=s;function c(F){const U=F;if(U?.uri)return{id:U.id,uri:y.URI.revive(U.uri)};const G=F;if(G?.configPath)return{id:G.id,configPath:y.URI.revive(G.configPath)};if(F?.id)return{id:F.id}}e.reviveIdentifier=c;function i(F,U){return f.extUriBiasedIgnorePathCase.isEqualOrParent(F,U.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function r(F){return o(F)||d(F)}e.isStoredWorkspaceFolder=r;function o(F){const U=F;return typeof U?.path=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=o;function d(F){const U=F;return typeof U?.uri=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=d;function g(F,U,G,Y,q=!h.isWindows,z){if(F.scheme!==Y.scheme)return{name:G,uri:F.toString(!0)};let J=U?void 0:z.relativePath(Y,F);if(J!==void 0)J.length===0?J=".":h.isWindows&&F.scheme===n.Schemas.file&&!q&&(J=J.replace(/\//g,"\\"));else if(F.scheme===n.Schemas.file)J=F.fsPath,h.isWindows&&(J=(0,C.normalizeDriveLetter)(J),q&&(J=(0,v.toSlashes)(J)));else{if(!z.isEqualAuthority(F.authority,Y.authority))return{name:G,uri:F.toString(!0)};J=F.path}return{name:G,path:J}}e.getStoredWorkspaceFolder=g;function k(F,U,G){let Y=[],q=new Set;const z=G.dirname(U);for(let J of F){let O;if(o(J))J.path&&(O=G.resolvePath(z,J.path));else if(d(J))try{O=y.URI.parse(J.uri),O.path[0]!=="/"&&(O=O.with({path:"/"+O.path}))}catch(D){console.warn(D)}if(O){let D=G.getComparisonKey(O);if(!q.has(D)){q.add(D);const T=J.name||G.basenameOrAuthority(O);Y.push(new t.WorkspaceFolder({uri:O,name:T,index:Y.length},J))}}}return Y}e.toWorkspaceFolders=k;function L(F,U,G,Y,q){let z=A(U,F);const J=q.dirname(U),O=q.dirname(Y),D=[],T=W(z.folders);for(const N of z.folders){const H=o(N)?q.resolvePath(J,N.path):y.URI.parse(N.uri);let ie;G?ie=!1:ie=!o(N)||(0,I.isAbsolute)(N.path),D.push(g(H,ie,N.name,O,T,q))}const _={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},B=M.setProperty(F,["folders"],D,_);let X=M.applyEdits(F,B);return(0,f.isEqualAuthority)(z.remoteAuthority,(0,p.getRemoteAuthority)(Y))&&(X=M.applyEdits(X,M.removeProperty(X,["remoteAuthority"],_))),X}e.rewriteWorkspaceFileForNewLocation=L;function A(F,U){let G=R.parse(U);if(G&&Array.isArray(G.folders))G.folders=G.folders.filter(Y=>r(Y));else throw new Error(`${F} looks like an invalid workspace file.`);return G}function W(F){return h.isWindows?F.some(U=>o(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=W;function V(F){return F.workspace&&typeof F.workspace=="object"&&typeof F.workspace.id=="string"&&typeof F.workspace.configPath=="string"}function ee(F){return typeof F.folderUri=="string"}function oe(F){return typeof F.fileUri=="string"}function ae(F,U){const G={workspaces:[],files:[]};if(F){const Y=function(z,J){for(let O=0;O<z.length;O++)try{J(z[O],O)}catch(D){U.warn(`Error restoring recent entry ${JSON.stringify(z[O])}: ${D.toString()}. Skip entry.`)}},q=F;if(Array.isArray(q.entries))Y(q.entries,z=>{const J=z.label,O=z.remoteAuthority;V(z)?G.workspaces.push({label:J,remoteAuthority:O,workspace:{id:z.workspace.id,configPath:y.URI.parse(z.workspace.configPath)}}):ee(z)?G.workspaces.push({label:J,remoteAuthority:O,folderUri:y.URI.parse(z.folderUri)}):oe(z)&&G.files.push({label:J,remoteAuthority:O,fileUri:y.URI.parse(z.fileUri)})});else{const z=F;Array.isArray(z.workspaces3)&&Y(z.workspaces3,(J,O)=>{const D=Array.isArray(z.workspaceLabels)&&z.workspaceLabels[O]||void 0;typeof J=="object"&&typeof J.id=="string"&&typeof J.configURIPath=="string"?G.workspaces.push({label:D,workspace:{id:J.id,configPath:y.URI.parse(J.configURIPath)}}):typeof J=="string"&&G.workspaces.push({label:D,folderUri:y.URI.parse(J)})}),Array.isArray(z.files2)&&Y(z.files2,(J,O)=>{const D=Array.isArray(z.fileLabels)&&z.fileLabels[O]||void 0;typeof J=="string"&&G.files.push({label:D,fileUri:y.URI.parse(J)})})}}return G}e.restoreRecentlyOpened=ae;function K(F){const U={entries:[]};for(const G of F.workspaces)P(G)?U.entries.push({folderUri:G.folderUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority}):U.entries.push({workspace:{id:G.workspace.id,configPath:G.workspace.configPath.toString()},label:G.label,remoteAuthority:G.remoteAuthority});for(const G of F.files)U.entries.push({fileUri:G.fileUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority});return U}e.toStoreData=K}),define(Q[51],Z([0,1,5,27]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function M(C){const n=C;return n&&(0,R.isWorkspaceIdentifier)(n.workspace)}e.isWorkspaceBackupInfo=M}),define(Q[52],Z([0,1,14,9,81,33,2,70,8,3,13,21,136,5,6,38,27]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let S=class vt{constructor(l,a){this.stateMainService=l,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new R.Queue}pickFileFolder(l,a){return this.doPick({...l,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},a)}pickFolder(l,a){return this.doPick({...l,pickFolders:!0,title:(0,m.localize)(1,null)},a)}pickFile(l,a){return this.doPick({...l,pickFiles:!0,title:(0,m.localize)(2,null)},a)}pickWorkspace(l,a){const u=(0,m.localize)(3,null),s=(0,C.mnemonicButtonLabel)((0,m.localize)(4,null)),c=b.WORKSPACE_FILTER;return this.doPick({...l,pickFiles:!0,title:u,filters:c,buttonLabel:s},a)}async doPick(l,a){const u={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters};u.defaultPath=l.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(u.properties=void 0,l.pickFiles&&l.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&u.properties.push("treatPackageAsDirectory");const s=a||v.BrowserWindow.getFocusedWindow(),c=await this.showOpenDialog(u,(0,y.withNullAsUndefined)(s));if(c&&c.filePaths&&c.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,(0,h.dirname)(c.filePaths[0])),c.filePaths}getWindowDialogQueue(l){if(l){let a=this.windowDialogQueues.get(l.id);return a||(a=new R.Queue,this.windowDialogQueues.set(l.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(l,a){return this.getWindowDialogQueue(a).queue(async()=>a?v.dialog.showMessageBox(a,l):v.dialog.showMessageBox(l))}async showSaveDialog(l,a){const u=this.acquireFileDialogLock(l,a);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await v.dialog.showSaveDialog(a,l):s=await v.dialog.showSaveDialog(l),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,n.dispose)(u)}}normalizePath(l){return l&&f.isMacintosh&&(l=(0,I.normalizeNFC)(l)),l}normalizePaths(l){return l.map(a=>this.normalizePath(a))}async showOpenDialog(l,a){l.defaultPath&&(await E.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const u=this.acquireFileDialogLock(l,a);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await v.dialog.showOpenDialog(a,l):s=await v.dialog.showOpenDialog(l),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,n.dispose)(u)}}acquireFileDialogLock(l,a){if(!a)return n.Disposable.None;let u=this.windowFileDialogLocks.get(a.id);u||(u=new Set,this.windowFileDialogLocks.set(a.id,u));const s=(0,M.hash)(l);if(!u.has(s))return u.add(s),(0,n.toDisposable)(()=>{u?.delete(s),u?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};S.workingDirPickerStorageKey="pickerWorkingDir",S=ge([te(0,w.IStateMainService),te(1,t.ILogService)],S),e.DialogMainService=S}),define(Q[219],Z([0,1,4,2,27]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends R.Disposable{constructor(I,h){super();this.logService=I,this.storageMainService=h,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,h)=>(I?I.push(h):I=[h],I),C.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const h=new Map,f=new Set;return I.forEach(y=>{const E=this.storageMainService.globalStorage.get(y.key);typeof E=="string"?h.set(y.key,E):f.add(y.key)}),{changed:Array.from(h.entries()),deleted:Array.from(f.values())}}listen(I,h){switch(h){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${h}`)}async call(I,h,f){const y=(0,M.reviveIdentifier)(f.workspace),E=await this.withStorageInitialized(y);switch(h){case"getItems":return Array.from(E.items.entries());case"updateItems":{const m=f;if(m.insert)for(const[p,t]of m.insert)E.set(p,t);m.delete&&m.delete.forEach(p=>E.delete(p));break}case"close":{if(y)return E.close();break}default:throw new Error(`Call not found: ${h}`)}}async withStorageInitialized(I){const h=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await h.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${f}`)}return h}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[220],Z([0,1,4,2,8,21,86,126,6,98,29,27]),function($,e,v,R,M,C,n,I,h,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class m extends R.Disposable{constructor(b){super();this.logService=b,this._onDidChangeStorage=this._register(new v.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new v.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const b=await this.doCreate();this.storage.dispose(),this.storage=b,this._register(b.onDidChangeStorage(P=>this._onDidChangeStorage.fire({key:P}))),await this.doInit(b);const S=b.getBoolean(f.IS_NEW_KEY);S===void 0?b.set(f.IS_NEW_KEY,!0):S&&b.set(f.IS_NEW_KEY,!1)}catch(b){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${b}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===h.LogLevel.Trace?b=>this.logService.trace(b):void 0,logError:b=>this.logService.error(b)}}doInit(b){return b.init()}get items(){return this.storage.items}get(b,S){return this.storage.get(b,S)}set(b,S){return this.storage.set(b,S)}delete(b){return this.storage.delete(b)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class p extends m{constructor(b,S,P){super(S);this.options=b,this.environmentService=P}async doCreate(){let b;return this.options.useInMemoryStorage?b=I.SQLiteStorageDatabase.IN_MEMORY_PATH:b=(0,M.join)(this.environmentService.globalStorageHome.fsPath,p.STORAGE_NAME),new n.Storage(new I.SQLiteStorageDatabase(b,{logging:this.createLoggingOptions()}))}async doInit(b){await super.doInit(b),this.updateTelemetryState(b)}updateTelemetryState(b){b.get(y.firstSessionDateStorageKey,void 0)===void 0&&b.set(y.firstSessionDateStorageKey,new Date().toUTCString());const P=b.get(y.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();b.set(y.lastSessionDateStorageKey,typeof P=="undefined"?null:P),b.set(y.currentSessionDateStorageKey,l)}}e.GlobalStorageMain=p,p.STORAGE_NAME="state.vscdb";class t extends m{constructor(b,S,P,l){super(P);this.workspace=b,this.options=S,this.environmentService=l}async doCreate(){const{storageFilePath:b,wasCreated:S}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new I.SQLiteStorageDatabase(b,{logging:this.createLoggingOptions()}),{hint:S?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const b=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),S=(0,M.join)(b,t.WORKSPACE_STORAGE_NAME);return await C.Promises.exists(b)?{storageFilePath:S,wasCreated:!1}:(await C.Promises.mkdir(b,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(b),{storageFilePath:S,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(b){let S;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?S={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(S={workspace:this.workspace.configPath.toString()}),S)try{const P=(0,M.join)(b,t.WORKSPACE_META_NAME);await C.Promises.exists(P)||await C.Promises.writeFile(P,JSON.stringify(S,void 0,2))}catch(P){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${P}`)}}}e.WorkspaceStorageMain=t,t.WORKSPACE_STORAGE_NAME="state.vscdb",t.WORKSPACE_META_NAME="workspace.json"}),define(Q[100],Z([0,1,42,2,48,5,20,6,220]),function($,e,v,R,M,C,n,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,C.createDecorator)("storageMainService");let f=class extends R.Disposable{constructor(E,m,p){super();this.logService=E,this.environmentService=m,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async E=>{E.workspace&&this.workspaceStorage(E.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(E=>{E.join(this.globalStorage.close());for(const[,m]of this.mapWorkspaceToStorage)E.join(m.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const E=new h.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),E}createWorkspaceStorage(E){return new h.WorkspaceStorageMain(E,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(E){let m=this.mapWorkspaceToStorage.get(E.id);return m||(this.logService.trace(`StorageMainService: creating workspace storage (${E.id})`),m=this.createWorkspaceStorage(E),this.mapWorkspaceToStorage.set(E.id,m),(0,v.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${E.id})`),this.mapWorkspaceToStorage.delete(E.id)})),m}};f=ge([te(0,I.ILogService),te(1,M.IEnvironmentService),te(2,n.ILifecycleMainService)],f),e.StorageMainService=f}),define(Q[101],Z([0,1,15,7,27]),function($,e,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(h,f,y){for(const m of h){const p=m.openedWorkspace;if((0,M.isWorkspaceIdentifier)(p)){const t=y(p);if(t){if(t.folders.some(w=>v.extUriBiasedIgnorePathCase.isEqualOrParent(f,w.uri)))return m}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(f,p.configPath))return m}}const E=h.filter(m=>(0,M.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(f,m.openedWorkspace.uri));if(E.length)return E.sort((m,p)=>-(m.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function n(h,f){for(const y of h)if((0,M.isWorkspaceIdentifier)(y.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,f)||(0,M.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,f))return y}e.findWindowOnWorkspaceOrFolder=n;function I(h,f){const y=E=>f.some(m=>v.extUriBiasedIgnorePathCase.isEqual(R.URI.file(m),R.URI.file(E)));for(const E of h)if(E.config?.extensionDevelopmentPath?.some(m=>y(m)))return E}e.findWindowOnExtensionDevelopmentPath=I}),define(Q[221],Z([0,1,14,2,3,15,7,19,20,6,38,36,27]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class yt extends R.Disposable{constructor(l,a,u,s,c){super();this.windowsMainService=l,this.stateMainService=a,this.lifecycleMainService=u,this.logService=s,this.configurationService=c,this._state=t(this.stateMainService.getItem(yt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(l=>this.onBeforeCloseWindow(l)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(l=>{l.newCount-l.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(l=>this.onBeforeCloseWindow(l))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let s=this.windowsMainService.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.windowsMainService.getWindows().find(c=>!c.isExtensionDevelopmentHost)),s&&(l.lastActiveWindow=this.toWindowState(s))}const a=this.windowsMainService.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);a&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>this.toWindowState(s)));const u=b(l);this.stateMainService.setItem(yt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(l){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(l);l.isExtensionDevelopmentHost&&!l.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!l.isExtensionDevelopmentHost&&l.openedWorkspace&&this._state.openedWindows.forEach(u=>{const s=(0,m.isWorkspaceIdentifier)(l.openedWorkspace)&&u.workspace?.id===l.openedWorkspace.id,c=(0,m.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)&&u.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(u.folderUri,l.openedWorkspace.uri);(s||c)&&(u.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(l){return{workspace:(0,m.isWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace:void 0,folderUri:(0,m.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace.uri:void 0,backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.serializeWindowState()}}getNewWindowState(l){const a=this.doGetNewWindowState(l),u=this.configurationService.getValue("window");let s;return a.hasDefaultState?s=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(s=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),s&&M.isMacintosh&&this.windowsMainService.getWindows().some(c=>c.isFullScreen)&&(s=!1)),a.mode===3&&!s&&(a.mode=1),a}doGetNewWindowState(l){const a=this.windowsMainService.getLastActiveWindow();if(!l.extensionTestsPath){if(!!l.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=l.workspace;if((0,m.isWorkspaceIdentifier)(o)){const g=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===o.id).map(k=>k.uiState);if(g.length)return g[0]}if((0,m.isSingleFolderWorkspaceIdentifier)(o)){const g=this.state.openedWindows.filter(k=>k.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(k.folderUri,o.uri)).map(k=>k.uiState);if(g.length)return g[0]}else if(l.backupPath){const g=this.state.openedWindows.filter(k=>k.backupPath===l.backupPath).map(k=>k.uiState);if(g.length)return g[0]}const d=this.lastClosedState||this.state.lastActiveWindow;if(!a&&d)return d.uiState}let u;const s=v.screen.getAllDisplays();if(s.length===1)u=s[0];else{if(M.isMacintosh){const o=v.screen.getCursorScreenPoint();u=v.screen.getDisplayNearestPoint(o)}!u&&a&&(u=v.screen.getDisplayMatching(a.getBounds())),u||(u=v.screen.getPrimaryDisplay()||s[0])}let c=(0,E.defaultWindowState)();c.x=Math.round(u.bounds.x+u.bounds.width/2-c.width/2),c.y=Math.round(u.bounds.y+u.bounds.height/2-c.height/2);const i=this.configurationService.getValue("window");let r=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")c.mode=0,r=!1;else if(i.newWindowDimensions==="fullscreen")c.mode=3,r=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&a){const o=a.serializeWindowState();o.mode===3?c.mode=3:c=o,r=c.mode!==3&&i.newWindowDimensions==="offset"}}return r&&(c=this.ensureNoOverlap(c)),c.hasDefaultState=!0,c}ensureNoOverlap(l){if(this.windowsMainService.getWindows().length===0)return l;l.x=typeof l.x=="number"?l.x:0,l.y=typeof l.y=="number"?l.y:0;const a=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;a.some(u=>u.x===l.x||u.y===l.y);)l.x+=30,l.y+=30;return l}};p.windowsStateStorageKey="windowsState",p=ge([te(0,E.IWindowsMainService),te(1,y.IStateMainService),te(2,h.ILifecycleMainService),te(3,f.ILogService),te(4,I.IConfigurationService)],p),e.WindowsStateHandler=p;function t(P){const l={openedWindows:[]},a=P||{openedWindows:[]};return a.lastActiveWindow&&(l.lastActiveWindow=w(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(l.lastPluginDevelopmentHostWindow=w(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(l.openedWindows=a.openedWindows.map(u=>w(u))),l}e.restoreWindowsState=t;function w(P){const l={uiState:P.uiState};return P.backupPath&&(l.backupPath=P.backupPath),P.remoteAuthority&&(l.remoteAuthority=P.remoteAuthority),P.folder&&(l.folderUri=n.URI.parse(P.folder)),P.workspaceIdentifier&&(l.workspace={id:P.workspaceIdentifier.id,configPath:n.URI.parse(P.workspaceIdentifier.configURIPath)}),l}function b(P){return{lastActiveWindow:P.lastActiveWindow&&S(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&S(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(l=>S(l))}}e.getWindowsStateStoreData=b;function S(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(Q[102],Z([0,1,61,28,10,3,15]),function($,e,v,R,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(f){function y(){let E=f.scheme===M.Schemas.file?(0,n.originalFSPath)(f):f.toString();return C.isLinux||(E=E.toLowerCase()),(0,v.createHash)("md5").update(E).digest("hex")}return{id:y(),configPath:f}}e.getWorkspaceIdentifier=I;function h(f,y){function E(){if(f.scheme!==M.Schemas.file)return(0,v.createHash)("md5").update(f.toString()).digest("hex");if(!y)try{y=(0,R.statSync)(f.fsPath)}catch(t){return}let p;return C.isLinux?p=y.ino:C.isMacintosh?p=y.birthtime.getTime():C.isWindows&&(typeof y.birthtimeMs=="number"?p=Math.floor(y.birthtimeMs):p=y.birthtime.getTime()),(0,v.createHash)("md5").update(f.fsPath).update(p?String(p):"").digest("hex")}const m=E();if(typeof m=="string")return{id:m,uri:f}}e.getSingleFolderWorkspaceIdentifier=h}),define(Q[222],Z([0,1,16,10,6,250,113,20]),function($,e,v,R,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class h{constructor(m,p){this._worker=new C.Worker(R.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",$).fsPath),this._worker.on("message",m),this._worker.on("error",p)}getId(){return 1}postMessage(m,p){this._worker.postMessage(m,p)}dispose(){this._worker.terminate()}}let f=class{constructor(m){this._logService=m}async logInfo(m){this._logService.info(m)}};f=ge([te(0,M.ILogService)],f);let y=class{constructor(m,p){this._logService=m,this._shutdown=!1,this._proxy=null;const t={create:(w,b,S)=>{const P=new h(b,S);return P.postMessage(w,[]),P}};this._worker=new n.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new f(this._logService)),this._initialize(),p.onWillShutdown(w=>{this._shutdown=!0,this._proxy&&w.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(m){return this._proxy.onDynamicStdout(m)}onDynamicStderr(m){return this._proxy.onDynamicStderr(m)}onDynamicMessage(m){return this._proxy.onDynamicMessage(m)}onDynamicError(m){return this._proxy.onDynamicError(m)}onDynamicExit(m){return this._proxy.onDynamicExit(m)}async createExtensionHost(){const m=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return m.createExtensionHost()}async start(m,p){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return t.start(m,p)}async enableInspectPort(m){const p=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return p.enableInspectPort(m)}async kill(m){const p=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return p.kill(m)}};y=ge([te(0,M.ILogService),te(1,I.ILifecycleMainService)],y),e.WorkerMainProcessExtensionHostStarter=y}),define(Q[58],Z([0,1,61,62,26,17,16,4,2,8,3,31,35,84,223]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(g){this.socket=g,this._errorListener=k=>{if(k){if(k.code==="EPIPE")return;(0,n.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(g){const k=L=>g(C.VSBuffer.wrap(L));return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(g){const k=L=>{g({type:0,hadError:L,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(g){return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(g){if(!this.socket.destroyed)try{this.socket.write(g.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,n.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,n.onUnexpectedError)(k)}}end(){this.socket.end()}drain(){return new Promise((g,k)=>{if(this.socket.bufferSize===0){g();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),g()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=w;var b;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var S;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(S||(S={}));class P extends h.Disposable{constructor(g,k,L,A){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=g,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=k,this._recordInflateBytes=A,k?(this._zlibInflate=t.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",W=>{console.error(W),(0,n.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})}),this._zlibInflate.on("data",W=>{this._pendingInflateData.push(W)}),L&&(this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",W=>{console.error(W),(0,n.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})}),this._zlibDeflate.on("data",W=>{this._pendingDeflateData.push(W)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(W=>this._acceptChunk(W))),this._register(this.socket.onClose(W=>this._onClose.fire(W)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){this._totalOutgoingDataBytes+=g.byteLength,this._zlibDeflate?(this._zlibDeflate.write(g.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let k=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.length-4),this._isEnded||this._write(C.VSBuffer.wrap(k),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(g,!1)}_write(g,k){let L=2;g.byteLength<126?L+=0:g.byteLength<2**16?L+=2:L+=8;const A=C.VSBuffer.alloc(L);if(k?A.writeUInt8(194,0):A.writeUInt8(130,0),g.byteLength<126)A.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){A.writeUInt8(126,1);let W=1;A.writeUInt8(g.byteLength>>>8&255,++W),A.writeUInt8(g.byteLength>>>0&255,++W)}else{A.writeUInt8(127,1);let W=1;A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(g.byteLength>>>24&255,++W),A.writeUInt8(g.byteLength>>>16&255,++W),A.writeUInt8(g.byteLength>>>8&255,++W),A.writeUInt8(g.byteLength>>>0&255,++W)}this._totalOutgoingWireBytes+=A.byteLength+g.byteLength,this.socket.write(C.VSBuffer.concat([A,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._totalIncomingWireBytes+=g.byteLength,this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),L=k.readUInt8(0),A=(L&128)>>>7,W=(L&64)>>>6,V=k.readUInt8(1),ee=(V&128)>>>7,oe=V&127;this._state.state=2,this._state.readLen=2+(ee?4:0)+(oe===126?2:0)+(oe===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(W)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),L=k.readUInt8(1),A=(L&128)>>>7;let W=L&127,V=1;W===126?W=k.readUInt8(++V)*2**8+k.readUInt8(++V):W===127&&(W=k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*2**24+k.readUInt8(++V)*2**16+k.readUInt8(++V)*2**8+k.readUInt8(++V));let ee=0;A&&(ee=k.readUInt8(++V)*2**24+k.readUInt8(++V)*2**16+k.readUInt8(++V)*2**8+k.readUInt8(++V)),this._state.state=3,this._state.readLen=W,this._state.mask=ee}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);l(k,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(k.buffer)),this._zlibInflate.write(k.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const L=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=L.length,this._onData.fire(C.VSBuffer.wrap(L))})):(this._totalIncomingDataBytes+=k.byteLength,this._onData.fire(k))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=P;function l(d,g){if(g===0)return;let k=d.byteLength>>>2;for(let oe=0;oe<k;oe++){const ae=d.readUInt32BE(oe*4);d.writeUInt32BE(ae^g,oe*4)}let L=k*4,A=d.byteLength-L;const W=g>>>24&255,V=g>>>16&255,ee=g>>>8&255;A>=1&&d.writeUInt8(d.readUInt8(L)^W,L),A>=2&&d.writeUInt8(d.readUInt8(L+1)^V,L+1),A>=3&&d.writeUInt8(d.readUInt8(L+2)^ee,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function u(){const d=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let g;return e.XDG_RUNTIME_DIR?g=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):g=(0,f.join)((0,M.tmpdir)(),`vscode-ipc-${d}.sock`),c(g),g}e.createRandomIPCHandle=u;function s(d,g,k){const L=(0,v.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${k}-${g}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${k}-${g}.sock`):A=(0,f.join)(d,`${k}-${g}.sock`),c(A),A}e.createStaticIPCHandle=s;function c(d){const g=a[y.platform];typeof g=="number"&&d.length>=g&&console.warn(`WARNING: IPC handle "${d}" is longer than ${g} chars, try a shorter --user-data-dir`)}class i extends m.IPCServer{constructor(g){super(i.toClientConnectionEvent(g));this.server=g}static toClientConnectionEvent(g){const k=I.Event.fromNodeEventEmitter(g,"connection");return I.Event.map(k,L=>({protocol:new p.Protocol(new w(L)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function r(d){return new Promise((g,k)=>{const L=(0,R.createServer)();L.on("error",k),L.listen(d,()=>{L.removeListener("error",k),g(new i(L))})})}e.serve=r;function o(d,g){return new Promise((k,L)=>{const A=(0,R.createConnection)(d,()=>{A.removeListener("error",L),k(p.Client.fromSocket(new w(A),g))});A.once("error",L)})}e.connect=o}),define(Q[224],Z([0,1,58]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(h){this.driver=h}listen(h,f){throw new Error("No event found")}call(h,f,y){switch(f){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(y);case"reloadWindow":return this.driver.reloadWindow(y);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(y[0],y[1]);case"click":return this.driver.click(y[0],y[1],y[2],y[3]);case"doubleClick":return this.driver.doubleClick(y[0],y[1]);case"setValue":return this.driver.setValue(y[0],y[1],y[2]);case"getTitle":return this.driver.getTitle(y[0]);case"isActiveElement":return this.driver.isActiveElement(y[0],y[1]);case"getElements":return this.driver.getElements(y[0],y[1],y[2]);case"getElementXY":return this.driver.getElementXY(y[0],y[1],y[2]);case"typeInEditor":return this.driver.typeInEditor(y[0],y[1],y[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(y[0],y[1]);case"writeInTerminal":return this.driver.writeInTerminal(y[0],y[1],y[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(y);case"getLocalizedStrings":return this.driver.getLocalizedStrings(y)}throw new Error(`Call not found: ${f}`)}}e.DriverChannel=R;class M{constructor(h){this.channel=h}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(h){return this.channel.call("capturePage",h)}reloadWindow(h){return this.channel.call("reloadWindow",h)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(h,f){return this.channel.call("dispatchKeybinding",[h,f])}click(h,f,y,E){return this.channel.call("click",[h,f,y,E])}doubleClick(h,f){return this.channel.call("doubleClick",[h,f])}setValue(h,f,y){return this.channel.call("setValue",[h,f,y])}getTitle(h){return this.channel.call("getTitle",[h])}isActiveElement(h,f){return this.channel.call("isActiveElement",[h,f])}getElements(h,f,y){return this.channel.call("getElements",[h,f,y])}getElementXY(h,f,y,E){return this.channel.call("getElementXY",[h,f,y,E])}typeInEditor(h,f,y){return this.channel.call("typeInEditor",[h,f,y])}getTerminalBuffer(h,f){return this.channel.call("getTerminalBuffer",[h,f])}writeInTerminal(h,f,y){return this.channel.call("writeInTerminal",[h,f,y])}getLocaleInfo(h){return this.channel.call("getLocaleInfo",h)}getLocalizedStrings(h){return this.channel.call("getLocalizedStrings",h)}}e.DriverChannelClient=M;class C{constructor(h){this.registry=h}listen(h,f){throw new Error(`Event not found: ${f}`)}call(h,f,y){switch(f){case"registerWindowDriver":return this.registry.registerWindowDriver(y);case"reloadWindowDriver":return this.registry.reloadWindowDriver(y)}throw new Error(`Call not found: ${f}`)}}e.WindowDriverRegistryChannel=C;async function n(I){const h=await(0,v.connect)(I,"driverClient"),f=h.getChannel("driver"),y=new M(f);return{client:h,driver:y}}e.connect=n}),define(Q[225],Z([0,1,9,4,106,59,2,3,35,58,160,224,178,20,36]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function w(P){return P<21}let b=class{constructor(l,a,u,s){this.windowServer=l,this.options=a,this.windowsMainService=u,this.lifecycleMainService=s,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new R.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const a=this.windowsMainService.getWindowById(l);if(!a?.win)throw new Error("Invalid window");return(await a.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const a=this.windowsMainService.getWindowById(l);if(!a)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(a)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(l,a){await this.whenUnfrozen(l);const u=M.KeybindingParser.parseUserBinding(a);for(let s of u)await this._dispatchKeybinding(l,s)}async _dispatchKeybinding(l,a){if(a instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const u=this.windowsMainService.getWindowById(l);if(!u?.win)throw new Error("Invalid window");const s=u.win.webContents,c=new C.SimpleKeybinding(!1,!1,!1,!1,a.keyCode),r=new m.USLayoutResolvedKeybinding(c.toChord(),I.OS).getElectronAccelerator(),o=[];a.ctrlKey&&o.push("ctrl"),a.metaKey&&o.push("meta"),a.shiftKey&&o.push("shift"),a.altKey&&o.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:r,modifiers:o}),w(a.keyCode)||s.sendInputEvent({type:"char",keyCode:r,modifiers:o}),s.sendInputEvent({type:"keyUp",keyCode:r,modifiers:o}),await(0,v.timeout)(100)}async click(l,a,u,s){await(await this.getWindowDriver(l)).click(a,u,s)}async doubleClick(l,a){await(await this.getWindowDriver(l)).doubleClick(a)}async setValue(l,a,u){await(await this.getWindowDriver(l)).setValue(a,u)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,a){return await(await this.getWindowDriver(l)).isActiveElement(a)}async getElements(l,a,u){return await(await this.getWindowDriver(l)).getElements(a,u)}async getElementXY(l,a,u,s){return await(await this.getWindowDriver(l)).getElementXY(a,u,s)}async typeInEditor(l,a,u){await(await this.getWindowDriver(l)).typeInEditor(a,u)}async getTerminalBuffer(l,a){return await(await this.getWindowDriver(l)).getTerminalBuffer(a)}async writeInTerminal(l,a,u){await(await this.getWindowDriver(l)).writeInTerminal(a,u)}async getLocaleInfo(l){return await(await this.getWindowDriver(l)).getLocaleInfo()}async getLocalizedStrings(l){return await(await this.getWindowDriver(l)).getLocalizedStrings()}async getWindowDriver(l){await this.whenUnfrozen(l);const a=`window:${l}`,u=new h.StaticRouter(c=>c===a),s=this.windowServer.getChannel("windowDriver",u);return new y.WindowDriverChannelClient(s)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await R.Event.toPromise(this.onDidReloadingChange.event)}};b=ge([te(2,t.IWindowsMainService),te(3,p.ILifecycleMainService)],b),e.Driver=b;async function S(P,l,a,u){const s=a.driverVerbose,c=u.createInstance(b,P,{verbose:s}),i=new E.WindowDriverRegistryChannel(c);P.registerChannel("windowDriverRegistry",i);const r=await(0,f.serve)(l),o=new E.DriverChannel(c);return r.registerChannel("driver",o),(0,n.combinedDisposable)(r,P)}e.serve=S}),define(Q[24],Z([0,1,46,8,58,48,164,5]),function($,e,v,R,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(C.IEnvironmentService);class h extends n.NativeEnvironmentService{get cachedLanguagesPath(){return(0,R.join)(this.userDataPath,"clp")}get backupHome(){return(0,R.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,R.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,M.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,R.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ge([v.memoize],h.prototype,"cachedLanguagesPath",null),ge([v.memoize],h.prototype,"backupHome",null),ge([v.memoize],h.prototype,"backupWorkspacesPath",null),ge([v.memoize],h.prototype,"mainIPCHandle",null),ge([v.memoize],h.prototype,"mainLockfile",null),ge([v.memoize],h.prototype,"sandbox",null),ge([v.memoize],h.prototype,"driverVerbose",null),ge([v.memoize],h.prototype,"disableUpdates",null),ge([v.memoize],h.prototype,"disableKeytar",null),ge([v.memoize],h.prototype,"codeCachePath",null),ge([v.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(Q[226],Z([0,1,61,28,32,10,8,3,15,7,21,51,19,24,18,6,27]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(l,a,u){this.configurationService=a,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(s,c)=>(0,M.isEqual)(s,c,!I.isLinux)},this.backupHome=l.backupHome,this.workspacesJsonPath=l.backupWorkspacesPath}async initialize(){let l;try{l=JSON.parse(await y.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(s){l=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(l.emptyWorkspaceInfos);let a=[];try{Array.isArray(l.rootURIWorkspaces)&&(a=l.rootURIWorkspaces.map(s=>({workspace:{id:s.id,configPath:f.URI.parse(s.configURIPath)},remoteAuthority:s.remoteAuthority})))}catch(s){}this.workspaces=await this.validateWorkspaces(a);let u=[];try{Array.isArray(l.folderURIWorkspaces)&&(u=l.folderURIWorkspaces.map(s=>f.URI.parse(s)))}catch(s){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(l,a){this.workspaces.some(s=>l.workspace.id===s.workspace.id)||(this.workspaces.push(l),this.saveSync());const u=this.getBackupPath(l.workspace.id);return a&&this.moveBackupFolderSync(u,a),u}moveBackupFolderSync(l,a){if(R.existsSync(l)&&this.convertToEmptyWindowBackupSync(l),R.existsSync(a))try{R.renameSync(a,l)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(l){const a=l.id,u=this.workspaces.findIndex(s=>s.workspace.id===a);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(l){return this.folders.some(a=>this.backupUriComparer.isEqual(l,a))||(this.folders.push(l),this.saveSync()),this.getBackupPath(this.getFolderHash(l))}unregisterFolderBackupSync(l){const a=this.folders.findIndex(u=>this.backupUriComparer.isEqual(l,u));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(l,a){const u=l||this.getRandomEmptyWindowId();return this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:a}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(l){const a=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,l));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(l){return(0,n.join)(this.backupHome,l)}async validateWorkspaces(l){if(!Array.isArray(l))return[];const a=new Set,u=[];for(let s of l){const c=s.workspace;if(!(0,b.isWorkspaceIdentifier)(c))return[];if(!a.has(c.id)){a.add(c.id);const i=this.getBackupPath(c.id);await this.doHasBackups(i)?c.configPath.scheme!==C.Schemas.file||await y.Promises.exists(c.configPath.fsPath)?u.push(s):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return u}async validateFolders(l){if(!Array.isArray(l))return[];const a=[],u=new Set;for(let s of l){const c=this.backupUriComparer.getComparisonKey(s);if(!u.has(c)){u.add(c);const i=this.getBackupPath(this.getFolderHash(s));await this.doHasBackups(i)?s.scheme!==C.Schemas.file||await y.Promises.exists(s.fsPath)?a.push(s):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateEmptyWorkspaces(l){if(!Array.isArray(l))return[];const a=[],u=new Set;for(let s of l){const c=s.backupFolder;if(typeof c!="string")return[];if(!u.has(c)){u.add(c);const i=this.getBackupPath(c);await this.doHasBackups(i)?a.push(s):await this.deleteStaleBackup(i)}}return a}async deleteStaleBackup(l){try{await y.Promises.exists(l)&&await y.Promises.rm(l,y.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(l){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{await y.Promises.rename(l,u)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(l){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{R.renameSync(l,u)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const l=[];for(const a of this.workspaces)await this.hasBackups(a)&&l.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&l.push(a);return l}hasBackups(l){let a;return f.URI.isUri(l)?a=this.getBackupPath(this.getFolderHash(l)):(0,E.isWorkspaceBackupInfo)(l)?a=this.getBackupPath(l.workspace.id):a=l.backupFolder,this.doHasBackups(a)}async doHasBackups(l){try{const a=await y.Promises.readdir(l);for(const u of a)try{if((await y.Promises.readdir((0,n.join)(l,u))).length>0)return!0}catch(s){}}catch(a){}return!1}saveSync(){try{(0,y.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}async save(){try{await y.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(l=>({id:l.workspace.id,configURIPath:l.workspace.configPath.toString(),remoteAuthority:l.remoteAuthority})),folderURIWorkspaces:this.folders.map(l=>l.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(l){let a;return l.scheme===C.Schemas.file?a=I.isLinux?l.fsPath:l.fsPath.toLowerCase():a=l.toString().toLowerCase(),(0,v.createHash)("md5").update(a).digest("hex")}};S=ge([te(0,p.IEnvironmentMainService),te(1,m.IConfigurationService),te(2,w.ILogService)],S),e.BackupMainService=S}),define(Q[227],Z([0,1,62,58]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(M,C,n,I){const h=y=>I(y,void 0),f=v.createConnection({host:M,port:C},()=>{f.removeListener("error",h);const y=Buffer.alloc(16);for(let t=0;t<16;t++)y[t]=Math.round(Math.random()*256);const E=y.toString("base64");let m=[`GET ws://${/:/.test(M)?`[${M}]`:M}:${C}/?${n}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];f.write(m.join(`\r
`)+`\r
\r
`);const p=t=>{t.toString().indexOf(`\r
\r
`)>=0&&(f.off("data",p),I(void 0,new R.NodeSocket(f)))};f.on("data",p)});f.once("error",h)}}}),define(Q[228],Z([0,1,62,118,227,9,2,19,6,22,194,97,76]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(P,l,a,u,s){let c;for(let i=3;i&&(c&&c.dispose(),c=await new t(P,l,a,u,s).waitForReady(),!(s&&R.BROWSER_RESTRICTED_PORTS[s]||!R.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));i--);return c}class t extends n.Disposable{constructor(l,a,u,s,c){super();this.defaultTunnelHost=a,this.suggestedLocalPort=c,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=v.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let l=await(0,R.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(l){l.pause();const a=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,y.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),s=u.getSocket().socket,c=u.readEntireBuffer();u.dispose(),c.byteLength>0&&l.write(c.buffer),l.on("end",()=>{this._socketsDispose.delete(l.localAddress),s.end()}),l.on("close",()=>s.end()),l.on("error",()=>{this._socketsDispose.delete(l.localAddress),s.destroy()}),s.on("end",()=>l.end()),s.on("close",()=>l.end()),s.on("error",()=>{l.destroy()}),l.pipe(s),s.pipe(l),this._socketsDispose.set(l.localAddress,()=>{l.end(),s.end()})}}let w=class extends E.AbstractTunnelService{constructor(l,a,u,s,c){super(a);this.socketFactory=l,this.signService=u,this.productService=s,this.configurationService=c}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(l,a,u,s,c,i,r){const o=this.getTunnelFromMap(a,u);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,u,s,c,i,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${u} on local port ${s}.`);const d={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},g=p(d,this.defaultTunnelHost,a,u,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,u,g),g}}};w=ge([te(1,h.ILogService),te(2,m.ISignService),te(3,f.IProductService),te(4,I.IConfigurationService)],w),e.BaseTunnelService=w;let b=class extends w{constructor(l,a,u,s){super(M.nodeSocketFactory,l,a,u,s)}};b=ge([te(0,h.ILogService),te(1,m.ISignService),te(2,f.IProductService),te(3,I.IConfigurationService)],b),e.TunnelService=b;let S=class extends n.Disposable{constructor(l,a,u,s){super();this.logService=l,this.productService=a,this.signService=u,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(l,a,u,s,c,i,r,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${s} on local port ${c}.`),!this._tunnelServices.has(l)){const d=new b(this.logService,this.signService,this.productService,this.configurationService);this._register(d),this._tunnelServices.set(l,d),d.onTunnelClosed(async()=>{(await d.tunnels).length===0&&(d.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(a,u,s,c,i,r,o)}};S=ge([te(0,h.ILogService),te(1,f.IProductService),te(2,m.ISignService),te(3,I.IConfigurationService)],S),e.SharedTunnelsService=S}),define(Q[229],Z([0,1,198,9,17,16,2,13,19,48,91,6,197,223]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends n.Disposable{constructor(b,S,P){super();this.environmentService=S,this.logService=P,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,S){this.logService.trace("RequestService#request",b.url);const{proxyUrl:P,strictSSL:l}=this;let a;try{a=await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(c){this.logService.error("RequestService#request resolving shell environment failed",c)}const u={...process.env,...a},s=b.agent?b.agent:await(0,m.getProxyAgent)(b.url||"",u,{proxyUrl:P,strictSSL:l});return b.agent=s,b.strictSSL=l,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization}),this._request(b,S)}async getNodeRequest(b){return((0,v.parse)(b.url).protocol==="https:"?await new Promise((l,a)=>{$(["https"],l,a)}):await new Promise((l,a)=>{$(["http"],l,a)})).request}_request(b,S){return R.Promises.withAsyncBody(async(P,l)=>{let a;const u=(0,v.parse)(b.url),s=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),c={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,I.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(c.auth=b.user+":"+b.password),a=s(c,i=>{const r=(0,I.isNumber)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this._request({...b,url:i.headers.location,followRedirects:r-1},S).then(P,l);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,p.createGunzip)())),P({res:i,stream:(0,M.streamToBufferReadableStream)(o)})}}),a.on("error",l),b.timeout&&a.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&a.write(b.data),a.end(),S.onCancellationRequested(()=>{a.abort(),l((0,C.canceled)())})})}async resolveProxy(b){}};t=ge([te(0,h.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,E.ILogService)],t),e.RequestService=t}),define(Q[230],Z([0,1,14,229]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function M(n){return v.net.request}class C extends R.RequestService{request(I,h){return super.request({...I||{},getRawRequest:M},h)}}e.RequestMainService=C}),define(Q[231],Z([0,1,14,9,4,2,10,13,85,24,20,6,56,57,66,44]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let b=class extends C.Disposable{constructor(P,l,a,u,s,c,i){super();this.machineId=P,this.userEnv=l,this.environmentMainService=a,this.lifecycleMainService=u,this.logService=s,this.themeMainService=c,this.protocolMainService=i,this.firstWindowConnectionBarrier=new R.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new M.Emitter),this.onDidError=M.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,l)=>this.onWindowConnection(P,l)),v.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,l)=>this.onWorkerConnection(P,l)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,l){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(P.sender.isDestroyed())return a.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",l,[a])}onWorkerConnection(P,l){this.logService.trace("SharedProcess: onWorkerConnection",l);const a=new C.DisposableStore,u=c=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${c}')`,l),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",l))},s=v.BrowserWindow.fromId(l.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!l.reply.channel){u("unavailable");return}a.add(M.Event.filter(this.lifecycleMainService.onWillLoadWindow,c=>c.window.win===s)(()=>u("load"))),a.add(M.Event.fromNodeEventEmitter(s,"closed")(()=>u("closed"))),s.webContents.postMessage(l.reply.channel,l.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch(l){}this.window=void 0},0))}send(P,...l){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...l)}catch(a){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,w.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:n.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",$).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,l)=>this._onDidError.fire({type:2,details:l})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,l,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:l}})))}async connect(){await this.whenIpcReady;const P=(0,I.assertIsDefined)(this.window);return(0,h.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};b=ge([te(2,f.IEnvironmentMainService),te(3,y.ILifecycleMainService),te(4,E.ILogService),te(5,t.IThemeMainService),te(6,p.IProtocolMainService)],b),e.SharedProcess=b}),define(Q[232],Z([0,1,9,17,8,13,7,24,18,6]),function($,e,v,R,M,C,n,I,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class y{constructor(p,t,w){this.storagePath=p,this.logService=t,this.fileService=w,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,t){const w=this.storage[p];return(0,C.isUndefinedOrNull)(w)?t:w}setItem(p,t){this.setItems([{key:p,data:t}])}setItems(p){let t=!1;for(const{key:w,data:b}of p)this.storage[w]!==b&&((0,C.isUndefinedOrNull)(b)?(0,C.isUndefined)(this.storage[w])||(this.storage[w]=void 0,t=!0):(this.storage[w]=b,t=!0));t&&this.save()}removeItem(p){(0,C.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,R.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=y;let E=class It{constructor(p,t,w){this.fileStorage=new y(n.URI.file((0,M.join)(p.userDataPath,It.STATE_FILE)),t,w)}async init(){return this.fileStorage.init()}getItem(p,t){return this.fileStorage.getItem(p,t)}setItem(p,t){this.fileStorage.setItem(p,t)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=ge([te(0,I.IEnvironmentMainService),te(1,f.ILogService),te(2,h.IFileService)],E),e.StateMainService=E}),define(Q[77],Z([0,1,9,23,4,19,24,20,6,22,50,41]),function($,e,v,R,M,C,n,I,h,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function m(t,w,b){return`${b.updateUrl}/api/update/${t}/${w}/${b.commit}`}e.createUpdateURL=m;let p=class{constructor(w,b,S,P,l,a){this.lifecycleMainService=w,this.configurationService=b,this.environmentMainService=S,this.requestService=P,this.logService=l,this.productService=a,this._state=E.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.getUpdateMode(),b=this.getProductQuality(w);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(E.State.Idle(this.getUpdateType())),w==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(w){return w==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(w=60*60*1e3){return(0,v.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(w){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},R.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};p=ge([te(0,I.ILifecycleMainService),te(1,C.IConfigurationService),te(2,n.IEnvironmentMainService),te(3,y.IRequestService),te(4,h.ILogService),te(5,f.IProductService)],p),e.AbstractUpdateService=p}),define(Q[233],Z([0,1,14,46,4,2,19,24,20,6,22,50,29,41,77]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends t.AbstractUpdateService{constructor(S,P,l,a,u,s,c){super(S,P,a,u,s,c);this.telemetryService=l,this.disposables=new C.DisposableStore}get onRawError(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"error",(S,P)=>P)}get onRawUpdateNotAvailable(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(S,P,l)=>({url:P,version:l,productVersion:l}))}get onRawUpdateDownloaded(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(S,P,l,a)=>({releaseNotes:P,version:l,productVersion:l,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(S){this.logService.error("UpdateService error:",S);const l=(this.state.type==="checking for updates"?this.state.explicit:!0)?S:void 0;this.setState(p.State.Idle(1,l))}buildUpdateFeedUrl(S){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,t.createUpdateURL)(P,S,this.productService);try{v.autoUpdater.setFeedURL({url:l})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return l}doCheckForUpdates(S){this.setState(p.State.CheckingForUpdates(S)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(S){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(S))}onUpdateDownloaded(S){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:S.version}),this.setState(p.State.Ready(S)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ge([R.memoize],w.prototype,"onRawError",null),ge([R.memoize],w.prototype,"onRawUpdateNotAvailable",null),ge([R.memoize],w.prototype,"onRawUpdateAvailable",null),ge([R.memoize],w.prototype,"onRawUpdateDownloaded",null),w=ge([te(0,h.ILifecycleMainService),te(1,n.IConfigurationService),te(2,m.ITelemetryService),te(3,I.IEnvironmentMainService),te(4,E.IRequestService),te(5,f.ILogService),te(6,y.IProductService)],w),e.DarwinUpdateService=w}),define(Q[234],Z([0,1,43,28,9,4,8,24,20,6,29,41]),function($,e,v,R,M,C,n,I,h,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let m=class{constructor(w,b,S){if(this.lifecycleMainService=w,this.logService=S,this._state=E.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(E.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}scheduleCheckForUpdates(w=60*60*1e3){return(0,M.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(w){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};m=ge([te(0,h.ILifecycleMainService),te(1,I.IEnvironmentMainService),te(2,f.ILogService)],m);let p=class extends m{constructor(w,b,S,P,l,a){super(S,P,l);this.snap=w,this.snapRevision=b,this.telemetryService=a;const u=(0,R.watch)(n.dirname(this.snap)),s=C.Event.fromNodeEventEmitter(u,"change",(o,d)=>d),c=C.Event.filter(s,o=>o==="current"),r=C.Event.debounce(c,(o,d)=>d,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{r.dispose(),u.close()})}doCheckForUpdates(){this.setState(E.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(w=>{w?this.setState(E.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2)))},w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2,w.message||w))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+n.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const w=await new Promise((S,P)=>(0,R.realpath)(`${n.dirname(this.snap)}/current`,(l,a)=>l?P(l):S(a))),b=n.basename(w);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,w=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ge([te(2,h.ILifecycleMainService),te(3,I.IEnvironmentMainService),te(4,f.ILogService),te(5,y.ITelemetryService)],p),e.SnapUpdateService=p}),define(Q[45],Z([0,1,14,28,4,39,33,2,10,8,3,15,13,21,158,51,52,24,5,6,22,101,27,102]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a,u,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let i=class extends I.Disposable{constructor(o,d,g,k,L){super();this.environmentMainService=o,this.logService=d,this.backupMainService=g,this.dialogMainService=k,this.productService=L,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new M.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new M.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,d=>(0,R.readFileSync)(d,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,d=>p.Promises.readFile(d,"utf8"))}doResolveLocalWorkspace(o,d){if(!!this.isWorkspacePath(o)&&o.scheme===h.Schemas.file)try{const g=d(o.fsPath);return g instanceof Promise?g.then(k=>this.doResolveWorkspace(o,k),k=>{}):this.doResolveWorkspace(o,g)}catch{return}}isWorkspacePath(o){return(0,s.isUntitledWorkspace)(o,this.environmentMainService)||(0,s.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,d){try{const g=this.doParseStoredWorkspace(o,d),k=(0,c.getWorkspaceIdentifier)(o);return{id:k.id,configPath:k.configPath,folders:(0,s.toWorkspaceFolders)(g.folders,k.configPath,E.extUriBiasedIgnorePathCase),remoteAuthority:g.remoteAuthority,transient:g.transient}}catch(g){this.logService.warn(g.toString())}}doParseStoredWorkspace(o,d){const g=(0,C.parse)(d);if(g&&Array.isArray(g.folders))g.folders=g.folders.filter(k=>(0,s.isStoredWorkspaceFolder)(k));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return g}async createUntitledWorkspace(o,d){const{workspace:g,storedWorkspace:k}=this.newUntitledWorkspace(o,d),L=g.configPath.fsPath;return await p.Promises.mkdir((0,f.dirname)(L),{recursive:!0}),await p.Promises.writeFile(L,JSON.stringify(k,null,"	")),g}createUntitledWorkspaceSync(o,d){const{workspace:g,storedWorkspace:k}=this.newUntitledWorkspace(o,d),L=g.configPath.fsPath;return(0,R.mkdirSync)((0,f.dirname)(L),{recursive:!0}),(0,p.writeFileSync)(L,JSON.stringify(k,null,"	")),g}newUntitledWorkspace(o=[],d){const g=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,E.joinPath)(this.untitledWorkspacesHome,g),L=(0,E.joinPath)(k,s.UNTITLED_WORKSPACE_NAME),A=[];for(const W of o)A.push((0,s.getStoredWorkspaceFolder)(W.uri,!0,W.name,k,!y.isWindows,E.extUriBiasedIgnorePathCase));return{workspace:(0,c.getWorkspaceIdentifier)(L),storedWorkspace:{folders:A,remoteAuthority:d}}}async getWorkspaceIdentifier(o){return(0,c.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,s.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const d=(0,E.originalFSPath)(o.configPath);try{(0,p.rimrafSync)((0,f.dirname)(d));const g=(0,f.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,R.existsSync)(g)&&(0,p.writeFileSync)((0,f.join)(g,"obsolete"),"")}catch(g){this.logService.warn(`Unable to delete untitled workspace ${d} (${g}).`)}}getUntitledWorkspacesSync(){const o=[];try{const d=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(g=>(0,E.joinPath)(this.untitledWorkspacesHome,g,s.UNTITLED_WORKSPACE_NAME));for(const g of d){const k=(0,c.getWorkspaceIdentifier)(g),L=this.resolveLocalWorkspaceSync(g);L?o.push({workspace:k,remoteAuthority:L.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(d){d.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${d}).`)}return o}async enterWorkspace(o,d,g){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,d,g))return;const L=this.doEnterWorkspace(o,(0,c.getWorkspaceIdentifier)(g));if(!!L)return this._onDidEnterWorkspace.fire({window:o,workspace:L.workspace}),L}async isValidTargetWorkspacePath(o,d,g){if(!g)return!0;if((0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,g))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(d,g)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,n.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,E.basename)(g)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,m.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,d){if(!o.config)return;o.focus();let g;return o.config.extensionDevelopmentPath||(g=this.backupMainService.registerWorkspaceBackupSync({workspace:d,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=d,o.config.backupPath=g,{workspace:d,backupPath:g}}};i=ge([te(0,S.IEnvironmentMainService),te(1,l.ILogService),te(2,w.IBackupMainService),te(3,b.IDialogMainService),te(4,a.IProductService)],i),e.WorkspacesManagementMainService=i}),define(Q[103],Z([0,1,14,30,23,3,13,7,21,19,54,5,6,99,36,27,45]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,E.createDecorator)(e.ID);let S=class{constructor(l,a,u,s,c){this.logService=l,this.windowsMainService=a,this.urlService=u,this.workspacesManagementMainService=s,this.configurationService=c}async start(l,a){this.logService.trace("Received data from other instance: ",l,a),C.isMacintosh&&v.app.focus({steal:!0});const u=this.parseOpenUrl(l);if(u.length){let s=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(s=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),s.then(()=>{for(const{uri:c,url:i}of u)this.urlService.open(c,{originalUrl:i})})}else return this.startOpenWindow(l,a)}parseOpenUrl(l){return l["open-url"]&&l._urls&&l._urls.length>0?(0,R.coalesce)(l._urls.map(a=>{try{return{uri:I.URI.parse(a),url:a}}catch(u){return null}})):[]}async startOpenWindow(l,a){const u=(0,y.isLaunchedFromCli)(a)?0:4;let s=[];const c=l.wait&&l.waitMarkerFilePath?I.URI.file(l.waitMarkerFilePath):void 0,i=l.remote||void 0,r={context:u,cli:l,userEnv:a,waitMarkerFileURI:c,remoteAuthority:i};if(l.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(l.extensionDevelopmentPath,r);else if(!l._.length&&!l["folder-uri"]&&!l["file-uri"]){let o=!1;if(l["new-window"]||l["unity-launch"])o=!0;else if(l["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!C.isMacintosh}if(o)s=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const d=this.windowsMainService.getLastActiveWindow();d?(this.windowsMainService.openExistingWindow(d,r),s=[d]):s=this.windowsMainService.open({...r,forceEmpty:!0})}}else s=this.windowsMainService.open({...r,forceNewWindow:l["new-window"],preferNewWindow:!l["reuse-window"]&&!l.wait,forceReuseWindow:l["reuse-window"],diffMode:l.diff,addMode:l.add,noRecentEntry:!!l["skip-add-to-recently-opened"],gotoLineMode:l.goto});if(c&&s.length===1&&s[0])return Promise.race([s[0].whenClosedOrLoaded,(0,h.whenDeleted)(c.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const l=[];return v.BrowserWindow.getAllWindows().forEach(a=>{const u=this.windowsMainService.getWindowById(a.id);u?l.push(this.codeWindowToInfo(u)):l.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:l,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(l){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(s=>new Promise(c=>{const i=s.remoteAuthority;if(i){const r=`vscode:getDiagnosticInfoResponse${s.id}`,o={includeProcesses:l.includeProcesses,folders:l.includeWorkspaceMetadata?this.getFolderURIs(s):void 0};s.sendWhenReady("vscode:getDiagnosticInfo",M.CancellationToken.None,{replyChannel:r,args:o}),v.ipcMain.once(r,(d,g)=>{g||c({hostName:i,errorMessage:`Unable to resolve connection to '${i}'.`}),c(g)}),setTimeout(()=>{c({hostName:i,errorMessage:`Fetching remote diagnostics for '${i}' timed out.`})},5e3)}else c(void 0)})))).filter(s=>!!s)}getFolderURIs(l){const a=[],u=l.openedWorkspace;if((0,w.isSingleFolderWorkspaceIdentifier)(u))a.push(u.uri);else if((0,w.isWorkspaceIdentifier)(u)){const s=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);s&&s.folders.forEach(i=>{a.push(i.uri)})}return a}codeWindowToInfo(l){const a=this.getFolderURIs(l),u=(0,n.assertIsDefined)(l.win);return this.browserWindowToInfo(u,a,l.remoteAuthority)}browserWindowToInfo(l,a=[],u){return{pid:l.webContents.getOSProcessId(),title:l.getTitle(),folderURIs:a,remoteAuthority:u}}};S=ge([te(0,m.ILogService),te(1,t.IWindowsMainService),te(2,p.IURLService),te(3,b.IWorkspacesManagementMainService),te(4,f.IConfigurationService)],S),e.LaunchMainService=S}),define(Q[53],Z([0,1,43,14,26,117,46,4,33,2,10,8,3,7,82,71,21,150,52,24,5,20,6,22,29,66,36,27,45]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a,u,s,c,i,r,o,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let k=class ft extends f.Disposable{constructor(A,W,V,ee,oe,ae,K,F,U,G){super();this.sharedProcess=A,this.windowsMainService=W,this.dialogMainService=V,this.lifecycleMainService=ee,this.environmentMainService=oe,this.telemetryService=ae,this.logService=K,this.productService=F,this.themeMainService=U,this.workspacesManagementMainService=G,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-maximize",(Y,q)=>q.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-unmaximize",(Y,q)=>q.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(Y,q)=>q.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(Y,q)=>q.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(Y,q,z)=>z),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),I.Event.fromNodeEventEmitter(R.screen,"display-added"),I.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){R.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(A){return this.windowsMainService.getWindowCount()}async getActiveWindowId(A){const W=R.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(A,W,V){return Array.isArray(W)?this.doOpenWindow(A,W,V):this.doOpenEmptyWindow(A,W)}async doOpenWindow(A,W,V=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:A,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:V.forceNewWindow,forceReuseWindow:V.forceReuseWindow,preferNewWindow:V.preferNewWindow,diffMode:V.diffMode,addMode:V.addMode,gotoLineMode:V.gotoLineMode,noRecentEntry:V.noRecentEntry,waitMarkerFileURI:V.waitMarkerFileURI,remoteAuthority:V.remoteAuthority||void 0})}async doOpenEmptyWindow(A,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:A},W)}async toggleFullScreen(A){const W=this.windowById(A);W&&W.toggleFullScreen()}async handleTitleDoubleClick(A){const W=this.windowById(A);W&&W.handleTitleDoubleClick()}async isMaximized(A){const W=this.windowById(A);return W?.win?W.win.isMaximized():!1}async maximizeWindow(A){const W=this.windowById(A);W?.win&&W.win.maximize()}async unmaximizeWindow(A){const W=this.windowById(A);W?.win&&W.win.unmaximize()}async minimizeWindow(A){const W=this.windowById(A);W?.win&&W.win.minimize()}async focusWindow(A,W){W&&typeof W.windowId=="number"&&(A=W.windowId);const V=this.windowById(A);V&&V.focus({force:W?.force??!1})}async setMinimumSize(A,W,V){const ee=this.windowById(A);if(ee?.win){const[oe,ae]=ee.win.getSize(),[K,F]=ee.win.getMinimumSize(),[U,G]=[W??K,V??F],[Y,q]=[Math.max(oe,U),Math.max(ae,G)];(K!==U||F!==G)&&ee.win.setMinimumSize(U,G),(oe!==Y||ae!==q)&&ee.win.setSize(Y,q)}}async saveWindowSplash(A,W){this.themeMainService.saveWindowSplash(A,W)}async installShellCommand(A){const{source:W,target:V}=await this.getShellCommandLink();try{const{symbolicLink:ee}=await b.SymlinkSupport.stat(W);if(ee&&!ee.dangling){const oe=await(0,t.realpath)(W);if(V===oe)return}await b.Promises.unlink(W)}catch(ee){if(ee.code!=="ENOENT")throw ee}try{await b.Promises.symlink(V,W)}catch(ee){if(ee.code!=="EACCES"&&ee.code!=="ENOENT")throw ee;const{response:oe}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${V}' '${W}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(ae)}catch(ae){throw new Error((0,S.localize)(3,null,W))}}}async uninstallShellCommand(A){const{source:W}=await this.getShellCommandLink();try{await b.Promises.unlink(W)}catch(V){switch(V.code){case"EACCES":const{response:ee}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ee===0)try{const oe=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(oe)}catch(oe){throw new Error((0,S.localize)(7,null,W))}break;case"ENOENT":break;default:throw V}}}async getShellCommandLink(){const A=(0,E.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(A))throw new Error((0,S.localize)(8,null,A));return{source:W,target:A}}async showMessageBox(A,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(A))}async showSaveDialog(A,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(A))}async showOpenDialog(A,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(A))}toBrowserWindow(A){const W=this.windowById(A);if(W?.win)return W.win}async pickFileFolderAndOpen(A,W){const V=await this.dialogMainService.pickFileFolder(W);V&&(this.sendPickerTelemetry(V,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(V.map(async ee=>await b.SymlinkSupport.existsDirectory(ee)?{folderUri:p.URI.file(ee)}:{fileUri:p.URI.file(ee)})),W,A))}async pickFolderAndOpen(A,W){const V=await this.dialogMainService.pickFolder(W);V&&(this.sendPickerTelemetry(V,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(V.map(ee=>({folderUri:p.URI.file(ee)})),W,A))}async pickFileAndOpen(A,W){const V=await this.dialogMainService.pickFile(W);V&&(this.sendPickerTelemetry(V,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(V.map(ee=>({fileUri:p.URI.file(ee)})),W,A))}async pickWorkspaceAndOpen(A,W){const V=await this.dialogMainService.pickWorkspace(W);V&&(this.sendPickerTelemetry(V,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(V.map(ee=>({workspaceUri:p.URI.file(ee)})),W,A))}doOpenPicked(A,W,V){this.windowsMainService.open({context:3,contextWindowId:V,cli:this.environmentMainService.args,urisToOpen:A,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(A,W,V){const ee=A?A.length:0;this.telemetryService.publicLog(W,{...V,outcome:ee?"success":"canceled",numberOfPaths:ee})}async showItemInFolder(A,W){R.shell.showItemInFolder(W)}async setRepresentedFilename(A,W){const V=this.windowById(A);V&&V.setRepresentedFilename(W)}async setDocumentEdited(A,W){const V=this.windowById(A);V&&V.setDocumentEdited(W)}async openExternal(A,W){return m.isLinuxSnap?this.safeSnapOpenExternal(W):R.shell.openExternal(W),!0}safeSnapOpenExternal(A){const W=process.env.GDK_PIXBUF_MODULE_FILE,V=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,R.shell.openExternal(A),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=V}moveItemToTrash(A,W){return R.shell.trashItem(W)}async isAdmin(){let A;return m.isWindows?A=(await new Promise((W,V)=>{$(["native-is-elevated"],W,V)}))():A=process.getuid()===0,A}async writeElevated(A,W,V,ee){const oe=await new Promise((ae,K)=>{$(["@vscode/sudo-prompt"],ae,K)});return new Promise((ae,K)=>{const F=[`"${this.cliPath}"`];ee?.unlock&&F.push("--file-chmod"),F.push("--file-write",`"${W.fsPath}"`,`"${V.fsPath}"`);const U={name:this.productService.nameLong.replace("-",""),icns:m.isMacintosh&&this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};oe.exec(F.join(" "),U,(G,Y,q)=>{Y&&this.logService.trace(`[sudo-prompt] received stdout: ${Y}`),q&&this.logService.trace(`[sudo-prompt] received stderr: ${q}`),G?K(G):ae(void 0)})})}get cliPath(){return m.isWindows?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):m.isLinux?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,E.join)(this.environmentMainService.appRoot,"bin","code"):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,M.totalmem)(),freemem:(0,M.freemem)(),loadavg:(0,M.loadavg)()}}async getOSProperties(){return{arch:(0,M.arch)(),platform:(0,M.platform)(),release:(0,M.release)(),type:(0,M.type)(),cpus:(0,M.cpus)()}}async getOSVirtualMachineHint(){return w.virtualMachineHint.value()}get osColorScheme(){return{highContrast:R.nativeTheme.shouldUseInvertedColorScheme||R.nativeTheme.shouldUseHighContrastColors,dark:R.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(A,W,V){process.kill(W,V)}async readClipboardText(A,W){return R.clipboard.readText(W)}async writeClipboardText(A,W,V){return R.clipboard.writeText(W,V)}async readClipboardFindText(A){return R.clipboard.readFindText()}async writeClipboardFindText(A,W){return R.clipboard.writeFindText(W)}async writeClipboardBuffer(A,W,V,ee){return R.clipboard.writeBuffer(W,Buffer.from(V),ee)}async readClipboardBuffer(A,W){return R.clipboard.readBuffer(W)}async hasClipboard(A,W,V){return R.clipboard.has(W,V)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(A,W){const V=this.windowById(A);V&&V.updateTouchBar(W)}async notifyReady(A){const W=this.windowById(A);W&&W.setReady()}async relaunch(A,W){return this.lifecycleMainService.relaunch(W)}async reload(A,W){const V=this.windowById(A);if(V){if((0,d.isWorkspaceIdentifier)(V.openedWorkspace)){const ee=V.openedWorkspace.configPath;if(ee.scheme===y.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ee))?.transient)return this.openWindow(V.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(V,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(A){this.closeWindowById(A,A)}async closeWindowById(A,W){const V=this.windowById(W);if(V?.win)return V.win.close()}async quit(A){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(A,W){await this.lifecycleMainService.kill(W)}async resolveProxy(A,W){const ee=this.windowById(A)?.win?.webContents?.session;if(ee)return ee.resolveProxy(W)}async openDevTools(A,W){const V=this.windowById(A);V?.win&&V.win.webContents.openDevTools(W)}async toggleDevTools(A){const W=this.windowById(A);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(A,W){const V=this.windowById(A);V?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&V.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(A,W,V,ee){if(!m.isWindows)return;const oe=await new Promise((ae,K)=>{$(["vscode-windows-registry"],ae,K)});try{return oe.GetStringRegKey(W,V,ee)}catch{return}}async getPassword(A,W,V){const ee=await this.withKeytar(),oe=await ee.getPassword(W,V);if(oe)try{let{content:ae,hasNextChunk:K}=JSON.parse(oe);if(!ae||!K)return oe;let F=1;for(;K;){const U=await ee.getPassword(W,`${V}-${F}`),G=JSON.parse(U);ae+=G.content,K=G.hasNextChunk,F++}return ae}catch{return oe}return oe}async setPassword(A,W,V,ee){const oe=await this.withKeytar(),ae=3,K=async(F,U,G)=>{let Y=0,q;for(;Y<ae;)try{await oe.setPassword(F,U,G);return}catch(z){q=z,this.logService.warn("Error attempting to set a password: ",z),Y++,await new Promise(J=>setTimeout(J,200))}throw q};if(m.isWindows&&ee.length>ft.MAX_PASSWORD_LENGTH){let F=0,U=0,G=!0;for(;G;){const Y=ee.substring(F,F+ft.PASSWORD_CHUNK_SIZE);F+=ft.PASSWORD_CHUNK_SIZE,G=ee.length-F>0;const q={content:Y,hasNextChunk:G};await K(W,U?`${V}-${U}`:V,JSON.stringify(q)),U++}}else await K(W,V,ee);this._onDidChangePassword.fire({service:W,account:V})}async deletePassword(A,W,V){const oe=await(await this.withKeytar()).deletePassword(W,V);return oe&&this._onDidChangePassword.fire({service:W,account:V}),oe}async findPassword(A,W){return(await this.withKeytar()).findPassword(W)}async findCredentials(A,W){return(await this.withKeytar()).findCredentials(W)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((A,W)=>{$(["keytar"],A,W)})}windowById(A){if(typeof A=="number")return this.windowsMainService.getWindowById(A)}};k.MAX_PASSWORD_LENGTH=2500,k.PASSWORD_CHUNK_SIZE=k.MAX_PASSWORD_LENGTH-100,ge([n.memoize],k.prototype,"cliPath",null),k=ge([te(1,o.IWindowsMainService),te(2,P.IDialogMainService),te(3,u.ILifecycleMainService),te(4,l.IEnvironmentMainService),te(5,i.ITelemetryService),te(6,s.ILogService),te(7,c.IProductService),te(8,r.IThemeMainService),te(9,g.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(Q[235],Z([0,1,14,23,4,81,2,31,89,6,53,22,36]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let t=class extends n.Disposable{constructor(b,S,P,l,a){super();this.logService=b,this.windowsMainService=S,this.nativeHostMainService=P,this.encryptionMainService=l,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=M.Event.fromNodeEventEmitter(v.app,"login",(S,P,l,a,u)=>({event:S,webContents:P,req:l,authInfo:a,callback:u}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:S,req:P,callback:l}){if(!S.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(S);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}l(a?.username,a?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const S=await this.doResolveProxyCredentials(b);if(S)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),S;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const S=String((0,C.hash)({scheme:b.scheme,host:b.host,port:b.port}));let P,l;try{const c=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S);if(c){const i=JSON.parse(await this.encryptionMainService.decrypt(c));P=i.username,l=i.password}}catch(c){this.logService.error(c)}if(this.state!==p.StoredCredentialsUsed&&typeof P=="string"&&typeof l=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:P,password:l};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const u={authInfo:b,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??l,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,u),this.state=p.LoginDialogShown;const s=await new Promise(c=>{const i=async(r,o,d)=>{if(o===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",i),d){const g={username:d.username,password:d.password};try{if(d.remember){const k=await this.encryptionMainService.encrypt(JSON.stringify(g));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S,k)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S)}catch(k){this.logService.error(k)}c({username:g.username,password:g.password})}else c(void 0)};a.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=s,s}};t=ge([te(0,f.ILogService),te(1,m.IWindowsMainService),te(2,y.INativeHostMainService),te(3,h.IEncryptionMainService),te(4,E.IProductService)],t),e.ProxyAuthHandler=t}),define(Q[236],Z([0,1,14,26,33,2,10,3,83,148,74,52,24,5,103,6,53,56,22,57,67]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let u=class Pt{constructor(c,i,r,o,d,g,k,L,A){this.userEnv=c,this.environmentMainService=i,this.launchMainService=r,this.logService=o,this.diagnosticsService=d,this.dialogMainService=g,this.nativeHostMainService=k,this.protocolMainService=L,this.productService=A,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async c=>{const[i,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(i,r);this.safeSend(c,"vscode:issueSystemInfoResponse",o)}),v.ipcMain.on("vscode:listProcesses",async c=>{const i=[];try{const r=await this.launchMainService.getMainProcessId();i.push({name:(0,f.localize)(0,null),rootProcess:await(0,h.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(d=>{(0,y.isRemoteDiagnosticError)(d)?i.push({name:d.hostName,rootProcess:d}):d.processes&&i.push({name:d.hostName,rootProcess:d.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(c,"vscode:listProcessesResponse",i)}),v.ipcMain.on("vscode:issueReporterClipboard",async c=>{const i={title:this.productService.nameLong,message:(0,f.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,f.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,f.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(c,"vscode:issueReporterClipboardResponse",r.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async c=>{const i=await this.getPerformanceInfo();this.safeSend(c,"vscode:issuePerformanceInfoResponse",i)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const c={title:this.productService.nameLong,message:(0,f.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,f.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,f.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(c,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(c,i)=>{const{id:r,from:o,args:d}=i;let g;switch(o){case"issueReporter":g=this.issueReporterParentWindow;break;case"processExplorer":g=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}g&&g.webContents.send("vscode:runAction",{id:r,from:o,args:d})}),v.ipcMain.on("vscode:openExternal",(c,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),v.ipcMain.on("vscode:closeIssueReporter",c=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",c=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async c=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(c,"vscode:windowsInfoResponse",i.windows)})}safeSend(c,i,...r){c.sender.isDestroyed()||c.sender.send(i,...r)}async openReporter(c){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new C.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,r,{backgroundColor:c.styles.backgroundColor,title:(0,f.localize)(7,null),zoomLevel:c.zoomLevel,alwaysOnTop:!1},"issue-reporter"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:c,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:S.default}),this.issueReporterWindow.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",$).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(c){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new C.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,r,{backgroundColor:c.styles.backgroundColor,title:(0,f.localize)(8,null),zoomLevel:c.zoomLevel,alwaysOnTop:!0},"process-explorer"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:c,product:S.default}),this.processExplorerWindow.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",$).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(c){c.isMinimized()&&c.restore(),c.focus()}createBrowserWindow(c,i,r,o){const d=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:c.width,height:c.height,minWidth:300,minHeight:200,x:c.x,y:c.y,title:r.title,backgroundColor:r.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:n.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${o}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return d.setMenuBarVisibility(!1),d}async getSystemStatus(){const[c,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(c,i)}getWindowPosition(c,i,r){let o;const d=v.screen.getAllDisplays();if(d.length===1)o=d[0];else{if(I.isMacintosh){const L=v.screen.getCursorScreenPoint();o=v.screen.getDisplayNearestPoint(L)}!o&&c&&(o=v.screen.getDisplayMatching(c.getBounds())),o||(o=v.screen.getPrimaryDisplay()||d[0])}const g={width:i,height:r},k=o.bounds;return g.x=k.x+k.width/2-g.width/2,g.y=k.y+k.height/2-g.height/2,k.width>0&&k.height>0&&(g.x<k.x&&(g.x=k.x),g.y<k.y&&(g.y=k.y),g.x>k.x+k.width&&(g.x=k.x),g.y>k.y+k.height&&(g.y=k.y),g.width>k.width&&(g.width=k.width),g.height>k.height&&(g.height=k.height)),g}async getPerformanceInfo(){try{const[c,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(c,i)}catch(c){throw this.logService.warn("issueService#getPerformanceInfo ",c.message),c}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=ge([te(1,m.IEnvironmentMainService),te(2,t.ILaunchMainService),te(3,w.ILogService),te(4,y.IDiagnosticsService),te(5,E.IDialogMainService),te(6,b.INativeHostMainService),te(7,l.IProtocolMainService),te(8,P.IProductService)],u),e.IssueMainService=u}),define(Q[237],Z([0,1,23,19,24,20,6,53,22,50,29,41,77]),function($,e,v,R,M,C,n,I,h,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends m.AbstractUpdateService{constructor(w,b,S,P,l,a,u,s){super(w,b,P,l,a,s);this.telemetryService=S,this.nativeHostMainService=u}buildUpdateFeedUrl(w){return(0,m.createUpdateURL)(`linux-${process.arch}`,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(E.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},v.CancellationToken.None).then(f.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(E.State.Idle(1))):this.setState(E.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const S=w?b.message||b:void 0;this.setState(E.State.Idle(1,S))}))}async doDownloadUpdate(w){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(E.State.Idle(1))}};p=ge([te(0,C.ILifecycleMainService),te(1,R.IConfigurationService),te(2,y.ITelemetryService),te(3,M.IEnvironmentMainService),te(4,f.IRequestService),te(5,n.ILogService),te(6,I.INativeHostMainService),te(7,h.IProductService)],p),e.LinuxUpdateService=p}),define(Q[238],Z([0,1,43,28,26,9,23,46,8,7,114,21,19,24,18,20,6,53,22,50,29,41,77]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function c(d,g=1e3){for(;!d();)await(0,C.timeout)(g)}let i;function r(){return typeof i=="undefined"&&(i=R.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends s.AbstractUpdateService{constructor(g,k,L,A,W,V,ee,oe,ae){super(g,k,A,W,V,ae);this.telemetryService=L,this.fileService=ee,this.nativeHostMainService=oe}get cachePath(){const g=h.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(g,{recursive:!0}).then(()=>g)}initialize(){super.initialize(),r()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(g){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),r()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,s.createUpdateURL)(k,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(u.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},n.CancellationToken.None).then(l.asJson).then(k=>{const L=r();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(u.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(u.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(u.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(A=>E.Promises.exists(A).then(W=>{if(W)return Promise.resolve(A);const V=k.url,ee=k.hash,oe=`${A}.tmp`;return this.requestService.request({url:V},n.CancellationToken.None).then(ae=>this.fileService.writeFile(f.URI.file(oe),ae.stream)).then(ee?()=>(0,y.checksum)(oe,k.hash):()=>{}).then(()=>E.Promises.rename(oe,A)).then(()=>A)})).then(A=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},W&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(k)):this.setState(u.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const L=g?k.message||k:void 0;this.setState(u.State.Idle(r(),L))}))}async doDownloadUpdate(g){g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(u.State.Idle(r()))}async getUpdatePackagePath(g){const k=await this.cachePath;return h.join(k,`CodeSetup-${this.productService.quality}-${g}.exe`)}async cleanup(g=null){const k=g?V=>!new RegExp(`${this.productService.quality}-${g}\\.exe$`).test(V):()=>!0,L=await this.cachePath,W=(await E.Promises.readdir(L)).filter(k).map(async V=>{try{await E.Promises.unlink(h.join(L,V))}catch(ee){}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const g=this.state.update;this.setState(u.State.Updating(g));const k=await this.cachePath;this.availableUpdate.updateFilePath=h.join(k,`CodeSetup-${this.productService.quality}-${g.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(r()))});const A=`${this.productService.win32MutexName}-ready`,W=await new Promise((V,ee)=>{$(["windows-mutex"],V,ee)});c(()=>W.isActive(A)).then(()=>this.setState(u.State.Ready(g)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?R.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}};ge([I.memoize],o.prototype,"cachePath",null),o=ge([te(0,w.ILifecycleMainService),te(1,m.IConfigurationService),te(2,a.ITelemetryService),te(3,p.IEnvironmentMainService),te(4,l.IRequestService),te(5,b.ILogService),te(6,t.IFileService),te(7,S.INativeHostMainService),te(8,P.IProductService)],o),e.Win32UpdateService=o}),define(Q[239],Z([0,1,14,9,23,44,4,33,2,10,8,63,3,7,154,51,19,52,24,54,205,18,20,6,22,57,100,29,208,66,67,36,27,45]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a,u,s,c,i,r,o,d,g,k,L,A,W,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ee;(function(ae){ae[ae.NONE=0]="NONE",ae[ae.LOADING=1]="LOADING",ae[ae.NAVIGATING=2]="NAVIGATING",ae[ae.READY=3]="READY"})(ee||(ee={}));let oe=class extends h.Disposable{constructor(K,F,U,G,Y,q,z,J,O,D,T,_,B,X,N){super();this.logService=F,this.environmentMainService=U,this.fileService=G,this.configurationService=q,this.themeMainService=z,this.workspacesManagementMainService=J,this.backupMainService=O,this.telemetryService=D,this.dialogMainService=T,this.lifecycleMainService=_,this.productService=B,this.protocolMainService=X,this.windowsMainService=N,this._onWillLoad=this._register(new n.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new n.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new n.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new n.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[H,ie]=this.restoreWindowState(K.state);this.windowState=H,this.logService.trace("window#ctor: using window state",H);const re=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),x={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:L.WindowMinimumSize.WIDTH,minHeight:L.WindowMinimumSize.HEIGHT,show:!re,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,L.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};m.isLinux?x.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):m.isWindows&&!this.environmentMainService.isBuilt&&(x.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.useNativeFullScreen()&&(x.fullscreenable=!1),m.isMacintosh&&(x.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(x.acceptFirstMouse=!1));const ce=m.isMacintosh&&se?.nativeTabs===!0;ce&&(x.tabbingIdentifier=this.productService.nameShort);const le=(0,L.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(x.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,m.isMacintosh||(x.frame=!1)),(0,E.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(x),(0,E.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),m.isMacintosh&&le&&this._win.setSheetOffset(22),m.isMacintosh&&ie&&(!ce||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")){const he=this.windowState;this._win.setBounds({width:he.width,height:he.height,x:he.x,y:he.y})}re&&((0,E.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,E.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:H=>Y.globalStorage.get(H),store:(H,ie)=>Y.globalStorage.set(H,ie)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){m.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return m.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){m.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return m.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){m.isMacintosh&&K?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function F(){U.dispose(),G.dispose(),K()}const U=this.onDidClose(()=>F()),G=this.onWillLoad(()=>F())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(Y,q)=>this.onWindowError(2,q)),this._win.webContents.on("did-fail-load",(Y,q,z)=>this.onWindowError(3,{reason:z,exitCode:q})),this._win.webContents.on("will-prevent-unload",Y=>{Y.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),F=Y=>{for(let q=Y;q;q=q.parent)if(q.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},U=Y=>Y.resourceType==="xhr"||F(Y.frame);this._win.webContents.session.webRequest.onBeforeRequest((Y,q)=>{const z=p.URI.parse(Y.url);return z.path.endsWith(".svg")&&!K.has(z.scheme)?q({cancel:!U(Y)}):q({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((Y,q)=>{const z=Y.responseHeaders,J=z["content-type"]||z["Content-Type"];if(J&&Array.isArray(J)){const O=p.URI.parse(Y.url);if(O.path.endsWith(".svg")&&K.has(O.scheme))return z["Content-Type"]=["image/svg+xml"],q({cancel:!1,responseHeaders:z});if(!O.path.includes(f.Schemas.vscodeRemoteResource)&&J.some(D=>D.toLowerCase().includes("image/svg")))return q({cancel:!U(Y)})}return q({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",Y,this._win)}),this._win.on("unmaximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",Y,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",M.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",M.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(Y=>this.onDidDeleteUntitledWorkspace(Y)));const G=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:G},async(Y,q)=>{const z=await this.marketplaceHeadersPromise;q({cancel:!1,requestHeaders:Object.assign(Y.requestHeaders,z)})})}async onWindowError(K,F){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:F?.reason,code:F?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(U.response!==1){const G=U.response===0;this.destroyWindow(G)}}else if(K===2){let U;F?U=(0,t.localize)(6,null,F.reason,F.exitCode??"<unknown>"):U=(0,t.localize)(5,null);const Y=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:U,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(Y)}break}}destroyWindow(K){if(this._onDidDestroy.fire(),this._win?.destroy(),K&&this.config){let F,U;(0,W.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?F={folderUri:this.openedWorkspace.uri}:(0,W.isWorkspaceIdentifier)(this.openedWorkspace)?F={workspaceUri:this.openedWorkspace.configPath}:U=!0;const[G]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:F?[F]:void 0,forceEmpty:U,forceNewWindow:!0});G.focus()}}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let F=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.currentHttpProxy||U!==this.currentNoProxy)){this.currentHttpProxy=F,this.currentNoProxy=U;const G=F||"",Y=U?`${U},<local>`:"<local>";this.logService.trace(`Setting proxy to '${G}', bypassing '${Y}'`),this._win.webContents.session.setProxy({proxyRules:G,proxyBypassRules:Y,pacScript:""})}}addTabbedWindow(K){m.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,F=Object.create(null)){this.isDocumentEdited()&&(!F.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,F),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",$).toString(!0));const U=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new R.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:F.isReload?3:U?2:1})}updateConfiguration(K,F){const U=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(U){const G=(0,l.isLaunchedFromCli)(U)&&!(0,l.isLaunchedFromCli)(K.userEnv),Y=this.isExtensionDevelopmentHost;(G||Y)&&(K.userEnv={...U,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(K["disable-extensions"]=F.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,E.mark)("code/willOpenNewWindow"),K.perfMarks=(0,E.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const F=Object.assign({},this.currentConfig);F.workspace=await this.validateWorkspaceBeforeReload(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToWait,this.isExtensionDevelopmentHost&&K&&(F.verbose=K.verbose,F.debugId=K.debugId,F.extensionEnvironment=K.extensionEnvironment,F["inspect-extensions"]=K["inspect-extensions"],F["inspect-brk-extensions"]=K["inspect-brk-extensions"],F["extensions-dir"]=K["extensions-dir"]),F.isInitialStartup=!1,this.load(F,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,W.isWorkspaceIdentifier)(K.workspace)){const F=K.workspace.configPath;if(F.scheme===f.Schemas.file&&!await this.fileService.exists(F))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(K.workspace)){const F=K.workspace.uri;if(F.scheme===f.Schemas.file&&!await this.fileService.exists(F))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,A.defaultWindowState)();if(this.isFullScreen){let U;try{U=v.screen.getDisplayMatching(this.getBounds())}catch(q){}const G=(0,A.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||G.width,height:this.windowState.height||G.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let F;if(!m.isMacintosh&&this._win.isMaximized()?F=0:F=1,F===0?K.mode=0:K.mode=1,F===1||F===0){let U;F===1?U=this.getBounds():U=this._win.getNormalBounds(),K.x=U.x,K.y=U.y,K.width=U.width,K.height=U.height}return K}restoreWindowState(K){(0,E.mark)("code/willRestoreCodeWindowState");let F=!1;if(K)try{const U=v.screen.getAllDisplays();F=U.length>1,K=this.validateWindowState(K,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,E.mark)("code/didRestoreCodeWindowState"),[K||(0,A.defaultWindowState)(),F]}validateWindowState(K,F){if(this.logService.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const Y=this.getWorkingArea(F[0]);if(Y){let q=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!Y||(K.x<Y.x&&(K.x=Y.x),K.y<Y.y&&(K.y=Y.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",Y),q(),K.width>Y.width&&(K.width=Y.width),K.height>Y.height&&(K.height=Y.height),K.x>Y.x+Y.width-128&&(K.x=Y.x+Y.width-K.width),K.y>Y.y+Y.height-128&&(K.y=Y.y+Y.height-K.height),q()}return K}if(K.display&&K.mode===3){const Y=F.find(q=>q.id===K.display);if(Y&&typeof Y.bounds?.x=="number"&&typeof Y.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const q=(0,A.defaultWindowState)(3);return q.x=Y.bounds.x,q.y=Y.bounds.y,q}}let U,G;try{U=v.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),G=this.getWorkingArea(U)}catch(Y){}if(U&&G&&K.x+K.width>G.x&&K.y+K.height>G.y&&K.x<G.x+G.width&&K.y<G.y+G.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",G),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,F]=this._win.getPosition(),[U,G]=this._win.getSize();return{x:K,y:F,width:U,height:G}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",M.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,L.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,F=!0){m.isMacintosh||(K==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const F=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!F),this._win.autoHideMenuBar=F;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,F,...U){this.isReady?this.send(K,...U):this.ready().then(()=>{F.isCancellationRequested||this.send(K,...U)})}send(K,...F){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${K}' for window that is destroyed`);return}try{this._win.webContents.send(K,...F)}catch(U){this.logService.warn(`Error sending IPC message to channel '${K}' of window ${this._id}: ${(0,C.toErrorMessage)(U)}`)}}}updateTouchBar(K){!m.isMacintosh||this.touchBarGroups.forEach((F,U)=>{const G=K[U];F.segments=this.createTouchBarGroupSegments(G)})}createTouchBar(){if(!!m.isMacintosh){for(let K=0;K<10;K++){const F=this.createTouchBarGroup();this.touchBarGroups.push(F)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const F=this.createTouchBarGroupSegments(K),U=new v.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:G=>{this.sendWhenReady("vscode:runAction",M.CancellationToken.None,{id:U.segments[G].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(K=[]){return K.map(U=>{let G;U.icon&&!g.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===f.Schemas.file&&(G=v.nativeImage.createFromPath(p.URI.revive(U.icon.dark).fsPath),G.isEmpty()&&(G=void 0));let Y;return typeof U.title=="string"?Y=U.title:Y=U.title.value,{id:U.id,label:G?void 0:Y,icon:G}})}dispose(){super.dispose(),this._win=null}};oe=ge([te(1,c.ILogService),te(2,P.IEnvironmentMainService),te(3,u.IFileService),te(4,o.IStorageMainService),te(5,b.IConfigurationService),te(6,k.IThemeMainService),te(7,V.IWorkspacesManagementMainService),te(8,w.IBackupMainService),te(9,d.ITelemetryService),te(10,S.IDialogMainService),te(11,s.ILifecycleMainService),te(12,i.IProductService),te(13,r.IProtocolMainService),te(14,A.IWindowsMainService)],oe),e.CodeWindow=oe}),define(Q[68],Z([0,1,14,30,9,4,33,2,10,3,15,7,21,157,5,20,6,38,27,45]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class qe extends I.Disposable{constructor(s,c,i,r){super();this.stateMainService=s,this.logService=c,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace}])))}handleWindowsJumpList(){!f.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(s){const c=[],i=[];for(let r of s)if((0,P.isRecentWorkspace)(r))!this.workspacesManagementMainService.isUntitledWorkspace(r.workspace)&&this.indexOfWorkspace(c,r.workspace)===-1&&c.push(r);else if((0,P.isRecentFolder)(r))this.indexOfFolder(c,r.folderUri)===-1&&c.push(r);else{const o=this.indexOfFile(i,r.fileUri)>=0,d=r.fileUri.scheme===h.Schemas.file&&qe.COMMON_FILES_FILTER.indexOf((0,y.basename)(r.fileUri))>=0;!o&&!d&&(i.push(r),f.isWindows&&r.fileUri.scheme===h.Schemas.file&&v.app.addRecentDocument(r.fileUri.fsPath))}this.addEntriesFromStorage(c,i),c.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(c.length=qe.MAX_TOTAL_RECENT_ENTRIES),i.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(i.length=qe.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:c,files:i}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(s){const c=d=>{const g=this.location(d);for(const k of s)if(y.extUriBiasedIgnorePathCase.isEqual(k,g))return!1;return!0},i=this.getRecentlyOpened(),r=i.workspaces.filter(c),o=i.files.filter(c);(r.length!==i.workspaces.length||o.length!==i.files.length)&&(this.saveRecentlyOpened({files:o,workspaces:r}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!f.isMacintosh)return;v.app.clearRecentDocuments();const s=this.getRecentlyOpened(),c=[];let i=0;for(let o=0;o<s.workspaces.length&&i<qe.MAX_MACOS_DOCK_RECENT_WORKSPACES;o++){const d=this.location(s.workspaces[o]);if(d.scheme===h.Schemas.file){const g=(0,y.originalFSPath)(d);await m.Promises.exists(g)&&(c.push(g),i++)}}const r=[];for(let o=0;o<s.files.length&&i<qe.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;o++){const d=this.location(s.files[o]);if(d.scheme===h.Schemas.file){const g=(0,y.originalFSPath)(d);if(qe.COMMON_FILES_FILTER.includes((0,y.basename)(d))||c.includes(g))continue;await m.Promises.exists(g)&&(r.push(g),i++)}}r.reverse().forEach(o=>v.app.addRecentDocument(o)),c.reverse().forEach(o=>v.app.addRecentDocument(o))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(s){const c=[],i=[],r=s?.config?.workspace;(0,P.isWorkspaceIdentifier)(r)&&!this.workspacesManagementMainService.isUntitledWorkspace(r)?c.push({workspace:r}):(0,P.isSingleFolderWorkspaceIdentifier)(r)&&c.push({folderUri:r.uri});const o=s?.config?.filesToOpenOrCreate;if(o)for(let d of o){const g=d.fileUri;g&&this.indexOfFile(i,g)===-1&&i.push({fileUri:g})}return this.addEntriesFromStorage(c,i),{workspaces:c,files:i}}addEntriesFromStorage(s,c){let i=this.getRecentlyOpenedFromStorage();for(let r of i.workspaces){let o=(0,P.isRecentFolder)(r)?this.indexOfFolder(s,r.folderUri):this.indexOfWorkspace(s,r.workspace);o>=0?s[o].label=s[o].label||r.label:s.push(r)}for(let r of i.files){let o=this.indexOfFile(c,r.fileUri);o>=0?c[o].label=c[o].label||r.label:c.push(r)}}getRecentlyOpenedFromStorage(){const s=this.stateMainService.getItem(qe.recentlyOpenedStorageKey);return(0,P.restoreRecentlyOpened)(s,this.logService)}saveRecentlyOpened(s){const c=(0,P.toStoreData)(s);this.stateMainService.setItem(qe.recentlyOpenedStorageKey,c)}updateWindowsJumpList(){if(!f.isWindows)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let c=[];for(let o of v.app.getJumpListSettings().removedItems){const d=o.args;if(d){const g=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(d);g&&c.push(E.URI.parse(g[2]))}}this.removeRecentlyOpened(c);let i=!1;const r=(0,R.coalesce)(this.getRecentlyOpened().workspaces.slice(0,qe.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(o=>{const d=(0,P.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:g,description:k}=this.getWindowsJumpListLabel(d,o.label);let L;return E.URI.isUri(d)?L=`--folder-uri "${d.toString()}"`:(i=!0,L=`--file-uri "${d.configPath.toString()}"`),{type:"task",title:g.substr(0,255),description:k.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));r.length>0&&s.push({type:"custom",name:i?(0,p.localize)(2,null):(0,p.localize)(3,null),items:r})}s.push({type:"recent"});try{v.app.setJumpList(s)}catch(c){this.logService.warn("updateWindowsJumpList#setJumpList",c)}}getWindowsJumpListLabel(s,c){if(c)return{title:(0,n.splitName)(c).name,description:c};if(E.URI.isUri(s))return{title:(0,y.basename)(s),description:this.renderJumpListPathDescription(s)};if(this.workspacesManagementMainService.isUntitledWorkspace(s))return{title:(0,p.localize)(4,null),description:""};let i=(0,y.basename)(s.configPath);return i.endsWith(P.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,i),description:this.renderJumpListPathDescription(s.configPath)}}renderJumpListPathDescription(s){return s.scheme==="file"?(0,n.normalizeDriveLetter)(s.fsPath):s.toString()}location(s){return(0,P.isRecentFolder)(s)?s.folderUri:(0,P.isRecentFile)(s)?s.fileUri:s.workspace.configPath}indexOfWorkspace(s,c){return s.findIndex(i=>(0,P.isRecentWorkspace)(i)&&i.workspace.id===c.id)}indexOfFolder(s,c){return s.findIndex(i=>(0,P.isRecentFolder)(i)&&y.extUriBiasedIgnorePathCase.isEqual(i.folderUri,c))}indexOfFile(s,c){return s.findIndex(i=>y.extUriBiasedIgnorePathCase.isEqual(i.fileUri,c))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=ge([te(0,S.IStateMainService),te(1,b.ILogService),te(2,l.IWorkspacesManagementMainService),te(3,w.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a}),define(Q[240],Z([0,1,14,9,23,33,3,7,149,19,24,20,6,187,53,22,38,29,41,67,36,68]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let c=class St{constructor(o,d,g,k,L,A,W,V,ee,oe,ae){this.updateService=o,this.configurationService=d,this.windowsMainService=g,this.environmentMainService=k,this.telemetryService=L,this.workspacesHistoryMainService=A,this.stateMainService=W,this.lifecycleMainService=V,this.logService=ee,this.nativeHostMainService=oe,this.productService=ae,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new R.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new R.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(n.isMacintosh||(0,l.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(St.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,W,V)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,W,V)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,W,V)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(V),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,W,V)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(V),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const d=this.productService.requestFeatureUrl;d&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(d,"openUserVoiceUrl"));const g=this.productService.reportIssueUrl;g&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(g,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(n.language){const A=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${A}lang=${n.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!n.isMacintosh)return!1;let o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,d){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(St.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!n.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!n.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=v.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(n.isMacintosh?new v.Menu:null);return}const d=new v.Menu;let g;if(n.isMacintosh){const L=new v.Menu;g=new v.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),d.append(g)}if(n.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new v.Menu;L.append(new v.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:L});this.setMenuById(L,"File"),d.append(A)}if(this.shouldDrawMenu("Edit")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),d.append(A)}if(this.shouldDrawMenu("Selection")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),d.append(A)}if(this.shouldDrawMenu("View")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:L});this.setMenuById(L,"View"),d.append(A)}if(this.shouldDrawMenu("Go")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),d.append(A)}if(this.shouldDrawMenu("Run")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),d.append(A)}if(this.shouldDrawMenu("Terminal")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),d.append(A)}let k;if(this.shouldDrawMenu("Window")){const L=new v.Menu;k=new v.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(k&&d.append(k),this.shouldDrawMenu("Help")){const L=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),d.append(A)}d.items&&d.items.length>0?v.Menu.setApplicationMenu(d):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const d=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),g=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const K=new v.Menu;this.setMenuById(K,"Preferences"),k=new v.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:K})}const L=new v.Menu,A=new v.MenuItem({label:h.localize(12,null),role:"services",submenu:L}),W=new v.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),V=new v.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ee=new v.MenuItem({label:h.localize(15,null),role:"unhide"}),oe=new v.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:()=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),ae=[d];ae.push(...g),k&&ae.push(i(),k),ae.push(i(),A,i(),W,V,ee,i(),oe),ae.forEach(K=>o.append(K))}shouldDrawMenu(o){if(!n.isMacintosh&&(0,l.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(n.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(n.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,d){d.forEach(g=>{if((0,p.isMenubarMenuItemSeparator)(g))o.append(i());else if((0,p.isMenubarMenuItemSubmenu)(g)){const k=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.label),submenu:k});this.setMenu(k,g.submenu.items),o.append(L)}else(0,p.isMenubarMenuItemRecentAction)(g)?o.append(this.createOpenRecentMenuItem(g)):(0,p.isMenubarMenuItemAction)(g)&&(g.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),n.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[g.id]?o.append(new v.MenuItem(this.likeAction(g.id,{label:this.mnemonicLabel(g.label),click:this.fallbackMenuHandlers[g.id]}))):o.append(this.createMenuItem(g.label,g.id,!1,g.checked)):o.append(this.createMenuItem(g.label,g.id,g.enabled!==!1,!!g.checked)):o.append(this.createMenuItem(g.label,g.id,g.enabled!==!1,!!g.checked)))})}setMenuById(o,d){this.menubarMenus&&this.menubarMenus[d]&&this.setMenu(o,this.menubarMenus[d].items)}insertCheckForUpdatesItems(o){const d=this.getUpdateMenuItems();d.length&&(d.forEach(g=>o.append(g)),o.append(i()))}createOpenRecentMenuItem(o){const d=I.URI.revive(o.uri),g=o.id,k=g==="openRecentFile"?{fileUri:d}:g==="openRecentWorkspace"?{workspaceUri:d}:{folderUri:d};return new v.MenuItem(this.likeAction(g,{label:o.label,click:(L,A,W)=>{const V=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:V,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([d])}},!1))}isOptionClick(o){return!!(o&&(!n.isMacintosh&&(o.ctrlKey||o.shiftKey)||n.isMacintosh&&(o.metaKey||o.altKey)))}createRoleMenuItem(o,d,g){const k={label:this.mnemonicLabel(o),role:g,enabled:!0};return new v.MenuItem(this.withKeybinding(d,k))}setMacWindowMenu(o){const d=new v.MenuItem({label:h.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),g=new v.MenuItem({label:h.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new v.MenuItem({label:h.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(h.localize(20,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(i()),A.push(this.createMenuItem(h.localize(21,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(h.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(h.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(h.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[d,g,i(),L,...A,i(),k].forEach(W=>o.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:h.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:h.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:h.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,d,g,k){const L=this.mnemonicLabel(o),A=typeof d=="function"?d:(ae,K,F)=>{const U=ae?ae.userSettingsLabel:null;let G=d;Array.isArray(d)&&(G=this.isOptionClick(F)?d[1]:d[0]),U&&F.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:U}):this.runActionInRenderer({type:"commandId",commandId:G})},W=typeof g=="boolean"?g:this.windowsMainService.getWindowCount()>0,V=typeof k=="boolean"?k:!1,ee={label:L,click:A,enabled:W};V&&(ee.type="checkbox",ee.checked=V);let oe;return typeof d=="string"?oe=d:Array.isArray(d)&&(oe=d[0]),n.isMacintosh&&(oe==="editor.action.clipboardCutAction"?ee.role="cut":oe==="editor.action.clipboardCopyAction"?ee.role="copy":oe==="editor.action.clipboardPasteAction"&&(ee.role="paste"),oe==="undo"?ee.click=this.makeContextAwareClickHandler(A,{inDevTools:ae=>ae.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):oe==="redo"?ee.click=this.makeContextAwareClickHandler(A,{inDevTools:ae=>ae.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):oe==="editor.action.selectAll"&&(ee.click=this.makeContextAwareClickHandler(A,{inDevTools:ae=>ae.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(oe,ee))}makeContextAwareClickHandler(o,d){return(g,k,L)=>{const A=v.BrowserWindow.getFocusedWindow();if(!A)return d.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return d.inDevTools(A.webContents.devToolsWebContents);o(g,k||A,L)}}runActionInRenderer(o){let d=v.BrowserWindow.getFocusedWindow();if(!d){const k=this.windowsMainService.getLastActiveWindow();k?.isMinimized()&&(d=k.win)}const g=d?this.windowsMainService.getWindowById(d.id):void 0;if(g){if(this.logService.trace("menubar#runActionInRenderer",o),n.isMacintosh&&!this.environmentMainService.isBuilt&&!g.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const k={id:o.commandId,from:"menu"};g.sendWhenReady("vscode:runAction",M.CancellationToken.None,k)}else{const k={userSettingsLabel:o.userSettingsLabel};g.sendWhenReady("vscode:runKeybinding",M.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,d){const g=typeof o=="string"?this.keybindings[o]:void 0;if(g?.label){if(g.isNative!==!1)d.accelerator=g.label,d.userSettingsLabel=g.userSettingsLabel;else if(typeof d.label=="string"){const k=d.label.indexOf("[");k>=0?d.label=`${d.label.substr(0,k)} [${g.label}]`:d.label=`${d.label} [${g.label}]`}}else d.accelerator=void 0;return d}likeAction(o,d,g=!d.accelerator){g&&(d=this.withKeybinding(o,d));const k=d.click;return d.click=(L,A,W)=>{this.reportMenuActionTelemetry(o),k&&k(L,A,W)},d}openUrl(o,d){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(d)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,C.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};c.lastKnownMenubarStorageKey="lastKnownMenubarData",c=ge([te(0,P.IUpdateService),te(1,f.IConfigurationService),te(2,a.IWindowsMainService),te(3,y.IEnvironmentMainService),te(4,S.ITelemetryService),te(5,u.IWorkspacesHistoryMainService),te(6,b.IStateMainService),te(7,E.ILifecycleMainService),te(8,m.ILogService),te(9,t.INativeHostMainService),te(10,w.IProductService)],c),e.Menubar=c;function i(){return new v.MenuItem({type:"separator"})}}),define(Q[241],Z([0,1,5,20,6,240]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let n=class{constructor(h,f,y){this.instantiationService=h,this.lifecycleMainService=f,this.logService=y,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(h,f){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(f,h)}};n=ge([te(0,v.IInstantiationService),te(1,R.ILifecycleMainService),te(2,M.ILogService)],n),e.MenubarMainService=n}),define(Q[242],Z([0,1,14,28,26,30,23,4,32,42,33,2,10,8,63,3,34,15,13,7,155,51,19,52,24,18,5,20,6,56,22,57,64,38,67,239,101,221,27,102,68,45]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a,u,s,c,i,r,o,d,g,k,L,A,W,V,ee,oe,ae,K,F,U,G,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(O){return(0,F.isWorkspaceIdentifier)(O?.workspace)}function z(O){return(0,F.isSingleFolderWorkspaceIdentifier)(O?.workspace)}let J=class it extends E.Disposable{constructor(D,T,_,B,X,N,H,ie,re,se,x,ce,le,he,me){super();this.machineId=D,this.initialUserEnv=T,this.logService=_,this.stateMainService=B,this.environmentMainService=X,this.lifecycleMainService=N,this.backupMainService=H,this.configurationService=ie,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=se,this.instantiationService=x,this.dialogMainService=ce,this.fileService=le,this.productService=he,this.protocolMainService=me,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new K.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(D=>this._onDidSignalReadyWindow.fire(D.window))),this._register(this.onDidSignalReadyWindow(D=>{if(D.config?.extensionDevelopmentPath||D.config?.extensionTestsPath){const T=new E.DisposableStore;if(T.add(I.Event.any(D.onDidClose,D.onDidDestroy)(()=>T.dispose())),D.config.extensionDevelopmentPath)for(const _ of D.config.extensionDevelopmentPath)T.add(this.protocolMainService.addValidFileRoot(l.URI.file(_)));D.config.extensionTestsPath&&T.add(this.protocolMainService.addValidFileRoot(l.URI.file(D.config.extensionTestsPath)))}}))}openEmptyWindow(D,T){let _=this.environmentMainService.args;const B=T?.remoteAuthority||void 0,X=!0,N=T?.forceReuseWindow,H=!N;return this.open({...D,cli:_,forceEmpty:X,forceNewWindow:H,forceReuseWindow:N,remoteAuthority:B})}openExistingWindow(D,T){D.focus(),this.handleWaitMarkerFile(T,[D])}open(D){this.logService.trace("windowsManager#open"),D.addMode&&(D.initialStartup||!this.getLastActiveWindow())&&(D.addMode=!1);const T=[],_=[],B=[],X=[],N=[];let H,ie=0;const re=this.getPathsToOpen(D);this.logService.trace("windowsManager#open pathsToOpen",re);for(const le of re)z(le)?D.addMode?T.push(le):_.push(le):q(le)?B.push(le):le.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),H.filesToOpenOrCreate.push(le)):le.backupPath?N.push({backupFolder:(0,p.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):ie++;D.diffMode&&H&&H.filesToOpenOrCreate.length>=2&&(H.filesToDiff=H.filesToOpenOrCreate.slice(0,2),H.filesToOpenOrCreate=[]),H&&D.waitMarkerFileURI&&(H.filesToWait={paths:[...H.filesToDiff,...H.filesToOpenOrCreate],waitMarkerFileUri:D.waitMarkerFileURI}),D.initialStartup?(X.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),B.push(...X),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:se,filesOpenedInWindow:x}=this.doOpen(D,B,_,N,ie,H,T);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${_.length}, emptyToRestore: ${N.length}, emptyToOpen: ${ie})`),se.length>1)if(x)x.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!D.forceEmpty&&!D.cli._.length&&!D.cli["file-uri"]&&!D.cli["folder-uri"]&&!(D.urisToOpen&&D.urisToOpen.length);let he=!0,me=!0;if(le){const be=se.filter(de=>this.windowsStateHandler.state.lastActiveWindow&&de.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);be.length&&(be[0].focus(),he=!1,me=!1)}if(he)for(let be=se.length-1;be>=0;be--){const de=se[be];if(!(de.openedWorkspace&&X.some(fe=>de.openedWorkspace&&fe.workspace.id===de.openedWorkspace.id)||de.backupPath&&N.some(fe=>de.backupPath&&fe.backupFolder===(0,p.basename)(de.backupPath)))){de.focus(),me=!1;break}}me&&se[se.length-1].focus()}const ce=H&&H.filesToDiff.length>0;if(!se.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!D.noRecentEntry){const le=[];for(const he of re)q(he)&&!he.transient?le.push({label:he.label,workspace:he.workspace,remoteAuthority:he.remoteAuthority}):z(he)?le.push({label:he.label,folderUri:he.workspace.uri,remoteAuthority:he.remoteAuthority}):he.fileUri&&le.push({label:he.label,fileUri:he.fileUri,remoteAuthority:he.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(D,se),se}handleWaitMarkerFile(D,T){const _=D.waitMarkerFileURI;D.context===0&&_&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch(B){}})()}doOpen(D,T,_,B,X,N,H){const ie=[];let re;function se(de,fe){ie.push(de),fe&&(re=de,N=void 0)}let{openFolderInNewWindow:x,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(D);if(!D.initialStartup&&H.length>0){const de=H[0].remoteAuthority,fe=this.getLastActiveWindowForAuthority(de);fe&&se(this.doAddFoldersToExistingWindow(fe,H.map(Se=>Se.workspace.uri)))}const le=_.length+T.length+B.length;if(N&&le===0){const de=N.filesToOpenOrCreate[0]||N.filesToDiff[0],fe=this.getWindows().filter(Ce=>N&&(0,S.isEqualAuthority)(Ce.remoteAuthority,N.remoteAuthority));let Se;de?.fileUri&&!ce&&((D.context===4||D.context===0||D.context===1)&&(Se=(0,ae.findWindowOnFile)(fe,de.fileUri,Ce=>Ce.configPath.scheme===m.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Ce.configPath):void 0)),Se||(Se=this.doGetLastActiveWindow(fe))),Se?(0,F.isWorkspaceIdentifier)(Se.openedWorkspace)?T.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):(0,F.isSingleFolderWorkspaceIdentifier)(Se.openedWorkspace)?_.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):se(this.doOpenFilesInExistingWindow(D,Se,N),!0):se(this.openInBrowserWindow({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:D.forceNewTabbedWindow}),!0)}const he=(0,C.distinct)(T,de=>de.workspace.id);if(he.length>0){const de=(0,C.coalesce)(he.map(fe=>(0,ae.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.configPath)));if(de.length>0){const fe=de[0],Se=(0,S.isEqualAuthority)(N?.remoteAuthority,fe.remoteAuthority)?N:void 0;se(this.doOpenFilesInExistingWindow(D,fe,Se),!!Se),x=!0}he.forEach(fe=>{if(de.some(Le=>Le.openedWorkspace&&Le.openedWorkspace.id===fe.workspace.id))return;const Se=fe.remoteAuthority,Ce=(0,S.isEqualAuthority)(N?.remoteAuthority,Se)?N:void 0;se(this.doOpenFolderOrWorkspace(D,fe,x,Ce),!!Ce),x=!0})}const me=(0,C.distinct)(_,de=>S.extUriBiasedIgnorePathCase.getComparisonKey(de.workspace.uri));if(me.length>0){const de=(0,C.coalesce)(me.map(fe=>(0,ae.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.uri)));if(de.length>0){const fe=de[0],Se=(0,S.isEqualAuthority)(N?.remoteAuthority,fe.remoteAuthority)?N:void 0;se(this.doOpenFilesInExistingWindow(D,fe,Se),!!Se),x=!0}me.forEach(fe=>{if(de.some(Le=>(0,F.isSingleFolderWorkspaceIdentifier)(Le.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(Le.openedWorkspace.uri,fe.workspace.uri)))return;const Se=fe.remoteAuthority,Ce=(0,S.isEqualAuthority)(N?.remoteAuthority,Se)?N:void 0;se(this.doOpenFolderOrWorkspace(D,fe,x,Ce),!!Ce),x=!0})}const be=(0,C.distinct)(B,de=>de.backupFolder);if(be.length>0&&be.forEach(de=>{const fe=de.remoteAuthority,Se=(0,S.isEqualAuthority)(N?.remoteAuthority,fe)?N:void 0;se(this.doOpenEmpty(D,!0,fe,Se,de),!!Se),x=!0}),ie.length===0||N){N&&!X&&X++;const de=N?N.remoteAuthority:D.remoteAuthority;for(let fe=0;fe<X;fe++)se(this.doOpenEmpty(D,x,de,N),!!N),x=!0}return{windows:(0,C.distinct)(ie),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(D,T,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),T.focus();const B={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToWait:_?.filesToWait,termProgram:D?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",n.CancellationToken.None,B),T}doAddFoldersToExistingWindow(D,T){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),D.focus();const _={foldersToAdd:T};return D.sendWhenReady("vscode:addFolders",n.CancellationToken.None,_),D}doOpenEmpty(D,T,_,B,X){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:_,filesToOpen:B,forceNewWindow:T});let N;return!T&&typeof D.contextWindowId=="number"&&(N=this.getWindowById(D.contextWindowId)),this.openInBrowserWindow({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:_,forceNewWindow:T,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:B,windowToUse:N,emptyWindowBackupInfo:X})}doOpenFolderOrWorkspace(D,T,_,B,X){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:B}),!_&&!X&&typeof D.contextWindowId=="number"&&(X=this.getWindowById(D.contextWindowId)),this.openInBrowserWindow({workspace:T.workspace,userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:B,windowToUse:X})}getPathsToOpen(D){let T,_=!1,B=!1;if(D.urisToOpen&&D.urisToOpen.length>0?(T=this.doExtractPathsFromAPI(D),_=!0):D.forceEmpty?T=[Object.create(null)]:D.cli._.length||D.cli["folder-uri"]||D.cli["file-uri"]?(T=this.doExtractPathsFromCLI(D.cli),T.length===0&&T.push(Object.create(null)),_=!0):(T=this.doGetPathsFromLastSession(),T.length===0&&T.push(Object.create(null)),B=!0),!D.addMode&&_){const X=T.filter(N=>z(N));if(X.length>1){const N=X[0].remoteAuthority;if(X.every(H=>(0,S.isEqualAuthority)(H.remoteAuthority,N))){const H=this.workspacesManagementMainService.createUntitledWorkspaceSync(X.map(ie=>({uri:ie.workspace.uri})));T.push({workspace:H,remoteAuthority:N}),T=T.filter(ie=>!z(ie))}}}return D.initialStartup&&!B&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&T.unshift(...this.doGetPathsFromLastSession().filter(X=>q(X)||z(X)||X.backupPath)),T}doExtractPathsFromAPI(D){const T=[],_={gotoLineMode:D.gotoLineMode,remoteAuthority:D.remoteAuthority};for(const B of(0,C.coalesce)(D.urisToOpen||[])){const X=this.resolveOpenable(B,_);if(X)X.label=B.label,T.push(X);else{const N=this.resourceFromOpenable(B),H={title:this.productService.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:N.scheme===m.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:N.scheme===m.Schemas.file?(0,a.localize)(3,null,(0,y.getPathLabel)(N.fsPath,this.environmentMainService)):(0,a.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(H,(0,P.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return T}doExtractPathsFromCLI(D){const T=[],_={ignoreFileNotFound:!0,gotoLineMode:D.goto,remoteAuthority:D.remote||void 0,forceOpenWorkspaceAsFile:!1},B=D["folder-uri"];if(B)for(const H of B){const ie=this.cliArgToUri(H);if(ie){const re=this.resolveOpenable({folderUri:ie},_);re&&T.push(re)}}const X=D["file-uri"];if(X)for(const H of X){const ie=this.cliArgToUri(H);if(ie){const re=this.resolveOpenable((0,F.hasWorkspaceFileExtension)(H)?{workspaceUri:ie}:{fileUri:ie},_);re&&T.push(re)}}const N=D._;for(const H of N){const ie=_.remoteAuthority?this.doResolvePathRemote(H,_):this.doResolveFilePath(H,_);ie&&T.push(ie)}return T}cliArgToUri(D){try{const T=l.URI.parse(D);if(!T.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${D}`);return}return T}catch(T){this.logService.error(`Invalid URI input string: ${D}, ${T.message}`)}}doGetPathsFromLastSession(){const D=this.getRestoreWindowsSetting();switch(D){case"none":return[];case"one":case"all":case"preserve":case"folders":const T=[];D!=="one"&&T.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&T.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const B of T)if(B.workspace){const X=this.resolveOpenable({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});q(X)&&_.push(X)}else if(B.folderUri){const X=this.resolveOpenable({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});z(X)&&_.push(X)}else D!=="folders"&&B.backupPath&&_.push({backupPath:B.backupPath,remoteAuthority:B.remoteAuthority});return _}}getRestoreWindowsSetting(){let D;return this.lifecycleMainService.wasRestarted?D="all":(D=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(D)||(D="all")),D}resolveOpenable(D,T=Object.create(null)){let _=this.resourceFromOpenable(D);return _.scheme===m.Schemas.file?((0,ee.isFileToOpen)(D)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,T)):this.doResolveRemoteOpenable(D,T)}doResolveRemoteOpenable(D,T){let _=this.resourceFromOpenable(D);const B=(0,W.getRemoteAuthority)(_)||T.remoteAuthority;if(_=(0,S.removeTrailingPathSeparator)((0,S.normalizePath)(_)),(0,ee.isFileToOpen)(D)){if(T.gotoLineMode){const{path:X,line:N,column:H}=(0,h.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:X}),selection:N?{startLineNumber:N,startColumn:H||1}:void 0,remoteAuthority:B}}return{fileUri:_,remoteAuthority:B}}else if((0,ee.isWorkspaceToOpen)(D))return{workspace:(0,U.getWorkspaceIdentifier)(_),remoteAuthority:B};return{workspace:(0,U.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:B}}resourceFromOpenable(D){return(0,ee.isWorkspaceToOpen)(D)?D.workspaceUri:(0,ee.isFolderToOpen)(D)?D.folderUri:D.fileUri}doResolveFilePath(D,T){let _,B;T.gotoLineMode&&({path:D,line:_,column:B}=(0,h.parseLineAndColumnAware)(D)),D=(0,h.sanitizeFilePath)((0,p.normalize)(D),(0,b.cwd)());try{const X=(0,R.statSync)(D);if(X.isFile()){if(!T.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.URI.file(D));if(N)return N.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},type:r.FileType.File,exists:!0,remoteAuthority:N.remoteAuthority,transient:N.transient}}return{fileUri:l.URI.file(D),type:r.FileType.File,exists:!0,selection:_?{startLineNumber:_,startColumn:B||1}:void 0}}else{if(X.isDirectory())return{workspace:(0,U.getSingleFolderWorkspaceIdentifier)(l.URI.file(D),X),type:r.FileType.Directory,exists:!0};if(!w.isWindows&&D==="/dev/null")return{fileUri:l.URI.file(D),type:r.FileType.File,exists:!0}}}catch(X){const N=l.URI.file(D);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),T.ignoreFileNotFound)return{fileUri:N,type:r.FileType.File,exists:!1}}}doResolvePathRemote(D,T){const _=D.charCodeAt(0),B=T.remoteAuthority;let X,N;T.gotoLineMode&&({path:D,line:X,column:N}=(0,h.parseLineAndColumnAware)(D)),_!==47&&((0,h.isWindowsDriveLetter)(_)&&D.charCodeAt(D.charCodeAt(1))===58&&(D=(0,h.toSlashes)(D)),D=`/${D}`);const H=l.URI.from({scheme:m.Schemas.vscodeRemote,authority:B,path:D});if(D.charCodeAt(D.length-1)!==47){if((0,F.hasWorkspaceFileExtension)(D))return T.forceOpenWorkspaceAsFile?{fileUri:H,selection:X?{startLineNumber:X,startColumn:N||1}:void 0,remoteAuthority:T.remoteAuthority}:{workspace:(0,U.getWorkspaceIdentifier)(H),remoteAuthority:B};if(T.gotoLineMode||p.posix.basename(D).indexOf(".")!==-1)return{fileUri:H,selection:X?{startLineNumber:X,startColumn:N||1}:void 0,remoteAuthority:B}}return{workspace:(0,U.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:B}}shouldOpenNewWindow(D){const T=this.configurationService.getValue("window"),_=T?.openFoldersInNewWindow||"default",B=T?.openFilesInNewWindow||"off";let X=(D.preferNewWindow||D.forceNewWindow)&&!D.forceReuseWindow;!D.forceNewWindow&&!D.forceReuseWindow&&(_==="on"||_==="off")&&(X=_==="on");let N=!1;return D.forceNewWindow||D.forceReuseWindow?N=!!D.forceNewWindow&&!D.forceReuseWindow:(w.isMacintosh?D.context===1&&(N=!0):D.context!==3&&D.context!==2&&!(D.userEnv&&D.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!D.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(N=B==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(D,T){const _=(0,ae.findWindowOnExtensionDevelopmentPath)(this.getWindows(),D);if(_)return this.lifecycleMainService.reload(_,T.cli),_.focus(),[_];let B=T.cli["folder-uri"]||[],X=T.cli["file-uri"]||[],N=T.cli._;if(!N.length&&!B.length&&!X.length&&!T.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,x=se&&(se.workspace||se.folderUri);x&&(l.URI.isUri(x)?x.scheme===m.Schemas.file?N=[x.fsPath]:B=[x.toString()]:x.configPath.scheme===m.Schemas.file?N=[(0,S.originalFSPath)(x.configPath)]:X=[x.configPath.toString()])}let H=T.remoteAuthority;for(const se of D)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const x=l.URI.parse(se),ce=(0,W.getRemoteAuthority)(x);ce&&(H?ce!==H&&this.logService.error("more than one extension development path authority"):H=ce)}N=N.filter(se=>{const x=l.URI.file(se);return(0,ae.findWindowOnWorkspaceOrFolder)(this.getWindows(),x)?!1:(0,S.isEqualAuthority)((0,W.getRemoteAuthority)(x),H)}),B=B.filter(se=>{const x=this.cliArgToUri(se);return x&&!!(0,ae.findWindowOnWorkspaceOrFolder)(this.getWindows(),x)?!1:x?(0,S.isEqualAuthority)((0,W.getRemoteAuthority)(x),H):!1}),X=X.filter(se=>{const x=this.cliArgToUri(se);return x&&!!(0,ae.findWindowOnWorkspaceOrFolder)(this.getWindows(),x)?!1:x?(0,S.isEqualAuthority)((0,W.getRemoteAuthority)(x),H):!1}),T.cli._=N,T.cli["folder-uri"]=B,T.cli["file-uri"]=X;const ie=!N.length&&!B.length&&!X.length,re={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:H};return this.open(re)}openInBrowserWindow(D){const T=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...D.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:D.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,D.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:D.remoteAuthority,workspace:D.workspace,userEnv:{...this.initialUserEnv,...D.userEnv},filesToOpenOrCreate:D.filesToOpen?.filesToOpenOrCreate,filesToDiff:D.filesToOpen?.filesToDiff,filesToWait:D.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:k.default,isInitialStartup:D.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:T?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let B;if(!D.forceNewWindow&&!D.forceNewTabbedWindow&&(B=D.windowToUse||this.getLastActiveWindow(),B&&B.focus()),B){const X=B.config;!_.extensionDevelopmentPath&&X&&!!X.extensionDevelopmentPath&&(_.extensionDevelopmentPath=X.extensionDevelopmentPath,_.verbose=X.verbose,_["inspect-brk-extensions"]=X["inspect-brk-extensions"],_.debugId=X.debugId,_.extensionEnvironment=X.extensionEnvironment,_["inspect-extensions"]=X["inspect-extensions"],_["extensions-dir"]=X["extensions-dir"])}else{const X=this.windowsStateHandler.getNewWindowState(_);(0,t.mark)("code/willCreateCodeWindow");const N=B=this.instantiationService.createInstance(oe.CodeWindow,{state:X,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),D.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(N)}it.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,f.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,f.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,f.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const H=(0,P.assertIsDefined)(N.win?.webContents);H.removeAllListeners("devtools-reload-page"),H.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return _.windowId=B.id,B.isReady?this.lifecycleMainService.unload(B,4).then(X=>{X||this.doOpenInBrowserWindow(B,_,D)}):this.doOpenInBrowserWindow(B,_,D),B}doOpenInBrowserWindow(D,T,_){if(!T.extensionDevelopmentPath)if((0,F.isWorkspaceIdentifier)(T.workspace))T.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:T.workspace,remoteAuthority:T.remoteAuthority});else if((0,F.isSingleFolderWorkspaceIdentifier)(T.workspace))T.backupPath=this.backupMainService.registerFolderBackupSync(T.workspace.uri);else{const B=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;T.backupPath=this.backupMainService.registerEmptyWindowBackupSync(B,T.remoteAuthority)}D.load(T)}onWindowClosed(D){const T=it.WINDOWS.indexOf(D);it.WINDOWS.splice(T,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const D=v.BrowserWindow.getFocusedWindow();if(D)return this.getWindowById(D.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(D){return this.doGetLastActiveWindow(this.getWindows().filter(T=>(0,S.isEqualAuthority)(T.remoteAuthority,D)))}doGetLastActiveWindow(D){const T=Math.max.apply(Math,D.map(_=>_.lastFocusTime));return D.find(_=>_.lastFocusTime===T)}sendToFocused(D,...T){const _=this.getFocusedWindow()||this.getLastActiveWindow();_&&_.sendWhenReady(D,n.CancellationToken.None,...T)}sendToAll(D,T,_){for(const B of this.getWindows())_&&_.indexOf(B.id)>=0||B.sendWhenReady(D,n.CancellationToken.None,T)}getWindows(){return it.WINDOWS}getWindowCount(){return it.WINDOWS.length}getWindowById(D){const T=this.getWindows().filter(_=>_.id===D);return(0,C.firstOrDefault)(T)}getWindowByWebContents(D){const T=v.BrowserWindow.fromWebContents(D);if(!!T)return this.getWindowById(T.id)}};J.WINDOWS=[],J=ge([te(2,g.ILogService),te(3,V.IStateMainService),te(4,i.IEnvironmentMainService),te(5,d.ILifecycleMainService),te(6,u.IBackupMainService),te(7,s.IConfigurationService),te(8,G.IWorkspacesHistoryMainService),te(9,Y.IWorkspacesManagementMainService),te(10,o.IInstantiationService),te(11,c.IDialogMainService),te(12,r.IFileService),te(13,L.IProductService),te(14,A.IProtocolMainService)],J),e.WindowsMainService=J}),define(Q[243],Z([0,1,51,36,68,45]),function($,e,v,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let n=class{constructor(h,f,y,E){this.workspacesManagementMainService=h,this.windowsMainService=f,this.workspacesHistoryMainService=y,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,f){const y=this.windowsMainService.getWindowById(h);if(y)return this.workspacesManagementMainService.enterWorkspace(y,this.windowsMainService.getWindows(),f)}createUntitledWorkspace(h,f,y){return this.workspacesManagementMainService.createUntitledWorkspace(f,y)}deleteUntitledWorkspace(h,f){return this.workspacesManagementMainService.deleteUntitledWorkspace(f)}getWorkspaceIdentifier(h,f){return this.workspacesManagementMainService.getWorkspaceIdentifier(f)}async getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(h))}async addRecentlyOpened(h,f){return this.workspacesHistoryMainService.addRecentlyOpened(f)}async removeRecentlyOpened(h,f){return this.workspacesHistoryMainService.removeRecentlyOpened(f)}async clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};n=ge([te(0,C.IWorkspacesManagementMainService),te(1,R.IWindowsMainService),te(2,M.IWorkspacesHistoryMainService),te(3,v.IBackupMainService)],n),e.WorkspacesMainService=n}),define(Q[244],Z([0,1,14,28,26,17,44,16,32,42,39,33,2,10,8,3,15,13,7,31,71,122,35,125,85,235,134,51,226,19,180,162,74,52,225,89,24,54,91,170,188,171,222,90,172,18,183,94,73,5,75,236,201,103,20,6,185,241,53,22,64,231,76,38,219,100,202,29,204,206,65,41,210,233,237,234,238,99,211,212,213,214,216,36,242,217,27,68,243,45]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a,u,s,c,i,r,o,d,g,k,L,A,W,V,ee,oe,ae,K,F,U,G,Y,q,z,J,O,D,T,_,B,X,N,H,ie,re,se,x,ce,le,he,me,be,de,fe,Se,Ce,Le,We,$e,ze,Qe,Ge,gt,Je,at,ct,Ve,He,j,ne,ue,pe,Ie,Me,Te,Fe,Oe,Ne,je,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends m.Disposable{constructor(we,ye,Ee,ve,Pe,De,ke,Re,Ae,Xe){super();this.mainProcessNodeIpcServer=we,this.userEnv=ye,this.mainInstantiationService=Ee,this.logService=ve,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=ke,this.stateMainService=Re,this.fileService=Ae,this.productService=Xe,this.configureSession(),this.registerListeners()}configureSession(){const we=ve=>ve?.startsWith(`${p.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((ve,Pe,De,ke)=>we(ke.requestingUrl)?De(ye.has(Pe)):De(!1)),v.session.defaultSession.setPermissionCheckHandler((ve,Pe,De,ke)=>we(ke.requestingUrl)?ye.has(Pe):!1);const Ee=v.session.defaultSession;typeof Ee.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ee.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(Ee=>this.onUnexpectedError(Ee)),process.on("uncaughtException",Ee=>(0,I.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,I.onUnexpectedError)(Ee)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Ee,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),v.app.on("activate",(Ee,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Ee,ve)=>{ve.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ve.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let we=[],ye;v.app.on("open-file",(Ee,ve)=>{this.logService.trace("app#open-file: ",ve),Ee.preventDefault(),we.push(this.getWindowOpenableFromPathSync(ve)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],ye=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",Ee=>{const ve=this.windowsMainService?.getWindowByWebContents(Ee.sender);let Pe,De;return ve?.config?(Pe=ve.config,De={...process.env,...ve.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),v.ipcMain.handle("vscode:writeNlsFile",(Ee,ve,Pe)=>{const De=this.validateNlsPath([ve]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,C.VSBuffer.fromString(Pe))}),v.ipcMain.handle("vscode:readNlsFile",async(Ee,...ve)=>{const Pe=this.validateNlsPath(ve);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}validateNlsPath(we){let ye;for(const Ee of we)typeof Ee=="string"&&(typeof ye!="string"?ye=Ee:ye=(0,t.join)(ye,Ee));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,h.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!w.isLinux)))return P.URI.file(ye)}onUnexpectedError(we){if(we){const ye={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;w.isWindows&&we&&v.app.setAppUserModelId(we);try{w.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ae){this.logService.error(Ae)}const ye=new c.Server;this.logService.trace("Resolving machine identifier...");const Ee=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:ve,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(Ee),ke=await this.initServices(Ee,ve,Pe);if(this.environmentMainService.driverHandle){const Ae=await(0,ee.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,ke);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ae)}this._register(ke.createInstance(r.ProxyAuthHandler)),ke.invokeFunction(Ae=>this.initChannels(Ae,ye,De));const Re=ke.invokeFunction(Ae=>this.openFirstWindow(Ae,ye));ke.invokeFunction(Ae=>this.afterWindowOpen(Ae,ve)),this.environmentMainService.args.trace&&ke.invokeFunction(Ae=>this.stopTracingEventually(Ae,Re))}async resolveMachineId(){let we=this.stateMainService.getItem(We.machineIdKey);return(!we||w.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,a.getMachineId)(),this.stateMainService.setItem(We.machineIdKey,we)),we}setupSharedProcess(we){const ye=this._register(this.mainInstantiationService.createInstance(be.SharedProcess,we,this.userEnv)),Ee=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(Pe,"main")})(),ve=(async()=>(await ye.whenReady(),Ee))();return{sharedProcess:ye,sharedProcessReady:ve,sharedProcessClient:Ee}}async initServices(we,ye,Ee){const ve=new X.ServiceCollection;switch(process.platform){case"win32":ve.set(Ge.IUpdateService,new _.SyncDescriptor(Ve.Win32UpdateService));break;case"linux":w.isLinuxSnap?ve.set(Ge.IUpdateService,new _.SyncDescriptor(ct.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(Ge.IUpdateService,new _.SyncDescriptor(at.LinuxUpdateService));break;case"darwin":ve.set(Ge.IUpdateService,new _.SyncDescriptor(Je.DarwinUpdateService));break}ve.set(Me.IWindowsMainService,new _.SyncDescriptor(Te.WindowsMainService,[we,this.userEnv])),ve.set(V.IDialogMainService,new _.SyncDescriptor(V.DialogMainService)),ve.set(ie.ILaunchMainService,new _.SyncDescriptor(ie.LaunchMainService)),ve.set(W.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(Ee.then(De=>De.getChannel("diagnostics"))))),ve.set(N.IIssueMainService,new _.SyncDescriptor(N.IssueMainService,[this.userEnv])),ve.set(oe.IEncryptionMainService,new _.SyncDescriptor(oe.EncryptionMainService,[we])),ve.set(H.IKeyboardLayoutMainService,new _.SyncDescriptor(H.KeyboardLayoutMainService)),ve.set(le.INativeHostMainService,new _.SyncDescriptor(le.NativeHostMainService,[ye])),ve.set(pe.IWebviewManagerService,new _.SyncDescriptor(Ie.WebviewMainService)),ve.set(Oe.IWorkspacesService,new _.SyncDescriptor(je.WorkspacesMainService)),ve.set(bt.IWorkspacesManagementMainService,new _.SyncDescriptor(bt.WorkspacesManagementMainService)),ve.set(Ne.IWorkspacesHistoryMainService,new _.SyncDescriptor(Ne.WorkspacesHistoryMainService)),ve.set(ce.IMenubarMainService,new _.SyncDescriptor(ce.MenubarMainService)),ve.set(U.IExtensionUrlTrustService,new _.SyncDescriptor(G.ExtensionUrlTrustService)),ve.set(Y.IExtensionHostStarter,new _.SyncDescriptor(q.WorkerMainProcessExtensionHostStarter)),ve.set(Ce.IStorageMainService,new _.SyncDescriptor(Ce.StorageMainService)),w.isWindows?ve.set(z.IExternalTerminalMainService,new _.SyncDescriptor(J.WindowsExternalTerminalService)):w.isMacintosh?ve.set(z.IExternalTerminalMainService,new _.SyncDescriptor(J.MacExternalTerminalService)):w.isLinux&&ve.set(z.IExternalTerminalMainService,new _.SyncDescriptor(J.LinuxExternalTerminalService));const Pe=new g.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(d.IBackupMainService,Pe),ve.set(He.IURLService,new _.SyncDescriptor(ne.NativeURLService)),(0,Qe.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,s.getDelayedChannel)(Ee.then(Ze=>Ze.getChannel("telemetryAppender"))),ke=new $e.TelemetryAppenderClient(De),Re=(0,Le.resolveCommonProperties)(this.fileService,(0,M.release)(),(0,M.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ae=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Xe={appenders:[ke],commonProperties:Re,piiPaths:Ae,sendErrorTelemetry:!0};ve.set(We.ITelemetryService,new _.SyncDescriptor(ze.TelemetryService,[Xe]))}else ve.set(We.ITelemetryService,Qe.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(we,ye,Ee){const ve=s.ProxyChannel.fromService(we.get(ie.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve);const Pe=this.fileService.getProvider(p.Schemas.file);(0,S.assertType)(Pe instanceof T.DiskFileSystemProvider);const De=new D.DiskFileSystemProviderChannel(Pe,this.logService);ye.registerChannel("localFilesystem",De);const ke=new L.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);ye.registerChannel(L.UserConfigurationFileServiceId,s.ProxyChannel.fromService(ke)),Ee.then(Be=>Be.registerChannel(L.UserConfigurationFileServiceId,s.ProxyChannel.fromService(ke)));const Re=new gt.UpdateChannel(we.get(Ge.IUpdateService));ye.registerChannel("update",Re);const Ae=s.ProxyChannel.fromService(we.get(N.IIssueMainService));ye.registerChannel("issue",Ae);const Xe=s.ProxyChannel.fromService(we.get(oe.IEncryptionMainService));ye.registerChannel("encryption",Xe);const Ze=s.ProxyChannel.fromService(we.get(de.ISignService));ye.registerChannel("sign",Ze);const nt=s.ProxyChannel.fromService(we.get(H.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",nt),this.nativeHostMainService=we.get(le.INativeHostMainService);const xe=s.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",xe),Ee.then(Be=>Be.registerChannel("nativeHost",xe));const wt=s.ProxyChannel.fromService(we.get(Oe.IWorkspacesService));ye.registerChannel("workspaces",wt);const Ue=s.ProxyChannel.fromService(we.get(ce.IMenubarMainService));ye.registerChannel("menubar",Ue);const lt=s.ProxyChannel.fromService(we.get(He.IURLService));ye.registerChannel("url",lt);const rt=s.ProxyChannel.fromService(we.get(U.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",rt);const st=s.ProxyChannel.fromService(we.get(pe.IWebviewManagerService));ye.registerChannel("webview",st);const ot=this._register(new Se.StorageDatabaseChannel(this.logService,we.get(Ce.IStorageMainService)));ye.registerChannel("storage",ot),Ee.then(Be=>Be.registerChannel("storage",ot));const ut=s.ProxyChannel.fromService(we.get(z.IExternalTerminalMainService));ye.registerChannel("externalTerminal",ut);const et=new x.LogLevelChannel(we.get(se.ILogService));ye.registerChannel("logLevel",et),Ee.then(Be=>Be.registerChannel("logLevel",et));const tt=new x.LoggerChannel(we.get(se.ILoggerService));ye.registerChannel("logger",tt),Ee.then(Be=>Be.registerChannel("logger",tt));const ht=new A.ElectronExtensionHostDebugBroadcastChannel(we.get(Me.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ht);const _e=s.ProxyChannel.fromService(we.get(Y.IExtensionHostStarter));ye.registerChannel(Y.ipcExtensionHostStarterChannelName,_e)}openFirstWindow(we,ye){const Ee=this.windowsMainService=we.get(Me.IWindowsMainService),ve=we.get(He.IURLService),Pe=we.get(le.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],ke=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(_e=>{try{return{uri:P.URI.parse(_e),url:_e}}catch{return}}).filter(_e=>{if(!_e||this.shouldBlockURI(_e.uri))return!1;const Be=this.getWindowOpenableFromProtocolLink(_e.uri);return Be?(De.push(Be),!1):!0}),Re=this,Ae=this.environmentMainService,Xe=this.productService;ve.registerHandler({async handleURL(_e,Be){if(_e.scheme===Xe.urlProtocol&&_e.path==="workspace"&&(_e=_e.with({authority:"file",path:P.URI.parse(_e.query).path,query:""})),Re.shouldBlockURI(_e))return!0;const Et=Re.getWindowOpenableFromProtocolLink(_e);if(Et){const[pt]=Ee.open({context:5,cli:{...Ae.args},urisToOpen:[Et],gotoLineMode:!0});return pt.focus(),!0}if(w.isMacintosh&&Ee.getWindowCount()===0){const[pt]=Ee.open({context:5,cli:{...Ae.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,me.getRemoteAuthority)(_e)});return await pt.ready(),ve.open(_e,Be)}return!1}});const Ze=this._register(new Fe.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),nt=new s.StaticRouter(_e=>Ze.getActiveClientId().then(Be=>_e===Be)),xe=new j.URLHandlerRouter(nt),wt=ye.getChannel("urlHandler",xe);ve.registerHandler(new j.URLHandlerChannelClient(wt)),this._register(new ue.ElectronURLListener(ke,ve,Ee,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,lt=global.macOpenFiles,rt=(0,K.isLaunchedFromCli)(process.env)?0:4,st=Ue._.length,ot=!!Ue["folder-uri"],ut=!!Ue["file-uri"],et=Ue["skip-add-to-recently-opened"]===!0,tt=Ue.wait&&Ue.waitMarkerFilePath?P.URI.file(Ue.waitMarkerFilePath):void 0,ht=Ue.remote||void 0;return De.length>0?Ee.open({context:rt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!st&&!ot&&!ut?Ee.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0,remoteAuthority:ht}):lt.length&&!st&&!ot&&!ut?Ee.open({context:1,cli:Ue,urisToOpen:lt.map(_e=>this.getWindowOpenableFromPathSync(_e)),noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0}):Ee.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!st&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:et,waitMarkerFileURI:tt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(we){return!!(we.authority===p.Schemas.file&&w.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,E.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,E.getPathLabel)(we.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===p.Schemas.file){const ye=P.URI.file(we.fsPath);return(0,Oe.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(we.authority===p.Schemas.vscodeRemote){const ye=we.path.indexOf(t.posix.sep,1);if(ye!==-1){const Ee=we.path.substring(1,ye),ve=we.path.substring(ye),Pe=P.URI.from({scheme:p.Schemas.vscodeRemote,authority:Ee,path:ve,query:we.query,fragment:we.fragment});return(0,Oe.hasWorkspaceFileExtension)(ve)?{workspaceUri:Pe}:/:[\d]+$/.test(ve)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(we){try{if((0,R.statSync)(we).isDirectory())return{folderUri:P.URI.file(we)};if((0,Oe.hasWorkspaceFileExtension)(we))return{workspaceUri:P.URI.file(we)}}catch(ye){}return{fileUri:P.URI.file(we)}}async afterWindowOpen(we,ye){this.lifecycleMainService.phase=3;let Ee=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee=!0);const ve=we.get(We.ITelemetryService);this._register(ye.onDidError(({type:ke,details:Re})=>{let Ae;switch(ke){case 1:Ae="SharedProcess: detected unresponsive window";break;case 2:Ae=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Ae=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Ae)),ve.publicLog2("sharedprocesserror",{type:ke,reason:Re?.reason,code:Re?.exitCode,visible:ye.isVisible(),shuttingdown:Ee})}));const Pe=this.productService.win32MutexName;if(w.isWindows&&Pe)try{const ke=$.__$__nodeRequire("windows-mutex").Mutex,Re=new ke(Pe);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(ke){this.logService.error(ke)}v.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(ke,Re)=>{Re({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})});const De=we.get(Ge.IUpdateService);(De instanceof Ve.Win32UpdateService||De instanceof at.LinuxUpdateService||De instanceof Je.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,y.stripComments)(Re))["enable-crash-reporter"]===void 0){const Ze=(0,Qe.getTelemetryLevel)(this.configurationService)>=1,nt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ze},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.generateUuid)()}"`,"}"],xe=Re.substring(0,Re.length-2).concat(`,
`,nt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(xe))}}catch(ke){this.logService.error(ke)}}async resolveShellEnvironment(we,ye,Ee){try{return await(0,F.resolveShellEnv)(this.logService,we,ye)}catch(ve){const Pe=(0,n.toErrorMessage)(ve);Ee?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(we,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Ee=we.get(V.IDialogMainService);let ve=!1;const Pe=async ke=>{if(ve)return;ve=!0;const Re=await v.contentTracing.stopRecording((0,b.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);ke?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):Ee.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Re),buttons:[(0,E.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,S.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(ye.map(ke=>ke.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};mt=ge([te(2,B.IInstantiationService),te(3,se.ILogService),te(4,ae.IEnvironmentMainService),te(5,re.ILifecycleMainService),te(6,k.IConfigurationService),te(7,fe.IStateMainService),te(8,O.IFileService),te(9,he.IProductService)],mt),e.CodeApplication=mt}),define(Q[251],Z([0,1,14,28,30,9,44,16,32,42,33,10,8,63,3,34,25,21,35,58,244,11,19,192,203,24,54,165,18,182,94,73,175,75,20,95,6,186,96,56,22,57,189,97,228,50,230,76,200,38,232,65,66,209]),function($,e,v,R,M,C,n,I,h,f,y,E,m,p,t,w,b,S,P,l,a,u,s,c,i,r,o,d,g,k,L,A,W,V,ee,oe,ae,K,F,U,G,Y,q,z,J,O,D,T,_,B,X,N,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(x){console.error(x.message),v.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(fe=>console.error(fe));const[x,ce,le,he,me,be,de]=this.createServices();try{try{await this.initServices(le,he,me)}catch(fe){throw this.handleStartupDataDirError(le,de.nameLong,fe),fe}await x.invokeFunction(async fe=>{const Se=fe.get(ae.ILogService),Ce=fe.get(ee.ILifecycleMainService),Le=fe.get(g.IFileService),We=await this.claimInstance(Se,le,Ce,x,de,!0);return S.Promises.writeFile(le.mainLockfile,String(process.pid)).catch($e=>{Se.warn(`Error writing main lockfile: ${$e.stack}`)}),be.logger=new F.SpdLogLogger("main",(0,m.join)(le.logsPath,"main.log"),!0,!1,be.getLevel()),(0,f.once)(Ce.onWillShutdown)($e=>{Le.dispose(),he.dispose(),$e.join(S.Promises.unlink(le.mainLockfile).catch(()=>{}))}),x.createInstance(a.CodeApplication,We,ce).startup()})}catch(fe){x.invokeFunction(this.quit,fe)}}createServices(){const x=new V.ServiceCollection,ce={_serviceBrand:void 0,...U.default};x.set(G.IProductService,ce);const le=new r.EnvironmentMainService(this.resolveArgs(),ce),he=this.patchEnvironment(le);x.set(r.IEnvironmentMainService,le);const me=new oe.BufferLogService,be=new ae.MultiplexLogService([new ae.ConsoleMainLogger((0,ae.getLogLevel)(le)),me]);process.once("exit",()=>be.dispose()),x.set(ae.ILogService,be);const de=new k.FileService(be);x.set(g.IFileService,de);const fe=new L.DiskFileSystemProvider(be);de.registerProvider(E.Schemas.file,fe),x.set(ae.ILoggerService,new K.LoggerService(be,de));const Se=new c.ConfigurationService(le.settingsResource,de);x.set(s.IConfigurationService,Se),x.set(ee.ILifecycleMainService,new A.SyncDescriptor(ee.LifecycleMainService));const Ce=new X.StateMainService(le,be,de);return x.set(B.IStateMainService,Ce),x.set(O.IRequestService,new A.SyncDescriptor(D.RequestMainService)),x.set(H.IThemeMainService,new A.SyncDescriptor(H.ThemeMainService)),x.set(T.ISignService,new A.SyncDescriptor(_.SignService)),x.set(z.ITunnelService,new A.SyncDescriptor(J.TunnelService)),x.set(Y.IProtocolMainService,new A.SyncDescriptor(q.ProtocolMainService)),[new W.InstantiationService(x,!0),he,le,Se,Ce,me,ce]}patchEnvironment(x){const ce={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const he=process.env[le];typeof he=="string"&&(ce[le]=he)}),Object.assign(process.env,ce),ce}initServices(x,ce,le){return C.Promises.settled([Promise.all([x.extensionsPath,x.codeCachePath,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(he=>he?S.Promises.mkdir(he,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(x,ce,le,he,me,be){let de;try{(0,p.mark)("code/willStartMainServer"),de=await(0,l.serve)(ce.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,f.once)(le.onWillShutdown)(()=>de.dispose())}catch(fe){if(fe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,me.nameLong,fe),fe;let Se;try{Se=await(0,l.connect)(ce.mainIPCHandle,"main")}catch(We){if(!be||t.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,me.nameShort),(0,u.localize)(1,null),me.nameLong),We;try{(0,R.unlinkSync)(ce.mainIPCHandle)}catch($e){throw x.warn("Could not delete obsolete instance handle",$e),$e}return this.claimInstance(x,ce,le,he,me,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(We),Se.dispose(),new Error(We)}let Ce;!ce.args.wait&&!ce.args.status&&(Ce=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,me.nameShort),(0,u.localize)(3,null),me.nameLong)},1e4));const Le=P.ProxyChannel.toService(Se.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return he.invokeFunction(async()=>{const We=new i.DiagnosticsService(N.NullTelemetryService,me),$e=await Le.getMainProcessInfo(),ze=await Le.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Qe=await We.getDiagnostics($e,ze);throw console.log(Qe),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Le,x),x.trace("Sending env to running instance..."),await Le.start(ce.args,process.env),Se.dispose(),Ce&&clearTimeout(Ce),new I.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(x,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const he=(0,M.coalesce)([x.userDataPath,x.extensionsPath,l.XDG_RUNTIME_DIR]).map(me=>(0,y.getPathLabel)(me,x));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,n.toErrorMessage)(le),he.join(`
`)),ce)}}showStartupWarningDialog(x,ce,le){v.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,u.localize)(6,null))],message:x,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(x,ce){if(t.isWindows){const le=await x.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((he,me)=>{$(["windows-foreground-love"],he,me)})).allowSetForegroundWindow(le)}catch(he){ce.error(he)}}}quit(x,ce){const le=x.get(ae.ILogService),he=x.get(ee.ILifecycleMainService);let me=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(me=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),he.kill(me)}resolveArgs(){const x=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ce=(0,d.createWaitMarkerFile)(x.verbose);ce&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ce),x.waitMarkerFilePath=ce)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ce=this.doValidatePaths(x._,x.goto);x._=ce}return x}doValidatePaths(x,ce){const le=(0,w.cwd)(),he=x.map(de=>{let fe=String(de),Se;ce&&(Se=(0,h.parseLineAndColumnAware)(fe),fe=Se.path),fe&&(fe=this.preparePath(le,fe));const Ce=(0,h.sanitizeFilePath)(fe,le),Le=(0,m.basename)(Ce);return Le&&!(0,h.isValidBasename)(Le)?null:ce&&Se?(Se.path=Ce,this.toPath(Se)):Ce}),me=t.isWindows||t.isMacintosh,be=(0,M.distinct)(he,de=>de&&me?de.toLowerCase():de||"");return(0,M.coalesce)(be)}preparePath(x,ce){return t.isWindows&&(ce=(0,b.rtrim)(ce,'"')),ce=(0,b.trim)((0,b.trim)(ce," "),"	"),t.isWindows&&(ce=(0,m.resolve)(x,ce),ce=(0,b.rtrim)(ce,".")),ce}toPath(x){const ce=[x.path];return typeof x.line=="number"&&ce.push(String(x.line)),typeof x.column=="number"&&ce.push(String(x.column)),ce.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c1f2f40bcd81380bf2e286af64becddada57db88/core/vs/code/electron-main/main.js.map
