/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/path","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","os","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","vs/base/parts/ipc/common/ipc","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/map","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(z){for(var i=[],T=0,P=z.length;T<P;T++)i[T]=Y[z[T]];return i};define(Y[56],Q([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function T(P,b){if(!P)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}i.ok=T}),define(Y[46],Q([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function T(C){return(w,l,g)=>{let y=null,R=null;if(typeof g.value=="function"?(y="value",R=g.value):typeof g.get=="function"&&(y="get",R=g.get),!R)throw new Error("not supported");g[y]=C(R,l)}}i.createDecorator=T;function P(C,w,l){let g=null,y=null;if(typeof l.value=="function"?(g="value",y=l.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(g="get",y=l.get),!y)throw new Error("not supported");const R=`$memoize$${w}`;l[g]=function(...c){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,c)}),this[R]}}i.memoize=P;function b(C,w,l){return T((g,y)=>{const R=`$debounce$${y}`,c=`$debounce$result$${y}`;return function(...E){this[c]||(this[c]=l?l():void 0),clearTimeout(this[R]),w&&(this[c]=w(this[c],...E),E=[this[c]]),this[R]=setTimeout(()=>{g.apply(this,E),this[c]=l?l():void 0},C)}})}i.debounce=b;function D(C,w,l){return T((g,y)=>{const R=`$throttle$timer$${y}`,c=`$throttle$result$${y}`,E=`$throttle$lastRun$${y}`,u=`$throttle$pending$${y}`;return function(...d){if(this[c]||(this[c]=l?l():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),w&&(this[c]=w(this[c],...d)),this[u])return;const p=this[E]+C;p<=Date.now()?(this[E]=Date.now(),g.apply(this,[this[c]]),this[c]=l?l():void 0):(this[u]=!0,this[R]=setTimeout(()=>{this[u]=!1,this[E]=Date.now(),g.apply(this,[this[c]]),this[c]=l?l():void 0},p-Date.now()))}})}i.throttle=D}),define(Y[57],Q([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=i.ScanError||(i.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=i.SyntaxKind||(i.SyntaxKind={}));var b;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(b=i.ParseErrorCode||(i.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=i.ParseOptions||(i.ParseOptions={}));function C(t,r=!1){let e=0,n=t.length,o="",h=0,m=16,L=0;function I(ie){let me=0,j=0;for(;me<ie;){const B=t.charCodeAt(e);if(B>=48&&B<=57)j=j*16+B-48;else if(B>=65&&B<=70)j=j*16+B-65+10;else if(B>=97&&B<=102)j=j*16+B-97+10;else break;e++,me++}return me<ie&&(j=-1),j}function O(ie){e=ie,o="",h=0,m=16,L=0}function N(){const ie=e;if(t.charCodeAt(e)===48)e++;else for(e++;e<t.length&&g(t.charCodeAt(e));)e++;if(e<t.length&&t.charCodeAt(e)===46)if(e++,e<t.length&&g(t.charCodeAt(e)))for(e++;e<t.length&&g(t.charCodeAt(e));)e++;else return L=3,t.substring(ie,e);let me=e;if(e<t.length&&(t.charCodeAt(e)===69||t.charCodeAt(e)===101))if(e++,(e<t.length&&t.charCodeAt(e)===43||t.charCodeAt(e)===45)&&e++,e<t.length&&g(t.charCodeAt(e))){for(e++;e<t.length&&g(t.charCodeAt(e));)e++;me=e}else L=3;return t.substring(ie,me)}function K(){let ie="",me=e;for(;;){if(e>=n){ie+=t.substring(me,e),L=2;break}const j=t.charCodeAt(e);if(j===34){ie+=t.substring(me,e),e++;break}if(j===92){if(ie+=t.substring(me,e),e++,e>=n){L=2;break}switch(t.charCodeAt(e++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:const ne=I(4);ne>=0?ie+=String.fromCharCode(ne):L=4;break;default:L=5}me=e;continue}if(j>=0&&j<=31)if(l(j)){ie+=t.substring(me,e),L=2;break}else L=6;e++}return ie}function te(){if(o="",L=0,h=e,e>=n)return h=n,m=17;let ie=t.charCodeAt(e);if(w(ie)){do e++,o+=String.fromCharCode(ie),ie=t.charCodeAt(e);while(w(ie));return m=15}if(l(ie))return e++,o+=String.fromCharCode(ie),ie===13&&t.charCodeAt(e)===10&&(e++,o+=`
`),m=14;switch(ie){case 123:return e++,m=1;case 125:return e++,m=2;case 91:return e++,m=3;case 93:return e++,m=4;case 58:return e++,m=6;case 44:return e++,m=5;case 34:return e++,o=K(),m=10;case 47:const me=e-1;if(t.charCodeAt(e+1)===47){for(e+=2;e<n&&!l(t.charCodeAt(e));)e++;return o=t.substring(me,e),m=12}if(t.charCodeAt(e+1)===42){e+=2;const j=n-1;let B=!1;for(;e<j;){if(t.charCodeAt(e)===42&&t.charCodeAt(e+1)===47){e+=2,B=!0;break}e++}return B||(e++,L=1),o=t.substring(me,e),m=13}return o+=String.fromCharCode(ie),e++,m=16;case 45:if(o+=String.fromCharCode(ie),e++,e===n||!g(t.charCodeAt(e)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=N(),m=11;default:for(;e<n&&de(ie);)e++,ie=t.charCodeAt(e);if(h!==e){switch(o=t.substring(h,e),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(ie),e++,m=16}}function de(ie){if(w(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let ie;do ie=te();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>e,scan:r?ce:te,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>e-h,getTokenError:()=>L}}i.createScanner=C;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function l(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function R(t,r){const e=[],n=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function L(I,O,N,K){h.value=I,h.offset=O,h.length=N,h.type=K,h.colonOffset=void 0,o=h}try{f(t,{onObjectBegin:(I,O)=>{if(r<=I)throw n;o=void 0,m=r>I,e.push("")},onObjectProperty:(I,O,N)=>{if(r<O||(L(I,O,N,"property"),e[e.length-1]=I,r<=O+N))throw n},onObjectEnd:(I,O)=>{if(r<=I)throw n;o=void 0,e.pop()},onArrayBegin:(I,O)=>{if(r<=I)throw n;o=void 0,e.push(0)},onArrayEnd:(I,O)=>{if(r<=I)throw n;o=void 0,e.pop()},onLiteralValue:(I,O,N)=>{if(r<O||(L(I,O,N,a(I)),r<=O+N))throw n},onSeparator:(I,O,N)=>{if(r<=O)throw n;if(I===":"&&o&&o.type==="property")o.colonOffset=O,m=!1,o=void 0;else if(I===","){const K=e[e.length-1];typeof K=="number"?e[e.length-1]=K+1:(m=!0,e[e.length-1]=""),o=void 0}}})}catch(I){if(I!==n)throw I}return{path:e,previousNode:o,isAtPropertyKey:m,matches:I=>{let O=0;for(let N=0;O<I.length&&N<e.length;N++)if(I[O]===e[N]||I[O]==="*")O++;else if(I[O]!=="**")return!1;return O===I.length}}}i.getLocation=R;function c(t,r=[],e=D.DEFAULT){let n=null,o=[];const h=[];function m(I){Array.isArray(o)?o.push(I):n!==null&&(o[n]=I)}return f(t,{onObjectBegin:()=>{const I={};m(I),h.push(o),o=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const I=[];m(I),h.push(o),o=I,n=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:m,onError:(I,O,N)=>{r.push({error:I,offset:O,length:N})}},e),o[0]}i.parse=c;function E(t,r=[],e=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function h(I){return n.children.push(I),I}f(t,{onObjectBegin:I=>{n=h({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,O,N)=>{n=h({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:O,length:N,parent:n})},onObjectEnd:(I,O)=>{n.length=I+O-n.offset,n=n.parent,o(I+O)},onArrayBegin:(I,O)=>{n=h({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,O)=>{n.length=I+O-n.offset,n=n.parent,o(I+O)},onLiteralValue:(I,O,N)=>{h({type:a(I),offset:O,length:N,parent:n,value:I}),o(O+N)},onSeparator:(I,O,N)=>{n.type==="property"&&(I===":"?n.colonOffset=O:I===","&&o(O))},onError:(I,O,N)=>{r.push({error:I,offset:O,length:N})}},e);const L=n.children[0];return L&&delete L.parent,L}i.parseTree=E;function u(t,r){if(!t)return;let e=t;for(let n of r)if(typeof n=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let o=!1;for(const h of e.children)if(Array.isArray(h.children)&&h.children[0].value===n){e=h.children[1],o=!0;break}if(!o)return}else{const o=n;if(e.type!=="array"||o<0||!Array.isArray(e.children)||o>=e.children.length)return;e=e.children[o]}return e}i.findNodeAtLocation=u;function d(t){if(!t.parent||!t.parent.children)return[];const r=d(t.parent);if(t.parent.type==="property"){const e=t.parent.children[0].value;r.push(e)}else if(t.parent.type==="array"){const e=t.parent.children.indexOf(t);e!==-1&&r.push(e)}return r}i.getNodePath=d;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const r=Object.create(null);for(let e of t.children){const n=e.children[1];n&&(r[e.children[0].value]=p(n))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}i.getNodeValue=p;function v(t,r,e=!1){return r>=t.offset&&r<t.offset+t.length||e&&r===t.offset+t.length}i.contains=v;function S(t,r,e=!1){if(v(t,r,e)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const h=S(n[o],r,e);if(h)return h}return t}}i.findNodeAtOffset=S;function f(t,r,e=D.DEFAULT){const n=C(t,!1);function o(H){return H?()=>H(n.getTokenOffset(),n.getTokenLength()):()=>!0}function h(H){return H?Z=>H(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const m=o(r.onObjectBegin),L=h(r.onObjectProperty),I=o(r.onObjectEnd),O=o(r.onArrayBegin),N=o(r.onArrayEnd),K=h(r.onLiteralValue),te=h(r.onSeparator),de=o(r.onComment),ce=h(r.onError),ie=e&&e.disallowComments,me=e&&e.allowTrailingComma;function j(){for(;;){const H=n.scan();switch(n.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:ie||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(H){case 12:case 13:ie?B(10):de();break;case 16:B(1);break;case 15:case 14:break;default:return H}}}function B(H,Z=[],_=[]){if(ce(H),Z.length+_.length>0){let ae=n.getToken();for(;ae!==17;){if(Z.indexOf(ae)!==-1){j();break}else if(_.indexOf(ae)!==-1)break;ae=j()}}}function ne(H){const Z=n.getTokenValue();return H?K(Z):L(Z),j(),!0}function M(){switch(n.getToken()){case 11:let H=0;try{H=JSON.parse(n.getTokenValue()),typeof H!="number"&&(B(2),H=0)}catch(Z){B(2)}K(H);break;case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return j(),!0}function k(){return n.getToken()!==10?(B(3,[],[2,5]),!1):(ne(!1),n.getToken()===6?(te(":"),j(),ee()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function W(){m(),j();let H=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(H||B(4,[],[]),te(","),j(),n.getToken()===2&&me)break}else H&&B(6,[],[]);k()||B(4,[],[2,5]),H=!0}return I(),n.getToken()!==2?B(7,[2],[]):j(),!0}function G(){O(),j();let H=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(H||B(4,[],[]),te(","),j(),n.getToken()===4&&me)break}else H&&B(6,[],[]);ee()||B(4,[],[4,5]),H=!0}return N(),n.getToken()!==4?B(8,[4],[]):j(),!0}function ee(){switch(n.getToken()){case 3:return G();case 1:return W();case 10:return ne(!0);default:return M()}}return j(),n.getToken()===17?e.allowEmptyContent?!0:(B(4,[],[]),!1):ee()?(n.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}i.visit=f;function s(t,r){let e=C(t),n=[],o,h=0,m;do switch(m=e.getPosition(),o=e.scan(),o){case 12:case 13:case 17:h!==m&&n.push(t.substring(h,m)),r!==void 0&&n.push(e.getTokenValue().replace(/[^\r\n]/g,r)),h=e.getPosition();break}while(o!==17);return n.join("")}i.stripComments=s;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=a}),function(){function z(b){const D=[];typeof b=="number"&&D.push("code/timeOrigin",b);function C(l){D.push(l,Date.now())}function w(){const l=[];for(let g=0;g<D.length;g+=2)l.push({name:D[g],startTime:D[g+1]});return l}return{mark:C,getMarks:w}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const C of performance.getEntriesByType("mark"))D.push({name:C.name,startTime:Math.round(b+C.startTime)});return D}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function T(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=i()),b.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=T(P))}(),define(Y[58],Q([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var T;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(T=i.Source||(i.Source={}));var P;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(P=i.TerminateResponseCode||(i.TerminateResponseCode={}));function b(D,...C){const w=C.reduce((y,R)=>(y[R]=!0,y),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(y=>!w[y]).forEach(y=>{for(let R=0;R<l.length;R++)if(y.search(l[R])!==-1){delete D[y];break}})}i.sanitizeProcessEnvironment=b}),function(z,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var T=i();for(var P in T)(typeof exports=="object"?exports:z)[P]=T[P]}}(typeof self!="undefined"?self:this,function(){return function(z){var i={};function T(P){if(i[P])return i[P].exports;var b=i[P]={i:P,l:!1,exports:{}};return z[P].call(b.exports,b,b.exports,T),b.l=!0,b.exports}return T.m=z,T.c=i,T.d=function(P,b,D){T.o(P,b)||Object.defineProperty(P,b,{enumerable:!0,get:D})},T.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},T.t=function(P,b){if(1&b&&(P=T(P)),8&b||4&b&&typeof P=="object"&&P&&P.__esModule)return P;var D=Object.create(null);if(T.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:P}),2&b&&typeof P!="string")for(var C in P)T.d(D,C,function(w){return P[w]}.bind(null,C));return D},T.n=function(P){var b=P&&P.__esModule?function(){return P.default}:function(){return P};return T.d(b,"a",b),b},T.o=function(P,b){return Object.prototype.hasOwnProperty.call(P,b)},T.p="",T(T.s=0)}([function(z,i,T){(function(P){var b;i=z.exports=_,b=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var D=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,w=i.re=[],l=i.src=[],g=0,y=g++;l[y]="0|[1-9]\\d*";var R=g++;l[R]="[0-9]+";var c=g++;l[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=g++;l[E]="("+l[y]+")\\.("+l[y]+")\\.("+l[y]+")";var u=g++;l[u]="("+l[R]+")\\.("+l[R]+")\\.("+l[R]+")";var d=g++;l[d]="(?:"+l[y]+"|"+l[c]+")";var p=g++;l[p]="(?:"+l[R]+"|"+l[c]+")";var v=g++;l[v]="(?:-("+l[d]+"(?:\\."+l[d]+")*))";var S=g++;l[S]="(?:-?("+l[p]+"(?:\\."+l[p]+")*))";var f=g++;l[f]="[0-9A-Za-z-]+";var s=g++;l[s]="(?:\\+("+l[f]+"(?:\\."+l[f]+")*))";var a=g++,t="v?"+l[E]+l[v]+"?"+l[s]+"?";l[a]="^"+t+"$";var r="[v=\\s]*"+l[u]+l[S]+"?"+l[s]+"?",e=g++;l[e]="^"+r+"$";var n=g++;l[n]="((?:<|>)?=?)";var o=g++;l[o]=l[R]+"|x|X|\\*";var h=g++;l[h]=l[y]+"|x|X|\\*";var m=g++;l[m]="[v=\\s]*("+l[h]+")(?:\\.("+l[h]+")(?:\\.("+l[h]+")(?:"+l[v]+")?"+l[s]+"?)?)?";var L=g++;l[L]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[S]+")?"+l[s]+"?)?)?";var I=g++;l[I]="^"+l[n]+"\\s*"+l[m]+"$";var O=g++;l[O]="^"+l[n]+"\\s*"+l[L]+"$";var N=g++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=g++;l[K]="(?:~>?)";var te=g++;l[te]="(\\s*)"+l[K]+"\\s+",w[te]=new RegExp(l[te],"g");var de=g++;l[de]="^"+l[K]+l[m]+"$";var ce=g++;l[ce]="^"+l[K]+l[L]+"$";var ie=g++;l[ie]="(?:\\^)";var me=g++;l[me]="(\\s*)"+l[ie]+"\\s+",w[me]=new RegExp(l[me],"g");var j=g++;l[j]="^"+l[ie]+l[m]+"$";var B=g++;l[B]="^"+l[ie]+l[L]+"$";var ne=g++;l[ne]="^"+l[n]+"\\s*("+r+")$|^$";var M=g++;l[M]="^"+l[n]+"\\s*("+t+")$|^$";var k=g++;l[k]="(\\s*)"+l[n]+"\\s*("+r+"|"+l[m]+")",w[k]=new RegExp(l[k],"g");var W=g++;l[W]="^\\s*("+l[m]+")\\s+-\\s+("+l[m]+")\\s*$";var G=g++;l[G]="^\\s*("+l[L]+")\\s+-\\s+("+l[L]+")\\s*$";var ee=g++;l[ee]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)b(H,l[H]),w[H]||(w[H]=new RegExp(l[H]));function Z(F,x){if(F instanceof _)return F;if(typeof F!="string"||F.length>D||!(x?w[e]:w[a]).test(F))return null;try{return new _(F,x)}catch($){return null}}function _(F,x){if(F instanceof _){if(F.loose===x)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof _))return new _(F,x);b("SemVer",F,x),this.loose=x;var $=F.trim().match(x?w[e]:w[a]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var ge=+le;if(ge>=0&&ge<C)return ge}return le}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}i.parse=Z,i.valid=function(F,x){var $=Z(F,x);return $?$.version:null},i.clean=function(F,x){var $=Z(F.trim().replace(/^[=v]+/,""),x);return $?$.version:null},i.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),U(this.major,F.major)||U(this.minor,F.minor)||U(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var x=0;do{var $=this.prerelease[x],le=F.prerelease[x];if(b("prerelease compare",x,$,le),$===void 0&&le===void 0)return 0;if(le===void 0)return 1;if($===void 0)return-1;if($!==le)return U($,le)}while(++x)},_.prototype.inc=function(F,x){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,x,$,le){typeof $=="string"&&(le=$,$=void 0);try{return new _(F,$).inc(x,le).version}catch(ge){return null}},i.diff=function(F,x){if(X(F,x))return null;var $=Z(F),le=Z(x);if($.prerelease.length||le.prerelease.length){for(var ge in $)if((ge==="major"||ge==="minor"||ge==="patch")&&$[ge]!==le[ge])return"pre"+ge;return"prerelease"}for(var ge in $)if((ge==="major"||ge==="minor"||ge==="patch")&&$[ge]!==le[ge])return ge},i.compareIdentifiers=U;var ae=/^[0-9]+$/;function U(F,x){var $=ae.test(F),le=ae.test(x);return $&&le&&(F=+F,x=+x),$&&!le?-1:le&&!$?1:F<x?-1:F>x?1:0}function A(F,x,$){return new _(F,$).compare(new _(x,$))}function q(F,x,$){return A(F,x,$)>0}function V(F,x,$){return A(F,x,$)<0}function X(F,x,$){return A(F,x,$)===0}function J(F,x,$){return A(F,x,$)!==0}function ve(F,x,$){return A(F,x,$)>=0}function fe(F,x,$){return A(F,x,$)<=0}function ue(F,x,$,le){var ge;switch(x){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),ge=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),ge=F!==$;break;case"":case"=":case"==":ge=X(F,$,le);break;case"!=":ge=J(F,$,le);break;case">":ge=q(F,$,le);break;case">=":ge=ve(F,$,le);break;case"<":ge=V(F,$,le);break;case"<=":ge=fe(F,$,le);break;default:throw new TypeError("Invalid operator: "+x)}return ge}function re(F,x){if(F instanceof re){if(F.loose===x)return F;F=F.value}if(!(this instanceof re))return new re(F,x);b("comparator",F,x),this.loose=x,this.parse(F),this.semver===Ee?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}i.rcompareIdentifiers=function(F,x){return U(x,F)},i.major=function(F,x){return new _(F,x).major},i.minor=function(F,x){return new _(F,x).minor},i.patch=function(F,x){return new _(F,x).patch},i.compare=A,i.compareLoose=function(F,x){return A(F,x,!0)},i.rcompare=function(F,x,$){return A(x,F,$)},i.sort=function(F,x){return F.sort(function($,le){return i.compare($,le,x)})},i.rsort=function(F,x){return F.sort(function($,le){return i.rcompare($,le,x)})},i.gt=q,i.lt=V,i.eq=X,i.neq=J,i.gte=ve,i.lte=fe,i.cmp=ue,i.Comparator=re;var Ee={};function oe(F,x){if(F instanceof oe)return F.loose===x?F:new oe(F.raw,x);if(F instanceof re)return new oe(F.value,x);if(!(this instanceof oe))return new oe(F,x);if(this.loose=x,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function he(F){return!F||F.toLowerCase()==="x"||F==="*"}function Re(F,x,$,le,ge,Ce,Se,ke,Pe,Oe,Me,De,Te){return((x=he($)?"":he(le)?">="+$+".0.0":he(ge)?">="+$+"."+le+".0":">="+x)+" "+(ke=he(Pe)?"":he(Oe)?"<"+(+Pe+1)+".0.0":he(Me)?"<"+Pe+"."+(+Oe+1)+".0":De?"<="+Pe+"."+Oe+"."+Me+"-"+De:"<="+ke)).trim()}function ze(F,x){for(var $=0;$<F.length;$++)if(!F[$].test(x))return!1;if(x.prerelease.length){for($=0;$<F.length;$++)if(b(F[$].semver),F[$].semver!==Ee&&F[$].semver.prerelease.length>0){var le=F[$].semver;if(le.major===x.major&&le.minor===x.minor&&le.patch===x.patch)return!0}return!1}return!0}function Ae(F,x,$){try{x=new oe(x,$)}catch(le){return!1}return x.test(F)}function je(F,x,$,le){var ge,Ce,Se,ke,Pe;switch(F=new _(F,le),x=new oe(x,le),$){case">":ge=q,Ce=fe,Se=V,ke=">",Pe=">=";break;case"<":ge=V,Ce=ve,Se=q,ke="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(F,x,le))return!1;for(var Oe=0;Oe<x.set.length;++Oe){var Me=x.set[Oe],De=null,Te=null;if(Me.forEach(function(Fe){Fe.semver===Ee&&(Fe=new re(">=0.0.0")),De=De||Fe,Te=Te||Fe,ge(Fe.semver,De.semver,le)?De=Fe:Se(Fe.semver,Te.semver,le)&&(Te=Fe)}),De.operator===ke||De.operator===Pe||(!Te.operator||Te.operator===ke)&&Ce(F,Te.semver)||Te.operator===Pe&&Se(F,Te.semver))return!1}return!0}re.prototype.parse=function(F){var x=this.loose?w[ne]:w[M],$=F.match(x);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new _($[2],this.loose):this.semver=Ee},re.prototype.toString=function(){return this.value},re.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===Ee||(typeof F=="string"&&(F=new _(F,this.loose)),ue(F,this.operator,this.semver,this.loose))},re.prototype.intersects=function(F,x){if(!(F instanceof re))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new oe(F.value,x),Ae(this.value,$,x);if(F.operator==="")return $=new oe(this.value,x),Ae(F.semver,$,x);var le=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),ke=ue(this.semver,"<",F.semver,x)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Pe=ue(this.semver,">",F.semver,x)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return le||ge||Ce&&Se||ke||Pe},i.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function(F){var x=this.loose;F=F.trim(),b("range",F,x);var $=x?w[G]:w[W];F=F.replace($,Re),b("hyphen replace",F),F=F.replace(w[k],"$1$2$3"),b("comparator trim",F,w[k]),F=(F=(F=F.replace(w[te],"$1~")).replace(w[me],"$1^")).split(/\s+/).join(" ");var le=x?w[ne]:w[M],ge=F.split(" ").map(function(Ce){return function(Se,ke){return b("comp",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(Me){return function(De,Te){b("caret",De,Te);var Fe=Te?w[B]:w[j];return De.replace(Fe,function(Ne,ye,we,be,Ie){var Le;return b("caret",De,Ne,ye,we,be,Ie),he(ye)?Le="":he(we)?Le=">="+ye+".0.0 <"+(+ye+1)+".0.0":he(be)?Le=ye==="0"?">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+".0 <"+(+ye+1)+".0.0":Ie?(b("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=ye==="0"?we==="0"?">="+ye+"."+we+"."+be+Ie+" <"+ye+"."+we+"."+(+be+1):">="+ye+"."+we+"."+be+Ie+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+be+Ie+" <"+(+ye+1)+".0.0"):(b("no pr"),Le=ye==="0"?we==="0"?">="+ye+"."+we+"."+be+" <"+ye+"."+we+"."+(+be+1):">="+ye+"."+we+"."+be+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+be+" <"+(+ye+1)+".0.0"),b("caret return",Le),Le})}(Me,Oe)}).join(" ")}(Se,ke),b("caret",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(Me){return function(De,Te){var Fe=Te?w[ce]:w[de];return De.replace(Fe,function(Ne,ye,we,be,Ie){var Le;return b("tilde",De,Ne,ye,we,be,Ie),he(ye)?Le="":he(we)?Le=">="+ye+".0.0 <"+(+ye+1)+".0.0":he(be)?Le=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":Ie?(b("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=">="+ye+"."+we+"."+be+Ie+" <"+ye+"."+(+we+1)+".0"):Le=">="+ye+"."+we+"."+be+" <"+ye+"."+(+we+1)+".0",b("tilde return",Le),Le})}(Me,Oe)}).join(" ")}(Se,ke),b("tildes",Se),Se=function(Pe,Oe){return b("replaceXRanges",Pe,Oe),Pe.split(/\s+/).map(function(Me){return function(De,Te){De=De.trim();var Fe=Te?w[O]:w[I];return De.replace(Fe,function(Ne,ye,we,be,Ie,Le){b("xRange",De,Ne,ye,we,be,Ie,Le);var We=he(we),xe=We||he(be),Ve=xe||he(Ie);return ye==="="&&Ve&&(ye=""),We?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Ve?(xe&&(be=0),Ve&&(Ie=0),ye===">"?(ye=">=",xe?(we=+we+1,be=0,Ie=0):Ve&&(be=+be+1,Ie=0)):ye==="<="&&(ye="<",xe?we=+we+1:be=+be+1),Ne=ye+we+"."+be+"."+Ie):xe?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":Ve&&(Ne=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),b("xRange return",Ne),Ne})}(Me,Oe)}).join(" ")}(Se,ke),b("xrange",Se),Se=function(Pe,Oe){return b("replaceStars",Pe,Oe),Pe.trim().replace(w[ee],"")}(Se,ke),b("stars",Se),Se}(Ce,x)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Ce){return!!Ce.match(le)})),ge=ge.map(function(Ce){return new re(Ce,x)})},oe.prototype.intersects=function(F,x){if(!(F instanceof oe))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(le){return F.set.some(function(ge){return ge.every(function(Ce){return le.intersects(Ce,x)})})})})},i.toComparators=function(F,x){return new oe(F,x).set.map(function($){return $.map(function(le){return le.value}).join(" ").trim().split(" ")})},oe.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var x=0;x<this.set.length;x++)if(ze(this.set[x],F))return!0;return!1},i.satisfies=Ae,i.maxSatisfying=function(F,x,$){var le=null,ge=null;try{var Ce=new oe(x,$)}catch(Se){return null}return F.forEach(function(Se){Ce.test(Se)&&(le&&ge.compare(Se)!==-1||(ge=new _(le=Se,$)))}),le},i.minSatisfying=function(F,x,$){var le=null,ge=null;try{var Ce=new oe(x,$)}catch(Se){return null}return F.forEach(function(Se){Ce.test(Se)&&(le&&ge.compare(Se)!==1||(ge=new _(le=Se,$)))}),le},i.validRange=function(F,x){try{return new oe(F,x).range||"*"}catch($){return null}},i.ltr=function(F,x,$){return je(F,x,"<",$)},i.gtr=function(F,x,$){return je(F,x,">",$)},i.outside=je,i.prerelease=function(F,x){var $=Z(F,x);return $&&$.prerelease.length?$.prerelease:null},i.intersects=function(F,x,$){return F=new oe(F,$),x=new oe(x,$),F.intersects(x)},i.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var x=F.match(w[N]);return x==null?null:Z((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,T(1))},function(z,i){var T,P,b=z.exports={};function D(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function w(p){if(T===setTimeout)return setTimeout(p,0);if((T===D||!T)&&setTimeout)return T=setTimeout,setTimeout(p,0);try{return T(p,0)}catch(v){try{return T.call(null,p,0)}catch(S){return T.call(this,p,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:D}catch(p){T=D}try{P=typeof clearTimeout=="function"?clearTimeout:C}catch(p){P=C}})();var l,g=[],y=!1,R=-1;function c(){y&&l&&(y=!1,l.length?g=l.concat(g):R=-1,g.length&&E())}function E(){if(!y){var p=w(c);y=!0;for(var v=g.length;v;){for(l=g,g=[];++R<v;)l&&l[R].run();R=-1,v=g.length}l=null,y=!1,function(S){if(P===clearTimeout)return clearTimeout(S);if((P===C||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(S);try{P(S)}catch(f){try{return P.call(null,S)}catch(s){return P.call(this,S)}}}(p)}}function u(p,v){this.fun=p,this.array=v}function d(){}b.nextTick=function(p){var v=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)v[S-1]=arguments[S];g.push(new u(p,v)),g.length!==1||y||w(E)},u.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=d,b.addListener=d,b.once=d,b.off=d,b.removeListener=d,b.removeAllListeners=d,b.emit=d,b.prependListener=d,b.prependOnceListener=d,b.listeners=function(p){return[]},b.binding=function(p){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(p){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Y[59],Q([0,1]),function(z,i){"use strict";var T;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class P{constructor(w,l,g){this.level=w,this.key=l,this.value=g,this.forward=[]}}const b=void 0;class D{constructor(w,l=2**16){this.comparator=w,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new P(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new P(this._maxLevel,b,b)}has(w){return Boolean(D._search(this,w,this.comparator))}get(w){return D._search(this,w,this.comparator)?.value}set(w,l){return D._insert(this,w,l,this.comparator)&&(this._size+=1),this}delete(w){const l=D._delete(this,w,this.comparator);return l&&(this._size-=1),l}forEach(w,l){let g=this._header.forward[0];for(;g;)w.call(l,g.value,g.key,this),g=g.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",l=this._header.forward[0];for(;l;)w+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return w}static _search(w,l,g){let y=w._header;for(let R=w._level-1;R>=0;R--)for(;y.forward[R]&&g(y.forward[R].key,l)<0;)y=y.forward[R];if(y=y.forward[0],y&&g(y.key,l)===0)return y}static _insert(w,l,g,y){let R=[],c=w._header;for(let E=w._level-1;E>=0;E--){for(;c.forward[E]&&y(c.forward[E].key,l)<0;)c=c.forward[E];R[E]=c}if(c=c.forward[0],c&&y(c.key,l)===0)return c.value=g,!1;{let E=D._randomLevel(w);if(E>w._level){for(let u=w._level;u<E;u++)R[u]=w._header;w._level=E}c=new P(E,l,g);for(let u=0;u<E;u++)c.forward[u]=R[u].forward[u],R[u].forward[u]=c;return!0}}static _randomLevel(w,l=.5){let g=1;for(;Math.random()<l&&g<w._maxLevel;)g+=1;return g}static _delete(w,l,g){let y=[],R=w._header;for(let c=w._level-1;c>=0;c--){for(;R.forward[c]&&g(R.forward[c].key,l)<0;)R=R.forward[c];y[c]=R}if(R=R.forward[0],!R||g(R.key,l)!==0)return!1;for(let c=0;c<w._level&&y[c].forward[c]===R;c++)y[c].forward[c]=R.forward[c];for(;w._level>0&&w._header.forward[w._level-1]===b;)w._level-=1;return!0}}i.SkipList=D}),define(Y[38],Q([0,1,7,2]),function(z,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function b(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}i.isReadableStream=b;function D(f){const s=f;return s?b(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=D;function C(f,s){return new w(f,s)}i.newWriteableStream=C;class w{constructor(s,a){this.reducer=s,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(a=>a(s))}emitError(s){this.listeners.error.length===0?(0,T.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(a=>a(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,a){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(s,a){if(this.state.destroyed)return;let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(f,s){const a=[];let t;for(;(t=f.read())!==null;)a.push(t);return s(a)}i.consumeReadable=l;function g(f,s,a){const t=[];let r;for(;(r=f.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return f.read()}}}i.peekReadable=g;function y(f,s){return new Promise((a,t)=>{const r=[];R(f,{onData:e=>{s&&r.push(e)},onError:e=>{s?t(e):a(void 0)},onEnd:()=>{a(s?s(r):void 0)}})})}i.consumeStream=y;function R(f,s){f.on("error",a=>s.onError(a)),f.on("end",()=>s.onEnd()),f.on("data",a=>s.onData(a))}i.listenStream=R;function c(f,s){return new Promise((a,t)=>{const r=new P.DisposableStore,e=[],n=m=>{if(e.push(m),e.length>s)return r.dispose(),f.pause(),a({stream:f,buffer:e,ended:!1})},o=m=>t(m),h=()=>a({stream:f,buffer:e,ended:!0});r.add((0,P.toDisposable)(()=>f.removeListener("error",o))),f.on("error",o),r.add((0,P.toDisposable)(()=>f.removeListener("end",h))),f.on("end",h),r.add((0,P.toDisposable)(()=>f.removeListener("data",n))),f.on("data",n)})}i.peekStream=c;function E(f,s){const a=C(s);return a.end(f),a}i.toStream=E;function u(){const f=C(()=>{throw new Error("not supported")});return f.end(),f}i.emptyStream=u;function d(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}i.toReadable=d;function p(f,s,a){const t=C(a);return R(f,{onData:r=>t.write(s.data(r)),onError:r=>t.error(s.error?s.error(r):r),onEnd:()=>t.end()}),t}i.transform=p;function v(f,s,a){let t=!1;return{read:()=>{const r=s.read();return t?r:(t=!0,r!==null?a([f,r]):f)}}}i.prefixedReadable=v;function S(f,s,a){let t=!1;const r=C(a);return R(s,{onData:e=>t?r.write(e):(t=!0,r.write(a([f,e]))),onError:e=>r.error(e),onEnd:()=>{t||(t=!0,r.write(f)),r.end()}}),r}i.prefixedStream=S}),define(Y[17],Q([0,1,38]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const P=typeof Buffer!="undefined";let b,D;class C{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return P?new C(Buffer.allocUnsafe(n)):new C(new Uint8Array(n))}static wrap(n){return P&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new C(n)}static fromString(n,o){return!(o?.dontUseNodeBuffer||!1)&&P?new C(Buffer.from(n)):(b||(b=new TextEncoder),new C(b.encode(n)))}static concat(n,o){if(typeof o=="undefined"){o=0;for(let L=0,I=n.length;L<I;L++)o+=n[L].byteLength}const h=C.alloc(o);let m=0;for(let L=0,I=n.length;L<I;L++){const O=n[L];h.set(O,m),m+=O.byteLength}return h}toString(){return P?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(n,o){return new C(this.buffer.subarray(n,o))}set(n,o){n instanceof C?this.buffer.set(n.buffer,o):this.buffer.set(n,o)}readUInt32BE(n){return g(this.buffer,n)}writeUInt32BE(n,o){y(this.buffer,n,o)}readUInt32LE(n){return R(this.buffer,n)}writeUInt32LE(n,o){c(this.buffer,n,o)}readUInt8(n){return E(this.buffer,n)}writeUInt8(n,o){u(this.buffer,n,o)}}i.VSBuffer=C;function w(e,n){return e[n+0]<<0>>>0|e[n+1]<<8>>>0}i.readUInt16LE=w;function l(e,n,o){e[o+0]=n&255,n=n>>>8,e[o+1]=n&255}i.writeUInt16LE=l;function g(e,n){return e[n]*2**24+e[n+1]*2**16+e[n+2]*2**8+e[n+3]}i.readUInt32BE=g;function y(e,n,o){e[o+3]=n,n=n>>>8,e[o+2]=n,n=n>>>8,e[o+1]=n,n=n>>>8,e[o]=n}i.writeUInt32BE=y;function R(e,n){return e[n+0]<<0>>>0|e[n+1]<<8>>>0|e[n+2]<<16>>>0|e[n+3]<<24>>>0}i.readUInt32LE=R;function c(e,n,o){e[o+0]=n&255,n=n>>>8,e[o+1]=n&255,n=n>>>8,e[o+2]=n&255,n=n>>>8,e[o+3]=n&255}i.writeUInt32LE=c;function E(e,n){return e[n]}i.readUInt8=E;function u(e,n,o){e[o]=n}i.writeUInt8=u;function d(e){return T.consumeReadable(e,n=>C.concat(n))}i.readableToBuffer=d;function p(e){return T.toReadable(e)}i.bufferToReadable=p;function v(e){return T.consumeStream(e,n=>C.concat(n))}i.streamToBuffer=v;async function S(e){return e.ended?C.concat(e.buffer):C.concat([...e.buffer,await v(e.stream)])}i.bufferedStreamToBuffer=S;function f(e){return T.toStream(e,n=>C.concat(n))}i.bufferToStream=f;function s(e){return T.transform(e,{data:n=>typeof n=="string"?C.fromString(n):C.wrap(n)},n=>C.concat(n))}i.streamToBufferReadableStream=s;function a(e){return T.newWriteableStream(n=>C.concat(n),e)}i.newWriteableBufferStream=a;function t(e,n){return T.prefixedReadable(e,n,o=>C.concat(o))}i.prefixedBufferReadable=t;function r(e,n){return T.prefixedStream(e,n,o=>C.concat(o))}i.prefixedBufferStream=r}),define(Y[21],Q([0,1,11]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function P(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const p=Array.isArray(d)?[]:{};return Object.keys(d).forEach(v=>{d[v]&&typeof d[v]=="object"?p[v]=P(d[v]):p[v]=d[v]}),p}i.deepClone=P;function b(d){if(!d||typeof d!="object")return d;const p=[d];for(;p.length>0;){const v=p.shift();Object.freeze(v);for(const S in v)if(D.call(v,S)){const f=v[S];typeof f=="object"&&!Object.isFrozen(f)&&p.push(f)}}return d}i.deepFreeze=b;const D=Object.prototype.hasOwnProperty;function C(d,p){return w(d,p,new Set)}i.cloneAndChange=C;function w(d,p,v){if((0,T.isUndefinedOrNull)(d))return d;const S=p(d);if(typeof S!="undefined")return S;if((0,T.isArray)(d)){const f=[];for(const s of d)f.push(w(s,p,v));return f}if((0,T.isObject)(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const f={};for(let s in d)D.call(d,s)&&(f[s]=w(d[s],p,v));return v.delete(d),f}return d}function l(d,p,v=!0){return(0,T.isObject)(d)?((0,T.isObject)(p)&&Object.keys(p).forEach(S=>{S in d?v&&((0,T.isObject)(d[S])&&(0,T.isObject)(p[S])?l(d[S],p[S],v):d[S]=p[S]):d[S]=p[S]}),d):p}i.mixin=l;function g(d,p){if(d===p)return!0;if(d==null||p===null||p===void 0||typeof d!=typeof p||typeof d!="object"||Array.isArray(d)!==Array.isArray(p))return!1;let v,S;if(Array.isArray(d)){if(d.length!==p.length)return!1;for(v=0;v<d.length;v++)if(!g(d[v],p[v]))return!1}else{const f=[];for(S in d)f.push(S);f.sort();const s=[];for(S in p)s.push(S);if(s.sort(),!g(f,s))return!1;for(v=0;v<f.length;v++)if(!g(d[f[v]],p[f[v]]))return!1}return!0}i.equals=g;function y(d){const p=new Set;return JSON.stringify(d,(v,S)=>{if((0,T.isObject)(S)||Array.isArray(S)){if(p.has(S))return"[Circular]";p.add(S)}return S})}i.safeStringify=y;function R(d,p,v){const S=p(d);return typeof S=="undefined"?v:S}i.getOrDefault=R;function c(d,p){const v=Object.create(null);return!d||!p||Object.keys(p).forEach(f=>{const s=d[f],a=p[f];g(s,a)||(v[f]=a)}),v}i.distinct=c;function E(d,p){const v=p.toLowerCase(),S=Object.keys(d).find(f=>f.toLowerCase()===v);return S?d[S]:d[p]}i.getCaseInsensitive=E;function u(d,p){const v=Object.create(null);for(const[S,f]of Object.entries(d))p(S,f)&&(v[S]=f);return v}i.filter=u}),define(Y[60],Q([0,1,8]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function P(g){const y=g;return y&&typeof y.type=="string"&&typeof y.severity=="string"}i.isRemoteConsoleLog=P;function b(g){const y=[];let R;try{const c=JSON.parse(g.arguments),E=c[c.length-1];E&&E.__$stack&&(c.pop(),R=E.__$stack),y.push(...c)}catch(c){y.push("Unable to log remote console arguments",g.arguments)}return{args:y,stack:R}}i.parse=b;function D(g){if(typeof g!="string")return D(b(g).stack);const y=g;if(y){const R=C(y),c=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(c&&c.length===4)return{uri:T.URI.file(c[1]),line:Number(c[2]),column:Number(c[3])}}}i.getFirstFrame=D;function C(g){if(!g)return g;const y=g.indexOf(`
`);return y===-1?g:g.substring(0,y)}function w(g,y){const{args:R,stack:c}=b(g),E=typeof R[0]=="string"&&R.length===1;let u=C(c);u&&(u=`(${u.trim()})`);let d=[];if(typeof R[0]=="string"?u&&E?d=[`%c[${y}] %c${R[0]} %c${u}`,l("blue"),l(""),l("grey")]:d=[`%c[${y}] %c${R[0]}`,l("blue"),l(""),...R.slice(1)]:d=[`%c[${y}]%`,l("blue"),...R],u&&!E&&d.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,d)}i.log=w;function l(g){return`color: ${g}`}}),define(Y[61],Q([0,1,17,27,8]),function(z,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.MarshalledId=i.parse=i.stringify=void 0;function D(y){return JSON.stringify(y,l)}i.stringify=D;function C(y){let R=JSON.parse(y);return R=g(R),R}i.parse=C;var w;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(w=i.MarshalledId||(i.MarshalledId={}));function l(y,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,P.regExpFlags)(R)}:R}function g(y,R=0){if(!y||R>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return b.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof T.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let c=0;c<y.length;++c)y[c]=g(y[c],R+1);else for(const c in y)Object.hasOwnProperty.call(y,c)&&(y[c]=g(y[c],R+1))}return y}i.revive=g}),define(Y[62],Q([0,1,47,9,6,12,18,27,8]),function(z,i,T,P,b,D,C,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function g(n,o,h){if(typeof n=="string"&&(n=l.URI.file(n)),h){const L=h.getWorkspaceFolder(n);if(L){const I=h.getWorkspace().folders.length>1;let O;if((0,C.isEqual)(L.uri,n)?O="":O=(0,C.relativePath)(L.uri,n),I){const N=L.name?L.name:(0,C.basename)(L.uri);O=O?N+" \u2022 "+O:N}return O}}if(n.scheme!==P.Schemas.file&&n.scheme!==P.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(n.fsPath))return(0,b.normalize)(R(n.fsPath));let m=(0,b.normalize)(n.fsPath);return!D.isWindows&&o?.userHome&&(m=E(m,o.userHome.fsPath)),m}i.getPathLabel=g;function y(n){if(!n)return;typeof n=="string"&&(n=l.URI.file(n));const o=(0,C.basename)(n)||(n.scheme===P.Schemas.file?n.fsPath:n.path);return D.isWindows&&(0,T.isRootOrDriveLetter)(o)?R(o):o}i.getBaseLabel=y;function R(n,o){return(0,T.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}i.normalizeDriveLetter=R;let c=Object.create(null);function E(n,o){if(D.isWindows||!n||!o)return n;let h=c.original===o?c.normalized:void 0;return h||(h=`${(0,w.rtrim)(o,b.posix.sep)}${b.posix.sep}`,c={original:o,normalized:h}),(D.isLinux?n.startsWith(h):(0,w.startsWithIgnoreCase)(n,h))&&(n=`~/${n.substr(h.length)}`),n}i.tildify=E;function u(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}i.untildify=u;const d="\u2026",p="\\\\",v="~";function S(n,o=b.sep){const h=new Array(n.length);let m=!1;for(let L=0;L<n.length;L++){let I=n[L];if(I===""){h[L]=`.${o}`;continue}if(!I){h[L]=I;continue}m=!0;let O="";I.indexOf(p)===0?(O=I.substr(0,I.indexOf(p)+p.length),I=I.substr(I.indexOf(p)+p.length)):I.indexOf(o)===0?(O=I.substr(0,I.indexOf(o)+o.length),I=I.substr(I.indexOf(o)+o.length)):I.indexOf(v)===0&&(O=I.substr(0,I.indexOf(v)+v.length),I=I.substr(I.indexOf(v)+v.length));const N=I.split(o);for(let K=1;m&&K<=N.length;K++)for(let te=N.length-K;m&&te>=0;te--){m=!1;let de=N.slice(te,te+K).join(o);for(let ce=0;!m&&ce<n.length;ce++)if(ce!==L&&n[ce]&&n[ce].indexOf(de)>-1){const ie=te+K===N.length,me=te>0&&n[ce].indexOf(o)>-1?o+de:de,j=n[ce].endsWith(me);m=!ie||j}if(!m){let ce="";(N[0].endsWith(":")||O!=="")&&(te===1&&(te=0,K++,de=N[0]+o+de),te>0&&(ce=N[0]+o),ce=O+ce),te>0&&(ce=ce+d+o),ce=ce+de,te+K<N.length&&(ce=ce+o+d),h[L]=ce}}m&&(h[L]=I)}return h}i.shorten=S;var f;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function s(n,o=Object.create(null)){const h=[];let m=!1,L="";for(const I of n)if(I==="$"||m&&I==="{")L&&h.push({value:L,type:f.TEXT}),L="",m=!0;else if(I==="}"&&m){const O=o[L];if(typeof O=="string")O.length&&h.push({value:O,type:f.VARIABLE});else if(O){const N=h[h.length-1];(!N||N.type!==f.SEPARATOR)&&h.push({value:O.label,type:f.SEPARATOR})}L="",m=!1}else L+=I;return L&&!m&&h.push({value:L,type:f.TEXT}),h.filter((I,O)=>{if(I.type===f.SEPARATOR){const N=h[O-1],K=h[O+1];return[N,K].every(te=>te&&(te.type===f.VARIABLE||te.type===f.TEXT)&&te.value.length>0)}return!0}).map(I=>I.value).join("")}i.template=s;function a(n,o){return D.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):n.replace(/&&|&/g,h=>h==="&"?"&&":"&")}i.mnemonicMenuLabel=a;function t(n,o){return D.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):D.isWindows?n.replace(/&&|&/g,h=>h==="&"?"&&":"&"):n.replace(/&&/g,"_")}i.mnemonicButtonLabel=t;function r(n){return n.replace(/&/g,"&&")}i.unmnemonicLabel=r;function e(n){const o=n.indexOf("/")!==-1?b.posix:b.win32,h=o.basename(n),m=o.dirname(n);return h.length?{name:h,parentPath:m}:{name:m,parentPath:""}}i.splitName=e}),define(Y[63],Q([0,1,131]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class P{constructor(D="utf8"){this.stringDecoder=new T.StringDecoder(D),this.remaining=null}write(D){const C=[],w=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(w.length<1)return C;let l=0,g,y=l;for(;y<w.length;)if(g=w.charCodeAt(y),g===13||g===10){if(C.push(w.substring(l,y)),y++,y<w.length){const R=g;g=w.charCodeAt(y),(R===13&&g===10||R===10&&g===13)&&y++}l=y}else y++;return this.remaining=l<w.length?w.substr(l):null,C}end(){return this.remaining}}i.LineDecoder=P}),define(Y[64],Q([0,1,48,6,27,13]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.realpathSync=i.realpath=i.realcaseSync=void 0;function C(y){const R=(0,P.dirname)(y);if(y===R)return y;const c=((0,P.basename)(y)||y).toLowerCase();try{const u=(0,D.readdirSync)(R).filter(d=>d.toLowerCase()===c);if(u.length===1){const d=C(R);if(d)return(0,P.join)(d,u[0])}else if(u.length>1){const d=u.indexOf(c);if(d>=0){const p=C(R);if(p)return(0,P.join)(p,u[d])}}}catch(E){}return null}i.realcaseSync=C;async function w(y){try{return await D.Promises.realpath(y)}catch(R){const c=g(y);return await D.Promises.access(c,T.constants.R_OK),c}}i.realpath=w;function l(y){try{return T.realpathSync(y)}catch(R){const c=g(y);return T.accessSync(c,T.constants.R_OK),c}}i.realpathSync=l;function g(y){return(0,b.rtrim)((0,P.normalize)(y),P.sep)}}),define(Y[65],Q([0,1,34,6,13]),function(z,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,C=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var l;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(l||(l={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class R{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function c({useAlternateBitness:s=!1}={}){return s?g===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:s=!1,findPreview:a=!1}={}){const t=c({useAlternateBitness:s});if(!t)return null;const r=P.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let e=-1,n=null;for(const m of await b.Promises.readdir(r)){let L=-1;if(a){const O=m.indexOf("-");if(O<0)continue;const N=m.substring(0,O);if(!D.test(N)||m.substring(O+1)!=="preview")continue;L=parseInt(N,10)}else{if(!D.test(m))continue;L=parseInt(m,10)}if(L<=e)continue;const I=P.join(r,m,"pwsh.exe");!await b.SymlinkSupport.existsFile(I)||(n=I,e=L)}if(!n)return null;const o=t.includes("x86")?" (x86)":"",h=a?" Preview":"";return new R(n,`PowerShell${h}${o}`,!0)}async function u({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const a=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=s?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const e of await b.Promises.readdir(a))if(t.test(e)){const n=P.join(a,e,"pwsh.exe");return new R(n,r)}return null}function d(){const s=P.join(T.homedir(),".dotnet","tools","pwsh.exe");return new R(s,".NET Core PowerShell Global Tool")}function p(){const s=P.join(process.env.windir,g===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(s,"Windows PowerShell",!0)}async function*v(){let s=await E();s&&(yield s),s=await E({useAlternateBitness:!0}),s&&(yield s),s=await u(),s&&(yield s),s=d(),s&&(yield s),s=await E({findPreview:!0}),s&&(yield s),s=await u({findPreview:!0}),s&&(yield s),s=await E({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=p(),s&&(yield s)}async function*S(){for await(const s of v())await s.exists()&&(yield s)}i.enumeratePowerShellInstallations=S;async function f(){for await(const s of S())return s;return null}i.getFirstAvailablePowerShellInstallation=f});var pe=this&&this.__decorate||function(z,i,T,P){var b=arguments.length,D=b<3?i:P===null?P=Object.getOwnPropertyDescriptor(i,T):P,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(z,i,T,P);else for(var w=z.length-1;w>=0;w--)(C=z[w])&&(D=(b<3?C(D):b>3?C(i,T,D):C(i,T))||D);return b>3&&D&&Object.defineProperty(i,T,D),D};define(Y[39],Q([0,1,19,3,17,24,46,7,10,2,61,27,11]),function(z,i,T,P,b,D,C,w,l,g,y,R,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var E;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(E=i.RequestType||(i.RequestType={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(d=i.ResponseType||(i.ResponseType={}));function p(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(v||(v={}));class S{constructor(k){this.buffer=k,this.pos=0}read(k){const W=this.buffer.slice(this.pos,this.pos+k);return this.pos+=W.byteLength,W}}class f{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var s;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(s||(s={}));function a(M){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(M,0),k}function t(M){return M.read(4).readUInt32BE(0)}function r(M){const k=b.VSBuffer.alloc(1);return k.writeUInt8(M,0),k}const e={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},n=typeof Buffer!="undefined";function o(M,k){if(typeof k=="undefined")M.write(e.Undefined);else if(typeof k=="string"){const W=b.VSBuffer.fromString(k);M.write(e.String),M.write(a(W.byteLength)),M.write(W)}else if(n&&Buffer.isBuffer(k)){const W=b.VSBuffer.wrap(k);M.write(e.Buffer),M.write(a(W.byteLength)),M.write(W)}else if(k instanceof b.VSBuffer)M.write(e.VSBuffer),M.write(a(k.byteLength)),M.write(k);else if(Array.isArray(k)){M.write(e.Array),M.write(a(k.length));for(const W of k)o(M,W)}else{const W=b.VSBuffer.fromString(JSON.stringify(k));M.write(e.Object),M.write(a(W.byteLength)),M.write(W)}}function h(M){switch(M.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return M.read(t(M)).toString();case s.Buffer:return M.read(t(M)).buffer;case s.VSBuffer:return M.read(t(M));case s.Array:{const W=t(M),G=[];for(let ee=0;ee<W;ee++)G.push(h(M));return G}case s.Object:return JSON.parse(M.read(t(M)).toString())}}class m{constructor(k,W,G=null,ee=1e3){this.protocol=k,this.ctx=W,this.logger=G,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(k,W){this.channels.set(k,W),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const W=this.send([k.type]);this.logger&&this.logger.logOutgoing(W,0,1,p(k.type));return}case 201:case 202:case 204:case 203:{const W=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(W,k.id,1,p(k.type),k.data);return}}}send(k,W=void 0){const G=new f;return o(G,k),o(G,W),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(W){return 0}}onRawMessage(k){const W=new S(k),G=h(W),ee=h(W),H=G[0];switch(H){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(H)}: ${G[2]}.${G[3]}`,ee),this.onPromise({type:H,id:G[1],channelName:G[2],name:G[3],arg:ee});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(H)}: ${G[2]}.${G[3]}`,ee),this.onEventListen({type:H,id:G[1],channelName:G[2],name:G[3],arg:ee});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(H)}`),this.disposeActiveRequest({type:H,id:G[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(H)}`),this.disposeActiveRequest({type:H,id:G[1]})}}onPromise(k){const W=this.channels.get(k.channelName);if(!W){this.collectPendingRequest(k);return}const G=new D.CancellationTokenSource;let ee;try{ee=W.call(this.ctx,k.name,k.arg,G.token)}catch(_){ee=Promise.reject(_)}const H=k.id;ee.then(_=>{this.sendResponse({id:H,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:H,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:H,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,g.toDisposable)(()=>G.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const W=this.channels.get(k.channelName);if(!W){this.collectPendingRequest(k);return}const G=k.id,H=W.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:G,data:Z,type:204}));this.activeRequests.set(k.id,H)}disposeActiveRequest(k){const W=this.activeRequests.get(k.id);W&&(W.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let W=this.pendingRequests.get(k.channelName);W||(W=[],this.pendingRequests.set(k.channelName,W));const G=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:k,timeoutTimer:G})}flushPendingRequests(k){const W=this.pendingRequests.get(k);if(W){for(const G of W)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}i.ChannelServer=m;var L;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(L=i.RequestInitiator||(i.RequestInitiator={}));class I{constructor(k,W=null){this.protocol=k,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=W}getChannel(k){const W=this;return{call(G,ee,H){return W.isDisposed?Promise.reject(w.canceled()):W.requestPromise(k,G,ee,H)},listen(G,ee){return W.isDisposed?Promise.reject(w.canceled()):W.requestEvent(k,G,ee)}}}requestPromise(k,W,G,ee=D.CancellationToken.None){const H=this.lastRequestId++,_={id:H,type:100,channelName:k,name:W,arg:G};if(ee.isCancellationRequested)return Promise.reject(w.canceled());let ae;return new Promise((A,q)=>{if(ee.isCancellationRequested)return q(w.canceled());const V=()=>{const fe=ue=>{switch(ue.type){case 201:this.handlers.delete(H),A(ue.data);break;case 202:this.handlers.delete(H);const re=new Error(ue.data.message);re.stack=ue.data.stack,re.name=ue.data.name,q(re);break;case 203:this.handlers.delete(H),q(ue.data);break}};this.handlers.set(H,fe),this.sendRequest(_)};let X=null;this.state===v.Idle?V():(X=(0,P.createCancelablePromise)(fe=>this.whenInitialized()),X.then(()=>{X=null,V()}));const J=()=>{X?(X.cancel(),X=null):this.sendRequest({id:H,type:101}),q(w.canceled())},ve=ee.onCancellationRequested(J);ae=(0,g.combinedDisposable)((0,g.toDisposable)(J),ve),this.activeRequests.add(ae)}).finally(()=>{this.activeRequests.delete(ae)})}requestEvent(k,W,G){const ee=this.lastRequestId++,Z={id:ee,type:102,channelName:k,name:W,arg:G};let _=null;const ae=new l.Emitter({onFirstListenerAdd:()=>{_=(0,P.createCancelablePromise)(A=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(ae),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(ae),this.sendRequest({id:ee,type:103}))}}),U=A=>ae.fire(A.data);return this.handlers.set(ee,U),ae.event}sendRequest(k){switch(k.type){case 100:case 102:{const W=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(W,k.id,0,`${u(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const W=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(W,k.id,0,u(k.type));return}}}send(k,W=void 0){const G=new f;return o(G,k),o(G,W),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(W){return 0}}onBuffer(k){const W=new S(k),G=h(W),ee=h(W),H=G[0];switch(H){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,p(H)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],0,p(H),ee),this.onResponse({type:G[0],id:G[1],data:ee})}}onResponse(k){if(k.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(k.id);W&&W(k)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}pe([C.memoize],I.prototype,"onDidInitializePromise",null),i.ChannelClient=I;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:W,onDidClientDisconnect:G})=>{l.Event.once(W.onMessage)(H=>{const Z=new S(H),_=h(Z),ae=new m(W,_),U=new I(W);this.channels.forEach((q,V)=>ae.registerChannel(V,q));const A={channelServer:ae,channelClient:U,ctx:_};this._connections.add(A),this._onDidAddConnection.fire(A),G(()=>{ae.dispose(),U.dispose(),this._connections.delete(A),this._onDidRemoveConnection.fire(A)})})})}get connections(){const k=[];return this._connections.forEach(W=>k.push(W)),k}getChannel(k,W){const G=this;return{call(ee,H,Z){let _;if((0,c.isFunction)(W)){let U=(0,T.getRandomElement)(G.connections.filter(W));_=U?Promise.resolve(U):l.Event.toPromise(l.Event.filter(G.onDidAddConnection,W))}else _=W.routeCall(G,ee,H);const ae=_.then(U=>U.channelClient.getChannel(k));return K(ae).call(ee,H,Z)},listen(ee,H){if((0,c.isFunction)(W))return G.getMulticastEvent(k,W,ee,H);const Z=W.routeEvent(G,ee,H).then(_=>_.channelClient.getChannel(k));return K(Z).listen(ee,H)}}}getMulticastEvent(k,W,G,ee){const H=this;let Z=new g.DisposableStore;const _=new l.Emitter({onFirstListenerAdd:()=>{Z=new g.DisposableStore;const ae=new l.EventMultiplexer,U=new Map,A=V=>{const J=V.channelClient.getChannel(k).listen(G,ee),ve=ae.add(J);U.set(V,ve)},q=V=>{const X=U.get(V);!X||(X.dispose(),U.delete(V))};H.connections.filter(W).forEach(A),l.Event.filter(H.onDidAddConnection,W)(A,void 0,Z),H.onDidRemoveConnection(q,void 0,Z),ae.event(_.fire,_,Z),Z.add(ae)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,W){this.channels.set(k,W),this._connections.forEach(G=>{G.channelServer.registerChannel(k,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=O;class N{constructor(k,W,G=null){const ee=new f;o(ee,W),k.send(ee.buffer),this.channelClient=new I(k,G),this.channelServer=new m(k,W,G)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,W){this.channelServer.registerChannel(k,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function K(M){return{call(k,W,G){return M.then(ee=>ee.call(k,W,G))},listen(k,W){const G=new l.Relay;return M.then(ee=>G.input=ee.listen(k,W)),G.event}}}i.getDelayedChannel=K;function te(M){let k=!1;return{call(W,G,ee){return k?M.call(W,G,ee):(0,P.timeout)(0).then(()=>k=!0).then(()=>M.call(W,G,ee))},listen(W,G){if(k)return M.listen(W,G);const ee=new l.Relay;return(0,P.timeout)(0).then(()=>k=!0).then(()=>ee.input=M.listen(W,G)),ee.event}}}i.getNextTickChannel=te;class de{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const W of k.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await l.Event.toPromise(k.onDidAddConnection),await this.route(k)}}i.StaticRouter=de;var ce;(function(M){function k(H,Z){const _=H,ae=Z&&Z.disableMarshalling,U=new Map;for(const A in _)G(A)&&U.set(A,l.Event.buffer(_[A],!0));return new class{listen(A,q,V){const X=U.get(q);if(X)return X;if(ee(q)){const J=_[q];if(typeof J=="function")return J.call(_,V)}throw new Error(`Event not found: ${q}`)}call(A,q,V){const X=_[q];if(typeof X=="function"){if(!ae&&Array.isArray(V))for(let J=0;J<V.length;J++)V[J]=(0,y.revive)(V[J]);return X.apply(_,V)}throw new Error(`Method not found: ${q}`)}}}M.fromService=k;function W(H,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(ae,U){if(typeof U=="string")return Z?.properties?.has(U)?Z.properties.get(U):ee(U)?function(A){return H.listen(U,A)}:G(U)?H.listen(U):async function(...A){let q;Z&&!(0,c.isUndefinedOrNull)(Z.context)?q=[Z.context,...A]:q=A;const V=await H.call(U,q);return _?V:(0,y.revive)(V)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=W;function G(H){return H[0]==="o"&&H[1]==="n"&&R.isUpperAsciiLetter(H.charCodeAt(2))}function ee(H){return/^onDynamic/.test(H)&&R.isUpperAsciiLetter(H.charCodeAt(9))}})(ce=i.ProxyChannel||(i.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let k=M.toString();if(k!=="[object Object]")return k}return M}function j(M){return Array.isArray(M)?M.map(me):me(M)}function B(M,k,W,G,ee,H,Z){Z=j(Z);const _=ie[ee],ae=_[G%_.length];let U=[`%c[${M}]%c[${String(k).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${ae}`];/\($/.test(H)?(U=U.concat(Z),U.push(")")):U.push(Z),console.log.apply(console,U)}i.logWithColors=B;class ne{constructor(k,W){this._outgoingPrefix=k,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,W,G,ee,H){this._totalOutgoing+=k,B(this._outgoingPrefix,this._totalOutgoing,k,W,G,ee,H)}logIncoming(k,W,G,ee,H){this._totalIncoming+=k,B(this._incomingPrefix,this._totalIncoming,k,W,G,ee,H)}}i.IPCLogger=ne}),define(Y[66],Q([0,1,3,10,2,11]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var C;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(C=i.StorageHint||(i.StorageHint={}));function w(R){const c=R;return c?.changed instanceof Map||c?.deleted instanceof Set}i.isStorageItemsChangeEvent=w;var l;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(l||(l={}));class g extends b.Disposable{constructor(c,E=Object.create(null)){super();this.database=c,this.options=E,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(c=>this.onDidChangeItemsExternal(c)))}onDidChangeItemsExternal(c){c.changed?.forEach((E,u)=>this.accept(u,E)),c.deleted?.forEach(E=>this.accept(E,void 0))}accept(c,E){if(this.state===l.Closed)return;let u=!1;(0,D.isUndefinedOrNull)(E)?u=this.cache.delete(c):this.cache.get(c)!==E&&(this.cache.set(c,E),u=!0),u&&this._onDidChangeStorage.fire(c)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(c,E){const u=this.cache.get(c);return(0,D.isUndefinedOrNull)(u)?E:u}getBoolean(c,E){const u=this.get(c);return(0,D.isUndefinedOrNull)(u)?E:u==="true"}getNumber(c,E){const u=this.get(c);return(0,D.isUndefinedOrNull)(u)?E:parseInt(u,10)}async set(c,E){if(this.state===l.Closed)return;if((0,D.isUndefinedOrNull)(E))return this.delete(c);const u=String(E);if(this.cache.get(c)!==u)return this.cache.set(c,u),this.pendingInserts.set(c,u),this.pendingDeletes.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async delete(c){if(!(this.state===l.Closed||!this.cache.delete(c)))return this.pendingDeletes.has(c)||this.pendingDeletes.add(c),this.pendingInserts.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch(c){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const c={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(c).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(c){if(!!this.hasPending)return this.doFlush(c)}async doFlush(c){return this.flushDelayer.trigger(()=>this.flushPending(),c)}async whenFlushed(){if(!!this.hasPending)return new Promise(c=>this.whenFlushedCallbacks.push(c))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(c){c.insert&&c.insert.forEach((E,u)=>this.items.set(u,E)),c.delete&&c.delete.forEach(E=>this.items.delete(E))}async close(){}}i.InMemoryStorageDatabase=y}),define(Y[67],Q([4,5]),function(z,i){return z.create("vs/base/common/date",i)}),define(Y[68],Q([0,1,67]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const P=60,b=P*60,D=b*24,C=D*7,w=D*30,l=D*365;function g(R,c){typeof R!="number"&&(R=R.getTime());const E=Math.round((new Date().getTime()-R)/1e3);if(E<-30)return(0,T.localize)(0,null,g(new Date().getTime()+E*1e3,!1));if(E<30)return(0,T.localize)(1,null);let u;return E<P?(u=E,c?u===1?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):u===1?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u)):E<b?(u=Math.floor(E/P),c?u===1?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):u===1?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):E<D?(u=Math.floor(E/b),c?u===1?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):u===1?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u)):E<C?(u=Math.floor(E/D),c?u===1?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):u===1?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):E<w?(u=Math.floor(E/C),c?u===1?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):u===1?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u)):E<l?(u=Math.floor(E/w),c?u===1?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):u===1?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):(u=Math.floor(E/l),c?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u))}i.fromNow=g;function y(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=y}),define(Y[69],Q([4,5]),function(z,i){return z.create("vs/base/common/errorMessage",i)}),define(Y[28],Q([0,1,19,11,69]),function(z,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toErrorMessage=void 0;function D(g,y){return y&&(g.stack||g.stacktrace)?b.localize(0,null,w(g),C(g.stack)||C(g.stacktrace)):w(g)}function C(g){return Array.isArray(g)?g.join(`
`):g}function w(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?b.localize(1,null,g.message):g.message||b.localize(2,null)}function l(g=null,y=!1){if(!g)return b.localize(3,null);if(Array.isArray(g)){const R=T.coalesce(g),c=l(R[0],y);return R.length>1?b.localize(4,null,c,R.length):c}if(P.isString(g))return g;if(g.detail){const R=g.detail;if(R.error)return D(R.error,y);if(R.exception)return D(R.exception,y)}return g.stack?D(g,y):g.message?g.message:b.localize(5,null)}i.toErrorMessage=l}),define(Y[70],Q([4,5]),function(z,i){return z.create("vs/base/node/processes",i)}),define(Y[49],Q([0,1,40,47,9,21,6,12,29,58,11,63,13,70]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function u(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(t,r){if(w.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const n=T.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise(o=>{n.once("error",h=>{o({success:!1,error:h})}),n.once("exit",(h,m)=>{o(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?u(e.status):1})}else if(w.isLinux||w.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(n=>{T.execFile(e,[t.pid.toString()],{encoding:"utf8",shell:!0},(o,h,m)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function p(t){!t||(delete t.DEBUG,w.isMacintosh&&delete t.DYLD_LIBRARY_PATH,w.isLinux&&delete t.LD_PRELOAD)}i.removeDangerousEnvVariables=p;function v(t=l.env){return t.comspec||"cmd.exe"}i.getWindowsShell=v;class S{constructor(r,e,n,o){if(e!==void 0&&n!==void 0&&o!==void 0)this.cmd=r,this.args=e,this.shell=n,this.options=o;else{const h=r;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(l.env).forEach(m=>{h[m]=l.env[m]}),Object.keys(this.options.env).forEach(m=>{h[m]=this.options.env[m]}),this.options.env=h}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(C.sep);return e!==-1&&(r=r.substring(e+1)),S.WellKnowCommands[r]?r:"other"}start(r){return w.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(l.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(e=>{let n,o;const h=new Promise((m,L)=>{n=m,o=L});if(e){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=T.exec(m,this.options,(L,I,O)=>{this.childProcess=null;const N=L;N&&N.killed?o({killed:this.terminateRequested,stdout:I.toString(),stderr:O.toString()}):this.handleExec(n,r,L,I,O)})}else{let m=null;const L=I=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(I,n,r,o);const O={terminated:this.terminateRequested};y.isNumber(I)&&(O.cmdCode=I),n(O)};if(this.shell&&w.isWindows){const I=D.deepClone(this.options);I.windowsVerbatimArguments=!0,I.detached=!1;let O=!1,N=!1;const K=[];let te=this.ensureQuotes(this.cmd);K.push(te.value),O=te.quoted,this.args&&this.args.forEach(ce=>{te=this.ensureQuotes(ce),K.push(te.value),N=N&&te.quoted});const de=["/s","/c"];O?N?de.push('"'+K.join(" ")+'"'):K.length>1?de.push('"'+K[0]+'" '+K.slice(1).join(" ")):de.push('"'+K[0]+'"'):de.push(K.join(" ")),m=T.spawn(v(),de,I)}else this.cmd&&(m=T.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(y.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",I=>{this.childProcess=null,o({terminated:this.terminateRequested,error:I})}),m.pid&&(this.childProcess.on("close",L),this.handleSpawn(m,n,r,o,!0)))}return h})}handleClose(r,e,n,o){}ensureQuotes(r){return S.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,d(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!w.isWindows)return r(!1);const e=T.spawn(v(),["/s","/c"]);e.on("error",n=>r(!0)),e.on("exit",n=>r(!1))})}}i.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class f extends S{constructor(r,e,n,o){super(r,e,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,n,o,h){[o,h].forEach((m,L)=>{const I=new R.LineDecoder;I.write(m).forEach(K=>{e({line:K,source:L===0?0:1})});const N=I.end();N&&e({line:N,source:L===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,e,n,o,h){const m=new R.LineDecoder,L=new R.LineDecoder;r.stdout.on("data",I=>{m.write(I).forEach(N=>n({line:N,source:0}))}),r.stderr.on("data",I=>{L.write(I).forEach(N=>n({line:N,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=L}handleClose(r,e,n,o){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&n({line:h,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&n({line:m,source:1})}}i.LineProcess=f;function s(t){let r=[],e=!1;const n=function(o){if(e){r.push(o);return}(!t.send(o,m=>{if(m&&console.error(m),e=!1,r.length>0){const L=r.slice(0);r=[],L.forEach(I=>n(I))}})||w.isWindows)&&(e=!0)};return{send:n}}i.createQueuedSender=s;var a;(function(t){async function r(e,n,o){if(C.isAbsolute(e))return e;if(n===void 0&&(n=l.cwd()),C.dirname(e)!=="."||(o===void 0&&y.isString(l.env.PATH)&&(o=l.env.PATH.split(C.delimiter)),o===void 0||o.length===0))return C.join(n,e);async function m(L){if(await c.Promises.exists(L)){let I;try{I=await c.Promises.stat(L)}catch(O){O.message.startsWith("EACCES")&&(I=await c.Promises.lstat(L))}return I?!I.isDirectory():!1}return!1}for(let L of o){let I;if(C.isAbsolute(L)?I=C.join(L,e):I=C.join(n,L,e),await m(I))return I;let O=I+".com";if(await m(O)||(O=I+".exe",await m(O)))return O}return C.join(n,e)}t.findExecutable=r})(a=i.win32||(i.win32={}))}),define(Y[71],Q([0,1,34,12,65,49]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function C(E,u){return E===1?P.isWindows?R():D.getWindowsShell(u):g(E,u)}i.getSystemShell=C;function w(E,u){return E===1?P.isWindows?c(u):D.getWindowsShell(u):g(E,u)}i.getSystemShellSync=w;let l=null;function g(E,u){if(P.isLinux&&E===2||P.isMacintosh&&E===3)return"/bin/bash";if(!l){let d;if(P.isWindows)d="/bin/bash";else{if(d=u.SHELL,!d)try{d=(0,T.userInfo)().shell}catch(p){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}l=d}return l}let y=null;async function R(){return y||(y=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),y}function c(E){if(y)return y;const u=P.isWindows&&parseFloat((0,T.release)())>=10,d=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${E.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?p:D.getWindowsShell(E)}}),define(Y[50],Q([0,1,40,3,17,24,60,7,10,2,21,49,39]),function(z,i,T,P,b,D,C,w,l,g,y,R,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class E extends c.ChannelServer{constructor(p){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(S){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",v=>b.VSBuffer.wrap(Buffer.from(v,"base64")))},p);process.once("disconnect",()=>this.dispose())}}i.Server=E;class u{constructor(p,v){this.modulePath=p,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new P.Delayer(S),this.child=null,this._client=null}getChannel(p){const v=this;return{call(S,f,s){return v.requestPromise(p,S,f,s)},listen(S,f){return v.requestEvent(p,S,f)}}}requestPromise(p,v,S,f=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(p),a=(0,P.createCancelablePromise)(e=>s.call(v,S,e)),t=f.onCancellationRequested(()=>a.cancel()),r=(0,g.toDisposable)(()=>a.cancel());return this.activeRequests.add(r),a.finally(()=>{t.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(p,v,S){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let f;const s=new l.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(p).listen(v,S)(s.fire,s),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,R.removeDangerousEnvVariables)(v.env),this.child=(0,T.fork)(this.modulePath,p,v);const S=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,C.isRemoteConsoleLog)(n)){(0,C.log)(n,`IPC Library: ${this.options.serverName}`);return}S.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const s=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,a=n=>this.child&&this.child.connected&&s.send(n.buffer.toString("base64")),t=S.event,r={send:a,onMessage:t};this._client=new c.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",e),this.activeRequests.forEach(h=>(0,g.dispose)(h)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(p){let v=this.channels.get(p);return v||(v=this.client.getChannel(p),this.channels.set(p,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=u}),define(Y[72],Q([4,5]),function(z,i){return z.create("vs/base/node/zip",i)}),define(Y[73],Q([4,5]),function(z,i){return z.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Y[74],Q([4,5]),function(z,i){return z.create("vs/platform/environment/node/shellEnv",i)}),define(Y[75],Q([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Y[76],Q([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Y[77],Q([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Y[78],Q([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Y[79],Q([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Y[80],Q([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(Y[81],Q([4,5]),function(z,i){return z.create("vs/platform/extensions/common/extensionValidator",i)}),define(Y[82],Q([4,5]),function(z,i){return z.create("vs/platform/files/common/fileService",i)}),define(Y[83],Q([4,5]),function(z,i){return z.create("vs/platform/files/common/io",i)}),define(Y[84],Q([4,5]),function(z,i){return z.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Y[85],Q([4,5]),function(z,i){return z.create("vs/platform/request/common/request",i)}),define(Y[86],Q([4,5]),function(z,i){return z.create("vs/platform/telemetry/common/telemetryService",i)}),define(Y[87],Q([0,1,68,46,9,6,29,18,8]),function(z,i,T,P,b,D,C,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class g{constructor(d,p,v){this._args=d,this.paths=p,this.productService=v}get appRoot(){return(0,D.dirname)(b.FileAccess.asFileUri("",z).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(l.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=C.env.VSCODE_PORTABLE;return d?l.URI.file((0,D.join)(d,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,w.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,D.resolve)(d):(0,D.normalize)((0,D.join)(b.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,D.resolve)(d):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,D.resolve)(d);const p=C.env.VSCODE_EXTENSIONS;if(p)return p;const v=C.env.VSCODE_PORTABLE;return v?(0,D.join)(v,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(p=>/^[^:/?#]+?:\/\//.test(p)?l.URI.parse(p):l.URI.file((0,D.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?l.URI.parse(d):l.URI.file((0,D.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,w.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}pe([P.memoize],g.prototype,"appRoot",null),pe([P.memoize],g.prototype,"userHome",null),pe([P.memoize],g.prototype,"userDataPath",null),pe([P.memoize],g.prototype,"appSettingsHome",null),pe([P.memoize],g.prototype,"tmpDir",null),pe([P.memoize],g.prototype,"userRoamingDataHome",null),pe([P.memoize],g.prototype,"settingsResource",null),pe([P.memoize],g.prototype,"userDataSyncHome",null),pe([P.memoize],g.prototype,"userDataSyncLogResource",null),pe([P.memoize],g.prototype,"sync",null),pe([P.memoize],g.prototype,"machineSettingsResource",null),pe([P.memoize],g.prototype,"globalStorageHome",null),pe([P.memoize],g.prototype,"workspaceStorageHome",null),pe([P.memoize],g.prototype,"keybindingsResource",null),pe([P.memoize],g.prototype,"keyboardLayoutResource",null),pe([P.memoize],g.prototype,"argvResource",null),pe([P.memoize],g.prototype,"snippetsHome",null),pe([P.memoize],g.prototype,"isExtensionDevelopment",null),pe([P.memoize],g.prototype,"untitledWorkspacesHome",null),pe([P.memoize],g.prototype,"installSourcePath",null),pe([P.memoize],g.prototype,"builtinExtensionsPath",null),pe([P.memoize],g.prototype,"extensionsPath",null),pe([P.memoize],g.prototype,"extensionDevelopmentLocationURI",null),pe([P.memoize],g.prototype,"extensionDevelopmentKind",null),pe([P.memoize],g.prototype,"extensionTestsLocationURI",null),pe([P.memoize],g.prototype,"debugExtensionHost",null),pe([P.memoize],g.prototype,"serviceMachineIdResource",null),pe([P.memoize],g.prototype,"telemetryLogResource",null),pe([P.memoize],g.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=g;function y(u,d){return E(u["inspect-extensions"],u["inspect-brk-extensions"],5870,d,u.debugId,u.extensionEnvironment)}i.parseExtensionHostPort=y;function R(u,d){return E(u["inspect-search"],u["inspect-brk-search"],5876,d,u.extensionEnvironment)}i.parseSearchPort=R;function c(u,d){return E(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,d,u.extensionEnvironment)}i.parsePtyHostPort=c;function E(u,d,p,v,S,f){const a=Number(d||u)||(v?null:p),t=a?Boolean(!!d):!1;let r;if(f)try{r=JSON.parse(f)}catch{}return{port:a,break:t,debugId:S,env:r}}}),function(){"use strict";function z(i,T,P,b){function D(w){const l=C(w),g=[l];return i.isAbsolute(l)||g.unshift(b),i.resolve(...g)}function C(w){const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return i.join(g,P);const y=w["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=i.join(R,"AppData","Roaming")}break;case"darwin":g=i.join(T.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||i.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(g,P)}return{getUserDataPath:D}}if(typeof define=="function")define(Y[88],Q([0,132,34,9,18,29]),function(i,T,P,b,D,C){const w=D.dirname(b.FileAccess.asFileUri("",i)),l=i.__$__nodeRequire(D.joinPath(w,"package.json").fsPath);return z(T,P,l.name,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),T=require("path"),P=require("os");module.exports=z(T,P,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],Q([0,1,34,87,88]),function(z,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class D extends P.AbstractNativeEnvironmentService{constructor(w,l){super(w,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,b.getUserDataPath)(w)},l)}}i.NativeEnvironmentService=D}),define(Y[90],Q([0,1,21]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function b(D,C){const w=l=>{if(typeof l!="string")return;const g=P.exec(l);if(!g)return;const y=C[g[1]]??l;return typeof y=="string"?y:typeof y.message=="string"?y.message:l};return(0,T.cloneAndChange)(D,w)}i.localizeManifest=b}),define(Y[51],Q([0,1,81]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function D(c){return c=c.trim(),c==="*"||P.test(c)}i.isValidVersionStr=D;function C(c){if(!D(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=c.match(P);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}i.parseVersion=C;function w(c){if(!c)return null;let E=c.majorBase,u=c.majorMustEqual,d=c.minorBase,p=c.minorMustEqual,v=c.patchBase,S=c.patchMustEqual;c.hasCaret&&(E===0||(p=!1),S=!1);let f=0;if(c.preRelease){const s=b.exec(c.preRelease);if(s){const[,a,t,r]=s;f=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:E,majorMustEqual:u,minorBase:d,minorMustEqual:p,patchBase:v,patchMustEqual:S,isMinimum:c.hasGreaterEquals,notBefore:f}}i.normalizeVersion=w;function l(c,E,u){let d;typeof c=="string"?d=w(C(c)):d=c;let p;E instanceof Date?p=E.getTime():typeof E=="string"&&(p=new Date(E).getTime());let v;if(typeof u=="string"?v=w(C(u)):v=u,!d||!v)return!1;let S=d.majorBase,f=d.minorBase,s=d.patchBase,a=v.majorBase,t=v.minorBase,r=v.patchBase,e=v.notBefore,n=v.majorMustEqual,o=v.minorMustEqual,h=v.patchMustEqual;return v.isMinimum?S>a?!0:S<a?!1:f>t?!0:f<t||p&&p<e?!1:s>=r:(S===1&&a===0&&(!n||!o||!h)&&(a=1,t=0,r=0,n=!0,o=!1,h=!1),S<a?!1:S>a?!n:f<t?!1:f>t?!o:s<r?!1:s>r?!h:!(p&&p<e))}i.isValidVersion=l;function g(c,E,u,d){return u.isBuiltin||typeof u.main=="undefined"?!0:R(c,E,u.engines.vscode,d)}i.isValidExtensionVersion=g;function y(c,E,u){return c==="*"||R(E,u,c)}i.isEngineValid=y;function R(c,E,u,d=[]){let p=w(C(u));if(!p)return d.push(T.localize(0,null,u)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return d.push(T.localize(1,null,u)),!1}else if(!p.majorMustEqual)return d.push(T.localize(2,null,u)),!1;return l(c,E,p)?!0:(d.push(T.localize(3,null,c,u)),!1)}}),define(Y[41],Q([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class T{constructor(b,D=[],C=!1){this.ctor=b,this.staticArguments=D,this.supportsDelayedInstantiation=C}}i.SyncDescriptor=T}),define(Y[91],Q([0,1,41]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const P=[];function b(C,w,l){w instanceof T.SyncDescriptor||(w=new T.SyncDescriptor(w,[],l)),P.push([C,w])}i.registerSingleton=b;function D(){return P}i.getSingletonServiceDescriptors=D}),define(Y[92],Q([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class T{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}i.Node=T;class P{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let C of this._nodes.values())C.outgoing.size===0&&D.push(C);return D}insertEdge(D,C){const w=this.lookupOrInsertNode(D),l=this.lookupOrInsertNode(C);w.outgoing.set(this._hashFn(C),l),l.incoming.set(this._hashFn(D),w)}removeNode(D){const C=this._hashFn(D);this._nodes.delete(C);for(let w of this._nodes.values())w.outgoing.delete(C),w.incoming.delete(C)}lookupOrInsertNode(D){const C=this._hashFn(D);let w=this._nodes.get(C);return w||(w=new T(D),this._nodes.set(C,w)),w}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[C,w]of this._nodes)D.push(`${C}, (incoming)[${[...w.incoming.keys()].join(", ")}], (outgoing)[${[...w.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,C]of this._nodes){const w=new Set([D]),l=this._findCycle(C,w);if(l)return l}}_findCycle(D,C){for(let[w,l]of D.outgoing){if(C.has(w))return[...C,w].join(" -> ");C.add(w);const g=this._findCycle(l,C);if(g)return g;C.delete(w)}}}i.Graph=P}),define(Y[52],Q([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Y[20],Q([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,T.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,T.refineServiceDecorator)(i.IEnvironmentService)}),define(Y[22],Q([0,1,9,76,14]),function(z,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";var D;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(D=i.TargetPlatform||(i.TargetPlatform={}));function C(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=C;function w(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=w;function l(f,s){switch(f){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=l;function g(f,s){return s==="web"&&!f.includes("web")}i.isNotWebExtensionInWebTargetPlatform=g;function y(f,s,a){return g(s,a)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===a?!0:R(a).includes(f)}i.isTargetPlatformCompatible=y;function R(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=R;function c(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}i.isIExtensionIdentifier=c;var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E=i.SortBy||(i.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=i.SortOrder||(i.SortOrder={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d=i.StatisticType||(i.StatisticType={}));var p;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(p=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var v;(function(f){f.Unsupported="Unsupported",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(v=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class S extends Error{constructor(s,a){super(s);this.code=a,this.name=a}}i.ExtensionManagementError=S,i.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),i.ExtensionsLabel=(0,P.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,P.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(Y[93],Q([0,1,40,6,74,24,28,7,12,31,71,133,3]),function(z,i,T,P,b,D,C,w,l,g,y,R,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveShellEnv=void 0;const E=1e4;let u;async function d(v,S,f){return S["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(f)&&!S["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(f)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=c.Promises.withAsyncBody(async(s,a)=>{const t=new D.CancellationTokenSource,r=setTimeout(()=>{t.dispose(!0),a(new Error((0,b.localize)(0,null)))},E);try{s(await p(v,t.token))}catch(e){!(0,w.isPromiseCanceledError)(e)&&!t.token.isCancellationRequested?a(new Error((0,b.localize)(1,null,(0,C.toErrorMessage)(e)))):s({})}finally{clearTimeout(r),t.dispose()}})),u)}i.resolveShellEnv=d;async function p(v,S){const f=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",f);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",s);const a=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",r);const e=await(0,y.getSystemShell)(l.OS,r);return v.trace("getUnixShellEnvironment#shell",e),new Promise((n,o)=>{if(S.isCancellationRequested)return o((0,w.canceled)());const h=(0,P.basename)(e);let m,L;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(m=`& '${process.execPath}' ${I} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,L=["-Login","-Command"]):(m=`'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,h==="tcsh"?L=["-ic"]:L=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),m);const O=(0,T.spawn)(e,[...L,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});S.onCancellationRequested(()=>(O.kill(),o((0,w.canceled)()))),O.on("error",te=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(te)),o(te)});const N=[];O.stdout.on("data",te=>N.push(te));const K=[];O.stderr.on("data",te=>K.push(te)),O.on("close",(te,de)=>{const ce=Buffer.concat(N).toString("utf8");v.trace("getUnixShellEnvironment#raw",ce);const ie=Buffer.concat(K).toString("utf8");if(ie.trim()&&v.trace("getUnixShellEnvironment#stderr",ie),te||de)return o(new Error((0,b.localize)(2,null,te,de)));const me=t.exec(ce),j=me?me[1]:"{}";try{const B=JSON.parse(j);f?B.ELECTRON_RUN_AS_NODE=f:delete B.ELECTRON_RUN_AS_NODE,s?B.ELECTRON_NO_ATTACH_CONSOLE=s:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",B),n(B)}catch(B){v.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(B)),o(B)}})})}}),define(Y[53],Q([0,1,17,7,83,16]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function C(y,R,c,E,u,d){let p;try{await w(y,R,c,E,u,d)}catch(v){p=v}finally{p&&u.errorTransformer&&(p=u.errorTransformer(p)),typeof p!="undefined"&&c.error(p),c.end()}}i.readFileIntoStream=C;async function w(y,R,c,E,u,d){l(d);const p=await y.open(R,{create:!1});try{l(d);let v=0,S=0,f=u&&typeof u.length=="number"?u.length:void 0,s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),a=u&&typeof u.position=="number"?u.position:0,t=0;do S=await y.read(p,a,s.buffer,t,s.byteLength-t),a+=S,t+=S,v+=S,typeof f=="number"&&(f-=S),t===s.byteLength&&(await c.write(E(s)),s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),t=0);while(S>0&&(typeof f!="number"||f>0)&&l(d)&&g(v,u));if(t>0){let r=t;typeof f=="number"&&(r=Math.min(t,f)),c.write(E(s.slice(0,r)))}}catch(v){throw(0,D.ensureFileSystemProviderError)(v)}finally{await y.close(p)}}function l(y){if(y.isCancellationRequested)throw(0,P.canceled)();return!0}function g(y,R){if(R?.limits){if(typeof R.limits.memory=="number"&&y>R.limits.memory)throw(0,D.createFileSystemProviderError)((0,b.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&y>R.limits.size)throw(0,D.createFileSystemProviderError)((0,b.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[35],Q([0,1,2,12,8,16]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.coalesceEvents=i.toFileChanges=i.WatcherService=i.AbstractWatcherService=void 0;class C extends T.Disposable{constructor(c,E,u){super();this.onFileChanges=c,this.onLogMessage=E,this.verboseLogging=u,this.serviceDisposables=this._register(new T.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new T.DisposableStore;this.serviceDisposables.value=c,this.service=this.createService(c),this.service.setVerboseLogging(this.verboseLogging),c.add(this.service.onDidChangeFile(E=>this.onFileChanges(E))),c.add(this.service.onDidLogMessage(E=>this.onLogMessage(E))),c.add(this.service.onDidError(E=>this.onError(E)))}onError(c){this.restartCounter<C.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.service?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.service?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${c}`})}dispose(){return this.service=void 0,super.dispose()}}i.AbstractWatcherService=C,C.MAX_RESTARTS=5;class w extends T.Disposable{}i.WatcherService=w;function l(R){return R.map(c=>({type:c.type,resource:b.URI.file(c.path)}))}i.toFileChanges=l;function g(R){const c=new y;for(const E of R)c.processEvent(E);return c.coalesce()}i.coalesceEvents=g;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return P.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const E=this.mapPathToChange.get(this.toKey(c));let u=!1;if(E){const d=E.type,p=c.type;E.path!==c.path&&c.type===2?u=!0:d===1&&p===2?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(E)):d===2&&p===1?E.type=0:d===1&&p===0||(E.type=p)}else u=!0;u&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],E=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(c.push(u),!1):!0).sort((u,d)=>u.path.length-d.path.length).filter(u=>E.some(d=>(0,D.isParent)(u.path,d,!P.isLinux))?!1:(E.push(u.path),!0)).concat(c)}}}),define(Y[94],Q([0,1,3,2,6,64,13,134,35]),function(z,i,T,P,b,D,C,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class g extends P.Disposable{constructor(R,c,E,u){super();this.path=R,this.onDidFilesChange=c,this.onLogMessage=E,this.verboseLogging=u,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(w.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(R){this.verboseLogging=R}async startWatching(){try{const{stat:R,symbolicLink:c}=await C.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(c)try{E=await(0,D.realpath)(E)}catch(u){if(this.onError(u),c.dangling)return}R.isDirectory()?this._register((0,w.watchFolder)(E,(u,d)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,b.join)(this.path,(0,b.basename)(d))})},u=>this.onError(u))):this._register((0,w.watchFile)(E,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(R){R.code!=="ENOENT"&&this.onError(R)}}onFileChange(R){this.fileChangesBuffer.push(R),this.verboseLogging&&this.onVerbose(`${R.type===1?"[ADDED]":R.type===2?"[DELETED]":"[CHANGED]"} ${R.path}`),this.fileChangesDelayer.trigger(async()=>{const c=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,l.coalesceEvents)(c);if(this.verboseLogging)for(const u of E)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(R){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${R}`})}onVerbose(R){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${R}`})}dispose(){this.isDisposed=!0,super.dispose()}}i.FileWatcher=g}),define(Y[95],Q([0,1,9,39,50,35]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class C extends D.WatcherService{constructor(l,g,y){super();this.onDidFilesChange=l,this.onLogMessage=g,this.verboseLogging=y,this.isDisposed=!1,this.startWatching()}startWatching(){const l=this._register(new b.Client(T.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=P.ProxyChannel.toService((0,P.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}async watch(l){this.isDisposed||await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}i.FileWatcher=C}),define(Y[96],Q([0,1,9,39,50,35]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class C extends D.AbstractWatcherService{constructor(l,g,y){super(l,g,y);this.init()}createService(l){const g=l.add(new b.Client(T.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(g.onDidProcessExit(({code:y,signal:R})=>this.onError(`terminated by itself with code ${y}, signal: ${R}`))),P.ProxyChannel.toService((0,P.getNextTickChannel)(g.getChannel("watcher")))}}i.FileWatcher=C}),define(Y[54],Q([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class T{constructor(...b){this._entries=new Map;for(let[D,C]of b)this.set(D,C)}set(b,D){const C=this._entries.get(b);return this._entries.set(b,D),C}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}i.ServiceCollection=T}),define(Y[97],Q([0,1,3,7,41,92,14,54]),function(z,i,T,P,b,D,C,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InstantiationService=void 0;const l=!1;class g extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class y{constructor(u=new w.ServiceCollection,d=!1,p){this._activeInstantiations=new Set,this._services=u,this._strict=d,this._parent=p,this._services.set(C.IInstantiationService,this)}createChild(u){return new y(u,this._strict,this)}invokeFunction(u,...d){let p=c.traceInvocation(u),v=!1;try{return u({get:f=>{if(v)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,p);if(!s)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...d)}finally{v=!0,p.stop()}}createInstance(u,...d){let p,v;return u instanceof b.SyncDescriptor?(p=c.traceCreation(u.ctor),v=this._createInstance(u.ctor,u.staticArguments.concat(d),p)):(p=c.traceCreation(u),v=this._createInstance(u,d,p)),p.stop(),v}_createInstance(u,d=[],p){let v=C._util.getServiceDependencies(u).sort((s,a)=>s.index-a.index),S=[];for(const s of v){let a=this._getOrCreateServiceInstance(s.id,p);if(!a&&this._strict&&!s.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${s.id}.`);S.push(a)}let f=v.length>0?v[0].index:d.length;if(d.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${d.length} static arguments`);let s=f-d.length;s>0?d=d.concat(new Array(s)):d=d.slice(0,f)}return new u(...[...d,...S])}_setServiceInstance(u,d){if(this._services.get(u)instanceof b.SyncDescriptor)this._services.set(u,d);else if(this._parent)this._parent._setServiceInstance(u,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let d=this._services.get(u);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):d}_getOrCreateServiceInstance(u,d){let p=this._getServiceInstanceOrDescriptor(u);return p instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,p,d.branch(u,!0)):(d.branch(u,!1),p)}_safeCreateAndCacheServiceInstance(u,d,p){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,d,p)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,d,p){const v=new D.Graph(s=>s.id.toString());let S=0;const f=[{id:u,desc:d,_trace:p}];for(;f.length;){const s=f.pop();if(v.lookupOrInsertNode(s),S++>1e3)throw new g(v);for(let a of C._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof b.SyncDescriptor){const r={id:a.id,desc:t,_trace:s._trace.branch(a.id,!0)};v.insertEdge(s,r),f.push(r)}}}for(;;){const s=v.roots();if(s.length===0){if(!v.isEmpty())throw new g(v);break}for(const{data:a}of s){if(this._getServiceInstanceOrDescriptor(a.id)instanceof b.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}v.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,d,p=[],v,S){if(this._services.get(u)instanceof b.SyncDescriptor)return this._createServiceInstance(d,p,v,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,d,p,v,S);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(u,d=[],p,v){if(p){const S=new T.IdleValue(()=>this._createInstance(u,d,v));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let a=S.value,t=a[s];return typeof t!="function"||(t=t.bind(a),f[s]=t),t},set(f,s,a){return S.value[s]=a,!0}})}else return this._createInstance(u,d,v)}}i.InstantiationService=y;var R;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(R||(R={}));class c{constructor(u,d){this.type=u,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new c(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(u){return l?new c(0,u.name):c._None}branch(u,d){let p=new c(2,u.toString());return this._dep.push([u,d,p]),p}stop(){let u=Date.now()-this._start;c._totals+=u;let d=!1;function p(S,f){let s=[],a=new Array(S+1).join("	");for(const[t,r,e]of f._dep)if(r&&e){d=!0,s.push(`${a}CREATES -> ${t}`);let n=p(S+1,e);n&&s.push(n)}else s.push(`${a}uses -> ${t}`);return s.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(u>2||d)&&console.log(v.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(Y[55],Q([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,T.createDecorator)("localizationsService");function P(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const D of b.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}i.isValidLocalization=P}),define(Y[15],Q([0,1,28,10,2,12,14]),function(z,i,T,P,b,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,C.createDecorator)("logService"),i.ILoggerService=(0,C.createDecorator)("loggerService");function w(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function g(r,e,n){switch(e){case l.Trace:r.trace(n);break;case l.Debug:r.debug(n);break;case l.Info:r.info(n);break;case l.Warning:r.warn(n);break;case l.Error:r.error(n);break;case l.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=g;function y(r){let e="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(h){}e+=(n>0?" ":"")+o}return e}i.format=y;class R extends b.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=R;class c extends R{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,y([e,...n]))}debug(e,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,y([e,...n]))}info(e,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,y([e,...n]))}warn(e,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,y([e,...n]))}error(e,...n){if(this.checkLogLevel(l.Error))if(e instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=e.stack,this.log(l.Error,y(o))}else this.log(l.Error,y([e,...n]))}critical(e,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,y([e,...n]))}flush(){}}i.AbstractMessageLogger=c;class E extends R{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!D.isWindows}trace(e,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...n):console.log(`[main ${w()}]`,e,...n))}debug(e,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...n):console.log(`[main ${w()}]`,e,...n))}info(e,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...n):console.log(`[main ${w()}]`,e,...n))}warn(e,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${w()}][0m`,e,...n):console.warn(`[main ${w()}]`,e,...n))}error(e,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${w()}][0m`,e,...n):console.error(`[main ${w()}]`,e,...n))}critical(e,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${w()}][0m`,e,...n):console.error(`[main ${w()}]`,e,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=E;class u extends R{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}i.ConsoleLogger=u;class d extends R{constructor(e,n=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=d;class p extends R{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const o of this.logServices)o.trace(e,...n)}debug(e,...n){for(const o of this.logServices)o.debug(e,...n)}info(e,...n){for(const o of this.logServices)o.info(e,...n)}warn(e,...n){for(const o of this.logServices)o.warn(e,...n)}error(e,...n){for(const o of this.logServices)o.error(e,...n)}critical(e,...n){for(const o of this.logServices)o.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=p;class v extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}i.LogService=v;class S extends b.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(o))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let o=this.loggers.get(e.toString());return o||(o=this.doCreateLogger(e,n?.always?l.Trace:this.logLevel,n),this.loggers.set(e.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=S;class f{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}i.NullLogService=f;function s(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const e=a(r.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=s;function a(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=a;function t(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=t});var se=this&&this.__param||function(z,i){return function(T,P){i(T,P,z)}};define(Y[98],Q([0,1,40,3,28,10,2,9,6,13,20,15]),function(z,i,T,P,b,D,C,w,l,g,y,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let c=class extends C.Disposable{constructor(u,d){super();this.environmentService=u,this.logService=d,this.processesLimiter=new P.Limiter(5)}async postUninstall(u){const d=this.parseScript(u,"uninstall");return d&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${p}`)))),g.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(u,d){const p=`vscode:${d}`;if(u.location.scheme===w.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[p]=="string"){const v=u.manifest.scripts[p].split(" ");return v.length<2||v[0]!=="node"||!v[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${p} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,v[1]),args:v.slice(2)||[]}}return null}runLifecycleHook(u,d,p,v,S){return new Promise((f,s)=>{const a=this.start(u,d,p,S);let t;const r=e=>{t&&(clearTimeout(t),t=null),e?s(e):f(void 0)};a.on("error",e=>{r((0,b.toErrorMessage)(e)||"Unknown")}),a.on("exit",(e,n)=>{r(e?`post-${d} process exited with code ${e}`:void 0)}),v&&(t=setTimeout(()=>{t=null,a.kill(),s("timed out")},5e3))})}start(u,d,p,v){const S={silent:!0,execArgv:void 0},f=(0,T.fork)(u,[`--type=extension-post-${d}`,...p],S);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=D.Event.fromNodeEventEmitter(f.stdout,"data"),a=D.Event.fromNodeEventEmitter(f.stderr,"data");s(e=>this.logService.info(v.identifier.id,v.manifest.version,`post-${d}`,e)),a(e=>this.logService.error(v.identifier.id,v.manifest.version,`post-${d}`,e));const t=D.Event.any(D.Event.map(s,e=>({data:`%c${e}`,format:[""]})),D.Event.map(a,e=>({data:`%c${e}`,format:["color: red"]})));return D.Event.debounce(t,(e,n)=>e?{data:e.data+n.data,format:[...e.format,...n.format]}:{data:n.data,format:n.format},100)(e=>{console.group(v.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};c=pe([se(0,y.IEnvironmentService),se(1,R.ILogService)],c),i.ExtensionsLifecycle=c}),define(Y[99],Q([0,1,19,3,7,10,2,6,35,15]),function(z,i,T,P,b,D,C,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class y extends C.Disposable{constructor(c){super();this.logService=c,this._onDidErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}watch(c,E){return E.recursive?this.watchRecursive(c,E):this.watchNonRecursive(c)}watchRecursive(c,E){const u={path:this.toFilePath(c),excludes:E.excludes},d=(0,T.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(c=>(0,b.onUnexpectedError)(c))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(c=>this._onDidChangeFile.fire((0,l.toFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(c,E){return c.watch(E)}watchNonRecursive(c){const E=this.createNonRecursiveWatcher(this.toFilePath(c),d=>this._onDidChangeFile.fire((0,l.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===g.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{E.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)});return(0,C.combinedDisposable)(E,u)}onWatcherLogMessage(c){c.type==="error"&&this._onDidErrorOccur.fire(c.message),this.logService[c.type](c.message)}toFilePath(c){return(0,w.normalize)(c.fsPath)}}i.AbstractDiskFileSystemProvider=y}),define(Y[100],Q([0,1,19,3,17,24,10,135,2,101,9,102,18,38,82,16,53,15]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E,u,d,p,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let S=class Ue extends l.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new C.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new d.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new d.FileChangesEvent(a,!0)))),this.watchedResources=g.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(s,a){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,R.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:a});const t=new l.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:s}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:a}),this.provider.delete(s),(0,l.dispose)(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){a.push(t)}}),!this.provider.has(s)&&await P.Promises.settled(a)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,a){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return w.Iterable.map(this.provider,([s,a])=>({scheme:s,capabilities:a.capabilities}))}async withProvider(s){if(!(0,c.isAbsolutePath)(s))throw new d.FileOperationError((0,u.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const a=this.provider.get(s.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,u.localize)(1,null,s.toString()),t}return a}async withReadProvider(s){const a=await this.withProvider(s);if((0,d.hasOpenReadWriteCloseCapability)(a)||(0,d.hasReadWriteCapability)(a)||(0,d.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const a=await this.withProvider(s);if((0,d.hasOpenReadWriteCloseCapability)(a)||(0,d.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,a){try{return await this.doResolveFile(s,a)}catch(t){throw(0,d.toFileSystemProviderErrorCode)(t)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,u.localize)(2,null,this.resourceForError(s)),1):(0,d.ensureFileSystemProviderError)(t)}}async doResolveFile(s,a){const t=await this.withProvider(s),r=this.isPathCaseSensitive(t),e=a?.resolveTo,n=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,h=await t.stat(s);let m;return this.toFileStat(t,s,h,void 0,!!o,(L,I)=>(m||(m=g.TernarySearchTree.forUris(()=>!r),m.set(s,!0),e&&m.fill(!0,e)),m.get(L.resource)||m.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&n?I===1:!1))}async toFileStat(s,a,t,r,e,n){const{providerExtUri:o}=this.getExtUri(s),h={resource:a,name:o.basename(a),isFile:(t.type&d.FileType.File)!=0,isDirectory:(t.type&d.FileType.Directory)!=0,isSymbolicLink:(t.type&d.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&d.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,d.etag)({mtime:t.mtime,size:t.size})};if(h.isDirectory&&n(h,r)){try{const m=await s.readdir(a),L=await P.Promises.settled(m.map(async([I,O])=>{try{const N=o.joinPath(a,I),K=e?await s.stat(N):{type:O};return await this.toFileStat(s,N,K,m.length,e,n)}catch(N){return this.logService.trace(N),null}}));h.children=(0,T.coalesce)(L)}catch(m){this.logService.trace(m),h.children=[]}return h}return h}async resolveAll(s){return P.Promises.settled(s.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const a=await this.withProvider(s);try{return!!await a.stat(s)}catch(t){return!1}}async canCreateFile(s,a){try{await this.doValidateCreateFile(s,a)}catch(t){return t}return!0}async doValidateCreateFile(s,a){if(!a?.overwrite&&await this.exists(s))throw new d.FileOperationError((0,u.localize)(3,null,this.resourceForError(s)),3,a)}async createFile(s,a=b.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const r=await this.writeFile(s,a);return this._onDidRunOperation.fire(new d.FileOperationEvent(s,0,r)),r}async writeFile(s,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:e}=this.getExtUri(r);try{await this.validateWriteFile(r,s,t)||await this.mkdirp(r,e.dirname(s));let o;if((0,d.hasReadWriteCapability)(r)&&!(a instanceof b.VSBuffer))if((0,E.isReadableStream)(a)){const h=await(0,E.peekStream)(a,3);h.ended?o=b.VSBuffer.concat(h.buffer):o=h}else o=(0,E.peekReadable)(a,h=>b.VSBuffer.concat(h),3);else o=a;!(0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r)&&o instanceof b.VSBuffer?await this.doWriteUnbuffered(r,s,t,o):await this.doWriteBuffered(r,s,t,o instanceof b.VSBuffer?(0,b.bufferToReadable)(o):o)}catch(n){throw new d.FileOperationError((0,u.localize)(4,null,this.resourceForError(s),(0,d.ensureFileSystemProviderError)(n).toString()),(0,d.toFileOperationResult)(n),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,a,t){if(!!t?.unlock&&!(s.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(a)));let e;try{e=await s.stat(a)}catch(n){return}if((e.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,u.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,e),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==d.ETAG_DISABLED&&typeof e.mtime=="number"&&typeof e.size=="number"&&t.mtime<e.mtime&&t.etag!==(0,d.etag)({mtime:t.mtime,size:e.size}))throw new d.FileOperationError((0,u.localize)(7,null),3,t);return e}async readFile(s,a){const t=await this.withReadProvider(s);return a?.atomic?this.doReadFileAtomic(t,s,a):this.doReadFile(t,s,a)}async doReadFileAtomic(s,a,t){return new Promise((r,e)=>{this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(s,a,t);r(n)}catch(n){e(n)}})})}async doReadFile(s,a,t){const r=await this.doReadFileStream(s,a,{...t,preferUnbuffered:!0});return{...r,value:await(0,b.streamToBuffer)(r.value)}}async readFileStream(s,a){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,a)}async doReadFileStream(s,a,t){const r=new D.CancellationTokenSource,e=this.validateReadFile(a,t).then(o=>o,o=>{throw r.cancel(),o});let n;try{return typeof t?.etag=="string"&&t.etag!==d.ETAG_DISABLED&&await e,!((0,d.hasOpenReadWriteCloseCapability)(s)||(0,d.hasFileReadStreamCapability)(s))||(0,d.hasReadWriteCapability)(s)&&t?.preferUnbuffered?n=this.readFileUnbuffered(s,a,t):(0,d.hasFileReadStreamCapability)(s)?n=this.readFileStreamed(s,a,r.token,t):n=this.readFileBuffered(s,a,r.token,t),{...await e,value:n}}catch(o){n&&await(0,E.consumeStream)(n);const h=(0,u.localize)(8,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(o).toString());throw o instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(h,o.stat,t):new d.FileOperationError(h,(0,d.toFileOperationResult)(o),t)}}readFileStreamed(s,a,t,r=Object.create(null)){const e=s.readFileStream(a,r,t);return(0,E.transform)(e,{data:n=>n instanceof b.VSBuffer?n:b.VSBuffer.wrap(n),error:n=>new d.FileOperationError((0,u.localize)(9,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(n).toString()),(0,d.toFileOperationResult)(n),r)},n=>b.VSBuffer.concat(n))}readFileBuffered(s,a,t,r=Object.create(null)){const e=(0,b.newWriteableBufferStream)();return(0,p.readFileIntoStream)(s,a,e,n=>n,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new d.FileOperationError((0,u.localize)(10,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(n).toString()),(0,d.toFileOperationResult)(n),r)},t),e}readFileUnbuffered(s,a,t){const r=(0,E.newWriteableStream)(e=>b.VSBuffer.concat(e));return(async()=>{try{let e=await s.readFile(a);typeof t?.position=="number"&&(e=e.slice(t.position)),typeof t?.length=="number"&&(e=e.slice(0,t.length)),this.validateReadFileLimits(a,e.byteLength,t),r.end(b.VSBuffer.wrap(e))}catch(e){r.error(e),r.end()}})(),r}async validateReadFile(s,a){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new d.FileOperationError((0,u.localize)(11,null,this.resourceForError(s)),0,a);if(typeof a?.etag=="string"&&a.etag!==d.ETAG_DISABLED&&a.etag===t.etag)throw new d.NotModifiedSinceFileOperationError((0,u.localize)(12,null),t,a);return this.validateReadFileLimits(s,t.size,a),t}validateReadFileLimits(s,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new d.FileOperationError((0,u.localize)(13,null,this.resourceForError(s)),r)}}async canMove(s,a,t){return this.doCanMoveCopy(s,a,"move",t)}async canCopy(s,a,t){return this.doCanMoveCopy(s,a,"copy",t)}async doCanMoveCopy(s,a,t,r){if(s.toString()!==a.toString())try{const e=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(e,s,n,a,t,r)}catch(e){return e}return!0}async move(s,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=await this.doMoveCopy(r,s,e,a,"move",!!t),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(s,n==="move"?2:3,o)),o}async copy(s,a,t){const r=await this.withReadProvider(s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=await this.doMoveCopy(r,s,e,a,"copy",!!t),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(s,n==="copy"?3:2,o)),o}async doMoveCopy(s,a,t,r,e,n){if(a.toString()===r.toString())return e;const{exists:o,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(s,a,t,r,e,n);if(o&&!h&&n&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),e==="copy"){if(s===t&&(0,d.hasFileFolderCopyCapability)(s))await s.copy(a,r,{overwrite:n});else{const m=await this.resolve(a);m.isDirectory?await this.doCopyFolder(s,m,t,r):await this.doCopyFile(s,a,t,r)}return e}else return s===t?(await s.rename(a,r,{overwrite:n}),e):(await this.doMoveCopy(s,a,t,r,"copy",n),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(s,a,t,r){if((0,d.hasOpenReadWriteCloseCapability)(s)&&(0,d.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,a,t,r);if((0,d.hasOpenReadWriteCloseCapability)(s)&&(0,d.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,a,t,r);if((0,d.hasReadWriteCapability)(s)&&(0,d.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,a,t,r);if((0,d.hasReadWriteCapability)(s)&&(0,d.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,a,t,r)}async doCopyFolder(s,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await P.Promises.settled(a.children.map(async e=>{const n=this.getExtUri(t).providerExtUri.joinPath(r,e.name);return e.isDirectory?this.doCopyFolder(s,await this.resolve(e.resource),t,n):this.doCopyFile(s,e.resource,t,n)}))}async doValidateMoveCopy(s,a,t,r,e,n){let o=!1;if(s===t){const{providerExtUri:m,isPathCaseSensitive:L}=this.getExtUri(s);if(L||(o=m.isEqual(a,r)),o&&e==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!o&&m.isEqualOrParent(r,a))throw new Error((0,u.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const h=await this.exists(r);if(h&&!o){if(!n)throw new d.FileOperationError((0,u.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(s===t){const{providerExtUri:m}=this.getExtUri(s);if(m.isEqualOrParent(a,r))throw new Error((0,u.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:h,isSameResourceWithDifferentPathCase:o}}getExtUri(s){const a=this.isPathCaseSensitive(s);return{providerExtUri:a?c.extUri:c.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(a,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(s,0,t)),t}async mkdirp(s,a){const t=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(a,r.dirname(a));)try{if(((await s.stat(a)).type&d.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(a)));break}catch(e){if((0,d.toFileSystemProviderErrorCode)(e)!==d.FileSystemProviderErrorCode.FileNotFound)throw e;t.push(r.basename(a)),a=r.dirname(a)}for(let e=t.length-1;e>=0;e--){a=r.joinPath(a,t[e]);try{await s.mkdir(a)}catch(n){if((0,d.toFileSystemProviderErrorCode)(n)!==d.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(s,a){try{await this.doValidateDelete(s,a)}catch(t){return t}return!0}async doValidateDelete(s,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(s)));let e;try{e=await t.stat(s)}catch(o){}if(e)this.throwIfFileIsReadonly(s,e);else throw new d.FileOperationError((0,u.localize)(20,null,this.resourceForError(s)),1);if(!!!a?.recursive){const o=await this.resolve(s);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(s)))}return t}async del(s,a){const t=await this.doValidateDelete(s,a),r=!!a?.useTrash,e=!!a?.recursive;await t.delete(s,{recursive:e,useTrash:r}),this._onDidRunOperation.fire(new d.FileOperationEvent(s,1))}onDidChangeFile(s,a){this._onDidChangeFilesRaw.fire({changes:s});let t,r;{for(const e of s)this.watchedResources.has(e.resource)?(t||(t=[]),t.push(e)):(r||(r=[]),r.push(e));t&&this._onDidFilesChange.fire(new d.FileChangesEvent(t,!a))}if(r){const e=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!e.work(r)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),e.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${e.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,a={recursive:!1,excludes:[]}){const t=new l.DisposableStore;let r=!1,e=()=>{r=!0};return t.add((0,l.toDisposable)(()=>e())),this.doWatch(s,a).then(n=>{r?(0,l.dispose)(n):e=()=>(0,l.dispose)(n)},n=>this.logService.error(n)),a.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),t.add((0,l.toDisposable)(()=>{const n=this.watchedResources.get(s);typeof n=="number"&&(n<=1?this.watchedResources.delete(s):this.watchedResources.set(s,n-1))}))),t}async doWatch(s,a){const t=await this.withProvider(s),r=this.toWatchKey(t,s,a);let e=this.activeWatchers.get(r);return e||(e={count:0,disposable:t.watch(s,a)},this.activeWatchers.set(r,e)),e.count+=1,(0,l.toDisposable)(()=>{e&&(e.count--,e.count===0&&((0,l.dispose)(e.disposable),this.activeWatchers.delete(r)))})}toWatchKey(s,a,t){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,l.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{const e=await s.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,E.isReadableStream)(r)||(0,E.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,e,r):await this.doWriteReadableBufferedQueued(s,e,r)}catch(n){throw(0,d.ensureFileSystemProviderError)(n)}finally{await s.close(e)}})}async doWriteStreamBufferedQueued(s,a,t){let r=0,e;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const n=b.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,a,n,n.byteLength,r,0),r+=n.byteLength}if(t.ended)return;e=t.stream}else e=t;return new Promise((n,o)=>{(0,E.listenStream)(e,{onData:async h=>{e.pause();try{await this.doWriteBuffer(s,a,h,h.byteLength,r,0)}catch(m){return o(m)}r+=h.byteLength,setTimeout(()=>e.resume())},onError:h=>o(h),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(s,a,t){let r=0,e;for(;(e=t.read())!==null;)await this.doWriteBuffer(s,a,e,e.byteLength,r,0),r+=e.byteLength}async doWriteBuffer(s,a,t,r,e,n){let o=0;for(;o<r;)o+=await s.write(a,e+o,t.buffer,n+o,r-o)}async doWriteUnbuffered(s,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,a,t,r))}async doWriteUnbufferedQueued(s,a,t,r){let e;r instanceof b.VSBuffer?e=r:(0,E.isReadableStream)(r)?e=await(0,b.streamToBuffer)(r):(0,E.isReadableBufferedStream)(r)?e=await(0,b.bufferedStreamToBuffer)(r):e=(0,b.readableToBuffer)(r),await s.writeFile(a,e.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,a,t,r))}async doPipeBufferedQueued(s,a,t,r){let e,n;try{e=await s.open(a,{create:!1}),n=await t.open(r,{create:!0,unlock:!1});const o=b.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,m=0,L=0;do L=await s.read(e,h,o.buffer,m,o.byteLength-m),await this.doWriteBuffer(t,n,o,L,h,m),h+=L,m+=L,m===o.byteLength&&(m=0);while(L>0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await P.Promises.settled([typeof e=="number"?s.close(e):Promise.resolve(),typeof n=="number"?t.close(n):Promise.resolve()])}}async doPipeUnbuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,a,t,r))}async doPipeUnbufferedQueued(s,a,t,r){return t.writeFile(r,await s.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,a,t,r))}async doPipeUnbufferedToBufferedQueued(s,a,t,r){const e=await t.open(r,{create:!0,unlock:!1});try{const n=await s.readFile(a);await this.doWriteBuffer(t,e,b.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,d.ensureFileSystemProviderError)(n)}finally{await t.close(e)}}async doPipeBufferedToUnbuffered(s,a,t,r){const e=await(0,b.streamToBuffer)(this.readFileBuffered(s,a,D.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,e)}throwIfFileSystemIsReadonly(s,a){if(s.capabilities&2048)throw new d.FileOperationError((0,u.localize)(22,null,this.resourceForError(a)),6);return s}throwIfFileIsReadonly(s,a){if((a.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,u.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===y.Schemas.file?s.fsPath:s.toString(!0)}};S.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},S=pe([se(0,v.ILogService)],S),i.FileService=S}),define(Y[103],Q([0,1,48,136,3,17,10,47,6,12,18,38,13,84,16,53,94,95,96,99,28]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E,u,d,p,v,S,f,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,P.gracefulify)(T)}catch(t){console.error(`Error enabling graceful-fs: ${(0,s.toErrorMessage)(t)}`)}})();class a extends f.AbstractDiskFileSystemProvider{constructor(r,e){super(r);this.options=e,this.onDidChangeCapabilities=C.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:e,symbolicLink:n}=await c.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(e,n),ctime:e.birthtime.getTime(),mtime:e.mtime.getTime(),size:e.size}}catch(e){throw this.toFileSystemProviderError(e)}}async readdir(r){try{const e=await c.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),n=[];return await Promise.all(e.map(async o=>{try{let h;o.isSymbolicLink()?h=(await this.stat((0,y.joinPath)(r,o.name))).type:h=this.toType(o),n.push([o.name,h])}catch(h){this.logService.trace(h)}})),n}catch(e){throw this.toFileSystemProviderError(e)}}toType(r,e){let n;return e?.dangling?n=u.FileType.Unknown:r.isFile()?n=u.FileType.File:r.isDirectory()?n=u.FileType.Directory:n=u.FileType.Unknown,e&&(n|=u.FileType.SymbolicLink),n}async readFile(r){try{const e=this.toFilePath(r);return await c.Promises.readFile(e)}catch(e){throw this.toFileSystemProviderError(e)}}readFileStream(r,e,n){const o=(0,R.newWriteableStream)(h=>D.VSBuffer.concat(h.map(m=>D.VSBuffer.wrap(m))).buffer);return(0,d.readFileIntoStream)(this,r,o,h=>h.buffer,{...e,bufferSize:256*1024},n),o}async writeFile(r,e,n){let o;try{const h=this.toFilePath(r);if(!n.create||!n.overwrite){if(await c.Promises.exists(h)){if(!n.overwrite)throw(0,u.createFileSystemProviderError)((0,E.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,u.createFileSystemProviderError)((0,E.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(o,0,e,0,e.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(r,h)}finally{typeof o=="number"&&await this.close(o)}}async open(r,e){try{const n=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(e)&&e.unlock)try{const{stat:m}=await c.SymlinkSupport.stat(n);m.mode&128||await c.Promises.chmod(n,m.mode|128)}catch(m){this.logService.trace(m)}let o;if((0,u.isFileOpenForWriteOptions)(e)){if(g.isWindows)try{await c.Promises.truncate(n,0),o="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}o||(o="w")}else o="r";const h=await c.Promises.open(n,o);return this.mapHandleToPos.set(h,0),(0,u.isFileOpenForWriteOptions)(e)&&this.writeHandles.set(h,r),h}catch(n){throw(0,u.isFileOpenForWriteOptions)(e)?await this.toFileSystemProviderWriteError(r,n):this.toFileSystemProviderError(n)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await c.Promises.fdatasync(r)}catch(e){this.canFlush=!1,this.logService.error(e)}return await c.Promises.close(r)}catch(e){throw this.toFileSystemProviderError(e)}}async read(r,e,n,o,h){const m=this.normalizePos(r,e);let L=null;try{const I=await c.Promises.read(r,n,o,h,m);return typeof I=="number"?L=I:L=I.bytesRead,L}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(r,m,L)}}normalizePos(r,e){return e===this.mapHandleToPos.get(r)?null:e}updatePos(r,e,n){const o=this.mapHandleToPos.get(r);typeof o=="number"&&(typeof e=="number"||(typeof n=="number"?this.mapHandleToPos.set(r,o+n):this.mapHandleToPos.delete(r)))}async write(r,e,n,o,h){return(0,b.retry)(()=>this.doWrite(r,e,n,o,h),100,3)}async doWrite(r,e,n,o,h){const m=this.normalizePos(r,e);let L=null;try{const I=await c.Promises.write(r,n,o,h,m);return typeof I=="number"?L=I:L=I.bytesWritten,L}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),I)}finally{this.updatePos(r,m,L)}}async mkdir(r){try{await c.Promises.mkdir(this.toFilePath(r))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(r,e){try{const n=this.toFilePath(r);await this.doDelete(n,e)}catch(n){throw this.toFileSystemProviderError(n)}}async doDelete(r,e){e.recursive?await c.Promises.rm(r,c.RimRafMode.MOVE):await c.Promises.unlink(r)}async rename(r,e,n){const o=this.toFilePath(r),h=this.toFilePath(e);if(o!==h)try{await this.validateTargetDeleted(r,e,"move",n.overwrite),await c.Promises.move(o,h)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,E.localize)(2,null,(0,l.basename)(o),(0,l.basename)((0,l.dirname)(h)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(r,e,n){const o=this.toFilePath(r),h=this.toFilePath(e);if(o!==h)try{await this.validateTargetDeleted(r,e,"copy",n.overwrite),await c.Promises.copy(o,h,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,E.localize)(3,null,(0,l.basename)(o),(0,l.basename)((0,l.dirname)(h)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(r,e,n,o){const h=this.toFilePath(r),m=this.toFilePath(e);let L=!1;if(!!(this.capabilities&1024)||(L=(0,w.isEqual)(h,m,!0)),L&&n==="copy")throw(0,u.createFileSystemProviderError)((0,E.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!L&&await c.Promises.exists(m)){if(!o)throw(0,u.createFileSystemProviderError)((0,E.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(e,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,e,n){let o,h=!1;return this.options?.watcher?.usePolling?h=!1:h=this.options?.legacyWatcher==="on",h?o=v.FileWatcher:o=S.FileWatcher,new o(m=>r(m),m=>e(m),n,this.options?.watcher)}doWatch(r,e){const n=this.options?.watcher?.usePolling;if(n===!0)for(const o of e)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const o of e)n.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,e)}createNonRecursiveWatcher(r,e,n,o){return new p.FileWatcher(r,h=>e(h),h=>n(h),o)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let e;switch(r.code){case"ENOENT":e=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":e=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":e=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":e=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":e=u.FileSystemProviderErrorCode.NoPermissions;break;default:e=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,e)}async toFileSystemProviderWriteError(r,e){let n=this.toFileSystemProviderError(e);if(r&&n.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.toFilePath(r));o.mode&128||(n=(0,u.createFileSystemProviderError)(e,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return n}}i.DiskFileSystemProvider=a}),define(Y[104],Q([0,1,16,15]),function(z,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function b(w,l,g,y,R){try{const c=await new Promise((u,d)=>{z(["spdlog"],u,d)});c.setFlushOn(P.LogLevel.Trace);const E=await c.createAsyncRotatingLogger(w,l,g,y);return R&&E.clearFormatters(),E}catch(c){console.error(c)}return null}function D(w,l,g){switch(l){case P.LogLevel.Trace:w.trace(g);break;case P.LogLevel.Debug:w.debug(g);break;case P.LogLevel.Info:w.info(g);break;case P.LogLevel.Warning:w.warn(g);break;case P.LogLevel.Error:w.error(g);break;case P.LogLevel.Critical:w.critical(g);break;default:throw new Error("Invalid log level")}}class C extends P.AbstractMessageLogger{constructor(l,g,y,R,c){super();this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(l,g,y,R),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(l,g,y,R){const c=y?6:1,E=30/c*T.ByteSize.MB,u=await b(l,g,E,c,R);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:d,message:p}of this.buffer)D(this._logger,d,p);this.buffer=[]}}log(l,g){this._logger?D(this._logger,l,g):this.getLevel()<=l&&this.buffer.push({level:l,message:g})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=C}),define(Y[32],Q([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IProductService=void 0,i.IProductService=(0,T.createDecorator)("productService")}),define(Y[25],Q([0,1,56,11]),function(z,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class b{constructor(){this.data=new Map}add(C,w){T.ok(P.isString(C)),T.ok(P.isObject(w)),T.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,w)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}i.Registry=new b}),define(Y[105],Q([0,1,10,25]),function(z,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function b(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class D{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,g){this.schemasById[b(l)]=g,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new D;P.Registry.add(i.Extensions.JSONContribution,C)}),define(Y[33],Q([0,1,19,10,11,73,105,25]),function(z,i,T,P,b,D,C,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var l;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(l=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var g;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=w.Registry.as(C.Extensions.JSONContribution);class R{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,t=!0){this.registerConfigurations([a],t)}registerConfigurations(a,t=!0){const r=this.doRegisterConfigurations(a,t);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(a){const t=this.doDeregisterConfigurations(a);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(t)}updateConfigurations({add:a,remove:t}){const r=[];r.push(...this.doDeregisterConfigurations(t)),r.push(...this.doRegisterConfigurations(a,!1)),y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,T.distinct)(r))}registerDefaultConfigurations(a){const t=[],r=[];for(const e of a)for(const n in e)if(t.push(n),i.OVERRIDE_PROPERTY_REGEX.test(n)){this.defaultValues[n]={...this.defaultValues[n]||{},...e[n]};const o={type:"object",default:this.defaultValues[n],description:D.localize(1,null,n),$ref:i.resourceLanguageSettingsSchemaId};r.push(...u(n)),this.configurationProperties[n]=o,this.defaultLanguageConfigurationOverridesNode.properties[n]=o}else{this.defaultValues[n]=e[n];const o=this.configurationProperties[n];o&&(this.updatePropertyDefaultValue(n,o),this.updateSchema(n,o))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(t)}deregisterDefaultConfigurations(a){const t=[];for(const r of a)for(const e in r)if(t.push(e),delete this.defaultValues[e],i.OVERRIDE_PROPERTY_REGEX.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const n=this.configurationProperties[e];n&&(this.updatePropertyDefaultValue(e,n),this.updateSchema(e,n))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(t)}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const t of a)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,t){const r=[];return a.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,t,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),r}doDeregisterConfigurations(a){const t=[],r=e=>{if(e.properties)for(const n in e.properties)t.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,e.properties[n]);e.allOf&&e.allOf.forEach(n=>r(n))};for(const e of a){r(e);const n=this.configurationContributors.indexOf(e);n!==-1&&this.configurationContributors.splice(n,1)}return t}validateAndRegisterProperties(a,t=!0,r,e=3){e=b.isUndefinedOrNull(a.scope)?e:a.scope;let n=[],o=a.properties;if(o)for(let m in o){if(t&&S(m)){delete o[m];continue}const L=o[m];if(this.updatePropertyDefaultValue(m,L),i.OVERRIDE_PROPERTY_REGEX.test(m)?L.scope=void 0:(L.scope=b.isUndefinedOrNull(L.scope)?e:L.scope,L.restricted=b.isUndefinedOrNull(L.restricted)?!!r?.restrictedConfigurations?.includes(m):L.restricted),o[m].hasOwnProperty("included")&&!o[m].included){this.excludedConfigurationProperties[m]=o[m],delete o[m];continue}else this.configurationProperties[m]=o[m];!o[m].deprecationMessage&&o[m].markdownDeprecationMessage&&(o[m].deprecationMessage=o[m].markdownDeprecationMessage),n.push(m)}let h=a.allOf;if(h)for(let m of h)n.push(...this.validateAndRegisterProperties(m,t,r,e));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(a){const t=r=>{let e=r.properties;if(e)for(const o in e)this.updateSchema(o,e[o]);let n=r.allOf;n&&n.forEach(t)};t(a)}updateSchema(a,t){switch(i.allSettings.properties[a]=t,t.scope){case 1:i.applicationSettings.properties[a]=t;break;case 2:i.machineSettings.properties[a]=t;break;case 6:i.machineOverridableSettings.properties[a]=t;break;case 3:i.windowSettings.properties[a]=t;break;case 4:i.resourceSettings.properties[a]=t;break;case 5:i.resourceSettings.properties[a]=t,this.resourceLanguageSettingsSchema.properties[a]=t;break}}removeFromSchema(a,t){switch(delete i.allSettings.properties[a],t.scope){case 1:delete i.applicationSettings.properties[a];break;case 2:delete i.machineSettings.properties[a];break;case 6:delete i.machineOverridableSettings.properties[a];break;case 3:delete i.windowSettings.properties[a];break;case 4:case 5:delete i.resourceSettings.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const t=`[${a}]`,r={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,r),i.allSettings.properties[t]=r,i.applicationSettings.properties[t]=r,i.machineSettings.properties[t]=r,i.machineOverridableSettings.properties[t]=r,i.windowSettings.properties[t]=r,i.resourceSettings.properties[t]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,t){let r=this.defaultValues[a];b.isUndefined(r)&&(r=t.default),b.isUndefined(r)&&(r=p(t.type)),t.default=r}}const c="\\[([^\\]]+)\\]",E=new RegExp(c,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function u(s){const a=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let t=E.exec(s);for(;t?.length;){const r=t[1].trim();r&&a.push(r),t=E.exec(s)}}return(0,T.distinct)(a)}i.overrideIdentifiersFromKey=u;function d(s){return s.reduce((a,t)=>`${a}[${t}]`,"")}i.keyFromOverrideIdentifiers=d;function p(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=p;const v=new R;w.Registry.add(i.Extensions.Configuration,v);function S(s){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?D.localize(7,null,s):v.getConfigurationProperties()[s]!==void 0?D.localize(8,null,s):null:D.localize(6,null)}i.validateProperty=S;function f(){const s=[],a=v.getConfigurationProperties();for(const t of Object.keys(a))s.push([t,a[t].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=f}),define(Y[26],Q([0,1,11,8,33,14,25]),function(z,i,T,P,b,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.getDefaultValues=i.getConfigurationKeys=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,D.createDecorator)("configurationService");function w(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof P.URI)}i.isConfigurationOverrides=w;function l(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||T.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof P.URI)}i.isConfigurationUpdateOverrides=l;var g;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(g=i.ConfigurationTarget||(i.ConfigurationTarget={}));function y(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=y;function R(s,a){const t=Object.create(null);for(let r in s)c(t,r,s[r],a);return t}i.toValuesTree=R;function c(s,a,t,r){const e=a.split("."),n=e.pop();let o=s;for(let h=0;h<e.length;h++){let m=e[h],L=o[m];switch(typeof L){case"undefined":L=o[m]=Object.create(null);break;case"object":break;default:r(`Ignoring ${a} as ${e.slice(0,h+1).join(".")} is ${JSON.stringify(L)}`);return}o=L}if(typeof o=="object"&&o!==null)try{o[n]=t}catch(h){r(`Ignoring ${a} as ${e.join(".")} is ${JSON.stringify(o)}`)}else r(`Ignoring ${a} as ${e.join(".")} is ${JSON.stringify(o)}`)}i.addToValueTree=c;function E(s,a){const t=a.split(".");u(s,t)}i.removeFromValueTree=E;function u(s,a){const t=a.shift();if(a.length===0){delete s[t];return}if(Object.keys(s).indexOf(t)!==-1){const r=s[t];typeof r=="object"&&!Array.isArray(r)&&(u(r,a),Object.keys(r).length===0&&delete s[t])}}function d(s,a,t){function r(o,h){let m=o;for(const L of h){if(typeof m!="object"||m===null)return;m=m[L]}return m}const e=a.split("."),n=r(s,e);return typeof n=="undefined"?t:n}i.getConfigurationValue=d;function p(s,a,t){Object.keys(a).forEach(r=>{r!=="__proto__"&&(r in s?T.isObject(s[r])&&T.isObject(a[r])?p(s[r],a[r],t):t&&(s[r]=a[r]):s[r]=a[r])})}i.merge=p;function v(){const s=C.Registry.as(b.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}i.getConfigurationKeys=v;function S(){const s=Object.create(null),a=C.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(let t in a){let r=a[t].default;c(s,t,r,e=>console.error(`Conflict in default settings: ${e}`))}return s}i.getDefaultValues=S;function f(s,a,t){const r=s.inspect(a),e=s.inspect(t);return typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:typeof e.userValue!="undefined"||typeof e.workspaceValue!="undefined"||typeof e.workspaceFolderValue!="undefined"?e.value:r.defaultValue}i.getMigratedSettingValue=f}),define(Y[106],Q([0,1,19,10,57,2,101,21,11,8,26,33,25]),function(z,i,T,P,b,D,C,w,l,g,y,R,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class E{constructor(e={},n=[],o=[]){this._contents=e,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,y.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const o=this.getContentsForOverrideIdentifer(n);return o?e?(0,y.getConfigurationValue)(o,e):o:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const o of this.overrides)o.identifiers.includes(e)&&n.push(...o.keys);return T.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return T.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=w.deepClone(this.contents),o=w.deepClone(this.overrides),h=[...this.keys];for(const m of e){this.mergeContents(n,m.contents);for(const L of m.overrides){const[I]=o.filter(O=>T.equals(O.identifiers,L.identifiers));I?(this.mergeContents(I.contents,L.contents),I.keys.push(...L.keys),I.keys=T.distinct(I.keys)):o.push(w.deepClone(L))}for(const L of m.keys)h.indexOf(L)===-1&&h.push(L)}return new E(n,h,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const h of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let m=this.contents[h],L=n[h];L&&(typeof m=="object"&&typeof L=="object"?(m=w.deepClone(m),this.mergeContents(m,L)):m=L),o[h]=m}return new E(o,this.keys,this.overrides)}mergeContents(e,n){for(const o of Object.keys(n)){if(o in e&&l.isObject(e[o])&&l.isObject(n[o])){this.mergeContents(e[o],n[o]);continue}e[o]=w.deepClone(n[o])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?w.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,o=null;const h=m=>{m&&(o?this.mergeContents(o,m):o=w.deepClone(m))};for(const m of this.overrides)T.equals(m.identifiers,[e])?n=m.contents:m.identifiers.includes(e)&&h(m.contents);return h(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,y.addToValueTree)(this.contents,e,n,o=>{throw new Error(o)})}removeValue(e){this.removeKey(e)&&(0,y.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let o=0;o<n;o++)e.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=E;class u extends E{constructor(){const e=(0,y.getDefaultValues)(),n=(0,y.getConfigurationKeys)(),o=[];for(const h of Object.keys(e))R.OVERRIDE_PROPERTY_REGEX.test(h)&&o.push({identifiers:(0,R.overrideIdentifiersFromKey)(h),keys:Object.keys(e[h]),contents:(0,y.toValuesTree)(e[h],m=>console.error(`Conflict in default settings file: ${m}`))});super(e,n,o)}}i.DefaultConfigurationModel=u;class d{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!l.isUndefinedOrNull(e)){const o=this.doParseContent(e);this.parseRaw(o,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:o,keys:h,overrides:m,restricted:L}=this.doParseRaw(e,n);this._configurationModel=new E(o,h,m),this._restrictedConfigurations=L||[]}doParseContent(e){let n={},o=null,h=[],m=[],L=[];function I(N){Array.isArray(h)?h.push(N):o!==null&&(h[o]=N)}let O={onObjectBegin:()=>{let N={};I(N),m.push(h),h=N,o=null},onObjectProperty:N=>{o=N},onObjectEnd:()=>{h=m.pop()},onArrayBegin:()=>{let N=[];I(N),m.push(h),h=N,o=null},onArrayEnd:()=>{h=m.pop()},onLiteralValue:I,onError:(N,K,te)=>{L.push({error:N,offset:K,length:te})}};if(e)try{b.visit(e,O),n=h[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(e,n){const o=c.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),h=this.filter(e,o,!0,n);e=h.raw;const m=(0,y.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),L=Object.keys(e),I=this.toOverrides(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:m,keys:L,overrides:I,restricted:h.restricted}}filter(e,n,o,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:e,restricted:[]};const m={},L=[];for(let I in e)if(R.OVERRIDE_PROPERTY_REGEX.test(I)&&o){const O=this.filter(e[I],n,!1,h);m[I]=O.raw,L.push(...O.restricted)}else{const O=n[I],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&L.push(I),(N===void 0||h.scopes===void 0||h.scopes.includes(N))&&(h.skipRestricted&&O?.restricted||(m[I]=e[I]))}return{raw:m,restricted:L}}toOverrides(e,n){const o=[];for(const h of Object.keys(e))if(R.OVERRIDE_PROPERTY_REGEX.test(h)){const m={};for(const L in e[h])m[L]=e[h][L];o.push({identifiers:(0,R.overrideIdentifiersFromKey)(h),keys:Object.keys(m),contents:(0,y.toValuesTree)(m,n)})}return o}}i.ConfigurationModelParser=d;class p extends D.Disposable{constructor(e,n,o,h){super();this.userSettingsResource=e,this.scopes=n,this.fileService=h,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,m=>m.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=p;class v{constructor(e,n,o=new E,h=new E,m=new C.ResourceMap,L=new E,I=new C.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=h,this._folderConfigurations=m,this._memoryConfiguration=L,this._memoryConfigurationByResource=I,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(e)}updateValue(e,n,o={}){let h;o.resource?(h=this._memoryConfigurationByResource.get(o.resource),h||(h=new E,this._memoryConfigurationByResource.set(o.resource,h))):h=this._memoryConfiguration,n===void 0?h.removeValue(e):h.setValue(e,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,o){const h=this.getConsolidateConfigurationModel(n,o),m=this.getFolderConfigurationModelForResource(n.resource,o),L=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,I=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),K=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),te=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,de=m?n.overrideIdentifier?m.freeze().override(n.overrideIdentifier).getValue(e):m.freeze().getValue(e):void 0,ce=n.overrideIdentifier?L.override(n.overrideIdentifier).getValue(e):L.getValue(e),ie=h.getValue(e),me=T.distinct(T.flatten(h.overrides.map(j=>j.identifiers))).filter(j=>h.getOverrideValue(e,j)!==void 0);return{defaultValue:I,userValue:O,userLocalValue:N,userRemoteValue:K,workspaceValue:te,workspaceFolderValue:de,memoryValue:ce,value:ie,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:K!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:te!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:de!==void 0?{value:m?.freeze().getValue(e),override:n.overrideIdentifier?m?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:ce!==void 0?{value:L.getValue(e),override:n.overrideIdentifier?L.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:me.length?me:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const o=[];for(const h of n)for(const m of(0,R.overrideIdentifiersFromKey)(h)){const L=this._defaultConfiguration.getKeysForOverrideIdentifier(m),I=e.getKeysForOverrideIdentifier(m),O=[...I.filter(N=>L.indexOf(N)===-1),...L.filter(N=>I.indexOf(N)===-1),...L.filter(N=>!w.equals(this._defaultConfiguration.override(m).getValue(N),e.override(m).getValue(N)))];o.push([m,O])}return this.updateDefaultConfiguration(e),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:o,removed:h,overrides:m}=a(this.localUserConfiguration,e),L=[...n,...o,...h];return L.length&&this.updateLocalUserConfiguration(e),{keys:L,overrides:m}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:o,removed:h,overrides:m}=a(this.remoteUserConfiguration,e);let L=[...n,...o,...h];return L.length&&this.updateRemoteUserConfiguration(e),{keys:L,overrides:m}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:o,removed:h,overrides:m}=a(this.workspaceConfiguration,e);let L=[...n,...o,...h];return L.length&&this.updateWorkspaceConfiguration(e),{keys:L,overrides:m}}compareAndUpdateFolderConfiguration(e,n){const o=this.folderConfigurations.get(e),{added:h,updated:m,removed:L,overrides:I}=a(o,n);let O=[...h,...m,...L];return(O.length||!o)&&this.updateFolderConfiguration(e,n),{keys:O,overrides:I}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:o,updated:h,removed:m,overrides:L}=a(n,void 0);return{keys:[...o,...h,...m],overrides:L}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let o=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?o.override(e.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:e},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const h=n.getFolder(e);h&&(o=this.getFolderConsolidatedConfiguration(h.uri)||o);const m=this._memoryConfigurationByResource.get(e);m&&(o=o.merge(m))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(e);h?(n=o.merge(h),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=o}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const o=n.getFolder(e);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:o,overrides:h,keys:m}=this._folderConfigurations.get(n);return e.push([n,{contents:o,overrides:h,keys:m}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>e.add(o))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>e.add(o))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(e).forEach(h=>n.add(h))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),o=this.parseConfigurationModel(e.user),h=this.parseConfigurationModel(e.workspace),m=e.folders.reduce((L,I)=>(L.set(g.URI.revive(I[0]),this.parseConfigurationModel(I[1])),L),new C.ResourceMap);return new v(n,o,new E,h,m,new E,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new E(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=v;function S(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,n=new Map;for(const h of r)h.keys.forEach(m=>e.add(m)),h.overrides.forEach(([m,L])=>{const I=(0,C.getOrSet)(n,m,new Set);L.forEach(O=>I.add(O))});const o=[];return n.forEach((h,m)=>o.push([m,[...h.values()]])),{keys:[...e.values()],overrides:o}}i.mergeChanges=S;class f{constructor(e,n,o,h){this.change=e,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=h,this._previousConfiguration=void 0;const m=new Set;e.keys.forEach(I=>m.add(I)),e.overrides.forEach(([,I])=>I.forEach(O=>m.add(O))),this.affectedKeys=[...m.values()];const L=new E;this.affectedKeys.forEach(I=>L.setValue(I,{})),this.affectedKeysTree=L.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!w.equals(o,h)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let o=(0,y.toValuesTree)({[n]:!0},()=>{}),h;for(;typeof o=="object"&&(h=Object.keys(o)[0]);){if(e=e[h],!e)return!1;o=o[h]}return!0}}i.ConfigurationChangeEvent=f;class s extends f{constructor(e,n,o,h){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=o,this.sourceConfig=h}}i.AllKeysConfigurationChangeEvent=s;function a(r,e){const{added:n,removed:o,updated:h}=t(e,r),m=[],L=r?.getAllOverrideIdentifiers()||[],I=e?.getAllOverrideIdentifiers()||[];if(e){const O=I.filter(N=>!L.includes(N));for(const N of O)m.push([N,e.getKeysForOverrideIdentifier(N)])}if(r){const O=L.filter(N=>!I.includes(N));for(const N of O)m.push([N,r.getKeysForOverrideIdentifier(N)])}if(e&&r){for(const O of L)if(I.includes(O)){const N=t({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:e.getOverrideValue(void 0,O)||{},keys:e.getKeysForOverrideIdentifier(O)});m.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:o,updated:h,overrides:m}}function t(r,e){const n=r?e?r.keys.filter(m=>e.keys.indexOf(m)===-1):[...r.keys]:[],o=e?r?e.keys.filter(m=>r.keys.indexOf(m)===-1):[...e.keys]:[],h=[];if(r&&e){for(const m of e.keys)if(r.keys.indexOf(m)!==-1){const L=(0,y.getConfigurationValue)(e.contents,m),I=(0,y.getConfigurationValue)(r.contents,m);w.equals(L,I)||h.push(m)}}return{added:n,removed:o,updated:h}}}),define(Y[107],Q([0,1,3,10,2,18,26,106,33,25]),function(z,i,T,P,b,D,C,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class y extends b.Disposable{constructor(c,E){super();this.settingsResource=c,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,E)),this.configuration=new w.Configuration(new w.DefaultConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const c=await this.userConfiguration.loadConfiguration();this.configuration=new w.Configuration(new w.DefaultConfigurationModel,c)}getConfigurationData(){return this.configuration.toData()}getValue(c,E){const u=typeof c=="string"?c:void 0,d=(0,C.isConfigurationOverrides)(c)?c:(0,C.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(u,d,void 0)}updateValue(c,E,u,d){return Promise.reject(new Error("not supported"))}inspect(c){return this.configuration.inspect(c,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const c=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(c)}onDidChangeUserConfiguration(c){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(c);this.trigger(u,E,1)}onDidDefaultConfigurationChange(c){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new w.DefaultConfigurationModel,c);this.trigger(u,E,6)}trigger(c,E,u){const d=new w.ConfigurationChangeEvent(c,{data:E},this.configuration);d.source=u,d.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(c){switch(c){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=y}),define(Y[108],Q([0,1,9]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isVirtualWorkspace=i.getVirtualWorkspaceScheme=i.getVirtualWorkspaceLocation=i.isVirtualResource=i.getRemoteName=i.getRemoteAuthority=void 0;function P(g){return g.scheme===T.Schemas.vscodeRemote?g.authority:void 0}i.getRemoteAuthority=P;function b(g){if(!g)return;const y=g.indexOf("+");return y<0?g:g.substr(0,y)}i.getRemoteName=b;function D(g){return g.scheme!==T.Schemas.file&&g.scheme!==T.Schemas.vscodeRemote}i.isVirtualResource=D;function C(g){if(g.folders.length)return g.folders.every(y=>D(y.uri))?g.folders[0].uri:void 0;if(g.configuration&&D(g.configuration))return g.configuration}i.getVirtualWorkspaceLocation=C;function w(g){return C(g)?.scheme}i.getVirtualWorkspaceScheme=w;function l(g){return C(g)!==void 0}i.isVirtualWorkspace=l}),define(Y[42],Q([0,1,27,14,108]),function(z,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}i.getWorkspaceSupportTypeMessage=D;function C(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}i.isIExtensionIdentifier=C,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(w=i.ExtensionType||(i.ExtensionType={}));class l{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,u){if(typeof E=="undefined"||E===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof E=="string"||typeof u=="string"){let d=typeof E=="string"?E:E.value,p=typeof u=="string"?u:u.value;return T.equalsIgnoreCase(d,p)}return E._lower===u._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}i.ExtensionIdentifier=l;function g(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}i.isLanguagePackExtension=g;function y(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=y;function R(c,E){if(E){const u=`onResolveRemoteAuthority:${(0,b.getRemoteName)(E)}`;return c.activationEvents?.indexOf(u)!==-1}return!1}i.isResolverExtension=R,i.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[23],Q([0,1,27,42]),function(z,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function b(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,T.compareIgnoreCase)(u.id,d.id)===0}i.areSameExtensions=b;class D{constructor(d,p){this.version=p,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof D?b(this,d)&&this.version===d.version:!1}}i.ExtensionIdentifierWithVersion=D;function C(u,d){return`${u}.${d}`}i.getExtensionId=C;function w(u){return u.toLocaleLowerCase()}i.adoptToGalleryExtensionId=w;function l(u,d){return w(C(u,d))}i.getGalleryExtensionId=l;function g(u,d){const p=[],v=S=>{for(const f of p)if(f.some(s=>b(d(s),d(S))))return f;return null};for(const S of u){const f=v(S);f?f.push(S):p.push([S])}return p}i.groupByExtension=g;function y(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=y;function R(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}i.getGalleryExtensionTelemetryData=R,i.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function c(u){const d=new Set;for(const p of u)p.malicious&&d.add(p.id.id);return d}i.getMaliciousExtensionsSet=c;function E(u,d){const p=[],v=d.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const S=v.shift();if(S&&p.every(f=>!b(f.identifier,{id:S}))){const f=u.filter(s=>b(s.identifier,{id:S}));f.length===1&&(p.push(f[0]),v.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}i.getExtensionDependencies=E}),define(Y[109],Q([0,1,24,7,62,9,43,8,77,22,23,42]),function(z,i,T,P,b,D,C,w,l,g,y,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=i.getIdAndVersion=void 0;const c=S=>(0,l.localize)(0,null,S),E=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(S,f){return f?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}const d=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function p(S){const f=d.exec(S);return f&&f[1]?[(0,y.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,y.adoptToGalleryExtensionId)(S),void 0]}i.getIdAndVersion=p;let v=class{constructor(f,s){this.extensionManagementService=f,this.extensionGalleryService=s}get location(){}async listExtensions(f,s,a=console){let t=await this.extensionManagementService.getInstalled(1);const r=R.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(s&&s!==""){if(r.indexOf(s.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}t=t.filter(n=>n.manifest.categories?n.manifest.categories.map(h=>h.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){a.log("Possible Categories: "),r.forEach(n=>{a.log(n)});return}this.location&&a.log((0,l.localize)(2,null,this.location)),t=t.sort((n,o)=>n.identifier.id.localeCompare(o.identifier.id));let e;for(let n of t)e!==n.identifier.id&&(e=n.identifier.id,a.log(u(n.manifest,f)))}async installExtensions(f,s,a,t,r=console){const e=[],n=[];f.length&&r.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const o=await this.extensionManagementService.getInstalled(1),h=(I,O)=>{const N=o.find(K=>(0,y.areSameExtensions)(K.identifier,{id:I}));if(N){if(!O&&!t)return r.log((0,l.localize)(5,null,I,N.manifest.version,I)),!1;if(O&&N.manifest.version===O)return r.log((0,l.localize)(6,null,`${I}@${O}`)),!1}return!0},m=[],L=[];for(const I of f)if(I instanceof w.URI)m.push(I);else{const[O,N]=p(I);h(O,N)&&L.push({id:O,version:N,installOptions:{isBuiltin:!1,isMachineScoped:a}})}for(const I of s){const[O,N]=p(I);h(O,N)&&L.push({id:O,version:N,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(m.length&&await Promise.all(m.map(async I=>{try{const O=await this.installVSIX(I,{isBuiltin:!1,isMachineScoped:a},t,r);O&&n.push(O)}catch(O){r.error(O.message||O.stack||O),e.push(I.toString())}})),L.length){const I=await this.getGalleryExtensions(L);await Promise.all(L.map(async O=>{const N=I.get(O.id.toLowerCase());if(N)try{const K=await this.installFromGallery(O,N,o,t,r);K&&n.push(K)}catch(K){r.error(K.message||K.stack||K),e.push(O.id)}else r.error(`${c(O.version?`${O.id}@${O.version}`:O.id)}
${E}`),e.push(O.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(f,s,a,t){const r=await this.extensionManagementService.getManifest(f);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,a,t))try{return await this.extensionManagementService.install(f,s),t.log((0,l.localize)(8,null,(0,b.getBaseLabel)(f))),r}catch(n){if((0,P.isPromiseCanceledError)(n))return t.log((0,l.localize)(9,null,(0,b.getBaseLabel)(f))),null;throw n}return null}async getGalleryExtensions(f){const s=new Map,a=await this.extensionGalleryService.getExtensions(f,T.CancellationToken.None);for(const t of a)s.set(t.identifier.id.toLowerCase(),t);return s}async installFromGallery({id:f,version:s,installOptions:a},t,r,e,n){const o=await this.extensionGalleryService.getManifest(t,T.CancellationToken.None);if(o&&!this.validateExtensionKind(o,n))return null;const h=r.find(m=>(0,y.areSameExtensions)(m.identifier,t.identifier));if(h){if(t.version===h.manifest.version)return n.log((0,l.localize)(10,null,s?`${f}@${s}`:f)),null;n.log((0,l.localize)(11,null,f,t.version))}try{return a.isBuiltin?n.log(s?(0,l.localize)(12,null,f,s):(0,l.localize)(13,null,f)):n.log(s?(0,l.localize)(14,null,f,s):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(t,{...a,installGivenVersion:!!s}),n.log((0,l.localize)(16,null,f,t.version)),o}catch(m){if((0,P.isPromiseCanceledError)(m))return n.log((0,l.localize)(17,null,f)),null;throw m}}validateExtensionKind(f,s){return!0}async validateVSIX(f,s,a){const t={id:(0,y.getGalleryExtensionId)(f.publisher,f.name)},e=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,y.areSameExtensions)(t,n.identifier)&&(0,C.gt)(n.manifest.version,f.version));return e&&!s?(a.log((0,l.localize)(18,null,e.identifier.id,e.manifest.version,f.version)),!1):this.validateExtensionKind(f,a)}async uninstallExtensions(f,s,a=console){const t=async e=>{if(e instanceof w.URI){const n=await this.extensionManagementService.getManifest(e);return u(n)}return e},r=[];for(const e of f){const n=await t(e),h=(await this.extensionManagementService.getInstalled()).filter(m=>(0,y.areSameExtensions)(m.identifier,{id:n}));if(!h.length)throw new Error(`${this.notInstalled(n)}
${E}`);if(h.some(m=>m.type===0)){a.log((0,l.localize)(19,null,n));return}if(!s&&h.some(m=>m.isBuiltin)){a.log((0,l.localize)(20,null,n));return}a.log((0,l.localize)(21,null,n));for(const m of h)await this.extensionManagementService.uninstall(m),r.push(m);this.location?a.log((0,l.localize)(22,null,n,this.location)):a.log((0,l.localize)(23,null,n))}}async locateExtension(f,s=console){const a=await this.extensionManagementService.getInstalled();f.forEach(t=>{a.forEach(r=>{if(r.identifier.id===t&&r.location.scheme===D.Schemas.file){s.log(r.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};v=pe([se(0,g.IExtensionManagementService),se(1,g.IExtensionGalleryService)],v),i.ExtensionManagementCLIService=v}),define(Y[110],Q([0,1,3,7,2,12,18,43,8,31,13,20,22,23,16,15]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E,u,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends b.Disposable{constructor(f,s,a,t){super();this.fileService=s,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=l.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const a=this.getName(f),t=(0,C.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=(0,C.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(f,r,s);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(r)}catch(n){}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,r.path),e}}return t}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,s,a){try{await y.Promises.rename(f.fsPath,s.fsPath)}catch(t){if(D.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],a=[];for(const e of f.children){const n=this.parse(e.name);n&&a.push([n,e])}const t=(0,E.groupByExtension)(a,([e])=>e),r=[];for(const e of t)e.sort((n,o)=>w.rcompare(n[0].version,o[0].version)),s.push(...e.slice(1).map(n=>n[1].resource)),r.push(e[0][1]);r.sort((e,n)=>e.mtime-n.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await T.Promises.settled(s.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new E.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(f){const s=p.exec(f);return s&&s[1]&&s[2]?new E.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};v=pe([se(0,R.INativeEnvironmentService),se(1,u.IFileService),se(2,c.IExtensionGalleryService),se(3,d.ILogService)],v),i.ExtensionsDownloader=v}),define(Y[111],Q([0,1,2,6,13,42]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class C extends T.Disposable{constructor(l,g){super();this.environmentService=l,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(g.onDidUninstallExtension(y=>this.onDidUnInstallExtension(y)))}onDidInstallExtensions(l){l.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=C}),define(Y[112],Q([0,1,137,19,3,2,9,6,13,20,22,23,55,15]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let u=class extends D.Disposable{constructor(v,S,f){super();this.extensionManagementService=v,this.logService=f,this.cache=this._register(new d(S,f)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const v=await this.cache.getLanguagePacks(),S=["en",...Object.keys(v)];return(0,P.distinct)(S)}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const S=await this.cache.getLanguagePacks();Object.keys(S).some(f=>S[f]&&S[f].extensions.some(s=>(0,R.areSameExtensions)(s.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,S]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(S);return!(0,P.equals)(Object.keys(v),Object.keys(f))}};u=pe([se(0,y.IExtensionManagementService),se(1,g.INativeEnvironmentService),se(2,E.ILogService)],u),i.LocalizationsService=u;let d=class extends D.Disposable{constructor(v,S){super();this.logService=S,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(S=>{Object.keys(S).forEach(f=>delete S[f]),this.createLanguagePacksFromExtensions(S,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...S){for(const f of S)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,f);Object.keys(v).forEach(f=>this.updateHash(v[f]))}createLanguagePacksFromExtension(v,S){const f=S.identifier,s=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const a of s)if(S.location.scheme===C.Schemas.file&&(0,c.isValidLocalization)(a)){let t=v[a.languageId];t||(t={hash:"",extensions:[],translations:{}},v[a.languageId]=t);let r=t.extensions.filter(e=>(0,R.areSameExtensions)(e.extensionIdentifier,f))[0];r?r.version=S.manifest.version:t.extensions.push({extensionIdentifier:f,version:S.manifest.version});for(const e of a.translations)t.translations[e.id]=(0,w.join)(S.location.fsPath,e.path)}}updateHash(v){if(v){const S=(0,T.createHash)("md5");for(const f of v.extensions)S.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);v.hash=S.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let S=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(s){return{}}}).then(f=>(S=v(f),f)).then(f=>{for(const a of Object.keys(f))f[a]||delete f[a];this.languagePacks=f,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),l.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>S,f=>this.logService.error(f))})}};d=pe([se(0,g.INativeEnvironmentService),se(1,E.ILogService)],d)}),define(Y[44],Q([0,1,17,85,33,14,25]),function(z,i,T,P,b,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,D.createDecorator)("requestService");function w(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}i.isSuccess=w;function l(u){return u.res.statusCode===204}async function g(u){if(!w(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,T.streamToBuffer)(u.stream)).toString()}i.asText=g;async function y(u){if(!w(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const p=(await(0,T.streamToBuffer)(u.stream)).toString();try{return JSON.parse(p)}catch(v){throw v.message+=`:
`+p,v}}i.asJson=y;function R(u){E(u)}i.updateProxyConfigurationsScope=R;let c;function E(u){const d=C.Registry.as(b.Extensions.Configuration),p=c;c={id:"http",order:15,title:(0,P.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(4,null),(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],default:"override",description:(0,P.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[c],remove:p?[p]:[]})}E(2)}),define(Y[113],Q([0,1,24,9,16,44]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let C=class{constructor(l,g){this.requestService=l,this.fileService=g}async download(l,g,y=T.CancellationToken.None){if(l.scheme===P.Schemas.file||l.scheme===P.Schemas.vscodeRemote){await this.fileService.copy(l,g);return}const R={type:"GET",url:l.toString()},c=await this.requestService.request(R,y);if(c.res.statusCode===200)await this.fileService.writeFile(g,c.stream);else{const E=await(0,D.asText)(c);throw new Error(`Expected 200, got back ${c.res.statusCode} instead.

${E}`)}}};C=pe([se(0,D.IRequestService),se(1,b.IFileService)],C),i.DownloadService=C}),define(Y[114],Q([0,1,115,11]),function(z,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function b(C,w){return C.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:C.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function D(C,w,l={}){const g=(0,T.parse)(C),y=l.proxyUrl||b(g,w);if(!y)return null;const R=(0,T.parse)(y);if(!/^https?:$/.test(R.protocol||""))return null;const c={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,P.isBoolean)(l.strictSSL)?l.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((E,u)=>{z(["http-proxy-agent"],E,u)}))(c):new(await new Promise((E,u)=>{z(["https-proxy-agent"],E,u)}))(c)}i.getProxyAgent=D}),define(Y[116],Q([0,1,17,31]),function(z,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function b(D,C,w){let l=w&&w.get("storage.serviceMachineId",0)||null;if(l)return l;try{const y=(await C.readFile(D.serviceMachineIdResource)).value.toString();l=(0,P.isUUID)(y)?y:null}catch(g){l=null}if(!l){l=(0,P.generateUuid)();try{await C.writeFile(D.serviceMachineIdResource,T.VSBuffer.fromString(l))}catch(g){}}return w&&w.store("storage.serviceMachineId",l,0,1),l}i.getServiceMachineId=b}),define(Y[117],Q([0,1,3,10,2,102,11,66,14]),function(z,i,T,P,b,D,C,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";i.IStorageService=(0,l.createDecorator)("storageService");var y;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(y=i.WillSaveStateReason||(i.WillSaveStateReason={}));var R;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(R=i.StorageScope||(i.StorageScope={}));var c;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(c=i.StorageTarget||(i.StorageTarget={}));class E extends b.Disposable{constructor(v={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,S){S===g?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:S,target:this.getKeyTargets(v)[S]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,S,f){return this.getStorage(S)?.get(v,f)}getBoolean(v,S,f){return this.getStorage(S)?.getBoolean(v,f)}getNumber(v,S,f){return this.getStorage(S)?.getNumber(v,f)}store(v,S,f,s){if((0,C.isUndefinedOrNull)(S)){this.remove(v,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,f,s),this.getStorage(f)?.set(v,S)})}remove(v,S){this.withPausedEmitters(()=>{this.updateKeyTarget(v,S,void 0),this.getStorage(S)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,S){const f=[],s=this.getKeyTargets(v);for(const a of Object.keys(s))s[a]===S&&f.push(a);return f}updateKeyTarget(v,S,f){const s=this.getKeyTargets(S);typeof f=="number"?s[v]!==f&&(s[v]=f,this.getStorage(S)?.set(g,JSON.stringify(s))):typeof s[v]=="number"&&(delete s[v],this.getStorage(S)?.set(g,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const S=this.get(g,v);if(S)try{return JSON.parse(S)}catch(f){}return Object.create(null)}isNew(v){return this.getBoolean(i.IS_NEW_KEY,v)===!0}async flush(v=y.NONE){this._onWillSaveState.fire({reason:v});const S=this.getStorage(0),f=this.getStorage(1);switch(v){case y.NONE:await T.Promises.settled([S?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await T.Promises.settled([S?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return d(v,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends E{constructor(){super();this.globalStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}i.InMemoryStorageService=u;async function d(p,v,S,f){const s=h=>{try{return JSON.parse(h)}catch(m){return h}},a=new Map,t=new Map;p.forEach((h,m)=>{a.set(m,h),t.set(m,s(h))});const r=new Map,e=new Map;v.forEach((h,m)=>{r.set(m,h),e.set(m,s(h))}),console.group(`Storage: Global (path: ${S})`);let n=[];a.forEach((h,m)=>{n.push({key:m,value:h})}),console.table(n),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${f})`);let o=[];r.forEach((h,m)=>{o.push({key:m,value:h})}),console.table(o),console.groupEnd(),console.log(e)}i.logStorage=d}),define(Y[118],Q([0,1,12,29,8,31]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function C(g){if(T.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function w(g,y,R,c,E,u,d,p,v,S){const f=Object.create(null);f["common.machineId"]=d,f.sessionID=(0,D.generateUuid)()+Date.now(),f.commitHash=E,f.version=u,f["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,T.PlatformToString)(T.platform),f["common.nodePlatform"]=P.platform,f["common.nodeArch"]=c,f["common.product"]=S||"desktop";const s=l(p||[]);s&&(f["common.msftInternal"]=s);let a=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),T.isLinuxSnap&&(f["common.snap"]="true");const r=C(R);r&&(f["common.platformDetail"]=r);try{const e=await g.readFile(b.URI.file(v));f["common.source"]=e.value.toString().slice(0,30)}catch(e){}return f}i.resolveCommonProperties=w;function l(g){const y=P.env.USERDNSDOMAIN;if(!y)return!1;const R=y.toLowerCase();return g.some(c=>R===c)}i.verifyMicrosoftInternalDomain=l}),define(Y[30],Q([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,T.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(P=i.TelemetryLevel||(i.TelemetryLevel={}));var b;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(b=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Y[119],Q([0,1,19,3,24,7,10,2,12,8,75,22,23,15,32,30]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E,u,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let p=class extends w.Disposable{constructor(t,r,e,n){super();this.galleryService=t,this.telemetryService=r,this.logService=e,this.productService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new C.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new C.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new C.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new C.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(e=>(0,R.isTargetPlatformCompatible)(e,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new R.ExtensionManagementError(y.localize(0,null),R.ExtensionManagementErrorCode.Internal);const e=await this.checkAndGetCompatibleVersion(t,!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(e.manifest,e.extension,r)}catch(e){throw f(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(t),void 0,e),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(e),S(e)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.unininstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(y.localize(1,null));const r=await this.findGalleryExtension(t);if(!r)throw new Error(y.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(r)}getExtensionsReport(){const t=new Date().getTime();return(!this.reportedExtensions||t-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=t),this.reportedExtensions}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,e){if(!g.URI.isUri(r)){let L=this.installingExtensions.get(new c.ExtensionIdentifierWithVersion(r.identifier,r.version).key());if(L)return this.logService.info("Extensions is already requested to install",r.identifier.id),L.waitUntilTaskIsFinished();e={...e,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],o=[],h=this.createInstallExtensionTask(t,r,e);g.URI.isUri(r)||this.installingExtensions.set(new c.ExtensionIdentifierWithVersion(h.identifier,t.version).key(),h),this._onInstallExtension.fire({identifier:h.identifier,source:r}),this.logService.info("Installing extension:",h.identifier.id),n.push({task:h,manifest:t});let m=!1;try{if(e.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",h.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(h.identifier,t,!!e.installOnlyNewlyAddedFromExtensionPack,!!e.installPreReleaseVersion);for(const{gallery:O,manifest:N}of I)if(m=m||!!N.extensionDependencies?.some(K=>(0,c.areSameExtensions)({id:K},h.identifier)),this.installingExtensions.has(new c.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const K=this.createInstallExtensionTask(N,O,{...e,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new c.ExtensionIdentifierWithVersion(K.identifier,N.version).key(),K),this._onInstallExtension.fire({identifier:K.identifier,source:O}),this.logService.info("Installing extension:",K.identifier.id),n.push({task:K,manifest:N})}}catch(I){if(g.URI.isUri(h.source))(0,T.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",h.identifier.id,I.message),(0,T.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",h.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",h.identifier.id),I}const L=n.reduce((I,{task:O,manifest:N})=>(I.set(O.identifier.id.toLowerCase(),{task:O,manifest:N}),I),new Map);for(;L.size;){let I;const O=[...L.values()].filter(({manifest:N})=>!N.extensionDependencies?.some(K=>L.has(K.toLowerCase())));O.length?I=L.size===1?O:O.filter(({task:N})=>!(N===h&&!m)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:N})=>N.identifier.id)),I=[...L.values()]),await this.joinAllSettled(I.map(async({task:N})=>{const K=new Date().getTime();try{const te=await N.run();if(await this.joinAllSettled(this.participants.map(de=>de.postInstall(te,N.source,e,b.CancellationToken.None))),!g.URI.isUri(N.source)&&(f(this.telemetryService,N.operation===2?"extensionGallery:update":"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(N.source),new Date().getTime()-K,void 0),l.isWeb&&N.operation===1))try{await this.galleryService.reportStatistic(te.manifest.publisher,te.manifest.name,te.manifest.version,"install")}catch(de){}o.push({local:te,identifier:N.identifier,operation:N.operation,source:N.source})}catch(te){throw g.URI.isUri(N.source)||f(this.telemetryService,N.operation===2?"extensionGallery:update":"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(N.source),new Date().getTime()-K,te),this.logService.error("Error while installing the extension:",N.identifier.id),te}finally{L.delete(N.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,c.areSameExtensions)(I,h.identifier))[0].local}catch(L){if(n.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<I.length;O++){const N=I[O],{identifier:K}=o[O];N.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",K.id):this.logService.warn("Rollback: Error while uninstalling extension",K.id,(0,D.getErrorMessage)(N.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(I),o.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(n.map(({task:I})=>({identifier:I.identifier,operation:1,source:I.source}))),L}finally{for(const{task:L,manifest:I}of n)if(!g.URI.isUri(L.source)){const O=new c.ExtensionIdentifierWithVersion(L.identifier,I.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(t){const r=[],e=[],n=await Promise.allSettled(t);for(const o of n)o.status==="fulfilled"?r.push(o.value):e.push(o.reason);if(e.length)throw v(e);return r}async getAllDepsAndPackExtensionsToInstall(t,r,e,n){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const h=[t,...o.map(I=>I.identifier)],m=[],L=async(I,O)=>{const N=O.extensionDependencies||[],K=[...N];if(O.extensionPack){const te=e?o.find(de=>(0,c.areSameExtensions)(de.identifier,I)):void 0;for(const de of O.extensionPack)te&&te.manifest.extensionPack&&te.manifest.extensionPack.some(ce=>(0,c.areSameExtensions)({id:ce},{id:de}))||K.every(ce=>!(0,c.areSameExtensions)({id:ce},{id:de}))&&K.push(de)}if(K.length){const te=[...h,...m.map(ce=>ce.gallery.identifier)],de=K.filter(ce=>te.every(ie=>!(0,c.areSameExtensions)(ie,{id:ce})));if(de.length){const ce=await this.galleryService.query({names:de,pageSize:K.length},b.CancellationToken.None);for(const ie of ce.firstPage){if(te.find(B=>(0,c.areSameExtensions)(B,ie.identifier)))continue;const me=N.some(B=>(0,c.areSameExtensions)({id:B},ie.identifier));let j;try{j=await this.checkAndGetCompatibleVersion(ie,!0,n)}catch(B){if(B instanceof R.ExtensionManagementError&&B.code===R.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!me){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}else throw B}m.push({gallery:j.extension,manifest:j.manifest}),await L(j.extension.identifier,O)}}}};return await L(t,r),o=await this.getInstalled(),m.filter(I=>!o.some(O=>(0,c.areSameExtensions)(O.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(t,r,e){if(await this.isMalicious(t))throw new R.ExtensionManagementError(y.localize(3,null,t.identifier.id),R.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const h=await this.getTargetPlatform();throw new R.ExtensionManagementError(y.localize(4,null,t.identifier.id,this.productService.nameLong,(0,R.TargetPlatformToString)(h)),R.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const n=await this.getCompatibleVersion(t,r,e);if(n){if(e&&t.hasPreReleaseVersion&&!n.properties.isPreReleaseVersion)throw new R.ExtensionManagementError(y.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new R.ExtensionManagementError(y.localize(6,null,t.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.Incompatible);const o=await this.galleryService.getManifest(n,b.CancellationToken.None);if(o===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,R.ExtensionManagementErrorCode.Invalid);if(o.version!==n.version)throw new R.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,R.ExtensionManagementErrorCode.Invalid);return{extension:n,manifest:o}}async getCompatibleVersion(t,r,e){const n=await this.getTargetPlatform();let o=null;return r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==e&&(o=await this.galleryService.getCompatibleExtension(t.identifier,e,n)),!o&&await this.galleryService.isExtensionCompatible(t,e,n)&&(o=t),!o&&r&&(o=await this.galleryService.getCompatibleExtension(t,e,n)),o}async isMalicious(t){const r=await this.getExtensionsReport();return(0,c.getMaliciousExtensionsSet)(r).has(t.identifier.id)}async unininstallExtension(t,r){const e=this.uninstallingExtensions.get(t.identifier.id.toLowerCase());if(e)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),e.waitUntilTaskIsFinished();const n=(L,I)=>{const O=this.createUninstallExtensionTask(L,I);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",L.identifier.id),this._onUninstallExtension.fire(L.identifier),O},o=(L,I)=>{I?this.logService.error("Failed to uninstall extension:",L.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",L.identifier.id),f(this.telemetryService,"extensionGallery:uninstall",(0,c.getLocalExtensionTelemetryData)(L),void 0,I),this._onDidUninstallExtension.fire({identifier:L.identifier,error:I?.code})},h=[],m=[];try{h.push(n(t,{}));const L=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",t.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(t,L);for(const O of I)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):h.push(n(O,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",t.identifier.id):this.checkForDependents(h.map(I=>I.extension),L,t),await this.joinAllSettled(h.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(I.extension,r,b.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch(O){}o(I.extension)}catch(O){const N=O instanceof R.ExtensionManagementError?O:new R.ExtensionManagementError((0,D.getErrorMessage)(O),R.ExtensionManagementErrorCode.Internal);throw o(I.extension,N),N}finally{m.push(I)}}))}catch(L){const I=L instanceof R.ExtensionManagementError?L:new R.ExtensionManagementError((0,D.getErrorMessage)(L),R.ExtensionManagementErrorCode.Internal);for(const O of h){try{O.cancel()}catch(N){}m.includes(O)||o(O.extension,I)}throw I}finally{for(const L of h)this.uninstallingExtensions.delete(L.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",L.extension.identifier.id)}}checkForDependents(t,r,e){for(const n of t){const o=this.getDependents(n,r);if(o.length){const h=o.filter(m=>!t.some(L=>(0,c.areSameExtensions)(L.identifier,m.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(n,h,e))}}}getDependentsErrorMessage(t,r,e){return e===t?r.length===1?y.localize(7,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(8,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(9,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?y.localize(10,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(11,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(12,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,e=[]){if(e.indexOf(t)!==-1)return[];e.push(t);const n=t.manifest.extensionPack?t.manifest.extensionPack:[];if(n.length){const o=r.filter(m=>!m.isBuiltin&&n.some(L=>(0,c.areSameExtensions)({id:L},m.identifier))),h=[];for(const m of o)h.push(...this.getAllPackExtensionsToUninstall(m,r,e));return[...o,...h]}return[]}getDependents(t,r){return r.filter(e=>e.manifest.extensionDependencies&&e.manifest.extensionDependencies.some(n=>(0,c.areSameExtensions)({id:n},t.identifier)))}async findGalleryExtension(t){if(t.identifier.uuid){const r=await this.findGalleryExtensionById(t.identifier.uuid);return r||this.findGalleryExtensionByName(t.identifier.id)}return this.findGalleryExtensionByName(t.identifier.id)}async findGalleryExtensionById(t){return(await this.galleryService.query({ids:[t],pageSize:1},b.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(t){return(await this.galleryService.query({names:[t],pageSize:1},b.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${t.length} reported extensions from service`),t}catch(t){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};p=pe([se(0,R.IExtensionGalleryService),se(1,d.ITelemetryService),se(2,E.ILogService),se(3,u.IProductService)],p),i.AbstractExtensionManagementService=p;function v(a){const t=Array.isArray(a)?a:[a];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,e)=>new Error(`${r.message}${r.message?",":""}${e instanceof Error?e.message:e}`),new Error(""))}i.joinErrors=v;function S(a){if(a instanceof R.ExtensionManagementError)return a;const t=new R.ExtensionManagementError(a.message,R.ExtensionManagementErrorCode.Internal);return t.stack=a.stack,t}function f(a,t,r,e,n){const o=n?n instanceof R.ExtensionManagementError?n.code:R.ExtensionManagementErrorCode.Internal:void 0;a.publicLogError(t,{...r,success:!n,duration:e,errorcode:o})}i.reportTelemetry=f;class s{constructor(){this.barrier=new P.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(t=>new Promise((r,e)=>{const n=t.onCancellationRequested(()=>{n.dispose(),e((0,D.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=s}),define(Y[36],Q([0,1,21,11,26,30]),function(z,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,S){return Promise.resolve(void 0)}publicLog2(v,S){return this.publicLog(v,S)}publicLogError(v,S){return Promise.resolve(void 0)}publicLogError2(v,S){return this.publicLogError(v,S)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=C,i.NullTelemetryService=new C;class w{async publicLog(v,S,f){}async publicLogError(v,S,f){}}i.NullEndpointTelemetryService=w,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(p,v){return v.onDidChangeConfiguration(S=>{S.source!==6&&p.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(S.source),configurationKeys:u(S.sourceConfig)})})}i.configurationTelemetry=l;function g(p,v){return!(v.disableTelemetry||!p.enableTelemetry)}i.supportsTelemetry=g;function y(p){const v=p.getValue(D.TELEMETRY_SETTING_ID),S=p.getValue("telemetry.enableCrashReporter");if(p.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||S===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=y;function R(p){const v=Object.create(null),S=Object.create(null),f=Object.create(null);E(p,f);for(let s in f){s=s.length>150?s.substr(s.length-149):s;const a=f[s];typeof a=="number"?S[s]=a:typeof a=="boolean"?S[s]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${a.length}`),v[s]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(v[s]=a)}return{properties:v,measurements:S}}i.validateTelemetryData=R;function c(p){if(!p)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{p.indexOf(`${f}+`)===0&&(v=f)}),v}i.cleanRemoteAuthority=c;function E(p,v,S=0,f){if(!!p)for(let s of Object.getOwnPropertyNames(p)){const a=p[s],t=f?f+s:s;Array.isArray(a)?v[t]=(0,T.safeStringify)(a):a instanceof Date?v[t]=a.toISOString():(0,P.isObject)(a)?S<2?E(a,v,S+1,t+"."):v[t]=(0,T.safeStringify)(a):v[t]=a}}function u(p){if(!p)return[];const v=[];return d(v,"",p),v}function d(p,v,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(f=>d(p,v?`${v}.${f}`:f,S[f])):p.push(v)}}),define(Y[120],Q([0,1,19,24,7,21,12,29,11,8,26,20,22,23,51,16,15,32,44,116,117,30,36]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E,u,d,p,v,S,f,s,a,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const r=C.isWeb?"web":(0,c.getTargetPlatform)(C.platform,w.arch);var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(e||(e={}));function n(...U){return String(U.reduce((A,q)=>A|q,0))}var o;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class O{constructor(A=I){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,q=this.state.pageSize){return new O({...this.state,pageNumber:A,pageSize:q})}withFilter(A,...q){const V=[...this.state.criteria,...q.length?q.map(X=>({filterType:A,value:X})):[{filterType:A}]];return new O({...this.state,criteria:V})}withSortBy(A){return new O({...this.state,sortBy:A})}withSortOrder(A){return new O({...this.state,sortOrder:A})}withFlags(...A){return new O({...this.state,flags:A.reduce((q,V)=>q|V,0)})}withAssetTypes(...A){return new O({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:q,pageSize:V,sortBy:X,sortOrder:J,flags:ve,assetTypes:fe}=this.state;return{filters:[{criteria:A,pageNumber:q,pageSize:V,sortBy:X,sortOrder:J}],assetTypes:fe,flags:ve}}get searchText(){const A=this.state.criteria.filter(q=>q.filterType===o.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function N(U,A){const q=(U||[]).filter(V=>V.statisticName===A)[0];return q?q.value:0}function K(U){const A="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(V=>V.assetType.indexOf(A)===0).reduce((V,X)=>{const J=ie(U,X.assetType);return J&&V.push([X.assetType.substring(A.length),J]),V},[])}function te(U){if(U.properties){const A=U.properties.filter(X=>X.key===h.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=A.filter(X=>q.test(X.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return ie(U,h.Repository)}function de(U){return{uri:`${U.fallbackAssetUri}/${h.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${h.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ce(U){const A=ie(U,h.Icon);if(A)return A;const q=c.DefaultIconPath;return{uri:q,fallbackUri:q}}function ie(U,A){return U.files.filter(V=>V.assetType===A)[0]?{uri:`${U.assetUri}/${A}`,fallbackUri:`${U.fallbackAssetUri}/${A}`}:null}function me(U,A){const q=U.properties?U.properties.filter(X=>X.key===A):[],V=q.length>0&&q[0].value;return V?V.split(",").map(X=>(0,E.adoptToGalleryExtensionId)(X)):[]}function j(U){const A=U.properties?U.properties.filter(q=>q.key===m.Engine):[];return A.length>0&&A[0].value||""}function B(U){const A=U.properties?U.properties.filter(q=>q.key===m.PreRelease):[];return A.length>0&&A[0].value==="true"}function ne(U){const A=U.properties?U.properties.filter(V=>V.key===m.LocalizedLanguages):[],q=A.length>0&&A[0].value||"";return q?q.split(","):[]}function M(U){return U.indexOf("preview")!==-1}function k(U){return U.targetPlatform?(0,c.toTargetPlatform)(U.targetPlatform):"undefined"}function W(U){const A=(0,T.distinct)(U.versions.map(k)),q=!!U.tags?.includes(c.WEB_EXTENSION_TAG),V=A.indexOf("web");return q?V===-1&&A.push("web"):V!==-1&&A.splice(V,1),A}function G(U,A){const q=(0,c.getFallbackTargetPlarforms)(A);for(let V=0;V<U.length;V++){const X=U[V];if(X.version===U[V-1]?.version){let J=V;const ve=k(X);if(ve===A)for(;J>0&&U[J-1].version===X.version;)J--;else if(q.includes(ve))for(;J>0&&U[J-1].version===X.version&&k(U[J-1])!==A;)J--;J!==V&&(U.splice(V,1),U.splice(J,0,X))}}return U}i.sortExtensionVersions=G;function ee(U,A,q,V){const X=U.versions[0],J={manifest:ie(A,h.Manifest),readme:ie(A,h.Details),changelog:ie(A,h.Changelog),license:ie(A,h.License),repository:te(A),download:de(A),icon:ce(A),coreTranslations:K(A)};return{identifier:{id:(0,E.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:A.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:N(U.statistics,"install"),rating:N(U.statistics,"averagerating"),ratingCount:N(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:q,assets:J,properties:{dependencies:me(A,m.Dependency),extensionPack:me(A,m.ExtensionPack),engine:j(A),localizedLanguages:ne(A),targetPlatform:k(A),isPreReleaseVersion:B(A)},hasPreReleaseVersion:B(X),preview:M(U.flags),telemetryData:V}}let H=class{constructor(A,q,V,X,J,ve,fe,ue){this.requestService=q,this.logService=V,this.environmentService=X,this.telemetryService=J,this.fileService=ve,this.productService=fe,this.configurationService=ue;const re=fe.extensionsGallery;this.extensionsGalleryUrl=re&&re.serviceUrl,this.extensionsControlUrl=re&&re.controlUrl,this.commonHeadersPromise=ae(fe.version,fe,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,q,V){const X=(0,l.isBoolean)(q)?q:!1,J=(0,l.isBoolean)(q)?V:q;let ve=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,A.length).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionName,...A.map(({id:re})=>re.toLowerCase()));A.every(re=>!re.version)&&(ve=ve.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:fe}=await this.queryGallery(ve,r,P.CancellationToken.None),ue=fe.map(re=>{const Ee=(0,E.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName);return{rawGalleryExtension:re,version:A.find(oe=>(0,E.areSameExtensions)(oe,{id:Ee}))?.version}});return this.converToGalleryExtensions(ue,X,r,()=>{},J)}async getCompatibleExtension(A,q,V){const X=(0,c.isIExtensionIdentifier)(A)?null:A;if(X){if((0,c.isNotWebExtensionInWebTargetPlatform)(X.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(X,q,V))return X}const{id:J,uuid:ve}=X?X.identifier:A;let fe=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");ve?fe=fe.withFilter(o.ExtensionId,ve):fe=fe.withFilter(o.ExtensionName,J);const{galleryExtensions:ue}=await this.queryGallery(fe,V,P.CancellationToken.None),[re]=ue;if(!re||!re.versions.length)return null;const Ee=W(re);if((0,c.isNotWebExtensionInWebTargetPlatform)(Ee,V))return null;for(let oe of re.versions){if(!j(oe)){const he=await this.getEngine(oe);oe={...oe,properties:[...oe.properties||[],{key:m.Engine,value:he}]}}if(await this.isRawExtensionVersionCompatible(oe,q,Ee,V))return ee(re,oe,Ee)}return null}async isExtensionCompatible(A,q,V){if(!(0,c.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,V)||!q&&A.properties.isPreReleaseVersion)return!1;let X=A.properties.engine;if(!X){const J=await this.getManifest(A,P.CancellationToken.None);if(!J)throw new Error("Manifest was not found");X=J.engines.vscode}return(0,u.isEngineValid)(X,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,q,V,X){if(!(0,c.isTargetPlatformCompatible)(k(A),V,X)||!q&&B(A))return!1;const J=await this.getEngine(A);return(0,u.isEngineValid)(J,this.productService.version,this.productService.date)}async query(A,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let V=A.text||"";const X=(0,D.getOrDefault)(A,oe=>oe.pageSize,50);let J=new O().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,X).withFilter(o.Target,"Microsoft.VisualStudio.Code");V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,he,Re)=>(J=J.withFilter(o.Category,Re||he),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,he,Re)=>(J=J.withFilter(o.Tag,Re||he),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(o.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),J=J.withFilter(o.SearchText,V)),J=J.withSortBy(0)):A.ids?J=J.withFilter(o.ExtensionId,...A.ids):A.names?J=J.withFilter(o.ExtensionName,...A.names):J=J.withSortBy(4),typeof A.sortBy=="number"&&(J=J.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(J=J.withSortOrder(A.sortOrder));const{galleryExtensions:ve,total:fe}=await this.queryGallery(J,r,q),ue=oe=>({index:(J.pageNumber-1)*J.pageSize+oe,querySource:A.source}),re=await this.converToGalleryExtensions(ve.map(oe=>({rawGalleryExtension:oe})),!!A.includePreRelease,r,ue,q),Ee=async(oe,he)=>{if(he.isCancellationRequested)throw(0,b.canceled)();const Re=J.withPage(oe+1),{galleryExtensions:ze}=await this.queryGallery(Re,r,he);return await this.converToGalleryExtensions(ze.map(Ae=>({rawGalleryExtension:Ae})),!!A.includePreRelease,r,ue,q)};return{firstPage:re,total:fe,pageSize:J.pageSize,getPage:Ee}}async converToGalleryExtensions(A,q,V,X,J){const ve=(re,Ee)=>{const oe=W(re);let he=re.versions[0];return he=re.versions.find(Re=>Re.version===he.version&&(0,c.isTargetPlatformCompatible)(k(Re),oe,V))||he,!q&&B(he)&&(he=re.versions.find(Re=>Re.version!==he.version&&!B(Re))||he),ee(re,he,oe,X(Ee))},fe=[],ue=new Map;for(let re=0;re<A.length;re++){const{rawGalleryExtension:Ee,version:oe}=A[re];if(oe){const he=Ee.versions.find(Re=>Re.version===oe);he&&fe.push([re,ee(Ee,he,W(Ee))])}else{const he=ve(Ee,re);he.properties.isPreReleaseVersion&&!q?ue.set(he.identifier.uuid,re):fe.push([re,he])}}if(ue.size){const re=new O().withFlags(e.IncludeVersions,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,ue.size).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionId,...ue.keys()),{galleryExtensions:Ee}=await this.queryGallery(re,V,J);if(Ee.length!==ue.size)throw new Error("Not all extensions with latest versions are returned");for(const oe of Ee){const he=ue.get(oe.extensionId),Re=ve(oe,he);fe.push([he,Re])}}return fe.sort((re,Ee)=>re[0]-Ee[0]).map(([,re])=>re)}async queryGallery(A,q,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,e.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,n(e.Unpublished));const X=await this.commonHeadersPromise,J=JSON.stringify(A.raw),ve={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},fe=new Date().getTime();let ue,re,Ee=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:J,headers:ve},V),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:Ee};const oe=await(0,S.asJson)(ue);if(oe){const he=oe.results[0],Re=he.extensions;Re.forEach(Ae=>G(Ae.versions,q));const ze=he.resultMetadata&&he.resultMetadata.filter(Ae=>Ae.metadataType==="ResultCount")[0];return Ee=ze&&ze.metadataItems.filter(Ae=>Ae.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(oe){throw re=oe,oe}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-fe,success:!!ue&&(0,S.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:re?(0,b.isPromiseCanceledError)(re)?"canceled":(0,b.getErrorMessage)(re).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(A,q,V,X){if(!this.isEnabled())return;const J=C.isWeb?this.api(`/itemName/${A}.${q}/version/${V}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${q}/${V}/stats?statType=${X}`),ve=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ve};try{await this.requestService.request({type:"POST",url:J,headers:ue},P.CancellationToken.None)}catch(re){}}async download(A,q,V){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const X=(0,E.getGalleryExtensionTelemetryData)(A),J=new Date().getTime(),ve=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:Ee}),fe=V===1?"install":V===2?"update":"",ue=fe?{uri:`${A.assets.download.uri}${g.URI.parse(A.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${A.assets.download.fallbackUri}${g.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:A.assets.download,re=await this.getAsset(ue);await this.fileService.writeFile(q,re.stream),ve(new Date().getTime()-J)}async getReadme(A,q){if(A.assets.readme){const V=await this.getAsset(A.assets.readme,{},q);return await(0,S.asText)(V)||""}return""}async getManifest(A,q){if(A.assets.manifest){const V=await this.getAsset(A.assets.manifest,{},q),X=await(0,S.asText)(V);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(A,q){const V=ie(A,h.Manifest);if(!V)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},J=await this.getAsset(V,{headers:X});return await(0,S.asJson)(J)}async getCoreTranslation(A,q){const V=A.assets.coreTranslations.filter(X=>X[0]===q.toUpperCase())[0];if(V){const X=await this.getAsset(V[1]),J=await(0,S.asText)(X);return J?JSON.parse(J):null}return null}async getChangelog(A,q){if(A.assets.changelog){const V=await this.getAsset(A.assets.changelog,{},q);return await(0,S.asText)(V)||""}return""}async getAllCompatibleVersions(A,q,V){let X=new O().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?X=X.withFilter(o.ExtensionId,A.identifier.uuid):X=X.withFilter(o.ExtensionName,A.identifier.id);const{galleryExtensions:J}=await this.queryGallery(X,V,P.CancellationToken.None);if(!J.length)return[];const ve=W(J[0]);if((0,c.isNotWebExtensionInWebTargetPlatform)(ve,V))return[];const fe=[];for(const ue of J[0].versions)try{fe[fe.length-1]?.version!==ue.version&&await this.isRawExtensionVersionCompatible(ue,q,ve,V)&&fe.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:B(ue)})}catch(re){}return fe}async getAsset(A,q={},V=P.CancellationToken.None){const X=await this.commonHeadersPromise,J={type:"GET"},ve={...X,...q.headers||{}};q={...q,...J,headers:ve};const fe=A.uri,ue=A.fallbackUri,re={...q,url:fe};try{const Ee=await this.requestService.request(re,V);if(Ee.res.statusCode===200)return Ee;const oe=await(0,S.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${oe}`)}catch(Ee){if((0,b.isPromiseCanceledError)(Ee))throw Ee;const oe=(0,b.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:fe,message:oe});const he={...q,url:ue};return this.requestService.request(he,V)}}async getEngine(A){let q=j(A);if(!q){const V=await this.getManifestFromRawExtensionVersion(A,P.CancellationToken.None);if(!V)throw new Error("Manifest was not found");q=V.engines.vscode}return q}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},P.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,S.asJson)(A),V=new Map;if(q)for(const X of q.malicious){const J=V.get(X)||{id:{id:X},malicious:!0,slow:!1};J.malicious=!0,V.set(X,J)}return[...V.values()]}};H=pe([se(1,S.IRequestService),se(2,p.ILogService),se(3,R.IEnvironmentService),se(4,a.ITelemetryService),se(5,d.IFileService),se(6,v.IProductService),se(7,y.IConfigurationService)],H);let Z=class extends H{constructor(A,q,V,X,J,ve,fe,ue){super(A,q,V,X,J,ve,fe,ue)}};Z=pe([se(0,s.IStorageService),se(1,S.IRequestService),se(2,p.ILogService),se(3,R.IEnvironmentService),se(4,a.ITelemetryService),se(5,d.IFileService),se(6,v.IProductService),se(7,y.IConfigurationService)],Z),i.ExtensionGalleryService=Z;let _=class extends H{constructor(A,q,V,X,J,ve,fe){super(void 0,A,q,V,X,J,ve,fe)}};_=pe([se(0,S.IRequestService),se(1,p.ILogService),se(2,R.IEnvironmentService),se(3,a.ITelemetryService),se(4,d.IFileService),se(5,v.IProductService),se(6,y.IConfigurationService)],_),i.ExtensionGalleryServiceWithNoStorageService=_;async function ae(U,A,q,V,X,J){const ve={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},fe=await(0,f.getServiceMachineId)(q,X,J);return(0,t.supportsTelemetry)(A,q)&&(0,t.getTelemetryLevel)(V)===3&&(ve["X-Market-User-Id"]=fe),ve}i.resolveMarketplaceHeaders=ae}),define(Y[121],Q([0,1,2,21,12,27,86,26,33,122,25,30,36]),function(z,i,T,P,b,D,C,w,l,g,y,R,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let E=class{constructor(p,v){this._configurationService=v,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(S),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(S=>{const f=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(p,v){this._experimentProperties[p]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,c.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const p=await this._commonProperties;let v=p.sessionID,S=p["common.machineId"],f=p["common.firstSessionDate"],s=p["common.msftInternal"];return{sessionId:v,machineId:S,firstSessionDate:f,msftInternal:s}}dispose(){this._disposables.dispose()}_log(p,v,S,f){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(s=>{S=(0,P.mixin)(S,s),S=(0,P.mixin)(S,this._experimentProperties),S=(0,P.cloneAndChange)(S,a=>{if(typeof a=="string")return this._cleanupInfo(a,f)}),this._appenders.forEach(a=>a.log(p,S))},s=>{console.error(s)})}publicLog(p,v,S){return this._log(p,3,v,S)}publicLog2(p,v,S){return this.publicLog(p,v,S)}publicLogError(p,v){return this.sendErrorTelemetry?this._log(p,2,v,!0):Promise.resolve(void 0)}publicLogError2(p,v){return this.publicLogError(p,v)}_anonymizeFilePaths(p){let v=p;const S=[];for(let t of this._cleanupPatterns)for(;;){const r=t.exec(p);if(!r)break;S.push([r.index,t.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(v="";;){const t=s.exec(p);if(!t)break;!f.test(t[0])&&S.every(([r,e])=>t.index<r||t.index>=e)&&(v+=p.substring(a,t.index)+"<REDACTED: user-file-path>",a=s.lastIndex)}return a<p.length&&(v+=p.substr(a)),v}_removePropertiesWithPossibleUserInfo(p){if(!p)return p;const v=p.toLowerCase(),S=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(v)?"<REDACTED: secret>":S.test(v)?"<REDACTED: email>":p}_cleanupInfo(p,v){let S=p;v&&(S=this._anonymizeFilePaths(S));for(let f of this._cleanupPatterns)S=S.replace(f,"");return S=this._removePropertiesWithPossibleUserInfo(S),S}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=pe([se(1,w.IConfigurationService)],E),i.TelemetryService=E;function u(){const d=(0,C.localize)(0,null,g.default.nameLong),p=g.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=b.isWeb?"":(0,C.localize)(3,null),S=(0,C.localize)(4,null),f=(0,C.localize)(5,null),s=(0,C.localize)(6,null),a=(0,C.localize)(7,null),t=`
|       | ${S} | ${f} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${d} ${p} ${v}

&nbsp;

${a}
${t}

&nbsp;

${r}
`}y.Registry.as(l.Extensions.Configuration).registerConfiguration({id:R.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[R.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(l.Extensions.Configuration).registerConfiguration({id:R.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[R.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,C.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,C.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${R.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[123],Q([0,1,7,21,36]),function(z,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function D(w,l){const g=await new Promise((R,c)=>{z(["applicationinsights"],R,c)});let y;return g.defaultClient?(y=new g.TelemetryClient(w),y.channel.setUseDiskRetryCaching(!0)):(g.setup(w).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),y=g.defaultClient),w.indexOf("AIF-")===0&&(y.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),y}class C{constructor(l,g,y,R,c){this._eventPrefix=l,this._defaultData=g,this.testCollector=R,this.mirrored=c,this._defaultData||(this._defaultData=Object.create(null)),typeof y=="function"?this._aiClient=y():this._aiClient=y,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(g=>{l(g)},g=>{(0,T.onUnexpectedError)(g),console.error(g)})}}log(l,g){!this._aiClient||(g=(0,P.mixin)(g,this._defaultData),g=(0,b.validateTelemetryData)(g),this.testCollector&&(g.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(y=>y.trackEvent({name:this._eventPrefix+"/"+l,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}i.AppInsightsAppender=C}),define(Y[124],Q([0,1,6,13]),function(z,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function b(D,C){const w=Object.create(null),l=(y,R)=>{const c=JSON.parse(y);w[R]=c};if(C){const y=[],R=await P.Promises.readdir(C);for(const E of R)try{(await P.Promises.stat((0,T.join)(C,E))).isDirectory()&&y.push(E)}catch{}const c=[];for(const E of y)(await P.Promises.readdir((0,T.join)(C,E))).filter(d=>d==="telemetry.json").length===1&&c.push(E);for(const E of c){const u=(await P.Promises.readFile((0,T.join)(C,E,"telemetry.json"))).toString();l(u,E)}}let g=(await P.Promises.readFile((0,T.join)(D,"telemetry-core.json"))).toString();return l(g,"vscode-core"),g=(await P.Promises.readFile((0,T.join)(D,"telemetry-extensions.json"))).toString(),l(g,"vscode-extensions"),JSON.stringify(w,null,4)}i.buildTelemetryMessage=b}),define(Y[37],Q([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Y[125],Q([0,1,10,2,8,20,23,16,15,37]),function(z,i,T,P,b,D,C,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let y=class extends P.Disposable{constructor(c,E,u,d,p){super();this.extensionsManagementService=c,this.logService=d,this.uriIdentityService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(S=>{this.installedExtensions=S.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(c.onInstallExtension(S=>this.onInstallExtension(S))),this._register(c.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(c.onDidUninstallExtension(S=>this.onDidUninstallExtension(S)));const v=b.URI.file(u.extensionsPath);this._register(E.watch(v)),this._register(T.Event.filter(E.onDidChangeFilesRaw,S=>S.changes.some(f=>this.doesChangeAffects(f,v)))(()=>this.onDidChange()))}doesChangeAffects(c,E){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(c.resource),E)?this.uriIdentityService.extUri.isEqual(c.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!(c.type!==1&&c.type!==2||this.uriIdentityService.extUri.basename(c.resource).startsWith(".")):!1}onInstallExtension(c){this.addInstallingExtension(c.identifier)}onDidInstallExtensions(c){for(const E of c)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(c){c.error||this.removeInstalledExtension(c.identifier)}addInstallingExtension(c){this.removeInstallingExtension(c),this.installingExtensions.push(c)}removeInstallingExtension(c){this.installingExtensions=this.installingExtensions.filter(E=>!(0,C.areSameExtensions)(E,c))}addInstalledExtension(c){this.installedExtensions&&(this.removeInstalledExtension(c),this.installedExtensions.push(c))}removeInstalledExtension(c){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,C.areSameExtensions)(E,c)))}async onDidChange(){if(this.installedExtensions){const c=await this.extensionsManagementService.getInstalled(1),E=c.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(p=>(0,C.areSameExtensions)(p,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),u=this.installedExtensions.filter(d=>this.installingExtensions.some(p=>(0,C.areSameExtensions)(p,d))?!1:c.every(p=>!(0,C.areSameExtensions)(p.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=c.map(d=>d.identifier),(E.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:u})}}};y=pe([se(1,w.IFileService),se(2,D.INativeEnvironmentService),se(3,l.ILogService),se(4,g.IUriIdentityService)],y),i.ExtensionsWatcher=y}),define(Y[126],Q([0,1,37,91,16,18,59,10,2]),function(z,i,T,P,b,D,C,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class g{constructor(c){this.uri=c,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let y=class{constructor(c){this._fileService=c,this._dispooables=new l.DisposableStore,this._limit=2**16;const E=new Map,u=d=>{let p=E.get(d.scheme);return p===void 0&&(p=c.hasProvider(d)&&!this._fileService.hasCapability(d,1024),E.set(d.scheme,p)),p};this._dispooables.add(w.Event.any(c.onDidChangeFileSystemProviderRegistrations,c.onDidChangeFileSystemProviderCapabilities)(d=>{E.delete(d.scheme)})),this.extUri=new D.ExtUri(u),this._canonicalUris=new C.SkipList((d,p)=>this.extUri.compare(d,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(c){this._fileService.hasProvider(c)&&(c=(0,D.normalizePath)(c));let E=this._canonicalUris.get(c);return E?E.touch().uri.with({fragment:c.fragment}):(this._canonicalUris.set(c,new g(c)),this._checkTrim(),c)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const c=[...this._canonicalUris.entries()].sort((u,d)=>u[1].touch<d[1].touch?1:u[1].touch>d[1].touch?-1:0);g._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let u=0;u<E;u++)this._canonicalUris.set(c[u][0],c[u][1].touch())}};y=pe([se(0,b.IFileService)],y),i.UriIdentityService=y,(0,P.registerSingleton)(T.IUriIdentityService,y,!0)}),define(Y[45],Q([0,1,48,3,6,11,13,72,138,139]),function(z,i,T,P,b,D,C,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class y extends Error{constructor(t,r){let e=r.message;switch(t){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=t,this.cause=r}}i.ExtractError=y;function R(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,e)=>r+e,t&61440)}function c(a){if(a instanceof y)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new y(t,a)}function E(a,t,r,e,n,o){const h=b.dirname(t),m=b.join(e,h);if(!m.startsWith(e))return Promise.reject(new Error(w.localize(0,null,t)));const L=b.join(e,t);let I;return o.onCancellationRequested(()=>{I&&I.destroy()}),Promise.resolve(C.Promises.mkdir(m,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!o.isCancellationRequested)try{I=(0,T.createWriteStream)(L,{mode:r}),I.once("close",()=>O()),I.once("error",N),a.once("error",N),a.pipe(I)}catch(K){N(K)}}))}function u(a,t,r,e){let n=(0,P.createCancelablePromise)(()=>Promise.resolve()),o=0;return e.onCancellationRequested(()=>{n.cancel(),a.close()}),new Promise((h,m)=>{const L=new P.Sequencer,I=O=>{O.isCancellationRequested||(o++,a.readEntry())};a.once("error",m),a.once("close",()=>n.then(()=>{e.isCancellationRequested||a.entryCount===o?h():m(new y("Incomplete",new Error(w.localize(1,null,o,a.entryCount))))},m)),a.readEntry(),a.on("entry",O=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){I(e);return}const N=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(N)){const de=b.join(t,N);n=(0,P.createCancelablePromise)(ce=>C.Promises.mkdir(de,{recursive:!0}).then(()=>I(ce)).then(void 0,m));return}const K=p(a,O),te=R(O);n=(0,P.createCancelablePromise)(de=>L.queue(()=>K.then(ce=>E(ce,N,te,t,r,de).then(()=>I(de)))).then(null,m))})})}function d(a,t=!1){return new Promise((r,e)=>{(0,l.open)(a,t?{lazyEntries:!0}:void 0,(n,o)=>{n?e(c(n)):r((0,D.assertIsDefined)(o))})})}function p(a,t){return new Promise((r,e)=>{a.openReadStream(t,(n,o)=>{n?e(c(n)):r((0,D.assertIsDefined)(o))})})}function v(a,t){return new Promise((r,e)=>{const n=new g.ZipFile;t.forEach(h=>{h.contents?n.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&n.addFile(h.localPath,h.path)}),n.end();const o=(0,T.createWriteStream)(a);n.outputStream.pipe(o),n.outputStream.once("error",e),o.once("error",e),o.once("finish",()=>r(a))})}i.zip=v;function S(a,t,r={},e){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=d(a,!0);return r.overwrite&&(o=o.then(h=>C.Promises.rm(t).then(()=>h))),o.then(h=>u(h,t,{sourcePathRegex:n},e))}i.extract=S;function f(a,t){return d(a).then(r=>new Promise((e,n)=>{r.on("entry",o=>{o.fileName===t&&p(r,o).then(h=>e(h),h=>n(h))}),r.once("close",()=>n(new Error(w.localize(2,null,t))))}))}function s(a,t){return f(a,t).then(r=>new Promise((e,n)=>{const o=[];r.once("error",n),r.on("data",h=>o.push(h)),r.on("end",()=>e(Buffer.concat(o)))}))}i.buffer=s}),define(Y[127],Q([0,1,45,79]),function(z,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function b(D){return(0,T.buffer)(D,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch(w){throw new Error((0,P.localize)(0,null))}})}i.getManifest=b}),define(Y[128],Q([0,1,19,3,7,2,9,6,12,18,43,8,31,13,45,80,20,22,23,90,16,15,32]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E,u,d,p,v,S,f,s,a,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let r=class extends D.Disposable{constructor(n,o,h,m,L){super();this.beforeRemovingExtension=n,this.fileService=o,this.logService=h,this.environmentService=m,this.productService=L,this._devSystemExtensionsPath=null,this.systemExtensionsPath=m.builtinExtensionsPath,this.extensionsPath=m.extensionsPath,this.uninstalledPath=w.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const o=[];(n===null||n===0)&&o.push(this.scanSystemExtensions().then(null,h=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(h).message,v.ExtensionManagementErrorCode.Internal)))),(n===null||n===1)&&o.push(this.scanUserExtensions(!0).then(null,h=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(h).message,v.ExtensionManagementErrorCode.Internal))));try{const h=await Promise.all(o);return(0,T.flatten)(h)}catch(h){throw this.joinErrors(h)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[o,h]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return h=h.filter(m=>!o[new S.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]),n&&(h=(0,S.groupByExtension)(h,L=>L.identifier).map(L=>L.sort((I,O)=>y.rcompare(I.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",h.length),h}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,o,h,m){const L=n.key(),I=w.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),O=w.join(this.extensionsPath,L);try{await E.Promises.rm(O)}catch(K){try{await E.Promises.rm(O)}catch(te){}throw new v.ExtensionManagementError((0,d.localize)(0,null,O,n.id),v.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(n,o,I,m);let N=await this.scanExtension(R.URI.file(I),1);if(!N)throw new Error((0,d.localize)(1,null,I));await this.storeMetadata(N,{...h,installedTimestamp:Date.now()});try{await this.rename(n,I,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(K){try{await E.Promises.rm(I)}catch(te){}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",n.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(K)}. Deleted from extracted location`,I),K}try{N=await this.scanExtension(R.URI.file(O),1)}catch(K){}if(N)return N;throw new Error((0,d.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,o){return this.setMetadata(n,o),await this.storeMetadata(n,{...o,installedTimestamp:n.installedTimestamp}),n}async storeMetadata(n,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const h=w.join(n.location.fsPath,"package.json"),m=await E.Promises.readFile(h,"utf8"),{manifest:L}=await this.parseManifest(m);return L.__metadata=o,await E.Promises.writeFile(h,JSON.stringify(L,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...n){const o=n.map(h=>new S.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version));await this.withUninstalledExtensions(h=>{o.forEach(m=>h[m.key()]=!0)})}async setInstalled(n){await this.withUninstalledExtensions(m=>delete m[n.key()]);const h=(await this.scanExtensions(1)).find(m=>new S.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).equals(n))||null;return h?(await this.storeMetadata(h,{installedTimestamp:Date.now()}),this.scanExtension(h.location,1)):null}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(m){if(m.code!=="ENOENT")throw m}let h={};if(o)try{h=JSON.parse(o)}catch(m){}return n&&(n(h),Object.keys(h).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(h)):await E.Promises.rm(this.uninstalledPath)),h})}async removeExtension(n,o){this.logService.trace(`Deleting ${o} extension from disk`,n.identifier.id,n.location.fsPath),await E.Promises.rm(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new S.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,o,h,m){this.logService.trace(`Started extracting the extension from ${o} to ${h}`);try{await E.Promises.rm(h)}catch(L){throw new v.ExtensionManagementError(this.joinErrors(L).message,v.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(o,h,{sourcePath:"extension",overwrite:!0},m),this.logService.info(`Extracted extension to ${h}:`,n.id)}catch(L){try{await E.Promises.rm(h)}catch(O){}let I=v.ExtensionManagementErrorCode.Extract;throw L instanceof u.ExtractError&&(L.type==="CorruptZip"?I=v.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(I=v.ExtensionManagementErrorCode.IncompleteZip)),new v.ExtensionManagementError(L.message,I)}}async rename(n,o,h,m){try{await E.Promises.rename(o,h)}catch(L){if(l.isWindows&&L&&L.code==="EPERM"&&Date.now()<m)return this.logService.info(`Failed renaming ${o} to ${h} with 'EPERM' error. Trying again...`,n.id),this.rename(n,o,h,m);throw new v.ExtensionManagementError(L.message||(0,d.localize)(3,null,o,h),L.code||v.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const o=this.scanDevSystemExtensions(),[h,m]=await Promise.all([n,o]);return[...h,...m]}async scanExtensionsInDir(n,o){const h=new P.Limiter(10),m=await this.fileService.resolve(R.URI.file(n));return m.children?(await Promise.all(m.children.filter(I=>I.isDirectory).map(I=>h.queue(async()=>o===1&&(0,g.basename)(I.resource).indexOf(".")===0?null:this.scanExtension(I.resource,o))))).filter(I=>I&&I.identifier):[]}async scanExtension(n,o){try{const h=await this.fileService.resolve(n);if(h.children){const{manifest:m,metadata:L}=await this.readManifest(n.fsPath),I=h.children.find(({name:te})=>/^readme(\.txt|\.md|)$/i.test(te))?.resource,O=h.children.find(({name:te})=>/^changelog(\.txt|\.md|)$/i.test(te))?.resource,N={id:(0,S.getGalleryExtensionId)(m.publisher,m.name)},K={type:o,identifier:N,manifest:m,location:n,readmeUrl:I,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return L&&this.setMetadata(K,L),K}}catch(h){o!==0&&this.logService.trace(h)}return null}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(h=>n.some(m=>(0,S.areSameExtensions)(h.identifier,{id:m})))}else return[]}setMetadata(n,o){n.publisherDisplayName=o.publisherDisplayName||null,n.publisherId=o.publisherId||null,n.identifier.uuid=o.id,n.isMachineScoped=!!o.isMachineScoped,n.isPreReleaseVersion=!!o.isPreReleaseVersion,n.hadPreReleaseVersion=!!o.hadPreReleaseVersion,n.isBuiltin=n.type===0||!!o.isBuiltin,n.installedTimestamp=o.installedTimestamp}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),h=new Set;for(const I of o)n[new S.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]||h.add(I.identifier.id.toLowerCase());const m=(0,S.groupByExtension)(o,I=>I.identifier);await P.Promises.settled(m.map(async I=>{const O=I.sort((N,K)=>y.rcompare(N.manifest.version,K.manifest.version))[0];h.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const L=o.filter(I=>n[new S.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]);await P.Promises.settled(L.map(I=>this.removeUninstalledExtension(I)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),o=[],h=(0,S.groupByExtension)(n,m=>m.identifier);o.push(...(0,T.flatten)(h.map(m=>m.sort((L,I)=>y.rcompare(L.manifest.version,I.manifest.version)).slice(1)))),await P.Promises.settled(o.map(m=>this.removeExtension(m,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const o=Array.isArray(n)?n:[n];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((h,m)=>new Error(`${h.message}${h.message?",":""}${m instanceof Error?m.message:m}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=w.normalize(w.join(C.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const o=[E.Promises.readFile(w.join(n,"package.json"),"utf8").then(I=>this.parseManifest(I)),E.Promises.readFile(w.join(n,"package.nls.json"),"utf8").then(void 0,I=>I.code!=="ENOENT"?Promise.reject(I):"{}").then(I=>JSON.parse(I))],[{manifest:h,metadata:m},L]=await Promise.all(o);return{manifest:(0,f.localizeManifest)(h,L),metadata:m}}parseManifest(n){return new Promise((o,h)=>{try{const m=JSON.parse(n),L=m.__metadata||null;o({manifest:m,metadata:L})}catch(m){h(new Error((0,d.localize)(4,null)))}})}};r=pe([se(1,s.IFileService),se(2,a.ILogService),se(3,p.INativeEnvironmentService),se(4,t.IProductService)],r),i.ExtensionsScanner=r}),define(Y[129],Q([0,1,28,7,9,6,12,29,18,43,8,31,13,45,78,52,20,119,22,23,110,98,127,111,128,125,51,16,14,15,32,30,37]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E,u,d,p,v,S,f,s,a,t,r,e,n,o,h,m,L,I,O,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let K=class extends v.AbstractExtensionManagementService{constructor(j,B,ne,M,k,W,G,ee,H){super(j,B,ne,ee);this.environmentService=M,this.downloadService=k,this.fileService=G;const Z=this._register(W.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(e.ExtensionsScanner,ae=>Z.postUninstall(ae))),this.manifestCache=this._register(new r.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(W.createInstance(s.ExtensionsDownloader));const _=this._register(new n.ExtensionsWatcher(this,G,M,ne,H));this._register(_.onDidChangeExtensionsByAnotherSource(({added:ae,removed:U})=>{ae.length&&this._onDidInstallExtensions.fire(ae.map(A=>({identifier:A.identifier,operation:0,local:A}))),U.forEach(A=>this._onDidUninstallExtension.fire({identifier:A}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const j=await this.isAlpineLinux(),B=(0,S.getTargetPlatform)(j?"alpine":C.platform,w.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",B),B})()),this._targetPlatformPromise}async isAlpineLinux(){if(!C.isLinux)return!1;let j;try{j=(await this.fileService.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch(B){try{j=(await this.fileService.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(ne){this.logService.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(ne))}}return!!j&&(j.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(j){this.logService.trace("ExtensionManagementService#zip",j.identifier.id);const B=await this.collectFiles(j),ne=await(0,E.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,R.generateUuid)()).fsPath,B);return y.URI.file(ne)}async unzip(j){return this.logService.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const B=await this.downloadVsix(j),ne=D.resolve(B.fsPath);return(0,t.getManifest)(ne)}getInstalled(j=null){return this.extensionsScanner.scanExtensions(j)}async install(j,B={}){this.logService.trace("ExtensionManagementService#install",j.toString());const ne=await this.downloadVsix(j),M=await(0,t.getManifest)(D.resolve(ne.fsPath));if(M.engines&&M.engines.vscode&&!(0,o.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,f.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,ne,B)}async updateMetadata(j,B){return this.logService.trace("ExtensionManagementService#updateMetadata",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,{...j.manifest.__metadata||{},...B}),this.manifestCache.invalidate(),j}async updateExtensionScope(j,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,{...j.manifest.__metadata||{},isMachineScoped:B}),this.manifestCache.invalidate(),j}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(j){if(j.scheme===b.Schemas.file)return j;const B=(0,l.joinPath)(this.environmentService.tmpDir,(0,R.generateUuid)());return await this.downloadService.download(j,B),B}createInstallExtensionTask(j,B,ne){return y.URI.isUri(B)?new ce(j,B,ne,this.galleryService,this.extensionsScanner,this.logService):new de(B,ne,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(j,B){return new ie(j,B,this.extensionsScanner)}async collectFiles(j){const B=async M=>{let k=await c.Promises.readdir(M);k=k.map(ee=>D.join(M,ee));const W=await Promise.all(k.map(ee=>c.Promises.stat(ee)));let G=Promise.resolve([]);return W.forEach((ee,H)=>{const Z=k[H];ee.isFile()&&(G=G.then(_=>[..._,Z])),ee.isDirectory()&&(G=G.then(_=>B(Z).then(ae=>[..._,...ae])))}),G};return(await B(j.location.fsPath)).map(M=>({path:`extension/${D.relative(j.location.fsPath,M)}`,localPath:M}))}};K=pe([se(0,S.IExtensionGalleryService),se(1,O.ITelemetryService),se(2,L.ILogService),se(3,p.INativeEnvironmentService),se(4,d.IDownloadService),se(5,m.IInstantiationService),se(6,h.IFileService),se(7,I.IProductService),se(8,N.IUriIdentityService)],K),i.ExtensionManagementService=K;class te extends v.AbstractExtensionTask{constructor(j,B,ne,M){super();this.identifier=j,this.source=B,this.extensionsScanner=ne,this.logService=M,this._operation=1}get operation(){return this._operation}async installExtension(j,B){try{const ne=await this.unsetUninstalledAndGetLocal(j.identifierWithVersion);if(ne)return j.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ne,{...ne.manifest.__metadata||{},...j.metadata}):ne}catch(ne){throw C.isMacintosh?new S.ExtensionManagementError(u.localize(1,null),S.ExtensionManagementErrorCode.Internal):new S.ExtensionManagementError(u.localize(2,null),S.ExtensionManagementErrorCode.Internal)}return this.extract(j,B)}async unsetUninstalledAndGetLocal(j){if(!await this.isUninstalled(j))return null;this.logService.trace("Removing the extension from uninstalled list:",j.id);const ne=await this.extensionsScanner.setInstalled(j);return this.logService.info("Removed the extension from uninstalled list:",j.id),ne}async isUninstalled(j){return!!(await this.extensionsScanner.getUninstalledExtensions())[j.key()]}async extract({zipPath:j,identifierWithVersion:B,metadata:ne},M){let k=await this.extensionsScanner.extractUserExtension(B,j,ne,M);return this.logService.info("Extracting completed.",B.id),k}}class de extends te{constructor(j,B,ne,M,k){super(j.identifier,j,M,k);this.gallery=j,this.options=B,this.extensionsDownloader=ne}async doRun(j){const ne=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,f.areSameExtensions)(k.identifier,this.gallery.identifier));ne&&(this._operation=2);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||ne?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||ne?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.hadPreReleaseVersion=this.gallery.properties.isPreReleaseVersion||ne?.hadPreReleaseVersion;try{const k=await this.installExtension(M,j);return ne&&g.neq(ne.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ne),k}catch(k){throw await this.deleteDownloadedVSIX(M.zipPath),k}}async deleteDownloadedVSIX(j){try{await this.extensionsDownloader.delete(y.URI.file(j))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",j.toString(),(0,P.getErrorMessage)(B))}}async downloadInstallableExtension(j,B){const ne={id:j.identifier.uuid,publisherId:j.publisherId,publisherDisplayName:j.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",j.identifier.id),M=(await this.extensionsDownloader.downloadExtension(j,B)).fsPath,this.logService.info("Downloaded extension:",j.identifier.id,M)}catch(k){throw new S.ExtensionManagementError((0,v.joinErrors)(k).message,S.ExtensionManagementErrorCode.Download)}try{const k=await(0,t.getManifest)(M);return{zipPath:M,identifierWithVersion:new f.ExtensionIdentifierWithVersion(j.identifier,k.version),metadata:ne}}catch(k){throw await this.deleteDownloadedVSIX(M),new S.ExtensionManagementError((0,v.joinErrors)(k).message,S.ExtensionManagementErrorCode.Invalid)}}}class ce extends te{constructor(j,B,ne,M,k,W){super({id:(0,f.getGalleryExtensionId)(j.publisher,j.name)},B,k,W);this.manifest=j,this.location=B,this.options=ne,this.galleryService=M}async doRun(j){const B=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(W=>(0,f.areSameExtensions)(this.identifier,W.identifier)),k=await this.getMetadata(this.identifier.id,j);if(k.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=2,B.equals(new f.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch(W){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const W=await this.unsetUninstalledAndGetLocal(B);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch(G){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:D.resolve(this.location.fsPath),identifierWithVersion:B,metadata:k},j)}async getMetadata(j,B){try{const ne=(await this.galleryService.query({names:[j],pageSize:1},B)).firstPage[0];if(ne)return{id:ne.identifier.uuid,publisherDisplayName:ne.publisherDisplayName,publisherId:ne.publisherId}}catch(ne){}return{}}}class ie extends v.AbstractExtensionTask{constructor(j,B,ne){super();this.extension=j,this.options=B,this.extensionsScanner=ne}async doRun(j){const B=[],ne=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);B.push(...ne.filter(k=>M.equals(new f.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else B.push(...ne.filter(M=>(0,f.areSameExtensions)(M.identifier,this.extension.identifier)));if(!B.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const M of B)try{j.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(u.localize(6,null,(0,T.toErrorMessage)(k)))}}}}),define(Y[130],Q([0,1,115,3,17,7,2,11,26,20,93,15,114,140]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let u=class extends C.Disposable{constructor(p,v,S){super();this.environmentService=v,this.logService=S,this.configure(p.getValue()),this._register(p.onDidChangeConfiguration(()=>this.configure(p.getValue()),this))}configure(p){this.proxyUrl=p.http&&p.http.proxy,this.strictSSL=!!(p.http&&p.http.proxyStrictSSL),this.authorization=p.http&&p.http.proxyAuthorization}async request(p,v){this.logService.trace("RequestService#request",p.url);const{proxyUrl:S,strictSSL:f}=this;let s;try{s=await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.logService.error("RequestService#request resolving shell environment failed",r)}const a={...process.env,...s},t=p.agent?p.agent:await(0,c.getProxyAgent)(p.url||"",a,{proxyUrl:S,strictSSL:f});return p.agent=t,p.strictSSL=f,this.authorization&&(p.headers={...p.headers||{},"Proxy-Authorization":this.authorization}),this._request(p,v)}async getNodeRequest(p){return((0,T.parse)(p.url).protocol==="https:"?await new Promise((f,s)=>{z(["https"],f,s)}):await new Promise((f,s)=>{z(["http"],f,s)})).request}_request(p,v){return P.Promises.withAsyncBody(async(S,f)=>{let s;const a=(0,T.parse)(p.url),t=p.getRawRequest?p.getRawRequest(p):await this.getNodeRequest(p),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,w.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(r.auth=p.user+":"+p.password),s=t(r,e=>{const n=(0,w.isNumber)(p.followRedirects)?p.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)this._request({...p,url:e.headers.location,followRedirects:n-1},v).then(S,f);else{let o=e;e.headers["content-encoding"]==="gzip"&&(o=e.pipe((0,E.createGunzip)())),S({res:e,stream:(0,b.streamToBufferReadableStream)(o)})}}),s.on("error",f),p.timeout&&s.setTimeout(p.timeout),p.data&&typeof p.data=="string"&&s.write(p.data),s.end(),v.onCancellationRequested(()=>{s.abort(),f((0,D.canceled)())})})}async resolveProxy(p){}};u=pe([se(0,l.IConfigurationService),se(1,g.INativeEnvironmentService),se(2,R.ILogService)],u),i.RequestService=u}),define(Y[141],Q([0,1,34,3,17,28,7,2,9,6,29,8,13,26,107,52,113,20,89,120,22,109,129,16,100,103,41,97,54,55,112,15,104,122,32,44,130,118,30,121,36,123,124,37,126]),function(z,i,T,P,b,D,C,w,l,g,y,R,c,E,u,d,p,v,S,f,s,a,t,r,e,n,o,h,m,L,I,O,N,K,te,de,ce,ie,me,j,B,ne,M,k,W){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class G extends w.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async ae=>{const U=ae.get(O.ILogService),A=ae.get(r.IFileService),q=ae.get(v.INativeEnvironmentService),V=ae.get(s.IExtensionManagementCLIService);U.info("CLI main",this.argv),this.registerErrorHandler(U),await this.doRun(q,V,A),await Promise.all(_.map(X=>{(0,P.raceTimeout)(X.flush(),1e3)}))})}async initServices(){const Z=new m.ServiceCollection,_={_serviceBrand:void 0,...K.default};Z.set(te.IProductService,_);const ae=new S.NativeEnvironmentService(this.argv,_);Z.set(v.INativeEnvironmentService,ae),await Promise.all([ae.appSettingsHome.fsPath,ae.extensionsPath].map(fe=>fe?c.Promises.mkdir(fe,{recursive:!0}):void 0));const U=(0,O.getLogLevel)(ae),A=[];A.push(new N.SpdLogLogger("cli",(0,g.join)(ae.logsPath,"cli.log"),!0,!1,U)),U===O.LogLevel.Trace&&A.push(new O.ConsoleLogger(U));const q=this._register(new O.MultiplexLogService(A));Z.set(O.ILogService,q);const V=this._register(new e.FileService(q));Z.set(r.IFileService,V);const X=this._register(new n.DiskFileSystemProvider(q));V.registerProvider(l.Schemas.file,X);const J=this._register(new u.ConfigurationService(ae.settingsResource,V));Z.set(E.IConfigurationService,J),await J.initialize(),Z.set(k.IUriIdentityService,new W.UriIdentityService(V)),Z.set(de.IRequestService,new o.SyncDescriptor(ce.RequestService)),Z.set(d.IDownloadService,new o.SyncDescriptor(p.DownloadService)),Z.set(s.IExtensionManagementService,new o.SyncDescriptor(t.ExtensionManagementService)),Z.set(s.IExtensionGalleryService,new o.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService)),Z.set(s.IExtensionManagementCLIService,new o.SyncDescriptor(a.ExtensionManagementCLIService)),Z.set(L.ILocalizationsService,new o.SyncDescriptor(I.LocalizationsService));const ve=[];if((0,B.supportsTelemetry)(_,ae)){_.aiConfig&&_.aiConfig.asimovKey&&ve.push(new ne.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:fe,extensionsPath:ue,installSourcePath:re}=ae,Ee={appenders:ve,sendErrorTelemetry:!1,commonProperties:(async()=>{let oe;try{const he=await c.Promises.readFile((0,g.join)(ae.userDataPath,"storage.json"));oe=JSON.parse(he.toString())[me.machineIdKey]}catch(he){he.code!=="ENOENT"&&q.error(he)}return(0,ie.resolveCommonProperties)(V,(0,T.release)(),(0,T.hostname)(),process.arch,_.commit,_.version,oe,_.msftInternalDomains,re)})(),piiPaths:[fe,ue]};Z.set(me.ITelemetryService,new o.SyncDescriptor(j.TelemetryService,[Ee]))}else Z.set(me.ITelemetryService,B.NullTelemetryService);return[new h.InstantiationService(Z),ve]}registerErrorHandler(Z){(0,C.setUnexpectedErrorHandler)(_=>{const ae=(0,D.toErrorMessage)(_,!0);!ae||Z.error(`[uncaught exception in CLI]: ${ae}`)}),process.on("uncaughtException",_=>(0,C.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,C.onUnexpectedError)(_))}async doRun(Z,_,ae){if(this.argv["install-source"])return this.setInstallSource(Z,ae,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?R.URI.file((0,g.isAbsolute)(_)?_:(0,g.join)((0,y.cwd)(),_)):_)}async setInstallSource(Z,_,ae){await _.writeFile(R.URI.file(Z.installSourcePath),b.VSBuffer.fromString(ae.slice(0,30)))}}async function ee(H){const Z=new G(H);try{await Z.run()}finally{Z.dispose()}}i.main=ee})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c1f2f40bcd81380bf2e286af64becddada57db88/core/vs/code/node/cliProcessMain.js.map
