/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(oe){for(var e=[],a=0,F=oe.length;a<F;a++)e[a]=Ee[oe[a]];return e};define(Ee[41],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function a(F,w){if(!F)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=a}),define(Ee[75],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const a=Object.prototype.hasOwnProperty;function F(R){const _=[];for(let n in R)a.call(R,n)&&_.push(R[n]);return _}e.values=F;function w(R,_){for(let n in R)if(a.call(R,n)&&_({key:n,value:R[n]},function(){delete R[n]})===!1)return}e.forEach=w;function T(R,_){const n=Object.create(null);for(const d of R){const s=_(d);let u=n[s];u||(u=n[s]=[]),u.push(d)}return n}e.groupBy=T;function t(R){const _=Object.create(null);return R&&R.forEach((n,d)=>{_[d]=n}),_}e.fromMap=t;function A(R,_){const n=[],d=[];for(let s of R)_.has(s)||n.push(s);for(let s of _)R.has(s)||d.push(s);return{removed:n,added:d}}e.diffSets=A;function S(R,_){const n=[],d=[];for(let[s,u]of R)_.has(s)||n.push(u);for(let[s,u]of _)R.has(s)||d.push(u);return{removed:n,added:d}}e.diffMaps=S;class C{constructor(){this.map=new Map}add(_,n){let d=this.map.get(_);d||(d=new Set,this.map.set(_,d)),d.add(n)}delete(_,n){const d=this.map.get(_);!d||(d.delete(n),d.size===0&&this.map.delete(_))}forEach(_,n){const d=this.map.get(_);!d||d.forEach(n)}}e.SetMap=C}),define(Ee[51],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function a(t){return(A,S,C)=>{let R=null,_=null;if(typeof C.value=="function"?(R="value",_=C.value):typeof C.get=="function"&&(R="get",_=C.get),!_)throw new Error("not supported");C[R]=t(_,S)}}e.createDecorator=a;function F(t,A,S){let C=null,R=null;if(typeof S.value=="function"?(C="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",R=S.get),!R)throw new Error("not supported");const _=`$memoize$${A}`;S[C]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,n)}),this[_]}}e.memoize=F;function w(t,A,S){return a((C,R)=>{const _=`$debounce$${R}`,n=`$debounce$result$${R}`;return function(...d){this[n]||(this[n]=S?S():void 0),clearTimeout(this[_]),A&&(this[n]=A(this[n],...d),d=[this[n]]),this[_]=setTimeout(()=>{C.apply(this,d),this[n]=S?S():void 0},t)}})}e.debounce=w;function T(t,A,S){return a((C,R)=>{const _=`$throttle$timer$${R}`,n=`$throttle$result$${R}`,d=`$throttle$lastRun$${R}`,s=`$throttle$pending$${R}`;return function(...u){if(this[n]||(this[n]=S?S():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),A&&(this[n]=A(this[n],...u)),this[s])return;const g=this[d]+t;g<=Date.now()?(this[d]=Date.now(),C.apply(this,[this[n]]),this[n]=S?S():void 0):(this[s]=!0,this[_]=setTimeout(()=>{this[s]=!1,this[d]=Date.now(),C.apply(this,[this[n]]),this[n]=S?S():void 0},g-Date.now()))}})}e.throttle=T}),define(Ee[52],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Ee[100],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var F;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(l){l.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function t(l,M=!1){let r=0,i=l.length,p="",h=0,o=16,v=0;function c(x){let N=0,z=0;for(;N<x;){const H=l.charCodeAt(r);if(H>=48&&H<=57)z=z*16+H-48;else if(H>=65&&H<=70)z=z*16+H-65+10;else if(H>=97&&H<=102)z=z*16+H-97+10;else break;r++,N++}return N<x&&(z=-1),z}function E(x){r=x,p="",h=0,o=16,v=0}function I(){const x=r;if(l.charCodeAt(r)===48)r++;else for(r++;r<l.length&&C(l.charCodeAt(r));)r++;if(r<l.length&&l.charCodeAt(r)===46)if(r++,r<l.length&&C(l.charCodeAt(r)))for(r++;r<l.length&&C(l.charCodeAt(r));)r++;else return v=3,l.substring(x,r);let N=r;if(r<l.length&&(l.charCodeAt(r)===69||l.charCodeAt(r)===101))if(r++,(r<l.length&&l.charCodeAt(r)===43||l.charCodeAt(r)===45)&&r++,r<l.length&&C(l.charCodeAt(r))){for(r++;r<l.length&&C(l.charCodeAt(r));)r++;N=r}else v=3;return l.substring(x,N)}function D(){let x="",N=r;for(;;){if(r>=i){x+=l.substring(N,r),v=2;break}const z=l.charCodeAt(r);if(z===34){x+=l.substring(N,r),r++;break}if(z===92){if(x+=l.substring(N,r),r++,r>=i){v=2;break}switch(l.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const q=c(4);q>=0?x+=String.fromCharCode(q):v=4;break;default:v=5}N=r;continue}if(z>=0&&z<=31)if(S(z)){x+=l.substring(N,r),v=2;break}else v=6;r++}return x}function B(){if(p="",v=0,h=r,r>=i)return h=i,o=17;let x=l.charCodeAt(r);if(A(x)){do r++,p+=String.fromCharCode(x),x=l.charCodeAt(r);while(A(x));return o=15}if(S(x))return r++,p+=String.fromCharCode(x),x===13&&l.charCodeAt(r)===10&&(r++,p+=`
`),o=14;switch(x){case 123:return r++,o=1;case 125:return r++,o=2;case 91:return r++,o=3;case 93:return r++,o=4;case 58:return r++,o=6;case 44:return r++,o=5;case 34:return r++,p=D(),o=10;case 47:const N=r-1;if(l.charCodeAt(r+1)===47){for(r+=2;r<i&&!S(l.charCodeAt(r));)r++;return p=l.substring(N,r),o=12}if(l.charCodeAt(r+1)===42){r+=2;const z=i-1;let H=!1;for(;r<z;){if(l.charCodeAt(r)===42&&l.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,v=1),p=l.substring(N,r),o=13}return p+=String.fromCharCode(x),r++,o=16;case 45:if(p+=String.fromCharCode(x),r++,r===i||!C(l.charCodeAt(r)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=I(),o=11;default:for(;r<i&&L(x);)r++,x=l.charCodeAt(r);if(h!==r){switch(p=l.substring(h,r),p){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return p+=String.fromCharCode(x),r++,o=16}}function L(x){if(A(x)||S(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function y(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>r,scan:M?y:B,getToken:()=>o,getTokenValue:()=>p,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>v}}e.createScanner=t;function A(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function S(l){return l===10||l===13||l===8232||l===8233}function C(l){return l>=48&&l<=57}var R;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(R||(R={}));function _(l,M){const r=[],i=new Object;let p;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v(c,E,I,D){h.value=c,h.offset=E,h.length=I,h.type=D,h.colonOffset=void 0,p=h}try{m(l,{onObjectBegin:(c,E)=>{if(M<=c)throw i;p=void 0,o=M>c,r.push("")},onObjectProperty:(c,E,I)=>{if(M<E||(v(c,E,I,"property"),r[r.length-1]=c,M<=E+I))throw i},onObjectEnd:(c,E)=>{if(M<=c)throw i;p=void 0,r.pop()},onArrayBegin:(c,E)=>{if(M<=c)throw i;p=void 0,r.push(0)},onArrayEnd:(c,E)=>{if(M<=c)throw i;p=void 0,r.pop()},onLiteralValue:(c,E,I)=>{if(M<E||(v(c,E,I,P(c)),M<=E+I))throw i},onSeparator:(c,E,I)=>{if(M<=E)throw i;if(c===":"&&p&&p.type==="property")p.colonOffset=E,o=!1,p=void 0;else if(c===","){const D=r[r.length-1];typeof D=="number"?r[r.length-1]=D+1:(o=!0,r[r.length-1]=""),p=void 0}}})}catch(c){if(c!==i)throw c}return{path:r,previousNode:p,isAtPropertyKey:o,matches:c=>{let E=0;for(let I=0;E<c.length&&I<r.length;I++)if(c[E]===r[I]||c[E]==="*")E++;else if(c[E]!=="**")return!1;return E===c.length}}}e.getLocation=_;function n(l,M=[],r=T.DEFAULT){let i=null,p=[];const h=[];function o(c){Array.isArray(p)?p.push(c):i!==null&&(p[i]=c)}return m(l,{onObjectBegin:()=>{const c={};o(c),h.push(p),p=c,i=null},onObjectProperty:c=>{i=c},onObjectEnd:()=>{p=h.pop()},onArrayBegin:()=>{const c=[];o(c),h.push(p),p=c,i=null},onArrayEnd:()=>{p=h.pop()},onLiteralValue:o,onError:(c,E,I)=>{M.push({error:c,offset:E,length:I})}},r),p[0]}e.parse=n;function d(l,M=[],r=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(c){i.type==="property"&&(i.length=c-i.offset,i=i.parent)}function h(c){return i.children.push(c),c}m(l,{onObjectBegin:c=>{i=h({type:"object",offset:c,length:-1,parent:i,children:[]})},onObjectProperty:(c,E,I)=>{i=h({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:c,offset:E,length:I,parent:i})},onObjectEnd:(c,E)=>{i.length=c+E-i.offset,i=i.parent,p(c+E)},onArrayBegin:(c,E)=>{i=h({type:"array",offset:c,length:-1,parent:i,children:[]})},onArrayEnd:(c,E)=>{i.length=c+E-i.offset,i=i.parent,p(c+E)},onLiteralValue:(c,E,I)=>{h({type:P(c),offset:E,length:I,parent:i,value:c}),p(E+I)},onSeparator:(c,E,I)=>{i.type==="property"&&(c===":"?i.colonOffset=E:c===","&&p(E))},onError:(c,E,I)=>{M.push({error:c,offset:E,length:I})}},r);const v=i.children[0];return v&&delete v.parent,v}e.parseTree=d;function s(l,M){if(!l)return;let r=l;for(let i of M)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let p=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===i){r=h.children[1],p=!0;break}if(!p)return}else{const p=i;if(r.type!=="array"||p<0||!Array.isArray(r.children)||p>=r.children.length)return;r=r.children[p]}return r}e.findNodeAtLocation=s;function u(l){if(!l.parent||!l.parent.children)return[];const M=u(l.parent);if(l.parent.type==="property"){const r=l.parent.children[0].value;M.push(r)}else if(l.parent.type==="array"){const r=l.parent.children.indexOf(l);r!==-1&&M.push(r)}return M}e.getNodePath=u;function g(l){switch(l.type){case"array":return l.children.map(g);case"object":const M=Object.create(null);for(let r of l.children){const i=r.children[1];i&&(M[r.children[0].value]=g(i))}return M;case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=g;function k(l,M,r=!1){return M>=l.offset&&M<l.offset+l.length||r&&M===l.offset+l.length}e.contains=k;function b(l,M,r=!1){if(k(l,M,r)){const i=l.children;if(Array.isArray(i))for(let p=0;p<i.length&&i[p].offset<=M;p++){const h=b(i[p],M,r);if(h)return h}return l}}e.findNodeAtOffset=b;function m(l,M,r=T.DEFAULT){const i=t(l,!1);function p(ie){return ie?()=>ie(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(ie){return ie?we=>ie(we,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=p(M.onObjectBegin),v=h(M.onObjectProperty),c=p(M.onObjectEnd),E=p(M.onArrayBegin),I=p(M.onArrayEnd),D=h(M.onLiteralValue),B=h(M.onSeparator),L=p(M.onComment),y=h(M.onError),x=r&&r.disallowComments,N=r&&r.allowTrailingComma;function z(){for(;;){const ie=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:x||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ie){case 12:case 13:x?H(10):L();break;case 16:H(1);break;case 15:case 14:break;default:return ie}}}function H(ie,we=[],Me=[]){if(y(ie),we.length+Me.length>0){let Fe=i.getToken();for(;Fe!==17;){if(we.indexOf(Fe)!==-1){z();break}else if(Me.indexOf(Fe)!==-1)break;Fe=z()}}}function q(ie){const we=i.getTokenValue();return ie?D(we):v(we),z(),!0}function ue(){switch(i.getToken()){case 11:let ie=0;try{ie=JSON.parse(i.getTokenValue()),typeof ie!="number"&&(H(2),ie=0)}catch(we){H(2)}D(ie);break;case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return z(),!0}function G(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(B(":"),z(),Q()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function ce(){o(),z();let ie=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ie||H(4,[],[]),B(","),z(),i.getToken()===2&&N)break}else ie&&H(6,[],[]);G()||H(4,[],[2,5]),ie=!0}return c(),i.getToken()!==2?H(7,[2],[]):z(),!0}function de(){E(),z();let ie=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ie||H(4,[],[]),B(","),z(),i.getToken()===4&&N)break}else ie&&H(6,[],[]);Q()||H(4,[],[4,5]),ie=!0}return I(),i.getToken()!==4?H(8,[4],[]):z(),!0}function Q(){switch(i.getToken()){case 3:return de();case 1:return ce();case 10:return q(!0);default:return ue()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):Q()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=m;function f(l,M){let r=t(l),i=[],p,h=0,o;do switch(o=r.getPosition(),p=r.scan(),p){case 12:case 13:case 17:h!==o&&i.push(l.substring(h,o)),M!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,M)),h=r.getPosition();break}while(p!==17);return i.join("")}e.stripComments=f;function P(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=P}),define(Ee[101],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new a(()=>w(this.getValue()))}}e.Lazy=a}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,oe.marked=e())}(this,function(){"use strict";function oe(Pe,Se){for(var ve=0;ve<Se.length;ve++){var re=Se[ve];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Pe,re.key,re)}}function e(Pe,Se,ve){return Se&&oe(Pe.prototype,Se),ve&&oe(Pe,ve),Pe}function a(Pe,Se){if(!!Pe){if(typeof Pe=="string")return F(Pe,Se);var ve=Object.prototype.toString.call(Pe).slice(8,-1);if(ve==="Object"&&Pe.constructor&&(ve=Pe.constructor.name),ve==="Map"||ve==="Set")return Array.from(Pe);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return F(Pe,Se)}}function F(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var ve=0,re=new Array(Se);ve<Se;ve++)re[ve]=Pe[ve];return re}function w(Pe,Se){var ve=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(ve)return(ve=ve.call(Pe)).next.bind(ve);if(Array.isArray(Pe)||(ve=a(Pe))||Se&&Pe&&typeof Pe.length=="number"){ve&&(Pe=ve);var re=0;return function(){return re>=Pe.length?{done:!0}:{done:!1,value:Pe[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function t(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function A(Pe){T.exports.defaults=Pe}T.exports={defaults:t(),getDefaults:t,changeDefaults:A};var S=/[&<>"']/,C=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(Se){return n[Se]};function s(Pe,Se){if(Se){if(S.test(Pe))return Pe.replace(C,d)}else if(R.test(Pe))return Pe.replace(_,d);return Pe}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Pe){return Pe.replace(u,function(Se,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var k=/(^|[^\[])\^/g;function b(Pe,Se){Pe=Pe.source||Pe,Se=Se||"";var ve={replace:function(ae,he){return he=he.source||he,he=he.replace(k,"$1"),Pe=Pe.replace(ae,he),ve},getRegex:function(){return new RegExp(Pe,Se)}};return ve}var m=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function P(Pe,Se,ve){if(Pe){var re;try{re=decodeURIComponent(g(ve)).replace(m,"").toLowerCase()}catch(ae){return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Se&&!f.test(ve)&&(ve=p(Se,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch(ae){return null}return ve}var l={},M=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(Pe,Se){l[" "+Pe]||(M.test(Pe)?l[" "+Pe]=Pe+"/":l[" "+Pe]=c(Pe,"/",!0)),Pe=l[" "+Pe];var ve=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?ve?Se:Pe.replace(r,"$1")+Se:Se.charAt(0)==="/"?ve?Se:Pe.replace(i,"$1")+Se:Pe+Se}var h={exec:function(){}};function o(Pe){for(var Se=1,ve,re;Se<arguments.length;Se++){ve=arguments[Se];for(re in ve)Object.prototype.hasOwnProperty.call(ve,re)&&(Pe[re]=ve[re])}return Pe}function v(Pe,Se){var ve=Pe.replace(/\|/g,function(he,me,Ie){for(var ze=!1,Oe=me;--Oe>=0&&Ie[Oe]==="\\";)ze=!ze;return ze?"|":" |"}),re=ve.split(/ \|/),ae=0;if(re[0].trim()||re.shift(),re[re.length-1].trim()||re.pop(),re.length>Se)re.splice(Se);else for(;re.length<Se;)re.push("");for(;ae<re.length;ae++)re[ae]=re[ae].trim().replace(/\\\|/g,"|");return re}function c(Pe,Se,ve){var re=Pe.length;if(re===0)return"";for(var ae=0;ae<re;){var he=Pe.charAt(re-ae-1);if(he===Se&&!ve)ae++;else if(he!==Se&&ve)ae++;else break}return Pe.substr(0,re-ae)}function E(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var ve=Pe.length,re=0,ae=0;ae<ve;ae++)if(Pe[ae]==="\\")ae++;else if(Pe[ae]===Se[0])re++;else if(Pe[ae]===Se[1]&&(re--,re<0))return ae;return-1}function I(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(Pe,Se){if(Se<1)return"";for(var ve="";Se>1;)Se&1&&(ve+=Pe),Se>>=1,Pe+=Pe;return ve+Pe}var B={escape:s,unescape:g,edit:b,cleanUrl:P,resolveUrl:p,noopTest:h,merge:o,splitCells:v,rtrim:c,findClosingBracket:E,checkSanitizeDeprecation:I,repeatString:D},L=T.exports.defaults,y=B.rtrim,x=B.splitCells,N=B.escape,z=B.findClosingBracket;function H(Pe,Se,ve,re){var ae=Se.href,he=Se.title?N(Se.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){re.state.inLink=!0;var Ie={type:"link",raw:ve,href:ae,title:he,text:me,tokens:re.inlineTokens(me,[])};return re.state.inLink=!1,Ie}else return{type:"image",raw:ve,href:ae,title:he,text:N(me)}}function q(Pe,Se){var ve=Pe.match(/^(\s+)(?:```)/);if(ve===null)return Se;var re=ve[1];return Se.split(`
`).map(function(ae){var he=ae.match(/^\s+/);if(he===null)return ae;var me=he[0];return me.length>=re.length?ae.slice(re.length):ae}).join(`
`)}var ue=function(){function Pe(ve){this.options=ve||L}var Se=Pe.prototype;return Se.space=function(re){var ae=this.rules.block.newline.exec(re);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Se.code=function(re){var ae=this.rules.block.code.exec(re);if(ae){var he=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?he:y(he,`
`)}}},Se.fences=function(re){var ae=this.rules.block.fences.exec(re);if(ae){var he=ae[0],me=q(he,ae[3]||"");return{type:"code",raw:he,lang:ae[2]?ae[2].trim():ae[2],text:me}}},Se.heading=function(re){var ae=this.rules.block.heading.exec(re);if(ae){var he=ae[2].trim();if(/#$/.test(he)){var me=y(he,"#");(this.options.pedantic||!me||/ $/.test(me))&&(he=me.trim())}var Ie={type:"heading",raw:ae[0],depth:ae[1].length,text:he,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},Se.hr=function(re){var ae=this.rules.block.hr.exec(re);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(re){var ae=this.rules.block.blockquote.exec(re);if(ae){var he=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},Se.list=function(re){var ae=this.rules.block.list.exec(re);if(ae){var he,me,Ie,ze,Oe,We,it,ot,ne,ge,te=ae[1].trim(),W=te.length>1,be={type:"list",raw:"",ordered:W,start:W?+te.slice(0,-1):"",loose:!1,items:[]};te=W?"\\d{1,9}\\"+te.slice(-1):"\\"+te,this.options.pedantic&&(te=W?te:"[*+-]");for(var ke=new RegExp("^( {0,3}"+te+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");re&&!(this.rules.block.hr.test(re)||!(ae=ke.exec(re)));){ne=ae[2].split(`
`),this.options.pedantic?(ze=2,ge=ne[0].trimLeft()):(ze=ae[2].search(/[^ ]/),ze=ae[1].length+(ze>4?1:ze),ge=ne[0].slice(ze-ae[1].length)),We=!1,he=ae[0],!ne[0]&&/^ *$/.test(ne[1])&&(he=ae[1]+ne.slice(0,2).join(`
`)+`
`,be.loose=!0,ne=[]);var qe=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Oe=1;Oe<ne.length;Oe++){if(ot=ne[Oe],this.options.pedantic&&(ot=ot.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),qe.test(ot)){he=ae[1]+ne.slice(0,Oe).join(`
`)+`
`;break}if(!We){ot.trim()||(We=!0),ot.search(/[^ ]/)>=ze?ge+=`
`+ot.slice(ze):ge+=`
`+ot;continue}if(ot.search(/[^ ]/)>=ze||!ot.trim()){ge+=`
`+ot.slice(ze);continue}else{he=ae[1]+ne.slice(0,Oe).join(`
`)+`
`;break}}be.loose||(it?be.loose=!0:/\n *\n *$/.test(he)&&(it=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ge),me&&(Ie=me[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:he,task:!!me,checked:Ie,loose:!1,text:ge}),be.raw+=he,re=re.slice(he.length)}be.items[be.items.length-1].raw=he.trimRight(),be.items[be.items.length-1].text=ge.trimRight(),be.raw=be.raw.trimRight();var Le=be.items.length;for(Oe=0;Oe<Le;Oe++)this.lexer.state.top=!1,be.items[Oe].tokens=this.lexer.blockTokens(be.items[Oe].text,[]),be.items[Oe].tokens.some(function(dt){return dt.type==="space"})&&(be.loose=!0,be.items[Oe].loose=!0);return be}},Se.html=function(re){var ae=this.rules.block.html.exec(re);if(ae){var he={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};return this.options.sanitize&&(he.type="paragraph",he.text=this.options.sanitizer?this.options.sanitizer(ae[0]):N(ae[0]),he.tokens=[],this.lexer.inline(he.text,he.tokens)),he}},Se.def=function(re){var ae=this.rules.block.def.exec(re);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var he=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(re){var ae=this.rules.block.table.exec(re);if(ae){var he={type:"table",header:x(ae[1]).map(function(it){return{text:it}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=ae[0];var me=he.align.length,Ie,ze,Oe,We;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(he.align[Ie])?he.align[Ie]="right":/^ *:-+: *$/.test(he.align[Ie])?he.align[Ie]="center":/^ *:-+ *$/.test(he.align[Ie])?he.align[Ie]="left":he.align[Ie]=null;for(me=he.rows.length,Ie=0;Ie<me;Ie++)he.rows[Ie]=x(he.rows[Ie],he.header.length).map(function(it){return{text:it}});for(me=he.header.length,ze=0;ze<me;ze++)he.header[ze].tokens=[],this.lexer.inlineTokens(he.header[ze].text,he.header[ze].tokens);for(me=he.rows.length,ze=0;ze<me;ze++)for(We=he.rows[ze],Oe=0;Oe<We.length;Oe++)We[Oe].tokens=[],this.lexer.inlineTokens(We[Oe].text,We[Oe].tokens);return he}}},Se.lheading=function(re){var ae=this.rules.block.lheading.exec(re);if(ae){var he={type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},Se.paragraph=function(re){var ae=this.rules.block.paragraph.exec(re);if(ae){var he={type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},Se.text=function(re){var ae=this.rules.block.text.exec(re);if(ae){var he={type:"text",raw:ae[0],text:ae[0],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},Se.escape=function(re){var ae=this.rules.inline.escape.exec(re);if(ae)return{type:"escape",raw:ae[0],text:N(ae[1])}},Se.tag=function(re){var ae=this.rules.inline.tag.exec(re);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):N(ae[0]):ae[0]}},Se.link=function(re){var ae=this.rules.inline.link.exec(re);if(ae){var he=ae[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var me=y(he.slice(0,-1),"\\");if((he.length-me.length)%2==0)return}else{var Ie=z(ae[2],"()");if(Ie>-1){var ze=ae[0].indexOf("!")===0?5:4,Oe=ze+ae[1].length+Ie;ae[2]=ae[2].substring(0,Ie),ae[0]=ae[0].substring(0,Oe).trim(),ae[3]=""}}var We=ae[2],it="";if(this.options.pedantic){var ot=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);ot&&(We=ot[1],it=ot[3])}else it=ae[3]?ae[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(he)?We=We.slice(1):We=We.slice(1,-1)),H(ae,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},Se.reflink=function(re,ae){var he;if((he=this.rules.inline.reflink.exec(re))||(he=this.rules.inline.nolink.exec(re))){var me=(he[2]||he[1]).replace(/\s+/g," ");if(me=ae[me.toLowerCase()],!me||!me.href){var Ie=he[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return H(he,me,he[0],this.lexer)}},Se.emStrong=function(re,ae,he){he===void 0&&(he="");var me=this.rules.inline.emStrong.lDelim.exec(re);if(!!me&&!(me[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(he===""||this.rules.inline.punctuation.exec(he))){var ze=me[0].length-1,Oe,We,it=ze,ot=0,ne=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ne.lastIndex=0,ae=ae.slice(-1*re.length+ze);(me=ne.exec(ae))!=null;)if(Oe=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Oe){if(We=Oe.length,me[3]||me[4]){it+=We;continue}else if((me[5]||me[6])&&ze%3&&!((ze+We)%3)){ot+=We;continue}if(it-=We,!(it>0)){if(We=Math.min(We,We+it+ot),Math.min(ze,We)%2){var ge=re.slice(1,ze+me.index+We);return{type:"em",raw:re.slice(0,ze+me.index+We+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var te=re.slice(2,ze+me.index+We-1);return{type:"strong",raw:re.slice(0,ze+me.index+We+1),text:te,tokens:this.lexer.inlineTokens(te,[])}}}}}},Se.codespan=function(re){var ae=this.rules.inline.code.exec(re);if(ae){var he=ae[2].replace(/\n/g," "),me=/[^ ]/.test(he),Ie=/^ /.test(he)&&/ $/.test(he);return me&&Ie&&(he=he.substring(1,he.length-1)),he=N(he,!0),{type:"codespan",raw:ae[0],text:he}}},Se.br=function(re){var ae=this.rules.inline.br.exec(re);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(re){var ae=this.rules.inline.del.exec(re);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2],[])}},Se.autolink=function(re,ae){var he=this.rules.inline.autolink.exec(re);if(he){var me,Ie;return he[2]==="@"?(me=N(this.options.mangle?ae(he[1]):he[1]),Ie="mailto:"+me):(me=N(he[1]),Ie=me),{type:"link",raw:he[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},Se.url=function(re,ae){var he;if(he=this.rules.inline.url.exec(re)){var me,Ie;if(he[2]==="@")me=N(this.options.mangle?ae(he[0]):he[0]),Ie="mailto:"+me;else{var ze;do ze=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(ze!==he[0]);me=N(he[0]),he[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:he[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},Se.inlineText=function(re,ae){var he=this.rules.inline.text.exec(re);if(he){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):N(he[0]):he[0]:me=N(this.options.smartypants?ae(he[0]):he[0]),{type:"text",raw:he[0],text:me}}},Pe}(),G=B.noopTest,ce=B.edit,de=B.merge,Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:G,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=ce(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=ce(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=ce(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=ce(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=ce(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=ce(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=de({},Q),Q.gfm=de({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=ce(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=de({},Q.normal,{html:ce(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:G,paragraph:ce(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:G,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:G,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=ce(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ie.escapedEmSt=/\\\*|\\_/g,ie._comment=ce(Q._comment).replace("(?:-->|$)","-->").getRegex(),ie.emStrong.lDelim=ce(ie.emStrong.lDelim).replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimAst=ce(ie.emStrong.rDelimAst,"g").replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimUnd=ce(ie.emStrong.rDelimUnd,"g").replace(/punct/g,ie._punctuation).getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=ce(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=ce(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=ce(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=ce(ie.reflink).replace("label",ie._label).getRegex(),ie.reflinkSearch=ce(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=de({},ie),ie.pedantic=de({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ce(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:ce(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=de({},ie.normal,{escape:ce(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ie.gfm.url=ce(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=de({},ie.gfm,{br:ce(ie.br).replace("{2,}","*").getRegex(),text:ce(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var we={block:Q,inline:ie},Me=ue,Fe=T.exports.defaults,Be=we.block,Ke=we.inline,je=B.repeatString;function Qe(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(Pe){var Se="",ve,re,ae=Pe.length;for(ve=0;ve<ae;ve++)re=Pe.charCodeAt(ve),Math.random()>.5&&(re="x"+re.toString(16)),Se+="&#"+re+";";return Se}var K=function(){function Pe(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Fe,this.options.tokenizer=this.options.tokenizer||new Me,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:Be.normal,inline:Ke.normal};this.options.pedantic?(re.block=Be.pedantic,re.inline=Ke.pedantic):this.options.gfm&&(re.block=Be.gfm,this.options.breaks?re.inline=Ke.breaks:re.inline=Ke.gfm),this.tokenizer.rules=re}Pe.lex=function(re,ae){var he=new Pe(ae);return he.lex(re)},Pe.lexInline=function(re,ae){var he=new Pe(ae);return he.inlineTokens(re)};var Se=Pe.prototype;return Se.lex=function(re){re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},Se.blockTokens=function(re,ae){var he=this;ae===void 0&&(ae=[]),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var me,Ie,ze,Oe;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(me=it.call({lexer:he},re,ae))?(re=re.substring(me.raw.length),ae.push(me),!0):!1}))){if(me=this.tokenizer.space(re)){re=re.substring(me.raw.length),me.type&&ae.push(me);continue}if(me=this.tokenizer.code(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ae.push(me);continue}if(me=this.tokenizer.fences(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.heading(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.hr(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.blockquote(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.list(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.html(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.def(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.lheading(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(ze=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,ot=re.slice(1),ne=void 0;he.options.extensions.startBlock.forEach(function(ge){ne=ge.call({lexer:this},ot),typeof ne=="number"&&ne>=0&&(it=Math.min(it,ne))}),it<Infinity&&it>=0&&(ze=re.substring(0,it+1))}(),this.state.top&&(me=this.tokenizer.paragraph(ze))){Ie=ae[ae.length-1],Oe&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ae.push(me),Oe=ze.length!==re.length,re=re.substring(me.raw.length);continue}if(me=this.tokenizer.text(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ae.push(me);continue}if(re){var We="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return this.state.top=!0,ae},Se.inline=function(re,ae){this.inlineQueue.push({src:re,tokens:ae})},Se.inlineTokens=function(re,ae){var he=this;ae===void 0&&(ae=[]);var me,Ie,ze,Oe=re,We,it,ot;if(this.tokens.links){var ne=Object.keys(this.tokens.links);if(ne.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)ne.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,We.index)+"["+je("a",We[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,We.index)+"["+je("a",We[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,We.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(it||(ot=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(te){return(me=te.call({lexer:he},re,ae))?(re=re.substring(me.raw.length),ae.push(me),!0):!1}))){if(me=this.tokenizer.escape(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.tag(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ae.push(me);continue}if(me=this.tokenizer.link(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ae.push(me);continue}if(me=this.tokenizer.emStrong(re,Oe,ot)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.codespan(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.br(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.del(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.autolink(re,$)){re=re.substring(me.raw.length),ae.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(re,$))){re=re.substring(me.raw.length),ae.push(me);continue}if(ze=re,this.options.extensions&&this.options.extensions.startInline&&function(){var te=Infinity,W=re.slice(1),be=void 0;he.options.extensions.startInline.forEach(function(ke){be=ke.call({lexer:this},W),typeof be=="number"&&be>=0&&(te=Math.min(te,be))}),te<Infinity&&te>=0&&(ze=re.substring(0,te+1))}(),me=this.tokenizer.inlineText(ze,Qe)){re=re.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(ot=me.raw.slice(-1)),it=!0,Ie=ae[ae.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ae.push(me);continue}if(re){var ge="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ae},e(Pe,null,[{key:"rules",get:function(){return{block:Be,inline:Ke}}}]),Pe}(),X=T.exports.defaults,se=B.cleanUrl,j=B.escape,Z=function(){function Pe(ve){this.options=ve||X}var Se=Pe.prototype;return Se.code=function(re,ae,he){var me=(ae||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(re,me);Ie!=null&&Ie!==re&&(he=!0,re=Ie)}return re=re.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+j(me,!0)+'">'+(he?re:j(re,!0))+`</code></pre>
`:"<pre><code>"+(he?re:j(re,!0))+`</code></pre>
`},Se.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Se.html=function(re){return re},Se.heading=function(re,ae,he,me){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+me.slug(he)+'">'+re+"</h"+ae+`>
`:"<h"+ae+">"+re+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(re,ae,he){var me=ae?"ol":"ul",Ie=ae&&he!==1?' start="'+he+'"':"";return"<"+me+Ie+`>
`+re+"</"+me+`>
`},Se.listitem=function(re){return"<li>"+re+`</li>
`},Se.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(re){return"<p>"+re+`</p>
`},Se.table=function(re,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ae+`</table>
`},Se.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Se.tablecell=function(re,ae){var he=ae.header?"th":"td",me=ae.align?"<"+he+' align="'+ae.align+'">':"<"+he+">";return me+re+"</"+he+`>
`},Se.strong=function(re){return"<strong>"+re+"</strong>"},Se.em=function(re){return"<em>"+re+"</em>"},Se.codespan=function(re){return"<code>"+re+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(re){return"<del>"+re+"</del>"},Se.link=function(re,ae,he){if(re=se(this.options.sanitize,this.options.baseUrl,re),re===null)return he;var me='<a href="'+j(re)+'"';return ae&&(me+=' title="'+ae+'"'),me+=">"+he+"</a>",me},Se.image=function(re,ae,he){if(re=se(this.options.sanitize,this.options.baseUrl,re),re===null)return he;var me='<img src="'+re+'" alt="'+he+'"';return ae&&(me+=' title="'+ae+'"'),me+=this.options.xhtml?"/>":">",me},Se.text=function(re){return re},Pe}(),fe=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(re){return re},Se.em=function(re){return re},Se.codespan=function(re){return re},Se.del=function(re){return re},Se.html=function(re){return re},Se.text=function(re){return re},Se.link=function(re,ae,he){return""+he},Se.image=function(re,ae,he){return""+he},Se.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(re,ae){var he=re,me=0;if(this.seen.hasOwnProperty(he)){me=this.seen[re];do me++,he=re+"-"+me;while(this.seen.hasOwnProperty(he))}return ae||(this.seen[re]=me,this.seen[he]=0),he},Se.slug=function(re,ae){ae===void 0&&(ae={});var he=this.serialize(re);return this.getNextSafeSlug(he,ae.dryrun)},Pe}(),Ne=Z,He=fe,Ge=Te,tt=T.exports.defaults,st=B.unescape,Xe=function(){function Pe(ve){this.options=ve||tt,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Ge}Pe.parse=function(re,ae){var he=new Pe(ae);return he.parse(re)},Pe.parseInline=function(re,ae){var he=new Pe(ae);return he.parseInline(re)};var Se=Pe.prototype;return Se.parse=function(re,ae){ae===void 0&&(ae=!0);var he="",me,Ie,ze,Oe,We,it,ot,ne,ge,te,W,be,ke,qe,Le,dt,bt,Ct,pt,ht=re.length;for(me=0;me<ht;me++){if(te=re[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[te.type]&&(pt=this.options.extensions.renderers[te.type].call({parser:this},te),pt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(te.type))){he+=pt||"";continue}switch(te.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(te.tokens),te.depth,st(this.parseInline(te.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(te.text,te.lang,te.escaped);continue}case"table":{for(ne="",ot="",Oe=te.header.length,Ie=0;Ie<Oe;Ie++)ot+=this.renderer.tablecell(this.parseInline(te.header[Ie].tokens),{header:!0,align:te.align[Ie]});for(ne+=this.renderer.tablerow(ot),ge="",Oe=te.rows.length,Ie=0;Ie<Oe;Ie++){for(it=te.rows[Ie],ot="",We=it.length,ze=0;ze<We;ze++)ot+=this.renderer.tablecell(this.parseInline(it[ze].tokens),{header:!1,align:te.align[ze]});ge+=this.renderer.tablerow(ot)}he+=this.renderer.table(ne,ge);continue}case"blockquote":{ge=this.parse(te.tokens),he+=this.renderer.blockquote(ge);continue}case"list":{for(W=te.ordered,be=te.start,ke=te.loose,Oe=te.items.length,ge="",Ie=0;Ie<Oe;Ie++)Le=te.items[Ie],dt=Le.checked,bt=Le.task,qe="",Le.task&&(Ct=this.renderer.checkbox(dt),ke?Le.tokens.length>0&&Le.tokens[0].type==="paragraph"?(Le.tokens[0].text=Ct+" "+Le.tokens[0].text,Le.tokens[0].tokens&&Le.tokens[0].tokens.length>0&&Le.tokens[0].tokens[0].type==="text"&&(Le.tokens[0].tokens[0].text=Ct+" "+Le.tokens[0].tokens[0].text)):Le.tokens.unshift({type:"text",text:Ct}):qe+=Ct),qe+=this.parse(Le.tokens,ke),ge+=this.renderer.listitem(qe,bt,dt);he+=this.renderer.list(ge,W,be);continue}case"html":{he+=this.renderer.html(te.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(te.tokens));continue}case"text":{for(ge=te.tokens?this.parseInline(te.tokens):te.text;me+1<ht&&re[me+1].type==="text";)te=re[++me],ge+=`
`+(te.tokens?this.parseInline(te.tokens):te.text);he+=ae?this.renderer.paragraph(ge):ge;continue}default:{var vt='Token with "'+te.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return he},Se.parseInline=function(re,ae){ae=ae||this.renderer;var he="",me,Ie,ze,Oe=re.length;for(me=0;me<Oe;me++){if(Ie=re[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(ze=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){he+=ze||"";continue}switch(Ie.type){case"escape":{he+=ae.text(Ie.text);break}case"html":{he+=ae.html(Ie.text);break}case"link":{he+=ae.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ae));break}case"image":{he+=ae.image(Ie.href,Ie.title,Ie.text);break}case"strong":{he+=ae.strong(this.parseInline(Ie.tokens,ae));break}case"em":{he+=ae.em(this.parseInline(Ie.tokens,ae));break}case"codespan":{he+=ae.codespan(Ie.text);break}case"br":{he+=ae.br();break}case"del":{he+=ae.del(this.parseInline(Ie.tokens,ae));break}case"text":{he+=ae.text(Ie.text);break}default:{var We='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(We);return}else throw new Error(We)}}}return he},Pe}(),rt=K,De=Xe,gt=ue,V=Z,J=fe,pe=Te,Ue=B.merge,Ye=B.checkSanitizeDeprecation,Je=B.escape,lt=T.exports.getDefaults,Et=T.exports.changeDefaults,It=T.exports.defaults;function et(Pe,Se,ve){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(ve=Se,Se=null),Se=Ue({},et.defaults,Se||{}),Ye(Se),ve){var re=Se.highlight,ae;try{ae=rt.lex(Pe,Se)}catch(ze){return ve(ze)}var he=function(Oe){var We;if(!Oe)try{Se.walkTokens&&et.walkTokens(ae,Se.walkTokens),We=De.parse(ae,Se)}catch(it){Oe=it}return Se.highlight=re,Oe?ve(Oe):ve(null,We)};if(!re||re.length<3||(delete Se.highlight,!ae.length))return he();var me=0;et.walkTokens(ae,function(ze){ze.type==="code"&&(me++,setTimeout(function(){re(ze.text,ze.lang,function(Oe,We){if(Oe)return he(Oe);We!=null&&We!==ze.text&&(ze.text=We,ze.escaped=!0),me--,me===0&&he()})},0))}),me===0&&he();return}try{var Ie=rt.lex(Pe,Se);return Se.walkTokens&&et.walkTokens(Ie,Se.walkTokens),De.parse(Ie,Se)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+Je(ze.message+"",!0)+"</pre>";throw ze}}et.options=et.setOptions=function(Pe){return Ue(et.defaults,Pe),Et(et.defaults),et},et.getDefaults=lt,et.defaults=It,et.use=function(){for(var Pe=this,Se=arguments.length,ve=new Array(Se),re=0;re<Se;re++)ve[re]=arguments[re];var ae=Ue.apply(void 0,[{}].concat(ve)),he=et.defaults.extensions||{renderers:{},childTokens:{}},me;ve.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Oe){if(!Oe.name)throw new Error("extension name required");if(Oe.renderer){var We=he.renderers?he.renderers[Oe.name]:null;We?he.renderers[Oe.name]=function(){for(var it=arguments.length,ot=new Array(it),ne=0;ne<it;ne++)ot[ne]=arguments[ne];var ge=Oe.renderer.apply(this,ot);return ge===!1&&(ge=We.apply(this,ot)),ge}:he.renderers[Oe.name]=Oe.renderer}if(Oe.tokenizer){if(!Oe.level||Oe.level!=="block"&&Oe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Oe.level]?he[Oe.level].unshift(Oe.tokenizer):he[Oe.level]=[Oe.tokenizer],Oe.start&&(Oe.level==="block"?he.startBlock?he.startBlock.push(Oe.start):he.startBlock=[Oe.start]:Oe.level==="inline"&&(he.startInline?he.startInline.push(Oe.start):he.startInline=[Oe.start]))}Oe.childTokens&&(he.childTokens[Oe.name]=Oe.childTokens)})),Ie.renderer&&function(){var Oe=et.defaults.renderer||new V,We=function(ne){var ge=Oe[ne];Oe[ne]=function(){for(var te=arguments.length,W=new Array(te),be=0;be<te;be++)W[be]=arguments[be];var ke=Ie.renderer[ne].apply(Oe,W);return ke===!1&&(ke=ge.apply(Oe,W)),ke}};for(var it in Ie.renderer)We(it);ae.renderer=Oe}(),Ie.tokenizer&&function(){var Oe=et.defaults.tokenizer||new gt,We=function(ne){var ge=Oe[ne];Oe[ne]=function(){for(var te=arguments.length,W=new Array(te),be=0;be<te;be++)W[be]=arguments[be];var ke=Ie.tokenizer[ne].apply(Oe,W);return ke===!1&&(ke=ge.apply(Oe,W)),ke}};for(var it in Ie.tokenizer)We(it);ae.tokenizer=Oe}(),Ie.walkTokens){var ze=et.defaults.walkTokens;ae.walkTokens=function(Oe){Ie.walkTokens.call(Pe,Oe),ze&&ze(Oe)}}me&&(ae.extensions=he),et.setOptions(ae)})},et.walkTokens=function(Pe,Se){for(var ve=function(){var me=ae.value;switch(Se(me),me.type){case"table":{for(var Ie=w(me.header),ze;!(ze=Ie()).done;){var Oe=ze.value;et.walkTokens(Oe.tokens,Se)}for(var We=w(me.rows),it;!(it=We()).done;)for(var ot=it.value,ne=w(ot),ge;!(ge=ne()).done;){var te=ge.value;et.walkTokens(te.tokens,Se)}break}case"list":{et.walkTokens(me.items,Se);break}default:et.defaults.extensions&&et.defaults.extensions.childTokens&&et.defaults.extensions.childTokens[me.type]?et.defaults.extensions.childTokens[me.type].forEach(function(W){et.walkTokens(me[W],Se)}):me.tokens&&et.walkTokens(me.tokens,Se)}},re=w(Pe),ae;!(ae=re()).done;)ve()},et.parseInline=function(Pe,Se){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=Ue({},et.defaults,Se||{}),Ye(Se);try{var ve=rt.lexInline(Pe,Se);return Se.walkTokens&&et.walkTokens(ve,Se.walkTokens),De.parseInline(ve,Se)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+Je(re.message+"",!0)+"</pre>";throw re}},et.Parser=De,et.parser=De.parse,et.Renderer=V,et.TextRenderer=J,et.Lexer=rt,et.lexer=rt.lex,et.Tokenizer=gt,et.Slugger=pe,et.parse=et;var Tt=et;return Tt}),define(Ee[76],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(t,A,S){return Math.min(Math.max(t,A),S)}e.clamp=a;function F(t,A){return(A+t%A)%A}e.rot=F;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class T{constructor(){this._n=1,this._val=0}update(A){return this._val=this._val+(A-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function oe(w){const T=[];typeof w=="number"&&T.push("code/timeOrigin",w);function t(S){T.push(S,Date.now())}function A(){const S=[];for(let C=0;C<T.length;C+=2)S.push({name:T[C],startTime:T[C+1]});return S}return{mark:t,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const t of performance.getEntriesByType("mark"))T.push({name:t.name,startTime:Math.round(w+t.startTime)});return T}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function a(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=a(F))}(),define(Ee[53],_e([0,1,3]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new a.Emitter}add(R){const _=this._icons.get(R.id);_?R.description?_.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const w=new F;e.iconRegistry=w;function T(C){return C?C.replace(/\$\((.*?)\)/g,(R,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=T;class t{constructor(R,_,n){this.id=R,this.definition=_,this.description=n,w.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=t,t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function A(C,R){const _=["codicon","codicon-"+C];return R&&_.push("codicon-modifier-"+R),_}e.getClassNamesArray=A;var S;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function _(s){if(s instanceof t)return["codicon","codicon-"+s.id];const u=R.exec(s.id);if(!u)return _(t.error);let[,g,k]=u;const b=["codicon","codicon-"+g];return k&&b.push("codicon-modifier-"+k.substr(1)),b}C.asClassNameArray=_;function n(s){return _(s).join(" ")}C.asClassName=n;function d(s){return"."+_(s).join(".")}C.asCSSSelector=d})(S=e.CSSIcon||(e.CSSIcon={}))}),define(Ee[102],_e([0,1,15,6]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(m){const f=m;return f?[f.on,f.pause,f.resume,f.destroy].every(P=>typeof P=="function"):!1}e.isReadableStream=w;function T(m){const f=m;return f?w(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=T;function t(m,f){return new A(m,f)}e.newWriteableStream=t;class A{constructor(f,P){this.reducer=f,this.options=P,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(P=>this.pendingWritePromises.push(P))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(P=>P(f))}emitError(f){this.listeners.error.length===0?(0,a.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(P=>P(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,P){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(P),this.resume();break;case"end":this.listeners.end.push(P),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(P),this.state.flowing&&this.flowErrors();break}}removeListener(f,P){if(this.state.destroyed)return;let l;switch(f){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const M=l.indexOf(P);M>=0&&l.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const P=[...this.pendingWritePromises];this.pendingWritePromises.length=0,P.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(m,f){const P=[];let l;for(;(l=m.read())!==null;)P.push(l);return f(P)}e.consumeReadable=S;function C(m,f,P){const l=[];let M;for(;(M=m.read())!==null&&l.length<P;)l.push(M);return M===null&&l.length>0?f(l):{read:()=>{if(l.length>0)return l.shift();if(typeof M!="undefined"){const r=M;return M=void 0,r}return m.read()}}}e.peekReadable=C;function R(m,f){return new Promise((P,l)=>{const M=[];_(m,{onData:r=>{f&&M.push(r)},onError:r=>{f?l(r):P(void 0)},onEnd:()=>{P(f?f(M):void 0)}})})}e.consumeStream=R;function _(m,f){m.on("error",P=>f.onError(P)),m.on("end",()=>f.onEnd()),m.on("data",P=>f.onData(P))}e.listenStream=_;function n(m,f){return new Promise((P,l)=>{const M=new F.DisposableStore,r=[],i=o=>{if(r.push(o),r.length>f)return M.dispose(),m.pause(),P({stream:m,buffer:r,ended:!1})},p=o=>l(o),h=()=>P({stream:m,buffer:r,ended:!0});M.add((0,F.toDisposable)(()=>m.removeListener("error",p))),m.on("error",p),M.add((0,F.toDisposable)(()=>m.removeListener("end",h))),m.on("end",h),M.add((0,F.toDisposable)(()=>m.removeListener("data",i))),m.on("data",i)})}e.peekStream=n;function d(m,f){const P=t(f);return P.end(m),P}e.toStream=d;function s(){const m=t(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=s;function u(m){let f=!1;return{read:()=>f?null:(f=!0,m)}}e.toReadable=u;function g(m,f,P){const l=t(P);return _(m,{onData:M=>l.write(f.data(M)),onError:M=>l.error(f.error?f.error(M):M),onEnd:()=>l.end()}),l}e.transform=g;function k(m,f,P){let l=!1;return{read:()=>{const M=f.read();return l?M:(l=!0,M!==null?P([m,M]):m)}}}e.prefixedReadable=k;function b(m,f,P){let l=!1;const M=t(P);return _(f,{onData:r=>l?M.write(r):(l=!0,M.write(P([m,r]))),onError:r=>M.error(r),onEnd:()=>{l||(l=!0,M.write(m)),M.end()}}),M}e.prefixedStream=b}),define(Ee[22],_e([0,1,102]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let w,T;class t{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return F?new t(Buffer.allocUnsafe(i)):new t(new Uint8Array(i))}static wrap(i){return F&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new t(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&F?new t(Buffer.from(i)):(w||(w=new TextEncoder),new t(w.encode(i)))}static concat(i,p){if(typeof p=="undefined"){p=0;for(let v=0,c=i.length;v<c;v++)p+=i[v].byteLength}const h=t.alloc(p);let o=0;for(let v=0,c=i.length;v<c;v++){const E=i[v];h.set(E,o),o+=E.byteLength}return h}toString(){return F?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(i,p){return new t(this.buffer.subarray(i,p))}set(i,p){i instanceof t?this.buffer.set(i.buffer,p):this.buffer.set(i,p)}readUInt32BE(i){return C(this.buffer,i)}writeUInt32BE(i,p){R(this.buffer,i,p)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,p){n(this.buffer,i,p)}readUInt8(i){return d(this.buffer,i)}writeUInt8(i,p){s(this.buffer,i,p)}}e.VSBuffer=t;function A(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=A;function S(r,i,p){r[p+0]=i&255,i=i>>>8,r[p+1]=i&255}e.writeUInt16LE=S;function C(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=C;function R(r,i,p){r[p+3]=i,i=i>>>8,r[p+2]=i,i=i>>>8,r[p+1]=i,i=i>>>8,r[p]=i}e.writeUInt32BE=R;function _(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=_;function n(r,i,p){r[p+0]=i&255,i=i>>>8,r[p+1]=i&255,i=i>>>8,r[p+2]=i&255,i=i>>>8,r[p+3]=i&255}e.writeUInt32LE=n;function d(r,i){return r[i]}e.readUInt8=d;function s(r,i,p){r[p]=i}e.writeUInt8=s;function u(r){return a.consumeReadable(r,i=>t.concat(i))}e.readableToBuffer=u;function g(r){return a.toReadable(r)}e.bufferToReadable=g;function k(r){return a.consumeStream(r,i=>t.concat(i))}e.streamToBuffer=k;async function b(r){return r.ended?t.concat(r.buffer):t.concat([...r.buffer,await k(r.stream)])}e.bufferedStreamToBuffer=b;function m(r){return a.toStream(r,i=>t.concat(i))}e.bufferToStream=m;function f(r){return a.transform(r,{data:i=>typeof i=="string"?t.fromString(i):t.wrap(i)},i=>t.concat(i))}e.streamToBufferReadableStream=f;function P(r){return a.newWriteableStream(i=>t.concat(i),r)}e.newWriteableBufferStream=P;function l(r,i){return a.prefixedReadable(r,i,p=>t.concat(p))}e.prefixedBufferReadable=l;function M(r,i){return a.prefixedStream(r,i,p=>t.concat(p))}e.prefixedBufferStream=M});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[21],_e([0,1,16,9]),function(oe,e,a,F){"use strict";var w,T,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(r,i,p){let h=r.get(i);return h===void 0&&(h=p,r.set(i,h)),h}e.getOrSet=A;function S(r){const i=[];return r.forEach((p,h)=>{i.push(`${h} => ${p}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=S;function C(r){const i=[];return r.forEach(p=>{i.push(p)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=C;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const p=i.charCodeAt(0),h=this._value.charCodeAt(this._pos);return p-h}value(){return this._value[this._pos]}}e.StringIterator=R;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,F.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(i=!0,p=!0){this._splitOnBackslash=i,this._caseSensitive=p}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,F.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var d;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(d||(d={}));class s{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,F.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=s;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(g||(g={}));class k{constructor(i){this._iter=i}static forUris(i=()=>!1){return new k(new s(i))}static forPaths(){return new k(new n)}static forStrings(){return new k(new R)}static forConfigKeys(){return new k(new _)}clear(){this._root=void 0}fill(i,p){if(p){const h=p.slice(0);(0,a.shuffle)(h);for(let o of h)this.set(o,i)}else{const h=i.slice(0);(0,a.shuffle)(h);for(let o of h)this.set(o[0],o[1])}}set(i,p){const h=this._iter.reset(i);let o;this._root||(this._root=new u,this._root.segment=h.value());const v=[];for(o=this._root;;){const E=h.cmp(o.segment);if(E>0)o.left||(o.left=new u,o.left.segment=h.value()),v.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new u,o.right.segment=h.value()),v.push([1,o]),o=o.right;else if(h.hasNext())h.next(),o.mid||(o.mid=new u,o.mid.segment=h.value()),v.push([0,o]),o=o.mid;else break}const c=o.value;o.value=p,o.key=i;for(let E=v.length-1;E>=0;E--){const I=v[E][1];I.updateHeight();const D=I.balanceFactor();if(D<-1||D>1){const B=v[E][0],L=v[E+1][0];if(B===1&&L===1)v[E][1]=I.rotateLeft();else if(B===-1&&L===-1)v[E][1]=I.rotateRight();else if(B===1&&L===-1)I.right=v[E+1][1]=v[E+1][1].rotateRight(),v[E][1]=I.rotateLeft();else if(B===-1&&L===1)I.left=v[E+1][1]=v[E+1][1].rotateLeft(),v[E][1]=I.rotateRight();else throw new Error;if(E>0)switch(v[E-1][0]){case-1:v[E-1][1].left=v[E][1];break;case 1:v[E-1][1].right=v[E][1];break;case 0:v[E-1][1].mid=v[E][1];break}else this._root=v[0][1]}}return c}get(i){return this._getNode(i)?.value}_getNode(i){const p=this._iter.reset(i);let h=this._root;for(;h;){const o=p.cmp(h.segment);if(o>0)h=h.left;else if(o<0)h=h.right;else if(p.hasNext())p.next(),h=h.mid;else break}return h}has(i){const p=this._getNode(i);return!(p?.value===void 0&&p?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,p){const h=this._iter.reset(i),o=[];let v=this._root;for(;v;){const c=h.cmp(v.segment);if(c>0)o.push([-1,v]),v=v.left;else if(c<0)o.push([1,v]),v=v.right;else if(h.hasNext())h.next(),o.push([0,v]),v=v.mid;else break}if(!!v){if(p?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const c=this._min(v.right),{key:E,value:I,segment:D}=c;this._delete(c.key,!1),v.key=E,v.value=I,v.segment=D}else{const c=v.left??v.right;if(o.length>0){const[E,I]=o[o.length-1];switch(E){case-1:I.left=c;break;case 0:I.mid=c;break;case 1:I.right=c;break}}else this._root=c}for(let c=o.length-1;c>=0;c--){const E=o[c][1];E.updateHeight();const I=E.balanceFactor();if(I>1?(E.right.balanceFactor()>=0||(E.right=o[c+1][1]=o[c+1][1].rotateRight()),o[c][1]=E.rotateLeft()):I<-1&&(E.left.balanceFactor()<=0||(E.left=o[c+1][1]=o[c+1][1].rotateLeft()),o[c][1]=E.rotateRight()),c>0)switch(o[c-1][0]){case-1:o[c-1][1].left=o[c][1];break;case 1:o[c-1][1].right=o[c][1];break;case 0:o[c-1][1].mid=o[c][1];break}else this._root=o[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const p=this._iter.reset(i);let h=this._root,o;for(;h;){const v=p.cmp(h.segment);if(v>0)h=h.left;else if(v<0)h=h.right;else if(p.hasNext())p.next(),o=h.value||o,h=h.mid;else break}return h&&h.value||o}findSuperstr(i){const p=this._iter.reset(i);let h=this._root;for(;h;){const o=p.cmp(h.segment);if(o>0)h=h.left;else if(o<0)h=h.right;else if(p.hasNext())p.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(i){for(const[p,h]of this)i(h,p)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=p=>{if(!p)return!0;const h=p.balanceFactor();return h<-1||h>1?!1:i(p.left)&&i(p.right)};return i(this._root)}}e.TernarySearchTree=k;class b{constructor(i,p){this.uri=i,this.value=p}}class m{constructor(i,p){this[w]="ResourceMap",i instanceof m?(this.map=new Map(i.map),this.toKey=p??m.defaultToKey):(this.map=new Map,this.toKey=i??m.defaultToKey)}set(i,p){return this.map.set(this.toKey(i),new b(i,p)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,p){typeof p!="undefined"&&(i=i.bind(p));for(let[h,o]of this.map)i(o.value,o.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=m,m.defaultToKey=r=>r.toString();var f;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class P{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,p=0){const h=this._map.get(i);if(!!h)return p!==0&&this.touch(h,p),h.value}set(i,p,h=0){let o=this._map.get(i);if(o)o.value=p,h!==0&&this.touch(o,h);else{switch(o={key:i,value:p,next:void 0,previous:void 0},h){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const p=this._map.get(i);if(!!p)return this._map.delete(i),this.removeItem(p),this._size--,p.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,p){const h=this._state;let o=this._head;for(;o;){if(p?i.bind(p)(o.value,o.key,this):i(o.value,o.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,p=this._state;let h=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:h.key,done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return o}values(){const i=this,p=this._state;let h=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:h.value,done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return o}entries(){const i=this,p=this._state;let h=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:[h.key,h.value],done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return o}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let p=this._head,h=this.size;for(;p&&h>i;)this._map.delete(p.key),p=p.next,h--;this._head=p,this._size=h,p&&(p.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const p=i.next,h=i.previous;if(!p||!h)throw new Error("Invalid list");p.previous=h,h.next=p}i.next=void 0,i.previous=void 0,this._state++}touch(i,p){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(i===this._head)return;const h=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(h.previous=o,o.next=h),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(p===2){if(i===this._tail)return;const h=i.next,o=i.previous;i===this._head?(h.previous=void 0,this._head=h):(h.previous=o,o.next=h),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((p,h)=>{i.push([h,p])}),i}fromJSON(i){this.clear();for(const[p,h]of i)this.set(p,h)}}e.LinkedMap=P;class l extends P{constructor(i,p=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,p),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,p=2){return super.get(i,p)}peek(i){return super.get(i,0)}set(i,p){return super.set(i,p,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class M{constructor(i){t.set(this,void 0),Ze(this,t,i,"f")}get size(){return Ae(this,t,"f").size}forEach(i,p){Ae(this,t,"f").forEach(i,p)}get(i){return Ae(this,t,"f").get(i)}has(i){return Ae(this,t,"f").has(i)}entries(){return Ae(this,t,"f").entries()}keys(){return Ae(this,t,"f").keys()}values(){return Ae(this,t,"f").values()}[(t=new WeakMap,Symbol.iterator)](){return Ae(this,t,"f").entries()}}e.ReadonlyMapView=M}),define(Ee[103],_e([0,1,21,9]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...j){return function(Z,fe){for(let Te=0,Ne=j.length;Te<Ne;Te++){const He=j[Te](Z,fe);if(He)return He}return null}}e.or=w,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(j,Z,fe){if(!fe||fe.length<Z.length)return null;let Te;return j?Te=F.startsWithIgnoreCase(fe,Z):Te=fe.indexOf(Z)===0,Te?Z.length>0?[{start:0,end:Z.length}]:[]:null}function t(j,Z){const fe=Z.toLowerCase().indexOf(j.toLowerCase());return fe===-1?null:[{start:fe,end:fe+j.length}]}e.matchesContiguousSubString=t;function A(j,Z){return S(j.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=A;function S(j,Z,fe,Te){if(fe===j.length)return[];if(Te===Z.length)return null;if(j[fe]===Z[Te]){let Ne=null;return(Ne=S(j,Z,fe+1,Te+1))?k({start:Te,end:Te+1},Ne):null}return S(j,Z,fe,Te+1)}function C(j){return 97<=j&&j<=122}function R(j){return 65<=j&&j<=90}e.isUpper=R;function _(j){return 48<=j&&j<=57}function n(j){return j===32||j===9||j===10||j===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(j=>d.add(j.charCodeAt(0)));function s(j){return n(j)||d.has(j)}function u(j,Z){return j===Z||s(j)&&s(Z)}function g(j){return C(j)||R(j)||_(j)}function k(j,Z){return Z.length===0?Z=[j]:j.end===Z[0].start?Z[0].start=j.start:Z.unshift(j),Z}function b(j,Z){for(let fe=Z;fe<j.length;fe++){const Te=j.charCodeAt(fe);if(R(Te)||_(Te)||fe>0&&!g(j.charCodeAt(fe-1)))return fe}return j.length}function m(j,Z,fe,Te){if(fe===j.length)return[];if(Te===Z.length)return null;if(j[fe]!==Z[Te].toLowerCase())return null;{let Ne=null,He=Te+1;for(Ne=m(j,Z,fe+1,Te+1);!Ne&&(He=b(Z,He))<Z.length;)Ne=m(j,Z,fe+1,He),He++;return Ne===null?null:k({start:Te,end:Te+1},Ne)}}function f(j){let Z=0,fe=0,Te=0,Ne=0,He=0;for(let rt=0;rt<j.length;rt++)He=j.charCodeAt(rt),R(He)&&Z++,C(He)&&fe++,g(He)&&Te++,_(He)&&Ne++;const Ge=Z/j.length,tt=fe/j.length,st=Te/j.length,Xe=Ne/j.length;return{upperPercent:Ge,lowerPercent:tt,alphaPercent:st,numericPercent:Xe}}function P(j){const{upperPercent:Z,lowerPercent:fe}=j;return fe===0&&Z>.6}function l(j){const{upperPercent:Z,lowerPercent:fe,alphaPercent:Te,numericPercent:Ne}=j;return fe>.2&&Z<.8&&Te>.6&&Ne<.2}function M(j){let Z=0,fe=0,Te=0,Ne=0;for(let He=0;He<j.length;He++)Te=j.charCodeAt(He),R(Te)&&Z++,C(Te)&&fe++,n(Te)&&Ne++;return(Z===0||fe===0)&&Ne===0?j.length<=30:Z<=5}function r(j,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!M(j)||Z.length>60)return null;const fe=f(Z);if(!l(fe)){if(!P(fe))return null;Z=Z.toLowerCase()}let Te=null,Ne=0;for(j=j.toLowerCase();Ne<Z.length&&(Te=m(j,Z,0,Ne))===null;)Ne=b(Z,Ne+1);return Te}e.matchesCamelCase=r;function i(j,Z,fe=!1){if(!Z||Z.length===0)return null;let Te=null,Ne=0;for(j=j.toLowerCase(),Z=Z.toLowerCase();Ne<Z.length&&(Te=p(j,Z,0,Ne,fe))===null;)Ne=h(Z,Ne+1);return Te}e.matchesWords=i;function p(j,Z,fe,Te,Ne){if(fe===j.length)return[];if(Te===Z.length)return null;if(u(j.charCodeAt(fe),Z.charCodeAt(Te))){let He=null,Ge=Te+1;if(He=p(j,Z,fe+1,Te+1,Ne),!Ne)for(;!He&&(Ge=h(Z,Ge))<Z.length;)He=p(j,Z,fe+1,Ge,Ne),Ge++;return He===null?null:k({start:Te,end:Te+1},He)}else return null}function h(j,Z){for(let fe=Z;fe<j.length;fe++)if(s(j.charCodeAt(fe))||fe>0&&s(j.charCodeAt(fe-1)))return fe;return j.length}const o=w(e.matchesPrefix,r,t),v=w(e.matchesPrefix,r,A),c=new a.LRUCache(1e4);function E(j,Z,fe=!1){if(typeof j!="string"||typeof Z!="string")return null;let Te=c.get(j);Te||(Te=new RegExp(F.convertSimple2RegExpPattern(j),"i"),c.set(j,Te));const Ne=Te.exec(Z);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:fe?v(j,Z):o(j,Z)}e.matchesFuzzy=E;function I(j,Z){const fe=Ke(j,j.toLowerCase(),0,Z,Z.toLowerCase(),0,!0);return fe?B(fe):null}e.matchesFuzzy2=I;function D(j,Z,fe,Te,Ne,He){const Ge=Math.min(13,j.length);for(;fe<Ge;fe++){const tt=Ke(j,Z,fe,Te,Ne,He,!1);if(tt)return tt}return[0,He]}e.anyScore=D;function B(j){if(typeof j=="undefined")return[];const Z=[],fe=j[1];for(let Te=j.length-1;Te>1;Te--){const Ne=j[Te]+fe,He=Z[Z.length-1];He&&He.end===Ne?He.end=Ne+1:Z.push({start:Ne,end:Ne+1})}return Z}e.createMatches=B;const L=128;function y(){const j=[],Z=[];for(let fe=0;fe<=L;fe++)Z[fe]=0;for(let fe=0;fe<=L;fe++)j.push(Z.slice(0));return j}function x(j){const Z=[];for(let fe=0;fe<=j;fe++)Z[fe]=0;return Z}const N=x(2*L),z=x(2*L),H=y(),q=y(),ue=y(),G=!1;function ce(j,Z,fe,Te,Ne){function He(tt,st,Xe=" "){for(;tt.length<st;)tt=Xe+tt;return tt}let Ge=` |   |${Te.split("").map(tt=>He(tt,3)).join("|")}
`;for(let tt=0;tt<=fe;tt++)tt===0?Ge+=" |":Ge+=`${Z[tt-1]}|`,Ge+=j[tt].slice(0,Ne+1).map(st=>He(st.toString(),3)).join("|")+`
`;return Ge}function de(j,Z,fe,Te){j=j.substr(Z),fe=fe.substr(Te),console.log(ce(q,j,j.length,fe,fe.length)),console.log(ce(ue,j,j.length,fe,fe.length)),console.log(ce(H,j,j.length,fe,fe.length))}function Q(j,Z){if(Z<0||Z>=j.length)return!1;const fe=j.codePointAt(Z);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(fe)}}function ie(j,Z){if(Z<0||Z>=j.length)return!1;switch(j.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function we(j,Z,fe){return Z[j]!==fe[j]}function Me(j,Z,fe,Te,Ne,He,Ge=!1){for(;Z<fe&&Ne<He;)j[Z]===Te[Ne]&&(Ge&&(N[Z]=Ne),Z+=1),Ne+=1;return Z===fe}e.isPatternInWord=Me;var Fe;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var Be;(function(j){j.Default=[-100,0];function Z(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}j.isDefault=Z})(Be=e.FuzzyScore||(e.FuzzyScore={}));function Ke(j,Z,fe,Te,Ne,He,Ge){const tt=j.length>L?L:j.length,st=Te.length>L?L:Te.length;if(fe>=tt||He>=st||tt-fe>st-He||!Me(Z,fe,tt,Ne,He,st,!0))return;je(tt,st,fe,He,Z,Ne);let Xe=1,rt=1,De=fe,gt=He;const V=[!1];for(Xe=1,De=fe;De<tt;Xe++,De++){const Je=N[De],lt=z[De],Et=De+1<tt?z[De+1]:st;for(rt=Je-He+1,gt=Je;gt<Et;rt++,gt++){let It=Number.MIN_SAFE_INTEGER,et=!1;gt<=lt&&(It=Qe(j,Z,De,fe,Te,Ne,gt,st,He,H[Xe-1][rt-1]===0,V));let Tt=0;It!==Number.MAX_SAFE_INTEGER&&(et=!0,Tt=It+q[Xe-1][rt-1]);const Pe=gt>Je,Se=Pe?q[Xe][rt-1]+(H[Xe][rt-1]>0?-5:0):0,ve=gt>Je+1&&H[Xe][rt-1]>0,re=ve?q[Xe][rt-2]+(H[Xe][rt-2]>0?-5:0):0;if(ve&&(!Pe||re>=Se)&&(!et||re>=Tt))q[Xe][rt]=re,ue[Xe][rt]=3,H[Xe][rt]=0;else if(Pe&&(!et||Se>=Tt))q[Xe][rt]=Se,ue[Xe][rt]=2,H[Xe][rt]=0;else if(et)q[Xe][rt]=Tt,ue[Xe][rt]=1,H[Xe][rt]=H[Xe-1][rt-1]+1;else throw new Error("not possible")}}if(G&&de(j,fe,Te,He),!V[0]&&!Ge)return;Xe--,rt--;const J=[q[Xe][rt],He];let pe=0,Ue=0;for(;Xe>=1;){let Je=rt;do{const lt=ue[Xe][Je];if(lt===3)Je=Je-2;else if(lt===2)Je=Je-1;else break}while(Je>=1);pe>1&&Z[fe+Xe-1]===Ne[He+rt-1]&&!we(Je+He-1,Te,Ne)&&pe+1>H[Xe][Je]&&(Je=rt),Je===rt?pe++:pe=1,Ue||(Ue=Je),Xe--,rt=Je-1,J.push(rt)}st===tt&&(J[0]+=2);const Ye=Ue-tt;return J[0]-=Ye,J}e.fuzzyScore=Ke;function je(j,Z,fe,Te,Ne,He){let Ge=j-1,tt=Z-1;for(;Ge>=fe&&tt>=Te;)Ne[Ge]===He[tt]&&(z[Ge]=tt,Ge--),tt--}function Qe(j,Z,fe,Te,Ne,He,Ge,tt,st,Xe,rt){if(Z[fe]!==He[Ge])return Number.MIN_SAFE_INTEGER;let De=1,gt=!1;return Ge===fe-Te?De=j[fe]===Ne[Ge]?7:5:we(Ge,Ne,He)&&(Ge===0||!we(Ge-1,Ne,He))?(De=j[fe]===Ne[Ge]?7:5,gt=!0):Q(He,Ge)&&(Ge===0||!Q(He,Ge-1))?De=5:(Q(He,Ge-1)||ie(He,Ge-1))&&(De=5,gt=!0),De>1&&fe===Te&&(rt[0]=!0),gt||(gt=we(Ge,Ne,He)||Q(He,Ge-1)||ie(He,Ge-1)),fe===Te?Ge>st&&(De-=gt?3:5):Xe?De+=gt?2:0:De+=gt?0:1,Ge+1===tt&&(De-=gt?3:5),De}function $(j,Z,fe,Te,Ne,He,Ge){return X(j,Z,fe,Te,Ne,He,!0,Ge)}e.fuzzyScoreGracefulAggressive=$;function K(j,Z,fe,Te,Ne,He,Ge){return X(j,Z,fe,Te,Ne,He,!1,Ge)}e.fuzzyScoreGraceful=K;function X(j,Z,fe,Te,Ne,He,Ge,tt){let st=Ke(j,Z,fe,Te,Ne,He,tt);if(st&&!Ge)return st;if(j.length>=3){const Xe=Math.min(7,j.length-1);for(let rt=fe+1;rt<Xe;rt++){const De=se(j,rt);if(De){const gt=Ke(De,De.toLowerCase(),fe,Te,Ne,He,tt);gt&&(gt[0]-=3,(!st||gt[0]>st[0])&&(st=gt))}}}return st}function se(j,Z){if(Z+1>=j.length)return;const fe=j[Z],Te=j[Z+1];if(fe!==Te)return j.slice(0,Z)+Te+fe+j.slice(Z+2)}}),define(Ee[104],_e([0,1,53,103,9]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),t=new RegExp(a.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${T.source}`,"g");function S(g){return g.replace(A,(k,b)=>b?k:`\\${k}`)}e.escapeIcons=S;const C=new RegExp(`\\\\${T.source}`,"g");function R(g){return g.replace(C,k=>`\\${k}`)}e.markdownEscapeEscapedIcons=R;const _=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function n(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(_,(k,b,m,f)=>m?k:b||f||"")}e.stripIcons=n;function d(g){const k=g.indexOf(e.iconStartMarker);return k===-1?{text:g}:s(g,k)}e.parseLabelWithIcons=d;function s(g,k){const b=[];let m="";function f(o){if(o){m+=o;for(const v of o)b.push(M)}}let P=-1,l="",M=0,r,i,p=k;const h=g.length;for(f(g.substr(0,k));p<h;)r=g[p],i=g[p+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(P=p,f(l),l=e.iconStartMarker,p++):r===")"&&P!==-1?(M+=p-P+1,P=-1,l=""):P!==-1?t.test(r)?l+=r:(f(l),P=-1,l=""):f(r),p++;return f(l),{text:m,iconOffsets:b}}function u(g,k,b=!1){const{text:m,iconOffsets:f}=k;if(!f||f.length===0)return(0,F.matchesFuzzy)(g,m,b);const P=(0,w.ltrim)(m," "),l=m.length-P.length,M=(0,F.matchesFuzzy)(g,P,b);if(M)for(const r of M){const i=f[r.start+l]+l;r.start+=i,r.end+=i}return M}e.matchesFuzzyIconAware=u}),define(Ee[77],_e([0,1,15,104]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(d="",s=!1){if(this.value=d,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(d,s=0){return this.value+=C(this.supportThemeIcons?(0,F.escapeIcons)(d):d).replace(/([ \t]+)/g,(u,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,s){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=T;function t(n){return A(n)?!n.value:Array.isArray(n)?n.every(t):!0}e.isEmptyMarkdownString=t;function A(n){return n instanceof T?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function S(n,d){return n===d?!0:!n||!d?!1:n.value===d.value&&n.isTrusted===d.isTrusted&&n.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=S;function C(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function R(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function _(n){const d=[],s=n.split("|").map(g=>g.trim());n=s[0];const u=s[1];if(u){const g=/height=(\d+)/.exec(u),k=/width=(\d+)/.exec(u),b=g?g[1]:"",m=k?k[1]:"",f=isFinite(parseInt(m)),P=isFinite(parseInt(b));f&&d.push(`width="${m}"`),P&&d.push(`height="${b}"`)}return{href:n,dimensions:d}}e.parseHrefAndDimensions=_}),define(Ee[35],_e([0,1,9]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(F||(F={})),function(w){const T="error",t="warning",A="warn",S="info",C="ignore";function R(n){return n?a.equalsIgnoreCase(T,n)?w.Error:a.equalsIgnoreCase(t,n)||a.equalsIgnoreCase(A,n)?w.Warning:a.equalsIgnoreCase(S,n)?w.Info:w.Ignore:w.Ignore}w.fromValue=R;function _(n){switch(n){case w.Error:return T;case w.Warning:return t;case w.Info:return S;default:return C}}w.toString=_}(F||(F={})),e.default=F}),define(Ee[42],_e([0,1,17,23,9,11]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function t(r){return r===47||r===92}e.isPathSeparator=t;function A(r){return r.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=A;function S(r){return r.indexOf("/")===-1&&(r=A(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function C(r,i=a.posix.sep){if(!r)return"";const p=r.length,h=r.charCodeAt(0);if(t(h)){if(t(r.charCodeAt(1))&&!t(r.charCodeAt(2))){let v=3;const c=v;for(;v<p&&!t(r.charCodeAt(v));v++);if(c!==v&&!t(r.charCodeAt(v+1))){for(v+=1;v<p;v++)if(t(r.charCodeAt(v)))return r.slice(0,v+1).replace(/[\\/]/g,i)}}return i}else if(k(h)&&r.charCodeAt(1)===58)return t(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let o=r.indexOf("://");if(o!==-1){for(o+=3;o<p;o++)if(t(r.charCodeAt(o)))return r.slice(0,o+1)}return""}e.getRoot=C;function R(r){if(!F.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let p=2;const h=p;for(;p<r.length&&(i=r.charCodeAt(p),i!==92);p++);return!(h===p||(i=r.charCodeAt(p+1),isNaN(i)||i===92))}e.isUNC=R;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(r,i=F.isWindows){const p=i?_:n;return!(!r||r.length===0||/^\s+$/.test(r)||(p.lastIndex=0,p.test(r))||i&&d.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=s;function u(r,i,p){const h=r===i;return!p||h?h:!r||!i?!1:(0,w.equalsIgnoreCase)(r,i)}e.isEqual=u;function g(r,i,p,h=a.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(p){if(!(0,w.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let v=i.length;return i.charAt(i.length-1)===h&&v--,r.charAt(v)===h}return i.charAt(i.length-1)!==h&&(i+=h),r.indexOf(i)===0}e.isEqualOrParent=g;function k(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=k;function b(r,i){return F.isWindows&&r.endsWith(":")&&(r+=a.sep),(0,a.isAbsolute)(r)||(r=(0,a.join)(i,r)),r=(0,a.normalize)(r),F.isWindows?(r=(0,w.rtrim)(r,a.sep),r.endsWith(":")&&(r+=a.sep)):(r=(0,w.rtrim)(r,a.sep),r||(r=a.sep)),r}e.sanitizeFilePath=b;function m(r){const i=(0,a.normalize)(r);return F.isWindows?r.length>3?!1:f(i)&&(r.length===2||i.charCodeAt(2)===92):i===a.posix.sep}e.isRootOrDriveLetter=m;function f(r,i){return(i!==void 0?i:F.isWindows)?k(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function P(r){return f(r)?r[0]:void 0}e.getDriveLetter=P;function l(r,i,p){return i.length>r.length?-1:r===i?0:(p&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=l;function M(r){const i=r.split(":");let p,h,o;if(i.forEach(v=>{const c=Number(v);(0,T.isNumber)(c)?h===void 0?h=c:o===void 0&&(o=c):p=p?[p,v].join(":"):v}),!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:h!==void 0?h:void 0,column:o!==void 0?o:h!==void 0?1:void 0}}e.parseLineAndColumnAware=M}),define(Ee[54],_e([0,1,22,9,2]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(R){return JSON.stringify(R,S)}e.stringify=T;function t(R){let _=JSON.parse(R);return _=C(_),_}e.parse=t;var A;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext"})(A=e.MarshalledId||(e.MarshalledId={}));function S(R,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,F.regExpFlags)(_)}:_}function C(R,_=0){if(!R||_>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return w.URI.revive(R);case 2:return new RegExp(R.source,R.flags)}if(R instanceof a.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let n=0;n<R.length;++n)R[n]=C(R[n],_+1);else for(const n in R)Object.hasOwnProperty.call(R,n)&&(R[n]=C(R[n],_+1))}return R}e.revive=C}),define(Ee[10],_e([0,1,23,2]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var w;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeInteractive="vscode-interactive",A.vscodeInteractiveInput="vscode-interactive-input",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp",A.vsls="vsls"})(w=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,C,R){this._hosts[S]=C,this._ports[S]=R}setConnectionToken(S,C){this._connectionTokens[S]=C}rewrite(S){if(this._delegate)return this._delegate(S);const C=S.authority;let R=this._hosts[C];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const _=this._ports[C],n=this._connectionTokens[C];let d=`path=${encodeURIComponent(S.path)}`;return typeof n=="string"&&(d+=`&tkn=${encodeURIComponent(n)}`),F.URI.from({scheme:a.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${R}:${_}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new T;class t{asBrowserUri(S,C){const R=this.toUri(S,C);return R.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===w.file&&(a.isNative||typeof a.globals.importScripts=="function"&&a.globals.origin===`${w.vscodeFileResource}://${t.FALLBACK_AUTHORITY}`)?R.with({scheme:w.vscodeFileResource,authority:R.authority||t.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(S,C){const R=this.toUri(S,C);return R.scheme===w.vscodeFileResource?R.with({scheme:w.file,authority:R.authority!==t.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(S,C){return F.URI.isUri(S)?S:F.URI.parse(C.toUrl(S))}}t.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new t}),define(Ee[24],_e([0,1,42,10,17,23,9,2]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(d){return(0,A.uriToFsPath)(d,!0)}e.originalFSPath=S;class C{constructor(s){this._ignorePathCasing=s}compare(s,u,g=!1){return s===u?0:(0,t.compare)(this.getComparisonKey(s,g),this.getComparisonKey(u,g))}isEqual(s,u,g=!1){return s===u?!0:!s||!u?!1:this.getComparisonKey(s,g)===this.getComparisonKey(u,g)}getComparisonKey(s,u=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,u,g=!1){if(s.scheme===u.scheme){if(s.scheme===F.Schemas.file)return a.isEqualOrParent(S(s),S(u),this._ignorePathCasing(s))&&s.query===u.query&&(g||s.fragment===u.fragment);if((0,e.isEqualAuthority)(s.authority,u.authority))return a.isEqualOrParent(s.path,u.path,this._ignorePathCasing(s),"/")&&s.query===u.query&&(g||s.fragment===u.fragment)}return!1}joinPath(s,...u){return A.URI.joinPath(s,...u)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return w.posix.basename(s.path)}extname(s){return w.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let u;return s.scheme===F.Schemas.file?u=A.URI.file(w.dirname(S(s))).path:(u=w.posix.dirname(s.path),s.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),u="/")),s.with({path:u})}normalizePath(s){if(!s.path.length)return s;let u;return s.scheme===F.Schemas.file?u=A.URI.file(w.normalize(S(s))).path:u=w.posix.normalize(s.path),s.with({path:u})}relativePath(s,u){if(s.scheme!==u.scheme||!(0,e.isEqualAuthority)(s.authority,u.authority))return;if(s.scheme===F.Schemas.file){const b=w.relative(S(s),S(u));return T.isWindows?a.toSlashes(b):b}let g=s.path||"/",k=u.path||"/";if(this._ignorePathCasing(s)){let b=0;for(const m=Math.min(g.length,k.length);b<m&&!(g.charCodeAt(b)!==k.charCodeAt(b)&&g.charAt(b).toLowerCase()!==k.charAt(b).toLowerCase());b++);g=k.substr(0,b)+g.substr(b)}return w.posix.relative(g,k)}resolvePath(s,u){if(s.scheme===F.Schemas.file){const g=A.URI.file(w.resolve(S(s),u));return s.with({authority:g.authority,path:g.path})}return u=a.toPosixPath(u),s.with({path:w.posix.resolve(s.path,u)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,u){return s===u||s!==void 0&&u!==void 0&&(0,t.equalsIgnoreCase)(s,u)}hasTrailingPathSeparator(s,u=w.sep){if(s.scheme===F.Schemas.file){const g=S(s);return g.length>a.getRoot(g).length&&g[g.length-1]===u}else{const g=s.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,u=w.sep){return(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,u=w.sep){let g=!1;if(s.scheme===F.Schemas.file){const k=S(s);g=k!==void 0&&k.length===a.getRoot(k).length&&k[k.length-1]===u}else{u="/";const k=s.path;g=k.length===1&&k.charCodeAt(k.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path+"/"}):s}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(d=>d.scheme===F.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new C(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(d,s){const u=[];for(let g=0;g<d.length;g++){const k=s(d[g]);d.some((b,m)=>m===g?!1:(0,e.isEqualOrParent)(k,s(b)))||u.push(d[g])}return u}e.distinctParents=R;var _;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function s(u){const g=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(m=>{const[f,P]=m.split(":");f&&P&&g.set(f,P)});const b=u.path.substring(0,u.path.indexOf(";"));return b&&g.set(d.META_DATA_MIME,b),g}d.parseMetaData=s})(_=e.DataUri||(e.DataUri={}));function n(d,s,u){if(s){let g=d.path;return g&&g[0]!==w.posix.sep&&(g=w.posix.sep+g),d.with({scheme:u,authority:s,path:g})}return d.with({scheme:u})}e.toLocalResource=n}),define(Ee[14],_e([0,1,20,15,3,6,24,23]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(de){return!!de&&typeof de.then=="function"}e.isThenable=S;function C(de){const Q=new a.CancellationTokenSource,ie=de(Q.token),we=new Promise((Me,Fe)=>{const Be=Q.token.onCancellationRequested(()=>{Be.dispose(),Q.dispose(),Fe((0,F.canceled)())});Promise.resolve(ie).then(Ke=>{Be.dispose(),Q.dispose(),Me(Ke)},Ke=>{Be.dispose(),Q.dispose(),Fe(Ke)})});return new class{cancel(){Q.cancel()}then(Me,Fe){return we.then(Me,Fe)}catch(Me){return this.then(void 0,Me)}finally(Me){return we.finally(Me)}}}e.createCancelablePromise=C;function R(de,Q,ie){return Promise.race([de,new Promise(we=>Q.onCancellationRequested(()=>we(ie)))])}e.raceCancellation=R;async function _(de){let Q=-1;const ie=de.map((Me,Fe)=>Me.then(Be=>(Q=Fe,Be))),we=await Promise.race(ie);return de.forEach((Me,Fe)=>{Fe!==Q&&Me.cancel()}),we}e.raceCancellablePromises=_;function n(de,Q,ie){let we;const Me=setTimeout(()=>{we?.(void 0),ie?.()},Q);return Promise.race([de.finally(()=>clearTimeout(Me)),new Promise(Fe=>we=Fe)])}e.raceTimeout=n;function d(de){return new Promise((Q,ie)=>{const we=de();S(we)?we.then(Q,ie):Q(we)})}e.asPromise=d;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const ie=()=>{this.queuedPromise=null;const we=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,we};this.queuedPromise=new Promise(we=>{this.activePromise.then(ie,ie).then(we)})}return new Promise((ie,we)=>{this.queuedPromise.then(ie,we)})}return this.activePromise=Q(),new Promise((ie,we)=>{this.activePromise.then(Me=>{this.activePromise=null,ie(Me)},Me=>{this.activePromise=null,we(Me)})})}}e.Throttler=s;class u{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=u;class g{constructor(){this.promiseMap=new Map}queue(Q,ie){const Me=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(Q)===Me&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,Me),Me}}e.SequencerByKey=g;class k{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,ie=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((we,Me)=>{this.doResolve=we,this.doReject=Me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const we=this.task;return this.task=null,we()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ie),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=k;class b{constructor(Q){this.delayer=new k(Q),this.throttler=new s}trigger(Q,ie){return this.delayer.trigger(()=>this.throttler.queue(Q),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class m{constructor(){this._isOpen=!1,this._promise=new Promise((Q,ie)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class f extends m{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function P(de,Q){return Q?new Promise((ie,we)=>{const Me=setTimeout(()=>{Fe.dispose(),ie()},de),Fe=Q.onCancellationRequested(()=>{clearTimeout(Me),Fe.dispose(),we((0,F.canceled)())})}):C(ie=>P(de,ie))}e.timeout=P;function l(de,Q=0){const ie=setTimeout(de,Q);return(0,T.toDisposable)(()=>clearTimeout(ie))}e.disposableTimeout=l;function M(de){const Q=[];let ie=0;const we=de.length;function Me(){return ie<we?de[ie++]():null}function Fe(Be){Be!=null&&Q.push(Be);const Ke=Me();return Ke?Ke.then(Fe):Promise.resolve(Q)}return Promise.resolve(null).then(Fe)}e.sequence=M;function r(de,Q=we=>!!we,ie=null){let we=0;const Me=de.length,Fe=()=>{if(we>=Me)return Promise.resolve(ie);const Be=de[we++];return Promise.resolve(Be()).then(je=>Q(je)?Promise.resolve(je):Fe())};return Fe()}e.first=r;function i(de,Q=we=>!!we,ie=null){if(de.length===0)return Promise.resolve(ie);let we=de.length;const Me=()=>{we=-1;for(const Fe of de)Fe.cancel?.()};return new Promise((Fe,Be)=>{for(const Ke of de)Ke.then(je=>{--we>=0&&Q(je)?(Me(),Fe(je)):we===0&&Fe(ie)}).catch(je=>{--we>=0&&(Me(),Be(je))})})}e.firstParallel=i;class p{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((ie,we)=>{this.outstandingPromises.push({factory:Q,c:ie,e:we}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const ie=Q.factory();ie.then(Q.c,Q.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class h extends p{constructor(){super(1)}}e.Queue=h;class o{constructor(){this.queues=new Map}queueFor(Q,ie=t.extUri){const we=ie.getComparisonKey(Q);let Me=this.queues.get(we);return Me||(Me=new h,w.Event.once(Me.onFinished)(()=>{Me?.dispose(),this.queues.delete(we)}),this.queues.set(we,Me)),Me}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=o;class v{constructor(Q,ie){this._token=-1,typeof Q=="function"&&typeof ie=="number"&&this.setIfNotSet(Q,ie)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,ie){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},ie)}setIfNotSet(Q,ie){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},ie))}}e.TimeoutTimer=v;class c{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,ie){this.cancel(),this._token=setInterval(()=>{Q()},ie)}}e.IntervalTimer=c;class E{constructor(Q,ie){this.timeoutToken=-1,this.runner=Q,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class I{constructor(Q,ie){ie%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=I;class D extends E{constructor(Q,ie){super(Q,ie);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=D;class B extends T.Disposable{constructor(Q,ie,we,Me){super();this.maxWorkChunkSize=Q,this.maxPendingWork=ie,this.throttleDelay=we,this.handler=Me,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.maxPendingWork)return!1}else if(this.pending+Q.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=de=>{(0,A.setTimeout0)(()=>{if(Q)return;const ie=Date.now()+3;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(de,Q)=>{const ie=requestIdleCallback(de,typeof Q=="number"?{timeout:Q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ie))}}}}();class L{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(ie){this._error=ie}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function y(de,Q,ie){let we;for(let Me=0;Me<ie;Me++)try{return await de()}catch(Fe){we=Fe,await P(Q)}throw we}e.retry=y;class x{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Q,ie,we){return this._pending={taskId:Q,cancel:()=>we?.(),promise:ie},ie.then(()=>this.donePending(Q),()=>this.donePending(Q)),ie}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let ie,we;const Me=new Promise((Fe,Be)=>{ie=Fe,we=Be});this._next={run:Q,promise:Me,promiseResolve:ie,promiseReject:we}}return this._next.promise}}e.TaskSequentializer=x;class N{constructor(Q,ie=()=>Date.now()){this.interval=Q,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,ie)=>{this.completeCallback=Q,this.errorCallback=ie})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(ie=>{this.completeCallback(Q),this.resolved=!0,ie()})}error(Q){return new Promise(ie=>{this.errorCallback(Q),this.rejected=!0,ie()})}cancel(){new Promise(Q=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=z;var H;(function(de){async function Q(we){let Me;const Fe=await Promise.all(we.map(Be=>Be.then(Ke=>Ke,Ke=>{Me||(Me=Ke)})));if(typeof Me!="undefined")throw Me;return Fe}de.settled=Q;function ie(we){return new Promise(async(Me,Fe)=>{try{await we(Me,Fe)}catch(Be){Fe(Be)}})}de.withAsyncBody=ie})(H=e.Promises||(e.Promises={}));var q;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(q||(q={}));class ue{constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const ie={emitOne:we=>this.emitOne(we),emitMany:we=>this.emitMany(we),reject:we=>this.reject(we)};try{await Promise.resolve(Q(ie)),this.resolve()}catch(we){this.reject(we)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}static fromArray(Q){return new ue(ie=>{ie.emitMany(Q)})}static fromPromise(Q){return new ue(async ie=>{ie.emitMany(await Q)})}static fromPromises(Q){return new ue(async ie=>{await Promise.all(Q.map(async we=>ie.emitOne(await we)))})}static merge(Q){return new ue(async ie=>{await Promise.all(Q.map(async we=>{for await(const Me of we)ie.emitOne(Me)}))})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,ie){return new ue(async we=>{for await(const Me of Q)we.emitOne(ie(Me))})}map(Q){return ue.map(this,Q)}static filter(Q,ie){return new ue(async we=>{for await(const Me of Q)ie(Me)&&we.emitOne(Me)})}filter(Q){return ue.filter(this,Q)}static coalesce(Q){return ue.filter(Q,ie=>!!ie)}coalesce(){return ue.coalesce(this)}static async toPromise(Q){const ie=[];for await(const we of Q)ie.push(we);return ie}toPromise(){return ue.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class G extends ue{constructor(Q,ie){super(ie);this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=G;function ce(de){const Q=new a.CancellationTokenSource,ie=de(Q.token);return new G(Q,async we=>{const Me=Q.token.onCancellationRequested(()=>{Me.dispose(),Q.dispose(),we.reject((0,F.canceled)())});try{for await(const Fe of ie){if(Q.token.isCancellationRequested)return;we.emitOne(Fe)}Me.dispose(),Q.dispose()}catch(Fe){Me.dispose(),Q.dispose(),we.reject(Fe)}})}e.createCancelableAsyncIterable=ce}),define(Ee[105],_e([0,1,14,17]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new a.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),T=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),t=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(c,E,I=!1){const D=c||"",B=E||"",L=w.value.collator.compare(D,B);return w.value.collatorIsNumeric&&L===0&&D!==B?D<B?-1:1:L}e.compareFileNames=A;function S(c,E){const I=T.value.collator;return c=c||"",E=E||"",P(I,c,E)}e.compareFileNamesDefault=S;function C(c,E){const I=T.value.collator;return c=c||"",E=E||"",i(c,E)||P(I,c,E)}e.compareFileNamesUpper=C;function R(c,E){const I=T.value.collator;return c=c||"",E=E||"",r(c,E)||P(I,c,E)}e.compareFileNamesLower=R;function _(c,E){return c=c||"",E=E||"",c===E?0:c<E?-1:1}e.compareFileNamesUnicode=_;function n(c,E,I=!1){I||(c=c&&c.toLowerCase(),E=E&&E.toLowerCase());const[D,B]=m(c),[L,y]=m(E);return D!==L?D<L?-1:1:B===y?0:B<y?-1:1}e.noIntlCompareFileNames=n;function d(c,E){const[I,D]=m(c),[B,L]=m(E);let y=w.value.collator.compare(D,L);if(y===0){if(w.value.collatorIsNumeric&&D!==L)return D<L?-1:1;if(y=w.value.collator.compare(I,B),w.value.collatorIsNumeric&&y===0&&I!==B)return I<B?-1:1}return y}e.compareFileExtensions=d;function s(c,E){c=c||"",E=E||"";const I=f(c),D=f(E),B=T.value.collator,L=t.value.collator;return P(L,I,D)||P(B,c,E)}e.compareFileExtensionsDefault=s;function u(c,E){c=c||"",E=E||"";const I=f(c),D=f(E),B=T.value.collator,L=t.value.collator;return P(L,I,D)||i(c,E)||P(B,c,E)}e.compareFileExtensionsUpper=u;function g(c,E){c=c||"",E=E||"";const I=f(c),D=f(E),B=T.value.collator,L=t.value.collator;return P(L,I,D)||r(c,E)||P(B,c,E)}e.compareFileExtensionsLower=g;function k(c,E){c=c||"",E=E||"";const I=f(c).toLowerCase(),D=f(E).toLowerCase();return I!==D?I<D?-1:1:c!==E?c<E?-1:1:0}e.compareFileExtensionsUnicode=k;const b=/^(.*?)(\.([^.]*))?$/;function m(c,E=!1){const I=c?b.exec(c):[];let D=[I&&I[1]||"",I&&I[3]||""];return E&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function f(c){const E=c?b.exec(c):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function P(c,E,I){let D=c.compare(E,I);return D!==0?D:E.length!==I.length?E.length<I.length?-1:1:0}function l(c){const E=c.charAt(0);return E.toLocaleUpperCase()!==E}function M(c){const E=c.charAt(0);return E.toLocaleLowerCase()!==E}function r(c,E){return l(c)&&M(E)?-1:M(c)&&l(E)?1:0}function i(c,E){return M(c)&&l(E)?-1:l(c)&&M(E)?1:0}function p(c,E,I=!1){return I||(c=c&&c.toLowerCase(),E=E&&E.toLowerCase()),c===E?0:c<E?-1:1}function h(c,E,I=!1){const D=c.split(F.sep),B=E.split(F.sep),L=D.length-1,y=B.length-1;let x,N;for(let z=0;;z++){if(x=L===z,N=y===z,x&&N)return A(D[z],B[z],I);if(x)return-1;if(N)return 1;const H=p(D[z],B[z],I);if(H!==0)return H}}e.comparePaths=h;function o(c,E,I){const D=c.toLowerCase(),B=E.toLowerCase(),L=v(c,E,I);if(L)return L;const y=D.endsWith(I),x=B.endsWith(I);if(y!==x)return y?-1:1;const N=A(D,B);return N!==0?N:D.localeCompare(B)}e.compareAnything=o;function v(c,E,I){const D=c.toLowerCase(),B=E.toLowerCase(),L=D.startsWith(I),y=B.startsWith(I);if(L!==y)return L?-1:1;if(L&&y){if(D.length<B.length)return-1;if(D.length>B.length)return 1}return 0}e.compareByPrefix=v}),define(Ee[29],_e([0,1,14,42,21,17,9]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A;const S="**",C="/",R="[/\\\\]",_="[^/\\\\]",n=/\//g;function d(G){switch(G){case 0:return"";case 1:return`${_}*?`;default:return`(?:${R}|${_}+${R}|${R}${_}+)*?`}}function s(G,ce){if(!G)return[];const de=[];let Q=!1,ie=!1,we="";for(const Me of G){switch(Me){case ce:if(!Q&&!ie){de.push(we),we="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}we+=Me}return we&&de.push(we),de}e.splitGlobAware=s;function u(G){if(!G)return"";let ce="";const de=s(G,C);if(de.every(Q=>Q===S))ce=".*";else{let Q=!1;de.forEach((ie,we)=>{if(ie===S){Q||(ce+=d(2),Q=!0);return}let Me=!1,Fe="",Be=!1,Ke="";for(const je of ie){if(je!=="}"&&Me){Fe+=je;continue}if(Be&&(je!=="]"||!Ke)){let Qe;je==="-"?Qe=je:(je==="^"||je==="!")&&!Ke?Qe="^":je===C?Qe="":Qe=t.escapeRegExpCharacters(je),Ke+=Qe;continue}switch(je){case"{":Me=!0;continue;case"[":Be=!0;continue;case"}":ce+=`(?:${s(Fe,",").map(K=>u(K)).join("|")})`,Me=!1,Fe="";break;case"]":ce+="["+Ke+"]",Be=!1,Ke="";break;case"?":ce+=_;continue;case"*":ce+=d(1);continue;default:ce+=t.escapeRegExpCharacters(je)}}we<de.length-1&&(de[we+1]!==S||we+2<de.length)&&(ce+=R),Q=!1})}return ce}const g=/^\*\*\/\*\.[\w\.-]+$/,k=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,P=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new w.LRUCache(1e4),M=function(){return!1},r=function(){return null};function i(G,ce){if(!G)return r;let de;typeof G!="string"?de=G.pattern:de=G,de=de.trim();const Q=`${de}_${!!ce.trimForExclusions}`;let ie=l.get(Q);if(ie)return p(ie,G);let we;if(g.test(de)){const Me=de.substr(4);ie=function(Fe,Be){return typeof Fe=="string"&&Fe.endsWith(Me)?de:null}}else(we=k.exec(h(de,ce)))?ie=o(we[1],de):(ce.trimForExclusions?m:b).test(de)?ie=v(de,ce):(we=f.exec(h(de,ce)))?ie=c(we[1].substr(1),de,!0):(we=P.exec(h(de,ce)))?ie=c(we[1],de,!1):ie=E(de);return l.set(Q,ie),p(ie,G)}function p(G,ce){return typeof ce=="string"?G:function(de,Q){return F.isEqualOrParent(de,ce.base)?G(T.relative(ce.base,de),Q):null}}function h(G,ce){return ce.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function o(G,ce){const de=`/${G}`,Q=`\\${G}`,ie=function(Me,Fe){return typeof Me!="string"?null:Fe?Fe===G?ce:null:Me===G||Me.endsWith(de)||Me.endsWith(Q)?ce:null},we=[G];return ie.basenames=we,ie.patterns=[ce],ie.allBasenames=we,ie}function v(G,ce){const de=ue(G.slice(1,-1).split(",").map(Fe=>i(Fe,ce)).filter(Fe=>Fe!==r),G),Q=de.length;if(!Q)return r;if(Q===1)return de[0];const ie=function(Fe,Be){for(let Ke=0,je=de.length;Ke<je;Ke++)if(de[Ke](Fe,Be))return G;return null},we=de.find(Fe=>!!Fe.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=de.reduce((Fe,Be)=>Be.allPaths?Fe.concat(Be.allPaths):Fe,[]);return Me.length&&(ie.allPaths=Me),ie}function c(G,ce,de){const Q=T.sep===T.posix.sep,ie=Q?G:G.replace(n,T.sep),we=T.sep+ie,Me=T.posix.sep+G,Fe=de?function(Be,Ke){return typeof Be=="string"&&(Be===ie||Be.endsWith(we)||!Q&&(Be===G||Be.endsWith(Me)))?ce:null}:function(Be,Ke){return typeof Be=="string"&&(Be===ie||!Q&&Be===G)?ce:null};return Fe.allPaths=[(de?"*/":"./")+G],Fe}function E(G){try{const ce=new RegExp(`^${u(G)}$`);return function(de){return ce.lastIndex=0,typeof de=="string"&&ce.test(de)?G:null}}catch(ce){return r}}function I(G,ce,de){return!G||typeof ce!="string"?!1:D(G)(ce,void 0,de)}e.match=I;function D(G,ce={}){if(!G)return M;if(typeof G=="string"||x(G)){const de=i(G,ce);if(de===r)return M;const Q=function(ie,we){return!!de(ie,we)};return de.allBasenames&&(Q.allBasenames=de.allBasenames),de.allPaths&&(Q.allPaths=de.allPaths),Q}return H(G,ce)}e.parse=D;function B(G){if(!G)return;let ce;return de=>(ce||(ce=(G()||Promise.resolve([])).then(Q=>Q?y(Q):{})),ce.then(Q=>!!Q[de]))}e.hasSiblingPromiseFn=B;function L(G){if(!G)return;let ce;return de=>{if(!ce){const Q=G();ce=Q?y(Q):{}}return!!ce[de]}}e.hasSiblingFn=L;function y(G){const ce={};for(const de of G)ce[de]=!0;return ce}function x(G){const ce=G;return ce&&typeof ce.base=="string"&&typeof ce.pattern=="string"}e.isRelativePattern=x;function N(G){return G.allBasenames||[]}e.getBasenameTerms=N;function z(G){return G.allPaths||[]}e.getPathTerms=z;function H(G,ce){const de=ue(Object.getOwnPropertyNames(G).map(Fe=>q(Fe,G[Fe],ce)).filter(Fe=>Fe!==r)),Q=de.length;if(!Q)return r;if(!de.some(Fe=>!!Fe.requiresSiblings)){if(Q===1)return de[0];const Fe=function(je,Qe){for(let $=0,K=de.length;$<K;$++){const X=de[$](je,Qe);if(X)return X}return null},Be=de.find(je=>!!je.allBasenames);Be&&(Fe.allBasenames=Be.allBasenames);const Ke=de.reduce((je,Qe)=>Qe.allPaths?je.concat(Qe.allPaths):je,[]);return Ke.length&&(Fe.allPaths=Ke),Fe}const ie=function(Fe,Be,Ke){let je;for(let Qe=0,$=de.length;Qe<$;Qe++){const K=de[Qe];K.requiresSiblings&&Ke&&(Be||(Be=T.basename(Fe)),je||(je=Be.substr(0,Be.length-T.extname(Fe).length)));const X=K(Fe,Be,je,Ke);if(X)return X}return null},we=de.find(Fe=>!!Fe.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=de.reduce((Fe,Be)=>Be.allPaths?Fe.concat(Be.allPaths):Fe,[]);return Me.length&&(ie.allPaths=Me),ie}function q(G,ce,de){if(ce===!1)return r;const Q=i(G,de);if(Q===r)return r;if(typeof ce=="boolean")return Q;if(ce){const ie=ce.when;if(typeof ie=="string"){const we=(Me,Fe,Be,Ke)=>{if(!Ke||!Q(Me,Fe))return null;const je=ie.replace("$(basename)",Be),Qe=Ke(je);return(0,a.isThenable)(Qe)?Qe.then($=>$?G:null):Qe?G:null};return we.requiresSiblings=!0,we}}return Q}function ue(G,ce){const de=G.filter(Fe=>!!Fe.basenames);if(de.length<2)return G;const Q=de.reduce((Fe,Be)=>{const Ke=Be.basenames;return Ke?Fe.concat(Ke):Fe},[]);let ie;if(ce){ie=[];for(let Fe=0,Be=Q.length;Fe<Be;Fe++)ie.push(ce)}else ie=de.reduce((Fe,Be)=>{const Ke=Be.patterns;return Ke?Fe.concat(Ke):Fe},[]);const we=function(Fe,Be){if(typeof Fe!="string")return null;if(!Be){let je;for(je=Fe.length;je>0;je--){const Qe=Fe.charCodeAt(je-1);if(Qe===47||Qe===92)break}Be=Fe.substr(je)}const Ke=Q.indexOf(Be);return Ke!==-1?ie[Ke]:null};we.basenames=Q,we.patterns=ie,we.allBasenames=Q;const Me=G.filter(Fe=>!Fe.basenames);return Me.push(we),Me}}),define(Ee[78],_e([0,1,42,10,17,23,24,9,2]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(i,p,h){if(typeof i=="string"&&(i=S.URI.file(i)),h){const v=h.getWorkspaceFolder(i);if(v){const c=h.getWorkspace().folders.length>1;let E;if((0,t.isEqual)(v.uri,i)?E="":E=(0,t.relativePath)(v.uri,i),c){const I=v.name?v.name:(0,t.basename)(v.uri);E=E?I+" \u2022 "+E:I}return E}}if(i.scheme!==F.Schemas.file&&i.scheme!==F.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,a.hasDriveLetter)(i.fsPath))return(0,w.normalize)(_(i.fsPath));let o=(0,w.normalize)(i.fsPath);return!T.isWindows&&p?.userHome&&(o=d(o,p.userHome.fsPath)),o}e.getPathLabel=C;function R(i){if(!i)return;typeof i=="string"&&(i=S.URI.file(i));const p=(0,t.basename)(i)||(i.scheme===F.Schemas.file?i.fsPath:i.path);return T.isWindows&&(0,a.isRootOrDriveLetter)(p)?_(p):p}e.getBaseLabel=R;function _(i,p){return(0,a.hasDriveLetter)(i,p)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let n=Object.create(null);function d(i,p){if(T.isWindows||!i||!p)return i;let h=n.original===p?n.normalized:void 0;return h||(h=`${(0,A.rtrim)(p,w.posix.sep)}${w.posix.sep}`,n={original:p,normalized:h}),(T.isLinux?i.startsWith(h):(0,A.startsWithIgnoreCase)(i,h))&&(i=`~/${i.substr(h.length)}`),i}e.tildify=d;function s(i,p){return i.replace(/^~($|\/|\\)/,`${p}$1`)}e.untildify=s;const u="\u2026",g="\\\\",k="~";function b(i,p=w.sep){const h=new Array(i.length);let o=!1;for(let v=0;v<i.length;v++){let c=i[v];if(c===""){h[v]=`.${p}`;continue}if(!c){h[v]=c;continue}o=!0;let E="";c.indexOf(g)===0?(E=c.substr(0,c.indexOf(g)+g.length),c=c.substr(c.indexOf(g)+g.length)):c.indexOf(p)===0?(E=c.substr(0,c.indexOf(p)+p.length),c=c.substr(c.indexOf(p)+p.length)):c.indexOf(k)===0&&(E=c.substr(0,c.indexOf(k)+k.length),c=c.substr(c.indexOf(k)+k.length));const I=c.split(p);for(let D=1;o&&D<=I.length;D++)for(let B=I.length-D;o&&B>=0;B--){o=!1;let L=I.slice(B,B+D).join(p);for(let y=0;!o&&y<i.length;y++)if(y!==v&&i[y]&&i[y].indexOf(L)>-1){const x=B+D===I.length,N=B>0&&i[y].indexOf(p)>-1?p+L:L,z=i[y].endsWith(N);o=!x||z}if(!o){let y="";(I[0].endsWith(":")||E!=="")&&(B===1&&(B=0,D++,L=I[0]+p+L),B>0&&(y=I[0]+p),y=E+y),B>0&&(y=y+u+p),y=y+L,B+D<I.length&&(y=y+p+u),h[v]=y}}o&&(h[v]=c)}return h}e.shorten=b;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function f(i,p=Object.create(null)){const h=[];let o=!1,v="";for(const c of i)if(c==="$"||o&&c==="{")v&&h.push({value:v,type:m.TEXT}),v="",o=!0;else if(c==="}"&&o){const E=p[v];if(typeof E=="string")E.length&&h.push({value:E,type:m.VARIABLE});else if(E){const I=h[h.length-1];(!I||I.type!==m.SEPARATOR)&&h.push({value:E.label,type:m.SEPARATOR})}v="",o=!1}else v+=c;return v&&!o&&h.push({value:v,type:m.TEXT}),h.filter((c,E)=>{if(c.type===m.SEPARATOR){const I=h[E-1],D=h[E+1];return[I,D].every(B=>B&&(B.type===m.VARIABLE||B.type===m.TEXT)&&B.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=f;function P(i,p){return T.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function l(i,p){return T.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,""):T.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function M(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=M;function r(i){const p=i.indexOf("/")!==-1?w.posix:w.win32,h=p.basename(i),o=p.dirname(i);return h.length?{name:h,parentPath:o}:{name:o,parentPath:""}}e.splitName=r}),define(Ee[79],_e([0,1,29,10,17,24,9]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var A;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(A=e.Mimes||(e.Mimes={}));let S=[],C=[],R=[];function _(i,p=!1){const h=n(i);S.push(h),h.userConfigured?R.push(h):C.push(h),p&&!h.userConfigured&&S.forEach(o=>{o.mime===h.mime||o.userConfigured||(h.extension&&o.extension===h.extension&&console.warn(`Overwriting extension <<${h.extension}>> to now point to mime <<${h.mime}>>`),h.filename&&o.filename===h.filename&&console.warn(`Overwriting filename <<${h.filename}>> to now point to mime <<${h.mime}>>`),h.filepattern&&o.filepattern===h.filepattern&&console.warn(`Overwriting filepattern <<${h.filepattern}>> to now point to mime <<${h.mime}>>`),h.firstline&&o.firstline===h.firstline&&console.warn(`Overwriting firstline <<${h.firstline}>> to now point to mime <<${h.mime}>>`))})}e.registerTextMime=_;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,a.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(w.posix.sep)>=0:!1}}function d(i){i?(S=S.filter(p=>!p.userConfigured),R=[]):(S=[],C=[],R=[])}e.clearTextMimes=d;function s(i,p){let h;if(i)switch(i.scheme){case F.Schemas.file:h=i.fsPath;break;case F.Schemas.data:h=T.DataUri.parseMetaData(i).get(T.DataUri.META_DATA_LABEL);break;default:h=i.path}if(!h)return[A.unknown];h=h.toLowerCase();const o=(0,w.basename)(h),v=u(h,o,R);if(v)return[v,A.text];const c=u(h,o,C);if(c)return[c,A.text];if(p){const E=g(p);if(E)return[E,A.text]}return[A.unknown]}e.guessMimeTypes=s;function u(i,p,h){let o=null,v=null,c=null;for(let E=h.length-1;E>=0;E--){const I=h[E];if(p===I.filenameLowercase){o=I;break}if(I.filepattern&&(!v||I.filepattern.length>v.filepattern.length)){const D=I.filepatternOnPath?i:p;I.filepatternLowercase?.(D)&&(v=I)}I.extension&&(!c||I.extension.length>c.extension.length)&&p.endsWith(I.extensionLowercase)&&(c=I)}return o?o.mime:v?v.mime:c?c.mime:null}function g(i){if((0,t.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let p=S.length-1;p>=0;p--){const h=S[p];if(!h.firstline)continue;const o=i.match(h.firstline);if(o&&o.length>0)return h.mime}return null}function k(i){return i?typeof i=="string"?i===A.binary||i===A.text||i===A.unknown:i.length===1&&k(i[0]):!0}e.isUnspecific=k;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},m={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(i){const p=(0,w.extname)(i),h=b[p.toLowerCase()];return h!==void 0?h:P(i)}e.getMediaOrTextMime=f;function P(i){const p=(0,w.extname)(i);return m[p.toLowerCase()]}e.getMediaMime=P;function l(i){for(const p in m)if(m[p]===i)return p}e.getExtensionForMimeType=l;const M=/^(.+)\/(.+?)(;.+)?$/;function r(i,p){const h=M.exec(i);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:p?void 0:i}e.normalizeMimeType=r}),define(Ee[106],_e([0,1,2]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(R){return R.toJSON()}class w{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:F(a.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:F(a.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:a.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function T(R,_,n){if(!R||n>200)return null;if(typeof R=="object"){if(R instanceof a.URI)return _.transformOutgoing(R);for(let d in R)if(Object.hasOwnProperty.call(R,d)){const s=T(R[d],_,n+1);s!==null&&(R[d]=s)}}return null}function t(R,_){const n=T(R,_,0);return n===null?R:n}e.transformOutgoingURIs=t;function A(R,_,n,d){if(!R||d>200)return null;if(typeof R=="object"){if(R.$mid===1)return n?a.URI.revive(_.transformIncoming(R)):_.transformIncoming(R);for(let s in R)if(Object.hasOwnProperty.call(R,s)){const u=A(R[s],_,n,d+1);u!==null&&(R[s]=u)}}return null}function S(R,_){const n=A(R,_,!1,0);return n===null?R:n}e.transformIncomingURIs=S;function C(R,_){const n=A(R,_,!0,0);return n===null?R:n}e.transformAndReviveIncomingURIs=C}),define(Ee[36],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(S){return a.test(S)}e.isUUID=F;const w=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let t;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?t=crypto.getRandomValues.bind(crypto):t=function(S){for(let C=0;C<S.length;C++)S[C]=Math.floor(Math.random()*256);return S};function A(){t(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let S=0,C="";return C+=T[w[S++]],C+=T[w[S++]],C+=T[w[S++]],C+=T[w[S++]],C+="-",C+=T[w[S++]],C+=T[w[S++]],C+="-",C+=T[w[S++]],C+=T[w[S++]],C+="-",C+=T[w[S++]],C+=T[w[S++]],C+="-",C+=T[w[S++]],C+=T[w[S++]],C+=T[w[S++]],C+=T[w[S++]],C+=T[w[S++]],C+=T[w[S++]],C}e.generateUuid=A}),define(Ee[107],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class F{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._standardTokenMask=0,Array.isArray(A.notIn))for(let S=0,C=A.notIn.length;S<C;S++)switch(A.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(A){return(this._standardTokenMask&A)==0}shouldAutoClose(A,S){if(A.getTokenCount()===0)return!0;const C=A.findTokenIndexAtOffset(S-2),R=A.getStandardTokenType(C);return this.isOK(R)}_findNeutralCharacterInRange(A,S){for(let C=A;C<=S;C++){const R=String.fromCharCode(C);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=F;class w{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of A)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=w;function T(t,A,S){t.has(A)?t.get(A).push(S):t.set(A,[S])}}),define(Ee[55],_e([0,1,29,17]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(T,t,A,S){if(Array.isArray(T)){let C=0;for(const R of T){const _=w(R,t,A,S);if(_===10)return _;_>C&&(C=_)}return C}else{if(typeof T=="string")return S?T==="*"?5:T===A?10:0:0;if(T){const{language:C,pattern:R,scheme:_,hasAccessToAllModels:n}=T;if(!S&&!n)return 0;let d=0;if(_)if(_===t.scheme)d=10;else if(_==="*")d=5;else return 0;if(C)if(C===A)d=10;else if(C==="*")d=Math.max(d,5);else return 0;if(R){let s;if(typeof R=="string"?s=R:s={...R,base:(0,F.normalize)(R.base)},s===t.fsPath||(0,a.match)(s,t.fsPath))d=10;else return 0}return d}else return 0}}e.score=w}),define(Ee[108],_e([0,1,3,6]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class w{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new a.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(t){this._onDidChange.fire({changedLanguages:t,changedColorMap:!1})}register(t,A){return this._map.set(t,A),this.fire([t]),(0,F.toDisposable)(()=>{this._map.get(t)===A&&(this._map.delete(t),this.fire([t]))})}registerPromise(t,A){let S=null,C=!1;return this._promises.set(t,A.then(R=>{this._promises.delete(t),!(C||!R)&&(S=this.register(t,R))})),(0,F.toDisposable)(()=>{C=!0,S&&S.dispose()})}getPromise(t){const A=this.get(t);if(A)return Promise.resolve(A);const S=this._promises.get(t);return S?S.then(C=>this.get(t)):null}get(t){return this._map.get(t)||null}setColorMap(t){this._colorMap=t,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=w}),define(Ee[80],_e([0,1,22,23]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(w||(w={}));function T(_){for(let n=0,d=_.length;n<d;n+=4){const s=_[n+0],u=_[n+1],g=_[n+2],k=_[n+3];_[n+0]=k,_[n+1]=g,_[n+2]=u,_[n+3]=s}}function t(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return F.isLittleEndian()||T(n),a.VSBuffer.wrap(n)}function A(_){const n=_.buffer;if(F.isLittleEndian()||T(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const d=new Uint8Array(n.byteLength);return d.set(n),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function S(_){const n=new Uint32Array(C(_));let d=0;if(n[d++]=_.id,_.type==="full")n[d++]=1,n[d++]=_.data.length,n.set(_.data,d),d+=_.data.length;else{n[d++]=2,n[d++]=_.deltas.length;for(const s of _.deltas)n[d++]=s.start,n[d++]=s.deleteCount,s.data?(n[d++]=s.data.length,n.set(s.data,d),d+=s.data.length):n[d++]=0}return t(n)}e.encodeSemanticTokensDto=S;function C(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const d of _.deltas)d.data&&(n+=d.data.length)}return n}function R(_){const n=A(_);let d=0;const s=n[d++];if(n[d++]===1){const b=n[d++],m=n.subarray(d,d+b);return d+=b,{id:s,type:"full",data:m}}const g=n[d++];let k=[];for(let b=0;b<g;b++){const m=n[d++],f=n[d++],P=n[d++];let l;P>0&&(l=n.subarray(d,d+P),d+=P),k[b]={start:m,deleteCount:f,data:l}}return{id:s,type:"delta",deltas:k}}e.decodeSemanticTokensDto=R}),define(Ee[109],_e([18,19]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(Ee[110],_e([0,1,109]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,w=F*60,T=w*24,t=T*7,A=T*30,S=T*365;function C(_,n){typeof _!="number"&&(_=_.getTime());const d=Math.round((new Date().getTime()-_)/1e3);if(d<-30)return(0,a.localize)(0,null,C(new Date().getTime()+d*1e3,!1));if(d<30)return(0,a.localize)(1,null);let s;return d<F?(s=d,n?s===1?(0,a.localize)(2,null,s):(0,a.localize)(3,null,s):s===1?(0,a.localize)(4,null,s):(0,a.localize)(5,null,s)):d<w?(s=Math.floor(d/F),n?s===1?(0,a.localize)(6,null,s):(0,a.localize)(7,null,s):s===1?(0,a.localize)(8,null,s):(0,a.localize)(9,null,s)):d<T?(s=Math.floor(d/w),n?s===1?(0,a.localize)(10,null,s):(0,a.localize)(11,null,s):s===1?(0,a.localize)(12,null,s):(0,a.localize)(13,null,s)):d<t?(s=Math.floor(d/T),n?s===1?(0,a.localize)(14,null,s):(0,a.localize)(15,null,s):s===1?(0,a.localize)(16,null,s):(0,a.localize)(17,null,s)):d<A?(s=Math.floor(d/t),n?s===1?(0,a.localize)(18,null,s):(0,a.localize)(19,null,s):s===1?(0,a.localize)(20,null,s):(0,a.localize)(21,null,s)):d<S?(s=Math.floor(d/A),n?s===1?(0,a.localize)(22,null,s):(0,a.localize)(23,null,s):s===1?(0,a.localize)(24,null,s):(0,a.localize)(25,null,s)):(s=Math.floor(d/S),n?s===1?(0,a.localize)(26,null,s):(0,a.localize)(27,null,s):s===1?(0,a.localize)(28,null,s):(0,a.localize)(29,null,s))}e.fromNow=C;function R(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ee[111],_e([18,19]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(Ee[43],_e([0,1,16,11,111]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(C,R){return R&&(C.stack||C.stacktrace)?w.localize(0,null,A(C),t(C.stack)||t(C.stacktrace)):A(C)}function t(C){return Array.isArray(C)?C.join(`
`):C}function A(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?w.localize(1,null,C.message):C.message||w.localize(2,null)}function S(C=null,R=!1){if(!C)return w.localize(3,null);if(Array.isArray(C)){const _=a.coalesce(C),n=S(_[0],R);return _.length>1?w.localize(4,null,n,_.length):n}if(F.isString(C))return C;if(C.detail){const _=C.detail;if(_.error)return T(_.error,R);if(_.exception)return T(_.exception,R)}return C.stack?T(C,R):C.message?C.message:w.localize(5,null)}e.toErrorMessage=S}),define(Ee[112],_e([18,19]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(Ee[113],_e([0,1,112,23,114]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.deriveFromWorkspaceTrust=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class t{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=t;class A{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,pe){this._values[J]=pe}}e.ValidatedEditorOptions=A;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class C{constructor(J,pe,Ue,Ye){this.id=J,this.name=pe,this.defaultValue=Ue,this.schema=Ye}compute(J,pe,Ue){return Ue}}class R{constructor(J,pe=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(J){return this.defaultValue}}class _{constructor(J,pe,Ue,Ye){this.id=J,this.name=pe,this.defaultValue=Ue,this.schema=Ye}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,pe,Ue){return Ue}}function n(V,J){return typeof V=="undefined"?J:V==="false"?!1:Boolean(V)}e.boolean=n;class d extends _{constructor(J,pe,Ue,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=Ue),super(J,pe,Ue,Ye)}validate(J){return n(J,this.defaultValue)}}function s(V,J,pe,Ue){if(typeof V=="undefined")return J;let Ye=parseInt(V,10);return isNaN(Ye)?J:(Ye=Math.max(pe,Ye),Ye=Math.min(Ue,Ye),Ye|0)}e.clampedInt=s;class u extends _{constructor(J,pe,Ue,Ye,Je,lt=void 0){typeof lt!="undefined"&&(lt.type="integer",lt.default=Ue,lt.minimum=Ye,lt.maximum=Je),super(J,pe,Ue,lt),this.minimum=Ye,this.maximum=Je}static clampedInt(J,pe,Ue,Ye){return s(J,pe,Ue,Ye)}validate(J){return u.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class g extends _{constructor(J,pe,Ue,Ye,Je){typeof Je!="undefined"&&(Je.type="number",Je.default=Ue),super(J,pe,Ue,Je),this.validationFn=Ye}static clamp(J,pe,Ue){return J<pe?pe:J>Ue?Ue:J}static float(J,pe){if(typeof J=="number")return J;if(typeof J=="undefined")return pe;const Ue=parseFloat(J);return isNaN(Ue)?pe:Ue}validate(J){return this.validationFn(g.float(J,this.defaultValue))}}class k extends _{static string(J,pe){return typeof J!="string"?pe:J}constructor(J,pe,Ue,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=Ue),super(J,pe,Ue,Ye)}validate(J){return k.string(J,this.defaultValue)}}function b(V,J,pe){return typeof V!="string"||pe.indexOf(V)===-1?J:V}e.stringSet=b;class m extends _{constructor(J,pe,Ue,Ye,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.enum=Ye,Je.default=Ue),super(J,pe,Ue,Je),this._allowedValues=Ye}validate(J){return b(J,this.defaultValue,this._allowedValues)}}class f extends C{constructor(J,pe,Ue,Ye,Je,lt,Et=void 0){typeof Et!="undefined"&&(Et.type="string",Et.enum=Je,Et.default=Ye),super(J,pe,Ue,Et),this._allowedValues=Je,this._convert=lt}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function P(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",description:a.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,pe,Ue){return Ue===0?J.accessibilitySupport:Ue}}class M extends C{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:a.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{insertSpace:n(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function h(V){switch(V){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function o(V){switch(V){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class v extends R{constructor(){super(127,[65,33])}compute(J,pe,Ue){const Ye=["monaco-editor"];return pe.get(33)&&Ye.push(pe.get(33)),J.extraEditorClassName&&Ye.push(J.extraEditorClassName),pe.get(65)==="default"?Ye.push("mouse-default"):pe.get(65)==="copy"&&Ye.push("mouse-copy"),pe.get(99)&&Ye.push("showUnused"),pe.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class c extends d{constructor(){super(32,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(J,pe,Ue){return Ue&&J.emptySelectionClipboard}}class E extends C{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:a.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:a.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{cursorMoveOnType:n(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":b(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":b(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(pe.loop,this.defaultValue.loop)}}}class I extends C{constructor(){super(44,"fontLigatures",I.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?I.OFF:J==="true"?I.ON:J:Boolean(J)?I.ON:I.OFF}}e.EditorFontLigatures=I,I.OFF='"liga" off, "calt" off',I.ON='"liga" on, "calt" on';class D extends R{constructor(){super(43)}compute(J,pe,Ue){return J.fontInfo}}class B extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(22,null)})}validate(J){let pe=g.float(J,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(pe,6,100)}compute(J,pe,Ue){return J.fontInfo.fontSize}}class L extends C{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:a.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(u.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class y extends C{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[a.localize(25,null),a.localize(26,null),a.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:a.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:a.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:a.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Ue,description:a.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Ue,description:a.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Ue,description:a.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Ue,description:a.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Ue,description:a.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{multiple:b(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??b(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??b(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??b(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??b(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??b(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:k.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:k.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:k.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:k.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:k.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends C{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:a.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:a.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:a.localize(41,null)},"editor.hover.above":{type:"boolean",default:J.above,description:a.localize(42,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),delay:u.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:n(pe.sticky,this.defaultValue.sticky),above:n(pe.above,this.defaultValue.above)}}}var N;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class z extends R{constructor(){super(130,[49,57,37,64,91,59,60,93,117,120,121,122,2])}compute(J,pe,Ue){return z.computeLayout(pe,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const pe=J.height/J.lineHeight,Ue=J.scrollBeyondLastLine?pe-1:0,Ye=(J.viewLineCount+Ue)/(J.pixelRatio*J.height),Je=Math.floor(J.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ue,desiredRatio:Ye,minimapLineCount:Je}}static _computeMinimapLayout(J,pe){const Ue=J.outerWidth,Ye=J.outerHeight,Je=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Je*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const lt=pe.stableMinimapLayoutInput,Et=lt&&J.outerHeight===lt.outerHeight&&J.lineHeight===lt.lineHeight&&J.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&J.pixelRatio===lt.pixelRatio&&J.scrollBeyondLastLine===lt.scrollBeyondLastLine&&J.minimap.enabled===lt.minimap.enabled&&J.minimap.side===lt.minimap.side&&J.minimap.size===lt.minimap.size&&J.minimap.showSlider===lt.minimap.showSlider&&J.minimap.renderCharacters===lt.minimap.renderCharacters&&J.minimap.maxColumn===lt.minimap.maxColumn&&J.minimap.scale===lt.minimap.scale&&J.verticalScrollbarWidth===lt.verticalScrollbarWidth&&J.isViewportWrapping===lt.isViewportWrapping,It=J.lineHeight,et=J.typicalHalfwidthCharacterWidth,Tt=J.scrollBeyondLastLine,Pe=J.minimap.renderCharacters;let Se=Je>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const ve=J.minimap.maxColumn,re=J.minimap.size,ae=J.minimap.side,he=J.verticalScrollbarWidth,me=J.viewLineCount,Ie=J.remainingWidth,ze=J.isViewportWrapping,Oe=Pe?2:3;let We=Math.floor(Je*Ye);const it=We/Je;let ot=!1,ne=!1,ge=Oe*Se,te=Se/Je,W=1;if(re==="fill"||re==="fit"){const{typicalViewportLineCount:Ct,extraLinesBeyondLastLine:pt,desiredRatio:ht,minimapLineCount:vt}=z.computeContainedMinimapLineCount({viewLineCount:me,scrollBeyondLastLine:Tt,height:Ye,lineHeight:It,pixelRatio:Je});if(me/vt>1)ot=!0,ne=!0,Se=1,ge=1,te=Se/Je;else{let Ft=!1,yt=Se+1;if(re==="fit"){const At=Math.ceil((me+pt)*ge);ze&&Et&&Ie<=pe.stableFitRemainingWidth?(Ft=!0,yt=pe.stableFitMaxMinimapScale):Ft=At>We}if(re==="fill"||Ft){ot=!0;const At=Se;ge=Math.min(It*Je,Math.max(1,Math.floor(1/ht))),ze&&Et&&Ie<=pe.stableFitRemainingWidth&&(yt=pe.stableFitMaxMinimapScale),Se=Math.min(yt,Math.max(1,Math.floor(ge/Oe))),Se>At&&(W=Math.min(2,Se/At)),te=Se/Je/W,We=Math.ceil(Math.max(Ct,me+pt)*ge),ze?(pe.stableMinimapLayoutInput=J,pe.stableFitRemainingWidth=Ie,pe.stableFitMaxMinimapScale=Se):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const be=Math.floor(ve*te),ke=Math.min(be,Math.max(0,Math.floor((Ie-he-2)*te/(et+te)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(Je*ke);const Le=qe/Je;qe=Math.floor(qe*W);const dt=Pe?1:2,bt=ae==="left"?0:Ue-ke-he;return{renderMinimap:dt,minimapLeft:bt,minimapWidth:ke,minimapHeightIsEditorHeight:ot,minimapIsSampling:ne,minimapScale:Se,minimapLineHeight:ge,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:We,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:it}}static computeLayout(J,pe){const Ue=pe.outerWidth|0,Ye=pe.outerHeight|0,Je=pe.lineHeight|0,lt=pe.lineNumbersDigitCount|0,Et=pe.typicalHalfwidthCharacterWidth,It=pe.maxDigitWidth,et=pe.pixelRatio,Tt=pe.viewLineCount,Pe=J.get(122),Se=Pe==="inherit"?J.get(121):Pe,ve=Se==="inherit"?J.get(117):Se,re=J.get(120),ae=J.get(2),he=pe.isDominatedByLongLines,me=J.get(49),Ie=J.get(59).renderType!==0,ze=J.get(60),Oe=J.get(93),We=J.get(64),it=J.get(91),ot=it.verticalScrollbarSize,ne=it.verticalHasArrows,ge=it.arrowSize,te=it.horizontalScrollbarSize,W=J.get(57),be=J.get(37);let ke;if(typeof W=="string"&&/^\d+(\.\d+)?ch$/.test(W)){const Bt=parseFloat(W.substr(0,W.length-2));ke=u.clampedInt(Bt*Et,0,0,1e3)}else ke=u.clampedInt(W,0,0,1e3);be&&(ke+=16);let qe=0;if(Ie){const Bt=Math.max(lt,ze);qe=Math.round(Bt*It)}let Le=0;me&&(Le=Je);let dt=0,bt=dt+Le,Ct=bt+qe,pt=Ct+ke;const ht=Ue-Le-qe-ke;let vt=!1,_t=!1,Ft=-1;ae!==2&&(Se==="inherit"&&he?(vt=!0,_t=!0):ve==="on"||ve==="bounded"?_t=!0:ve==="wordWrapColumn"&&(Ft=re));const yt=z._computeMinimapLayout({outerWidth:Ue,outerHeight:Ye,lineHeight:Je,typicalHalfwidthCharacterWidth:Et,pixelRatio:et,scrollBeyondLastLine:Oe,minimap:We,verticalScrollbarWidth:ot,viewLineCount:Tt,remainingWidth:ht,isViewportWrapping:_t},pe.memory||new S);yt.renderMinimap!==0&&yt.minimapLeft===0&&(dt+=yt.minimapWidth,bt+=yt.minimapWidth,Ct+=yt.minimapWidth,pt+=yt.minimapWidth);const At=ht-yt.minimapWidth,Ut=Math.max(1,Math.floor((At-ot-2)/Et)),Pt=ne?ge:0;return _t&&(Ft=Math.max(1,Ut),ve==="bounded"&&(Ft=Math.min(Ft,re))),{width:Ue,height:Ye,glyphMarginLeft:dt,glyphMarginWidth:Le,lineNumbersLeft:bt,lineNumbersWidth:qe,decorationsLeft:Ct,decorationsWidth:ke,contentLeft:pt,contentWidth:At,minimap:yt,viewportColumn:Ut,isWordWrapMinified:vt,isViewportWrapping:_t,wrappingColumn:Ft,verticalScrollbarWidth:ot,horizontalScrollbarHeight:te,overviewRuler:{top:Pt,width:ot,height:Ye-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=z;class H extends C{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:a.localize(43,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class q extends C{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:a.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:a.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:a.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:k.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class ue extends g{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>g.clamp(J,0,150),{markdownDescription:a.localize(47,null)})}compute(J,pe,Ue){return J.fontInfo.lineHeight}}class G extends C{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:a.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(49,null),a.localize(50,null),a.localize(51,null)],default:J.size,description:a.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:a.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:a.localize(54,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:a.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:a.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),size:b(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(pe.side,this.defaultValue.side,["right","left"]),showSlider:b(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(pe.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(pe.scale,1,1,3),maxColumn:u.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ce(V){return V==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class de extends C{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(59,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{top:u.clampedInt(pe.top,0,0,1e3),bottom:u.clampedInt(pe.bottom,0,0,1e3)}}}class Q extends C{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:a.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:a.localize(61,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),cycle:n(pe.cycle,this.defaultValue.cycle)}}}class ie extends R{constructor(){super(128)}compute(J,pe,Ue){return J.pixelRatio}}class we extends C{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:a.localize(62,null)},comments:{type:"boolean",default:J.comments,description:a.localize(63,null)},other:{type:"boolean",default:J.other,description:a.localize(64,null)}}}],default:J,description:a.localize(65,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const pe=J,Ue={other:n(pe.other,this.defaultValue.other),comments:n(pe.comments,this.defaultValue.comments),strings:n(pe.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Me;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Me=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends C{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null),a.localize(69,null)],default:"on",description:a.localize(70,null)})}validate(J){let pe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(pe=4,Ue=J):J==="interval"?pe=3:J==="relative"?pe=2:J==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ue}}}function Be(V){const J=V.get(86);return J==="editable"?V.get(80):J!=="on"}e.filterValidationDecorations=Be;class Ke extends C{constructor(){const J=[],pe={type:"number",description:a.localize(71,null)};super(90,"rulers",J,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:a.localize(72,null),format:"color-hex"}}}]},default:J,description:a.localize(73,null)})}validate(J){if(Array.isArray(J)){let pe=[];for(let Ue of J)if(typeof Ue=="number")pe.push({column:u.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ye=Ue;pe.push({column:u.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((Ue,Ye)=>Ue.column-Ye.column),pe}return this.defaultValue}}function je(V,J){if(typeof V!="string")return J;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class Qe extends C{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(74,null),a.localize(75,null),a.localize(76,null)],default:"auto",description:a.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(78,null),a.localize(79,null),a.localize(80,null)],default:"auto",description:a.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:a.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:a.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:a.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J,Ue=u.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=u.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(pe.vertical,this.defaultValue.vertical),horizontal:je(pe.horizontal,this.defaultValue.horizontal),useShadows:n(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:u.clampedInt(pe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:u.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:n(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.deriveFromWorkspaceTrust="deriveFromWorkspaceTrust",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class $ extends C{constructor(){const J={nonBasicASCII:e.deriveFromWorkspaceTrust,invisibleCharacters:e.deriveFromWorkspaceTrust,ambiguousCharacters:e.deriveFromWorkspaceTrust,includeComments:e.deriveFromWorkspaceTrust,allowedCharacters:""};super(112,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.nonBasicASCII,description:a.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.invisibleCharacters,description:a.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.ambiguousCharacters,description:a.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.includeComments,description:a.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"string",default:J.allowedCharacters,description:a.localize(89,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{nonBasicASCII:Z(pe.nonBasicASCII,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),invisibleCharacters:Z(pe.invisibleCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),ambiguousCharacters:Z(pe.ambiguousCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),includeComments:Z(pe.includeComments,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),allowedCharacters:K(pe.allowedCharacters,"")}}}function K(V,J){return typeof V!="string"?J:V}class X extends C{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:a.localize(90,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),mode:b(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class se extends C{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:a.localize(91,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class j extends C{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(92,null),a.localize(93,null),a.localize(94,null)],default:J.bracketPairs,description:a.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(96,null),a.localize(97,null),a.localize(98,null)],default:J.bracketPairsHorizontal,description:a.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:a.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:a.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:a.localize(102,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{bracketPairs:Z(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Z(V,J,pe){const Ue=pe.indexOf(V);return Ue===-1?J:pe[Ue]}class fe extends C{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(103,null),a.localize(104,null)],default:J.insertMode,description:a.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:a.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:a.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:a.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:a.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:a.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:a.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:a.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:a.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{insertMode:b(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(pe.showIcons,this.defaultValue.showIcons),showStatusBar:n(pe.showStatusBar,this.defaultValue.showStatusBar),preview:n(pe.preview,this.defaultValue.preview),previewMode:b(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(pe.showMethods,this.defaultValue.showMethods),showFunctions:n(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:n(pe.showFields,this.defaultValue.showFields),showVariables:n(pe.showVariables,this.defaultValue.showVariables),showClasses:n(pe.showClasses,this.defaultValue.showClasses),showStructs:n(pe.showStructs,this.defaultValue.showStructs),showInterfaces:n(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(pe.showModules,this.defaultValue.showModules),showProperties:n(pe.showProperties,this.defaultValue.showProperties),showEvents:n(pe.showEvents,this.defaultValue.showEvents),showOperators:n(pe.showOperators,this.defaultValue.showOperators),showUnits:n(pe.showUnits,this.defaultValue.showUnits),showValues:n(pe.showValues,this.defaultValue.showValues),showConstants:n(pe.showConstants,this.defaultValue.showConstants),showEnums:n(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(pe.showKeywords,this.defaultValue.showKeywords),showWords:n(pe.showWords,this.defaultValue.showWords),showColors:n(pe.showColors,this.defaultValue.showColors),showFiles:n(pe.showFiles,this.defaultValue.showFiles),showReferences:n(pe.showReferences,this.defaultValue.showReferences),showFolders:n(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(pe.showSnippets,this.defaultValue.showSnippets),showUsers:n(pe.showUsers,this.defaultValue.showUsers),showIssues:n(pe.showIssues,this.defaultValue.showIssues)}}}class Te extends C{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(145,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ne extends R{constructor(){super(129,[80])}compute(J,pe,Ue){return pe.get(80)?!0:J.tabFocusMode}}var He;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(He=e.WrappingIndent||(e.WrappingIndent={}));function Ge(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class tt extends R{constructor(){super(131,[130])}compute(J,pe,Ue){const Ye=pe.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const st="Consolas, 'Courier New', monospace",Xe="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?Xe:F.isLinux?rt:st,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function De(V){return e.editorOptionsRegistry[V.id]=V,V}var gt;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.bracketPairColorization=12]="bracketPairColorization",V[V.guides=13]="guides",V[V.codeLens=14]="codeLens",V[V.codeLensFontFamily=15]="codeLensFontFamily",V[V.codeLensFontSize=16]="codeLensFontSize",V[V.colorDecorators=17]="colorDecorators",V[V.columnSelection=18]="columnSelection",V[V.comments=19]="comments",V[V.contextmenu=20]="contextmenu",V[V.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",V[V.cursorBlinking=22]="cursorBlinking",V[V.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",V[V.cursorStyle=24]="cursorStyle",V[V.cursorSurroundingLines=25]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",V[V.cursorWidth=27]="cursorWidth",V[V.disableLayerHinting=28]="disableLayerHinting",V[V.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",V[V.domReadOnly=30]="domReadOnly",V[V.dragAndDrop=31]="dragAndDrop",V[V.emptySelectionClipboard=32]="emptySelectionClipboard",V[V.extraEditorClassName=33]="extraEditorClassName",V[V.fastScrollSensitivity=34]="fastScrollSensitivity",V[V.find=35]="find",V[V.fixedOverflowWidgets=36]="fixedOverflowWidgets",V[V.folding=37]="folding",V[V.foldingStrategy=38]="foldingStrategy",V[V.foldingHighlight=39]="foldingHighlight",V[V.foldingImportsByDefault=40]="foldingImportsByDefault",V[V.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=42]="fontFamily",V[V.fontInfo=43]="fontInfo",V[V.fontLigatures=44]="fontLigatures",V[V.fontSize=45]="fontSize",V[V.fontWeight=46]="fontWeight",V[V.formatOnPaste=47]="formatOnPaste",V[V.formatOnType=48]="formatOnType",V[V.glyphMargin=49]="glyphMargin",V[V.gotoLocation=50]="gotoLocation",V[V.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",V[V.hover=52]="hover",V[V.inDiffEditor=53]="inDiffEditor",V[V.inlineSuggest=54]="inlineSuggest",V[V.letterSpacing=55]="letterSpacing",V[V.lightbulb=56]="lightbulb",V[V.lineDecorationsWidth=57]="lineDecorationsWidth",V[V.lineHeight=58]="lineHeight",V[V.lineNumbers=59]="lineNumbers",V[V.lineNumbersMinChars=60]="lineNumbersMinChars",V[V.linkedEditing=61]="linkedEditing",V[V.links=62]="links",V[V.matchBrackets=63]="matchBrackets",V[V.minimap=64]="minimap",V[V.mouseStyle=65]="mouseStyle",V[V.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=67]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",V[V.multiCursorModifier=69]="multiCursorModifier",V[V.multiCursorPaste=70]="multiCursorPaste",V[V.occurrencesHighlight=71]="occurrencesHighlight",V[V.overviewRulerBorder=72]="overviewRulerBorder",V[V.overviewRulerLanes=73]="overviewRulerLanes",V[V.padding=74]="padding",V[V.parameterHints=75]="parameterHints",V[V.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",V[V.quickSuggestions=78]="quickSuggestions",V[V.quickSuggestionsDelay=79]="quickSuggestionsDelay",V[V.readOnly=80]="readOnly",V[V.renameOnType=81]="renameOnType",V[V.renderControlCharacters=82]="renderControlCharacters",V[V.renderFinalNewline=83]="renderFinalNewline",V[V.renderLineHighlight=84]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=86]="renderValidationDecorations",V[V.renderWhitespace=87]="renderWhitespace",V[V.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",V[V.roundedSelection=89]="roundedSelection",V[V.rulers=90]="rulers",V[V.scrollbar=91]="scrollbar",V[V.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=93]="scrollBeyondLastLine",V[V.scrollPredominantAxis=94]="scrollPredominantAxis",V[V.selectionClipboard=95]="selectionClipboard",V[V.selectionHighlight=96]="selectionHighlight",V[V.selectOnLineNumbers=97]="selectOnLineNumbers",V[V.showFoldingControls=98]="showFoldingControls",V[V.showUnused=99]="showUnused",V[V.snippetSuggestions=100]="snippetSuggestions",V[V.smartSelect=101]="smartSelect",V[V.smoothScrolling=102]="smoothScrolling",V[V.stickyTabStops=103]="stickyTabStops",V[V.stopRenderingLineAfter=104]="stopRenderingLineAfter",V[V.suggest=105]="suggest",V[V.suggestFontSize=106]="suggestFontSize",V[V.suggestLineHeight=107]="suggestLineHeight",V[V.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",V[V.suggestSelection=109]="suggestSelection",V[V.tabCompletion=110]="tabCompletion",V[V.tabIndex=111]="tabIndex",V[V.unicodeHighlighting=112]="unicodeHighlighting",V[V.unusualLineTerminators=113]="unusualLineTerminators",V[V.useShadowDOM=114]="useShadowDOM",V[V.useTabStops=115]="useTabStops",V[V.wordSeparators=116]="wordSeparators",V[V.wordWrap=117]="wordWrap",V[V.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=120]="wordWrapColumn",V[V.wordWrapOverride1=121]="wordWrapOverride1",V[V.wordWrapOverride2=122]="wordWrapOverride2",V[V.wrappingIndent=123]="wrappingIndent",V[V.wrappingStrategy=124]="wrappingStrategy",V[V.showDeprecated=125]="showDeprecated",V[V.inlayHints=126]="inlayHints",V[V.editorClassName=127]="editorClassName",V[V.pixelRatio=128]="pixelRatio",V[V.tabFocusMode=129]="tabFocusMode",V[V.layoutInfo=130]="layoutInfo",V[V.wrappingInfo=131]="wrappingInfo"})(gt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:De(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(146,null)})),acceptSuggestionOnEnter:De(new m(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(147,null),""],markdownDescription:a.localize(148,null)})),accessibilitySupport:De(new l),accessibilityPageSize:De(new u(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(149,null)})),ariaLabel:De(new k(4,"ariaLabel",a.localize(150,null))),autoClosingBrackets:De(new m(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(151,null),a.localize(152,null),""],description:a.localize(153,null)})),autoClosingDelete:De(new m(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(154,null),""],description:a.localize(155,null)})),autoClosingOvertype:De(new m(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(156,null),""],description:a.localize(157,null)})),autoClosingQuotes:De(new m(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(158,null),a.localize(159,null),""],description:a.localize(160,null)})),autoIndent:De(new f(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],P,{enumDescriptions:[a.localize(161,null),a.localize(162,null),a.localize(163,null),a.localize(164,null),a.localize(165,null)],description:a.localize(166,null)})),automaticLayout:De(new d(10,"automaticLayout",!1)),autoSurround:De(new m(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(167,null),a.localize(168,null),a.localize(169,null),""],description:a.localize(170,null)})),bracketPairColorization:De(new se),bracketPairGuides:De(new j),stickyTabStops:De(new d(103,"stickyTabStops",!1,{description:a.localize(171,null)})),codeLens:De(new d(14,"codeLens",!0,{description:a.localize(172,null)})),codeLensFontFamily:De(new k(15,"codeLensFontFamily","",{description:a.localize(173,null)})),codeLensFontSize:De(new u(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(174,null)})),colorDecorators:De(new d(17,"colorDecorators",!0,{description:a.localize(175,null)})),columnSelection:De(new d(18,"columnSelection",!1,{description:a.localize(176,null)})),comments:De(new M),contextmenu:De(new d(20,"contextmenu",!0)),copyWithSyntaxHighlighting:De(new d(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(177,null)})),cursorBlinking:De(new f(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:a.localize(178,null)})),cursorSmoothCaretAnimation:De(new d(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(179,null)})),cursorStyle:De(new f(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],o,{description:a.localize(180,null)})),cursorSurroundingLines:De(new u(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(181,null)})),cursorSurroundingLinesStyle:De(new m(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(182,null),a.localize(183,null)],description:a.localize(184,null)})),cursorWidth:De(new u(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(185,null)})),disableLayerHinting:De(new d(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:De(new d(29,"disableMonospaceOptimizations",!1)),domReadOnly:De(new d(30,"domReadOnly",!1)),dragAndDrop:De(new d(31,"dragAndDrop",!0,{description:a.localize(186,null)})),emptySelectionClipboard:De(new c),extraEditorClassName:De(new k(33,"extraEditorClassName","")),fastScrollSensitivity:De(new g(34,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:a.localize(187,null)})),find:De(new E),fixedOverflowWidgets:De(new d(36,"fixedOverflowWidgets",!1)),folding:De(new d(37,"folding",!0,{description:a.localize(188,null)})),foldingStrategy:De(new m(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(189,null),a.localize(190,null)],description:a.localize(191,null)})),foldingHighlight:De(new d(39,"foldingHighlight",!0,{description:a.localize(192,null)})),foldingImportsByDefault:De(new d(40,"foldingImportsByDefault",!1,{description:a.localize(193,null)})),unfoldOnClickAfterEndOfLine:De(new d(41,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(194,null)})),fontFamily:De(new k(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(195,null)})),fontInfo:De(new D),fontLigatures2:De(new I),fontSize:De(new B),fontWeight:De(new L),formatOnPaste:De(new d(47,"formatOnPaste",!1,{description:a.localize(196,null)})),formatOnType:De(new d(48,"formatOnType",!1,{description:a.localize(197,null)})),glyphMargin:De(new d(49,"glyphMargin",!0,{description:a.localize(198,null)})),gotoLocation:De(new y),hideCursorInOverviewRuler:De(new d(51,"hideCursorInOverviewRuler",!1,{description:a.localize(199,null)})),hover:De(new x),inDiffEditor:De(new d(53,"inDiffEditor",!1)),letterSpacing:De(new g(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>g.clamp(V,-5,20),{description:a.localize(200,null)})),lightbulb:De(new H),lineDecorationsWidth:De(new _(57,"lineDecorationsWidth",10)),lineHeight:De(new ue),lineNumbers:De(new Fe),lineNumbersMinChars:De(new u(60,"lineNumbersMinChars",5,1,300)),linkedEditing:De(new d(61,"linkedEditing",!1,{description:a.localize(201,null)})),links:De(new d(62,"links",!0,{description:a.localize(202,null)})),matchBrackets:De(new m(63,"matchBrackets","always",["always","near","never"],{description:a.localize(203,null)})),minimap:De(new G),mouseStyle:De(new m(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:De(new g(66,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:a.localize(204,null)})),mouseWheelZoom:De(new d(67,"mouseWheelZoom",!1,{markdownDescription:a.localize(205,null)})),multiCursorMergeOverlapping:De(new d(68,"multiCursorMergeOverlapping",!0,{description:a.localize(206,null)})),multiCursorModifier:De(new f(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ce,{markdownEnumDescriptions:[a.localize(207,null),a.localize(208,null)],markdownDescription:a.localize(209,null)})),multiCursorPaste:De(new m(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(210,null),a.localize(211,null)],markdownDescription:a.localize(212,null)})),occurrencesHighlight:De(new d(71,"occurrencesHighlight",!0,{description:a.localize(213,null)})),overviewRulerBorder:De(new d(72,"overviewRulerBorder",!0,{description:a.localize(214,null)})),overviewRulerLanes:De(new u(73,"overviewRulerLanes",3,0,3)),padding:De(new de),parameterHints:De(new Q),peekWidgetDefaultFocus:De(new m(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(215,null),a.localize(216,null)],description:a.localize(217,null)})),definitionLinkOpensInPeek:De(new d(77,"definitionLinkOpensInPeek",!1,{description:a.localize(218,null)})),quickSuggestions:De(new we),quickSuggestionsDelay:De(new u(79,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(219,null)})),readOnly:De(new d(80,"readOnly",!1)),renameOnType:De(new d(81,"renameOnType",!1,{description:a.localize(220,null),markdownDeprecationMessage:a.localize(221,null)})),renderControlCharacters:De(new d(82,"renderControlCharacters",!0,{description:a.localize(222,null),restricted:!0})),renderFinalNewline:De(new d(83,"renderFinalNewline",!0,{description:a.localize(223,null)})),renderLineHighlight:De(new m(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(224,null)],description:a.localize(225,null)})),renderLineHighlightOnlyWhenFocus:De(new d(85,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(226,null)})),renderValidationDecorations:De(new m(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:De(new m(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(227,null),a.localize(228,null),a.localize(229,null),""],description:a.localize(230,null)})),revealHorizontalRightPadding:De(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:De(new d(89,"roundedSelection",!0,{description:a.localize(231,null)})),rulers:De(new Ke),scrollbar:De(new Qe),scrollBeyondLastColumn:De(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:a.localize(232,null)})),scrollBeyondLastLine:De(new d(93,"scrollBeyondLastLine",!0,{description:a.localize(233,null)})),scrollPredominantAxis:De(new d(94,"scrollPredominantAxis",!0,{description:a.localize(234,null)})),selectionClipboard:De(new d(95,"selectionClipboard",!0,{description:a.localize(235,null),included:F.isLinux})),selectionHighlight:De(new d(96,"selectionHighlight",!0,{description:a.localize(236,null)})),selectOnLineNumbers:De(new d(97,"selectOnLineNumbers",!0)),showFoldingControls:De(new m(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),showUnused:De(new d(99,"showUnused",!0,{description:a.localize(240,null)})),showDeprecated:De(new d(125,"showDeprecated",!0,{description:a.localize(241,null)})),inlayHints:De(new q),snippetSuggestions:De(new m(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(242,null),a.localize(243,null),a.localize(244,null),a.localize(245,null)],description:a.localize(246,null)})),smartSelect:De(new Te),smoothScrolling:De(new d(102,"smoothScrolling",!1,{description:a.localize(247,null)})),stopRenderingLineAfter:De(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:De(new fe),inlineSuggest:De(new X),suggestFontSize:De(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(248,null)})),suggestLineHeight:De(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(249,null)})),suggestOnTriggerCharacters:De(new d(108,"suggestOnTriggerCharacters",!0,{description:a.localize(250,null)})),suggestSelection:De(new m(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(251,null),a.localize(252,null),a.localize(253,null)],description:a.localize(254,null)})),tabCompletion:De(new m(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(255,null),a.localize(256,null),a.localize(257,null)],description:a.localize(258,null)})),tabIndex:De(new u(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:De(new $),unusualLineTerminators:De(new m(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(259,null),a.localize(260,null),a.localize(261,null)],description:a.localize(262,null)})),useShadowDOM:De(new d(114,"useShadowDOM",!0)),useTabStops:De(new d(115,"useTabStops",!0,{description:a.localize(263,null)})),wordSeparators:De(new k(116,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:a.localize(264,null)})),wordWrap:De(new m(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(265,null),a.localize(266,null),a.localize(267,null),a.localize(268,null)],description:a.localize(269,null)})),wordWrapBreakAfterCharacters:De(new k(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:De(new k(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:De(new u(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(270,null)})),wordWrapOverride1:De(new m(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:De(new m(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:De(new f(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ge,{enumDescriptions:[a.localize(271,null),a.localize(272,null),a.localize(273,null),a.localize(274,null)],description:a.localize(275,null)})),wrappingStrategy:De(new m(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[a.localize(276,null),a.localize(277,null)],description:a.localize(278,null)})),editorClassName:De(new v),pixelRatio:De(new ie),tabFocusMode:De(new Ne),layoutInfo:De(new z),wrappingInfo:De(new tt)}}),define(Ee[115],_e([18,19]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[116],_e([18,19]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[117],_e([18,19]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(Ee[118],_e([18,19]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(Ee[119],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[120],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[121],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[122],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[123],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[124],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[125],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[126],_e([18,19]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(Ee[127],_e([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[128],_e([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[129],_e([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[130],_e([18,19]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[131],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var a;(function(t){t[t.ACTIVATE=1]="ACTIVATE",t[t.RESTORE=2]="RESTORE",t[t.PRESERVE=3]="PRESERVE"})(a=e.EditorActivation||(e.EditorActivation={}));var F;(function(t){t[t.PICK=0]="PICK",t[t.DISABLED=1]="DISABLED",t[t.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var w;(function(t){t[t.API=0]="API",t[t.USER=1]="USER"})(w=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(t){t[t.Center=0]="Center",t[t.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",t[t.NearTop=2]="NearTop",t[t.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[132],_e([0,1,116]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function T(n){return n=n.trim(),n==="*"||F.test(n)}e.isValidVersionStr=T;function t(n){if(!T(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=n.match(F);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=t;function A(n){if(!n)return null;let d=n.majorBase,s=n.majorMustEqual,u=n.minorBase,g=n.minorMustEqual,k=n.patchBase,b=n.patchMustEqual;n.hasCaret&&(d===0||(g=!1),b=!1);let m=0;if(n.preRelease){const f=w.exec(n.preRelease);if(f){const[,P,l,M]=f;m=Date.UTC(Number(P),Number(l)-1,Number(M))}}return{majorBase:d,majorMustEqual:s,minorBase:u,minorMustEqual:g,patchBase:k,patchMustEqual:b,isMinimum:n.hasGreaterEquals,notBefore:m}}e.normalizeVersion=A;function S(n,d,s){let u;typeof n=="string"?u=A(t(n)):u=n;let g;d instanceof Date?g=d.getTime():typeof d=="string"&&(g=new Date(d).getTime());let k;if(typeof s=="string"?k=A(t(s)):k=s,!u||!k)return!1;let b=u.majorBase,m=u.minorBase,f=u.patchBase,P=k.majorBase,l=k.minorBase,M=k.patchBase,r=k.notBefore,i=k.majorMustEqual,p=k.minorMustEqual,h=k.patchMustEqual;return k.isMinimum?b>P?!0:b<P?!1:m>l?!0:m<l||g&&g<r?!1:f>=M:(b===1&&P===0&&(!i||!p||!h)&&(P=1,l=0,M=0,i=!0,p=!1,h=!1),b<P?!1:b>P?!i:m<l?!1:m>l?!p:f<M?!1:f>M?!h:!(g&&g<r))}e.isValidVersion=S;function C(n,d,s,u){return s.isBuiltin||typeof s.main=="undefined"?!0:_(n,d,s.engines.vscode,u)}e.isValidExtensionVersion=C;function R(n,d,s){return n==="*"||_(d,s,n)}e.isEngineValid=R;function _(n,d,s,u=[]){let g=A(t(s));if(!g)return u.push(a.localize(0,null,s)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return u.push(a.localize(1,null,s)),!1}else if(!g.majorMustEqual)return u.push(a.localize(2,null,s)),!1;return S(n,d,g)?!0:(u.push(a.localize(3,null,n,s)),!1)}}),define(Ee[81],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(w,T=[],t=!1){this.ctor=w,this.staticArguments=T,this.supportsDelayedInstantiation=t}}e.SyncDescriptor=a}),define(Ee[56],_e([0,1,81]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function w(t,A,S){A instanceof a.SyncDescriptor||(A=new a.SyncDescriptor(A,[],S)),F.push([t,A])}e.registerSingleton=w;function T(){return F}e.getSingletonServiceDescriptors=T}),define(Ee[133],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=a;class F{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let t of this._nodes.values())t.outgoing.size===0&&T.push(t);return T}insertEdge(T,t){const A=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(t);A.outgoing.set(this._hashFn(t),S),S.incoming.set(this._hashFn(T),A)}removeNode(T){const t=this._hashFn(T);this._nodes.delete(t);for(let A of this._nodes.values())A.outgoing.delete(t),A.incoming.delete(t)}lookupOrInsertNode(T){const t=this._hashFn(T);let A=this._nodes.get(t);return A||(A=new a(T),this._nodes.set(t,A)),A}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[t,A]of this._nodes)T.push(`${t}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,t]of this._nodes){const A=new Set([T]),S=this._findCycle(t,A);if(S)return S}}_findCycle(T,t){for(let[A,S]of T.outgoing){if(t.has(A))return[...t,A].join(" -> ");t.add(A);const C=this._findCycle(S,t);if(C)return C;t.delete(A)}}}e.Graph=F}),define(Ee[4],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(t){t.serviceIds=new Map,t.DI_TARGET="$di$target",t.DI_DEPENDENCIES="$di$dependencies";function A(S){return S[t.DI_DEPENDENCIES]||[]}t.getServiceDependencies=A})(a=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function F(t,A,S,C){A[a.DI_TARGET]===A?A[a.DI_DEPENDENCIES].push({id:t,index:S,optional:C}):(A[a.DI_DEPENDENCIES]=[{id:t,index:S,optional:C}],A[a.DI_TARGET]=A)}function w(t){if(a.serviceIds.has(t))return a.serviceIds.get(t);const A=function(S,C,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(A,S,R,!1)};return A.toString=()=>t,a.serviceIds.set(t,A),A}e.createDecorator=w;function T(t){return t}e.refineServiceDecorator=T}),define(Ee[134],_e([0,1,4]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,a.createDecorator)("modelService");function F(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(Ee[135],_e([0,1,3,57,6,21,76,55,134]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(C):!!u.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new a.Emitter}get onDidChange(){return this._onDidChange.event}register(g,k){let b={selector:g,provider:k,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,w.toDisposable)(()=>{if(b){let m=this._entries.indexOf(b);m>=0&&(this._entries.splice(m,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const k=[];for(let b of this._entries)b._score>0&&k.push(b.provider);return k}ordered(g){const k=[];return this._orderedForEach(g,b=>k.push(b.provider)),k}orderedGroups(g){const k=[];let b,m;return this._orderedForEach(g,f=>{b&&m===f._score?b.push(f.provider):(m=f._score,b=[f.provider],k.push(b))}),k}_orderedForEach(g,k){if(!!g){this._updateScores(g);for(const b of this._entries)b._score>0&&k(b)}}_updateScores(g){let k={uri:g.uri.toString(),language:g.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===k.language&&this._lastCandidate.uri===k.uri)){this._lastCandidate=k;for(let b of this._entries)if(b._score=(0,A.score)(b.selector,g.uri,g.getLanguageId(),(0,S.shouldSynchronizeModel)(g)),C(b.selector)&&b._score>0){for(let m of this._entries)m._score=0;b._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(g,k){return g._score<k._score?1:g._score>k._score?-1:g._time<k._time?1:g._time>k._time?-1:0}}e.LanguageFeatureRegistry=R;const _=new WeakMap;let n=0;function d(u){let g=_.get(u);return g===void 0&&(g=++n,_.set(u,g)),g}class s{constructor(g,k,b=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=k,this.max=b,this._cache=new T.LRUCache(50,.7)}_key(g){return g.id+this._registry.all(g).reduce((k,b)=>(0,F.doHash)(d(b),k),0)}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const k=this._key(g),b=this._cache.get(k);return this._clamp(b?.value)}update(g,k){const b=this._key(g);let m=this._cache.get(b);return m||(m=new t.MovingAverage,this._cache.set(b,m)),m.update(k),this.get(g)}}e.LanguageFeatureRequestDelays=s}),define(Ee[58],_e([0,1,2,59,135,108,53]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var A;(function(c){c[c.Null=0]="Null",c[c.PlainText=1]="PlainText"})(A=e.LanguageId||(e.LanguageId={}));var S;(function(c){c[c.NotSet=-1]="NotSet",c[c.None=0]="None",c[c.Italic=1]="Italic",c[c.Bold=2]="Bold",c[c.Underline=4]="Underline"})(S=e.FontStyle||(e.FontStyle={}));var C;(function(c){c[c.None=0]="None",c[c.DefaultForeground=1]="DefaultForeground",c[c.DefaultBackground=2]="DefaultBackground"})(C=e.ColorId||(e.ColorId={}));var R;(function(c){c[c.Other=0]="Other",c[c.Comment=1]="Comment",c[c.String=2]="String",c[c.RegEx=4]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(c){c[c.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",c[c.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",c[c.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",c[c.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",c[c.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",c[c.ITALIC_MASK=2048]="ITALIC_MASK",c[c.BOLD_MASK=4096]="BOLD_MASK",c[c.UNDERLINE_MASK=8192]="UNDERLINE_MASK",c[c.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",c[c.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",c[c.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",c[c.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",c[c.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",c[c.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",c[c.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",c[c.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",c[c.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",c[c.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let I=this.getForeground(E),D="mtk"+I,B=this.getFontStyle(E);return B&1&&(D+=" mtki"),B&2&&(D+=" mtkb"),B&4&&(D+=" mtku"),D}static getInlineStyleFromMetadata(E,I){const D=this.getForeground(E),B=this.getFontStyle(E);let L=`color: ${I[D]};`;return B&1&&(L+="font-style: italic;"),B&2&&(L+="font-weight: bold;"),B&4&&(L+="text-decoration: underline;"),L}}e.TokenMetadata=n;var d;(function(c){c[c.Method=0]="Method",c[c.Function=1]="Function",c[c.Constructor=2]="Constructor",c[c.Field=3]="Field",c[c.Variable=4]="Variable",c[c.Class=5]="Class",c[c.Struct=6]="Struct",c[c.Interface=7]="Interface",c[c.Module=8]="Module",c[c.Property=9]="Property",c[c.Event=10]="Event",c[c.Operator=11]="Operator",c[c.Unit=12]="Unit",c[c.Value=13]="Value",c[c.Constant=14]="Constant",c[c.Enum=15]="Enum",c[c.EnumMember=16]="EnumMember",c[c.Keyword=17]="Keyword",c[c.Text=18]="Text",c[c.Color=19]="Color",c[c.File=20]="File",c[c.Reference=21]="Reference",c[c.Customcolor=22]="Customcolor",c[c.Folder=23]="Folder",c[c.TypeParameter=24]="TypeParameter",c[c.User=25]="User",c[c.Issue=26]="Issue",c[c.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let c=Object.create(null);return c[0]="symbol-method",c[1]="symbol-function",c[2]="symbol-constructor",c[3]="symbol-field",c[4]="symbol-variable",c[5]="symbol-class",c[6]="symbol-struct",c[7]="symbol-interface",c[8]="symbol-module",c[9]="symbol-property",c[10]="symbol-event",c[11]="symbol-operator",c[12]="symbol-unit",c[13]="symbol-value",c[14]="symbol-constant",c[15]="symbol-enum",c[16]="symbol-enum-member",c[17]="symbol-keyword",c[27]="symbol-snippet",c[18]="symbol-text",c[19]="symbol-color",c[20]="symbol-file",c[21]="symbol-reference",c[22]="symbol-customcolor",c[23]="symbol-folder",c[24]="symbol-type-parameter",c[25]="account",c[26]="issues",function(E){const I=c[E];let D=I&&t.iconRegistry.get(I);return D||(console.info("No codicon found for CompletionItemKind "+E),D=t.Codicon.symbolProperty),D.classNames}}(),e.completionKindFromString=function(){let c=Object.create(null);return c.method=0,c.function=1,c.constructor=2,c.field=3,c.variable=4,c.class=5,c.struct=6,c.interface=7,c.module=8,c.property=9,c.event=10,c.operator=11,c.unit=12,c.value=13,c.constant=14,c.enum=15,c["enum-member"]=16,c.enumMember=16,c.keyword=17,c.snippet=27,c.text=18,c.color=19,c.file=20,c.reference=21,c.customcolor=22,c.folder=23,c["type-parameter"]=24,c.typeParameter=24,c.account=25,c.issue=26,function(E,I){let D=c[E];return typeof D=="undefined"&&!I&&(D=9),D}}();var s;(function(c){c[c.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var u;(function(c){c[c.KeepWhitespace=1]="KeepWhitespace",c[c.InsertAsSnippet=4]="InsertAsSnippet"})(u=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(c){c[c.Invoke=0]="Invoke",c[c.TriggerCharacter=1]="TriggerCharacter",c[c.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var k;(function(c){c[c.Automatic=0]="Automatic",c[c.Explicit=1]="Explicit"})(k=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(c){c[c.Invoke=1]="Invoke",c[c.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(c){c[c.Invoke=1]="Invoke",c[c.TriggerCharacter=2]="TriggerCharacter",c[c.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(c){c[c.Text=0]="Text",c[c.Read=1]="Read",c[c.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function P(c){return c&&a.URI.isUri(c.uri)&&F.Range.isIRange(c.range)&&(F.Range.isIRange(c.originSelectionRange)||F.Range.isIRange(c.targetSelectionRange))}e.isLocationLink=P;var l;(function(c){c[c.File=0]="File",c[c.Module=1]="Module",c[c.Namespace=2]="Namespace",c[c.Package=3]="Package",c[c.Class=4]="Class",c[c.Method=5]="Method",c[c.Property=6]="Property",c[c.Field=7]="Field",c[c.Constructor=8]="Constructor",c[c.Enum=9]="Enum",c[c.Interface=10]="Interface",c[c.Function=11]="Function",c[c.Variable=12]="Variable",c[c.Constant=13]="Constant",c[c.String=14]="String",c[c.Number=15]="Number",c[c.Boolean=16]="Boolean",c[c.Array=17]="Array",c[c.Object=18]="Object",c[c.Key=19]="Key",c[c.Null=20]="Null",c[c.EnumMember=21]="EnumMember",c[c.Struct=22]="Struct",c[c.Event=23]="Event",c[c.Operator=24]="Operator",c[c.TypeParameter=25]="TypeParameter"})(l=e.SymbolKind||(e.SymbolKind={}));var M;(function(c){c[c.Deprecated=1]="Deprecated"})(M=e.SymbolTag||(e.SymbolTag={}));var r;(function(c){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const I=new Map;I.set(0,"file"),I.set(1,"module"),I.set(2,"namespace"),I.set(3,"package"),I.set(4,"class"),I.set(5,"method"),I.set(6,"property"),I.set(7,"field"),I.set(8,"constructor"),I.set(9,"enum"),I.set(10,"interface"),I.set(11,"function"),I.set(12,"variable"),I.set(13,"constant"),I.set(14,"string"),I.set(15,"number"),I.set(16,"boolean"),I.set(17,"array"),I.set(18,"object"),I.set(19,"key"),I.set(20,"null"),I.set(21,"enum-member"),I.set(22,"struct"),I.set(23,"event"),I.set(24,"operator"),I.set(25,"type-parameter");function D(y){return E.get(y)}c.fromString=D;function B(y){return I.get(y)}c.toString=B;function L(y,x){const N=I.get(y);let z=N&&t.iconRegistry.get("symbol-"+N);return z||(console.info("No codicon found for SymbolKind "+y),z=t.Codicon.symbolProperty),`${x?"inline":"block"} ${z.classNames}`}c.toCssClassName=L})(r=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(E){this.value=E}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var p;(function(c){c[c.Collapsed=0]="Collapsed",c[c.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(c){c[c.Editing=0]="Editing",c[c.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var o;(function(c){c[c.Other=0]="Other",c[c.Type=1]="Type",c[c.Parameter=2]="Parameter"})(o=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new w.LanguageFeatureRegistry,e.RenameProviderRegistry=new w.LanguageFeatureRegistry,e.CompletionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new w.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new w.LanguageFeatureRegistry,e.HoverProviderRegistry=new w.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new w.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new w.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new w.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new w.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new w.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.LinkProviderRegistry=new w.LanguageFeatureRegistry,e.ColorProviderRegistry=new w.LanguageFeatureRegistry,e.SelectionRangeRegistry=new w.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var v;(function(c){c[c.None=0]="None",c[c.Option=1]="Option",c[c.Default=2]="Default",c[c.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[44],_e([0,1,23,9,4]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=a.userAgent||"";const t=new Map;t.set("false",!1),t.set("true",!0),t.set("isMac",a.isMacintosh),t.set("isLinux",a.isLinux),t.set("isWindows",a.isWindows),t.set("isWeb",a.isWeb),t.set("isMacNative",a.isMacintosh&&!a.isWeb),t.set("isEdge",T.indexOf("Edg/")>=0),t.set("isFirefox",T.indexOf("Firefox")>=0),t.set("isChrome",T.indexOf("Chrome")>=0),t.set("isSafari",T.indexOf("Safari")>=0);const A=Object.prototype.hasOwnProperty;var S;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return n.INSTANCE}static true(){return d.INSTANCE}static has(y){return s.create(y)}static equals(y,x){return u.create(y,x)}static notEquals(y,x){return b.create(y,x)}static regex(y,x){return i.create(y,x)}static in(y,x){return g.create(y,x)}static not(y){return m.create(y)}static and(...y){return o.create(y,null)}static or(...y){return v.create(y,null,!0)}static greater(y,x){return P.create(y,x)}static greaterEquals(y,x){return l.create(y,x)}static smaller(y,x){return M.create(y,x)}static smallerEquals(y,x){return r.create(y,x)}static deserialize(y,x=!1){if(!!y)return this._deserializeOrExpression(y,x)}static _deserializeOrExpression(y,x){let N=y.split("||");return v.create(N.map(z=>this._deserializeAndExpression(z,x)),null,!0)}static _deserializeAndExpression(y,x){let N=y.split("&&");return o.create(N.map(z=>this._deserializeOne(z,x)),null)}static _deserializeOne(y,x){if(y=y.trim(),y.indexOf("!=")>=0){let N=y.split("!=");return b.create(N[0].trim(),this._deserializeValue(N[1],x))}if(y.indexOf("==")>=0){let N=y.split("==");return u.create(N[0].trim(),this._deserializeValue(N[1],x))}if(y.indexOf("=~")>=0){let N=y.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(y.indexOf(" in ")>=0){let N=y.split(" in ");return g.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const N=y.split(">=");return l.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const N=y.split(">");return P.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const N=y.split("<=");return r.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const N=y.split("<");return M.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(y)?m.create(y.substr(1).trim()):s.create(y)}static _deserializeValue(y,x){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let N=/^'([^']*)'$/.exec(y);return N?N[1].trim():y}static _deserializeRegexValue(y,x){if((0,F.isFalsyOrWhitespace)(y)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=y.indexOf("/"),z=y.lastIndexOf("/");if(N===z||N<0){if(x)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let H=y.slice(N+1,z),q=y[z+1]==="i"?"i":"";try{return new RegExp(H,q)}catch(ue){if(x)throw new Error(`bad regexp-value '${y}', parse error: ${ue}`);return console.warn(`bad regexp-value '${y}', parse error: ${ue}`),null}}}e.ContextKeyExpr=C;function R(L,y){const x=L?L.substituteConstants():void 0,N=y?y.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=R;function _(L,y){return L.cmp(y)}class n{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class d{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class s{constructor(y,x){this.key=y,this.negated=x,this.type=2}static create(y,x=null){const N=t.get(y);return typeof N=="boolean"?N?d.INSTANCE:n.INSTANCE:new s(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=t.get(this.key);return typeof y=="boolean"?y?d.INSTANCE:n.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=s;class u{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=4}static create(y,x,N=null){if(typeof x=="boolean")return x?s.create(y,N):m.create(y,N);const z=t.get(y);return typeof z=="boolean"?x===(z?"true":"false")?d.INSTANCE:n.INSTANCE:new u(y,x,N)}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=t.get(this.key);if(typeof y=="boolean"){const x=y?"true":"false";return this.value===x?d.INSTANCE:n.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class g{constructor(y,x){this.key=y,this.valueKey=x,this.type=10,this.negated=null}static create(y,x){return new g(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const x=y.getValue(this.valueKey),N=y.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?A.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=k.create(this)),this.negated}}e.ContextKeyInExpr=g;class k{constructor(y){this._actual=y,this.type=11}static create(y){return new k(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new k(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=k;class b{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=5}static create(y,x,N=null){if(typeof x=="boolean")return x?m.create(y,N):s.create(y,N);const z=t.get(y);return typeof z=="boolean"?x===(z?"true":"false")?n.INSTANCE:d.INSTANCE:new b(y,x,N)}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=t.get(this.key);if(typeof y=="boolean"){const x=y?"true":"false";return this.value===x?n.INSTANCE:d.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class m{constructor(y,x){this.key=y,this.negated=x,this.type=3}static create(y,x=null){const N=t.get(y);return typeof N=="boolean"?N?n.INSTANCE:d.INSTANCE:new m(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=t.get(this.key);return typeof y=="boolean"?y?n.INSTANCE:d.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function f(L,y){if(typeof L=="string"){const x=parseFloat(L);isNaN(x)||(L=x)}return typeof L=="string"||typeof L=="number"?y(L):n.INSTANCE}class P{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=12}static create(y,x,N=null){return f(x,z=>new P(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=P;class l{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=13}static create(y,x,N=null){return f(x,z=>new l(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class M{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=14}static create(y,x,N=null){return f(x,z=>new M(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class r{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=15}static create(y,x,N=null){return f(x,z=>new r(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(y,x){this.key=y,this.regexp=x,this.type=7,this.negated=null}static create(y,x){return new i(y,x)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const x=this.regexp?this.regexp.source:"",N=y.regexp?y.regexp.source:"";return x<N?-1:x>N?1:0}equals(y){if(y.type===this.type){const x=this.regexp?this.regexp.source:"",N=y.regexp?y.regexp.source:"";return this.key===y.key&&x===N}return!1}substituteConstants(){return this}evaluate(y){let x=y.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class p{constructor(y){this._actual=y,this.type=8}static create(y){return new p(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new p(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=p;function h(L){let y=null;for(let x=0,N=L.length;x<N;x++){const z=L[x].substituteConstants();if(L[x]!==z&&y===null){y=[];for(let H=0;H<x;H++)y[H]=L[H]}y!==null&&(y[x]=z)}return y===null?L:y}class o{constructor(y,x){this.expr=y,this.negated=x,this.type=6}static create(y,x){return o._normalizeArr(y,x)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const z=_(this.expr[x],y.expr[x]);if(z!==0)return z}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(y.expr[x]))return!1;return!0}return!1}substituteConstants(){const y=h(this.expr);return y===this.expr?this:o.create(y,this.negated)}evaluate(y){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(y))return!1;return!0}static _normalizeArr(y,x){const N=[];let z=!1;for(const H of y)if(!!H){if(H.type===1){z=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){N.push(...H.expr);continue}N.push(H)}if(N.length===0&&z)return d.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(_);for(let H=1;H<N.length;H++)N[H-1].equals(N[H])&&(N.splice(H,1),H--);if(N.length===1)return N[0];for(;N.length>1;){const H=N[N.length-1];if(H.type!==9)break;N.pop();const q=N.pop(),ue=N.length===0,G=v.create(H.expr.map(ce=>o.create([ce,q],null)),null,ue);G&&(N.push(G),N.sort(_))}return N.length===1?N[0]:new o(N,x)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let x of this.expr)y.push(...x.keys());return y}map(y){return new o(this.expr.map(x=>x.map(y)),null)}negate(){if(!this.negated){const y=[];for(let x of this.expr)y.push(x.negate());this.negated=v.create(y,this,!0)}return this.negated}}class v{constructor(y,x){this.expr=y,this.negated=x,this.type=9}static create(y,x,N){return v._normalizeArr(y,x,N)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const z=_(this.expr[x],y.expr[x]);if(z!==0)return z}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(y.expr[x]))return!1;return!0}return!1}substituteConstants(){const y=h(this.expr);return y===this.expr?this:v.create(y,this.negated,!1)}evaluate(y){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(y))return!0;return!1}static _normalizeArr(y,x,N){let z=[],H=!1;if(y){for(let q=0,ue=y.length;q<ue;q++){const G=y[q];if(!!G){if(G.type===0){H=!0;continue}if(G.type===1)return d.INSTANCE;if(G.type===9){z=z.concat(G.expr);continue}z.push(G)}}if(z.length===0&&H)return n.INSTANCE;z.sort(_)}if(z.length!==0){if(z.length===1)return z[0];for(let q=1;q<z.length;q++)z[q-1].equals(z[q])&&(z.splice(q,1),q--);if(z.length===1)return z[0];if(N){for(let q=0;q<z.length;q++)for(let ue=q+1;ue<z.length;ue++)D(z[q],z[ue])&&(z.splice(ue,1),ue--);if(z.length===1)return z[0]}return new v(z,x)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let x of this.expr)y.push(...x.keys());return y}map(y){return new v(this.expr.map(x=>x.map(y)),null)}negate(){if(!this.negated){let y=[];for(let x of this.expr)y.push(x.negate());for(;y.length>1;){const x=y.shift(),N=y.shift(),z=[];for(const q of B(x))for(const ue of B(N))z.push(o.create([q,ue],null));const H=y.length===0;y.unshift(v.create(z,null,H))}this.negated=y[0]}return this.negated}}class c extends s{constructor(y,x,N){super(y,null);this._defaultValue=x,typeof N=="object"?c._info.push({...N,key:y}):N!==!0&&c._info.push({key:y,description:N,type:x!=null?typeof x:void 0})}static all(){return c._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return u.create(this.key,y)}notEqualsTo(y){return b.create(this.key,y)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(L,y){return L<y?-1:L>y?1:0}function I(L,y,x,N){return L<x?-1:L>x?1:y<N?-1:y>N?1:0}function D(L,y){if(y.type===6&&L.type!==9&&L.type!==6){for(const z of y.expr)if(L.equals(z))return!0}const x=L.negate(),N=B(x).concat(B(y));N.sort(_);for(let z=0;z<N.length;z++){const q=N[z].negate();for(let ue=z+1;ue<N.length;ue++){const G=N[ue];if(q.equals(G))return!0}}return!1}e.implies=D;function B(L){return L.type===9?L.expr:[L]}}),define(Ee[136],_e([0,1,4]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[45],_e([0,1,21,17,9,11,2,117,4]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(N){return N.create===!0}e.isFileOpenForWriteOptions=C;var R;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=d;function s(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=s;function u(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function g(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=g;var k;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,H){super(z);this.code=H}}e.FileSystemProviderError=b;function m(N,z){const H=new b(N.toString(),z);return P(H,z),H}e.createFileSystemProviderError=m;function f(N){return N||m((0,A.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=f;function P(N,z){return N.name=z?`${z} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=P;function l(N){if(!N)return k.Unknown;if(N instanceof b)return N.code;const z=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!z)return k.Unknown;switch(z[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=l;function M(N){if(N instanceof v)return N.fileOperationResult;switch(l(N)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=M;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(z,H,q){this.resource=z,this.operation=H,this.target=q}isOperation(z){return this.operation===z}}e.FileOperationEvent=i;var p;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(p=e.FileChangeType||(e.FileChangeType={}));class h{constructor(z,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const q=new Map;for(const ue of z){const G=q.get(ue.type);G?G.push([ue.resource,ue]):q.set(ue.type,[[ue.resource,ue]])}for(const[ue,G]of q)switch(ue){case 1:this.added=a.TernarySearchTree.forUris(()=>H),this.added.fill(G);break;case 0:this.updated=a.TernarySearchTree.forUris(()=>H),this.updated.fill(G);break;case 2:this.deleted=a.TernarySearchTree.forUris(()=>H),this.deleted.fill(G);break}}contains(z,...H){return this.doContains(z,{includeChildren:!1},...H)}affects(z,...H){return this.doContains(z,{includeChildren:!0},...H)}doContains(z,H,...q){if(!z)return!1;const ue=q.length>0;return!!((!ue||q.includes(1))&&(this.added?.get(z)||H.includeChildren&&this.added?.findSuperstr(z))||(!ue||q.includes(0))&&(this.updated?.get(z)||H.includeChildren&&this.updated?.findSuperstr(z))||(!ue||q.includes(2))&&(this.deleted?.findSubstr(z)||H.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function o(N,z,H){return!N||!z||N===z||z.length>N.length?!1:(z.charAt(z.length-1)!==F.sep&&(z+=F.sep),H?(0,w.startsWithIgnoreCase)(N,z):N.indexOf(z)===0)}e.isParent=o;class v extends Error{constructor(z,H,q){super(z);this.fileOperationResult=H,this.options=q}}e.FileOperationError=v;class c extends v{constructor(z,H,q){super(z,2,q);this.stat=H}}e.NotModifiedSinceFileOperationError=c;var E;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=D;async function B(N,z){if(!z.hasProvider(t.URI.from({scheme:N.scheme})))return new Promise(H=>{const q=z.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===N.scheme&&ue.added&&(q.dispose(),H())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(z){return(0,T.isNumber)(z)||(z=0),z<L.KB?(0,A.localize)(1,null,z.toFixed(0)):z<L.MB?(0,A.localize)(2,null,(z/L.KB).toFixed(2)):z<L.GB?(0,A.localize)(3,null,(z/L.MB).toFixed(2)):z<L.TB?(0,A.localize)(4,null,(z/L.GB).toFixed(2)):(0,A.localize)(5,null,(z/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var y;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(y=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*L.MB:16*L.GB,maxHeapSize:N===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=x}),define(Ee[60],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...w){this._entries=new Map;for(let[T,t]of w)this.set(T,t)}set(w,T){const t=this._entries.get(w);return this._entries.set(w,T),t}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=a}),define(Ee[137],_e([0,1,14,15,81,133,4,60]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class C extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class R{constructor(s=new A.ServiceCollection,u=!1,g){this._activeInstantiations=new Set,this._services=s,this._strict=u,this._parent=g,this._services.set(t.IInstantiationService,this)}createChild(s){return new R(s,this._strict,this)}invokeFunction(s,...u){let g=n.traceInvocation(s),k=!1;try{return s({get:m=>{if(k)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(m,g);if(!f)throw new Error(`[invokeFunction] unknown service '${m}'`);return f}},...u)}finally{k=!0,g.stop()}}createInstance(s,...u){let g,k;return s instanceof w.SyncDescriptor?(g=n.traceCreation(s.ctor),k=this._createInstance(s.ctor,s.staticArguments.concat(u),g)):(g=n.traceCreation(s),k=this._createInstance(s,u,g)),g.stop(),k}_createInstance(s,u=[],g){let k=t._util.getServiceDependencies(s).sort((f,P)=>f.index-P.index),b=[];for(const f of k){let P=this._getOrCreateServiceInstance(f.id,g);if(!P&&this._strict&&!f.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${f.id}.`);b.push(P)}let m=k.length>0?k[0].index:u.length;if(u.length!==m){console.warn(`[createInstance] First service dependency of ${s.name} at position ${m+1} conflicts with ${u.length} static arguments`);let f=m-u.length;f>0?u=u.concat(new Array(f)):u=u.slice(0,m)}return new s(...[...u,...b])}_setServiceInstance(s,u){if(this._services.get(s)instanceof w.SyncDescriptor)this._services.set(s,u);else if(this._parent)this._parent._setServiceInstance(s,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let u=this._services.get(s);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):u}_getOrCreateServiceInstance(s,u){let g=this._getServiceInstanceOrDescriptor(s);return g instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,g,u.branch(s,!0)):(u.branch(s,!1),g)}_safeCreateAndCacheServiceInstance(s,u,g){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,u,g)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,u,g){const k=new T.Graph(f=>f.id.toString());let b=0;const m=[{id:s,desc:u,_trace:g}];for(;m.length;){const f=m.pop();if(k.lookupOrInsertNode(f),b++>1e3)throw new C(k);for(let P of t._util.getServiceDependencies(f.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(P.id);if(!l&&!P.optional&&console.warn(`[createInstance] ${s} depends on ${P.id} which is NOT registered.`),l instanceof w.SyncDescriptor){const M={id:P.id,desc:l,_trace:f._trace.branch(P.id,!0)};k.insertEdge(f,M),m.push(M)}}}for(;;){const f=k.roots();if(f.length===0){if(!k.isEmpty())throw new C(k);break}for(const{data:P}of f){if(this._getServiceInstanceOrDescriptor(P.id)instanceof w.SyncDescriptor){const M=this._createServiceInstanceWithOwner(P.id,P.desc.ctor,P.desc.staticArguments,P.desc.supportsDelayedInstantiation,P._trace);this._setServiceInstance(P.id,M)}k.removeNode(P)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,u,g=[],k,b){if(this._services.get(s)instanceof w.SyncDescriptor)return this._createServiceInstance(u,g,k,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,u,g,k,b);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(s,u=[],g,k){if(g){const b=new a.IdleValue(()=>this._createInstance(s,u,k));return new Proxy(Object.create(null),{get(m,f){if(f in m)return m[f];let P=b.value,l=P[f];return typeof l!="function"||(l=l.bind(P),m[f]=l),l},set(m,f,P){return b.value[f]=P,!0}})}else return this._createInstance(s,u,k)}}e.InstantiationService=R;var _;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(_||(_={}));class n{constructor(s,u){this.type=s,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return S?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return S?new n(0,s.name):n._None}branch(s,u){let g=new n(2,s.toString());return this._dep.push([s,u,g]),g}stop(){let s=Date.now()-this._start;n._totals+=s;let u=!1;function g(b,m){let f=[],P=new Array(b+1).join("	");for(const[l,M,r]of m._dep)if(M&&r){u=!0,f.push(`${P}CREATES -> ${l}`);let i=g(b+1,r);i&&f.push(i)}else f.push(`${P}uses -> ${l}`);return f.join(`
`)}let k=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||u)&&console.log(k.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(Ee[12],_e([0,1,43,3,6,23,4]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,t.createDecorator)("logService"),e.ILoggerService=(0,t.createDecorator)("loggerService");function A(){return new Date().toISOString()}var S;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function C(M,r,i){switch(r){case S.Trace:M.trace(i);break;case S.Debug:M.debug(i);break;case S.Info:M.info(i);break;case S.Warning:M.warn(i);break;case S.Error:M.error(i);break;case S.Critical:M.critical(i);break;default:throw new Error("Invalid log level")}}e.log=C;function R(M){let r="";for(let i=0;i<M.length;i++){let p=M[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch(h){}r+=(i>0?" ":"")+p}return r}e.format=R;class _ extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class n extends _{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(S.Trace)&&this.log(S.Trace,R([r,...i]))}debug(r,...i){this.checkLogLevel(S.Debug)&&this.log(S.Debug,R([r,...i]))}info(r,...i){this.checkLogLevel(S.Info)&&this.log(S.Info,R([r,...i]))}warn(r,...i){this.checkLogLevel(S.Warning)&&this.log(S.Warning,R([r,...i]))}error(r,...i){if(this.checkLogLevel(S.Error))if(r instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=r.stack,this.log(S.Error,R(p))}else this.log(S.Error,R([r,...i]))}critical(r,...i){this.checkLogLevel(S.Critical)&&this.log(S.Critical,R([r,...i]))}flush(){}}e.AbstractMessageLogger=n;class d extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!T.isWindows}trace(r,...i){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}debug(r,...i){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}info(r,...i){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}warn(r,...i){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,r,...i):console.warn(`[main ${A()}]`,r,...i))}error(r,...i){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,r,...i):console.error(`[main ${A()}]`,r,...i))}critical(r,...i){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,r,...i):console.error(`[main ${A()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class s extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=s;class u extends _{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,a.toErrorMessage)(r,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class g extends _{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const p of this.logServices)p.trace(r,...i)}debug(r,...i){for(const p of this.logServices)p.debug(r,...i)}info(r,...i){for(const p of this.logServices)p.info(r,...i)}warn(r,...i){for(const p of this.logServices)p.warn(r,...i)}error(r,...i){for(const p of this.logServices)p.error(r,...i)}critical(r,...i){for(const p of this.logServices)p.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=g;class k extends w.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=k;class b extends w.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(p=>{this.logLevel=p,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(p))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let p=this.loggers.get(r.toString());return p||(p=this.doCreateLogger(r,i?.always?S.Trace:this.logLevel,i),this.loggers.set(r.toString(),p),i?.always||this.logLevelChangeableLoggers.push(p)),p}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class m{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(r){}getLevel(){return S.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=m;function f(M){if(M.verbose)return S.Trace;if(typeof M.logLevel=="string"){const r=P(M.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function P(M){switch(M){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=P;function l(M){switch(M){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=l}),define(Ee[82],_e([0,1,35,118,4]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var t;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(t=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(s,u){return u-s}S.compare=C;const R=Object.create(null);R[S.Error]=(0,F.localize)(0,null),R[S.Warning]=(0,F.localize)(1,null),R[S.Info]=(0,F.localize)(2,null);function _(s){return R[s]||""}S.toString=_;function n(s){switch(s){case a.default.Error:return S.Error;case a.default.Warning:return S.Warning;case a.default.Info:return S.Info;case a.default.Ignore:return S.Hint}}S.fromSeverity=n;function d(s){switch(s){case S.Error:return a.default.Error;case S.Warning:return a.default.Warning;case S.Info:return a.default.Info;case S.Hint:return a.default.Ignore}}S.toSeverity=d}(t=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(S){const C="";function R(n){return _(n,!0)}S.makeKey=R;function _(n,d){let s=[C];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(C),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(C),n.severity!==void 0&&n.severity!==null?s.push(t.toString(n.severity)):s.push(C),n.message&&d?s.push(n.message.replace("\xA6","\\\xA6")):s.push(C),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(C),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(C),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(C),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(C),s.push(C),s.join("\xA6")}S.makeKeyOptionalMessage=_})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ee[138],_e([0,1,3,35,4]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,w.createDecorator)("notificationService");var T;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var t;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(t=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new S,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=A;class S{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=S}),define(Ee[139],_e([0,1,6,9,2,4]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return a.Disposable.None},registerValidator(){return a.Disposable.None},registerExternalUriResolver(){return a.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return a.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function t(S,C){return w.URI.isUri(S)?(0,F.equalsIgnoreCase)(S.scheme,C):(0,F.startsWithIgnoreCase)(S,C+":")}e.matchesScheme=t;function A(S,...C){return C.some(R=>t(S,R))}e.matchesSomeScheme=A});var xe=this&&this.__decorate||function(oe,e,a,F){var w=arguments.length,T=w<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,a):F,t;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(oe,e,a,F);else for(var A=oe.length-1;A>=0;A--)(t=oe[A])&&(T=(w<3?t(T):w>3?t(e,a,T):t(e,a))||T);return w>3&&T&&Object.defineProperty(e,a,T),T},$e=this&&this.__param||function(oe,e){return function(a,F){e(a,F,oe)}};define(Ee[140],_e([0,1,14,20,6,4]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var t;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(t=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let S=class extends w.Disposable{constructor(_,n){super();this.deferred=new a.DeferredPromise,n.withProgress(_,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};S=xe([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends w.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,d=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:d.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(Ee[30],_e([0,1,41,11]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(t,A){a.ok(F.isString(t)),a.ok(F.isObject(A)),a.ok(!this.data.has(t),"There is already an extension with this id"),this.data.set(t,A)}knows(t){return this.data.has(t)}as(t){return this.data.get(t)||null}}e.Registry=new w}),define(Ee[141],_e([0,1,3,30]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class T{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,C){this.schemasById[w(S)]=C,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const t=new T;F.Registry.add(e.Extensions.JSONContribution,t)}),define(Ee[61],_e([0,1,16,3,11,115,141,30]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const R=A.Registry.as(t.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(P,l=!0){this.registerConfigurations([P],l)}registerConfigurations(P,l=!0){const M=this.doRegisterConfigurations(P,l);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(M)}deregisterConfigurations(P){const l=this.doDeregisterConfigurations(P);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}updateConfigurations({add:P,remove:l}){const M=[];M.push(...this.doDeregisterConfigurations(l)),M.push(...this.doRegisterConfigurations(P,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,a.distinct)(M))}registerDefaultConfigurations(P){const l=[],M=[];for(const r of P)for(const i in r)if(l.push(i),e.OVERRIDE_PROPERTY_REGEX.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...r[i]};const p={type:"object",default:this.defaultValues[i],description:T.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};M.push(...s(i)),this.configurationProperties[i]=p,this.defaultLanguageConfigurationOverridesNode.properties[i]=p}else{this.defaultValues[i]=r[i];const p=this.configurationProperties[i];p&&(this.updatePropertyDefaultValue(i,p),this.updateSchema(i,p))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(P){const l=[];for(const M of P)for(const r in M)if(l.push(r),delete this.defaultValues[r],e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const i=this.configurationProperties[r];i&&(this.updatePropertyDefaultValue(r,i),this.updateSchema(r,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const l of P)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(P,l){const M=[];return P.forEach(r=>{M.push(...this.validateAndRegisterProperties(r,l,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),M}doDeregisterConfigurations(P){const l=[],M=r=>{if(r.properties)for(const i in r.properties)l.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>M(i))};for(const r of P){M(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return l}validateAndRegisterProperties(P,l=!0,M,r=3){r=w.isUndefinedOrNull(P.scope)?r:P.scope;let i=[],p=P.properties;if(p)for(let o in p){if(l&&b(o)){delete p[o];continue}const v=p[o];if(this.updatePropertyDefaultValue(o,v),e.OVERRIDE_PROPERTY_REGEX.test(o)?v.scope=void 0:(v.scope=w.isUndefinedOrNull(v.scope)?r:v.scope,v.restricted=w.isUndefinedOrNull(v.restricted)?!!M?.restrictedConfigurations?.includes(o):v.restricted),p[o].hasOwnProperty("included")&&!p[o].included){this.excludedConfigurationProperties[o]=p[o],delete p[o];continue}else this.configurationProperties[o]=p[o];!p[o].deprecationMessage&&p[o].markdownDeprecationMessage&&(p[o].deprecationMessage=p[o].markdownDeprecationMessage),i.push(o)}let h=P.allOf;if(h)for(let o of h)i.push(...this.validateAndRegisterProperties(o,l,M,r));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const l=M=>{let r=M.properties;if(r)for(const p in r)this.updateSchema(p,r[p]);let i=M.allOf;i&&i.forEach(l)};l(P)}updateSchema(P,l){switch(e.allSettings.properties[P]=l,l.scope){case 1:e.applicationSettings.properties[P]=l;break;case 2:e.machineSettings.properties[P]=l;break;case 6:e.machineOverridableSettings.properties[P]=l;break;case 3:e.windowSettings.properties[P]=l;break;case 4:e.resourceSettings.properties[P]=l;break;case 5:e.resourceSettings.properties[P]=l,this.resourceLanguageSettingsSchema.properties[P]=l;break}}removeFromSchema(P,l){switch(delete e.allSettings.properties[P],l.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const l=`[${P}]`,M={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,M),e.allSettings.properties[l]=M,e.applicationSettings.properties[l]=M,e.machineSettings.properties[l]=M,e.machineOverridableSettings.properties[l]=M,e.windowSettings.properties[l]=M,e.resourceSettings.properties[l]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const P={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,l){let M=this.defaultValues[P];w.isUndefined(M)&&(M=l.default),w.isUndefined(M)&&(M=g(l.type)),l.default=M}}const n="\\[([^\\]]+)\\]",d=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function s(f){const P=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let l=d.exec(f);for(;l?.length;){const M=l[1].trim();M&&P.push(M),l=d.exec(f)}}return(0,a.distinct)(P)}e.overrideIdentifiersFromKey=s;function u(f){return f.reduce((P,l)=>`${P}[${l}]`,"")}e.keyFromOverrideIdentifiers=u;function g(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const k=new _;A.Registry.add(e.Extensions.Configuration,k);function b(f){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?T.localize(7,null,f):k.getConfigurationProperties()[f]!==void 0?T.localize(8,null,f):null:T.localize(6,null)}e.validateProperty=b;function m(){const f=[],P=k.getConfigurationProperties();for(const l of Object.keys(P))f.push([l,P[l].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=m}),define(Ee[83],_e([0,1,11,2,61,4,30]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof F.URI)}e.isConfigurationOverrides=A;function S(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||a.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof F.URI)}e.isConfigurationUpdateOverrides=S;var C;(function(f){f[f.USER=1]="USER",f[f.USER_LOCAL=2]="USER_LOCAL",f[f.USER_REMOTE=3]="USER_REMOTE",f[f.WORKSPACE=4]="WORKSPACE",f[f.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",f[f.DEFAULT=6]="DEFAULT",f[f.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(f){switch(f){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function _(f,P){const l=Object.create(null);for(let M in f)n(l,M,f[M],P);return l}e.toValuesTree=_;function n(f,P,l,M){const r=P.split("."),i=r.pop();let p=f;for(let h=0;h<r.length;h++){let o=r[h],v=p[o];switch(typeof v){case"undefined":v=p[o]=Object.create(null);break;case"object":break;default:M(`Ignoring ${P} as ${r.slice(0,h+1).join(".")} is ${JSON.stringify(v)}`);return}p=v}if(typeof p=="object"&&p!==null)try{p[i]=l}catch(h){M(`Ignoring ${P} as ${r.join(".")} is ${JSON.stringify(p)}`)}else M(`Ignoring ${P} as ${r.join(".")} is ${JSON.stringify(p)}`)}e.addToValueTree=n;function d(f,P){const l=P.split(".");s(f,l)}e.removeFromValueTree=d;function s(f,P){const l=P.shift();if(P.length===0){delete f[l];return}if(Object.keys(f).indexOf(l)!==-1){const M=f[l];typeof M=="object"&&!Array.isArray(M)&&(s(M,P),Object.keys(M).length===0&&delete f[l])}}function u(f,P,l){function M(p,h){let o=p;for(const v of h){if(typeof o!="object"||o===null)return;o=o[v]}return o}const r=P.split("."),i=M(f,r);return typeof i=="undefined"?l:i}e.getConfigurationValue=u;function g(f,P,l){Object.keys(P).forEach(M=>{M!=="__proto__"&&(M in f?a.isObject(f[M])&&a.isObject(P[M])?g(f[M],P[M],l):l&&(f[M]=P[M]):f[M]=P[M])})}e.merge=g;function k(){const f=t.Registry.as(w.Extensions.Configuration).getConfigurationProperties();return Object.keys(f)}e.getConfigurationKeys=k;function b(){const f=Object.create(null),P=t.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(let l in P){let M=P[l].default;n(f,l,M,r=>console.error(`Conflict in default settings: ${r}`))}return f}e.getDefaultValues=b;function m(f,P,l){const M=f.inspect(P),r=f.inspect(l);return typeof M.userValue!="undefined"||typeof M.workspaceValue!="undefined"||typeof M.workspaceFolderValue!="undefined"?M.value:typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:M.defaultValue}e.getMigratedSettingValue=m}),define(Ee[142],_e([0,1,16,3,100,6,21,27,11,2,83,61,30]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(r={},i=[],p=[]){this._contents=r,this._keys=i,this._overrides=p,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const p=this.getContentsForOverrideIdentifer(i);return p?r?(0,R.getConfigurationValue)(p,r):p:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const p of this.overrides)p.identifiers.includes(r)&&i.push(...p.keys);return a.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return a.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=A.deepClone(this.contents),p=A.deepClone(this.overrides),h=[...this.keys];for(const o of r){this.mergeContents(i,o.contents);for(const v of o.overrides){const[c]=p.filter(E=>a.equals(E.identifiers,v.identifiers));c?(this.mergeContents(c.contents,v.contents),c.keys.push(...v.keys),c.keys=a.distinct(c.keys)):p.push(A.deepClone(v))}for(const v of o.keys)h.indexOf(v)===-1&&h.push(v)}return new d(i,h,p)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let p={};for(const h of a.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[h],v=i[h];v&&(typeof o=="object"&&typeof v=="object"?(o=A.deepClone(o),this.mergeContents(o,v)):o=v),p[h]=o}return new d(p,this.keys,this.overrides)}mergeContents(r,i){for(const p of Object.keys(i)){if(p in r&&S.isObject(r[p])&&S.isObject(i[p])){this.mergeContents(r[p],i[p]);continue}r[p]=A.deepClone(i[p])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?A.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,p=null;const h=o=>{o&&(p?this.mergeContents(p,o):p=A.deepClone(o))};for(const o of this.overrides)a.equals(o.identifiers,[r])?i=o.contents:o.identifiers.includes(r)&&h(o.contents);return h(i),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,R.addToValueTree)(this.contents,r,i,p=>{throw new Error(p)})}removeValue(r){this.removeKey(r)&&(0,R.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let p=0;p<i;p++)r.indexOf(this.keys[p])===0&&(i=p);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=d;class s extends d{constructor(){const r=(0,R.getDefaultValues)(),i=(0,R.getConfigurationKeys)(),p=[];for(const h of Object.keys(r))_.OVERRIDE_PROPERTY_REGEX.test(h)&&p.push({identifiers:(0,_.overrideIdentifiersFromKey)(h),keys:Object.keys(r[h]),contents:(0,R.toValuesTree)(r[h],o=>console.error(`Conflict in default settings file: ${o}`))});super(r,i,p)}}e.DefaultConfigurationModel=s;class u{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!S.isUndefinedOrNull(r)){const p=this.doParseContent(r);this.parseRaw(p,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:p,keys:h,overrides:o,restricted:v}=this.doParseRaw(r,i);this._configurationModel=new d(p,h,o),this._restrictedConfigurations=v||[]}doParseContent(r){let i={},p=null,h=[],o=[],v=[];function c(I){Array.isArray(h)?h.push(I):p!==null&&(h[p]=I)}let E={onObjectBegin:()=>{let I={};c(I),o.push(h),h=I,p=null},onObjectProperty:I=>{p=I},onObjectEnd:()=>{h=o.pop()},onArrayBegin:()=>{let I=[];c(I),o.push(h),h=I,p=null},onArrayEnd:()=>{h=o.pop()},onLiteralValue:c,onError:(I,D,B)=>{v.push({error:I,offset:D,length:B})}};if(r)try{w.visit(r,E),i=h[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return i}doParseRaw(r,i){const p=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),h=this.filter(r,p,!0,i);r=h.raw;const o=(0,R.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),v=Object.keys(r),c=this.toOverrides(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:v,overrides:c,restricted:h.restricted}}filter(r,i,p,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:r,restricted:[]};const o={},v=[];for(let c in r)if(_.OVERRIDE_PROPERTY_REGEX.test(c)&&p){const E=this.filter(r[c],i,!1,h);o[c]=E.raw,v.push(...E.restricted)}else{const E=i[c],I=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&v.push(c),(I===void 0||h.scopes===void 0||h.scopes.includes(I))&&(h.skipRestricted&&E?.restricted||(o[c]=r[c]))}return{raw:o,restricted:v}}toOverrides(r,i){const p=[];for(const h of Object.keys(r))if(_.OVERRIDE_PROPERTY_REGEX.test(h)){const o={};for(const v in r[h])o[v]=r[h][v];p.push({identifiers:(0,_.overrideIdentifiersFromKey)(h),keys:Object.keys(o),contents:(0,R.toValuesTree)(o,i)})}return p}}e.ConfigurationModelParser=u;class g extends T.Disposable{constructor(r,i,p,h){super();this.userSettingsResource=r,this.scopes=i,this.fileService=h,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(p.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class k{constructor(r,i,p=new d,h=new d,o=new t.ResourceMap,v=new d,c=new t.ResourceMap,E=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=p,this._workspaceConfiguration=h,this._folderConfigurations=o,this._memoryConfiguration=v,this._memoryConfigurationByResource=c,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new t.ResourceMap,this._userConfiguration=null}getValue(r,i,p){return this.getConsolidateConfigurationModel(i,p).getValue(r)}updateValue(r,i,p={}){let h;p.resource?(h=this._memoryConfigurationByResource.get(p.resource),h||(h=new d,this._memoryConfigurationByResource.set(p.resource,h))):h=this._memoryConfiguration,i===void 0?h.removeValue(r):h.setValue(r,i),p.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,p){const h=this.getConsolidateConfigurationModel(i,p),o=this.getFolderConfigurationModelForResource(i.resource,p),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,c=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),I=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),D=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),B=p?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,L=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(r):o.freeze().getValue(r):void 0,y=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(r):v.getValue(r),x=h.getValue(r),N=a.distinct(a.flatten(h.overrides.map(z=>z.identifiers))).filter(z=>h.getOverrideValue(r,z)!==void 0);return{defaultValue:c,userValue:E,userLocalValue:I,userRemoteValue:D,workspaceValue:B,workspaceFolderValue:L,memoryValue:y,value:x,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:D!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:o?.freeze().getValue(r),override:i.overrideIdentifier?o?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:y!==void 0?{value:v.getValue(r),override:i.overrideIdentifier?v.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const p=[];for(const h of i)for(const o of(0,_.overrideIdentifiersFromKey)(h)){const v=this._defaultConfiguration.getKeysForOverrideIdentifier(o),c=r.getKeysForOverrideIdentifier(o),E=[...c.filter(I=>v.indexOf(I)===-1),...v.filter(I=>c.indexOf(I)===-1),...v.filter(I=>!A.equals(this._defaultConfiguration.override(o).getValue(I),r.override(o).getValue(I)))];p.push([o,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:p,removed:h,overrides:o}=P(this.localUserConfiguration,r),v=[...i,...p,...h];return v.length&&this.updateLocalUserConfiguration(r),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:p,removed:h,overrides:o}=P(this.remoteUserConfiguration,r);let v=[...i,...p,...h];return v.length&&this.updateRemoteUserConfiguration(r),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:p,removed:h,overrides:o}=P(this.workspaceConfiguration,r);let v=[...i,...p,...h];return v.length&&this.updateWorkspaceConfiguration(r),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(r,i){const p=this.folderConfigurations.get(r),{added:h,updated:o,removed:v,overrides:c}=P(p,i);let E=[...h,...o,...v];return(E.length||!p)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:c}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:p,updated:h,removed:o,overrides:v}=P(i,void 0);return{keys:[...p,...h,...o],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let p=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?p.override(r.overrideIdentifier):p}getConsolidatedConfigurationModelForResource({resource:r},i){let p=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const h=i.getFolder(r);h&&(p=this.getFolderConsolidatedConfiguration(h.uri)||p);const o=this._memoryConfigurationByResource.get(r);o&&(p=p.merge(o))}return p}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const p=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(r);h?(i=p.merge(h),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=p}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const p=i.getFolder(r);if(p)return this._folderConfigurations.get(p.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:p,overrides:h,keys:o}=this._folderConfigurations.get(i);return r.push([i,{contents:p,overrides:h,keys:o}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(p=>r.add(p))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(p=>r.add(p))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this._folderConfigurations.forEach(p=>p.getKeysForOverrideIdentifier(r).forEach(h=>i.add(h))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),p=this.parseConfigurationModel(r.user),h=this.parseConfigurationModel(r.workspace),o=r.folders.reduce((v,c)=>(v.set(C.URI.revive(c[0]),this.parseConfigurationModel(c[1])),v),new t.ResourceMap);return new k(i,p,new d,h,o,new d,new t.ResourceMap,!1)}static parseConfigurationModel(r){return new d(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=k;function b(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const r=new Set,i=new Map;for(const h of M)h.keys.forEach(o=>r.add(o)),h.overrides.forEach(([o,v])=>{const c=(0,t.getOrSet)(i,o,new Set);v.forEach(E=>c.add(E))});const p=[];return i.forEach((h,o)=>p.push([o,[...h.values()]])),{keys:[...r.values()],overrides:p}}e.mergeChanges=b;class m{constructor(r,i,p,h){this.change=r,this.previous=i,this.currentConfiguraiton=p,this.currentWorkspace=h,this._previousConfiguration=void 0;const o=new Set;r.keys.forEach(c=>o.add(c)),r.overrides.forEach(([,c])=>c.forEach(E=>o.add(E))),this.affectedKeys=[...o.values()];const v=new d;this.affectedKeys.forEach(c=>v.setValue(c,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=k.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const p=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!A.equals(p,h)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let p=(0,R.toValuesTree)({[i]:!0},()=>{}),h;for(;typeof p=="object"&&(h=Object.keys(p)[0]);){if(r=r[h],!r)return!1;p=p[h]}return!0}}e.ConfigurationChangeEvent=m;class f extends m{constructor(r,i,p,h){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=p,this.sourceConfig=h}}e.AllKeysConfigurationChangeEvent=f;function P(M,r){const{added:i,removed:p,updated:h}=l(r,M),o=[],v=M?.getAllOverrideIdentifiers()||[],c=r?.getAllOverrideIdentifiers()||[];if(r){const E=c.filter(I=>!v.includes(I));for(const I of E)o.push([I,r.getKeysForOverrideIdentifier(I)])}if(M){const E=v.filter(I=>!c.includes(I));for(const I of E)o.push([I,M.getKeysForOverrideIdentifier(I)])}if(r&&M){for(const E of v)if(c.includes(E)){const I=l({contents:M.getOverrideValue(void 0,E)||{},keys:M.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});o.push([E,[...I.added,...I.removed,...I.updated]])}}return{added:i,removed:p,updated:h,overrides:o}}function l(M,r){const i=M?r?M.keys.filter(o=>r.keys.indexOf(o)===-1):[...M.keys]:[],p=r?M?r.keys.filter(o=>M.keys.indexOf(o)===-1):[...r.keys]:[],h=[];if(M&&r){for(const o of r.keys)if(M.keys.indexOf(o)!==-1){const v=(0,R.getConfigurationValue)(r.contents,o),c=(0,R.getConfigurationValue)(M.contents,o);A.equals(v,c)||h.push(o)}}return{added:i,removed:p,updated:h}}}),define(Ee[84],_e([0,1,4]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,a.createDecorator)("remoteAuthorityResolverService");var F;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(t,A=F.Unknown,S){super(t);this._message=t,this._code=A,this._detail=S,this.isHandled=A===F.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(t){return t instanceof w&&t._code===F.TemporarilyNotAvailable}static isNoResolverFound(t){return t instanceof w&&t._code===F.NoResolverFound}static isHandled(t){return t instanceof w&&t.isHandled}}e.RemoteAuthorityResolverError=w}),define(Ee[62],_e([0,1,10]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(C){return C.scheme===a.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=F;function w(C){if(!C)return;const R=C.indexOf("+");return R<0?C:C.substr(0,R)}e.getRemoteName=w;function T(C){return C.scheme!==a.Schemas.file&&C.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=T;function t(C){if(C.folders.length)return C.folders.every(R=>T(R.uri))?C.folders[0].uri:void 0;if(C.configuration&&T(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=t;function A(C){return t(C)?.scheme}e.getVirtualWorkspaceScheme=A;function S(C){return t(C)!==void 0}e.isVirtualWorkspace=S}),define(Ee[25],_e([0,1,9,4,62]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=T;function t(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=t,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class S{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,s){if(typeof d=="undefined"||d===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof d=="string"||typeof s=="string"){let u=typeof d=="string"?d:d.value,g=typeof s=="string"?s:s.value;return a.equalsIgnoreCase(u,g)}return d._lower===s._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.ExtensionIdentifier=S;function C(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function R(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function _(n,d){if(d){const s=`onResolveRemoteAuthority:${(0,w.getRemoteName)(d)}`;return n.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[143],_e([0,1,9,25]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(s,u){return s.uuid&&u.uuid?s.uuid===u.uuid:s.id===u.id?!0:(0,a.compareIgnoreCase)(s.id,u.id)===0}e.areSameExtensions=w;class T{constructor(u,g){this.version=g,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof T?w(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=T;function t(s,u){return`${s}.${u}`}e.getExtensionId=t;function A(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function S(s,u){return A(t(s,u))}e.getGalleryExtensionId=S;function C(s,u){const g=[],k=b=>{for(const m of g)if(m.some(f=>w(u(f),u(b))))return m;return null};for(const b of s){const m=k(b);m?m.push(b):g.push([b])}return g}e.groupByExtension=C;function R(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function _(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function n(s){const u=new Set;for(const g of s)g.malicious&&u.add(g.id.id);return u}e.getMaliciousExtensionsSet=n;function d(s,u){const g=[],k=u.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const b=k.shift();if(b&&g.every(m=>!w(m.identifier,{id:b}))){const m=s.filter(f=>w(f.identifier,{id:b}));m.length===1&&(g.push(m[0]),k.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=d}),define(Ee[144],_e([0,1,3,23,4,12]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var t;(function(s){s.Http="http",s.Https="https"})(t=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=_;function n(s,u){return u?u!==1&&s<1024:!F.isWindows&&s<1024}e.isPortPrivileged=n;let d=class{constructor(u){this.logService=u,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,g){return this._tunnelProvider=u,u?(this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],g=Array.from(this._tunnels.values());for(let k of g){const b=Array.from(k.values());for(let m of b){const f=await m.value;f&&u.push(f)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:g}of u.values())await g.then(k=>k?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,g,k,b,m=!1,f=A.Private,P){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${k} on local port ${b}.`),!u)return;g||(g="localhost");const l=this.retainOrCreateTunnel(u,g,k,b,m,f,P);return l?l.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,k);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(M);return(M.tunnelRemoteHost!==g||M.tunnelRemotePort!==k)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const g=this._tunnels.get(u.tunnelRemoteHost);if(g){const k=g.get(u.tunnelRemotePort);k&&(k.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,k))}}}}async tryDisposeTunnel(u,g,k){if(k.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${g}.`);const b=k.value.then(async m=>{m&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(g),b}}async closeTunnel(u,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${g} `);const k=this._tunnels.get(u);if(k&&k.has(g)){const b=k.get(g);b.refcount=0,await this.tryDisposeTunnel(u,g,b)}}addTunnelToMap(u,g,k){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(g,{refcount:1,value:k})}async removeEmptyTunnelFromMap(u,g){const k=this._tunnels.get(u);k&&(await k.get(g)||k.delete(g),k.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,g){let k=[u];R(u)?(k.push(...e.LOCALHOST_ADDRESSES),k.push(...e.ALL_INTERFACES_ADDRESSES)):_(u)&&k.push(...e.ALL_INTERFACES_ADDRESSES);const b=k.map(m=>this._tunnels.get(m));for(const m of b){const f=m?.get(g);if(f)return f}}canTunnel(u){return!!C(u)}createWithProvider(u,g,k,b,m,f,P){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${k} on local port ${b}.`);const M={elevationRequired:m?n(b===void 0?k:b):!1},r={remoteAddress:{host:g,port:k},localAddressPort:b,privacy:f,public:f!==A.Private,protocol:P},i=u.forwardPort(r,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(g,k,i),i}};d=xe([$e(0,T.ILogService)],d),e.AbstractTunnelService=d}),define(Ee[145],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,T,t=5){let A;return A=T(S=>{const C=typeof S=="string"?S:S.data;let R=this._terminalBufferMap.get(w);if(R){R.data.push(C);return}const _=setTimeout(()=>this.flushBuffer(w),t);R={data:[C],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(w),A.dispose()}},this._terminalBufferMap.set(w,R)}),A}stopBuffering(w){const T=this._terminalBufferMap.get(w);T&&T.dispose()}flushBuffer(w){const T=this._terminalBufferMap.get(w);T&&(this._terminalBufferMap.delete(w),this._callback(w,T.data.join("")))}}e.TerminalDataBufferer=a}),define(Ee[146],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var a;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(a=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[63],_e([0,1,53,3,6,4,30,146]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(g){function k(b){return b&&typeof b=="object"&&typeof b.id=="string"}g.isThemeColor=k})(S=e.ThemeColor||(e.ThemeColor={}));function C(g){return{id:g}}e.themeColorFromId=C;var R;(function(g){function k(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||S.isThemeColor(r.color))}g.isThemeIcon=k;const b=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function m(r){const i=b.exec(r);if(!i)return;let[,p]=i;return{id:p}}g.fromString=m;function f(r,i){let p=r.id;const h=p.lastIndexOf("~");return h!==-1&&(p=p.substring(0,h)),i&&(p=`${p}~${i}`),{id:p}}g.modify=f;function P(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}g.getModifier=P;function l(r,i){return r.id===i.id&&r.color?.id===i.color?.id}g.isEqual=l;function M(r,i){return{id:r.id,color:i?C(i):void 0}}g.asThemeIcon=M,g.asClassNameArray=a.CSSIcon.asClassNameArray,g.asClassName=a.CSSIcon.asClassName,g.asCSSSelector=a.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function _(g){switch(g){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(k){return this.themingParticipants.push(k),this.onThemingParticipantAddedEmitter.fire(k),(0,w.toDisposable)(()=>{const b=this.themingParticipants.indexOf(k);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new n;t.Registry.add(e.Extensions.ThemingContribution,d);function s(g){return d.onColorThemeChange(g)}e.registerThemingParticipant=s;class u extends w.Disposable{constructor(k){super();this.themeService=k,this.theme=k.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(k){this.theme=k,this.updateStyles()}updateStyles(){}getColor(k,b){let m=this.theme.getColor(k);return m&&b&&(m=b(m,this.theme)),m?m.toString():null}}e.Themable=u}),define(Ee[46],_e([0,1,21,24,2,4]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var t;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(t=e.WorkbenchState||(e.WorkbenchState={}));function A(n){const d=n;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=A;function S(n){const d=n;return!!(d&&typeof d=="object"&&w.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(d,s,u,g,k){this._id=d,this._transient=u,this._configuration=g,this._ignorePathCasing=k,this._foldersMap=a.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(d){this._id=d.id,this._configuration=d.configuration,this._transient=d.transient,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=a.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class R{constructor(d,s){this.raw=s,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,F.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function _(n){return new R({uri:n,index:0,name:(0,F.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(Ee[64],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const T=this._idPool++;return this._data.set(T,w),this.logDebugInfo(),T}get(w,T){return this._data.has(w)?this._data.get(w)[T]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=a,a.enableDebugLogging=!1}),define(Ee[31],_e([0,1,10,24,4]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(A=>{const S=this._providerInfo.get(A.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(A,S){S===null?this._providerInfo.delete(A):this._providerInfo.set(A,S)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],_e([0,1,4]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Ee[147],_e([0,1,14]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(t,A,S){this._deferredPromises=new Map,this._id=t,this._shared=A,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of C.values())R.complete()}catch(R){for(const _ of C.values())_.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,t])=>t!==void 0).map(([t])=>t)}get whenReady(){return this._init}get(t,A){let S=this._value[t];return typeof S=="undefined"&&(S=A),S}update(t,A){this._value[t]=A;let S=this._deferredPromises.get(t);if(S!==void 0)return S.p;const C=new a.DeferredPromise;return this._deferredPromises.set(t,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class w extends F{constructor(t,A){super(t.identifier.value,!0,A);this._extension=t}setKeysForSync(t){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},t)}}e.ExtensionGlobalMemento=w}),define(Ee[148],_e([0,1,3,2,12]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(A,S){this._logService=A,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new a.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(A,S,C){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(S.value,C)}$acceptDirtyStateChanged(A,S){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A)).acceptDirty(S)}$acceptModelSaved(A){const S=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(A,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",A.path,S);const C=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A));C.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};T=xe([$e(0,w.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(Ee[13],_e([0,1,4]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class F{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=F});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[149],_e([0,1,25,3]),function(oe,e,a,F){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(A,S){w.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(A.identifier),Ze(this,w,S,"f"),Ae(this,w,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(A){return Ae(this,w,"f").get(this._id,A)}store(A,S){return Ae(this,w,"f").store(this._id,A,S)}delete(A){return Ae(this,w,"f").delete(this._id,A)}}e.ExtensionSecrets=T,w=new WeakMap}),define(Ee[85],_e([0,1,4,3]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(t){this._enabled=t}$onDidChangeTelemetryEnabled(t){this._enabled=t,this._onDidChangeTelemetryEnabled.fire(t)}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Ee[47],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var a;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(a=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,w=(b,m)=>{const f={controllerId:m};return F.set(b,f),f};e.createPrivateApiFor=w;const T=b=>F.get(b);e.getPrivateApiFor=T;const t=(b,m,f,P)=>{let l=f;return{enumerable:!0,configurable:!1,get(){return l},set(M){if(!P(l,M)){const r=l;l=M,b.listener?.({op:3,key:m,value:M,previous:r})}}}},A=(b,m)=>b===m,S={range:(b,m)=>b===m?!0:!b||!m?!1:b.isEqual(m),label:A,description:A,busy:A,error:A,canResolveChildren:A,tags:(b,m)=>!(b.length!==m.length||b.some(f=>!m.find(P=>f.id===P.id)))},C=Object.keys(S),R=(b,m)=>({range:t(b,"range",void 0,S.range),label:t(b,"label",m,S.label),description:t(b,"description",void 0,S.description),canResolveChildren:t(b,"canResolveChildren",!1,S.canResolveChildren),busy:t(b,"busy",!1,S.busy),error:t(b,"error",void 0,S.error),tags:t(b,"tags",[],S.tags)}),_=(b,m)=>{const f=new Map;for(const P of C)S[P](b[P],m[P])||f.set(P,m[P]);return f};e.diffTestItems=_;class n extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=n;class d extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class s extends Error{constructor(m,f,P){super(`TestItem with ID "${m}" is from controller "${f}" and cannot be added as a child of an item from controller "${P}".`)}}e.MixedTestItemController=s;const u=b=>{const m=(0,e.getPrivateApiFor)(b);let f=new Map;return{get size(){return f.size},forEach(P,l){for(const M of f.values())P.call(l,M,this)},replace(P){const l=new Map,M=new Set(f.keys()),r={op:4,ops:[]};for(const i of P){if(!(i instanceof g))throw new d(i.id);const p=(0,e.getPrivateApiFor)(i).controllerId;if(p!==m.controllerId)throw new s(i.id,p,m.controllerId);if(l.has(i.id))throw new n(i.id);l.set(i.id,i),M.delete(i.id),r.ops.push({op:0,item:i})}for(const i of M.keys())r.ops.push({op:1,id:i});m.listener?.(r),f=l},add(P){if(!(P instanceof g))throw new d(P.id);f.set(P.id,P),m.listener?.({op:0,item:P})},delete(P){f.delete(P)&&m.listener?.({op:1,id:P})},get(P){return f.get(P)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class g{constructor(m,f,P,l){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const M=(0,e.createPrivateApiFor)(this,m);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof k?void 0:M.parent}},children:{value:u(this),enumerable:!0,writable:!1},...R(M,P)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=g;class k extends g{constructor(m,f){super(m,m,f,void 0)}}e.TestItemRootImpl=k}),define(Ee[65],_e([0,1,4,144,3,13]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var t;(function(S){function C(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?F.TunnelPrivacyId.Public:F.TunnelPrivacyId.Private),protocol:_.protocol}}S.fromApiTunnel=C;function R(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==F.TunnelPrivacyId.ConstantPrivate&&_.privacy!==F.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}S.fromServiceTunnel=R})(t=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let A=class{constructor(C){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,R){}async getTunnels(){return[]}async setTunnelExtensionFunctions(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,R){return{dispose:()=>{}}}async $providePortAttributes(C,R,_,n,d){return[]}async $forwardPort(C,R){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=xe([$e(0,T.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[7],_e([0,1,16,15,77,21,79,9,11,2,36,45,84]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n){"use strict";var d,s,u,g,k,b,m,f,P,l,M,r,i,p,h,o,v,c,E,I;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(U){function O(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(O,U),Object.setPrototypeOf(O.prototype,U.prototype),O}let B=k=class{constructor(O){d.set(this,void 0),Ze(this,d,O,"f")}static from(...O){let ee=O;return new k(function(){if(ee){for(const ye of ee)ye&&typeof ye.dispose=="function"&&ye.dispose();ee=void 0}})}dispose(){typeof Ae(this,d,"f")=="function"&&(Ae(this,d,"f").call(this),Ze(this,d,void 0,"f"))}};d=new WeakMap,B=k=xe([D],B),e.Disposable=B;let L=b=class{constructor(O,ee){if(O<0)throw(0,F.illegalArgument)("line must be non-negative");if(ee<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=O,this._character=ee}static Min(...O){if(O.length===0)throw new TypeError;let ee=O[0];for(let ye=1;ye<O.length;ye++){const Ve=O[ye];Ve.isBefore(ee)&&(ee=Ve)}return ee}static Max(...O){if(O.length===0)throw new TypeError;let ee=O[0];for(let ye=1;ye<O.length;ye++){const Ve=O[ye];Ve.isAfter(ee)&&(ee=Ve)}return ee}static isPosition(O){if(!O)return!1;if(O instanceof b)return!0;let{line:ee,character:ye}=O;return typeof ee=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ee=0){if(O===null||ee===null)throw(0,F.illegalArgument)();let ye;return typeof O=="undefined"?ye=0:typeof O=="number"?ye=O:(ye=typeof O.lineDelta=="number"?O.lineDelta:0,ee=typeof O.characterDelta=="number"?O.characterDelta:0),ye===0&&ee===0?this:new b(this.line+ye,this.character+ee)}with(O,ee=this.character){if(O===null||ee===null)throw(0,F.illegalArgument)();let ye;return typeof O=="undefined"?ye=this.line:typeof O=="number"?ye=O:(ye=typeof O.line=="number"?O.line:this.line,ee=typeof O.character=="number"?O.character:this.character),ye===this.line&&ee===this.character?this:new b(ye,ee)}toJSON(){return{line:this.line,character:this.character}}};L=b=xe([D],L),e.Position=L;let y=m=class{constructor(O,ee,ye,Ve){let nt,at;if(typeof O=="number"&&typeof ee=="number"&&typeof ye=="number"&&typeof Ve=="number"?(nt=new L(O,ee),at=new L(ye,Ve)):O instanceof L&&ee instanceof L&&(nt=O,at=ee),!nt||!at)throw new Error("Invalid arguments");nt.isBefore(at)?(this._start=nt,this._end=at):(this._start=at,this._end=nt)}static isRange(O){return O instanceof m?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof m?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ee=L.Max(O.start,this._start),ye=L.Min(O.end,this._end);if(!ee.isAfter(ye))return new m(ee,ye)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ee=L.Min(O.start,this._start),ye=L.Max(O.end,this.end);return new m(ee,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ee=this.end){if(O===null||ee===null)throw(0,F.illegalArgument)();let ye;return O?L.isPosition(O)?ye=O:(ye=O.start||this.start,ee=O.end||this.end):ye=this.start,ye.isEqual(this._start)&&ee.isEqual(this.end)?this:new m(ye,ee)}toJSON(){return[this.start,this.end]}};y=m=xe([D],y),e.Range=y;let x=f=class extends y{constructor(O,ee,ye,Ve){let nt,at;if(typeof O=="number"&&typeof ee=="number"&&typeof ye=="number"&&typeof Ve=="number"?(nt=new L(O,ee),at=new L(ye,Ve)):O instanceof L&&ee instanceof L&&(nt=O,at=ee),!nt||!at)throw new Error("Invalid arguments");super(nt,at);this._anchor=nt,this._active=at}static isSelection(O){return O instanceof f?!0:O?y.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=f=xe([D],x),e.Selection=x;class N{constructor(O,ee,ye){if(typeof O!="string"||O.length===0)throw(0,F.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,F.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,F.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ee),this.connectionToken=ye}}e.ResolvedAuthority=N;class z extends Error{constructor(O,ee=n.RemoteAuthorityResolverErrorCode.Unknown,ye){super(O);this._message=O,this._code=ee,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(O,ee){return new z(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(O){return new z(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var H;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var q;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=P=class{constructor(O,ee){this._range=O,this._newText=ee}static isTextEdit(O){return O instanceof P?!0:O?y.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ee){return new P(O,ee)}static insert(O,ee){return P.replace(new y(O,O),ee)}static delete(O){return P.replace(O,"")}static setEndOfLine(O){const ee=new P(new y(new L(0,0),new L(0,0)),"");return ee.newEol=O,ee}get range(){return this._range}set range(O){if(O&&!y.isRange(O))throw(0,F.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,F.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,F.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=P=xe([D],ue),e.TextEdit=ue;var G;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(G=e.FileEditType||(e.FileEditType={}));let ce=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ee,ye,Ve){this._edits.push({_type:1,from:O,to:ee,options:ye,metadata:Ve})}createFile(O,ee,ye){this._edits.push({_type:1,from:void 0,to:O,options:ee,metadata:ye})}deleteFile(O,ee,ye){this._edits.push({_type:1,from:O,to:void 0,options:ee,metadata:ye})}replaceNotebookMetadata(O,ee,ye){this._edits.push({_type:3,metadata:ye,uri:O,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(O,ee,ye,Ve,nt){let at,ut,kt=[],Mt;if(Re.isNotebookRange(ee)&&Lt.isNotebookCellDataArray(ye)&&!Lt.isNotebookCellDataArray(Ve)?(at=ee.start,ut=ee.end,kt=ye,Mt=Ve):typeof ee=="number"&&typeof ye=="number"&&Lt.isNotebookCellDataArray(Ve)&&(at=ee,ut=ye,kt=Ve,Mt=nt),at===void 0||ut===void 0)throw new Error("Invalid arguments");(at!==ut||kt.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:ut-at,cells:kt,metadata:Mt})}replaceNotebookCellMetadata(O,ee,ye,Ve){this._edits.push({_type:3,metadata:Ve,uri:O,edit:{editType:8,index:ee,metadata:ye}})}replace(O,ee,ye,Ve){this._edits.push({_type:2,uri:O,edit:new ue(ee,ye),metadata:Ve})}insert(O,ee,ye,Ve){this.replace(O,new y(ee,ee),ye,Ve)}delete(O,ee,ye){this.replace(O,ee,"",ye)}has(O){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===O.toString())}set(O,ee){if(ee)for(const ye of ee)ye&&this._edits.push({_type:2,uri:O,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Ve=this._edits[ye];Ve._type===2&&Ve.uri.toString()===O.toString()&&(this._edits[ye]=void 0)}(0,a.coalesceInPlace)(this._edits)}}get(O){const ee=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===O.toString()&&ee.push(ye.edit);return ee}entries(){const O=new T.ResourceMap;for(let ee of this._edits)if(ee._type===2){let ye=O.get(ee.uri);ye||(ye=[ee.uri,[]],O.set(ee.uri,ye)),ye[1].push(ee.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ce=xe([D],ce),e.WorkspaceEdit=ce;let de=l=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=l._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ee=this._tabstop++){if(typeof O=="function"){const ye=new l;ye._tabstop=this._tabstop,O(ye),this._tabstop=ye._tabstop,O=ye.value}else O=l._escape(O);return this.value+="${",this.value+=ee,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ee=this._tabstop++){const ye=O.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(O,ee){if(typeof ee=="function"){const ye=new l;ye._tabstop=this._tabstop,ee(ye),this._tabstop=ye._tabstop,ee=ye.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};de=l=xe([D],de),e.SnippetString=de;var Q;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var ie;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let we=M=class{constructor(O,ee){if(this.uri=O,ee)if(ee instanceof y)this.range=ee;else if(ee instanceof L)this.range=new y(ee,ee);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof M?!0:O?y.isRange(O.range)&&C.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};we=M=xe([D],we),e.Location=we;let Me=class{constructor(O,ee){this.location=O,this.message=ee}static is(O){return O?typeof O.message=="string"&&O.location&&y.isRange(O.location.range)&&C.URI.isUri(O.location.uri):!1}static isEqual(O,ee){return O===ee?!0:!O||!ee?!1:O.message===ee.message&&O.location.range.isEqual(ee.location.range)&&O.location.uri.toString()===ee.location.uri.toString()}};Me=xe([D],Me),e.DiagnosticRelatedInformation=Me;let Fe=class{constructor(O,ee,ye=ie.Error){if(!y.isRange(O))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=O,this.message=ee,this.severity=ye}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ee){return O===ee?!0:!O||!ee?!1:O.message===ee.message&&O.severity===ee.severity&&O.code===ee.code&&O.severity===ee.severity&&O.source===ee.source&&O.range.isEqual(ee.range)&&(0,a.equals)(O.tags,ee.tags)&&(0,a.equals)(O.relatedInformation,ee.relatedInformation,Me.isEqual)}};Fe=xe([D],Fe),e.Diagnostic=Fe;let Be=class{constructor(O,ee){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ee}};Be=xe([D],Be),e.Hover=Be;var Ke;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let je=class{constructor(O,ee=Ke.Text){this.range=O,this.kind=ee}toJSON(){return{range:this.range,kind:Ke[this.kind]}}};je=xe([D],je),e.DocumentHighlight=je;var Qe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var $;(function(U){U[U.Deprecated=1]="Deprecated"})($=e.SymbolTag||(e.SymbolTag={}));let K=r=class{constructor(O,ee,ye,Ve,nt){this.name=O,this.kind=ee,this.containerName=nt,typeof ye=="string"&&(this.containerName=ye),Ve instanceof we?this.location=Ve:ye instanceof y&&(this.location=new we(Ve,ye)),r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};K=r=xe([D],K),e.SymbolInformation=K;let X=i=class{constructor(O,ee,ye,Ve,nt){this.name=O,this.detail=ee,this.kind=ye,this.range=Ve,this.selectionRange=nt,this.children=[],i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(i.validate)}};X=i=xe([D],X),e.DocumentSymbol=X;var se;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let j=class{constructor(O,ee){this.title=O,this.kind=ee}};j=xe([D],j),e.CodeAction=j;let Z=p=class{constructor(O){this.value=O}append(O){return new p(this.value?this.value+p.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+p.sep)}};Z.sep=".",Z=p=xe([D],Z),e.CodeActionKind=Z,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll");let fe=class{constructor(O,ee){if(this.range=O,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};fe=xe([D],fe),e.SelectionRange=fe;class Te{constructor(O,ee,ye,Ve,nt,at){this.kind=O,this.name=ee,this.detail=ye,this.uri=Ve,this.range=nt,this.selectionRange=at}}e.CallHierarchyItem=Te;class Ne{constructor(O,ee){this.fromRanges=ee,this.from=O}}e.CallHierarchyIncomingCall=Ne;class He{constructor(O,ee){this.fromRanges=ee,this.to=O}}e.CallHierarchyOutgoingCall=He;var Ge;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ge=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(O,ee){this.range=O,this.command=ee}get isResolved(){return!!this.command}};tt=xe([D],tt),e.CodeLens=tt;let st=h=class{constructor(O,ee=!1){s.set(this,void 0),Ze(this,s,new w.MarkdownString(O,{supportThemeIcons:ee}),"f")}static isMarkdownString(O){return O instanceof h?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ae(this,s,"f").value}set value(O){Ae(this,s,"f").value=O}get isTrusted(){return Ae(this,s,"f").isTrusted}set isTrusted(O){Ae(this,s,"f").isTrusted=O}get supportThemeIcons(){return Ae(this,s,"f").supportThemeIcons}set supportThemeIcons(O){Ae(this,s,"f").supportThemeIcons=O}get supportHtml(){return Ae(this,s,"f").supportHtml}set supportHtml(O){Ae(this,s,"f").supportHtml=O}appendText(O){return Ae(this,s,"f").appendText(O),this}appendMarkdown(O){return Ae(this,s,"f").appendMarkdown(O),this}appendCodeblock(O,ee){return Ae(this,s,"f").appendCodeblock(ee??"",O),this}};s=new WeakMap,st=h=xe([D],st),e.MarkdownString=st;let Xe=class{constructor(O,ee){this.label=O,this.documentation=ee}};Xe=xe([D],Xe),e.ParameterInformation=Xe;let rt=class{constructor(O,ee){this.label=O,this.documentation=ee,this.parameters=[]}};rt=xe([D],rt),e.SignatureInformation=rt;let De=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};De=xe([D],De),e.SignatureHelp=De;var gt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(gt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var V;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(V=e.InlayHintKind||(e.InlayHintKind={}));let J=class{constructor(O,ee,ye){this.text=O,this.position=ee,this.kind=ye}};J=xe([D],J),e.InlayHint=J;var pe;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(U){U[U.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let Je=class{constructor(O,ee){this.label=O,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Je=xe([D],Je),e.CompletionItem=Je;let lt=class{constructor(O=[],ee=!1){this.items=O,this.isIncomplete=ee}};lt=xe([D],lt),e.CompletionList=lt;let Et=class{constructor(O,ee,ye){this.text=O,this.range=ee,this.command=ye}};Et=xe([D],Et),e.InlineSuggestion=Et;let It=class{constructor(O){this.items=O}};It=xe([D],It),e.InlineSuggestions=It;var et;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(et=e.ViewColumn||(e.ViewColumn={}));var Tt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Se;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var re;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ae;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(ae=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var he;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(he=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function O(ee){switch(ee){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=O}(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let me=class{constructor(O,ee){if(ee&&!C.URI.isUri(ee))throw(0,F.illegalArgument)("target");if(!y.isRange(O)||O.isEmpty)throw(0,F.illegalArgument)("range");this.range=O,this.target=ee}};me=xe([D],me),e.DocumentLink=me;let Ie=class{constructor(O,ee,ye,Ve){this.red=O,this.green=ee,this.blue=ye,this.alpha=Ve}};Ie=xe([D],Ie),e.Color=Ie;let ze=class{constructor(O,ee){if(ee&&!(ee instanceof Ie))throw(0,F.illegalArgument)("color");if(!y.isRange(O)||O.isEmpty)throw(0,F.illegalArgument)("range");this.range=O,this.color=ee}};ze=xe([D],ze),e.ColorInformation=ze;let Oe=class{constructor(O){if(!O||typeof O!="string")throw(0,F.illegalArgument)("label");this.label=O}};Oe=xe([D],Oe),e.ColorPresentation=Oe;var We;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(We=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ot{constructor(O,ee,ye){if(this.startIndex=O,this.length=ee,this.tooltip=ye,typeof O!="number"||O<0)throw(0,F.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,F.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=ot;var ne;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(O){this.options=O,typeof O!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=ge;var te;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(te=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let be=o=class{constructor(O,ee){if(this.label=ee,typeof O!="string"||typeof ee!="string")throw(0,F.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};be.Clean=new o("clean","Clean"),be.Build=new o("build","Build"),be.Rebuild=new o("rebuild","Rebuild"),be.Test=new o("test","Test"),be=o=xe([D],be),e.TaskGroup=be;function ke(U){let O="";for(let ee=0;ee<U.length;ee++)O+=U[ee].replace(/,/g,",,")+",";return O}let qe=class{constructor(O,ee,ye){if(typeof O!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=O,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=ye):this._options=ee)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,F.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)O.push(ee);return ke(O)}};qe=xe([D],qe),e.ProcessExecution=qe;let Le=class{constructor(O,ee,ye){if(this._args=[],Array.isArray(ee)){if(!O)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,F.illegalArgument)("command");this._command=O,this._args=ee,this._options=ye}else{if(typeof O!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=O,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,F.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)O.push(typeof ee=="string"?ee:ee.value);return ke(O)}};Le=xe([D],Le),e.ShellExecution=Le;var dt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class Ct{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Ct;let pt=v=class{constructor(O,ee,ye,Ve,nt,at){this.__deprecated=!1,this._definition=this.definition=O;let ut;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=ye,this.execution=Ve,ut=nt,this.__deprecated=!0):ee===bt.Global||ee===bt.Workspace?(this.target=ee,this._name=this.name=ye,this._source=this.source=Ve,this.execution=nt,ut=at):(this.target=ee,this._name=this.name=ye,this._source=this.source=Ve,this.execution=nt,ut=at),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ee=this._definition.type;(v.EmptyType===ee||v.ProcessType===ee||v.ShellType===ee||v.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};pt.ExtensionCallbackType="customExecution",pt.ProcessType="process",pt.ShellType="shell",pt.EmptyType="$empty",pt=v=xe([D],pt),e.Task=pt;var ht;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(O,ee=_t.None){this.collapsibleState=ee,C.URI.isUri(O)?this.resourceUri=O:this.label=O}};vt=xe([D],vt),e.TreeItem=vt;var _t;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ft=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};Ft=xe([D],Ft),e.TreeDataTransferItem=Ft;let yt=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,ee){this._items.set(O,ee)}forEach(O){this._items.forEach(O)}};yt=xe([D],yt),e.TreeDataTransfer=yt;let At=class{constructor(O,ee){this.id=O,this.color=ee}};At=xe([D],At),e.ThemeIcon=At,At.File=new At("file"),At.Folder=new At("folder");let Ut=class{constructor(O){this.id=O}};Ut=xe([D],Ut),e.ThemeColor=Ut;var Pt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Bt=class{constructor(O,ee){if(typeof O!="string"&&(!O||!C.URI.isUri(O)&&!C.URI.isUri(O.uri)))throw(0,F.illegalArgument)("base");if(typeof ee!="string")throw(0,F.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=C.URI.file(O),this.base=O):C.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ee}};Bt=xe([D],Bt),e.RelativePattern=Bt;let zt=class{constructor(O,ee,ye,Ve){this.enabled=typeof O=="boolean"?O:!0,typeof ee=="string"&&(this.condition=ee),typeof ye=="string"&&(this.hitCondition=ye),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};zt=xe([D],zt),e.Breakpoint=zt;let wt=class extends zt{constructor(O,ee,ye,Ve,nt){super(ee,ye,Ve,nt);if(O===null)throw(0,F.illegalArgument)("location");this.location=O}};wt=xe([D],wt),e.SourceBreakpoint=wt;let Qt=class extends zt{constructor(O,ee,ye,Ve,nt){super(ee,ye,Ve,nt);this.functionName=O}};Qt=xe([D],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends zt{constructor(O,ee,ye,Ve,nt,at,ut){super(Ve,nt,at,ut);if(!ee)throw(0,F.illegalArgument)("dataId");this.label=O,this.dataId=ee,this.canPersist=ye}};Vt=xe([D],Vt),e.DataBreakpoint=Vt;let oi=class{constructor(O,ee,ye){this.command=O,this.args=ee||[],this.options=ye}};oi=xe([D],oi),e.DebugAdapterExecutable=oi;let si=class{constructor(O,ee){this.port=O,this.host=ee}};si=xe([D],si),e.DebugAdapterServer=si;let Rt=class{constructor(O){this.path=O}};Rt=xe([D],Rt),e.DebugAdapterNamedPipeServer=Rt;let Yt=class{constructor(O){this.implementation=O}};Yt=xe([D],Yt),e.DebugAdapterInlineImplementation=Yt;let ai=class{constructor(O,ee){this.range=O,this.expression=ee}};ai=xe([D],ai),e.EvaluatableExpression=ai;var Xt;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(Xt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,ee){this.range=O,this.text=ee}};Wt=xe([D],Wt),e.InlineValueText=Wt;let mt=class{constructor(O,ee,ye=!0){this.range=O,this.variableName=ee,this.caseSensitiveLookup=ye}};mt=xe([D],mt),e.InlineValueVariableLookup=mt;let ci=class{constructor(O,ee){this.range=O,this.expression=ee}};ci=xe([D],ci),e.InlineValueEvaluatableExpression=ci;let Ot=class{constructor(O,ee){this.frameId=O,this.stoppedLocation=ee}};Ot=xe([D],Ot),e.InlineValueContext=Ot;var jt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Jt=c=class extends Error{constructor(O,ee=_.FileSystemProviderErrorCode.Unknown,ye){super(C.URI.isUri(O)?O.toString(!0):O);this.code=ye?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,c.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(O){return new c(O,_.FileSystemProviderErrorCode.FileExists,c.FileExists)}static FileNotFound(O){return new c(O,_.FileSystemProviderErrorCode.FileNotFound,c.FileNotFound)}static FileNotADirectory(O){return new c(O,_.FileSystemProviderErrorCode.FileNotADirectory,c.FileNotADirectory)}static FileIsADirectory(O){return new c(O,_.FileSystemProviderErrorCode.FileIsADirectory,c.FileIsADirectory)}static NoPermissions(O){return new c(O,_.FileSystemProviderErrorCode.NoPermissions,c.NoPermissions)}static Unavailable(O){return new c(O,_.FileSystemProviderErrorCode.Unavailable,c.Unavailable)}};Jt=c=xe([D],Jt),e.FileSystemError=Jt;let li=class{constructor(O,ee,ye){this.start=O,this.end=ee,this.kind=ye}};li=xe([D],li),e.FoldingRange=li;var fi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,ee=[]){this.tokenTypes=O,this.tokenModifiers=ee}}e.SemanticTokensLegend=Zt;function _i(U){return typeof U=="undefined"||(0,S.isStringArray)(U)}class qt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ee=0,ye=O.tokenTypes.length;ee<ye;ee++)this._tokenTypeStrToInt.set(O.tokenTypes[ee],ee);for(let ee=0,ye=O.tokenModifiers.length;ee<ye;ee++)this._tokenModifierStrToInt.set(O.tokenModifiers[ee],ee)}}push(O,ee,ye,Ve,nt){if(typeof O=="number"&&typeof ee=="number"&&typeof ye=="number"&&typeof Ve=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,ee,ye,Ve,nt);if(y.isRange(O)&&typeof ee=="string"&&_i(ye))return this._push(O,ee,ye);throw(0,F.illegalArgument)()}_push(O,ee,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const Ve=O.start.line,nt=O.start.character,at=O.end.character-O.start.character,ut=this._tokenTypeStrToInt.get(ee);let kt=0;if(ye)for(const Mt of ye){if(!this._tokenModifierStrToInt.has(Mt))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Mt);kt|=1<<Nt>>>0}this._pushEncoded(Ve,nt,at,ut,kt)}_pushEncoded(O,ee,ye,Ve,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Mt=0,Nt=0;for(let xt=0;xt<kt;xt++){let $t=this._data[5*xt],di=this._data[5*xt+1];$t===0?($t=Mt,di+=Nt):$t+=Mt,this._data[5*xt]=$t,this._data[5*xt+1]=di,Mt=$t,Nt=di}}let at=O,ut=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=ee}static _sortAndDeltaEncode(O){let ee=[];const ye=O.length/5|0;for(let ut=0;ut<ye;ut++)ee[ut]=ut;ee.sort((ut,kt)=>{const Mt=O[5*ut],Nt=O[5*kt];if(Mt===Nt){const xt=O[5*ut+1],$t=O[5*kt+1];return xt-$t}return Mt-Nt});const Ve=new Uint32Array(O.length);let nt=0,at=0;for(let ut=0;ut<ye;ut++){const kt=5*ee[ut],Mt=O[kt+0],Nt=O[kt+1],xt=O[kt+2],$t=O[kt+3],di=O[kt+4],Hi=Mt-nt,Yi=Hi===0?Nt-at:Nt,hi=5*ut;Ve[hi+0]=Hi,Ve[hi+1]=Yi,Ve[hi+2]=xt,Ve[hi+3]=$t,Ve[hi+4]=di,nt=Mt,at=Nt}return Ve}build(O){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),O):new Kt(qt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=qt;class Kt{constructor(O,ee){this.resultId=ee,this.data=O}}e.SemanticTokens=Kt;class yi{constructor(O,ee,ye){this.start=O,this.deleteCount=ee,this.data=ye}}e.SemanticTokensEdit=yi;class Si{constructor(O,ee){this.resultId=ee,this.edits=O}}e.SemanticTokensEdits=Si;var Gt;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ci;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Ci=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new At("arrow-left")},ei=xe([D],ei),e.QuickInputButtons=ei;var Di;(function(U){U[U.Default=1]="Default",U[U.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(O,ee,ye){this.badge=O,this.tooltip=ee,this.color=ye}static validate(O){if(O.badge){let ee=(0,A.nextCharLength)(O.badge,0);if(ee<O.badge.length&&(ee+=(0,A.nextCharLength)(O.badge,ee)),O.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(O){this.kind=O}};ti=xe([D],ti),e.ColorTheme=ti;var gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Re{constructor(O,ee){if(O<0)throw(0,F.illegalArgument)("start must be positive");if(ee<0)throw(0,F.illegalArgument)("end must be positive");O<=ee?(this._start=O,this._end=ee):(this._start=ee,this._end=O)}static isNotebookRange(O){return O instanceof Re?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ee=this._start,ye=this._end;return O.start!==void 0&&(ee=O.start),O.end!==void 0&&(ye=O.end),ee===this._start&&ye===this._end?this:new Re(ee,ye)}}e.NotebookRange=Re;class Lt{constructor(O,ee,ye,Ve,nt,at,ut){this.kind=O,this.value=ee,this.languageId=ye,this.mime=Ve,this.outputs=nt??[],this.metadata=at,this.executionSummary=ut,Lt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ee=>Lt.isNotebookCellData(ee))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Lt;class pi{constructor(O){this.cells=O}}e.NotebookData=pi;class ft{constructor(O,ee){this.data=O,this.mime=ee;const ye=(0,t.normalizeMimeType)(ee,!0);if(!ye)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}static isNotebookCellOutputItem(O){return O instanceof ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ee={name:O.name,message:O.message,stack:O.stack};return ft.json(ee,"application/vnd.code.notebook.error")}static stdout(O){return ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ee="application/octet-stream"){return new ft(O,ee)}static text(O,ee=t.Mimes.text){const ye=Ae(ft,u,"f",g).encode(String(O));return new ft(ye,ee)}static json(O,ee="application/json"){const ye=JSON.stringify(O,void 0,"	");return ft.text(ye,ee)}}e.NotebookCellOutputItem=ft,u=ft,g={value:new TextEncoder};class ii{constructor(O,ee,ye){this.items=ii.ensureUniqueMimeTypes(O,!0),typeof ee=="string"?(this.id=ee,this.metadata=ye):(this.id=(0,R.generateUuid)(),this.metadata=ee??ye)}static isNotebookCellOutput(O){return O instanceof ii?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,S.isArray)(O.items)}static ensureUniqueMimeTypes(O,ee=!1){const ye=new Set,Ve=new Set;for(let nt=0;nt<O.length;nt++){const at=O[nt],ut=(0,t.normalizeMimeType)(at.mime);if(!ye.has(ut)){ye.add(ut);continue}Ve.add(nt),ee&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ve.size===0?O:O.filter((nt,at)=>!Ve.has(at))}}e.NotebookCellOutput=ii;var Ii;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(O,ee){this.text=O,this.alignment=ee}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(O,ee=[]){this.uri=O,this.provides=(0,a.asArray)(ee)}}e.NotebookRendererScript=Ri;let ni=class{constructor(O,ee){this.label=O,this.timestamp=ee}};ni=xe([D],ni),e.TimelineItem=ni;var Fi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(O,ee){this.ranges=O,this.wordPattern=ee}}e.LinkedEditingRanges=Li;class Ni{constructor(O,ee){this._port=O,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var Y;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Y=e.TestResultState||(e.TestResultState={}));var le;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(le=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ce=class{constructor(O=void 0,ee=void 0,ye=void 0){this.include=O,this.exclude=ee,this.profile=ye}};Ce=xe([D],Ce),e.TestRunRequest=Ce;let ct=E=class{constructor(O){this.message=O}static diff(O,ee,ye){const Ve=new E(O);return Ve.expectedOutput=ee,Ve.actualOutput=ye,Ve}};ct=E=xe([D],ct),e.TestMessage=ct;let St=class{constructor(O){this.id=O}};St=xe([D],St),e.TestTag=St;let Dt=class{constructor(O,ee){this.covered=O,this.total=ee}};Dt=xe([D],Dt),e.CoveredCount=Dt;let xi=I=class{constructor(O,ee,ye,Ve){this.uri=O,this.statementCoverage=ee,this.branchCoverage=ye,this.functionCoverage=Ve}static fromDetails(O,ee){const ye=new Dt(0,0),Ve=new Dt(0,0),nt=new Dt(0,0);for(const ut of ee)if("branches"in ut){ye.total+=1,ye.covered+=ut.executionCount>0?1:0;for(const kt of ut.branches)Ve.total+=1,Ve.covered+=kt.executionCount>0?1:0}else nt.total+=1,nt.covered+=ut.executionCount>0?1:0;const at=new I(O,ye,Ve.total>0?Ve:void 0,nt.total>0?nt:void 0);return at.detailedCoverage=ee,at}};xi=I=xe([D],xi),e.FileCoverage=xi;let Ui=class{constructor(O,ee,ye=[]){this.executionCount=O,this.location=ee,this.branches=ye}};Ui=xe([D],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(O,ee){this.executionCount=O,this.location=ee}};Bi=xe([D],Bi),e.BranchCoverage=Bi;let $i=class{constructor(O,ee){this.executionCount=O,this.location=ee}};$i=xe([D],$i),e.FunctionCoverage=$i;var qi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ki;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Ki=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Gi;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(O,ee,ye,Ve,nt,at){this.kind=O,this.name=ee,this.detail=ye,this.uri=Ve,this.range=nt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(Ee[86],_e([0,1,41,10,9,223,114,7,16]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function R(s,u){u?C.set(s,u):C.delete(s)}e.setWordDefinitionFor=R;function _(s){return C.get(s)}e.getWordDefinitionFor=_;class n extends T.MirrorTextModel{constructor(u,g,k,b,m,f,P,l){super(g,k,b,m);this._proxy=u,this._languageId=f,this._isDirty=P,this._notebook=l,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,S.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===F.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(g){return g?u._getTextInRange(g):u.getText()},get eol(){return u._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(g){return u._lineAt(g)},offsetAt(g){return u._offsetAt(g)},positionAt(g){return u._positionAt(g)},validateRange(g){return u._validateRange(g)},validatePosition(g){return u._validatePosition(g)},getWordRangeAtPosition(g,k){return u._getWordRangeAtPosition(g,k)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,a.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,a.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const g=this._validateRange(u);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const k=this._eol,b=g.start.line,m=g.end.line,f=[];f.push(this._lines[b].substring(g.start.character));for(let P=b+1;P<m;P++)f.push(this._lines[P]);return f.push(this._lines[m].substring(0,g.end.character)),f.join(k)}_lineAt(u){let g;if(u instanceof A.Position?g=u.line:typeof u=="number"&&(g=u),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new d(g,this._lines[g],g===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(u),k=this._lines[g.index].length;return new A.Position(g.index,Math.min(g.remainder,k))}_validateRange(u){if(!(u instanceof A.Range))throw new Error("Invalid argument");const g=this._validatePosition(u.start),k=this._validatePosition(u.end);return g===u.start&&k===u.end?u:new A.Range(g.line,g.character,k.line,k.character)}_validatePosition(u){if(!(u instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:g,character:k}=u,b=!1;if(g<0)g=0,k=0,b=!0;else if(g>=this._lines.length)g=this._lines.length-1,k=this._lines[g].length,b=!0;else{const m=this._lines[g].length;k<0?(k=0,b=!0):k>m&&(k=m,b=!0)}return b?new A.Position(g,k):u}_getWordRangeAtPosition(u,g){const k=this._validatePosition(u);if(!g)g=_(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const b=(0,t.getWordAtText)(k.character+1,(0,t.ensureValidWordDefinition)(g),this._lines[k.line],0);if(b)return new A.Range(k.line,b.startColumn-1,k.line,b.endColumn-1)}}e.ExtHostDocumentData=n;class d{constructor(u,g,k){this._line=u,this._text=g,this._isLastLine=k}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(Ee[150],_e([0,1,7,3,224,6,55,21,2,36]),function(oe,e,a,F,w,T,t,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(n,d,s,u){this._notebook=s,this._selector=u,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(k=>{const b=this._cellUris.get(k.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=k=>{k===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(k=>g(k.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const n=[],d=[];for(const s of this._notebook.getCells())s.kind===a.NotebookCellKind.Code&&(!this._selector||(0,t.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),d.push(s.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(n){if(!n){let b="";for(const m of this._cells)b+=m.document.getText()+`
`;return b=b.slice(0,-1),b}if(n.isEmpty)return"";const d=this.locationAt(n.start),s=this.locationAt(n.end),u=this._cellUris.get(d.uri),g=this._cellUris.get(s.uri);if(u===void 0||g===void 0)return"";if(u===g)return this._cells[u].document.getText(new a.Range(d.range.start,s.range.end));const k=[this._cells[u].document.getText(new a.Range(d.range.start,new a.Position(this._cells[u].document.lineCount,0)))];for(let b=u+1;b<g;b++)k.push(this._cells[b].document.getText());return k.push(this._cells[g].document.getText(new a.Range(new a.Position(0,0),s.range.end))),k.join(`
`)}offsetAt(n){const d=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(d.index-1),u=this._cells[d.index].document.offsetAt(n.with(d.remainder));return s+u}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),u=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(u)}const d=this._cellUris.get(n.uri);if(d!==void 0){const s=this._cellLines.getPrefixSum(d-1);return new a.Position(s+n.range.start.line,n.range.start.character)}return new a.Position(0,0)}locationAt(n){a.Range.isRange(n)||(n=new a.Range(n,n));const d=this._cellLines.getIndexOf(n.start.line);let s=d;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const u=new a.Position(d.remainder,n.start.character),g=new a.Position(s.remainder,n.end.character),k=new a.Range(u,g),b=this._cells[d.index];return new a.Location(b.document.uri,b.document.validateRange(k))}contains(n){return this._cellUris.has(n)}validateRange(n){const d=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(d,s)}validatePosition(n){const d=this._cellLines.getIndexOf(n.line),s=new a.Position(d.remainder,n.character),u=this._cells[d.index].document.validatePosition(s),g=this._cellLines.getPrefixSum(d.index-1);return new a.Position(g+u.line,u.character)}}e.ExtHostNotebookConcatDocument=R}),define(Ee[151],_e([0,1,7,13,3]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(A){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let S=A==="light"?a.ColorThemeKind.Light:A==="dark"?a.ColorThemeKind.Dark:a.ColorThemeKind.HighContrast;this._actual=new a.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=xe([$e(0,F.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(Ee[66],_e([0,1,4]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class F{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=t=>t,this.transformOutgoing=t=>t,this.transformOutgoingURI=t=>t,this.transformOutgoingScheme=t=>t)}}e.URITransformerService=F}),define(Ee[152],_e([0,1,22]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function w(A,S){if(S.serializeBuffersForPostMessage){const C=new F,R=(d,s)=>{if(s instanceof ArrayBuffer){const u=C.add(s);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(s)){const u=T(s);if(u){const g=C.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:u,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},_=JSON.stringify(A,R),n=C.buffers.map(d=>{const s=new Uint8Array(d);return a.VSBuffer.wrap(s)});return{message:_,buffers:n}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=w;function T(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function t(A,S){const C=S.map(n=>{const d=new ArrayBuffer(n.byteLength);return new Uint8Array(d).set(n.buffer),d}),R=S.length?(n,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const s=d,{index:u}=s,g=C[u];if(s.view)switch(s.view.type){case 1:return new Int8Array(g,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return d}:void 0;return{message:JSON.parse(A,R),arrayBuffers:C}}e.deserializeWebviewMessage=t}),define(Ee[153],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var a;(function(F){function w(t){const A=new Map;return t.types.forEach((S,C)=>{A.set(S,{asString:async()=>t.items[C].asString})}),A}F.toITreeDataTransfer=w;async function T(t){const A={types:[],items:[]},S=Array.from(t.entries());for(const C of S)A.types.push(C[0]),A.items.push({asString:await C[1].asString()});return A}F.toTreeDataTransferDTO=T})(a=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[67],_e([0,1,10,2]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(A,S){return A.scheme===a.Schemas.http||A.scheme===a.Schemas.https?A:(S&&S.authority&&S.isRemote&&A.scheme===a.Schemas.file&&(A=F.URI.from({scheme:a.Schemas.vscodeRemote,authority:S.authority,path:A.path})),F.URI.from({scheme:a.Schemas.https,authority:`${A.scheme}+${T(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=w;function T(A){return A.replace(/./g,S=>{const C=S.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?S:"-"+C.toString(16).padStart(4,"0")})}function t(A){return A.replace(/-([0-9a-f]{4})/g,(S,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=t}),define(Ee[154],_e([0,1,3,6,67]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(A,S,C){this._proxy=A,this._editors=S,this._initData=C,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const _ of this._insets.values())R.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,S,C,R,_){let n;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===A){n=m;break}if(!n)throw new Error("not a visible editor");const d=this,s=this._handlePool++,u=new a.Emitter,g=new a.Emitter,k=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,w.asWebviewUri)(m,d._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(m){this._options=m,d._proxy.$setOptions(s,m)}get options(){return this._options}set html(m){this._html=m,d._proxy.$setHtml(s,m)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(m){return d._proxy.$postMessage(s,m)}},b=new class{constructor(){this.editor=A,this.line=S,this.height=C,this.webview=k,this.onDidDispose=g.event}dispose(){d._insets.has(s)&&(d._insets.delete(s),d._proxy.$disposeEditorInset(s),g.fire(),g.dispose(),u.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,S+1,C,R||{},_.identifier,_.extensionLocation),this._insets.set(s,{editor:A,inset:b,onDidReceiveMessage:u}),b}$onDidDispose(A){const S=this._insets.get(A);S&&S.inset.dispose()}$onDidReceiveMessage(A,S){const C=this._insets.get(A);C&&C.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=T}),define(Ee[155],_e([0,1,126,11,2,6,4,44,30,45,16,10]),function(oe,e,a,F,w,T,t,A,S,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.ActiveEditorDirtyContext=new A.RawContextKey("activeEditorIsDirty",!1,(0,a.localize)(2,null)),e.ActiveEditorPinnedContext=new A.RawContextKey("activeEditorIsNotPreview",!1,(0,a.localize)(3,null)),e.ActiveEditorStickyContext=new A.RawContextKey("activeEditorIsPinned",!1,(0,a.localize)(4,null)),e.ActiveEditorReadonlyContext=new A.RawContextKey("activeEditorIsReadonly",!1,(0,a.localize)(5,null)),e.ActiveEditorCanRevertContext=new A.RawContextKey("activeEditorCanRevert",!1,(0,a.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new A.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new A.RawContextKey("activeEditor",null,{type:"string",description:(0,a.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new A.RawContextKey("activeEditorAvailableEditorIds","",(0,a.localize)(8,null)),e.TextCompareEditorVisibleContext=new A.RawContextKey("textCompareEditorVisible",!1,(0,a.localize)(9,null)),e.TextCompareEditorActiveContext=new A.RawContextKey("textCompareEditorActive",!1,(0,a.localize)(10,null)),e.SideBySideEditorActiveContext=new A.RawContextKey("sideBySideEditorActive",!1,(0,a.localize)(11,null)),e.EditorGroupEditorsCountContext=new A.RawContextKey("groupEditorsCount",0,(0,a.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new A.RawContextKey("activeEditorGroupEmpty",!1,(0,a.localize)(13,null)),e.ActiveEditorGroupIndexContext=new A.RawContextKey("activeEditorGroupIndex",0,(0,a.localize)(14,null)),e.ActiveEditorGroupLastContext=new A.RawContextKey("activeEditorGroupLast",!1,(0,a.localize)(15,null)),e.ActiveEditorGroupLockedContext=new A.RawContextKey("activeEditorGroupLocked",!1,(0,a.localize)(16,null)),e.MultipleEditorGroupsContext=new A.RawContextKey("multipleEditorGroups",!1,(0,a.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new A.RawContextKey("editorIsOpen",!1,(0,a.localize)(18,null)),e.InEditorZenModeContext=new A.RawContextKey("inZenMode",!1,(0,a.localize)(19,null)),e.IsCenteredLayoutContext=new A.RawContextKey("isCenteredLayout",!1,(0,a.localize)(20,null)),e.SplitEditorsVertically=new A.RawContextKey("splitEditorsVertically",!1,(0,a.localize)(21,null)),e.EditorAreaVisibleContext=new A.RawContextKey("editorAreaVisible",!0,(0,a.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(L,y,x){for(const N of x.visibleEditorPanes)if(N.group.id===y&&L.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function d(L){if(P(L))return!1;const y=L;return w.URI.isUri(y?.resource)}e.isResourceEditorInput=d;function s(L){if(P(L))return!1;const y=L;return y?.original!==void 0&&y.modified!==void 0}e.isResourceDiffEditorInput=s;function u(L){if(P(L)||s(L))return!1;const y=L;return y?.primary!==void 0&&y.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function g(L){if(P(L))return!1;const y=L;return y?y.resource===void 0||y.resource.scheme===_.Schemas.untitled||y.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;var k;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(k=e.Verbosity||(e.Verbosity={}));var b;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var m;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class f extends T.Disposable{}e.AbstractEditorInput=f;function P(L){return L instanceof f}e.isEditorInput=P;function l(L){const y=L;return w.URI.isUri(y?.preferredResource)}function M(L){const y=L;return P(y?.primary)&&P(y?.secondary)}e.isSideBySideEditorInput=M;function r(L){const y=L;return P(y?.modified)&&P(y?.original)}e.isDiffEditorInput=r;function i(L){return P(L?.editor)}e.isEditorInputWithOptions=i;function p(L){const y=L;return i(L)&&y?.group!==void 0}e.isEditorInputWithOptionsAndGroup=p;function h(L){const y=L;return typeof y?.groupId=="number"&&P(y.editor)}e.isEditorIdentifier=h;var o;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var v;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(v=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(y,x){if(!y)return;if(x?.supportSideBySide){const{primary:z,secondary:H}=this.getSideEditors(y);if(z&&H){if(x?.supportSideBySide===v.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(H,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===v.ANY)return this.getOriginalUri(z,{filterByScheme:x.filterByScheme})??this.getOriginalUri(H,{filterByScheme:x.filterByScheme});y=x.supportSideBySide===v.PRIMARY?z:H}}if(s(y)||u(y))return;const N=l(y)?y.preferredResource:y.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(y){return M(y)||u(y)?{primary:y.primary,secondary:y.secondary}:r(y)||s(y)?{primary:y.modified,secondary:y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(y,x){if(!y)return;if(x?.supportSideBySide){const{primary:z,secondary:H}=this.getSideEditors(y);if(z&&H){if(x?.supportSideBySide===v.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(H,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===v.ANY)return this.getCanonicalUri(z,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(H,{filterByScheme:x.filterByScheme});y=x.supportSideBySide===v.PRIMARY?z:H}}if(s(y)||u(y))return;const N=y.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(y,x){if(Array.isArray(x)){if(x.some(N=>y.scheme===N))return y}else if(x===y.scheme)return y}}e.EditorResourceAccessor=new c;var E;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class I{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(y){const x=this.instantiationService=y.get(t.IInstantiationService);for(const[N,z]of this.editorSerializerConstructors)this.createEditorSerializer(N,z,x);this.editorSerializerConstructors.clear()}createEditorSerializer(y,x,N){const z=N.createInstance(x);this.editorSerializerInstances.set(y,z)}registerFileEditorFactory(y){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=y}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(y,x){if(this.editorSerializerConstructors.has(y)||this.editorSerializerInstances.has(y))throw new Error(`A editor serializer with type ID '${y}' was already registered.`);return this.instantiationService?this.createEditorSerializer(y,x,this.instantiationService):this.editorSerializerConstructors.set(y,x),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(y),this.editorSerializerInstances.delete(y)})}getEditorSerializer(y){return this.editorSerializerInstances.get(typeof y=="string"?y:y.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new I);async function D(L,y){if(!L||!L.length)return[];const x=await Promise.all(L.map(async N=>{const z=w.URI.revive(N.fileUri);if(!z||!await y.canHandleResource(z))return;let q=N.exists,ue=N.type;if(typeof q!="boolean"||typeof ue!="number")try{ue=(await y.resolve(z)).isFile?C.FileType.File:C.FileType.Unknown,q=!0}catch{q=!1}if(!q&&N.openOnlyIfExists||ue!==C.FileType.File)return;const G={selection:q?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let ce;return q?ce={resource:z,options:G}:ce={resource:z,options:G,forceUntitled:!0},ce}));return(0,R.coalesce)(x)}e.pathsToEditors=D;var B;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[156],_e([0,1,3,14,127]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,S,C,R){const _={command:A};if(S&&Object.keys(S).length>0&&(_.arguments=S),this.internalSend("request",_),typeof R=="number"){const n=setTimeout(()=>{clearTimeout(n);const d=this.pendingRequests.get(_.seq);if(d){this.pendingRequests.delete(_.seq);const s={type:"response",seq:0,request_seq:_.seq,success:!1,command:A,message:(0,w.localize)(0,null,R,A)};d(s)}},R)}return C&&this.pendingRequests.set(_.seq,C),_.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,S){return A.type!=="event"||S.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,F.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":const S=A,C=this.pendingRequests.get(S.request_seq);C&&(this.pendingRequests.delete(S.request_seq),C(S));break}}}internalSend(A,S){S.type=A,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((S,C)=>A.set(C,S)),await(0,F.timeout)(500),A.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(Ee[157],_e([0,1,9,2,17,27,10]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function S(r,i,p){return r.replace(A,function(h,o){return i&&o.length>0&&o[0]!=="_"?h:p&&p.hasOwnProperty(o)?p[o]:h})}e.formatPII=S;function C(r){const i={};for(const p of Object.keys(r))p.startsWith("!")||(i[p]=r[p]);return i}e.filterExceptionsFromTelemetry=C;function R(r){return r.configuration.request==="attach"&&!_(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function _(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(i,"extensionhost")||(0,a.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?_(r.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function d(r,i,p){let h,o=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,c=null;for(;c=v.exec(r);){let E=c.index+1,I=E+c[0].length;if(E<=i&&I>=p){h=c[0],o=E;break}}if(h){let E=/\w+/g,I=null;for(;(I=E.exec(h))&&!(I.index+1+o+I[0].length>=p););I&&(h=h.substring(0,E.lastIndex))}return h?{start:o,end:o+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(r){return!!(r&&r.match(s))}e.isUri=u;function g(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(u(r.path))return F.URI.parse(r.path);if((0,w.isAbsolute)(r.path))return F.URI.file(r.path)}return r.path}function k(r){if(typeof r.path=="object"){const i=F.URI.revive(r.path);if(i)return i.scheme===t.Schemas.file?i.fsPath:i.toString()}return r.path}function b(r,i){const p=i?g:k,h=(0,T.deepClone)(r);return f(h,(o,v)=>{o&&v&&(v.path=p(v))}),h}e.convertToDAPaths=b;function m(r,i){const p=i?g:k,h=(0,T.deepClone)(r);return f(h,(o,v)=>{!o&&v&&(v.path=p(v))}),h}e.convertToVSCPaths=m;function f(r,i){switch(r.type){case"event":const p=r;switch(p.event){case"output":i(!1,p.body.source);break;case"loadedSource":i(!1,p.body.source);break;case"breakpoint":i(!1,p.body.breakpoint.source);break;default:break}break;case"request":const h=r;switch(h.command){case"setBreakpoints":i(!0,h.arguments.source);break;case"breakpointLocations":i(!0,h.arguments.source);break;case"source":i(!0,h.arguments.source);break;case"gotoTargets":i(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(v=>i(!1,v));break;default:break}break;case"response":const o=r;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(v=>i(!1,v.source));break;case"loadedSources":o.body.sources.forEach(v=>i(!1,v));break;case"scopes":o.body.scopes.forEach(v=>i(!1,v.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(v=>i(!1,v.source));break;case"setBreakpoints":o.body.breakpoints.forEach(v=>i(!1,v.source));break;default:break}break}}function P(r){return r.filter(i=>!i.presentation?.hidden).sort((i,p)=>i.presentation?p.presentation?i.presentation.group?p.presentation.group?i.presentation.group!==p.presentation.group?i.presentation.group.localeCompare(p.presentation.group):l(i.presentation.order,p.presentation.order):-1:p.presentation.group?1:l(i.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.getVisibleAndSorted=P;function l(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function M(r,i){const p=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(p!=="none"&&(await i.saveAll(),p==="allEditorsInActiveGroup")){const h=i.activeEditorPane;h&&await i.save({editor:h.input,groupId:h.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(Ee[87],_e([0,1,29,158,79,10,17,23,44]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var d;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(d=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var k;(function(E){E.scheme=T.Schemas.vscodeNotebookCell;const I=/^ch(\d{7,})/;function D(z,H){return z.with({scheme:E.scheme,fragment:`ch${H.toString().padStart(7,"0")}${z.scheme!==T.Schemas.file?z.scheme:""}`})}E.generate=D;function B(z){if(z.scheme!==E.scheme)return;const H=I.exec(z.fragment);return H?{handle:Number(H[1]),notebook:z.with({scheme:z.fragment.substr(H[0].length)||T.Schemas.file,fragment:null})}:void 0}E.parse=B;function L(z,H,q){return z.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`ch${H.toString().padStart(7,"0")},${q??""},${z.scheme!==T.Schemas.file?z.scheme:""}`})}E.generateCellOutputUri=L;function y(z){if(z.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const H=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(z.fragment);if(!H)return;const q=Number(H[1]),ue=H[2]&&H[2]!==""?H[2]:void 0,G=H[3];return{handle:q,outputId:ue,notebook:z.with({scheme:G||T.Schemas.file,fragment:null})}}E.parseCellOutputUri=y;function x(z,H,q){return z.with({scheme:q,fragment:`ch${H.toString().padStart(7,"0")}${z.scheme!==T.Schemas.file?z.scheme:""}`})}E.generateCellUri=x;function N(z,H){if(z.scheme!==H)return;const q=I.exec(z.fragment);return q?{handle:Number(q[1]),notebook:z.with({scheme:z.fragment.substr(q[0].length)||T.Schemas.file,fragment:null})}:void 0}E.parseCellUri=N})(k=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(E){return b.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=m;function f(E){return b.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=f;function P(E){return b.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=P;const l=E=>A.isWindows?E.replace(/\//g,"\\"):E;class M{constructor(I=[],D=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=D,this.order=[...new Set(I)].map(B=>({pattern:B,matches:a.parse(l(B))}))}sort(I){const D=new Map(F.Iterable.map(I,L=>[L,l(L)]));let B=[];for(const{matches:L}of this.order)for(const[y,x]of D)if(L(x)){B.push(y),D.delete(y);break}return D.size&&(B=B.concat([...D.keys()].sort((L,y)=>this.defaultOrder.indexOf(L)-this.defaultOrder.indexOf(y)))),B}prioritize(I,D){const B=this.findIndex(I);if(B===-1){this.order.unshift({pattern:I,matches:a.parse(l(I))});return}const L=new Set(D.map(x=>this.findIndex(x,B)));L.delete(-1);const y=Array.from(L).sort();this.order.splice(B+1,0,...y.map(x=>this.order[x]));for(let x=y.length-1;x>=0;x--)this.order.splice(y[x],1)}toArray(){return this.order.map(I=>I.pattern)}findIndex(I,D=this.order.length){const B=l(I);for(let L=0;L<D;L++)if(this.order[L].matches(B))return L;return-1}}e.MimeTypeDisplayOrder=M;function r(E,I,D,B=(L,y)=>L===y){const L=[];function y(z,H,q){if(H===0&&q.length===0)return;const ue=L[L.length-1];ue&&ue.start+ue.deleteCount===z?(ue.deleteCount+=H,ue.toInsert.push(...q)):L.push({start:z,deleteCount:H,toInsert:q})}let x=0,N=0;for(;;){if(x===E.length){y(x,0,I.slice(N));break}if(N===I.length){y(x,E.length-x,[]);break}const z=E[x],H=I[N];if(B(z,H)){x+=1,N+=1;continue}D(H)?(y(x,1,[]),x+=1):(y(x,0,[H]),N+=1)}return L}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(E){E.default="default",E.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function p(E){const I=E;return!!((typeof I.include=="string"||a.isRelativePattern(I.include))&&(typeof I.exclude=="string"||a.isRelativePattern(I.exclude)))}e.isDocumentExcludePattern=p;function h(E,I,D){if(Array.isArray(E.viewType)&&E.viewType.indexOf(I)>=0||E.viewType===I)return!0;if(E.filenamePattern){let B=p(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,L=p(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(a.match(B,(0,t.basename)(D.fsPath).toLowerCase()))return!(L&&a.match(L,(0,t.basename)(D.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class o{constructor(I){this.textModel=I}getElements(){const I=new Int32Array(this.textModel.cells.length);for(let D=0;D<this.textModel.cells.length;D++)I[D]=this.textModel.cells[D].getHashValue();return I}}e.CellSequence=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var v;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(I){return`${c._prefix}${I}`}static parse(I){if(I.startsWith(c._prefix))return I.substr(c._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c._prefix="notebook/"}),define(Ee[159],_e([0,1,4]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState",w[w.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Ee[160],_e([0,1,4,44]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new F.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new F.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new F.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,a.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[161],_e([0,1,129,4,44]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,a.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,a.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,a.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[162],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=a;function F(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=F}),define(Ee[88],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var a;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(a=e.TestResultState||(e.TestResultState={}));var F;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var w;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(w=e.TestMessageType||(e.TestMessageType={}));var T;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const t=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=t;var A;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(A=e.DetailType||(e.DetailType={}));var S;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class C{add(n){}update(n){}remove(n,d){}complete(){}}e.IncrementalChangeCollector=C;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const d=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const u=s[1];if(u.parent){if(this.items.has(u.parent)){const g=this.items.get(u.parent);g.children.add(u.item.extId);const k=this.createItem(u,g);this.items.set(u.item.extId,k),d.add(k)}}else{const g=this.createItem(u);this.roots.add(g),this.items.set(u.item.extId,g),d.add(g)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=s[1],g=this.items.get(u.extId);if(!g)break;u.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,u),d.update(g);break}case 2:{const u=this.items.get(s[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const g=[[s[1]]];for(;g.length;)for(const k of g.pop()){const b=this.items.get(k);b&&(g.push(b.children),this.items.delete(k),d.remove(b,b!==u),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}d.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new C}}e.AbstractIncrementalTestCollection=R}),define(Ee[68],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(T){T.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class w{constructor(t,A=t.length){if(this.path=t,this.viewEnd=A,t.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(t,A,S=t.parent){if(t.id===A)return new w([A]);let C=[t.id];for(let R=S;R&&R.id!==A;R=R.parent)C.push(R.id);return C.push(A),new w(C.reverse())}static isRoot(t){return!t.includes("\0")}static fromString(t){return new w(t.split("\0"))}static join(t,A){return new w([...t.path,A])}static joinToString(t,A){return t.toString()+"\0"+A}static compare(t,A){return t===A?0:A.startsWith(t+"\0")?2:t.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let t=1;t<=this.viewEnd;t++)yield new w(this.path,t)}compare(t){if(typeof t=="string")return w.compare(this.toString(),t);for(let A=0;A<t.viewEnd&&A<this.viewEnd;A++)if(t.path[A]!==this.path[A])return 1;return t.viewEnd>this.viewEnd?2:t.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let t=1;t<this.viewEnd;t++)this.stringifed+="\0",this.stringifed+=this.path[t]}return this.stringifed}}e.TestId=w}),define(Ee[163],_e([0,1,17,89,11,27,23,78,130]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(_,n,d){this._contributedVariables=new Map,this._context=_,this._labelService=n,d&&(this._envVariablesPromise=d.then(s=>this.prepareEnv(s)))}prepareEnv(_){if(t.isWindows){const n=Object.create(null);return Object.keys(_).forEach(d=>{n[d.toLowerCase()]=_[d]}),n}return _}resolveWithEnvironment(_,n,d){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,d)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,d,s){const u=T.deepClone(n);return t.isWindows&&u.windows?Object.keys(u.windows).forEach(g=>u[g]=u.windows[g]):t.isMacintosh&&u.osx?Object.keys(u.osx).forEach(g=>u[g]=u.osx[g]):t.isLinux&&u.linux&&Object.keys(u.linux).forEach(g=>u[g]=u.linux[g]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,u,d,s)}async resolveAnyAsync(_,n,d){return this.resolveAnyBase(_,n,d)}async resolveAnyMap(_,n,d){const s=new Map;return{newConfig:await this.resolveAnyBase(_,n,d,s),resolvedVariables:s}}resolveWithInteractionReplace(_,n,d,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,d,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,d,s,u){if(w.isString(d))return this.resolveString(_,n,d,s,u);if(w.isArray(d))return d.map(g=>this.recursiveResolve(_,n,g,s,u));if(w.isObject(d)){let g=Object.create(null);return Object.keys(d).forEach(k=>{const b=this.resolveString(_,n,k,s,u);g[b]=this.recursiveResolve(_,n,d[k],s,u)}),g}return d}resolveString(_,n,d,s,u){return d.replace(C.VARIABLE_REGEXP,(k,b)=>{if(b.includes(C.VARIABLE_LHS))return k;let m=this.evaluateSingleVariable(_,k,b,n,s);return u&&u.set(b,m),m!==k&&w.isString(m)&&m.match(C.VARIABLE_REGEXP)&&(m=this.resolveString(_,n,m,s,u)),m})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,d,s,u){let g;const k=d.split(":");k.length>1&&(d=k[0],g=k[1]);const b=()=>{const P=this._context.getFilePath();if(P)return P;throw new Error((0,S.localize)(0,null,n))},m=()=>{const P=b();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,S.localize)(1,null,n,a.basename(P)))},f=()=>{if(g){const P=this._context.getFolderUri(g);if(P)return P;throw new Error((0,S.localize)(2,null,n,g))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(d){case"env":if(g){if(_){const P=_[t.isWindows?g.toLowerCase():g];if(w.isString(P))return P}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(g){const P=this._context.getConfigurationValue(s,g);if(w.isUndefinedOrNull(P))throw new Error((0,S.localize)(6,null,n,g));if(w.isObject(P))throw new Error((0,S.localize)(7,null,n,g));return P}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,g,u,"command");case"input":return this.resolveFromMap(n,g,u,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return s||g?(0,A.normalizeDriveLetter)(this.fsPath(f())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.fsPath(f()));case"lineNumber":const P=this._context.getLineNumber();if(P)return P;throw new Error((0,S.localize)(9,null,n));case"selectedText":const l=this._context.getSelectedText();if(l)return l;throw new Error((0,S.localize)(10,null,n));case"file":return b();case"fileWorkspaceFolder":return m();case"relativeFile":return s||g?a.relative(this.fsPath(f()),b()):b();case"relativeFileDirname":const M=a.dirname(b());if(s||g){const h=a.relative(this.fsPath(f()),M);return h.length===0?".":h}return M;case"fileDirname":return a.dirname(b());case"fileExtname":return a.extname(b());case"fileBasename":return a.basename(b());case"fileBasenameNoExtension":const r=a.basename(b());return r.slice(0,r.length-a.extname(r).length);case"fileDirnameBasename":return a.basename(a.dirname(b()));case"execPath":const i=this._context.getExecPath();return i||n;case"execInstallFolder":const p=this._context.getAppRoot();return p||n;case"pathSeparator":return a.sep;default:try{const h=g?`${d}:${g}`:d;return this.resolveFromMap(n,h,u,void 0)}catch(h){return n}}}}resolveFromMap(_,n,d,s){if(n&&d){const u=s===void 0?d[n]:d[s+":"+n];if(typeof u=="string")return u;throw new Error((0,S.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[90],_e([0,1,4,155]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var w;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var T;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var t;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(t=e.GroupLocation||(e.GroupLocation={}));var A;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function C(u){const g=u;return(0,F.isEditorInput)(g?.editor)&&(0,F.isEditorInput)(g?.replacement)}e.isEditorReplacement=C;var R;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(u){u[u.GROUP_ACTIVE=0]="GROUP_ACTIVE",u[u.GROUP_INDEX=1]="GROUP_INDEX",u[u.GROUP_LOCKED=2]="GROUP_LOCKED",u[u.EDITOR_OPEN=3]="EDITOR_OPEN",u[u.EDITOR_CLOSE=4]="EDITOR_CLOSE",u[u.EDITOR_MOVE=5]="EDITOR_MOVE",u[u.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",u[u.EDITOR_LABEL=7]="EDITOR_LABEL",u[u.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",u[u.EDITOR_PIN=9]="EDITOR_PIN",u[u.EDITOR_STICKY=10]="EDITOR_STICKY",u[u.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function d(u){const g=u;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=d;function s(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=s}),define(Ee[164],_e([0,1,4,90]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(T){const t=T;return typeof T=="number"||(0,F.isEditorGroup)(t)}e.isPreferredGroup=w}),define(Ee[8],_e([0,1,16,22,77,225,54,27,11,2,59,58,131,82,47,87,68,164,7]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var m;(function(ne){function ge(W){const{selectionStartLineNumber:be,selectionStartColumn:ke,positionLineNumber:qe,positionColumn:Le}=W,dt=new b.Position(be-1,ke-1),bt=new b.Position(qe-1,Le-1);return new b.Selection(dt,bt)}ne.to=ge;function te(W){const{anchor:be,active:ke}=W;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}ne.from=te})(m=e.Selection||(e.Selection={}));var f;(function(ne){function ge(W){if(!W)return;const{start:be,end:ke}=W;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}ne.from=ge;function te(W){if(!W)return;const{startLineNumber:be,startColumn:ke,endLineNumber:qe,endColumn:Le}=W;return new b.Range(be-1,ke-1,qe-1,Le-1)}ne.to=te})(f=e.Range||(e.Range={}));var P;(function(ne){function ge(te){switch(te){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ne.to=ge})(P=e.TokenType||(e.TokenType={}));var l;(function(ne){function ge(W){return new b.Position(W.lineNumber-1,W.column-1)}ne.to=ge;function te(W){return{lineNumber:W.line+1,column:W.character+1}}ne.from=te})(l=e.Position||(e.Position={}));var M;(function(ne){function ge(be,ke){return(0,a.coalesce)((0,a.asArray)(be).map(qe=>te(qe,ke)))}ne.from=ge;function te(be,ke){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:W(be.scheme,ke),pattern:typeof be.pattern=="undefined"?void 0:Ue.from(be.pattern),exclusive:be.exclusive}}function W(be,ke){return ke&&typeof be=="string"?ke.transformOutgoingScheme(be):be}})(M=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ne){function ge(W){switch(W){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ne.from=ge;function te(W){switch(W){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ne.to=te})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ne){function ge(W){let be;return W.code&&((0,S.isString)(W.code)||(0,S.isNumber)(W.code)?be=String(W.code):be={value:String(W.code.value),target:W.code.target}),{...f.from(W.range),message:W.message,source:W.source,code:be,severity:h.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(p.from),tags:Array.isArray(W.tags)?(0,a.coalesce)(W.tags.map(r.from)):void 0}}ne.from=ge;function te(W){const be=new b.Diagnostic(f.to(W),W.message,h.to(W.severity));return be.source=W.source,be.code=(0,S.isString)(W.code)?W.code:W.code?.value,be.relatedInformation=W.relatedInformation&&W.relatedInformation.map(p.to),be.tags=W.tags&&(0,a.coalesce)(W.tags.map(r.to)),be}ne.to=te})(i=e.Diagnostic||(e.Diagnostic={}));var p;(function(ne){function ge(W){return{...f.from(W.location.range),message:W.message,resource:W.location.uri}}ne.from=ge;function te(W){return new b.DiagnosticRelatedInformation(new b.Location(W.resource,f.to(W)),W.message)}ne.to=te})(p=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(ne){function ge(W){switch(W){case b.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ne.from=ge;function te(W){switch(W){case d.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ne.to=te})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(ne){function ge(W){return typeof W=="number"&&W>=b.ViewColumn.One?W-1:W===b.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}ne.from=ge;function te(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=te})(o=e.ViewColumn||(e.ViewColumn={}));function v(ne){return typeof ne.range!="undefined"}function c(ne){return ne.length===0?!0:!!v(ne[0])}e.isDecorationOptionsArr=c;var E;(function(ne){function ge(Le){return Le.map(ne.from)}ne.fromMany=ge;function te(Le){return Le&&typeof Le=="object"&&typeof Le.language=="string"&&typeof Le.value=="string"}function W(Le){let dt;if(te(Le)){const{language:ht,value:vt}=Le;dt={value:"```"+ht+`
`+vt+"\n```\n"}}else b.MarkdownString.isMarkdownString(Le)?dt={value:Le.value,isTrusted:Le.isTrusted,supportThemeIcons:Le.supportThemeIcons,supportHtml:Le.supportHtml}:typeof Le=="string"?dt={value:Le}:dt={value:""};const bt=Object.create(null);dt.uris=bt;const Ct=ht=>{try{let vt=C.URI.parse(ht,!0);vt=vt.with({query:be(vt.query,bt)}),bt[ht]=vt}catch(vt){}return""},pt=new T.Renderer;return pt.link=Ct,pt.image=ht=>Ct(w.parseHrefAndDimensions(ht).href),T(dt.value,{renderer:pt}),dt}ne.from=W;function be(Le,dt){if(!Le)return Le;let bt;try{bt=(0,t.parse)(Le)}catch(pt){}if(!bt)return Le;let Ct=!1;return bt=(0,A.cloneAndChange)(bt,pt=>{if(C.URI.isUri(pt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ht]=pt,Ct=!0,ht}else return}),Ct?JSON.stringify(bt):Le}function ke(Le){const dt=new b.MarkdownString(Le.value,Le.supportThemeIcons);return dt.isTrusted=Le.isTrusted,dt.supportHtml=Le.supportHtml,dt}ne.to=ke;function qe(Le){if(!!Le)return typeof Le=="string"?Le:ne.from(Le)}ne.fromStrict=qe})(E=e.MarkdownString||(e.MarkdownString={}));function I(ne){return c(ne)?ne.map(ge=>({range:f.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?E.fromMany(ge.hoverMessage):ge.hoverMessage?E.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):ne.map(ge=>({range:f.from(ge)}))}e.fromRangeOrRangeWithMessage=I;function D(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?C.URI.file(ne):ne}e.pathOrURIToURI=D;var B;(function(ne){function ge(te){return typeof te=="undefined"?te:{contentText:te.contentText,contentIconPath:te.contentIconPath?D(te.contentIconPath):void 0,border:te.border,borderColor:te.borderColor,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,color:te.color,backgroundColor:te.backgroundColor,margin:te.margin,width:te.width,height:te.height}}ne.from=ge})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(ne){function ge(te){return typeof te=="undefined"?te:{backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?D(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?B.from(te.before):void 0,after:te.after?B.from(te.after):void 0}}ne.from=ge})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var y;(function(ne){function ge(te){if(typeof te=="undefined")return te;switch(te){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=ge})(y=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ne){function ge(te){return{isWholeLine:te.isWholeLine,rangeBehavior:te.rangeBehavior?y.from(te.rangeBehavior):void 0,overviewRulerLane:te.overviewRulerLane,light:te.light?L.from(te.light):void 0,dark:te.dark?L.from(te.dark):void 0,backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?D(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?B.from(te.before):void 0,after:te.after?B.from(te.after):void 0}}ne.from=ge})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ne){function ge(W){return{text:W.newText,eol:W.newEol&&De.from(W.newEol),range:f.from(W.range)}}ne.from=ge;function te(W){const be=new b.TextEdit(f.to(W.range),W.text);return be.newEol=typeof W.eol=="undefined"?void 0:De.to(W.eol),be}ne.to=te})(N=e.TextEdit||(e.TextEdit={}));var z;(function(ne){function ge(W,be,ke){const qe={edits:[]};if(W instanceof b.WorkspaceEdit)for(let Le of W._allEntries())if(Le._type===1)qe.edits.push({_type:1,oldUri:Le.from,newUri:Le.to,options:Le.options,metadata:Le.metadata});else if(Le._type===2){const dt=be?.getDocument(Le.uri);qe.edits.push({_type:2,resource:Le.uri,edit:N.from(Le.edit),modelVersionId:dt?.version,metadata:Le.metadata})}else Le._type===3?qe.edits.push({_type:3,metadata:Le.metadata,resource:Le.uri,edit:Le.edit,notebookMetadata:Le.notebookMetadata,notebookVersionId:ke?.getNotebookDocument(Le.uri,!0)?.apiNotebook.version}):Le._type===5&&qe.edits.push({_type:3,metadata:Le.metadata,resource:Le.uri,notebookVersionId:ke?.getNotebookDocument(Le.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Le.index,count:Le.count,cells:Le.cells.map(et.from)}});return qe}ne.from=ge;function te(W){const be=new b.WorkspaceEdit;for(const ke of W.edits)ke.edit?be.replace(C.URI.revive(ke.resource),f.to(ke.edit.range),ke.edit.text):be.renameFile(C.URI.revive(ke.oldUri),C.URI.revive(ke.newUri),ke.options);return be}ne.to=te})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(ne){const ge=Object.create(null);ge[b.SymbolKind.File]=0,ge[b.SymbolKind.Module]=1,ge[b.SymbolKind.Namespace]=2,ge[b.SymbolKind.Package]=3,ge[b.SymbolKind.Class]=4,ge[b.SymbolKind.Method]=5,ge[b.SymbolKind.Property]=6,ge[b.SymbolKind.Field]=7,ge[b.SymbolKind.Constructor]=8,ge[b.SymbolKind.Enum]=9,ge[b.SymbolKind.Interface]=10,ge[b.SymbolKind.Function]=11,ge[b.SymbolKind.Variable]=12,ge[b.SymbolKind.Constant]=13,ge[b.SymbolKind.String]=14,ge[b.SymbolKind.Number]=15,ge[b.SymbolKind.Boolean]=16,ge[b.SymbolKind.Array]=17,ge[b.SymbolKind.Object]=18,ge[b.SymbolKind.Key]=19,ge[b.SymbolKind.Null]=20,ge[b.SymbolKind.EnumMember]=21,ge[b.SymbolKind.Struct]=22,ge[b.SymbolKind.Event]=23,ge[b.SymbolKind.Operator]=24,ge[b.SymbolKind.TypeParameter]=25;function te(be){return typeof ge[be]=="number"?ge[be]:6}ne.from=te;function W(be){for(const ke in ge)if(ge[ke]===be)return Number(ke);return b.SymbolKind.Property}ne.to=W})(H=e.SymbolKind||(e.SymbolKind={}));var q;(function(ne){function ge(W){switch(W){case b.SymbolTag.Deprecated:return 1}}ne.from=ge;function te(W){switch(W){case 1:return b.SymbolTag.Deprecated}}ne.to=te})(q=e.SymbolTag||(e.SymbolTag={}));var ue;(function(ne){function ge(W){return{name:W.name,kind:H.from(W.kind),tags:W.tags&&W.tags.map(q.from),containerName:W.containerName,location:ie.from(W.location)}}ne.from=ge;function te(W){const be=new b.SymbolInformation(W.name,H.to(W.kind),W.containerName,ie.to(W.location));return be.tags=W.tags&&W.tags.map(q.to),be}ne.to=te})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(ne){function ge(W){const be={name:W.name||"!!MISSING: name!!",detail:W.detail,range:f.from(W.range),selectionRange:f.from(W.selectionRange),kind:H.from(W.kind),tags:W.tags?.map(q.from)??[]};return W.children&&(be.children=W.children.map(ge)),be}ne.from=ge;function te(W){const be=new b.DocumentSymbol(W.name,W.detail,H.to(W.kind),f.to(W.range),f.to(W.selectionRange));return(0,a.isNonEmptyArray)(W.tags)&&(be.tags=W.tags.map(q.to)),W.children&&(be.children=W.children.map(te)),be}ne.to=te})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var ce;(function(ne){function ge(W){const be=new b.CallHierarchyItem(H.to(W.kind),W.name,W.detail||"",C.URI.revive(W.uri),f.to(W.range),f.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=ge;function te(W,be,ke){if(be=be??W._sessionId,ke=ke??W._itemId,be===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:ke,name:W.name,detail:W.detail,kind:H.from(W.kind),uri:W.uri,range:f.from(W.range),selectionRange:f.from(W.selectionRange),tags:W.tags?.map(q.from)}}ne.from=te})(ce=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(ne){function ge(te){return new b.CallHierarchyIncomingCall(ce.to(te.from),te.fromRanges.map(W=>f.to(W)))}ne.to=ge})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(ne){function ge(te){return new b.CallHierarchyOutgoingCall(ce.to(te.to),te.fromRanges.map(W=>f.to(W)))}ne.to=ge})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ie;(function(ne){function ge(W){return{range:W.range&&f.from(W.range),uri:W.uri}}ne.from=ge;function te(W){return new b.Location(C.URI.revive(W.uri),f.to(W.range))}ne.to=te})(ie=e.location||(e.location={}));var we;(function(ne){function ge(W){const be=W,ke=W;return{originSelectionRange:be.originSelectionRange?f.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:ke.uri,range:f.from(be.targetRange?be.targetRange:ke.range),targetSelectionRange:be.targetSelectionRange?f.from(be.targetSelectionRange):void 0}}ne.from=ge;function te(W){return{targetUri:C.URI.revive(W.uri),targetRange:f.to(W.range),targetSelectionRange:W.targetSelectionRange?f.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?f.to(W.originSelectionRange):void 0}}ne.to=te})(we=e.DefinitionLink||(e.DefinitionLink={}));var Me;(function(ne){function ge(W){return{range:f.from(W.range),contents:E.fromMany(W.contents)}}ne.from=ge;function te(W){return new b.Hover(W.contents.map(E.to),f.to(W.range))}ne.to=te})(Me=e.Hover||(e.Hover={}));var Fe;(function(ne){function ge(W){return{range:f.from(W.range),expression:W.expression}}ne.from=ge;function te(W){return new b.EvaluatableExpression(f.to(W.range),W.expression)}ne.to=te})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Be;(function(ne){function ge(W){if(W instanceof b.InlineValueText)return{type:"text",range:f.from(W.range),text:W.text};if(W instanceof b.InlineValueVariableLookup)return{type:"variable",range:f.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:f.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=ge;function te(W){switch(W.type){case"text":return{range:f.to(W.range),text:W.text};case"variable":return{range:f.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:f.to(W.range),expression:W.expression}}}ne.to=te})(Be=e.InlineValue||(e.InlineValue={}));var Ke;(function(ne){function ge(W){return{frameId:W.frameId,stoppedLocation:f.from(W.stoppedLocation)}}ne.from=ge;function te(W){return new b.InlineValueContext(W.frameId,f.to(W.stoppedLocation))}ne.to=te})(Ke=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(ne){function ge(W){return{range:f.from(W.range),kind:W.kind}}ne.from=ge;function te(W){return new b.DocumentHighlight(f.to(W.range),W.kind)}ne.to=te})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var Qe;(function(ne){function ge(te){switch(te){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ne.to=ge})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $;(function(ne){function ge(te){return{triggerKind:Qe.to(te.triggerKind),triggerCharacter:te.triggerCharacter}}ne.to=ge})($=e.CompletionContext||(e.CompletionContext={}));var K;(function(ne){function ge(W){switch(W){case b.CompletionItemTag.Deprecated:return 1}}ne.from=ge;function te(W){switch(W){case 1:return b.CompletionItemTag.Deprecated}}ne.to=te})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(ne){const ge=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function te(ke){return ge.get(ke)??9}ne.from=te;const W=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function be(ke){return W.get(ke)??b.CompletionItemKind.Property}ne.to=be})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(ne){function ge(te,W){const be=new b.CompletionItem(te.label);return be.insertText=te.insertText,be.kind=X.to(te.kind),be.tags=te.tags?.map(K.to),be.detail=te.detail,be.documentation=w.isMarkdownString(te.documentation)?E.to(te.documentation):te.documentation,be.sortText=te.sortText,be.filterText=te.filterText,be.preselect=te.preselect,be.commitCharacters=te.commitCharacters,R.Range.isIRange(te.range)?be.range=f.to(te.range):typeof te.range=="object"&&(be.range={inserting:f.to(te.range.insert),replacing:f.to(te.range.replace)}),be.keepWhitespace=typeof te.insertTextRules=="undefined"?!1:Boolean(te.insertTextRules&1),typeof te.insertTextRules!="undefined"&&te.insertTextRules&4?be.insertText=new b.SnippetString(te.insertText):(be.insertText=te.insertText,be.textEdit=be.range instanceof b.Range?new b.TextEdit(be.range,be.insertText):void 0),te.additionalTextEdits&&te.additionalTextEdits.length>0&&(be.additionalTextEdits=te.additionalTextEdits.map(ke=>N.to(ke))),be.command=W&&te.command?W.fromInternal(te.command):void 0,be}ne.to=ge})(se=e.CompletionItem||(e.CompletionItem={}));var j;(function(ne){function ge(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0}}ne.from=ge;function te(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation}}ne.to=te})(j=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(ne){function ge(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(j.from):[],activeParameter:W.activeParameter}}ne.from=ge;function te(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(j.to):[],activeParameter:W.activeParameter}}ne.to=te})(Z=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(ne){function ge(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(Z.from):[]}}ne.from=ge;function te(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(Z.to):[]}}ne.to=te})(fe=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(ne){function ge(W){return{text:W.text,position:l.from(W.position),kind:Ne.from(W.kind??b.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}ne.from=ge;function te(W){const be=new b.InlayHint(W.text,l.to(W.position),Ne.to(W.kind));return be.whitespaceAfter=W.whitespaceAfter,be.whitespaceBefore=W.whitespaceBefore,be}ne.to=te})(Te=e.InlayHint||(e.InlayHint={}));var Ne;(function(ne){function ge(W){return W}ne.from=ge;function te(W){return W}ne.to=te})(Ne=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(ne){function ge(W){return{range:f.from(W.range),url:W.target,tooltip:W.tooltip}}ne.from=ge;function te(W){let be;if(W.url)try{be=typeof W.url=="string"?C.URI.parse(W.url,!0):C.URI.revive(W.url)}catch(ke){}return new b.DocumentLink(f.to(W.range),be)}ne.to=te})(He=e.DocumentLink||(e.DocumentLink={}));var Ge;(function(ne){function ge(W){const be=new b.ColorPresentation(W.label);return W.textEdit&&(be.textEdit=N.to(W.textEdit)),W.additionalTextEdits&&(be.additionalTextEdits=W.additionalTextEdits.map(ke=>N.to(ke))),be}ne.to=ge;function te(W){return{label:W.label,textEdit:W.textEdit?N.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(be=>N.from(be)):void 0}}ne.from=te})(Ge=e.ColorPresentation||(e.ColorPresentation={}));var tt;(function(ne){function ge(W){return new b.Color(W[0],W[1],W[2],W[3])}ne.to=ge;function te(W){return[W.red,W.green,W.blue,W.alpha]}ne.from=te})(tt=e.Color||(e.Color={}));var st;(function(ne){function ge(W){return{range:f.from(W.range)}}ne.from=ge;function te(W){return new b.SelectionRange(f.to(W.range))}ne.to=te})(st=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(ne){function ge(te){switch(te){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ne.to=ge})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var rt;(function(ne){function ge(W){switch(W){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=ge;function te(W){switch(W){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ne.to=te})(rt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(ne){function ge(W){if(W===b.EndOfLine.CRLF)return 1;if(W===b.EndOfLine.LF)return 0}ne.from=ge;function te(W){if(W===1)return b.EndOfLine.CRLF;if(W===0)return b.EndOfLine.LF}ne.to=te})(De=e.EndOfLine||(e.EndOfLine={}));var gt;(function(ne){function ge(te){if(typeof te=="object")return te.viewId;switch(te){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=ge})(gt=e.ProgressLocation||(e.ProgressLocation={}));var V;(function(ne){function ge(te){const W={start:te.start+1,end:te.end+1};return te.kind&&(W.kind=J.from(te.kind)),W}ne.from=ge})(V=e.FoldingRange||(e.FoldingRange={}));var J;(function(ne){function ge(te){if(te)switch(te){case b.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ne.from=ge})(J=e.FoldingRangeKind||(e.FoldingRangeKind={}));var pe;(function(ne){function ge(te){if(te)return{pinned:typeof te.preview=="boolean"?!te.preview:void 0,inactive:te.background,preserveFocus:te.preserveFocus,selection:typeof te.selection=="object"?f.from(te.selection):void 0,override:typeof te.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=ge})(pe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ue;(function(ne){function ge(W){return W instanceof b.RelativePattern||typeof W=="string"?W:te(W)?new b.RelativePattern(W.base,W.pattern):W}ne.from=ge;function te(W){const be=W;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(Ue=e.GlobPattern||(e.GlobPattern={}));var Ye;(function(ne){function ge(te){if(te){if(Array.isArray(te))return te.map(ge);if(typeof te=="string")return te;{const W=te;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:Ue.from(W.pattern),exclusive:W.exclusive}}}else return}ne.from=ge})(Ye=e.LanguageSelector||(e.LanguageSelector={}));var Je;(function(ne){function ge(W){return{start:W.start,end:W.end}}ne.from=ge;function te(W){return new b.NotebookRange(W.start,W.end)}ne.to=te})(Je=e.NotebookRange||(e.NotebookRange={}));var lt;(function(ne){function ge(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ne.to=ge;function te(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ne.from=te})(lt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Et;(function(ne){function ge(W){switch(W){case b.NotebookCellKind.Markup:return u.CellKind.Markup;case b.NotebookCellKind.Code:default:return u.CellKind.Code}}ne.from=ge;function te(W){switch(W){case u.CellKind.Markup:return b.NotebookCellKind.Markup;case u.CellKind.Code:default:return b.NotebookCellKind.Code}}ne.to=te})(Et=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(ne){function ge(W){const be={metadata:W.metadata??Object.create(null),cells:[]};for(let ke of W.cells)b.NotebookCellData.validate(ke),be.cells.push(et.from(ke));return be}ne.from=ge;function te(W){const be=new b.NotebookData(W.cells.map(et.to));return(0,S.isEmptyObject)(W.metadata)||(be.metadata=W.metadata),be}ne.to=te})(It=e.NotebookData||(e.NotebookData={}));var et;(function(ne){function ge(W){return{cellKind:Et.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:lt.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Pe.from):[]}}ne.from=ge;function te(W){return new b.NotebookCellData(Et.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Pe.to):void 0,W.metadata,W.internalMetadata?lt.to(W.internalMetadata):void 0)}ne.to=te})(et=e.NotebookCellData||(e.NotebookCellData={}));var Tt;(function(ne){function ge(W){return{mime:W.mime,valueBytes:F.VSBuffer.wrap(W.data)}}ne.from=ge;function te(W){return new b.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ne.to=te})(Tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(ne){function ge(W){return{outputId:W.id,items:W.items.map(Tt.from),metadata:W.metadata}}ne.from=ge;function te(W){const be=W.items.map(Tt.to);return new b.NotebookCellOutput(be,W.outputId,W.metadata)}ne.to=te})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(ne){function ge(ke){if(ke!=null){if(ke instanceof b.RelativePattern||typeof ke=="string")return ke;if(be(ke))return new b.RelativePattern(ke.base,ke.pattern);if(W(ke))return{include:Ue.from(ke.include)||void 0,exclude:Ue.from(ke.exclude)||void 0}}}ne.from=ge;function te(ke){return typeof ke=="string"?ke:be(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}ne.to=te;function W(ke){const qe=ke,Le=Ue.from(qe.include);if(!(Le&&Le instanceof b.RelativePattern||typeof Le=="string"))return!1;const dt=Ue.from(qe.exclude);return!!(dt&&dt instanceof b.RelativePattern||typeof dt=="string")}function be(ke){const qe=ke;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ve;(function(ne){function ge(te){return{backgroundColor:te.backgroundColor,borderColor:te.borderColor,top:te.top?B.from(te.top):void 0}}ne.from=ge})(ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var re;(function(ne){function ge(te,W,be){const ke=typeof te.command=="string"?{title:"",command:te.command}:te.command;return{alignment:te.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(ke,be),text:te.text,tooltip:te.tooltip,accessibilityInformation:te.accessibilityInformation,priority:te.priority}}ne.from=ge})(re=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ae;(function(ne){function ge(te){return{transientOutputs:te?.transientOutputs??!1,transientCellMetadata:te?.transientCellMetadata??{},transientDocumentMetadata:te?.transientDocumentMetadata??{}}}ne.from=ge})(ae=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var he;(function(ne){function ge(W){return{uri:W.uri,provides:W.provides}}ne.from=ge;function te(W){return new b.NotebookRendererScript(C.URI.revive(W.uri),W.provides)}ne.to=te})(he=e.NotebookRendererScript||(e.NotebookRendererScript={}));var me;(function(ne){function ge(W){return{message:E.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ie.from(W.location):void 0}}ne.from=ge;function te(W){const be=new b.TestMessage(typeof W.message=="string"?W.message:E.to(W.message));return be.actualOutput=W.actual,be.expectedOutput=W.expected,be.location=W.location?ie.to(W.location):void 0,be}ne.to=te})(me=e.TestMessage||(e.TestMessage={}));var Ie;(function(ne){let ge;(function(te){te.Delimiter="\0"})(ge||(ge={})),ne.namespace=(te,W)=>te+"\0"+W,ne.denamespace=te=>{const W=te.indexOf("\0");return{ctrlId:te.slice(0,W),tagId:te.slice(W+1)}}})(Ie=e.TestTag||(e.TestTag={}));var ze;(function(ne){function ge(ke){const qe=(0,s.getPrivateApiFor)(ke).controllerId;return{extId:g.TestId.fromExtHostTestItem(ke,qe).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map(Le=>Ie.namespace(qe,Le.id)),range:f.from(ke.range)||null,description:ke.description||null,error:ke.error&&E.fromStrict(ke.error)||null}}ne.from=ge;function te(ke){return{parent:void 0,error:void 0,id:g.TestId.fromString(ke.extId).localId,label:ke.label,uri:C.URI.revive(ke.uri),tags:(ke.tags||[]).map(qe=>{const{tagId:Le}=Ie.denamespace(qe);return new b.TestTag(Le)}),range:f.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}ne.toPlain=te;function W(ke){const qe=g.TestId.fromString(ke.extId),Le=new s.TestItemImpl(qe.controllerId,qe.localId,ke.label,C.URI.revive(ke.uri));return Le.range=f.to(ke.range||void 0),Le.description=ke.description||void 0,Le}function be(ke){let qe;for(const Le of ke.tests){const dt=W(Le.item);(0,s.getPrivateApiFor)(dt).parent=qe,qe=dt}return qe}ne.toItemFromContext=be})(ze=e.TestItem||(e.TestItem={})),function(ne){function ge(W){return{id:W.id}}ne.from=ge;function te(W){return new b.TestTag(W.id)}ne.to=te}(Ie=e.TestTag||(e.TestTag={}));var Oe;(function(ne){const ge=(W,be)=>{const ke={...ze.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(Le=>Le.type===0).map(me.to)})),children:W.children.map(qe=>be.get(qe)).filter(S.isDefined).map(qe=>ge(qe,be))};for(const qe of ke.children)qe.parent=ke;return ke};function te(W){const be=[],ke=new Map;for(const qe of W.items)ke.set(qe.item.extId,qe),W.request.targets.some(Le=>Le.controllerId===qe.controllerId&&Le.testIds.includes(qe.item.extId))&&be.push(qe);return{completedAt:W.completedAt,results:be.map(qe=>ge(qe,ke))}}ne.to=te})(Oe=e.TestResults||(e.TestResults={}));var We;(function(ne){function ge(ke){return{covered:ke.covered,total:ke.covered}}function te(ke){return"line"in ke?l.from(ke):f.from(ke)}function W(ke){return"branches"in ke?{count:ke.executionCount,location:te(ke.location),type:1,branches:ke.branches.length?ke.branches.map(qe=>({count:qe.executionCount,location:qe.location&&te(qe.location)})):void 0}:{type:0,count:ke.executionCount,location:te(ke.location)}}ne.fromDetailed=W;function be(ke){return{uri:ke.uri,statement:ge(ke.statementCoverage),branch:ke.branchCoverage&&ge(ke.branchCoverage),function:ke.functionCoverage&&ge(ke.functionCoverage),details:ke.detailedCoverage?.map(W)}}ne.fromFile=be})(We=e.TestCoverage||(e.TestCoverage={}));var it;(function(ne){function ge(te){switch(te){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ne.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ot;(function(ne){function ge(W){const be=new b.TypeHierarchyItem(H.to(W.kind),W.name,W.detail||"",C.URI.revive(W.uri),f.to(W.range),f.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=ge;function te(W,be,ke){if(be=be??W._sessionId,ke=ke??W._itemId,be===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:ke,kind:H.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:f.from(W.range),selectionRange:f.from(W.selectionRange),tags:W.tags?.map(q.from)}}ne.from=te})(ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[165],_e([0,1,2,15,7,8,226]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(C,R,_,n={timeout:1500,errors:3}){this._logService=C,this._documents=R,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new t.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(R,_,n)=>{const s={dispose:this._callbacks.push([R,_,C])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(C,R){const _=a.URI.revive(C);let n=!1;const d=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let u of[...this._callbacks]){if(n)break;const g=this._documents.getDocument(_),k=await this._deliverEventAsyncAndBlameBadListeners(u,{document:g,reason:T.TextDocumentSaveReason.to(R)});s.push(k)}}finally{clearTimeout(d)}return s}_deliverEventAsyncAndBlameBadListeners([C,R,_],n){const d=this._badListeners.get(C);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,C,R,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const u=this._badListeners.get(C);this._badListeners.set(C,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,R,_,n){const d=[],s=Date.now(),{document:u,reason:g}=n,{version:k}=u,b=Object.freeze({document:u,reason:g,waitUntil(m){if(Object.isFrozen(d))throw(0,F.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(m))}});try{R.apply(_,[b])}catch(m){return Promise.reject(m)}return Object.freeze(d),new Promise((m,f)=>{const P=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(P),m(l)}).catch(l=>{clearTimeout(P),f(l)})}).then(m=>{const f={edits:[]};for(const P of m)if(Array.isArray(P)&&P.every(l=>l instanceof w.TextEdit))for(const{newText:l,newEol:M,range:r}of P)f.edits.push({_type:2,resource:u.uri,edit:{range:r&&T.Range.from(r),text:l,eol:M&&T.EndOfLine.from(M)}});if(f.edits.length!==0)return k===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ee[166],_e([0,1,3,29,2,8,7]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class A{constructor(R,_,n,d,s){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter,this._config=0,n&&(this._config+=1),d&&(this._config+=2),s&&(this._config+=4);const u=(0,F.parse)(_),g=R(k=>{if(!n)for(let b of k.created){const m=w.URI.revive(b);u(m.fsPath)&&this._onDidCreate.fire(m)}if(!d)for(let b of k.changed){const m=w.URI.revive(b);u(m.fsPath)&&this._onDidChange.fire(m)}if(!s)for(let b of k.deleted){const m=w.URI.revive(b);u(m.fsPath)&&this._onDidDelete.fire(m)}});this._disposable=t.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(R,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(R,_,n,d){return new A(this._onFileSystemEvent.event,R,_,n,d)}$onFileEvent(R){this._onFileSystemEvent.fire(R)}$onDidRunFileOperation(R,_){switch(R){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:w.URI.revive(n.source),newUri:w.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(R){return this._createWillExecuteEvent(R,this._onWillRenameFile)}getOnWillCreateFileEvent(R){return this._createWillExecuteEvent(R,this._onWillCreateFile)}getOnWillDeleteFileEvent(R){return this._createWillExecuteEvent(R,this._onWillDeleteFile)}_createWillExecuteEvent(R,_){return(n,d,s)=>{const u=function(k){n.call(d,k)};return u.extension=R,_.event(u,void 0,s)}}async $onWillRunFileOperation(R,_,n,d){switch(R){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(s=>({oldUri:w.URI.revive(s.source),newUri:w.URI.revive(s.target)}))},n,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(s=>w.URI.revive(s.target))},n,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(s=>w.URI.revive(s.target))},n,d)}}async _fireWillEvent(R,_,n,d){const s=new Set,u=[];if(await R.fireAsync(_,d,async(k,b)=>{const m=Date.now(),f=await Promise.resolve(k);f instanceof t.WorkspaceEdit&&(u.push(f),s.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-m>n&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),d.isCancellationRequested||u.length===0)return;const g={edits:[]};for(let k of u){let{edits:b}=T.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(b)}return{edit:g,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=S}),define(Ee[167],_e([0,1,10,27,2,8,7,87]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,d,s,u){this.start=n,this.deletedCount=d,this.deletedItems=s,this.items=u}static asApiEvents(n){return n.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(s=>s.apiCell)}))}}class C{constructor(n,d,s){this.notebook=n,this._extHostDocument=d,this._cellData=s,this.handle=s.handle,this.uri=w.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(n,d){return{EOL:d.eol,lines:d.source,languageId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return n._mime},set mime(s){n._mime=s},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(T.NotebookCellOutput.to)}setOutputItems(n,d,s){const u=s.map(T.NotebookCellOutputItem.to),g=this._outputs.find(k=>k.id===n);g&&(d||(g.items.length=0),g.items.push(...u))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=C;class R{constructor(n,d,s,u,g,k){this._proxy=n,this._textDocumentsAndEditors=d,this._textDocuments=s,this._emitter=u,this.uri=g,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=k.viewType,this._metadata=Object.freeze(k.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,k.cells]],!0),this._versionId=k.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===a.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(d){return d=n._validateIndex(d),n._cells[d].apiCell},getCells(d){return(d?n._getCells(d):n._cells).map(u=>u.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,d){this._versionId=n.versionId,this._isDirty=d;for(const s of n.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===A.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===A.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===A.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===A.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(s.index,s.metadata):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(s.index,s.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let d=n.start|0,s=n.end|0;return d<0&&(d=0),s>this._cells.length&&(s=this._cells.length),n.with({start:d,end:s})}_getCells(n){n=this._validateRange(n);const d=[];for(let s=n.start;s<n.end;s++)d.push(this._cells[s]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,d){if(this._disposed)return;const s=[],u=[],g=[];n.reverse().forEach(k=>{const m=k[2].map(l=>{const M=new C(this,this._textDocumentsAndEditors,l);return d||u.push(C.asModelAddData(this.apiNotebook,l)),M}),f=new S(k[0],k[1],[],m),P=this._cells.splice(k[0],k[1],...m);for(const l of P)g.push(l.uri),f.deletedItems.push(l.apiCell);s.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:g}),d||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(s)}))}_moveCell(n,d){const s=this._cells.splice(n,1);this._cells.splice(d,0,...s);const u=[new S(n,1,s.map(g=>g.apiCell),[]),new S(d,0,[],s)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(u)}))}_setCellOutputs(n,d){const s=this._cells[n];s.setOutputs(d),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(n,d,s,u){const g=this._cells[n];g.setOutputItems(d,s,u),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(n,d){const s=this._cells[n];s.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(s.uri,d)}_changeCellMime(n,d){const s=this._cells[n];s.apiCell.mime=d}_changeCellMetadata(n,d){const s=this._cells[n],u=s.apiCell.metadata;s.setMetadata(d);const g=s.apiCell.metadata;(0,F.equals)(u,g)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(n,d){const s=this._cells[n],u=s.internalMetadata;if(s.setInternalMetadata(d),u.runState!==d.runState){const g=d.runState??t.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:s.apiCell,state:g}))}}getCellFromApiCell(n){return this._cells.find(d=>d.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(d=>d.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(Ee[91],_e([0,1,7,8,15]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:C})}replaceCells(S,C,R){this._throwIfFinalized(),!(S===C&&R.length===0)&&this._collectedEdits.push({editType:1,index:S,count:C-S,cells:R.map(F.NotebookCellData.from)})}}class t{constructor(S,C,R,_,n,d){this.id=S,this._proxy=C,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=d}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(C){if(!Array.isArray(C)||!C.every(a.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");S._selections=C,S._trySetSelections(C)},get visibleRanges(){return S._visibleRanges},revealRange(C,R){S._proxy.$tryRevealRange(S.id,F.NotebookRange.from(C),R??a.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(C){const R=new T(this.document.version);return C(R),S._applyEdit(R.finalize())},setDecorations(C,R){return S.setDecorations(C,R)}},t.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(F.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const C=[];let R=-1;for(let _=0;_<S.cellEdits.length;_++){if(R<0){C.push(S.cellEdits[_]),R++;continue}const d=C[R],s=S.cellEdits[_];if(d.editType===1&&s.editType===1&&d.index===s.index){d.cells.push(...S.cellEdits[_].cells),d.count+=S.cellEdits[_].count;continue}C.push(S.cellEdits[_]),R++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,C)}setDecorations(S,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return C.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(C),S.key)}}e.ExtHostNotebookEditor=t,t.apiEditorsToExtHost=new WeakMap}),define(Ee[168],_e([0,1,8,140,121,20,51,15]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,d,s){const u=this._handles++,{title:g,location:k,cancellable:b}=d,m={label:(0,w.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(u,{location:a.ProgressLocation.from(k),title:g,source:m,cancellable:b},n).catch(A.onUnexpectedExternalError),this._withProgress(u,s,!!b)}_withProgress(n,d,s){let u;s&&(u=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,u));const g=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),u&&u.dispose()};let k;try{k=d(new R(this._proxy,n),s&&u?u.token:T.CancellationToken.None)}catch(b){throw g(n),b}return k.then(b=>g(n),b=>g(n)),k}$acceptProgressCanceled(n){const d=this._mapHandleToCancellationSource.get(n);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=S;function C(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class R extends F.Progress{constructor(n,d){super(s=>this.throttledReport(s));this._proxy=n,this._handle=d}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}xe([(0,t.throttle)(100,(_,n)=>C(_,n),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ee[92],_e([0,1,41,15,52,8,7]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(n,d,s){const u=A._Keys.nextId();n.$registerTextEditorDecorationType(d.identifier,u,T.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:u,dispose(){n.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=A,A._Keys=new w.IdGenerator("TextEditorDecorationType");class S{constructor(n,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,d){this._throwIfFinalized();let s=null;if(n instanceof t.Position)s=new t.Range(n,n);else if(n instanceof t.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,d,!1)}insert(n,d){this._throwIfFinalized(),this._pushEdit(new t.Range(n,n),d,!0)}delete(n){this._throwIfFinalized();let d=null;if(n instanceof t.Range)d=n;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(n,d,s){const u=this._document.validateRange(n);this._collectedEdits.push({range:u,text:d,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==t.EndOfLine.LF&&n!==t.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class C{constructor(n,d,s,u){this._proxy=n,this._id=d,this._accept(s),this._logService=u;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(k){g._setTabSize(k)},get insertSpaces(){return g._insertSpaces},set insertSpaces(k){g._setInsertSpaces(k)},get cursorStyle(){return g._cursorStyle},set cursorStyle(k){g._setCursorStyle(k)},get lineNumbers(){return g._lineNumbers},set lineNumbers(k){g._setLineNumbers(k)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const d=Math.floor(n);return d>0?d:null}if(typeof n=="string"){const d=parseInt(n,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(n){const d=this._validateTabSize(n);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const d=this._validateInsertSpaces(n);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(n)})))}assign(n){const d={};let s=!1;if(typeof n.tabSize!="undefined"){const u=this._validateTabSize(n.tabSize);u==="auto"?(s=!0,d.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,s=!0,d.tabSize=u)}if(typeof n.insertSpaces!="undefined"){const u=this._validateInsertSpaces(n.insertSpaces);u==="auto"?(s=!0,d.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,s=!0,d.insertSpaces=u)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,d.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,d.lineNumbers=T.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,d))}_warnOnError(n,d){d.catch(s=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(s)})}}e.ExtHostTextEditorOptions=C;class R{constructor(n,d,s,u,g,k,b,m){this.id=n,this._proxy=d,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new C(this._proxy,this.id,k,s),this._visibleRanges=b,this._viewColumn=m;const f=this;this.value=Object.freeze({get document(){return u.getValue()},set document(P){throw(0,F.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(P){if(!(P instanceof t.Selection))throw(0,F.illegalArgument)("selection");f._selections=[P],f._trySetSelection()},get selections(){return f._selections},set selections(P){if(!Array.isArray(P)||P.some(l=>!(l instanceof t.Selection)))throw(0,F.illegalArgument)("selections");f._selections=P,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(P){throw(0,F.readonly)("visibleRanges")},get options(){return f._options.value},set options(P){f._disposed||f._options.assign(P)},get viewColumn(){return f._viewColumn},set viewColumn(P){throw(0,F.readonly)("viewColumn")},edit(P,l={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new S(u.getValue(),l);return P(M),f._applyEdit(M)},insertSnippet(P,l,M={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!l||Array.isArray(l)&&l.length===0)r=f._selections.map(i=>T.Range.from(i));else if(l instanceof t.Position){const{lineNumber:i,column:p}=T.Position.from(l);r=[{startLineNumber:i,startColumn:p,endLineNumber:i,endColumn:p}]}else if(l instanceof t.Range)r=[T.Range.from(l)];else{r=[];for(const i of l)if(i instanceof t.Range)r.push(T.Range.from(i));else{const{lineNumber:p,column:h}=T.Position.from(i);r.push({startLineNumber:p,startColumn:h,endLineNumber:p,endColumn:h})}}return d.$tryInsertSnippet(n,P.value,r,M)},setDecorations(P,l){const M=l.length===0;M&&!f._hasDecorationsForKey.has(P.key)||(M?f._hasDecorationsForKey.delete(P.key):f._hasDecorationsForKey.add(P.key),f._runOnProxy(()=>{if(T.isDecorationOptionsArr(l))return d.$trySetDecorations(n,P.key,T.fromRangeOrRangeWithMessage(l));{const r=new Array(4*l.length);for(let i=0,p=l.length;i<p;i++){const h=l[i];r[4*i]=h.start.line+1,r[4*i+1]=h.start.character+1,r[4*i+2]=h.end.line+1,r[4*i+3]=h.end.character+1}return d.$trySetDecorationsFast(n,P.key,r)}}))},revealRange(P,l){f._runOnProxy(()=>d.$tryRevealRange(n,T.Range.from(P),l||t.TextEditorRevealType.Default))},show(P){d.$tryShowEditor(n,T.ViewColumn.from(P))},hide(){d.$tryHideEditor(n)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,a.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,a.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,a.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,a.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const d=n.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const s=d.edits.map(g=>g.range);s.sort((g,k)=>g.end.line===k.end.line?g.end.character===k.end.character?g.start.line===k.start.line?g.start.character-k.start.character:g.start.line-k.start.line:g.end.character-k.end.character:g.end.line-k.end.line);for(let g=0,k=s.length-1;g<k;g++){const b=s[g].end;if(s[g+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=d.edits.map(g=>({range:T.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,u,{setEndOfLine:typeof d.setEndOfLine=="number"?T.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=R}),define(Ee[169],_e([0,1,124,24,2,3,6,14,7,11,16,8,20,153]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function s(k,b){if((0,C.isString)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let m;return Array.isArray(k.highlights)&&(m=k.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),m=m.length?m:void 0),{label:k.label,highlights:m}}}class u{constructor(b,m,f){this._proxy=b,this.commands=m,this.logService=f,this.treeViews=new Map;function P(l){return l&&l.$treeViewId&&l.$treeItemHandle}m.registerArgumentProcessor({processArgument:l=>P(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(M=>P(M)?this.convertArgument(M):M):l})}registerTreeDataProvider(b,m,f){const P=this.createTreeView(b,{treeDataProvider:m},f);return{dispose:()=>P.dispose()}}createTreeView(b,m,f){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const P=m.dragAndDropController?.supportedMimeTypes,l=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dragAndDropMimeTypes:P}),M=this.createExtHostTreeView(b,m,f);return{get onDidCollapseElement(){return M.onDidCollapseElement},get onDidExpandElement(){return M.onDidExpandElement},get selection(){return M.selectedElements},get onDidChangeSelection(){return M.onDidChangeSelection},get visible(){return M.visible},get onDidChangeVisibility(){return M.onDidChangeVisibility},get message(){return M.message},set message(r){M.message=r},get title(){return M.title},set title(r){M.title=r},get description(){return M.description},set description(r){M.description=r},reveal:(r,i)=>M.reveal(r,i),dispose:async()=>{await l,this.treeViews.delete(b),M.dispose()}}}$getChildren(b,m){const f=this.treeViews.get(b);return f?f.getChildren(m):Promise.reject(new Error((0,a.localize)(0,null,b)))}async $onDrop(b,m,f,P,l){const M=this.treeViews.get(b);if(!M)return Promise.reject(new Error((0,a.localize)(1,null,b)));const r=d.TreeDataTransferConverter.toITreeDataTransfer(m);if(P===b&&l){const i=await M.onWillDrop(l);i&&i.forEach((p,h)=>{p&&r.set(h,p)})}return M.onDrop(r,f)}async $hasResolve(b){const m=this.treeViews.get(b);if(!m)throw new Error((0,a.localize)(2,null,b));return m.hasResolve}$resolve(b,m,f){const P=this.treeViews.get(b);if(!P)throw new Error((0,a.localize)(3,null,b));return P.resolveTreeItem(m,f)}$setExpanded(b,m,f){const P=this.treeViews.get(b);if(!P)throw new Error((0,a.localize)(4,null,b));P.setExpanded(m,f)}$setSelection(b,m){const f=this.treeViews.get(b);if(!f)throw new Error((0,a.localize)(5,null,b));f.setSelection(m)}$setVisible(b,m){const f=this.treeViews.get(b);if(!f)throw new Error((0,a.localize)(6,null,b));f.setVisible(m)}createExtHostTreeView(b,m,f){const P=new g(b,m,this._proxy,this.commands.converter,this.logService,f);return this.treeViews.set(b,P),P}convertArgument(b){const m=this.treeViews.get(b.$treeViewId);return m?m.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=u;class g extends t.Disposable{constructor(b,m,f,P,l,M){super();if(this.viewId=b,this.proxy=f,this.commands=P,this.logService=l,this.extension=M,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,M.contributes&&M.contributes.views)for(const p in M.contributes.views)for(const h of M.contributes.views[p])h.id===b&&(this._title=h.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(p=>this._onDidChangeData.fire({message:!1,element:p}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>this._onDidChangeData.fire({message:!1,element:p})));let r,i;this._register(T.Event.debounce(this._onDidChangeData.event,(p,h)=>(p||(p={message:!1,elements:[]}),h.element!==!1&&(r||(r=new Promise(o=>i=o),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(h.element)?p.elements.push(...h.element):p.elements.push(h.element)),h.message&&(p.message=!0),p),200,!0)(({message:p,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const o=i;return r=null,this.refresh(h).then(()=>o())})),p&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,C.isUndefinedOrNull)(b))}async getChildren(b){const m=b?this.getExtensionElement(b):void 0;if(b&&!m)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let f=this.getChildrenNodes(b);return f||(f=await this.fetchChildrenNodes(m)),f?f.map(P=>P.item):void 0}getExtensionElement(b){return this.elements.get(b)}reveal(b,m){m=m||{select:!0,focus:!1};const f=(0,C.isUndefinedOrNull)(m.select)?!0:m.select,P=(0,C.isUndefinedOrNull)(m.focus)?!1:m.focus,l=(0,C.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(M=>this.resolveTreeNode(b,M[M.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:M.map(i=>i.item)},{select:f,focus:P,expand:l})),M=>this.logService.error(M)):this.proxy.$reveal(this.viewId,void 0,{select:f,focus:P,expand:l})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,m){const f=this.getExtensionElement(b);f&&(m?this._onDidExpandElement.fire(Object.freeze({element:f})):this._onDidCollapseElement.fire(Object.freeze({element:f})))}setSelection(b){(0,R.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(b){const m=[];for(const f of b){const P=this.getExtensionElement(f);P&&m.push(P)}if(!(!this.dndController?.onWillDrop||m.length===0))return this.dndController.onWillDrop(m)}async onDrop(b,m){const f=this.getExtensionElement(m);if(!!f)return(0,A.asPromise)(()=>this.dndController?.onDrop(b,f))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,m){if(!this.dataProvider.resolveTreeItem)return;const f=this.elements.get(b);if(f){const P=this.nodes.get(f);if(P){const l=await this.dataProvider.resolveTreeItem(P.extensionItem,f,m)??P.extensionItem;return P.item.tooltip=this.getTooltip(l.tooltip),P.item.command=this.getCommand(P.disposableStore,l.command),P.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(m=>m?this.resolveUnknownParentChain(m).then(f=>this.resolveTreeNode(m,f[f.length-1]).then(P=>(f.push(P),f))):Promise.resolve([]))}resolveParent(b){const m=this.nodes.get(b);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,m){const f=this.nodes.get(b);return f?Promise.resolve(f):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(P=>this.createHandle(b,P,m,!0)).then(P=>this.getChildren(m?m.item.handle:void 0).then(()=>{const l=this.getExtensionElement(P);if(l){const M=this.nodes.get(l);if(M)return Promise.resolve(M)}throw new Error(`Cannot resolve tree item for element ${P}`)}))}getChildrenNodes(b){if(b){let m;if(typeof b=="string"){const f=this.getExtensionElement(b);m=f?this.nodes.get(f):void 0}else m=b;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const m=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const f=b?this.nodes.get(b):void 0,P=await this.dataProvider.getChildren(b);if(m.token.isCancellationRequested)return;const l=await Promise.all((0,R.coalesce)(P||[]).map(async M=>{const r=await this.dataProvider.getTreeItem(M);return r&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(M,r,f):null}));return m.token.isCancellationRequested?void 0:(0,R.coalesce)(l)}finally{m.dispose()}}refresh(b){if(b.some(f=>!f))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const f=this.getHandlesToRefresh(b);if(f.length)return this.refreshHandles(f)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const m=new Set,f=b.map(l=>this.nodes.get(l));for(const l of f)if(l&&!m.has(l.item.handle)){let M=l;for(;M&&M.parent&&f.findIndex(r=>M&&M.parent&&r&&r.item.handle===M.parent.item.handle)===-1;){const r=this.elements.get(M.parent.item.handle);M=r?this.nodes.get(r):void 0}M&&!M.parent&&m.add(l.item.handle)}const P=[];return m.forEach(l=>{const M=this.elements.get(l);if(M){const r=this.nodes.get(M);r&&(!r.parent||!m.has(r.parent.item.handle))&&P.push(l)}}),P}refreshHandles(b){const m={};return Promise.all(b.map(f=>this.refreshNode(f).then(P=>{P&&(m[f]=P.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(b){const m=this.getExtensionElement(b);if(m){const f=this.nodes.get(m);if(f)return this.clearChildren(m),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(P=>{if(P){const l=this.createTreeNode(m,P,f.parent);return this.updateNodeCache(m,l,f,f.parent),f.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,m,f){const P=this.createTreeNode(b,m,f);if(m.id&&this.elements.has(P.item.handle))throw new Error((0,a.localize)(7,null,m.id));return this.addNodeToCache(b,P),this.addNodeToParentCache(P,f),P}getTooltip(b){return S.MarkdownString.isMarkdownString(b)?_.MarkdownString.from(b):b}getCommand(b,m){return m?this.commands.toInternal(m,b):void 0}createTreeNode(b,m,f){const P=new t.DisposableStore,l=this.createHandle(b,m,f),M=this.getLightIconPath(m);return{item:{handle:l,parentHandle:f?f.item.handle:void 0,label:s(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(P,m.command),contextValue:m.contextValue,icon:M,iconDark:this.getDarkIconPath(m)||M,themeIcon:this.getThemeIcon(m),collapsibleState:(0,C.isUndefinedOrNull)(m.collapsibleState)?S.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:f,children:void 0,disposableStore:P,dispose(){P.dispose()}}}getThemeIcon(b){return b.iconPath instanceof S.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:m,label:f,resourceUri:P},l,M){if(m)return`${g.ID_HANDLE_PREFIX}/${m}`;const r=s(f,this.extension),i=l?l.item.handle:g.LABEL_HANDLE_PREFIX;let p=r?r.label:P?(0,F.basename)(P):"";p=p.indexOf("/")!==-1?p.replace("/","//"):p;const h=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,o=this.getChildrenNodes(l)||[];let v,c=0;do{if(v=`${i}/${c}:${p}`,M||!this.elements.has(v)||h===v)break;c++}while(c<=o.length);return v}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof S.ThemeIcon))return typeof b.iconPath=="string"||w.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof S.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return w.URI.isUri(b)?b:w.URI.file(b)}addNodeToCache(b,m){this.elements.set(m.item.handle,b),this.nodes.set(b,m)}updateNodeCache(b,m,f,P){this.elements.delete(m.item.handle),this.nodes.delete(b),m.item.handle!==f.item.handle&&this.elements.delete(f.item.handle),this.addNodeToCache(b,m);const l=this.getChildrenNodes(P)||[],M=l.filter(r=>r.item.handle===f.item.handle)[0];M&&l.splice(l.indexOf(M),1,m)}addNodeToParentCache(b,m){m?(m.children||(m.children=[]),m.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const m=this.nodes.get(b);if(m){if(m.children)for(const f of m.children){const P=this.elements.get(f.item.handle);P&&this.clear(P)}m.children=void 0}}else this.clearAll()}clear(b){const m=this.nodes.get(b);if(m){if(m.children)for(const f of m.children){const P=this.elements.get(f.item.handle);P&&this.clear(P)}this.nodes.delete(b),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(Ee[170],_e([0,1,14,3,6,11,47,8,88,68]),function(oe,e,a,F,w,T,t,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends w.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new t.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const d=this.diff[this.diff.length-1];if(d&&n[0]===1){if(d[0]===1&&d[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(d[1],n[1]);return}if(d[0]===0&&d[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(d[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,d){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||d>s.expandLevels)&&(s.expandLevels=d),s.expand===1){const u=this.resolveChildren(s);return u.isOpen()?this.expandChildren(s,d-1):u.wait().then(()=>this.expandChildren(s,d-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,d-1)):this.expandChildren(s,d-1)}}dispose(){for(const n of this.tree.values())(0,t.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,d){switch(d.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(C.TestId.joinToString(n.fullId,d.id));break;case 0:this.upsertItem(d.item,n);break;case 4:for(const b of d.ops)this.onTestItemEvent(n,b);break;case 3:const{key:s,value:u,previous:g}=d,k=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(u,g,k);break;case"range":this.pushDiff([1,{extId:k,item:{range:A.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:k,item:{error:A.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:k,item:{[s]:u??null}}]);break}break;default:(0,T.assertNever)(d)}}upsertItem(n,d){if(!(n instanceof t.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=C.TestId.fromExtHostTestItem(n,this.root.id,d?.actual),u=(0,t.getPrivateApiFor)(n);u.parent&&u.parent!==d?.actual&&u.parent.children.delete(n.id);let g=this.tree.get(s.toString());if(!g){g={fullId:s,actual:n,parent:d?s.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(g.fullId.toString(),g),this.setItemParent(n,d),this.pushDiff([0,{parent:g.parent&&g.parent.toString(),controllerId:this.controllerId,expand:g.expand,item:A.TestItem.from(n)}]),this.connectItemAndChildren(n,g,d);return}if(g.actual===n){this.connectItem(n,g,d);return}const k=g.actual.children,b=g.actual,m=(0,t.diffTestItems)(b,n);(0,t.getPrivateApiFor)(b).listener=void 0,g.actual=n,g.expand=0;for(const[f,P]of m)this.onTestItemEvent(g,{op:3,key:f,value:P,previous:b[f]});this.connectItemAndChildren(n,g,d);for(const f of k)n.children.get(f.id)||this.removeItem(C.TestId.joinToString(s,f.id))}diffTagRefs(n,d,s){const u=new Set(d.map(g=>g.id));for(const g of n)u.delete(g.id)||this.incrementTagRefs(g);this.pushDiff([1,{extId:s,item:{tags:n.map(g=>A.TestTag.namespace(this.controllerId,g.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const d=this.tags.get(n.id);d?d.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:A.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const d=this.tags.get(n);d&&!--d.refCount&&(this.tags.delete(n),this.pushDiff([6,A.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,d){(0,t.getPrivateApiFor)(n).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(n,d,s){this.setItemParent(n,s);const u=(0,t.getPrivateApiFor)(n);u.parent=s?.actual,u.listener=g=>this.onTestItemEvent(d,g),this.updateExpandability(d)}connectItemAndChildren(n,d,s){this.connectItem(n,d,s);for(const u of n.children)this.upsertItem(u,d)}updateExpandability(n){let d;this._resolveHandler?n.resolveBarrier?d=n.resolveBarrier.isOpen()?3:2:d=n.actual.canResolveChildren?1:0:d=0,d!==n.expand&&(n.expand=d,this.pushDiff([1,{extId:n.fullId.toString(),expand:d}]),d===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,d){if(d<0)return;const s=[];for(const u of n.actual.children){const g=this.expand(C.TestId.joinToString(n.fullId,u.id),d);(0,a.isThenable)(g)&&s.push(g)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const g=new a.Barrier;return g.open(),g}n.expand=2,this.pushExpandStateUpdate(n);const d=n.resolveBarrier=new a.Barrier,s=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=g.stack||g.message||String(g))};let u;try{u=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(g){s(g)}return(0,a.isThenable)(u)?u.catch(s).then(()=>{d.open(),this.updateExpandability(n)}):(d.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const d=this.tree.get(n);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[d];for(;s.length;){const u=s.pop();if(!!u){(0,t.getPrivateApiFor)(u.actual).listener=void 0;for(const g of u.actual.tags)this.decrementTagRefs(g.id);this.tree.delete(u.fullId.toString());for(const g of u.actual.children)s.push(this.tree.get(C.TestId.joinToString(u.fullId,g.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=R}),define(Ee[171],_e([0,1,4,136]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(F.IEnvironmentService)}),define(Ee[172],_e([0,1,25,3,17]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=T;class t{constructor(R){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let _ of R.activationEvents)_==="onUri"&&(_=`onUri:${a.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(R)}}keepOnly(R){const _=new Set;R.forEach(n=>_.add(a.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(a.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,_){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const n=t._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(d=>d.identifier)),_.length>0){const d=new Set;_.forEach(s=>d.add(a.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!d.has(a.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(n)}static _findLoopingExtensions(R){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,k){this.addNode(g),this.addNode(k),this._arcs.has(g)?this._arcs.get(g).push(k):this._arcs.set(g,[k])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,k){const b=_.getArcs(g);for(let m=0;m<b.length;m++)if(!k.has(b[m]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let g of R){const k=a.ExtensionIdentifier.toKey(g.identifier);if(n.set(k,g),g.extensionDependencies)for(let b of g.extensionDependencies){const m=a.ExtensionIdentifier.toKey(b);_.addArc(k,m)}}let d=new Set;_.getNodes().filter(g=>_.getArcs(g).length===0).forEach(g=>d.add(g));let s=_.getNodes().filter(g=>!d.has(g)),u;do{u=!1;for(let g=0;g<s.length;g++){const k=s[g];_.hasOnlyGoodArcs(k,d)&&(s.splice(g,1),g--,d.add(k),u=!0)}}while(u);return s.map(g=>n.get(g))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const _=this._activationMap.get(R);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const _=this._extensionsMap.get(a.ExtensionIdentifier.toKey(R));return _||void 0}}e.ExtensionDescriptionRegistry=t;var A;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(A||(A={}));function S(C,R){const _=C.isBuiltin?0:C.isUnderDevelopment?2:1,n=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(_!==n)return _-n;const d=w.posix.basename(C.extensionLocation.path),s=w.posix.basename(R.extensionLocation.path);return d<s?-1:d>s?1:0}}),define(Ee[173],_e([0,1,22]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(A){A[A.VersionMismatch=55]="VersionMismatch",A[A.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var w;(function(A){A[A.Initialized=0]="Initialized",A[A.Ready=1]="Ready",A[A.Terminate=2]="Terminate"})(w=e.MessageType||(e.MessageType={}));function T(A){const S=a.VSBuffer.alloc(1);switch(A){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=T;function t(A,S){if(A.byteLength!==1)return!1;switch(A.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=t}),define(Ee[26],_e([0,1,3,2,4,25,143]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var A;(function(f){f[f.None=0]="None",f[f.LocalProcess=1]="LocalProcess",f[f.LocalWebWorker=2]="LocalWebWorker",f[f.Remote=3]="Remote"})(A=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(f){switch(f){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class C{constructor(P){this.dependency=P}}e.MissingExtensionDependency=C;var R;(function(f){f[f.LocalProcess=0]="LocalProcess",f[f.LocalWebWorker=1]="LocalWebWorker",f[f.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(f){switch(f){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;function n(f,P){return f.enabledApiProposals?.includes(P)?!0:Boolean(f.enableProposedApi)}e.isProposedApiEnabled=n;function d(f,P){if(!n(f,P))throw new Error(`Extension '${f.identifier.value}' CANNOT use API proposal: ${P}.
Its package.json#enabledApiProposals-property declares: ${f.enabledApiProposals?.join(", ")??"[]"} but NOT ${P}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.checkProposedApiEnabled=d;class s{constructor(P,l,M,r){this.codeLoadingTime=P,this.activateCallTime=l,this.activateResolvedTime=M,this.activationReason=r}}e.ActivationTimes=s;class u{constructor(P,l){this.description=P,this.value=l}}e.ExtensionPointContribution=u,e.ExtensionHostLogFileName="exthost";var g;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(g=e.ActivationKind||(e.ActivationKind={}));function k(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,t.getGalleryExtensionId)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation}}e.toExtension=k;function b(f,P){return{identifier:new T.ExtensionIdentifier(f.identifier.id),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!P,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid}}e.toExtensionDescription=b;class m{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,l){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,l,M,r,i){}_onDidActivateExtensionError(P,l){}_onExtensionRuntimeError(P,l){}_onExtensionHostExit(P){}}e.NullExtensionService=m}),define(Ee[174],_e([0,1,15,25,26,12]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const t=Promise.resolve(void 0);class A{constructor(u,g,k,b){this.startup=u,this.codeLoadingTime=g,this.activateCallTime=k,this.activateResolvedTime=b}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class S{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,g){return u===-1||g===-1?-1:g-u}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class C{constructor(u,g,k,b,m,f){this.activationFailed=u,this.activationFailedError=g,this.activationTimes=k,this.module=b,this.exports=m,this.subscriptions=f}}e.ActivatedExtension=C;class R extends C{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class _ extends C{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=_;class n extends C{constructor(u){super(!0,u,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let d=class{constructor(u,g,k,b,m){this._logService=m,this._isDisposed=!1,this._registry=u,this._resolvedExtensionsSet=new Set,g.forEach(f=>this._resolvedExtensionsSet.add(F.ExtensionIdentifier.toKey(f))),this._hostExtensionsMap=new Map,k.forEach(f=>this._hostExtensionsMap.set(F.ExtensionIdentifier.toKey(f),f)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(u){const g=F.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(g)}getActivatedExtension(u){const g=F.ExtensionIdentifier.toKey(u),k=this._activatedExtensions.get(g);if(!k)throw new Error("Extension `"+u.value+"` is not known or not activated");return k}activateByEvent(u,g){if(this._alreadyActivatedEvents[u])return t;const k=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(k.map(b=>({id:b.identifier,reason:{startup:g,extensionId:b.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,g){const k=this._registry.getExtensionDescription(u);if(!k)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:k.identifier,reason:g}])}_handleActivateRequest(u,g,k){if(this._hostExtensionsMap.has(F.ExtensionIdentifier.toKey(u.id))){g[F.ExtensionIdentifier.toKey(u.id)]=u;return}const b=this._registry.getExtensionDescription(u.id);if(!b){const P=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,P,new w.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(u.id),new n(P));return}const m=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let f=!0;for(let P=0,l=m.length;P<l;P++){const M=m[P];if(this._resolvedExtensionsSet.has(F.ExtensionIdentifier.toKey(M)))continue;const r=this._activatedExtensions.get(F.ExtensionIdentifier.toKey(M));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const o=b.displayName||b.identifier.value,v=this._registry.getExtensionDescription(M),c=v&&v.displayName||M,E=new Error(`Cannot activate the '${o}' extension because its dependency '${c}' failed to activate`);E.detail=r.activationFailedError,this._host.onExtensionActivationError(b.identifier,E,null),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(b.identifier),new n(E));return}if(this._hostExtensionsMap.has(F.ExtensionIdentifier.toKey(M))){f=!1,g[F.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(F.ExtensionIdentifier.toKey(M)),reason:u.reason};continue}const i=this._registry.getExtensionDescription(M);if(i){if(!i.main&&!i.browser)continue;f=!1,g[F.ExtensionIdentifier.toKey(M)]={id:i.identifier,reason:u.reason};continue}const p=b.displayName||b.identifier.value,h=new Error(`Cannot activate the '${p}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(b.identifier,h,new w.MissingExtensionDependency(M)),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(b.identifier),new n(h));return}f?g[F.ExtensionIdentifier.toKey(b.identifier)]=u:k.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(m=>!this._activatedExtensions.has(F.ExtensionIdentifier.toKey(m.id))),u.length===0))return Promise.resolve(void 0);const g=Object.create(null),k=[];for(let m=0,f=u.length;m<f;m++)this._handleActivateRequest(u[m],g,k);for(let m=0,f=k.length;m<f;m++){const P=F.ExtensionIdentifier.toKey(k[m].id);g[P]&&delete g[P]}const b=Object.keys(g).map(m=>g[m]);return k.length===0?Promise.all(b.map(m=>this._activateExtension(m.id,m.reason))).then(m=>{}):this._activateExtensions(b).then(m=>this._activateExtensions(k))}_activateExtension(u,g){const k=F.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(k))return Promise.resolve(void 0);const b=this._activatingExtensions.get(k);if(b)return b;const m=this._host.actualActivateExtension(u,g).then(void 0,f=>{const P=new Error;return f&&f.name&&(P.name=f.name),f&&f.message?P.message=`Activating extension '${u.value}' failed: ${f.message}.`:P.message=`Activating extension '${u.value}' failed: ${f}.`,f&&f.stack&&(P.stack=f.stack),this._isDisposed&&a.isPromiseCanceledError(f)?new n(f):(this._host.onExtensionActivationError(u,P,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(f),new n(f))}).then(f=>{this._activatedExtensions.set(k,f),this._activatingExtensions.delete(k)});return this._activatingExtensions.set(k,m),m}};d=xe([$e(4,T.ILogService)],d),e.ExtensionsActivator=d}),define(Ee[175],_e([0,1,12,28,26]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends a.LogService{constructor(A,S){super(A.createLogger(S.logFile,{name:w.ExtensionHostLogFileName}))}};T=xe([$e(0,a.ILoggerService),$e(1,F.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(Ee[176],_e([0,1,15]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,t)=>{this._actualOk=T,this._actualErr=t,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,a.onUnexpectedError)(T))}then(T,t){return this._ensureActual().then(T,t)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=F}),define(Ee[37],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(C,R){this._proxyIdentifierBrand=void 0,this.isMain=C,this.sid=R,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const F=[];function w(S){const C=new a(!0,S);return F[C.nid]=C,C}e.createMainContextProxyIdentifier=w;function T(S){const C=new a(!1,S);return F[C.nid]=C,C}e.createExtHostContextProxyIdentifier=T;function t(S){return F[S].sid}e.getStringIdentifierForProxy=t;class A{constructor(C){this.value=C}}e.SerializableObjectWithBuffers=A}),define(Ee[5],_e([0,1,54,2,37]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var t;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var A;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(m){m.name="$ident";function f(l,M){return Object.defineProperty(l,m.name,{value:M,enumerable:!0}),l}m.mixin=f;function P(l){return l[m.name]}m.of=P})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(f){return f._id=d._n++,f}}e.IdObject=d,d._n=0;var s;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.command="m",m.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(m){m[m.File=1]="File",m[m.Text=2]="Text",m[m.Cell=3]="Cell"})(g=e.WorkspaceEditType||(e.WorkspaceEditType={}));function k(m){if(m&&m.edits)for(const f of m.edits)typeof f.resource=="object"?f.resource=F.URI.revive(f.resource):(f.newUri=F.URI.revive(f.newUri),f.oldUri=F.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,a.revive)(f.metadata));return m}e.reviveWorkspaceEditDto=k;var b;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[69],_e([0,1,5,3,4]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(A){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,S){return this._proxy.$getPassword(A,S)}store(A,S,C){return this._proxy.$setPassword(A,S,C)}delete(A,S){return this._proxy.$deletePassword(A,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(Ee[70],_e([0,1,4,12,5,13]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let t=class{constructor(S,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(w.MainContext.MainThreadTelemetry)}report(S,C,R){const _=this.getUsageKey(S,C);this._reportedUsages.has(_)||(this._reportedUsages.add(_),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}getUsageKey(S,C){return`${S}-${C.identifier.value}`}};t=xe([$e(0,T.IExtHostRpcService),$e(1,F.ILogService)],t),e.ExtHostApiDeprecationService=t,e.NullApiDeprecationService=Object.freeze(new class{report(A,S,C){}})}),define(Ee[177],_e([0,1,3,5,7,25]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class t{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,C,R,_={}){const n=T.ExtensionIdentifier.toKey(S.identifier),d=this._inFlightRequests.get(n)||[],s=[...R].sort().join(" ");let u=d.find(g=>g.scopes===s);if(u)return u.result;{const g=this._getSession(S,n,C,R,_);u={scopes:s,result:g},d.push(u),this._inFlightRequests.set(n,d);try{await g}finally{const k=d.findIndex(b=>b.scopes===s);k>-1&&(d.splice(k),this._inFlightRequests.set(n,d))}return g}}async _getSession(S,C,R,_,n={}){await this._proxy.$ensureProvider(R);const d=S.displayName||S.name;return this._proxy.$getSession(R,_,C,d,n)}async removeSession(S,C){const R=this._authenticationProviders.get(S);return R?R.provider.removeSession(C):this._proxy.$removeSession(S,C)}registerAuthenticationProvider(S,C,R,_){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:C,provider:R,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===S)||this._providers.push({id:S,label:C});const n=R.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(S,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,C,_?.supportsMultipleAccounts??!1),new w.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const d=this._providers.findIndex(s=>s.id===S);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this._onDidChangeSessions.fire({provider:{id:S,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=t}),define(Ee[178],_e([0,1,5,13,8]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(A,S){this._extHostDocumentsAndEditors=S,this._proxy=A.getProxy(a.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(A){const S=w.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=xe([$e(0,F.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(Ee[179],_e([0,1,5]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(T){const t=T.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return t.$readText()},writeText(A){return t.$writeText(A)}})}}e.ExtHostClipboard=F}),define(Ee[38],_e([0,1,11,7,8,27,5,16,12,54,59,227,2,6,4,13,47,22,37,43]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(p,h){this._commands=new Map,this._apiCommands=new Map,this._proxy=p.getProxy(t.MainContext.MainThreadCommands),this._logService=h,this.converter=new P(this,o=>{const v=this._apiCommands.get(o);return v?.result===M.Void?v:void 0},h),this._argumentProcessors=[{processArgument(o){return(0,C.revive)(o)}},{processArgument(o){return(0,T.cloneAndChange)(o,function(v){if(R.Range.isIRange(v))return w.Range.to(v);if(_.Position.isIPosition(v))return w.Position.to(v);if(R.Range.isIRange(v.range)&&n.URI.isUri(v.uri))return w.location.to(v);if(v instanceof k.VSBuffer)return v.buffer.buffer;if(!Array.isArray(v))return v})}}]}registerArgumentProcessor(p){this._argumentProcessors.push(p)}registerApiCommand(p){const h=this.registerCommand(!1,p.id,async(...o)=>{const v=p.args.map((E,I)=>{if(!E.validate(o[I]))throw new Error(`Invalid argument '${E.name}' when running '${p.id}', received: ${o[I]}`);return E.convert(o[I])}),c=await this.executeCommand(p.internalId,...v);return p.result.convert(c,o,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this._apiCommands.set(p.id,p),new F.Disposable(()=>{h.dispose(),this._apiCommands.delete(p.id)})}registerCommand(p,h,o,v,c,E){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:o,thisArg:v,description:c,extension:E}),p&&this._proxy.$registerCommand(h),new F.Disposable(()=>{this._commands.delete(h)&&p&&this._proxy.$unregisterCommand(h)})}executeCommand(p,...h){return this._logService.trace("ExtHostCommands#executeCommand",p),this._doExecuteCommand(p,h,!0)}async _doExecuteCommand(p,h,o){if(this._commands.has(p))return this._executeContributedCommand(p,h,!1);{let v=!1;const c=(0,T.cloneAndChange)(h,function(E){if(E instanceof F.Position)return w.Position.from(E);if(E instanceof F.Range)return w.Range.from(E);if(E instanceof F.Location)return w.location.from(E);if(F.NotebookRange.isNotebookRange(E))return w.NotebookRange.from(E);if(E instanceof ArrayBuffer)return v=!0,k.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return v=!0,k.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(p,v?new b.SerializableObjectWithBuffers(c):c,o);return(0,C.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(p,h,!1);throw E}}}async _executeContributedCommand(p,h,o){const v=this._commands.get(p);if(!v)throw new Error("Unknown command");let{callback:c,thisArg:E,description:I}=v;if(I)for(let D=0;D<I.args.length;D++)try{(0,a.validateConstraint)(h[D],I.args[D].constraint)}catch(B){throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${I.args[D].name}' - ${I.args[D].description}`)}try{return await c.apply(E,h)}catch(D){if(p===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...h);B&&(p=B.command)}throw this._logService.error(D,p,v.extension?.identifier),o?new class extends Error{constructor(){super((0,m.toErrorMessage)(D));this.id=p,this.source=v.extension?.displayName??v.extension?.name}}:D}}$executeContributedCommand(p,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",p),this._commands.has(p)?(h=h.map(o=>this._argumentProcessors.reduce((v,c)=>c.processArgument(v),o)),this._executeContributedCommand(p,h,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this._logService.trace("ExtHostCommands#getCommands",p),this._proxy.$getCommands().then(h=>(p&&(h=h.filter(o=>o[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const p=Object.create(null);for(let[h,o]of this._commands){let{description:v}=o;v&&(p[h]=v)}return Promise.resolve(p)}};f=xe([$e(0,u.IExtHostRpcService),$e(1,S.ILogService)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class P{constructor(p,h,o){this._commands=p,this._lookupApiCommand=h,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(p,h){if(!p)return;const o={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return o;const v=this._lookupApiCommand(p.command);if(v)o.id=v.internalId,o.arguments=v.args.map((c,E)=>c.convert(p.arguments&&p.arguments[E]));else if((0,A.isNonEmptyArray)(p.arguments)){const c=++this._cachIdPool;this._cache.set(c,p),h.add((0,d.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),o.$ident=c,o.id=this.delegatingCommandId,o.arguments=[c],this._logService.trace("CommandsConverter#CREATE",p.command,c)}return o}fromInternal(p){const h=t.ObjectIdentifier.of(p);return typeof h=="number"?this._cache.get(h):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this._cache.get(p[0])}_executeConvertedCommand(...p){const h=this.getActualCommand(...p);return this._logService.trace("CommandsConverter#EXECUTE",p[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=P;class l{constructor(p,h,o,v){this.name=p,this.description=h,this.validate=o,this.convert=v}optional(){return new l(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,h){return new l(p??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),l.Position=new l("position","A position in a text document",i=>F.Position.isPosition(i),w.Position.from),l.Range=new l("range","A range in a text document",i=>F.Range.isRange(i),w.Range.from),l.Selection=new l("selection","A selection in a text document",i=>F.Selection.isSelection(i),w.Selection.from),l.Number=new l("number","",i=>typeof i=="number",i=>i),l.String=new l("string","",i=>typeof i=="string",i=>i),l.CallHierarchyItem=new l("item","A call hierarchy item",i=>i instanceof F.CallHierarchyItem,w.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",i=>i instanceof F.TypeHierarchyItem,w.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",i=>i instanceof g.TestItemImpl,w.TestItem.from);class M{constructor(p,h){this.description=p,this.convert=h}}e.ApiCommandResult=M,M.Void=new M("no result",i=>i);class r{constructor(p,h,o,v,c){this.id=p,this.internalId=h,this.description=o,this.args=v,this.result=c}}e.ApiCommand=r}),define(Ee[180],_e([0,1,8,7,58,38,16,80]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(a.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,d)=>{if((0,t.isFalsyOrEmpty)(n))return;class s extends F.SymbolInformation{static to(g){const k=new s(g.name,a.SymbolKind.to(g.kind),g.containerName||"",new F.Location(d[0],a.Range.to(g.range)));return k.detail=g.detail,k.range=k.location.range,k.selectionRange=a.Range.to(g.selectionRange),k.children=g.children?g.children.map(s.to):[],k}}return n.map(s.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(a.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(a.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(a.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(a.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(a.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(d=>F.Position.isPosition(d)),n=>n.map(a.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(d=>{let s;for(const u of d.reverse())s=new F.SelectionRange(a.Range.to(u),s);return s}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:a.Range.to(n.range),placeholder:n.text}})),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,A.decodeSemanticTokensDto)(n);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range.optional()],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,A.decodeSemanticTokensDto)(n);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,d,s)=>{if(!n)return new F.CompletionList([]);const u=n.suggestions.map(g=>a.CompletionItem.to(g,s));return new F.CompletionList(u,n.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,d,s)=>R(u=>new F.CodeLens(a.Range.to(u.range),u.command&&s.fromInternal(u.command)))(n))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>F.Range.isRange(n),n=>F.Selection.isSelection(n)?a.Selection.from(n):a.Range.from(n)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,d,s)=>R(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(u.command)}else{const g=new F.CodeAction(u.title,u.kind?new F.CodeActionKind(u.kind):void 0);return u.edit&&(g.edit=a.WorkspaceEdit.to(u.edit)),u.command&&(g.command=s.fromInternal(u.command)),g.isPreferred=u.isPreferred,g}})(n))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(d=>new F.ColorInformation(a.Range.to(d.range),a.Color.to(d.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",n=>n instanceof F.Color,a.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(a.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(d=>a.NotebookExclusiveDocumentPattern.to(d))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class C{static register(d){S.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=C;function R(n){return d=>{if(Array.isArray(d))return d.map(n)}}function _(n){if(!Array.isArray(n))return;const d=[];for(const s of n)w.isLocationLink(s)?d.push(a.DefinitionLink.to(s)):d.push(a.location.to(s));return d}}),define(Ee[181],_e([0,1,14,51,3,6,2,58,25,8,7,5]),function(oe,e,a,F,w,T,t,A,S,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(d,s,u){const g=d.getProxy(_.MainContext.MainThreadComments);class k{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const p=this._commentControllers.get(i.handle);return p||i}else if(i&&i.$mid===7){const p=this._commentControllers.get(i.commentControlHandle);if(!p)return i;const h=p.getCommentThread(i.commentThreadHandle);return h||i}else if(i&&i.$mid===8){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const h=p.getCommentThread(i.thread.commentThreadHandle);return h?{thread:h,text:i.text}:i}else if(i&&i.$mid===9){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const h=p.getCommentThread(i.thread.commentThreadHandle);if(!h)return i;let o=i.commentUniqueId,v=h.getCommentByUniqueId(o);return v||i}else if(i&&i.$mid===10){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const h=p.getCommentThread(i.thread.commentThreadHandle);if(!h)return i;let o=i.text,v=i.commentUniqueId,c=h.getCommentByUniqueId(v);return c?(c.body=o,c):i}return i}})}createCommentController(i,p,h){const o=k.handlePool++,v=new m(i,o,p,h);this._commentControllers.set(v.handle,v);const c=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(i.identifier))||[];return c.push(v),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(i.identifier),c),v.value}$createCommentThreadTemplate(i,p,h){const o=this._commentControllers.get(i);!o||o.$createCommentThreadTemplate(p,h)}async $updateCommentThreadTemplate(i,p,h){const o=this._commentControllers.get(i);!o||o.$updateCommentThreadTemplate(p,h)}$deleteCommentThread(i,p){const h=this._commentControllers.get(i);h&&h.$deleteCommentThread(p)}$provideCommentingRanges(i,p,h){const o=this._commentControllers.get(i);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const v=u.getDocument(t.URI.revive(p));return(0,a.asPromise)(()=>o.commentingRangeProvider.provideCommentingRanges(v,h)).then(c=>c?c.map(E=>C.Range.from(E)):void 0)}$toggleReaction(i,p,h,o,v){const c=this._commentControllers.get(i);return!c||!c.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const E=c.getCommentThread(p);if(E){const I=E.getCommentByUniqueId(o.uniqueIdInThread);if(c!==void 0&&I&&c.reactionHandler)return c.reactionHandler(I,l(v))}return Promise.resolve(void 0)})}dispose(){}}k.handlePool=0;class b{constructor(i,p,h,o,v,c,E){this._commentControllerHandle=p,this._id=h,this._uri=o,this._range=v,this._comments=c,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),g.$createCommentThread(p,this.handle,this._id,this._uri,C.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=c,this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(p,this.handle)}});const I=this;this.value={get uri(){return I.uri},get range(){return I.range},set range(D){I.range=D},get comments(){return I.comments},set comments(D){I.comments=D},get collapsibleState(){return I.collapsibleState},set collapsibleState(D){I.collapsibleState=D},get canReply(){return I.canReply},set canReply(D){I.canReply=D},get contextValue(){return I.contextValue},set contextValue(D){I.contextValue=D},get label(){return I.label},set label(D){I.label=D},dispose:()=>{I.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const i=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),p={};i("range")&&(p.range=C.Range.from(this._range)),i("label")&&(p.label=this.label),i("contextValue")&&(p.contextValue=this.contextValue??null),i("comments")&&(p.comments=this._comments.map(h=>f(this,h,this._commentsMap))),i("collapsibleState")&&(p.collapseState=M(this._collapseState)),i("canReply")&&(p.canReply=this.canReply),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,p)}getCommentByUniqueId(i){for(let p of this._commentsMap){let h=p[0],o=p[1];if(i===o)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}b._handlePool=0,xe([(0,F.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class m{constructor(i,p,h,o){this._extension=i,this._handle=p,this._id=h,this._label=o,this._threads=new Map,g.$registerCommentController(this.handle,h,o);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(c){v.options=c},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(c){v.commentingRangeProvider=c},get reactionHandler(){return v.reactionHandler},set reactionHandler(c){v.reactionHandler=c},createCommentThread(c,E,I){return v.createCommentThread(c,E,I).value},dispose:()=>{v.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,g.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,p,h,o){if(typeof i=="string"){const v=new b(this.id,this.handle,i,p,h,o,this._extension.identifier);return this._threads.set(v.handle,v),v}else{const v=new b(this.id,this.handle,void 0,i,p,h,this._extension.identifier);return this._threads.set(v.handle,v),v}}$createCommentThreadTemplate(i,p){const h=new b(this.id,this.handle,void 0,t.URI.revive(i),C.Range.to(p),[],this._extension.identifier);return h.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(i,p){let h=this._threads.get(i);h&&(h.range=C.Range.to(p))}$deleteCommentThread(i){let p=this._threads.get(i);p&&p.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function f(r,i,p){let h=p.get(i);h||(h=++r.commentHandle,p.set(i,h));const o=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:h,body:C.MarkdownString.from(i.body),userName:i.author.name,userIconPath:o,label:i.label,commentReactions:i.reactions?i.reactions.map(v=>P(v)):void 0}}function P(r){return{label:r.label,iconPath:r.iconPath?C.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function l(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?t.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function M(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}return new k}e.createExtHostComments=n}),define(Ee[93],_e([0,1,2,5,7,4,13,12,16,9,17]),function(oe,e,a,F,w,T,t,A,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(d,s){this._logService=s,this._provider=new Map,this._proxy=d.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,s){const u=wi._handlePool++;this._provider.set(u,{provider:d,extensionId:s}),this._proxy.$registerDecorationProvider(u,s.value);const g=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(k=>{if(!k){this._proxy.$onDidChange(u,null);return}let b=(0,S.asArray)(k);if(b.length<=wi._maxEventSize){this._proxy.$onDidChange(u,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,b.length);const m=b.map(l=>({uri:l,rank:(0,C.count)(l.path,"/")})),f=(0,S.groupBy)(m,(l,M)=>l.rank-M.rank||(0,C.compare)(l.uri.path,M.uri.path));let P=[];e:for(let l of f){let M;for(let r of l){let i=(0,R.dirname)(r.uri.path);if(M!==i&&(M=i,P.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(u,P)});return new w.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(d,s,u){if(!this._provider.has(d))return Object.create(null);const g=Object.create(null),{provider:k,extensionId:b}=this._provider.get(d);return await Promise.all(s.map(async m=>{try{const{uri:f,id:P}=m,l=await Promise.resolve(k.provideFileDecoration(a.URI.revive(f),u));if(!l)return;try{w.FileDecoration.validate(l),g[P]=[l.propagate,l.tooltip,l.badge,l.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${b.value}': ${M}`)}}catch(f){this._logService.error(f)}})),g}};_._handlePool=0,_._maxEventSize=250,_=xe([$e(0,t.IExtHostRpcService),$e(1,A.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[182],_e([0,1,119,82,2,5,7,8,3,12,21,31]),function(oe,e,a,F,w,T,t,A,S,C,R,_){"use strict";var n,d,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(b,m,f,P,l,M){this._name=b,this._owner=m,this._maxDiagnosticsPerFile=f,n.set(this,void 0),d.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Ze(this,s,new R.ResourceMap(r=>P.getComparisonKey(r)),"f"),Ze(this,n,l,"f"),Ze(this,d,M,"f")}dispose(){this._isDisposed||(Ae(this,d,"f").fire([...Ae(this,s,"f").keys()]),Ae(this,n,"f")&&Ae(this,n,"f").$clear(this._owner),Ae(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,m){if(!b){this.clear();return}this._checkDisposed();let f=[];if(w.URI.isUri(b)){if(!m){this.delete(b);return}Ae(this,s,"f").set(b,m.slice()),f=[b]}else if(Array.isArray(b)){f=[];let l;b=[...b].sort(u._compareIndexedTuplesByUri);for(const M of b){const[r,i]=M;if((!l||r.toString()!==l.toString())&&(l&&Ae(this,s,"f").get(l).length===0&&Ae(this,s,"f").delete(l),l=r,f.push(r),Ae(this,s,"f").set(r,[])),i){const p=Ae(this,s,"f").get(r);p&&p.push(...i)}else{const p=Ae(this,s,"f").get(r);p&&(p.length=0)}}}if(Ae(this,d,"f").fire(f),!Ae(this,n,"f"))return;const P=[];for(let l of f){let M=[];const r=Ae(this,s,"f").get(l);if(r)if(r.length>this._maxDiagnosticsPerFile){M=[];const i=[t.DiagnosticSeverity.Error,t.DiagnosticSeverity.Warning,t.DiagnosticSeverity.Information,t.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(let h of r)if(h.severity===i[p]&&M.push(A.Diagnostic.from(h))===this._maxDiagnosticsPerFile)break e;M.push({severity:F.MarkerSeverity.Info,message:(0,a.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=r.map(i=>A.Diagnostic.from(i));P.push([l,M])}Ae(this,n,"f").$changeMany(this._owner,P)}delete(b){this._checkDisposed(),Ae(this,d,"f").fire([b]),Ae(this,s,"f").delete(b),Ae(this,n,"f")&&Ae(this,n,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Ae(this,d,"f").fire([...Ae(this,s,"f").keys()]),Ae(this,s,"f").clear(),Ae(this,n,"f")&&Ae(this,n,"f").$clear(this._owner)}forEach(b,m){this._checkDisposed();for(let f of Ae(this,s,"f").keys())b.apply(m,[f,this.get(f),this])}get(b){this._checkDisposed();const m=Ae(this,s,"f").get(b);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Ae(this,s,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,m){return b[0].toString()<m[0].toString()?-1:b[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=u,n=new WeakMap,d=new WeakMap,s=new WeakMap;let g=class ri{constructor(b,m,f){this._logService=m,this._fileSystemInfoService=f,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:P=>P.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=b.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(b){const m=new R.ResourceMap;for(const f of b)m.set(f,f);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(b,m){const{_collections:f,_proxy:P,_onDidChangeDiagnostics:l,_logService:M,_fileSystemInfoService:r}=this,i=new class{$changeMany(o,v){P.$changeMany(o,v),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,o,v.length===0?"CLEARING":v)}$clear(o){P.$clear(o),M.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,o)}dispose(){P.dispose()}};let p;if(!m)m="_generated_diagnostic_collection_name_#"+ri._idPool++,p=m;else if(!f.has(m))p=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do p=m+ri._idPool++;while(f.has(p))}return new class extends u{constructor(){super(m,p,ri._maxDiagnosticsPerFile,r.extUri,i,l);f.set(p,this)}dispose(){super.dispose(),f.delete(p)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const m=new Map,f=[];for(const P of this._collections.values())P.forEach((l,M)=>{let r=m.get(l.toString());typeof r=="undefined"&&(r=f.length,m.set(l.toString(),r),f.push([l,[]])),f[r][1]=f[r][1].concat(...M)});return f}}_getDiagnostics(b){let m=[];for(let f of this._collections.values())f.has(b)&&(m=m.concat(f.get(b)));return m}$acceptMarkersChange(b){if(!this._mirrorCollection){const m="_generated_mirror",f=new u(m,m,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,f),this._mirrorCollection=f}for(const[m,f]of b)this._mirrorCollection.set(w.URI.revive(m),f.map(A.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=xe([$e(1,C.ILogService),$e(2,_.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(Ee[183],_e([0,1,2,5]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(t){this._proxy=t.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(t){return this._proxy.$showOpenDialog(t).then(A=>A?A.map(S=>a.URI.revive(S)):void 0)}showSaveDialog(t){return this._proxy.$showSaveDialog(t).then(A=>A?a.URI.revive(A):void 0)}}e.ExtHostDialogs=w}),define(Ee[184],_e([0,1,15,2,7,5,10,20,9]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(_,n,d){this._documentsAndEditors=n,this._logService=d,this._documentContentProviders=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(t.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const d=C._handlePool++;this._documentContentProviders.set(d,n),this._proxy.$registerTextContentProvider(d,_);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(u=>{if(u.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(d,u).then(g=>{if(!g&&typeof g!="string")return;const k=this._documentsAndEditors.getDocument(u);if(!k)return;const b=(0,S.splitLines)(g);if(!k.equalLines(b))return this._proxy.$onVirtualDocumentChange(u,g)},a.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(_,n){const d=this._documentContentProviders.get(_);return d?Promise.resolve(d.provideTextDocumentContent(F.URI.revive(n),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(Ee[185],_e([0,1,3,6,2,5,86,8,11,27,7]),function(oe,e,a,F,w,T,t,A,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(d,s){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const g of u)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const g of u)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const s=this._documentsAndEditors.getDocument(d);if(s)return s}getDocument(d){const s=this.getDocumentData(d);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return s.document}ensureDocumentData(d){const s=this._documentsAndEditors.getDocument(d);if(s)return Promise.resolve(s);let u=this._documentLoader.get(d.toString());return u||(u=this._proxy.$tryOpenDocument(d).then(g=>{this._documentLoader.delete(d.toString());const k=w.URI.revive(g);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(k))},g=>(this._documentLoader.delete(d.toString()),Promise.reject(g))),this._documentLoader.set(d.toString(),u)),u}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(s=>w.URI.revive(s))}$acceptModelModeChanged(d,s){const u=w.URI.revive(d),g=this._documentsAndEditors.getDocument(u);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(s),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(d){const s=w.URI.revive(d),u=this._documentsAndEditors.getDocument(s);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(d,s){const u=w.URI.revive(d),g=this._documentsAndEditors.getDocument(u);if(!g)throw new Error("unknown document");g._acceptIsDirty(s),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,s,u){const g=w.URI.revive(d),k=this._documentsAndEditors.getDocument(g);if(!k)throw new Error("unknown document");k._acceptIsDirty(u),k.onEvents(s);let b;s.isUndoing?b=R.TextDocumentChangeReason.Undo:s.isRedoing&&(b=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:k.document,contentChanges:s.changes.map(m=>({range:A.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:b}))}setWordDefinitionFor(d,s){(0,t.setWordDefinitionFor)(d,s)}}e.ExtHostDocuments=_}),define(Ee[48],_e([0,1,41,3,6,2,4,5,86,13,92,8,12,21,10,158,101]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class k{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(f,P){this._extHostRpc=f,this._logService=P,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const P=[],l=[],M=[];if(f.removedDocuments)for(const r of f.removedDocuments){const i=T.URI.revive(r),p=this._documents.get(i);p?.unref()&&(this._documents.delete(i),P.push(p.value))}if(f.addedDocuments)for(const r of f.addedDocuments){const i=T.URI.revive(r.uri);let p=this._documents.get(i);if(p&&i.scheme!==s.Schemas.vscodeNotebookCell&&i.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);p||(p=new k(new S.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,p),l.push(p.value)),p.ref()}if(f.removedEditors)for(const r of f.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&M.push(i)}if(f.addedEditors)for(const r of f.addedEditors){const i=T.URI.revive(r.documentUri);a.ok(this._documents.has(i),`document '${i}' does not exist`),a.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const p=this._documents.get(i).value,h=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>p.document),r.selections.map(_.Selection.to),r.options,r.visibleRanges.map(o=>_.Range.to(o)),typeof r.editorPosition=="number"?_.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,h)}f.newActiveEditor!==void 0&&(a.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,w.dispose)(P),(0,w.dispose)(M),f.removedDocuments&&this._onDidRemoveDocuments.fire(P),f.addedDocuments&&this._onDidAddDocuments.fire(l),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const P=this._editors.get(this._activeEditorId);return f?P:P?.value}allEditors(){return[...this._editors.values()]}};b=xe([$e(0,C.IExtHostRpcService),$e(1,n.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,t.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[71],_e([0,1,8,5,2,3,4,13,14]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,t.createDecorator)("IExtHostEditorTabs");let C=class{constructor(_){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new T.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(F.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((s,u)=>(s.isActive&&(n=u),Object.freeze({label:s.label,viewColumn:a.ViewColumn.to(s.viewColumn),index:u,resource:w.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:g,viewId:k})=>({resource:w.URI.revive(g),viewId:k})),viewId:s.editorId,isActive:s.isActive,move:async(g,k)=>{this._proxy.$moveTab(s,g,a.ViewColumn.from(k)),await(0,S.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,S.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,u)=>s.viewColumn===u.viewColumn?s.index-u.index:s.viewColumn-u.viewColumn);const d=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==d&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};C=xe([$e(0,A.IExtHostRpcService)],C),e.ExtHostEditorTabs=C}),define(Ee[186],_e([0,1,2,5,6,7,8,228,9,22,26]),function(oe,e,a,F,w,T,t,A,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(s){this._stateMachine=void 0,this._schemes.push(s)}delete(s){const u=this._schemes.indexOf(s);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const s=this._schemes.sort(),u=[];let g,k,b=14,m=14;for(const f of s){let P=g?(0,S.commonPrefixLength)(g,f):0;for(P===0?k=1:k=m;P<f.length;P++)P+1===f.length?(b=m,m=9):m+=1,u.push([k,f.toUpperCase().charCodeAt(P),m]),u.push([k,f.toLowerCase().charCodeAt(P),m]),k=m;g=f,m=b}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new A.StateMachine(u)}}provideDocumentLinks(s){this._initStateMachine();const u=[],g=A.LinkComputer.computeLinks({getLineContent(k){return s.lineAt(k-1).text},getLineCount(){return s.lineCount}},this._stateMachine);for(const k of g){const b=t.DocumentLink.to(k);b.target&&u.push(b)}return u}}class n{constructor(s,u){this._extHostLanguageFeatures=u,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=s.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(s,u,g,k={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(b,g);let m=2;k.isCaseSensitive&&(m+=1024),k.isReadonly&&(m+=2048),typeof g.copy=="function"&&(m+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,R.checkProposedApiEnabled)(s,"fsChunks"),m+=4),this._proxy.$registerFileSystemProvider(b,u,m).catch(P=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${u}`),console.error(P)});const f=g.onDidChangeFile(P=>{const l=[];for(const M of P){let{uri:r,type:i}=M;if(r.scheme!==u)continue;let p;switch(i){case T.FileChangeType.Changed:p=0;break;case T.FileChangeType.Created:p=1;break;case T.FileChangeType.Deleted:p=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:r,type:p})}this._proxy.$onFileSystemChange(b,l)});return(0,w.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(s){const{type:u,ctime:g,mtime:k,size:b,permissions:m}=s;return{type:u,ctime:g,mtime:k,size:b,permissions:m}}$stat(s,u){return Promise.resolve(this._getFsProvider(s).stat(a.URI.revive(u))).then(g=>n._asIStat(g))}$readdir(s,u){return Promise.resolve(this._getFsProvider(s).readDirectory(a.URI.revive(u)))}$readFile(s,u){return Promise.resolve(this._getFsProvider(s).readFile(a.URI.revive(u))).then(g=>C.VSBuffer.wrap(g))}$writeFile(s,u,g,k){return Promise.resolve(this._getFsProvider(s).writeFile(a.URI.revive(u),g.buffer,k))}$delete(s,u,g){return Promise.resolve(this._getFsProvider(s).delete(a.URI.revive(u),g))}$rename(s,u,g,k){return Promise.resolve(this._getFsProvider(s).rename(a.URI.revive(u),a.URI.revive(g),k))}$copy(s,u,g,k){const b=this._getFsProvider(s);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(a.URI.revive(u),a.URI.revive(g),k))}$mkdir(s,u){return Promise.resolve(this._getFsProvider(s).createDirectory(a.URI.revive(u)))}$watch(s,u,g,k){const b=this._getFsProvider(s).watch(a.URI.revive(g),k);this._watches.set(u,b)}$unwatch(s,u){const g=this._watches.get(u);g&&(g.dispose(),this._watches.delete(u))}$open(s,u,g){const k=this._getFsProvider(s);if(!k.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(k.open(a.URI.revive(u),g))}$close(s,u){const g=this._getFsProvider(s);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(u))}$read(s,u,g,k){const b=this._getFsProvider(s);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const m=C.VSBuffer.alloc(k);return Promise.resolve(b.read(u,g,m.buffer,0,k)).then(f=>m.slice(0,f))}$write(s,u,g,k){const b=this._getFsProvider(s);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(u,g,k.buffer,0,k.byteLength))}_getFsProvider(s){const u=this._fsProvider.get(s);if(!u){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return u}}e.ExtHostFileSystem=n}),define(Ee[49],_e([0,1,5,45,7,22,4,13,31,6]),function(oe,e,a,F,w,T,t,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Ht{constructor(n,d){this._fileSystemProvider=new Map,this._proxy=n.getProxy(a.MainContext.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(u){try{const g=s._fileSystemProvider.get(u.scheme);if(!g)return await s._proxy.$stat(u);await s._proxy.$ensureActivation(u.scheme);const k=await g.stat(u);return{type:k.type,ctime:k.ctime,mtime:k.mtime,size:k.size,permissions:k.permissions}}catch(g){Ht._handleError(g)}},async readDirectory(u){try{const g=s._fileSystemProvider.get(u.scheme);return g?(await s._proxy.$ensureActivation(u.scheme),(await g.readDirectory(u)).slice()):await s._proxy.$readdir(u)}catch(g){return Ht._handleError(g)}},async createDirectory(u){try{return await s._proxy.$mkdir(u)}catch(g){return Ht._handleError(g)}},async readFile(u){try{const g=s._fileSystemProvider.get(u.scheme);return g?(await s._proxy.$ensureActivation(u.scheme),(await g.readFile(u)).slice()):(await s._proxy.$readFile(u)).buffer}catch(g){return Ht._handleError(g)}},async writeFile(u,g){try{return await s._proxy.$writeFile(u,T.VSBuffer.wrap(g))}catch(k){return Ht._handleError(k)}},async delete(u,g){try{const k=s._fileSystemProvider.get(u.scheme);return k?(await s._proxy.$ensureActivation(u.scheme),await k.delete(u,{recursive:!1,...g})):await s._proxy.$delete(u,{recursive:!1,useTrash:!1,...g})}catch(k){return Ht._handleError(k)}},async rename(u,g,k){try{return await s._proxy.$rename(u,g,{overwrite:!1,...k})}catch(b){return Ht._handleError(b)}},async copy(u,g,k){try{return await s._proxy.$copy(u,g,{overwrite:!1,...k})}catch(b){return Ht._handleError(b)}},isWritableFileSystem(u){const g=d.getCapabilities(u);if(typeof g=="number")return!(g&2048)}})}static _handleError(n){if(n instanceof w.FileSystemError)throw n;if(!(n instanceof Error))throw new w.FileSystemError(String(n));if(n.name==="ENOPRO")throw w.FileSystemError.Unavailable(n.message);switch(n.name){case F.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(n.message);case F.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(n.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(n.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(n.message);case F.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(n.message);case F.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(n.message);default:throw new w.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,d){return this._fileSystemProvider.set(n,d),(0,C.toDisposable)(()=>this._fileSystemProvider.delete(n))}};R=xe([$e(0,A.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,t.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[187],_e([0,1,2,38]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(t,A,S,C){this._extHostNotebooks=A,this._textDocumentsAndEditors=S,this._commands=C;const R=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new F.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new F.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new F.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new F.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:a.URI.revive(_.notebookUri),inputUri:a.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:a.URI.revive(_.notebookUri),inputUri:a.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(t,A,S,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:S,uri:t,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(t,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[t]})}}e.ExtHostInteractive=w}),define(Ee[188],_e([0,1,6,5]),function(oe,e,a,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(t){this._handlePool=0,this._proxy=t.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(t){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,t),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=w}),define(Ee[189],_e([0,1,2,27,8,7,5,9,59,16,11,229,6,80,52,64,190,15,3]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor($,K){this._documents=$,this._provider=K}async provideDocumentSymbols($,K){const X=this._documents.getDocument($),se=await this._provider.provideDocumentSymbols(X,K);if(!(0,C.isFalsyOrEmpty)(se))return se[0]instanceof T.DocumentSymbol?se.map(w.DocumentSymbol.from):m._asDocumentSymbolTree(se)}static _asDocumentSymbolTree($){$=$.slice(0).sort((se,j)=>{let Z=se.location.range.start.compareTo(j.location.range.start);return Z===0&&(Z=j.location.range.end.compareTo(se.location.range.end)),Z});const K=[],X=[];for(const se of $){const j={name:se.name||"!!MISSING: name!!",kind:w.SymbolKind.from(se.kind),tags:se.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:w.Range.from(se.location.range),selectionRange:w.Range.from(se.location.range),children:[]};for(;;){if(X.length===0){X.push(j),K.push(j);break}const Z=X[X.length-1];if(S.Range.containsRange(Z.range,j.range)&&!S.Range.equalsRange(Z.range,j.range)){Z.children&&Z.children.push(j),X.push(j);break}X.pop()}}return K}}class f{constructor($,K,X){this._documents=$,this._commands=K,this._provider=X,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,K){const X=this._documents.getDocument($),se=await this._provider.provideCodeLenses(X,K);if(!se||K.isCancellationRequested)return;const j=this._cache.add(se),Z=new n.DisposableStore;this._disposables.set(j,Z);const fe={cacheId:j,lenses:[]};for(let Te=0;Te<se.length;Te++)fe.lenses.push({cacheId:[j,Te],range:w.Range.from(se[Te].range),command:this._commands.toInternal(se[Te].command,Z)});return fe}async resolveCodeLens($,K){const X=$.cacheId&&this._cache.get(...$.cacheId);if(!X)return;let se;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?se=X:se=await this._provider.resolveCodeLens(X,K),se||(se=X),K.isCancellationRequested)return;const j=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!j)return $.command=this._commands.toInternal(se.command??f._badCmd,j),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function P(Qe){return Array.isArray(Qe)?Qe.map(w.DefinitionLink.from):Qe?[w.DefinitionLink.from(Qe)]:[]}class l{constructor($,K){this._documents=$,this._provider=K}async provideDefinition($,K,X){const se=this._documents.getDocument($),j=w.Position.to(K),Z=await this._provider.provideDefinition(se,j,X);return P(Z)}}class M{constructor($,K){this._documents=$,this._provider=K}async provideDeclaration($,K,X){const se=this._documents.getDocument($),j=w.Position.to(K),Z=await this._provider.provideDeclaration(se,j,X);return P(Z)}}class r{constructor($,K){this._documents=$,this._provider=K}async provideImplementation($,K,X){const se=this._documents.getDocument($),j=w.Position.to(K),Z=await this._provider.provideImplementation(se,j,X);return P(Z)}}class i{constructor($,K){this._documents=$,this._provider=K}async provideTypeDefinition($,K,X){const se=this._documents.getDocument($),j=w.Position.to(K),Z=await this._provider.provideTypeDefinition(se,j,X);return P(Z)}}class p{constructor($,K){this._documents=$,this._provider=K}async provideHover($,K,X){const se=this._documents.getDocument($),j=w.Position.to(K),Z=await this._provider.provideHover(se,j,X);if(!(!Z||(0,C.isFalsyOrEmpty)(Z.contents)))return Z.range||(Z.range=se.getWordRangeAtPosition(j)),Z.range||(Z.range=new T.Range(j,j)),w.Hover.from(Z)}}class h{constructor($,K){this._documents=$,this._provider=K}async provideEvaluatableExpression($,K,X){const se=this._documents.getDocument($),j=w.Position.to(K),Z=await this._provider.provideEvaluatableExpression(se,j,X);if(Z)return w.EvaluatableExpression.from(Z)}}class o{constructor($,K){this._documents=$,this._provider=K}async provideInlineValues($,K,X,se){const j=this._documents.getDocument($),Z=await this._provider.provideInlineValues(j,w.Range.to(K),w.InlineValueContext.to(X),se);if(Array.isArray(Z))return Z.map(fe=>w.InlineValue.from(fe))}}class v{constructor($,K){this._documents=$,this._provider=K}async provideDocumentHighlights($,K,X){const se=this._documents.getDocument($),j=w.Position.to(K),Z=await this._provider.provideDocumentHighlights(se,j,X);if(Array.isArray(Z))return Z.map(w.DocumentHighlight.from)}}class c{constructor($,K){this._documents=$,this._provider=K}async provideLinkedEditingRanges($,K,X){const se=this._documents.getDocument($),j=w.Position.to(K),Z=await this._provider.provideLinkedEditingRanges(se,j,X);if(Z&&Array.isArray(Z.ranges))return{ranges:(0,C.coalesce)(Z.ranges.map(w.Range.from)),wordPattern:Z.wordPattern}}}class E{constructor($,K){this._documents=$,this._provider=K}async provideReferences($,K,X,se){const j=this._documents.getDocument($),Z=w.Position.to(K),fe=await this._provider.provideReferences(j,Z,X,se);if(Array.isArray(fe))return fe.map(w.location.from)}}class I{constructor($,K,X,se,j,Z,fe){this._documents=$,this._commands=K,this._diagnostics=X,this._provider=se,this._logService=j,this._extension=Z,this._apiDeprecation=fe,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,K,X,se){const j=this._documents.getDocument($),Z=_.Selection.isISelection(K)?w.Selection.to(K):w.Range.to(K),fe=[];for(const st of this._diagnostics.getDiagnostics($))if(Z.intersection(st.range)&&fe.push(st)>I._maxCodeActionsPerFile)break;const Te={diagnostics:fe,only:X.only?new T.CodeActionKind(X.only):void 0,triggerKind:w.CodeActionTriggerKind.to(X.trigger)},Ne=await this._provider.provideCodeActions(j,Z,Te,se);if(!(0,C.isNonEmptyArray)(Ne)||se.isCancellationRequested)return;const He=this._cache.add(Ne),Ge=new n.DisposableStore;this._disposables.set(He,Ge);const tt=[];for(let st=0;st<Ne.length;st++){const Xe=Ne[st];!Xe||(I._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,Ge)})):(Te.only&&(Xe.kind?Te.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[He,st],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,Ge),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(w.Diagnostic.from),edit:Xe.edit&&w.WorkspaceEdit.from(Xe.edit),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:He,actions:tt}}async resolveCodeAction($,K){const[X,se]=$,j=this._cache.get(X,se);if(!j||I._isCommand(j)||!this._provider.resolveCodeAction)return;const Z=await this._provider.resolveCodeAction(j,K)??j;return Z?.edit?w.WorkspaceEdit.from(Z.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}I._maxCodeActionsPerFile=1e3;class D{constructor($,K){this._documents=$,this._provider=K}async provideDocumentFormattingEdits($,K,X){const se=this._documents.getDocument($),j=await this._provider.provideDocumentFormattingEdits(se,K,X);if(Array.isArray(j))return j.map(w.TextEdit.from)}}class B{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeFormattingEdits($,K,X,se){const j=this._documents.getDocument($),Z=w.Range.to(K),fe=await this._provider.provideDocumentRangeFormattingEdits(j,Z,X,se);if(Array.isArray(fe))return fe.map(w.TextEdit.from)}}class L{constructor($,K){this._documents=$,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,K,X,se,j){const Z=this._documents.getDocument($),fe=w.Position.to(K),Te=await this._provider.provideOnTypeFormattingEdits(Z,fe,X,se,j);if(Array.isArray(Te))return Te.map(w.TextEdit.from)}}class y{constructor($,K){this._provider=$,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,K){const X=t.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols($,K);if((0,C.isNonEmptyArray)(se))for(const j of se){if(!j)continue;if(!j.name){this._logService.warn("INVALID SymbolInformation, lacks name",j);continue}const Z=t.IdObject.mixin(w.WorkspaceSymbol.from(j));this._symbolCache.set(Z._id,j),X.symbols.push(Z)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol($,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const X=this._symbolCache.get($._id);if(X){const se=await this._provider.resolveWorkspaceSymbol(X,K);return se&&(0,F.mixin)($,w.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols($){const K=this._resultCache.get($);if(K){for(let[X,se]=K;X<=se;X++)this._symbolCache.delete(X);this._resultCache.delete($)}}}class x{constructor($,K,X){this._documents=$,this._provider=K,this._logService=X}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,K,X,se){const j=this._documents.getDocument($),Z=w.Position.to(K);try{const fe=await this._provider.provideRenameEdits(j,Z,X,se);return fe?w.WorkspaceEdit.from(fe):void 0}catch(fe){const Te=x._asMessage(fe);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation($,K,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument($),j=w.Position.to(K);try{const Z=await this._provider.prepareRename(se,j,X);let fe,Te;if(T.Range.isRange(Z)?(fe=Z,Te=se.getText(Z)):(0,R.isObject)(Z)&&(fe=Z.range,Te=Z.placeholder),!fe||!Te)return;if(fe.start.line>j.line||fe.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(fe),text:Te}}catch(Z){const fe=x._asMessage(Z);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(Z)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class N{constructor($,K){this.resultId=$,this.tokens=K}}class z{constructor($,K){this._documents=$,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,K,X){const se=this._documents.getDocument($),j=K!==0?this._previousResults.get(K):null;let Z=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,j.resultId,X):await this._provider.provideDocumentSemanticTokens(se,X);return j&&this._previousResults.delete(K),Z?(Z=z._fixProvidedSemanticTokens(Z),this._send(z._convertToEdits(j,Z),Z)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return z._isSemanticTokens($)?z._isCorrectSemanticTokens($)?$:new T.SemanticTokens(new Uint32Array($.data),$.resultId):z._isSemanticTokensEdits($)?z._isCorrectSemanticTokensEdits($)?$:new T.SemanticTokensEdits($.edits.map(K=>new T.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const K of $.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,K){if(!z._isSemanticTokens(K)||!$||!$.tokens)return K;const X=$.tokens,se=X.length,j=K.data,Z=j.length;let fe=0;const Te=Math.min(se,Z);for(;fe<Te&&X[fe]===j[fe];)fe++;if(fe===se&&fe===Z)return new T.SemanticTokensEdits([],K.resultId);let Ne=0;const He=Te-fe;for(;Ne<He&&X[se-Ne-1]===j[Z-Ne-1];)Ne++;return new T.SemanticTokensEdits([{start:fe,deleteCount:se-fe-Ne,data:j.subarray(fe,Z-Ne)}],K.resultId)}_send($,K){if(z._isSemanticTokens($)){const X=this._nextResultId++;return this._previousResults.set(X,new N($.resultId,$.data)),(0,d.encodeSemanticTokensDto)({id:X,type:"full",data:$.data})}if(z._isSemanticTokensEdits($)){const X=this._nextResultId++;return z._isSemanticTokens(K)?this._previousResults.set(X,new N(K.resultId,K.data)):this._previousResults.set(X,new N($.resultId)),(0,d.encodeSemanticTokensDto)({id:X,type:"delta",deltas:($.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class H{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeSemanticTokens($,K,X){const se=this._documents.getDocument($),j=await this._provider.provideDocumentRangeSemanticTokens(se,w.Range.to(K),X);return j?this._send(j):null}_send($){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=H;class q{constructor($,K,X,se,j){this._documents=$,this._commands=K,this._provider=X,this._apiDeprecation=se,this._extension=j,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,K,X,se){const j=this._documents.getDocument($),Z=w.Position.to(K),fe=j.getWordRangeAtPosition(Z)||new T.Range(Z,Z),Te=fe.with({end:Z}),Ne=new g.StopWatch(!0),He=await this._provider.provideCompletionItems(j,Z,se,w.CompletionContext.to(X));if(!He||se.isCancellationRequested)return;const Ge=Array.isArray(He)?new T.CompletionList(He):He,tt=q.supportsResolving(this._provider)?this._cache.add(Ge.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(tt,st);const Xe=[],rt={x:tt,b:Xe,a:{replace:w.Range.from(fe),insert:w.Range.from(Te)},c:Ge.isIncomplete||void 0,d:Ne.elapsed()};for(let De=0;De<Ge.items.length;De++){const gt=Ge.items[De],V=this._convertCompletionItem(gt,[tt,De],Te,fe);Xe.push(V)}return rt}async resolveCompletionItem($,K){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...$);if(!X)return;const se=await this._provider.resolveCompletionItem(X,K);if(!!se)return this._convertCompletionItem(se,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,K,X,se){const j=this._disposables.get(K[0]);if(!j)throw Error("DisposableStore is missing...");const Z={x:K,a:$.label,b:$.kind!==void 0?w.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(w.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:w.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal($.command,j)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Z.h=$.textEdit.newText):typeof $.insertText=="string"?Z.h=$.insertText:$.insertText instanceof T.SnippetString&&(Z.h=$.insertText.value,Z.i|=4);let fe;return $.textEdit?fe=$.textEdit.range:$.range&&(fe=$.range),T.Range.isRange(fe)?Z.j=w.Range.from(fe):fe&&(!X?.isEqual(fe.inserting)||!se?.isEqual(fe.replacing))&&(Z.j={insert:w.Range.from(fe.inserting),replace:w.Range.from(fe.replacing)}),Z}}class ue{constructor($,K,X){this._documents=$,this._provider=K,this._commands=X,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,K,X,se){const j=this._documents.getDocument($),Z=w.Position.to(K),fe=await this._provider.provideInlineCompletionItems(j,Z,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:w.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text,isSnippetText:X.selectedSuggestionInfo.isSnippetText,completionKind:w.CompletionItemKind.to(X.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:X.triggerKind},se);if(!fe||se.isCancellationRequested)return;const Te=(0,R.isArray)(fe)?{items:fe}:fe,Ne=this._cache.add(Te.items);let He;return{pid:Ne,items:Te.items.map((Ge,tt)=>{let st;return Ge.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ne,He)),st=this._commands.toInternal(Ge.command,He)),{text:Ge.text,range:Ge.range?w.Range.from(Ge.range):void 0,command:st,idx:tt}})}}disposeCompletions($){this._cache.delete($);const K=this._disposables.get($);K&&K.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,K){const X=this._cache.get($,K);X&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let K=G.map.get($);return K||(K=new G,G.map.set($,K)),K}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=G,G.map=new WeakMap;class ce{constructor($,K){this._documents=$,this._provider=K,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp($,K,X,se){const j=this._documents.getDocument($),Z=w.Position.to(K),fe=this.reviveContext(X),Te=await this._provider.provideSignatureHelp(j,Z,se,fe);if(Te){const Ne=this._cache.add([Te]);return{...w.SignatureHelp.from(Te),id:Ne}}}reviveContext($){let K;if($.activeSignatureHelp){const X=w.SignatureHelp.to($.activeSignatureHelp),se=this._cache.get($.activeSignatureHelp.id,0);se?(K=se,K.activeSignature=X.activeSignature,K.activeParameter=X.activeParameter):K=X}return{...$,activeSignatureHelp:K}}releaseSignatureHelp($){this._cache.delete($)}}class de{constructor($,K){this._documents=$,this._provider=K}async provideInlayHints($,K,X){const se=this._documents.getDocument($),j=await this._provider.provideInlayHints(se,w.Range.to(K),X);return j?{hints:j.map(w.InlayHint.from)}:void 0}}class Q{constructor($,K){this._documents=$,this._provider=K,this._cache=new u.Cache("DocumentLink")}async provideLinks($,K){const X=this._documents.getDocument($),se=await this._provider.provideDocumentLinks(X,K);if(!(!Array.isArray(se)||se.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(Q._validateLink).map(w.DocumentLink.from)};{const j=this._cache.add(se),Z={links:[],id:j};for(let fe=0;fe<se.length;fe++){if(!Q._validateLink(se[fe]))continue;const Te=w.DocumentLink.from(se[fe]);Te.cacheId=[j,fe],Z.links.push(Te)}return Z}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,K){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...$);if(!X)return;const se=await this._provider.resolveDocumentLink(X,K);if(!(!se||!Q._validateLink(se)))return w.DocumentLink.from(se)}releaseLinks($){this._cache.delete($)}}class ie{constructor($,K){this._documents=$,this._provider=K}async provideColors($,K){const X=this._documents.getDocument($),se=await this._provider.provideDocumentColors(X,K);return Array.isArray(se)?se.map(Z=>({color:w.Color.from(Z.color),range:w.Range.from(Z.range)})):[]}async provideColorPresentations($,K,X){const se=this._documents.getDocument($),j=w.Range.to(K.range),Z=w.Color.to(K.color),fe=await this._provider.provideColorPresentations(Z,{document:se,range:j},X);if(!!Array.isArray(fe))return fe.map(w.ColorPresentation.from)}}class we{constructor($,K){this._documents=$,this._provider=K}async provideFoldingRanges($,K,X){const se=this._documents.getDocument($),j=await this._provider.provideFoldingRanges(se,K,X);if(!!Array.isArray(j))return j.map(w.FoldingRange.from)}}class Me{constructor($,K,X){this._documents=$,this._provider=K,this._logService=X}async provideSelectionRanges($,K,X){const se=this._documents.getDocument($),j=K.map(w.Position.to),Z=await this._provider.provideSelectionRanges(se,j,X);if(!(0,C.isNonEmptyArray)(Z))return[];if(Z.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Te=0;Te<j.length;Te++){const Ne=[];fe.push(Ne);let He=j[Te],Ge=Z[Te];for(;;){if(!Ge.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(w.SelectionRange.from(Ge)),!Ge.parent)break;He=Ge.range,Ge=Ge.parent}}return fe}}class Fe{constructor($,K){this._documents=$,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession($,K,X){const se=this._documents.getDocument($),j=w.Position.to(K),Z=await this._provider.prepareCallHierarchy(se,j,X);if(!Z)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(Z)?Z.map(Te=>this._cacheAndConvertItem(fe,Te)):[this._cacheAndConvertItem(fe,Z)]}async provideCallsTo($,K,X){const se=this._itemFromCache($,K);if(!se)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(se,X);if(!!j)return j.map(Z=>({from:this._cacheAndConvertItem($,Z.from),fromRanges:Z.fromRanges.map(fe=>w.Range.from(fe))}))}async provideCallsFrom($,K,X){const se=this._itemFromCache($,K);if(!se)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(se,X);if(!!j)return j.map(Z=>({to:this._cacheAndConvertItem($,Z.to),fromRanges:Z.fromRanges.map(fe=>w.Range.from(fe))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const X=this._cache.get($),se=w.CallHierarchyItem.from(K,$,X.size.toString(36));return X.set(se._itemId,K),se}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class Be{constructor($,K){this._documents=$,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession($,K,X){const se=this._documents.getDocument($),j=w.Position.to(K),Z=await this._provider.prepareTypeHierarchy(se,j,X);if(!Z)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(Z)?Z.map(Te=>this._cacheAndConvertItem(fe,Te)):[this._cacheAndConvertItem(fe,Z)]}async provideSupertypes($,K,X){const se=this._itemFromCache($,K);if(!se)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(se,X);if(!!j)return j.map(Z=>this._cacheAndConvertItem($,Z))}async provideSubtypes($,K,X){const se=this._itemFromCache($,K);if(!se)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(se,X);if(!!j)return j.map(Z=>this._cacheAndConvertItem($,Z))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const X=this._cache.get($),se=w.TypeHierarchyItem.from(K,$,X.size.toString(36));return X.set(se._itemId,K),se}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class Ke{constructor($,K){this.adapter=$,this.extension=K}}class je{constructor($,K,X,se,j,Z,fe){this._adapter=new Map,this._uriTransformer=K,this._proxy=$.getProxy(t.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=se,this._diagnostics=j,this._logService=Z,this._apiDeprecation=fe}_transformDocumentSelector($){return w.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new T.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return je._handlePool++}_withAdapter($,K,X,se,j=!1){const Z=this._adapter.get($);if(!Z)return Promise.resolve(se);if(Z.adapter instanceof K){let fe;Z.extension&&(fe=Date.now(),this._logService.trace(`[${Z.extension.identifier.value}] INVOKE provider '${K.name}'`));const Te=X(Z.adapter,Z.extension),Ne=Z.extension;return Ne&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Ne.identifier.value}] provider DONE after ${Date.now()-fe}ms`),He=>{j&&He instanceof k.CancellationError||(this._logService.error(`[${Ne.identifier.value}] provider FAILED`),this._logService.error(He))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,K){const X=this._nextHandle();return this._adapter.set(X,new Ke($,K)),X}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,K,X,se){const j=this._addNewAdapter(new m(this._documents,X),$),Z=se&&se.label||je._extLabel($);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(K),Z),this._createDisposable(j)}$provideDocumentSymbols($,K,X){return this._withAdapter($,m,se=>se.provideDocumentSymbols(a.URI.revive(K),X),void 0)}registerCodeLensProvider($,K,X){const se=this._nextHandle(),j=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ke(new f(this._documents,this._commands.converter,X),$)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(K),j);let Z=this._createDisposable(se);if(j!==void 0){const fe=X.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(j));Z=T.Disposable.from(Z,fe)}return Z}$provideCodeLenses($,K,X){return this._withAdapter($,f,se=>se.provideCodeLenses(a.URI.revive(K),X),void 0)}$resolveCodeLens($,K,X){return this._withAdapter($,f,se=>se.resolveCodeLens(K,X),void 0)}$releaseCodeLenses($,K){this._withAdapter($,f,X=>Promise.resolve(X.releaseCodeLenses(K)),void 0)}registerDefinitionProvider($,K,X){const se=this._addNewAdapter(new l(this._documents,X),$);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDefinition($,K,X,se){return this._withAdapter($,l,j=>j.provideDefinition(a.URI.revive(K),X,se),[])}registerDeclarationProvider($,K,X){const se=this._addNewAdapter(new M(this._documents,X),$);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDeclaration($,K,X,se){return this._withAdapter($,M,j=>j.provideDeclaration(a.URI.revive(K),X,se),[])}registerImplementationProvider($,K,X){const se=this._addNewAdapter(new r(this._documents,X),$);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideImplementation($,K,X,se){return this._withAdapter($,r,j=>j.provideImplementation(a.URI.revive(K),X,se),[])}registerTypeDefinitionProvider($,K,X){const se=this._addNewAdapter(new i(this._documents,X),$);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideTypeDefinition($,K,X,se){return this._withAdapter($,i,j=>j.provideTypeDefinition(a.URI.revive(K),X,se),[])}registerHoverProvider($,K,X,se){const j=this._addNewAdapter(new p(this._documents,X),$);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideHover($,K,X,se){return this._withAdapter($,p,j=>j.provideHover(a.URI.revive(K),X,se),void 0)}registerEvaluatableExpressionProvider($,K,X,se){const j=this._addNewAdapter(new h(this._documents,X),$);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideEvaluatableExpression($,K,X,se){return this._withAdapter($,h,j=>j.provideEvaluatableExpression(a.URI.revive(K),X,se),void 0)}registerInlineValuesProvider($,K,X,se){const j=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new o(this._documents,X),$);this._proxy.$registerInlineValuesProvider(Z,this._transformDocumentSelector(K),j);let fe=this._createDisposable(Z);if(j!==void 0){const Te=X.onDidChangeInlineValues(Ne=>this._proxy.$emitInlineValuesEvent(j));fe=T.Disposable.from(fe,Te)}return fe}$provideInlineValues($,K,X,se,j){return this._withAdapter($,o,Z=>Z.provideInlineValues(a.URI.revive(K),X,se,j),void 0)}registerDocumentHighlightProvider($,K,X){const se=this._addNewAdapter(new v(this._documents,X),$);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentHighlights($,K,X,se){return this._withAdapter($,v,j=>j.provideDocumentHighlights(a.URI.revive(K),X,se),void 0)}registerLinkedEditingRangeProvider($,K,X){const se=this._addNewAdapter(new c(this._documents,X),$);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideLinkedEditingRanges($,K,X,se){return this._withAdapter($,c,async j=>{const Z=await j.provideLinkedEditingRanges(a.URI.revive(K),X,se);if(Z)return{ranges:Z.ranges,wordPattern:Z.wordPattern?je._serializeRegExp(Z.wordPattern):void 0}},void 0)}registerReferenceProvider($,K,X){const se=this._addNewAdapter(new E(this._documents,X),$);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideReferences($,K,X,se,j){return this._withAdapter($,E,Z=>Z.provideReferences(a.URI.revive(K),X,se,j),void 0)}registerCodeActionProvider($,K,X,se){const j=new n.DisposableStore,Z=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,X,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(Z,this._transformDocumentSelector(K),{providedKinds:se?.providedCodeActionKinds?.map(fe=>fe.value),documentation:se?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,j)}))},je._extLabel($),Boolean(X.resolveCodeAction)),j.add(this._createDisposable(Z)),j}$provideCodeActions($,K,X,se,j){return this._withAdapter($,I,Z=>Z.provideCodeActions(a.URI.revive(K),X,se,j),void 0)}$resolveCodeAction($,K,X){return this._withAdapter($,I,se=>se.resolveCodeAction(K,X),void 0)}$releaseCodeActions($,K){this._withAdapter($,I,X=>Promise.resolve(X.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider($,K,X){const se=this._addNewAdapter(new D(this._documents,X),$);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(se)}$provideDocumentFormattingEdits($,K,X,se){return this._withAdapter($,D,j=>j.provideDocumentFormattingEdits(a.URI.revive(K),X,se),void 0)}registerDocumentRangeFormattingEditProvider($,K,X){const se=this._addNewAdapter(new B(this._documents,X),$);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits($,K,X,se,j){return this._withAdapter($,B,Z=>Z.provideDocumentRangeFormattingEdits(a.URI.revive(K),X,se,j),void 0)}registerOnTypeFormattingEditProvider($,K,X,se){const j=this._addNewAdapter(new L(this._documents,X),$);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(K),se,$.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits($,K,X,se,j,Z){return this._withAdapter($,L,fe=>fe.provideOnTypeFormattingEdits(a.URI.revive(K),X,se,j,Z),void 0)}registerWorkspaceSymbolProvider($,K){const X=this._addNewAdapter(new y(K,this._logService),$);return this._proxy.$registerNavigateTypeSupport(X,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols($,K,X){return this._withAdapter($,y,se=>se.provideWorkspaceSymbols(K,X),{symbols:[]})}$resolveWorkspaceSymbol($,K,X){return this._withAdapter($,y,se=>se.resolveWorkspaceSymbol(K,X),void 0)}$releaseWorkspaceSymbols($,K){this._withAdapter($,y,X=>X.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider($,K,X){const se=this._addNewAdapter(new x(this._documents,X,this._logService),$);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(K),x.supportsResolving(X)),this._createDisposable(se)}$provideRenameEdits($,K,X,se,j){return this._withAdapter($,x,Z=>Z.provideRenameEdits(a.URI.revive(K),X,se,j),void 0)}$resolveRenameLocation($,K,X,se){return this._withAdapter($,x,j=>j.resolveRenameLocation(a.URI.revive(K),X,se),void 0)}registerDocumentSemanticTokensProvider($,K,X,se){const j=this._nextHandle(),Z=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(j,new Ke(new z(this._documents,X),$)),this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(K),se,Z);let fe=this._createDisposable(j);if(Z){const Te=X.onDidChangeSemanticTokens(Ne=>this._proxy.$emitDocumentSemanticTokensEvent(Z));fe=T.Disposable.from(fe,Te)}return fe}$provideDocumentSemanticTokens($,K,X,se){return this._withAdapter($,z,j=>j.provideDocumentSemanticTokens(a.URI.revive(K),X,se),null,!0)}$releaseDocumentSemanticTokens($,K){this._withAdapter($,z,X=>X.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider($,K,X,se){const j=this._addNewAdapter(new H(this._documents,X),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(K),se),this._createDisposable(j)}$provideDocumentRangeSemanticTokens($,K,X,se){return this._withAdapter($,H,j=>j.provideDocumentRangeSemanticTokens(a.URI.revive(K),X,se),null,!0)}registerCompletionItemProvider($,K,X,se){const j=this._addNewAdapter(new q(this._documents,this._commands.converter,X,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(K),se,q.supportsResolving(X),`${$.identifier.value}(${se.join("")})`),this._createDisposable(j)}$provideCompletionItems($,K,X,se,j){return this._withAdapter($,q,Z=>Z.provideCompletionItems(a.URI.revive(K),X,se,j),void 0)}$resolveCompletionItem($,K,X){return this._withAdapter($,q,se=>se.resolveCompletionItem(K,X),void 0)}$releaseCompletionItems($,K){this._withAdapter($,q,X=>X.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider($,K,X){const se=this._addNewAdapter(new ue(this._documents,X,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideInlineCompletions($,K,X,se,j){return this._withAdapter($,ue,Z=>Z.provideInlineCompletions(a.URI.revive(K),X,se,j),void 0)}$handleInlineCompletionDidShow($,K,X){this._withAdapter($,ue,async se=>{se.handleDidShowCompletionItem(K,X)},void 0)}$freeInlineCompletionsList($,K){this._withAdapter($,ue,async X=>{X.disposeCompletions(K)},void 0)}registerSignatureHelpProvider($,K,X,se){const j=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,Z=this._addNewAdapter(new ce(this._documents,X),$);return this._proxy.$registerSignatureHelpProvider(Z,this._transformDocumentSelector(K),j),this._createDisposable(Z)}$provideSignatureHelp($,K,X,se,j){return this._withAdapter($,ce,Z=>Z.provideSignatureHelp(a.URI.revive(K),X,se,j),void 0)}$releaseSignatureHelp($,K){this._withAdapter($,ce,X=>X.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider($,K,X){const se=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new de(this._documents,X),$);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(K),se);let Z=this._createDisposable(j);if(se!==void 0){const fe=X.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(se));Z=T.Disposable.from(Z,fe)}return Z}$provideInlayHints($,K,X,se){return this._withAdapter($,de,j=>j.provideInlayHints(a.URI.revive(K),X,se),void 0)}registerDocumentLinkProvider($,K,X){const se=this._addNewAdapter(new Q(this._documents,X),$);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(K),typeof X.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks($,K,X){return this._withAdapter($,Q,se=>se.provideLinks(a.URI.revive(K),X),void 0)}$resolveDocumentLink($,K,X){return this._withAdapter($,Q,se=>se.resolveLink(K,X),void 0)}$releaseDocumentLinks($,K){this._withAdapter($,Q,X=>X.releaseLinks(K),void 0)}registerColorProvider($,K,X){const se=this._addNewAdapter(new ie(this._documents,X),$);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentColors($,K,X){return this._withAdapter($,ie,se=>se.provideColors(a.URI.revive(K),X),[])}$provideColorPresentations($,K,X,se){return this._withAdapter($,ie,j=>j.provideColorPresentations(a.URI.revive(K),X,se),void 0)}registerFoldingRangeProvider($,K,X){const se=this._nextHandle(),j=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ke(new we(this._documents,X),$)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(K),j);let Z=this._createDisposable(se);if(j!==void 0){const fe=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));Z=T.Disposable.from(Z,fe)}return Z}$provideFoldingRanges($,K,X,se){return this._withAdapter($,we,j=>j.provideFoldingRanges(a.URI.revive(K),X,se),void 0)}registerSelectionRangeProvider($,K,X){const se=this._addNewAdapter(new Me(this._documents,X,this._logService),$);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideSelectionRanges($,K,X,se){return this._withAdapter($,Me,j=>j.provideSelectionRanges(a.URI.revive(K),X,se),[])}registerCallHierarchyProvider($,K,X){const se=this._addNewAdapter(new Fe(this._documents,X),$);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareCallHierarchy($,K,X,se){return this._withAdapter($,Fe,j=>Promise.resolve(j.prepareSession(a.URI.revive(K),X,se)),void 0)}$provideCallHierarchyIncomingCalls($,K,X,se){return this._withAdapter($,Fe,j=>j.provideCallsTo(K,X,se),void 0)}$provideCallHierarchyOutgoingCalls($,K,X,se){return this._withAdapter($,Fe,j=>j.provideCallsFrom(K,X,se),void 0)}$releaseCallHierarchy($,K){this._withAdapter($,Fe,X=>Promise.resolve(X.releaseSession(K)),void 0)}registerTypeHierarchyProvider($,K,X){const se=this._addNewAdapter(new Be(this._documents,X),$);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareTypeHierarchy($,K,X,se){return this._withAdapter($,Be,j=>Promise.resolve(j.prepareSession(a.URI.revive(K),X,se)),void 0)}$provideTypeHierarchySupertypes($,K,X,se){return this._withAdapter($,Be,j=>j.provideSupertypes(K,X,se),void 0)}$provideTypeHierarchySubtypes($,K,X,se){return this._withAdapter($,Be,j=>j.provideSubtypes(K,X,se),void 0)}$releaseTypeHierarchy($,K){this._withAdapter($,Be,X=>Promise.resolve(X.releaseSession(K)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,A.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:je._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?je._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?je._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:je._serializeRegExp($.beforeText),afterText:$.afterText?je._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?je._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(je._serializeOnEnterRule)}setLanguageConfiguration($,K,X){let{wordPattern:se}=X;if(se&&(0,A.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(K,se):this._documents.setWordDefinitionFor(K,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const j=this._nextHandle(),Z={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?je._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?je._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?je._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,K,Z),this._createDisposable(j)}$setWordDefinitions($){for(const K of $)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(Ee[191],_e([0,1,5,8,7,35,14,6]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,_,n,d){this._documents=_,this._commands=n,this._uriTransformer=d,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,_){await this._proxy.$changeLanguage(R,_);const n=this._documents.getDocumentData(R);if(!n)throw new Error(`document '${R.toString}' NOT found`);return n.document}async tokenAtPosition(R,_){const n=R.version,d=F.Position.from(_),s=await this._proxy.$tokensAtPosition(R.uri,d),u={type:w.StandardTokenType.Other,range:R.getWordRangeAtPosition(_)??new w.Range(_.line,_.character,_.line,_.character)};if(!s)return u;const g={range:F.Range.to(s.range),type:F.TokenType.to(s.type)};return!g.range.contains(_)||n!==R.version?u:g}createLanguageStatusItem(R,_,n){const d=this._handlePool++,s=this._proxy,u=this._ids,g=`${R.identifier.value}/${_}`;if(u.has(g))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);u.add(g);const k={selector:n,id:_,name:R.displayName??R.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let b,m=new A.DisposableStore;const f=()=>{b?.dispose(),b=(0,t.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(d,{id:g,name:k.name??R.displayName??R.name,source:R.displayName??R.name,selector:F.DocumentSelector.from(k.selector,this._uriTransformer),label:k.text,detail:k.detail??"",severity:k.severity===w.LanguageStatusSeverity.Error?T.default.Error:k.severity===w.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:k.command&&this._commands.toInternal(k.command,m),accessibilityInfo:k.accessibilityInformation})},0)},P={dispose(){m.dispose(),b?.dispose(),s.$removeLanguageStatus(d),u.delete(g)},get id(){return k.id},get name(){return k.name},set name(l){k.name=l,f()},get selector(){return k.selector},set selector(l){k.selector=l,f()},get text(){return k.text},set text(l){k.text=l,f()},get detail(){return k.detail},set detail(l){k.detail=l,f()},get severity(){return k.severity},set severity(l){k.severity=l,f()},get accessibilityInformation(){return k.accessibilityInformation},set accessibilityInformation(l){k.accessibilityInformation=l,f()},get command(){return k.command},set command(l){k.command=l,f()}};return f(),P}}e.ExtHostLanguages=S}),define(Ee[192],_e([0,1,12,5,28,13,3]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends a.AbstractLoggerService{constructor(R,_){const n=new t.Emitter;super(_.logLevel,n.event);this._proxy=R.getProxy(F.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,_,n){return new S(this._proxy,R,_,n)}};A=xe([$e(0,T.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class S extends a.AbstractMessageLogger{constructor(R,_,n,d){super(d?.always);this.proxy=R,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(_,d).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,_){const n=[[R,_]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(R){this.proxy.$log(this.file,R)}}}),define(Ee[193],_e([0,1,5,12,26]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(A){return A&&A.title}let t=class{constructor(S,C){this._logService=C,this._proxy=S.getProxy(a.MainContext.MainThreadMessageService)}showMessage(S,C,R,_,n){const d={extension:S};let s;typeof _=="string"||T(_)?s=[_,...n]:(d.modal=_?.modal,d.useCustom=_?.useCustom,d.detail=_?.detail,s=n),d.useCustom&&(0,w.checkProposedApiEnabled)(S,"resolvers");const u=[];for(let g=0;g<s.length;g++){const k=s[g];if(typeof k=="string")u.push({title:k,handle:g,isCloseAffordance:!1});else if(typeof k=="object"){let{title:b,isCloseAffordance:m}=k;u.push({title:b,isCloseAffordance:!!m,handle:g})}else this._logService.warn("Invalid message item:",k)}return this._proxy.$showMessage(C,R,d,u).then(g=>{if(typeof g=="number")return s[g]})}};t=xe([$e(1,F.ILogService)],t),e.ExtHostMessageService=t}),define(Ee[194],_e([0,1,22,3,57,6,21,9,11,2,64,5,8,7,37,167,91]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class k{constructor(m,f,P,l,M){this._textDocumentsAndEditors=P,this._textDocuments=l,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new t.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=m.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=f.converter,f.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,p=r.cell.handle,o=this._documents.get(i)?.getCell(p);if(o)return o.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}getEditorById(m){const f=this._editors.get(m);if(!f)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);return f}getIdByEditor(m){for(const[f,P]of this._editors)if(P.apiEditor===m)return f}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,f){const P=this._documents.get(m);if(!P&&!f)throw new Error(`NO notebook document for '${m}'`);return P}_getProviderData(m){const f=this._notebookContentProviders.get(m);if(!f)throw new Error(`NO provider for '${m}'`);return f}registerNotebookContentProvider(m,f,P,l,M){if((0,A.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(f))throw new Error(`Notebook provider for '${f}' already registered`);this._notebookContentProviders.set(f,{extension:m,provider:P});let r;return P.onDidChangeNotebookContentOptions&&(r=P.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(P.options);this._notebookProxy.$updateNotebookProviderOptions(f,i)})),this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation},f,n.NotebookDocumentContentOptions.from(l),k._convertNotebookRegistrationData(m,M)),new d.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(f),this._notebookProxy.$unregisterNotebookProvider(f)})}static _convertNotebookRegistrationData(m,f){if(!f)return;const P=f.filenamePattern.map(l=>n.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(f.filenamePattern&&!P){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:f.displayName,filenamePattern:P,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,f,P){const l=k._notebookStatusBarItemProviderHandlePool++,M=typeof P.onDidChangeCellStatusBarItems=="function"?k._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,P),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,M,f);let r;return M!==void 0&&(r=P.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(M))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,M),r&&r.dispose()})}async createNotebookDocument(m){const f=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&n.NotebookData.from(m.content)});return C.URI.revive(f)}async openNotebookDocument(m){const f=this._documents.get(m);if(f)return f.apiNotebook;const P=await this._notebookDocumentsProxy.$tryOpenNotebook(m),l=this._documents.get(C.URI.revive(P));return(0,S.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(m,f){C.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let P;typeof f=="object"?P={position:n.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(n.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:P={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,P),M=l&&this._editors.get(l)?.apiEditor;if(M)return M;throw l?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,f,P,l){const M=this._notebookStatusBarItemProviders.get(m),r=C.URI.revive(f),i=this._documents.get(r);if(!i||!M)return;const p=i.getCellFromIndex(P);if(!p)return;const h=await M.provideCellStatusBarItems(p.apiCell,l);if(!h)return;const o=new T.DisposableStore,v=this._statusBarCache.add([o]),E=(Array.isArray(h)?h:[h]).map(I=>n.NotebookStatusBarItem.from(I,this._commandsConverter,o));return{cacheId:v,items:E}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,f,P,l,M){if((0,A.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,P),this._notebookProxy.$registerNotebookSerializer(r,{id:m.identifier,location:m.extensionLocation},f,n.NotebookDocumentContentOptions.from(l),k._convertNotebookRegistrationData(m,M)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(m,f,P){const l=this._notebookSerializer.get(m);if(!l)throw new Error("NO serializer found");const M=await l.deserializeNotebook(f.buffer,P);return new s.SerializableObjectWithBuffers(n.NotebookData.from(M))}async $notebookToData(m,f,P){const l=this._notebookSerializer.get(m);if(!l)throw new Error("NO serializer found");const M=await l.serializeNotebook(n.NotebookData.to(f.value),P);return a.VSBuffer.wrap(M)}async $openNotebook(m,f,P,l,M){const{provider:r}=this._getProviderData(m),i=await r.openNotebook(C.URI.revive(f),{backupId:P,untitledDocumentData:l?.buffer},M);return new s.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(m,f,P){const l=this.getNotebookDocument(C.URI.revive(f)),{provider:M}=this._getProviderData(m);return await M.saveNotebook(l.apiNotebook,P),!0}async $saveNotebookAs(m,f,P,l){const M=this.getNotebookDocument(C.URI.revive(f)),{provider:r}=this._getProviderData(m);return await r.saveNotebookAs(C.URI.revive(P),M.apiNotebook,l),!0}async $backupNotebook(m,f,P){const l=this.getNotebookDocument(C.URI.revive(f)),M=this._getProviderData(m),r=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),i=String((0,w.hash)([l.uri.toString(),this._backupIdPool++])),p=C.URI.joinPath(r,i),h=await M.provider.backupNotebook(l.apiNotebook,{destination:p},P);return l.updateBackup(h),h.id}_createExtHostEditor(m,f,P){if(this._editors.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const l=new g.ExtHostNotebookEditor(f,this._notebookEditorsProxy,m,P.visibleRanges.map(n.NotebookRange.to),P.selections.map(n.NotebookRange.to),typeof P.viewColumn=="number"?n.ViewColumn.to(P.viewColumn):void 0);this._editors.set(f,l)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const P of m.value.removedDocuments){const l=C.URI.revive(P),M=this._documents.get(l);M&&(M.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===l.toString()&&this._editors.delete(r.id)}if(m.value.addedDocuments){const P=[];for(const l of m.value.addedDocuments){const M=C.URI.revive(l.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const r=this,i=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(p){r._onDidChangeNotebookCells.fire(p)},emitCellOutputsChange(p){r._onDidChangeCellOutputs.fire(p)},emitCellMetadataChange(p){r._onDidChangeCellMetadata.fire(p)},emitCellExecutionStateChange(p){r._onDidChangeCellExecutionState.fire(p)}},M,l);P.push(...l.cells.map(p=>u.ExtHostCell.asModelAddData(i.apiNotebook,p))),this._documents.get(M)?.dispose(),this._documents.set(M,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:P}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(m.value.addedEditors)for(const P of m.value.addedEditors){if(this._editors.has(P.id))return;const l=C.URI.revive(P.documentUri),M=this._documents.get(l);M&&this._createExtHostEditor(M,P.id,P)}const f=[];if(m.value.removedEditors)for(const P of m.value.removedEditors){const l=this._editors.get(P);l&&(this._editors.delete(P),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),f.push(l))}if(m.value.visibleEditors){this._visibleNotebookEditors=m.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const P=new Set;this._visibleNotebookEditors.forEach(l=>P.add(l.id));for(const l of this._editors.values()){const M=P.has(l.id);l._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this._activeNotebookEditor=void 0:m.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=k,k._notebookStatusBarItemProviderHandlePool=0}),define(Ee[195],_e([0,1,3,52,12,5,13,8]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(_,n){const d=S._Keys.nextId();_.$registerNotebookEditorDecorationType(d,A.NotebookDecorationRenderOptions.from(n)),this.value={key:d,dispose(){_.$removeNotebookEditorDecorationType(d)}}}}S._Keys=new F.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(_,n,d){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new S(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const d=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&d._acceptVisibleRanges(n.visibleRanges.ranges.map(A.NotebookRange.to)),n.selections&&d._acceptSelections(n.selections.selections.map(A.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(A.ViewColumn.to(_[n]))}};C=xe([$e(0,w.ILogService),$e(1,t.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(Ee[196],_e([0,1,16,14,20,3,6,21,2,25,12,5,38,8,7,67,159,26,37]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let m=class{constructor(r,i,p,h,o){this._initData=i,this._extHostNotebook=p,this._commands=h,this._logService=o,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(_.MainContext.MainThreadNotebookKernels);const v=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",c=>!0,c=>{if(c&&"notebookEditor"in c&&"id"in c){const E=this._extHostNotebook.getIdByEditor(c.notebookEditor);return{id:c.id,extension:c.extension,notebookEditorId:E}}else if(c&&"notebookEditor"in c){const E=this._extHostNotebook.getIdByEditor(c.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${c.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return c})],n.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(r,i,p,h,o,v){for(let ce of this._kernelData.values())if(ce.controller.id===i&&C.ExtensionIdentifier.equals(r.identifier,ce.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const c=this._handlePool++,E=this;this._logService.trace(`NotebookController[${c}], CREATED by ${r.identifier.value}, ${i}`);const I=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${r.identifier}'`);let D=!1;const B=new t.DisposableStore,L=new T.Emitter,y=new T.Emitter,x={id:`${r.identifier.value}/${i}`,notebookType:p,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:h||r.identifier.value,preloads:v?v.map(d.NotebookRendererScript.from):[]};let N=o??I,z;this._proxy.$addKernel(c,x).catch(ce=>{console.log(ce),D=!0});let H=0;const q=()=>{if(D)return;const ce=++H;Promise.resolve().then(()=>{ce===H&&this._proxy.$updateKernel(c,x)})},ue=new A.ResourceMap,G={get id(){return i},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return x.label},set label(ce){x.label=ce??r.displayName??r.name,q()},get detail(){return x.detail??""},set detail(ce){x.detail=ce,q()},get description(){return x.description??""},set description(ce){x.description=ce,q()},get kind(){return(0,k.checkProposedApiEnabled)(r,"notebookControllerKind"),x.kind??""},set kind(ce){(0,k.checkProposedApiEnabled)(r,"notebookControllerKind"),x.kind=ce,q()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(ce){x.supportedLanguages=ce,q()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){x.supportsExecutionOrder=ce,q()},get rendererScripts(){return x.preloads?x.preloads.map(d.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(ce){N=ce??I},get interruptHandler(){return z},set interruptHandler(ce){z=ce,x.supportsInterrupt=Boolean(ce),q()},createNotebookCellExecution(ce){if(D)throw new Error("notebook controller is DISPOSED");if(!ue.has(ce.notebook.uri))throw E._logService.trace(`NotebookController[${c}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return E._createNotebookCellExecution(ce)},dispose:()=>{D||(this._logService.trace(`NotebookController[${c}], DISPOSED`),D=!0,this._kernelData.delete(c),B.dispose(),L.dispose(),y.dispose(),this._proxy.$removeKernel(c))},updateNotebookAffinity(ce,de){E._proxy.$updateNotebookPriority(c,ce.uri,de)},onDidReceiveMessage:y.event,postMessage(ce,de){return(0,k.checkProposedApiEnabled)(r,"notebookMessaging"),E._proxy.$postMessage(c,de&&E._extHostNotebook.getIdByEditor(de),ce)},asWebviewUri(ce){return(0,k.checkProposedApiEnabled)(r,"notebookMessaging"),(0,u.asWebviewUri)(ce,E._initData.remote)}};return this._kernelData.set(c,{extensionId:r.identifier,controller:G,onDidReceiveMessage:y,onDidChangeSelection:L,associatedNotebooks:ue}),G}$acceptNotebookAssociation(r,i,p){const h=this._kernelData.get(r);if(h){const o=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));p?h.associatedNotebooks.set(o.uri,!0):h.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,o.uri.toString(),p),h.onDidChangeSelection.fire({selected:p,notebook:o.apiNotebook})}}async $executeCells(r,i,p){const h=this._kernelData.get(r);if(!h)return;const o=this._extHostNotebook.getNotebookDocument(S.URI.revive(i)),v=[];for(let c of p){const E=o.getCell(c);E&&v.push(E.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,o.uri.toString(),v.length),await h.controller.executeHandler.call(h.controller,v,o.apiNotebook,h.controller)}catch(c){this._logService.error(`NotebookController[${r}] execute cells FAILED`,c),console.error(c)}}async $cancelCells(r,i,p){const h=this._kernelData.get(r);if(!h)return;const o=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,o.apiNotebook);else for(let v of p){const c=o.getCell(v);c&&this._activeExecutions.get(c.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,p){const h=this._kernelData.get(r);if(!h)return;const o=this._extHostNotebook.getEditorById(i);h.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:p}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!p)throw new Error("invalid cell");if(this._activeExecutions.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const h=new P(p.notebook,p,this._proxy);this._activeExecutions.set(p.uri,h);const o=h.onDidChangeState(()=>{h.state===f.Resolved&&(h.dispose(),o.dispose(),this._activeExecutions.delete(p.uri))});return h.asApiObject()}};m=xe([$e(4,R.ILogService)],m),e.ExtHostNotebookKernels=m;var f;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(f||(f={}));class P extends t.Disposable{constructor(r,i,p){super();this._document=r,this._cell=i,this._proxy=p,this._handle=P.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new l(10,h=>this.update(h)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===f.Init)throw new Error("Must call start before modifying cell output");if(this._state===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const p=s.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return p===i.items?d.NotebookCellOutput.from(i):d.NotebookCellOutput.from({items:p,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,p){const h=this.cellIndexToHandle(i),o=this.validateAndConvertOutputs((0,a.asArray)(r));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:h,append:p,outputs:o})}async updateOutputItems(r,i,p){return r=s.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(r),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(d.NotebookCellOutputItem.from),outputId:i.id,append:p})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(p){r._executionOrder=p,r.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(p){if(r._state===f.Resolved||r._state===f.Started)throw new Error("Cannot call start again");r._state=f.Started,r._onDidChangeState.fire(),r.update({editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:p})},end(p,h){if(r._state===f.Resolved)throw new Error("Cannot call resolve twice");r._state=f.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:g.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:h,lastRunSuccess:p}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(p){return r.verifyStateForOutput(),r.updateOutputs([],p,!1)},appendOutput(p,h){return r.verifyStateForOutput(),r.updateOutputs(p,h,!0)},replaceOutput(p,h){return r.verifyStateForOutput(),r.updateOutputs(p,h,!1)},appendOutputItems(p,h){return r.verifyStateForOutput(),r.updateOutputItems(p,h,!0)},replaceOutputItems(p,h){return r.verifyStateForOutput(),r.updateOutputItems(p,h,!1)}})}}P.HANDLE=0;class l{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(Ee[197],_e([0,1,3,5,91,26]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class t{constructor(S,C){this._extHostNotebook=C,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,C,R){const _=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(C)?.fire({editor:_.apiEditor,message:R})}createRendererMessaging(S,C){if(!S.contributes?.notebookRenderer?.some(d=>d.id===C))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${C})`);const R=(0,T.isProposedApiEnabled)(S,"notebookEditor"),_=new WeakMap;return{onDidReceiveMessage:(d,s,u)=>{const g=R?d:k=>{const b={};_.set(b,k.editor),d({editor:b,message:k.message})};return this.getOrCreateEmitterFor(C).event(g,s,u)},postMessage:(d,s)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(d)&&([d,s]=[s,d]);const u=R?s:_.get(s),g=u&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(g?.id,C,d)}}}getOrCreateEmitterFor(S){let C=this._rendererMessageEmitters.get(S);return C||(C=new a.Emitter({onLastListenerRemove:()=>{C?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,C),C)}}e.ExtHostNotebookRenderers=t}),define(Ee[94],_e([0,1,5,6,4,13,12,160,49,28,31,110,22]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class d extends F.Disposable{constructor(g,k,b,m){super();this.id=g,this.name=k,this.logger=b,this.proxy=m,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(g){this.append(g+`
`)}append(g){this.write(g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const g=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,g)}replace(g){const k=this.offset;this.write(g),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,k),this.visible&&this.logger.flush()}show(g,k){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof g=="boolean"?g:k))}hide(){this.proxy.$close(this.id)}write(g){this.offset+=n.VSBuffer.fromString(g).byteLength,this.logger.info(g)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=d;let s=class{constructor(g,k,b,m,f){this.extHostFileSystem=b,this.extHostFileSystemInfo=m,this.loggerService=f,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=g.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(k.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.visibleChannelId=g;for(const[k,b]of this.channels)b.visible=k===this.visibleChannelId}createOutputChannel(g,k){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const b=this.doCreateOutputChannel(g,k);return b.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(g,b)}async doCreateOutputChannel(g,k){const b=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(b,`${this.namePool++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),P=await this.proxy.$register(g,!1,m,k.identifier.value);return new d(P,g,f,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(g,k){let b=!1;const m=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return g},append(f){m(),k.then(P=>P.append(f))},appendLine(f){m(),k.then(P=>P.appendLine(f))},clear(){m(),k.then(f=>f.clear())},replace(f){m(),k.then(P=>P.replace(f))},show(f,P){m(),k.then(l=>l.show(f,P))},hide(){m(),k.then(f=>f.hide())},dispose(){b=!0,k.then(f=>f.dispose())}}}};s=xe([$e(0,T.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,S.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,t.ILoggerService)],s),e.ExtHostOutputService=s,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(Ee[198],_e([0,1,14,20,3,6,5,2,7,15,16,35,63,26]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function s(u,g,k){const b=u.getProxy(t.MainContext.MainThreadQuickOpen);class m{constructor(o,v){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=v}showQuickPick(o,v,c=F.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(o),I=++this._instances,D=b.$show(I,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},c),B={},L=D.then(()=>B);return Promise.race([L,E]).then(y=>{if(y!==B)return E.then(x=>{const N=[];for(let z=0;z<x.length;z++){const H=x[z];typeof H=="string"?N.push({label:H,handle:z}):H.kind===S.QuickPickItemKind.Separator?N.push({type:"separator",label:H.label}):N.push({label:H.label,description:H.description,detail:H.detail,picked:H.picked,alwaysShow:H.alwaysShow,handle:z})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{v.onDidSelectItem(x[z])}),b.$setItems(I,N),D.then(z=>{if(typeof z=="number")return x[z];if(Array.isArray(z))return z.map(H=>x[H])})})}).then(void 0,y=>{if(!(0,C.isPromiseCanceledError)(y))return b.$setError(I,y),Promise.reject(y)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,v=F.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,b.$input(o,typeof this._validateInput=="function",v).then(void 0,c=>{if(!(0,C.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(o){return this._validateInput?(0,a.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,v=F.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!c)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(I=>I.uri.toString()===c.uri.toString())}createQuickPick(o){const v=new i(o,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(o){const v=new p(o,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}$onDidChangeValue(o,v){const c=this._sessions.get(o);c&&c._fireDidChangeValue(v)}$onDidAccept(o){const v=this._sessions.get(o);v&&v._fireDidAccept()}$onDidChangeActive(o,v){const c=this._sessions.get(o);c instanceof i&&c._fireDidChangeActive(v)}$onDidChangeSelection(o,v){const c=this._sessions.get(o);c instanceof i&&c._fireDidChangeSelection(v)}$onDidTriggerButton(o,v){const c=this._sessions.get(o);c&&c._fireDidTriggerButton(v)}$onDidTriggerItemButton(o,v,c){const E=this._sessions.get(o);E instanceof i&&E._fireDidTriggerItemButton(v,c)}$onDidHide(o){const v=this._sessions.get(o);v&&v._fireDidHide()}}class f{constructor(o,v){this._extensionId=o,this._onDidDispose=v,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((v,c)=>{const E=v===S.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(E,v)}),this.update({buttons:o.map((v,c)=>({...r(v),tooltip:v.tooltip,handle:v===S.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const v=this._handlesToButtons.get(o);v&&this._onDidTriggerButtonEmitter.fire(v)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(o){if(!this._disposed){for(const v of Object.keys(o)){const c=o[v];this._pendingUpdate[v]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}f._nextId=1;function P(h){if(h instanceof S.ThemeIcon)return{id:h.id};const o=M(h),v=l(h);return{dark:typeof o=="string"?A.URI.file(o):o,light:typeof v=="string"?A.URI.file(v):v}}function l(h){return typeof h=="object"&&"light"in h?h.light:h}function M(h){return typeof h=="object"&&"dark"in h?h.dark:h}function r(h){const o=P(h.iconPath);let v,c;return"id"in o?c=n.ThemeIcon.asClassName(o):v=o,{iconPath:v,iconClass:c}}class i extends f{constructor(o,v){super(o.identifier,v);this.extension=o,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){o.some(c=>c.kind!==void 0)&&(0,d.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((c,E)=>{this._handlesToItems.set(E,c),this._itemsToHandles.set(c,E)});const v=[];for(let c=0;c<o.length;c++){const E=o[c];E.kind===S.QuickPickItemKind.Separator?v.push({type:"separator",label:E.label}):v.push({handle:c,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((I,D)=>({...r(I),tooltip:I.tooltip,handle:D}))})}this.update({items:v})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(v=>this._itemsToHandles.has(v)),this.update({activeItems:this._activeItems.map(v=>this._itemsToHandles.get(v))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(v=>this._itemsToHandles.has(v)),this.update({selectedItems:this._selectedItems.map(v=>this._itemsToHandles.get(v))})}_fireDidChangeActive(o){const v=(0,R.coalesce)(o.map(c=>this._handlesToItems.get(c)));this._activeItems=v,this._onDidChangeActiveEmitter.fire(v)}_fireDidChangeSelection(o){const v=(0,R.coalesce)(o.map(c=>this._handlesToItems.get(c)));this._selectedItems=v,this._onDidChangeSelectionEmitter.fire(v)}_fireDidTriggerItemButton(o,v){const c=this._handlesToItems.get(o);if(!c||!c.buttons||!c.buttons.length)return;const E=c.buttons[v];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:c})}}class p extends f{constructor(o,v){super(o,v);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?_.default.Error:_.default.Ignore})}}return new m(g,k)}e.createExtHostQuickOpen=s}),define(Ee[199],_e([0,1,2,3,51,6,14,5,16,105,12,25,63,8,26]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(h){if(h)return typeof h.iconPath=="string"?a.URI.file(h.iconPath):a.URI.isUri(h.iconPath)||n.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function g(h,o){if(!h.iconPath&&!o.iconPath)return 0;if(h.iconPath){if(!o.iconPath)return 1}else return-1;const v=typeof h.iconPath=="string"?h.iconPath:a.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,c=typeof o.iconPath=="string"?o.iconPath:a.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id;return(0,C.comparePaths)(v,c)}function k(h,o){let v=0;if(h.strikeThrough!==o.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==o.faded)return h.faded?1:-1;if(h.tooltip!==o.tooltip)return(h.tooltip||"").localeCompare(o.tooltip||"");if(v=g(h,o),v!==0)return v;if(h.light&&o.light)v=g(h.light,o.light);else{if(h.light)return 1;if(o.light)return-1}if(v!==0)return v;if(h.dark&&o.dark)v=g(h.dark,o.dark);else{if(h.dark)return 1;if(o.dark)return-1}return v}function b(h,o){if(h.command!==o.command)return h.command<o.command?-1:1;if(h.title!==o.title)return h.title<o.title?-1:1;if(h.tooltip!==o.tooltip){if(h.tooltip!==void 0&&o.tooltip!==void 0)return h.tooltip<o.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(h.arguments===o.arguments)return 0;if(h.arguments)if(o.arguments){if(h.arguments.length!==o.arguments.length)return h.arguments.length-o.arguments.length}else return 1;else return-1;for(let v=0;v<h.arguments.length;v++){const c=h.arguments[v],E=o.arguments[v];if(c!==E)return c<E?-1:1}return 0}function m(h,o){let v=(0,C.comparePaths)(h.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(v!==0)return v;if(h.command&&o.command)v=b(h.command,o.command);else{if(h.command)return 1;if(o.command)return-1}if(v!==0)return v;if(h.decorations&&o.decorations)v=k(h.decorations,o.decorations);else{if(h.decorations)return 1;if(o.decorations)return-1}return v}function f(h,o){for(let v=0;v<h.length;v++)if(h[v]!==o[v])return!1;return!0}function P(h,o){return h.command===o.command&&h.title===o.title&&h.tooltip===o.tooltip&&(h.arguments&&o.arguments?f(h.arguments,o.arguments):h.arguments===o.arguments)}function l(h,o){return(0,S.equals)(h,o,P)}class M{constructor(o,v,c){this._extension=o,this._proxy=v,this._sourceControlHandle=c,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(o){if((0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}showValidationMessage(o,v){(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,o,v)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=M;class r{constructor(o,v,c,E,I){this._proxy=o,this._commands=v,this._sourceControlHandle=c,this._id=E,this._label=I,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,v){const c=this._resourceStatesCommandsMap.get(o);return c?(0,t.asPromise)(()=>this._commands.executeCommand(c.command,...c.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const o=[...this._resourceStates].sort(m),c=(0,S.sortedDiff)(this._resourceSnapshot,o,m).map(D=>{const B=D.toInsert.map(L=>{const y=this._resourceHandlePool++;this._resourceStatesMap.set(y,L);const x=L.resourceUri;let N;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const we=new T.DisposableStore;N=this._commands.converter.toInternal(L.command,we),this._resourceStatesDisposablesMap.set(y,we)}else this._resourceStatesCommandsMap.set(y,L.command);const z=u(L.decorations),H=L.decorations&&u(L.decorations.light)||z,q=L.decorations&&u(L.decorations.dark)||z,ue=[H,q],G=L.decorations&&L.decorations.tooltip||"",ce=L.decorations&&!!L.decorations.strikeThrough,de=L.decorations&&!!L.decorations.faded,Q=L.contextValue||"";return{rawResource:[y,x,ue,G,ce,de,Q,N],handle:y}});return{start:D.start,deleteCount:D.deleteCount,toInsert:B}}),E=c.map(({start:D,deleteCount:B,toInsert:L})=>[D,B,L.map(y=>y.rawResource)]),I=c.reverse();for(const{start:D,deleteCount:B,toInsert:L}of I){const y=L.map(N=>N.handle),x=this._handlesSnapshot.splice(D,B,...y);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=o,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(o,v,c,E,I,D){this._extension=o,this._proxy=v,this._commands=c,this._id=E,this._label=I,this._rootUri=D,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new M(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,I,D)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=o;const v=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(o){(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=o;const v=o!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&l(this._statusBarCommands,o))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=o;const v=(o||[]).map(c=>this._commands.converter.toInternal(c,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(o,v){const c=new r(this._proxy,this._commands,this.handle,o,v),E=F.Event.once(c.onDidDispose)(()=>this.createdResourceGroups.delete(c));return this.createdResourceGroups.set(c,E),this.eventuallyAddResourceGroups(),c}eventuallyAddResourceGroups(){const o=[],v=[];for(const[c,E]of this.createdResourceGroups){E.dispose();const I=c.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(c),this.eventuallyUpdateResourceStates()});F.Event.once(c.onDidDispose)(()=>{this.updatedResourceGroups.delete(c),I.dispose(),this._groups.delete(c.handle),this._proxy.$unregisterGroup(this.handle,c.handle)}),o.push([c.handle,c.id,c.label,c.features]);const D=c._takeResourceStateSnapshot();D.length>0&&v.push([c.handle,D]),this._groups.set(c.handle,c)}this._proxy.$registerGroups(this.handle,o,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(v=>{const c=v._takeResourceStateSnapshot();c.length!==0&&o.push([v.handle,c])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,xe([(0,w.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),xe([(0,w.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let p=class zi{constructor(o,v,c){this._commands=v,this.logService=c,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=o.getProxy(A.MainContext.MainThreadSCM),this._telemetry=o.getProxy(A.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const I=this._sourceControls.get(E.sourceControlHandle);if(!I)return E;const D=I.getResourceGroup(E.groupHandle);return D?D.getResourceState(E.handle):E}else if(E&&E.$mid===4){const I=this._sourceControls.get(E.sourceControlHandle);return I?I.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const I=this._sourceControls.get(E.handle);return I||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,v,c,E){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,v,c,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const I=zi._handlePool++,D=new i(o,this._proxy,this._commands,v,c,E);this._sourceControls.set(I,D);const B=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(o.identifier))||[];return B.push(D),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(o.identifier),B),D}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const v=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(o.identifier)),c=v&&v[v.length-1];return c&&c.inputBox}$provideOriginalResource(o,v,c){const E=a.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,E.toString());const I=this._sourceControls.get(o);return!I||!I.quickDiffProvider||!I.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,t.asPromise)(()=>I.quickDiffProvider.provideOriginalResource(E,c)).then(D=>D||null)}$onInputBoxValueChange(o,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const c=this._sourceControls.get(o);return c&&c.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(o,v,c,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,v,c);const I=this._sourceControls.get(o);if(!I)return Promise.resolve(void 0);const D=I.getResourceGroup(v);return D?D.$executeResourceCommand(c,E):Promise.resolve(void 0)}$validateInput(o,v,c){this.logService.trace("ExtHostSCM#$validateInput",o);const E=this._sourceControls.get(o);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,t.asPromise)(()=>E.inputBox.validateInput(v,c)).then(I=>{if(!I)return Promise.resolve(void 0);const D=d.MarkdownString.fromStrict(I.message);return D?Promise.resolve([D,I.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(o){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&this._sourceControls.get(o)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};p._handlePool=0,p=xe([$e(2,R.ILogService)],p),e.ExtHostSCM=p});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[200],_e([0,1,7,5,122,6,8,11]),function(oe,e,a,F,w,T,t,A){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(s,u,g,k,b=a.StatusBarAlignment.Left,m){S.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ze(this,S,s,"f"),Ze(this,C,u,"f"),this._entryId=R.ID_GEN++,this._extension=g,this._id=k,this._alignment=b,this._priority=this.validatePriority(m)}validatePriority(s){if(!!(0,A.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!R.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:Ae(this,C,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:Ae(this,C,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let u;this._name?u=this._name:u=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const k=this._tooltip?t.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,S,"f").$setEntry(this._entryId,s,u,this._text,k,this._command?.internal,g,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,S=new WeakMap,C=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const u={message:s};return this._messages.unshift(u),this._update(),new a.Disposable(()=>{const g=this._messages.indexOf(u);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(s,u){this._proxy=s.getProxy(F.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new _(this)}createStatusBarEntry(s,u,g,k){return new R(this._proxy,this._commands,s,u,g,k)}setStatusBarMessage(s,u){const g=this._statusMessage.setMessage(s);let k;return typeof u=="number"?k=setTimeout(()=>g.dispose(),u):typeof u!="undefined"&&u.then(()=>g.dispose(),()=>g.dispose()),new a.Disposable(()=>{g.dispose(),clearTimeout(k)})}}e.ExtHostStatusBar=n}),define(Ee[72],_e([0,1,5,3,4]),function(oe,e,a,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(A){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,S){this._proxy.$registerExtensionStorageKeysToSync(A,S)}getValue(A,S,C){return this._proxy.$getValue(A,S).then(R=>R||C)}setValue(A,S,C){return this._proxy.$setValue(A,S,C)}$acceptValue(A,S,C){this._onDidChangeStorage.fire({shared:A,key:S,value:C})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ee[73],_e([0,1,4,28,12,49,2]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let A=class{constructor(C,R,_){this._logService=R,this._extHostFileSystem=_,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(C){return t.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,R=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(t.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:t.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(C){if(this._value)return t.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return t.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=xe([$e(0,F.IExtHostInitDataService),$e(1,w.ILogService),$e(2,T.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ee[39],_e([0,1,3,5,4,2,13,6,7,123,15,162,20,36,145,63,11,14]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class b{constructor(h,o,v,c){this._proxy=h,this._id=o,this._creationOptions=v,this._name=c,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(I=>this._pidPromiseComplete=I);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(I,D=!0){E._checkDisposed(),E._proxy.$sendText(E._id,I,D)},show(I){E._checkDisposed(),E._proxy.$show(E._id,I)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(h,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:h.name,shellPath:(0,g.withNullAsUndefined)(h.shellPath),shellArgs:(0,g.withNullAsUndefined)(h.shellArgs),cwd:(0,g.withNullAsUndefined)(h.cwd),env:(0,g.withNullAsUndefined)(h.env),icon:(0,g.withNullAsUndefined)(r(h.iconPath)),color:u.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:(0,g.withNullAsUndefined)(h.message),strictEnv:(0,g.withNullAsUndefined)(h.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(h.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(h.location,o?.resolvedExtHostIdentifier)})}async createExtensionTerminal(h,o,v,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:u.ThemeColor.isThemeColor(c)?c.id:void 0,location:this._serializeParentTerminal(h,o)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(h,o){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in h?{viewColumn:h.viewColumn,preserveFocus:h.preserveFocus}:void 0:h}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(h){this._name=h}setExitCode(h){this._exitStatus=Object.freeze({code:h})}setDimensions(h,o){return h===this._cols&&o===this._rows||h===0||o===0?!1:(this._cols=h,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(h){this._pidPromiseComplete?(this._pidPromiseComplete(h),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==h&&(this._pidPromise=Promise.resolve(h))})}}e.ExtHostTerminal=b;class m{constructor(h){this._pty=h,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(h){this._pty.handleInput?.(h)}resize(h,o){this._pty.setDimensions?.({columns:h,rows:o})}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(h){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(h||void 0),h&&this._pty.setDimensions?.(h),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=m;let f=1,P=class extends A.Disposable{constructor(h,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(h),this._register({dispose:()=>{for(const[v,c]of this._terminalProcesses)c.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(h=>h.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(h){return(h?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(h){return(h?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(h,o){const v=new b(this._proxy,(0,d.generateUuid)(),h,h.name),c=new m(h.pty);return v.createExtensionTerminal(h.location,this._serializeParentTerminal(h,o).resolvedExtHostIdentifier,r(h.iconPath),i(h.color)).then(E=>{const I=this._setupExtHostProcessListeners(E,c);this._terminalProcessDisposables[E]=I}),this._terminals.push(v),v.value}_serializeParentTerminal(h,o){if(o=o||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const v=h.location.parentTerminal;if(v){const c=this._terminals.find(E=>E.value===v);c&&(o.resolvedExtHostIdentifier=c._id)}}else h.location&&typeof h.location!="object"?o.location=h.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(h,o){if(!this._getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const c=new m(o),E=this._setupExtHostProcessListeners(h,c);this._terminalProcessDisposables[h]=E}async $acceptActiveTerminalChanged(h){const o=this._activeTerminal;if(h===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(h);v&&(this._activeTerminal=v,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(h,o){const v=this._getTerminalById(h);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:o})}async $acceptTerminalDimensions(h,o,v){const c=this._getTerminalById(h);c&&c.setDimensions(o,v)&&this._onDidChangeTerminalDimensions.fire({terminal:c.value,dimensions:c.value.dimensions})}async $acceptTerminalMaximumDimensions(h,o,v){this._terminalProcesses.get(h)?.resize(o,v)}async $acceptTerminalTitleChange(h,o){const v=this._getTerminalById(h);v&&(v.name=o)}async $acceptTerminalClosed(h,o){const v=this._getTerminalObjectIndexById(this._terminals,h);if(v!==null){const c=this._terminals.splice(v,1)[0];c.setExitCode(o),this._onDidCloseTerminal.fire(c.value)}}$acceptTerminalOpened(h,o,v,c){if(o){const D=this._getTerminalObjectIndexById(this._terminals,o);if(D!==null){this._terminals[D]._id=h,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const E={name:c.name,shellPath:c.executable,shellArgs:c.args,cwd:typeof c.cwd=="string"?c.cwd:T.URI.revive(c.cwd),env:c.env,hideFromUser:c.hideFromUser},I=new b(this._proxy,h,E,v);this._terminals.push(I),this._onDidOpenTerminal.fire(I.value),I.isOpen=!0}async $acceptTerminalProcessId(h,o){const v=this._getTerminalById(h);v&&v._setProcessId(o)}async $startExtensionTerminal(h,o){const v=this._getTerminalById(h);if(!v)return{message:(0,C.localize)(0,null,h)};v.isOpen||await new Promise(E=>{const I=this.onDidOpenTerminal(async D=>{D===v.value&&(I.dispose(),E())})});const c=this._terminalProcesses.get(h);c?c.startSendingEvents(o):this._extensionTerminalAwaitingStart[h]={initialDimensions:o}}_setupExtHostProcessListeners(h,o){const v=new A.DisposableStore;v.add(o.onProcessReady(E=>this._proxy.$sendProcessReady(h,E.pid,E.cwd))),v.add(o.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(h,E))),this._bufferer.startBuffering(h,o.onProcessData),v.add(o.onProcessExit(E=>this._onProcessExit(h,E))),this._terminalProcesses.set(h,o);const c=this._extensionTerminalAwaitingStart[h];return c&&o instanceof m&&(o.startSendingEvents(c.initialDimensions),delete this._extensionTerminalAwaitingStart[h]),v}$acceptProcessAckDataEvent(h,o){this._terminalProcesses.get(h)?.acknowledgeDataEvent(o)}$acceptProcessInput(h,o){this._terminalProcesses.get(h)?.input(o)}$acceptTerminalInteraction(h){const o=this._getTerminalById(h);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(h,o,v){try{this._terminalProcesses.get(h)?.resize(o,v)}catch(c){if(c.code!=="EPIPE"&&c.code!=="ERR_IPC_CHANNEL_CLOSED")throw c}}$acceptProcessShutdown(h,o){this._terminalProcesses.get(h)?.shutdown(o)}$acceptProcessRequestInitialCwd(h){this._terminalProcesses.get(h)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(h,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(h){this._terminalProcesses.get(h)?.getCwd().then(o=>this._proxy.$sendProcessProperty(h,{type:"cwd",value:o}))}$acceptProcessRequestLatency(h){return h}registerLinkProvider(h){return this._linkProviders.add(h),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(h),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(h,o,v){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,v),this._proxy.$registerProfileProvider(o,h.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(h,o){const v=new n.CancellationTokenSource().token;let c=await this._profileProviders.get(h)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(c&&!("options"in c)&&(c={options:c}),!c||!("options"in c))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in c.options){this.createExtensionTerminal(c.options,o);return}this.createTerminalFromOptions(c.options,o)}}async $provideLinks(h,o){const v=this._getTerminalById(h);if(!v)return[];this._terminalLinkCache.delete(h);const c=this._terminalLinkCancellationSource.get(h);c&&c.dispose(!0);const E=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(h,E);const I=[],D={terminal:v.value,line:o},B=[];for(const x of this._linkProviders)B.push(k.Promises.withAsyncBody(async N=>{E.token.onCancellationRequested(()=>N({provider:x,links:[]}));const z=await x.provideTerminalLinks(D,E.token)||[];E.token.isCancellationRequested||N({provider:x,links:z})}));const L=await Promise.all(B);if(E.token.isCancellationRequested)return[];const y=new Map;for(const x of L)x&&x.links.length>0&&I.push(...x.links.map(N=>{const z={id:f++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return y.set(z.id,{provider:x.provider,link:N}),z}));return this._terminalLinkCache.set(h,y),I}$activateLink(h,o){const v=this._terminalLinkCache.get(h)?.get(o);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(h,o){this._bufferer.stopBuffering(h),this._terminalProcesses.delete(h),delete this._extensionTerminalAwaitingStart[h];const v=this._terminalProcessDisposables[h];v&&(v.dispose(),delete this._terminalProcessDisposables[h]),this._proxy.$sendProcessExit(h,o)}_getTerminalById(h){return this._getTerminalObjectById(this._terminals,h)}_getTerminalObjectById(h,o){const v=this._getTerminalObjectIndexById(h,o);return v!==null?h[v]:null}_getTerminalObjectIndexById(h,o){let v=null;return h.some((c,E)=>c._id===o?(v=E,!0):!1),v}getEnvironmentVariableCollection(h){let o=this._environmentVariableCollections.get(h.identifier.value);return o||(o=new l,this._setEnvironmentVariableCollection(h.identifier.value,o)),o}_syncEnvironmentVariableCollection(h,o){const v=(0,_.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(h,o.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(h){h.forEach(o=>{const v=o[0],c=new l(o[1]);this._setEnvironmentVariableCollection(v,c)})}$acceptDefaultProfile(h,o){this._defaultProfile=h,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(h,o){this._environmentVariableCollections.set(h,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(h,o)})}};P=xe([$e(1,t.IExtHostRpcService)],P),e.BaseExtHostTerminalService=P;class l{constructor(h){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(h)}get persistent(){return this._persistent}set persistent(h){this._persistent=h,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(h,o){this._setIfDiffers(h,{value:o,type:S.EnvironmentVariableMutatorType.Replace})}append(h,o){this._setIfDiffers(h,{value:o,type:S.EnvironmentVariableMutatorType.Append})}prepend(h,o){this._setIfDiffers(h,{value:o,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(h,o){const v=this.map.get(h);(!v||v.value!==o.value||v.type!==o.type)&&(this.map.set(h,o),this._onDidChangeCollection.fire())}get(h){return this.map.get(h)}forEach(h,o){this.map.forEach((v,c)=>h.call(o,c,v,this))}delete(h){this.map.delete(h),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let M=class extends P{constructor(h){super(!1,h)}createTerminal(h,o,v){throw new R.NotSupportedError}createTerminalFromOptions(h,o){throw new R.NotSupportedError}};M=xe([$e(0,t.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function r(p){if(!(!p||typeof p=="string"))return"id"in p?{id:p.id,color:p.color}:p}function i(p){return u.ThemeColor.isThemeColor(p)?p:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[201],_e([0,1,16,22,20,3,230,57,6,27,11,36,5,13,47,8,7,170,88,68]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let P=class{constructor(D,B){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=D.getProxy(n.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new M(this.proxy),B.registerArgumentProcessor({processArgument:L=>L?.$mid===13?u.TestItem.toItemFromContext(L):L})}createTestController(D,B){if(this.controllers.has(D))throw new Error(`Attempt to insert a duplicate controller with ID "${D}"`);const L=new S.DisposableStore,y=L.add(new k.SingleUseTestCollection(D));y.root.label=B;const x=new Map,N=this.proxy,z={items:y.root.children,get label(){return B},set label(q){B=q,y.root.label=q,N.$updateControllerLabel(D,B)},get id(){return D},createRunProfile:(q,ue,G,ce,de)=>{let Q=(0,A.hash)(q);for(;x.has(Q);)Q++;const ie=new c(this.proxy,D,Q,q,ue,G,ce,de);return x.set(Q,ie),ie},createTestItem(q,ue,G){return new s.TestItemImpl(D,q,ue,G)},createTestRun:(q,ue,G=!0)=>this.runTracker.createTestRun(D,y,q,ue,G),set resolveHandler(q){y.resolveHandler=q},get resolveHandler(){return y.resolveHandler},dispose:()=>{L.dispose()}};z.createRunConfiguration=z.createRunProfile,N.$registerTestController(D,B),L.add((0,S.toDisposable)(()=>N.$unregisterTestController(D)));const H={controller:z,collection:y,profiles:x};return this.controllers.set(D,H),L.add((0,S.toDisposable)(()=>this.controllers.delete(D))),L.add(y.onDidGenerateDiff(q=>N.$publishDiff(D,q))),z}createTestObserver(){return this.observer.checkout()}async runTests(D,B=w.CancellationToken.None){const L=r(D);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const y=this.controllers.get(L.controllerId);if(!y)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:D.include?.map(x=>x.id)??[y.collection.root.id],profileGroup:E[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:D.exclude?.map(x=>x.id)},B)}$provideFileCoverage(D,B,L){return(0,a.mapFind)(this.runTracker.trackers,x=>x.id===D?x.getCoverage(B):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(D,B,L,y){return(0,a.mapFind)(this.runTracker.trackers,N=>N.id===D?N.getCoverage(B):void 0)?.resolveFileCoverage(L,y)??Promise.resolve([])}$configureRunProfile(D,B){this.controllers.get(D)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(D){this.results=Object.freeze(D.map(B=>(0,C.deepFreeze)(u.TestResults.to(B))).concat(this.results).sort((B,L)=>L.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(D,B){const L=this.controllers.get(m.TestId.fromString(D).controllerId)?.collection;L&&(await L.expand(D,B<0?Infinity:B),L.flushDiff())}$acceptDiff(D){this.observer.applyDiff(D)}async $runControllerTests(D,B){const L=this.controllers.get(D.controllerId);if(!L)return;const{collection:y,profiles:x}=L,N=x.get(D.profileId);if(!N)return;const z=D.testIds.map(G=>y.tree.get(G)).filter(R.isDefined),H=D.excludeExtIds.map(G=>L.collection.tree.get(G)).filter(R.isDefined).filter(G=>z.some(ce=>ce.fullId.compare(G.fullId)===2));if(!z.length)return;const q=new g.TestRunRequest(z.some(G=>G.actual instanceof s.TestItemRootImpl)?void 0:z.map(G=>G.actual),H.map(G=>G.actual),N),ue=this.runTracker.prepareForMainThreadTestRun(q,i.fromInternal(D,L.collection),B);try{await N.runHandler(q,B)}finally{ue.isRunning&&!B.isCancellationRequested&&await T.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(D){D===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(D)}};P=xe([$e(0,d.IExtHostRpcService)],P),e.ExtHostTesting=P;class l extends S.Disposable{constructor(D,B,L){super();this.dto=D,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:y}of this.tasks.values())y.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(D){return this.tasks.get(D)?.coverage}createRun(D){const B=this.dto.id,L=this.dto.controllerId,y=(0,_.generateUuid)(),x=new p(this.proxy,B,y),N=ue=>(G,...ce)=>{if(H){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(G)||(this.ensureTestIsKnown(G),ue(G,...ce))},z=(ue,G)=>{const ce=G instanceof Array?G.map(u.TestMessage.from):[u.TestMessage.from(G)];if(ue.uri&&ue.range){const de={range:u.Range.from(ue.range),uri:ue.uri};for(const Q of ce)Q.location=Q.location||de}this.proxy.$appendTestMessagesInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),ce)};let H=!1;const q={isPersisted:this.dto.isPersisted,token:this.cts.token,name:D,get coverageProvider(){return x.coverageProvider},set coverageProvider(ue){x.coverageProvider=ue},enqueued:N(ue=>{this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),1)}),skipped:N(ue=>{this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),5)}),started:N(ue=>{this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),2)}),errored:N((ue,G,ce)=>{z(ue,G),this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),6,ce)}),failed:N((ue,G,ce)=>{z(ue,G),this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),4,ce)}),passed:N((ue,G)=>{this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,G)}),appendOutput:(ue,G,ce)=>{H||(ce&&(this.dto.isIncluded(ce)?this.ensureTestIsKnown(ce):ce=void 0),this.proxy.$appendOutputToRun(B,y,F.VSBuffer.fromString(ue),G&&u.location.from(G),ce&&m.TestId.fromExtHostTestItem(ce,L).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(B,y),this.tasks.delete(y),this.isRunning||this.dispose())}};return this.tasks.set(y,{run:q,coverage:x}),this.proxy.$startedTestRunTask(B,{id:y,name:D,running:!0}),q}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(D){if(!(D instanceof s.TestItemImpl))throw new s.InvalidTestItemError(D.id);if(this.sharedTestIds.has(m.TestId.fromExtHostTestItem(D,this.dto.controllerId).toString()))return;const B=[],L=this.dto.colllection.root;for(;;){const y=u.TestItem.from(D);if(B.unshift(y),this.sharedTestIds.has(y.extId)||(this.sharedTestIds.add(y.extId),D===L))break;D=D.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class M{constructor(D){this.proxy=D,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(D,B,L){return this.getTracker(D,B,L)}cancelRunById(D){for(const B of this.tracked.values())if(B.id===D){B.dispose();return}}cancelAllRuns(){for(const D of this.tracked.values())D.dispose()}createTestRun(D,B,L,y,x){const N=this.tracked.get(L);if(N)return N.createRun(y);const z=i.fromPublic(D,B,L,x),H=r(L);this.proxy.$startedExtensionTestRun({controllerId:D,profile:H&&{group:E[H.kind],id:H.profileId},exclude:L.exclude?.map(ue=>ue.id)??[],id:z.id,include:L.include?.map(ue=>ue.id)??[B.root.id],persist:x});const q=this.getTracker(L,z);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),q.createRun(y)}getTracker(D,B,L){const y=new l(B,this.proxy,L);return this.tracked.set(D,y),y.onEnd(()=>this.tracked.delete(D)),y}}e.TestRunCoordinator=M;const r=I=>{if(!!I.profile){if(!(I.profile instanceof c))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return I.profile}};class i{constructor(D,B,L,y,x,N){this.controllerId=D,this.id=B,this.isPersisted=x,this.colllection=N,this.includePrefix=L.map(z=>z+"\0"),this.excludePrefix=y.map(z=>z+"\0")}static fromPublic(D,B,L,y){return new i(D,(0,_.generateUuid)(),L.include?.map(x=>m.TestId.fromExtHostTestItem(x,D).toString())??[D],L.exclude?.map(x=>m.TestId.fromExtHostTestItem(x,D).toString())??[],y,B)}static fromInternal(D,B){return new i(D.controllerId,D.runId,D.testIds,D.excludeExtIds,!0,B)}isIncluded(D){const B=m.TestId.fromExtHostTestItem(D,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(B===L||B.startsWith(L))return!1;for(const L of this.includePrefix)if(B===L||B.startsWith(L))return!0;return!1}}e.TestRunDto=i;class p{constructor(D,B,L){this.proxy=D,this.runId=B,this.taskId=L}set coverageProvider(D){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!D||(this._coverageProvider=D,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(D){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(D))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(D,B){const L=await this.fileCoverage;let y=L?.[D];return!this._coverageProvider||!L||!y?[]:(y.detailedCoverage||(y=L[D]=await this._coverageProvider.resolveFileCoverage?.(y,B)??y),y.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class h extends b.IncrementalChangeCollector{constructor(D){super();this.emitter=D,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(D){this.added.add(D)}update(D){Object.assign(D.revived,u.TestItem.toPlain(D.item)),this.added.has(D)||this.updated.add(D)}remove(D){if(this.added.has(D)){this.added.delete(D);return}if(this.updated.delete(D),D.parent&&this.alreadyRemoved.has(D.parent)){this.alreadyRemoved.add(D.item.extId);return}this.removed.add(D)}getChangeEvent(){const{added:D,updated:B,removed:L}=this;return{get added(){return[...D].map(y=>y.revived)},get updated(){return[...B].map(y=>y.revived)},get removed(){return[...L].map(y=>y.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(D){return this.items.get(D)}getMirroredTestDataByReference(D){return this.items.get(D.id)}createItem(D,B){return{...D,revived:u.TestItem.toPlain(D.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=o;class v{constructor(D){this.proxy=D}checkout(){this.current||(this.current=this.createObserverData());const D=this.current;return D.observers++,{onDidChangeTest:D.tests.onDidChangeTests,get tests(){return[...D.tests.rootTests].map(B=>B.revived)},dispose:(0,t.once)(()=>{--D.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(D){return this.current?.tests.getMirroredTestDataByReference(D)}applyDiff(D){this.current?.tests.apply(D)}createObserverData(){const D=new o;return this.proxy.$subscribeToDiffs(),{observers:0,tests:D}}}class c{constructor(D,B,L,y,x,N,z=!1,H=void 0){this.controllerId=B,this.profileId=L,this._label=y,this.kind=x,this.runHandler=N,this._isDefault=z,this._tag=H,f.set(this,void 0),Ze(this,f,D,"f");const q=E[x];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ae(this,f,"f").$publishTestRunProfile({profileId:L,controllerId:B,tag:H?u.TestTag.namespace(this.controllerId,H.id):null,label:y,group:q,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(D){D!==this._label&&(this._label=D,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:D}))}get isDefault(){return this._isDefault}set isDefault(D){D!==this._isDefault&&(this._isDefault=D,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:D}))}get tag(){return this._tag}set tag(D){D?.id!==this._tag?.id&&(this._tag=D,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:D?u.TestTag.namespace(this.controllerId,D.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(D){D!==this._configureHandler&&(this._configureHandler=D,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!D}))}dispose(){Ae(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=c,f=new WeakMap;const E={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(Ee[202],_e([0,1,3,16,5,92,8,7]),function(oe,e,a,F,w,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(R,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new a.Emitter,this._onDidChangeTextEditorOptions=new a.Emitter,this._onDidChangeTextEditorVisibleRanges=new a.Emitter,this._onDidChangeTextEditorViewColumn=new a.Emitter,this._onDidChangeActiveTextEditor=new a.Emitter,this._onDidChangeVisibleTextEditors=new a.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const _=this._extHostDocumentsAndEditors.allEditors();return R?_:_.map(n=>n.value)}async showTextDocument(R,_,n){let d;typeof _=="number"?d={position:t.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?d={position:t.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?t.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:d={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(R.uri,d),u=s&&this._extHostDocumentsAndEditors.getEditor(s);if(u)return u.value;throw s?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,_){return new T.TextEditorDecorationType(this._proxy,R,_).value}$acceptEditorPropertiesChanged(R,_){const n=this._extHostDocumentsAndEditors.getEditor(R);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const d=_.selections.selections.map(t.Selection.to);n._acceptSelections(d)}if(_.visibleRanges){const d=F.coalesce(_.visibleRanges.map(t.Range.to));n._acceptVisibleRanges(d)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:t.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const d=A.TextEditorSelectionChangeKind.fromValue(_.selections.source),s=_.selections.selections.map(t.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:d})}if(_.visibleRanges){const d=F.coalesce(_.visibleRanges.map(t.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:d})}}$acceptEditorPositionData(R){for(const _ in R){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const d=t.ViewColumn.to(R[_]);n.value.viewColumn!==d&&(n._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:d}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=S}),define(Ee[203],_e([0,1,2,4,5,6,7]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class A{constructor(R,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(w.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const d=n.uri===void 0?void 0:a.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(d))?.get(n.handle)}return n}})}async $getTimeline(R,_,n,d,s){return this._providers.get(R)?.provideTimeline(a.URI.revive(_),n,d,s)}registerTimelineProvider(R,_,n,d){const s=new T.DisposableStore,u=this.convertTimelineItem(_.id,d,s).bind(this);let g;_.onDidChange&&(g=_.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:_.id}),this));const k=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:R,onDidChange:void 0,async provideTimeline(b,m,f,P){P?.resetCache&&(s.clear(),k.get(_.id)?.clear());const l=await _.provideTimeline(b,m,f);if(l==null)return;const M=u(b,P);return{...l,source:_.id,items:l.items.map(M)}},dispose(){for(const b of k.values())b.get(_.id)?.clear();g?.dispose(),s.dispose()}})}convertTimelineItem(R,_,n){return(d,s)=>{let u;if(s?.cacheResults){let g=this._itemsBySourceAndUriMap.get(R);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(R,g));const k=S(d);u=g.get(k),u===void 0&&(u=new Map,g.set(k,u))}return g=>{const{iconPath:k,...b}=g,m=`${R}|${g.id??g.timestamp}`;u?.set(m,g);let f,P,l;return g.iconPath&&(k instanceof t.ThemeIcon?l={id:k.id,color:k.color}:a.URI.isUri(k)?(f=k,P=k):{light:f,dark:P}=k),{...b,id:b.id??void 0,handle:m,source:R,command:g.command?_.toInternal(g.command,n):void 0,icon:f,iconDark:P,themeIcon:l,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,T.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=A;function S(C){return C?.toString()}}),define(Ee[204],_e([0,1,6,10,2,5]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class t{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,R,_){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const n=_.schemes.find(d=>!t.supportedSchemes.has(d));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,R),this._proxy.$registerUriOpener(C,_.schemes,S,_.label),(0,a.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(S,C,R){const _=this._openers.get(S);if(!_)throw new Error(`Unknown opener with id: ${S}`);const n=w.URI.revive(C);return _.canOpenExternalUri(n,R)}async $openUri(S,C,R){const _=this._openers.get(S);if(!_)throw new Error(`Unknown opener id: '${S}'`);return _.openExternalUri(w.URI.revive(C.resolvedUri),{sourceUri:w.URI.revive(C.sourceUri)},R)}}e.ExtHostUriOpeners=t,t.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(Ee[205],_e([0,1,5,2,6,15,25]),function(oe,e,a,F,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(C,R){if(this.handles.has(t.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const _=A.HandlePool++;return this.handles.add(t.ExtensionIdentifier.toKey(C)),this.handlers.set(_,R),this._proxy.$registerUriHandler(_,C),(0,w.toDisposable)(()=>{this.handles.delete(t.ExtensionIdentifier.toKey(C)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(C,R){const _=this.handlers.get(C);if(!_)return Promise.resolve(void 0);try{_.handleUri(F.URI.revive(R))}catch(n){(0,T.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(C){return F.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=A,A.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[50],_e([0,1,3,10,2,132,152,67,5]),function(oe,e,a,F,w,T,t,A,S){"use strict";var C,R,_,n,d,s,u,g,k,b,m,f;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class P{constructor(v,c,E,I,D,B,L){C.set(this,void 0),R.set(this,void 0),_.set(this,void 0),n.set(this,void 0),d.set(this,void 0),s.set(this,void 0),u.set(this,""),g.set(this,void 0),k.set(this,!1),b.set(this,!1),m.set(this,!1),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,f.set(this,new a.Emitter),this._onDidDispose=Ae(this,f,"f").event,Ze(this,C,v,"f"),Ze(this,R,c,"f"),Ze(this,g,E,"f"),Ze(this,n,I,"f"),Ze(this,d,D,"f"),Ze(this,s,B,"f"),Ze(this,m,l(B),"f"),Ze(this,_,L,"f")}dispose(){Ze(this,k,!0,"f"),Ae(this,f,"f").fire(),Ae(this,f,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return Ze(this,b,!0,"f"),(0,A.asWebviewUri)(v,Ae(this,n,"f").remote)}get cspSource(){const v=Ae(this,s,"f").extensionLocation;if(v.scheme===F.Schemas.https||v.scheme===F.Schemas.http){let c=v.toString();return c.endsWith("/")||(c+="/"),c+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,u,"f")}set html(v){this.assertNotDisposed(),Ae(this,u,"f")!==v&&(Ze(this,u,v,"f"),!Ae(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(Ze(this,b,!0,"f"),Ae(this,_,"f").report("Webview vscode-resource: uris",Ae(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,R,"f").$setHtml(Ae(this,C,"f"),v))}get options(){return this.assertNotDisposed(),Ae(this,g,"f")}set options(v){this.assertNotDisposed(),Ae(this,R,"f").$setOptions(Ae(this,C,"f"),i(Ae(this,s,"f"),Ae(this,d,"f"),v)),Ze(this,g,v,"f")}async postMessage(v){if(Ae(this,k,"f"))return!1;const c=(0,t.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Ae(this,m,"f")});return Ae(this,R,"f").$postMessage(Ae(this,C,"f"),c.message,...c.buffers)}assertNotDisposed(){if(Ae(this,k,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=P,C=new WeakMap,R=new WeakMap,_=new WeakMap,n=new WeakMap,d=new WeakMap,s=new WeakMap,u=new WeakMap,g=new WeakMap,k=new WeakMap,b=new WeakMap,m=new WeakMap,f=new WeakMap;function l(o){try{const v=(0,T.normalizeVersion)((0,T.parseVersion)(o.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class M{constructor(v,c,E,I,D){this.initData=c,this.workspace=E,this._logService=I,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=v.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(v,c,...E){const I=this.getWebview(v);if(I){const{message:D}=(0,t.deserializeWebviewMessage)(c,E);I._onMessageEmitter.fire(D)}}$onMissingCsp(v,c){this._logService.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,c,E){const I=new P(v,this._webviewProxy,p(c),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(v,I),I._onDidDispose(()=>{this._webviews.delete(v)}),I}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=M;function r(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=r;function i(o,v,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||h(o,v)}}e.serializeWebviewOptions=i;function p(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(v=>w.URI.from(v))}}e.reviveOptions=p;function h(o,v){return[...(v?.getWorkspaceFolders()||[]).map(c=>c.uri),o.extensionLocation]}}),define(Ee[206],_e([0,1,20,57,6,10,24,2,8,50,64,5,7]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(l,M){this.document=l,this._storagePath=M,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,M){await this.getEdit(l).undo(),M||this.disposeBackup()}async redo(l,M){await this.getEdit(l).redo(),M||this.disposeBackup()}disposeEdits(l){for(const M of l)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=f(this.document.uri)+this._backupCounter++;return(0,t.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const M=this._edits.get(l,0);if(!M)throw new Error("No edit found");return M}}class s{constructor(){this._documents=new Map}get(l,M){return this._documents.get(this.key(l,M))}add(l,M,r){const i=this.key(l,M.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${l} resource:${M.uri}`);const p=new d(M,r);return this._documents.set(i,p),p}delete(l,M){const r=this.key(l,M.uri);this._documents.delete(r)}key(l,M){return`${l}@@@${M}`}}var u;(function(P){P[P.Text=0]="Text",P[P.Custom=1]="Custom"})(u||(u={}));class g{constructor(){this._providers=new Map}addTextProvider(l,M,r){return this.add(0,l,M,r)}addCustomProvider(l,M,r){return this.add(1,l,M,r)}get(l){return this._providers.get(l)}add(l,M,r,i){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:l,extension:r,provider:i}),new n.Disposable(()=>this._providers.delete(M))}}class k{constructor(l,M,r,i,p){this._extHostDocuments=M,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=p,this._editorProviders=new g,this._documents=new s,this._proxy=l.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,M,r,i){const p=new w.DisposableStore;return b(r)?(p.add(this._editorProviders.addTextProvider(M,l,r)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(l),M,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(l))):(p.add(this._editorProviders.addCustomProvider(M,l,r)),this.supportEditing(r)&&p.add(r.onDidChangeCustomDocument(h=>{const o=this.getCustomDocumentEntry(M,h.document.uri);if(m(h)){const v=o.addEdit(h);this._proxy.$onDidEdit(h.document.uri,M,v,h.label)}else this._proxy.$onContentChange(h.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(l),M,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(l))),n.Disposable.from(p,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(l,M,r,i,p){const h=this._editorProviders.get(M);if(!h)throw new Error(`No provider found for '${M}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${M}'`);const o=A.URI.revive(l),v=await h.provider.openCustomDocument(o,{backupId:r,untitledDocumentData:i?.buffer},p);let c;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(c=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(M,v,c),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(l,M){const r=this._editorProviders.get(M);if(!r)throw new Error(`No provider found for '${M}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${M}'`);const i=A.URI.revive(l),{document:p}=this.getCustomDocumentEntry(M,i);this._documents.delete(M,p),p.dispose()}async $resolveWebviewEditor(l,M,r,i,p,h){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);const v=S.ViewColumn.to(p),c=this._extHostWebview.createNewWebview(M,i.webviewOptions,o.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(M,r,i.title,v,i.panelOptions,c),I=A.URI.revive(l);switch(o.type){case 1:{const{document:D}=this.getCustomDocumentEntry(r,I);return o.provider.resolveCustomEditor(D,E,h)}case 0:{const D=this._extHostDocuments.getDocument(I);return o.provider.resolveCustomTextEditor(D,E,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,M,r){this.getCustomDocumentEntry(M,l).disposeEdits(r)}async $onMoveCustomEditor(l,M,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const p=this._extHostWebviewPanels.getWebviewPanel(l);if(!p)throw new Error("No webview found");const h=A.URI.revive(M),o=this._extHostDocuments.getDocument(h);await i.provider.moveCustomTextEditor(o,p,a.CancellationToken.None)}async $undo(l,M,r,i){return this.getCustomDocumentEntry(M,l).undo(r,i)}async $redo(l,M,r,i){return this.getCustomDocumentEntry(M,l).redo(r,i)}async $revert(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(l,M,r,i){const p=this.getCustomDocumentEntry(M,l);return this.getCustomEditorProvider(M).saveCustomDocumentAs(p.document,A.URI.revive(r),i)}async $backup(l,M,r){const i=this.getCustomDocumentEntry(M,l),h=await this.getCustomEditorProvider(M).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(h),h.id}getCustomDocumentEntry(l,M){const r=this._documents.get(l,A.URI.revive(M));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(l){const r=this._editorProviders.get(l)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=k;function b(P){return typeof P.resolveCustomTextEditor=="function"}function m(P){return typeof P.undo=="function"&&typeof P.redo=="function"}function f(P){const l=P.scheme===T.Schemas.file||P.scheme===T.Schemas.untitled?P.fsPath:P.toString();return(0,F.hash)(l)+""}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[207],_e([0,1,3,6,2,36,8,50,5,7]),function(oe,e,a,F,w,T,t,A,S,C){"use strict";var R,_,n,d,s,u,g,k,b,m,f,P,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends F.Disposable{constructor(h,o,v,c,E,I,D){super();R.set(this,void 0),_.set(this,void 0),n.set(this,void 0),d.set(this,void 0),s.set(this,void 0),u.set(this,void 0),g.set(this,void 0),k.set(this,void 0),b.set(this,!0),m.set(this,!0),f.set(this,!1),P.set(this,this._register(new a.Emitter)),this.onDidDispose=Ae(this,P,"f").event,l.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Ae(this,l,"f").event,Ze(this,R,h,"f"),Ze(this,_,o,"f"),Ze(this,n,v,"f"),Ze(this,s,I,"f"),Ze(this,k,E,"f"),Ze(this,u,c,"f"),Ze(this,d,D,"f")}dispose(){Ae(this,f,"f")||(Ze(this,f,!0,"f"),Ae(this,P,"f").fire(),Ae(this,_,"f").$disposeWebview(Ae(this,R,"f")),Ae(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,d,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,n,"f")}get title(){return this.assertNotDisposed(),Ae(this,u,"f")}set title(h){this.assertNotDisposed(),Ae(this,u,"f")!==h&&(Ze(this,u,h,"f"),Ae(this,_,"f").$setTitle(Ae(this,R,"f"),h))}get iconPath(){return this.assertNotDisposed(),Ae(this,g,"f")}set iconPath(h){this.assertNotDisposed(),Ae(this,g,"f")!==h&&(Ze(this,g,h,"f"),Ae(this,_,"f").$setIconPath(Ae(this,R,"f"),w.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Ae(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,k,"f")=="number"&&Ae(this,k,"f")<0))return Ae(this,k,"f")}get active(){return this.assertNotDisposed(),Ae(this,m,"f")}get visible(){return this.assertNotDisposed(),Ae(this,b,"f")}_updateViewState(h){Ae(this,f,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(Ze(this,m,h.active,"f"),Ze(this,b,h.visible,"f"),Ze(this,k,h.viewColumn,"f"),Ae(this,l,"f").fire({webviewPanel:this}))}reveal(h,o){this.assertNotDisposed(),Ae(this,_,"f").$reveal(Ae(this,R,"f"),{viewColumn:h?t.ViewColumn.from(h):void 0,preserveFocus:!!o})}assertNotDisposed(){if(Ae(this,f,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,_=new WeakMap,n=new WeakMap,d=new WeakMap,s=new WeakMap,u=new WeakMap,g=new WeakMap,k=new WeakMap,b=new WeakMap,m=new WeakMap,f=new WeakMap,P=new WeakMap,l=new WeakMap;class r{constructor(h,o,v){this.webviews=o,this.workspace=v,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(h,o,v,c,E={}){const I=typeof c=="object"?c.viewColumn:c,D={viewColumn:t.ViewColumn.from(I),preserveFocus:typeof c=="object"&&!!c.preserveFocus},B=(0,A.shouldSerializeBuffersForPostMessage)(h),L=r.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(h),L,o,{title:v,panelOptions:i(E),webviewOptions:(0,A.serializeWebviewOptions)(h,this.workspace,E),serializeBuffersForPostMessage:B},D);const y=this.webviews.createNewWebview(L,E,h);return this.createNewWebviewPanel(L,o,v,I,E,y)}$onDidChangeWebviewPanelViewStates(h){const o=Object.keys(h);o.sort((v,c)=>{const E=h[v],I=h[c];return E.active?1:I.active?-1:+E.visible-+I.visible});for(const v of o){const c=this.getWebviewPanel(v);if(!c)continue;const E=h[v];c._updateViewState({active:E.active,visible:E.visible,viewColumn:t.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,o,v){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:v,extension:h}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(h)}),new C.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(h,o,v,c){const E=this._serializers.get(o);if(!E)throw new Error(`No serializer found for '${o}'`);const{serializer:I,extension:D}=E,B=this.webviews.createNewWebview(h,v.webviewOptions,D),L=this.createNewWebviewPanel(h,o,v.title,c,v.panelOptions,B);await I.deserializeWebviewPanel(L,v.state)}createNewWebviewPanel(h,o,v,c,E,I){const D=new M(h,this._proxy,o,v,c,E,I);return this._webviewPanels.set(h,D),D}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=r;function i(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[208],_e([0,1,3,6,50,5,7]),function(oe,e,a,F,w,T,t){"use strict";var A,S,C,R,_,n,d,s,u,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class k extends F.Disposable{constructor(f,P,l,M,r,i){super();A.set(this,void 0),S.set(this,void 0),C.set(this,void 0),R.set(this,void 0),_.set(this,!1),n.set(this,void 0),d.set(this,void 0),s.set(this,void 0),u.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Ae(this,u,"f").event,g.set(this,this._register(new a.Emitter)),this.onDidDispose=Ae(this,g,"f").event,Ze(this,C,l,"f"),Ze(this,d,M,"f"),Ze(this,A,f,"f"),Ze(this,S,P,"f"),Ze(this,R,r,"f"),Ze(this,n,i,"f")}dispose(){Ae(this,_,"f")||(Ze(this,_,!0,"f"),Ae(this,g,"f").fire(),Ae(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,d,"f")}set title(f){this.assertNotDisposed(),Ae(this,d,"f")!==f&&(Ze(this,d,f,"f"),Ae(this,S,"f").$setWebviewViewTitle(Ae(this,A,"f"),f))}get description(){return this.assertNotDisposed(),Ae(this,s,"f")}set description(f){this.assertNotDisposed(),Ae(this,s,"f")!==f&&(Ze(this,s,f,"f"),Ae(this,S,"f").$setWebviewViewDescription(Ae(this,A,"f"),f))}get visible(){return Ae(this,n,"f")}get webview(){return Ae(this,R,"f")}get viewType(){return Ae(this,C,"f")}_setVisible(f){f===Ae(this,n,"f")||Ae(this,_,"f")||(Ze(this,n,f,"f"),Ae(this,u,"f").fire())}show(f){this.assertNotDisposed(),Ae(this,S,"f").$show(Ae(this,A,"f"),!!f)}assertNotDisposed(){if(Ae(this,_,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,S=new WeakMap,C=new WeakMap,R=new WeakMap,_=new WeakMap,n=new WeakMap,d=new WeakMap,s=new WeakMap,u=new WeakMap,g=new WeakMap;class b{constructor(f,P){this._extHostWebview=P,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,P,l,M){if(this._viewProviders.has(P))throw new Error(`View provider for '${P}' already registered`);return this._viewProviders.set(P,{provider:l,extension:f}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(f),P,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new t.Disposable(()=>{this._viewProviders.delete(P),this._proxy.$unregisterWebviewViewProvider(P)})}async $resolveWebviewView(f,P,l,M,r){const i=this._viewProviders.get(P);if(!i)throw new Error(`No view provider found for '${P}'`);const{provider:p,extension:h}=i,o=this._extHostWebview.createNewWebview(f,{},h),v=new k(f,this._proxy,P,l,o,!0);this._webviewViews.set(f,v),await p.resolveWebviewView(v,{state:M},r)}async $onDidChangeWebviewViewVisibility(f,P){this.getWebviewView(f)._setVisible(P)}async $disposeWebviewView(f){const P=this.getWebviewView(f);this._webviewViews.delete(f),P.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const P=this._webviewViews.get(f);if(!P)throw new Error("No webview found");return P}}e.ExtHostWebviewViews=b}),define(Ee[95],_e([0,1,3,5,2,10,9,4,13]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Wi{constructor(_){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=_.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let d;if(typeof _=="string"){d=_;try{_=w.URI.parse(_)}catch(s){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,t.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,d,n)}async asExternalUri(_,n){if((0,t.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(_,n);return w.URI.from(d)}};C.InitialState={focused:!0},C=xe([$e(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ee[209],_e([0,1,14,22,20,15,3,6,106,176,37]),function(oe,e,a,F,w,T,t,A,S,C,R){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(E,I){try{return JSON.stringify(E,I)}catch(D){return"null"}}const d="$$ref$$",s={[d]:-1};class u{constructor(I,D){this.jsonString=I,this.referencedBuffers=D}}function g(E,I=null,D=!1){const B=[];return{jsonString:(D?n:JSON.stringify)(E,(y,x)=>{if(typeof x=="undefined")return s;if(typeof x=="object"){if(x instanceof F.VSBuffer){const N=B.push(x)-1;return{[d]:N}}if(I)return I(y,x)}return x}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=g;function k(E,I,D){return JSON.parse(E,(B,L)=>{if(L){const y=L[d];if(typeof y=="number")return I[y];if(D&&L.$mid===1)return D.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=k;function b(E,I){return JSON.stringify(E,I)}function m(E){return E?(I,D)=>D&&D.$mid===1?E.transformOutgoing(D):D:null}var f;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var P;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(P=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},M=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends A.Disposable{constructor(I,D=null,B=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new t.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=I,this._logger=D,this._uriTransformer=B,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,y=R.ProxyIdentifier.count;L<y;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(I=>{this._pendingRPCReplies[I].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(I){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(I){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(I){this._responsiveState!==I&&(this._responsiveState=I,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(I){return this._uriTransformer?(0,S.transformIncomingURIs)(I,this._uriTransformer):I}getProxy(I){const{nid:D,sid:B}=I;return this._proxies[D]||(this._proxies[D]=this._createProxy(D,B)),this._proxies[D]}_createProxy(I,D){let B={get:(L,y)=>(typeof y=="string"&&!L[y]&&y.charCodeAt(0)===36&&(L[y]=(...x)=>this._remoteCall(I,y,x)),y===r?D:L[y])};return new Proxy(Object.create(null),B)}set(I,D){return this._locals[I.nid]=D,D}assertRegistered(I){for(let D=0,B=I.length;D<B;D++){const L=I[D];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(I){if(this._isDisposed)return;const D=I.byteLength,B=p.read(I,0),L=B.readUInt8(),y=B.readUInt32();switch(L){case 1:case 2:{let{rpcId:x,method:N,args:z}=o.deserializeRequestJSONArgs(B);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(D,y,x,N,z,L===2);break}case 3:case 4:{let{rpcId:x,method:N,args:z}=o.deserializeRequestMixedArgs(B);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(D,y,x,N,z,L===4);break}case 5:{this._logger&&this._logger.logIncoming(D,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(D,y);break}case 7:{this._receiveReply(D,y,void 0);break}case 9:{let x=o.deserializeReplyOKJSON(B);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(D,y,x);break}case 10:{const x=o.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(D,y,x);break}case 8:{let x=o.deserializeReplyOKVSBuffer(B);this._receiveReply(D,y,x);break}case 11:{let x=o.deserializeReplyErrError(B);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(D,y,x);break}case 12:{this._receiveReplyErr(D,y,void 0);break}default:console.error("received unexpected message"),console.error(I)}}_receiveRequest(I,D,B,L,y,x){this._logger&&this._logger.logIncoming(I,D,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(B)}.${L}(`,y);const N=String(D);let z,H;if(x){const ue=new w.CancellationTokenSource;y.push(ue.token),z=this._invokeHandler(B,L,y),H=()=>ue.cancel()}else z=this._invokeHandler(B,L,y),H=l;this._cancelInvokedHandlers[N]=H;const q=o.serializeAcknowledged(D);this._logger&&this._logger.logOutgoing(q.byteLength,D,1,"ack"),this._protocol.send(q),z.then(ue=>{delete this._cancelInvokedHandlers[N];const G=o.serializeReplyOK(D,ue,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,D,1,"reply:",ue),this._protocol.send(G)},ue=>{delete this._cancelInvokedHandlers[N];const G=o.serializeReplyErr(D,ue);this._logger&&this._logger.logOutgoing(G.byteLength,D,1,"replyErr:",ue),this._protocol.send(G)})}_receiveCancel(I,D){this._logger&&this._logger.logIncoming(I,D,1,"receiveCancel");const B=String(D);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(I,D,B){this._logger&&this._logger.logIncoming(I,D,0,"receiveReply:",B);const L=String(D);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const y=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],y.resolveOk(B)}_receiveReplyErr(I,D,B){this._logger&&this._logger.logIncoming(I,D,0,"receiveReplyErr:",B);const L=String(D);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const y=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let x;B&&(B.$isError?(x=new Error,x.name=B.name,x.message=B.message,x.stack=B.stack):x=B),y.resolveErr(x)}_invokeHandler(I,D,B){try{return Promise.resolve(this._doInvokeHandler(I,D,B))}catch(L){return Promise.reject(L)}}_doInvokeHandler(I,D,B){const L=this._locals[I];if(!L)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(I));let y=L[D];if(typeof y!="function")throw new Error("Unknown method "+D+" on actor "+(0,R.getStringIdentifierForProxy)(I));return y.apply(L,B)}_remoteCall(I,D,B){if(this._isDisposed)return Promise.reject(T.canceled());let L=null;if(B.length>0&&w.CancellationToken.isCancellationToken(B[B.length-1])&&(L=B.pop()),L&&L.isCancellationRequested)return Promise.reject(T.canceled());const y=o.serializeRequestArguments(B,this._uriReplacer),x=++this._lastMessageId,N=String(x),z=new C.LazyPromise;L&&L.onCancellationRequested(()=>{const q=o.serializeCancel(x);this._logger&&this._logger.logOutgoing(q.byteLength,x,0,"cancel"),this._protocol.send(o.serializeCancel(x))}),this._pendingRPCReplies[N]=z,this._onWillSendRequest(x);const H=o.serializeRequest(x,I,D,y,!!L);return this._logger&&this._logger.logOutgoing(H.byteLength,x,0,`request: ${(0,R.getStringIdentifierForProxy)(I)}.${D}(`,B),this._protocol.send(H),z}}e.RPCProtocol=i,_=M,i.UNRESPONSIVE_TIME=3*1e3;class p{constructor(I,D){this._buff=I,this._offset=D}static alloc(I,D,B){let L=new p(F.VSBuffer.alloc(B+1+4),0);return L.writeUInt8(I),L.writeUInt32(D),L}static read(I,D){return new p(I,D)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(I){this._buff.writeUInt8(I,this._offset),this._offset+=1}readUInt8(){const I=this._buff.readUInt8(this._offset);return this._offset+=1,I}writeUInt32(I){this._buff.writeUInt32BE(I,this._offset),this._offset+=4}readUInt32(){const I=this._buff.readUInt32BE(this._offset);return this._offset+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this._buff.writeUInt8(I.byteLength,this._offset),this._offset+=1,this._buff.set(I,this._offset),this._offset+=I.byteLength}readShortString(){const I=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,B}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readLongString(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,B}writeBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readVSBuffer(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const D=this._buff.slice(this._offset,this._offset+I);return this._offset+=I,D}static sizeMixedArray(I){let D=0;D+=1;for(let B=0,L=I.length;B<L;B++){const y=I[B];switch(D+=1,y.type){case 1:D+=this.sizeLongString(y.value);break;case 2:D+=this.sizeVSBuffer(y.value);break;case 3:D+=this.sizeUInt32,D+=this.sizeLongString(y.value);for(let x=0;x<y.buffers.length;++x)D+=this.sizeVSBuffer(y.buffers[x]);break;case 4:break}}return D}writeMixedArray(I){this._buff.writeUInt8(I.length,this._offset),this._offset+=1;for(let D=0,B=I.length;D<B;D++){const L=I[D];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let y=0;y<L.buffers.length;++y)this.writeBuffer(L.buffers[y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this._buff.readUInt8(this._offset);this._offset+=1;let D=new Array(I);for(let B=0;B<I;B++)switch(this.readUInt8()){case 1:D[B]=this.readLongString();break;case 2:D[B]=this.readVSBuffer();break;case 3:const y=this.readUInt32(),x=this.readLongString(),N=[];for(let z=0;z<y;++z)N.push(this.readVSBuffer());D[B]=new R.SerializableObjectWithBuffers(k(x,N,null));break;case 4:D[B]=void 0;break}return D}}p.sizeUInt32=4;var h;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(h||(h={}));class o{static _useMixedArgSerialization(I){for(let D=0,B=I.length;D<B;D++)if(I[D]instanceof F.VSBuffer||I[D]instanceof R.SerializableObjectWithBuffers||typeof I[D]=="undefined")return!0;return!1}static serializeRequestArguments(I,D){if(this._useMixedArgSerialization(I)){const B=[];for(let L=0,y=I.length;L<y;L++){const x=I[L];if(x instanceof F.VSBuffer)B[L]={type:2,value:x};else if(typeof x=="undefined")B[L]={type:4};else if(x instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:z}=g(x.value,D);B[L]={type:3,value:F.VSBuffer.fromString(N),buffers:z}}else B[L]={type:1,value:F.VSBuffer.fromString(b(x,D))}}return{type:1,args:B}}return{type:0,args:b(I,D)}}static serializeRequest(I,D,B,L,y){switch(L.type){case 0:return this._requestJSONArgs(I,D,B,L.args,y);case 1:return this._requestMixedArgs(I,D,B,L.args,y)}}static _requestJSONArgs(I,D,B,L,y){const x=F.VSBuffer.fromString(B),N=F.VSBuffer.fromString(L);let z=0;z+=p.sizeUInt8(),z+=p.sizeShortString(x),z+=p.sizeLongString(N);let H=p.alloc(y?2:1,I,z);return H.writeUInt8(D),H.writeShortString(x),H.writeLongString(N),H.buffer}static deserializeRequestJSONArgs(I){const D=I.readUInt8(),B=I.readShortString(),L=I.readLongString();return{rpcId:D,method:B,args:JSON.parse(L)}}static _requestMixedArgs(I,D,B,L,y){const x=F.VSBuffer.fromString(B);let N=0;N+=p.sizeUInt8(),N+=p.sizeShortString(x),N+=p.sizeMixedArray(L);let z=p.alloc(y?4:3,I,N);return z.writeUInt8(D),z.writeShortString(x),z.writeMixedArray(L),z.buffer}static deserializeRequestMixedArgs(I){const D=I.readUInt8(),B=I.readShortString(),L=I.readMixedArray(),y=new Array(L.length);for(let x=0,N=L.length;x<N;x++){const z=L[x];typeof z=="string"?y[x]=JSON.parse(z):y[x]=z}return{rpcId:D,method:B,args:y}}static serializeAcknowledged(I){return p.alloc(5,I,0).buffer}static serializeCancel(I){return p.alloc(6,I,0).buffer}static serializeReplyOK(I,D,B){if(typeof D=="undefined")return this._serializeReplyOKEmpty(I);if(D instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(I,D);if(D instanceof R.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:y}=g(D.value,B,!0);return this._serializeReplyOKJSONWithBuffers(I,L,y)}else return this._serializeReplyOKJSON(I,n(D,B))}static _serializeReplyOKEmpty(I){return p.alloc(7,I,0).buffer}static _serializeReplyOKVSBuffer(I,D){let B=0;B+=p.sizeVSBuffer(D);let L=p.alloc(8,I,B);return L.writeVSBuffer(D),L.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static _serializeReplyOKJSON(I,D){const B=F.VSBuffer.fromString(D);let L=0;L+=p.sizeLongString(B);let y=p.alloc(9,I,L);return y.writeLongString(B),y.buffer}static _serializeReplyOKJSONWithBuffers(I,D,B){const L=F.VSBuffer.fromString(D);let y=0;y+=p.sizeUInt32,y+=p.sizeLongString(L);for(const N of B)y+=p.sizeVSBuffer(N);let x=p.alloc(10,I,y);x.writeUInt32(B.length),x.writeLongString(L);for(const N of B)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(I){const D=I.readLongString();return JSON.parse(D)}static deserializeReplyOKJSONWithBuffers(I,D){const B=I.readUInt32(),L=I.readLongString(),y=[];for(let x=0;x<B;++x)y.push(I.readVSBuffer());return new R.SerializableObjectWithBuffers(k(L,y,D))}static serializeReplyErr(I,D){return D?this._serializeReplyErrEror(I,D):this._serializeReplyErrEmpty(I)}static _serializeReplyErrEror(I,D){const B=F.VSBuffer.fromString(n(T.transformErrorForSerialization(D),null));let L=0;L+=p.sizeLongString(B);let y=p.alloc(11,I,L);return y.writeLongString(B),y.buffer}static deserializeReplyErrError(I){const D=I.readLongString();return JSON.parse(D)}static _serializeReplyErrEmpty(I){return p.alloc(12,I,0).buffer}}var v;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var c;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(c||(c={}))}),define(Ee[210],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const a=function(T){const t=A=>{self.removeEventListener("message",t);const S=A.data;Object.defineProperties(self,{postMessage:{value(C,R){S.postMessage(C,R)}},onmessage:{get(){return S.onmessage},set(C){S.onmessage=C}}}),S.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",t)}.toString();class F extends EventTarget{constructor(T,t,A){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${a})('${t}'))`,C=new Blob([S],{type:"application/javascript"}),R=URL.createObjectURL(C),_=new MessageChannel,n=R,d={type:"_newWorker",id:n,port:_.port2,url:R,options:A};T(d,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};_.port1.postMessage(s),URL.revokeObjectURL(R),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(s){_.port1.onmessage=s}},onmessageerror:{get(){return _.port1.onmessageerror},set(s){_.port1.onmessageerror=s}}}),_.port1.addEventListener("messageerror",s=>{const u=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(u)}),_.port1.addEventListener("message",s=>{const u=new MessageEvent("message",{data:s.data});this.dispatchEvent(u)}),_.port1.start()}}e.NestedWorker=F}),define(Ee[211],_e([0,1,4]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Ee[212],_e([0,1,10,17,23,2,4,62,46,171,211]),function(oe,e,a,F,w,T,t,A,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,t.createDecorator)("pathService");let _=class Vi{constructor(d,s,u,g){this.localUserHome=d,this.remoteAgentService=s,this.environmentService=u,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||w.OS)(),this.resolveUserHome=(async()=>{const k=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=k?.userHome||d})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,s){if(d.remoteAuthority)return a.Schemas.vscodeRemote;const u=(0,A.getVirtualWorkspaceScheme)(s.getWorkspace());if(u)return u;const g=s.getWorkspace().folders[0];if(g)return g.uri.scheme;const k=s.getWorkspace().configuration;return k?k.scheme:a.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?F.win32:F.posix)}async fileURI(d){let s="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const g=d.indexOf("/",2);g===-1?(s=d.substring(2),d="/"):(s=d.substring(2,g),d=d.substring(g)||"/")}return T.URI.from({scheme:a.Schemas.file,authority:s,path:d,query:"",fragment:""})}};_=xe([$e(1,R.IRemoteAgentService),$e(2,C.IWorkbenchEnvironmentService),$e(3,S.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(Ee[96],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(t,A){this.line=t,this.character=A}isBefore(t){return!1}isBeforeOrEqual(t){return!1}isAfter(t){return!1}isAfterOrEqual(t){return!1}isEqual(t){return!1}compareTo(t){return 0}translate(t,A){return new a(0,0)}with(t){return new a(0,0)}}e.Position=a;class F{constructor(t,A,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(t,A),this.end=new a(S,C)}contains(t){return!1}isEqual(t){return!1}intersection(t){}union(t){return new F(0,0,0,0)}with(t){return new F(0,0,0,0)}}e.Range=F;var w;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[40],_e([0,1,16,29,27,42,9,4,17,15,96,11]),function(oe,e,a,F,w,T,t,A,S,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",d=" characters skipped \u27EB",s=(n.length+d.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var u;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function k(q){return!!q.preview}e.resultIsMatch=k;function b(q){return!!q.resource}e.isFileMatch=b;function m(q){return!!q.message}e.isProgressMessage=m;var f;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class P{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=P;class l{constructor(ue,G,ce){this.ranges=G;const de=Array.isArray(G)?G:[G];if(ce&&ce.matchLines===1&&M(de)){ue=(0,t.getNLines)(ue,ce.matchLines);let Q="",ie=0,we=0;const Me=Math.floor(ce.charsPerLine/5),Fe=[];for(const Be of de){const Ke=Math.max(Be.startColumn-Me,0),je=Be.startColumn+ce.charsPerLine;if(Ke>we+Me+s){const Qe=n+(Ke-we)+d;Q+=Qe+ue.slice(Ke,je),ie+=Ke-(we+Qe.length)}else Q+=ue.slice(we,je);Fe.push(new i(0,Be.startColumn-ie,Be.endColumn-ie)),we=je}this.preview={text:Q,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const Q=Array.isArray(G)?G[0].startLineNumber:G.startLineNumber;this.preview={text:ue,matches:(0,a.mapArrayOrNot)(G,ie=>new r(ie.startLineNumber-Q,ie.startColumn,ie.endLineNumber-Q,ie.endColumn))}}}}e.TextSearchMatch=l;function M(q){const ue=q[0].startLineNumber;for(const G of q)if(G.startLineNumber!==ue||G.endLineNumber!==ue)return!1;return!0}class r{constructor(ue,G,ce,de){this.startLineNumber=ue,this.startColumn=G,this.endLineNumber=ce,this.endColumn=de}}e.SearchRange=r;class i extends r{constructor(ue,G,ce){super(ue,G,ue,ce)}}e.OneLineRange=i;var p;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(p=e.SearchSortOrder||(e.SearchSortOrder={}));function h(q,ue=!0){const G=q&&q.files&&q.files.exclude,ce=ue&&q&&q.search&&q.search.exclude;if(!G&&!ce)return;if(!G||!ce)return G||ce;let de=Object.create(null);return de=w.mixin(de,w.deepClone(G)),de=w.mixin(de,w.deepClone(ce),!0),de}e.getExcludes=h;function o(q,ue){return q.excludePattern&&F.match(q.excludePattern,ue)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&F.match(q.includePattern,ue)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(G=>{const ce=G.folder.fsPath;if(T.isEqualOrParent(ue,ce)){const de=S.relative(ce,ue);return!G.includePattern||!!F.match(G.includePattern,de)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var v;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class c extends Error{constructor(ue,G){super(ue);this.code=G}}e.SearchError=c;function E(q){const ue=q.message;if((0,C.isPromiseCanceledError)(q))return new c(ue,v.canceled);try{const G=JSON.parse(ue);return new c(G.message,G.code)}catch(G){return new c(ue,v.other)}}e.deserializeSearchError=E;function I(q){const ue={message:q.message,code:q.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=I;function D(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=D;function B(q){return q.type==="success"}e.isSerializedSearchSuccess=B;function L(q){return!!q.path}e.isSerializedFileMatch=L;function y(q,ue){const G=q.searchPath?q.searchPath:q.relativePath;return(0,t.fuzzyContains)(G,ue)}e.isFilePatternMatch=y;class x{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N(q,ue){const G={...q||{},...ue||{}};return Object.keys(G).filter(ce=>{const de=G[ce];return typeof de=="boolean"&&de})}e.resolvePatternsForProvider=N;class z{constructor(ue,G){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...G.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let ce=ue.includePattern;G.includePattern&&(ce?ce={...ce,...G.includePattern}:ce=G.includePattern),ce&&(this._parsedIncludeExpression=F.parse(ce))}matchesExcludesSync(ue,G,ce){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,G,ce))}includedInQuerySync(ue,G,ce){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,G,ce)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,G,ce))}includedInQuery(ue,G,ce){const de=this._parsedExcludeExpression(ue,G,ce),Q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,G,ce):!0;return(0,_.isPromise)(de)?de.then(ie=>ie?!1:Q()):Q()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=z;function H(q){for(const ue in q)if(typeof q[ue]!="boolean")return!0;return!1}}),define(Ee[32],_e([0,1,16,14,20,3,21,10,76,24,9,11,2,125,4,12,138,46,31,28,13,7,40,5]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b,m,f,P,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(I,D,B){return new C.ExtUri(L=>o(L,B)).isEqual(I,D)}function i(I,D,B){return r(I.uri,D.uri,B)?0:(0,R.compare)(I.uri.toString(),D.uri.toString())}function p(I,D,B){return I.index!==D.index?I.index<D.index?-1:1:r(I.uri,D.uri,B)?(0,R.compare)(I.name,D.name):(0,R.compare)(I.uri.toString(),D.uri.toString())}function h(I,D,B,L){const y=I.slice(0).sort((N,z)=>B(N,z,L)),x=D.slice(0).sort((N,z)=>B(N,z,L));return(0,a.delta)(y,x,(N,z)=>B(N,z,L))}function o(I,D){const B=D.getCapabilities(I.scheme);return!(B&&B&1024)}class v extends k.Workspace{constructor(D,B,L,y,x,N,z){super(D,L.map(H=>new k.WorkspaceFolder(H)),y,x,z);this._name=B,this._isUntitled=N,this._workspaceFolders=[],this._structure=t.TernarySearchTree.forUris(z),L.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(D,B,L,y){if(!D)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:z,configuration:H,transient:q,isUntitled:ue}=D,G=[],ce=B;B?z.forEach((we,Me)=>{const Fe=n.URI.revive(we.uri),Be=v._findFolder(L||B,Fe,y);Be?(Be.name=we.name,Be.index=we.index,G.push(Be)):G.push({uri:Fe,name:we.name,index:Me})}):G.push(...z.map(({uri:we,name:Me,index:Fe})=>({uri:n.URI.revive(we),name:Me,index:Fe}))),G.sort((we,Me)=>we.index<Me.index?-1:1);const de=new v(x,N,G,!!q,H?n.URI.revive(H):null,!!ue,we=>o(we,y)),{added:Q,removed:ie}=h(ce?ce.workspaceFolders:[],de.workspaceFolders,i,y);return{workspace:de,added:Q,removed:ie}}static _findFolder(D,B,L){for(let y=0;y<D.folders.length;y++){const x=D.workspaceFolders[y];if(r(x.uri,B,L))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(D,B){return B&&this._structure.get(D)&&(D=(0,C.dirname)(D)),this._structure.findSubstr(D)}resolveWorkspaceFolder(D){return this._structure.get(D)}}let c=class{constructor(D,B,L,y){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=y,this._extHostFileSystemInfo=L,this._requestIdProvider=new S.Counter,this._barrier=new F.Barrier,this._proxy=D.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=D.getProxy(M.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new v(x.id,x.name,[],!!x.transient,x.configuration?n.URI.revive(x.configuration):null,!!x.isUntitled,N=>o(N,L)):void 0}$initializeWorkspace(D,B){this._trusted=B,this.$acceptWorkspaceData(D),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:A.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(D,B,L,...y){const x=[];if(Array.isArray(y)&&y.forEach(ue=>{n.URI.isUri(ue.uri)&&!x.some(G=>r(G.uri,ue.uri,this._extHostFileSystemInfo))&&x.push({uri:ue.uri,name:ue.name||(0,C.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[B,L].some(ue=>typeof ue!="number"||ue<0)||L===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+L>N.length)return!1;const z=N.slice(0);z.splice(B,L,...x.map(ue=>({uri:ue.uri,name:ue.name||(0,C.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<z.length;ue++){const G=z[ue];if(z.some((ce,de)=>de!==ue&&r(G.uri,ce.uri,this._extHostFileSystemInfo)))return!1}z.forEach((ue,G)=>ue.index=G);const{added:H,removed:q}=h(N,z,p,this._extHostFileSystemInfo);if(H.length===0&&q.length===0)return!1;if(this._proxy){const ue=D.displayName||D.name;this._proxy.$updateWorkspaceFolders(ue,B,L,x).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(g.Severity.Error,(0,d.localize)(0,null,ue,G.toString()),{extension:D},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(D,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(D,B)}async getWorkspaceFolder2(D,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(D,B)}async resolveWorkspaceFolder(D){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(D)}getPath(){if(!this._actualWorkspace)return;const{folders:D}=this._actualWorkspace;if(D.length!==0)return D[0].uri.fsPath}getRelativePath(D,B){let L,y="";if(typeof D=="string"?(L=n.URI.file(D),y=D):typeof D!="undefined"&&(L=D,y=D.fsPath),!L)return y;const x=this.getWorkspaceFolder(L,!0);if(!x)return y;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let N=(0,C.relativePath)(x.uri,L);return B&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(D){this._actualWorkspace&&(this._unconfirmedWorkspace=v.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:D,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(D){const{workspace:B,added:L,removed:y}=v.toExtHostWorkspace(D,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:y}))}findFiles(D,B,L,y,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${y.value}, entryPoint: findFiles`);let N;if(B===null?N=!1:B&&(typeof B=="string"?N=B:N=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:H}=E(D);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(z),(0,_.withUndefinedAsNull)(H),(0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(L),x).then(q=>Array.isArray(q)?q.map(ue=>n.URI.revive(ue)):[])}async findTextInFiles(D,B,L,y,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${y.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),z=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:H,folder:q}=E(B.include),ue=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,G={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:z,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:H,excludePattern:ue},ce=!1;if(this._activeSearchCallbacks[N]=de=>{if(ce)return;const Q=n.URI.revive(de.resource);de.results.forEach(ie=>{(0,l.resultIsMatch)(ie)?L({uri:Q,preview:{text:ie.preview.text,matches:(0,a.mapArrayOrNot)(ie.preview.matches,we=>new P.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,a.mapArrayOrNot)(ie.ranges,we=>new P.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):L({uri:Q,text:ie.text,lineNumber:ie.lineNumber})})},x.isCancellationRequested)return{};try{const de=await this._proxy.$startTextSearch(D,(0,_.withUndefinedAsNull)(q),G,N,x);return delete this._activeSearchCallbacks[N],de||{}}catch(de){throw delete this._activeSearchCallbacks[N],de}}$handleTextSearchResult(D,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](D)}saveAll(D){return this._proxy.$saveAll(D)}resolveProxy(D){return this._proxy.$resolveProxy(D)}get trusted(){return this._trusted}requestWorkspaceTrust(D){return this._proxy.$requestWorkspaceTrust(D)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};c=xe([$e(0,f.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,u.ILogService)],c),e.ExtHostWorkspace=c,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function E(I){let D,B;return I&&(typeof I=="string"?D=I:(D=I.pattern,B=I.baseFolder||n.URI.file(I.base))),{includePattern:D,folder:B}}}),define(Ee[33],_e([0,1,27,3,32,5,7,142,61,11,14,4,13,12,2]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(M,r){if(r){const i=r.split(".");let p=M;for(let h=0;p&&h<i.length;h++)p=p[i[h]];return p}}function g(M){return M instanceof s.URI}function k(M){return M&&M.uri instanceof s.URI&&M.languageId&&typeof M.languageId=="string"}function b(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function m(M){return M&&M.uri instanceof s.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function f(M){if(g(M))return{resource:M};if(k(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(b(M))return{overrideIdentifier:M.languageId};if(m(M))return{resource:M.uri};if(M===null)return{resource:null}}let P=class{constructor(r,i,p){this._proxy=r.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=p,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new l(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(r,i))}};P=xe([$e(0,n.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,d.ILogService)],P),e.ExtHostConfiguration=P;class l{constructor(r,i,p,h){this._onDidChangeConfiguration=new F.Emitter,this._proxy=r,this._logService=h,this._extHostWorkspace=i,this._configuration=A.Configuration.parse(p),this._configurationScopes=this._toMap(p.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const p={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,p))}getConfiguration(r,i,p){const h=f(i)||{},o=this._toReadonlyValue(r?u(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,h,p?.identifier);function v(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case t.ConfigurationTarget.Global:return 1;case t.ConfigurationTarget.Workspace:return 4;case t.ConfigurationTarget.WorkspaceFolder:return 5}}const c={has(E){return typeof u(o,E)!="undefined"},get:(E,I)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,h,p?.identifier);let D=u(o,E);if(typeof D=="undefined")D=I;else{let B;const L=(y,x)=>{let N;const z=()=>{B=B||(0,a.deepClone)(o),N=N||u(B,x)};return(0,C.isObject)(y)?new Proxy(y,{get:(H,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return z(),()=>N;if(B)return N=N||u(B,x),N[q];const ue=H[q];return typeof q=="string"?L(ue,`${x}.${q}`):ue},set:(H,q,ue)=>(z(),N&&(N[q]=ue),!0),deleteProperty:(H,q)=>(z(),N&&delete N[q],!0),defineProperty:(H,q,ue)=>(z(),N&&Object.defineProperty(N,q,ue),!0)}):y};D=L(D,E)}return D},update:(E,I,D,B)=>{E=r?`${r}.${E}`:E;const L=v(D);return I!==void 0?this._proxy.$updateConfigurationOption(L,E,I,h,B):this._proxy.$removeConfigurationOption(L,E,h,B)},inspect:E=>{E=r?`${r}.${E}`:E;const I=(0,a.deepClone)(this._configuration.inspect(E,h,this._extHostWorkspace.workspace));if(I)return{key:E,defaultValue:I.default?.value,globalValue:I.user?.value,workspaceValue:I.workspace?.value,workspaceFolderValue:I.workspaceFolder?.value,defaultLanguageValue:I.default?.override,globalLanguageValue:I.user?.override,workspaceLanguageValue:I.workspace?.override,workspaceFolderLanguageValue:I.workspaceFolder?.override,languageIds:I.overrideIdentifiers}}};return typeof o=="object"&&(0,a.mixin)(c,o,!1),Object.freeze(c)}_toReadonlyValue(r){const i=p=>(0,C.isObject)(p)?new Proxy(p,{get:(h,o)=>i(h[o]),set:(h,o,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(h,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(h,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return i(r)}_validateConfigurationAccess(r,i,p){const h=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),o=p?`[${p.value}] `:"";if(h===4){typeof i?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){i?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const p=new A.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,o)=>p.affectsConfiguration(h,f(o))})}_toMap(r){return r.reduce((i,p)=>(i.set(p[0],p[1]),i),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[97],_e([0,1,2,14,3,5,7,32,48,33,20,39,13,28,4,10,23,12,70,161,15]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b,m,f){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(x){function N(q){if(q){const ue=q;return ue&&!!ue.process}else return!1}x.is=N;function z(q){if(q==null)return;const ue={process:q.process,args:q.args};return q.options&&(ue.options=r.from(q.options)),ue}x.from=z;function H(q){if(q!=null)return new t.ProcessExecution(q.process,q.args,q.options)}x.to=H})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var p;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(p=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(x){function N(q){if(q){const ue=q;return ue&&(!!ue.commandLine||!!ue.command)}else return!1}x.is=N;function z(q){if(q==null)return;const ue={};return q.commandLine!==void 0?ue.commandLine=q.commandLine:(ue.command=q.command,ue.args=q.args),q.options&&(ue.options=p.from(q.options)),ue}x.from=z;function H(q){if(!(q==null||q.command===void 0&&q.commandLine===void 0))return q.commandLine?new t.ShellExecution(q.commandLine,q.options):new t.ShellExecution(q.command,q.args?q.args:[],q.options)}x.to=H})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(x){function N(q){if(q){let ue=q;return ue&&ue.customExecution==="customExecution"}else return!1}x.is=N;function z(q){return{customExecution:"customExecution"}}x.from=z;function H(q,ue){return ue.get(q)}x.to=H})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var v;(function(x){function N(z,H){let q;return z.scope!==void 0&&typeof z.scope!="number"?q=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===t.TaskScope.Workspace&&H&&H.workspaceFile?q=H.workspaceFile:q=m.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:q}}x.from=N})(v=e.TaskHandleDTO||(e.TaskHandleDTO={}));var c;(function(x){function N(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}x.from=N})(c=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(x){function N(q,ue){if(q==null)return[];const G=[];for(let ce of q){const de=z(ce,ue);de&&G.push(de)}return G}x.fromMany=N;function z(q,ue){if(q==null)return;let G;q.execution instanceof t.ProcessExecution?G=i.from(q.execution):q.execution instanceof t.ShellExecution?G=h.from(q.execution):q.execution&&q.execution instanceof t.CustomExecution&&(G=o.from(q.execution));const ce=l.from(q.definition);let de;return q.scope?typeof q.scope=="number"?de=q.scope:de=q.scope.uri:de=t.TaskScope.Workspace,!ce||!de?void 0:{_id:q._id,definition:ce,name:q.name,source:{extensionId:ue.identifier.value,label:q.source,scope:de},execution:G,isBackground:q.isBackground,group:c.from(q.group),presentationOptions:M.from(q.presentationOptions),problemMatchers:q.problemMatchers,hasDefinedMatchers:q.hasDefinedMatchers,runOptions:q.runOptions?q.runOptions:{reevaluateOnRerun:!0},detail:q.detail}}x.from=z;async function H(q,ue,G){if(q==null)return;let ce;i.is(q.execution)?ce=i.to(q.execution):h.is(q.execution)?ce=h.to(q.execution):o.is(q.execution)&&(ce=o.to(q._id,G));const de=l.to(q.definition);let Q;if(q.source&&(q.source.scope!==void 0?typeof q.source.scope=="number"?Q=q.source.scope:Q=await ue.resolveWorkspaceFolder(a.URI.revive(q.source.scope)):Q=t.TaskScope.Workspace),!de||!Q)return;const ie=new t.Task(de,Q,q.name,q.source.label,ce,q.problemMatchers);return q.isBackground!==void 0&&(ie.isBackground=q.isBackground),q.group!==void 0&&(ie.group=t.TaskGroup.from(q.group._id),ie.group&&q.group.isDefault&&(ie.group=new t.TaskGroup(ie.group.id,ie.group.label),q.group.isDefault&&(ie.group.isDefault=q.group.isDefault))),q.presentationOptions&&(ie.presentationOptions=M.to(q.presentationOptions)),q._id&&(ie._id=q._id),q.detail&&(ie.detail=q.detail),ie}x.to=H})(E=e.TaskDTO||(e.TaskDTO={}));var I;(function(x){function N(H){return H}x.from=N;function z(H){if(!!H)return Object.assign(Object.create(null),H)}x.to=z})(I=e.TaskFilterDTO||(e.TaskFilterDTO={}));class D{constructor(N,z,H){this._id=z,this._task=H,P.set(this,void 0),Ze(this,P,N,"f")}get task(){return this._task}terminate(){Ae(this,P,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}P=new WeakMap;var B;(function(x){function N(z){return{id:z._id,task:void 0}}x.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(N,z,H,q,ue,G,ce,de){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=N.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=q,this._configurationService=ue,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ce,this._deprecationService=de,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,z,H){if(!H)return new t.Disposable(()=>{});const q=this.nextHandle();return this._handlers.set(q,{type:z,provider:H,extension:N}),this._proxy.$registerTaskProvider(q,z),new t.Disposable(()=>{this._handlers.delete(q),this._proxy.$unregisterTaskProvider(q)})}registerTaskSystem(N,z){this._proxy.$registerTaskSystem(N,z)}fetchTasks(N){return this._proxy.$fetchTasks(I.from(N)).then(async z=>{const H=[];for(let q of z){const ue=await E.to(q,this._workspaceProvider,this._providedCustomExecutions2);ue&&H.push(ue)}return H})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(z=>N.push(z)),N}terminateTask(N){if(!(N instanceof D))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,z,H){const q=this._providedCustomExecutions2.get(N.id);q&&(this._activeCustomExecutions2.set(N.id,q),this._terminalService.attachPtyToTerminal(z,await q.callback(H))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const z=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const z=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:z,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const z=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:N.exitCode})}$provideTasks(N,z){const H=this._handlers.get(N);if(!H)return Promise.reject(new Error("no handler found"));const q=[],ue=(0,F.asPromise)(()=>H.provider.provideTasks(R.CancellationToken.None)).then(G=>this.provideTasksInternal(z,q,H,G));return new Promise(G=>{ue.then(ce=>{Promise.all(q).then(()=>{G(ce)})})})}async $resolveTask(N,z){const H=this._handlers.get(N);if(!H)return Promise.reject(new Error("no handler found"));if(z.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${H.type}].`);const q=await E.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!q)throw new Error("Unexpected: Task cannot be resolved.");const ue=await H.provider.resolveTask(q,R.CancellationToken.None);if(!ue)return;this.checkDeprecation(ue,H);const G=E.from(ue,H.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(ue.definition!==q.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(G.execution)&&await this.addCustomExecution(G,ue,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,z,H){const q=await this._proxy.$createTaskId(N);!H&&!this._providedCustomExecutions2.has(q)&&(this._notProvidedCustomExecutions.add(q),this._activeCustomExecutions2.set(q,z.execution)),this._providedCustomExecutions2.set(q,z.execution)}async getTaskExecution(N,z){if(typeof N=="string"){const ue=this._taskExecutionPromises.get(N);if(!ue)throw new Error("Unexpected: The specified task is missing an execution");return ue}let H=this._taskExecutionPromises.get(N.id);if(H)return H;const q=new Promise((ue,G)=>{function ce(de,Q,ie){ie?ue(new D(de,Q.id,ie)):G("Unexpected: Task does not exist.")}z?ce(this,N,z):E.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(de=>ce(this,N,de))});return this._taskExecutionPromises.set(N.id,q),q.then(ue=>(this._taskExecutions.set(N.id,ue),ue),ue=>Promise.reject(ue))}checkDeprecation(N,z){N._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let H=this._notProvidedCustomExecutions.values(),q=H.next();for(;!q.done;)!this._activeCustomExecutions2.has(q.value)&&this._lastStartedTask!==q.value&&(this._providedCustomExecutions2.delete(q.value),this._notProvidedCustomExecutions.delete(q.value)),q=H.next()}};L=xe([$e(0,n.IExtHostRpcService),$e(1,d.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,k.ILogService),$e(7,b.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let y=class extends L{constructor(N,z,H,q,ue,G,ce,de){super(N,z,H,q,ue,G,ce,de);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(N,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const H=E.from(z,N);if(H===void 0)throw new Error("Task is not valid");if(o.is(H.execution))await this.addCustomExecution(H,z,!1);else throw new f.NotSupportedError;const q=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),z);return this._proxy.$executeTask(H).catch(ue=>{throw new Error(ue)}),q}provideTasksInternal(N,z,H,q){const ue=[];if(q)for(let G of q){this.checkDeprecation(G,H),(!G.definition||!N[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const ce=E.from(G,H.extension);ce&&o.is(ce.execution)?(ue.push(ce),z.push(this.addCustomExecution(ce,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ue,extension:H.extension}}async resolveTaskInternal(N){if(o.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,z,H){}};y=xe([$e(0,n.IExtHostRpcService),$e(1,d.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,k.ILogService),$e(7,b.IExtHostApiDeprecationService)],y),e.WorkerExtHostTask=y,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(Ee[213],_e([0,1,16,75,29,78,21,10,17,24,9,11,2,231,128,83,46,90,212,40]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(v,c,E,I){this.configurationService=v,this.workspaceContextService=c,this.editorGroupsService=E,this.pathService=I}text(v,c,E={}){v=this.getContentPattern(v,E);const I=this.configurationService.getValue(),D=c&&c.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(c?.map(g.toWorkspaceFolder),E),type:2,contentPattern:v,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:I.search.usePCRE2||D||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(v,c){const E=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const I={...v,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(v,c)&&(I.isCaseSensitive=!0),this.isMultiline(v)&&(I.isMultiline=!0),I}file(v,c={}){return{...this.commonQuery(v,c),type:1,filePattern:c.filePattern?c.filePattern.trim():c.filePattern,exists:c.exists,sortByScore:c.sortByScore,cacheKey:c.cacheKey}}handleIncludeExclude(v,c){return v?(v=Array.isArray(v)?v.map(i):i(v),c?this.parseSearchPaths(v):{pattern:l(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],c={}){const E=this.handleIncludeExclude(c.includePattern,c.expandPatterns),I=this.handleIncludeExclude(c.excludePattern,c.expandPatterns),D=v.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,c,I)):v.map(x=>this.getFolderQueryForRoot(x,c,I,D))).filter(x=>!!x),L={_reason:c._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:c.extraFileResources,excludePattern:I.pattern,includePattern:E.pattern,onlyOpenEditors:c.onlyOpenEditors,maxResults:c.maxResults};if(c.onlyOpenEditors){const N=a.coalesce(a.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(q=>q.resource)))).filter(H=>(0,m.pathIncludedInQuery)(L,H.fsPath)),z=this.commonQueryFromFileList(N);return{...L,...z}}const y=c.extraFileResources&&c.extraFileResources.filter(x=>(0,m.pathIncludedInQuery)(L,x.fsPath));return L.extraFileResources=y&&y.length?y:void 0,L}commonQueryFromFileList(v){const c=[],E=new t.ResourceMap,I={};let D=!1;return v.forEach(B=>{if(B.scheme===A.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(B)){const y=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:S.dirname(B.fsPath)});let x=E.get(y);x||(D=!0,x={folder:y,includePattern:{}},c.push(x),E.set(y,x));const N=S.relative(y.fsPath,B.fsPath);(0,_.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(D=!0,I[B.fsPath]=!0)}),{folderQueries:c,includePattern:I,usingSearchPaths:!0,excludePattern:D?void 0:{"**/*":!0}}}isCaseSensitive(v,c){if(c.isSmartCase){if(v.isRegExp){if(R.containsUppercaseCharacter(v.pattern,!0))return!0}else if(R.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,d.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const c=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),I=(Array.isArray(v)?v:M(v)).map(z=>{const H=this.pathService.resolvedUserHome;return H?(0,T.untildify)(z,H.scheme===A.Schemas.file?H.fsPath:H.path):z}),D=F.groupBy(I,z=>c(z)?"searchPaths":"exprSegments"),B=(D.exprSegments||[]).map(z=>R.rtrim(z,"/")).map(z=>R.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),L={},y=this.expandSearchPathPatterns(D.searchPaths||[]);y&&y.length&&(L.searchPaths=y);const x=a.flatten(B),N=l(...x);return N&&(L.pattern=N),L}getExcludesForFolder(v,c){return c.disregardExcludeSettings?void 0:(0,m.getExcludes)(v,!c.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const c=a.flatten(v.map(I=>{let{pathPortion:D,globPortion:B}=P(I);B&&(B=p(B));const L=this.expandOneSearchPath(D);return a.flatten(L.map(y=>this.resolveOneSearchPathPattern(y,B)))})),E=new Map;return c.forEach(I=>{const D=I.searchPath.toString(),B=E.get(D);B?I.pattern&&(B.pattern=B.pattern||{},B.pattern[I.pattern]=!0):E.set(D,{searchPath:I.searchPath,pattern:I.pattern?l(I.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(v){if(S.isAbsolute(v)){const c=this.workspaceContextService.getWorkspace().folders;return c[0]&&c[0].uri.scheme!==A.Schemas.file?[{searchPath:c[0].uri.with({path:v})}]:[{searchPath:n.URI.file(S.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const c=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=i(v),v.startsWith("../")||v===".."){const I=S.posix.resolve(c.path,v);return[{searchPath:c.with({path:I})}]}const E=p(v);return[{searchPath:c,pattern:E}]}else{if(v==="./"||v===".\\")return[];{const c=v.replace(/^\.[\/\\]/,""),I=this.workspaceContextService.getWorkspace().folders.map(D=>{const B=c.match(new RegExp(`^${R.escapeRegExpCharacters(D.name)}(?:/(.*)|$)`));return B?{match:B,folder:D}:null}).filter(_.isDefined);if(I.length)return I.map(D=>{const B=D.match[1];return{searchPath:D.folder.uri,pattern:B&&p(B)}});{const D=v.match(/\.[\/\\](.+)[\/\\]?/),B=D?D[1]:v,L=s.localize(0,null,B);throw new Error(L)}}}}resolveOneSearchPathPattern(v,c){const E=v.pattern&&c?`${v.pattern}/${c}`:v.pattern||c,I=[{searchPath:v.searchPath,pattern:E}];return E&&!E.endsWith("**")&&I.push({searchPath:v.searchPath,pattern:E+"/**"}),I}getFolderQueryForSearchPath(v,c,E){const I=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(v.searchPath),c,E,!1);return I?{...I,includePattern:v.pattern}:null}getFolderQueryForRoot(v,c,E,I){let D;const B=n.URI.isUri(v)?v:v.uri;if(E.searchPaths){const z=E.searchPaths.filter(H=>(0,C.isEqual)(H.searchPath,B))[0];if(z&&!z.pattern)return null;z&&(D=z.pattern)}const L=this.configurationService.getValue({resource:B}),x={...this.getExcludesForFolder(L,c)||{},...D||{}},N=n.URI.isUri(v)?(0,C.basename)(v):v.name;return{folder:B,folderName:I?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof c.disregardIgnoreFiles=="boolean"?c.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof c.disregardGlobalIgnoreFiles=="boolean"?c.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof c.ignoreSymlinks=="boolean"?c.ignoreSymlinks:!L.search.followSymlinks}}};f=xe([$e(0,u.IConfigurationService),$e(1,g.IWorkspaceContextService),$e(2,k.IEditorGroupsService),$e(3,b.IPathService)],f),e.QueryBuilder=f;function P(o){const v=o.match(/[\*\{\}\(\)\[\]\?]/);if(v){const c=v.index,E=o.substr(0,c).match(/[/|\\][^/\\]*$/);if(E){let I=o.substr(0,E.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:o.substr((E.index||0)+1)}}}return{pathPortion:o}}function l(...o){return o.length?o.reduce((v,c)=>(v[c]=!0,v),Object.create(null)):void 0}function M(o){return w.splitGlobAware(o,",").map(v=>v.trim()).filter(v=>!!v.length)}function r(o){return[`**/${o}/**`,`**/${o}`].map(c=>c.replace(/\*\*\/\*\*/g,"**"))}function i(o){return o.replace(/\\/g,"/")}function p(o){return i(o).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(o,v){o=a.distinct(o,I=>I.toString());const c=[],E=v.getWorkspace();return o&&o.forEach(I=>{let D;if(v.getWorkbenchState()===2)D=(0,C.relativePath)(E.folders[0].uri,I),D&&D!=="."&&(D="./"+D);else{const B=v.getWorkspaceFolder(I);if(B){const L=B.name;if(E.folders.filter(x=>x.name===L).length===1){const x=(0,C.relativePath)(B.uri,I);x===""?D=`./${B.name}`:D=`./${B.name}/${x}`}else D=I.fsPath}}D&&c.push(D)}),c}e.resolveResourcesForSearchIncludes=h}),define(Ee[214],_e([0,1,24,2,20,15,4,213,40,46]),function(oe,e,a,F,w,T,t,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function _(u,g){const k=g.activationEvents;if(!k)return Promise.resolve(void 0);const b=[],m=[];for(const i of k)if(/^workspaceContains:/.test(i)){const p=i.substr("workspaceContains:".length);p.indexOf("*")>=0||p.indexOf("?")>=0||u.forceUsingSearch?m.push(p):b.push(p)}if(b.length===0&&m.length===0)return Promise.resolve(void 0);let f;const P=new Promise((i,p)=>{f=i}),l=i=>f({activationEvent:i}),M=Promise.all(b.map(i=>n(u,i,l))).then(()=>{}),r=d(u,g.identifier,m,l);return Promise.all([M,r]).then(()=>{f(void 0)}),P}e.checkActivateWorkspaceContainsExtension=_;async function n(u,g,k){for(const b of u.folders)if(await u.exists(a.joinPath(F.URI.revive(b),g))){k(`workspaceContains:${g}`);return}}async function d(u,g,k,b){if(k.length===0)return Promise.resolve(void 0);const m=new w.CancellationTokenSource,f=u.checkExists(u.folders,k,m.token),P=setTimeout(async()=>{m.cancel(),u.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${k.join(",")}`)},R);let l=!1;try{l=await f}catch(M){T.isPromiseCanceledError(M)||T.onUnexpectedError(M)}m.dispose(),clearTimeout(P),l&&b(`workspaceContains:${k.join(",")}`)}function s(u,g,k,b){const m=u.get(t.IInstantiationService),f=u.get(S.ISearchService),l=m.createInstance(A.QueryBuilder).file(g.map(M=>(0,C.toWorkspaceFolder)(F.URI.revive(M))),{_reason:"checkExists",includePattern:k,exists:!0});return f.fileSearch(l,b).then(M=>!!M.limitHit,M=>T.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=s});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,a,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,a):w?w.value=a:e.set(oe,a),a},Ae=this&&this.__classPrivateFieldGet||function(oe,e,a,F){if(a==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?F:a==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[34],_e([0,1,120,17,74,24,14,6,21,2,12,5,33,174,72,32,26,172,15,25,22,147,7,84,4,28,73,13,60,65,39,3,214,69,149,10]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b,m,f,P,l,M,r,i,p,h,o,v,c,E,I,D,B,L){"use strict";var y,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let z=class ji extends A.Disposable{constructor(G,ce,de,Q,ie,we,Me,Fe,Be,Ke){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ce,this._extHostContext=de,this._initData=Me,this._extHostWorkspace=Q,this._extHostConfiguration=ie,this._logService=we,this._extHostTunnelService=Be,this._extHostTerminalService=Ke,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new t.Barrier,this._readyToStartExtensionHost=new t.Barrier,this._readyToRunExtensions=new t.Barrier,this._eagerExtensionsActivated=new t.Barrier,this._registry=new k.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new D.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=G.createChild(new o.ServiceCollection([s.IExtHostStorage,this._storage],[D.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(Qe=>je.add(m.ExtensionIdentifier.toKey(Qe))),this._activator=this._register(new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Qe,$,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Qe,b.transformErrorForSerialization($),K)},actualActivateExtension:async(Qe,$)=>{if(je.has(m.ExtensionIdentifier.toKey(Qe)))return await this._mainThreadExtensionsProxy.$activateExtension(Qe,$),new d.HostExtension;const K=this._registry.getExtensionDescription(Qe);return this._activateExtension(K,$)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){b.onUnexpectedError(G)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._registry.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this._deactivate(ie))}catch(ce){}await Promise.all(G)}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}_activateByEvent(G,ce){return this._activator.activateByEvent(G,ce)}_activateById(G,ce){return this._activator.activateById(G,ce)}activateByIdWithErrors(G,ce){return this._activateById(G,ce).then(()=>{const de=this._activator.getActivatedExtension(G);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._registry)}getExtensionExports(G){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(G).exports:null}async _realPathExtensionUri(G){if(G.scheme!==L.Schemas.file)return G;const ce=await this._hostUtils.realpath(G.fsPath);return C.URI.file(ce)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const G=S.TernarySearchTree.forUris(ce=>T.extUriBiasedIgnorePathCase.ignorePathCasing(ce));for(const ce of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ce)){const de=await this._realPathExtensionUri(ce.extensionLocation);G.set(de,ce)}return G})()),this._extensionPathIndex}_deactivate(G){let ce=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return ce;const de=this._activator.getActivatedExtension(G);if(!de)return ce;try{typeof de.module.deactivate=="function"&&(ce=Promise.resolve(de.module.deactivate()).then(void 0,Q=>(this._logService.error(Q),Promise.resolve(void 0))))}catch(Q){this._logService.error(Q)}try{(0,A.dispose)(de.subscriptions)}catch(Q){this._logService.error(Q)}return ce}async _activateExtension(G,ce){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,ce).then(de=>{const Q=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,Q.codeLoadingTime,Q.activateCallTime,Q.activateResolvedTime,ce),this._logExtensionActivationTimes(G,ce,"success",Q),de},de=>{throw this._logExtensionActivationTimes(G,ce,"failure"),de})}_logExtensionActivationTimes(G,ce,de,Q){const ie=H(G,ce);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ie,...Q||{},outcome:de})}_doActivateExtension(G,ce){const de=H(G,ce);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const Q=this._getEntryPoint(G);if(!Q)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${ce.startup}, activationEvent: '${ce.activationEvent}'${G.identifier.value!==ce.extensionId.value?`, root cause: ${ce.extensionId.value}`:""}`),this._logService.flush();const ie=new d.ExtensionActivationTimesBuilder(ce.startup);return Promise.all([this._loadCommonJSModule(G.identifier,(0,T.joinPath)(G.extensionLocation,Q),ie),this._loadExtensionContext(G)]).then(we=>(w.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),ji._callActivate(this._logService,G.identifier,we[0],we[1],ie))).then(we=>(w.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),we))}_loadExtensionContext(G){const ce=new P.ExtensionGlobalMemento(G,this._storage),de=new P.ExtensionMemento(G.identifier.value,!1,this._storage),Q=new B.ExtensionSecrets(G,this._secretState),ie=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,we=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([ce.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const Me=this;let Fe;return Object.freeze({globalState:ce,workspaceState:de,secrets:Q,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(Be){return F.join(G.extensionLocation.fsPath,Be)},get storagePath(){return Me._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return Me._storagePath.globalValue(G).fsPath},get logPath(){return F.join(Me._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return C.URI.joinPath(Me._initData.logsLocation,G.identifier.value)},get storageUri(){return Me._storagePath.workspaceValue(G)},get globalStorageUri(){return Me._storagePath.globalValue(G)},get extensionMode(){return ie},get extension(){return Fe===void 0&&(Fe=new q(Me,G.identifier,G,we)),Fe},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(G,"extensionRuntime"),Me.extensionRuntime},get environmentVariableCollection(){return Me._extHostTerminalService.getEnvironmentVariableCollection(G)}})})}static _callActivate(G,ce,de,Q,ie){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,ce,de,Q,ie).then(we=>new d.ActivatedExtension(!1,null,ie.build(),de,we,Q.subscriptions))}static _callActivateOptional(G,ce,de,Q,ie){if(typeof de.activate=="function")try{ie.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${ce.value}`);const we=typeof global=="object"?global:self,Me=de.activate.apply(we,[Q]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(Me).then(Fe=>(ie.activateResolveStop(),Fe))}catch(we){return Promise.reject(we)}else return Promise.resolve(de)}_activateOneStartupFinished(G,ce){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:ce}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const G of this._registry.getAllExtensionDescriptions())if(G.activationEvents)for(const ce of G.activationEvents)ce==="onStartupFinished"&&this._activateOneStartupFinished(G,ce)}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,ie=>{this._logService.error(ie)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ie=>this._handleWorkspaceContainsEagerExtensions(ie.added)));const ce=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(ce),Q=Promise.all([G,de]).then(()=>{});return Promise.race([Q,(0,t.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Q}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ce=>this._handleWorkspaceContainsEagerExtension(G,ce))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,ce){if(this.isActivated(ce.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Q={logService:this._logService,folders:G.map(we=>we.uri),forceUsingSearch:de,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Me,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(we,Me,Fe)},ie=await(0,I.checkActivateWorkspaceContainsExtension)(Q,ce);if(!!ie)return this._activateById(ce.identifier,{startup:!0,extensionId:ce.identifier,activationEvent:ie.activationEvent}).then(void 0,we=>this._logService.error(we))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:ce}=this._initData.environment;if(!G||!ce)throw new Error(a.localize(0,null));const de=await this._loadCommonJSModule(null,ce,new d.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(a.localize(1,null,ce.toString()));return new Promise((Q,ie)=>{const we=(Be,Ke)=>{Be?ie(Be):Q(typeof Ke=="number"&&Ke>0?1:0)},Me=(0,T.originalFSPath)(ce),Fe=de.run(Me,we);Fe&&Fe.then&&Fe.then(()=>{Q(0)}).catch(Be=>{ie(Be.toString())})})}async $extensionTestsExit(G){this._logService.info(`Extension host terminating: test runner requested exit with code ${G}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${G}`),this._logService.flush(),this._hostUtils.exit(G)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,ce){return this._resolvers[G]=ce,(0,A.toDisposable)(()=>{delete this._resolvers[G]})}async _activateAndGetResolver(G){const ce=G.indexOf("+");if(ce===-1)throw new Error("Not an authority that can be resolved!");const de=G.substr(0,ce);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(G,ce){const{authorityPrefix:de,resolver:Q}=await this._activateAndGetResolver(G);if(!Q)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${de}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(Q)),w.mark(`code/extHost/willResolveAuthority/${de}`);const ie=await Q.resolve(G,{resolveAttempt:ce});w.mark(`code/extHost/didResolveAuthorityOK/${de}`);const we={authority:G,host:ie.host,port:ie.port,connectionToken:ie.connectionToken},Me={extensionHostEnv:ie.extensionHostEnv,isTrusted:ie.isTrusted,authenticationSession:ie.authenticationSessionForInitializingExtensions?{id:ie.authenticationSessionForInitializingExtensions.id,providerId:ie.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:we,options:Me,tunnelInformation:{environmentTunnels:ie.environmentTunnels}}}}catch(ie){if(w.mark(`code/extHost/didResolveAuthorityError/${de}`),ie instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:ie._code,message:ie._message,detail:ie._detail}};throw ie}}async $getCanonicalURI(G,ce){const{authorityPrefix:de,resolver:Q}=await this._activateAndGetResolver(G);if(!Q)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${de}`);const ie=C.URI.revive(ce);if(typeof Q.getCanonicalURI=="undefined")return ie;const we=await(0,t.asPromise)(()=>Q.getCanonicalURI(ie));return we||ie}$startExtensionHost(G){return this._registry.keepOnly(G),this._startExtensionHost()}$activateByEvent(G,ce){return ce===1?this._activateByEvent(G,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(G,!1))}async $activate(G,ce){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(G)?(await this._activateById(G,ce),!0):!1}async $deltaExtensions(G,ce){G.forEach(Q=>Q.extensionLocation=C.URI.revive(Q.extensionLocation));const de=await this.getExtensionPathIndex();return await Promise.all(ce.map(async Q=>{const ie=this._registry.getExtensionDescription(Q);ie&&de.delete(await this._realPathExtensionUri(ie.extensionLocation))})),await Promise.all(G.map(async Q=>{const ie=await this._realPathExtensionUri(Q.extensionLocation);de.set(ie,Q)})),this._registry.deltaExtensions(G,ce),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){let ce=f.VSBuffer.alloc(G),de=Math.random()%256;for(let Q=0;Q<G;Q++)ce.writeUInt8(de,Q);return ce}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};z=xe([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,h.IExtHostRpcService),$e(3,u.IExtHostWorkspace),$e(4,n.IExtHostConfiguration),$e(5,R.ILogService),$e(6,i.IExtHostInitDataService),$e(7,p.IExtensionStoragePaths),$e(8,v.IExtHostTunnelService),$e(9,c.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function H(ue,G){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class q{constructor(G,ce,de,Q){y.set(this,void 0),x.set(this,void 0),N.set(this,void 0),Ze(this,y,G,"f"),Ze(this,x,ce,"f"),Ze(this,N,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=F.normalize((0,T.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=Q}get isActive(){return Ae(this,y,"f").isActivated(Ae(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,y,"f").getExtensionExports(Ae(this,N,"f"))}activate(){return Ae(this,y,"f").activateByIdWithErrors(Ae(this,N,"f"),{startup:!1,extensionId:Ae(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=q,y=new WeakMap,x=new WeakMap,N=new WeakMap}),define(Ee[98],_e([0,1,17,2,3,14,5,7,156,32,34,48,163,33,157,13,4,11,89,71]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let f=class{constructor(o,v,c,E,I,D){this._workspaceService=v,this._extensionService=c,this._editorsService=E,this._configurationService=I,this._editorTabs=D,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=o.getProxy(t.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(L=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,v){const c=o;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let E=`debug:${encodeURIComponent(c.path||"")}`,I="?";return v&&(E+=`${I}session=${encodeURIComponent(v.id)}`,I="&"),E+=`${I}ref=${c.sourceReference}`,F.URI.parse(E)}else{if(c.path)return F.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const v=[];for(const c of o.getAllExtensionDescriptions())if(c.contributes){const E=c.contributes.debuggers;if(E&&E.length>0)for(const I of E)(0,s.isDebuggerMainContribution)(I)&&v.push(I.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(v=>o.push(v)),o}addBreakpoints(o){this.startBreakpoints();const v=o.filter(I=>{const D=I.id;return this._breakpoints.has(D)?!1:(this._breakpoints.set(D,I),!0)});this.fireBreakpointChanges(v,[],[]);const c=[],E=new Map;for(const I of v)if(I instanceof A.SourceBreakpoint){let D=E.get(I.location.uri.toString());D||(D={type:"sourceMulti",uri:I.location.uri,lines:[]},E.set(I.location.uri.toString(),D),c.push(D)),D.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character})}else I instanceof A.FunctionBreakpoint&&c.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName});return this._debugServiceProxy.$registerBreakpoints(c)}removeBreakpoints(o){this.startBreakpoints();const v=o.filter(D=>this._breakpoints.delete(D.id));this.fireBreakpointChanges([],v,[]);const c=v.filter(D=>D instanceof A.SourceBreakpoint).map(D=>D.id),E=v.filter(D=>D instanceof A.FunctionBreakpoint).map(D=>D.id),I=v.filter(D=>D instanceof A.DataBreakpoint).map(D=>D.id);return this._debugServiceProxy.$unregisterBreakpoints(c,E,I)}startDebugging(o,v,c){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,v,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,debugUI:c.debugUI,suppressSaveBeforeStart:c.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,v,c){if(!v)return new A.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:E,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,c,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,E),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(I=>I.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(o,v,c){if(!c)return new A.Disposable(()=>{});if(!this.definesDebugType(o,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:E,factory:c}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,E),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(I=>I.factory!==c),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(o,v){if(!v)return new A.Disposable(()=>{});const c=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:c,factory:v}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==v)})}async $runInTerminal(o,v){return Promise.resolve(void 0)}async $substituteVariables(o,v){if(!this._variableResolver){const[I,D]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(I||[],this._editorsService,D)}let c;const E=await this.getFolder(o);return E&&(c={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(c,v)}createDebugAdapter(o,v){if(o.type==="implementation")return new i(o.implementation)}createSignService(){}async $startDASession(o,v){const c=this,E=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const D=this.convertToDto(I),B=this.createDebugAdapter(D,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const L=B;return this._debugAdapters.set(o,L),this.getDebugAdapterTrackers(E).then(y=>(y&&this._debugAdaptersTrackers.set(o,y),L.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,z={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(N.arguments.value);z.body={signature:H},L.sendResponse(z)}else throw new Error("no signer")}catch(H){z.success=!1,z.message=H.message,L.sendResponse(z)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(x),x=(0,s.convertToVSCPaths)(x,!0),c._debugServiceProxy.$acceptDAMessage(o,x)}),L.onError(x=>{y&&y.onError&&y.onError(x),this._debugServiceProxy.$acceptDAError(o,x.name,x.message,x.stack)}),L.onExit(x=>{y&&y.onExit&&y.onExit((0,k.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,k.withNullAsUndefined)(x),void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),L.startSession()))})}$sendDAMessage(o,v){v=(0,s.convertToDAPaths)(v,!1);const c=this._debugAdaptersTrackers.get(o);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(v);const E=this._debugAdapters.get(o);E&&E.sendMessage(v)}$stopDASession(o){const v=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),v&&v.onWillStopSession&&v.onWillStopSession();const c=this._debugAdapters.get(o);return this._debugAdapters.delete(o),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const v=[],c=[],E=[];if(o.added)for(const I of o.added){const D=I.id;if(D&&!this._breakpoints.has(D)){let B;if(I.type==="function")B=new A.FunctionBreakpoint(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage);else if(I.type==="data")B=new A.DataBreakpoint(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage);else{const L=F.URI.revive(I.uri);B=new A.SourceBreakpoint(new A.Location(L,new A.Position(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage)}B._id=D,this._breakpoints.set(D,B),v.push(B)}}if(o.removed)for(const I of o.removed){const D=this._breakpoints.get(I);D&&(this._breakpoints.delete(I),c.push(D))}if(o.changed){for(const I of o.changed)if(I.id){const D=this._breakpoints.get(I.id);if(D){if(D instanceof A.FunctionBreakpoint&&I.type==="function"){const B=D;B.enabled=I.enabled,B.condition=I.condition,B.hitCondition=I.hitCondition,B.logMessage=I.logMessage,B.functionName=I.functionName}else if(D instanceof A.SourceBreakpoint&&I.type==="source"){const B=D;B.enabled=I.enabled,B.condition=I.condition,B.hitCondition=I.hitCondition,B.logMessage=I.logMessage,B.location=new A.Location(F.URI.revive(I.uri),new A.Position(I.line,I.character))}E.push(D)}}}this.fireBreakpointChanges(v,c,E)}$provideDebugConfigurations(o,v,c){return(0,T.asPromise)(async()=>{const E=this.getConfigProviderByHandle(o);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.getFolder(v);return E.provideDebugConfigurations(I,c)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(o,v,c,E){return(0,T.asPromise)(async()=>{const I=this.getConfigProviderByHandle(o);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.getFolder(v);return I.resolveDebugConfiguration(D,c,E)})}$resolveDebugConfigurationWithSubstitutedVariables(o,v,c,E){return(0,T.asPromise)(async()=>{const I=this.getConfigProviderByHandle(o);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.getFolder(v);return I.resolveDebugConfigurationWithSubstitutedVariables(D,c,E)})}async $provideDebugAdapter(o,v){const c=this.getAdapterDescriptorFactoryByHandle(o);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(v);return this.getAdapterDescriptor(c,E).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(I)})}async $acceptDebugSessionStarted(o){const v=await this.getSession(o);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(o){const v=await this.getSession(o);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,v){const c=await this.getSession(o);c&&c._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(o,v){const E={session:await this.getSession(o),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(o){if(o instanceof A.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof A.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const v=this._adapterFactories.filter(c=>c.type===o);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(o){const v=this._adapterFactories.filter(c=>c.handle===o);if(v.length>0)return v[0].factory}getConfigProviderByHandle(o){const v=this._configProviders.filter(c=>c.handle===o);if(v.length>0)return v[0].provider}definesDebugType(o,v){if(o.contributes){const c=o.contributes.debuggers;if(c&&c.length>0){for(const E of c)if(E.label&&E.type&&E.type===v)return!0}}return!1}getDebugAdapterTrackers(o){const c=o.configuration.type,E=this._trackerFactories.filter(I=>I.type===c||I.type==="*").map(I=>(0,T.asPromise)(()=>I.factory.createDebugAdapterTracker(o)).then(D=>D,D=>null));return Promise.race([Promise.all(E).then(I=>{const D=I.filter(B=>!!B);if(D.length>0)return new r(D)}),new Promise((I,D)=>{const B=setTimeout(()=>{clearTimeout(B),D(new Error("timeout"))},1e3)})]).catch(I=>{})}async getAdapterDescriptor(o,v){const c=v.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new A.DebugAdapterServer(c));if(o){const I=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>o.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,I))).then(D=>{if(D)return D})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,E))}daExecutableFromPackage(o,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,v,c){(o.length>0||v.length>0||c.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:v,changed:c}))}async getSession(o){if(o)if(typeof o=="string"){const v=this._debugSessions.get(o);if(v)return v}else{let v=this._debugSessions.get(o.id);if(!v){const c=await this.getFolder(o.folderUri),E=o.parent?this._debugSessions.get(o.parent):void 0;v=new P(this._debugServiceProxy,o.id,o.type,o.name,c,o.configuration,E),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(o){if(o){const v=F.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};f=xe([$e(0,u.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,d.IExtHostConfiguration),$e(5,m.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class P{constructor(o,v,c,E,I,D,B){this._debugServiceProxy=o,this._id=v,this._type=c,this._name=E,this._workspaceFolder=I,this._configuration=D,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,v)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=P;class l{constructor(o){this.value=Object.freeze({append(v){o.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=l;class M extends n.AbstractVariableResolverService{constructor(o,v,c,E,I){function D(){if(v){const B=v.activeEditor();if(B)return B.document.uri;const L=E.tabs.filter(y=>y.isActive);if(L.length>0){const y=L[0].resource;return y&&(y.primary||y.secondary)?y.primary??y.secondary:L[0].resource}}}super({getFolderUri:B=>{const L=o.filter(y=>y.name===B);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(B,L)=>c.getConfiguration(void 0,B).get(L),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=D();if(B)return a.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(I){const B=D();if(B){const L=I.getWorkspaceFolder(B);if(L)return a.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(v){const B=v.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(v){const B=v.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=M;class r{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(v=>v.onError?v.onError(o):void 0)}onExit(o,v){this.trackers.forEach(c=>c.onExit?c.onExit(o,v):void 0)}}class i extends S.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let p=class extends f{constructor(o,v,c,E,I,D){super(o,v,c,E,I,D)}createVariableResolver(o,v,c){return new M(o,v,c,this._editorTabs)}};p=xe([$e(0,u.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,d.IExtHostConfiguration),$e(5,m.IExtHostEditorTabs)],p),e.WorkerExtHostDebugService=p}),define(Ee[215],_e([0,1,74,2,5,33,26,25,13,28,4,34,89,12]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(m,f,P,l,M,r,i){this._apiFactory=m,this._extensionRegistry=f,this._instaService=P,this._extHostConfiguration=l,this._extHostExtensionService=M,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,f,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(g,f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(k,f,this._initData.environment.appUriScheme))}register(m){if(Array.isArray(m.nodeModuleName))for(let f of m.nodeModuleName)this._factories.set(f,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(f=>m.alternativeModuleName(f))}};s=xe([$e(2,R.IInstantiationService),$e(3,T.IExtHostConfiguration),$e(4,_.IExtHostExtensionService),$e(5,C.IExtHostInitDataService),$e(6,d.ILogService)],s),e.RequireInterceptor=s;class u{constructor(m,f,P,l,M){this._apiFactory=m,this._extensionPaths=f,this._extensionRegistry=P,this._configProvider=l,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,f){const P=this._extensionPaths.findSubstr(f);if(P){let l=this._extApiImpl.get(A.ExtensionIdentifier.toKey(P.identifier));return l||(l=this._apiFactory(P,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(P.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((M,r)=>l+=`	${r} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(t.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(m,f,P){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=f.getProxy(w.MainContext.MainThreadTelemetry);const{environment:l}=P,M=f.getProxy(w.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;n.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>M.$getPassword(r,i),setPassword:(r,i,p)=>M.$setPassword(r,i,p),deletePassword:(r,i)=>M.$deletePassword(r,i),findPassword:r=>M.$findPassword(r),findCredentials(r){return M.$findCredentials(r)}}}load(m,f){const P=this._extensionPaths.findSubstr(f);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:P?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const f=m.length;if(f<=7||!this.alternativeNames)return;const P=f-7;if((m.charAt(P)==="/"||m.charAt(P)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};g=xe([$e(1,S.IExtHostRpcService),$e(2,C.IExtHostInitDataService)],g);let k=class{constructor(m,f,P){this._extensionPaths=m,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=P.getProxy(w.MainContext.MainThreadTelemetry);const l=P.getProxy(w.MainContext.MainThreadWindow);this._impl=(M,r)=>{const i=F.URI.parse(M);return r?this.callOriginal(M,r):i.scheme==="http"||i.scheme==="https"?l.$openUri(i,M,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?l.$openUri(i,M,{}):this.callOriginal(M,r)}}load(m,f,P){const l=this._extensionPaths.findSubstr(f);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=P(m),this._impl}callOriginal(m,f){return this.sendNoForwardTelemetry(),this._original(m,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};k=xe([$e(2,S.IExtHostRpcService)],k)}),define(Ee[216],_e([0,1,14,15,74,6,2,5,209,12,56,60,28,137,13,66,34,39]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(f,P,l,M){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new S.RPCProtocol(f,null,M),P=b._transform(P,this._rpcProtocol);const r=new _.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...P}),r.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),r.set(u.IURITransformerService,new u.URITransformerService(M)),r.set(g.IHostUtils,l);const i=new d.InstantiationService(r,!0);this._disposables.add(i.invokeFunction(v=>v.get(k.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(v=>v.get(g.IExtHostExtensionService))),this._logService=i.invokeFunction(v=>v.get(C.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",P),this._extensionService=i.invokeFunction(v=>v.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(c,E)=>{let I="",D,B;for(const L of E)I+=`
	at ${L.toString()}`,B=L.getFileName(),!D&&B&&(D=v.findSubstr(t.URI.file(B)));return p.set(c,D),`${c.name||"Error"}: ${c.message||""}${I}`}});const h=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),o=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(v=>{const c=F.transformErrorForSerialization(v),E=p.get(v);E?h.$onExtensionRuntimeError(E.identifier,c):o.$onUnexpectedError(c)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const P=this._extensionService.deactivateAll();Promise.race([(0,a.timeout)(5e3),P]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(f,P){f.extensions.forEach(M=>M.extensionLocation=t.URI.revive(P.transformIncomingURIs(M.extensionLocation))),f.environment.appRoot=t.URI.revive(P.transformIncomingURIs(f.environment.appRoot));const l=f.environment.extensionDevelopmentLocationURI;return l&&(f.environment.extensionDevelopmentLocationURI=l.map(M=>t.URI.revive(P.transformIncomingURIs(M)))),f.environment.extensionTestsLocationURI=t.URI.revive(P.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=t.URI.revive(P.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=t.URI.revive(P.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=t.URI.revive(P.transformIncomingURIs(f.logsLocation)),f.logFile=t.URI.revive(P.transformIncomingURIs(f.logFile)),f.workspace=P.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=b}),define(Ee[217],_e([0,1,17,20,43,29,24,190,40]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(n,d,s){this.config=n,this.provider=d,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&T.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&T.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const d=this.config.folderQueries||[];return new Promise((s,u)=>{const g=k=>{this.resultCount++,n(k)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(k=>{const b=k.toString(),m=a.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,m)||this.matchFile(g,{base:k,basename:m})}),Promise.all(d.map(k=>this.searchInFolder(k,g))).then(k=>{s({limitHit:this.isLimitHit,stats:k[0]||void 0})},k=>{u(new Error((0,w.toErrorMessage)(k)))})})}async searchInFolder(n,d){const s=new F.CancellationTokenSource,u=this.getSearchOptionsForFolder(n),g=this.initDirectoryTree(),k=new S.QueryGlobTester(this.config,n),b=!k.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(s),m=A.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,s.token),P=m.elapsed(),l=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(M=>{const r=a.posix.relative(n.folder.path,M.path);if(b){const i=a.basename(M.path);this.matchFile(d,{base:n.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(g,n.folder,r,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,k,d),{providerTime:P,postProcessTime:l.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const d=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:d,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},d,s,u){if(s===this.filePattern){const k=a.basename(this.filePattern);this.matchFile(u,{base:d,relativePath:this.filePattern,basename:k})}function g(k){const b=a.basename(k),m=a.dirname(k);let f=n[m];f||(f=n[m]=[],g(m)),f.push({base:d,relativePath:k,basename:b})}g(s)}matchDirectoryTree({rootEntries:n,pathToEntries:d},s,u){const g=this,k=this.filePattern;function b(m){const f=T.hasSiblingFn(()=>m.map(P=>P.basename));for(let P=0,l=m.length;P<l;P++){const M=m[P],{relativePath:r,basename:i}=M;if(s.matchesExcludesSync(r,i,k!==i?f:void 0))continue;const p=d[r];if(p)b(p);else{if(r===k)continue;g.matchFile(u,M)}if(g.isLimitHit)break}}b(n)}matchFile(n,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(d))}}class R{constructor(){this.sessions=new Map}fileSearch(n,d,s,u){const g=this.getSessionTokenSource(n.cacheKey),k=new C(n,d,g&&g.token);let b=0;const m=f=>{b+=f.length,s(f.map(P=>this.rawMatchToSearchItem(P)))};return this.doSearch(k,R.BATCH_SIZE,m,u).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:f.stats}}))}clearCache(n){const d=this.getSessionTokenSource(n);d&&d.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new F.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:t.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,d,s,u){u.onCancellationRequested(()=>{n.cancel()});const g=b=>{b&&(k.push(b),d>0&&k.length>=d&&(s(k),k=[]))};let k=[];return n.search(g).then(b=>(k.length&&s(k),b),b=>(k.length&&s(k),Promise.reject(b)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ee[218],_e([0,1,16,20,43,29,10,17,24,11,2,40]),function(oe,e,a,F,w,T,t,A,S,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(m,f,P,l){this.query=m,this.provider=f,this.fileUtils=P,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(m,f){const P=this.query.folderQueries||[],l=new F.CancellationTokenSource;return f.onCancellationRequested(()=>l.cancel()),new Promise((M,r)=>{this.collector=new s(m);let i=!1;const p=(h,o)=>{if(!i&&!this.isLimitHit){const v=this.resultSize(h);g(h)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,i=!0,l.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const c=this.resultSize(h);this.resultCount+=c,(c>0||!g(h))&&this.collector.add(h,o)}};Promise.all(P.map((h,o)=>this.searchInFolder(h,v=>p(v,o),l.token))).then(h=>{l.dispose(),this.collector.flush();const o=h.some(v=>!!v&&!!v.limitHit);M({limitHit:this.isLimitHit||o,messages:(0,a.flatten)(h.map(v=>v?.message?(0,C.isArray)(v.message)?v.message:[v.message]:[])),stats:{type:this.processType}})},h=>{l.dispose();const o=(0,w.toErrorMessage)(h);r(new Error(o))})})}resultSize(m){return g(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,f){const P=Array.isArray(m.ranges)?m.ranges:[m.ranges],l=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:P.slice(0,f),preview:{matches:l.slice(0,f),text:m.preview.text},uri:m.uri}}async searchInFolder(m,f,P){const l=new _.QueryGlobTester(this.query,m),M=[],r={report:h=>{if(!this.validateProviderResult(h))return;const o=m.folder.scheme===t.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(h.uri))):void 0,v=S.relativePath(m.folder,h.uri);if(v){const c=l.includedInQuery(v,A.basename(v),o);(0,C.isPromise)(c)?M.push(c.then(E=>{E&&f(h)})):c&&f(h)}}},i=this.getSearchOptionsForFolder(m),p=await this.provider.provideTextSearchResults(d(this.query.contentPattern),i,r,P);return M.length&&await Promise.all(M),p}validateProviderResult(m){if(g(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const f=(0,_.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),P=(0,_.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),l={folder:R.URI.from(m.folder),excludes:P,includes:f,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=n;function d(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class s{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new k(512,f=>this.sendItems(f))}add(m,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!S.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(u(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=s;function u(b){return g(b)?{preview:{matches:(0,a.mapArrayOrNot)(b.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:b.preview.text},ranges:(0,a.mapArrayOrNot)(b.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function g(b){return!!b.preview}e.extensionResultIsMatch=g;class k{constructor(m,f){this.maxBatchSize=m,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,f){!m||this.addItemToBatch(m,f)}addItems(m,f){!m||this.addItemsToBatch(m,f)}addItemToBatch(m,f){this.batch.push(m),this.batchSize+=f,this.onUpdate()}addItemsToBatch(m,f){this.batch=this.batch.concat(m),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<k.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},k.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=k,k.TIMEOUT=4e3,k.START_BATCH_AFTER_COUNT=50}),define(Ee[99],_e([0,1,6,5,4,217,13,66,12,2,218]),function(oe,e,a,F,w,T,t,A,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let _=class{constructor(u,g,k){this.extHostRpc=u,this._uriTransformer=g,this._logService=k,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,g){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const k=this._handlePool++;return this._textSearchProvider.set(k,g),this._proxy.$registerTextSearchProvider(k,this._transformScheme(u)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}registerFileSearchProvider(u,g){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const k=this._handlePool++;return this._fileSearchProvider.set(k,g),this._proxy.$registerFileSearchProvider(k,this._transformScheme(u)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}$provideFileSearchResults(u,g,k,b){const m=n(k),f=this._fileSearchProvider.get(u);if(f)return this._fileSearchManager.fileSearch(m,f,P=>{this._proxy.$handleFileMatch(u,g,P.map(l=>l.resource))},b);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,g,k,b){const m=this._textSearchProvider.get(u);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const f=n(k);return this.createTextSearchManager(f,m).search(l=>this._proxy.$handleTextMatch(u,g,l),b)}$enableExtensionHostSearch(){}createTextSearchManager(u,g){return new R.TextSearchManager(u,g,{readdir:k=>Promise.resolve([]),toCanonicalName:k=>k},"textSearchProvider")}};_=xe([$e(0,t.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,S.ILogService)],_),e.ExtHostSearch=_;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(d),extraFileResources:s.extraFileResources&&s.extraFileResources.map(u=>C.URI.revive(u))}}e.reviveQuery=n;function d(s){return{...s,folder:C.URI.revive(s.folder)}}}),define(Ee[219],_e([0,1,20,15,3,35,2,113,232,107,55,45,5,180,179,38,181,33,182,183,184,165,185,48,34,186,166,189,191,193,94,168,198,199,200,72,39,202,169,8,7,205,50,95,32,75,154,188,62,93,97,98,99,12,66,13,28,194,151,65,70,177,203,150,73,49,208,206,207,178,31,201,204,69,71,85,196,96,197,10,139,195,148,187,6,26]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b,m,f,P,l,M,r,i,p,h,o,v,c,E,I,D,B,L,y,x,N,z,H,q,ue,G,ce,de,Q,ie,we,Me,Fe,Be,Ke,je,Qe,$,K,X,se,j,Z,fe,Te,Ne,He,Ge,tt,st,Xe,rt,De,gt,V,J,pe,Ue,Ye,Je,lt,Et,It,et,Tt,Pe,Se,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function re(ae){const he=ae.get(K.IExtHostInitDataService),me=ae.get(De.IExtHostFileSystemInfo),Ie=ae.get(Ge.IExtHostConsumerFileSystem),ze=ae.get(r.IExtHostExtensionService),Oe=ae.get(ce.IExtHostWorkspace),We=ae.get(Ue.IExtHostTelemetry),it=ae.get(k.IExtHostConfiguration),ot=ae.get(Qe.IURITransformerService),ne=ae.get($.IExtHostRpcService),ge=ae.get(L.IExtHostStorage),te=ae.get(He.IExtensionStoragePaths),W=ae.get(je.ILoggerService),be=ae.get(je.ILogService),ke=ae.get(j.IExtHostTunnelService),qe=ae.get(Z.IExtHostApiDeprecationService),Le=ae.get(G.IExtHostWindow),dt=ae.get(J.IExtHostSecretState),bt=ae.get(pe.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,me),ne.set(n.ExtHostContext.ExtHostLogLevelServiceShape,W),ne.set(n.ExtHostContext.ExtHostWorkspace,Oe),ne.set(n.ExtHostContext.ExtHostConfiguration,it),ne.set(n.ExtHostContext.ExtHostExtensionService,ze),ne.set(n.ExtHostContext.ExtHostStorage,ge),ne.set(n.ExtHostContext.ExtHostTunnelService,ke),ne.set(n.ExtHostContext.ExtHostWindow,Le),ne.set(n.ExtHostContext.ExtHostSecretState,dt),ne.set(n.ExtHostContext.ExtHostTelemetry,We),ne.set(n.ExtHostContext.ExtHostEditorTabs,bt);const Ct=ne.set(n.ExtHostContext.ExtHostDecorations,ae.get(Me.IExtHostDecorations)),pt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ae.get(M.IExtHostDocumentsAndEditors)),ht=ne.set(n.ExtHostContext.ExtHostCommands,ae.get(u.IExtHostCommands)),vt=ne.set(n.ExtHostContext.ExtHostTerminalService,ae.get(y.IExtHostTerminalService)),_t=ne.set(n.ExtHostContext.ExtHostDebugService,ae.get(Be.IExtHostDebugService)),Ft=ne.set(n.ExtHostContext.ExtHostSearch,ae.get(Ke.IExtHostSearch)),yt=ne.set(n.ExtHostContext.ExtHostTask,ae.get(Fe.IExtHostTask)),At=ne.set(n.ExtHostContext.ExtHostOutputService,ae.get(c.IExtHostOutputService)),Ut=ne.set(n.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(ne)),Pt=ne.set(n.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(ne,pt)),Bt=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(ne,pt,be)),zt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new P.ExtHostDocumentSaveParticipant(be,Pt,ne.getProxy(n.MainContext.MainThreadBulkEdits))),wt=ne.set(n.ExtHostContext.ExtHostNotebook,new X.ExtHostNotebookController(ne,ht,pt,Pt,te)),Qt=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new Tt.ExtHostNotebookDocuments(be,wt)),Vt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new et.ExtHostNotebookEditors(be,ne,wt)),oi=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new Ye.ExtHostNotebookKernels(ne,he,wt,ht,be)),si=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new lt.ExtHostNotebookRenderers(ne,wt)),Rt=ne.set(n.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(ne,pt)),Yt=ne.set(n.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),ht,be)),ai=ne.set(n.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),Rt,he)),Xt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(ne,be,me)),Wt=ne.set(n.ExtHostContext.ExtHostLanguages,new o.ExtHostLanguages(ne,Pt,ht.converter,ot)),mt=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(ne,ot,Pt,ht,Xt,be,qe)),ci=ne.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ne,mt)),Ot=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(ne,be,pt)),jt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,I.createExtHostQuickOpen)(ne,Oe,ht)),Jt=ne.set(n.ExtHostContext.ExtHostSCM,new D.ExtHostSCM(ne,ht,be)),li=ne.set(n.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(ne,ht,Pt)),fi=ne.set(n.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new ie.ExtHostLabelService(ne)),mi=ne.set(n.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(ne)),Zt=ne.set(n.ExtHostContext.ExtHostAuthentication,new fe.ExtHostAuthentication(ne)),_i=ne.set(n.ExtHostContext.ExtHostTimeline,new Te.ExtHostTimeline(ne,ht)),qt=ne.set(n.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(ne,{remote:he.remote},Oe,be,qe)),Kt=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new Xe.ExtHostWebviewPanels(ne,qt,Oe)),yi=ne.set(n.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(ne,Pt,te,qt,Kt)),Si=ne.set(n.ExtHostContext.ExtHostWebviewViews,new tt.ExtHostWebviewViews(ne,qt)),Gt=ne.set(n.ExtHostContext.ExtHostTesting,new gt.ExtHostTesting(ne,ht)),Ci=ne.set(n.ExtHostContext.ExtHostUriOpeners,new V.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new Pe.ExtHostInteractive(ne,wt,pt,ht));const ei=(0,de.values)(n.ExtHostContext);ne.assertRegistered(ei);const Di=new rt.ExtHostBulkEdits(ne,pt),ki=new s.ExtHostClipboard(ne),ui=new v.ExtHostMessageService(ne,be),ti=new m.ExtHostDialogs(ne),gi=new B.ExtHostStatusBar(ne,ht.converter);return d.ExtHostApiCommands.register(ht),function(Re,Lt,pi){const ft=function(){let Y=!Re.isUnderDevelopment;function le(){Y||(be.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Ce(ct){if(Array.isArray(ct))ct.forEach(Ce);else if(typeof ct=="string")le();else{const St=ct;typeof St.scheme=="undefined"&&le(),typeof St.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Re,"documentFiltersExclusive")}return ct}}(),ii={getSession(Y,le,Ce){return Zt.getSession(Re,Y,le,Ce)},async hasSession(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"authSession"),!!await Zt.getSession(Re,Y,le,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(Y,le,Ce,ct){return Zt.registerAuthenticationProvider(Y,le,Ce,ct)}},Ii={registerCommand(Y,le,Ce){return ht.registerCommand(!0,Y,le,Ce,void 0,Re)},registerTextEditorCommand(Y,le,Ce){return ht.registerCommand(!0,Y,(...ct)=>{const St=Rt.getActiveTextEditor();if(!St){be.warn("Cannot execute "+Y+" because there is no active text editor.");return}return St.edit(Dt=>{le.apply(Ce,[St,Dt,...ct])}).then(Dt=>{Dt||be.warn("Edits from command "+Y+" were not applied.")},Dt=>{be.warn("An error occurred while running command "+Y,Dt)})},void 0,void 0,Re)},registerDiffInformationCommand:(Y,le,Ce)=>((0,ve.checkProposedApiEnabled)(Re,"diffCommand"),ht.registerCommand(!0,Y,async(...ct)=>{const St=pt.activeEditor(!0);if(!St){be.warn("Cannot execute "+Y+" because there is no active text editor.");return}const Dt=await Rt.getDiffInformation(St.id);le.apply(Ce,[Dt,...ct])},void 0,void 0,Re)),executeCommand(Y,...le){return ht.executeCommand(Y,...le)},getCommands(Y=!1){return ht.getCommands(Y)}},vi={get machineId(){return he.telemetryInfo.machineId},get sessionId(){return he.telemetryInfo.sessionId},get language(){return he.environment.appLanguage},get appName(){return he.environment.appName},get appRoot(){return he.environment.appRoot?.fsPath??""},get appHost(){return he.environment.appHost},get uriScheme(){return he.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return We.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return We.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(he.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,le){return Le.openUri(Y,{allowTunneling:!!he.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===he.environment.appUriScheme)return Ut.createAppUri(Y);try{return await Le.asExternalUri(Y,{allowTunneling:!!he.remote.authority})}catch(le){if((0,It.matchesScheme)(Y,Et.Schemas.http)||(0,It.matchesScheme)(Y,Et.Schemas.https))return Y;throw le}},get remoteName(){return(0,we.getRemoteName)(he.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Re,"resolvers"),he.remote.authority},get uiKind(){return he.uiKind}};he.environment.extensionTestsLocationURI||Object.freeze(vi);const bi=he.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Pi={createTestController(Y,le){return Gt.createTestController(Y,le)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Gt.createTestObserver()},runTests(Y){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Gt.runTests(Y)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Gt.results}},Ti={getExtension(Y){const le=Lt.getExtensionDescription(Y);if(le)return new r.Extension(ze,Re.identifier,le,bi)},get all(){return Lt.getAllExtensionDescriptions().map(Y=>new r.Extension(ze,Re.identifier,Y,bi))},get onDidChange(){return Lt.onDidChange}},Ai={createDiagnosticCollection(Y){return Xt.createDiagnosticCollection(Re.identifier,Y)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:Y=>Xt.getDiagnostics(Y),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Y,le){return Wt.changeLanguage(Y.uri,le)},match(Y,le){return(0,R.score)(z.LanguageSelector.from(Y),le.uri,le.languageId,!0)},registerCodeActionsProvider(Y,le,Ce){return mt.registerCodeActionProvider(Re,ft(Y),le,Ce)},registerCodeLensProvider(Y,le){return mt.registerCodeLensProvider(Re,ft(Y),le)},registerDefinitionProvider(Y,le){return mt.registerDefinitionProvider(Re,ft(Y),le)},registerDeclarationProvider(Y,le){return mt.registerDeclarationProvider(Re,ft(Y),le)},registerImplementationProvider(Y,le){return mt.registerImplementationProvider(Re,ft(Y),le)},registerTypeDefinitionProvider(Y,le){return mt.registerTypeDefinitionProvider(Re,ft(Y),le)},registerHoverProvider(Y,le){return mt.registerHoverProvider(Re,ft(Y),le,Re.identifier)},registerEvaluatableExpressionProvider(Y,le){return mt.registerEvaluatableExpressionProvider(Re,ft(Y),le,Re.identifier)},registerInlineValuesProvider(Y,le){return mt.registerInlineValuesProvider(Re,ft(Y),le,Re.identifier)},registerDocumentHighlightProvider(Y,le){return mt.registerDocumentHighlightProvider(Re,ft(Y),le)},registerLinkedEditingRangeProvider(Y,le){return mt.registerLinkedEditingRangeProvider(Re,ft(Y),le)},registerReferenceProvider(Y,le){return mt.registerReferenceProvider(Re,ft(Y),le)},registerRenameProvider(Y,le){return mt.registerRenameProvider(Re,ft(Y),le)},registerDocumentSymbolProvider(Y,le,Ce){return mt.registerDocumentSymbolProvider(Re,ft(Y),le,Ce)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Re,Y)},registerDocumentFormattingEditProvider(Y,le){return mt.registerDocumentFormattingEditProvider(Re,ft(Y),le)},registerDocumentRangeFormattingEditProvider(Y,le){return mt.registerDocumentRangeFormattingEditProvider(Re,ft(Y),le)},registerOnTypeFormattingEditProvider(Y,le,Ce,...ct){return mt.registerOnTypeFormattingEditProvider(Re,ft(Y),le,[Ce].concat(ct))},registerDocumentSemanticTokensProvider(Y,le,Ce){return mt.registerDocumentSemanticTokensProvider(Re,ft(Y),le,Ce)},registerDocumentRangeSemanticTokensProvider(Y,le,Ce){return mt.registerDocumentRangeSemanticTokensProvider(Re,ft(Y),le,Ce)},registerSignatureHelpProvider(Y,le,Ce,...ct){return typeof Ce=="object"?mt.registerSignatureHelpProvider(Re,ft(Y),le,Ce):mt.registerSignatureHelpProvider(Re,ft(Y),le,typeof Ce=="undefined"?[]:[Ce,...ct])},registerCompletionItemProvider(Y,le,...Ce){return mt.registerCompletionItemProvider(Re,ft(Y),le,Ce)},registerInlineCompletionItemProvider(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"inlineCompletions"),mt.registerInlineCompletionsProvider(Re,ft(Y),le)},registerDocumentLinkProvider(Y,le){return mt.registerDocumentLinkProvider(Re,ft(Y),le)},registerColorProvider(Y,le){return mt.registerColorProvider(Re,ft(Y),le)},registerFoldingRangeProvider(Y,le){return mt.registerFoldingRangeProvider(Re,ft(Y),le)},registerSelectionRangeProvider(Y,le){return mt.registerSelectionRangeProvider(Re,Y,le)},registerCallHierarchyProvider(Y,le){return mt.registerCallHierarchyProvider(Re,Y,le)},registerTypeHierarchyProvider(Y,le){return mt.registerTypeHierarchyProvider(Re,Y,le)},setLanguageConfiguration:(Y,le)=>mt.setLanguageConfiguration(Re,Y,le),getTokenInformationAtPosition(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"tokenInformation"),Wt.tokenAtPosition(Y,le)},registerInlayHintsProvider(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"inlayHints"),mt.registerInlayHintsProvider(Re,Y,le)},createLanguageStatusItem(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"languageStatus"),Wt.createLanguageStatusItem(Re,Y,le)}},Ri={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(Y,le,Ce){const ct=await(t.URI.isUri(Y)?Promise.resolve(ni.openTextDocument(Y)):Promise.resolve(Y));return Rt.showTextDocument(ct,le,Ce)},createTextEditorDecorationType(Y){return Rt.createTextEditorDecorationType(Re,Y)},onDidChangeActiveTextEditor(Y,le,Ce){return Rt.onDidChangeActiveTextEditor(Y,le,Ce)},onDidChangeVisibleTextEditors(Y,le,Ce){return Rt.onDidChangeVisibleTextEditors(Y,le,Ce)},onDidChangeTextEditorSelection(Y,le,Ce){return Rt.onDidChangeTextEditorSelection(Y,le,Ce)},onDidChangeTextEditorOptions(Y,le,Ce){return Rt.onDidChangeTextEditorOptions(Y,le,Ce)},onDidChangeTextEditorVisibleRanges(Y,le,Ce){return Rt.onDidChangeTextEditorVisibleRanges(Y,le,Ce)},onDidChangeTextEditorViewColumn(Y,le,Ce){return Rt.onDidChangeTextEditorViewColumn(Y,le,Ce)},onDidCloseTerminal(Y,le,Ce){return vt.onDidCloseTerminal(Y,le,Ce)},onDidOpenTerminal(Y,le,Ce){return vt.onDidOpenTerminal(Y,le,Ce)},onDidChangeActiveTerminal(Y,le,Ce){return vt.onDidChangeActiveTerminal(Y,le,Ce)},onDidChangeTerminalDimensions(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"terminalDimensions"),vt.onDidChangeTerminalDimensions(Y,le,Ce)},onDidChangeTerminalState(Y,le,Ce){return vt.onDidChangeTerminalState(Y,le,Ce)},onDidWriteTerminalData(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(Y,le,Ce)},get state(){return Le.state},onDidChangeWindowState(Y,le,Ce){return Le.onDidChangeWindowState(Y,le,Ce)},showInformationMessage(Y,...le){return ui.showMessage(Re,T.default.Info,Y,le[0],le.slice(1))},showWarningMessage(Y,...le){return ui.showMessage(Re,T.default.Warning,Y,le[0],le.slice(1))},showErrorMessage(Y,...le){return ui.showMessage(Re,T.default.Error,Y,le[0],le.slice(1))},showQuickPick(Y,le,Ce){return Array.isArray(Y)&&Y.some(ct=>ct.kind!==void 0)&&(0,ve.checkProposedApiEnabled)(Re,"quickPickSeparators"),jt.showQuickPick(Y,le,Ce)},showWorkspaceFolderPick(Y){return jt.showWorkspaceFolderPick(Y)},showInputBox(Y,le){return jt.showInput(Y,le)},showOpenDialog(Y){return ti.showOpenDialog(Y)},showSaveDialog(Y){return ti.showSaveDialog(Y)},createStatusBarItem(Y,le,Ce){let ct,St,Dt;return typeof Y=="string"?(ct=Y,St=le,Dt=Ce):(St=Y,Dt=le),gi.createStatusBarEntry(Re,ct,St,Dt)},setStatusBarMessage(Y,le){return gi.setStatusBarMessage(Y,le)},withScmProgress(Y){return qe.report("window.withScmProgress",Re,"Use 'withProgress' instead."),fi.withProgress(Re,{location:H.ProgressLocation.SourceControl},(le,Ce)=>Y({report(ct){}}))},withProgress(Y,le){return fi.withProgress(Re,Y,le)},createOutputChannel(Y){return At.createOutputChannel(Y,Re)},createWebviewPanel(Y,le,Ce,ct){return Kt.createWebviewPanel(Re,Y,le,Ce,ct)},createWebviewTextEditorInset(Y,le,Ce,ct){return(0,ve.checkProposedApiEnabled)(Re,"editorInsets"),ai.createWebviewEditorInset(Y,le,Ce,ct,Re)},createTerminal(Y,le,Ce){return typeof Y=="object"?("location"in Y&&(0,ve.checkProposedApiEnabled)(Re,"terminalLocation"),"pty"in Y?vt.createExtensionTerminal(Y):vt.createTerminalFromOptions(Y)):vt.createTerminal(Y,le,Ce)},registerTerminalLinkProvider(Y){return vt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,le){return vt.registerProfileProvider(Re,Y,le)},registerTreeDataProvider(Y,le){return Yt.registerTreeDataProvider(Y,le,Re)},createTreeView(Y,le){return Yt.createTreeView(Y,le,Re)},registerWebviewPanelSerializer:(Y,le)=>Kt.registerWebviewPanelSerializer(Re,Y,le),registerCustomEditorProvider:(Y,le,Ce={})=>yi.registerCustomEditorProvider(Re,Y,le,Ce),registerFileDecorationProvider(Y){return Ct.registerFileDecorationProvider(Y,Re.identifier)},registerUriHandler(Y){return Ut.registerUriHandler(Re.identifier,Y)},createQuickPick(){return jt.createQuickPick(Re)},createInputBox(){return jt.createInputBox(Re.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,le,Ce){return mi.onDidChangeActiveColorTheme(Y,le,Ce)},registerWebviewViewProvider(Y,le,Ce){return Si.registerWebviewViewProvider(Re,Y,le,Ce?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(Y,le,Ce)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(Y,le,Ce)},onDidChangeNotebookEditorVisibleRanges(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(Y,le,Ce)},showNotebookDocument(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.showNotebookDocument(Y,le)},registerExternalUriOpener(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"externalUriOpener"),Ci.registerExternalUriOpener(Re.identifier,Y,le,Ce)},get tabs(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ve.checkProposedApiEnabled)(Re,"inlineCompletions"),h.InlineCompletionController.get(Y)}},ni={get rootPath(){return qe.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Oe.getPath()},set rootPath(Y){throw F.readonly()},getWorkspaceFolder(Y){return Oe.getWorkspaceFolder(Y)},get workspaceFolders(){return Oe.getWorkspaceFolders()},get name(){return Oe.name},set name(Y){throw F.readonly()},get workspaceFile(){return Oe.workspaceFile},set workspaceFile(Y){throw F.readonly()},updateWorkspaceFolders:(Y,le,...Ce)=>Oe.updateWorkspaceFolders(Re,Y,le||0,...Ce),onDidChangeWorkspaceFolders:function(Y,le,Ce){return Oe.onDidChangeWorkspace(Y,le,Ce)},asRelativePath:(Y,le)=>Oe.getRelativePath(Y,le),findFiles:(Y,le,Ce,ct)=>Oe.findFiles(z.GlobPattern.from(Y),z.GlobPattern.from(le),Ce,Re.identifier,ct),findTextInFiles:(Y,le,Ce,ct)=>{(0,ve.checkProposedApiEnabled)(Re,"findTextInFiles");let St,Dt;return typeof le=="object"?(St=le,Dt=Ce):(St={},Dt=le,ct=Ce),Oe.findTextInFiles(Y,St||{},Dt,Re.identifier,ct)},saveAll:Y=>Oe.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,le,Ce,ct)=>Ot.createFileSystemWatcher(z.GlobPattern.from(Y),le,Ce,ct),get textDocuments(){return Pt.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw F.readonly()},openTextDocument(Y){let le;const Ce=Y;if(typeof Y=="string")le=Promise.resolve(t.URI.file(Y));else if(t.URI.isUri(Y))le=Promise.resolve(Y);else if(!Ce||typeof Ce=="object")le=Pt.createDocumentData(Ce);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ct=>Pt.ensureDocumentData(ct).then(St=>St.document))},onDidOpenTextDocument:(Y,le,Ce)=>Pt.onDidAddDocument(Y,le,Ce),onDidCloseTextDocument:(Y,le,Ce)=>Pt.onDidRemoveDocument(Y,le,Ce),onDidChangeTextDocument:(Y,le,Ce)=>Pt.onDidChangeDocument(Y,le,Ce),onDidSaveTextDocument:(Y,le,Ce)=>Pt.onDidSaveDocument(Y,le,Ce),onWillSaveTextDocument:(Y,le,Ce)=>zt.getOnWillSaveTextDocumentEvent(Re)(Y,le,Ce),get notebookDocuments(){return wt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,le){let Ce;if(t.URI.isUri(Y))Ce=Y,await wt.openNotebookDocument(Y);else if(typeof Y=="string")Ce=t.URI.revive(await wt.createNotebookDocument({viewType:Y,content:le}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Ce).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,le,Ce,ct){return wt.registerNotebookSerializer(Re,Y,le,Ce,(0,ve.isProposedApiEnabled)(Re,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(Y,le,Ce,ct)=>((0,ve.checkProposedApiEnabled)(Re,"notebookContentProvider"),wt.registerNotebookContentProvider(Re,Y,le,Ce,(0,ve.isProposedApiEnabled)(Re,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(Y,le,Ce)=>pi.onDidChangeConfiguration(Y,le,Ce),getConfiguration(Y,le){return le=arguments.length===1?void 0:le,pi.getConfiguration(Y,le,Re)},registerTextDocumentContentProvider(Y,le){return Bt.registerTextDocumentContentProvider(Y,le)},registerTaskProvider:(Y,le)=>(qe.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Re,Y,le)),registerFileSystemProvider(Y,le,Ce){return(0,Se.combinedDisposable)(ci.registerFileSystemProvider(Re,Y,le,Ce),Ie.addFileSystemProvider(Y,le))},get fs(){return Ie.value},registerFileSearchProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"fileSearchProvider"),Ft.registerFileSearchProvider(Y,le)),registerTextSearchProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"textSearchProvider"),Ft.registerTextSearchProvider(Y,le)),registerRemoteAuthorityResolver:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),ze.registerRemoteAuthorityResolver(Y,le)),registerResourceLabelFormatter:Y=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,le,Ce)=>Ot.onDidCreateFile(Y,le,Ce),onDidDeleteFiles:(Y,le,Ce)=>Ot.onDidDeleteFile(Y,le,Ce),onDidRenameFiles:(Y,le,Ce)=>Ot.onDidRenameFile(Y,le,Ce),onWillCreateFiles:(Y,le,Ce)=>Ot.getOnWillCreateFileEvent(Re)(Y,le,Ce),onWillDeleteFiles:(Y,le,Ce)=>Ot.getOnWillDeleteFileEvent(Re)(Y,le,Ce),onWillRenameFiles:(Y,le,Ce)=>Ot.getOnWillRenameFileEvent(Re)(Y,le,Ce),openTunnel:Y=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),ke.openTunnel(Re,Y).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Re,"resolvers"),ke.getTunnels()},onDidChangeTunnels:(Y,le,Ce)=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),ke.onDidChangeTunnels(Y,le,Ce)),registerPortAttributesProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"portsAttributes"),ke.registerPortsAttributesProvider(Y,le)),registerTimelineProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"timeline"),_i.registerTimelineProvider(Y,le,Re.identifier,ht.converter)),get isTrusted(){return Oe.trusted},requestWorkspaceTrust:Y=>((0,ve.checkProposedApiEnabled)(Re,"workspaceTrust"),Oe.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,le,Ce)=>Oe.onDidGrantWorkspaceTrust(Y,le,Ce)},Fi={get inputBox(){return qe.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Re)},createSourceControl(Y,le,Ce){return Jt.createSourceControl(Re,Y,le,Ce)}},Mi={createCommentController(Y,le){return li.createCommentController(Re,Y,le)}},Oi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(Y,le,Ce){return _t.onDidStartDebugSession(Y,le,Ce)},onDidTerminateDebugSession(Y,le,Ce){return _t.onDidTerminateDebugSession(Y,le,Ce)},onDidChangeActiveDebugSession(Y,le,Ce){return _t.onDidChangeActiveDebugSession(Y,le,Ce)},onDidReceiveDebugSessionCustomEvent(Y,le,Ce){return _t.onDidReceiveDebugSessionCustomEvent(Y,le,Ce)},onDidChangeBreakpoints(Y,le,Ce){return _t.onDidChangeBreakpoints(Y,le,Ce)},registerDebugConfigurationProvider(Y,le,Ce){return _t.registerDebugConfigurationProvider(Y,le,Ce||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,le){return _t.registerDebugAdapterDescriptorFactory(Re,Y,le)},registerDebugAdapterTrackerFactory(Y,le){return _t.registerDebugAdapterTrackerFactory(Y,le)},startDebugging(Y,le,Ce){return!Ce||typeof Ce=="object"&&"configuration"in Ce?_t.startDebugging(Y,le,{parentSession:Ce}):_t.startDebugging(Y,le,Ce||{})},stopDebugging(Y){return _t.stopDebugging(Y)},addBreakpoints(Y){return _t.addBreakpoints(Y)},removeBreakpoints(Y){return _t.removeBreakpoints(Y)},asDebugSourceUri(Y,le){return _t.asDebugSourceUri(Y,le)}},Li={registerTaskProvider:(Y,le)=>yt.registerTaskProvider(Re,Y,le),fetchTasks:Y=>yt.fetchTasks(Y),executeTask:Y=>yt.executeTask(Re,Y),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(Y,le,Ce)=>yt.onDidStartTask(Y,le,Ce),onDidEndTask:(Y,le,Ce)=>yt.onDidEndTask(Y,le,Ce),onDidStartTaskProcess:(Y,le,Ce)=>yt.onDidStartTaskProcess(Y,le,Ce),onDidEndTaskProcess:(Y,le,Ce)=>yt.onDidEndTaskProcess(Y,le,Ce)},Ni={createNotebookController(Y,le,Ce,ct,St){return oi.createNotebookController(Re,Y,le,Ce,ct,(0,ve.isProposedApiEnabled)(Re,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(Y,le)=>wt.registerNotebookCellStatusBarItemProvider(Re,Y,le),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return si.createRendererMessaging(Re,Y)},onDidChangeNotebookDocumentMetadata(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(Y,le,Ce)},onDidChangeNotebookCells(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeNotebookCells(Y,le,Ce)},onDidChangeNotebookCellExecutionState(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookCellExecutionState"),wt.onDidChangeNotebookCellExecutionState(Y,le,Ce)},onDidChangeCellOutputs(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeCellOutputs(Y,le,Ce)},onDidChangeCellMetadata(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeCellMetadata(Y,le,Ce)},createConcatTextDocument(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"notebookConcatTextDocument"),new Ne.ExtHostNotebookConcatDocument(wt,Pt,Y,le)}};return{version:he.version,authentication:ii,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ni,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:C.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:t.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Je.TextSearchCompleteMessageType,TreeDataTransfer:H.TreeDataTransfer,TreeDataTransferItem:H.TreeDataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=re}),define(Ee[220],_e([0,1,56,94,32,93,33,38,48,39,97,98,99,72,65,70,95,49,31,69,85,71,192,12,175]),function(oe,e,a,F,w,T,t,A,S,C,R,_,n,d,s,u,g,k,b,m,f,P,l,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(M.ILoggerService,l.ExtHostLoggerService),(0,a.registerSingleton)(M.ILogService,r.ExtHostLogService),(0,a.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,a.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,a.registerSingleton)(t.IExtHostConfiguration,t.ExtHostConfiguration),(0,a.registerSingleton)(k.IExtHostConsumerFileSystem,k.ExtHostConsumerFileSystem),(0,a.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,a.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,a.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,a.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,a.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,a.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,a.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,a.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,a.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,a.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,a.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,a.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,a.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState),(0,a.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,a.registerSingleton)(P.IExtHostEditorTabs,P.ExtHostEditorTabs)}),define(Ee[221],_e([0,1,219,34,215,7,14,5,10]),function(oe,e,a,F,w,T,t,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(s){const u=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(k,...b)=>{b.forEach(l=>{if(!self.trustedTypes?.isScript(l))throw new Error("TrustedScripts only, please")});const m=b.slice(0,-1).join(","),f=b.pop().toString();return`(function anonymous(${m}) {${f}
})`}});function g(...k){return u?self.eval(u.createScript("",...k)):new Function(...k)}s.create=g})(C||(C={}));class R extends w.RequireInterceptor{_installInterceptor(){}getModule(u,g){for(let k of this._alternatives){let b=k(u);if(b){u=b;break}}if(this._factories.has(u))return this._factories.get(u).load(u,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const u=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);d(u,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(a.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(u){return u.browser}async _loadCommonJSModule(u,g,k){g=g.with({path:n(g.path,".js")}),u&&performance.mark(`code/extHost/willFetchExtensionCode/${u.value}`);const b=await fetch(S.FileAccess.asBrowserUri(g).toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u.value}`),b.status!==200)throw new Error(b.statusText);const m=await b.text(),f=`${g.toString(!0)}#vscode-extension`,P=`${m}
//# sourceURL=${f}`;let l;try{l=C.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(P)??P)}catch(p){throw console.error(u?`Loading code for extension ${u.value} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${g.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}const M={},r={exports:M},i=p=>{const h=this._fakeModules.getModule(p,g);if(h===void 0)throw new Error(`Cannot load module '${p}'`);return h};try{return k.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u.value}`),l(r,M,i),r.exports!==M?r.exports:M}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u.value}`),k.codeLoadingStop()}}async $setRemoteEnvironment(u){}async _waitForDebuggerAttachment(u=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+u;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,t.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:s=>s});function n(s,u){return s.endsWith(u)?s:s+u}function d(s,u){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(m,f){const P=console[m];console[m]=function(){s.$logExtensionHostMessage({type:"__$console",severity:f,arguments:b(arguments)}),u&&P.apply(console,arguments)}}const k=1e5;function b(m){const f=[],P=[];if(m.length)for(let l=0;l<m.length;l++){if(typeof m[l]=="undefined")m[l]="undefined";else if(m[l]instanceof Error){const M=m[l];M.stack?m[l]=M.stack:m[l]=M.toString()}P.push(m[l])}try{const l=JSON.stringify(P,function(M,r){if(r&&typeof r=="object"){if(f.indexOf(r)!==-1)return"[Circular]";f.push(r)}return r});return l.length>k?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}}),define(Ee[222],_e([0,1,56,34,73,221]),function(oe,e,a,F,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(F.IExtHostExtensionService,T.ExtHostExtensionService),(0,a.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(Ee[233],_e([0,1,22,3,173,216,210,17,74,10,2,220,222]),function(oe,e,a,F,w,T,t,A,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const d=fetch.bind(self);if(self.fetch=function(m,f){return m instanceof Request||/^file:/i.test(String(m))&&(m=C.FileAccess.asBrowserUri(R.URI.parse(String(m))).toString(!0)),d(m,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,f,P,l,M){return/^file:/i.test(f.toString())&&(f=C.FileAccess.asBrowserUri(R.URI.parse(f.toString())).toString(!0)),super.open(m,f,P??!0,l,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const m=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:P=>P}),f=self.Worker;Worker=function(P,l){/^file:/i.test(P.toString())&&(P=C.FileAccess.asBrowserUri(R.URI.parse(P.toString())).toString(!0));const r=`(${function(o){function v(D){return typeof D=="string"||D instanceof URL?String(D).replace(/^file:\/\//i,"vscode-file://vscode-app"):D}const c=fetch.bind(self);self.fetch=function(D,B){return D instanceof Request?c(D,B):c(v(D),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(D,B,L,y,x){return super.open(D,v(B),L??!0,y,x)}};const E=importScripts.bind(self);self.importScripts=(...D)=>{E(...D.map(v))};const I=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:D=>D}):void 0;E(I?I.createScriptURL(o):o)}.toString()}('${P}'))`;l=l||{},l.name=l.name||A.basename(P.toString());const i=new Blob([r],{type:"application/javascript"}),p=URL.createObjectURL(i);return new f(m?m.createScriptURL(p):p,l)}}else self.Worker=class extends t.NestedWorker{constructor(m,f){super(n,m,{name:A.basename(m.toString()),...f})}};const s=new class{constructor(){this.pid=void 0}exit(m){_()}async exists(m){return!0}async realpath(m){return m}};class u{constructor(){const f=new MessageChannel,P=new F.Emitter;let l=!1;n(f.port2,[f.port2]),f.port1.onmessage=M=>{const{data:r}=M;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const i=a.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,w.isMessageOfType)(i,2)){l=!0,k("received terminate message from renderer");return}P.fire(i)},this.protocol={onMessage:P.event,send:M=>{if(!l){const r=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);f.port1.postMessage(r,[r])}}}}}function g(m){return new Promise(f=>{const P=m.onMessage(l=>{P.dispose();const M=JSON.parse(l.toString());m.send((0,w.createMessageOfType)(0)),f({protocol:m,initData:M})});m.send((0,w.createMessageOfType)(1))})}let k=m=>_();function b(){const m=new u;S.mark("code/extHost/willConnectToRenderer"),g(m.protocol).then(f=>{S.mark("code/extHost/didWaitForInitData");const P=new T.ExtensionHostMain(f.protocol,f.initData,s,null);k=l=>P.terminate(l)})}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c1f2f40bcd81380bf2e286af64becddada57db88/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
